-- filename : char-def.lua
-- comment  : companion to char-def.tex (in ConTeXt)
-- author   : Hans Hagen, PRAGMA-ADE, Hasselt NL
-- copyright: PRAGMA ADE / ConTeXt Development Team
-- license  : see context related readme files

-- remark   : compact version

if not versions   then versions   = { } end versions['char-def'] = 1.001
if not characters then characters = { } end

characters.data = {
	[0x0000] = { unicodeslot=0x0000, category='cc', description='NULL' },
	[0x0001] = { unicodeslot=0x0001, category='cc', description='START OF HEADING' },
	[0x0002] = { unicodeslot=0x0002, category='cc', description='START OF TEXT' },
	[0x0003] = { unicodeslot=0x0003, category='cc', description='END OF TEXT' },
	[0x0004] = { unicodeslot=0x0004, category='cc', description='END OF TRANSMISSION' },
	[0x0005] = { unicodeslot=0x0005, category='cc', description='ENQUIRY' },
	[0x0006] = { unicodeslot=0x0006, category='cc', description='ACKNOWLEDGE' },
	[0x0007] = { unicodeslot=0x0007, category='cc', description='BELL' },
	[0x0008] = { unicodeslot=0x0008, category='cc', description='BACKSPACE' },
	[0x0009] = { unicodeslot=0x0009, category='cc', description='CHARACTER TABULATION' },
	[0x000A] = { unicodeslot=0x000A, category='cc', description='LINE FEED (LF)' },
	[0x000B] = { unicodeslot=0x000B, category='cc', description='LINE TABULATION' },
	[0x000C] = { unicodeslot=0x000C, category='cc', description='FORM FEED (FF)' },
	[0x000D] = { unicodeslot=0x000D, category='cc', description='CARRIAGE RETURN (CR)' },
	[0x000E] = { unicodeslot=0x000E, category='cc', description='SHIFT OUT' },
	[0x000F] = { unicodeslot=0x000F, category='cc', description='SHIFT IN' },
	[0x0010] = { unicodeslot=0x0010, category='cc', description='DATA LINK ESCAPE' },
	[0x0011] = { unicodeslot=0x0011, category='cc', description='DEVICE CONTROL ONE' },
	[0x0012] = { unicodeslot=0x0012, category='cc', description='DEVICE CONTROL TWO' },
	[0x0013] = { unicodeslot=0x0013, category='cc', description='DEVICE CONTROL THREE' },
	[0x0014] = { unicodeslot=0x0014, category='cc', description='DEVICE CONTROL FOUR' },
	[0x0015] = { unicodeslot=0x0015, category='cc', description='NEGATIVE ACKNOWLEDGE' },
	[0x0016] = { unicodeslot=0x0016, category='cc', description='SYNCHRONOUS IDLE' },
	[0x0017] = { unicodeslot=0x0017, category='cc', description='END OF TRANSMISSION BLOCK' },
	[0x0018] = { unicodeslot=0x0018, category='cc', description='CANCEL' },
	[0x0019] = { unicodeslot=0x0019, category='cc', description='END OF MEDIUM' },
	[0x001A] = { unicodeslot=0x001A, category='cc', description='SUBSTITUTE' },
	[0x001B] = { unicodeslot=0x001B, category='cc', description='ESCAPE' },
	[0x001C] = { unicodeslot=0x001C, category='cc', description='INFORMATION SEPARATOR FOUR' },
	[0x001D] = { unicodeslot=0x001D, category='cc', description='INFORMATION SEPARATOR THREE' },
	[0x001E] = { unicodeslot=0x001E, category='cc', description='INFORMATION SEPARATOR TWO' },
	[0x001F] = { unicodeslot=0x001F, category='cc', description='INFORMATION SEPARATOR ONE' },
	[0x0020] = { unicodeslot=0x0020, category='zs', adobename='space', description='SPACE' },
	[0x0021] = { unicodeslot=0x0021, category='po', adobename='exclam', description='EXCLAMATION MARK' },
	[0x0022] = { unicodeslot=0x0022, category='po', adobename='quotedbl', description='QUOTATION MARK' },
	[0x0023] = { unicodeslot=0x0023, category='po', adobename='numbersign', description='NUMBER SIGN' },
	[0x0024] = { unicodeslot=0x0024, category='sc', adobename='dollar', description='DOLLAR SIGN' },
	[0x0025] = { unicodeslot=0x0025, category='po', adobename='percent', contextname='percent', description='PERCENT SIGN' },
	[0x0026] = { unicodeslot=0x0026, category='po', adobename='ampersand', description='AMPERSAND' },
	[0x0027] = { unicodeslot=0x0027, category='po', adobename='quotesingle', description='APOSTROPHE' },
	[0x0028] = { unicodeslot=0x0028, category='ps', adobename='parenleft', description='LEFT PARENTHESIS' },
	[0x0029] = { unicodeslot=0x0029, category='pe', adobename='parenright', description='RIGHT PARENTHESIS' },
	[0x002A] = { unicodeslot=0x002A, category='po', adobename='asterisk', description='ASTERISK' },
	[0x002B] = { unicodeslot=0x002B, category='sm', adobename='plus', description='PLUS SIGN' },
	[0x002C] = { unicodeslot=0x002C, category='po', adobename='comma', description='COMMA' },
	[0x002D] = { unicodeslot=0x002D, category='pd', adobename='hyphen', description='HYPHEN-MINUS' },
	[0x002E] = { unicodeslot=0x002E, category='po', adobename='period', description='FULL STOP' },
	[0x002F] = { unicodeslot=0x002F, category='po', adobename='slash', description='SOLIDUS' },
	[0x0030] = { unicodeslot=0x0030, category='nd', adobename='zero', description='DIGIT ZERO' },
	[0x0031] = { unicodeslot=0x0031, category='nd', adobename='one', description='DIGIT ONE' },
	[0x0032] = { unicodeslot=0x0032, category='nd', adobename='two', description='DIGIT TWO' },
	[0x0033] = { unicodeslot=0x0033, category='nd', adobename='three', description='DIGIT THREE' },
	[0x0034] = { unicodeslot=0x0034, category='nd', adobename='four', description='DIGIT FOUR' },
	[0x0035] = { unicodeslot=0x0035, category='nd', adobename='five', description='DIGIT FIVE' },
	[0x0036] = { unicodeslot=0x0036, category='nd', adobename='six', description='DIGIT SIX' },
	[0x0037] = { unicodeslot=0x0037, category='nd', adobename='seven', description='DIGIT SEVEN' },
	[0x0038] = { unicodeslot=0x0038, category='nd', adobename='eight', description='DIGIT EIGHT' },
	[0x0039] = { unicodeslot=0x0039, category='nd', adobename='nine', description='DIGIT NINE' },
	[0x003A] = { unicodeslot=0x003A, category='po', adobename='colon', description='COLON' },
	[0x003B] = { unicodeslot=0x003B, category='po', adobename='semicolon', description='SEMICOLON' },
	[0x003C] = { unicodeslot=0x003C, category='sm', adobename='less', description='LESS-THAN SIGN' },
	[0x003D] = { unicodeslot=0x003D, category='sm', adobename='equal', description='EQUALS SIGN' },
	[0x003E] = { unicodeslot=0x003E, category='sm', adobename='greater', description='GREATER-THAN SIGN' },
	[0x003F] = { unicodeslot=0x003F, category='po', adobename='question', description='QUESTION MARK' },
	[0x0040] = { unicodeslot=0x0040, category='po', adobename='at', description='COMMERCIAL AT' },
	[0x0041] = { unicodeslot=0x0041, category='lu', adobename='A', description='LATIN CAPITAL LETTER A', lccode=0x0061 },
	[0x0042] = { unicodeslot=0x0042, category='lu', adobename='B', description='LATIN CAPITAL LETTER B', lccode=0x0062 },
	[0x0043] = { unicodeslot=0x0043, category='lu', adobename='C', description='LATIN CAPITAL LETTER C', lccode=0x0063 },
	[0x0044] = { unicodeslot=0x0044, category='lu', adobename='D', description='LATIN CAPITAL LETTER D', lccode=0x0064 },
	[0x0045] = { unicodeslot=0x0045, category='lu', adobename='E', description='LATIN CAPITAL LETTER E', lccode=0x0065 },
	[0x0046] = { unicodeslot=0x0046, category='lu', adobename='F', description='LATIN CAPITAL LETTER F', lccode=0x0066 },
	[0x0047] = { unicodeslot=0x0047, category='lu', adobename='G', description='LATIN CAPITAL LETTER G', lccode=0x0067 },
	[0x0048] = { unicodeslot=0x0048, category='lu', adobename='H', description='LATIN CAPITAL LETTER H', lccode=0x0068 },
	[0x0049] = { unicodeslot=0x0049, category='lu', adobename='I', description='LATIN CAPITAL LETTER I', lccode=0x0069 },
	[0x004A] = { unicodeslot=0x004A, category='lu', adobename='J', description='LATIN CAPITAL LETTER J', lccode=0x006A },
	[0x004B] = { unicodeslot=0x004B, category='lu', adobename='K', description='LATIN CAPITAL LETTER K', lccode=0x006B },
	[0x004C] = { unicodeslot=0x004C, category='lu', adobename='L', description='LATIN CAPITAL LETTER L', lccode=0x006C },
	[0x004D] = { unicodeslot=0x004D, category='lu', adobename='M', description='LATIN CAPITAL LETTER M', lccode=0x006D },
	[0x004E] = { unicodeslot=0x004E, category='lu', adobename='N', description='LATIN CAPITAL LETTER N', lccode=0x006E },
	[0x004F] = { unicodeslot=0x004F, category='lu', adobename='O', description='LATIN CAPITAL LETTER O', lccode=0x006F },
	[0x0050] = { unicodeslot=0x0050, category='lu', adobename='P', description='LATIN CAPITAL LETTER P', lccode=0x0070 },
	[0x0051] = { unicodeslot=0x0051, category='lu', adobename='Q', description='LATIN CAPITAL LETTER Q', lccode=0x0071 },
	[0x0052] = { unicodeslot=0x0052, category='lu', adobename='R', description='LATIN CAPITAL LETTER R', lccode=0x0072 },
	[0x0053] = { unicodeslot=0x0053, category='lu', adobename='S', description='LATIN CAPITAL LETTER S', lccode=0x0073 },
	[0x0054] = { unicodeslot=0x0054, category='lu', adobename='T', description='LATIN CAPITAL LETTER T', lccode=0x0074 },
	[0x0055] = { unicodeslot=0x0055, category='lu', adobename='U', description='LATIN CAPITAL LETTER U', lccode=0x0075 },
	[0x0056] = { unicodeslot=0x0056, category='lu', adobename='V', description='LATIN CAPITAL LETTER V', lccode=0x0076 },
	[0x0057] = { unicodeslot=0x0057, category='lu', adobename='W', description='LATIN CAPITAL LETTER W', lccode=0x0077 },
	[0x0058] = { unicodeslot=0x0058, category='lu', adobename='X', description='LATIN CAPITAL LETTER X', lccode=0x0078 },
	[0x0059] = { unicodeslot=0x0059, category='lu', adobename='Y', description='LATIN CAPITAL LETTER Y', lccode=0x0079 },
	[0x005A] = { unicodeslot=0x005A, category='lu', adobename='Z', description='LATIN CAPITAL LETTER Z', lccode=0x007A },
	[0x005B] = { unicodeslot=0x005B, category='ps', adobename='bracketleft', description='LEFT SQUARE BRACKET' },
	[0x005C] = { unicodeslot=0x005C, category='po', adobename='backslash', contextname='textbackslash', description='REVERSE SOLIDUS' },
	[0x005D] = { unicodeslot=0x005D, category='pe', adobename='bracketright', description='RIGHT SQUARE BRACKET' },
	[0x005E] = { unicodeslot=0x005E, category='sk', adobename='asciicircum', contextname='textasciicircum', description='CIRCUMFLEX ACCENT' },
	[0x005F] = { unicodeslot=0x005F, category='pc', adobename='underscore', contextname='textunderscore', description='LOW LINE' },
	[0x0060] = { unicodeslot=0x0060, category='sk', adobename='grave', contextname='textgrave', description='GRAVE ACCENT' },
	[0x0061] = { unicodeslot=0x0061, category='ll', adobename='a', description='LATIN SMALL LETTER A', uccode=0x0041 },
	[0x0062] = { unicodeslot=0x0062, category='ll', adobename='b', description='LATIN SMALL LETTER B', uccode=0x0042 },
	[0x0063] = { unicodeslot=0x0063, category='ll', adobename='c', description='LATIN SMALL LETTER C', uccode=0x0043 },
	[0x0064] = { unicodeslot=0x0064, category='ll', adobename='d', description='LATIN SMALL LETTER D', uccode=0x0044 },
	[0x0065] = { unicodeslot=0x0065, category='ll', adobename='e', description='LATIN SMALL LETTER E', uccode=0x0045 },
	[0x0066] = { unicodeslot=0x0066, category='ll', adobename='f', description='LATIN SMALL LETTER F', uccode=0x0046 },
	[0x0067] = { unicodeslot=0x0067, category='ll', adobename='g', description='LATIN SMALL LETTER G', uccode=0x0047 },
	[0x0068] = { unicodeslot=0x0068, category='ll', adobename='h', description='LATIN SMALL LETTER H', uccode=0x0048 },
	[0x0069] = { unicodeslot=0x0069, category='ll', adobename='i', description='LATIN SMALL LETTER I', uccode=0x0049 },
	[0x006A] = { unicodeslot=0x006A, category='ll', adobename='j', description='LATIN SMALL LETTER J', uccode=0x004A },
	[0x006B] = { unicodeslot=0x006B, category='ll', adobename='k', description='LATIN SMALL LETTER K', uccode=0x004B },
	[0x006C] = { unicodeslot=0x006C, category='ll', adobename='l', description='LATIN SMALL LETTER L', uccode=0x004C },
	[0x006D] = { unicodeslot=0x006D, category='ll', adobename='m', description='LATIN SMALL LETTER M', uccode=0x004D },
	[0x006E] = { unicodeslot=0x006E, category='ll', adobename='n', description='LATIN SMALL LETTER N', uccode=0x004E },
	[0x006F] = { unicodeslot=0x006F, category='ll', adobename='o', description='LATIN SMALL LETTER O', uccode=0x004F },
	[0x0070] = { unicodeslot=0x0070, category='ll', adobename='p', description='LATIN SMALL LETTER P', uccode=0x0050 },
	[0x0071] = { unicodeslot=0x0071, category='ll', adobename='q', description='LATIN SMALL LETTER Q', uccode=0x0051 },
	[0x0072] = { unicodeslot=0x0072, category='ll', adobename='r', description='LATIN SMALL LETTER R', uccode=0x0052 },
	[0x0073] = { unicodeslot=0x0073, category='ll', adobename='s', description='LATIN SMALL LETTER S', uccode=0x0053 },
	[0x0074] = { unicodeslot=0x0074, category='ll', adobename='t', description='LATIN SMALL LETTER T', uccode=0x0054 },
	[0x0075] = { unicodeslot=0x0075, category='ll', adobename='u', description='LATIN SMALL LETTER U', uccode=0x0055 },
	[0x0076] = { unicodeslot=0x0076, category='ll', adobename='v', description='LATIN SMALL LETTER V', uccode=0x0056 },
	[0x0077] = { unicodeslot=0x0077, category='ll', adobename='w', description='LATIN SMALL LETTER W', uccode=0x0057 },
	[0x0078] = { unicodeslot=0x0078, category='ll', adobename='x', description='LATIN SMALL LETTER X', uccode=0x0058 },
	[0x0079] = { unicodeslot=0x0079, category='ll', adobename='y', description='LATIN SMALL LETTER Y', uccode=0x0059 },
	[0x007A] = { unicodeslot=0x007A, category='ll', adobename='z', description='LATIN SMALL LETTER Z', uccode=0x005A },
	[0x007B] = { unicodeslot=0x007B, category='ps', adobename='braceleft', contextname='textbraceleft', description='LEFT CURLY BRACKET' },
	[0x007C] = { unicodeslot=0x007C, category='sm', adobename='bar', description='VERTICAL LINE' },
	[0x007D] = { unicodeslot=0x007D, category='pe', adobename='braceright', contextname='textbraceright', description='RIGHT CURLY BRACKET' },
	[0x007E] = { unicodeslot=0x007E, category='sm', adobename='asciitilde', contextname='textasciitilde', description='TILDE' },
	[0x007F] = { unicodeslot=0x007F, category='cc', description='DELETE' },
	[0x0080] = { unicodeslot=0x0080, category='cc' },
	[0x0081] = { unicodeslot=0x0081, category='cc' },
	[0x0082] = { unicodeslot=0x0082, category='cc', description='BREAK PERMITTED HERE' },
	[0x0083] = { unicodeslot=0x0083, category='cc', description='NO BREAK HERE' },
	[0x0084] = { unicodeslot=0x0084, category='cc' },
	[0x0085] = { unicodeslot=0x0085, category='cc', description='NEXT LINE (NEL)' },
	[0x0086] = { unicodeslot=0x0086, category='cc', description='START OF SELECTED AREA' },
	[0x0087] = { unicodeslot=0x0087, category='cc', description='END OF SELECTED AREA' },
	[0x0088] = { unicodeslot=0x0088, category='cc', description='CHARACTER TABULATION SET' },
	[0x0089] = { unicodeslot=0x0089, category='cc', description='CHARACTER TABULATION WITH JUSTIFICATION' },
	[0x008A] = { unicodeslot=0x008A, category='cc', description='LINE TABULATION SET' },
	[0x008B] = { unicodeslot=0x008B, category='cc', description='PARTIAL LINE FORWARD' },
	[0x008C] = { unicodeslot=0x008C, category='cc', description='PARTIAL LINE BACKWARD' },
	[0x008D] = { unicodeslot=0x008D, category='cc', description='REVERSE LINE FEED' },
	[0x008E] = { unicodeslot=0x008E, category='cc', description='SINGLE SHIFT TWO' },
	[0x008F] = { unicodeslot=0x008F, category='cc', description='SINGLE SHIFT THREE' },
	[0x0090] = { unicodeslot=0x0090, category='cc', description='DEVICE CONTROL STRING' },
	[0x0091] = { unicodeslot=0x0091, category='cc', description='PRIVATE USE ONE' },
	[0x0092] = { unicodeslot=0x0092, category='cc', description='PRIVATE USE TWO' },
	[0x0093] = { unicodeslot=0x0093, category='cc', description='SET TRANSMIT STATE' },
	[0x0094] = { unicodeslot=0x0094, category='cc', description='CANCEL CHARACTER' },
	[0x0095] = { unicodeslot=0x0095, category='cc', description='MESSAGE WAITING' },
	[0x0096] = { unicodeslot=0x0096, category='cc', description='START OF GUARDED AREA' },
	[0x0097] = { unicodeslot=0x0097, category='cc', description='END OF GUARDED AREA' },
	[0x0098] = { unicodeslot=0x0098, category='cc', description='START OF STRING' },
	[0x0099] = { unicodeslot=0x0099, category='cc' },
	[0x009A] = { unicodeslot=0x009A, category='cc', description='SINGLE CHARACTER INTRODUCER' },
	[0x009B] = { unicodeslot=0x009B, category='cc', description='CONTROL SEQUENCE INTRODUCER' },
	[0x009C] = { unicodeslot=0x009C, category='cc', description='STRING TERMINATOR' },
	[0x009D] = { unicodeslot=0x009D, category='cc', description='OPERATING SYSTEM COMMAND' },
	[0x009E] = { unicodeslot=0x009E, category='cc', description='PRIVACY MESSAGE' },
	[0x009F] = { unicodeslot=0x009F, category='cc', description='APPLICATION PROGRAM COMMAND' },
	[0x00A0] = { unicodeslot=0x00A0, category='zs', contextname='nonbreakablespace', description='NO-BREAK SPACE', specials={'nobreak',0x0020} },
	[0x00A1] = { unicodeslot=0x00A1, category='po', adobename='exclamdown', contextname='exclamdown', description='INVERTED EXCLAMATION MARK' },
	[0x00A2] = { unicodeslot=0x00A2, category='sc', adobename='cent', contextname='textcent', description='CENT SIGN' },
	[0x00A3] = { unicodeslot=0x00A3, category='sc', adobename='sterling', contextname='textsterling', description='POUND SIGN' },
	[0x00A4] = { unicodeslot=0x00A4, category='sc', adobename='currency', contextname='textcurrency', description='CURRENCY SIGN' },
	[0x00A5] = { unicodeslot=0x00A5, category='sc', adobename='yen', contextname='textyen', description='YEN SIGN' },
	[0x00A6] = { unicodeslot=0x00A6, category='so', adobename='brokenbar', contextname='textbrokenbar', description='BROKEN BAR' },
	[0x00A7] = { unicodeslot=0x00A7, category='so', adobename='section', contextname='sectionmark', description='SECTION SIGN' },
	[0x00A8] = { unicodeslot=0x00A8, category='sk', adobename='dieresis', contextname='textdiaeresis', description='DIAERESIS', specials={'compat',0x0020,0x0308} },
	[0x00A9] = { unicodeslot=0x00A9, category='so', adobename='copyright', contextname='copyright', description='COPYRIGHT SIGN' },
	[0x00AA] = { unicodeslot=0x00AA, category='ll', adobename='ordfeminine', contextname='ordfeminine', description='FEMININE ORDINAL INDICATOR', specials={'super',0x0061} },
	[0x00AB] = { unicodeslot=0x00AB, category='pi', adobename='guillemotleft', contextname='leftguillemot', description='LEFT-POINTING DOUBLE ANGLE QUOTATION MARK' },
	[0x00AC] = { unicodeslot=0x00AC, category='sm', adobename='logicalnot', contextname='textlognot', description='NOT SIGN' },
	[0x00AD] = { unicodeslot=0x00AD, category='cf', contextname='softhyphen', description='SOFT HYPHEN' },
	[0x00AE] = { unicodeslot=0x00AE, category='so', adobename='registered', contextname='registered', description='REGISTERED SIGN' },
	[0x00AF] = { unicodeslot=0x00AF, category='sk', adobename='macron', contextname='textmacron', description='MACRON', specials={'compat',0x0020,0x0304} },
	[0x00B0] = { unicodeslot=0x00B0, category='so', adobename='degree', contextname='textdegree', description='DEGREE SIGN' },
	[0x00B1] = { unicodeslot=0x00B1, category='sm', adobename='plusminus', contextname='textpm', description='PLUS-MINUS SIGN' },
	[0x00B2] = { unicodeslot=0x00B2, category='no', contextname='twosuperior', description='SUPERSCRIPT TWO', specials={'super',0x0032} },
	[0x00B3] = { unicodeslot=0x00B3, category='no', contextname='threesuperior', description='SUPERSCRIPT THREE', specials={'super',0x0033} },
	[0x00B4] = { unicodeslot=0x00B4, category='sk', adobename='acute', contextname='textacute', description='ACUTE ACCENT', specials={'compat',0x0020,0x0301} },
	[0x00B5] = { unicodeslot=0x00B5, category='ll', adobename='mu', contextname='textmu', description='MICRO SIGN', uccode=0x039C, specials={'compat',0x03BC} },
	[0x00B6] = { unicodeslot=0x00B6, category='so', adobename='paragraph', contextname='paragraphmark', description='PILCROW SIGN' },
	[0x00B7] = { unicodeslot=0x00B7, category='po', adobename='periodcentered', contextname='periodcentered', description='MIDDLE DOT' },
	[0x00B8] = { unicodeslot=0x00B8, category='sk', adobename='cedilla', contextname='textcedilla', description='CEDILLA', specials={'compat',0x0020,0x0327} },
	[0x00B9] = { unicodeslot=0x00B9, category='no', contextname='onesuperior', description='SUPERSCRIPT ONE', specials={'super',0x0031} },
	[0x00BA] = { unicodeslot=0x00BA, category='ll', adobename='ordmasculine', contextname='ordmasculine', description='MASCULINE ORDINAL INDICATOR', specials={'super',0x006F} },
	[0x00BB] = { unicodeslot=0x00BB, category='pf', adobename='guillemotright', contextname='rightguillemot', description='RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK' },
	[0x00BC] = { unicodeslot=0x00BC, category='no', adobename='onequarter', contextname='onequarter', description='VULGAR FRACTION ONE QUARTER', specials={'fraction',0x0031,0x2044,0x0034} },
	[0x00BD] = { unicodeslot=0x00BD, category='no', adobename='onehalf', contextname='onehalf', description='VULGAR FRACTION ONE HALF', specials={'fraction',0x0031,0x2044,0x0032} },
	[0x00BE] = { unicodeslot=0x00BE, category='no', adobename='threequarters', contextname='threequarter', description='VULGAR FRACTION THREE QUARTERS', specials={'fraction',0x0033,0x2044,0x0034} },
	[0x00BF] = { unicodeslot=0x00BF, category='po', adobename='questiondown', contextname='questiondown', description='INVERTED QUESTION MARK' },
	[0x00C0] = { unicodeslot=0x00C0, category='lu', adobename='Agrave', contextname='Agrave', description='LATIN CAPITAL LETTER A WITH GRAVE', shcode=0x0041, lccode=0x00E0, specials={'char',0x0041,0x0300} },
	[0x00C1] = { unicodeslot=0x00C1, category='lu', adobename='Aacute', contextname='Aacute', description='LATIN CAPITAL LETTER A WITH ACUTE', shcode=0x0041, lccode=0x00E1, specials={'char',0x0041,0x0301} },
	[0x00C2] = { unicodeslot=0x00C2, category='lu', adobename='Acircumflex', contextname='Acircumflex', description='LATIN CAPITAL LETTER A WITH CIRCUMFLEX', shcode=0x0041, lccode=0x00E2, specials={'char',0x0041,0x0302} },
	[0x00C3] = { unicodeslot=0x00C3, category='lu', adobename='Atilde', contextname='Atilde', description='LATIN CAPITAL LETTER A WITH TILDE', shcode=0x0041, lccode=0x00E3, specials={'char',0x0041,0x0303} },
	[0x00C4] = { unicodeslot=0x00C4, category='lu', adobename='Adieresis', contextname='Adiaeresis', description='LATIN CAPITAL LETTER A WITH DIAERESIS', shcode=0x0041, lccode=0x00E4, specials={'char',0x0041,0x0308} },
	[0x00C5] = { unicodeslot=0x00C5, category='lu', adobename='Aring', contextname='Aring', description='LATIN CAPITAL LETTER A WITH RING ABOVE', shcode=0x0041, lccode=0x00E5, specials={'char',0x0041,0x030A} },
	[0x00C6] = { unicodeslot=0x00C6, category='lu', adobename='AE', contextname='AEligature', description='LATIN CAPITAL LETTER AE', lccode=0x00E6 },
	[0x00C7] = { unicodeslot=0x00C7, category='lu', adobename='Ccedilla', contextname='Ccedilla', description='LATIN CAPITAL LETTER C WITH CEDILLA', shcode=0x0043, lccode=0x00E7, specials={'char',0x0043,0x0327} },
	[0x00C8] = { unicodeslot=0x00C8, category='lu', adobename='Egrave', contextname='Egrave', description='LATIN CAPITAL LETTER E WITH GRAVE', shcode=0x0045, lccode=0x00E8, specials={'char',0x0045,0x0300} },
	[0x00C9] = { unicodeslot=0x00C9, category='lu', adobename='Eacute', contextname='Eacute', description='LATIN CAPITAL LETTER E WITH ACUTE', shcode=0x0045, lccode=0x00E9, specials={'char',0x0045,0x0301} },
	[0x00CA] = { unicodeslot=0x00CA, category='lu', adobename='Ecircumflex', contextname='Ecircumflex', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX', shcode=0x0045, lccode=0x00EA, specials={'char',0x0045,0x0302} },
	[0x00CB] = { unicodeslot=0x00CB, category='lu', adobename='Edieresis', contextname='Ediaeresis', description='LATIN CAPITAL LETTER E WITH DIAERESIS', shcode=0x0045, lccode=0x00EB, specials={'char',0x0045,0x0308} },
	[0x00CC] = { unicodeslot=0x00CC, category='lu', adobename='Igrave', contextname='Igrave', description='LATIN CAPITAL LETTER I WITH GRAVE', shcode=0x0049, lccode=0x00EC, specials={'char',0x0049,0x0300} },
	[0x00CD] = { unicodeslot=0x00CD, category='lu', adobename='Iacute', contextname='Iacute', description='LATIN CAPITAL LETTER I WITH ACUTE', shcode=0x0049, lccode=0x00ED, specials={'char',0x0049,0x0301} },
	[0x00CE] = { unicodeslot=0x00CE, category='lu', adobename='Icircumflex', contextname='Icircumflex', description='LATIN CAPITAL LETTER I WITH CIRCUMFLEX', shcode=0x0049, lccode=0x00EE, specials={'char',0x0049,0x0302} },
	[0x00CF] = { unicodeslot=0x00CF, category='lu', adobename='Idieresis', contextname='Idiaeresis', description='LATIN CAPITAL LETTER I WITH DIAERESIS', shcode=0x0049, lccode=0x00EF, specials={'char',0x0049,0x0308} },
	[0x00D0] = { unicodeslot=0x00D0, category='lu', adobename='Eth', contextname='Eth', description='LATIN CAPITAL LETTER ETH', lccode=0x00F0 },
	[0x00D1] = { unicodeslot=0x00D1, category='lu', adobename='Ntilde', contextname='Ntilde', description='LATIN CAPITAL LETTER N WITH TILDE', shcode=0x004E, lccode=0x00F1, specials={'char',0x004E,0x0303} },
	[0x00D2] = { unicodeslot=0x00D2, category='lu', adobename='Ograve', contextname='Ograve', description='LATIN CAPITAL LETTER O WITH GRAVE', shcode=0x004F, lccode=0x00F2, specials={'char',0x004F,0x0300} },
	[0x00D3] = { unicodeslot=0x00D3, category='lu', adobename='Oacute', contextname='Oacute', description='LATIN CAPITAL LETTER O WITH ACUTE', shcode=0x004F, lccode=0x00F3, specials={'char',0x004F,0x0301} },
	[0x00D4] = { unicodeslot=0x00D4, category='lu', adobename='Ocircumflex', contextname='Ocircumflex', description='LATIN CAPITAL LETTER O WITH CIRCUMFLEX', shcode=0x004F, lccode=0x00F4, specials={'char',0x004F,0x0302} },
	[0x00D5] = { unicodeslot=0x00D5, category='lu', adobename='Otilde', contextname='Otilde', description='LATIN CAPITAL LETTER O WITH TILDE', shcode=0x004F, lccode=0x00F5, specials={'char',0x004F,0x0303} },
	[0x00D6] = { unicodeslot=0x00D6, category='lu', adobename='Odieresis', contextname='Odiaeresis', description='LATIN CAPITAL LETTER O WITH DIAERESIS', shcode=0x004F, lccode=0x00F6, specials={'char',0x004F,0x0308} },
	[0x00D7] = { unicodeslot=0x00D7, category='sm', adobename='multiply', contextname='textmultiply', description='MULTIPLICATION SIGN' },
	[0x00D8] = { unicodeslot=0x00D8, category='lu', adobename='Oslash', contextname='Ostroke', description='LATIN CAPITAL LETTER O WITH STROKE', shcode=0x004F, lccode=0x00F8 },
	[0x00D9] = { unicodeslot=0x00D9, category='lu', adobename='Ugrave', contextname='Ugrave', description='LATIN CAPITAL LETTER U WITH GRAVE', shcode=0x0055, lccode=0x00F9, specials={'char',0x0055,0x0300} },
	[0x00DA] = { unicodeslot=0x00DA, category='lu', adobename='Uacute', contextname='Uacute', description='LATIN CAPITAL LETTER U WITH ACUTE', shcode=0x0055, lccode=0x00FA, specials={'char',0x0055,0x0301} },
	[0x00DB] = { unicodeslot=0x00DB, category='lu', adobename='Ucircumflex', contextname='Ucircumflex', description='LATIN CAPITAL LETTER U WITH CIRCUMFLEX', shcode=0x0055, lccode=0x00FB, specials={'char',0x0055,0x0302} },
	[0x00DC] = { unicodeslot=0x00DC, category='lu', adobename='Udieresis', contextname='Udiaeresis', description='LATIN CAPITAL LETTER U WITH DIAERESIS', shcode=0x0055, lccode=0x00FC, specials={'char',0x0055,0x0308} },
	[0x00DD] = { unicodeslot=0x00DD, category='lu', adobename='Yacute', contextname='Yacute', description='LATIN CAPITAL LETTER Y WITH ACUTE', shcode=0x0059, lccode=0x00FD, specials={'char',0x0059,0x0301} },
	[0x00DE] = { unicodeslot=0x00DE, category='lu', adobename='Thorn', contextname='Thorn', description='LATIN CAPITAL LETTER THORN', lccode=0x00FE },
	[0x00DF] = { unicodeslot=0x00DF, category='ll', adobename='germandbls', contextname='ssharp', description='LATIN SMALL LETTER SHARP S' },
	[0x00E0] = { unicodeslot=0x00E0, category='ll', adobename='agrave', contextname='agrave', description='LATIN SMALL LETTER A WITH GRAVE', shcode=0x0061, uccode=0x00C0, specials={'char',0x0061,0x0300} },
	[0x00E1] = { unicodeslot=0x00E1, category='ll', adobename='aacute', contextname='aacute', description='LATIN SMALL LETTER A WITH ACUTE', shcode=0x0061, uccode=0x00C1, specials={'char',0x0061,0x0301} },
	[0x00E2] = { unicodeslot=0x00E2, category='ll', adobename='acircumflex', contextname='acircumflex', description='LATIN SMALL LETTER A WITH CIRCUMFLEX', shcode=0x0061, uccode=0x00C2, specials={'char',0x0061,0x0302} },
	[0x00E3] = { unicodeslot=0x00E3, category='ll', adobename='atilde', contextname='atilde', description='LATIN SMALL LETTER A WITH TILDE', shcode=0x0061, uccode=0x00C3, specials={'char',0x0061,0x0303} },
	[0x00E4] = { unicodeslot=0x00E4, category='ll', adobename='adieresis', contextname='adiaeresis', description='LATIN SMALL LETTER A WITH DIAERESIS', shcode=0x0061, uccode=0x00C4, specials={'char',0x0061,0x0308} },
	[0x00E5] = { unicodeslot=0x00E5, category='ll', adobename='aring', contextname='aring', description='LATIN SMALL LETTER A WITH RING ABOVE', shcode=0x0061, uccode=0x00C5, specials={'char',0x0061,0x030A} },
	[0x00E6] = { unicodeslot=0x00E6, category='ll', adobename='ae', contextname='aeligature', description='LATIN SMALL LETTER AE', uccode=0x00C6 },
	[0x00E7] = { unicodeslot=0x00E7, category='ll', adobename='ccedilla', contextname='ccedilla', description='LATIN SMALL LETTER C WITH CEDILLA', shcode=0x0063, uccode=0x00C7, specials={'char',0x0063,0x0327} },
	[0x00E8] = { unicodeslot=0x00E8, category='ll', adobename='egrave', contextname='egrave', description='LATIN SMALL LETTER E WITH GRAVE', shcode=0x0065, uccode=0x00C8, specials={'char',0x0065,0x0300} },
	[0x00E9] = { unicodeslot=0x00E9, category='ll', adobename='eacute', contextname='eacute', description='LATIN SMALL LETTER E WITH ACUTE', shcode=0x0065, uccode=0x00C9, specials={'char',0x0065,0x0301} },
	[0x00EA] = { unicodeslot=0x00EA, category='ll', adobename='ecircumflex', contextname='ecircumflex', description='LATIN SMALL LETTER E WITH CIRCUMFLEX', shcode=0x0065, uccode=0x00CA, specials={'char',0x0065,0x0302} },
	[0x00EB] = { unicodeslot=0x00EB, category='ll', adobename='edieresis', contextname='ediaeresis', description='LATIN SMALL LETTER E WITH DIAERESIS', shcode=0x0065, uccode=0x00CB, specials={'char',0x0065,0x0308} },
	[0x00EC] = { unicodeslot=0x00EC, category='ll', adobename='igrave', contextname='igrave', description='LATIN SMALL LETTER I WITH GRAVE', shcode=0x0069, uccode=0x00CC, specials={'char',0x0069,0x0300} },
	[0x00ED] = { unicodeslot=0x00ED, category='ll', adobename='iacute', contextname='iacute', description='LATIN SMALL LETTER I WITH ACUTE', shcode=0x0069, uccode=0x00CD, specials={'char',0x0069,0x0301} },
	[0x00EE] = { unicodeslot=0x00EE, category='ll', adobename='icircumflex', contextname='icircumflex', description='LATIN SMALL LETTER I WITH CIRCUMFLEX', shcode=0x0069, uccode=0x00CE, specials={'char',0x0069,0x0302} },
	[0x00EF] = { unicodeslot=0x00EF, category='ll', adobename='idieresis', contextname='idiaeresis', description='LATIN SMALL LETTER I WITH DIAERESIS', shcode=0x0069, uccode=0x00CF, specials={'char',0x0069,0x0308} },
	[0x00F0] = { unicodeslot=0x00F0, category='ll', adobename='eth', contextname='eth', description='LATIN SMALL LETTER ETH', uccode=0x00D0 },
	[0x00F1] = { unicodeslot=0x00F1, category='ll', adobename='ntilde', contextname='ntilde', description='LATIN SMALL LETTER N WITH TILDE', shcode=0x006E, uccode=0x00D1, specials={'char',0x006E,0x0303} },
	[0x00F2] = { unicodeslot=0x00F2, category='ll', adobename='ograve', contextname='ograve', description='LATIN SMALL LETTER O WITH GRAVE', shcode=0x006F, uccode=0x00D2, specials={'char',0x006F,0x0300} },
	[0x00F3] = { unicodeslot=0x00F3, category='ll', adobename='oacute', contextname='oacute', description='LATIN SMALL LETTER O WITH ACUTE', shcode=0x006F, uccode=0x00D3, specials={'char',0x006F,0x0301} },
	[0x00F4] = { unicodeslot=0x00F4, category='ll', adobename='ocircumflex', contextname='ocircumflex', description='LATIN SMALL LETTER O WITH CIRCUMFLEX', shcode=0x006F, uccode=0x00D4, specials={'char',0x006F,0x0302} },
	[0x00F5] = { unicodeslot=0x00F5, category='ll', adobename='otilde', contextname='otilde', description='LATIN SMALL LETTER O WITH TILDE', shcode=0x006F, uccode=0x00D5, specials={'char',0x006F,0x0303} },
	[0x00F6] = { unicodeslot=0x00F6, category='ll', adobename='odieresis', contextname='odiaeresis', description='LATIN SMALL LETTER O WITH DIAERESIS', shcode=0x006F, uccode=0x00D6, specials={'char',0x006F,0x0308} },
	[0x00F7] = { unicodeslot=0x00F7, category='sm', adobename='divide', contextname='textdiv', description='DIVISION SIGN' },
	[0x00F8] = { unicodeslot=0x00F8, category='ll', adobename='oslash', contextname='ostroke', description='LATIN SMALL LETTER O WITH STROKE', shcode=0x006F, uccode=0x00D8 },
	[0x00F9] = { unicodeslot=0x00F9, category='ll', adobename='ugrave', contextname='ugrave', description='LATIN SMALL LETTER U WITH GRAVE', shcode=0x0075, uccode=0x00D9, specials={'char',0x0075,0x0300} },
	[0x00FA] = { unicodeslot=0x00FA, category='ll', adobename='uacute', contextname='uacute', description='LATIN SMALL LETTER U WITH ACUTE', shcode=0x0075, uccode=0x00DA, specials={'char',0x0075,0x0301} },
	[0x00FB] = { unicodeslot=0x00FB, category='ll', adobename='ucircumflex', contextname='ucircumflex', description='LATIN SMALL LETTER U WITH CIRCUMFLEX', shcode=0x0075, uccode=0x00DB, specials={'char',0x0075,0x0302} },
	[0x00FC] = { unicodeslot=0x00FC, category='ll', adobename='udieresis', contextname='udiaeresis', description='LATIN SMALL LETTER U WITH DIAERESIS', shcode=0x0075, uccode=0x00DC, specials={'char',0x0075,0x0308} },
	[0x00FD] = { unicodeslot=0x00FD, category='ll', adobename='yacute', contextname='yacute', description='LATIN SMALL LETTER Y WITH ACUTE', shcode=0x0079, uccode=0x00DD, specials={'char',0x0079,0x0301} },
	[0x00FE] = { unicodeslot=0x00FE, category='ll', adobename='thorn', contextname='thorn', description='LATIN SMALL LETTER THORN', uccode=0x00DE },
	[0x00FF] = { unicodeslot=0x00FF, category='ll', adobename='ydieresis', contextname='ydiaeresis', description='LATIN SMALL LETTER Y WITH DIAERESIS', shcode=0x0079, uccode=0x0178, specials={'char',0x0079,0x0308} },
	[0x0100] = { unicodeslot=0x0100, category='lu', adobename='Amacron', contextname='Amacron', description='LATIN CAPITAL LETTER A WITH MACRON', shcode=0x0041, lccode=0x0101, specials={'char',0x0041,0x0304} },
	[0x0101] = { unicodeslot=0x0101, category='ll', adobename='amacron', contextname='amacron', description='LATIN SMALL LETTER A WITH MACRON', shcode=0x0061, uccode=0x0100, specials={'char',0x0061,0x0304} },
	[0x0102] = { unicodeslot=0x0102, category='lu', adobename='Abreve', contextname='Abreve', description='LATIN CAPITAL LETTER A WITH BREVE', shcode=0x0041, lccode=0x0103, specials={'char',0x0041,0x0306} },
	[0x0103] = { unicodeslot=0x0103, category='ll', adobename='abreve', contextname='abreve', description='LATIN SMALL LETTER A WITH BREVE', shcode=0x0061, uccode=0x0102, specials={'char',0x0061,0x0306} },
	[0x0104] = { unicodeslot=0x0104, category='lu', adobename='Aogonek', contextname='Aogonek', description='LATIN CAPITAL LETTER A WITH OGONEK', shcode=0x0041, lccode=0x0105, specials={'char',0x0041,0x0328} },
	[0x0105] = { unicodeslot=0x0105, category='ll', adobename='aogonek', contextname='aogonek', description='LATIN SMALL LETTER A WITH OGONEK', shcode=0x0061, uccode=0x0104, specials={'char',0x0061,0x0328} },
	[0x0106] = { unicodeslot=0x0106, category='lu', adobename='Cacute', contextname='Cacute', description='LATIN CAPITAL LETTER C WITH ACUTE', shcode=0x0043, lccode=0x0107, specials={'char',0x0043,0x0301} },
	[0x0107] = { unicodeslot=0x0107, category='ll', adobename='cacute', contextname='cacute', description='LATIN SMALL LETTER C WITH ACUTE', shcode=0x0063, uccode=0x0106, specials={'char',0x0063,0x0301} },
	[0x0108] = { unicodeslot=0x0108, category='lu', adobename='Ccircumflex', contextname='Ccircumflex', description='LATIN CAPITAL LETTER C WITH CIRCUMFLEX', shcode=0x0043, lccode=0x0109, specials={'char',0x0043,0x0302} },
	[0x0109] = { unicodeslot=0x0109, category='ll', adobename='ccircumflex', contextname='ccircumflex', description='LATIN SMALL LETTER C WITH CIRCUMFLEX', shcode=0x0063, uccode=0x0108, specials={'char',0x0063,0x0302} },
	[0x010A] = { unicodeslot=0x010A, category='lu', adobename='Cdotaccent', contextname='Cdotaccent', description='LATIN CAPITAL LETTER C WITH DOT ABOVE', shcode=0x0043, lccode=0x010B, specials={'char',0x0043,0x0307} },
	[0x010B] = { unicodeslot=0x010B, category='ll', adobename='cdotaccent', contextname='cdotaccent', description='LATIN SMALL LETTER C WITH DOT ABOVE', shcode=0x0063, uccode=0x010A, specials={'char',0x0063,0x0307} },
	[0x010C] = { unicodeslot=0x010C, category='lu', adobename='Ccaron', contextname='Ccaron', description='LATIN CAPITAL LETTER C WITH CARON', shcode=0x0043, lccode=0x010D, specials={'char',0x0043,0x030C} },
	[0x010D] = { unicodeslot=0x010D, category='ll', adobename='ccaron', contextname='ccaron', description='LATIN SMALL LETTER C WITH CARON', shcode=0x0063, uccode=0x010C, specials={'char',0x0063,0x030C} },
	[0x010E] = { unicodeslot=0x010E, category='lu', adobename='Dcaron', contextname='Dcaron', description='LATIN CAPITAL LETTER D WITH CARON', shcode=0x0044, lccode=0x010F, specials={'char',0x0044,0x030C} },
	[0x010F] = { unicodeslot=0x010F, category='ll', adobename='dcaron', contextname='dcaron', description='LATIN SMALL LETTER D WITH CARON', shcode=0x0064, uccode=0x010E, specials={'char',0x0064,0x030C} },
	[0x0110] = { unicodeslot=0x0110, category='lu', adobename='Dcroat', contextname='Dstroke', description='LATIN CAPITAL LETTER D WITH STROKE', shcode=0x0044, lccode=0x0111 },
	[0x0111] = { unicodeslot=0x0111, category='ll', adobename='dcroat', contextname='dstroke', description='LATIN SMALL LETTER D WITH STROKE', shcode=0x0064, uccode=0x0110 },
	[0x0112] = { unicodeslot=0x0112, category='lu', adobename='Emacron', contextname='Emacron', description='LATIN CAPITAL LETTER E WITH MACRON', shcode=0x0045, lccode=0x0113, specials={'char',0x0045,0x0304} },
	[0x0113] = { unicodeslot=0x0113, category='ll', adobename='emacron', contextname='emacron', description='LATIN SMALL LETTER E WITH MACRON', shcode=0x0065, uccode=0x0112, specials={'char',0x0065,0x0304} },
	[0x0114] = { unicodeslot=0x0114, category='lu', adobename='Ebreve', contextname='Ebreve', description='LATIN CAPITAL LETTER E WITH BREVE', shcode=0x0045, lccode=0x0115, specials={'char',0x0045,0x0306} },
	[0x0115] = { unicodeslot=0x0115, category='ll', adobename='ebreve', contextname='ebreve', description='LATIN SMALL LETTER E WITH BREVE', shcode=0x0065, uccode=0x0114, specials={'char',0x0065,0x0306} },
	[0x0116] = { unicodeslot=0x0116, category='lu', adobename='Edotaccent', contextname='Edotaccent', description='LATIN CAPITAL LETTER E WITH DOT ABOVE', shcode=0x0045, lccode=0x0117, specials={'char',0x0045,0x0307} },
	[0x0117] = { unicodeslot=0x0117, category='ll', adobename='edotaccent', contextname='edotaccent', description='LATIN SMALL LETTER E WITH DOT ABOVE', shcode=0x0065, uccode=0x0116, specials={'char',0x0065,0x0307} },
	[0x0118] = { unicodeslot=0x0118, category='lu', adobename='Eogonek', contextname='Eogonek', description='LATIN CAPITAL LETTER E WITH OGONEK', shcode=0x0045, lccode=0x0119, specials={'char',0x0045,0x0328} },
	[0x0119] = { unicodeslot=0x0119, category='ll', adobename='eogonek', contextname='eogonek', description='LATIN SMALL LETTER E WITH OGONEK', shcode=0x0065, uccode=0x0118, specials={'char',0x0065,0x0328} },
	[0x011A] = { unicodeslot=0x011A, category='lu', adobename='Ecaron', contextname='Ecaron', description='LATIN CAPITAL LETTER E WITH CARON', shcode=0x0045, lccode=0x011B, specials={'char',0x0045,0x030C} },
	[0x011B] = { unicodeslot=0x011B, category='ll', adobename='ecaron', contextname='ecaron', description='LATIN SMALL LETTER E WITH CARON', shcode=0x0065, uccode=0x011A, specials={'char',0x0065,0x030C} },
	[0x011C] = { unicodeslot=0x011C, category='lu', adobename='Gcircumflex', contextname='Gcircumflex', description='LATIN CAPITAL LETTER G WITH CIRCUMFLEX', shcode=0x0047, lccode=0x011D, specials={'char',0x0047,0x0302} },
	[0x011D] = { unicodeslot=0x011D, category='ll', adobename='gcircumflex', contextname='gcircumflex', description='LATIN SMALL LETTER G WITH CIRCUMFLEX', shcode=0x0067, uccode=0x011C, specials={'char',0x0067,0x0302} },
	[0x011E] = { unicodeslot=0x011E, category='lu', adobename='Gbreve', contextname='Gbreve', description='LATIN CAPITAL LETTER G WITH BREVE', shcode=0x0047, lccode=0x011F, specials={'char',0x0047,0x0306} },
	[0x011F] = { unicodeslot=0x011F, category='ll', adobename='gbreve', contextname='gbreve', description='LATIN SMALL LETTER G WITH BREVE', shcode=0x0067, uccode=0x011E, specials={'char',0x0067,0x0306} },
	[0x0120] = { unicodeslot=0x0120, category='lu', adobename='Gdotaccent', contextname='Gdotaccent', description='LATIN CAPITAL LETTER G WITH DOT ABOVE', shcode=0x0047, lccode=0x0121, specials={'char',0x0047,0x0307} },
	[0x0121] = { unicodeslot=0x0121, category='ll', adobename='gdotaccent', contextname='gdotaccent', description='LATIN SMALL LETTER G WITH DOT ABOVE', shcode=0x0067, uccode=0x0120, specials={'char',0x0067,0x0307} },
	[0x0122] = { unicodeslot=0x0122, category='lu', adobename='Gcommaaccent', contextname='Gcommaaccent', description='LATIN CAPITAL LETTER G WITH CEDILLA', shcode=0x0047, lccode=0x0123, specials={'char',0x0047,0x0327} },
	[0x0123] = { unicodeslot=0x0123, category='ll', adobename='gcommaaccent', contextname='gcommaaccent', description='LATIN SMALL LETTER G WITH CEDILLA', shcode=0x0067, uccode=0x0122, specials={'char',0x0067,0x0327} },
	[0x0124] = { unicodeslot=0x0124, category='lu', adobename='Hcircumflex', contextname='Hcircumflex', description='LATIN CAPITAL LETTER H WITH CIRCUMFLEX', shcode=0x0048, lccode=0x0125, specials={'char',0x0048,0x0302} },
	[0x0125] = { unicodeslot=0x0125, category='ll', adobename='hcircumflex', contextname='hcircumflex', description='LATIN SMALL LETTER H WITH CIRCUMFLEX', shcode=0x0068, uccode=0x0124, specials={'char',0x0068,0x0302} },
	[0x0126] = { unicodeslot=0x0126, category='lu', adobename='Hbar', contextname='Hstroke', description='LATIN CAPITAL LETTER H WITH STROKE', shcode=0x0048, lccode=0x0127 },
	[0x0127] = { unicodeslot=0x0127, category='ll', adobename='hbar', contextname='hstroke', description='LATIN SMALL LETTER H WITH STROKE', shcode=0x0068, uccode=0x0126 },
	[0x0128] = { unicodeslot=0x0128, category='lu', adobename='Itilde', contextname='Itilde', description='LATIN CAPITAL LETTER I WITH TILDE', shcode=0x0049, lccode=0x0129, specials={'char',0x0049,0x0303} },
	[0x0129] = { unicodeslot=0x0129, category='ll', adobename='itilde', contextname='itilde', description='LATIN SMALL LETTER I WITH TILDE', shcode=0x0069, uccode=0x0128, specials={'char',0x0069,0x0303} },
	[0x012A] = { unicodeslot=0x012A, category='lu', adobename='Imacron', contextname='Imacron', description='LATIN CAPITAL LETTER I WITH MACRON', shcode=0x0049, lccode=0x012B, specials={'char',0x0049,0x0304} },
	[0x012B] = { unicodeslot=0x012B, category='ll', adobename='imacron', contextname='imacron', description='LATIN SMALL LETTER I WITH MACRON', shcode=0x0069, uccode=0x012A, specials={'char',0x0069,0x0304} },
	[0x012C] = { unicodeslot=0x012C, category='lu', adobename='Ibreve', contextname='Ibreve', description='LATIN CAPITAL LETTER I WITH BREVE', shcode=0x0049, lccode=0x012D, specials={'char',0x0049,0x0306} },
	[0x012D] = { unicodeslot=0x012D, category='ll', adobename='ibreve', contextname='ibreve', description='LATIN SMALL LETTER I WITH BREVE', shcode=0x0069, uccode=0x012C, specials={'char',0x0069,0x0306} },
	[0x012E] = { unicodeslot=0x012E, category='lu', adobename='Iogonek', contextname='Iogonek', description='LATIN CAPITAL LETTER I WITH OGONEK', shcode=0x0049, lccode=0x012F, specials={'char',0x0049,0x0328} },
	[0x012F] = { unicodeslot=0x012F, category='ll', adobename='iogonek', contextname='iogonek', description='LATIN SMALL LETTER I WITH OGONEK', shcode=0x0069, uccode=0x012E, specials={'char',0x0069,0x0328} },
	[0x0130] = { unicodeslot=0x0130, category='lu', adobename='Idotaccent', contextname='Idotaccent', description='LATIN CAPITAL LETTER I WITH DOT ABOVE', shcode=0x0049, lccode=0x0069, specials={'char',0x0049,0x0307} },
	[0x0131] = { unicodeslot=0x0131, category='ll', adobename='dotlessi', contextname='dotlessi', description='LATIN SMALL LETTER DOTLESS I', uccode=0x0049 },
	[0x0132] = { unicodeslot=0x0132, category='lu', adobename='IJ', contextname='IJligature', description='LATIN CAPITAL LIGATURE IJ', lccode=0x0133, specials={'compat',0x0049,0x004A} },
	[0x0133] = { unicodeslot=0x0133, category='ll', adobename='ij', contextname='ijligature', description='LATIN SMALL LIGATURE IJ', uccode=0x0132, specials={'compat',0x0069,0x006A} },
	[0x0134] = { unicodeslot=0x0134, category='lu', adobename='Jcircumflex', contextname='Jcircumflex', description='LATIN CAPITAL LETTER J WITH CIRCUMFLEX', shcode=0x004A, lccode=0x0135, specials={'char',0x004A,0x0302} },
	[0x0135] = { unicodeslot=0x0135, category='ll', adobename='jcircumflex', contextname='jcircumflex', description='LATIN SMALL LETTER J WITH CIRCUMFLEX', shcode=0x006A, uccode=0x0134, specials={'char',0x006A,0x0302} },
	[0x0136] = { unicodeslot=0x0136, category='lu', adobename='Kcommaaccent', contextname='Kcommaaccent', description='LATIN CAPITAL LETTER K WITH CEDILLA', shcode=0x004B, lccode=0x0137, specials={'char',0x004B,0x0327} },
	[0x0137] = { unicodeslot=0x0137, category='ll', adobename='kcommaaccent', contextname='kcommaaccent', description='LATIN SMALL LETTER K WITH CEDILLA', shcode=0x006B, uccode=0x0136, specials={'char',0x006B,0x0327} },
	[0x0138] = { unicodeslot=0x0138, category='ll', adobename='kgreenlandic', contextname='kkra', description='LATIN SMALL LETTER KRA' },
	[0x0139] = { unicodeslot=0x0139, category='lu', adobename='Lacute', contextname='Lacute', description='LATIN CAPITAL LETTER L WITH ACUTE', shcode=0x004C, lccode=0x013A, specials={'char',0x004C,0x0301} },
	[0x013A] = { unicodeslot=0x013A, category='ll', adobename='lacute', contextname='lacute', description='LATIN SMALL LETTER L WITH ACUTE', shcode=0x006C, uccode=0x0139, specials={'char',0x006C,0x0301} },
	[0x013B] = { unicodeslot=0x013B, category='lu', adobename='Lcommaaccent', contextname='Lcommaaccent', description='LATIN CAPITAL LETTER L WITH CEDILLA', shcode=0x004C, lccode=0x013C, specials={'char',0x004C,0x0327} },
	[0x013C] = { unicodeslot=0x013C, category='ll', adobename='lcommaaccent', contextname='lcommaaccent', description='LATIN SMALL LETTER L WITH CEDILLA', shcode=0x006C, uccode=0x013B, specials={'char',0x006C,0x0327} },
	[0x013D] = { unicodeslot=0x013D, category='lu', adobename='Lcaron', contextname='Lcaron', description='LATIN CAPITAL LETTER L WITH CARON', shcode=0x004C, lccode=0x013E, specials={'char',0x004C,0x030C} },
	[0x013E] = { unicodeslot=0x013E, category='ll', adobename='lcaron', contextname='lcaron', description='LATIN SMALL LETTER L WITH CARON', shcode=0x006C, uccode=0x013D, specials={'char',0x006C,0x030C} },
	[0x013F] = { unicodeslot=0x013F, category='lu', adobename='Ldot', contextname='Ldotmiddle', description='LATIN CAPITAL LETTER L WITH MIDDLE DOT', shcode=0x004C, lccode=0x0140, specials={'compat',0x004C,0x00B7} },
	[0x0140] = { unicodeslot=0x0140, category='ll', adobename='ldot', contextname='ldotmiddle', description='LATIN SMALL LETTER L WITH MIDDLE DOT', shcode=0x006C, uccode=0x013F, specials={'compat',0x006C,0x00B7} },
	[0x0141] = { unicodeslot=0x0141, category='lu', adobename='Lslash', contextname='Lstroke', description='LATIN CAPITAL LETTER L WITH STROKE', shcode=0x004C, lccode=0x0142 },
	[0x0142] = { unicodeslot=0x0142, category='ll', adobename='lslash', contextname='lstroke', description='LATIN SMALL LETTER L WITH STROKE', shcode=0x006C, uccode=0x0141 },
	[0x0143] = { unicodeslot=0x0143, category='lu', adobename='Nacute', contextname='Nacute', description='LATIN CAPITAL LETTER N WITH ACUTE', shcode=0x004E, lccode=0x0144, specials={'char',0x004E,0x0301} },
	[0x0144] = { unicodeslot=0x0144, category='ll', adobename='nacute', contextname='nacute', description='LATIN SMALL LETTER N WITH ACUTE', shcode=0x006E, uccode=0x0143, specials={'char',0x006E,0x0301} },
	[0x0145] = { unicodeslot=0x0145, category='lu', adobename='Ncommaaccent', contextname='Ncommaaccent', description='LATIN CAPITAL LETTER N WITH CEDILLA', shcode=0x004E, lccode=0x0146, specials={'char',0x004E,0x0327} },
	[0x0146] = { unicodeslot=0x0146, category='ll', adobename='ncommaaccent', contextname='ncommaaccent', description='LATIN SMALL LETTER N WITH CEDILLA', shcode=0x006E, uccode=0x0145, specials={'char',0x006E,0x0327} },
	[0x0147] = { unicodeslot=0x0147, category='lu', adobename='Ncaron', contextname='Ncaron', description='LATIN CAPITAL LETTER N WITH CARON', shcode=0x004E, lccode=0x0148, specials={'char',0x004E,0x030C} },
	[0x0148] = { unicodeslot=0x0148, category='ll', adobename='ncaron', contextname='ncaron', description='LATIN SMALL LETTER N WITH CARON', shcode=0x006E, uccode=0x0147, specials={'char',0x006E,0x030C} },
	[0x0149] = { unicodeslot=0x0149, category='ll', adobename='napostrophe', contextname='napostrophe', description='LATIN SMALL LETTER N PRECEDED BY APOSTROPHE', specials={'compat',0x02BC,0x006E} },
	[0x014A] = { unicodeslot=0x014A, category='lu', adobename='Eng', contextname='Neng', description='LATIN CAPITAL LETTER ENG', lccode=0x014B },
	[0x014B] = { unicodeslot=0x014B, category='ll', adobename='eng', contextname='neng', description='LATIN SMALL LETTER ENG', uccode=0x014A },
	[0x014C] = { unicodeslot=0x014C, category='lu', adobename='Omacron', contextname='Omacron', description='LATIN CAPITAL LETTER O WITH MACRON', shcode=0x004F, lccode=0x014D, specials={'char',0x004F,0x0304} },
	[0x014D] = { unicodeslot=0x014D, category='ll', adobename='omacron', contextname='omacron', description='LATIN SMALL LETTER O WITH MACRON', shcode=0x006F, uccode=0x014C, specials={'char',0x006F,0x0304} },
	[0x014E] = { unicodeslot=0x014E, category='lu', adobename='Obreve', contextname='Obreve', description='LATIN CAPITAL LETTER O WITH BREVE', shcode=0x004F, lccode=0x014F, specials={'char',0x004F,0x0306} },
	[0x014F] = { unicodeslot=0x014F, category='ll', adobename='obreve', contextname='obreve', description='LATIN SMALL LETTER O WITH BREVE', shcode=0x006F, uccode=0x014E, specials={'char',0x006F,0x0306} },
	[0x0150] = { unicodeslot=0x0150, category='lu', adobename='Ohungarumlaut', contextname='Ohungarumlaut', description='LATIN CAPITAL LETTER O WITH DOUBLE ACUTE', shcode=0x004F, lccode=0x0151, specials={'char',0x004F,0x030B} },
	[0x0151] = { unicodeslot=0x0151, category='ll', adobename='ohungarumlaut', contextname='ohungarumlaut', description='LATIN SMALL LETTER O WITH DOUBLE ACUTE', shcode=0x006F, uccode=0x0150, specials={'char',0x006F,0x030B} },
	[0x0152] = { unicodeslot=0x0152, category='lu', adobename='OE', contextname='OEligature', description='LATIN CAPITAL LIGATURE OE', lccode=0x0153 },
	[0x0153] = { unicodeslot=0x0153, category='ll', adobename='oe', contextname='oeligature', description='LATIN SMALL LIGATURE OE', uccode=0x0152 },
	[0x0154] = { unicodeslot=0x0154, category='lu', adobename='Racute', contextname='Racute', description='LATIN CAPITAL LETTER R WITH ACUTE', shcode=0x0052, lccode=0x0155, specials={'char',0x0052,0x0301} },
	[0x0155] = { unicodeslot=0x0155, category='ll', adobename='racute', contextname='racute', description='LATIN SMALL LETTER R WITH ACUTE', shcode=0x0072, uccode=0x0154, specials={'char',0x0072,0x0301} },
	[0x0156] = { unicodeslot=0x0156, category='lu', adobename='Rcommaaccent', contextname='Rcommaaccent', description='LATIN CAPITAL LETTER R WITH CEDILLA', shcode=0x0052, lccode=0x0157, specials={'char',0x0052,0x0327} },
	[0x0157] = { unicodeslot=0x0157, category='ll', adobename='rcommaaccent', contextname='rcommaaccent', description='LATIN SMALL LETTER R WITH CEDILLA', shcode=0x0072, uccode=0x0156, specials={'char',0x0072,0x0327} },
	[0x0158] = { unicodeslot=0x0158, category='lu', adobename='Rcaron', contextname='Rcaron', description='LATIN CAPITAL LETTER R WITH CARON', shcode=0x0052, lccode=0x0159, specials={'char',0x0052,0x030C} },
	[0x0159] = { unicodeslot=0x0159, category='ll', adobename='rcaron', contextname='rcaron', description='LATIN SMALL LETTER R WITH CARON', shcode=0x0072, uccode=0x0158, specials={'char',0x0072,0x030C} },
	[0x015A] = { unicodeslot=0x015A, category='lu', adobename='Sacute', contextname='Sacute', description='LATIN CAPITAL LETTER S WITH ACUTE', shcode=0x0053, lccode=0x015B, specials={'char',0x0053,0x0301} },
	[0x015B] = { unicodeslot=0x015B, category='ll', adobename='sacute', contextname='sacute', description='LATIN SMALL LETTER S WITH ACUTE', shcode=0x0073, uccode=0x015A, specials={'char',0x0073,0x0301} },
	[0x015C] = { unicodeslot=0x015C, category='lu', adobename='Scircumflex', contextname='Scircumflex', description='LATIN CAPITAL LETTER S WITH CIRCUMFLEX', shcode=0x0053, lccode=0x015D, specials={'char',0x0053,0x0302} },
	[0x015D] = { unicodeslot=0x015D, category='ll', adobename='scircumflex', contextname='scircumflex', description='LATIN SMALL LETTER S WITH CIRCUMFLEX', shcode=0x0073, uccode=0x015C, specials={'char',0x0073,0x0302} },
	[0x015E] = { unicodeslot=0x015E, category='lu', adobename='Scedilla', contextname='Scedilla', description='LATIN CAPITAL LETTER S WITH CEDILLA', shcode=0x0053, lccode=0x015F, specials={'char',0x0053,0x0327} },
	[0x015F] = { unicodeslot=0x015F, category='ll', adobename='scedilla', contextname='scedilla', description='LATIN SMALL LETTER S WITH CEDILLA', shcode=0x0073, uccode=0x015E, specials={'char',0x0073,0x0327} },
	[0x0160] = { unicodeslot=0x0160, category='lu', adobename='Scaron', contextname='Scaron', description='LATIN CAPITAL LETTER S WITH CARON', shcode=0x0053, lccode=0x0161, specials={'char',0x0053,0x030C} },
	[0x0161] = { unicodeslot=0x0161, category='ll', adobename='scaron', contextname='scaron', description='LATIN SMALL LETTER S WITH CARON', shcode=0x0073, uccode=0x0160, specials={'char',0x0073,0x030C} },
	[0x0162] = { unicodeslot=0x0162, category='lu', adobename='Tcommaaccent', contextname='Tcedilla', description='LATIN CAPITAL LETTER T WITH CEDILLA', shcode=0x0054, lccode=0x0163, specials={'char',0x0054,0x0327} },
	[0x0163] = { unicodeslot=0x0163, category='ll', adobename='tcommaaccent', contextname='tcedilla', description='LATIN SMALL LETTER T WITH CEDILLA', shcode=0x0074, uccode=0x0162, specials={'char',0x0074,0x0327} },
	[0x0164] = { unicodeslot=0x0164, category='lu', adobename='Tcaron', contextname='Tcaron', description='LATIN CAPITAL LETTER T WITH CARON', shcode=0x0054, lccode=0x0165, specials={'char',0x0054,0x030C} },
	[0x0165] = { unicodeslot=0x0165, category='ll', adobename='tcaron', contextname='tcaron', description='LATIN SMALL LETTER T WITH CARON', shcode=0x0074, uccode=0x0164, specials={'char',0x0074,0x030C} },
	[0x0166] = { unicodeslot=0x0166, category='lu', adobename='Tbar', contextname='Tstroke', description='LATIN CAPITAL LETTER T WITH STROKE', shcode=0x0054, lccode=0x0167 },
	[0x0167] = { unicodeslot=0x0167, category='ll', adobename='tbar', contextname='tstroke', description='LATIN SMALL LETTER T WITH STROKE', shcode=0x0074, uccode=0x0166 },
	[0x0168] = { unicodeslot=0x0168, category='lu', adobename='Utilde', contextname='Utilde', description='LATIN CAPITAL LETTER U WITH TILDE', shcode=0x0055, lccode=0x0169, specials={'char',0x0055,0x0303} },
	[0x0169] = { unicodeslot=0x0169, category='ll', adobename='utilde', contextname='utilde', description='LATIN SMALL LETTER U WITH TILDE', shcode=0x0075, uccode=0x0168, specials={'char',0x0075,0x0303} },
	[0x016A] = { unicodeslot=0x016A, category='lu', adobename='Umacron', contextname='Umacron', description='LATIN CAPITAL LETTER U WITH MACRON', shcode=0x0055, lccode=0x016B, specials={'char',0x0055,0x0304} },
	[0x016B] = { unicodeslot=0x016B, category='ll', adobename='umacron', contextname='umacron', description='LATIN SMALL LETTER U WITH MACRON', shcode=0x0075, uccode=0x016A, specials={'char',0x0075,0x0304} },
	[0x016C] = { unicodeslot=0x016C, category='lu', adobename='Ubreve', contextname='Ubreve', description='LATIN CAPITAL LETTER U WITH BREVE', shcode=0x0055, lccode=0x016D, specials={'char',0x0055,0x0306} },
	[0x016D] = { unicodeslot=0x016D, category='ll', adobename='ubreve', contextname='ubreve', description='LATIN SMALL LETTER U WITH BREVE', shcode=0x0075, uccode=0x016C, specials={'char',0x0075,0x0306} },
	[0x016E] = { unicodeslot=0x016E, category='lu', adobename='Uring', contextname='Uring', description='LATIN CAPITAL LETTER U WITH RING ABOVE', shcode=0x0055, lccode=0x016F, specials={'char',0x0055,0x030A} },
	[0x016F] = { unicodeslot=0x016F, category='ll', adobename='uring', contextname='uring', description='LATIN SMALL LETTER U WITH RING ABOVE', shcode=0x0075, uccode=0x016E, specials={'char',0x0075,0x030A} },
	[0x0170] = { unicodeslot=0x0170, category='lu', adobename='Uhungarumlaut', contextname='Uhungarumlaut', description='LATIN CAPITAL LETTER U WITH DOUBLE ACUTE', shcode=0x0055, lccode=0x0171, specials={'char',0x0055,0x030B} },
	[0x0171] = { unicodeslot=0x0171, category='ll', adobename='uhungarumlaut', contextname='uhungarumlaut', description='LATIN SMALL LETTER U WITH DOUBLE ACUTE', shcode=0x0075, uccode=0x0170, specials={'char',0x0075,0x030B} },
	[0x0172] = { unicodeslot=0x0172, category='lu', adobename='Uogonek', contextname='Uogonek', description='LATIN CAPITAL LETTER U WITH OGONEK', shcode=0x0055, lccode=0x0173, specials={'char',0x0055,0x0328} },
	[0x0173] = { unicodeslot=0x0173, category='ll', adobename='uogonek', contextname='uogonek', description='LATIN SMALL LETTER U WITH OGONEK', shcode=0x0075, uccode=0x0172, specials={'char',0x0075,0x0328} },
	[0x0174] = { unicodeslot=0x0174, category='lu', adobename='Wcircumflex', contextname='Wcircumflex', description='LATIN CAPITAL LETTER W WITH CIRCUMFLEX', shcode=0x0057, lccode=0x0175, specials={'char',0x0057,0x0302} },
	[0x0175] = { unicodeslot=0x0175, category='ll', adobename='wcircumflex', contextname='wcircumflex', description='LATIN SMALL LETTER W WITH CIRCUMFLEX', shcode=0x0077, uccode=0x0174, specials={'char',0x0077,0x0302} },
	[0x0176] = { unicodeslot=0x0176, category='lu', adobename='Ycircumflex', contextname='Ycircumflex', description='LATIN CAPITAL LETTER Y WITH CIRCUMFLEX', shcode=0x0059, lccode=0x0177, specials={'char',0x0059,0x0302} },
	[0x0177] = { unicodeslot=0x0177, category='ll', adobename='ycircumflex', contextname='ycircumflex', description='LATIN SMALL LETTER Y WITH CIRCUMFLEX', shcode=0x0079, uccode=0x0176, specials={'char',0x0079,0x0302} },
	[0x0178] = { unicodeslot=0x0178, category='lu', adobename='Ydieresis', contextname='Ydiaeresis', description='LATIN CAPITAL LETTER Y WITH DIAERESIS', shcode=0x0059, lccode=0x00FF, specials={'char',0x0059,0x0308} },
	[0x0179] = { unicodeslot=0x0179, category='lu', adobename='Zacute', contextname='Zacute', description='LATIN CAPITAL LETTER Z WITH ACUTE', shcode=0x005A, lccode=0x017A, specials={'char',0x005A,0x0301} },
	[0x017A] = { unicodeslot=0x017A, category='ll', adobename='zacute', contextname='zacute', description='LATIN SMALL LETTER Z WITH ACUTE', shcode=0x007A, uccode=0x0179, specials={'char',0x007A,0x0301} },
	[0x017B] = { unicodeslot=0x017B, category='lu', adobename='Zdotaccent', contextname='Zdotaccent', description='LATIN CAPITAL LETTER Z WITH DOT ABOVE', shcode=0x005A, lccode=0x017C, specials={'char',0x005A,0x0307} },
	[0x017C] = { unicodeslot=0x017C, category='ll', adobename='zdotaccent', contextname='zdotaccent', description='LATIN SMALL LETTER Z WITH DOT ABOVE', shcode=0x007A, uccode=0x017B, specials={'char',0x007A,0x0307} },
	[0x017D] = { unicodeslot=0x017D, category='lu', adobename='Zcaron', contextname='Zcaron', description='LATIN CAPITAL LETTER Z WITH CARON', shcode=0x005A, lccode=0x017E, specials={'char',0x005A,0x030C} },
	[0x017E] = { unicodeslot=0x017E, category='ll', adobename='zcaron', contextname='zcaron', description='LATIN SMALL LETTER Z WITH CARON', shcode=0x007A, uccode=0x017D, specials={'char',0x007A,0x030C} },
	[0x017F] = { unicodeslot=0x017F, category='ll', adobename='longs', contextname='slong', description='LATIN SMALL LETTER LONG S', uccode=0x0053, specials={'compat',0x0073} },
	[0x0180] = { unicodeslot=0x0180, category='ll', contextname='bstroke', description='LATIN SMALL LETTER B WITH STROKE', shcode=0x0062, uccode=0x0243 },
	[0x0181] = { unicodeslot=0x0181, category='lu', contextname='Bhook', description='LATIN CAPITAL LETTER B WITH HOOK', shcode=0x0042, lccode=0x0253 },
	[0x0182] = { unicodeslot=0x0182, category='lu', description='LATIN CAPITAL LETTER B WITH TOPBAR', shcode=0x0042, lccode=0x0183 },
	[0x0183] = { unicodeslot=0x0183, category='ll', description='LATIN SMALL LETTER B WITH TOPBAR', shcode=0x0062, uccode=0x0182 },
	[0x0184] = { unicodeslot=0x0184, category='lu', description='LATIN CAPITAL LETTER TONE SIX', lccode=0x0185 },
	[0x0185] = { unicodeslot=0x0185, category='ll', description='LATIN SMALL LETTER TONE SIX', uccode=0x0184 },
	[0x0186] = { unicodeslot=0x0186, category='lu', description='LATIN CAPITAL LETTER OPEN O', lccode=0x0254 },
	[0x0187] = { unicodeslot=0x0187, category='lu', contextname='Chook', description='LATIN CAPITAL LETTER C WITH HOOK', shcode=0x0043, lccode=0x0188 },
	[0x0188] = { unicodeslot=0x0188, category='ll', contextname='chook', description='LATIN SMALL LETTER C WITH HOOK', shcode=0x0063, uccode=0x0187 },
	[0x0189] = { unicodeslot=0x0189, category='lu', contextname='Dafrican', description='LATIN CAPITAL LETTER AFRICAN D', lccode=0x0256 },
	[0x018A] = { unicodeslot=0x018A, category='lu', contextname='Dhook', description='LATIN CAPITAL LETTER D WITH HOOK', shcode=0x0044, lccode=0x0257 },
	[0x018B] = { unicodeslot=0x018B, category='lu', description='LATIN CAPITAL LETTER D WITH TOPBAR', shcode=0x0044, lccode=0x018C },
	[0x018C] = { unicodeslot=0x018C, category='ll', description='LATIN SMALL LETTER D WITH TOPBAR', shcode=0x0064, uccode=0x018B },
	[0x018D] = { unicodeslot=0x018D, category='ll', description='LATIN SMALL LETTER TURNED DELTA' },
	[0x018E] = { unicodeslot=0x018E, category='lu', description='LATIN CAPITAL LETTER REVERSED E', lccode=0x01DD },
	[0x018F] = { unicodeslot=0x018F, category='lu', contextname='Schwa', description='LATIN CAPITAL LETTER SCHWA', lccode=0x0259 },
	[0x0190] = { unicodeslot=0x0190, category='lu', description='LATIN CAPITAL LETTER OPEN E', lccode=0x025B },
	[0x0191] = { unicodeslot=0x0191, category='lu', contextname='Fhook', description='LATIN CAPITAL LETTER F WITH HOOK', shcode=0x0046, lccode=0x0192 },
	[0x0192] = { unicodeslot=0x0192, category='ll', adobename='florin', contextname='fhook', description='LATIN SMALL LETTER F WITH HOOK', shcode=0x0066, uccode=0x0191 },
	[0x0193] = { unicodeslot=0x0193, category='lu', contextname='Ghook', description='LATIN CAPITAL LETTER G WITH HOOK', shcode=0x0047, lccode=0x0260 },
	[0x0194] = { unicodeslot=0x0194, category='lu', description='LATIN CAPITAL LETTER GAMMA', lccode=0x0263 },
	[0x0195] = { unicodeslot=0x0195, category='ll', description='LATIN SMALL LETTER HV', uccode=0x01F6 },
	[0x0196] = { unicodeslot=0x0196, category='lu', description='LATIN CAPITAL LETTER IOTA', lccode=0x0269 },
	[0x0197] = { unicodeslot=0x0197, category='lu', contextname='Istroke', description='LATIN CAPITAL LETTER I WITH STROKE', shcode=0x0049, lccode=0x0268 },
	[0x0198] = { unicodeslot=0x0198, category='lu', contextname='Khook', description='LATIN CAPITAL LETTER K WITH HOOK', shcode=0x004B, lccode=0x0199 },
	[0x0199] = { unicodeslot=0x0199, category='ll', contextname='khook', description='LATIN SMALL LETTER K WITH HOOK', shcode=0x006B, uccode=0x0198 },
	[0x019A] = { unicodeslot=0x019A, category='ll', contextname='lbar', description='LATIN SMALL LETTER L WITH BAR', shcode=0x006C, uccode=0x023D },
	[0x019B] = { unicodeslot=0x019B, category='ll', description='LATIN SMALL LETTER LAMBDA WITH STROKE' },
	[0x019C] = { unicodeslot=0x019C, category='lu', description='LATIN CAPITAL LETTER TURNED M', lccode=0x026F },
	[0x019D] = { unicodeslot=0x019D, category='lu', description='LATIN CAPITAL LETTER N WITH LEFT HOOK', shcode=0x004E, lccode=0x0272 },
	[0x019E] = { unicodeslot=0x019E, category='ll', description='LATIN SMALL LETTER N WITH LONG RIGHT LEG', shcode=0x006E, uccode=0x0220 },
	[0x019F] = { unicodeslot=0x019F, category='lu', description='LATIN CAPITAL LETTER O WITH MIDDLE TILDE', shcode=0x004F, lccode=0x0275 },
	[0x01A0] = { unicodeslot=0x01A0, category='lu', adobename='Ohorn', contextname='Ohorn', description='LATIN CAPITAL LETTER O WITH HORN', shcode=0x004F, lccode=0x01A1, specials={'char',0x004F,0x031B} },
	[0x01A1] = { unicodeslot=0x01A1, category='ll', adobename='ohorn', contextname='ohorn', description='LATIN SMALL LETTER O WITH HORN', shcode=0x006F, uccode=0x01A0, specials={'char',0x006F,0x031B} },
	[0x01A2] = { unicodeslot=0x01A2, category='lu', description='LATIN CAPITAL LETTER OI', lccode=0x01A3 },
	[0x01A3] = { unicodeslot=0x01A3, category='ll', description='LATIN SMALL LETTER OI', uccode=0x01A2 },
	[0x01A4] = { unicodeslot=0x01A4, category='lu', contextname='Phook', description='LATIN CAPITAL LETTER P WITH HOOK', shcode=0x0050, lccode=0x01A5 },
	[0x01A5] = { unicodeslot=0x01A5, category='ll', contextname='phook', description='LATIN SMALL LETTER P WITH HOOK', shcode=0x0070, uccode=0x01A4 },
	[0x01A6] = { unicodeslot=0x01A6, category='lu', description='LATIN LETTER YR', lccode=0x0280 },
	[0x01A7] = { unicodeslot=0x01A7, category='lu', description='LATIN CAPITAL LETTER TONE TWO', lccode=0x01A8 },
	[0x01A8] = { unicodeslot=0x01A8, category='ll', description='LATIN SMALL LETTER TONE TWO', uccode=0x01A7 },
	[0x01A9] = { unicodeslot=0x01A9, category='lu', description='LATIN CAPITAL LETTER ESH', lccode=0x0283 },
	[0x01AA] = { unicodeslot=0x01AA, category='ll', description='LATIN LETTER REVERSED ESH LOOP' },
	[0x01AB] = { unicodeslot=0x01AB, category='ll', description='LATIN SMALL LETTER T WITH PALATAL HOOK', shcode=0x0074 },
	[0x01AC] = { unicodeslot=0x01AC, category='lu', contextname='Thook', description='LATIN CAPITAL LETTER T WITH HOOK', shcode=0x0054, lccode=0x01AD },
	[0x01AD] = { unicodeslot=0x01AD, category='ll', contextname='thook', description='LATIN SMALL LETTER T WITH HOOK', shcode=0x0074, uccode=0x01AC },
	[0x01AE] = { unicodeslot=0x01AE, category='lu', description='LATIN CAPITAL LETTER T WITH RETROFLEX HOOK', shcode=0x0054, lccode=0x0288 },
	[0x01AF] = { unicodeslot=0x01AF, category='lu', adobename='Uhorn', contextname='Uhorn', description='LATIN CAPITAL LETTER U WITH HORN', shcode=0x0055, lccode=0x01B0, specials={'char',0x0055,0x031B} },
	[0x01B0] = { unicodeslot=0x01B0, category='ll', adobename='uhorn', contextname='uhorn', description='LATIN SMALL LETTER U WITH HORN', shcode=0x0075, uccode=0x01AF, specials={'char',0x0075,0x031B} },
	[0x01B1] = { unicodeslot=0x01B1, category='lu', description='LATIN CAPITAL LETTER UPSILON', lccode=0x028A },
	[0x01B2] = { unicodeslot=0x01B2, category='lu', contextname='Uhook', description='LATIN CAPITAL LETTER V WITH HOOK', shcode=0x0056, lccode=0x028B },
	[0x01B3] = { unicodeslot=0x01B3, category='lu', contextname='Yhook', description='LATIN CAPITAL LETTER Y WITH HOOK', shcode=0x0059, lccode=0x01B4 },
	[0x01B4] = { unicodeslot=0x01B4, category='ll', contextname='yhook', description='LATIN SMALL LETTER Y WITH HOOK', shcode=0x0079, uccode=0x01B3 },
	[0x01B5] = { unicodeslot=0x01B5, category='lu', contextname='Zstroke', description='LATIN CAPITAL LETTER Z WITH STROKE', shcode=0x005A, lccode=0x01B6 },
	[0x01B6] = { unicodeslot=0x01B6, category='ll', contextname='zstroke', description='LATIN SMALL LETTER Z WITH STROKE', shcode=0x007A, uccode=0x01B5 },
	[0x01B7] = { unicodeslot=0x01B7, category='lu', description='LATIN CAPITAL LETTER EZH', lccode=0x0292 },
	[0x01B8] = { unicodeslot=0x01B8, category='lu', description='LATIN CAPITAL LETTER EZH REVERSED', lccode=0x01B9 },
	[0x01B9] = { unicodeslot=0x01B9, category='ll', description='LATIN SMALL LETTER EZH REVERSED', uccode=0x01B8 },
	[0x01BA] = { unicodeslot=0x01BA, category='ll', description='LATIN SMALL LETTER EZH WITH TAIL', shcode=0x0292 },
	[0x01BB] = { unicodeslot=0x01BB, category='lo', description='LATIN LETTER TWO WITH STROKE' },
	[0x01BC] = { unicodeslot=0x01BC, category='lu', description='LATIN CAPITAL LETTER TONE FIVE', lccode=0x01BD },
	[0x01BD] = { unicodeslot=0x01BD, category='ll', description='LATIN SMALL LETTER TONE FIVE', uccode=0x01BC },
	[0x01BE] = { unicodeslot=0x01BE, category='ll', description='LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE' },
	[0x01BF] = { unicodeslot=0x01BF, category='ll', description='LATIN LETTER WYNN', uccode=0x01F7 },
	[0x01C0] = { unicodeslot=0x01C0, category='lo', description='LATIN LETTER DENTAL CLICK' },
	[0x01C1] = { unicodeslot=0x01C1, category='lo', description='LATIN LETTER LATERAL CLICK' },
	[0x01C2] = { unicodeslot=0x01C2, category='lo', description='LATIN LETTER ALVEOLAR CLICK' },
	[0x01C3] = { unicodeslot=0x01C3, category='lo', description='LATIN LETTER RETROFLEX CLICK' },
	[0x01C4] = { unicodeslot=0x01C4, category='lu', contextname='DZcaronligature', description='LATIN CAPITAL LETTER DZ WITH CARON', shcode=0x01F1, uccode=0x01C5, lccode=0x01C6, specials={'compat',0x0044,0x017D} },
	[0x01C5] = { unicodeslot=0x01C5, category='lt', contextname='Dzcaronligature', description='LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON', shcode=0x01F2, uccode=0x01C4, lccode=0x01C6, specials={'compat',0x0044,0x017E} },
	[0x01C6] = { unicodeslot=0x01C6, category='ll', contextname='dzcaronligature', description='LATIN SMALL LETTER DZ WITH CARON', shcode=0x01F3, uccode=0x01C4, specials={'compat',0x0064,0x017E} },
	[0x01C7] = { unicodeslot=0x01C7, category='lu', contextname='LJligature', description='LATIN CAPITAL LETTER LJ', uccode=0x01C8, lccode=0x01C9, specials={'compat',0x004C,0x004A} },
	[0x01C8] = { unicodeslot=0x01C8, category='lt', contextname='Ljligature', description='LATIN CAPITAL LETTER L WITH SMALL LETTER J', shcode=0x004C, uccode=0x01C7, lccode=0x01C9, specials={'compat',0x004C,0x006A} },
	[0x01C9] = { unicodeslot=0x01C9, category='ll', contextname='ljligature', description='LATIN SMALL LETTER LJ', uccode=0x01C7, specials={'compat',0x006C,0x006A} },
	[0x01CA] = { unicodeslot=0x01CA, category='lu', contextname='NJligature', description='LATIN CAPITAL LETTER NJ', uccode=0x01CB, lccode=0x01CC, specials={'compat',0x004E,0x004A} },
	[0x01CB] = { unicodeslot=0x01CB, category='lt', contextname='Njligature', description='LATIN CAPITAL LETTER N WITH SMALL LETTER J', shcode=0x004E, uccode=0x01CA, lccode=0x01CC, specials={'compat',0x004E,0x006A} },
	[0x01CC] = { unicodeslot=0x01CC, category='ll', contextname='njligature', description='LATIN SMALL LETTER NJ', uccode=0x01CA, specials={'compat',0x006E,0x006A} },
	[0x01CD] = { unicodeslot=0x01CD, category='lu', contextname='Acaron', description='LATIN CAPITAL LETTER A WITH CARON', shcode=0x0041, lccode=0x01CE, specials={'char',0x0041,0x030C} },
	[0x01CE] = { unicodeslot=0x01CE, category='ll', contextname='acaron', description='LATIN SMALL LETTER A WITH CARON', shcode=0x0061, uccode=0x01CD, specials={'char',0x0061,0x030C} },
	[0x01CF] = { unicodeslot=0x01CF, category='lu', contextname='Icaron', description='LATIN CAPITAL LETTER I WITH CARON', shcode=0x0049, lccode=0x01D0, specials={'char',0x0049,0x030C} },
	[0x01D0] = { unicodeslot=0x01D0, category='ll', contextname='icaron', description='LATIN SMALL LETTER I WITH CARON', shcode=0x0069, uccode=0x01CF, specials={'char',0x0069,0x030C} },
	[0x01D1] = { unicodeslot=0x01D1, category='lu', contextname='Ocaron', description='LATIN CAPITAL LETTER O WITH CARON', shcode=0x004F, lccode=0x01D2, specials={'char',0x004F,0x030C} },
	[0x01D2] = { unicodeslot=0x01D2, category='ll', contextname='ocaron', description='LATIN SMALL LETTER O WITH CARON', shcode=0x006F, uccode=0x01D1, specials={'char',0x006F,0x030C} },
	[0x01D3] = { unicodeslot=0x01D3, category='lu', contextname='Ucaron', description='LATIN CAPITAL LETTER U WITH CARON', shcode=0x0055, lccode=0x01D4, specials={'char',0x0055,0x030C} },
	[0x01D4] = { unicodeslot=0x01D4, category='ll', contextname='ucaron', description='LATIN SMALL LETTER U WITH CARON', shcode=0x0075, uccode=0x01D3, specials={'char',0x0075,0x030C} },
	[0x01D5] = { unicodeslot=0x01D5, category='lu', contextname='Udiaeresismacron', description='LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON', shcode=0x0055, lccode=0x01D6, specials={'char',0x00DC,0x0304} },
	[0x01D6] = { unicodeslot=0x01D6, category='ll', contextname='udiaeresismacron', description='LATIN SMALL LETTER U WITH DIAERESIS AND MACRON', shcode=0x0075, uccode=0x01D5, specials={'char',0x00FC,0x0304} },
	[0x01D7] = { unicodeslot=0x01D7, category='lu', contextname='Udiaeresisacute', description='LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE', shcode=0x0055, lccode=0x01D8, specials={'char',0x00DC,0x0301} },
	[0x01D8] = { unicodeslot=0x01D8, category='ll', contextname='udiaeresisacute', description='LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE', shcode=0x0075, uccode=0x01D7, specials={'char',0x00FC,0x0301} },
	[0x01D9] = { unicodeslot=0x01D9, category='lu', contextname='Udiaeresiscaron', description='LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON', shcode=0x0055, lccode=0x01DA, specials={'char',0x00DC,0x030C} },
	[0x01DA] = { unicodeslot=0x01DA, category='ll', contextname='udiaeresiscaron', description='LATIN SMALL LETTER U WITH DIAERESIS AND CARON', shcode=0x0075, uccode=0x01D9, specials={'char',0x00FC,0x030C} },
	[0x01DB] = { unicodeslot=0x01DB, category='lu', contextname='Udiaeresisgrave', description='LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE', shcode=0x0055, lccode=0x01DC, specials={'char',0x00DC,0x0300} },
	[0x01DC] = { unicodeslot=0x01DC, category='ll', contextname='udiaeresisgrave', description='LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE', shcode=0x0075, uccode=0x01DB, specials={'char',0x00FC,0x0300} },
	[0x01DD] = { unicodeslot=0x01DD, category='ll', description='LATIN SMALL LETTER TURNED E', uccode=0x018E },
	[0x01DE] = { unicodeslot=0x01DE, category='lu', contextname='Adiaeresismacron', description='LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON', shcode=0x0041, lccode=0x01DF, specials={'char',0x00C4,0x0304} },
	[0x01DF] = { unicodeslot=0x01DF, category='ll', contextname='adiaeresismacron', description='LATIN SMALL LETTER A WITH DIAERESIS AND MACRON', shcode=0x0061, uccode=0x01DE, specials={'char',0x00E4,0x0304} },
	[0x01E0] = { unicodeslot=0x01E0, category='lu', contextname='Adotaccentmacron', description='LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON', shcode=0x0041, lccode=0x01E1, specials={'char',0x0226,0x0304} },
	[0x01E1] = { unicodeslot=0x01E1, category='ll', contextname='adotaccentmacron', description='LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON', shcode=0x0061, uccode=0x01E0, specials={'char',0x0227,0x0304} },
	[0x01E2] = { unicodeslot=0x01E2, category='lu', contextname='AEmacron', description='LATIN CAPITAL LETTER AE WITH MACRON', shcode=0x00C6, lccode=0x01E3, specials={'char',0x00C6,0x0304} },
	[0x01E3] = { unicodeslot=0x01E3, category='ll', contextname='aemacron', description='LATIN SMALL LETTER AE WITH MACRON', shcode=0x00E6, uccode=0x01E2, specials={'char',0x00E6,0x0304} },
	[0x01E4] = { unicodeslot=0x01E4, category='lu', contextname='Gstroke', description='LATIN CAPITAL LETTER G WITH STROKE', shcode=0x0047, lccode=0x01E5 },
	[0x01E5] = { unicodeslot=0x01E5, category='ll', contextname='gstroke', description='LATIN SMALL LETTER G WITH STROKE', shcode=0x0067, uccode=0x01E4 },
	[0x01E6] = { unicodeslot=0x01E6, category='lu', adobename='Gcaron', contextname='Gcaron', description='LATIN CAPITAL LETTER G WITH CARON', shcode=0x0047, lccode=0x01E7, specials={'char',0x0047,0x030C} },
	[0x01E7] = { unicodeslot=0x01E7, category='ll', adobename='gcaron', contextname='gcaron', description='LATIN SMALL LETTER G WITH CARON', shcode=0x0067, uccode=0x01E6, specials={'char',0x0067,0x030C} },
	[0x01E8] = { unicodeslot=0x01E8, category='lu', contextname='Kcaron', description='LATIN CAPITAL LETTER K WITH CARON', shcode=0x004B, lccode=0x01E9, specials={'char',0x004B,0x030C} },
	[0x01E9] = { unicodeslot=0x01E9, category='ll', contextname='kcaron', description='LATIN SMALL LETTER K WITH CARON', shcode=0x006B, uccode=0x01E8, specials={'char',0x006B,0x030C} },
	[0x01EA] = { unicodeslot=0x01EA, category='lu', contextname='Oogonek', description='LATIN CAPITAL LETTER O WITH OGONEK', shcode=0x004F, lccode=0x01EB, specials={'char',0x004F,0x0328} },
	[0x01EB] = { unicodeslot=0x01EB, category='ll', contextname='oogonek', description='LATIN SMALL LETTER O WITH OGONEK', shcode=0x006F, uccode=0x01EA, specials={'char',0x006F,0x0328} },
	[0x01EC] = { unicodeslot=0x01EC, category='lu', contextname='Oogonekmacron', description='LATIN CAPITAL LETTER O WITH OGONEK AND MACRON', shcode=0x004F, lccode=0x01ED, specials={'char',0x01EA,0x0304} },
	[0x01ED] = { unicodeslot=0x01ED, category='ll', contextname='oogonekmacron', description='LATIN SMALL LETTER O WITH OGONEK AND MACRON', shcode=0x006F, uccode=0x01EC, specials={'char',0x01EB,0x0304} },
	[0x01EE] = { unicodeslot=0x01EE, category='lu', description='LATIN CAPITAL LETTER EZH WITH CARON', shcode=0x01B7, lccode=0x01EF, specials={'char',0x01B7,0x030C} },
	[0x01EF] = { unicodeslot=0x01EF, category='ll', description='LATIN SMALL LETTER EZH WITH CARON', shcode=0x0292, uccode=0x01EE, specials={'char',0x0292,0x030C} },
	[0x01F0] = { unicodeslot=0x01F0, category='ll', contextname='jcaron', description='LATIN SMALL LETTER J WITH CARON', shcode=0x006A, specials={'char',0x006A,0x030C} },
	[0x01F1] = { unicodeslot=0x01F1, category='lu', contextname='DZligature', description='LATIN CAPITAL LETTER DZ', uccode=0x01F2, lccode=0x01F3, specials={'compat',0x0044,0x005A} },
	[0x01F2] = { unicodeslot=0x01F2, category='lt', contextname='Dzligature', description='LATIN CAPITAL LETTER D WITH SMALL LETTER Z', shcode=0x0044, uccode=0x01F1, lccode=0x01F3, specials={'compat',0x0044,0x007A} },
	[0x01F3] = { unicodeslot=0x01F3, category='ll', contextname='dzligature', description='LATIN SMALL LETTER DZ', uccode=0x01F1, specials={'compat',0x0064,0x007A} },
	[0x01F4] = { unicodeslot=0x01F4, category='lu', contextname='Gacute', description='LATIN CAPITAL LETTER G WITH ACUTE', shcode=0x0047, lccode=0x01F5, specials={'char',0x0047,0x0301} },
	[0x01F5] = { unicodeslot=0x01F5, category='ll', contextname='gacute', description='LATIN SMALL LETTER G WITH ACUTE', shcode=0x0067, uccode=0x01F4, specials={'char',0x0067,0x0301} },
	[0x01F6] = { unicodeslot=0x01F6, category='lu', description='LATIN CAPITAL LETTER HWAIR', lccode=0x0195 },
	[0x01F7] = { unicodeslot=0x01F7, category='lu', description='LATIN CAPITAL LETTER WYNN', lccode=0x01BF },
	[0x01F8] = { unicodeslot=0x01F8, category='lu', contextname='Ngrave', description='LATIN CAPITAL LETTER N WITH GRAVE', shcode=0x004E, lccode=0x01F9, specials={'char',0x004E,0x0300} },
	[0x01F9] = { unicodeslot=0x01F9, category='ll', contextname='ngrave', description='LATIN SMALL LETTER N WITH GRAVE', shcode=0x006E, uccode=0x01F8, specials={'char',0x006E,0x0300} },
	[0x01FA] = { unicodeslot=0x01FA, category='lu', adobename='Aringacute', contextname='Aringacute', description='LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE', shcode=0x0041, lccode=0x01FB, specials={'char',0x00C5,0x0301} },
	[0x01FB] = { unicodeslot=0x01FB, category='ll', adobename='aringacute', contextname='aringacute', description='LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE', shcode=0x0061, uccode=0x01FA, specials={'char',0x00E5,0x0301} },
	[0x01FC] = { unicodeslot=0x01FC, category='lu', adobename='AEacute', contextname='AEacute', description='LATIN CAPITAL LETTER AE WITH ACUTE', shcode=0x00C6, lccode=0x01FD, specials={'char',0x00C6,0x0301} },
	[0x01FD] = { unicodeslot=0x01FD, category='ll', adobename='aeacute', contextname='aeacute', description='LATIN SMALL LETTER AE WITH ACUTE', shcode=0x00E6, uccode=0x01FC, specials={'char',0x00E6,0x0301} },
	[0x01FE] = { unicodeslot=0x01FE, category='lu', adobename='Oslashacute', contextname='Ostrokeacute', description='LATIN CAPITAL LETTER O WITH STROKE AND ACUTE', shcode=0x004F, lccode=0x01FF, specials={'char',0x00D8,0x0301} },
	[0x01FF] = { unicodeslot=0x01FF, category='ll', adobename='oslashacute', contextname='ostrokeacute', description='LATIN SMALL LETTER O WITH STROKE AND ACUTE', shcode=0x006F, uccode=0x01FE, specials={'char',0x00F8,0x0301} },
	[0x0200] = { unicodeslot=0x0200, category='lu', contextname='Adoublegrave', description='LATIN CAPITAL LETTER A WITH DOUBLE GRAVE', shcode=0x0041, lccode=0x0201, specials={'char',0x0041,0x030F} },
	[0x0201] = { unicodeslot=0x0201, category='ll', contextname='adoublegrave', description='LATIN SMALL LETTER A WITH DOUBLE GRAVE', shcode=0x0061, uccode=0x0200, specials={'char',0x0061,0x030F} },
	[0x0202] = { unicodeslot=0x0202, category='lu', contextname='Ainvertedbreve', description='LATIN CAPITAL LETTER A WITH INVERTED BREVE', shcode=0x0041, lccode=0x0203, specials={'char',0x0041,0x0311} },
	[0x0203] = { unicodeslot=0x0203, category='ll', contextname='ainvertedbreve', description='LATIN SMALL LETTER A WITH INVERTED BREVE', shcode=0x0061, uccode=0x0202, specials={'char',0x0061,0x0311} },
	[0x0204] = { unicodeslot=0x0204, category='lu', contextname='Edoublegrave', description='LATIN CAPITAL LETTER E WITH DOUBLE GRAVE', shcode=0x0045, lccode=0x0205, specials={'char',0x0045,0x030F} },
	[0x0205] = { unicodeslot=0x0205, category='ll', contextname='edoublegrave', description='LATIN SMALL LETTER E WITH DOUBLE GRAVE', shcode=0x0065, uccode=0x0204, specials={'char',0x0065,0x030F} },
	[0x0206] = { unicodeslot=0x0206, category='lu', contextname='Einvertedbreve', description='LATIN CAPITAL LETTER E WITH INVERTED BREVE', shcode=0x0045, lccode=0x0207, specials={'char',0x0045,0x0311} },
	[0x0207] = { unicodeslot=0x0207, category='ll', contextname='einvertedbreve', description='LATIN SMALL LETTER E WITH INVERTED BREVE', shcode=0x0065, uccode=0x0206, specials={'char',0x0065,0x0311} },
	[0x0208] = { unicodeslot=0x0208, category='lu', contextname='Idoublegrave', description='LATIN CAPITAL LETTER I WITH DOUBLE GRAVE', shcode=0x0049, lccode=0x0209, specials={'char',0x0049,0x030F} },
	[0x0209] = { unicodeslot=0x0209, category='ll', contextname='idoublegrave', description='LATIN SMALL LETTER I WITH DOUBLE GRAVE', shcode=0x0069, uccode=0x0208, specials={'char',0x0069,0x030F} },
	[0x020A] = { unicodeslot=0x020A, category='lu', contextname='Iinvertedbreve', description='LATIN CAPITAL LETTER I WITH INVERTED BREVE', shcode=0x0049, lccode=0x020B, specials={'char',0x0049,0x0311} },
	[0x020B] = { unicodeslot=0x020B, category='ll', contextname='iinvertedbreve', description='LATIN SMALL LETTER I WITH INVERTED BREVE', shcode=0x0069, uccode=0x020A, specials={'char',0x0069,0x0311} },
	[0x020C] = { unicodeslot=0x020C, category='lu', contextname='Odoublegrave', description='LATIN CAPITAL LETTER O WITH DOUBLE GRAVE', shcode=0x004F, lccode=0x020D, specials={'char',0x004F,0x030F} },
	[0x020D] = { unicodeslot=0x020D, category='ll', contextname='odoublegrave', description='LATIN SMALL LETTER O WITH DOUBLE GRAVE', shcode=0x006F, uccode=0x020C, specials={'char',0x006F,0x030F} },
	[0x020E] = { unicodeslot=0x020E, category='lu', contextname='Oinvertedbreve', description='LATIN CAPITAL LETTER O WITH INVERTED BREVE', shcode=0x004F, lccode=0x020F, specials={'char',0x004F,0x0311} },
	[0x020F] = { unicodeslot=0x020F, category='ll', contextname='oinvertedbreve', description='LATIN SMALL LETTER O WITH INVERTED BREVE', shcode=0x006F, uccode=0x020E, specials={'char',0x006F,0x0311} },
	[0x0210] = { unicodeslot=0x0210, category='lu', contextname='Rdoublegrave', description='LATIN CAPITAL LETTER R WITH DOUBLE GRAVE', shcode=0x0052, lccode=0x0211, specials={'char',0x0052,0x030F} },
	[0x0211] = { unicodeslot=0x0211, category='ll', contextname='rdoublegrave', description='LATIN SMALL LETTER R WITH DOUBLE GRAVE', shcode=0x0072, uccode=0x0210, specials={'char',0x0072,0x030F} },
	[0x0212] = { unicodeslot=0x0212, category='lu', contextname='Rinvertedbreve', description='LATIN CAPITAL LETTER R WITH INVERTED BREVE', shcode=0x0052, lccode=0x0213, specials={'char',0x0052,0x0311} },
	[0x0213] = { unicodeslot=0x0213, category='ll', contextname='rinvertedbreve', description='LATIN SMALL LETTER R WITH INVERTED BREVE', shcode=0x0072, uccode=0x0212, specials={'char',0x0072,0x0311} },
	[0x0214] = { unicodeslot=0x0214, category='lu', contextname='Udoublegrave', description='LATIN CAPITAL LETTER U WITH DOUBLE GRAVE', shcode=0x0055, lccode=0x0215, specials={'char',0x0055,0x030F} },
	[0x0215] = { unicodeslot=0x0215, category='ll', contextname='udoublegrave', description='LATIN SMALL LETTER U WITH DOUBLE GRAVE', shcode=0x0075, uccode=0x0214, specials={'char',0x0075,0x030F} },
	[0x0216] = { unicodeslot=0x0216, category='lu', contextname='Uinvertedbreve', description='LATIN CAPITAL LETTER U WITH INVERTED BREVE', shcode=0x0055, lccode=0x0217, specials={'char',0x0055,0x0311} },
	[0x0217] = { unicodeslot=0x0217, category='ll', contextname='uinvertedbreve', description='LATIN SMALL LETTER U WITH INVERTED BREVE', shcode=0x0075, uccode=0x0216, specials={'char',0x0075,0x0311} },
	[0x0218] = { unicodeslot=0x0218, category='lu', adobename='Scommaaccent', contextname='Scommaaccent', description='LATIN CAPITAL LETTER S WITH COMMA BELOW', shcode=0x0053, lccode=0x0219, specials={'char',0x0053,0x0326} },
	[0x0219] = { unicodeslot=0x0219, category='ll', adobename='scommaaccent', contextname='scommaaccent', description='LATIN SMALL LETTER S WITH COMMA BELOW', shcode=0x0073, uccode=0x0218, specials={'char',0x0073,0x0326} },
	[0x021A] = { unicodeslot=0x021A, category='lu', contextname='Tcommaaccent', description='LATIN CAPITAL LETTER T WITH COMMA BELOW', shcode=0x0054, lccode=0x021B, specials={'char',0x0054,0x0326} },
	[0x021B] = { unicodeslot=0x021B, category='ll', contextname='tcommaaccent', description='LATIN SMALL LETTER T WITH COMMA BELOW', shcode=0x0074, uccode=0x021A, specials={'char',0x0074,0x0326} },
	[0x021C] = { unicodeslot=0x021C, category='lu', description='LATIN CAPITAL LETTER YOGH', lccode=0x021D },
	[0x021D] = { unicodeslot=0x021D, category='ll', description='LATIN SMALL LETTER YOGH', uccode=0x021C },
	[0x021E] = { unicodeslot=0x021E, category='lu', contextname='Hcaron', description='LATIN CAPITAL LETTER H WITH CARON', shcode=0x0048, lccode=0x021F, specials={'char',0x0048,0x030C} },
	[0x021F] = { unicodeslot=0x021F, category='ll', contextname='hcaron', description='LATIN SMALL LETTER H WITH CARON', shcode=0x0068, uccode=0x021E, specials={'char',0x0068,0x030C} },
	[0x0220] = { unicodeslot=0x0220, category='lu', description='LATIN CAPITAL LETTER N WITH LONG RIGHT LEG', shcode=0x004E, lccode=0x019E },
	[0x0221] = { unicodeslot=0x0221, category='ll', contextname='dcurl', description='LATIN SMALL LETTER D WITH CURL', shcode=0x0064 },
	[0x0222] = { unicodeslot=0x0222, category='lu', description='LATIN CAPITAL LETTER OU', lccode=0x0223 },
	[0x0223] = { unicodeslot=0x0223, category='ll', description='LATIN SMALL LETTER OU', uccode=0x0222 },
	[0x0224] = { unicodeslot=0x0224, category='lu', contextname='Zhook', description='LATIN CAPITAL LETTER Z WITH HOOK', shcode=0x005A, lccode=0x0225 },
	[0x0225] = { unicodeslot=0x0225, category='ll', contextname='zhook', description='LATIN SMALL LETTER Z WITH HOOK', shcode=0x007A, uccode=0x0224 },
	[0x0226] = { unicodeslot=0x0226, category='lu', contextname='Adotaccent', description='LATIN CAPITAL LETTER A WITH DOT ABOVE', shcode=0x0041, lccode=0x0227, specials={'char',0x0041,0x0307} },
	[0x0227] = { unicodeslot=0x0227, category='ll', contextname='adotaccent', description='LATIN SMALL LETTER A WITH DOT ABOVE', shcode=0x0061, uccode=0x0226, specials={'char',0x0061,0x0307} },
	[0x0228] = { unicodeslot=0x0228, category='lu', contextname='Ecedilla', description='LATIN CAPITAL LETTER E WITH CEDILLA', shcode=0x0045, lccode=0x0229, specials={'char',0x0045,0x0327} },
	[0x0229] = { unicodeslot=0x0229, category='ll', contextname='ecedilla', description='LATIN SMALL LETTER E WITH CEDILLA', shcode=0x0065, uccode=0x0228, specials={'char',0x0065,0x0327} },
	[0x022A] = { unicodeslot=0x022A, category='lu', contextname='Odiaeresismacron', description='LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON', shcode=0x004F, lccode=0x022B, specials={'char',0x00D6,0x0304} },
	[0x022B] = { unicodeslot=0x022B, category='ll', contextname='odiaeresismacron', description='LATIN SMALL LETTER O WITH DIAERESIS AND MACRON', shcode=0x006F, uccode=0x022A, specials={'char',0x00F6,0x0304} },
	[0x022C] = { unicodeslot=0x022C, category='lu', contextname='Otildemacron', description='LATIN CAPITAL LETTER O WITH TILDE AND MACRON', shcode=0x004F, lccode=0x022D, specials={'char',0x00D5,0x0304} },
	[0x022D] = { unicodeslot=0x022D, category='ll', contextname='otildemacron', description='LATIN SMALL LETTER O WITH TILDE AND MACRON', shcode=0x006F, uccode=0x022C, specials={'char',0x00F5,0x0304} },
	[0x022E] = { unicodeslot=0x022E, category='lu', contextname='Odotaccent', description='LATIN CAPITAL LETTER O WITH DOT ABOVE', shcode=0x004F, lccode=0x022F, specials={'char',0x004F,0x0307} },
	[0x022F] = { unicodeslot=0x022F, category='ll', contextname='odotaccent', description='LATIN SMALL LETTER O WITH DOT ABOVE', shcode=0x006F, uccode=0x022E, specials={'char',0x006F,0x0307} },
	[0x0230] = { unicodeslot=0x0230, category='lu', contextname='Odotaccentmacron', description='LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON', shcode=0x004F, lccode=0x0231, specials={'char',0x022E,0x0304} },
	[0x0231] = { unicodeslot=0x0231, category='ll', contextname='odotaccentmacron', description='LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON', shcode=0x006F, uccode=0x0230, specials={'char',0x022F,0x0304} },
	[0x0232] = { unicodeslot=0x0232, category='lu', contextname='Ymacron', description='LATIN CAPITAL LETTER Y WITH MACRON', shcode=0x0059, lccode=0x0233, specials={'char',0x0059,0x0304} },
	[0x0233] = { unicodeslot=0x0233, category='ll', contextname='ymacron', description='LATIN SMALL LETTER Y WITH MACRON', shcode=0x0079, uccode=0x0232, specials={'char',0x0079,0x0304} },
	[0x0234] = { unicodeslot=0x0234, category='ll', contextname='lcurl', description='LATIN SMALL LETTER L WITH CURL', shcode=0x006C },
	[0x0235] = { unicodeslot=0x0235, category='ll', contextname='ncurl', description='LATIN SMALL LETTER N WITH CURL', shcode=0x006E },
	[0x0236] = { unicodeslot=0x0236, category='ll', contextname='tcurl', description='LATIN SMALL LETTER T WITH CURL', shcode=0x0074 },
	[0x0237] = { unicodeslot=0x0237, category='ll', contextname='dotlessj', description='LATIN SMALL LETTER DOTLESS J' },
	[0x0238] = { unicodeslot=0x0238, category='ll', description='LATIN SMALL LETTER DB DIGRAPH' },
	[0x0239] = { unicodeslot=0x0239, category='ll', description='LATIN SMALL LETTER QP DIGRAPH' },
	[0x023A] = { unicodeslot=0x023A, category='lu', contextname='Astroke', description='LATIN CAPITAL LETTER A WITH STROKE', shcode=0x0041, lccode=0x2C65 },
	[0x023B] = { unicodeslot=0x023B, category='lu', contextname='Cstroke', description='LATIN CAPITAL LETTER C WITH STROKE', shcode=0x0043, lccode=0x023C },
	[0x023C] = { unicodeslot=0x023C, category='ll', contextname='cstroke', description='LATIN SMALL LETTER C WITH STROKE', shcode=0x0063, uccode=0x023B },
	[0x023D] = { unicodeslot=0x023D, category='lu', contextname='Lbar', description='LATIN CAPITAL LETTER L WITH BAR', shcode=0x004C, lccode=0x019A },
	[0x023E] = { unicodeslot=0x023E, category='lu', description='LATIN CAPITAL LETTER T WITH DIAGONAL STROKE', shcode=0x0054, lccode=0x2C66 },
	[0x023F] = { unicodeslot=0x023F, category='ll', description='LATIN SMALL LETTER S WITH SWASH TAIL', shcode=0x0073 },
	[0x0240] = { unicodeslot=0x0240, category='ll', description='LATIN SMALL LETTER Z WITH SWASH TAIL', shcode=0x007A },
	[0x0241] = { unicodeslot=0x0241, category='lu', description='LATIN CAPITAL LETTER GLOTTAL STOP', lccode=0x0242 },
	[0x0242] = { unicodeslot=0x0242, category='ll', description='LATIN SMALL LETTER GLOTTAL STOP', uccode=0x0241 },
	[0x0243] = { unicodeslot=0x0243, category='lu', description='LATIN CAPITAL LETTER B WITH STROKE', shcode=0x0042, lccode=0x0180 },
	[0x0244] = { unicodeslot=0x0244, category='lu', description='LATIN CAPITAL LETTER U BAR', lccode=0x0289 },
	[0x0245] = { unicodeslot=0x0245, category='lu', description='LATIN CAPITAL LETTER TURNED V', lccode=0x028C },
	[0x0246] = { unicodeslot=0x0246, category='lu', description='LATIN CAPITAL LETTER E WITH STROKE', shcode=0x0045, lccode=0x0247 },
	[0x0247] = { unicodeslot=0x0247, category='ll', description='LATIN SMALL LETTER E WITH STROKE', shcode=0x0065, uccode=0x0246 },
	[0x0248] = { unicodeslot=0x0248, category='lu', description='LATIN CAPITAL LETTER J WITH STROKE', shcode=0x004A, lccode=0x0249 },
	[0x0249] = { unicodeslot=0x0249, category='ll', description='LATIN SMALL LETTER J WITH STROKE', shcode=0x006A, uccode=0x0248 },
	[0x024A] = { unicodeslot=0x024A, category='lu', description='LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL', lccode=0x024B },
	[0x024B] = { unicodeslot=0x024B, category='ll', description='LATIN SMALL LETTER Q WITH HOOK TAIL', shcode=0x0071, uccode=0x024A },
	[0x024C] = { unicodeslot=0x024C, category='lu', description='LATIN CAPITAL LETTER R WITH STROKE', shcode=0x0052, lccode=0x024D },
	[0x024D] = { unicodeslot=0x024D, category='ll', description='LATIN SMALL LETTER R WITH STROKE', shcode=0x0072, uccode=0x024C },
	[0x024E] = { unicodeslot=0x024E, category='lu', description='LATIN CAPITAL LETTER Y WITH STROKE', shcode=0x0059, lccode=0x024F },
	[0x024F] = { unicodeslot=0x024F, category='ll', description='LATIN SMALL LETTER Y WITH STROKE', shcode=0x0079, uccode=0x024E },
	[0x0250] = { unicodeslot=0x0250, category='ll', description='LATIN SMALL LETTER TURNED A' },
	[0x0251] = { unicodeslot=0x0251, category='ll', description='LATIN SMALL LETTER ALPHA' },
	[0x0252] = { unicodeslot=0x0252, category='ll', description='LATIN SMALL LETTER TURNED ALPHA' },
	[0x0253] = { unicodeslot=0x0253, category='ll', contextname='bhook', description='LATIN SMALL LETTER B WITH HOOK', shcode=0x0062, uccode=0x0181 },
	[0x0254] = { unicodeslot=0x0254, category='ll', description='LATIN SMALL LETTER OPEN O', uccode=0x0186 },
	[0x0255] = { unicodeslot=0x0255, category='ll', contextname='ccurl', description='LATIN SMALL LETTER C WITH CURL', shcode=0x0063 },
	[0x0256] = { unicodeslot=0x0256, category='ll', contextname='dtail', description='LATIN SMALL LETTER D WITH TAIL', shcode=0x0064, uccode=0x0189 },
	[0x0257] = { unicodeslot=0x0257, category='ll', contextname='dhook', description='LATIN SMALL LETTER D WITH HOOK', shcode=0x0064, uccode=0x018A },
	[0x0258] = { unicodeslot=0x0258, category='ll', description='LATIN SMALL LETTER REVERSED E' },
	[0x0259] = { unicodeslot=0x0259, category='ll', contextname='schwa', description='LATIN SMALL LETTER SCHWA', uccode=0x018F },
	[0x025A] = { unicodeslot=0x025A, category='ll', contextname='schwahook', description='LATIN SMALL LETTER SCHWA WITH HOOK', shcode=0x0259 },
	[0x025B] = { unicodeslot=0x025B, category='ll', description='LATIN SMALL LETTER OPEN E', uccode=0x0190 },
	[0x025C] = { unicodeslot=0x025C, category='ll', description='LATIN SMALL LETTER REVERSED OPEN E' },
	[0x025D] = { unicodeslot=0x025D, category='ll', description='LATIN SMALL LETTER REVERSED OPEN E WITH HOOK' },
	[0x025E] = { unicodeslot=0x025E, category='ll', description='LATIN SMALL LETTER CLOSED REVERSED OPEN E' },
	[0x025F] = { unicodeslot=0x025F, category='ll', contextname='dotlessjstroke', description='LATIN SMALL LETTER DOTLESS J WITH STROKE' },
	[0x0260] = { unicodeslot=0x0260, category='ll', description='LATIN SMALL LETTER G WITH HOOK', shcode=0x0067, uccode=0x0193 },
	[0x0261] = { unicodeslot=0x0261, category='ll', description='LATIN SMALL LETTER SCRIPT G' },
	[0x0262] = { unicodeslot=0x0262, category='ll', description='LATIN LETTER SMALL CAPITAL G' },
	[0x0263] = { unicodeslot=0x0263, category='ll', description='LATIN SMALL LETTER GAMMA', uccode=0x0194 },
	[0x0264] = { unicodeslot=0x0264, category='ll', description='LATIN SMALL LETTER RAMS HORN' },
	[0x0265] = { unicodeslot=0x0265, category='ll', description='LATIN SMALL LETTER TURNED H' },
	[0x0266] = { unicodeslot=0x0266, category='ll', description='LATIN SMALL LETTER H WITH HOOK', shcode=0x0068 },
	[0x0267] = { unicodeslot=0x0267, category='ll', description='LATIN SMALL LETTER HENG WITH HOOK' },
	[0x0268] = { unicodeslot=0x0268, category='ll', description='LATIN SMALL LETTER I WITH STROKE', shcode=0x0069, uccode=0x0197 },
	[0x0269] = { unicodeslot=0x0269, category='ll', description='LATIN SMALL LETTER IOTA', uccode=0x0196 },
	[0x026A] = { unicodeslot=0x026A, category='ll', description='LATIN LETTER SMALL CAPITAL I' },
	[0x026B] = { unicodeslot=0x026B, category='ll', description='LATIN SMALL LETTER L WITH MIDDLE TILDE', shcode=0x006C, uccode=0x2C62 },
	[0x026C] = { unicodeslot=0x026C, category='ll', description='LATIN SMALL LETTER L WITH BELT', shcode=0x006C },
	[0x026D] = { unicodeslot=0x026D, category='ll', description='LATIN SMALL LETTER L WITH RETROFLEX HOOK', shcode=0x006C },
	[0x026E] = { unicodeslot=0x026E, category='ll', description='LATIN SMALL LETTER LEZH' },
	[0x026F] = { unicodeslot=0x026F, category='ll', description='LATIN SMALL LETTER TURNED M', uccode=0x019C },
	[0x0270] = { unicodeslot=0x0270, category='ll', description='LATIN SMALL LETTER TURNED M WITH LONG LEG' },
	[0x0271] = { unicodeslot=0x0271, category='ll', description='LATIN SMALL LETTER M WITH HOOK', shcode=0x006D },
	[0x0272] = { unicodeslot=0x0272, category='ll', description='LATIN SMALL LETTER N WITH LEFT HOOK', shcode=0x006E, uccode=0x019D },
	[0x0273] = { unicodeslot=0x0273, category='ll', description='LATIN SMALL LETTER N WITH RETROFLEX HOOK', shcode=0x006E },
	[0x0274] = { unicodeslot=0x0274, category='ll', description='LATIN LETTER SMALL CAPITAL N' },
	[0x0275] = { unicodeslot=0x0275, category='ll', description='LATIN SMALL LETTER BARRED O', uccode=0x019F },
	[0x0276] = { unicodeslot=0x0276, category='ll', description='LATIN LETTER SMALL CAPITAL OE' },
	[0x0277] = { unicodeslot=0x0277, category='ll', description='LATIN SMALL LETTER CLOSED OMEGA' },
	[0x0278] = { unicodeslot=0x0278, category='ll', description='LATIN SMALL LETTER PHI' },
	[0x0279] = { unicodeslot=0x0279, category='ll', description='LATIN SMALL LETTER TURNED R' },
	[0x027A] = { unicodeslot=0x027A, category='ll', description='LATIN SMALL LETTER TURNED R WITH LONG LEG' },
	[0x027B] = { unicodeslot=0x027B, category='ll', description='LATIN SMALL LETTER TURNED R WITH HOOK' },
	[0x027C] = { unicodeslot=0x027C, category='ll', description='LATIN SMALL LETTER R WITH LONG LEG', shcode=0x0072 },
	[0x027D] = { unicodeslot=0x027D, category='ll', description='LATIN SMALL LETTER R WITH TAIL', shcode=0x0072, uccode=0x2C64 },
	[0x027E] = { unicodeslot=0x027E, category='ll', description='LATIN SMALL LETTER R WITH FISHHOOK', shcode=0x0072 },
	[0x027F] = { unicodeslot=0x027F, category='ll', description='LATIN SMALL LETTER REVERSED R WITH FISHHOOK' },
	[0x0280] = { unicodeslot=0x0280, category='ll', description='LATIN LETTER SMALL CAPITAL R', uccode=0x01A6 },
	[0x0281] = { unicodeslot=0x0281, category='ll', description='LATIN LETTER SMALL CAPITAL INVERTED R' },
	[0x0282] = { unicodeslot=0x0282, category='ll', description='LATIN SMALL LETTER S WITH HOOK', shcode=0x0073 },
	[0x0283] = { unicodeslot=0x0283, category='ll', description='LATIN SMALL LETTER ESH', uccode=0x01A9 },
	[0x0284] = { unicodeslot=0x0284, category='ll', description='LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK' },
	[0x0285] = { unicodeslot=0x0285, category='ll', description='LATIN SMALL LETTER SQUAT REVERSED ESH' },
	[0x0286] = { unicodeslot=0x0286, category='ll', description='LATIN SMALL LETTER ESH WITH CURL', shcode=0x0283 },
	[0x0287] = { unicodeslot=0x0287, category='ll', description='LATIN SMALL LETTER TURNED T' },
	[0x0288] = { unicodeslot=0x0288, category='ll', description='LATIN SMALL LETTER T WITH RETROFLEX HOOK', shcode=0x0074, uccode=0x01AE },
	[0x0289] = { unicodeslot=0x0289, category='ll', description='LATIN SMALL LETTER U BAR', uccode=0x0244 },
	[0x028A] = { unicodeslot=0x028A, category='ll', description='LATIN SMALL LETTER UPSILON', uccode=0x01B1 },
	[0x028B] = { unicodeslot=0x028B, category='ll', description='LATIN SMALL LETTER V WITH HOOK', shcode=0x0076, uccode=0x01B2 },
	[0x028C] = { unicodeslot=0x028C, category='ll', description='LATIN SMALL LETTER TURNED V', uccode=0x0245 },
	[0x028D] = { unicodeslot=0x028D, category='ll', description='LATIN SMALL LETTER TURNED W' },
	[0x028E] = { unicodeslot=0x028E, category='ll', description='LATIN SMALL LETTER TURNED Y' },
	[0x028F] = { unicodeslot=0x028F, category='ll', description='LATIN LETTER SMALL CAPITAL Y' },
	[0x0290] = { unicodeslot=0x0290, category='ll', description='LATIN SMALL LETTER Z WITH RETROFLEX HOOK', shcode=0x007A },
	[0x0291] = { unicodeslot=0x0291, category='ll', description='LATIN SMALL LETTER Z WITH CURL', shcode=0x007A },
	[0x0292] = { unicodeslot=0x0292, category='ll', description='LATIN SMALL LETTER EZH', uccode=0x01B7 },
	[0x0293] = { unicodeslot=0x0293, category='ll', description='LATIN SMALL LETTER EZH WITH CURL', shcode=0x0292 },
	[0x0294] = { unicodeslot=0x0294, category='lo', description='LATIN LETTER GLOTTAL STOP' },
	[0x0295] = { unicodeslot=0x0295, category='ll', description='LATIN LETTER PHARYNGEAL VOICED FRICATIVE' },
	[0x0296] = { unicodeslot=0x0296, category='ll', description='LATIN LETTER INVERTED GLOTTAL STOP' },
	[0x0297] = { unicodeslot=0x0297, category='ll', description='LATIN LETTER STRETCHED C' },
	[0x0298] = { unicodeslot=0x0298, category='ll', description='LATIN LETTER BILABIAL CLICK' },
	[0x0299] = { unicodeslot=0x0299, category='ll', description='LATIN LETTER SMALL CAPITAL B' },
	[0x029A] = { unicodeslot=0x029A, category='ll', description='LATIN SMALL LETTER CLOSED OPEN E' },
	[0x029B] = { unicodeslot=0x029B, category='ll', description='LATIN LETTER SMALL CAPITAL G WITH HOOK' },
	[0x029C] = { unicodeslot=0x029C, category='ll', description='LATIN LETTER SMALL CAPITAL H' },
	[0x029D] = { unicodeslot=0x029D, category='ll', description='LATIN SMALL LETTER J WITH CROSSED-TAIL', shcode=0x006A },
	[0x029E] = { unicodeslot=0x029E, category='ll', description='LATIN SMALL LETTER TURNED K' },
	[0x029F] = { unicodeslot=0x029F, category='ll', description='LATIN LETTER SMALL CAPITAL L' },
	[0x02A0] = { unicodeslot=0x02A0, category='ll', description='LATIN SMALL LETTER Q WITH HOOK', shcode=0x0071 },
	[0x02A1] = { unicodeslot=0x02A1, category='ll', description='LATIN LETTER GLOTTAL STOP WITH STROKE' },
	[0x02A2] = { unicodeslot=0x02A2, category='ll', description='LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE' },
	[0x02A3] = { unicodeslot=0x02A3, category='ll', description='LATIN SMALL LETTER DZ DIGRAPH' },
	[0x02A4] = { unicodeslot=0x02A4, category='ll', description='LATIN SMALL LETTER DEZH DIGRAPH' },
	[0x02A5] = { unicodeslot=0x02A5, category='ll', description='LATIN SMALL LETTER DZ DIGRAPH WITH CURL' },
	[0x02A6] = { unicodeslot=0x02A6, category='ll', description='LATIN SMALL LETTER TS DIGRAPH' },
	[0x02A7] = { unicodeslot=0x02A7, category='ll', description='LATIN SMALL LETTER TESH DIGRAPH' },
	[0x02A8] = { unicodeslot=0x02A8, category='ll', description='LATIN SMALL LETTER TC DIGRAPH WITH CURL' },
	[0x02A9] = { unicodeslot=0x02A9, category='ll', description='LATIN SMALL LETTER FENG DIGRAPH' },
	[0x02AA] = { unicodeslot=0x02AA, category='ll', description='LATIN SMALL LETTER LS DIGRAPH' },
	[0x02AB] = { unicodeslot=0x02AB, category='ll', description='LATIN SMALL LETTER LZ DIGRAPH' },
	[0x02AC] = { unicodeslot=0x02AC, category='ll', description='LATIN LETTER BILABIAL PERCUSSIVE' },
	[0x02AD] = { unicodeslot=0x02AD, category='ll', description='LATIN LETTER BIDENTAL PERCUSSIVE' },
	[0x02AE] = { unicodeslot=0x02AE, category='ll', description='LATIN SMALL LETTER TURNED H WITH FISHHOOK' },
	[0x02AF] = { unicodeslot=0x02AF, category='ll', description='LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL' },
	[0x02B0] = { unicodeslot=0x02B0, category='lm', description='MODIFIER LETTER SMALL H', specials={'super',0x0068} },
	[0x02B1] = { unicodeslot=0x02B1, category='lm', description='MODIFIER LETTER SMALL H WITH HOOK', specials={'super',0x0266} },
	[0x02B2] = { unicodeslot=0x02B2, category='lm', description='MODIFIER LETTER SMALL J', specials={'super',0x006A} },
	[0x02B3] = { unicodeslot=0x02B3, category='lm', description='MODIFIER LETTER SMALL R', specials={'super',0x0072} },
	[0x02B4] = { unicodeslot=0x02B4, category='lm', description='MODIFIER LETTER SMALL TURNED R', specials={'super',0x0279} },
	[0x02B5] = { unicodeslot=0x02B5, category='lm', description='MODIFIER LETTER SMALL TURNED R WITH HOOK', specials={'super',0x027B} },
	[0x02B6] = { unicodeslot=0x02B6, category='lm', description='MODIFIER LETTER SMALL CAPITAL INVERTED R', specials={'super',0x0281} },
	[0x02B7] = { unicodeslot=0x02B7, category='lm', description='MODIFIER LETTER SMALL W', specials={'super',0x0077} },
	[0x02B8] = { unicodeslot=0x02B8, category='lm', description='MODIFIER LETTER SMALL Y', specials={'super',0x0079} },
	[0x02B9] = { unicodeslot=0x02B9, category='lm', description='MODIFIER LETTER PRIME' },
	[0x02BA] = { unicodeslot=0x02BA, category='lm', description='MODIFIER LETTER DOUBLE PRIME' },
	[0x02BB] = { unicodeslot=0x02BB, category='lm', description='MODIFIER LETTER TURNED COMMA' },
	[0x02BC] = { unicodeslot=0x02BC, category='lm', adobename='afii57929', description='MODIFIER LETTER APOSTROPHE' },
	[0x02BD] = { unicodeslot=0x02BD, category='lm', adobename='afii64937', description='MODIFIER LETTER REVERSED COMMA' },
	[0x02BE] = { unicodeslot=0x02BE, category='lm', description='MODIFIER LETTER RIGHT HALF RING' },
	[0x02BF] = { unicodeslot=0x02BF, category='lm', description='MODIFIER LETTER LEFT HALF RING' },
	[0x02C0] = { unicodeslot=0x02C0, category='lm', description='MODIFIER LETTER GLOTTAL STOP' },
	[0x02C1] = { unicodeslot=0x02C1, category='lm', description='MODIFIER LETTER REVERSED GLOTTAL STOP' },
	[0x02C2] = { unicodeslot=0x02C2, category='sk', description='MODIFIER LETTER LEFT ARROWHEAD' },
	[0x02C3] = { unicodeslot=0x02C3, category='sk', description='MODIFIER LETTER RIGHT ARROWHEAD' },
	[0x02C4] = { unicodeslot=0x02C4, category='sk', description='MODIFIER LETTER UP ARROWHEAD' },
	[0x02C5] = { unicodeslot=0x02C5, category='sk', description='MODIFIER LETTER DOWN ARROWHEAD' },
	[0x02C6] = { unicodeslot=0x02C6, category='lm', adobename='circumflex', contextname='textcircumflex', description='MODIFIER LETTER CIRCUMFLEX ACCENT' },
	[0x02C7] = { unicodeslot=0x02C7, category='lm', adobename='caron', contextname='textcaron', description='CARON' },
	[0x02C8] = { unicodeslot=0x02C8, category='lm', description='MODIFIER LETTER VERTICAL LINE' },
	[0x02C9] = { unicodeslot=0x02C9, category='lm', description='MODIFIER LETTER MACRON' },
	[0x02CA] = { unicodeslot=0x02CA, category='lm', description='MODIFIER LETTER ACUTE ACCENT' },
	[0x02CB] = { unicodeslot=0x02CB, category='lm', description='MODIFIER LETTER GRAVE ACCENT' },
	[0x02CC] = { unicodeslot=0x02CC, category='lm', description='MODIFIER LETTER LOW VERTICAL LINE' },
	[0x02CD] = { unicodeslot=0x02CD, category='lm', description='MODIFIER LETTER LOW MACRON' },
	[0x02CE] = { unicodeslot=0x02CE, category='lm', description='MODIFIER LETTER LOW GRAVE ACCENT' },
	[0x02CF] = { unicodeslot=0x02CF, category='lm', description='MODIFIER LETTER LOW ACUTE ACCENT' },
	[0x02D0] = { unicodeslot=0x02D0, category='lm', description='MODIFIER LETTER TRIANGULAR COLON' },
	[0x02D1] = { unicodeslot=0x02D1, category='lm', description='MODIFIER LETTER HALF TRIANGULAR COLON' },
	[0x02D2] = { unicodeslot=0x02D2, category='sk', description='MODIFIER LETTER CENTRED RIGHT HALF RING' },
	[0x02D3] = { unicodeslot=0x02D3, category='sk', description='MODIFIER LETTER CENTRED LEFT HALF RING' },
	[0x02D4] = { unicodeslot=0x02D4, category='sk', description='MODIFIER LETTER UP TACK' },
	[0x02D5] = { unicodeslot=0x02D5, category='sk', description='MODIFIER LETTER DOWN TACK' },
	[0x02D6] = { unicodeslot=0x02D6, category='sk', description='MODIFIER LETTER PLUS SIGN' },
	[0x02D7] = { unicodeslot=0x02D7, category='sk', description='MODIFIER LETTER MINUS SIGN' },
	[0x02D8] = { unicodeslot=0x02D8, category='sk', adobename='breve', contextname='textbreve', description='BREVE', specials={'compat',0x0020,0x0306} },
	[0x02D9] = { unicodeslot=0x02D9, category='sk', adobename='dotaccent', contextname='textdotaccent', description='DOT ABOVE', specials={'compat',0x0020,0x0307} },
	[0x02DA] = { unicodeslot=0x02DA, category='sk', adobename='ring', contextname='textring', description='RING ABOVE', specials={'compat',0x0020,0x030A} },
	[0x02DB] = { unicodeslot=0x02DB, category='sk', adobename='ogonek', contextname='textogonek', description='OGONEK', specials={'compat',0x0020,0x0328} },
	[0x02DC] = { unicodeslot=0x02DC, category='sk', adobename='tilde', contextname='texttilde', description='SMALL TILDE', specials={'compat',0x0020,0x0303} },
	[0x02DD] = { unicodeslot=0x02DD, category='sk', adobename='hungarumlaut', contextname='texthungarumlaut', description='DOUBLE ACUTE ACCENT', specials={'compat',0x0020,0x030B} },
	[0x02DE] = { unicodeslot=0x02DE, category='sk', description='MODIFIER LETTER RHOTIC HOOK' },
	[0x02DF] = { unicodeslot=0x02DF, category='sk', description='MODIFIER LETTER CROSS ACCENT' },
	[0x02E0] = { unicodeslot=0x02E0, category='lm', description='MODIFIER LETTER SMALL GAMMA', specials={'super',0x0263} },
	[0x02E1] = { unicodeslot=0x02E1, category='lm', description='MODIFIER LETTER SMALL L', specials={'super',0x006C} },
	[0x02E2] = { unicodeslot=0x02E2, category='lm', description='MODIFIER LETTER SMALL S', specials={'super',0x0073} },
	[0x02E3] = { unicodeslot=0x02E3, category='lm', description='MODIFIER LETTER SMALL X', specials={'super',0x0078} },
	[0x02E4] = { unicodeslot=0x02E4, category='lm', description='MODIFIER LETTER SMALL REVERSED GLOTTAL STOP', specials={'super',0x0295} },
	[0x02E5] = { unicodeslot=0x02E5, category='sk', description='MODIFIER LETTER EXTRA-HIGH TONE BAR' },
	[0x02E6] = { unicodeslot=0x02E6, category='sk', description='MODIFIER LETTER HIGH TONE BAR' },
	[0x02E7] = { unicodeslot=0x02E7, category='sk', description='MODIFIER LETTER MID TONE BAR' },
	[0x02E8] = { unicodeslot=0x02E8, category='sk', description='MODIFIER LETTER LOW TONE BAR' },
	[0x02E9] = { unicodeslot=0x02E9, category='sk', description='MODIFIER LETTER EXTRA-LOW TONE BAR' },
	[0x02EA] = { unicodeslot=0x02EA, category='sk', description='MODIFIER LETTER YIN DEPARTING TONE MARK' },
	[0x02EB] = { unicodeslot=0x02EB, category='sk', description='MODIFIER LETTER YANG DEPARTING TONE MARK' },
	[0x02EC] = { unicodeslot=0x02EC, category='sk', description='MODIFIER LETTER VOICING' },
	[0x02ED] = { unicodeslot=0x02ED, category='sk', description='MODIFIER LETTER UNASPIRATED' },
	[0x02EE] = { unicodeslot=0x02EE, category='lm', description='MODIFIER LETTER DOUBLE APOSTROPHE' },
	[0x02EF] = { unicodeslot=0x02EF, category='sk', description='MODIFIER LETTER LOW DOWN ARROWHEAD' },
	[0x02F0] = { unicodeslot=0x02F0, category='sk', description='MODIFIER LETTER LOW UP ARROWHEAD' },
	[0x02F1] = { unicodeslot=0x02F1, category='sk', description='MODIFIER LETTER LOW LEFT ARROWHEAD' },
	[0x02F2] = { unicodeslot=0x02F2, category='sk', description='MODIFIER LETTER LOW RIGHT ARROWHEAD' },
	[0x02F3] = { unicodeslot=0x02F3, category='sk', description='MODIFIER LETTER LOW RING' },
	[0x02F4] = { unicodeslot=0x02F4, category='sk', description='MODIFIER LETTER MIDDLE GRAVE ACCENT' },
	[0x02F5] = { unicodeslot=0x02F5, category='sk', description='MODIFIER LETTER MIDDLE DOUBLE GRAVE ACCENT' },
	[0x02F6] = { unicodeslot=0x02F6, category='sk', description='MODIFIER LETTER MIDDLE DOUBLE ACUTE ACCENT' },
	[0x02F7] = { unicodeslot=0x02F7, category='sk', description='MODIFIER LETTER LOW TILDE' },
	[0x02F8] = { unicodeslot=0x02F8, category='sk', description='MODIFIER LETTER RAISED COLON' },
	[0x02F9] = { unicodeslot=0x02F9, category='sk', description='MODIFIER LETTER BEGIN HIGH TONE' },
	[0x02FA] = { unicodeslot=0x02FA, category='sk', description='MODIFIER LETTER END HIGH TONE' },
	[0x02FB] = { unicodeslot=0x02FB, category='sk', description='MODIFIER LETTER BEGIN LOW TONE' },
	[0x02FC] = { unicodeslot=0x02FC, category='sk', description='MODIFIER LETTER END LOW TONE' },
	[0x02FD] = { unicodeslot=0x02FD, category='sk', description='MODIFIER LETTER SHELF' },
	[0x02FE] = { unicodeslot=0x02FE, category='sk', description='MODIFIER LETTER OPEN SHELF' },
	[0x02FF] = { unicodeslot=0x02FF, category='sk', description='MODIFIER LETTER LOW LEFT ARROW' },
	[0x0300] = { unicodeslot=0x0300, category='mn', adobename='gravecomb', description='COMBINING GRAVE ACCENT' },
	[0x0301] = { unicodeslot=0x0301, category='mn', adobename='acutecomb', description='COMBINING ACUTE ACCENT' },
	[0x0302] = { unicodeslot=0x0302, category='mn', description='COMBINING CIRCUMFLEX ACCENT' },
	[0x0303] = { unicodeslot=0x0303, category='mn', adobename='tildecomb', description='COMBINING TILDE' },
	[0x0304] = { unicodeslot=0x0304, category='mn', description='COMBINING MACRON' },
	[0x0305] = { unicodeslot=0x0305, category='mn', description='COMBINING OVERLINE' },
	[0x0306] = { unicodeslot=0x0306, category='mn', description='COMBINING BREVE' },
	[0x0307] = { unicodeslot=0x0307, category='mn', description='COMBINING DOT ABOVE' },
	[0x0308] = { unicodeslot=0x0308, category='mn', description='COMBINING DIAERESIS' },
	[0x0309] = { unicodeslot=0x0309, category='mn', adobename='hookabovecomb', description='COMBINING HOOK ABOVE' },
	[0x030A] = { unicodeslot=0x030A, category='mn', description='COMBINING RING ABOVE' },
	[0x030B] = { unicodeslot=0x030B, category='mn', description='COMBINING DOUBLE ACUTE ACCENT' },
	[0x030C] = { unicodeslot=0x030C, category='mn', description='COMBINING CARON' },
	[0x030D] = { unicodeslot=0x030D, category='mn', description='COMBINING VERTICAL LINE ABOVE' },
	[0x030E] = { unicodeslot=0x030E, category='mn', description='COMBINING DOUBLE VERTICAL LINE ABOVE' },
	[0x030F] = { unicodeslot=0x030F, category='mn', description='COMBINING DOUBLE GRAVE ACCENT' },
	[0x0310] = { unicodeslot=0x0310, category='mn', description='COMBINING CANDRABINDU' },
	[0x0311] = { unicodeslot=0x0311, category='mn', description='COMBINING INVERTED BREVE' },
	[0x0312] = { unicodeslot=0x0312, category='mn', description='COMBINING TURNED COMMA ABOVE' },
	[0x0313] = { unicodeslot=0x0313, category='mn', description='COMBINING COMMA ABOVE' },
	[0x0314] = { unicodeslot=0x0314, category='mn', description='COMBINING REVERSED COMMA ABOVE' },
	[0x0315] = { unicodeslot=0x0315, category='mn', description='COMBINING COMMA ABOVE RIGHT' },
	[0x0316] = { unicodeslot=0x0316, category='mn', description='COMBINING GRAVE ACCENT BELOW' },
	[0x0317] = { unicodeslot=0x0317, category='mn', description='COMBINING ACUTE ACCENT BELOW' },
	[0x0318] = { unicodeslot=0x0318, category='mn', description='COMBINING LEFT TACK BELOW' },
	[0x0319] = { unicodeslot=0x0319, category='mn', description='COMBINING RIGHT TACK BELOW' },
	[0x031A] = { unicodeslot=0x031A, category='mn', description='COMBINING LEFT ANGLE ABOVE' },
	[0x031B] = { unicodeslot=0x031B, category='mn', description='COMBINING HORN' },
	[0x031C] = { unicodeslot=0x031C, category='mn', description='COMBINING LEFT HALF RING BELOW' },
	[0x031D] = { unicodeslot=0x031D, category='mn', description='COMBINING UP TACK BELOW' },
	[0x031E] = { unicodeslot=0x031E, category='mn', description='COMBINING DOWN TACK BELOW' },
	[0x031F] = { unicodeslot=0x031F, category='mn', description='COMBINING PLUS SIGN BELOW' },
	[0x0320] = { unicodeslot=0x0320, category='mn', description='COMBINING MINUS SIGN BELOW' },
	[0x0321] = { unicodeslot=0x0321, category='mn', description='COMBINING PALATALIZED HOOK BELOW' },
	[0x0322] = { unicodeslot=0x0322, category='mn', description='COMBINING RETROFLEX HOOK BELOW' },
	[0x0323] = { unicodeslot=0x0323, category='mn', adobename='dotbelowcomb', description='COMBINING DOT BELOW' },
	[0x0324] = { unicodeslot=0x0324, category='mn', description='COMBINING DIAERESIS BELOW' },
	[0x0325] = { unicodeslot=0x0325, category='mn', description='COMBINING RING BELOW' },
	[0x0326] = { unicodeslot=0x0326, category='mn', description='COMBINING COMMA BELOW' },
	[0x0327] = { unicodeslot=0x0327, category='mn', description='COMBINING CEDILLA' },
	[0x0328] = { unicodeslot=0x0328, category='mn', description='COMBINING OGONEK' },
	[0x0329] = { unicodeslot=0x0329, category='mn', description='COMBINING VERTICAL LINE BELOW' },
	[0x032A] = { unicodeslot=0x032A, category='mn', description='COMBINING BRIDGE BELOW' },
	[0x032B] = { unicodeslot=0x032B, category='mn', description='COMBINING INVERTED DOUBLE ARCH BELOW' },
	[0x032C] = { unicodeslot=0x032C, category='mn', description='COMBINING CARON BELOW' },
	[0x032D] = { unicodeslot=0x032D, category='mn', description='COMBINING CIRCUMFLEX ACCENT BELOW' },
	[0x032E] = { unicodeslot=0x032E, category='mn', description='COMBINING BREVE BELOW' },
	[0x032F] = { unicodeslot=0x032F, category='mn', description='COMBINING INVERTED BREVE BELOW' },
	[0x0330] = { unicodeslot=0x0330, category='mn', description='COMBINING TILDE BELOW' },
	[0x0331] = { unicodeslot=0x0331, category='mn', description='COMBINING MACRON BELOW' },
	[0x0332] = { unicodeslot=0x0332, category='mn', description='COMBINING LOW LINE' },
	[0x0333] = { unicodeslot=0x0333, category='mn', description='COMBINING DOUBLE LOW LINE' },
	[0x0334] = { unicodeslot=0x0334, category='mn', description='COMBINING TILDE OVERLAY' },
	[0x0335] = { unicodeslot=0x0335, category='mn', description='COMBINING SHORT STROKE OVERLAY' },
	[0x0336] = { unicodeslot=0x0336, category='mn', description='COMBINING LONG STROKE OVERLAY' },
	[0x0337] = { unicodeslot=0x0337, category='mn', description='COMBINING SHORT SOLIDUS OVERLAY' },
	[0x0338] = { unicodeslot=0x0338, category='mn', description='COMBINING LONG SOLIDUS OVERLAY' },
	[0x0339] = { unicodeslot=0x0339, category='mn', description='COMBINING RIGHT HALF RING BELOW' },
	[0x033A] = { unicodeslot=0x033A, category='mn', description='COMBINING INVERTED BRIDGE BELOW' },
	[0x033B] = { unicodeslot=0x033B, category='mn', description='COMBINING SQUARE BELOW' },
	[0x033C] = { unicodeslot=0x033C, category='mn', description='COMBINING SEAGULL BELOW' },
	[0x033D] = { unicodeslot=0x033D, category='mn', description='COMBINING X ABOVE' },
	[0x033E] = { unicodeslot=0x033E, category='mn', description='COMBINING VERTICAL TILDE' },
	[0x033F] = { unicodeslot=0x033F, category='mn', description='COMBINING DOUBLE OVERLINE' },
	[0x0340] = { unicodeslot=0x0340, category='mn', description='COMBINING GRAVE TONE MARK', specials={'char',0x0300} },
	[0x0341] = { unicodeslot=0x0341, category='mn', description='COMBINING ACUTE TONE MARK', specials={'char',0x0301} },
	[0x0342] = { unicodeslot=0x0342, category='mn', description='COMBINING GREEK PERISPOMENI' },
	[0x0343] = { unicodeslot=0x0343, category='mn', description='COMBINING GREEK KORONIS', specials={'char',0x0313} },
	[0x0344] = { unicodeslot=0x0344, category='mn', description='COMBINING GREEK DIALYTIKA TONOS', specials={'char',0x0308,0x0301} },
	[0x0345] = { unicodeslot=0x0345, category='mn', description='COMBINING GREEK YPOGEGRAMMENI', uccode=0x0399 },
	[0x0346] = { unicodeslot=0x0346, category='mn', description='COMBINING BRIDGE ABOVE' },
	[0x0347] = { unicodeslot=0x0347, category='mn', description='COMBINING EQUALS SIGN BELOW' },
	[0x0348] = { unicodeslot=0x0348, category='mn', description='COMBINING DOUBLE VERTICAL LINE BELOW' },
	[0x0349] = { unicodeslot=0x0349, category='mn', description='COMBINING LEFT ANGLE BELOW' },
	[0x034A] = { unicodeslot=0x034A, category='mn', description='COMBINING NOT TILDE ABOVE' },
	[0x034B] = { unicodeslot=0x034B, category='mn', description='COMBINING HOMOTHETIC ABOVE' },
	[0x034C] = { unicodeslot=0x034C, category='mn', description='COMBINING ALMOST EQUAL TO ABOVE' },
	[0x034D] = { unicodeslot=0x034D, category='mn', description='COMBINING LEFT RIGHT ARROW BELOW' },
	[0x034E] = { unicodeslot=0x034E, category='mn', description='COMBINING UPWARDS ARROW BELOW' },
	[0x034F] = { unicodeslot=0x034F, category='mn', description='COMBINING GRAPHEME JOINER' },
	[0x0350] = { unicodeslot=0x0350, category='mn', description='COMBINING RIGHT ARROWHEAD ABOVE' },
	[0x0351] = { unicodeslot=0x0351, category='mn', description='COMBINING LEFT HALF RING ABOVE' },
	[0x0352] = { unicodeslot=0x0352, category='mn', description='COMBINING FERMATA' },
	[0x0353] = { unicodeslot=0x0353, category='mn', description='COMBINING X BELOW' },
	[0x0354] = { unicodeslot=0x0354, category='mn', description='COMBINING LEFT ARROWHEAD BELOW' },
	[0x0355] = { unicodeslot=0x0355, category='mn', description='COMBINING RIGHT ARROWHEAD BELOW' },
	[0x0356] = { unicodeslot=0x0356, category='mn', description='COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW' },
	[0x0357] = { unicodeslot=0x0357, category='mn', description='COMBINING RIGHT HALF RING ABOVE' },
	[0x0358] = { unicodeslot=0x0358, category='mn', description='COMBINING DOT ABOVE RIGHT' },
	[0x0359] = { unicodeslot=0x0359, category='mn', description='COMBINING ASTERISK BELOW' },
	[0x035A] = { unicodeslot=0x035A, category='mn', description='COMBINING DOUBLE RING BELOW' },
	[0x035B] = { unicodeslot=0x035B, category='mn', description='COMBINING ZIGZAG ABOVE' },
	[0x035C] = { unicodeslot=0x035C, category='mn', description='COMBINING DOUBLE BREVE BELOW' },
	[0x035D] = { unicodeslot=0x035D, category='mn', description='COMBINING DOUBLE BREVE' },
	[0x035E] = { unicodeslot=0x035E, category='mn', description='COMBINING DOUBLE MACRON' },
	[0x035F] = { unicodeslot=0x035F, category='mn', description='COMBINING DOUBLE MACRON BELOW' },
	[0x0360] = { unicodeslot=0x0360, category='mn', description='COMBINING DOUBLE TILDE' },
	[0x0361] = { unicodeslot=0x0361, category='mn', description='COMBINING DOUBLE INVERTED BREVE' },
	[0x0362] = { unicodeslot=0x0362, category='mn', description='COMBINING DOUBLE RIGHTWARDS ARROW BELOW' },
	[0x0363] = { unicodeslot=0x0363, category='mn', description='COMBINING LATIN SMALL LETTER A' },
	[0x0364] = { unicodeslot=0x0364, category='mn', description='COMBINING LATIN SMALL LETTER E' },
	[0x0365] = { unicodeslot=0x0365, category='mn', description='COMBINING LATIN SMALL LETTER I' },
	[0x0366] = { unicodeslot=0x0366, category='mn', description='COMBINING LATIN SMALL LETTER O' },
	[0x0367] = { unicodeslot=0x0367, category='mn', description='COMBINING LATIN SMALL LETTER U' },
	[0x0368] = { unicodeslot=0x0368, category='mn', description='COMBINING LATIN SMALL LETTER C' },
	[0x0369] = { unicodeslot=0x0369, category='mn', description='COMBINING LATIN SMALL LETTER D' },
	[0x036A] = { unicodeslot=0x036A, category='mn', description='COMBINING LATIN SMALL LETTER H' },
	[0x036B] = { unicodeslot=0x036B, category='mn', description='COMBINING LATIN SMALL LETTER M' },
	[0x036C] = { unicodeslot=0x036C, category='mn', description='COMBINING LATIN SMALL LETTER R' },
	[0x036D] = { unicodeslot=0x036D, category='mn', description='COMBINING LATIN SMALL LETTER T' },
	[0x036E] = { unicodeslot=0x036E, category='mn', description='COMBINING LATIN SMALL LETTER V' },
	[0x036F] = { unicodeslot=0x036F, category='mn', description='COMBINING LATIN SMALL LETTER X' },
	[0x0374] = { unicodeslot=0x0374, category='sk', description='GREEK NUMERAL SIGN', specials={'char',0x02B9} },
	[0x0375] = { unicodeslot=0x0375, category='sk', description='GREEK LOWER NUMERAL SIGN' },
	[0x037A] = { unicodeslot=0x037A, category='lm', description='GREEK YPOGEGRAMMENI', specials={'compat',0x0020,0x0345} },
	[0x037B] = { unicodeslot=0x037B, category='ll', description='GREEK SMALL REVERSED LUNATE SIGMA SYMBOL', uccode=0x03FD },
	[0x037C] = { unicodeslot=0x037C, category='ll', description='GREEK SMALL DOTTED LUNATE SIGMA SYMBOL', uccode=0x03FE },
	[0x037D] = { unicodeslot=0x037D, category='ll', description='GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL', uccode=0x03FF },
	[0x037E] = { unicodeslot=0x037E, category='po', description='GREEK QUESTION MARK', specials={'char',0x003B} },
	[0x0384] = { unicodeslot=0x0384, category='sk', adobename='tonos', contextname='greektonos', description='GREEK TONOS', specials={'compat',0x0020,0x0301} },
	[0x0385] = { unicodeslot=0x0385, category='sk', adobename='dieresistonos', contextname='greekdialytikatonos', description='GREEK DIALYTIKA TONOS', specials={'char',0x00A8,0x0301} },
	[0x0386] = { unicodeslot=0x0386, category='lu', adobename='Alphatonos', contextname='greekAlphatonos', description='GREEK CAPITAL LETTER ALPHA WITH TONOS', shcode=0x0391, lccode=0x03AC, specials={'char',0x0391,0x0301} },
	[0x0387] = { unicodeslot=0x0387, category='po', adobename='anoteleia', description='GREEK ANO TELEIA', specials={'char',0x00B7} },
	[0x0388] = { unicodeslot=0x0388, category='lu', adobename='Epsilontonos', contextname='greekEpsilontonos', description='GREEK CAPITAL LETTER EPSILON WITH TONOS', shcode=0x0395, lccode=0x03AD, specials={'char',0x0395,0x0301} },
	[0x0389] = { unicodeslot=0x0389, category='lu', adobename='Etatonos', contextname='greekEtatonos', description='GREEK CAPITAL LETTER ETA WITH TONOS', shcode=0x0397, lccode=0x03AE, specials={'char',0x0397,0x0301} },
	[0x038A] = { unicodeslot=0x038A, category='lu', adobename='Iotatonos', contextname='greekIotatonos', description='GREEK CAPITAL LETTER IOTA WITH TONOS', shcode=0x0399, lccode=0x03AF, specials={'char',0x0399,0x0301} },
	[0x038C] = { unicodeslot=0x038C, category='lu', adobename='Omicrontonos', contextname='greekOmicrontonos', description='GREEK CAPITAL LETTER OMICRON WITH TONOS', shcode=0x039F, lccode=0x03CC, specials={'char',0x039F,0x0301} },
	[0x038E] = { unicodeslot=0x038E, category='lu', adobename='Upsilontonos', contextname='greekUpsilontonos', description='GREEK CAPITAL LETTER UPSILON WITH TONOS', shcode=0x03A5, lccode=0x03CD, specials={'char',0x03A5,0x0301} },
	[0x038F] = { unicodeslot=0x038F, category='lu', adobename='Omegatonos', contextname='greekOmegatonos', description='GREEK CAPITAL LETTER OMEGA WITH TONOS', shcode=0x03A9, lccode=0x03CE, specials={'char',0x03A9,0x0301} },
	[0x0390] = { unicodeslot=0x0390, category='ll', adobename='iotadieresistonos', contextname='greekiotadialytikatonos', description='GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS', shcode=0x03B9, specials={'char',0x03CA,0x0301} },
	[0x0391] = { unicodeslot=0x0391, category='lu', adobename='Alpha', contextname='greekAlpha', description='GREEK CAPITAL LETTER ALPHA', lccode=0x03B1 },
	[0x0392] = { unicodeslot=0x0392, category='lu', adobename='Beta', contextname='greekBeta', description='GREEK CAPITAL LETTER BETA', lccode=0x03B2 },
	[0x0393] = { unicodeslot=0x0393, category='lu', adobename='Gamma', contextname='greekGamma', description='GREEK CAPITAL LETTER GAMMA', lccode=0x03B3 },
	[0x0394] = { unicodeslot=0x0394, category='lu', contextname='greekDelta', description='GREEK CAPITAL LETTER DELTA', lccode=0x03B4 },
	[0x0395] = { unicodeslot=0x0395, category='lu', adobename='Epsilon', contextname='greekEpsilon', description='GREEK CAPITAL LETTER EPSILON', lccode=0x03B5 },
	[0x0396] = { unicodeslot=0x0396, category='lu', adobename='Zeta', contextname='greekZeta', description='GREEK CAPITAL LETTER ZETA', lccode=0x03B6 },
	[0x0397] = { unicodeslot=0x0397, category='lu', adobename='Eta', contextname='greekEta', description='GREEK CAPITAL LETTER ETA', lccode=0x03B7 },
	[0x0398] = { unicodeslot=0x0398, category='lu', adobename='Theta', contextname='greekTheta', description='GREEK CAPITAL LETTER THETA', lccode=0x03B8 },
	[0x0399] = { unicodeslot=0x0399, category='lu', adobename='Iota', contextname='greekIota', description='GREEK CAPITAL LETTER IOTA', lccode=0x03B9 },
	[0x039A] = { unicodeslot=0x039A, category='lu', adobename='Kappa', contextname='greekKappa', description='GREEK CAPITAL LETTER KAPPA', lccode=0x03BA },
	[0x039B] = { unicodeslot=0x039B, category='lu', adobename='Lambda', contextname='greekLambda', description='GREEK CAPITAL LETTER LAMDA', lccode=0x03BB },
	[0x039C] = { unicodeslot=0x039C, category='lu', adobename='Mu', contextname='greekMu', description='GREEK CAPITAL LETTER MU', lccode=0x03BC },
	[0x039D] = { unicodeslot=0x039D, category='lu', adobename='Nu', contextname='greekNu', description='GREEK CAPITAL LETTER NU', lccode=0x03BD },
	[0x039E] = { unicodeslot=0x039E, category='lu', adobename='Xi', contextname='greekXi', description='GREEK CAPITAL LETTER XI', lccode=0x03BE },
	[0x039F] = { unicodeslot=0x039F, category='lu', adobename='Omicron', contextname='greekOmicron', description='GREEK CAPITAL LETTER OMICRON', lccode=0x03BF },
	[0x03A0] = { unicodeslot=0x03A0, category='lu', adobename='Pi', contextname='greekPi', description='GREEK CAPITAL LETTER PI', lccode=0x03C0 },
	[0x03A1] = { unicodeslot=0x03A1, category='lu', adobename='Rho', contextname='greekRho', description='GREEK CAPITAL LETTER RHO', lccode=0x03C1 },
	[0x03A3] = { unicodeslot=0x03A3, category='lu', adobename='Sigma', contextname='greekSigma', description='GREEK CAPITAL LETTER SIGMA', lccode=0x03C3 },
	[0x03A4] = { unicodeslot=0x03A4, category='lu', adobename='Tau', contextname='greekTau', description='GREEK CAPITAL LETTER TAU', lccode=0x03C4 },
	[0x03A5] = { unicodeslot=0x03A5, category='lu', adobename='Upsilon', contextname='greekUpsilon', description='GREEK CAPITAL LETTER UPSILON', lccode=0x03C5 },
	[0x03A6] = { unicodeslot=0x03A6, category='lu', adobename='Phi', contextname='greekPhi', description='GREEK CAPITAL LETTER PHI', lccode=0x03C6 },
	[0x03A7] = { unicodeslot=0x03A7, category='lu', adobename='Chi', contextname='greekChi', description='GREEK CAPITAL LETTER CHI', lccode=0x03C7 },
	[0x03A8] = { unicodeslot=0x03A8, category='lu', adobename='Psi', contextname='greekPsi', description='GREEK CAPITAL LETTER PSI', lccode=0x03C8 },
	[0x03A9] = { unicodeslot=0x03A9, category='lu', contextname='greekOmega', description='GREEK CAPITAL LETTER OMEGA', lccode=0x03C9 },
	[0x03AA] = { unicodeslot=0x03AA, category='lu', adobename='Iotadieresis', contextname='greekIotadialytika', description='GREEK CAPITAL LETTER IOTA WITH DIALYTIKA', shcode=0x0399, lccode=0x03CA, specials={'char',0x0399,0x0308} },
	[0x03AB] = { unicodeslot=0x03AB, category='lu', adobename='Upsilondieresis', contextname='greekUpsilondialytika', description='GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA', shcode=0x03A5, lccode=0x03CB, specials={'char',0x03A5,0x0308} },
	[0x03AC] = { unicodeslot=0x03AC, category='ll', adobename='alphatonos', contextname='greekalphatonos', description='GREEK SMALL LETTER ALPHA WITH TONOS', shcode=0x03B1, uccode=0x0386, specials={'char',0x03B1,0x0301} },
	[0x03AD] = { unicodeslot=0x03AD, category='ll', adobename='epsilontonos', contextname='greekepsilontonos', description='GREEK SMALL LETTER EPSILON WITH TONOS', shcode=0x03B5, uccode=0x0388, specials={'char',0x03B5,0x0301} },
	[0x03AE] = { unicodeslot=0x03AE, category='ll', adobename='etatonos', contextname='greeketatonos', description='GREEK SMALL LETTER ETA WITH TONOS', shcode=0x03B7, uccode=0x0389, specials={'char',0x03B7,0x0301} },
	[0x03AF] = { unicodeslot=0x03AF, category='ll', adobename='iotatonos', contextname='greekiotatonos', description='GREEK SMALL LETTER IOTA WITH TONOS', shcode=0x03B9, uccode=0x038A, specials={'char',0x03B9,0x0301} },
	[0x03B0] = { unicodeslot=0x03B0, category='ll', adobename='upsilondieresistonos', contextname='greekupsilondialytikatonos', description='GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS', shcode=0x03C5, specials={'char',0x03CB,0x0301} },
	[0x03B1] = { unicodeslot=0x03B1, category='ll', adobename='alpha', contextname='greekalpha', description='GREEK SMALL LETTER ALPHA', uccode=0x0391 },
	[0x03B2] = { unicodeslot=0x03B2, category='ll', adobename='beta', contextname='greekbeta', description='GREEK SMALL LETTER BETA', uccode=0x0392 },
	[0x03B3] = { unicodeslot=0x03B3, category='ll', adobename='gamma', contextname='greekgamma', description='GREEK SMALL LETTER GAMMA', uccode=0x0393 },
	[0x03B4] = { unicodeslot=0x03B4, category='ll', adobename='delta', contextname='greekdelta', description='GREEK SMALL LETTER DELTA', uccode=0x0394 },
	[0x03B5] = { unicodeslot=0x03B5, category='ll', adobename='epsilon', contextname='greekepsilon', description='GREEK SMALL LETTER EPSILON', uccode=0x0395 },
	[0x03B6] = { unicodeslot=0x03B6, category='ll', adobename='zeta', contextname='greekzeta', description='GREEK SMALL LETTER ZETA', uccode=0x0396 },
	[0x03B7] = { unicodeslot=0x03B7, category='ll', adobename='eta', contextname='greeketa', description='GREEK SMALL LETTER ETA', uccode=0x0397 },
	[0x03B8] = { unicodeslot=0x03B8, category='ll', adobename='theta', contextname='greektheta', description='GREEK SMALL LETTER THETA', uccode=0x0398 },
	[0x03B9] = { unicodeslot=0x03B9, category='ll', adobename='iota', contextname='greekiota', description='GREEK SMALL LETTER IOTA', uccode=0x0399 },
	[0x03BA] = { unicodeslot=0x03BA, category='ll', adobename='kappa', contextname='greekkappa', description='GREEK SMALL LETTER KAPPA', uccode=0x039A },
	[0x03BB] = { unicodeslot=0x03BB, category='ll', adobename='lambda', contextname='greeklambda', description='GREEK SMALL LETTER LAMDA', uccode=0x039B },
	[0x03BC] = { unicodeslot=0x03BC, category='ll', contextname='greekmu', description='GREEK SMALL LETTER MU', uccode=0x039C },
	[0x03BD] = { unicodeslot=0x03BD, category='ll', adobename='nu', contextname='greeknu', description='GREEK SMALL LETTER NU', uccode=0x039D },
	[0x03BE] = { unicodeslot=0x03BE, category='ll', adobename='xi', contextname='greekxi', description='GREEK SMALL LETTER XI', uccode=0x039E },
	[0x03BF] = { unicodeslot=0x03BF, category='ll', adobename='omicron', contextname='greekomicron', description='GREEK SMALL LETTER OMICRON', uccode=0x039F },
	[0x03C0] = { unicodeslot=0x03C0, category='ll', adobename='pi', contextname='greekpi', description='GREEK SMALL LETTER PI', uccode=0x03A0 },
	[0x03C1] = { unicodeslot=0x03C1, category='ll', adobename='rho', contextname='greekrho', description='GREEK SMALL LETTER RHO', uccode=0x03A1 },
	[0x03C2] = { unicodeslot=0x03C2, category='ll', adobename='sigma1', contextname='greekfinalsigma', description='GREEK SMALL LETTER FINAL SIGMA', uccode=0x03A3 },
	[0x03C3] = { unicodeslot=0x03C3, category='ll', adobename='sigma', contextname='greeksigma', description='GREEK SMALL LETTER SIGMA', uccode=0x03A3 },
	[0x03C4] = { unicodeslot=0x03C4, category='ll', adobename='tau', contextname='greektau', description='GREEK SMALL LETTER TAU', uccode=0x03A4 },
	[0x03C5] = { unicodeslot=0x03C5, category='ll', adobename='upsilon', contextname='greekupsilon', description='GREEK SMALL LETTER UPSILON', uccode=0x03A5 },
	[0x03C6] = { unicodeslot=0x03C6, category='ll', adobename='phi', contextname='greekphi', description='GREEK SMALL LETTER PHI', uccode=0x03A6 },
	[0x03C7] = { unicodeslot=0x03C7, category='ll', adobename='chi', contextname='greekchi', description='GREEK SMALL LETTER CHI', uccode=0x03A7 },
	[0x03C8] = { unicodeslot=0x03C8, category='ll', adobename='psi', contextname='greekpsi', description='GREEK SMALL LETTER PSI', uccode=0x03A8 },
	[0x03C9] = { unicodeslot=0x03C9, category='ll', adobename='omega', contextname='greekomega', description='GREEK SMALL LETTER OMEGA', uccode=0x03A9 },
	[0x03CA] = { unicodeslot=0x03CA, category='ll', adobename='iotadieresis', contextname='greekiotadialytika', description='GREEK SMALL LETTER IOTA WITH DIALYTIKA', shcode=0x03B9, uccode=0x03AA, specials={'char',0x03B9,0x0308} },
	[0x03CB] = { unicodeslot=0x03CB, category='ll', adobename='upsilondieresis', contextname='greekupsilondiaeresis', description='GREEK SMALL LETTER UPSILON WITH DIALYTIKA', shcode=0x03C5, uccode=0x03AB, specials={'char',0x03C5,0x0308} },
	[0x03CC] = { unicodeslot=0x03CC, category='ll', adobename='omicrontonos', contextname='greekomicrontonos', description='GREEK SMALL LETTER OMICRON WITH TONOS', shcode=0x03BF, uccode=0x038C, specials={'char',0x03BF,0x0301} },
	[0x03CD] = { unicodeslot=0x03CD, category='ll', adobename='upsilontonos', contextname='greekupsilontonos', description='GREEK SMALL LETTER UPSILON WITH TONOS', shcode=0x03C5, uccode=0x038E, specials={'char',0x03C5,0x0301} },
	[0x03CE] = { unicodeslot=0x03CE, category='ll', adobename='omegatonos', contextname='greekomegatonos', description='GREEK SMALL LETTER OMEGA WITH TONOS', shcode=0x03C9, uccode=0x038F, specials={'char',0x03C9,0x0301} },
	[0x03D0] = { unicodeslot=0x03D0, category='ll', description='GREEK BETA SYMBOL', uccode=0x0392, specials={'compat',0x03B2} },
	[0x03D1] = { unicodeslot=0x03D1, category='ll', adobename='theta1', contextname='greekthetaalt', description='GREEK THETA SYMBOL', uccode=0x0398, specials={'compat',0x03B8} },
	[0x03D2] = { unicodeslot=0x03D2, category='lu', adobename='Upsilon1', description='GREEK UPSILON WITH HOOK SYMBOL', specials={'compat',0x03A5} },
	[0x03D3] = { unicodeslot=0x03D3, category='lu', description='GREEK UPSILON WITH ACUTE AND HOOK SYMBOL', specials={'char',0x03D2,0x0301} },
	[0x03D4] = { unicodeslot=0x03D4, category='lu', description='GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL', specials={'char',0x03D2,0x0308} },
	[0x03D5] = { unicodeslot=0x03D5, category='ll', adobename='phi1', contextname='greekphialt', description='GREEK PHI SYMBOL', uccode=0x03A6, specials={'compat',0x03C6} },
	[0x03D6] = { unicodeslot=0x03D6, category='ll', adobename='omega1', contextname='greekpialt', description='GREEK PI SYMBOL', uccode=0x03A0, specials={'compat',0x03C0} },
	[0x03D7] = { unicodeslot=0x03D7, category='ll', description='GREEK KAI SYMBOL' },
	[0x03D8] = { unicodeslot=0x03D8, category='lu', description='GREEK LETTER ARCHAIC KOPPA', lccode=0x03D9 },
	[0x03D9] = { unicodeslot=0x03D9, category='ll', contextname='greekkoppa', description='GREEK SMALL LETTER ARCHAIC KOPPA', uccode=0x03D8 },
	[0x03DA] = { unicodeslot=0x03DA, category='lu', description='GREEK LETTER STIGMA', lccode=0x03DB },
	[0x03DB] = { unicodeslot=0x03DB, category='ll', contextname='greekstigma', description='GREEK SMALL LETTER STIGMA', uccode=0x03DA },
	[0x03DC] = { unicodeslot=0x03DC, category='lu', description='GREEK LETTER DIGAMMA', lccode=0x03DD },
	[0x03DD] = { unicodeslot=0x03DD, category='ll', contextname='greekdigamma', description='GREEK SMALL LETTER DIGAMMA', uccode=0x03DC },
	[0x03DE] = { unicodeslot=0x03DE, category='lu', description='GREEK LETTER KOPPA', lccode=0x03DF },
	[0x03DF] = { unicodeslot=0x03DF, category='ll', contextname='greeknumkoppa', description='GREEK SMALL LETTER KOPPA', uccode=0x03DE },
	[0x03E0] = { unicodeslot=0x03E0, category='lu', description='GREEK LETTER SAMPI', lccode=0x03E1 },
	[0x03E1] = { unicodeslot=0x03E1, category='ll', contextname='greeksampi', description='GREEK SMALL LETTER SAMPI', uccode=0x03E0 },
	[0x03E2] = { unicodeslot=0x03E2, category='lu', description='COPTIC CAPITAL LETTER SHEI', lccode=0x03E3 },
	[0x03E3] = { unicodeslot=0x03E3, category='ll', description='COPTIC SMALL LETTER SHEI', uccode=0x03E2 },
	[0x03E4] = { unicodeslot=0x03E4, category='lu', description='COPTIC CAPITAL LETTER FEI', lccode=0x03E5 },
	[0x03E5] = { unicodeslot=0x03E5, category='ll', description='COPTIC SMALL LETTER FEI', uccode=0x03E4 },
	[0x03E6] = { unicodeslot=0x03E6, category='lu', description='COPTIC CAPITAL LETTER KHEI', lccode=0x03E7 },
	[0x03E7] = { unicodeslot=0x03E7, category='ll', description='COPTIC SMALL LETTER KHEI', uccode=0x03E6 },
	[0x03E8] = { unicodeslot=0x03E8, category='lu', description='COPTIC CAPITAL LETTER HORI', lccode=0x03E9 },
	[0x03E9] = { unicodeslot=0x03E9, category='ll', description='COPTIC SMALL LETTER HORI', uccode=0x03E8 },
	[0x03EA] = { unicodeslot=0x03EA, category='lu', description='COPTIC CAPITAL LETTER GANGIA', lccode=0x03EB },
	[0x03EB] = { unicodeslot=0x03EB, category='ll', description='COPTIC SMALL LETTER GANGIA', uccode=0x03EA },
	[0x03EC] = { unicodeslot=0x03EC, category='lu', description='COPTIC CAPITAL LETTER SHIMA', lccode=0x03ED },
	[0x03ED] = { unicodeslot=0x03ED, category='ll', description='COPTIC SMALL LETTER SHIMA', uccode=0x03EC },
	[0x03EE] = { unicodeslot=0x03EE, category='lu', description='COPTIC CAPITAL LETTER DEI', lccode=0x03EF },
	[0x03EF] = { unicodeslot=0x03EF, category='ll', description='COPTIC SMALL LETTER DEI', uccode=0x03EE },
	[0x03F0] = { unicodeslot=0x03F0, category='ll', description='GREEK KAPPA SYMBOL', uccode=0x039A, specials={'compat',0x03BA} },
	[0x03F1] = { unicodeslot=0x03F1, category='ll', contextname='greekrhoalt', description='GREEK RHO SYMBOL', uccode=0x03A1, specials={'compat',0x03C1} },
	[0x03F2] = { unicodeslot=0x03F2, category='ll', contextname='greeksigmalunate', description='GREEK LUNATE SIGMA SYMBOL', uccode=0x03F9, specials={'compat',0x03C2} },
	[0x03F3] = { unicodeslot=0x03F3, category='ll', description='GREEK LETTER YOT' },
	[0x03F4] = { unicodeslot=0x03F4, category='lu', description='GREEK CAPITAL THETA SYMBOL', lccode=0x03B8, specials={'compat',0x0398} },
	[0x03F5] = { unicodeslot=0x03F5, category='ll', contextname='greekepsilonalt', description='GREEK LUNATE EPSILON SYMBOL', uccode=0x0395, specials={'compat',0x03B5} },
	[0x03F6] = { unicodeslot=0x03F6, category='sm', description='GREEK REVERSED LUNATE EPSILON SYMBOL' },
	[0x03F7] = { unicodeslot=0x03F7, category='lu', description='GREEK CAPITAL LETTER SHO', lccode=0x03F8 },
	[0x03F8] = { unicodeslot=0x03F8, category='ll', description='GREEK SMALL LETTER SHO', uccode=0x03F7 },
	[0x03F9] = { unicodeslot=0x03F9, category='lu', contextname='greekSigmalunate', description='GREEK CAPITAL LUNATE SIGMA SYMBOL', lccode=0x03F2, specials={'compat',0x03A3} },
	[0x03FA] = { unicodeslot=0x03FA, category='lu', description='GREEK CAPITAL LETTER SAN', lccode=0x03FB },
	[0x03FB] = { unicodeslot=0x03FB, category='ll', description='GREEK SMALL LETTER SAN', uccode=0x03FA },
	[0x03FC] = { unicodeslot=0x03FC, category='ll', description='GREEK RHO WITH STROKE SYMBOL' },
	[0x03FD] = { unicodeslot=0x03FD, category='lu', description='GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL', lccode=0x037B },
	[0x03FE] = { unicodeslot=0x03FE, category='lu', description='GREEK CAPITAL DOTTED LUNATE SIGMA SYMBOL', lccode=0x037C },
	[0x03FF] = { unicodeslot=0x03FF, category='lu', description='GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL', lccode=0x037D },
	[0x0400] = { unicodeslot=0x0400, category='lu', contextname='cyrillicEgrave', description='CYRILLIC CAPITAL LETTER IE WITH GRAVE', shcode=0x0415, lccode=0x0450, specials={'char',0x0415,0x0300} },
	[0x0401] = { unicodeslot=0x0401, category='lu', adobename='afii10023', contextname='cyrillicYO', description='CYRILLIC CAPITAL LETTER IO', lccode=0x0451, specials={'char',0x0415,0x0308} },
	[0x0402] = { unicodeslot=0x0402, category='lu', adobename='afii10051', contextname='cyrillicDJE', description='CYRILLIC CAPITAL LETTER DJE', lccode=0x0452 },
	[0x0403] = { unicodeslot=0x0403, category='lu', adobename='afii10052', contextname='cyrillicGJE', description='CYRILLIC CAPITAL LETTER GJE', lccode=0x0453, specials={'char',0x0413,0x0301} },
	[0x0404] = { unicodeslot=0x0404, category='lu', adobename='afii10053', contextname='cyrillicIE', description='CYRILLIC CAPITAL LETTER UKRAINIAN IE', lccode=0x0454 },
	[0x0405] = { unicodeslot=0x0405, category='lu', adobename='afii10054', contextname='cyrillicDZE', description='CYRILLIC CAPITAL LETTER DZE', lccode=0x0455 },
	[0x0406] = { unicodeslot=0x0406, category='lu', adobename='afii10055', contextname='cyrillicII', description='CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I', lccode=0x0456 },
	[0x0407] = { unicodeslot=0x0407, category='lu', adobename='afii10056', contextname='cyrillicYI', description='CYRILLIC CAPITAL LETTER YI', lccode=0x0457, specials={'char',0x0406,0x0308} },
	[0x0408] = { unicodeslot=0x0408, category='lu', adobename='afii10057', contextname='cyrillicJE', description='CYRILLIC CAPITAL LETTER JE', lccode=0x0458 },
	[0x0409] = { unicodeslot=0x0409, category='lu', adobename='afii10058', contextname='cyrillicLJE', description='CYRILLIC CAPITAL LETTER LJE', lccode=0x0459 },
	[0x040A] = { unicodeslot=0x040A, category='lu', adobename='afii10059', contextname='cyrillicNJE', description='CYRILLIC CAPITAL LETTER NJE', lccode=0x045A },
	[0x040B] = { unicodeslot=0x040B, category='lu', adobename='afii10060', contextname='cyrillicTSHE', description='CYRILLIC CAPITAL LETTER TSHE', lccode=0x045B },
	[0x040C] = { unicodeslot=0x040C, category='lu', adobename='afii10061', contextname='cyrillicKJE', description='CYRILLIC CAPITAL LETTER KJE', lccode=0x045C, specials={'char',0x041A,0x0301} },
	[0x040D] = { unicodeslot=0x040D, category='lu', contextname='cyrillicIgrave', description='CYRILLIC CAPITAL LETTER I WITH GRAVE', shcode=0x0418, lccode=0x045D, specials={'char',0x0418,0x0300} },
	[0x040E] = { unicodeslot=0x040E, category='lu', adobename='afii10062', contextname='cyrillicUSHRT', description='CYRILLIC CAPITAL LETTER SHORT U', lccode=0x045E, specials={'char',0x0423,0x0306} },
	[0x040F] = { unicodeslot=0x040F, category='lu', adobename='afii10145', contextname='cyrillicDZHE', description='CYRILLIC CAPITAL LETTER DZHE', lccode=0x045F },
	[0x0410] = { unicodeslot=0x0410, category='lu', adobename='afii10017', contextname='cyrillicA', description='CYRILLIC CAPITAL LETTER A', lccode=0x0430 },
	[0x0411] = { unicodeslot=0x0411, category='lu', adobename='afii10018', contextname='cyrillicB', description='CYRILLIC CAPITAL LETTER BE', lccode=0x0431 },
	[0x0412] = { unicodeslot=0x0412, category='lu', adobename='afii10019', contextname='cyrillicV', description='CYRILLIC CAPITAL LETTER VE', lccode=0x0432 },
	[0x0413] = { unicodeslot=0x0413, category='lu', adobename='afii10020', contextname='cyrillicG', description='CYRILLIC CAPITAL LETTER GHE', lccode=0x0433 },
	[0x0414] = { unicodeslot=0x0414, category='lu', adobename='afii10021', contextname='cyrillicD', description='CYRILLIC CAPITAL LETTER DE', lccode=0x0434 },
	[0x0415] = { unicodeslot=0x0415, category='lu', adobename='afii10022', contextname='cyrillicE', description='CYRILLIC CAPITAL LETTER IE', lccode=0x0435 },
	[0x0416] = { unicodeslot=0x0416, category='lu', adobename='afii10024', contextname='cyrillicZH', description='CYRILLIC CAPITAL LETTER ZHE', lccode=0x0436 },
	[0x0417] = { unicodeslot=0x0417, category='lu', adobename='afii10025', contextname='cyrillicZ', description='CYRILLIC CAPITAL LETTER ZE', lccode=0x0437 },
	[0x0418] = { unicodeslot=0x0418, category='lu', adobename='afii10026', contextname='cyrillicI', description='CYRILLIC CAPITAL LETTER I', lccode=0x0438 },
	[0x0419] = { unicodeslot=0x0419, category='lu', adobename='afii10027', contextname='cyrillicISHRT', description='CYRILLIC CAPITAL LETTER SHORT I', lccode=0x0439, specials={'char',0x0418,0x0306} },
	[0x041A] = { unicodeslot=0x041A, category='lu', adobename='afii10028', contextname='cyrillicK', description='CYRILLIC CAPITAL LETTER KA', lccode=0x043A },
	[0x041B] = { unicodeslot=0x041B, category='lu', adobename='afii10029', contextname='cyrillicL', description='CYRILLIC CAPITAL LETTER EL', lccode=0x043B },
	[0x041C] = { unicodeslot=0x041C, category='lu', adobename='afii10030', contextname='cyrillicM', description='CYRILLIC CAPITAL LETTER EM', lccode=0x043C },
	[0x041D] = { unicodeslot=0x041D, category='lu', adobename='afii10031', contextname='cyrillicN', description='CYRILLIC CAPITAL LETTER EN', lccode=0x043D },
	[0x041E] = { unicodeslot=0x041E, category='lu', adobename='afii10032', contextname='cyrillicO', description='CYRILLIC CAPITAL LETTER O', lccode=0x043E },
	[0x041F] = { unicodeslot=0x041F, category='lu', adobename='afii10033', contextname='cyrillicP', description='CYRILLIC CAPITAL LETTER PE', lccode=0x043F },
	[0x0420] = { unicodeslot=0x0420, category='lu', adobename='afii10034', contextname='cyrillicR', description='CYRILLIC CAPITAL LETTER ER', lccode=0x0440 },
	[0x0421] = { unicodeslot=0x0421, category='lu', adobename='afii10035', contextname='cyrillicS', description='CYRILLIC CAPITAL LETTER ES', lccode=0x0441 },
	[0x0422] = { unicodeslot=0x0422, category='lu', adobename='afii10036', contextname='cyrillicT', description='CYRILLIC CAPITAL LETTER TE', lccode=0x0442 },
	[0x0423] = { unicodeslot=0x0423, category='lu', adobename='afii10037', contextname='cyrillicU', description='CYRILLIC CAPITAL LETTER U', lccode=0x0443 },
	[0x0424] = { unicodeslot=0x0424, category='lu', adobename='afii10038', contextname='cyrillicF', description='CYRILLIC CAPITAL LETTER EF', lccode=0x0444 },
	[0x0425] = { unicodeslot=0x0425, category='lu', adobename='afii10039', contextname='cyrillicH', description='CYRILLIC CAPITAL LETTER HA', lccode=0x0445 },
	[0x0426] = { unicodeslot=0x0426, category='lu', adobename='afii10040', contextname='cyrillicC', description='CYRILLIC CAPITAL LETTER TSE', lccode=0x0446 },
	[0x0427] = { unicodeslot=0x0427, category='lu', adobename='afii10041', contextname='cyrillicCH', description='CYRILLIC CAPITAL LETTER CHE', lccode=0x0447 },
	[0x0428] = { unicodeslot=0x0428, category='lu', adobename='afii10042', contextname='cyrillicSH', description='CYRILLIC CAPITAL LETTER SHA', lccode=0x0448 },
	[0x0429] = { unicodeslot=0x0429, category='lu', adobename='afii10043', contextname='cyrillicSHCH', description='CYRILLIC CAPITAL LETTER SHCHA', lccode=0x0449 },
	[0x042A] = { unicodeslot=0x042A, category='lu', adobename='afii10044', contextname='cyrillicHRDSN', description='CYRILLIC CAPITAL LETTER HARD SIGN', lccode=0x044A },
	[0x042B] = { unicodeslot=0x042B, category='lu', adobename='afii10045', contextname='cyrillicERY', description='CYRILLIC CAPITAL LETTER YERU', lccode=0x044B },
	[0x042C] = { unicodeslot=0x042C, category='lu', adobename='afii10046', contextname='cyrillicSFTSN', description='CYRILLIC CAPITAL LETTER SOFT SIGN', lccode=0x044C },
	[0x042D] = { unicodeslot=0x042D, category='lu', adobename='afii10047', contextname='cyrillicEREV', description='CYRILLIC CAPITAL LETTER E', lccode=0x044D },
	[0x042E] = { unicodeslot=0x042E, category='lu', adobename='afii10048', contextname='cyrillicYU', description='CYRILLIC CAPITAL LETTER YU', lccode=0x044E },
	[0x042F] = { unicodeslot=0x042F, category='lu', adobename='afii10049', contextname='cyrillicYA', description='CYRILLIC CAPITAL LETTER YA', lccode=0x044F },
	[0x0430] = { unicodeslot=0x0430, category='ll', adobename='afii10065', contextname='cyrillica', description='CYRILLIC SMALL LETTER A', uccode=0x0410 },
	[0x0431] = { unicodeslot=0x0431, category='ll', adobename='afii10066', contextname='cyrillicb', description='CYRILLIC SMALL LETTER BE', uccode=0x0411 },
	[0x0432] = { unicodeslot=0x0432, category='ll', adobename='afii10067', contextname='cyrillicv', description='CYRILLIC SMALL LETTER VE', uccode=0x0412 },
	[0x0433] = { unicodeslot=0x0433, category='ll', adobename='afii10068', contextname='cyrillicg', description='CYRILLIC SMALL LETTER GHE', uccode=0x0413 },
	[0x0434] = { unicodeslot=0x0434, category='ll', adobename='afii10069', contextname='cyrillicd', description='CYRILLIC SMALL LETTER DE', uccode=0x0414 },
	[0x0435] = { unicodeslot=0x0435, category='ll', adobename='afii10070', contextname='cyrillice', description='CYRILLIC SMALL LETTER IE', uccode=0x0415 },
	[0x0436] = { unicodeslot=0x0436, category='ll', adobename='afii10072', contextname='cyrilliczh', description='CYRILLIC SMALL LETTER ZHE', uccode=0x0416 },
	[0x0437] = { unicodeslot=0x0437, category='ll', adobename='afii10073', contextname='cyrillicz', description='CYRILLIC SMALL LETTER ZE', uccode=0x0417 },
	[0x0438] = { unicodeslot=0x0438, category='ll', adobename='afii10074', contextname='cyrillici', description='CYRILLIC SMALL LETTER I', uccode=0x0418 },
	[0x0439] = { unicodeslot=0x0439, category='ll', adobename='afii10075', contextname='cyrillicishrt', description='CYRILLIC SMALL LETTER SHORT I', uccode=0x0419, specials={'char',0x0438,0x0306} },
	[0x043A] = { unicodeslot=0x043A, category='ll', adobename='afii10076', contextname='cyrillick', description='CYRILLIC SMALL LETTER KA', uccode=0x041A },
	[0x043B] = { unicodeslot=0x043B, category='ll', adobename='afii10077', contextname='cyrillicl', description='CYRILLIC SMALL LETTER EL', uccode=0x041B },
	[0x043C] = { unicodeslot=0x043C, category='ll', adobename='afii10078', contextname='cyrillicm', description='CYRILLIC SMALL LETTER EM', uccode=0x041C },
	[0x043D] = { unicodeslot=0x043D, category='ll', adobename='afii10079', contextname='cyrillicn', description='CYRILLIC SMALL LETTER EN', uccode=0x041D },
	[0x043E] = { unicodeslot=0x043E, category='ll', adobename='afii10080', contextname='cyrillico', description='CYRILLIC SMALL LETTER O', uccode=0x041E },
	[0x043F] = { unicodeslot=0x043F, category='ll', adobename='afii10081', contextname='cyrillicp', description='CYRILLIC SMALL LETTER PE', uccode=0x041F },
	[0x0440] = { unicodeslot=0x0440, category='ll', adobename='afii10082', contextname='cyrillicr', description='CYRILLIC SMALL LETTER ER', uccode=0x0420 },
	[0x0441] = { unicodeslot=0x0441, category='ll', adobename='afii10083', contextname='cyrillics', description='CYRILLIC SMALL LETTER ES', uccode=0x0421 },
	[0x0442] = { unicodeslot=0x0442, category='ll', adobename='afii10084', contextname='cyrillict', description='CYRILLIC SMALL LETTER TE', uccode=0x0422 },
	[0x0443] = { unicodeslot=0x0443, category='ll', adobename='afii10085', contextname='cyrillicu', description='CYRILLIC SMALL LETTER U', uccode=0x0423 },
	[0x0444] = { unicodeslot=0x0444, category='ll', adobename='afii10086', contextname='cyrillicf', description='CYRILLIC SMALL LETTER EF', uccode=0x0424 },
	[0x0445] = { unicodeslot=0x0445, category='ll', adobename='afii10087', contextname='cyrillich', description='CYRILLIC SMALL LETTER HA', uccode=0x0425 },
	[0x0446] = { unicodeslot=0x0446, category='ll', adobename='afii10088', contextname='cyrillicc', description='CYRILLIC SMALL LETTER TSE', uccode=0x0426 },
	[0x0447] = { unicodeslot=0x0447, category='ll', adobename='afii10089', contextname='cyrillicch', description='CYRILLIC SMALL LETTER CHE', uccode=0x0427 },
	[0x0448] = { unicodeslot=0x0448, category='ll', adobename='afii10090', contextname='cyrillicsh', description='CYRILLIC SMALL LETTER SHA', uccode=0x0428 },
	[0x0449] = { unicodeslot=0x0449, category='ll', adobename='afii10091', contextname='cyrillicshch', description='CYRILLIC SMALL LETTER SHCHA', uccode=0x0429 },
	[0x044A] = { unicodeslot=0x044A, category='ll', adobename='afii10092', contextname='cyrillichrdsn', description='CYRILLIC SMALL LETTER HARD SIGN', uccode=0x042A },
	[0x044B] = { unicodeslot=0x044B, category='ll', adobename='afii10093', contextname='cyrillicery', description='CYRILLIC SMALL LETTER YERU', uccode=0x042B },
	[0x044C] = { unicodeslot=0x044C, category='ll', adobename='afii10094', contextname='cyrillicsftsn', description='CYRILLIC SMALL LETTER SOFT SIGN', uccode=0x042C },
	[0x044D] = { unicodeslot=0x044D, category='ll', adobename='afii10095', contextname='cyrillicerev', description='CYRILLIC SMALL LETTER E', uccode=0x042D },
	[0x044E] = { unicodeslot=0x044E, category='ll', adobename='afii10096', contextname='cyrillicyu', description='CYRILLIC SMALL LETTER YU', uccode=0x042E },
	[0x044F] = { unicodeslot=0x044F, category='ll', adobename='afii10097', contextname='cyrillicya', description='CYRILLIC SMALL LETTER YA', uccode=0x042F },
	[0x0450] = { unicodeslot=0x0450, category='ll', contextname='cyrillicegrave', description='CYRILLIC SMALL LETTER IE WITH GRAVE', shcode=0x0435, uccode=0x0400, specials={'char',0x0435,0x0300} },
	[0x0451] = { unicodeslot=0x0451, category='ll', adobename='afii10071', contextname='cyrillicyo', description='CYRILLIC SMALL LETTER IO', uccode=0x0401, specials={'char',0x0435,0x0308} },
	[0x0452] = { unicodeslot=0x0452, category='ll', adobename='afii10099', contextname='cyrillicdje', description='CYRILLIC SMALL LETTER DJE', uccode=0x0402 },
	[0x0453] = { unicodeslot=0x0453, category='ll', adobename='afii10100', contextname='cyrillicgje', description='CYRILLIC SMALL LETTER GJE', uccode=0x0403, specials={'char',0x0433,0x0301} },
	[0x0454] = { unicodeslot=0x0454, category='ll', adobename='afii10101', contextname='cyrillicie', description='CYRILLIC SMALL LETTER UKRAINIAN IE', uccode=0x0404 },
	[0x0455] = { unicodeslot=0x0455, category='ll', adobename='afii10102', contextname='cyrillicdze', description='CYRILLIC SMALL LETTER DZE', uccode=0x0405 },
	[0x0456] = { unicodeslot=0x0456, category='ll', adobename='afii10103', contextname='cyrillicii', description='CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I', uccode=0x0406 },
	[0x0457] = { unicodeslot=0x0457, category='ll', adobename='afii10104', contextname='cyrillicyi', description='CYRILLIC SMALL LETTER YI', uccode=0x0407, specials={'char',0x0456,0x0308} },
	[0x0458] = { unicodeslot=0x0458, category='ll', adobename='afii10105', contextname='cyrillicje', description='CYRILLIC SMALL LETTER JE', uccode=0x0408 },
	[0x0459] = { unicodeslot=0x0459, category='ll', adobename='afii10106', contextname='cyrilliclje', description='CYRILLIC SMALL LETTER LJE', uccode=0x0409 },
	[0x045A] = { unicodeslot=0x045A, category='ll', adobename='afii10107', contextname='cyrillicnje', description='CYRILLIC SMALL LETTER NJE', uccode=0x040A },
	[0x045B] = { unicodeslot=0x045B, category='ll', adobename='afii10108', contextname='cyrillictshe', description='CYRILLIC SMALL LETTER TSHE', uccode=0x040B },
	[0x045C] = { unicodeslot=0x045C, category='ll', adobename='afii10109', contextname='cyrillickje', description='CYRILLIC SMALL LETTER KJE', uccode=0x040C, specials={'char',0x043A,0x0301} },
	[0x045D] = { unicodeslot=0x045D, category='ll', contextname='cyrillicigrave', description='CYRILLIC SMALL LETTER I WITH GRAVE', shcode=0x0438, uccode=0x040D, specials={'char',0x0438,0x0300} },
	[0x045E] = { unicodeslot=0x045E, category='ll', adobename='afii10110', contextname='cyrillicushrt', description='CYRILLIC SMALL LETTER SHORT U', uccode=0x040E, specials={'char',0x0443,0x0306} },
	[0x045F] = { unicodeslot=0x045F, category='ll', adobename='afii10193', contextname='cyrillicdzhe', description='CYRILLIC SMALL LETTER DZHE', uccode=0x040F },
	[0x0460] = { unicodeslot=0x0460, category='lu', contextname='cyrillicOMEGA', description='CYRILLIC CAPITAL LETTER OMEGA', lccode=0x0461 },
	[0x0461] = { unicodeslot=0x0461, category='ll', contextname='cyrillicomega', description='CYRILLIC SMALL LETTER OMEGA', uccode=0x0460 },
	[0x0462] = { unicodeslot=0x0462, category='lu', adobename='afii10146', contextname='cyrillicYAT', description='CYRILLIC CAPITAL LETTER YAT', lccode=0x0463 },
	[0x0463] = { unicodeslot=0x0463, category='ll', adobename='afii10194', contextname='cyrillicyat', description='CYRILLIC SMALL LETTER YAT', uccode=0x0462 },
	[0x0464] = { unicodeslot=0x0464, category='lu', contextname='cyrillicEiotified', description='CYRILLIC CAPITAL LETTER IOTIFIED E', lccode=0x0465 },
	[0x0465] = { unicodeslot=0x0465, category='ll', contextname='cyrilliceiotified', description='CYRILLIC SMALL LETTER IOTIFIED E', uccode=0x0464 },
	[0x0466] = { unicodeslot=0x0466, category='lu', contextname='cyrillicLITTLEYUS', description='CYRILLIC CAPITAL LETTER LITTLE YUS', lccode=0x0467 },
	[0x0467] = { unicodeslot=0x0467, category='ll', contextname='cyrilliclittleyus', description='CYRILLIC SMALL LETTER LITTLE YUS', uccode=0x0466 },
	[0x0468] = { unicodeslot=0x0468, category='lu', contextname='cyrillicLITTLEYUSiotified', description='CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS', lccode=0x0469 },
	[0x0469] = { unicodeslot=0x0469, category='ll', contextname='cyrilliclittleyusiotified', description='CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS', uccode=0x0468 },
	[0x046A] = { unicodeslot=0x046A, category='lu', contextname='cyrillicBIGYUS', description='CYRILLIC CAPITAL LETTER BIG YUS', lccode=0x046B },
	[0x046B] = { unicodeslot=0x046B, category='ll', contextname='cyrillicbigyus', description='CYRILLIC SMALL LETTER BIG YUS', uccode=0x046A },
	[0x046C] = { unicodeslot=0x046C, category='lu', contextname='cyrillicBIGYUSiotified', description='CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS', lccode=0x046D },
	[0x046D] = { unicodeslot=0x046D, category='ll', contextname='cyrillicbigyusiotified', description='CYRILLIC SMALL LETTER IOTIFIED BIG YUS', uccode=0x046C },
	[0x046E] = { unicodeslot=0x046E, category='lu', contextname='cyrillicKSI', description='CYRILLIC CAPITAL LETTER KSI', lccode=0x046F },
	[0x046F] = { unicodeslot=0x046F, category='ll', contextname='cyrillicksi', description='CYRILLIC SMALL LETTER KSI', uccode=0x046E },
	[0x0470] = { unicodeslot=0x0470, category='lu', contextname='cyrillicPSI', description='CYRILLIC CAPITAL LETTER PSI', lccode=0x0471 },
	[0x0471] = { unicodeslot=0x0471, category='ll', contextname='cyrillicpsi', description='CYRILLIC SMALL LETTER PSI', uccode=0x0470 },
	[0x0472] = { unicodeslot=0x0472, category='lu', adobename='afii10147', contextname='cyrillicFITA', description='CYRILLIC CAPITAL LETTER FITA', lccode=0x0473 },
	[0x0473] = { unicodeslot=0x0473, category='ll', adobename='afii10195', contextname='cyrillicfita', description='CYRILLIC SMALL LETTER FITA', uccode=0x0472 },
	[0x0474] = { unicodeslot=0x0474, category='lu', adobename='afii10148', contextname='cyrillicIZHITSA', description='CYRILLIC CAPITAL LETTER IZHITSA', lccode=0x0475 },
	[0x0475] = { unicodeslot=0x0475, category='ll', adobename='afii10196', contextname='cyrillicizhitsa', description='CYRILLIC SMALL LETTER IZHITSA', uccode=0x0474 },
	[0x0476] = { unicodeslot=0x0476, category='lu', contextname='cyrillicIZHITSAdoublegrave', description='CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT', shcode=0x0474, lccode=0x0477, specials={'char',0x0474,0x030F} },
	[0x0477] = { unicodeslot=0x0477, category='ll', contextname='cyrillicizhitsadoublegrave', description='CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT', shcode=0x0475, uccode=0x0476, specials={'char',0x0475,0x030F} },
	[0x0478] = { unicodeslot=0x0478, category='lu', contextname='cyrillicUK', description='CYRILLIC CAPITAL LETTER UK', lccode=0x0479 },
	[0x0479] = { unicodeslot=0x0479, category='ll', contextname='cyrillicuk', description='CYRILLIC SMALL LETTER UK', uccode=0x0478 },
	[0x047A] = { unicodeslot=0x047A, category='lu', contextname='cyrillicOMEGAround', description='CYRILLIC CAPITAL LETTER ROUND OMEGA', lccode=0x047B },
	[0x047B] = { unicodeslot=0x047B, category='ll', contextname='cyrillicomegaround', description='CYRILLIC SMALL LETTER ROUND OMEGA', uccode=0x047A },
	[0x047C] = { unicodeslot=0x047C, category='lu', contextname='cyrillicOMEGAtitlo', description='CYRILLIC CAPITAL LETTER OMEGA WITH TITLO', shcode=0x0460, lccode=0x047D },
	[0x047D] = { unicodeslot=0x047D, category='ll', contextname='cyrillicomegatitlo', description='CYRILLIC SMALL LETTER OMEGA WITH TITLO', shcode=0x0461, uccode=0x047C },
	[0x047E] = { unicodeslot=0x047E, category='lu', contextname='cyrillicOT', description='CYRILLIC CAPITAL LETTER OT', lccode=0x047F },
	[0x047F] = { unicodeslot=0x047F, category='ll', contextname='cyrillicot', description='CYRILLIC SMALL LETTER OT', uccode=0x047E },
	[0x0480] = { unicodeslot=0x0480, category='lu', contextname='cyrillicKOPPA', description='CYRILLIC CAPITAL LETTER KOPPA', lccode=0x0481 },
	[0x0481] = { unicodeslot=0x0481, category='ll', contextname='cyrillickoppa', description='CYRILLIC SMALL LETTER KOPPA', uccode=0x0480 },
	[0x0482] = { unicodeslot=0x0482, category='so', description='CYRILLIC THOUSANDS SIGN' },
	[0x0483] = { unicodeslot=0x0483, category='mn', contextname='cyrillicTITLO', description='COMBINING CYRILLIC TITLO' },
	[0x0484] = { unicodeslot=0x0484, category='mn', contextname='cyrillicPALATALIZATION', description='COMBINING CYRILLIC PALATALIZATION' },
	[0x0485] = { unicodeslot=0x0485, category='mn', contextname='cyrillicDASIAPNEUMATA', description='COMBINING CYRILLIC DASIA PNEUMATA' },
	[0x0486] = { unicodeslot=0x0486, category='mn', contextname='cyrillicPSILIPNEUMATA', description='COMBINING CYRILLIC PSILI PNEUMATA' },
	[0x0488] = { unicodeslot=0x0488, category='me', description='COMBINING CYRILLIC HUNDRED THOUSANDS SIGN' },
	[0x0489] = { unicodeslot=0x0489, category='me', description='COMBINING CYRILLIC MILLIONS SIGN' },
	[0x048A] = { unicodeslot=0x048A, category='lu', contextname='cyrillicISHRTtail', description='CYRILLIC CAPITAL LETTER SHORT I WITH TAIL', lccode=0x048B },
	[0x048B] = { unicodeslot=0x048B, category='ll', contextname='cyrillicishrttail', description='CYRILLIC SMALL LETTER SHORT I WITH TAIL', uccode=0x048A },
	[0x048C] = { unicodeslot=0x048C, category='lu', contextname='cyrillicSEMISOFT', description='CYRILLIC CAPITAL LETTER SEMISOFT SIGN', lccode=0x048D },
	[0x048D] = { unicodeslot=0x048D, category='ll', contextname='cyrillicsemisoft', description='CYRILLIC SMALL LETTER SEMISOFT SIGN', uccode=0x048C },
	[0x048E] = { unicodeslot=0x048E, category='lu', contextname='cyrillicERtick', description='CYRILLIC CAPITAL LETTER ER WITH TICK', shcode=0x0420, lccode=0x048F },
	[0x048F] = { unicodeslot=0x048F, category='ll', contextname='cyrillicertick', description='CYRILLIC SMALL LETTER ER WITH TICK', shcode=0x0440, uccode=0x048E },
	[0x0490] = { unicodeslot=0x0490, category='lu', adobename='afii10050', contextname='cyrillicGHEupturn', description='CYRILLIC CAPITAL LETTER GHE WITH UPTURN', shcode=0x0413, lccode=0x0491 },
	[0x0491] = { unicodeslot=0x0491, category='ll', adobename='afii10098', contextname='cyrillicgheupturn', description='CYRILLIC SMALL LETTER GHE WITH UPTURN', shcode=0x0433, uccode=0x0490 },
	[0x0492] = { unicodeslot=0x0492, category='lu', contextname='cyrillicGHEstroke', description='CYRILLIC CAPITAL LETTER GHE WITH STROKE', shcode=0x0413, lccode=0x0493 },
	[0x0493] = { unicodeslot=0x0493, category='ll', contextname='cyrillicghestroke', description='CYRILLIC SMALL LETTER GHE WITH STROKE', shcode=0x0433, uccode=0x0492 },
	[0x0494] = { unicodeslot=0x0494, category='lu', contextname='cyrillicGHEmidhook', description='CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK', shcode=0x0413, lccode=0x0495 },
	[0x0495] = { unicodeslot=0x0495, category='ll', contextname='cyrillicghemidhook', description='CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK', shcode=0x0433, uccode=0x0494 },
	[0x0496] = { unicodeslot=0x0496, category='lu', contextname='cyrillicZHEdescender', description='CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER', shcode=0x0416, lccode=0x0497 },
	[0x0497] = { unicodeslot=0x0497, category='ll', contextname='cyrilliczhedescender', description='CYRILLIC SMALL LETTER ZHE WITH DESCENDER', shcode=0x0436, uccode=0x0496 },
	[0x0498] = { unicodeslot=0x0498, category='lu', contextname='cyrillicZDSC', description='CYRILLIC CAPITAL LETTER ZE WITH DESCENDER', shcode=0x0417, lccode=0x0499 },
	[0x0499] = { unicodeslot=0x0499, category='ll', contextname='cyrilliczdsc', description='CYRILLIC SMALL LETTER ZE WITH DESCENDER', shcode=0x0437, uccode=0x0498 },
	[0x049A] = { unicodeslot=0x049A, category='lu', contextname='cyrillicKADC', description='CYRILLIC CAPITAL LETTER KA WITH DESCENDER', shcode=0x041A, lccode=0x049B },
	[0x049B] = { unicodeslot=0x049B, category='ll', contextname='cyrillickadc', description='CYRILLIC SMALL LETTER KA WITH DESCENDER', shcode=0x043A, uccode=0x049A },
	[0x049C] = { unicodeslot=0x049C, category='lu', contextname='cyrillicKAvertstroke', description='CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE', shcode=0x041A, lccode=0x049D },
	[0x049D] = { unicodeslot=0x049D, category='ll', contextname='cyrillickavertstroke', description='CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE', shcode=0x043A, uccode=0x049C },
	[0x049E] = { unicodeslot=0x049E, category='lu', contextname='cyrillicKAstroke', description='CYRILLIC CAPITAL LETTER KA WITH STROKE', shcode=0x041A, lccode=0x049F },
	[0x049F] = { unicodeslot=0x049F, category='ll', contextname='cyrillickastroke', description='CYRILLIC SMALL LETTER KA WITH STROKE', shcode=0x043A, uccode=0x049E },
	[0x04A0] = { unicodeslot=0x04A0, category='lu', contextname='cyrillicKAbashkir', description='CYRILLIC CAPITAL LETTER BASHKIR KA', lccode=0x04A1 },
	[0x04A1] = { unicodeslot=0x04A1, category='ll', contextname='cyrillickabashkir', description='CYRILLIC SMALL LETTER BASHKIR KA', uccode=0x04A0 },
	[0x04A2] = { unicodeslot=0x04A2, category='lu', contextname='cyrillicENDC', description='CYRILLIC CAPITAL LETTER EN WITH DESCENDER', shcode=0x041D, lccode=0x04A3 },
	[0x04A3] = { unicodeslot=0x04A3, category='ll', contextname='cyrillicendc', description='CYRILLIC SMALL LETTER EN WITH DESCENDER', shcode=0x043D, uccode=0x04A2 },
	[0x04A4] = { unicodeslot=0x04A4, category='lu', contextname='cyrillicENGHE', description='CYRILLIC CAPITAL LIGATURE EN GHE', lccode=0x04A5 },
	[0x04A5] = { unicodeslot=0x04A5, category='ll', contextname='cyrillicenghe', description='CYRILLIC SMALL LIGATURE EN GHE', uccode=0x04A4 },
	[0x04A6] = { unicodeslot=0x04A6, category='lu', contextname='cyrillicPEmidhook', description='CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK', shcode=0x041F, lccode=0x04A7 },
	[0x04A7] = { unicodeslot=0x04A7, category='ll', contextname='cyrillicpemidhook', description='CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK', shcode=0x043F, uccode=0x04A6 },
	[0x04A8] = { unicodeslot=0x04A8, category='lu', contextname='cyrillicHA', description='CYRILLIC CAPITAL LETTER ABKHASIAN HA', lccode=0x04A9 },
	[0x04A9] = { unicodeslot=0x04A9, category='ll', contextname='cyrillicha', description='CYRILLIC SMALL LETTER ABKHASIAN HA', uccode=0x04A8 },
	[0x04AA] = { unicodeslot=0x04AA, category='lu', contextname='cyrillicSDSC', description='CYRILLIC CAPITAL LETTER ES WITH DESCENDER', shcode=0x0421, lccode=0x04AB },
	[0x04AB] = { unicodeslot=0x04AB, category='ll', contextname='cyrillicsdsc', description='CYRILLIC SMALL LETTER ES WITH DESCENDER', shcode=0x0441, uccode=0x04AA },
	[0x04AC] = { unicodeslot=0x04AC, category='lu', contextname='cyrillicTEDC', description='CYRILLIC CAPITAL LETTER TE WITH DESCENDER', shcode=0x0422, lccode=0x04AD },
	[0x04AD] = { unicodeslot=0x04AD, category='ll', contextname='cyrillictedc', description='CYRILLIC SMALL LETTER TE WITH DESCENDER', shcode=0x0442, uccode=0x04AC },
	[0x04AE] = { unicodeslot=0x04AE, category='lu', contextname='cyrillicYstr', description='CYRILLIC CAPITAL LETTER STRAIGHT U', lccode=0x04AF },
	[0x04AF] = { unicodeslot=0x04AF, category='ll', contextname='cyrillicystr', description='CYRILLIC SMALL LETTER STRAIGHT U', uccode=0x04AE },
	[0x04B0] = { unicodeslot=0x04B0, category='lu', contextname='cyrillicYstrstroke', description='CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE', lccode=0x04B1 },
	[0x04B1] = { unicodeslot=0x04B1, category='ll', contextname='cyrillicystrstroke', description='CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE', uccode=0x04B0 },
	[0x04B2] = { unicodeslot=0x04B2, category='lu', contextname='cyrillicHADC', description='CYRILLIC CAPITAL LETTER HA WITH DESCENDER', shcode=0x0425, lccode=0x04B3 },
	[0x04B3] = { unicodeslot=0x04B3, category='ll', contextname='cyrillichadc', description='CYRILLIC SMALL LETTER HA WITH DESCENDER', shcode=0x0445, uccode=0x04B2 },
	[0x04B4] = { unicodeslot=0x04B4, category='lu', contextname='cyrillicTETSE', description='CYRILLIC CAPITAL LIGATURE TE TSE', lccode=0x04B5 },
	[0x04B5] = { unicodeslot=0x04B5, category='ll', contextname='cyrillictetse', description='CYRILLIC SMALL LIGATURE TE TSE', uccode=0x04B4 },
	[0x04B6] = { unicodeslot=0x04B6, category='lu', contextname='cyrillicCHEDC', description='CYRILLIC CAPITAL LETTER CHE WITH DESCENDER', shcode=0x0427, lccode=0x04B7 },
	[0x04B7] = { unicodeslot=0x04B7, category='ll', contextname='cyrillicchedc', description='CYRILLIC SMALL LETTER CHE WITH DESCENDER', shcode=0x0447, uccode=0x04B6 },
	[0x04B8] = { unicodeslot=0x04B8, category='lu', contextname='cyrillicCHEvertstroke', description='CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE', shcode=0x0427, lccode=0x04B9 },
	[0x04B9] = { unicodeslot=0x04B9, category='ll', contextname='cyrillicchevertstroke', description='CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE', shcode=0x0447, uccode=0x04B8 },
	[0x04BA] = { unicodeslot=0x04BA, category='lu', contextname='cyrillicSHHA', description='CYRILLIC CAPITAL LETTER SHHA', lccode=0x04BB },
	[0x04BB] = { unicodeslot=0x04BB, category='ll', contextname='cyrillicshha', description='CYRILLIC SMALL LETTER SHHA', uccode=0x04BA },
	[0x04BC] = { unicodeslot=0x04BC, category='lu', contextname='cyrillicCHEabkhasian', description='CYRILLIC CAPITAL LETTER ABKHASIAN CHE', lccode=0x04BD },
	[0x04BD] = { unicodeslot=0x04BD, category='ll', contextname='cyrilliccheabkhasian', description='CYRILLIC SMALL LETTER ABKHASIAN CHE', uccode=0x04BC },
	[0x04BE] = { unicodeslot=0x04BE, category='lu', contextname='cyrillicCHEDCabkhasian', description='CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER', lccode=0x04BF },
	[0x04BF] = { unicodeslot=0x04BF, category='ll', contextname='cyrillicchedcabkhasian', description='CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER', uccode=0x04BE },
	[0x04C0] = { unicodeslot=0x04C0, category='lu', contextname='cyrillicPALOCHKA', description='CYRILLIC LETTER PALOCHKA', lccode=0x04CF },
	[0x04C1] = { unicodeslot=0x04C1, category='lu', contextname='cyrillicZHEbreve', description='CYRILLIC CAPITAL LETTER ZHE WITH BREVE', shcode=0x0416, lccode=0x04C2, specials={'char',0x0416,0x0306} },
	[0x04C2] = { unicodeslot=0x04C2, category='ll', contextname='cyrilliczhebreve', description='CYRILLIC SMALL LETTER ZHE WITH BREVE', shcode=0x0436, uccode=0x04C1, specials={'char',0x0436,0x0306} },
	[0x04C3] = { unicodeslot=0x04C3, category='lu', contextname='cyrillicKAhook', description='CYRILLIC CAPITAL LETTER KA WITH HOOK', shcode=0x041A, lccode=0x04C4 },
	[0x04C4] = { unicodeslot=0x04C4, category='ll', contextname='cyrillickahook', description='CYRILLIC SMALL LETTER KA WITH HOOK', shcode=0x043A, uccode=0x04C3 },
	[0x04C5] = { unicodeslot=0x04C5, category='lu', contextname='cyrillicELtail', description='CYRILLIC CAPITAL LETTER EL WITH TAIL', shcode=0x041B, lccode=0x04C6 },
	[0x04C6] = { unicodeslot=0x04C6, category='ll', contextname='cyrilliceltail', description='CYRILLIC SMALL LETTER EL WITH TAIL', shcode=0x043B, uccode=0x04C5 },
	[0x04C7] = { unicodeslot=0x04C7, category='lu', contextname='cyrillicENhook', description='CYRILLIC CAPITAL LETTER EN WITH HOOK', shcode=0x041D, lccode=0x04C8 },
	[0x04C8] = { unicodeslot=0x04C8, category='ll', contextname='cyrillicenhook', description='CYRILLIC SMALL LETTER EN WITH HOOK', shcode=0x043D, uccode=0x04C7 },
	[0x04C9] = { unicodeslot=0x04C9, category='lu', contextname='cyrillicENtail', description='CYRILLIC CAPITAL LETTER EN WITH TAIL', shcode=0x041D, lccode=0x04CA },
	[0x04CA] = { unicodeslot=0x04CA, category='ll', contextname='cyrillicentail', description='CYRILLIC SMALL LETTER EN WITH TAIL', shcode=0x043D, uccode=0x04C9 },
	[0x04CB] = { unicodeslot=0x04CB, category='lu', contextname='cyrillicCHEkhakassian', description='CYRILLIC CAPITAL LETTER KHAKASSIAN CHE', lccode=0x04CC },
	[0x04CC] = { unicodeslot=0x04CC, category='ll', contextname='cyrillicchekhakassian', description='CYRILLIC SMALL LETTER KHAKASSIAN CHE', uccode=0x04CB },
	[0x04CD] = { unicodeslot=0x04CD, category='lu', contextname='cyrillicEMtail', description='CYRILLIC CAPITAL LETTER EM WITH TAIL', shcode=0x041C, lccode=0x04CE },
	[0x04CE] = { unicodeslot=0x04CE, category='ll', contextname='cyrillicemtail', description='CYRILLIC SMALL LETTER EM WITH TAIL', shcode=0x043C, uccode=0x04CD },
	[0x04CF] = { unicodeslot=0x04CF, category='ll', description='CYRILLIC SMALL LETTER PALOCHKA', uccode=0x04C0 },
	[0x04D0] = { unicodeslot=0x04D0, category='lu', contextname='cyrillicAbreve', description='CYRILLIC CAPITAL LETTER A WITH BREVE', shcode=0x0410, lccode=0x04D1, specials={'char',0x0410,0x0306} },
	[0x04D1] = { unicodeslot=0x04D1, category='ll', contextname='cyrillicabreve', description='CYRILLIC SMALL LETTER A WITH BREVE', shcode=0x0430, uccode=0x04D0, specials={'char',0x0430,0x0306} },
	[0x04D2] = { unicodeslot=0x04D2, category='lu', contextname='cyrillicAdiaeresis', description='CYRILLIC CAPITAL LETTER A WITH DIAERESIS', shcode=0x0410, lccode=0x04D3, specials={'char',0x0410,0x0308} },
	[0x04D3] = { unicodeslot=0x04D3, category='ll', contextname='cyrillicadiaeresis', description='CYRILLIC SMALL LETTER A WITH DIAERESIS', shcode=0x0430, uccode=0x04D2, specials={'char',0x0430,0x0308} },
	[0x04D4] = { unicodeslot=0x04D4, category='lu', contextname='cyrillicAE', description='CYRILLIC CAPITAL LIGATURE A IE', lccode=0x04D5 },
	[0x04D5] = { unicodeslot=0x04D5, category='ll', contextname='cyrillicae', description='CYRILLIC SMALL LIGATURE A IE', uccode=0x04D4 },
	[0x04D6] = { unicodeslot=0x04D6, category='lu', contextname='cyrillicEbreve', description='CYRILLIC CAPITAL LETTER IE WITH BREVE', shcode=0x0415, lccode=0x04D7, specials={'char',0x0415,0x0306} },
	[0x04D7] = { unicodeslot=0x04D7, category='ll', contextname='cyrillicebreve', description='CYRILLIC SMALL LETTER IE WITH BREVE', shcode=0x0435, uccode=0x04D6, specials={'char',0x0435,0x0306} },
	[0x04D8] = { unicodeslot=0x04D8, category='lu', contextname='cyrillicSCHWA', description='CYRILLIC CAPITAL LETTER SCHWA', lccode=0x04D9 },
	[0x04D9] = { unicodeslot=0x04D9, category='ll', adobename='afii10846', contextname='cyrillicschwa', description='CYRILLIC SMALL LETTER SCHWA', uccode=0x04D8 },
	[0x04DA] = { unicodeslot=0x04DA, category='lu', contextname='cyrillicSCHWAdiaeresis', description='CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS', shcode=0x04D8, lccode=0x04DB, specials={'char',0x04D8,0x0308} },
	[0x04DB] = { unicodeslot=0x04DB, category='ll', contextname='cyrillicschwadiaeresis', description='CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS', shcode=0x04D9, uccode=0x04DA, specials={'char',0x04D9,0x0308} },
	[0x04DC] = { unicodeslot=0x04DC, category='lu', contextname='cyrillicZHEdiaeresis', description='CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS', shcode=0x0416, lccode=0x04DD, specials={'char',0x0416,0x0308} },
	[0x04DD] = { unicodeslot=0x04DD, category='ll', contextname='cyrilliczhediaeresis', description='CYRILLIC SMALL LETTER ZHE WITH DIAERESIS', shcode=0x0436, uccode=0x04DC, specials={'char',0x0436,0x0308} },
	[0x04DE] = { unicodeslot=0x04DE, category='lu', contextname='cyrillicZEdiaeresis', description='CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS', shcode=0x0417, lccode=0x04DF, specials={'char',0x0417,0x0308} },
	[0x04DF] = { unicodeslot=0x04DF, category='ll', contextname='cyrilliczediaeresis', description='CYRILLIC SMALL LETTER ZE WITH DIAERESIS', shcode=0x0437, uccode=0x04DE, specials={'char',0x0437,0x0308} },
	[0x04E0] = { unicodeslot=0x04E0, category='lu', contextname='cyrillicDZEabkhasian', description='CYRILLIC CAPITAL LETTER ABKHASIAN DZE', lccode=0x04E1 },
	[0x04E1] = { unicodeslot=0x04E1, category='ll', contextname='cyrillicdzeabkhasian', description='CYRILLIC SMALL LETTER ABKHASIAN DZE', uccode=0x04E0 },
	[0x04E2] = { unicodeslot=0x04E2, category='lu', contextname='cyrillicImacron', description='CYRILLIC CAPITAL LETTER I WITH MACRON', shcode=0x0418, lccode=0x04E3, specials={'char',0x0418,0x0304} },
	[0x04E3] = { unicodeslot=0x04E3, category='ll', contextname='cyrillicimacron', description='CYRILLIC SMALL LETTER I WITH MACRON', shcode=0x0438, uccode=0x04E2, specials={'char',0x0438,0x0304} },
	[0x04E4] = { unicodeslot=0x04E4, category='lu', contextname='cyrillicIdiaeresis', description='CYRILLIC CAPITAL LETTER I WITH DIAERESIS', shcode=0x0418, lccode=0x04E5, specials={'char',0x0418,0x0308} },
	[0x04E5] = { unicodeslot=0x04E5, category='ll', contextname='cyrillicidiaeresis', description='CYRILLIC SMALL LETTER I WITH DIAERESIS', shcode=0x0438, uccode=0x04E4, specials={'char',0x0438,0x0308} },
	[0x04E6] = { unicodeslot=0x04E6, category='lu', contextname='cyrillicOdiaeresis', description='CYRILLIC CAPITAL LETTER O WITH DIAERESIS', shcode=0x041E, lccode=0x04E7, specials={'char',0x041E,0x0308} },
	[0x04E7] = { unicodeslot=0x04E7, category='ll', contextname='cyrillicodiaeresis', description='CYRILLIC SMALL LETTER O WITH DIAERESIS', shcode=0x043E, uccode=0x04E6, specials={'char',0x043E,0x0308} },
	[0x04E8] = { unicodeslot=0x04E8, category='lu', contextname='cyrillicObarred', description='CYRILLIC CAPITAL LETTER BARRED O', lccode=0x04E9 },
	[0x04E9] = { unicodeslot=0x04E9, category='ll', contextname='cyrillicobarred', description='CYRILLIC SMALL LETTER BARRED O', uccode=0x04E8 },
	[0x04EA] = { unicodeslot=0x04EA, category='lu', contextname='cyrillicObarreddiaeresis', description='CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS', lccode=0x04EB, specials={'char',0x04E8,0x0308} },
	[0x04EB] = { unicodeslot=0x04EB, category='ll', contextname='cyrillicobarreddiaeresis', description='CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS', uccode=0x04EA, specials={'char',0x04E9,0x0308} },
	[0x04EC] = { unicodeslot=0x04EC, category='lu', contextname='cyrillicEdiaeresis', description='CYRILLIC CAPITAL LETTER E WITH DIAERESIS', shcode=0x042D, lccode=0x04ED, specials={'char',0x042D,0x0308} },
	[0x04ED] = { unicodeslot=0x04ED, category='ll', contextname='cyrillicediaeresis', description='CYRILLIC SMALL LETTER E WITH DIAERESIS', shcode=0x044D, uccode=0x04EC, specials={'char',0x044D,0x0308} },
	[0x04EE] = { unicodeslot=0x04EE, category='lu', contextname='cyrillicUmacron', description='CYRILLIC CAPITAL LETTER U WITH MACRON', shcode=0x0423, lccode=0x04EF, specials={'char',0x0423,0x0304} },
	[0x04EF] = { unicodeslot=0x04EF, category='ll', contextname='cyrillicumacron', description='CYRILLIC SMALL LETTER U WITH MACRON', shcode=0x0443, uccode=0x04EE, specials={'char',0x0443,0x0304} },
	[0x04F0] = { unicodeslot=0x04F0, category='lu', contextname='cyrillicUdiaeresis', description='CYRILLIC CAPITAL LETTER U WITH DIAERESIS', shcode=0x0423, lccode=0x04F1, specials={'char',0x0423,0x0308} },
	[0x04F1] = { unicodeslot=0x04F1, category='ll', contextname='cyrillicudiaeresis', description='CYRILLIC SMALL LETTER U WITH DIAERESIS', shcode=0x0443, uccode=0x04F0, specials={'char',0x0443,0x0308} },
	[0x04F2] = { unicodeslot=0x04F2, category='lu', contextname='cyrillicUdoubleacute', description='CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE', shcode=0x0423, lccode=0x04F3, specials={'char',0x0423,0x030B} },
	[0x04F3] = { unicodeslot=0x04F3, category='ll', contextname='cyrillicudoubleacute', description='CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE', shcode=0x0443, uccode=0x04F2, specials={'char',0x0443,0x030B} },
	[0x04F4] = { unicodeslot=0x04F4, category='lu', contextname='cyrillicCHEdiaeresis', description='CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS', shcode=0x0427, lccode=0x04F5, specials={'char',0x0427,0x0308} },
	[0x04F5] = { unicodeslot=0x04F5, category='ll', contextname='cyrillicchediaeresis', description='CYRILLIC SMALL LETTER CHE WITH DIAERESIS', shcode=0x0447, uccode=0x04F4, specials={'char',0x0447,0x0308} },
	[0x04F6] = { unicodeslot=0x04F6, category='lu', description='CYRILLIC CAPITAL LETTER GHE WITH DESCENDER', shcode=0x0413, lccode=0x04F7 },
	[0x04F7] = { unicodeslot=0x04F7, category='ll', description='CYRILLIC SMALL LETTER GHE WITH DESCENDER', shcode=0x0433, uccode=0x04F6 },
	[0x04F8] = { unicodeslot=0x04F8, category='lu', contextname='cyrillicYERUdiaeresis', description='CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS', shcode=0x042B, lccode=0x04F9, specials={'char',0x042B,0x0308} },
	[0x04F9] = { unicodeslot=0x04F9, category='ll', contextname='cyrillicyerudiaeresis', description='CYRILLIC SMALL LETTER YERU WITH DIAERESIS', shcode=0x044B, uccode=0x04F8, specials={'char',0x044B,0x0308} },
	[0x04FA] = { unicodeslot=0x04FA, category='lu', description='CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK', shcode=0x0413, lccode=0x04FB },
	[0x04FB] = { unicodeslot=0x04FB, category='ll', description='CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK', shcode=0x0433, uccode=0x04FA },
	[0x04FC] = { unicodeslot=0x04FC, category='lu', description='CYRILLIC CAPITAL LETTER HA WITH HOOK', shcode=0x0425, lccode=0x04FD },
	[0x04FD] = { unicodeslot=0x04FD, category='ll', description='CYRILLIC SMALL LETTER HA WITH HOOK', shcode=0x0445, uccode=0x04FC },
	[0x04FE] = { unicodeslot=0x04FE, category='lu', description='CYRILLIC CAPITAL LETTER HA WITH STROKE', shcode=0x0425, lccode=0x04FF },
	[0x04FF] = { unicodeslot=0x04FF, category='ll', description='CYRILLIC SMALL LETTER HA WITH STROKE', shcode=0x0445, uccode=0x04FE },
	[0x0500] = { unicodeslot=0x0500, category='lu', description='CYRILLIC CAPITAL LETTER KOMI DE', lccode=0x0501 },
	[0x0501] = { unicodeslot=0x0501, category='ll', description='CYRILLIC SMALL LETTER KOMI DE', uccode=0x0500 },
	[0x0502] = { unicodeslot=0x0502, category='lu', description='CYRILLIC CAPITAL LETTER KOMI DJE', lccode=0x0503 },
	[0x0503] = { unicodeslot=0x0503, category='ll', description='CYRILLIC SMALL LETTER KOMI DJE', uccode=0x0502 },
	[0x0504] = { unicodeslot=0x0504, category='lu', description='CYRILLIC CAPITAL LETTER KOMI ZJE', lccode=0x0505 },
	[0x0505] = { unicodeslot=0x0505, category='ll', description='CYRILLIC SMALL LETTER KOMI ZJE', uccode=0x0504 },
	[0x0506] = { unicodeslot=0x0506, category='lu', description='CYRILLIC CAPITAL LETTER KOMI DZJE', lccode=0x0507 },
	[0x0507] = { unicodeslot=0x0507, category='ll', description='CYRILLIC SMALL LETTER KOMI DZJE', uccode=0x0506 },
	[0x0508] = { unicodeslot=0x0508, category='lu', description='CYRILLIC CAPITAL LETTER KOMI LJE', lccode=0x0509 },
	[0x0509] = { unicodeslot=0x0509, category='ll', description='CYRILLIC SMALL LETTER KOMI LJE', uccode=0x0508 },
	[0x050A] = { unicodeslot=0x050A, category='lu', description='CYRILLIC CAPITAL LETTER KOMI NJE', lccode=0x050B },
	[0x050B] = { unicodeslot=0x050B, category='ll', description='CYRILLIC SMALL LETTER KOMI NJE', uccode=0x050A },
	[0x050C] = { unicodeslot=0x050C, category='lu', description='CYRILLIC CAPITAL LETTER KOMI SJE', lccode=0x050D },
	[0x050D] = { unicodeslot=0x050D, category='ll', description='CYRILLIC SMALL LETTER KOMI SJE', uccode=0x050C },
	[0x050E] = { unicodeslot=0x050E, category='lu', description='CYRILLIC CAPITAL LETTER KOMI TJE', lccode=0x050F },
	[0x050F] = { unicodeslot=0x050F, category='ll', description='CYRILLIC SMALL LETTER KOMI TJE', uccode=0x050E },
	[0x0510] = { unicodeslot=0x0510, category='lu', description='CYRILLIC CAPITAL LETTER REVERSED ZE', lccode=0x0511 },
	[0x0511] = { unicodeslot=0x0511, category='ll', description='CYRILLIC SMALL LETTER REVERSED ZE', uccode=0x0510 },
	[0x0512] = { unicodeslot=0x0512, category='lu', description='CYRILLIC CAPITAL LETTER EL WITH HOOK', shcode=0x041B, lccode=0x0513 },
	[0x0513] = { unicodeslot=0x0513, category='ll', description='CYRILLIC SMALL LETTER EL WITH HOOK', shcode=0x043B, uccode=0x0512 },
	[0x0531] = { unicodeslot=0x0531, category='lu', description='ARMENIAN CAPITAL LETTER AYB', lccode=0x0561 },
	[0x0532] = { unicodeslot=0x0532, category='lu', description='ARMENIAN CAPITAL LETTER BEN', lccode=0x0562 },
	[0x0533] = { unicodeslot=0x0533, category='lu', description='ARMENIAN CAPITAL LETTER GIM', lccode=0x0563 },
	[0x0534] = { unicodeslot=0x0534, category='lu', description='ARMENIAN CAPITAL LETTER DA', lccode=0x0564 },
	[0x0535] = { unicodeslot=0x0535, category='lu', description='ARMENIAN CAPITAL LETTER ECH', lccode=0x0565 },
	[0x0536] = { unicodeslot=0x0536, category='lu', description='ARMENIAN CAPITAL LETTER ZA', lccode=0x0566 },
	[0x0537] = { unicodeslot=0x0537, category='lu', description='ARMENIAN CAPITAL LETTER EH', lccode=0x0567 },
	[0x0538] = { unicodeslot=0x0538, category='lu', description='ARMENIAN CAPITAL LETTER ET', lccode=0x0568 },
	[0x0539] = { unicodeslot=0x0539, category='lu', description='ARMENIAN CAPITAL LETTER TO', lccode=0x0569 },
	[0x053A] = { unicodeslot=0x053A, category='lu', description='ARMENIAN CAPITAL LETTER ZHE', lccode=0x056A },
	[0x053B] = { unicodeslot=0x053B, category='lu', description='ARMENIAN CAPITAL LETTER INI', lccode=0x056B },
	[0x053C] = { unicodeslot=0x053C, category='lu', description='ARMENIAN CAPITAL LETTER LIWN', lccode=0x056C },
	[0x053D] = { unicodeslot=0x053D, category='lu', description='ARMENIAN CAPITAL LETTER XEH', lccode=0x056D },
	[0x053E] = { unicodeslot=0x053E, category='lu', description='ARMENIAN CAPITAL LETTER CA', lccode=0x056E },
	[0x053F] = { unicodeslot=0x053F, category='lu', description='ARMENIAN CAPITAL LETTER KEN', lccode=0x056F },
	[0x0540] = { unicodeslot=0x0540, category='lu', description='ARMENIAN CAPITAL LETTER HO', lccode=0x0570 },
	[0x0541] = { unicodeslot=0x0541, category='lu', description='ARMENIAN CAPITAL LETTER JA', lccode=0x0571 },
	[0x0542] = { unicodeslot=0x0542, category='lu', description='ARMENIAN CAPITAL LETTER GHAD', lccode=0x0572 },
	[0x0543] = { unicodeslot=0x0543, category='lu', description='ARMENIAN CAPITAL LETTER CHEH', lccode=0x0573 },
	[0x0544] = { unicodeslot=0x0544, category='lu', description='ARMENIAN CAPITAL LETTER MEN', lccode=0x0574 },
	[0x0545] = { unicodeslot=0x0545, category='lu', description='ARMENIAN CAPITAL LETTER YI', lccode=0x0575 },
	[0x0546] = { unicodeslot=0x0546, category='lu', description='ARMENIAN CAPITAL LETTER NOW', lccode=0x0576 },
	[0x0547] = { unicodeslot=0x0547, category='lu', description='ARMENIAN CAPITAL LETTER SHA', lccode=0x0577 },
	[0x0548] = { unicodeslot=0x0548, category='lu', description='ARMENIAN CAPITAL LETTER VO', lccode=0x0578 },
	[0x0549] = { unicodeslot=0x0549, category='lu', description='ARMENIAN CAPITAL LETTER CHA', lccode=0x0579 },
	[0x054A] = { unicodeslot=0x054A, category='lu', description='ARMENIAN CAPITAL LETTER PEH', lccode=0x057A },
	[0x054B] = { unicodeslot=0x054B, category='lu', description='ARMENIAN CAPITAL LETTER JHEH', lccode=0x057B },
	[0x054C] = { unicodeslot=0x054C, category='lu', description='ARMENIAN CAPITAL LETTER RA', lccode=0x057C },
	[0x054D] = { unicodeslot=0x054D, category='lu', description='ARMENIAN CAPITAL LETTER SEH', lccode=0x057D },
	[0x054E] = { unicodeslot=0x054E, category='lu', description='ARMENIAN CAPITAL LETTER VEW', lccode=0x057E },
	[0x054F] = { unicodeslot=0x054F, category='lu', description='ARMENIAN CAPITAL LETTER TIWN', lccode=0x057F },
	[0x0550] = { unicodeslot=0x0550, category='lu', description='ARMENIAN CAPITAL LETTER REH', lccode=0x0580 },
	[0x0551] = { unicodeslot=0x0551, category='lu', description='ARMENIAN CAPITAL LETTER CO', lccode=0x0581 },
	[0x0552] = { unicodeslot=0x0552, category='lu', description='ARMENIAN CAPITAL LETTER YIWN', lccode=0x0582 },
	[0x0553] = { unicodeslot=0x0553, category='lu', description='ARMENIAN CAPITAL LETTER PIWR', lccode=0x0583 },
	[0x0554] = { unicodeslot=0x0554, category='lu', description='ARMENIAN CAPITAL LETTER KEH', lccode=0x0584 },
	[0x0555] = { unicodeslot=0x0555, category='lu', description='ARMENIAN CAPITAL LETTER OH', lccode=0x0585 },
	[0x0556] = { unicodeslot=0x0556, category='lu', description='ARMENIAN CAPITAL LETTER FEH', lccode=0x0586 },
	[0x0559] = { unicodeslot=0x0559, category='lm', description='ARMENIAN MODIFIER LETTER LEFT HALF RING' },
	[0x055A] = { unicodeslot=0x055A, category='po', description='ARMENIAN APOSTROPHE' },
	[0x055B] = { unicodeslot=0x055B, category='po', description='ARMENIAN EMPHASIS MARK' },
	[0x055C] = { unicodeslot=0x055C, category='po', description='ARMENIAN EXCLAMATION MARK' },
	[0x055D] = { unicodeslot=0x055D, category='po', description='ARMENIAN COMMA' },
	[0x055E] = { unicodeslot=0x055E, category='po', description='ARMENIAN QUESTION MARK' },
	[0x055F] = { unicodeslot=0x055F, category='po', description='ARMENIAN ABBREVIATION MARK' },
	[0x0561] = { unicodeslot=0x0561, category='ll', description='ARMENIAN SMALL LETTER AYB', uccode=0x0531 },
	[0x0562] = { unicodeslot=0x0562, category='ll', description='ARMENIAN SMALL LETTER BEN', uccode=0x0532 },
	[0x0563] = { unicodeslot=0x0563, category='ll', description='ARMENIAN SMALL LETTER GIM', uccode=0x0533 },
	[0x0564] = { unicodeslot=0x0564, category='ll', description='ARMENIAN SMALL LETTER DA', uccode=0x0534 },
	[0x0565] = { unicodeslot=0x0565, category='ll', description='ARMENIAN SMALL LETTER ECH', uccode=0x0535 },
	[0x0566] = { unicodeslot=0x0566, category='ll', description='ARMENIAN SMALL LETTER ZA', uccode=0x0536 },
	[0x0567] = { unicodeslot=0x0567, category='ll', description='ARMENIAN SMALL LETTER EH', uccode=0x0537 },
	[0x0568] = { unicodeslot=0x0568, category='ll', description='ARMENIAN SMALL LETTER ET', uccode=0x0538 },
	[0x0569] = { unicodeslot=0x0569, category='ll', description='ARMENIAN SMALL LETTER TO', uccode=0x0539 },
	[0x056A] = { unicodeslot=0x056A, category='ll', description='ARMENIAN SMALL LETTER ZHE', uccode=0x053A },
	[0x056B] = { unicodeslot=0x056B, category='ll', description='ARMENIAN SMALL LETTER INI', uccode=0x053B },
	[0x056C] = { unicodeslot=0x056C, category='ll', description='ARMENIAN SMALL LETTER LIWN', uccode=0x053C },
	[0x056D] = { unicodeslot=0x056D, category='ll', description='ARMENIAN SMALL LETTER XEH', uccode=0x053D },
	[0x056E] = { unicodeslot=0x056E, category='ll', description='ARMENIAN SMALL LETTER CA', uccode=0x053E },
	[0x056F] = { unicodeslot=0x056F, category='ll', description='ARMENIAN SMALL LETTER KEN', uccode=0x053F },
	[0x0570] = { unicodeslot=0x0570, category='ll', description='ARMENIAN SMALL LETTER HO', uccode=0x0540 },
	[0x0571] = { unicodeslot=0x0571, category='ll', description='ARMENIAN SMALL LETTER JA', uccode=0x0541 },
	[0x0572] = { unicodeslot=0x0572, category='ll', description='ARMENIAN SMALL LETTER GHAD', uccode=0x0542 },
	[0x0573] = { unicodeslot=0x0573, category='ll', description='ARMENIAN SMALL LETTER CHEH', uccode=0x0543 },
	[0x0574] = { unicodeslot=0x0574, category='ll', description='ARMENIAN SMALL LETTER MEN', uccode=0x0544 },
	[0x0575] = { unicodeslot=0x0575, category='ll', description='ARMENIAN SMALL LETTER YI', uccode=0x0545 },
	[0x0576] = { unicodeslot=0x0576, category='ll', description='ARMENIAN SMALL LETTER NOW', uccode=0x0546 },
	[0x0577] = { unicodeslot=0x0577, category='ll', description='ARMENIAN SMALL LETTER SHA', uccode=0x0547 },
	[0x0578] = { unicodeslot=0x0578, category='ll', description='ARMENIAN SMALL LETTER VO', uccode=0x0548 },
	[0x0579] = { unicodeslot=0x0579, category='ll', description='ARMENIAN SMALL LETTER CHA', uccode=0x0549 },
	[0x057A] = { unicodeslot=0x057A, category='ll', description='ARMENIAN SMALL LETTER PEH', uccode=0x054A },
	[0x057B] = { unicodeslot=0x057B, category='ll', description='ARMENIAN SMALL LETTER JHEH', uccode=0x054B },
	[0x057C] = { unicodeslot=0x057C, category='ll', description='ARMENIAN SMALL LETTER RA', uccode=0x054C },
	[0x057D] = { unicodeslot=0x057D, category='ll', description='ARMENIAN SMALL LETTER SEH', uccode=0x054D },
	[0x057E] = { unicodeslot=0x057E, category='ll', description='ARMENIAN SMALL LETTER VEW', uccode=0x054E },
	[0x057F] = { unicodeslot=0x057F, category='ll', description='ARMENIAN SMALL LETTER TIWN', uccode=0x054F },
	[0x0580] = { unicodeslot=0x0580, category='ll', description='ARMENIAN SMALL LETTER REH', uccode=0x0550 },
	[0x0581] = { unicodeslot=0x0581, category='ll', description='ARMENIAN SMALL LETTER CO', uccode=0x0551 },
	[0x0582] = { unicodeslot=0x0582, category='ll', description='ARMENIAN SMALL LETTER YIWN', uccode=0x0552 },
	[0x0583] = { unicodeslot=0x0583, category='ll', description='ARMENIAN SMALL LETTER PIWR', uccode=0x0553 },
	[0x0584] = { unicodeslot=0x0584, category='ll', description='ARMENIAN SMALL LETTER KEH', uccode=0x0554 },
	[0x0585] = { unicodeslot=0x0585, category='ll', description='ARMENIAN SMALL LETTER OH', uccode=0x0555 },
	[0x0586] = { unicodeslot=0x0586, category='ll', description='ARMENIAN SMALL LETTER FEH', uccode=0x0556 },
	[0x0587] = { unicodeslot=0x0587, category='ll', description='ARMENIAN SMALL LIGATURE ECH YIWN', specials={'compat',0x0565,0x0582} },
	[0x0589] = { unicodeslot=0x0589, category='po', description='ARMENIAN FULL STOP' },
	[0x058A] = { unicodeslot=0x058A, category='pd', description='ARMENIAN HYPHEN' },
	[0x0591] = { unicodeslot=0x0591, category='mn', description='HEBREW ACCENT ETNAHTA' },
	[0x0592] = { unicodeslot=0x0592, category='mn', description='HEBREW ACCENT SEGOL' },
	[0x0593] = { unicodeslot=0x0593, category='mn', description='HEBREW ACCENT SHALSHELET' },
	[0x0594] = { unicodeslot=0x0594, category='mn', description='HEBREW ACCENT ZAQEF QATAN' },
	[0x0595] = { unicodeslot=0x0595, category='mn', description='HEBREW ACCENT ZAQEF GADOL' },
	[0x0596] = { unicodeslot=0x0596, category='mn', description='HEBREW ACCENT TIPEHA' },
	[0x0597] = { unicodeslot=0x0597, category='mn', description='HEBREW ACCENT REVIA' },
	[0x0598] = { unicodeslot=0x0598, category='mn', description='HEBREW ACCENT ZARQA' },
	[0x0599] = { unicodeslot=0x0599, category='mn', description='HEBREW ACCENT PASHTA' },
	[0x059A] = { unicodeslot=0x059A, category='mn', description='HEBREW ACCENT YETIV' },
	[0x059B] = { unicodeslot=0x059B, category='mn', description='HEBREW ACCENT TEVIR' },
	[0x059C] = { unicodeslot=0x059C, category='mn', description='HEBREW ACCENT GERESH' },
	[0x059D] = { unicodeslot=0x059D, category='mn', description='HEBREW ACCENT GERESH MUQDAM' },
	[0x059E] = { unicodeslot=0x059E, category='mn', description='HEBREW ACCENT GERSHAYIM' },
	[0x059F] = { unicodeslot=0x059F, category='mn', description='HEBREW ACCENT QARNEY PARA' },
	[0x05A0] = { unicodeslot=0x05A0, category='mn', description='HEBREW ACCENT TELISHA GEDOLA' },
	[0x05A1] = { unicodeslot=0x05A1, category='mn', description='HEBREW ACCENT PAZER' },
	[0x05A2] = { unicodeslot=0x05A2, category='mn', description='HEBREW ACCENT ATNAH HAFUKH' },
	[0x05A3] = { unicodeslot=0x05A3, category='mn', description='HEBREW ACCENT MUNAH' },
	[0x05A4] = { unicodeslot=0x05A4, category='mn', description='HEBREW ACCENT MAHAPAKH' },
	[0x05A5] = { unicodeslot=0x05A5, category='mn', description='HEBREW ACCENT MERKHA' },
	[0x05A6] = { unicodeslot=0x05A6, category='mn', description='HEBREW ACCENT MERKHA KEFULA' },
	[0x05A7] = { unicodeslot=0x05A7, category='mn', description='HEBREW ACCENT DARGA' },
	[0x05A8] = { unicodeslot=0x05A8, category='mn', description='HEBREW ACCENT QADMA' },
	[0x05A9] = { unicodeslot=0x05A9, category='mn', description='HEBREW ACCENT TELISHA QETANA' },
	[0x05AA] = { unicodeslot=0x05AA, category='mn', description='HEBREW ACCENT YERAH BEN YOMO' },
	[0x05AB] = { unicodeslot=0x05AB, category='mn', description='HEBREW ACCENT OLE' },
	[0x05AC] = { unicodeslot=0x05AC, category='mn', description='HEBREW ACCENT ILUY' },
	[0x05AD] = { unicodeslot=0x05AD, category='mn', description='HEBREW ACCENT DEHI' },
	[0x05AE] = { unicodeslot=0x05AE, category='mn', description='HEBREW ACCENT ZINOR' },
	[0x05AF] = { unicodeslot=0x05AF, category='mn', description='HEBREW MARK MASORA CIRCLE' },
	[0x05B0] = { unicodeslot=0x05B0, category='mn', adobename='afii57799', description='HEBREW POINT SHEVA' },
	[0x05B1] = { unicodeslot=0x05B1, category='mn', adobename='afii57801', description='HEBREW POINT HATAF SEGOL' },
	[0x05B2] = { unicodeslot=0x05B2, category='mn', adobename='afii57800', description='HEBREW POINT HATAF PATAH' },
	[0x05B3] = { unicodeslot=0x05B3, category='mn', adobename='afii57802', description='HEBREW POINT HATAF QAMATS' },
	[0x05B4] = { unicodeslot=0x05B4, category='mn', adobename='afii57793', description='HEBREW POINT HIRIQ' },
	[0x05B5] = { unicodeslot=0x05B5, category='mn', adobename='afii57794', description='HEBREW POINT TSERE' },
	[0x05B6] = { unicodeslot=0x05B6, category='mn', adobename='afii57795', description='HEBREW POINT SEGOL' },
	[0x05B7] = { unicodeslot=0x05B7, category='mn', adobename='afii57798', description='HEBREW POINT PATAH' },
	[0x05B8] = { unicodeslot=0x05B8, category='mn', adobename='afii57797', description='HEBREW POINT QAMATS' },
	[0x05B9] = { unicodeslot=0x05B9, category='mn', adobename='afii57806', description='HEBREW POINT HOLAM' },
	[0x05BA] = { unicodeslot=0x05BA, category='mn', description='HEBREW POINT HOLAM HASER FOR VAV' },
	[0x05BB] = { unicodeslot=0x05BB, category='mn', adobename='afii57796', description='HEBREW POINT QUBUTS' },
	[0x05BC] = { unicodeslot=0x05BC, category='mn', adobename='afii57807', description='HEBREW POINT DAGESH OR MAPIQ' },
	[0x05BD] = { unicodeslot=0x05BD, category='mn', adobename='afii57839', description='HEBREW POINT METEG' },
	[0x05BE] = { unicodeslot=0x05BE, category='po', adobename='afii57645', description='HEBREW PUNCTUATION MAQAF' },
	[0x05BF] = { unicodeslot=0x05BF, category='mn', adobename='afii57841', description='HEBREW POINT RAFE' },
	[0x05C0] = { unicodeslot=0x05C0, category='po', adobename='afii57842', description='HEBREW PUNCTUATION PASEQ' },
	[0x05C1] = { unicodeslot=0x05C1, category='mn', adobename='afii57804', description='HEBREW POINT SHIN DOT' },
	[0x05C2] = { unicodeslot=0x05C2, category='mn', adobename='afii57803', description='HEBREW POINT SIN DOT' },
	[0x05C3] = { unicodeslot=0x05C3, category='po', adobename='afii57658', description='HEBREW PUNCTUATION SOF PASUQ' },
	[0x05C4] = { unicodeslot=0x05C4, category='mn', description='HEBREW MARK UPPER DOT' },
	[0x05C5] = { unicodeslot=0x05C5, category='mn', description='HEBREW MARK LOWER DOT' },
	[0x05C6] = { unicodeslot=0x05C6, category='po', description='HEBREW PUNCTUATION NUN HAFUKHA' },
	[0x05C7] = { unicodeslot=0x05C7, category='mn', description='HEBREW POINT QAMATS QATAN' },
	[0x05D0] = { unicodeslot=0x05D0, category='lo', adobename='afii57664', contextname='hebrewAlef', description='HEBREW LETTER ALEF' },
	[0x05D1] = { unicodeslot=0x05D1, category='lo', adobename='afii57665', contextname='hebrewBet', description='HEBREW LETTER BET' },
	[0x05D2] = { unicodeslot=0x05D2, category='lo', adobename='afii57666', contextname='hebrewGimel', description='HEBREW LETTER GIMEL' },
	[0x05D3] = { unicodeslot=0x05D3, category='lo', adobename='afii57667', contextname='hebrewDalet', description='HEBREW LETTER DALET' },
	[0x05D4] = { unicodeslot=0x05D4, category='lo', adobename='afii57668', contextname='hebrewHe', description='HEBREW LETTER HE' },
	[0x05D5] = { unicodeslot=0x05D5, category='lo', adobename='afii57669', contextname='hebrewVav', description='HEBREW LETTER VAV' },
	[0x05D6] = { unicodeslot=0x05D6, category='lo', adobename='afii57670', contextname='hebrewZayin', description='HEBREW LETTER ZAYIN' },
	[0x05D7] = { unicodeslot=0x05D7, category='lo', adobename='afii57671', contextname='hebrewHet', description='HEBREW LETTER HET' },
	[0x05D8] = { unicodeslot=0x05D8, category='lo', adobename='afii57672', contextname='hebrewTet', description='HEBREW LETTER TET' },
	[0x05D9] = { unicodeslot=0x05D9, category='lo', adobename='afii57673', contextname='hebrewYod', description='HEBREW LETTER YOD' },
	[0x05DA] = { unicodeslot=0x05DA, category='lo', adobename='afii57674', contextname='hebrewKaffinal', description='HEBREW LETTER FINAL KAF' },
	[0x05DB] = { unicodeslot=0x05DB, category='lo', adobename='afii57675', contextname='hebrewKaf', description='HEBREW LETTER KAF' },
	[0x05DC] = { unicodeslot=0x05DC, category='lo', adobename='afii57676', contextname='hebrewLamed', description='HEBREW LETTER LAMED' },
	[0x05DD] = { unicodeslot=0x05DD, category='lo', adobename='afii57677', contextname='hebrewMemfinal', description='HEBREW LETTER FINAL MEM' },
	[0x05DE] = { unicodeslot=0x05DE, category='lo', adobename='afii57678', contextname='hebrewMem', description='HEBREW LETTER MEM' },
	[0x05DF] = { unicodeslot=0x05DF, category='lo', adobename='afii57679', contextname='hebrewNunfinal', description='HEBREW LETTER FINAL NUN' },
	[0x05E0] = { unicodeslot=0x05E0, category='lo', adobename='afii57680', contextname='hebrewNun', description='HEBREW LETTER NUN' },
	[0x05E1] = { unicodeslot=0x05E1, category='lo', adobename='afii57681', contextname='hebrewSamekh', description='HEBREW LETTER SAMEKH' },
	[0x05E2] = { unicodeslot=0x05E2, category='lo', adobename='afii57682', contextname='hebrewAyin', description='HEBREW LETTER AYIN' },
	[0x05E3] = { unicodeslot=0x05E3, category='lo', adobename='afii57683', contextname='hebrewPefinal', description='HEBREW LETTER FINAL PE' },
	[0x05E4] = { unicodeslot=0x05E4, category='lo', adobename='afii57684', contextname='hebrewPe', description='HEBREW LETTER PE' },
	[0x05E5] = { unicodeslot=0x05E5, category='lo', adobename='afii57685', contextname='hebrewTsadifinal', description='HEBREW LETTER FINAL TSADI' },
	[0x05E6] = { unicodeslot=0x05E6, category='lo', adobename='afii57686', contextname='hebrewTsadi', description='HEBREW LETTER TSADI' },
	[0x05E7] = { unicodeslot=0x05E7, category='lo', adobename='afii57687', contextname='hebrewQof', description='HEBREW LETTER QOF' },
	[0x05E8] = { unicodeslot=0x05E8, category='lo', adobename='afii57688', contextname='hebrewResh', description='HEBREW LETTER RESH' },
	[0x05E9] = { unicodeslot=0x05E9, category='lo', adobename='afii57689', contextname='hebrewShin', description='HEBREW LETTER SHIN' },
	[0x05EA] = { unicodeslot=0x05EA, category='lo', adobename='afii57690', contextname='hebrewTav', description='HEBREW LETTER TAV' },
	[0x05F0] = { unicodeslot=0x05F0, category='lo', adobename='afii57716', description='HEBREW LIGATURE YIDDISH DOUBLE VAV' },
	[0x05F1] = { unicodeslot=0x05F1, category='lo', adobename='afii57717', description='HEBREW LIGATURE YIDDISH VAV YOD' },
	[0x05F2] = { unicodeslot=0x05F2, category='lo', adobename='afii57718', description='HEBREW LIGATURE YIDDISH DOUBLE YOD' },
	[0x05F3] = { unicodeslot=0x05F3, category='po', description='HEBREW PUNCTUATION GERESH' },
	[0x05F4] = { unicodeslot=0x05F4, category='po', description='HEBREW PUNCTUATION GERSHAYIM' },
	[0x0600] = { unicodeslot=0x0600, category='cf', description='ARABIC NUMBER SIGN' },
	[0x0601] = { unicodeslot=0x0601, category='cf', description='ARABIC SIGN SANAH' },
	[0x0602] = { unicodeslot=0x0602, category='cf', description='ARABIC FOOTNOTE MARKER' },
	[0x0603] = { unicodeslot=0x0603, category='cf', description='ARABIC SIGN SAFHA' },
	[0x060B] = { unicodeslot=0x060B, category='sc', description='AFGHANI SIGN' },
	[0x060C] = { unicodeslot=0x060C, category='po', adobename='afii57388', description='ARABIC COMMA' },
	[0x060D] = { unicodeslot=0x060D, category='po', description='ARABIC DATE SEPARATOR' },
	[0x060E] = { unicodeslot=0x060E, category='so', description='ARABIC POETIC VERSE SIGN' },
	[0x060F] = { unicodeslot=0x060F, category='so', description='ARABIC SIGN MISRA' },
	[0x0610] = { unicodeslot=0x0610, category='mn', description='ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM' },
	[0x0611] = { unicodeslot=0x0611, category='mn', description='ARABIC SIGN ALAYHE ASSALLAM' },
	[0x0612] = { unicodeslot=0x0612, category='mn', description='ARABIC SIGN RAHMATULLAH ALAYHE' },
	[0x0613] = { unicodeslot=0x0613, category='mn', description='ARABIC SIGN RADI ALLAHOU ANHU' },
	[0x0614] = { unicodeslot=0x0614, category='mn', description='ARABIC SIGN TAKHALLUS' },
	[0x0615] = { unicodeslot=0x0615, category='mn', description='ARABIC SMALL HIGH TAH' },
	[0x061B] = { unicodeslot=0x061B, category='po', adobename='afii57403', description='ARABIC SEMICOLON' },
	[0x061E] = { unicodeslot=0x061E, category='po', description='ARABIC TRIPLE DOT PUNCTUATION MARK' },
	[0x061F] = { unicodeslot=0x061F, category='po', adobename='afii57407', description='ARABIC QUESTION MARK' },
	[0x0621] = { unicodeslot=0x0621, category='lo', adobename='afii57409', description='ARABIC LETTER HAMZA' },
	[0x0622] = { unicodeslot=0x0622, category='lo', adobename='afii57410', description='ARABIC LETTER ALEF WITH MADDA ABOVE', shcode=0x0627, specials={'char',0x0627,0x0653} },
	[0x0623] = { unicodeslot=0x0623, category='lo', adobename='afii57411', description='ARABIC LETTER ALEF WITH HAMZA ABOVE', shcode=0x0627, specials={'char',0x0627,0x0654} },
	[0x0624] = { unicodeslot=0x0624, category='lo', adobename='afii57412', description='ARABIC LETTER WAW WITH HAMZA ABOVE', shcode=0x0648, specials={'char',0x0648,0x0654} },
	[0x0625] = { unicodeslot=0x0625, category='lo', adobename='afii57413', description='ARABIC LETTER ALEF WITH HAMZA BELOW', shcode=0x0627, specials={'char',0x0627,0x0655} },
	[0x0626] = { unicodeslot=0x0626, category='lo', adobename='afii57414', description='ARABIC LETTER YEH WITH HAMZA ABOVE', shcode=0x064A, specials={'char',0x064A,0x0654} },
	[0x0627] = { unicodeslot=0x0627, category='lo', adobename='afii57415', description='ARABIC LETTER ALEF' },
	[0x0628] = { unicodeslot=0x0628, category='lo', adobename='afii57416', description='ARABIC LETTER BEH' },
	[0x0629] = { unicodeslot=0x0629, category='lo', adobename='afii57417', description='ARABIC LETTER TEH MARBUTA' },
	[0x062A] = { unicodeslot=0x062A, category='lo', adobename='afii57418', description='ARABIC LETTER TEH' },
	[0x062B] = { unicodeslot=0x062B, category='lo', adobename='afii57419', description='ARABIC LETTER THEH' },
	[0x062C] = { unicodeslot=0x062C, category='lo', adobename='afii57420', description='ARABIC LETTER JEEM' },
	[0x062D] = { unicodeslot=0x062D, category='lo', adobename='afii57421', description='ARABIC LETTER HAH' },
	[0x062E] = { unicodeslot=0x062E, category='lo', adobename='afii57422', description='ARABIC LETTER KHAH' },
	[0x062F] = { unicodeslot=0x062F, category='lo', adobename='afii57423', description='ARABIC LETTER DAL' },
	[0x0630] = { unicodeslot=0x0630, category='lo', adobename='afii57424', description='ARABIC LETTER THAL' },
	[0x0631] = { unicodeslot=0x0631, category='lo', adobename='afii57425', description='ARABIC LETTER REH' },
	[0x0632] = { unicodeslot=0x0632, category='lo', adobename='afii57426', description='ARABIC LETTER ZAIN' },
	[0x0633] = { unicodeslot=0x0633, category='lo', adobename='afii57427', description='ARABIC LETTER SEEN' },
	[0x0634] = { unicodeslot=0x0634, category='lo', adobename='afii57428', description='ARABIC LETTER SHEEN' },
	[0x0635] = { unicodeslot=0x0635, category='lo', adobename='afii57429', description='ARABIC LETTER SAD' },
	[0x0636] = { unicodeslot=0x0636, category='lo', adobename='afii57430', description='ARABIC LETTER DAD' },
	[0x0637] = { unicodeslot=0x0637, category='lo', adobename='afii57431', description='ARABIC LETTER TAH' },
	[0x0638] = { unicodeslot=0x0638, category='lo', adobename='afii57432', description='ARABIC LETTER ZAH' },
	[0x0639] = { unicodeslot=0x0639, category='lo', adobename='afii57433', description='ARABIC LETTER AIN' },
	[0x063A] = { unicodeslot=0x063A, category='lo', adobename='afii57434', description='ARABIC LETTER GHAIN' },
	[0x0640] = { unicodeslot=0x0640, category='lm', adobename='afii57440', description='ARABIC TATWEEL' },
	[0x0641] = { unicodeslot=0x0641, category='lo', adobename='afii57441', description='ARABIC LETTER FEH' },
	[0x0642] = { unicodeslot=0x0642, category='lo', adobename='afii57442', description='ARABIC LETTER QAF' },
	[0x0643] = { unicodeslot=0x0643, category='lo', adobename='afii57443', description='ARABIC LETTER KAF' },
	[0x0644] = { unicodeslot=0x0644, category='lo', adobename='afii57444', description='ARABIC LETTER LAM' },
	[0x0645] = { unicodeslot=0x0645, category='lo', adobename='afii57445', description='ARABIC LETTER MEEM' },
	[0x0646] = { unicodeslot=0x0646, category='lo', adobename='afii57446', description='ARABIC LETTER NOON' },
	[0x0647] = { unicodeslot=0x0647, category='lo', adobename='afii57470', description='ARABIC LETTER HEH' },
	[0x0648] = { unicodeslot=0x0648, category='lo', adobename='afii57448', description='ARABIC LETTER WAW' },
	[0x0649] = { unicodeslot=0x0649, category='lo', adobename='afii57449', description='ARABIC LETTER ALEF MAKSURA' },
	[0x064A] = { unicodeslot=0x064A, category='lo', adobename='afii57450', description='ARABIC LETTER YEH' },
	[0x064B] = { unicodeslot=0x064B, category='mn', adobename='afii57451', description='ARABIC FATHATAN' },
	[0x064C] = { unicodeslot=0x064C, category='mn', adobename='afii57452', description='ARABIC DAMMATAN' },
	[0x064D] = { unicodeslot=0x064D, category='mn', adobename='afii57453', description='ARABIC KASRATAN' },
	[0x064E] = { unicodeslot=0x064E, category='mn', adobename='afii57454', description='ARABIC FATHA' },
	[0x064F] = { unicodeslot=0x064F, category='mn', adobename='afii57455', description='ARABIC DAMMA' },
	[0x0650] = { unicodeslot=0x0650, category='mn', adobename='afii57456', description='ARABIC KASRA' },
	[0x0651] = { unicodeslot=0x0651, category='mn', adobename='afii57457', description='ARABIC SHADDA' },
	[0x0652] = { unicodeslot=0x0652, category='mn', adobename='afii57458', description='ARABIC SUKUN' },
	[0x0653] = { unicodeslot=0x0653, category='mn', description='ARABIC MADDAH ABOVE' },
	[0x0654] = { unicodeslot=0x0654, category='mn', description='ARABIC HAMZA ABOVE' },
	[0x0655] = { unicodeslot=0x0655, category='mn', description='ARABIC HAMZA BELOW' },
	[0x0656] = { unicodeslot=0x0656, category='mn', description='ARABIC SUBSCRIPT ALEF' },
	[0x0657] = { unicodeslot=0x0657, category='mn', description='ARABIC INVERTED DAMMA' },
	[0x0658] = { unicodeslot=0x0658, category='mn', description='ARABIC MARK NOON GHUNNA' },
	[0x0659] = { unicodeslot=0x0659, category='mn', description='ARABIC ZWARAKAY' },
	[0x065A] = { unicodeslot=0x065A, category='mn', description='ARABIC VOWEL SIGN SMALL V ABOVE' },
	[0x065B] = { unicodeslot=0x065B, category='mn', description='ARABIC VOWEL SIGN INVERTED SMALL V ABOVE' },
	[0x065C] = { unicodeslot=0x065C, category='mn', description='ARABIC VOWEL SIGN DOT BELOW' },
	[0x065D] = { unicodeslot=0x065D, category='mn', description='ARABIC REVERSED DAMMA' },
	[0x065E] = { unicodeslot=0x065E, category='mn', description='ARABIC FATHA WITH TWO DOTS' },
	[0x0660] = { unicodeslot=0x0660, category='nd', adobename='afii57392', description='ARABIC-INDIC DIGIT ZERO' },
	[0x0661] = { unicodeslot=0x0661, category='nd', adobename='afii57393', description='ARABIC-INDIC DIGIT ONE' },
	[0x0662] = { unicodeslot=0x0662, category='nd', adobename='afii57394', description='ARABIC-INDIC DIGIT TWO' },
	[0x0663] = { unicodeslot=0x0663, category='nd', adobename='afii57395', description='ARABIC-INDIC DIGIT THREE' },
	[0x0664] = { unicodeslot=0x0664, category='nd', adobename='afii57396', description='ARABIC-INDIC DIGIT FOUR' },
	[0x0665] = { unicodeslot=0x0665, category='nd', adobename='afii57397', description='ARABIC-INDIC DIGIT FIVE' },
	[0x0666] = { unicodeslot=0x0666, category='nd', adobename='afii57398', description='ARABIC-INDIC DIGIT SIX' },
	[0x0667] = { unicodeslot=0x0667, category='nd', adobename='afii57399', description='ARABIC-INDIC DIGIT SEVEN' },
	[0x0668] = { unicodeslot=0x0668, category='nd', adobename='afii57400', description='ARABIC-INDIC DIGIT EIGHT' },
	[0x0669] = { unicodeslot=0x0669, category='nd', adobename='afii57401', description='ARABIC-INDIC DIGIT NINE' },
	[0x066A] = { unicodeslot=0x066A, category='po', adobename='afii57381', description='ARABIC PERCENT SIGN' },
	[0x066B] = { unicodeslot=0x066B, category='po', description='ARABIC DECIMAL SEPARATOR' },
	[0x066C] = { unicodeslot=0x066C, category='po', description='ARABIC THOUSANDS SEPARATOR' },
	[0x066D] = { unicodeslot=0x066D, category='po', adobename='afii63167', description='ARABIC FIVE POINTED STAR' },
	[0x066E] = { unicodeslot=0x066E, category='lo', description='ARABIC LETTER DOTLESS BEH' },
	[0x066F] = { unicodeslot=0x066F, category='lo', description='ARABIC LETTER DOTLESS QAF' },
	[0x0670] = { unicodeslot=0x0670, category='mn', description='ARABIC LETTER SUPERSCRIPT ALEF' },
	[0x0671] = { unicodeslot=0x0671, category='lo', description='ARABIC LETTER ALEF WASLA' },
	[0x0672] = { unicodeslot=0x0672, category='lo', description='ARABIC LETTER ALEF WITH WAVY HAMZA ABOVE', shcode=0x0627 },
	[0x0673] = { unicodeslot=0x0673, category='lo', description='ARABIC LETTER ALEF WITH WAVY HAMZA BELOW', shcode=0x0627 },
	[0x0674] = { unicodeslot=0x0674, category='lo', description='ARABIC LETTER HIGH HAMZA' },
	[0x0675] = { unicodeslot=0x0675, category='lo', description='ARABIC LETTER HIGH HAMZA ALEF', specials={'compat',0x0627,0x0674} },
	[0x0676] = { unicodeslot=0x0676, category='lo', description='ARABIC LETTER HIGH HAMZA WAW', specials={'compat',0x0648,0x0674} },
	[0x0677] = { unicodeslot=0x0677, category='lo', description='ARABIC LETTER U WITH HAMZA ABOVE', shcode=0x06C7, specials={'compat',0x06C7,0x0674} },
	[0x0678] = { unicodeslot=0x0678, category='lo', description='ARABIC LETTER HIGH HAMZA YEH', specials={'compat',0x064A,0x0674} },
	[0x0679] = { unicodeslot=0x0679, category='lo', adobename='afii57511', description='ARABIC LETTER TTEH' },
	[0x067A] = { unicodeslot=0x067A, category='lo', description='ARABIC LETTER TTEHEH' },
	[0x067B] = { unicodeslot=0x067B, category='lo', description='ARABIC LETTER BEEH' },
	[0x067C] = { unicodeslot=0x067C, category='lo', description='ARABIC LETTER TEH WITH RING', shcode=0x062A },
	[0x067D] = { unicodeslot=0x067D, category='lo', description='ARABIC LETTER TEH WITH THREE DOTS ABOVE DOWNWARDS', shcode=0x062A },
	[0x067E] = { unicodeslot=0x067E, category='lo', adobename='afii57506', description='ARABIC LETTER PEH' },
	[0x067F] = { unicodeslot=0x067F, category='lo', description='ARABIC LETTER TEHEH' },
	[0x0680] = { unicodeslot=0x0680, category='lo', description='ARABIC LETTER BEHEH' },
	[0x0681] = { unicodeslot=0x0681, category='lo', description='ARABIC LETTER HAH WITH HAMZA ABOVE', shcode=0x062D },
	[0x0682] = { unicodeslot=0x0682, category='lo', description='ARABIC LETTER HAH WITH TWO DOTS VERTICAL ABOVE', shcode=0x062D },
	[0x0683] = { unicodeslot=0x0683, category='lo', description='ARABIC LETTER NYEH' },
	[0x0684] = { unicodeslot=0x0684, category='lo', description='ARABIC LETTER DYEH' },
	[0x0685] = { unicodeslot=0x0685, category='lo', description='ARABIC LETTER HAH WITH THREE DOTS ABOVE', shcode=0x062D },
	[0x0686] = { unicodeslot=0x0686, category='lo', adobename='afii57507', description='ARABIC LETTER TCHEH' },
	[0x0687] = { unicodeslot=0x0687, category='lo', description='ARABIC LETTER TCHEHEH' },
	[0x0688] = { unicodeslot=0x0688, category='lo', adobename='afii57512', description='ARABIC LETTER DDAL' },
	[0x0689] = { unicodeslot=0x0689, category='lo', description='ARABIC LETTER DAL WITH RING', shcode=0x062F },
	[0x068A] = { unicodeslot=0x068A, category='lo', description='ARABIC LETTER DAL WITH DOT BELOW', shcode=0x062F },
	[0x068B] = { unicodeslot=0x068B, category='lo', description='ARABIC LETTER DAL WITH DOT BELOW AND SMALL TAH', shcode=0x062F },
	[0x068C] = { unicodeslot=0x068C, category='lo', description='ARABIC LETTER DAHAL' },
	[0x068D] = { unicodeslot=0x068D, category='lo', description='ARABIC LETTER DDAHAL' },
	[0x068E] = { unicodeslot=0x068E, category='lo', description='ARABIC LETTER DUL' },
	[0x068F] = { unicodeslot=0x068F, category='lo', description='ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARDS', shcode=0x062F },
	[0x0690] = { unicodeslot=0x0690, category='lo', description='ARABIC LETTER DAL WITH FOUR DOTS ABOVE', shcode=0x062F },
	[0x0691] = { unicodeslot=0x0691, category='lo', adobename='afii57513', description='ARABIC LETTER RREH' },
	[0x0692] = { unicodeslot=0x0692, category='lo', description='ARABIC LETTER REH WITH SMALL V', shcode=0x0631 },
	[0x0693] = { unicodeslot=0x0693, category='lo', description='ARABIC LETTER REH WITH RING', shcode=0x0631 },
	[0x0694] = { unicodeslot=0x0694, category='lo', description='ARABIC LETTER REH WITH DOT BELOW', shcode=0x0631 },
	[0x0695] = { unicodeslot=0x0695, category='lo', description='ARABIC LETTER REH WITH SMALL V BELOW', shcode=0x0631 },
	[0x0696] = { unicodeslot=0x0696, category='lo', description='ARABIC LETTER REH WITH DOT BELOW AND DOT ABOVE', shcode=0x0631 },
	[0x0697] = { unicodeslot=0x0697, category='lo', description='ARABIC LETTER REH WITH TWO DOTS ABOVE', shcode=0x0631 },
	[0x0698] = { unicodeslot=0x0698, category='lo', adobename='afii57508', description='ARABIC LETTER JEH' },
	[0x0699] = { unicodeslot=0x0699, category='lo', description='ARABIC LETTER REH WITH FOUR DOTS ABOVE', shcode=0x0631 },
	[0x069A] = { unicodeslot=0x069A, category='lo', description='ARABIC LETTER SEEN WITH DOT BELOW AND DOT ABOVE', shcode=0x0633 },
	[0x069B] = { unicodeslot=0x069B, category='lo', description='ARABIC LETTER SEEN WITH THREE DOTS BELOW', shcode=0x0633 },
	[0x069C] = { unicodeslot=0x069C, category='lo', description='ARABIC LETTER SEEN WITH THREE DOTS BELOW AND THREE DOTS ABOVE', shcode=0x0633 },
	[0x069D] = { unicodeslot=0x069D, category='lo', description='ARABIC LETTER SAD WITH TWO DOTS BELOW', shcode=0x0635 },
	[0x069E] = { unicodeslot=0x069E, category='lo', description='ARABIC LETTER SAD WITH THREE DOTS ABOVE', shcode=0x0635 },
	[0x069F] = { unicodeslot=0x069F, category='lo', description='ARABIC LETTER TAH WITH THREE DOTS ABOVE', shcode=0x0637 },
	[0x06A0] = { unicodeslot=0x06A0, category='lo', description='ARABIC LETTER AIN WITH THREE DOTS ABOVE', shcode=0x0639 },
	[0x06A1] = { unicodeslot=0x06A1, category='lo', description='ARABIC LETTER DOTLESS FEH' },
	[0x06A2] = { unicodeslot=0x06A2, category='lo', description='ARABIC LETTER FEH WITH DOT MOVED BELOW', shcode=0x0641 },
	[0x06A3] = { unicodeslot=0x06A3, category='lo', description='ARABIC LETTER FEH WITH DOT BELOW', shcode=0x0641 },
	[0x06A4] = { unicodeslot=0x06A4, category='lo', adobename='afii57505', description='ARABIC LETTER VEH' },
	[0x06A5] = { unicodeslot=0x06A5, category='lo', description='ARABIC LETTER FEH WITH THREE DOTS BELOW', shcode=0x0641 },
	[0x06A6] = { unicodeslot=0x06A6, category='lo', description='ARABIC LETTER PEHEH' },
	[0x06A7] = { unicodeslot=0x06A7, category='lo', description='ARABIC LETTER QAF WITH DOT ABOVE', shcode=0x0642 },
	[0x06A8] = { unicodeslot=0x06A8, category='lo', description='ARABIC LETTER QAF WITH THREE DOTS ABOVE', shcode=0x0642 },
	[0x06A9] = { unicodeslot=0x06A9, category='lo', description='ARABIC LETTER KEHEH' },
	[0x06AA] = { unicodeslot=0x06AA, category='lo', description='ARABIC LETTER SWASH KAF' },
	[0x06AB] = { unicodeslot=0x06AB, category='lo', description='ARABIC LETTER KAF WITH RING', shcode=0x0643 },
	[0x06AC] = { unicodeslot=0x06AC, category='lo', description='ARABIC LETTER KAF WITH DOT ABOVE', shcode=0x0643 },
	[0x06AD] = { unicodeslot=0x06AD, category='lo', description='ARABIC LETTER NG' },
	[0x06AE] = { unicodeslot=0x06AE, category='lo', description='ARABIC LETTER KAF WITH THREE DOTS BELOW', shcode=0x0643 },
	[0x06AF] = { unicodeslot=0x06AF, category='lo', adobename='afii57509', description='ARABIC LETTER GAF' },
	[0x06B0] = { unicodeslot=0x06B0, category='lo', description='ARABIC LETTER GAF WITH RING', shcode=0x06AF },
	[0x06B1] = { unicodeslot=0x06B1, category='lo', description='ARABIC LETTER NGOEH' },
	[0x06B2] = { unicodeslot=0x06B2, category='lo', description='ARABIC LETTER GAF WITH TWO DOTS BELOW', shcode=0x06AF },
	[0x06B3] = { unicodeslot=0x06B3, category='lo', description='ARABIC LETTER GUEH' },
	[0x06B4] = { unicodeslot=0x06B4, category='lo', description='ARABIC LETTER GAF WITH THREE DOTS ABOVE', shcode=0x06AF },
	[0x06B5] = { unicodeslot=0x06B5, category='lo', description='ARABIC LETTER LAM WITH SMALL V', shcode=0x0644 },
	[0x06B6] = { unicodeslot=0x06B6, category='lo', description='ARABIC LETTER LAM WITH DOT ABOVE', shcode=0x0644 },
	[0x06B7] = { unicodeslot=0x06B7, category='lo', description='ARABIC LETTER LAM WITH THREE DOTS ABOVE', shcode=0x0644 },
	[0x06B8] = { unicodeslot=0x06B8, category='lo', description='ARABIC LETTER LAM WITH THREE DOTS BELOW', shcode=0x0644 },
	[0x06B9] = { unicodeslot=0x06B9, category='lo', description='ARABIC LETTER NOON WITH DOT BELOW', shcode=0x0646 },
	[0x06BA] = { unicodeslot=0x06BA, category='lo', adobename='afii57514', description='ARABIC LETTER NOON GHUNNA' },
	[0x06BB] = { unicodeslot=0x06BB, category='lo', description='ARABIC LETTER RNOON' },
	[0x06BC] = { unicodeslot=0x06BC, category='lo', description='ARABIC LETTER NOON WITH RING', shcode=0x0646 },
	[0x06BD] = { unicodeslot=0x06BD, category='lo', description='ARABIC LETTER NOON WITH THREE DOTS ABOVE', shcode=0x0646 },
	[0x06BE] = { unicodeslot=0x06BE, category='lo', description='ARABIC LETTER HEH DOACHASHMEE' },
	[0x06BF] = { unicodeslot=0x06BF, category='lo', description='ARABIC LETTER TCHEH WITH DOT ABOVE', shcode=0x0686 },
	[0x06C0] = { unicodeslot=0x06C0, category='lo', description='ARABIC LETTER HEH WITH YEH ABOVE', shcode=0x0647, specials={'char',0x06D5,0x0654} },
	[0x06C1] = { unicodeslot=0x06C1, category='lo', description='ARABIC LETTER HEH GOAL' },
	[0x06C2] = { unicodeslot=0x06C2, category='lo', description='ARABIC LETTER HEH GOAL WITH HAMZA ABOVE', specials={'char',0x06C1,0x0654} },
	[0x06C3] = { unicodeslot=0x06C3, category='lo', description='ARABIC LETTER TEH MARBUTA GOAL' },
	[0x06C4] = { unicodeslot=0x06C4, category='lo', description='ARABIC LETTER WAW WITH RING', shcode=0x0648 },
	[0x06C5] = { unicodeslot=0x06C5, category='lo', description='ARABIC LETTER KIRGHIZ OE' },
	[0x06C6] = { unicodeslot=0x06C6, category='lo', description='ARABIC LETTER OE' },
	[0x06C7] = { unicodeslot=0x06C7, category='lo', description='ARABIC LETTER U' },
	[0x06C8] = { unicodeslot=0x06C8, category='lo', description='ARABIC LETTER YU' },
	[0x06C9] = { unicodeslot=0x06C9, category='lo', description='ARABIC LETTER KIRGHIZ YU' },
	[0x06CA] = { unicodeslot=0x06CA, category='lo', description='ARABIC LETTER WAW WITH TWO DOTS ABOVE', shcode=0x0648 },
	[0x06CB] = { unicodeslot=0x06CB, category='lo', description='ARABIC LETTER VE' },
	[0x06CC] = { unicodeslot=0x06CC, category='lo', description='ARABIC LETTER FARSI YEH' },
	[0x06CD] = { unicodeslot=0x06CD, category='lo', description='ARABIC LETTER YEH WITH TAIL', shcode=0x064A },
	[0x06CE] = { unicodeslot=0x06CE, category='lo', description='ARABIC LETTER YEH WITH SMALL V', shcode=0x064A },
	[0x06CF] = { unicodeslot=0x06CF, category='lo', description='ARABIC LETTER WAW WITH DOT ABOVE', shcode=0x0648 },
	[0x06D0] = { unicodeslot=0x06D0, category='lo', description='ARABIC LETTER E' },
	[0x06D1] = { unicodeslot=0x06D1, category='lo', description='ARABIC LETTER YEH WITH THREE DOTS BELOW', shcode=0x064A },
	[0x06D2] = { unicodeslot=0x06D2, category='lo', adobename='afii57519', description='ARABIC LETTER YEH BARREE' },
	[0x06D3] = { unicodeslot=0x06D3, category='lo', description='ARABIC LETTER YEH BARREE WITH HAMZA ABOVE', specials={'char',0x06D2,0x0654} },
	[0x06D4] = { unicodeslot=0x06D4, category='po', description='ARABIC FULL STOP' },
	[0x06D5] = { unicodeslot=0x06D5, category='lo', adobename='afii57534', description='ARABIC LETTER AE' },
	[0x06D6] = { unicodeslot=0x06D6, category='mn', description='ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA' },
	[0x06D7] = { unicodeslot=0x06D7, category='mn', description='ARABIC SMALL HIGH LIGATURE QAF WITH LAM WITH ALEF MAKSURA' },
	[0x06D8] = { unicodeslot=0x06D8, category='mn', description='ARABIC SMALL HIGH MEEM INITIAL FORM' },
	[0x06D9] = { unicodeslot=0x06D9, category='mn', description='ARABIC SMALL HIGH LAM ALEF' },
	[0x06DA] = { unicodeslot=0x06DA, category='mn', description='ARABIC SMALL HIGH JEEM' },
	[0x06DB] = { unicodeslot=0x06DB, category='mn', description='ARABIC SMALL HIGH THREE DOTS' },
	[0x06DC] = { unicodeslot=0x06DC, category='mn', description='ARABIC SMALL HIGH SEEN' },
	[0x06DD] = { unicodeslot=0x06DD, category='cf', description='ARABIC END OF AYAH' },
	[0x06DE] = { unicodeslot=0x06DE, category='me', description='ARABIC START OF RUB EL HIZB' },
	[0x06DF] = { unicodeslot=0x06DF, category='mn', description='ARABIC SMALL HIGH ROUNDED ZERO' },
	[0x06E0] = { unicodeslot=0x06E0, category='mn', description='ARABIC SMALL HIGH UPRIGHT RECTANGULAR ZERO' },
	[0x06E1] = { unicodeslot=0x06E1, category='mn', description='ARABIC SMALL HIGH DOTLESS HEAD OF KHAH' },
	[0x06E2] = { unicodeslot=0x06E2, category='mn', description='ARABIC SMALL HIGH MEEM ISOLATED FORM' },
	[0x06E3] = { unicodeslot=0x06E3, category='mn', description='ARABIC SMALL LOW SEEN' },
	[0x06E4] = { unicodeslot=0x06E4, category='mn', description='ARABIC SMALL HIGH MADDA' },
	[0x06E5] = { unicodeslot=0x06E5, category='lm', description='ARABIC SMALL WAW' },
	[0x06E6] = { unicodeslot=0x06E6, category='lm', description='ARABIC SMALL YEH' },
	[0x06E7] = { unicodeslot=0x06E7, category='mn', description='ARABIC SMALL HIGH YEH' },
	[0x06E8] = { unicodeslot=0x06E8, category='mn', description='ARABIC SMALL HIGH NOON' },
	[0x06E9] = { unicodeslot=0x06E9, category='so', description='ARABIC PLACE OF SAJDAH' },
	[0x06EA] = { unicodeslot=0x06EA, category='mn', description='ARABIC EMPTY CENTRE LOW STOP' },
	[0x06EB] = { unicodeslot=0x06EB, category='mn', description='ARABIC EMPTY CENTRE HIGH STOP' },
	[0x06EC] = { unicodeslot=0x06EC, category='mn', description='ARABIC ROUNDED HIGH STOP WITH FILLED CENTRE' },
	[0x06ED] = { unicodeslot=0x06ED, category='mn', description='ARABIC SMALL LOW MEEM' },
	[0x06EE] = { unicodeslot=0x06EE, category='lo', description='ARABIC LETTER DAL WITH INVERTED V', shcode=0x062F },
	[0x06EF] = { unicodeslot=0x06EF, category='lo', description='ARABIC LETTER REH WITH INVERTED V', shcode=0x0631 },
	[0x06F0] = { unicodeslot=0x06F0, category='nd', description='EXTENDED ARABIC-INDIC DIGIT ZERO' },
	[0x06F1] = { unicodeslot=0x06F1, category='nd', description='EXTENDED ARABIC-INDIC DIGIT ONE' },
	[0x06F2] = { unicodeslot=0x06F2, category='nd', description='EXTENDED ARABIC-INDIC DIGIT TWO' },
	[0x06F3] = { unicodeslot=0x06F3, category='nd', description='EXTENDED ARABIC-INDIC DIGIT THREE' },
	[0x06F4] = { unicodeslot=0x06F4, category='nd', description='EXTENDED ARABIC-INDIC DIGIT FOUR' },
	[0x06F5] = { unicodeslot=0x06F5, category='nd', description='EXTENDED ARABIC-INDIC DIGIT FIVE' },
	[0x06F6] = { unicodeslot=0x06F6, category='nd', description='EXTENDED ARABIC-INDIC DIGIT SIX' },
	[0x06F7] = { unicodeslot=0x06F7, category='nd', description='EXTENDED ARABIC-INDIC DIGIT SEVEN' },
	[0x06F8] = { unicodeslot=0x06F8, category='nd', description='EXTENDED ARABIC-INDIC DIGIT EIGHT' },
	[0x06F9] = { unicodeslot=0x06F9, category='nd', description='EXTENDED ARABIC-INDIC DIGIT NINE' },
	[0x06FA] = { unicodeslot=0x06FA, category='lo', description='ARABIC LETTER SHEEN WITH DOT BELOW', shcode=0x0634 },
	[0x06FB] = { unicodeslot=0x06FB, category='lo', description='ARABIC LETTER DAD WITH DOT BELOW', shcode=0x0636 },
	[0x06FC] = { unicodeslot=0x06FC, category='lo', description='ARABIC LETTER GHAIN WITH DOT BELOW', shcode=0x063A },
	[0x06FD] = { unicodeslot=0x06FD, category='so', description='ARABIC SIGN SINDHI AMPERSAND' },
	[0x06FE] = { unicodeslot=0x06FE, category='so', description='ARABIC SIGN SINDHI POSTPOSITION MEN' },
	[0x06FF] = { unicodeslot=0x06FF, category='lo', description='ARABIC LETTER HEH WITH INVERTED V', shcode=0x0647 },
	[0x0700] = { unicodeslot=0x0700, category='po', description='SYRIAC END OF PARAGRAPH' },
	[0x0701] = { unicodeslot=0x0701, category='po', description='SYRIAC SUPRALINEAR FULL STOP' },
	[0x0702] = { unicodeslot=0x0702, category='po', description='SYRIAC SUBLINEAR FULL STOP' },
	[0x0703] = { unicodeslot=0x0703, category='po', description='SYRIAC SUPRALINEAR COLON' },
	[0x0704] = { unicodeslot=0x0704, category='po', description='SYRIAC SUBLINEAR COLON' },
	[0x0705] = { unicodeslot=0x0705, category='po', description='SYRIAC HORIZONTAL COLON' },
	[0x0706] = { unicodeslot=0x0706, category='po', description='SYRIAC COLON SKEWED LEFT' },
	[0x0707] = { unicodeslot=0x0707, category='po', description='SYRIAC COLON SKEWED RIGHT' },
	[0x0708] = { unicodeslot=0x0708, category='po', description='SYRIAC SUPRALINEAR COLON SKEWED LEFT' },
	[0x0709] = { unicodeslot=0x0709, category='po', description='SYRIAC SUBLINEAR COLON SKEWED RIGHT' },
	[0x070A] = { unicodeslot=0x070A, category='po', description='SYRIAC CONTRACTION' },
	[0x070B] = { unicodeslot=0x070B, category='po', description='SYRIAC HARKLEAN OBELUS' },
	[0x070C] = { unicodeslot=0x070C, category='po', description='SYRIAC HARKLEAN METOBELUS' },
	[0x070D] = { unicodeslot=0x070D, category='po', description='SYRIAC HARKLEAN ASTERISCUS' },
	[0x070F] = { unicodeslot=0x070F, category='cf', description='SYRIAC ABBREVIATION MARK' },
	[0x0710] = { unicodeslot=0x0710, category='lo', description='SYRIAC LETTER ALAPH' },
	[0x0711] = { unicodeslot=0x0711, category='mn', description='SYRIAC LETTER SUPERSCRIPT ALAPH' },
	[0x0712] = { unicodeslot=0x0712, category='lo', description='SYRIAC LETTER BETH' },
	[0x0713] = { unicodeslot=0x0713, category='lo', description='SYRIAC LETTER GAMAL' },
	[0x0714] = { unicodeslot=0x0714, category='lo', description='SYRIAC LETTER GAMAL GARSHUNI' },
	[0x0715] = { unicodeslot=0x0715, category='lo', description='SYRIAC LETTER DALATH' },
	[0x0716] = { unicodeslot=0x0716, category='lo', description='SYRIAC LETTER DOTLESS DALATH RISH' },
	[0x0717] = { unicodeslot=0x0717, category='lo', description='SYRIAC LETTER HE' },
	[0x0718] = { unicodeslot=0x0718, category='lo', description='SYRIAC LETTER WAW' },
	[0x0719] = { unicodeslot=0x0719, category='lo', description='SYRIAC LETTER ZAIN' },
	[0x071A] = { unicodeslot=0x071A, category='lo', description='SYRIAC LETTER HETH' },
	[0x071B] = { unicodeslot=0x071B, category='lo', description='SYRIAC LETTER TETH' },
	[0x071C] = { unicodeslot=0x071C, category='lo', description='SYRIAC LETTER TETH GARSHUNI' },
	[0x071D] = { unicodeslot=0x071D, category='lo', description='SYRIAC LETTER YUDH' },
	[0x071E] = { unicodeslot=0x071E, category='lo', description='SYRIAC LETTER YUDH HE' },
	[0x071F] = { unicodeslot=0x071F, category='lo', description='SYRIAC LETTER KAPH' },
	[0x0720] = { unicodeslot=0x0720, category='lo', description='SYRIAC LETTER LAMADH' },
	[0x0721] = { unicodeslot=0x0721, category='lo', description='SYRIAC LETTER MIM' },
	[0x0722] = { unicodeslot=0x0722, category='lo', description='SYRIAC LETTER NUN' },
	[0x0723] = { unicodeslot=0x0723, category='lo', description='SYRIAC LETTER SEMKATH' },
	[0x0724] = { unicodeslot=0x0724, category='lo', description='SYRIAC LETTER FINAL SEMKATH' },
	[0x0725] = { unicodeslot=0x0725, category='lo', description='SYRIAC LETTER E' },
	[0x0726] = { unicodeslot=0x0726, category='lo', description='SYRIAC LETTER PE' },
	[0x0727] = { unicodeslot=0x0727, category='lo', description='SYRIAC LETTER REVERSED PE' },
	[0x0728] = { unicodeslot=0x0728, category='lo', description='SYRIAC LETTER SADHE' },
	[0x0729] = { unicodeslot=0x0729, category='lo', description='SYRIAC LETTER QAPH' },
	[0x072A] = { unicodeslot=0x072A, category='lo', description='SYRIAC LETTER RISH' },
	[0x072B] = { unicodeslot=0x072B, category='lo', description='SYRIAC LETTER SHIN' },
	[0x072C] = { unicodeslot=0x072C, category='lo', description='SYRIAC LETTER TAW' },
	[0x072D] = { unicodeslot=0x072D, category='lo', description='SYRIAC LETTER PERSIAN BHETH' },
	[0x072E] = { unicodeslot=0x072E, category='lo', description='SYRIAC LETTER PERSIAN GHAMAL' },
	[0x072F] = { unicodeslot=0x072F, category='lo', description='SYRIAC LETTER PERSIAN DHALATH' },
	[0x0730] = { unicodeslot=0x0730, category='mn', description='SYRIAC PTHAHA ABOVE' },
	[0x0731] = { unicodeslot=0x0731, category='mn', description='SYRIAC PTHAHA BELOW' },
	[0x0732] = { unicodeslot=0x0732, category='mn', description='SYRIAC PTHAHA DOTTED' },
	[0x0733] = { unicodeslot=0x0733, category='mn', description='SYRIAC ZQAPHA ABOVE' },
	[0x0734] = { unicodeslot=0x0734, category='mn', description='SYRIAC ZQAPHA BELOW' },
	[0x0735] = { unicodeslot=0x0735, category='mn', description='SYRIAC ZQAPHA DOTTED' },
	[0x0736] = { unicodeslot=0x0736, category='mn', description='SYRIAC RBASA ABOVE' },
	[0x0737] = { unicodeslot=0x0737, category='mn', description='SYRIAC RBASA BELOW' },
	[0x0738] = { unicodeslot=0x0738, category='mn', description='SYRIAC DOTTED ZLAMA HORIZONTAL' },
	[0x0739] = { unicodeslot=0x0739, category='mn', description='SYRIAC DOTTED ZLAMA ANGULAR' },
	[0x073A] = { unicodeslot=0x073A, category='mn', description='SYRIAC HBASA ABOVE' },
	[0x073B] = { unicodeslot=0x073B, category='mn', description='SYRIAC HBASA BELOW' },
	[0x073C] = { unicodeslot=0x073C, category='mn', description='SYRIAC HBASA-ESASA DOTTED' },
	[0x073D] = { unicodeslot=0x073D, category='mn', description='SYRIAC ESASA ABOVE' },
	[0x073E] = { unicodeslot=0x073E, category='mn', description='SYRIAC ESASA BELOW' },
	[0x073F] = { unicodeslot=0x073F, category='mn', description='SYRIAC RWAHA' },
	[0x0740] = { unicodeslot=0x0740, category='mn', description='SYRIAC FEMININE DOT' },
	[0x0741] = { unicodeslot=0x0741, category='mn', description='SYRIAC QUSHSHAYA' },
	[0x0742] = { unicodeslot=0x0742, category='mn', description='SYRIAC RUKKAKHA' },
	[0x0743] = { unicodeslot=0x0743, category='mn', description='SYRIAC TWO VERTICAL DOTS ABOVE' },
	[0x0744] = { unicodeslot=0x0744, category='mn', description='SYRIAC TWO VERTICAL DOTS BELOW' },
	[0x0745] = { unicodeslot=0x0745, category='mn', description='SYRIAC THREE DOTS ABOVE' },
	[0x0746] = { unicodeslot=0x0746, category='mn', description='SYRIAC THREE DOTS BELOW' },
	[0x0747] = { unicodeslot=0x0747, category='mn', description='SYRIAC OBLIQUE LINE ABOVE' },
	[0x0748] = { unicodeslot=0x0748, category='mn', description='SYRIAC OBLIQUE LINE BELOW' },
	[0x0749] = { unicodeslot=0x0749, category='mn', description='SYRIAC MUSIC' },
	[0x074A] = { unicodeslot=0x074A, category='mn', description='SYRIAC BARREKH' },
	[0x074D] = { unicodeslot=0x074D, category='lo', description='SYRIAC LETTER SOGDIAN ZHAIN' },
	[0x074E] = { unicodeslot=0x074E, category='lo', description='SYRIAC LETTER SOGDIAN KHAPH' },
	[0x074F] = { unicodeslot=0x074F, category='lo', description='SYRIAC LETTER SOGDIAN FE' },
	[0x0750] = { unicodeslot=0x0750, category='lo', description='ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW', shcode=0x0628 },
	[0x0751] = { unicodeslot=0x0751, category='lo', description='ARABIC LETTER BEH WITH DOT BELOW AND THREE DOTS ABOVE', shcode=0x0628 },
	[0x0752] = { unicodeslot=0x0752, category='lo', description='ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW', shcode=0x0628 },
	[0x0753] = { unicodeslot=0x0753, category='lo', description='ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE', shcode=0x0628 },
	[0x0754] = { unicodeslot=0x0754, category='lo', description='ARABIC LETTER BEH WITH TWO DOTS BELOW AND DOT ABOVE', shcode=0x0628 },
	[0x0755] = { unicodeslot=0x0755, category='lo', description='ARABIC LETTER BEH WITH INVERTED SMALL V BELOW', shcode=0x0628 },
	[0x0756] = { unicodeslot=0x0756, category='lo', description='ARABIC LETTER BEH WITH SMALL V', shcode=0x0628 },
	[0x0757] = { unicodeslot=0x0757, category='lo', description='ARABIC LETTER HAH WITH TWO DOTS ABOVE', shcode=0x062D },
	[0x0758] = { unicodeslot=0x0758, category='lo', description='ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW', shcode=0x062D },
	[0x0759] = { unicodeslot=0x0759, category='lo', description='ARABIC LETTER DAL WITH TWO DOTS VERTICALLY BELOW AND SMALL TAH', shcode=0x062F },
	[0x075A] = { unicodeslot=0x075A, category='lo', description='ARABIC LETTER DAL WITH INVERTED SMALL V BELOW', shcode=0x062F },
	[0x075B] = { unicodeslot=0x075B, category='lo', description='ARABIC LETTER REH WITH STROKE', shcode=0x0631 },
	[0x075C] = { unicodeslot=0x075C, category='lo', description='ARABIC LETTER SEEN WITH FOUR DOTS ABOVE', shcode=0x0633 },
	[0x075D] = { unicodeslot=0x075D, category='lo', description='ARABIC LETTER AIN WITH TWO DOTS ABOVE', shcode=0x0639 },
	[0x075E] = { unicodeslot=0x075E, category='lo', description='ARABIC LETTER AIN WITH THREE DOTS POINTING DOWNWARDS ABOVE', shcode=0x0639 },
	[0x075F] = { unicodeslot=0x075F, category='lo', description='ARABIC LETTER AIN WITH TWO DOTS VERTICALLY ABOVE', shcode=0x0639 },
	[0x0760] = { unicodeslot=0x0760, category='lo', description='ARABIC LETTER FEH WITH TWO DOTS BELOW', shcode=0x0641 },
	[0x0761] = { unicodeslot=0x0761, category='lo', description='ARABIC LETTER FEH WITH THREE DOTS POINTING UPWARDS BELOW', shcode=0x0641 },
	[0x0762] = { unicodeslot=0x0762, category='lo', description='ARABIC LETTER KEHEH WITH DOT ABOVE', shcode=0x06A9 },
	[0x0763] = { unicodeslot=0x0763, category='lo', description='ARABIC LETTER KEHEH WITH THREE DOTS ABOVE', shcode=0x06A9 },
	[0x0764] = { unicodeslot=0x0764, category='lo', description='ARABIC LETTER KEHEH WITH THREE DOTS POINTING UPWARDS BELOW', shcode=0x06A9 },
	[0x0765] = { unicodeslot=0x0765, category='lo', description='ARABIC LETTER MEEM WITH DOT ABOVE', shcode=0x0645 },
	[0x0766] = { unicodeslot=0x0766, category='lo', description='ARABIC LETTER MEEM WITH DOT BELOW', shcode=0x0645 },
	[0x0767] = { unicodeslot=0x0767, category='lo', description='ARABIC LETTER NOON WITH TWO DOTS BELOW', shcode=0x0646 },
	[0x0768] = { unicodeslot=0x0768, category='lo', description='ARABIC LETTER NOON WITH SMALL TAH', shcode=0x0646 },
	[0x0769] = { unicodeslot=0x0769, category='lo', description='ARABIC LETTER NOON WITH SMALL V', shcode=0x0646 },
	[0x076A] = { unicodeslot=0x076A, category='lo', description='ARABIC LETTER LAM WITH BAR', shcode=0x0644 },
	[0x076B] = { unicodeslot=0x076B, category='lo', description='ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE', shcode=0x0631 },
	[0x076C] = { unicodeslot=0x076C, category='lo', description='ARABIC LETTER REH WITH HAMZA ABOVE', shcode=0x0631 },
	[0x076D] = { unicodeslot=0x076D, category='lo', description='ARABIC LETTER SEEN WITH TWO DOTS VERTICALLY ABOVE', shcode=0x0633 },
	[0x0780] = { unicodeslot=0x0780, category='lo', description='THAANA LETTER HAA' },
	[0x0781] = { unicodeslot=0x0781, category='lo', description='THAANA LETTER SHAVIYANI' },
	[0x0782] = { unicodeslot=0x0782, category='lo', description='THAANA LETTER NOONU' },
	[0x0783] = { unicodeslot=0x0783, category='lo', description='THAANA LETTER RAA' },
	[0x0784] = { unicodeslot=0x0784, category='lo', description='THAANA LETTER BAA' },
	[0x0785] = { unicodeslot=0x0785, category='lo', description='THAANA LETTER LHAVIYANI' },
	[0x0786] = { unicodeslot=0x0786, category='lo', description='THAANA LETTER KAAFU' },
	[0x0787] = { unicodeslot=0x0787, category='lo', description='THAANA LETTER ALIFU' },
	[0x0788] = { unicodeslot=0x0788, category='lo', description='THAANA LETTER VAAVU' },
	[0x0789] = { unicodeslot=0x0789, category='lo', description='THAANA LETTER MEEMU' },
	[0x078A] = { unicodeslot=0x078A, category='lo', description='THAANA LETTER FAAFU' },
	[0x078B] = { unicodeslot=0x078B, category='lo', description='THAANA LETTER DHAALU' },
	[0x078C] = { unicodeslot=0x078C, category='lo', description='THAANA LETTER THAA' },
	[0x078D] = { unicodeslot=0x078D, category='lo', description='THAANA LETTER LAAMU' },
	[0x078E] = { unicodeslot=0x078E, category='lo', description='THAANA LETTER GAAFU' },
	[0x078F] = { unicodeslot=0x078F, category='lo', description='THAANA LETTER GNAVIYANI' },
	[0x0790] = { unicodeslot=0x0790, category='lo', description='THAANA LETTER SEENU' },
	[0x0791] = { unicodeslot=0x0791, category='lo', description='THAANA LETTER DAVIYANI' },
	[0x0792] = { unicodeslot=0x0792, category='lo', description='THAANA LETTER ZAVIYANI' },
	[0x0793] = { unicodeslot=0x0793, category='lo', description='THAANA LETTER TAVIYANI' },
	[0x0794] = { unicodeslot=0x0794, category='lo', description='THAANA LETTER YAA' },
	[0x0795] = { unicodeslot=0x0795, category='lo', description='THAANA LETTER PAVIYANI' },
	[0x0796] = { unicodeslot=0x0796, category='lo', description='THAANA LETTER JAVIYANI' },
	[0x0797] = { unicodeslot=0x0797, category='lo', description='THAANA LETTER CHAVIYANI' },
	[0x0798] = { unicodeslot=0x0798, category='lo', description='THAANA LETTER TTAA' },
	[0x0799] = { unicodeslot=0x0799, category='lo', description='THAANA LETTER HHAA' },
	[0x079A] = { unicodeslot=0x079A, category='lo', description='THAANA LETTER KHAA' },
	[0x079B] = { unicodeslot=0x079B, category='lo', description='THAANA LETTER THAALU' },
	[0x079C] = { unicodeslot=0x079C, category='lo', description='THAANA LETTER ZAA' },
	[0x079D] = { unicodeslot=0x079D, category='lo', description='THAANA LETTER SHEENU' },
	[0x079E] = { unicodeslot=0x079E, category='lo', description='THAANA LETTER SAADHU' },
	[0x079F] = { unicodeslot=0x079F, category='lo', description='THAANA LETTER DAADHU' },
	[0x07A0] = { unicodeslot=0x07A0, category='lo', description='THAANA LETTER TO' },
	[0x07A1] = { unicodeslot=0x07A1, category='lo', description='THAANA LETTER ZO' },
	[0x07A2] = { unicodeslot=0x07A2, category='lo', description='THAANA LETTER AINU' },
	[0x07A3] = { unicodeslot=0x07A3, category='lo', description='THAANA LETTER GHAINU' },
	[0x07A4] = { unicodeslot=0x07A4, category='lo', description='THAANA LETTER QAAFU' },
	[0x07A5] = { unicodeslot=0x07A5, category='lo', description='THAANA LETTER WAAVU' },
	[0x07A6] = { unicodeslot=0x07A6, category='mn', description='THAANA ABAFILI' },
	[0x07A7] = { unicodeslot=0x07A7, category='mn', description='THAANA AABAAFILI' },
	[0x07A8] = { unicodeslot=0x07A8, category='mn', description='THAANA IBIFILI' },
	[0x07A9] = { unicodeslot=0x07A9, category='mn', description='THAANA EEBEEFILI' },
	[0x07AA] = { unicodeslot=0x07AA, category='mn', description='THAANA UBUFILI' },
	[0x07AB] = { unicodeslot=0x07AB, category='mn', description='THAANA OOBOOFILI' },
	[0x07AC] = { unicodeslot=0x07AC, category='mn', description='THAANA EBEFILI' },
	[0x07AD] = { unicodeslot=0x07AD, category='mn', description='THAANA EYBEYFILI' },
	[0x07AE] = { unicodeslot=0x07AE, category='mn', description='THAANA OBOFILI' },
	[0x07AF] = { unicodeslot=0x07AF, category='mn', description='THAANA OABOAFILI' },
	[0x07B0] = { unicodeslot=0x07B0, category='mn', description='THAANA SUKUN' },
	[0x07B1] = { unicodeslot=0x07B1, category='lo', description='THAANA LETTER NAA' },
	[0x07C0] = { unicodeslot=0x07C0, category='nd', description='NKO DIGIT ZERO' },
	[0x07C1] = { unicodeslot=0x07C1, category='nd', description='NKO DIGIT ONE' },
	[0x07C2] = { unicodeslot=0x07C2, category='nd', description='NKO DIGIT TWO' },
	[0x07C3] = { unicodeslot=0x07C3, category='nd', description='NKO DIGIT THREE' },
	[0x07C4] = { unicodeslot=0x07C4, category='nd', description='NKO DIGIT FOUR' },
	[0x07C5] = { unicodeslot=0x07C5, category='nd', description='NKO DIGIT FIVE' },
	[0x07C6] = { unicodeslot=0x07C6, category='nd', description='NKO DIGIT SIX' },
	[0x07C7] = { unicodeslot=0x07C7, category='nd', description='NKO DIGIT SEVEN' },
	[0x07C8] = { unicodeslot=0x07C8, category='nd', description='NKO DIGIT EIGHT' },
	[0x07C9] = { unicodeslot=0x07C9, category='nd', description='NKO DIGIT NINE' },
	[0x07CA] = { unicodeslot=0x07CA, category='lo', description='NKO LETTER A' },
	[0x07CB] = { unicodeslot=0x07CB, category='lo', description='NKO LETTER EE' },
	[0x07CC] = { unicodeslot=0x07CC, category='lo', description='NKO LETTER I' },
	[0x07CD] = { unicodeslot=0x07CD, category='lo', description='NKO LETTER E' },
	[0x07CE] = { unicodeslot=0x07CE, category='lo', description='NKO LETTER U' },
	[0x07CF] = { unicodeslot=0x07CF, category='lo', description='NKO LETTER OO' },
	[0x07D0] = { unicodeslot=0x07D0, category='lo', description='NKO LETTER O' },
	[0x07D1] = { unicodeslot=0x07D1, category='lo', description='NKO LETTER DAGBASINNA' },
	[0x07D2] = { unicodeslot=0x07D2, category='lo', description='NKO LETTER N' },
	[0x07D3] = { unicodeslot=0x07D3, category='lo', description='NKO LETTER BA' },
	[0x07D4] = { unicodeslot=0x07D4, category='lo', description='NKO LETTER PA' },
	[0x07D5] = { unicodeslot=0x07D5, category='lo', description='NKO LETTER TA' },
	[0x07D6] = { unicodeslot=0x07D6, category='lo', description='NKO LETTER JA' },
	[0x07D7] = { unicodeslot=0x07D7, category='lo', description='NKO LETTER CHA' },
	[0x07D8] = { unicodeslot=0x07D8, category='lo', description='NKO LETTER DA' },
	[0x07D9] = { unicodeslot=0x07D9, category='lo', description='NKO LETTER RA' },
	[0x07DA] = { unicodeslot=0x07DA, category='lo', description='NKO LETTER RRA' },
	[0x07DB] = { unicodeslot=0x07DB, category='lo', description='NKO LETTER SA' },
	[0x07DC] = { unicodeslot=0x07DC, category='lo', description='NKO LETTER GBA' },
	[0x07DD] = { unicodeslot=0x07DD, category='lo', description='NKO LETTER FA' },
	[0x07DE] = { unicodeslot=0x07DE, category='lo', description='NKO LETTER KA' },
	[0x07DF] = { unicodeslot=0x07DF, category='lo', description='NKO LETTER LA' },
	[0x07E0] = { unicodeslot=0x07E0, category='lo', description='NKO LETTER NA WOLOSO' },
	[0x07E1] = { unicodeslot=0x07E1, category='lo', description='NKO LETTER MA' },
	[0x07E2] = { unicodeslot=0x07E2, category='lo', description='NKO LETTER NYA' },
	[0x07E3] = { unicodeslot=0x07E3, category='lo', description='NKO LETTER NA' },
	[0x07E4] = { unicodeslot=0x07E4, category='lo', description='NKO LETTER HA' },
	[0x07E5] = { unicodeslot=0x07E5, category='lo', description='NKO LETTER WA' },
	[0x07E6] = { unicodeslot=0x07E6, category='lo', description='NKO LETTER YA' },
	[0x07E7] = { unicodeslot=0x07E7, category='lo', description='NKO LETTER NYA WOLOSO' },
	[0x07E8] = { unicodeslot=0x07E8, category='lo', description='NKO LETTER JONA JA' },
	[0x07E9] = { unicodeslot=0x07E9, category='lo', description='NKO LETTER JONA CHA' },
	[0x07EA] = { unicodeslot=0x07EA, category='lo', description='NKO LETTER JONA RA' },
	[0x07EB] = { unicodeslot=0x07EB, category='mn', description='NKO COMBINING SHORT HIGH TONE' },
	[0x07EC] = { unicodeslot=0x07EC, category='mn', description='NKO COMBINING SHORT LOW TONE' },
	[0x07ED] = { unicodeslot=0x07ED, category='mn', description='NKO COMBINING SHORT RISING TONE' },
	[0x07EE] = { unicodeslot=0x07EE, category='mn', description='NKO COMBINING LONG DESCENDING TONE' },
	[0x07EF] = { unicodeslot=0x07EF, category='mn', description='NKO COMBINING LONG HIGH TONE' },
	[0x07F0] = { unicodeslot=0x07F0, category='mn', description='NKO COMBINING LONG LOW TONE' },
	[0x07F1] = { unicodeslot=0x07F1, category='mn', description='NKO COMBINING LONG RISING TONE' },
	[0x07F2] = { unicodeslot=0x07F2, category='mn', description='NKO COMBINING NASALIZATION MARK' },
	[0x07F3] = { unicodeslot=0x07F3, category='mn', description='NKO COMBINING DOUBLE DOT ABOVE' },
	[0x07F4] = { unicodeslot=0x07F4, category='lm', description='NKO HIGH TONE APOSTROPHE' },
	[0x07F5] = { unicodeslot=0x07F5, category='lm', description='NKO LOW TONE APOSTROPHE' },
	[0x07F6] = { unicodeslot=0x07F6, category='so', description='NKO SYMBOL OO DENNEN' },
	[0x07F7] = { unicodeslot=0x07F7, category='po', description='NKO SYMBOL GBAKURUNEN' },
	[0x07F8] = { unicodeslot=0x07F8, category='po', description='NKO COMMA' },
	[0x07F9] = { unicodeslot=0x07F9, category='po', description='NKO EXCLAMATION MARK' },
	[0x07FA] = { unicodeslot=0x07FA, category='lm', description='NKO LAJANYALAN' },
	[0x0901] = { unicodeslot=0x0901, category='mn', description='DEVANAGARI SIGN CANDRABINDU' },
	[0x0902] = { unicodeslot=0x0902, category='mn', description='DEVANAGARI SIGN ANUSVARA' },
	[0x0903] = { unicodeslot=0x0903, category='mc', description='DEVANAGARI SIGN VISARGA' },
	[0x0904] = { unicodeslot=0x0904, category='lo', description='DEVANAGARI LETTER SHORT A' },
	[0x0905] = { unicodeslot=0x0905, category='lo', description='DEVANAGARI LETTER A' },
	[0x0906] = { unicodeslot=0x0906, category='lo', description='DEVANAGARI LETTER AA' },
	[0x0907] = { unicodeslot=0x0907, category='lo', description='DEVANAGARI LETTER I' },
	[0x0908] = { unicodeslot=0x0908, category='lo', description='DEVANAGARI LETTER II' },
	[0x0909] = { unicodeslot=0x0909, category='lo', description='DEVANAGARI LETTER U' },
	[0x090A] = { unicodeslot=0x090A, category='lo', description='DEVANAGARI LETTER UU' },
	[0x090B] = { unicodeslot=0x090B, category='lo', description='DEVANAGARI LETTER VOCALIC R' },
	[0x090C] = { unicodeslot=0x090C, category='lo', description='DEVANAGARI LETTER VOCALIC L' },
	[0x090D] = { unicodeslot=0x090D, category='lo', description='DEVANAGARI LETTER CANDRA E' },
	[0x090E] = { unicodeslot=0x090E, category='lo', description='DEVANAGARI LETTER SHORT E' },
	[0x090F] = { unicodeslot=0x090F, category='lo', description='DEVANAGARI LETTER E' },
	[0x0910] = { unicodeslot=0x0910, category='lo', description='DEVANAGARI LETTER AI' },
	[0x0911] = { unicodeslot=0x0911, category='lo', description='DEVANAGARI LETTER CANDRA O' },
	[0x0912] = { unicodeslot=0x0912, category='lo', description='DEVANAGARI LETTER SHORT O' },
	[0x0913] = { unicodeslot=0x0913, category='lo', description='DEVANAGARI LETTER O' },
	[0x0914] = { unicodeslot=0x0914, category='lo', description='DEVANAGARI LETTER AU' },
	[0x0915] = { unicodeslot=0x0915, category='lo', description='DEVANAGARI LETTER KA' },
	[0x0916] = { unicodeslot=0x0916, category='lo', description='DEVANAGARI LETTER KHA' },
	[0x0917] = { unicodeslot=0x0917, category='lo', description='DEVANAGARI LETTER GA' },
	[0x0918] = { unicodeslot=0x0918, category='lo', description='DEVANAGARI LETTER GHA' },
	[0x0919] = { unicodeslot=0x0919, category='lo', description='DEVANAGARI LETTER NGA' },
	[0x091A] = { unicodeslot=0x091A, category='lo', description='DEVANAGARI LETTER CA' },
	[0x091B] = { unicodeslot=0x091B, category='lo', description='DEVANAGARI LETTER CHA' },
	[0x091C] = { unicodeslot=0x091C, category='lo', description='DEVANAGARI LETTER JA' },
	[0x091D] = { unicodeslot=0x091D, category='lo', description='DEVANAGARI LETTER JHA' },
	[0x091E] = { unicodeslot=0x091E, category='lo', description='DEVANAGARI LETTER NYA' },
	[0x091F] = { unicodeslot=0x091F, category='lo', description='DEVANAGARI LETTER TTA' },
	[0x0920] = { unicodeslot=0x0920, category='lo', description='DEVANAGARI LETTER TTHA' },
	[0x0921] = { unicodeslot=0x0921, category='lo', description='DEVANAGARI LETTER DDA' },
	[0x0922] = { unicodeslot=0x0922, category='lo', description='DEVANAGARI LETTER DDHA' },
	[0x0923] = { unicodeslot=0x0923, category='lo', description='DEVANAGARI LETTER NNA' },
	[0x0924] = { unicodeslot=0x0924, category='lo', description='DEVANAGARI LETTER TA' },
	[0x0925] = { unicodeslot=0x0925, category='lo', description='DEVANAGARI LETTER THA' },
	[0x0926] = { unicodeslot=0x0926, category='lo', description='DEVANAGARI LETTER DA' },
	[0x0927] = { unicodeslot=0x0927, category='lo', description='DEVANAGARI LETTER DHA' },
	[0x0928] = { unicodeslot=0x0928, category='lo', description='DEVANAGARI LETTER NA' },
	[0x0929] = { unicodeslot=0x0929, category='lo', description='DEVANAGARI LETTER NNNA', specials={'char',0x0928,0x093C} },
	[0x092A] = { unicodeslot=0x092A, category='lo', description='DEVANAGARI LETTER PA' },
	[0x092B] = { unicodeslot=0x092B, category='lo', description='DEVANAGARI LETTER PHA' },
	[0x092C] = { unicodeslot=0x092C, category='lo', description='DEVANAGARI LETTER BA' },
	[0x092D] = { unicodeslot=0x092D, category='lo', description='DEVANAGARI LETTER BHA' },
	[0x092E] = { unicodeslot=0x092E, category='lo', description='DEVANAGARI LETTER MA' },
	[0x092F] = { unicodeslot=0x092F, category='lo', description='DEVANAGARI LETTER YA' },
	[0x0930] = { unicodeslot=0x0930, category='lo', description='DEVANAGARI LETTER RA' },
	[0x0931] = { unicodeslot=0x0931, category='lo', description='DEVANAGARI LETTER RRA', specials={'char',0x0930,0x093C} },
	[0x0932] = { unicodeslot=0x0932, category='lo', description='DEVANAGARI LETTER LA' },
	[0x0933] = { unicodeslot=0x0933, category='lo', description='DEVANAGARI LETTER LLA' },
	[0x0934] = { unicodeslot=0x0934, category='lo', description='DEVANAGARI LETTER LLLA', specials={'char',0x0933,0x093C} },
	[0x0935] = { unicodeslot=0x0935, category='lo', description='DEVANAGARI LETTER VA' },
	[0x0936] = { unicodeslot=0x0936, category='lo', description='DEVANAGARI LETTER SHA' },
	[0x0937] = { unicodeslot=0x0937, category='lo', description='DEVANAGARI LETTER SSA' },
	[0x0938] = { unicodeslot=0x0938, category='lo', description='DEVANAGARI LETTER SA' },
	[0x0939] = { unicodeslot=0x0939, category='lo', description='DEVANAGARI LETTER HA' },
	[0x093C] = { unicodeslot=0x093C, category='mn', description='DEVANAGARI SIGN NUKTA' },
	[0x093D] = { unicodeslot=0x093D, category='lo', description='DEVANAGARI SIGN AVAGRAHA' },
	[0x093E] = { unicodeslot=0x093E, category='mc', description='DEVANAGARI VOWEL SIGN AA' },
	[0x093F] = { unicodeslot=0x093F, category='mc', description='DEVANAGARI VOWEL SIGN I' },
	[0x0940] = { unicodeslot=0x0940, category='mc', description='DEVANAGARI VOWEL SIGN II' },
	[0x0941] = { unicodeslot=0x0941, category='mn', description='DEVANAGARI VOWEL SIGN U' },
	[0x0942] = { unicodeslot=0x0942, category='mn', description='DEVANAGARI VOWEL SIGN UU' },
	[0x0943] = { unicodeslot=0x0943, category='mn', description='DEVANAGARI VOWEL SIGN VOCALIC R' },
	[0x0944] = { unicodeslot=0x0944, category='mn', description='DEVANAGARI VOWEL SIGN VOCALIC RR' },
	[0x0945] = { unicodeslot=0x0945, category='mn', description='DEVANAGARI VOWEL SIGN CANDRA E' },
	[0x0946] = { unicodeslot=0x0946, category='mn', description='DEVANAGARI VOWEL SIGN SHORT E' },
	[0x0947] = { unicodeslot=0x0947, category='mn', description='DEVANAGARI VOWEL SIGN E' },
	[0x0948] = { unicodeslot=0x0948, category='mn', description='DEVANAGARI VOWEL SIGN AI' },
	[0x0949] = { unicodeslot=0x0949, category='mc', description='DEVANAGARI VOWEL SIGN CANDRA O' },
	[0x094A] = { unicodeslot=0x094A, category='mc', description='DEVANAGARI VOWEL SIGN SHORT O' },
	[0x094B] = { unicodeslot=0x094B, category='mc', description='DEVANAGARI VOWEL SIGN O' },
	[0x094C] = { unicodeslot=0x094C, category='mc', description='DEVANAGARI VOWEL SIGN AU' },
	[0x094D] = { unicodeslot=0x094D, category='mn', description='DEVANAGARI SIGN VIRAMA' },
	[0x0950] = { unicodeslot=0x0950, category='lo', description='DEVANAGARI OM' },
	[0x0951] = { unicodeslot=0x0951, category='mn', description='DEVANAGARI STRESS SIGN UDATTA' },
	[0x0952] = { unicodeslot=0x0952, category='mn', description='DEVANAGARI STRESS SIGN ANUDATTA' },
	[0x0953] = { unicodeslot=0x0953, category='mn', description='DEVANAGARI GRAVE ACCENT' },
	[0x0954] = { unicodeslot=0x0954, category='mn', description='DEVANAGARI ACUTE ACCENT' },
	[0x0958] = { unicodeslot=0x0958, category='lo', description='DEVANAGARI LETTER QA', specials={'char',0x0915,0x093C} },
	[0x0959] = { unicodeslot=0x0959, category='lo', description='DEVANAGARI LETTER KHHA', specials={'char',0x0916,0x093C} },
	[0x095A] = { unicodeslot=0x095A, category='lo', description='DEVANAGARI LETTER GHHA', specials={'char',0x0917,0x093C} },
	[0x095B] = { unicodeslot=0x095B, category='lo', description='DEVANAGARI LETTER ZA', specials={'char',0x091C,0x093C} },
	[0x095C] = { unicodeslot=0x095C, category='lo', description='DEVANAGARI LETTER DDDHA', specials={'char',0x0921,0x093C} },
	[0x095D] = { unicodeslot=0x095D, category='lo', description='DEVANAGARI LETTER RHA', specials={'char',0x0922,0x093C} },
	[0x095E] = { unicodeslot=0x095E, category='lo', description='DEVANAGARI LETTER FA', specials={'char',0x092B,0x093C} },
	[0x095F] = { unicodeslot=0x095F, category='lo', description='DEVANAGARI LETTER YYA', specials={'char',0x092F,0x093C} },
	[0x0960] = { unicodeslot=0x0960, category='lo', description='DEVANAGARI LETTER VOCALIC RR' },
	[0x0961] = { unicodeslot=0x0961, category='lo', description='DEVANAGARI LETTER VOCALIC LL' },
	[0x0962] = { unicodeslot=0x0962, category='mn', description='DEVANAGARI VOWEL SIGN VOCALIC L' },
	[0x0963] = { unicodeslot=0x0963, category='mn', description='DEVANAGARI VOWEL SIGN VOCALIC LL' },
	[0x0964] = { unicodeslot=0x0964, category='po', description='DEVANAGARI DANDA' },
	[0x0965] = { unicodeslot=0x0965, category='po', description='DEVANAGARI DOUBLE DANDA' },
	[0x0966] = { unicodeslot=0x0966, category='nd', description='DEVANAGARI DIGIT ZERO' },
	[0x0967] = { unicodeslot=0x0967, category='nd', description='DEVANAGARI DIGIT ONE' },
	[0x0968] = { unicodeslot=0x0968, category='nd', description='DEVANAGARI DIGIT TWO' },
	[0x0969] = { unicodeslot=0x0969, category='nd', description='DEVANAGARI DIGIT THREE' },
	[0x096A] = { unicodeslot=0x096A, category='nd', description='DEVANAGARI DIGIT FOUR' },
	[0x096B] = { unicodeslot=0x096B, category='nd', description='DEVANAGARI DIGIT FIVE' },
	[0x096C] = { unicodeslot=0x096C, category='nd', description='DEVANAGARI DIGIT SIX' },
	[0x096D] = { unicodeslot=0x096D, category='nd', description='DEVANAGARI DIGIT SEVEN' },
	[0x096E] = { unicodeslot=0x096E, category='nd', description='DEVANAGARI DIGIT EIGHT' },
	[0x096F] = { unicodeslot=0x096F, category='nd', description='DEVANAGARI DIGIT NINE' },
	[0x0970] = { unicodeslot=0x0970, category='po', description='DEVANAGARI ABBREVIATION SIGN' },
	[0x097B] = { unicodeslot=0x097B, category='lo', description='DEVANAGARI LETTER GGA' },
	[0x097C] = { unicodeslot=0x097C, category='lo', description='DEVANAGARI LETTER JJA' },
	[0x097D] = { unicodeslot=0x097D, category='lo', description='DEVANAGARI LETTER GLOTTAL STOP' },
	[0x097E] = { unicodeslot=0x097E, category='lo', description='DEVANAGARI LETTER DDDA' },
	[0x097F] = { unicodeslot=0x097F, category='lo', description='DEVANAGARI LETTER BBA' },
	[0x0981] = { unicodeslot=0x0981, category='mn', description='BENGALI SIGN CANDRABINDU' },
	[0x0982] = { unicodeslot=0x0982, category='mc', description='BENGALI SIGN ANUSVARA' },
	[0x0983] = { unicodeslot=0x0983, category='mc', description='BENGALI SIGN VISARGA' },
	[0x0985] = { unicodeslot=0x0985, category='lo', description='BENGALI LETTER A' },
	[0x0986] = { unicodeslot=0x0986, category='lo', description='BENGALI LETTER AA' },
	[0x0987] = { unicodeslot=0x0987, category='lo', description='BENGALI LETTER I' },
	[0x0988] = { unicodeslot=0x0988, category='lo', description='BENGALI LETTER II' },
	[0x0989] = { unicodeslot=0x0989, category='lo', description='BENGALI LETTER U' },
	[0x098A] = { unicodeslot=0x098A, category='lo', description='BENGALI LETTER UU' },
	[0x098B] = { unicodeslot=0x098B, category='lo', description='BENGALI LETTER VOCALIC R' },
	[0x098C] = { unicodeslot=0x098C, category='lo', description='BENGALI LETTER VOCALIC L' },
	[0x098F] = { unicodeslot=0x098F, category='lo', description='BENGALI LETTER E' },
	[0x0990] = { unicodeslot=0x0990, category='lo', description='BENGALI LETTER AI' },
	[0x0993] = { unicodeslot=0x0993, category='lo', description='BENGALI LETTER O' },
	[0x0994] = { unicodeslot=0x0994, category='lo', description='BENGALI LETTER AU' },
	[0x0995] = { unicodeslot=0x0995, category='lo', description='BENGALI LETTER KA' },
	[0x0996] = { unicodeslot=0x0996, category='lo', description='BENGALI LETTER KHA' },
	[0x0997] = { unicodeslot=0x0997, category='lo', description='BENGALI LETTER GA' },
	[0x0998] = { unicodeslot=0x0998, category='lo', description='BENGALI LETTER GHA' },
	[0x0999] = { unicodeslot=0x0999, category='lo', description='BENGALI LETTER NGA' },
	[0x099A] = { unicodeslot=0x099A, category='lo', description='BENGALI LETTER CA' },
	[0x099B] = { unicodeslot=0x099B, category='lo', description='BENGALI LETTER CHA' },
	[0x099C] = { unicodeslot=0x099C, category='lo', description='BENGALI LETTER JA' },
	[0x099D] = { unicodeslot=0x099D, category='lo', description='BENGALI LETTER JHA' },
	[0x099E] = { unicodeslot=0x099E, category='lo', description='BENGALI LETTER NYA' },
	[0x099F] = { unicodeslot=0x099F, category='lo', description='BENGALI LETTER TTA' },
	[0x09A0] = { unicodeslot=0x09A0, category='lo', description='BENGALI LETTER TTHA' },
	[0x09A1] = { unicodeslot=0x09A1, category='lo', description='BENGALI LETTER DDA' },
	[0x09A2] = { unicodeslot=0x09A2, category='lo', description='BENGALI LETTER DDHA' },
	[0x09A3] = { unicodeslot=0x09A3, category='lo', description='BENGALI LETTER NNA' },
	[0x09A4] = { unicodeslot=0x09A4, category='lo', description='BENGALI LETTER TA' },
	[0x09A5] = { unicodeslot=0x09A5, category='lo', description='BENGALI LETTER THA' },
	[0x09A6] = { unicodeslot=0x09A6, category='lo', description='BENGALI LETTER DA' },
	[0x09A7] = { unicodeslot=0x09A7, category='lo', description='BENGALI LETTER DHA' },
	[0x09A8] = { unicodeslot=0x09A8, category='lo', description='BENGALI LETTER NA' },
	[0x09AA] = { unicodeslot=0x09AA, category='lo', description='BENGALI LETTER PA' },
	[0x09AB] = { unicodeslot=0x09AB, category='lo', description='BENGALI LETTER PHA' },
	[0x09AC] = { unicodeslot=0x09AC, category='lo', description='BENGALI LETTER BA' },
	[0x09AD] = { unicodeslot=0x09AD, category='lo', description='BENGALI LETTER BHA' },
	[0x09AE] = { unicodeslot=0x09AE, category='lo', description='BENGALI LETTER MA' },
	[0x09AF] = { unicodeslot=0x09AF, category='lo', description='BENGALI LETTER YA' },
	[0x09B0] = { unicodeslot=0x09B0, category='lo', description='BENGALI LETTER RA' },
	[0x09B2] = { unicodeslot=0x09B2, category='lo', description='BENGALI LETTER LA' },
	[0x09B6] = { unicodeslot=0x09B6, category='lo', description='BENGALI LETTER SHA' },
	[0x09B7] = { unicodeslot=0x09B7, category='lo', description='BENGALI LETTER SSA' },
	[0x09B8] = { unicodeslot=0x09B8, category='lo', description='BENGALI LETTER SA' },
	[0x09B9] = { unicodeslot=0x09B9, category='lo', description='BENGALI LETTER HA' },
	[0x09BC] = { unicodeslot=0x09BC, category='mn', description='BENGALI SIGN NUKTA' },
	[0x09BD] = { unicodeslot=0x09BD, category='lo', description='BENGALI SIGN AVAGRAHA' },
	[0x09BE] = { unicodeslot=0x09BE, category='mc', description='BENGALI VOWEL SIGN AA' },
	[0x09BF] = { unicodeslot=0x09BF, category='mc', description='BENGALI VOWEL SIGN I' },
	[0x09C0] = { unicodeslot=0x09C0, category='mc', description='BENGALI VOWEL SIGN II' },
	[0x09C1] = { unicodeslot=0x09C1, category='mn', description='BENGALI VOWEL SIGN U' },
	[0x09C2] = { unicodeslot=0x09C2, category='mn', description='BENGALI VOWEL SIGN UU' },
	[0x09C3] = { unicodeslot=0x09C3, category='mn', description='BENGALI VOWEL SIGN VOCALIC R' },
	[0x09C4] = { unicodeslot=0x09C4, category='mn', description='BENGALI VOWEL SIGN VOCALIC RR' },
	[0x09C7] = { unicodeslot=0x09C7, category='mc', description='BENGALI VOWEL SIGN E' },
	[0x09C8] = { unicodeslot=0x09C8, category='mc', description='BENGALI VOWEL SIGN AI' },
	[0x09CB] = { unicodeslot=0x09CB, category='mc', description='BENGALI VOWEL SIGN O', specials={'char',0x09C7,0x09BE} },
	[0x09CC] = { unicodeslot=0x09CC, category='mc', description='BENGALI VOWEL SIGN AU', specials={'char',0x09C7,0x09D7} },
	[0x09CD] = { unicodeslot=0x09CD, category='mn', description='BENGALI SIGN VIRAMA' },
	[0x09CE] = { unicodeslot=0x09CE, category='lo', description='BENGALI LETTER KHANDA TA' },
	[0x09D7] = { unicodeslot=0x09D7, category='mc', description='BENGALI AU LENGTH MARK' },
	[0x09DC] = { unicodeslot=0x09DC, category='lo', description='BENGALI LETTER RRA', specials={'char',0x09A1,0x09BC} },
	[0x09DD] = { unicodeslot=0x09DD, category='lo', description='BENGALI LETTER RHA', specials={'char',0x09A2,0x09BC} },
	[0x09DF] = { unicodeslot=0x09DF, category='lo', description='BENGALI LETTER YYA', specials={'char',0x09AF,0x09BC} },
	[0x09E0] = { unicodeslot=0x09E0, category='lo', description='BENGALI LETTER VOCALIC RR' },
	[0x09E1] = { unicodeslot=0x09E1, category='lo', description='BENGALI LETTER VOCALIC LL' },
	[0x09E2] = { unicodeslot=0x09E2, category='mn', description='BENGALI VOWEL SIGN VOCALIC L' },
	[0x09E3] = { unicodeslot=0x09E3, category='mn', description='BENGALI VOWEL SIGN VOCALIC LL' },
	[0x09E6] = { unicodeslot=0x09E6, category='nd', description='BENGALI DIGIT ZERO' },
	[0x09E7] = { unicodeslot=0x09E7, category='nd', description='BENGALI DIGIT ONE' },
	[0x09E8] = { unicodeslot=0x09E8, category='nd', description='BENGALI DIGIT TWO' },
	[0x09E9] = { unicodeslot=0x09E9, category='nd', description='BENGALI DIGIT THREE' },
	[0x09EA] = { unicodeslot=0x09EA, category='nd', description='BENGALI DIGIT FOUR' },
	[0x09EB] = { unicodeslot=0x09EB, category='nd', description='BENGALI DIGIT FIVE' },
	[0x09EC] = { unicodeslot=0x09EC, category='nd', description='BENGALI DIGIT SIX' },
	[0x09ED] = { unicodeslot=0x09ED, category='nd', description='BENGALI DIGIT SEVEN' },
	[0x09EE] = { unicodeslot=0x09EE, category='nd', description='BENGALI DIGIT EIGHT' },
	[0x09EF] = { unicodeslot=0x09EF, category='nd', description='BENGALI DIGIT NINE' },
	[0x09F0] = { unicodeslot=0x09F0, category='lo', description='BENGALI LETTER RA WITH MIDDLE DIAGONAL', shcode=0x09B0 },
	[0x09F1] = { unicodeslot=0x09F1, category='lo', description='BENGALI LETTER RA WITH LOWER DIAGONAL', shcode=0x09B0 },
	[0x09F2] = { unicodeslot=0x09F2, category='sc', description='BENGALI RUPEE MARK' },
	[0x09F3] = { unicodeslot=0x09F3, category='sc', description='BENGALI RUPEE SIGN' },
	[0x09F4] = { unicodeslot=0x09F4, category='no', description='BENGALI CURRENCY NUMERATOR ONE' },
	[0x09F5] = { unicodeslot=0x09F5, category='no', description='BENGALI CURRENCY NUMERATOR TWO' },
	[0x09F6] = { unicodeslot=0x09F6, category='no', description='BENGALI CURRENCY NUMERATOR THREE' },
	[0x09F7] = { unicodeslot=0x09F7, category='no', description='BENGALI CURRENCY NUMERATOR FOUR' },
	[0x09F8] = { unicodeslot=0x09F8, category='no', description='BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR' },
	[0x09F9] = { unicodeslot=0x09F9, category='no', description='BENGALI CURRENCY DENOMINATOR SIXTEEN' },
	[0x09FA] = { unicodeslot=0x09FA, category='so', description='BENGALI ISSHAR' },
	[0x0A01] = { unicodeslot=0x0A01, category='mn', description='GURMUKHI SIGN ADAK BINDI' },
	[0x0A02] = { unicodeslot=0x0A02, category='mn', description='GURMUKHI SIGN BINDI' },
	[0x0A03] = { unicodeslot=0x0A03, category='mc', description='GURMUKHI SIGN VISARGA' },
	[0x0A05] = { unicodeslot=0x0A05, category='lo', description='GURMUKHI LETTER A' },
	[0x0A06] = { unicodeslot=0x0A06, category='lo', description='GURMUKHI LETTER AA' },
	[0x0A07] = { unicodeslot=0x0A07, category='lo', description='GURMUKHI LETTER I' },
	[0x0A08] = { unicodeslot=0x0A08, category='lo', description='GURMUKHI LETTER II' },
	[0x0A09] = { unicodeslot=0x0A09, category='lo', description='GURMUKHI LETTER U' },
	[0x0A0A] = { unicodeslot=0x0A0A, category='lo', description='GURMUKHI LETTER UU' },
	[0x0A0F] = { unicodeslot=0x0A0F, category='lo', description='GURMUKHI LETTER EE' },
	[0x0A10] = { unicodeslot=0x0A10, category='lo', description='GURMUKHI LETTER AI' },
	[0x0A13] = { unicodeslot=0x0A13, category='lo', description='GURMUKHI LETTER OO' },
	[0x0A14] = { unicodeslot=0x0A14, category='lo', description='GURMUKHI LETTER AU' },
	[0x0A15] = { unicodeslot=0x0A15, category='lo', description='GURMUKHI LETTER KA' },
	[0x0A16] = { unicodeslot=0x0A16, category='lo', description='GURMUKHI LETTER KHA' },
	[0x0A17] = { unicodeslot=0x0A17, category='lo', description='GURMUKHI LETTER GA' },
	[0x0A18] = { unicodeslot=0x0A18, category='lo', description='GURMUKHI LETTER GHA' },
	[0x0A19] = { unicodeslot=0x0A19, category='lo', description='GURMUKHI LETTER NGA' },
	[0x0A1A] = { unicodeslot=0x0A1A, category='lo', description='GURMUKHI LETTER CA' },
	[0x0A1B] = { unicodeslot=0x0A1B, category='lo', description='GURMUKHI LETTER CHA' },
	[0x0A1C] = { unicodeslot=0x0A1C, category='lo', description='GURMUKHI LETTER JA' },
	[0x0A1D] = { unicodeslot=0x0A1D, category='lo', description='GURMUKHI LETTER JHA' },
	[0x0A1E] = { unicodeslot=0x0A1E, category='lo', description='GURMUKHI LETTER NYA' },
	[0x0A1F] = { unicodeslot=0x0A1F, category='lo', description='GURMUKHI LETTER TTA' },
	[0x0A20] = { unicodeslot=0x0A20, category='lo', description='GURMUKHI LETTER TTHA' },
	[0x0A21] = { unicodeslot=0x0A21, category='lo', description='GURMUKHI LETTER DDA' },
	[0x0A22] = { unicodeslot=0x0A22, category='lo', description='GURMUKHI LETTER DDHA' },
	[0x0A23] = { unicodeslot=0x0A23, category='lo', description='GURMUKHI LETTER NNA' },
	[0x0A24] = { unicodeslot=0x0A24, category='lo', description='GURMUKHI LETTER TA' },
	[0x0A25] = { unicodeslot=0x0A25, category='lo', description='GURMUKHI LETTER THA' },
	[0x0A26] = { unicodeslot=0x0A26, category='lo', description='GURMUKHI LETTER DA' },
	[0x0A27] = { unicodeslot=0x0A27, category='lo', description='GURMUKHI LETTER DHA' },
	[0x0A28] = { unicodeslot=0x0A28, category='lo', description='GURMUKHI LETTER NA' },
	[0x0A2A] = { unicodeslot=0x0A2A, category='lo', description='GURMUKHI LETTER PA' },
	[0x0A2B] = { unicodeslot=0x0A2B, category='lo', description='GURMUKHI LETTER PHA' },
	[0x0A2C] = { unicodeslot=0x0A2C, category='lo', description='GURMUKHI LETTER BA' },
	[0x0A2D] = { unicodeslot=0x0A2D, category='lo', description='GURMUKHI LETTER BHA' },
	[0x0A2E] = { unicodeslot=0x0A2E, category='lo', description='GURMUKHI LETTER MA' },
	[0x0A2F] = { unicodeslot=0x0A2F, category='lo', description='GURMUKHI LETTER YA' },
	[0x0A30] = { unicodeslot=0x0A30, category='lo', description='GURMUKHI LETTER RA' },
	[0x0A32] = { unicodeslot=0x0A32, category='lo', description='GURMUKHI LETTER LA' },
	[0x0A33] = { unicodeslot=0x0A33, category='lo', description='GURMUKHI LETTER LLA', specials={'char',0x0A32,0x0A3C} },
	[0x0A35] = { unicodeslot=0x0A35, category='lo', description='GURMUKHI LETTER VA' },
	[0x0A36] = { unicodeslot=0x0A36, category='lo', description='GURMUKHI LETTER SHA', specials={'char',0x0A38,0x0A3C} },
	[0x0A38] = { unicodeslot=0x0A38, category='lo', description='GURMUKHI LETTER SA' },
	[0x0A39] = { unicodeslot=0x0A39, category='lo', description='GURMUKHI LETTER HA' },
	[0x0A3C] = { unicodeslot=0x0A3C, category='mn', description='GURMUKHI SIGN NUKTA' },
	[0x0A3E] = { unicodeslot=0x0A3E, category='mc', description='GURMUKHI VOWEL SIGN AA' },
	[0x0A3F] = { unicodeslot=0x0A3F, category='mc', description='GURMUKHI VOWEL SIGN I' },
	[0x0A40] = { unicodeslot=0x0A40, category='mc', description='GURMUKHI VOWEL SIGN II' },
	[0x0A41] = { unicodeslot=0x0A41, category='mn', description='GURMUKHI VOWEL SIGN U' },
	[0x0A42] = { unicodeslot=0x0A42, category='mn', description='GURMUKHI VOWEL SIGN UU' },
	[0x0A47] = { unicodeslot=0x0A47, category='mn', description='GURMUKHI VOWEL SIGN EE' },
	[0x0A48] = { unicodeslot=0x0A48, category='mn', description='GURMUKHI VOWEL SIGN AI' },
	[0x0A4B] = { unicodeslot=0x0A4B, category='mn', description='GURMUKHI VOWEL SIGN OO' },
	[0x0A4C] = { unicodeslot=0x0A4C, category='mn', description='GURMUKHI VOWEL SIGN AU' },
	[0x0A4D] = { unicodeslot=0x0A4D, category='mn', description='GURMUKHI SIGN VIRAMA' },
	[0x0A59] = { unicodeslot=0x0A59, category='lo', description='GURMUKHI LETTER KHHA', specials={'char',0x0A16,0x0A3C} },
	[0x0A5A] = { unicodeslot=0x0A5A, category='lo', description='GURMUKHI LETTER GHHA', specials={'char',0x0A17,0x0A3C} },
	[0x0A5B] = { unicodeslot=0x0A5B, category='lo', description='GURMUKHI LETTER ZA', specials={'char',0x0A1C,0x0A3C} },
	[0x0A5C] = { unicodeslot=0x0A5C, category='lo', description='GURMUKHI LETTER RRA' },
	[0x0A5E] = { unicodeslot=0x0A5E, category='lo', description='GURMUKHI LETTER FA', specials={'char',0x0A2B,0x0A3C} },
	[0x0A66] = { unicodeslot=0x0A66, category='nd', description='GURMUKHI DIGIT ZERO' },
	[0x0A67] = { unicodeslot=0x0A67, category='nd', description='GURMUKHI DIGIT ONE' },
	[0x0A68] = { unicodeslot=0x0A68, category='nd', description='GURMUKHI DIGIT TWO' },
	[0x0A69] = { unicodeslot=0x0A69, category='nd', description='GURMUKHI DIGIT THREE' },
	[0x0A6A] = { unicodeslot=0x0A6A, category='nd', description='GURMUKHI DIGIT FOUR' },
	[0x0A6B] = { unicodeslot=0x0A6B, category='nd', description='GURMUKHI DIGIT FIVE' },
	[0x0A6C] = { unicodeslot=0x0A6C, category='nd', description='GURMUKHI DIGIT SIX' },
	[0x0A6D] = { unicodeslot=0x0A6D, category='nd', description='GURMUKHI DIGIT SEVEN' },
	[0x0A6E] = { unicodeslot=0x0A6E, category='nd', description='GURMUKHI DIGIT EIGHT' },
	[0x0A6F] = { unicodeslot=0x0A6F, category='nd', description='GURMUKHI DIGIT NINE' },
	[0x0A70] = { unicodeslot=0x0A70, category='mn', description='GURMUKHI TIPPI' },
	[0x0A71] = { unicodeslot=0x0A71, category='mn', description='GURMUKHI ADDAK' },
	[0x0A72] = { unicodeslot=0x0A72, category='lo', description='GURMUKHI IRI' },
	[0x0A73] = { unicodeslot=0x0A73, category='lo', description='GURMUKHI URA' },
	[0x0A74] = { unicodeslot=0x0A74, category='lo', description='GURMUKHI EK ONKAR' },
	[0x0A81] = { unicodeslot=0x0A81, category='mn', description='GUJARATI SIGN CANDRABINDU' },
	[0x0A82] = { unicodeslot=0x0A82, category='mn', description='GUJARATI SIGN ANUSVARA' },
	[0x0A83] = { unicodeslot=0x0A83, category='mc', description='GUJARATI SIGN VISARGA' },
	[0x0A85] = { unicodeslot=0x0A85, category='lo', description='GUJARATI LETTER A' },
	[0x0A86] = { unicodeslot=0x0A86, category='lo', description='GUJARATI LETTER AA' },
	[0x0A87] = { unicodeslot=0x0A87, category='lo', description='GUJARATI LETTER I' },
	[0x0A88] = { unicodeslot=0x0A88, category='lo', description='GUJARATI LETTER II' },
	[0x0A89] = { unicodeslot=0x0A89, category='lo', description='GUJARATI LETTER U' },
	[0x0A8A] = { unicodeslot=0x0A8A, category='lo', description='GUJARATI LETTER UU' },
	[0x0A8B] = { unicodeslot=0x0A8B, category='lo', description='GUJARATI LETTER VOCALIC R' },
	[0x0A8C] = { unicodeslot=0x0A8C, category='lo', description='GUJARATI LETTER VOCALIC L' },
	[0x0A8D] = { unicodeslot=0x0A8D, category='lo', description='GUJARATI VOWEL CANDRA E' },
	[0x0A8F] = { unicodeslot=0x0A8F, category='lo', description='GUJARATI LETTER E' },
	[0x0A90] = { unicodeslot=0x0A90, category='lo', description='GUJARATI LETTER AI' },
	[0x0A91] = { unicodeslot=0x0A91, category='lo', description='GUJARATI VOWEL CANDRA O' },
	[0x0A93] = { unicodeslot=0x0A93, category='lo', description='GUJARATI LETTER O' },
	[0x0A94] = { unicodeslot=0x0A94, category='lo', description='GUJARATI LETTER AU' },
	[0x0A95] = { unicodeslot=0x0A95, category='lo', description='GUJARATI LETTER KA' },
	[0x0A96] = { unicodeslot=0x0A96, category='lo', description='GUJARATI LETTER KHA' },
	[0x0A97] = { unicodeslot=0x0A97, category='lo', description='GUJARATI LETTER GA' },
	[0x0A98] = { unicodeslot=0x0A98, category='lo', description='GUJARATI LETTER GHA' },
	[0x0A99] = { unicodeslot=0x0A99, category='lo', description='GUJARATI LETTER NGA' },
	[0x0A9A] = { unicodeslot=0x0A9A, category='lo', description='GUJARATI LETTER CA' },
	[0x0A9B] = { unicodeslot=0x0A9B, category='lo', description='GUJARATI LETTER CHA' },
	[0x0A9C] = { unicodeslot=0x0A9C, category='lo', description='GUJARATI LETTER JA' },
	[0x0A9D] = { unicodeslot=0x0A9D, category='lo', description='GUJARATI LETTER JHA' },
	[0x0A9E] = { unicodeslot=0x0A9E, category='lo', description='GUJARATI LETTER NYA' },
	[0x0A9F] = { unicodeslot=0x0A9F, category='lo', description='GUJARATI LETTER TTA' },
	[0x0AA0] = { unicodeslot=0x0AA0, category='lo', description='GUJARATI LETTER TTHA' },
	[0x0AA1] = { unicodeslot=0x0AA1, category='lo', description='GUJARATI LETTER DDA' },
	[0x0AA2] = { unicodeslot=0x0AA2, category='lo', description='GUJARATI LETTER DDHA' },
	[0x0AA3] = { unicodeslot=0x0AA3, category='lo', description='GUJARATI LETTER NNA' },
	[0x0AA4] = { unicodeslot=0x0AA4, category='lo', description='GUJARATI LETTER TA' },
	[0x0AA5] = { unicodeslot=0x0AA5, category='lo', description='GUJARATI LETTER THA' },
	[0x0AA6] = { unicodeslot=0x0AA6, category='lo', description='GUJARATI LETTER DA' },
	[0x0AA7] = { unicodeslot=0x0AA7, category='lo', description='GUJARATI LETTER DHA' },
	[0x0AA8] = { unicodeslot=0x0AA8, category='lo', description='GUJARATI LETTER NA' },
	[0x0AAA] = { unicodeslot=0x0AAA, category='lo', description='GUJARATI LETTER PA' },
	[0x0AAB] = { unicodeslot=0x0AAB, category='lo', description='GUJARATI LETTER PHA' },
	[0x0AAC] = { unicodeslot=0x0AAC, category='lo', description='GUJARATI LETTER BA' },
	[0x0AAD] = { unicodeslot=0x0AAD, category='lo', description='GUJARATI LETTER BHA' },
	[0x0AAE] = { unicodeslot=0x0AAE, category='lo', description='GUJARATI LETTER MA' },
	[0x0AAF] = { unicodeslot=0x0AAF, category='lo', description='GUJARATI LETTER YA' },
	[0x0AB0] = { unicodeslot=0x0AB0, category='lo', description='GUJARATI LETTER RA' },
	[0x0AB2] = { unicodeslot=0x0AB2, category='lo', description='GUJARATI LETTER LA' },
	[0x0AB3] = { unicodeslot=0x0AB3, category='lo', description='GUJARATI LETTER LLA' },
	[0x0AB5] = { unicodeslot=0x0AB5, category='lo', description='GUJARATI LETTER VA' },
	[0x0AB6] = { unicodeslot=0x0AB6, category='lo', description='GUJARATI LETTER SHA' },
	[0x0AB7] = { unicodeslot=0x0AB7, category='lo', description='GUJARATI LETTER SSA' },
	[0x0AB8] = { unicodeslot=0x0AB8, category='lo', description='GUJARATI LETTER SA' },
	[0x0AB9] = { unicodeslot=0x0AB9, category='lo', description='GUJARATI LETTER HA' },
	[0x0ABC] = { unicodeslot=0x0ABC, category='mn', description='GUJARATI SIGN NUKTA' },
	[0x0ABD] = { unicodeslot=0x0ABD, category='lo', description='GUJARATI SIGN AVAGRAHA' },
	[0x0ABE] = { unicodeslot=0x0ABE, category='mc', description='GUJARATI VOWEL SIGN AA' },
	[0x0ABF] = { unicodeslot=0x0ABF, category='mc', description='GUJARATI VOWEL SIGN I' },
	[0x0AC0] = { unicodeslot=0x0AC0, category='mc', description='GUJARATI VOWEL SIGN II' },
	[0x0AC1] = { unicodeslot=0x0AC1, category='mn', description='GUJARATI VOWEL SIGN U' },
	[0x0AC2] = { unicodeslot=0x0AC2, category='mn', description='GUJARATI VOWEL SIGN UU' },
	[0x0AC3] = { unicodeslot=0x0AC3, category='mn', description='GUJARATI VOWEL SIGN VOCALIC R' },
	[0x0AC4] = { unicodeslot=0x0AC4, category='mn', description='GUJARATI VOWEL SIGN VOCALIC RR' },
	[0x0AC5] = { unicodeslot=0x0AC5, category='mn', description='GUJARATI VOWEL SIGN CANDRA E' },
	[0x0AC7] = { unicodeslot=0x0AC7, category='mn', description='GUJARATI VOWEL SIGN E' },
	[0x0AC8] = { unicodeslot=0x0AC8, category='mn', description='GUJARATI VOWEL SIGN AI' },
	[0x0AC9] = { unicodeslot=0x0AC9, category='mc', description='GUJARATI VOWEL SIGN CANDRA O' },
	[0x0ACB] = { unicodeslot=0x0ACB, category='mc', description='GUJARATI VOWEL SIGN O' },
	[0x0ACC] = { unicodeslot=0x0ACC, category='mc', description='GUJARATI VOWEL SIGN AU' },
	[0x0ACD] = { unicodeslot=0x0ACD, category='mn', description='GUJARATI SIGN VIRAMA' },
	[0x0AD0] = { unicodeslot=0x0AD0, category='lo', description='GUJARATI OM' },
	[0x0AE0] = { unicodeslot=0x0AE0, category='lo', description='GUJARATI LETTER VOCALIC RR' },
	[0x0AE1] = { unicodeslot=0x0AE1, category='lo', description='GUJARATI LETTER VOCALIC LL' },
	[0x0AE2] = { unicodeslot=0x0AE2, category='mn', description='GUJARATI VOWEL SIGN VOCALIC L' },
	[0x0AE3] = { unicodeslot=0x0AE3, category='mn', description='GUJARATI VOWEL SIGN VOCALIC LL' },
	[0x0AE6] = { unicodeslot=0x0AE6, category='nd', description='GUJARATI DIGIT ZERO' },
	[0x0AE7] = { unicodeslot=0x0AE7, category='nd', description='GUJARATI DIGIT ONE' },
	[0x0AE8] = { unicodeslot=0x0AE8, category='nd', description='GUJARATI DIGIT TWO' },
	[0x0AE9] = { unicodeslot=0x0AE9, category='nd', description='GUJARATI DIGIT THREE' },
	[0x0AEA] = { unicodeslot=0x0AEA, category='nd', description='GUJARATI DIGIT FOUR' },
	[0x0AEB] = { unicodeslot=0x0AEB, category='nd', description='GUJARATI DIGIT FIVE' },
	[0x0AEC] = { unicodeslot=0x0AEC, category='nd', description='GUJARATI DIGIT SIX' },
	[0x0AED] = { unicodeslot=0x0AED, category='nd', description='GUJARATI DIGIT SEVEN' },
	[0x0AEE] = { unicodeslot=0x0AEE, category='nd', description='GUJARATI DIGIT EIGHT' },
	[0x0AEF] = { unicodeslot=0x0AEF, category='nd', description='GUJARATI DIGIT NINE' },
	[0x0AF1] = { unicodeslot=0x0AF1, category='sc', description='GUJARATI RUPEE SIGN' },
	[0x0B01] = { unicodeslot=0x0B01, category='mn', description='ORIYA SIGN CANDRABINDU' },
	[0x0B02] = { unicodeslot=0x0B02, category='mc', description='ORIYA SIGN ANUSVARA' },
	[0x0B03] = { unicodeslot=0x0B03, category='mc', description='ORIYA SIGN VISARGA' },
	[0x0B05] = { unicodeslot=0x0B05, category='lo', description='ORIYA LETTER A' },
	[0x0B06] = { unicodeslot=0x0B06, category='lo', description='ORIYA LETTER AA' },
	[0x0B07] = { unicodeslot=0x0B07, category='lo', description='ORIYA LETTER I' },
	[0x0B08] = { unicodeslot=0x0B08, category='lo', description='ORIYA LETTER II' },
	[0x0B09] = { unicodeslot=0x0B09, category='lo', description='ORIYA LETTER U' },
	[0x0B0A] = { unicodeslot=0x0B0A, category='lo', description='ORIYA LETTER UU' },
	[0x0B0B] = { unicodeslot=0x0B0B, category='lo', description='ORIYA LETTER VOCALIC R' },
	[0x0B0C] = { unicodeslot=0x0B0C, category='lo', description='ORIYA LETTER VOCALIC L' },
	[0x0B0F] = { unicodeslot=0x0B0F, category='lo', description='ORIYA LETTER E' },
	[0x0B10] = { unicodeslot=0x0B10, category='lo', description='ORIYA LETTER AI' },
	[0x0B13] = { unicodeslot=0x0B13, category='lo', description='ORIYA LETTER O' },
	[0x0B14] = { unicodeslot=0x0B14, category='lo', description='ORIYA LETTER AU' },
	[0x0B15] = { unicodeslot=0x0B15, category='lo', description='ORIYA LETTER KA' },
	[0x0B16] = { unicodeslot=0x0B16, category='lo', description='ORIYA LETTER KHA' },
	[0x0B17] = { unicodeslot=0x0B17, category='lo', description='ORIYA LETTER GA' },
	[0x0B18] = { unicodeslot=0x0B18, category='lo', description='ORIYA LETTER GHA' },
	[0x0B19] = { unicodeslot=0x0B19, category='lo', description='ORIYA LETTER NGA' },
	[0x0B1A] = { unicodeslot=0x0B1A, category='lo', description='ORIYA LETTER CA' },
	[0x0B1B] = { unicodeslot=0x0B1B, category='lo', description='ORIYA LETTER CHA' },
	[0x0B1C] = { unicodeslot=0x0B1C, category='lo', description='ORIYA LETTER JA' },
	[0x0B1D] = { unicodeslot=0x0B1D, category='lo', description='ORIYA LETTER JHA' },
	[0x0B1E] = { unicodeslot=0x0B1E, category='lo', description='ORIYA LETTER NYA' },
	[0x0B1F] = { unicodeslot=0x0B1F, category='lo', description='ORIYA LETTER TTA' },
	[0x0B20] = { unicodeslot=0x0B20, category='lo', description='ORIYA LETTER TTHA' },
	[0x0B21] = { unicodeslot=0x0B21, category='lo', description='ORIYA LETTER DDA' },
	[0x0B22] = { unicodeslot=0x0B22, category='lo', description='ORIYA LETTER DDHA' },
	[0x0B23] = { unicodeslot=0x0B23, category='lo', description='ORIYA LETTER NNA' },
	[0x0B24] = { unicodeslot=0x0B24, category='lo', description='ORIYA LETTER TA' },
	[0x0B25] = { unicodeslot=0x0B25, category='lo', description='ORIYA LETTER THA' },
	[0x0B26] = { unicodeslot=0x0B26, category='lo', description='ORIYA LETTER DA' },
	[0x0B27] = { unicodeslot=0x0B27, category='lo', description='ORIYA LETTER DHA' },
	[0x0B28] = { unicodeslot=0x0B28, category='lo', description='ORIYA LETTER NA' },
	[0x0B2A] = { unicodeslot=0x0B2A, category='lo', description='ORIYA LETTER PA' },
	[0x0B2B] = { unicodeslot=0x0B2B, category='lo', description='ORIYA LETTER PHA' },
	[0x0B2C] = { unicodeslot=0x0B2C, category='lo', description='ORIYA LETTER BA' },
	[0x0B2D] = { unicodeslot=0x0B2D, category='lo', description='ORIYA LETTER BHA' },
	[0x0B2E] = { unicodeslot=0x0B2E, category='lo', description='ORIYA LETTER MA' },
	[0x0B2F] = { unicodeslot=0x0B2F, category='lo', description='ORIYA LETTER YA' },
	[0x0B30] = { unicodeslot=0x0B30, category='lo', description='ORIYA LETTER RA' },
	[0x0B32] = { unicodeslot=0x0B32, category='lo', description='ORIYA LETTER LA' },
	[0x0B33] = { unicodeslot=0x0B33, category='lo', description='ORIYA LETTER LLA' },
	[0x0B35] = { unicodeslot=0x0B35, category='lo', description='ORIYA LETTER VA' },
	[0x0B36] = { unicodeslot=0x0B36, category='lo', description='ORIYA LETTER SHA' },
	[0x0B37] = { unicodeslot=0x0B37, category='lo', description='ORIYA LETTER SSA' },
	[0x0B38] = { unicodeslot=0x0B38, category='lo', description='ORIYA LETTER SA' },
	[0x0B39] = { unicodeslot=0x0B39, category='lo', description='ORIYA LETTER HA' },
	[0x0B3C] = { unicodeslot=0x0B3C, category='mn', description='ORIYA SIGN NUKTA' },
	[0x0B3D] = { unicodeslot=0x0B3D, category='lo', description='ORIYA SIGN AVAGRAHA' },
	[0x0B3E] = { unicodeslot=0x0B3E, category='mc', description='ORIYA VOWEL SIGN AA' },
	[0x0B3F] = { unicodeslot=0x0B3F, category='mn', description='ORIYA VOWEL SIGN I' },
	[0x0B40] = { unicodeslot=0x0B40, category='mc', description='ORIYA VOWEL SIGN II' },
	[0x0B41] = { unicodeslot=0x0B41, category='mn', description='ORIYA VOWEL SIGN U' },
	[0x0B42] = { unicodeslot=0x0B42, category='mn', description='ORIYA VOWEL SIGN UU' },
	[0x0B43] = { unicodeslot=0x0B43, category='mn', description='ORIYA VOWEL SIGN VOCALIC R' },
	[0x0B47] = { unicodeslot=0x0B47, category='mc', description='ORIYA VOWEL SIGN E' },
	[0x0B48] = { unicodeslot=0x0B48, category='mc', description='ORIYA VOWEL SIGN AI', specials={'char',0x0B47,0x0B56} },
	[0x0B4B] = { unicodeslot=0x0B4B, category='mc', description='ORIYA VOWEL SIGN O', specials={'char',0x0B47,0x0B3E} },
	[0x0B4C] = { unicodeslot=0x0B4C, category='mc', description='ORIYA VOWEL SIGN AU', specials={'char',0x0B47,0x0B57} },
	[0x0B4D] = { unicodeslot=0x0B4D, category='mn', description='ORIYA SIGN VIRAMA' },
	[0x0B56] = { unicodeslot=0x0B56, category='mn', description='ORIYA AI LENGTH MARK' },
	[0x0B57] = { unicodeslot=0x0B57, category='mc', description='ORIYA AU LENGTH MARK' },
	[0x0B5C] = { unicodeslot=0x0B5C, category='lo', description='ORIYA LETTER RRA', specials={'char',0x0B21,0x0B3C} },
	[0x0B5D] = { unicodeslot=0x0B5D, category='lo', description='ORIYA LETTER RHA', specials={'char',0x0B22,0x0B3C} },
	[0x0B5F] = { unicodeslot=0x0B5F, category='lo', description='ORIYA LETTER YYA' },
	[0x0B60] = { unicodeslot=0x0B60, category='lo', description='ORIYA LETTER VOCALIC RR' },
	[0x0B61] = { unicodeslot=0x0B61, category='lo', description='ORIYA LETTER VOCALIC LL' },
	[0x0B66] = { unicodeslot=0x0B66, category='nd', description='ORIYA DIGIT ZERO' },
	[0x0B67] = { unicodeslot=0x0B67, category='nd', description='ORIYA DIGIT ONE' },
	[0x0B68] = { unicodeslot=0x0B68, category='nd', description='ORIYA DIGIT TWO' },
	[0x0B69] = { unicodeslot=0x0B69, category='nd', description='ORIYA DIGIT THREE' },
	[0x0B6A] = { unicodeslot=0x0B6A, category='nd', description='ORIYA DIGIT FOUR' },
	[0x0B6B] = { unicodeslot=0x0B6B, category='nd', description='ORIYA DIGIT FIVE' },
	[0x0B6C] = { unicodeslot=0x0B6C, category='nd', description='ORIYA DIGIT SIX' },
	[0x0B6D] = { unicodeslot=0x0B6D, category='nd', description='ORIYA DIGIT SEVEN' },
	[0x0B6E] = { unicodeslot=0x0B6E, category='nd', description='ORIYA DIGIT EIGHT' },
	[0x0B6F] = { unicodeslot=0x0B6F, category='nd', description='ORIYA DIGIT NINE' },
	[0x0B70] = { unicodeslot=0x0B70, category='so', description='ORIYA ISSHAR' },
	[0x0B71] = { unicodeslot=0x0B71, category='lo', description='ORIYA LETTER WA' },
	[0x0B82] = { unicodeslot=0x0B82, category='mn', description='TAMIL SIGN ANUSVARA' },
	[0x0B83] = { unicodeslot=0x0B83, category='lo', description='TAMIL SIGN VISARGA' },
	[0x0B85] = { unicodeslot=0x0B85, category='lo', description='TAMIL LETTER A' },
	[0x0B86] = { unicodeslot=0x0B86, category='lo', description='TAMIL LETTER AA' },
	[0x0B87] = { unicodeslot=0x0B87, category='lo', description='TAMIL LETTER I' },
	[0x0B88] = { unicodeslot=0x0B88, category='lo', description='TAMIL LETTER II' },
	[0x0B89] = { unicodeslot=0x0B89, category='lo', description='TAMIL LETTER U' },
	[0x0B8A] = { unicodeslot=0x0B8A, category='lo', description='TAMIL LETTER UU' },
	[0x0B8E] = { unicodeslot=0x0B8E, category='lo', description='TAMIL LETTER E' },
	[0x0B8F] = { unicodeslot=0x0B8F, category='lo', description='TAMIL LETTER EE' },
	[0x0B90] = { unicodeslot=0x0B90, category='lo', description='TAMIL LETTER AI' },
	[0x0B92] = { unicodeslot=0x0B92, category='lo', description='TAMIL LETTER O' },
	[0x0B93] = { unicodeslot=0x0B93, category='lo', description='TAMIL LETTER OO' },
	[0x0B94] = { unicodeslot=0x0B94, category='lo', description='TAMIL LETTER AU', specials={'char',0x0B92,0x0BD7} },
	[0x0B95] = { unicodeslot=0x0B95, category='lo', description='TAMIL LETTER KA' },
	[0x0B99] = { unicodeslot=0x0B99, category='lo', description='TAMIL LETTER NGA' },
	[0x0B9A] = { unicodeslot=0x0B9A, category='lo', description='TAMIL LETTER CA' },
	[0x0B9C] = { unicodeslot=0x0B9C, category='lo', description='TAMIL LETTER JA' },
	[0x0B9E] = { unicodeslot=0x0B9E, category='lo', description='TAMIL LETTER NYA' },
	[0x0B9F] = { unicodeslot=0x0B9F, category='lo', description='TAMIL LETTER TTA' },
	[0x0BA3] = { unicodeslot=0x0BA3, category='lo', description='TAMIL LETTER NNA' },
	[0x0BA4] = { unicodeslot=0x0BA4, category='lo', description='TAMIL LETTER TA' },
	[0x0BA8] = { unicodeslot=0x0BA8, category='lo', description='TAMIL LETTER NA' },
	[0x0BA9] = { unicodeslot=0x0BA9, category='lo', description='TAMIL LETTER NNNA' },
	[0x0BAA] = { unicodeslot=0x0BAA, category='lo', description='TAMIL LETTER PA' },
	[0x0BAE] = { unicodeslot=0x0BAE, category='lo', description='TAMIL LETTER MA' },
	[0x0BAF] = { unicodeslot=0x0BAF, category='lo', description='TAMIL LETTER YA' },
	[0x0BB0] = { unicodeslot=0x0BB0, category='lo', description='TAMIL LETTER RA' },
	[0x0BB1] = { unicodeslot=0x0BB1, category='lo', description='TAMIL LETTER RRA' },
	[0x0BB2] = { unicodeslot=0x0BB2, category='lo', description='TAMIL LETTER LA' },
	[0x0BB3] = { unicodeslot=0x0BB3, category='lo', description='TAMIL LETTER LLA' },
	[0x0BB4] = { unicodeslot=0x0BB4, category='lo', description='TAMIL LETTER LLLA' },
	[0x0BB5] = { unicodeslot=0x0BB5, category='lo', description='TAMIL LETTER VA' },
	[0x0BB6] = { unicodeslot=0x0BB6, category='lo', description='TAMIL LETTER SHA' },
	[0x0BB7] = { unicodeslot=0x0BB7, category='lo', description='TAMIL LETTER SSA' },
	[0x0BB8] = { unicodeslot=0x0BB8, category='lo', description='TAMIL LETTER SA' },
	[0x0BB9] = { unicodeslot=0x0BB9, category='lo', description='TAMIL LETTER HA' },
	[0x0BBE] = { unicodeslot=0x0BBE, category='mc', description='TAMIL VOWEL SIGN AA' },
	[0x0BBF] = { unicodeslot=0x0BBF, category='mc', description='TAMIL VOWEL SIGN I' },
	[0x0BC0] = { unicodeslot=0x0BC0, category='mn', description='TAMIL VOWEL SIGN II' },
	[0x0BC1] = { unicodeslot=0x0BC1, category='mc', description='TAMIL VOWEL SIGN U' },
	[0x0BC2] = { unicodeslot=0x0BC2, category='mc', description='TAMIL VOWEL SIGN UU' },
	[0x0BC6] = { unicodeslot=0x0BC6, category='mc', description='TAMIL VOWEL SIGN E' },
	[0x0BC7] = { unicodeslot=0x0BC7, category='mc', description='TAMIL VOWEL SIGN EE' },
	[0x0BC8] = { unicodeslot=0x0BC8, category='mc', description='TAMIL VOWEL SIGN AI' },
	[0x0BCA] = { unicodeslot=0x0BCA, category='mc', description='TAMIL VOWEL SIGN O', specials={'char',0x0BC6,0x0BBE} },
	[0x0BCB] = { unicodeslot=0x0BCB, category='mc', description='TAMIL VOWEL SIGN OO', specials={'char',0x0BC7,0x0BBE} },
	[0x0BCC] = { unicodeslot=0x0BCC, category='mc', description='TAMIL VOWEL SIGN AU', specials={'char',0x0BC6,0x0BD7} },
	[0x0BCD] = { unicodeslot=0x0BCD, category='mn', description='TAMIL SIGN VIRAMA' },
	[0x0BD7] = { unicodeslot=0x0BD7, category='mc', description='TAMIL AU LENGTH MARK' },
	[0x0BE6] = { unicodeslot=0x0BE6, category='nd', description='TAMIL DIGIT ZERO' },
	[0x0BE7] = { unicodeslot=0x0BE7, category='nd', description='TAMIL DIGIT ONE' },
	[0x0BE8] = { unicodeslot=0x0BE8, category='nd', description='TAMIL DIGIT TWO' },
	[0x0BE9] = { unicodeslot=0x0BE9, category='nd', description='TAMIL DIGIT THREE' },
	[0x0BEA] = { unicodeslot=0x0BEA, category='nd', description='TAMIL DIGIT FOUR' },
	[0x0BEB] = { unicodeslot=0x0BEB, category='nd', description='TAMIL DIGIT FIVE' },
	[0x0BEC] = { unicodeslot=0x0BEC, category='nd', description='TAMIL DIGIT SIX' },
	[0x0BED] = { unicodeslot=0x0BED, category='nd', description='TAMIL DIGIT SEVEN' },
	[0x0BEE] = { unicodeslot=0x0BEE, category='nd', description='TAMIL DIGIT EIGHT' },
	[0x0BEF] = { unicodeslot=0x0BEF, category='nd', description='TAMIL DIGIT NINE' },
	[0x0BF0] = { unicodeslot=0x0BF0, category='no', description='TAMIL NUMBER TEN' },
	[0x0BF1] = { unicodeslot=0x0BF1, category='no', description='TAMIL NUMBER ONE HUNDRED' },
	[0x0BF2] = { unicodeslot=0x0BF2, category='no', description='TAMIL NUMBER ONE THOUSAND' },
	[0x0BF3] = { unicodeslot=0x0BF3, category='so', description='TAMIL DAY SIGN' },
	[0x0BF4] = { unicodeslot=0x0BF4, category='so', description='TAMIL MONTH SIGN' },
	[0x0BF5] = { unicodeslot=0x0BF5, category='so', description='TAMIL YEAR SIGN' },
	[0x0BF6] = { unicodeslot=0x0BF6, category='so', description='TAMIL DEBIT SIGN' },
	[0x0BF7] = { unicodeslot=0x0BF7, category='so', description='TAMIL CREDIT SIGN' },
	[0x0BF8] = { unicodeslot=0x0BF8, category='so', description='TAMIL AS ABOVE SIGN' },
	[0x0BF9] = { unicodeslot=0x0BF9, category='sc', description='TAMIL RUPEE SIGN' },
	[0x0BFA] = { unicodeslot=0x0BFA, category='so', description='TAMIL NUMBER SIGN' },
	[0x0C01] = { unicodeslot=0x0C01, category='mc', description='TELUGU SIGN CANDRABINDU' },
	[0x0C02] = { unicodeslot=0x0C02, category='mc', description='TELUGU SIGN ANUSVARA' },
	[0x0C03] = { unicodeslot=0x0C03, category='mc', description='TELUGU SIGN VISARGA' },
	[0x0C05] = { unicodeslot=0x0C05, category='lo', description='TELUGU LETTER A' },
	[0x0C06] = { unicodeslot=0x0C06, category='lo', description='TELUGU LETTER AA' },
	[0x0C07] = { unicodeslot=0x0C07, category='lo', description='TELUGU LETTER I' },
	[0x0C08] = { unicodeslot=0x0C08, category='lo', description='TELUGU LETTER II' },
	[0x0C09] = { unicodeslot=0x0C09, category='lo', description='TELUGU LETTER U' },
	[0x0C0A] = { unicodeslot=0x0C0A, category='lo', description='TELUGU LETTER UU' },
	[0x0C0B] = { unicodeslot=0x0C0B, category='lo', description='TELUGU LETTER VOCALIC R' },
	[0x0C0C] = { unicodeslot=0x0C0C, category='lo', description='TELUGU LETTER VOCALIC L' },
	[0x0C0E] = { unicodeslot=0x0C0E, category='lo', description='TELUGU LETTER E' },
	[0x0C0F] = { unicodeslot=0x0C0F, category='lo', description='TELUGU LETTER EE' },
	[0x0C10] = { unicodeslot=0x0C10, category='lo', description='TELUGU LETTER AI' },
	[0x0C12] = { unicodeslot=0x0C12, category='lo', description='TELUGU LETTER O' },
	[0x0C13] = { unicodeslot=0x0C13, category='lo', description='TELUGU LETTER OO' },
	[0x0C14] = { unicodeslot=0x0C14, category='lo', description='TELUGU LETTER AU' },
	[0x0C15] = { unicodeslot=0x0C15, category='lo', description='TELUGU LETTER KA' },
	[0x0C16] = { unicodeslot=0x0C16, category='lo', description='TELUGU LETTER KHA' },
	[0x0C17] = { unicodeslot=0x0C17, category='lo', description='TELUGU LETTER GA' },
	[0x0C18] = { unicodeslot=0x0C18, category='lo', description='TELUGU LETTER GHA' },
	[0x0C19] = { unicodeslot=0x0C19, category='lo', description='TELUGU LETTER NGA' },
	[0x0C1A] = { unicodeslot=0x0C1A, category='lo', description='TELUGU LETTER CA' },
	[0x0C1B] = { unicodeslot=0x0C1B, category='lo', description='TELUGU LETTER CHA' },
	[0x0C1C] = { unicodeslot=0x0C1C, category='lo', description='TELUGU LETTER JA' },
	[0x0C1D] = { unicodeslot=0x0C1D, category='lo', description='TELUGU LETTER JHA' },
	[0x0C1E] = { unicodeslot=0x0C1E, category='lo', description='TELUGU LETTER NYA' },
	[0x0C1F] = { unicodeslot=0x0C1F, category='lo', description='TELUGU LETTER TTA' },
	[0x0C20] = { unicodeslot=0x0C20, category='lo', description='TELUGU LETTER TTHA' },
	[0x0C21] = { unicodeslot=0x0C21, category='lo', description='TELUGU LETTER DDA' },
	[0x0C22] = { unicodeslot=0x0C22, category='lo', description='TELUGU LETTER DDHA' },
	[0x0C23] = { unicodeslot=0x0C23, category='lo', description='TELUGU LETTER NNA' },
	[0x0C24] = { unicodeslot=0x0C24, category='lo', description='TELUGU LETTER TA' },
	[0x0C25] = { unicodeslot=0x0C25, category='lo', description='TELUGU LETTER THA' },
	[0x0C26] = { unicodeslot=0x0C26, category='lo', description='TELUGU LETTER DA' },
	[0x0C27] = { unicodeslot=0x0C27, category='lo', description='TELUGU LETTER DHA' },
	[0x0C28] = { unicodeslot=0x0C28, category='lo', description='TELUGU LETTER NA' },
	[0x0C2A] = { unicodeslot=0x0C2A, category='lo', description='TELUGU LETTER PA' },
	[0x0C2B] = { unicodeslot=0x0C2B, category='lo', description='TELUGU LETTER PHA' },
	[0x0C2C] = { unicodeslot=0x0C2C, category='lo', description='TELUGU LETTER BA' },
	[0x0C2D] = { unicodeslot=0x0C2D, category='lo', description='TELUGU LETTER BHA' },
	[0x0C2E] = { unicodeslot=0x0C2E, category='lo', description='TELUGU LETTER MA' },
	[0x0C2F] = { unicodeslot=0x0C2F, category='lo', description='TELUGU LETTER YA' },
	[0x0C30] = { unicodeslot=0x0C30, category='lo', description='TELUGU LETTER RA' },
	[0x0C31] = { unicodeslot=0x0C31, category='lo', description='TELUGU LETTER RRA' },
	[0x0C32] = { unicodeslot=0x0C32, category='lo', description='TELUGU LETTER LA' },
	[0x0C33] = { unicodeslot=0x0C33, category='lo', description='TELUGU LETTER LLA' },
	[0x0C35] = { unicodeslot=0x0C35, category='lo', description='TELUGU LETTER VA' },
	[0x0C36] = { unicodeslot=0x0C36, category='lo', description='TELUGU LETTER SHA' },
	[0x0C37] = { unicodeslot=0x0C37, category='lo', description='TELUGU LETTER SSA' },
	[0x0C38] = { unicodeslot=0x0C38, category='lo', description='TELUGU LETTER SA' },
	[0x0C39] = { unicodeslot=0x0C39, category='lo', description='TELUGU LETTER HA' },
	[0x0C3E] = { unicodeslot=0x0C3E, category='mn', description='TELUGU VOWEL SIGN AA' },
	[0x0C3F] = { unicodeslot=0x0C3F, category='mn', description='TELUGU VOWEL SIGN I' },
	[0x0C40] = { unicodeslot=0x0C40, category='mn', description='TELUGU VOWEL SIGN II' },
	[0x0C41] = { unicodeslot=0x0C41, category='mc', description='TELUGU VOWEL SIGN U' },
	[0x0C42] = { unicodeslot=0x0C42, category='mc', description='TELUGU VOWEL SIGN UU' },
	[0x0C43] = { unicodeslot=0x0C43, category='mc', description='TELUGU VOWEL SIGN VOCALIC R' },
	[0x0C44] = { unicodeslot=0x0C44, category='mc', description='TELUGU VOWEL SIGN VOCALIC RR' },
	[0x0C46] = { unicodeslot=0x0C46, category='mn', description='TELUGU VOWEL SIGN E' },
	[0x0C47] = { unicodeslot=0x0C47, category='mn', description='TELUGU VOWEL SIGN EE' },
	[0x0C48] = { unicodeslot=0x0C48, category='mn', description='TELUGU VOWEL SIGN AI', specials={'char',0x0C46,0x0C56} },
	[0x0C4A] = { unicodeslot=0x0C4A, category='mn', description='TELUGU VOWEL SIGN O' },
	[0x0C4B] = { unicodeslot=0x0C4B, category='mn', description='TELUGU VOWEL SIGN OO' },
	[0x0C4C] = { unicodeslot=0x0C4C, category='mn', description='TELUGU VOWEL SIGN AU' },
	[0x0C4D] = { unicodeslot=0x0C4D, category='mn', description='TELUGU SIGN VIRAMA' },
	[0x0C55] = { unicodeslot=0x0C55, category='mn', description='TELUGU LENGTH MARK' },
	[0x0C56] = { unicodeslot=0x0C56, category='mn', description='TELUGU AI LENGTH MARK' },
	[0x0C60] = { unicodeslot=0x0C60, category='lo', description='TELUGU LETTER VOCALIC RR' },
	[0x0C61] = { unicodeslot=0x0C61, category='lo', description='TELUGU LETTER VOCALIC LL' },
	[0x0C66] = { unicodeslot=0x0C66, category='nd', description='TELUGU DIGIT ZERO' },
	[0x0C67] = { unicodeslot=0x0C67, category='nd', description='TELUGU DIGIT ONE' },
	[0x0C68] = { unicodeslot=0x0C68, category='nd', description='TELUGU DIGIT TWO' },
	[0x0C69] = { unicodeslot=0x0C69, category='nd', description='TELUGU DIGIT THREE' },
	[0x0C6A] = { unicodeslot=0x0C6A, category='nd', description='TELUGU DIGIT FOUR' },
	[0x0C6B] = { unicodeslot=0x0C6B, category='nd', description='TELUGU DIGIT FIVE' },
	[0x0C6C] = { unicodeslot=0x0C6C, category='nd', description='TELUGU DIGIT SIX' },
	[0x0C6D] = { unicodeslot=0x0C6D, category='nd', description='TELUGU DIGIT SEVEN' },
	[0x0C6E] = { unicodeslot=0x0C6E, category='nd', description='TELUGU DIGIT EIGHT' },
	[0x0C6F] = { unicodeslot=0x0C6F, category='nd', description='TELUGU DIGIT NINE' },
	[0x0C82] = { unicodeslot=0x0C82, category='mc', description='KANNADA SIGN ANUSVARA' },
	[0x0C83] = { unicodeslot=0x0C83, category='mc', description='KANNADA SIGN VISARGA' },
	[0x0C85] = { unicodeslot=0x0C85, category='lo', description='KANNADA LETTER A' },
	[0x0C86] = { unicodeslot=0x0C86, category='lo', description='KANNADA LETTER AA' },
	[0x0C87] = { unicodeslot=0x0C87, category='lo', description='KANNADA LETTER I' },
	[0x0C88] = { unicodeslot=0x0C88, category='lo', description='KANNADA LETTER II' },
	[0x0C89] = { unicodeslot=0x0C89, category='lo', description='KANNADA LETTER U' },
	[0x0C8A] = { unicodeslot=0x0C8A, category='lo', description='KANNADA LETTER UU' },
	[0x0C8B] = { unicodeslot=0x0C8B, category='lo', description='KANNADA LETTER VOCALIC R' },
	[0x0C8C] = { unicodeslot=0x0C8C, category='lo', description='KANNADA LETTER VOCALIC L' },
	[0x0C8E] = { unicodeslot=0x0C8E, category='lo', description='KANNADA LETTER E' },
	[0x0C8F] = { unicodeslot=0x0C8F, category='lo', description='KANNADA LETTER EE' },
	[0x0C90] = { unicodeslot=0x0C90, category='lo', description='KANNADA LETTER AI' },
	[0x0C92] = { unicodeslot=0x0C92, category='lo', description='KANNADA LETTER O' },
	[0x0C93] = { unicodeslot=0x0C93, category='lo', description='KANNADA LETTER OO' },
	[0x0C94] = { unicodeslot=0x0C94, category='lo', description='KANNADA LETTER AU' },
	[0x0C95] = { unicodeslot=0x0C95, category='lo', description='KANNADA LETTER KA' },
	[0x0C96] = { unicodeslot=0x0C96, category='lo', description='KANNADA LETTER KHA' },
	[0x0C97] = { unicodeslot=0x0C97, category='lo', description='KANNADA LETTER GA' },
	[0x0C98] = { unicodeslot=0x0C98, category='lo', description='KANNADA LETTER GHA' },
	[0x0C99] = { unicodeslot=0x0C99, category='lo', description='KANNADA LETTER NGA' },
	[0x0C9A] = { unicodeslot=0x0C9A, category='lo', description='KANNADA LETTER CA' },
	[0x0C9B] = { unicodeslot=0x0C9B, category='lo', description='KANNADA LETTER CHA' },
	[0x0C9C] = { unicodeslot=0x0C9C, category='lo', description='KANNADA LETTER JA' },
	[0x0C9D] = { unicodeslot=0x0C9D, category='lo', description='KANNADA LETTER JHA' },
	[0x0C9E] = { unicodeslot=0x0C9E, category='lo', description='KANNADA LETTER NYA' },
	[0x0C9F] = { unicodeslot=0x0C9F, category='lo', description='KANNADA LETTER TTA' },
	[0x0CA0] = { unicodeslot=0x0CA0, category='lo', description='KANNADA LETTER TTHA' },
	[0x0CA1] = { unicodeslot=0x0CA1, category='lo', description='KANNADA LETTER DDA' },
	[0x0CA2] = { unicodeslot=0x0CA2, category='lo', description='KANNADA LETTER DDHA' },
	[0x0CA3] = { unicodeslot=0x0CA3, category='lo', description='KANNADA LETTER NNA' },
	[0x0CA4] = { unicodeslot=0x0CA4, category='lo', description='KANNADA LETTER TA' },
	[0x0CA5] = { unicodeslot=0x0CA5, category='lo', description='KANNADA LETTER THA' },
	[0x0CA6] = { unicodeslot=0x0CA6, category='lo', description='KANNADA LETTER DA' },
	[0x0CA7] = { unicodeslot=0x0CA7, category='lo', description='KANNADA LETTER DHA' },
	[0x0CA8] = { unicodeslot=0x0CA8, category='lo', description='KANNADA LETTER NA' },
	[0x0CAA] = { unicodeslot=0x0CAA, category='lo', description='KANNADA LETTER PA' },
	[0x0CAB] = { unicodeslot=0x0CAB, category='lo', description='KANNADA LETTER PHA' },
	[0x0CAC] = { unicodeslot=0x0CAC, category='lo', description='KANNADA LETTER BA' },
	[0x0CAD] = { unicodeslot=0x0CAD, category='lo', description='KANNADA LETTER BHA' },
	[0x0CAE] = { unicodeslot=0x0CAE, category='lo', description='KANNADA LETTER MA' },
	[0x0CAF] = { unicodeslot=0x0CAF, category='lo', description='KANNADA LETTER YA' },
	[0x0CB0] = { unicodeslot=0x0CB0, category='lo', description='KANNADA LETTER RA' },
	[0x0CB1] = { unicodeslot=0x0CB1, category='lo', description='KANNADA LETTER RRA' },
	[0x0CB2] = { unicodeslot=0x0CB2, category='lo', description='KANNADA LETTER LA' },
	[0x0CB3] = { unicodeslot=0x0CB3, category='lo', description='KANNADA LETTER LLA' },
	[0x0CB5] = { unicodeslot=0x0CB5, category='lo', description='KANNADA LETTER VA' },
	[0x0CB6] = { unicodeslot=0x0CB6, category='lo', description='KANNADA LETTER SHA' },
	[0x0CB7] = { unicodeslot=0x0CB7, category='lo', description='KANNADA LETTER SSA' },
	[0x0CB8] = { unicodeslot=0x0CB8, category='lo', description='KANNADA LETTER SA' },
	[0x0CB9] = { unicodeslot=0x0CB9, category='lo', description='KANNADA LETTER HA' },
	[0x0CBC] = { unicodeslot=0x0CBC, category='mn', description='KANNADA SIGN NUKTA' },
	[0x0CBD] = { unicodeslot=0x0CBD, category='lo', description='KANNADA SIGN AVAGRAHA' },
	[0x0CBE] = { unicodeslot=0x0CBE, category='mc', description='KANNADA VOWEL SIGN AA' },
	[0x0CBF] = { unicodeslot=0x0CBF, category='mn', description='KANNADA VOWEL SIGN I' },
	[0x0CC0] = { unicodeslot=0x0CC0, category='mc', description='KANNADA VOWEL SIGN II', specials={'char',0x0CBF,0x0CD5} },
	[0x0CC1] = { unicodeslot=0x0CC1, category='mc', description='KANNADA VOWEL SIGN U' },
	[0x0CC2] = { unicodeslot=0x0CC2, category='mc', description='KANNADA VOWEL SIGN UU' },
	[0x0CC3] = { unicodeslot=0x0CC3, category='mc', description='KANNADA VOWEL SIGN VOCALIC R' },
	[0x0CC4] = { unicodeslot=0x0CC4, category='mc', description='KANNADA VOWEL SIGN VOCALIC RR' },
	[0x0CC6] = { unicodeslot=0x0CC6, category='mn', description='KANNADA VOWEL SIGN E' },
	[0x0CC7] = { unicodeslot=0x0CC7, category='mc', description='KANNADA VOWEL SIGN EE', specials={'char',0x0CC6,0x0CD5} },
	[0x0CC8] = { unicodeslot=0x0CC8, category='mc', description='KANNADA VOWEL SIGN AI', specials={'char',0x0CC6,0x0CD6} },
	[0x0CCA] = { unicodeslot=0x0CCA, category='mc', description='KANNADA VOWEL SIGN O', specials={'char',0x0CC6,0x0CC2} },
	[0x0CCB] = { unicodeslot=0x0CCB, category='mc', description='KANNADA VOWEL SIGN OO', specials={'char',0x0CCA,0x0CD5} },
	[0x0CCC] = { unicodeslot=0x0CCC, category='mn', description='KANNADA VOWEL SIGN AU' },
	[0x0CCD] = { unicodeslot=0x0CCD, category='mn', description='KANNADA SIGN VIRAMA' },
	[0x0CD5] = { unicodeslot=0x0CD5, category='mc', description='KANNADA LENGTH MARK' },
	[0x0CD6] = { unicodeslot=0x0CD6, category='mc', description='KANNADA AI LENGTH MARK' },
	[0x0CDE] = { unicodeslot=0x0CDE, category='lo', description='KANNADA LETTER FA' },
	[0x0CE0] = { unicodeslot=0x0CE0, category='lo', description='KANNADA LETTER VOCALIC RR' },
	[0x0CE1] = { unicodeslot=0x0CE1, category='lo', description='KANNADA LETTER VOCALIC LL' },
	[0x0CE2] = { unicodeslot=0x0CE2, category='mn', description='KANNADA VOWEL SIGN VOCALIC L' },
	[0x0CE3] = { unicodeslot=0x0CE3, category='mn', description='KANNADA VOWEL SIGN VOCALIC LL' },
	[0x0CE6] = { unicodeslot=0x0CE6, category='nd', description='KANNADA DIGIT ZERO' },
	[0x0CE7] = { unicodeslot=0x0CE7, category='nd', description='KANNADA DIGIT ONE' },
	[0x0CE8] = { unicodeslot=0x0CE8, category='nd', description='KANNADA DIGIT TWO' },
	[0x0CE9] = { unicodeslot=0x0CE9, category='nd', description='KANNADA DIGIT THREE' },
	[0x0CEA] = { unicodeslot=0x0CEA, category='nd', description='KANNADA DIGIT FOUR' },
	[0x0CEB] = { unicodeslot=0x0CEB, category='nd', description='KANNADA DIGIT FIVE' },
	[0x0CEC] = { unicodeslot=0x0CEC, category='nd', description='KANNADA DIGIT SIX' },
	[0x0CED] = { unicodeslot=0x0CED, category='nd', description='KANNADA DIGIT SEVEN' },
	[0x0CEE] = { unicodeslot=0x0CEE, category='nd', description='KANNADA DIGIT EIGHT' },
	[0x0CEF] = { unicodeslot=0x0CEF, category='nd', description='KANNADA DIGIT NINE' },
	[0x0CF1] = { unicodeslot=0x0CF1, category='so', description='KANNADA SIGN JIHVAMULIYA' },
	[0x0CF2] = { unicodeslot=0x0CF2, category='so', description='KANNADA SIGN UPADHMANIYA' },
	[0x0D02] = { unicodeslot=0x0D02, category='mc', description='MALAYALAM SIGN ANUSVARA' },
	[0x0D03] = { unicodeslot=0x0D03, category='mc', description='MALAYALAM SIGN VISARGA' },
	[0x0D05] = { unicodeslot=0x0D05, category='lo', description='MALAYALAM LETTER A' },
	[0x0D06] = { unicodeslot=0x0D06, category='lo', description='MALAYALAM LETTER AA' },
	[0x0D07] = { unicodeslot=0x0D07, category='lo', description='MALAYALAM LETTER I' },
	[0x0D08] = { unicodeslot=0x0D08, category='lo', description='MALAYALAM LETTER II' },
	[0x0D09] = { unicodeslot=0x0D09, category='lo', description='MALAYALAM LETTER U' },
	[0x0D0A] = { unicodeslot=0x0D0A, category='lo', description='MALAYALAM LETTER UU' },
	[0x0D0B] = { unicodeslot=0x0D0B, category='lo', description='MALAYALAM LETTER VOCALIC R' },
	[0x0D0C] = { unicodeslot=0x0D0C, category='lo', description='MALAYALAM LETTER VOCALIC L' },
	[0x0D0E] = { unicodeslot=0x0D0E, category='lo', description='MALAYALAM LETTER E' },
	[0x0D0F] = { unicodeslot=0x0D0F, category='lo', description='MALAYALAM LETTER EE' },
	[0x0D10] = { unicodeslot=0x0D10, category='lo', description='MALAYALAM LETTER AI' },
	[0x0D12] = { unicodeslot=0x0D12, category='lo', description='MALAYALAM LETTER O' },
	[0x0D13] = { unicodeslot=0x0D13, category='lo', description='MALAYALAM LETTER OO' },
	[0x0D14] = { unicodeslot=0x0D14, category='lo', description='MALAYALAM LETTER AU' },
	[0x0D15] = { unicodeslot=0x0D15, category='lo', description='MALAYALAM LETTER KA' },
	[0x0D16] = { unicodeslot=0x0D16, category='lo', description='MALAYALAM LETTER KHA' },
	[0x0D17] = { unicodeslot=0x0D17, category='lo', description='MALAYALAM LETTER GA' },
	[0x0D18] = { unicodeslot=0x0D18, category='lo', description='MALAYALAM LETTER GHA' },
	[0x0D19] = { unicodeslot=0x0D19, category='lo', description='MALAYALAM LETTER NGA' },
	[0x0D1A] = { unicodeslot=0x0D1A, category='lo', description='MALAYALAM LETTER CA' },
	[0x0D1B] = { unicodeslot=0x0D1B, category='lo', description='MALAYALAM LETTER CHA' },
	[0x0D1C] = { unicodeslot=0x0D1C, category='lo', description='MALAYALAM LETTER JA' },
	[0x0D1D] = { unicodeslot=0x0D1D, category='lo', description='MALAYALAM LETTER JHA' },
	[0x0D1E] = { unicodeslot=0x0D1E, category='lo', description='MALAYALAM LETTER NYA' },
	[0x0D1F] = { unicodeslot=0x0D1F, category='lo', description='MALAYALAM LETTER TTA' },
	[0x0D20] = { unicodeslot=0x0D20, category='lo', description='MALAYALAM LETTER TTHA' },
	[0x0D21] = { unicodeslot=0x0D21, category='lo', description='MALAYALAM LETTER DDA' },
	[0x0D22] = { unicodeslot=0x0D22, category='lo', description='MALAYALAM LETTER DDHA' },
	[0x0D23] = { unicodeslot=0x0D23, category='lo', description='MALAYALAM LETTER NNA' },
	[0x0D24] = { unicodeslot=0x0D24, category='lo', description='MALAYALAM LETTER TA' },
	[0x0D25] = { unicodeslot=0x0D25, category='lo', description='MALAYALAM LETTER THA' },
	[0x0D26] = { unicodeslot=0x0D26, category='lo', description='MALAYALAM LETTER DA' },
	[0x0D27] = { unicodeslot=0x0D27, category='lo', description='MALAYALAM LETTER DHA' },
	[0x0D28] = { unicodeslot=0x0D28, category='lo', description='MALAYALAM LETTER NA' },
	[0x0D2A] = { unicodeslot=0x0D2A, category='lo', description='MALAYALAM LETTER PA' },
	[0x0D2B] = { unicodeslot=0x0D2B, category='lo', description='MALAYALAM LETTER PHA' },
	[0x0D2C] = { unicodeslot=0x0D2C, category='lo', description='MALAYALAM LETTER BA' },
	[0x0D2D] = { unicodeslot=0x0D2D, category='lo', description='MALAYALAM LETTER BHA' },
	[0x0D2E] = { unicodeslot=0x0D2E, category='lo', description='MALAYALAM LETTER MA' },
	[0x0D2F] = { unicodeslot=0x0D2F, category='lo', description='MALAYALAM LETTER YA' },
	[0x0D30] = { unicodeslot=0x0D30, category='lo', description='MALAYALAM LETTER RA' },
	[0x0D31] = { unicodeslot=0x0D31, category='lo', description='MALAYALAM LETTER RRA' },
	[0x0D32] = { unicodeslot=0x0D32, category='lo', description='MALAYALAM LETTER LA' },
	[0x0D33] = { unicodeslot=0x0D33, category='lo', description='MALAYALAM LETTER LLA' },
	[0x0D34] = { unicodeslot=0x0D34, category='lo', description='MALAYALAM LETTER LLLA' },
	[0x0D35] = { unicodeslot=0x0D35, category='lo', description='MALAYALAM LETTER VA' },
	[0x0D36] = { unicodeslot=0x0D36, category='lo', description='MALAYALAM LETTER SHA' },
	[0x0D37] = { unicodeslot=0x0D37, category='lo', description='MALAYALAM LETTER SSA' },
	[0x0D38] = { unicodeslot=0x0D38, category='lo', description='MALAYALAM LETTER SA' },
	[0x0D39] = { unicodeslot=0x0D39, category='lo', description='MALAYALAM LETTER HA' },
	[0x0D3E] = { unicodeslot=0x0D3E, category='mc', description='MALAYALAM VOWEL SIGN AA' },
	[0x0D3F] = { unicodeslot=0x0D3F, category='mc', description='MALAYALAM VOWEL SIGN I' },
	[0x0D40] = { unicodeslot=0x0D40, category='mc', description='MALAYALAM VOWEL SIGN II' },
	[0x0D41] = { unicodeslot=0x0D41, category='mn', description='MALAYALAM VOWEL SIGN U' },
	[0x0D42] = { unicodeslot=0x0D42, category='mn', description='MALAYALAM VOWEL SIGN UU' },
	[0x0D43] = { unicodeslot=0x0D43, category='mn', description='MALAYALAM VOWEL SIGN VOCALIC R' },
	[0x0D46] = { unicodeslot=0x0D46, category='mc', description='MALAYALAM VOWEL SIGN E' },
	[0x0D47] = { unicodeslot=0x0D47, category='mc', description='MALAYALAM VOWEL SIGN EE' },
	[0x0D48] = { unicodeslot=0x0D48, category='mc', description='MALAYALAM VOWEL SIGN AI' },
	[0x0D4A] = { unicodeslot=0x0D4A, category='mc', description='MALAYALAM VOWEL SIGN O', specials={'char',0x0D46,0x0D3E} },
	[0x0D4B] = { unicodeslot=0x0D4B, category='mc', description='MALAYALAM VOWEL SIGN OO', specials={'char',0x0D47,0x0D3E} },
	[0x0D4C] = { unicodeslot=0x0D4C, category='mc', description='MALAYALAM VOWEL SIGN AU', specials={'char',0x0D46,0x0D57} },
	[0x0D4D] = { unicodeslot=0x0D4D, category='mn', description='MALAYALAM SIGN VIRAMA' },
	[0x0D57] = { unicodeslot=0x0D57, category='mc', description='MALAYALAM AU LENGTH MARK' },
	[0x0D60] = { unicodeslot=0x0D60, category='lo', description='MALAYALAM LETTER VOCALIC RR' },
	[0x0D61] = { unicodeslot=0x0D61, category='lo', description='MALAYALAM LETTER VOCALIC LL' },
	[0x0D66] = { unicodeslot=0x0D66, category='nd', description='MALAYALAM DIGIT ZERO' },
	[0x0D67] = { unicodeslot=0x0D67, category='nd', description='MALAYALAM DIGIT ONE' },
	[0x0D68] = { unicodeslot=0x0D68, category='nd', description='MALAYALAM DIGIT TWO' },
	[0x0D69] = { unicodeslot=0x0D69, category='nd', description='MALAYALAM DIGIT THREE' },
	[0x0D6A] = { unicodeslot=0x0D6A, category='nd', description='MALAYALAM DIGIT FOUR' },
	[0x0D6B] = { unicodeslot=0x0D6B, category='nd', description='MALAYALAM DIGIT FIVE' },
	[0x0D6C] = { unicodeslot=0x0D6C, category='nd', description='MALAYALAM DIGIT SIX' },
	[0x0D6D] = { unicodeslot=0x0D6D, category='nd', description='MALAYALAM DIGIT SEVEN' },
	[0x0D6E] = { unicodeslot=0x0D6E, category='nd', description='MALAYALAM DIGIT EIGHT' },
	[0x0D6F] = { unicodeslot=0x0D6F, category='nd', description='MALAYALAM DIGIT NINE' },
	[0x0D82] = { unicodeslot=0x0D82, category='mc', description='SINHALA SIGN ANUSVARAYA' },
	[0x0D83] = { unicodeslot=0x0D83, category='mc', description='SINHALA SIGN VISARGAYA' },
	[0x0D85] = { unicodeslot=0x0D85, category='lo', description='SINHALA LETTER AYANNA' },
	[0x0D86] = { unicodeslot=0x0D86, category='lo', description='SINHALA LETTER AAYANNA' },
	[0x0D87] = { unicodeslot=0x0D87, category='lo', description='SINHALA LETTER AEYANNA' },
	[0x0D88] = { unicodeslot=0x0D88, category='lo', description='SINHALA LETTER AEEYANNA' },
	[0x0D89] = { unicodeslot=0x0D89, category='lo', description='SINHALA LETTER IYANNA' },
	[0x0D8A] = { unicodeslot=0x0D8A, category='lo', description='SINHALA LETTER IIYANNA' },
	[0x0D8B] = { unicodeslot=0x0D8B, category='lo', description='SINHALA LETTER UYANNA' },
	[0x0D8C] = { unicodeslot=0x0D8C, category='lo', description='SINHALA LETTER UUYANNA' },
	[0x0D8D] = { unicodeslot=0x0D8D, category='lo', description='SINHALA LETTER IRUYANNA' },
	[0x0D8E] = { unicodeslot=0x0D8E, category='lo', description='SINHALA LETTER IRUUYANNA' },
	[0x0D8F] = { unicodeslot=0x0D8F, category='lo', description='SINHALA LETTER ILUYANNA' },
	[0x0D90] = { unicodeslot=0x0D90, category='lo', description='SINHALA LETTER ILUUYANNA' },
	[0x0D91] = { unicodeslot=0x0D91, category='lo', description='SINHALA LETTER EYANNA' },
	[0x0D92] = { unicodeslot=0x0D92, category='lo', description='SINHALA LETTER EEYANNA' },
	[0x0D93] = { unicodeslot=0x0D93, category='lo', description='SINHALA LETTER AIYANNA' },
	[0x0D94] = { unicodeslot=0x0D94, category='lo', description='SINHALA LETTER OYANNA' },
	[0x0D95] = { unicodeslot=0x0D95, category='lo', description='SINHALA LETTER OOYANNA' },
	[0x0D96] = { unicodeslot=0x0D96, category='lo', description='SINHALA LETTER AUYANNA' },
	[0x0D9A] = { unicodeslot=0x0D9A, category='lo', description='SINHALA LETTER ALPAPRAANA KAYANNA' },
	[0x0D9B] = { unicodeslot=0x0D9B, category='lo', description='SINHALA LETTER MAHAAPRAANA KAYANNA' },
	[0x0D9C] = { unicodeslot=0x0D9C, category='lo', description='SINHALA LETTER ALPAPRAANA GAYANNA' },
	[0x0D9D] = { unicodeslot=0x0D9D, category='lo', description='SINHALA LETTER MAHAAPRAANA GAYANNA' },
	[0x0D9E] = { unicodeslot=0x0D9E, category='lo', description='SINHALA LETTER KANTAJA NAASIKYAYA' },
	[0x0D9F] = { unicodeslot=0x0D9F, category='lo', description='SINHALA LETTER SANYAKA GAYANNA' },
	[0x0DA0] = { unicodeslot=0x0DA0, category='lo', description='SINHALA LETTER ALPAPRAANA CAYANNA' },
	[0x0DA1] = { unicodeslot=0x0DA1, category='lo', description='SINHALA LETTER MAHAAPRAANA CAYANNA' },
	[0x0DA2] = { unicodeslot=0x0DA2, category='lo', description='SINHALA LETTER ALPAPRAANA JAYANNA' },
	[0x0DA3] = { unicodeslot=0x0DA3, category='lo', description='SINHALA LETTER MAHAAPRAANA JAYANNA' },
	[0x0DA4] = { unicodeslot=0x0DA4, category='lo', description='SINHALA LETTER TAALUJA NAASIKYAYA' },
	[0x0DA5] = { unicodeslot=0x0DA5, category='lo', description='SINHALA LETTER TAALUJA SANYOOGA NAAKSIKYAYA' },
	[0x0DA6] = { unicodeslot=0x0DA6, category='lo', description='SINHALA LETTER SANYAKA JAYANNA' },
	[0x0DA7] = { unicodeslot=0x0DA7, category='lo', description='SINHALA LETTER ALPAPRAANA TTAYANNA' },
	[0x0DA8] = { unicodeslot=0x0DA8, category='lo', description='SINHALA LETTER MAHAAPRAANA TTAYANNA' },
	[0x0DA9] = { unicodeslot=0x0DA9, category='lo', description='SINHALA LETTER ALPAPRAANA DDAYANNA' },
	[0x0DAA] = { unicodeslot=0x0DAA, category='lo', description='SINHALA LETTER MAHAAPRAANA DDAYANNA' },
	[0x0DAB] = { unicodeslot=0x0DAB, category='lo', description='SINHALA LETTER MUURDHAJA NAYANNA' },
	[0x0DAC] = { unicodeslot=0x0DAC, category='lo', description='SINHALA LETTER SANYAKA DDAYANNA' },
	[0x0DAD] = { unicodeslot=0x0DAD, category='lo', description='SINHALA LETTER ALPAPRAANA TAYANNA' },
	[0x0DAE] = { unicodeslot=0x0DAE, category='lo', description='SINHALA LETTER MAHAAPRAANA TAYANNA' },
	[0x0DAF] = { unicodeslot=0x0DAF, category='lo', description='SINHALA LETTER ALPAPRAANA DAYANNA' },
	[0x0DB0] = { unicodeslot=0x0DB0, category='lo', description='SINHALA LETTER MAHAAPRAANA DAYANNA' },
	[0x0DB1] = { unicodeslot=0x0DB1, category='lo', description='SINHALA LETTER DANTAJA NAYANNA' },
	[0x0DB3] = { unicodeslot=0x0DB3, category='lo', description='SINHALA LETTER SANYAKA DAYANNA' },
	[0x0DB4] = { unicodeslot=0x0DB4, category='lo', description='SINHALA LETTER ALPAPRAANA PAYANNA' },
	[0x0DB5] = { unicodeslot=0x0DB5, category='lo', description='SINHALA LETTER MAHAAPRAANA PAYANNA' },
	[0x0DB6] = { unicodeslot=0x0DB6, category='lo', description='SINHALA LETTER ALPAPRAANA BAYANNA' },
	[0x0DB7] = { unicodeslot=0x0DB7, category='lo', description='SINHALA LETTER MAHAAPRAANA BAYANNA' },
	[0x0DB8] = { unicodeslot=0x0DB8, category='lo', description='SINHALA LETTER MAYANNA' },
	[0x0DB9] = { unicodeslot=0x0DB9, category='lo', description='SINHALA LETTER AMBA BAYANNA' },
	[0x0DBA] = { unicodeslot=0x0DBA, category='lo', description='SINHALA LETTER YAYANNA' },
	[0x0DBB] = { unicodeslot=0x0DBB, category='lo', description='SINHALA LETTER RAYANNA' },
	[0x0DBD] = { unicodeslot=0x0DBD, category='lo', description='SINHALA LETTER DANTAJA LAYANNA' },
	[0x0DC0] = { unicodeslot=0x0DC0, category='lo', description='SINHALA LETTER VAYANNA' },
	[0x0DC1] = { unicodeslot=0x0DC1, category='lo', description='SINHALA LETTER TAALUJA SAYANNA' },
	[0x0DC2] = { unicodeslot=0x0DC2, category='lo', description='SINHALA LETTER MUURDHAJA SAYANNA' },
	[0x0DC3] = { unicodeslot=0x0DC3, category='lo', description='SINHALA LETTER DANTAJA SAYANNA' },
	[0x0DC4] = { unicodeslot=0x0DC4, category='lo', description='SINHALA LETTER HAYANNA' },
	[0x0DC5] = { unicodeslot=0x0DC5, category='lo', description='SINHALA LETTER MUURDHAJA LAYANNA' },
	[0x0DC6] = { unicodeslot=0x0DC6, category='lo', description='SINHALA LETTER FAYANNA' },
	[0x0DCA] = { unicodeslot=0x0DCA, category='mn', description='SINHALA SIGN AL-LAKUNA' },
	[0x0DCF] = { unicodeslot=0x0DCF, category='mc', description='SINHALA VOWEL SIGN AELA-PILLA' },
	[0x0DD0] = { unicodeslot=0x0DD0, category='mc', description='SINHALA VOWEL SIGN KETTI AEDA-PILLA' },
	[0x0DD1] = { unicodeslot=0x0DD1, category='mc', description='SINHALA VOWEL SIGN DIGA AEDA-PILLA' },
	[0x0DD2] = { unicodeslot=0x0DD2, category='mn', description='SINHALA VOWEL SIGN KETTI IS-PILLA' },
	[0x0DD3] = { unicodeslot=0x0DD3, category='mn', description='SINHALA VOWEL SIGN DIGA IS-PILLA' },
	[0x0DD4] = { unicodeslot=0x0DD4, category='mn', description='SINHALA VOWEL SIGN KETTI PAA-PILLA' },
	[0x0DD6] = { unicodeslot=0x0DD6, category='mn', description='SINHALA VOWEL SIGN DIGA PAA-PILLA' },
	[0x0DD8] = { unicodeslot=0x0DD8, category='mc', description='SINHALA VOWEL SIGN GAETTA-PILLA' },
	[0x0DD9] = { unicodeslot=0x0DD9, category='mc', description='SINHALA VOWEL SIGN KOMBUVA' },
	[0x0DDA] = { unicodeslot=0x0DDA, category='mc', description='SINHALA VOWEL SIGN DIGA KOMBUVA', specials={'char',0x0DD9,0x0DCA} },
	[0x0DDB] = { unicodeslot=0x0DDB, category='mc', description='SINHALA VOWEL SIGN KOMBU DEKA' },
	[0x0DDC] = { unicodeslot=0x0DDC, category='mc', description='SINHALA VOWEL SIGN KOMBUVA HAA AELA-PILLA', specials={'char',0x0DD9,0x0DCF} },
	[0x0DDD] = { unicodeslot=0x0DDD, category='mc', description='SINHALA VOWEL SIGN KOMBUVA HAA DIGA AELA-PILLA', specials={'char',0x0DDC,0x0DCA} },
	[0x0DDE] = { unicodeslot=0x0DDE, category='mc', description='SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA', specials={'char',0x0DD9,0x0DDF} },
	[0x0DDF] = { unicodeslot=0x0DDF, category='mc', description='SINHALA VOWEL SIGN GAYANUKITTA' },
	[0x0DF2] = { unicodeslot=0x0DF2, category='mc', description='SINHALA VOWEL SIGN DIGA GAETTA-PILLA' },
	[0x0DF3] = { unicodeslot=0x0DF3, category='mc', description='SINHALA VOWEL SIGN DIGA GAYANUKITTA' },
	[0x0DF4] = { unicodeslot=0x0DF4, category='po', description='SINHALA PUNCTUATION KUNDDALIYA' },
	[0x0E01] = { unicodeslot=0x0E01, category='lo', description='THAI CHARACTER KO KAI' },
	[0x0E02] = { unicodeslot=0x0E02, category='lo', description='THAI CHARACTER KHO KHAI' },
	[0x0E03] = { unicodeslot=0x0E03, category='lo', description='THAI CHARACTER KHO KHUAT' },
	[0x0E04] = { unicodeslot=0x0E04, category='lo', description='THAI CHARACTER KHO KHWAI' },
	[0x0E05] = { unicodeslot=0x0E05, category='lo', description='THAI CHARACTER KHO KHON' },
	[0x0E06] = { unicodeslot=0x0E06, category='lo', description='THAI CHARACTER KHO RAKHANG' },
	[0x0E07] = { unicodeslot=0x0E07, category='lo', description='THAI CHARACTER NGO NGU' },
	[0x0E08] = { unicodeslot=0x0E08, category='lo', description='THAI CHARACTER CHO CHAN' },
	[0x0E09] = { unicodeslot=0x0E09, category='lo', description='THAI CHARACTER CHO CHING' },
	[0x0E0A] = { unicodeslot=0x0E0A, category='lo', description='THAI CHARACTER CHO CHANG' },
	[0x0E0B] = { unicodeslot=0x0E0B, category='lo', description='THAI CHARACTER SO SO' },
	[0x0E0C] = { unicodeslot=0x0E0C, category='lo', description='THAI CHARACTER CHO CHOE' },
	[0x0E0D] = { unicodeslot=0x0E0D, category='lo', description='THAI CHARACTER YO YING' },
	[0x0E0E] = { unicodeslot=0x0E0E, category='lo', description='THAI CHARACTER DO CHADA' },
	[0x0E0F] = { unicodeslot=0x0E0F, category='lo', description='THAI CHARACTER TO PATAK' },
	[0x0E10] = { unicodeslot=0x0E10, category='lo', description='THAI CHARACTER THO THAN' },
	[0x0E11] = { unicodeslot=0x0E11, category='lo', description='THAI CHARACTER THO NANGMONTHO' },
	[0x0E12] = { unicodeslot=0x0E12, category='lo', description='THAI CHARACTER THO PHUTHAO' },
	[0x0E13] = { unicodeslot=0x0E13, category='lo', description='THAI CHARACTER NO NEN' },
	[0x0E14] = { unicodeslot=0x0E14, category='lo', description='THAI CHARACTER DO DEK' },
	[0x0E15] = { unicodeslot=0x0E15, category='lo', description='THAI CHARACTER TO TAO' },
	[0x0E16] = { unicodeslot=0x0E16, category='lo', description='THAI CHARACTER THO THUNG' },
	[0x0E17] = { unicodeslot=0x0E17, category='lo', description='THAI CHARACTER THO THAHAN' },
	[0x0E18] = { unicodeslot=0x0E18, category='lo', description='THAI CHARACTER THO THONG' },
	[0x0E19] = { unicodeslot=0x0E19, category='lo', description='THAI CHARACTER NO NU' },
	[0x0E1A] = { unicodeslot=0x0E1A, category='lo', description='THAI CHARACTER BO BAIMAI' },
	[0x0E1B] = { unicodeslot=0x0E1B, category='lo', description='THAI CHARACTER PO PLA' },
	[0x0E1C] = { unicodeslot=0x0E1C, category='lo', description='THAI CHARACTER PHO PHUNG' },
	[0x0E1D] = { unicodeslot=0x0E1D, category='lo', description='THAI CHARACTER FO FA' },
	[0x0E1E] = { unicodeslot=0x0E1E, category='lo', description='THAI CHARACTER PHO PHAN' },
	[0x0E1F] = { unicodeslot=0x0E1F, category='lo', description='THAI CHARACTER FO FAN' },
	[0x0E20] = { unicodeslot=0x0E20, category='lo', description='THAI CHARACTER PHO SAMPHAO' },
	[0x0E21] = { unicodeslot=0x0E21, category='lo', description='THAI CHARACTER MO MA' },
	[0x0E22] = { unicodeslot=0x0E22, category='lo', description='THAI CHARACTER YO YAK' },
	[0x0E23] = { unicodeslot=0x0E23, category='lo', description='THAI CHARACTER RO RUA' },
	[0x0E24] = { unicodeslot=0x0E24, category='lo', description='THAI CHARACTER RU' },
	[0x0E25] = { unicodeslot=0x0E25, category='lo', description='THAI CHARACTER LO LING' },
	[0x0E26] = { unicodeslot=0x0E26, category='lo', description='THAI CHARACTER LU' },
	[0x0E27] = { unicodeslot=0x0E27, category='lo', description='THAI CHARACTER WO WAEN' },
	[0x0E28] = { unicodeslot=0x0E28, category='lo', description='THAI CHARACTER SO SALA' },
	[0x0E29] = { unicodeslot=0x0E29, category='lo', description='THAI CHARACTER SO RUSI' },
	[0x0E2A] = { unicodeslot=0x0E2A, category='lo', description='THAI CHARACTER SO SUA' },
	[0x0E2B] = { unicodeslot=0x0E2B, category='lo', description='THAI CHARACTER HO HIP' },
	[0x0E2C] = { unicodeslot=0x0E2C, category='lo', description='THAI CHARACTER LO CHULA' },
	[0x0E2D] = { unicodeslot=0x0E2D, category='lo', description='THAI CHARACTER O ANG' },
	[0x0E2E] = { unicodeslot=0x0E2E, category='lo', description='THAI CHARACTER HO NOKHUK' },
	[0x0E2F] = { unicodeslot=0x0E2F, category='lo', description='THAI CHARACTER PAIYANNOI' },
	[0x0E30] = { unicodeslot=0x0E30, category='lo', description='THAI CHARACTER SARA A' },
	[0x0E31] = { unicodeslot=0x0E31, category='mn', description='THAI CHARACTER MAI HAN-AKAT' },
	[0x0E32] = { unicodeslot=0x0E32, category='lo', description='THAI CHARACTER SARA AA' },
	[0x0E33] = { unicodeslot=0x0E33, category='lo', description='THAI CHARACTER SARA AM', specials={'compat',0x0E4D,0x0E32} },
	[0x0E34] = { unicodeslot=0x0E34, category='mn', description='THAI CHARACTER SARA I' },
	[0x0E35] = { unicodeslot=0x0E35, category='mn', description='THAI CHARACTER SARA II' },
	[0x0E36] = { unicodeslot=0x0E36, category='mn', description='THAI CHARACTER SARA UE' },
	[0x0E37] = { unicodeslot=0x0E37, category='mn', description='THAI CHARACTER SARA UEE' },
	[0x0E38] = { unicodeslot=0x0E38, category='mn', description='THAI CHARACTER SARA U' },
	[0x0E39] = { unicodeslot=0x0E39, category='mn', description='THAI CHARACTER SARA UU' },
	[0x0E3A] = { unicodeslot=0x0E3A, category='mn', description='THAI CHARACTER PHINTHU' },
	[0x0E3F] = { unicodeslot=0x0E3F, category='sc', description='THAI CURRENCY SYMBOL BAHT' },
	[0x0E40] = { unicodeslot=0x0E40, category='lo', description='THAI CHARACTER SARA E' },
	[0x0E41] = { unicodeslot=0x0E41, category='lo', description='THAI CHARACTER SARA AE' },
	[0x0E42] = { unicodeslot=0x0E42, category='lo', description='THAI CHARACTER SARA O' },
	[0x0E43] = { unicodeslot=0x0E43, category='lo', description='THAI CHARACTER SARA AI MAIMUAN' },
	[0x0E44] = { unicodeslot=0x0E44, category='lo', description='THAI CHARACTER SARA AI MAIMALAI' },
	[0x0E45] = { unicodeslot=0x0E45, category='lo', description='THAI CHARACTER LAKKHANGYAO' },
	[0x0E46] = { unicodeslot=0x0E46, category='lm', description='THAI CHARACTER MAIYAMOK' },
	[0x0E47] = { unicodeslot=0x0E47, category='mn', description='THAI CHARACTER MAITAIKHU' },
	[0x0E48] = { unicodeslot=0x0E48, category='mn', description='THAI CHARACTER MAI EK' },
	[0x0E49] = { unicodeslot=0x0E49, category='mn', description='THAI CHARACTER MAI THO' },
	[0x0E4A] = { unicodeslot=0x0E4A, category='mn', description='THAI CHARACTER MAI TRI' },
	[0x0E4B] = { unicodeslot=0x0E4B, category='mn', description='THAI CHARACTER MAI CHATTAWA' },
	[0x0E4C] = { unicodeslot=0x0E4C, category='mn', description='THAI CHARACTER THANTHAKHAT' },
	[0x0E4D] = { unicodeslot=0x0E4D, category='mn', description='THAI CHARACTER NIKHAHIT' },
	[0x0E4E] = { unicodeslot=0x0E4E, category='mn', description='THAI CHARACTER YAMAKKAN' },
	[0x0E4F] = { unicodeslot=0x0E4F, category='po', description='THAI CHARACTER FONGMAN' },
	[0x0E50] = { unicodeslot=0x0E50, category='nd', description='THAI DIGIT ZERO' },
	[0x0E51] = { unicodeslot=0x0E51, category='nd', description='THAI DIGIT ONE' },
	[0x0E52] = { unicodeslot=0x0E52, category='nd', description='THAI DIGIT TWO' },
	[0x0E53] = { unicodeslot=0x0E53, category='nd', description='THAI DIGIT THREE' },
	[0x0E54] = { unicodeslot=0x0E54, category='nd', description='THAI DIGIT FOUR' },
	[0x0E55] = { unicodeslot=0x0E55, category='nd', description='THAI DIGIT FIVE' },
	[0x0E56] = { unicodeslot=0x0E56, category='nd', description='THAI DIGIT SIX' },
	[0x0E57] = { unicodeslot=0x0E57, category='nd', description='THAI DIGIT SEVEN' },
	[0x0E58] = { unicodeslot=0x0E58, category='nd', description='THAI DIGIT EIGHT' },
	[0x0E59] = { unicodeslot=0x0E59, category='nd', description='THAI DIGIT NINE' },
	[0x0E5A] = { unicodeslot=0x0E5A, category='po', description='THAI CHARACTER ANGKHANKHU' },
	[0x0E5B] = { unicodeslot=0x0E5B, category='po', description='THAI CHARACTER KHOMUT' },
	[0x0E81] = { unicodeslot=0x0E81, category='lo', description='LAO LETTER KO' },
	[0x0E82] = { unicodeslot=0x0E82, category='lo', description='LAO LETTER KHO SUNG' },
	[0x0E84] = { unicodeslot=0x0E84, category='lo', description='LAO LETTER KHO TAM' },
	[0x0E87] = { unicodeslot=0x0E87, category='lo', description='LAO LETTER NGO' },
	[0x0E88] = { unicodeslot=0x0E88, category='lo', description='LAO LETTER CO' },
	[0x0E8A] = { unicodeslot=0x0E8A, category='lo', description='LAO LETTER SO TAM' },
	[0x0E8D] = { unicodeslot=0x0E8D, category='lo', description='LAO LETTER NYO' },
	[0x0E94] = { unicodeslot=0x0E94, category='lo', description='LAO LETTER DO' },
	[0x0E95] = { unicodeslot=0x0E95, category='lo', description='LAO LETTER TO' },
	[0x0E96] = { unicodeslot=0x0E96, category='lo', description='LAO LETTER THO SUNG' },
	[0x0E97] = { unicodeslot=0x0E97, category='lo', description='LAO LETTER THO TAM' },
	[0x0E99] = { unicodeslot=0x0E99, category='lo', description='LAO LETTER NO' },
	[0x0E9A] = { unicodeslot=0x0E9A, category='lo', description='LAO LETTER BO' },
	[0x0E9B] = { unicodeslot=0x0E9B, category='lo', description='LAO LETTER PO' },
	[0x0E9C] = { unicodeslot=0x0E9C, category='lo', description='LAO LETTER PHO SUNG' },
	[0x0E9D] = { unicodeslot=0x0E9D, category='lo', description='LAO LETTER FO TAM' },
	[0x0E9E] = { unicodeslot=0x0E9E, category='lo', description='LAO LETTER PHO TAM' },
	[0x0E9F] = { unicodeslot=0x0E9F, category='lo', description='LAO LETTER FO SUNG' },
	[0x0EA1] = { unicodeslot=0x0EA1, category='lo', description='LAO LETTER MO' },
	[0x0EA2] = { unicodeslot=0x0EA2, category='lo', description='LAO LETTER YO' },
	[0x0EA3] = { unicodeslot=0x0EA3, category='lo', description='LAO LETTER LO LING' },
	[0x0EA5] = { unicodeslot=0x0EA5, category='lo', description='LAO LETTER LO LOOT' },
	[0x0EA7] = { unicodeslot=0x0EA7, category='lo', description='LAO LETTER WO' },
	[0x0EAA] = { unicodeslot=0x0EAA, category='lo', description='LAO LETTER SO SUNG' },
	[0x0EAB] = { unicodeslot=0x0EAB, category='lo', description='LAO LETTER HO SUNG' },
	[0x0EAD] = { unicodeslot=0x0EAD, category='lo', description='LAO LETTER O' },
	[0x0EAE] = { unicodeslot=0x0EAE, category='lo', description='LAO LETTER HO TAM' },
	[0x0EAF] = { unicodeslot=0x0EAF, category='lo', description='LAO ELLIPSIS' },
	[0x0EB0] = { unicodeslot=0x0EB0, category='lo', description='LAO VOWEL SIGN A' },
	[0x0EB1] = { unicodeslot=0x0EB1, category='mn', description='LAO VOWEL SIGN MAI KAN' },
	[0x0EB2] = { unicodeslot=0x0EB2, category='lo', description='LAO VOWEL SIGN AA' },
	[0x0EB3] = { unicodeslot=0x0EB3, category='lo', description='LAO VOWEL SIGN AM', specials={'compat',0x0ECD,0x0EB2} },
	[0x0EB4] = { unicodeslot=0x0EB4, category='mn', description='LAO VOWEL SIGN I' },
	[0x0EB5] = { unicodeslot=0x0EB5, category='mn', description='LAO VOWEL SIGN II' },
	[0x0EB6] = { unicodeslot=0x0EB6, category='mn', description='LAO VOWEL SIGN Y' },
	[0x0EB7] = { unicodeslot=0x0EB7, category='mn', description='LAO VOWEL SIGN YY' },
	[0x0EB8] = { unicodeslot=0x0EB8, category='mn', description='LAO VOWEL SIGN U' },
	[0x0EB9] = { unicodeslot=0x0EB9, category='mn', description='LAO VOWEL SIGN UU' },
	[0x0EBB] = { unicodeslot=0x0EBB, category='mn', description='LAO VOWEL SIGN MAI KON' },
	[0x0EBC] = { unicodeslot=0x0EBC, category='mn', description='LAO SEMIVOWEL SIGN LO' },
	[0x0EBD] = { unicodeslot=0x0EBD, category='lo', description='LAO SEMIVOWEL SIGN NYO' },
	[0x0EC0] = { unicodeslot=0x0EC0, category='lo', description='LAO VOWEL SIGN E' },
	[0x0EC1] = { unicodeslot=0x0EC1, category='lo', description='LAO VOWEL SIGN EI' },
	[0x0EC2] = { unicodeslot=0x0EC2, category='lo', description='LAO VOWEL SIGN O' },
	[0x0EC3] = { unicodeslot=0x0EC3, category='lo', description='LAO VOWEL SIGN AY' },
	[0x0EC4] = { unicodeslot=0x0EC4, category='lo', description='LAO VOWEL SIGN AI' },
	[0x0EC6] = { unicodeslot=0x0EC6, category='lm', description='LAO KO LA' },
	[0x0EC8] = { unicodeslot=0x0EC8, category='mn', description='LAO TONE MAI EK' },
	[0x0EC9] = { unicodeslot=0x0EC9, category='mn', description='LAO TONE MAI THO' },
	[0x0ECA] = { unicodeslot=0x0ECA, category='mn', description='LAO TONE MAI TI' },
	[0x0ECB] = { unicodeslot=0x0ECB, category='mn', description='LAO TONE MAI CATAWA' },
	[0x0ECC] = { unicodeslot=0x0ECC, category='mn', description='LAO CANCELLATION MARK' },
	[0x0ECD] = { unicodeslot=0x0ECD, category='mn', description='LAO NIGGAHITA' },
	[0x0ED0] = { unicodeslot=0x0ED0, category='nd', description='LAO DIGIT ZERO' },
	[0x0ED1] = { unicodeslot=0x0ED1, category='nd', description='LAO DIGIT ONE' },
	[0x0ED2] = { unicodeslot=0x0ED2, category='nd', description='LAO DIGIT TWO' },
	[0x0ED3] = { unicodeslot=0x0ED3, category='nd', description='LAO DIGIT THREE' },
	[0x0ED4] = { unicodeslot=0x0ED4, category='nd', description='LAO DIGIT FOUR' },
	[0x0ED5] = { unicodeslot=0x0ED5, category='nd', description='LAO DIGIT FIVE' },
	[0x0ED6] = { unicodeslot=0x0ED6, category='nd', description='LAO DIGIT SIX' },
	[0x0ED7] = { unicodeslot=0x0ED7, category='nd', description='LAO DIGIT SEVEN' },
	[0x0ED8] = { unicodeslot=0x0ED8, category='nd', description='LAO DIGIT EIGHT' },
	[0x0ED9] = { unicodeslot=0x0ED9, category='nd', description='LAO DIGIT NINE' },
	[0x0EDC] = { unicodeslot=0x0EDC, category='lo', description='LAO HO NO', specials={'compat',0x0EAB,0x0E99} },
	[0x0EDD] = { unicodeslot=0x0EDD, category='lo', description='LAO HO MO', specials={'compat',0x0EAB,0x0EA1} },
	[0x0F00] = { unicodeslot=0x0F00, category='lo', description='TIBETAN SYLLABLE OM' },
	[0x0F01] = { unicodeslot=0x0F01, category='so', description='TIBETAN MARK GTER YIG MGO TRUNCATED A' },
	[0x0F02] = { unicodeslot=0x0F02, category='so', description='TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA' },
	[0x0F03] = { unicodeslot=0x0F03, category='so', description='TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA' },
	[0x0F04] = { unicodeslot=0x0F04, category='po', description='TIBETAN MARK INITIAL YIG MGO MDUN MA' },
	[0x0F05] = { unicodeslot=0x0F05, category='po', description='TIBETAN MARK CLOSING YIG MGO SGAB MA' },
	[0x0F06] = { unicodeslot=0x0F06, category='po', description='TIBETAN MARK CARET YIG MGO PHUR SHAD MA' },
	[0x0F07] = { unicodeslot=0x0F07, category='po', description='TIBETAN MARK YIG MGO TSHEG SHAD MA' },
	[0x0F08] = { unicodeslot=0x0F08, category='po', description='TIBETAN MARK SBRUL SHAD' },
	[0x0F09] = { unicodeslot=0x0F09, category='po', description='TIBETAN MARK BSKUR YIG MGO' },
	[0x0F0A] = { unicodeslot=0x0F0A, category='po', description='TIBETAN MARK BKA- SHOG YIG MGO' },
	[0x0F0B] = { unicodeslot=0x0F0B, category='po', description='TIBETAN MARK INTERSYLLABIC TSHEG' },
	[0x0F0C] = { unicodeslot=0x0F0C, category='po', description='TIBETAN MARK DELIMITER TSHEG BSTAR', specials={'nobreak',0x0F0B} },
	[0x0F0D] = { unicodeslot=0x0F0D, category='po', description='TIBETAN MARK SHAD' },
	[0x0F0E] = { unicodeslot=0x0F0E, category='po', description='TIBETAN MARK NYIS SHAD' },
	[0x0F0F] = { unicodeslot=0x0F0F, category='po', description='TIBETAN MARK TSHEG SHAD' },
	[0x0F10] = { unicodeslot=0x0F10, category='po', description='TIBETAN MARK NYIS TSHEG SHAD' },
	[0x0F11] = { unicodeslot=0x0F11, category='po', description='TIBETAN MARK RIN CHEN SPUNGS SHAD' },
	[0x0F12] = { unicodeslot=0x0F12, category='po', description='TIBETAN MARK RGYA GRAM SHAD' },
	[0x0F13] = { unicodeslot=0x0F13, category='so', description='TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN' },
	[0x0F14] = { unicodeslot=0x0F14, category='so', description='TIBETAN MARK GTER TSHEG' },
	[0x0F15] = { unicodeslot=0x0F15, category='so', description='TIBETAN LOGOTYPE SIGN CHAD RTAGS' },
	[0x0F16] = { unicodeslot=0x0F16, category='so', description='TIBETAN LOGOTYPE SIGN LHAG RTAGS' },
	[0x0F17] = { unicodeslot=0x0F17, category='so', description='TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS' },
	[0x0F18] = { unicodeslot=0x0F18, category='mn', description='TIBETAN ASTROLOGICAL SIGN -KHYUD PA' },
	[0x0F19] = { unicodeslot=0x0F19, category='mn', description='TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS' },
	[0x0F1A] = { unicodeslot=0x0F1A, category='so', description='TIBETAN SIGN RDEL DKAR GCIG' },
	[0x0F1B] = { unicodeslot=0x0F1B, category='so', description='TIBETAN SIGN RDEL DKAR GNYIS' },
	[0x0F1C] = { unicodeslot=0x0F1C, category='so', description='TIBETAN SIGN RDEL DKAR GSUM' },
	[0x0F1D] = { unicodeslot=0x0F1D, category='so', description='TIBETAN SIGN RDEL NAG GCIG' },
	[0x0F1E] = { unicodeslot=0x0F1E, category='so', description='TIBETAN SIGN RDEL NAG GNYIS' },
	[0x0F1F] = { unicodeslot=0x0F1F, category='so', description='TIBETAN SIGN RDEL DKAR RDEL NAG' },
	[0x0F20] = { unicodeslot=0x0F20, category='nd', description='TIBETAN DIGIT ZERO' },
	[0x0F21] = { unicodeslot=0x0F21, category='nd', description='TIBETAN DIGIT ONE' },
	[0x0F22] = { unicodeslot=0x0F22, category='nd', description='TIBETAN DIGIT TWO' },
	[0x0F23] = { unicodeslot=0x0F23, category='nd', description='TIBETAN DIGIT THREE' },
	[0x0F24] = { unicodeslot=0x0F24, category='nd', description='TIBETAN DIGIT FOUR' },
	[0x0F25] = { unicodeslot=0x0F25, category='nd', description='TIBETAN DIGIT FIVE' },
	[0x0F26] = { unicodeslot=0x0F26, category='nd', description='TIBETAN DIGIT SIX' },
	[0x0F27] = { unicodeslot=0x0F27, category='nd', description='TIBETAN DIGIT SEVEN' },
	[0x0F28] = { unicodeslot=0x0F28, category='nd', description='TIBETAN DIGIT EIGHT' },
	[0x0F29] = { unicodeslot=0x0F29, category='nd', description='TIBETAN DIGIT NINE' },
	[0x0F2A] = { unicodeslot=0x0F2A, category='no', description='TIBETAN DIGIT HALF ONE' },
	[0x0F2B] = { unicodeslot=0x0F2B, category='no', description='TIBETAN DIGIT HALF TWO' },
	[0x0F2C] = { unicodeslot=0x0F2C, category='no', description='TIBETAN DIGIT HALF THREE' },
	[0x0F2D] = { unicodeslot=0x0F2D, category='no', description='TIBETAN DIGIT HALF FOUR' },
	[0x0F2E] = { unicodeslot=0x0F2E, category='no', description='TIBETAN DIGIT HALF FIVE' },
	[0x0F2F] = { unicodeslot=0x0F2F, category='no', description='TIBETAN DIGIT HALF SIX' },
	[0x0F30] = { unicodeslot=0x0F30, category='no', description='TIBETAN DIGIT HALF SEVEN' },
	[0x0F31] = { unicodeslot=0x0F31, category='no', description='TIBETAN DIGIT HALF EIGHT' },
	[0x0F32] = { unicodeslot=0x0F32, category='no', description='TIBETAN DIGIT HALF NINE' },
	[0x0F33] = { unicodeslot=0x0F33, category='no', description='TIBETAN DIGIT HALF ZERO' },
	[0x0F34] = { unicodeslot=0x0F34, category='so', description='TIBETAN MARK BSDUS RTAGS' },
	[0x0F35] = { unicodeslot=0x0F35, category='mn', description='TIBETAN MARK NGAS BZUNG NYI ZLA' },
	[0x0F36] = { unicodeslot=0x0F36, category='so', description='TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN' },
	[0x0F37] = { unicodeslot=0x0F37, category='mn', description='TIBETAN MARK NGAS BZUNG SGOR RTAGS' },
	[0x0F38] = { unicodeslot=0x0F38, category='so', description='TIBETAN MARK CHE MGO' },
	[0x0F39] = { unicodeslot=0x0F39, category='mn', description='TIBETAN MARK TSA -PHRU' },
	[0x0F3A] = { unicodeslot=0x0F3A, category='ps', description='TIBETAN MARK GUG RTAGS GYON' },
	[0x0F3B] = { unicodeslot=0x0F3B, category='pe', description='TIBETAN MARK GUG RTAGS GYAS' },
	[0x0F3C] = { unicodeslot=0x0F3C, category='ps', description='TIBETAN MARK ANG KHANG GYON' },
	[0x0F3D] = { unicodeslot=0x0F3D, category='pe', description='TIBETAN MARK ANG KHANG GYAS' },
	[0x0F3E] = { unicodeslot=0x0F3E, category='mc', description='TIBETAN SIGN YAR TSHES' },
	[0x0F3F] = { unicodeslot=0x0F3F, category='mc', description='TIBETAN SIGN MAR TSHES' },
	[0x0F40] = { unicodeslot=0x0F40, category='lo', description='TIBETAN LETTER KA' },
	[0x0F41] = { unicodeslot=0x0F41, category='lo', description='TIBETAN LETTER KHA' },
	[0x0F42] = { unicodeslot=0x0F42, category='lo', description='TIBETAN LETTER GA' },
	[0x0F43] = { unicodeslot=0x0F43, category='lo', description='TIBETAN LETTER GHA', specials={'char',0x0F42,0x0FB7} },
	[0x0F44] = { unicodeslot=0x0F44, category='lo', description='TIBETAN LETTER NGA' },
	[0x0F45] = { unicodeslot=0x0F45, category='lo', description='TIBETAN LETTER CA' },
	[0x0F46] = { unicodeslot=0x0F46, category='lo', description='TIBETAN LETTER CHA' },
	[0x0F47] = { unicodeslot=0x0F47, category='lo', description='TIBETAN LETTER JA' },
	[0x0F49] = { unicodeslot=0x0F49, category='lo', description='TIBETAN LETTER NYA' },
	[0x0F4A] = { unicodeslot=0x0F4A, category='lo', description='TIBETAN LETTER TTA' },
	[0x0F4B] = { unicodeslot=0x0F4B, category='lo', description='TIBETAN LETTER TTHA' },
	[0x0F4C] = { unicodeslot=0x0F4C, category='lo', description='TIBETAN LETTER DDA' },
	[0x0F4D] = { unicodeslot=0x0F4D, category='lo', description='TIBETAN LETTER DDHA', specials={'char',0x0F4C,0x0FB7} },
	[0x0F4E] = { unicodeslot=0x0F4E, category='lo', description='TIBETAN LETTER NNA' },
	[0x0F4F] = { unicodeslot=0x0F4F, category='lo', description='TIBETAN LETTER TA' },
	[0x0F50] = { unicodeslot=0x0F50, category='lo', description='TIBETAN LETTER THA' },
	[0x0F51] = { unicodeslot=0x0F51, category='lo', description='TIBETAN LETTER DA' },
	[0x0F52] = { unicodeslot=0x0F52, category='lo', description='TIBETAN LETTER DHA', specials={'char',0x0F51,0x0FB7} },
	[0x0F53] = { unicodeslot=0x0F53, category='lo', description='TIBETAN LETTER NA' },
	[0x0F54] = { unicodeslot=0x0F54, category='lo', description='TIBETAN LETTER PA' },
	[0x0F55] = { unicodeslot=0x0F55, category='lo', description='TIBETAN LETTER PHA' },
	[0x0F56] = { unicodeslot=0x0F56, category='lo', description='TIBETAN LETTER BA' },
	[0x0F57] = { unicodeslot=0x0F57, category='lo', description='TIBETAN LETTER BHA', specials={'char',0x0F56,0x0FB7} },
	[0x0F58] = { unicodeslot=0x0F58, category='lo', description='TIBETAN LETTER MA' },
	[0x0F59] = { unicodeslot=0x0F59, category='lo', description='TIBETAN LETTER TSA' },
	[0x0F5A] = { unicodeslot=0x0F5A, category='lo', description='TIBETAN LETTER TSHA' },
	[0x0F5B] = { unicodeslot=0x0F5B, category='lo', description='TIBETAN LETTER DZA' },
	[0x0F5C] = { unicodeslot=0x0F5C, category='lo', description='TIBETAN LETTER DZHA', specials={'char',0x0F5B,0x0FB7} },
	[0x0F5D] = { unicodeslot=0x0F5D, category='lo', description='TIBETAN LETTER WA' },
	[0x0F5E] = { unicodeslot=0x0F5E, category='lo', description='TIBETAN LETTER ZHA' },
	[0x0F5F] = { unicodeslot=0x0F5F, category='lo', description='TIBETAN LETTER ZA' },
	[0x0F60] = { unicodeslot=0x0F60, category='lo', description='TIBETAN LETTER -A' },
	[0x0F61] = { unicodeslot=0x0F61, category='lo', description='TIBETAN LETTER YA' },
	[0x0F62] = { unicodeslot=0x0F62, category='lo', description='TIBETAN LETTER RA' },
	[0x0F63] = { unicodeslot=0x0F63, category='lo', description='TIBETAN LETTER LA' },
	[0x0F64] = { unicodeslot=0x0F64, category='lo', description='TIBETAN LETTER SHA' },
	[0x0F65] = { unicodeslot=0x0F65, category='lo', description='TIBETAN LETTER SSA' },
	[0x0F66] = { unicodeslot=0x0F66, category='lo', description='TIBETAN LETTER SA' },
	[0x0F67] = { unicodeslot=0x0F67, category='lo', description='TIBETAN LETTER HA' },
	[0x0F68] = { unicodeslot=0x0F68, category='lo', description='TIBETAN LETTER A' },
	[0x0F69] = { unicodeslot=0x0F69, category='lo', description='TIBETAN LETTER KSSA', specials={'char',0x0F40,0x0FB5} },
	[0x0F6A] = { unicodeslot=0x0F6A, category='lo', description='TIBETAN LETTER FIXED-FORM RA' },
	[0x0F71] = { unicodeslot=0x0F71, category='mn', description='TIBETAN VOWEL SIGN AA' },
	[0x0F72] = { unicodeslot=0x0F72, category='mn', description='TIBETAN VOWEL SIGN I' },
	[0x0F73] = { unicodeslot=0x0F73, category='mn', description='TIBETAN VOWEL SIGN II', specials={'char',0x0F71,0x0F72} },
	[0x0F74] = { unicodeslot=0x0F74, category='mn', description='TIBETAN VOWEL SIGN U' },
	[0x0F75] = { unicodeslot=0x0F75, category='mn', description='TIBETAN VOWEL SIGN UU', specials={'char',0x0F71,0x0F74} },
	[0x0F76] = { unicodeslot=0x0F76, category='mn', description='TIBETAN VOWEL SIGN VOCALIC R', specials={'char',0x0FB2,0x0F80} },
	[0x0F77] = { unicodeslot=0x0F77, category='mn', description='TIBETAN VOWEL SIGN VOCALIC RR', specials={'compat',0x0FB2,0x0F81} },
	[0x0F78] = { unicodeslot=0x0F78, category='mn', description='TIBETAN VOWEL SIGN VOCALIC L', specials={'char',0x0FB3,0x0F80} },
	[0x0F79] = { unicodeslot=0x0F79, category='mn', description='TIBETAN VOWEL SIGN VOCALIC LL', specials={'compat',0x0FB3,0x0F81} },
	[0x0F7A] = { unicodeslot=0x0F7A, category='mn', description='TIBETAN VOWEL SIGN E' },
	[0x0F7B] = { unicodeslot=0x0F7B, category='mn', description='TIBETAN VOWEL SIGN EE' },
	[0x0F7C] = { unicodeslot=0x0F7C, category='mn', description='TIBETAN VOWEL SIGN O' },
	[0x0F7D] = { unicodeslot=0x0F7D, category='mn', description='TIBETAN VOWEL SIGN OO' },
	[0x0F7E] = { unicodeslot=0x0F7E, category='mn', description='TIBETAN SIGN RJES SU NGA RO' },
	[0x0F7F] = { unicodeslot=0x0F7F, category='mc', description='TIBETAN SIGN RNAM BCAD' },
	[0x0F80] = { unicodeslot=0x0F80, category='mn', description='TIBETAN VOWEL SIGN REVERSED I' },
	[0x0F81] = { unicodeslot=0x0F81, category='mn', description='TIBETAN VOWEL SIGN REVERSED II', specials={'char',0x0F71,0x0F80} },
	[0x0F82] = { unicodeslot=0x0F82, category='mn', description='TIBETAN SIGN NYI ZLA NAA DA' },
	[0x0F83] = { unicodeslot=0x0F83, category='mn', description='TIBETAN SIGN SNA LDAN' },
	[0x0F84] = { unicodeslot=0x0F84, category='mn', description='TIBETAN MARK HALANTA' },
	[0x0F85] = { unicodeslot=0x0F85, category='po', description='TIBETAN MARK PALUTA' },
	[0x0F86] = { unicodeslot=0x0F86, category='mn', description='TIBETAN SIGN LCI RTAGS' },
	[0x0F87] = { unicodeslot=0x0F87, category='mn', description='TIBETAN SIGN YANG RTAGS' },
	[0x0F88] = { unicodeslot=0x0F88, category='lo', description='TIBETAN SIGN LCE TSA CAN' },
	[0x0F89] = { unicodeslot=0x0F89, category='lo', description='TIBETAN SIGN MCHU CAN' },
	[0x0F8A] = { unicodeslot=0x0F8A, category='lo', description='TIBETAN SIGN GRU CAN RGYINGS' },
	[0x0F8B] = { unicodeslot=0x0F8B, category='lo', description='TIBETAN SIGN GRU MED RGYINGS' },
	[0x0F90] = { unicodeslot=0x0F90, category='mn', description='TIBETAN SUBJOINED LETTER KA' },
	[0x0F91] = { unicodeslot=0x0F91, category='mn', description='TIBETAN SUBJOINED LETTER KHA' },
	[0x0F92] = { unicodeslot=0x0F92, category='mn', description='TIBETAN SUBJOINED LETTER GA' },
	[0x0F93] = { unicodeslot=0x0F93, category='mn', description='TIBETAN SUBJOINED LETTER GHA', specials={'char',0x0F92,0x0FB7} },
	[0x0F94] = { unicodeslot=0x0F94, category='mn', description='TIBETAN SUBJOINED LETTER NGA' },
	[0x0F95] = { unicodeslot=0x0F95, category='mn', description='TIBETAN SUBJOINED LETTER CA' },
	[0x0F96] = { unicodeslot=0x0F96, category='mn', description='TIBETAN SUBJOINED LETTER CHA' },
	[0x0F97] = { unicodeslot=0x0F97, category='mn', description='TIBETAN SUBJOINED LETTER JA' },
	[0x0F99] = { unicodeslot=0x0F99, category='mn', description='TIBETAN SUBJOINED LETTER NYA' },
	[0x0F9A] = { unicodeslot=0x0F9A, category='mn', description='TIBETAN SUBJOINED LETTER TTA' },
	[0x0F9B] = { unicodeslot=0x0F9B, category='mn', description='TIBETAN SUBJOINED LETTER TTHA' },
	[0x0F9C] = { unicodeslot=0x0F9C, category='mn', description='TIBETAN SUBJOINED LETTER DDA' },
	[0x0F9D] = { unicodeslot=0x0F9D, category='mn', description='TIBETAN SUBJOINED LETTER DDHA', specials={'char',0x0F9C,0x0FB7} },
	[0x0F9E] = { unicodeslot=0x0F9E, category='mn', description='TIBETAN SUBJOINED LETTER NNA' },
	[0x0F9F] = { unicodeslot=0x0F9F, category='mn', description='TIBETAN SUBJOINED LETTER TA' },
	[0x0FA0] = { unicodeslot=0x0FA0, category='mn', description='TIBETAN SUBJOINED LETTER THA' },
	[0x0FA1] = { unicodeslot=0x0FA1, category='mn', description='TIBETAN SUBJOINED LETTER DA' },
	[0x0FA2] = { unicodeslot=0x0FA2, category='mn', description='TIBETAN SUBJOINED LETTER DHA', specials={'char',0x0FA1,0x0FB7} },
	[0x0FA3] = { unicodeslot=0x0FA3, category='mn', description='TIBETAN SUBJOINED LETTER NA' },
	[0x0FA4] = { unicodeslot=0x0FA4, category='mn', description='TIBETAN SUBJOINED LETTER PA' },
	[0x0FA5] = { unicodeslot=0x0FA5, category='mn', description='TIBETAN SUBJOINED LETTER PHA' },
	[0x0FA6] = { unicodeslot=0x0FA6, category='mn', description='TIBETAN SUBJOINED LETTER BA' },
	[0x0FA7] = { unicodeslot=0x0FA7, category='mn', description='TIBETAN SUBJOINED LETTER BHA', specials={'char',0x0FA6,0x0FB7} },
	[0x0FA8] = { unicodeslot=0x0FA8, category='mn', description='TIBETAN SUBJOINED LETTER MA' },
	[0x0FA9] = { unicodeslot=0x0FA9, category='mn', description='TIBETAN SUBJOINED LETTER TSA' },
	[0x0FAA] = { unicodeslot=0x0FAA, category='mn', description='TIBETAN SUBJOINED LETTER TSHA' },
	[0x0FAB] = { unicodeslot=0x0FAB, category='mn', description='TIBETAN SUBJOINED LETTER DZA' },
	[0x0FAC] = { unicodeslot=0x0FAC, category='mn', description='TIBETAN SUBJOINED LETTER DZHA', specials={'char',0x0FAB,0x0FB7} },
	[0x0FAD] = { unicodeslot=0x0FAD, category='mn', description='TIBETAN SUBJOINED LETTER WA' },
	[0x0FAE] = { unicodeslot=0x0FAE, category='mn', description='TIBETAN SUBJOINED LETTER ZHA' },
	[0x0FAF] = { unicodeslot=0x0FAF, category='mn', description='TIBETAN SUBJOINED LETTER ZA' },
	[0x0FB0] = { unicodeslot=0x0FB0, category='mn', description='TIBETAN SUBJOINED LETTER -A' },
	[0x0FB1] = { unicodeslot=0x0FB1, category='mn', description='TIBETAN SUBJOINED LETTER YA' },
	[0x0FB2] = { unicodeslot=0x0FB2, category='mn', description='TIBETAN SUBJOINED LETTER RA' },
	[0x0FB3] = { unicodeslot=0x0FB3, category='mn', description='TIBETAN SUBJOINED LETTER LA' },
	[0x0FB4] = { unicodeslot=0x0FB4, category='mn', description='TIBETAN SUBJOINED LETTER SHA' },
	[0x0FB5] = { unicodeslot=0x0FB5, category='mn', description='TIBETAN SUBJOINED LETTER SSA' },
	[0x0FB6] = { unicodeslot=0x0FB6, category='mn', description='TIBETAN SUBJOINED LETTER SA' },
	[0x0FB7] = { unicodeslot=0x0FB7, category='mn', description='TIBETAN SUBJOINED LETTER HA' },
	[0x0FB8] = { unicodeslot=0x0FB8, category='mn', description='TIBETAN SUBJOINED LETTER A' },
	[0x0FB9] = { unicodeslot=0x0FB9, category='mn', description='TIBETAN SUBJOINED LETTER KSSA', specials={'char',0x0F90,0x0FB5} },
	[0x0FBA] = { unicodeslot=0x0FBA, category='mn', description='TIBETAN SUBJOINED LETTER FIXED-FORM WA' },
	[0x0FBB] = { unicodeslot=0x0FBB, category='mn', description='TIBETAN SUBJOINED LETTER FIXED-FORM YA' },
	[0x0FBC] = { unicodeslot=0x0FBC, category='mn', description='TIBETAN SUBJOINED LETTER FIXED-FORM RA' },
	[0x0FBE] = { unicodeslot=0x0FBE, category='so', description='TIBETAN KU RU KHA' },
	[0x0FBF] = { unicodeslot=0x0FBF, category='so', description='TIBETAN KU RU KHA BZHI MIG CAN' },
	[0x0FC0] = { unicodeslot=0x0FC0, category='so', description='TIBETAN CANTILLATION SIGN HEAVY BEAT' },
	[0x0FC1] = { unicodeslot=0x0FC1, category='so', description='TIBETAN CANTILLATION SIGN LIGHT BEAT' },
	[0x0FC2] = { unicodeslot=0x0FC2, category='so', description='TIBETAN CANTILLATION SIGN CANG TE-U' },
	[0x0FC3] = { unicodeslot=0x0FC3, category='so', description='TIBETAN CANTILLATION SIGN SBUB -CHAL' },
	[0x0FC4] = { unicodeslot=0x0FC4, category='so', description='TIBETAN SYMBOL DRIL BU' },
	[0x0FC5] = { unicodeslot=0x0FC5, category='so', description='TIBETAN SYMBOL RDO RJE' },
	[0x0FC6] = { unicodeslot=0x0FC6, category='mn', description='TIBETAN SYMBOL PADMA GDAN' },
	[0x0FC7] = { unicodeslot=0x0FC7, category='so', description='TIBETAN SYMBOL RDO RJE RGYA GRAM' },
	[0x0FC8] = { unicodeslot=0x0FC8, category='so', description='TIBETAN SYMBOL PHUR PA' },
	[0x0FC9] = { unicodeslot=0x0FC9, category='so', description='TIBETAN SYMBOL NOR BU' },
	[0x0FCA] = { unicodeslot=0x0FCA, category='so', description='TIBETAN SYMBOL NOR BU NYIS -KHYIL' },
	[0x0FCB] = { unicodeslot=0x0FCB, category='so', description='TIBETAN SYMBOL NOR BU GSUM -KHYIL' },
	[0x0FCC] = { unicodeslot=0x0FCC, category='so', description='TIBETAN SYMBOL NOR BU BZHI -KHYIL' },
	[0x0FCF] = { unicodeslot=0x0FCF, category='so', description='TIBETAN SIGN RDEL NAG GSUM' },
	[0x0FD0] = { unicodeslot=0x0FD0, category='po', description='TIBETAN MARK BSKA- SHOG GI MGO RGYAN' },
	[0x0FD1] = { unicodeslot=0x0FD1, category='po', description='TIBETAN MARK MNYAM YIG GI MGO RGYAN' },
	[0x1000] = { unicodeslot=0x1000, category='lo', description='MYANMAR LETTER KA' },
	[0x1001] = { unicodeslot=0x1001, category='lo', description='MYANMAR LETTER KHA' },
	[0x1002] = { unicodeslot=0x1002, category='lo', description='MYANMAR LETTER GA' },
	[0x1003] = { unicodeslot=0x1003, category='lo', description='MYANMAR LETTER GHA' },
	[0x1004] = { unicodeslot=0x1004, category='lo', description='MYANMAR LETTER NGA' },
	[0x1005] = { unicodeslot=0x1005, category='lo', description='MYANMAR LETTER CA' },
	[0x1006] = { unicodeslot=0x1006, category='lo', description='MYANMAR LETTER CHA' },
	[0x1007] = { unicodeslot=0x1007, category='lo', description='MYANMAR LETTER JA' },
	[0x1008] = { unicodeslot=0x1008, category='lo', description='MYANMAR LETTER JHA' },
	[0x1009] = { unicodeslot=0x1009, category='lo', description='MYANMAR LETTER NYA' },
	[0x100A] = { unicodeslot=0x100A, category='lo', description='MYANMAR LETTER NNYA' },
	[0x100B] = { unicodeslot=0x100B, category='lo', description='MYANMAR LETTER TTA' },
	[0x100C] = { unicodeslot=0x100C, category='lo', description='MYANMAR LETTER TTHA' },
	[0x100D] = { unicodeslot=0x100D, category='lo', description='MYANMAR LETTER DDA' },
	[0x100E] = { unicodeslot=0x100E, category='lo', description='MYANMAR LETTER DDHA' },
	[0x100F] = { unicodeslot=0x100F, category='lo', description='MYANMAR LETTER NNA' },
	[0x1010] = { unicodeslot=0x1010, category='lo', description='MYANMAR LETTER TA' },
	[0x1011] = { unicodeslot=0x1011, category='lo', description='MYANMAR LETTER THA' },
	[0x1012] = { unicodeslot=0x1012, category='lo', description='MYANMAR LETTER DA' },
	[0x1013] = { unicodeslot=0x1013, category='lo', description='MYANMAR LETTER DHA' },
	[0x1014] = { unicodeslot=0x1014, category='lo', description='MYANMAR LETTER NA' },
	[0x1015] = { unicodeslot=0x1015, category='lo', description='MYANMAR LETTER PA' },
	[0x1016] = { unicodeslot=0x1016, category='lo', description='MYANMAR LETTER PHA' },
	[0x1017] = { unicodeslot=0x1017, category='lo', description='MYANMAR LETTER BA' },
	[0x1018] = { unicodeslot=0x1018, category='lo', description='MYANMAR LETTER BHA' },
	[0x1019] = { unicodeslot=0x1019, category='lo', description='MYANMAR LETTER MA' },
	[0x101A] = { unicodeslot=0x101A, category='lo', description='MYANMAR LETTER YA' },
	[0x101B] = { unicodeslot=0x101B, category='lo', description='MYANMAR LETTER RA' },
	[0x101C] = { unicodeslot=0x101C, category='lo', description='MYANMAR LETTER LA' },
	[0x101D] = { unicodeslot=0x101D, category='lo', description='MYANMAR LETTER WA' },
	[0x101E] = { unicodeslot=0x101E, category='lo', description='MYANMAR LETTER SA' },
	[0x101F] = { unicodeslot=0x101F, category='lo', description='MYANMAR LETTER HA' },
	[0x1020] = { unicodeslot=0x1020, category='lo', description='MYANMAR LETTER LLA' },
	[0x1021] = { unicodeslot=0x1021, category='lo', description='MYANMAR LETTER A' },
	[0x1023] = { unicodeslot=0x1023, category='lo', description='MYANMAR LETTER I' },
	[0x1024] = { unicodeslot=0x1024, category='lo', description='MYANMAR LETTER II' },
	[0x1025] = { unicodeslot=0x1025, category='lo', description='MYANMAR LETTER U' },
	[0x1026] = { unicodeslot=0x1026, category='lo', description='MYANMAR LETTER UU', specials={'char',0x1025,0x102E} },
	[0x1027] = { unicodeslot=0x1027, category='lo', description='MYANMAR LETTER E' },
	[0x1029] = { unicodeslot=0x1029, category='lo', description='MYANMAR LETTER O' },
	[0x102A] = { unicodeslot=0x102A, category='lo', description='MYANMAR LETTER AU' },
	[0x102C] = { unicodeslot=0x102C, category='mc', description='MYANMAR VOWEL SIGN AA' },
	[0x102D] = { unicodeslot=0x102D, category='mn', description='MYANMAR VOWEL SIGN I' },
	[0x102E] = { unicodeslot=0x102E, category='mn', description='MYANMAR VOWEL SIGN II' },
	[0x102F] = { unicodeslot=0x102F, category='mn', description='MYANMAR VOWEL SIGN U' },
	[0x1030] = { unicodeslot=0x1030, category='mn', description='MYANMAR VOWEL SIGN UU' },
	[0x1031] = { unicodeslot=0x1031, category='mc', description='MYANMAR VOWEL SIGN E' },
	[0x1032] = { unicodeslot=0x1032, category='mn', description='MYANMAR VOWEL SIGN AI' },
	[0x1036] = { unicodeslot=0x1036, category='mn', description='MYANMAR SIGN ANUSVARA' },
	[0x1037] = { unicodeslot=0x1037, category='mn', description='MYANMAR SIGN DOT BELOW' },
	[0x1038] = { unicodeslot=0x1038, category='mc', description='MYANMAR SIGN VISARGA' },
	[0x1039] = { unicodeslot=0x1039, category='mn', description='MYANMAR SIGN VIRAMA' },
	[0x1040] = { unicodeslot=0x1040, category='nd', description='MYANMAR DIGIT ZERO' },
	[0x1041] = { unicodeslot=0x1041, category='nd', description='MYANMAR DIGIT ONE' },
	[0x1042] = { unicodeslot=0x1042, category='nd', description='MYANMAR DIGIT TWO' },
	[0x1043] = { unicodeslot=0x1043, category='nd', description='MYANMAR DIGIT THREE' },
	[0x1044] = { unicodeslot=0x1044, category='nd', description='MYANMAR DIGIT FOUR' },
	[0x1045] = { unicodeslot=0x1045, category='nd', description='MYANMAR DIGIT FIVE' },
	[0x1046] = { unicodeslot=0x1046, category='nd', description='MYANMAR DIGIT SIX' },
	[0x1047] = { unicodeslot=0x1047, category='nd', description='MYANMAR DIGIT SEVEN' },
	[0x1048] = { unicodeslot=0x1048, category='nd', description='MYANMAR DIGIT EIGHT' },
	[0x1049] = { unicodeslot=0x1049, category='nd', description='MYANMAR DIGIT NINE' },
	[0x104A] = { unicodeslot=0x104A, category='po', description='MYANMAR SIGN LITTLE SECTION' },
	[0x104B] = { unicodeslot=0x104B, category='po', description='MYANMAR SIGN SECTION' },
	[0x104C] = { unicodeslot=0x104C, category='po', description='MYANMAR SYMBOL LOCATIVE' },
	[0x104D] = { unicodeslot=0x104D, category='po', description='MYANMAR SYMBOL COMPLETED' },
	[0x104E] = { unicodeslot=0x104E, category='po', description='MYANMAR SYMBOL AFOREMENTIONED' },
	[0x104F] = { unicodeslot=0x104F, category='po', description='MYANMAR SYMBOL GENITIVE' },
	[0x1050] = { unicodeslot=0x1050, category='lo', description='MYANMAR LETTER SHA' },
	[0x1051] = { unicodeslot=0x1051, category='lo', description='MYANMAR LETTER SSA' },
	[0x1052] = { unicodeslot=0x1052, category='lo', description='MYANMAR LETTER VOCALIC R' },
	[0x1053] = { unicodeslot=0x1053, category='lo', description='MYANMAR LETTER VOCALIC RR' },
	[0x1054] = { unicodeslot=0x1054, category='lo', description='MYANMAR LETTER VOCALIC L' },
	[0x1055] = { unicodeslot=0x1055, category='lo', description='MYANMAR LETTER VOCALIC LL' },
	[0x1056] = { unicodeslot=0x1056, category='mc', description='MYANMAR VOWEL SIGN VOCALIC R' },
	[0x1057] = { unicodeslot=0x1057, category='mc', description='MYANMAR VOWEL SIGN VOCALIC RR' },
	[0x1058] = { unicodeslot=0x1058, category='mn', description='MYANMAR VOWEL SIGN VOCALIC L' },
	[0x1059] = { unicodeslot=0x1059, category='mn', description='MYANMAR VOWEL SIGN VOCALIC LL' },
	[0x10A0] = { unicodeslot=0x10A0, category='lu', description='GEORGIAN CAPITAL LETTER AN', lccode=0x2D00 },
	[0x10A1] = { unicodeslot=0x10A1, category='lu', description='GEORGIAN CAPITAL LETTER BAN', lccode=0x2D01 },
	[0x10A2] = { unicodeslot=0x10A2, category='lu', description='GEORGIAN CAPITAL LETTER GAN', lccode=0x2D02 },
	[0x10A3] = { unicodeslot=0x10A3, category='lu', description='GEORGIAN CAPITAL LETTER DON', lccode=0x2D03 },
	[0x10A4] = { unicodeslot=0x10A4, category='lu', description='GEORGIAN CAPITAL LETTER EN', lccode=0x2D04 },
	[0x10A5] = { unicodeslot=0x10A5, category='lu', description='GEORGIAN CAPITAL LETTER VIN', lccode=0x2D05 },
	[0x10A6] = { unicodeslot=0x10A6, category='lu', description='GEORGIAN CAPITAL LETTER ZEN', lccode=0x2D06 },
	[0x10A7] = { unicodeslot=0x10A7, category='lu', description='GEORGIAN CAPITAL LETTER TAN', lccode=0x2D07 },
	[0x10A8] = { unicodeslot=0x10A8, category='lu', description='GEORGIAN CAPITAL LETTER IN', lccode=0x2D08 },
	[0x10A9] = { unicodeslot=0x10A9, category='lu', description='GEORGIAN CAPITAL LETTER KAN', lccode=0x2D09 },
	[0x10AA] = { unicodeslot=0x10AA, category='lu', description='GEORGIAN CAPITAL LETTER LAS', lccode=0x2D0A },
	[0x10AB] = { unicodeslot=0x10AB, category='lu', description='GEORGIAN CAPITAL LETTER MAN', lccode=0x2D0B },
	[0x10AC] = { unicodeslot=0x10AC, category='lu', description='GEORGIAN CAPITAL LETTER NAR', lccode=0x2D0C },
	[0x10AD] = { unicodeslot=0x10AD, category='lu', description='GEORGIAN CAPITAL LETTER ON', lccode=0x2D0D },
	[0x10AE] = { unicodeslot=0x10AE, category='lu', description='GEORGIAN CAPITAL LETTER PAR', lccode=0x2D0E },
	[0x10AF] = { unicodeslot=0x10AF, category='lu', description='GEORGIAN CAPITAL LETTER ZHAR', lccode=0x2D0F },
	[0x10B0] = { unicodeslot=0x10B0, category='lu', description='GEORGIAN CAPITAL LETTER RAE', lccode=0x2D10 },
	[0x10B1] = { unicodeslot=0x10B1, category='lu', description='GEORGIAN CAPITAL LETTER SAN', lccode=0x2D11 },
	[0x10B2] = { unicodeslot=0x10B2, category='lu', description='GEORGIAN CAPITAL LETTER TAR', lccode=0x2D12 },
	[0x10B3] = { unicodeslot=0x10B3, category='lu', description='GEORGIAN CAPITAL LETTER UN', lccode=0x2D13 },
	[0x10B4] = { unicodeslot=0x10B4, category='lu', description='GEORGIAN CAPITAL LETTER PHAR', lccode=0x2D14 },
	[0x10B5] = { unicodeslot=0x10B5, category='lu', description='GEORGIAN CAPITAL LETTER KHAR', lccode=0x2D15 },
	[0x10B6] = { unicodeslot=0x10B6, category='lu', description='GEORGIAN CAPITAL LETTER GHAN', lccode=0x2D16 },
	[0x10B7] = { unicodeslot=0x10B7, category='lu', description='GEORGIAN CAPITAL LETTER QAR', lccode=0x2D17 },
	[0x10B8] = { unicodeslot=0x10B8, category='lu', description='GEORGIAN CAPITAL LETTER SHIN', lccode=0x2D18 },
	[0x10B9] = { unicodeslot=0x10B9, category='lu', description='GEORGIAN CAPITAL LETTER CHIN', lccode=0x2D19 },
	[0x10BA] = { unicodeslot=0x10BA, category='lu', description='GEORGIAN CAPITAL LETTER CAN', lccode=0x2D1A },
	[0x10BB] = { unicodeslot=0x10BB, category='lu', description='GEORGIAN CAPITAL LETTER JIL', lccode=0x2D1B },
	[0x10BC] = { unicodeslot=0x10BC, category='lu', description='GEORGIAN CAPITAL LETTER CIL', lccode=0x2D1C },
	[0x10BD] = { unicodeslot=0x10BD, category='lu', description='GEORGIAN CAPITAL LETTER CHAR', lccode=0x2D1D },
	[0x10BE] = { unicodeslot=0x10BE, category='lu', description='GEORGIAN CAPITAL LETTER XAN', lccode=0x2D1E },
	[0x10BF] = { unicodeslot=0x10BF, category='lu', description='GEORGIAN CAPITAL LETTER JHAN', lccode=0x2D1F },
	[0x10C0] = { unicodeslot=0x10C0, category='lu', description='GEORGIAN CAPITAL LETTER HAE', lccode=0x2D20 },
	[0x10C1] = { unicodeslot=0x10C1, category='lu', description='GEORGIAN CAPITAL LETTER HE', lccode=0x2D21 },
	[0x10C2] = { unicodeslot=0x10C2, category='lu', description='GEORGIAN CAPITAL LETTER HIE', lccode=0x2D22 },
	[0x10C3] = { unicodeslot=0x10C3, category='lu', description='GEORGIAN CAPITAL LETTER WE', lccode=0x2D23 },
	[0x10C4] = { unicodeslot=0x10C4, category='lu', description='GEORGIAN CAPITAL LETTER HAR', lccode=0x2D24 },
	[0x10C5] = { unicodeslot=0x10C5, category='lu', description='GEORGIAN CAPITAL LETTER HOE', lccode=0x2D25 },
	[0x10D0] = { unicodeslot=0x10D0, category='lo', description='GEORGIAN LETTER AN' },
	[0x10D1] = { unicodeslot=0x10D1, category='lo', description='GEORGIAN LETTER BAN' },
	[0x10D2] = { unicodeslot=0x10D2, category='lo', description='GEORGIAN LETTER GAN' },
	[0x10D3] = { unicodeslot=0x10D3, category='lo', description='GEORGIAN LETTER DON' },
	[0x10D4] = { unicodeslot=0x10D4, category='lo', description='GEORGIAN LETTER EN' },
	[0x10D5] = { unicodeslot=0x10D5, category='lo', description='GEORGIAN LETTER VIN' },
	[0x10D6] = { unicodeslot=0x10D6, category='lo', description='GEORGIAN LETTER ZEN' },
	[0x10D7] = { unicodeslot=0x10D7, category='lo', description='GEORGIAN LETTER TAN' },
	[0x10D8] = { unicodeslot=0x10D8, category='lo', description='GEORGIAN LETTER IN' },
	[0x10D9] = { unicodeslot=0x10D9, category='lo', description='GEORGIAN LETTER KAN' },
	[0x10DA] = { unicodeslot=0x10DA, category='lo', description='GEORGIAN LETTER LAS' },
	[0x10DB] = { unicodeslot=0x10DB, category='lo', description='GEORGIAN LETTER MAN' },
	[0x10DC] = { unicodeslot=0x10DC, category='lo', description='GEORGIAN LETTER NAR' },
	[0x10DD] = { unicodeslot=0x10DD, category='lo', description='GEORGIAN LETTER ON' },
	[0x10DE] = { unicodeslot=0x10DE, category='lo', description='GEORGIAN LETTER PAR' },
	[0x10DF] = { unicodeslot=0x10DF, category='lo', description='GEORGIAN LETTER ZHAR' },
	[0x10E0] = { unicodeslot=0x10E0, category='lo', description='GEORGIAN LETTER RAE' },
	[0x10E1] = { unicodeslot=0x10E1, category='lo', description='GEORGIAN LETTER SAN' },
	[0x10E2] = { unicodeslot=0x10E2, category='lo', description='GEORGIAN LETTER TAR' },
	[0x10E3] = { unicodeslot=0x10E3, category='lo', description='GEORGIAN LETTER UN' },
	[0x10E4] = { unicodeslot=0x10E4, category='lo', description='GEORGIAN LETTER PHAR' },
	[0x10E5] = { unicodeslot=0x10E5, category='lo', description='GEORGIAN LETTER KHAR' },
	[0x10E6] = { unicodeslot=0x10E6, category='lo', description='GEORGIAN LETTER GHAN' },
	[0x10E7] = { unicodeslot=0x10E7, category='lo', description='GEORGIAN LETTER QAR' },
	[0x10E8] = { unicodeslot=0x10E8, category='lo', description='GEORGIAN LETTER SHIN' },
	[0x10E9] = { unicodeslot=0x10E9, category='lo', description='GEORGIAN LETTER CHIN' },
	[0x10EA] = { unicodeslot=0x10EA, category='lo', description='GEORGIAN LETTER CAN' },
	[0x10EB] = { unicodeslot=0x10EB, category='lo', description='GEORGIAN LETTER JIL' },
	[0x10EC] = { unicodeslot=0x10EC, category='lo', description='GEORGIAN LETTER CIL' },
	[0x10ED] = { unicodeslot=0x10ED, category='lo', description='GEORGIAN LETTER CHAR' },
	[0x10EE] = { unicodeslot=0x10EE, category='lo', description='GEORGIAN LETTER XAN' },
	[0x10EF] = { unicodeslot=0x10EF, category='lo', description='GEORGIAN LETTER JHAN' },
	[0x10F0] = { unicodeslot=0x10F0, category='lo', description='GEORGIAN LETTER HAE' },
	[0x10F1] = { unicodeslot=0x10F1, category='lo', description='GEORGIAN LETTER HE' },
	[0x10F2] = { unicodeslot=0x10F2, category='lo', description='GEORGIAN LETTER HIE' },
	[0x10F3] = { unicodeslot=0x10F3, category='lo', description='GEORGIAN LETTER WE' },
	[0x10F4] = { unicodeslot=0x10F4, category='lo', description='GEORGIAN LETTER HAR' },
	[0x10F5] = { unicodeslot=0x10F5, category='lo', description='GEORGIAN LETTER HOE' },
	[0x10F6] = { unicodeslot=0x10F6, category='lo', description='GEORGIAN LETTER FI' },
	[0x10F7] = { unicodeslot=0x10F7, category='lo', description='GEORGIAN LETTER YN' },
	[0x10F8] = { unicodeslot=0x10F8, category='lo', description='GEORGIAN LETTER ELIFI' },
	[0x10F9] = { unicodeslot=0x10F9, category='lo', description='GEORGIAN LETTER TURNED GAN' },
	[0x10FA] = { unicodeslot=0x10FA, category='lo', description='GEORGIAN LETTER AIN' },
	[0x10FB] = { unicodeslot=0x10FB, category='po', description='GEORGIAN PARAGRAPH SEPARATOR' },
	[0x10FC] = { unicodeslot=0x10FC, category='lm', description='MODIFIER LETTER GEORGIAN NAR', specials={'super',0x10DC} },
	[0x1100] = { unicodeslot=0x1100, category='lo', description='HANGUL CHOSEONG KIYEOK' },
	[0x1101] = { unicodeslot=0x1101, category='lo', description='HANGUL CHOSEONG SSANGKIYEOK' },
	[0x1102] = { unicodeslot=0x1102, category='lo', description='HANGUL CHOSEONG NIEUN' },
	[0x1103] = { unicodeslot=0x1103, category='lo', description='HANGUL CHOSEONG TIKEUT' },
	[0x1104] = { unicodeslot=0x1104, category='lo', description='HANGUL CHOSEONG SSANGTIKEUT' },
	[0x1105] = { unicodeslot=0x1105, category='lo', description='HANGUL CHOSEONG RIEUL' },
	[0x1106] = { unicodeslot=0x1106, category='lo', description='HANGUL CHOSEONG MIEUM' },
	[0x1107] = { unicodeslot=0x1107, category='lo', description='HANGUL CHOSEONG PIEUP' },
	[0x1108] = { unicodeslot=0x1108, category='lo', description='HANGUL CHOSEONG SSANGPIEUP' },
	[0x1109] = { unicodeslot=0x1109, category='lo', description='HANGUL CHOSEONG SIOS' },
	[0x110A] = { unicodeslot=0x110A, category='lo', description='HANGUL CHOSEONG SSANGSIOS' },
	[0x110B] = { unicodeslot=0x110B, category='lo', description='HANGUL CHOSEONG IEUNG' },
	[0x110C] = { unicodeslot=0x110C, category='lo', description='HANGUL CHOSEONG CIEUC' },
	[0x110D] = { unicodeslot=0x110D, category='lo', description='HANGUL CHOSEONG SSANGCIEUC' },
	[0x110E] = { unicodeslot=0x110E, category='lo', description='HANGUL CHOSEONG CHIEUCH' },
	[0x110F] = { unicodeslot=0x110F, category='lo', description='HANGUL CHOSEONG KHIEUKH' },
	[0x1110] = { unicodeslot=0x1110, category='lo', description='HANGUL CHOSEONG THIEUTH' },
	[0x1111] = { unicodeslot=0x1111, category='lo', description='HANGUL CHOSEONG PHIEUPH' },
	[0x1112] = { unicodeslot=0x1112, category='lo', description='HANGUL CHOSEONG HIEUH' },
	[0x1113] = { unicodeslot=0x1113, category='lo', description='HANGUL CHOSEONG NIEUN-KIYEOK' },
	[0x1114] = { unicodeslot=0x1114, category='lo', description='HANGUL CHOSEONG SSANGNIEUN' },
	[0x1115] = { unicodeslot=0x1115, category='lo', description='HANGUL CHOSEONG NIEUN-TIKEUT' },
	[0x1116] = { unicodeslot=0x1116, category='lo', description='HANGUL CHOSEONG NIEUN-PIEUP' },
	[0x1117] = { unicodeslot=0x1117, category='lo', description='HANGUL CHOSEONG TIKEUT-KIYEOK' },
	[0x1118] = { unicodeslot=0x1118, category='lo', description='HANGUL CHOSEONG RIEUL-NIEUN' },
	[0x1119] = { unicodeslot=0x1119, category='lo', description='HANGUL CHOSEONG SSANGRIEUL' },
	[0x111A] = { unicodeslot=0x111A, category='lo', description='HANGUL CHOSEONG RIEUL-HIEUH' },
	[0x111B] = { unicodeslot=0x111B, category='lo', description='HANGUL CHOSEONG KAPYEOUNRIEUL' },
	[0x111C] = { unicodeslot=0x111C, category='lo', description='HANGUL CHOSEONG MIEUM-PIEUP' },
	[0x111D] = { unicodeslot=0x111D, category='lo', description='HANGUL CHOSEONG KAPYEOUNMIEUM' },
	[0x111E] = { unicodeslot=0x111E, category='lo', description='HANGUL CHOSEONG PIEUP-KIYEOK' },
	[0x111F] = { unicodeslot=0x111F, category='lo', description='HANGUL CHOSEONG PIEUP-NIEUN' },
	[0x1120] = { unicodeslot=0x1120, category='lo', description='HANGUL CHOSEONG PIEUP-TIKEUT' },
	[0x1121] = { unicodeslot=0x1121, category='lo', description='HANGUL CHOSEONG PIEUP-SIOS' },
	[0x1122] = { unicodeslot=0x1122, category='lo', description='HANGUL CHOSEONG PIEUP-SIOS-KIYEOK' },
	[0x1123] = { unicodeslot=0x1123, category='lo', description='HANGUL CHOSEONG PIEUP-SIOS-TIKEUT' },
	[0x1124] = { unicodeslot=0x1124, category='lo', description='HANGUL CHOSEONG PIEUP-SIOS-PIEUP' },
	[0x1125] = { unicodeslot=0x1125, category='lo', description='HANGUL CHOSEONG PIEUP-SSANGSIOS' },
	[0x1126] = { unicodeslot=0x1126, category='lo', description='HANGUL CHOSEONG PIEUP-SIOS-CIEUC' },
	[0x1127] = { unicodeslot=0x1127, category='lo', description='HANGUL CHOSEONG PIEUP-CIEUC' },
	[0x1128] = { unicodeslot=0x1128, category='lo', description='HANGUL CHOSEONG PIEUP-CHIEUCH' },
	[0x1129] = { unicodeslot=0x1129, category='lo', description='HANGUL CHOSEONG PIEUP-THIEUTH' },
	[0x112A] = { unicodeslot=0x112A, category='lo', description='HANGUL CHOSEONG PIEUP-PHIEUPH' },
	[0x112B] = { unicodeslot=0x112B, category='lo', description='HANGUL CHOSEONG KAPYEOUNPIEUP' },
	[0x112C] = { unicodeslot=0x112C, category='lo', description='HANGUL CHOSEONG KAPYEOUNSSANGPIEUP' },
	[0x112D] = { unicodeslot=0x112D, category='lo', description='HANGUL CHOSEONG SIOS-KIYEOK' },
	[0x112E] = { unicodeslot=0x112E, category='lo', description='HANGUL CHOSEONG SIOS-NIEUN' },
	[0x112F] = { unicodeslot=0x112F, category='lo', description='HANGUL CHOSEONG SIOS-TIKEUT' },
	[0x1130] = { unicodeslot=0x1130, category='lo', description='HANGUL CHOSEONG SIOS-RIEUL' },
	[0x1131] = { unicodeslot=0x1131, category='lo', description='HANGUL CHOSEONG SIOS-MIEUM' },
	[0x1132] = { unicodeslot=0x1132, category='lo', description='HANGUL CHOSEONG SIOS-PIEUP' },
	[0x1133] = { unicodeslot=0x1133, category='lo', description='HANGUL CHOSEONG SIOS-PIEUP-KIYEOK' },
	[0x1134] = { unicodeslot=0x1134, category='lo', description='HANGUL CHOSEONG SIOS-SSANGSIOS' },
	[0x1135] = { unicodeslot=0x1135, category='lo', description='HANGUL CHOSEONG SIOS-IEUNG' },
	[0x1136] = { unicodeslot=0x1136, category='lo', description='HANGUL CHOSEONG SIOS-CIEUC' },
	[0x1137] = { unicodeslot=0x1137, category='lo', description='HANGUL CHOSEONG SIOS-CHIEUCH' },
	[0x1138] = { unicodeslot=0x1138, category='lo', description='HANGUL CHOSEONG SIOS-KHIEUKH' },
	[0x1139] = { unicodeslot=0x1139, category='lo', description='HANGUL CHOSEONG SIOS-THIEUTH' },
	[0x113A] = { unicodeslot=0x113A, category='lo', description='HANGUL CHOSEONG SIOS-PHIEUPH' },
	[0x113B] = { unicodeslot=0x113B, category='lo', description='HANGUL CHOSEONG SIOS-HIEUH' },
	[0x113C] = { unicodeslot=0x113C, category='lo', description='HANGUL CHOSEONG CHITUEUMSIOS' },
	[0x113D] = { unicodeslot=0x113D, category='lo', description='HANGUL CHOSEONG CHITUEUMSSANGSIOS' },
	[0x113E] = { unicodeslot=0x113E, category='lo', description='HANGUL CHOSEONG CEONGCHIEUMSIOS' },
	[0x113F] = { unicodeslot=0x113F, category='lo', description='HANGUL CHOSEONG CEONGCHIEUMSSANGSIOS' },
	[0x1140] = { unicodeslot=0x1140, category='lo', description='HANGUL CHOSEONG PANSIOS' },
	[0x1141] = { unicodeslot=0x1141, category='lo', description='HANGUL CHOSEONG IEUNG-KIYEOK' },
	[0x1142] = { unicodeslot=0x1142, category='lo', description='HANGUL CHOSEONG IEUNG-TIKEUT' },
	[0x1143] = { unicodeslot=0x1143, category='lo', description='HANGUL CHOSEONG IEUNG-MIEUM' },
	[0x1144] = { unicodeslot=0x1144, category='lo', description='HANGUL CHOSEONG IEUNG-PIEUP' },
	[0x1145] = { unicodeslot=0x1145, category='lo', description='HANGUL CHOSEONG IEUNG-SIOS' },
	[0x1146] = { unicodeslot=0x1146, category='lo', description='HANGUL CHOSEONG IEUNG-PANSIOS' },
	[0x1147] = { unicodeslot=0x1147, category='lo', description='HANGUL CHOSEONG SSANGIEUNG' },
	[0x1148] = { unicodeslot=0x1148, category='lo', description='HANGUL CHOSEONG IEUNG-CIEUC' },
	[0x1149] = { unicodeslot=0x1149, category='lo', description='HANGUL CHOSEONG IEUNG-CHIEUCH' },
	[0x114A] = { unicodeslot=0x114A, category='lo', description='HANGUL CHOSEONG IEUNG-THIEUTH' },
	[0x114B] = { unicodeslot=0x114B, category='lo', description='HANGUL CHOSEONG IEUNG-PHIEUPH' },
	[0x114C] = { unicodeslot=0x114C, category='lo', description='HANGUL CHOSEONG YESIEUNG' },
	[0x114D] = { unicodeslot=0x114D, category='lo', description='HANGUL CHOSEONG CIEUC-IEUNG' },
	[0x114E] = { unicodeslot=0x114E, category='lo', description='HANGUL CHOSEONG CHITUEUMCIEUC' },
	[0x114F] = { unicodeslot=0x114F, category='lo', description='HANGUL CHOSEONG CHITUEUMSSANGCIEUC' },
	[0x1150] = { unicodeslot=0x1150, category='lo', description='HANGUL CHOSEONG CEONGCHIEUMCIEUC' },
	[0x1151] = { unicodeslot=0x1151, category='lo', description='HANGUL CHOSEONG CEONGCHIEUMSSANGCIEUC' },
	[0x1152] = { unicodeslot=0x1152, category='lo', description='HANGUL CHOSEONG CHIEUCH-KHIEUKH' },
	[0x1153] = { unicodeslot=0x1153, category='lo', description='HANGUL CHOSEONG CHIEUCH-HIEUH' },
	[0x1154] = { unicodeslot=0x1154, category='lo', description='HANGUL CHOSEONG CHITUEUMCHIEUCH' },
	[0x1155] = { unicodeslot=0x1155, category='lo', description='HANGUL CHOSEONG CEONGCHIEUMCHIEUCH' },
	[0x1156] = { unicodeslot=0x1156, category='lo', description='HANGUL CHOSEONG PHIEUPH-PIEUP' },
	[0x1157] = { unicodeslot=0x1157, category='lo', description='HANGUL CHOSEONG KAPYEOUNPHIEUPH' },
	[0x1158] = { unicodeslot=0x1158, category='lo', description='HANGUL CHOSEONG SSANGHIEUH' },
	[0x1159] = { unicodeslot=0x1159, category='lo', description='HANGUL CHOSEONG YEORINHIEUH' },
	[0x115F] = { unicodeslot=0x115F, category='lo', description='HANGUL CHOSEONG FILLER' },
	[0x1160] = { unicodeslot=0x1160, category='lo', description='HANGUL JUNGSEONG FILLER' },
	[0x1161] = { unicodeslot=0x1161, category='lo', description='HANGUL JUNGSEONG A' },
	[0x1162] = { unicodeslot=0x1162, category='lo', description='HANGUL JUNGSEONG AE' },
	[0x1163] = { unicodeslot=0x1163, category='lo', description='HANGUL JUNGSEONG YA' },
	[0x1164] = { unicodeslot=0x1164, category='lo', description='HANGUL JUNGSEONG YAE' },
	[0x1165] = { unicodeslot=0x1165, category='lo', description='HANGUL JUNGSEONG EO' },
	[0x1166] = { unicodeslot=0x1166, category='lo', description='HANGUL JUNGSEONG E' },
	[0x1167] = { unicodeslot=0x1167, category='lo', description='HANGUL JUNGSEONG YEO' },
	[0x1168] = { unicodeslot=0x1168, category='lo', description='HANGUL JUNGSEONG YE' },
	[0x1169] = { unicodeslot=0x1169, category='lo', description='HANGUL JUNGSEONG O' },
	[0x116A] = { unicodeslot=0x116A, category='lo', description='HANGUL JUNGSEONG WA' },
	[0x116B] = { unicodeslot=0x116B, category='lo', description='HANGUL JUNGSEONG WAE' },
	[0x116C] = { unicodeslot=0x116C, category='lo', description='HANGUL JUNGSEONG OE' },
	[0x116D] = { unicodeslot=0x116D, category='lo', description='HANGUL JUNGSEONG YO' },
	[0x116E] = { unicodeslot=0x116E, category='lo', description='HANGUL JUNGSEONG U' },
	[0x116F] = { unicodeslot=0x116F, category='lo', description='HANGUL JUNGSEONG WEO' },
	[0x1170] = { unicodeslot=0x1170, category='lo', description='HANGUL JUNGSEONG WE' },
	[0x1171] = { unicodeslot=0x1171, category='lo', description='HANGUL JUNGSEONG WI' },
	[0x1172] = { unicodeslot=0x1172, category='lo', description='HANGUL JUNGSEONG YU' },
	[0x1173] = { unicodeslot=0x1173, category='lo', description='HANGUL JUNGSEONG EU' },
	[0x1174] = { unicodeslot=0x1174, category='lo', description='HANGUL JUNGSEONG YI' },
	[0x1175] = { unicodeslot=0x1175, category='lo', description='HANGUL JUNGSEONG I' },
	[0x1176] = { unicodeslot=0x1176, category='lo', description='HANGUL JUNGSEONG A-O' },
	[0x1177] = { unicodeslot=0x1177, category='lo', description='HANGUL JUNGSEONG A-U' },
	[0x1178] = { unicodeslot=0x1178, category='lo', description='HANGUL JUNGSEONG YA-O' },
	[0x1179] = { unicodeslot=0x1179, category='lo', description='HANGUL JUNGSEONG YA-YO' },
	[0x117A] = { unicodeslot=0x117A, category='lo', description='HANGUL JUNGSEONG EO-O' },
	[0x117B] = { unicodeslot=0x117B, category='lo', description='HANGUL JUNGSEONG EO-U' },
	[0x117C] = { unicodeslot=0x117C, category='lo', description='HANGUL JUNGSEONG EO-EU' },
	[0x117D] = { unicodeslot=0x117D, category='lo', description='HANGUL JUNGSEONG YEO-O' },
	[0x117E] = { unicodeslot=0x117E, category='lo', description='HANGUL JUNGSEONG YEO-U' },
	[0x117F] = { unicodeslot=0x117F, category='lo', description='HANGUL JUNGSEONG O-EO' },
	[0x1180] = { unicodeslot=0x1180, category='lo', description='HANGUL JUNGSEONG O-E' },
	[0x1181] = { unicodeslot=0x1181, category='lo', description='HANGUL JUNGSEONG O-YE' },
	[0x1182] = { unicodeslot=0x1182, category='lo', description='HANGUL JUNGSEONG O-O' },
	[0x1183] = { unicodeslot=0x1183, category='lo', description='HANGUL JUNGSEONG O-U' },
	[0x1184] = { unicodeslot=0x1184, category='lo', description='HANGUL JUNGSEONG YO-YA' },
	[0x1185] = { unicodeslot=0x1185, category='lo', description='HANGUL JUNGSEONG YO-YAE' },
	[0x1186] = { unicodeslot=0x1186, category='lo', description='HANGUL JUNGSEONG YO-YEO' },
	[0x1187] = { unicodeslot=0x1187, category='lo', description='HANGUL JUNGSEONG YO-O' },
	[0x1188] = { unicodeslot=0x1188, category='lo', description='HANGUL JUNGSEONG YO-I' },
	[0x1189] = { unicodeslot=0x1189, category='lo', description='HANGUL JUNGSEONG U-A' },
	[0x118A] = { unicodeslot=0x118A, category='lo', description='HANGUL JUNGSEONG U-AE' },
	[0x118B] = { unicodeslot=0x118B, category='lo', description='HANGUL JUNGSEONG U-EO-EU' },
	[0x118C] = { unicodeslot=0x118C, category='lo', description='HANGUL JUNGSEONG U-YE' },
	[0x118D] = { unicodeslot=0x118D, category='lo', description='HANGUL JUNGSEONG U-U' },
	[0x118E] = { unicodeslot=0x118E, category='lo', description='HANGUL JUNGSEONG YU-A' },
	[0x118F] = { unicodeslot=0x118F, category='lo', description='HANGUL JUNGSEONG YU-EO' },
	[0x1190] = { unicodeslot=0x1190, category='lo', description='HANGUL JUNGSEONG YU-E' },
	[0x1191] = { unicodeslot=0x1191, category='lo', description='HANGUL JUNGSEONG YU-YEO' },
	[0x1192] = { unicodeslot=0x1192, category='lo', description='HANGUL JUNGSEONG YU-YE' },
	[0x1193] = { unicodeslot=0x1193, category='lo', description='HANGUL JUNGSEONG YU-U' },
	[0x1194] = { unicodeslot=0x1194, category='lo', description='HANGUL JUNGSEONG YU-I' },
	[0x1195] = { unicodeslot=0x1195, category='lo', description='HANGUL JUNGSEONG EU-U' },
	[0x1196] = { unicodeslot=0x1196, category='lo', description='HANGUL JUNGSEONG EU-EU' },
	[0x1197] = { unicodeslot=0x1197, category='lo', description='HANGUL JUNGSEONG YI-U' },
	[0x1198] = { unicodeslot=0x1198, category='lo', description='HANGUL JUNGSEONG I-A' },
	[0x1199] = { unicodeslot=0x1199, category='lo', description='HANGUL JUNGSEONG I-YA' },
	[0x119A] = { unicodeslot=0x119A, category='lo', description='HANGUL JUNGSEONG I-O' },
	[0x119B] = { unicodeslot=0x119B, category='lo', description='HANGUL JUNGSEONG I-U' },
	[0x119C] = { unicodeslot=0x119C, category='lo', description='HANGUL JUNGSEONG I-EU' },
	[0x119D] = { unicodeslot=0x119D, category='lo', description='HANGUL JUNGSEONG I-ARAEA' },
	[0x119E] = { unicodeslot=0x119E, category='lo', description='HANGUL JUNGSEONG ARAEA' },
	[0x119F] = { unicodeslot=0x119F, category='lo', description='HANGUL JUNGSEONG ARAEA-EO' },
	[0x11A0] = { unicodeslot=0x11A0, category='lo', description='HANGUL JUNGSEONG ARAEA-U' },
	[0x11A1] = { unicodeslot=0x11A1, category='lo', description='HANGUL JUNGSEONG ARAEA-I' },
	[0x11A2] = { unicodeslot=0x11A2, category='lo', description='HANGUL JUNGSEONG SSANGARAEA' },
	[0x11A8] = { unicodeslot=0x11A8, category='lo', description='HANGUL JONGSEONG KIYEOK' },
	[0x11A9] = { unicodeslot=0x11A9, category='lo', description='HANGUL JONGSEONG SSANGKIYEOK' },
	[0x11AA] = { unicodeslot=0x11AA, category='lo', description='HANGUL JONGSEONG KIYEOK-SIOS' },
	[0x11AB] = { unicodeslot=0x11AB, category='lo', description='HANGUL JONGSEONG NIEUN' },
	[0x11AC] = { unicodeslot=0x11AC, category='lo', description='HANGUL JONGSEONG NIEUN-CIEUC' },
	[0x11AD] = { unicodeslot=0x11AD, category='lo', description='HANGUL JONGSEONG NIEUN-HIEUH' },
	[0x11AE] = { unicodeslot=0x11AE, category='lo', description='HANGUL JONGSEONG TIKEUT' },
	[0x11AF] = { unicodeslot=0x11AF, category='lo', description='HANGUL JONGSEONG RIEUL' },
	[0x11B0] = { unicodeslot=0x11B0, category='lo', description='HANGUL JONGSEONG RIEUL-KIYEOK' },
	[0x11B1] = { unicodeslot=0x11B1, category='lo', description='HANGUL JONGSEONG RIEUL-MIEUM' },
	[0x11B2] = { unicodeslot=0x11B2, category='lo', description='HANGUL JONGSEONG RIEUL-PIEUP' },
	[0x11B3] = { unicodeslot=0x11B3, category='lo', description='HANGUL JONGSEONG RIEUL-SIOS' },
	[0x11B4] = { unicodeslot=0x11B4, category='lo', description='HANGUL JONGSEONG RIEUL-THIEUTH' },
	[0x11B5] = { unicodeslot=0x11B5, category='lo', description='HANGUL JONGSEONG RIEUL-PHIEUPH' },
	[0x11B6] = { unicodeslot=0x11B6, category='lo', description='HANGUL JONGSEONG RIEUL-HIEUH' },
	[0x11B7] = { unicodeslot=0x11B7, category='lo', description='HANGUL JONGSEONG MIEUM' },
	[0x11B8] = { unicodeslot=0x11B8, category='lo', description='HANGUL JONGSEONG PIEUP' },
	[0x11B9] = { unicodeslot=0x11B9, category='lo', description='HANGUL JONGSEONG PIEUP-SIOS' },
	[0x11BA] = { unicodeslot=0x11BA, category='lo', description='HANGUL JONGSEONG SIOS' },
	[0x11BB] = { unicodeslot=0x11BB, category='lo', description='HANGUL JONGSEONG SSANGSIOS' },
	[0x11BC] = { unicodeslot=0x11BC, category='lo', description='HANGUL JONGSEONG IEUNG' },
	[0x11BD] = { unicodeslot=0x11BD, category='lo', description='HANGUL JONGSEONG CIEUC' },
	[0x11BE] = { unicodeslot=0x11BE, category='lo', description='HANGUL JONGSEONG CHIEUCH' },
	[0x11BF] = { unicodeslot=0x11BF, category='lo', description='HANGUL JONGSEONG KHIEUKH' },
	[0x11C0] = { unicodeslot=0x11C0, category='lo', description='HANGUL JONGSEONG THIEUTH' },
	[0x11C1] = { unicodeslot=0x11C1, category='lo', description='HANGUL JONGSEONG PHIEUPH' },
	[0x11C2] = { unicodeslot=0x11C2, category='lo', description='HANGUL JONGSEONG HIEUH' },
	[0x11C3] = { unicodeslot=0x11C3, category='lo', description='HANGUL JONGSEONG KIYEOK-RIEUL' },
	[0x11C4] = { unicodeslot=0x11C4, category='lo', description='HANGUL JONGSEONG KIYEOK-SIOS-KIYEOK' },
	[0x11C5] = { unicodeslot=0x11C5, category='lo', description='HANGUL JONGSEONG NIEUN-KIYEOK' },
	[0x11C6] = { unicodeslot=0x11C6, category='lo', description='HANGUL JONGSEONG NIEUN-TIKEUT' },
	[0x11C7] = { unicodeslot=0x11C7, category='lo', description='HANGUL JONGSEONG NIEUN-SIOS' },
	[0x11C8] = { unicodeslot=0x11C8, category='lo', description='HANGUL JONGSEONG NIEUN-PANSIOS' },
	[0x11C9] = { unicodeslot=0x11C9, category='lo', description='HANGUL JONGSEONG NIEUN-THIEUTH' },
	[0x11CA] = { unicodeslot=0x11CA, category='lo', description='HANGUL JONGSEONG TIKEUT-KIYEOK' },
	[0x11CB] = { unicodeslot=0x11CB, category='lo', description='HANGUL JONGSEONG TIKEUT-RIEUL' },
	[0x11CC] = { unicodeslot=0x11CC, category='lo', description='HANGUL JONGSEONG RIEUL-KIYEOK-SIOS' },
	[0x11CD] = { unicodeslot=0x11CD, category='lo', description='HANGUL JONGSEONG RIEUL-NIEUN' },
	[0x11CE] = { unicodeslot=0x11CE, category='lo', description='HANGUL JONGSEONG RIEUL-TIKEUT' },
	[0x11CF] = { unicodeslot=0x11CF, category='lo', description='HANGUL JONGSEONG RIEUL-TIKEUT-HIEUH' },
	[0x11D0] = { unicodeslot=0x11D0, category='lo', description='HANGUL JONGSEONG SSANGRIEUL' },
	[0x11D1] = { unicodeslot=0x11D1, category='lo', description='HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK' },
	[0x11D2] = { unicodeslot=0x11D2, category='lo', description='HANGUL JONGSEONG RIEUL-MIEUM-SIOS' },
	[0x11D3] = { unicodeslot=0x11D3, category='lo', description='HANGUL JONGSEONG RIEUL-PIEUP-SIOS' },
	[0x11D4] = { unicodeslot=0x11D4, category='lo', description='HANGUL JONGSEONG RIEUL-PIEUP-HIEUH' },
	[0x11D5] = { unicodeslot=0x11D5, category='lo', description='HANGUL JONGSEONG RIEUL-KAPYEOUNPIEUP' },
	[0x11D6] = { unicodeslot=0x11D6, category='lo', description='HANGUL JONGSEONG RIEUL-SSANGSIOS' },
	[0x11D7] = { unicodeslot=0x11D7, category='lo', description='HANGUL JONGSEONG RIEUL-PANSIOS' },
	[0x11D8] = { unicodeslot=0x11D8, category='lo', description='HANGUL JONGSEONG RIEUL-KHIEUKH' },
	[0x11D9] = { unicodeslot=0x11D9, category='lo', description='HANGUL JONGSEONG RIEUL-YEORINHIEUH' },
	[0x11DA] = { unicodeslot=0x11DA, category='lo', description='HANGUL JONGSEONG MIEUM-KIYEOK' },
	[0x11DB] = { unicodeslot=0x11DB, category='lo', description='HANGUL JONGSEONG MIEUM-RIEUL' },
	[0x11DC] = { unicodeslot=0x11DC, category='lo', description='HANGUL JONGSEONG MIEUM-PIEUP' },
	[0x11DD] = { unicodeslot=0x11DD, category='lo', description='HANGUL JONGSEONG MIEUM-SIOS' },
	[0x11DE] = { unicodeslot=0x11DE, category='lo', description='HANGUL JONGSEONG MIEUM-SSANGSIOS' },
	[0x11DF] = { unicodeslot=0x11DF, category='lo', description='HANGUL JONGSEONG MIEUM-PANSIOS' },
	[0x11E0] = { unicodeslot=0x11E0, category='lo', description='HANGUL JONGSEONG MIEUM-CHIEUCH' },
	[0x11E1] = { unicodeslot=0x11E1, category='lo', description='HANGUL JONGSEONG MIEUM-HIEUH' },
	[0x11E2] = { unicodeslot=0x11E2, category='lo', description='HANGUL JONGSEONG KAPYEOUNMIEUM' },
	[0x11E3] = { unicodeslot=0x11E3, category='lo', description='HANGUL JONGSEONG PIEUP-RIEUL' },
	[0x11E4] = { unicodeslot=0x11E4, category='lo', description='HANGUL JONGSEONG PIEUP-PHIEUPH' },
	[0x11E5] = { unicodeslot=0x11E5, category='lo', description='HANGUL JONGSEONG PIEUP-HIEUH' },
	[0x11E6] = { unicodeslot=0x11E6, category='lo', description='HANGUL JONGSEONG KAPYEOUNPIEUP' },
	[0x11E7] = { unicodeslot=0x11E7, category='lo', description='HANGUL JONGSEONG SIOS-KIYEOK' },
	[0x11E8] = { unicodeslot=0x11E8, category='lo', description='HANGUL JONGSEONG SIOS-TIKEUT' },
	[0x11E9] = { unicodeslot=0x11E9, category='lo', description='HANGUL JONGSEONG SIOS-RIEUL' },
	[0x11EA] = { unicodeslot=0x11EA, category='lo', description='HANGUL JONGSEONG SIOS-PIEUP' },
	[0x11EB] = { unicodeslot=0x11EB, category='lo', description='HANGUL JONGSEONG PANSIOS' },
	[0x11EC] = { unicodeslot=0x11EC, category='lo', description='HANGUL JONGSEONG IEUNG-KIYEOK' },
	[0x11ED] = { unicodeslot=0x11ED, category='lo', description='HANGUL JONGSEONG IEUNG-SSANGKIYEOK' },
	[0x11EE] = { unicodeslot=0x11EE, category='lo', description='HANGUL JONGSEONG SSANGIEUNG' },
	[0x11EF] = { unicodeslot=0x11EF, category='lo', description='HANGUL JONGSEONG IEUNG-KHIEUKH' },
	[0x11F0] = { unicodeslot=0x11F0, category='lo', description='HANGUL JONGSEONG YESIEUNG' },
	[0x11F1] = { unicodeslot=0x11F1, category='lo', description='HANGUL JONGSEONG YESIEUNG-SIOS' },
	[0x11F2] = { unicodeslot=0x11F2, category='lo', description='HANGUL JONGSEONG YESIEUNG-PANSIOS' },
	[0x11F3] = { unicodeslot=0x11F3, category='lo', description='HANGUL JONGSEONG PHIEUPH-PIEUP' },
	[0x11F4] = { unicodeslot=0x11F4, category='lo', description='HANGUL JONGSEONG KAPYEOUNPHIEUPH' },
	[0x11F5] = { unicodeslot=0x11F5, category='lo', description='HANGUL JONGSEONG HIEUH-NIEUN' },
	[0x11F6] = { unicodeslot=0x11F6, category='lo', description='HANGUL JONGSEONG HIEUH-RIEUL' },
	[0x11F7] = { unicodeslot=0x11F7, category='lo', description='HANGUL JONGSEONG HIEUH-MIEUM' },
	[0x11F8] = { unicodeslot=0x11F8, category='lo', description='HANGUL JONGSEONG HIEUH-PIEUP' },
	[0x11F9] = { unicodeslot=0x11F9, category='lo', description='HANGUL JONGSEONG YEORINHIEUH' },
	[0x1200] = { unicodeslot=0x1200, category='lo', description='ETHIOPIC SYLLABLE HA' },
	[0x1201] = { unicodeslot=0x1201, category='lo', description='ETHIOPIC SYLLABLE HU' },
	[0x1202] = { unicodeslot=0x1202, category='lo', description='ETHIOPIC SYLLABLE HI' },
	[0x1203] = { unicodeslot=0x1203, category='lo', description='ETHIOPIC SYLLABLE HAA' },
	[0x1204] = { unicodeslot=0x1204, category='lo', description='ETHIOPIC SYLLABLE HEE' },
	[0x1205] = { unicodeslot=0x1205, category='lo', description='ETHIOPIC SYLLABLE HE' },
	[0x1206] = { unicodeslot=0x1206, category='lo', description='ETHIOPIC SYLLABLE HO' },
	[0x1207] = { unicodeslot=0x1207, category='lo', description='ETHIOPIC SYLLABLE HOA' },
	[0x1208] = { unicodeslot=0x1208, category='lo', description='ETHIOPIC SYLLABLE LA' },
	[0x1209] = { unicodeslot=0x1209, category='lo', description='ETHIOPIC SYLLABLE LU' },
	[0x120A] = { unicodeslot=0x120A, category='lo', description='ETHIOPIC SYLLABLE LI' },
	[0x120B] = { unicodeslot=0x120B, category='lo', description='ETHIOPIC SYLLABLE LAA' },
	[0x120C] = { unicodeslot=0x120C, category='lo', description='ETHIOPIC SYLLABLE LEE' },
	[0x120D] = { unicodeslot=0x120D, category='lo', description='ETHIOPIC SYLLABLE LE' },
	[0x120E] = { unicodeslot=0x120E, category='lo', description='ETHIOPIC SYLLABLE LO' },
	[0x120F] = { unicodeslot=0x120F, category='lo', description='ETHIOPIC SYLLABLE LWA' },
	[0x1210] = { unicodeslot=0x1210, category='lo', description='ETHIOPIC SYLLABLE HHA' },
	[0x1211] = { unicodeslot=0x1211, category='lo', description='ETHIOPIC SYLLABLE HHU' },
	[0x1212] = { unicodeslot=0x1212, category='lo', description='ETHIOPIC SYLLABLE HHI' },
	[0x1213] = { unicodeslot=0x1213, category='lo', description='ETHIOPIC SYLLABLE HHAA' },
	[0x1214] = { unicodeslot=0x1214, category='lo', description='ETHIOPIC SYLLABLE HHEE' },
	[0x1215] = { unicodeslot=0x1215, category='lo', description='ETHIOPIC SYLLABLE HHE' },
	[0x1216] = { unicodeslot=0x1216, category='lo', description='ETHIOPIC SYLLABLE HHO' },
	[0x1217] = { unicodeslot=0x1217, category='lo', description='ETHIOPIC SYLLABLE HHWA' },
	[0x1218] = { unicodeslot=0x1218, category='lo', description='ETHIOPIC SYLLABLE MA' },
	[0x1219] = { unicodeslot=0x1219, category='lo', description='ETHIOPIC SYLLABLE MU' },
	[0x121A] = { unicodeslot=0x121A, category='lo', description='ETHIOPIC SYLLABLE MI' },
	[0x121B] = { unicodeslot=0x121B, category='lo', description='ETHIOPIC SYLLABLE MAA' },
	[0x121C] = { unicodeslot=0x121C, category='lo', description='ETHIOPIC SYLLABLE MEE' },
	[0x121D] = { unicodeslot=0x121D, category='lo', description='ETHIOPIC SYLLABLE ME' },
	[0x121E] = { unicodeslot=0x121E, category='lo', description='ETHIOPIC SYLLABLE MO' },
	[0x121F] = { unicodeslot=0x121F, category='lo', description='ETHIOPIC SYLLABLE MWA' },
	[0x1220] = { unicodeslot=0x1220, category='lo', description='ETHIOPIC SYLLABLE SZA' },
	[0x1221] = { unicodeslot=0x1221, category='lo', description='ETHIOPIC SYLLABLE SZU' },
	[0x1222] = { unicodeslot=0x1222, category='lo', description='ETHIOPIC SYLLABLE SZI' },
	[0x1223] = { unicodeslot=0x1223, category='lo', description='ETHIOPIC SYLLABLE SZAA' },
	[0x1224] = { unicodeslot=0x1224, category='lo', description='ETHIOPIC SYLLABLE SZEE' },
	[0x1225] = { unicodeslot=0x1225, category='lo', description='ETHIOPIC SYLLABLE SZE' },
	[0x1226] = { unicodeslot=0x1226, category='lo', description='ETHIOPIC SYLLABLE SZO' },
	[0x1227] = { unicodeslot=0x1227, category='lo', description='ETHIOPIC SYLLABLE SZWA' },
	[0x1228] = { unicodeslot=0x1228, category='lo', description='ETHIOPIC SYLLABLE RA' },
	[0x1229] = { unicodeslot=0x1229, category='lo', description='ETHIOPIC SYLLABLE RU' },
	[0x122A] = { unicodeslot=0x122A, category='lo', description='ETHIOPIC SYLLABLE RI' },
	[0x122B] = { unicodeslot=0x122B, category='lo', description='ETHIOPIC SYLLABLE RAA' },
	[0x122C] = { unicodeslot=0x122C, category='lo', description='ETHIOPIC SYLLABLE REE' },
	[0x122D] = { unicodeslot=0x122D, category='lo', description='ETHIOPIC SYLLABLE RE' },
	[0x122E] = { unicodeslot=0x122E, category='lo', description='ETHIOPIC SYLLABLE RO' },
	[0x122F] = { unicodeslot=0x122F, category='lo', description='ETHIOPIC SYLLABLE RWA' },
	[0x1230] = { unicodeslot=0x1230, category='lo', description='ETHIOPIC SYLLABLE SA' },
	[0x1231] = { unicodeslot=0x1231, category='lo', description='ETHIOPIC SYLLABLE SU' },
	[0x1232] = { unicodeslot=0x1232, category='lo', description='ETHIOPIC SYLLABLE SI' },
	[0x1233] = { unicodeslot=0x1233, category='lo', description='ETHIOPIC SYLLABLE SAA' },
	[0x1234] = { unicodeslot=0x1234, category='lo', description='ETHIOPIC SYLLABLE SEE' },
	[0x1235] = { unicodeslot=0x1235, category='lo', description='ETHIOPIC SYLLABLE SE' },
	[0x1236] = { unicodeslot=0x1236, category='lo', description='ETHIOPIC SYLLABLE SO' },
	[0x1237] = { unicodeslot=0x1237, category='lo', description='ETHIOPIC SYLLABLE SWA' },
	[0x1238] = { unicodeslot=0x1238, category='lo', description='ETHIOPIC SYLLABLE SHA' },
	[0x1239] = { unicodeslot=0x1239, category='lo', description='ETHIOPIC SYLLABLE SHU' },
	[0x123A] = { unicodeslot=0x123A, category='lo', description='ETHIOPIC SYLLABLE SHI' },
	[0x123B] = { unicodeslot=0x123B, category='lo', description='ETHIOPIC SYLLABLE SHAA' },
	[0x123C] = { unicodeslot=0x123C, category='lo', description='ETHIOPIC SYLLABLE SHEE' },
	[0x123D] = { unicodeslot=0x123D, category='lo', description='ETHIOPIC SYLLABLE SHE' },
	[0x123E] = { unicodeslot=0x123E, category='lo', description='ETHIOPIC SYLLABLE SHO' },
	[0x123F] = { unicodeslot=0x123F, category='lo', description='ETHIOPIC SYLLABLE SHWA' },
	[0x1240] = { unicodeslot=0x1240, category='lo', description='ETHIOPIC SYLLABLE QA' },
	[0x1241] = { unicodeslot=0x1241, category='lo', description='ETHIOPIC SYLLABLE QU' },
	[0x1242] = { unicodeslot=0x1242, category='lo', description='ETHIOPIC SYLLABLE QI' },
	[0x1243] = { unicodeslot=0x1243, category='lo', description='ETHIOPIC SYLLABLE QAA' },
	[0x1244] = { unicodeslot=0x1244, category='lo', description='ETHIOPIC SYLLABLE QEE' },
	[0x1245] = { unicodeslot=0x1245, category='lo', description='ETHIOPIC SYLLABLE QE' },
	[0x1246] = { unicodeslot=0x1246, category='lo', description='ETHIOPIC SYLLABLE QO' },
	[0x1247] = { unicodeslot=0x1247, category='lo', description='ETHIOPIC SYLLABLE QOA' },
	[0x1248] = { unicodeslot=0x1248, category='lo', description='ETHIOPIC SYLLABLE QWA' },
	[0x124A] = { unicodeslot=0x124A, category='lo', description='ETHIOPIC SYLLABLE QWI' },
	[0x124B] = { unicodeslot=0x124B, category='lo', description='ETHIOPIC SYLLABLE QWAA' },
	[0x124C] = { unicodeslot=0x124C, category='lo', description='ETHIOPIC SYLLABLE QWEE' },
	[0x124D] = { unicodeslot=0x124D, category='lo', description='ETHIOPIC SYLLABLE QWE' },
	[0x1250] = { unicodeslot=0x1250, category='lo', description='ETHIOPIC SYLLABLE QHA' },
	[0x1251] = { unicodeslot=0x1251, category='lo', description='ETHIOPIC SYLLABLE QHU' },
	[0x1252] = { unicodeslot=0x1252, category='lo', description='ETHIOPIC SYLLABLE QHI' },
	[0x1253] = { unicodeslot=0x1253, category='lo', description='ETHIOPIC SYLLABLE QHAA' },
	[0x1254] = { unicodeslot=0x1254, category='lo', description='ETHIOPIC SYLLABLE QHEE' },
	[0x1255] = { unicodeslot=0x1255, category='lo', description='ETHIOPIC SYLLABLE QHE' },
	[0x1256] = { unicodeslot=0x1256, category='lo', description='ETHIOPIC SYLLABLE QHO' },
	[0x1258] = { unicodeslot=0x1258, category='lo', description='ETHIOPIC SYLLABLE QHWA' },
	[0x125A] = { unicodeslot=0x125A, category='lo', description='ETHIOPIC SYLLABLE QHWI' },
	[0x125B] = { unicodeslot=0x125B, category='lo', description='ETHIOPIC SYLLABLE QHWAA' },
	[0x125C] = { unicodeslot=0x125C, category='lo', description='ETHIOPIC SYLLABLE QHWEE' },
	[0x125D] = { unicodeslot=0x125D, category='lo', description='ETHIOPIC SYLLABLE QHWE' },
	[0x1260] = { unicodeslot=0x1260, category='lo', description='ETHIOPIC SYLLABLE BA' },
	[0x1261] = { unicodeslot=0x1261, category='lo', description='ETHIOPIC SYLLABLE BU' },
	[0x1262] = { unicodeslot=0x1262, category='lo', description='ETHIOPIC SYLLABLE BI' },
	[0x1263] = { unicodeslot=0x1263, category='lo', description='ETHIOPIC SYLLABLE BAA' },
	[0x1264] = { unicodeslot=0x1264, category='lo', description='ETHIOPIC SYLLABLE BEE' },
	[0x1265] = { unicodeslot=0x1265, category='lo', description='ETHIOPIC SYLLABLE BE' },
	[0x1266] = { unicodeslot=0x1266, category='lo', description='ETHIOPIC SYLLABLE BO' },
	[0x1267] = { unicodeslot=0x1267, category='lo', description='ETHIOPIC SYLLABLE BWA' },
	[0x1268] = { unicodeslot=0x1268, category='lo', description='ETHIOPIC SYLLABLE VA' },
	[0x1269] = { unicodeslot=0x1269, category='lo', description='ETHIOPIC SYLLABLE VU' },
	[0x126A] = { unicodeslot=0x126A, category='lo', description='ETHIOPIC SYLLABLE VI' },
	[0x126B] = { unicodeslot=0x126B, category='lo', description='ETHIOPIC SYLLABLE VAA' },
	[0x126C] = { unicodeslot=0x126C, category='lo', description='ETHIOPIC SYLLABLE VEE' },
	[0x126D] = { unicodeslot=0x126D, category='lo', description='ETHIOPIC SYLLABLE VE' },
	[0x126E] = { unicodeslot=0x126E, category='lo', description='ETHIOPIC SYLLABLE VO' },
	[0x126F] = { unicodeslot=0x126F, category='lo', description='ETHIOPIC SYLLABLE VWA' },
	[0x1270] = { unicodeslot=0x1270, category='lo', description='ETHIOPIC SYLLABLE TA' },
	[0x1271] = { unicodeslot=0x1271, category='lo', description='ETHIOPIC SYLLABLE TU' },
	[0x1272] = { unicodeslot=0x1272, category='lo', description='ETHIOPIC SYLLABLE TI' },
	[0x1273] = { unicodeslot=0x1273, category='lo', description='ETHIOPIC SYLLABLE TAA' },
	[0x1274] = { unicodeslot=0x1274, category='lo', description='ETHIOPIC SYLLABLE TEE' },
	[0x1275] = { unicodeslot=0x1275, category='lo', description='ETHIOPIC SYLLABLE TE' },
	[0x1276] = { unicodeslot=0x1276, category='lo', description='ETHIOPIC SYLLABLE TO' },
	[0x1277] = { unicodeslot=0x1277, category='lo', description='ETHIOPIC SYLLABLE TWA' },
	[0x1278] = { unicodeslot=0x1278, category='lo', description='ETHIOPIC SYLLABLE CA' },
	[0x1279] = { unicodeslot=0x1279, category='lo', description='ETHIOPIC SYLLABLE CU' },
	[0x127A] = { unicodeslot=0x127A, category='lo', description='ETHIOPIC SYLLABLE CI' },
	[0x127B] = { unicodeslot=0x127B, category='lo', description='ETHIOPIC SYLLABLE CAA' },
	[0x127C] = { unicodeslot=0x127C, category='lo', description='ETHIOPIC SYLLABLE CEE' },
	[0x127D] = { unicodeslot=0x127D, category='lo', description='ETHIOPIC SYLLABLE CE' },
	[0x127E] = { unicodeslot=0x127E, category='lo', description='ETHIOPIC SYLLABLE CO' },
	[0x127F] = { unicodeslot=0x127F, category='lo', description='ETHIOPIC SYLLABLE CWA' },
	[0x1280] = { unicodeslot=0x1280, category='lo', description='ETHIOPIC SYLLABLE XA' },
	[0x1281] = { unicodeslot=0x1281, category='lo', description='ETHIOPIC SYLLABLE XU' },
	[0x1282] = { unicodeslot=0x1282, category='lo', description='ETHIOPIC SYLLABLE XI' },
	[0x1283] = { unicodeslot=0x1283, category='lo', description='ETHIOPIC SYLLABLE XAA' },
	[0x1284] = { unicodeslot=0x1284, category='lo', description='ETHIOPIC SYLLABLE XEE' },
	[0x1285] = { unicodeslot=0x1285, category='lo', description='ETHIOPIC SYLLABLE XE' },
	[0x1286] = { unicodeslot=0x1286, category='lo', description='ETHIOPIC SYLLABLE XO' },
	[0x1287] = { unicodeslot=0x1287, category='lo', description='ETHIOPIC SYLLABLE XOA' },
	[0x1288] = { unicodeslot=0x1288, category='lo', description='ETHIOPIC SYLLABLE XWA' },
	[0x128A] = { unicodeslot=0x128A, category='lo', description='ETHIOPIC SYLLABLE XWI' },
	[0x128B] = { unicodeslot=0x128B, category='lo', description='ETHIOPIC SYLLABLE XWAA' },
	[0x128C] = { unicodeslot=0x128C, category='lo', description='ETHIOPIC SYLLABLE XWEE' },
	[0x128D] = { unicodeslot=0x128D, category='lo', description='ETHIOPIC SYLLABLE XWE' },
	[0x1290] = { unicodeslot=0x1290, category='lo', description='ETHIOPIC SYLLABLE NA' },
	[0x1291] = { unicodeslot=0x1291, category='lo', description='ETHIOPIC SYLLABLE NU' },
	[0x1292] = { unicodeslot=0x1292, category='lo', description='ETHIOPIC SYLLABLE NI' },
	[0x1293] = { unicodeslot=0x1293, category='lo', description='ETHIOPIC SYLLABLE NAA' },
	[0x1294] = { unicodeslot=0x1294, category='lo', description='ETHIOPIC SYLLABLE NEE' },
	[0x1295] = { unicodeslot=0x1295, category='lo', description='ETHIOPIC SYLLABLE NE' },
	[0x1296] = { unicodeslot=0x1296, category='lo', description='ETHIOPIC SYLLABLE NO' },
	[0x1297] = { unicodeslot=0x1297, category='lo', description='ETHIOPIC SYLLABLE NWA' },
	[0x1298] = { unicodeslot=0x1298, category='lo', description='ETHIOPIC SYLLABLE NYA' },
	[0x1299] = { unicodeslot=0x1299, category='lo', description='ETHIOPIC SYLLABLE NYU' },
	[0x129A] = { unicodeslot=0x129A, category='lo', description='ETHIOPIC SYLLABLE NYI' },
	[0x129B] = { unicodeslot=0x129B, category='lo', description='ETHIOPIC SYLLABLE NYAA' },
	[0x129C] = { unicodeslot=0x129C, category='lo', description='ETHIOPIC SYLLABLE NYEE' },
	[0x129D] = { unicodeslot=0x129D, category='lo', description='ETHIOPIC SYLLABLE NYE' },
	[0x129E] = { unicodeslot=0x129E, category='lo', description='ETHIOPIC SYLLABLE NYO' },
	[0x129F] = { unicodeslot=0x129F, category='lo', description='ETHIOPIC SYLLABLE NYWA' },
	[0x12A0] = { unicodeslot=0x12A0, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL A' },
	[0x12A1] = { unicodeslot=0x12A1, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL U' },
	[0x12A2] = { unicodeslot=0x12A2, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL I' },
	[0x12A3] = { unicodeslot=0x12A3, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL AA' },
	[0x12A4] = { unicodeslot=0x12A4, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL EE' },
	[0x12A5] = { unicodeslot=0x12A5, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL E' },
	[0x12A6] = { unicodeslot=0x12A6, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL O' },
	[0x12A7] = { unicodeslot=0x12A7, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL WA' },
	[0x12A8] = { unicodeslot=0x12A8, category='lo', description='ETHIOPIC SYLLABLE KA' },
	[0x12A9] = { unicodeslot=0x12A9, category='lo', description='ETHIOPIC SYLLABLE KU' },
	[0x12AA] = { unicodeslot=0x12AA, category='lo', description='ETHIOPIC SYLLABLE KI' },
	[0x12AB] = { unicodeslot=0x12AB, category='lo', description='ETHIOPIC SYLLABLE KAA' },
	[0x12AC] = { unicodeslot=0x12AC, category='lo', description='ETHIOPIC SYLLABLE KEE' },
	[0x12AD] = { unicodeslot=0x12AD, category='lo', description='ETHIOPIC SYLLABLE KE' },
	[0x12AE] = { unicodeslot=0x12AE, category='lo', description='ETHIOPIC SYLLABLE KO' },
	[0x12AF] = { unicodeslot=0x12AF, category='lo', description='ETHIOPIC SYLLABLE KOA' },
	[0x12B0] = { unicodeslot=0x12B0, category='lo', description='ETHIOPIC SYLLABLE KWA' },
	[0x12B2] = { unicodeslot=0x12B2, category='lo', description='ETHIOPIC SYLLABLE KWI' },
	[0x12B3] = { unicodeslot=0x12B3, category='lo', description='ETHIOPIC SYLLABLE KWAA' },
	[0x12B4] = { unicodeslot=0x12B4, category='lo', description='ETHIOPIC SYLLABLE KWEE' },
	[0x12B5] = { unicodeslot=0x12B5, category='lo', description='ETHIOPIC SYLLABLE KWE' },
	[0x12B8] = { unicodeslot=0x12B8, category='lo', description='ETHIOPIC SYLLABLE KXA' },
	[0x12B9] = { unicodeslot=0x12B9, category='lo', description='ETHIOPIC SYLLABLE KXU' },
	[0x12BA] = { unicodeslot=0x12BA, category='lo', description='ETHIOPIC SYLLABLE KXI' },
	[0x12BB] = { unicodeslot=0x12BB, category='lo', description='ETHIOPIC SYLLABLE KXAA' },
	[0x12BC] = { unicodeslot=0x12BC, category='lo', description='ETHIOPIC SYLLABLE KXEE' },
	[0x12BD] = { unicodeslot=0x12BD, category='lo', description='ETHIOPIC SYLLABLE KXE' },
	[0x12BE] = { unicodeslot=0x12BE, category='lo', description='ETHIOPIC SYLLABLE KXO' },
	[0x12C0] = { unicodeslot=0x12C0, category='lo', description='ETHIOPIC SYLLABLE KXWA' },
	[0x12C2] = { unicodeslot=0x12C2, category='lo', description='ETHIOPIC SYLLABLE KXWI' },
	[0x12C3] = { unicodeslot=0x12C3, category='lo', description='ETHIOPIC SYLLABLE KXWAA' },
	[0x12C4] = { unicodeslot=0x12C4, category='lo', description='ETHIOPIC SYLLABLE KXWEE' },
	[0x12C5] = { unicodeslot=0x12C5, category='lo', description='ETHIOPIC SYLLABLE KXWE' },
	[0x12C8] = { unicodeslot=0x12C8, category='lo', description='ETHIOPIC SYLLABLE WA' },
	[0x12C9] = { unicodeslot=0x12C9, category='lo', description='ETHIOPIC SYLLABLE WU' },
	[0x12CA] = { unicodeslot=0x12CA, category='lo', description='ETHIOPIC SYLLABLE WI' },
	[0x12CB] = { unicodeslot=0x12CB, category='lo', description='ETHIOPIC SYLLABLE WAA' },
	[0x12CC] = { unicodeslot=0x12CC, category='lo', description='ETHIOPIC SYLLABLE WEE' },
	[0x12CD] = { unicodeslot=0x12CD, category='lo', description='ETHIOPIC SYLLABLE WE' },
	[0x12CE] = { unicodeslot=0x12CE, category='lo', description='ETHIOPIC SYLLABLE WO' },
	[0x12CF] = { unicodeslot=0x12CF, category='lo', description='ETHIOPIC SYLLABLE WOA' },
	[0x12D0] = { unicodeslot=0x12D0, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL A' },
	[0x12D1] = { unicodeslot=0x12D1, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL U' },
	[0x12D2] = { unicodeslot=0x12D2, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL I' },
	[0x12D3] = { unicodeslot=0x12D3, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL AA' },
	[0x12D4] = { unicodeslot=0x12D4, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL EE' },
	[0x12D5] = { unicodeslot=0x12D5, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL E' },
	[0x12D6] = { unicodeslot=0x12D6, category='lo', description='ETHIOPIC SYLLABLE PHARYNGEAL O' },
	[0x12D8] = { unicodeslot=0x12D8, category='lo', description='ETHIOPIC SYLLABLE ZA' },
	[0x12D9] = { unicodeslot=0x12D9, category='lo', description='ETHIOPIC SYLLABLE ZU' },
	[0x12DA] = { unicodeslot=0x12DA, category='lo', description='ETHIOPIC SYLLABLE ZI' },
	[0x12DB] = { unicodeslot=0x12DB, category='lo', description='ETHIOPIC SYLLABLE ZAA' },
	[0x12DC] = { unicodeslot=0x12DC, category='lo', description='ETHIOPIC SYLLABLE ZEE' },
	[0x12DD] = { unicodeslot=0x12DD, category='lo', description='ETHIOPIC SYLLABLE ZE' },
	[0x12DE] = { unicodeslot=0x12DE, category='lo', description='ETHIOPIC SYLLABLE ZO' },
	[0x12DF] = { unicodeslot=0x12DF, category='lo', description='ETHIOPIC SYLLABLE ZWA' },
	[0x12E0] = { unicodeslot=0x12E0, category='lo', description='ETHIOPIC SYLLABLE ZHA' },
	[0x12E1] = { unicodeslot=0x12E1, category='lo', description='ETHIOPIC SYLLABLE ZHU' },
	[0x12E2] = { unicodeslot=0x12E2, category='lo', description='ETHIOPIC SYLLABLE ZHI' },
	[0x12E3] = { unicodeslot=0x12E3, category='lo', description='ETHIOPIC SYLLABLE ZHAA' },
	[0x12E4] = { unicodeslot=0x12E4, category='lo', description='ETHIOPIC SYLLABLE ZHEE' },
	[0x12E5] = { unicodeslot=0x12E5, category='lo', description='ETHIOPIC SYLLABLE ZHE' },
	[0x12E6] = { unicodeslot=0x12E6, category='lo', description='ETHIOPIC SYLLABLE ZHO' },
	[0x12E7] = { unicodeslot=0x12E7, category='lo', description='ETHIOPIC SYLLABLE ZHWA' },
	[0x12E8] = { unicodeslot=0x12E8, category='lo', description='ETHIOPIC SYLLABLE YA' },
	[0x12E9] = { unicodeslot=0x12E9, category='lo', description='ETHIOPIC SYLLABLE YU' },
	[0x12EA] = { unicodeslot=0x12EA, category='lo', description='ETHIOPIC SYLLABLE YI' },
	[0x12EB] = { unicodeslot=0x12EB, category='lo', description='ETHIOPIC SYLLABLE YAA' },
	[0x12EC] = { unicodeslot=0x12EC, category='lo', description='ETHIOPIC SYLLABLE YEE' },
	[0x12ED] = { unicodeslot=0x12ED, category='lo', description='ETHIOPIC SYLLABLE YE' },
	[0x12EE] = { unicodeslot=0x12EE, category='lo', description='ETHIOPIC SYLLABLE YO' },
	[0x12EF] = { unicodeslot=0x12EF, category='lo', description='ETHIOPIC SYLLABLE YOA' },
	[0x12F0] = { unicodeslot=0x12F0, category='lo', description='ETHIOPIC SYLLABLE DA' },
	[0x12F1] = { unicodeslot=0x12F1, category='lo', description='ETHIOPIC SYLLABLE DU' },
	[0x12F2] = { unicodeslot=0x12F2, category='lo', description='ETHIOPIC SYLLABLE DI' },
	[0x12F3] = { unicodeslot=0x12F3, category='lo', description='ETHIOPIC SYLLABLE DAA' },
	[0x12F4] = { unicodeslot=0x12F4, category='lo', description='ETHIOPIC SYLLABLE DEE' },
	[0x12F5] = { unicodeslot=0x12F5, category='lo', description='ETHIOPIC SYLLABLE DE' },
	[0x12F6] = { unicodeslot=0x12F6, category='lo', description='ETHIOPIC SYLLABLE DO' },
	[0x12F7] = { unicodeslot=0x12F7, category='lo', description='ETHIOPIC SYLLABLE DWA' },
	[0x12F8] = { unicodeslot=0x12F8, category='lo', description='ETHIOPIC SYLLABLE DDA' },
	[0x12F9] = { unicodeslot=0x12F9, category='lo', description='ETHIOPIC SYLLABLE DDU' },
	[0x12FA] = { unicodeslot=0x12FA, category='lo', description='ETHIOPIC SYLLABLE DDI' },
	[0x12FB] = { unicodeslot=0x12FB, category='lo', description='ETHIOPIC SYLLABLE DDAA' },
	[0x12FC] = { unicodeslot=0x12FC, category='lo', description='ETHIOPIC SYLLABLE DDEE' },
	[0x12FD] = { unicodeslot=0x12FD, category='lo', description='ETHIOPIC SYLLABLE DDE' },
	[0x12FE] = { unicodeslot=0x12FE, category='lo', description='ETHIOPIC SYLLABLE DDO' },
	[0x12FF] = { unicodeslot=0x12FF, category='lo', description='ETHIOPIC SYLLABLE DDWA' },
	[0x1300] = { unicodeslot=0x1300, category='lo', description='ETHIOPIC SYLLABLE JA' },
	[0x1301] = { unicodeslot=0x1301, category='lo', description='ETHIOPIC SYLLABLE JU' },
	[0x1302] = { unicodeslot=0x1302, category='lo', description='ETHIOPIC SYLLABLE JI' },
	[0x1303] = { unicodeslot=0x1303, category='lo', description='ETHIOPIC SYLLABLE JAA' },
	[0x1304] = { unicodeslot=0x1304, category='lo', description='ETHIOPIC SYLLABLE JEE' },
	[0x1305] = { unicodeslot=0x1305, category='lo', description='ETHIOPIC SYLLABLE JE' },
	[0x1306] = { unicodeslot=0x1306, category='lo', description='ETHIOPIC SYLLABLE JO' },
	[0x1307] = { unicodeslot=0x1307, category='lo', description='ETHIOPIC SYLLABLE JWA' },
	[0x1308] = { unicodeslot=0x1308, category='lo', description='ETHIOPIC SYLLABLE GA' },
	[0x1309] = { unicodeslot=0x1309, category='lo', description='ETHIOPIC SYLLABLE GU' },
	[0x130A] = { unicodeslot=0x130A, category='lo', description='ETHIOPIC SYLLABLE GI' },
	[0x130B] = { unicodeslot=0x130B, category='lo', description='ETHIOPIC SYLLABLE GAA' },
	[0x130C] = { unicodeslot=0x130C, category='lo', description='ETHIOPIC SYLLABLE GEE' },
	[0x130D] = { unicodeslot=0x130D, category='lo', description='ETHIOPIC SYLLABLE GE' },
	[0x130E] = { unicodeslot=0x130E, category='lo', description='ETHIOPIC SYLLABLE GO' },
	[0x130F] = { unicodeslot=0x130F, category='lo', description='ETHIOPIC SYLLABLE GOA' },
	[0x1310] = { unicodeslot=0x1310, category='lo', description='ETHIOPIC SYLLABLE GWA' },
	[0x1312] = { unicodeslot=0x1312, category='lo', description='ETHIOPIC SYLLABLE GWI' },
	[0x1313] = { unicodeslot=0x1313, category='lo', description='ETHIOPIC SYLLABLE GWAA' },
	[0x1314] = { unicodeslot=0x1314, category='lo', description='ETHIOPIC SYLLABLE GWEE' },
	[0x1315] = { unicodeslot=0x1315, category='lo', description='ETHIOPIC SYLLABLE GWE' },
	[0x1318] = { unicodeslot=0x1318, category='lo', description='ETHIOPIC SYLLABLE GGA' },
	[0x1319] = { unicodeslot=0x1319, category='lo', description='ETHIOPIC SYLLABLE GGU' },
	[0x131A] = { unicodeslot=0x131A, category='lo', description='ETHIOPIC SYLLABLE GGI' },
	[0x131B] = { unicodeslot=0x131B, category='lo', description='ETHIOPIC SYLLABLE GGAA' },
	[0x131C] = { unicodeslot=0x131C, category='lo', description='ETHIOPIC SYLLABLE GGEE' },
	[0x131D] = { unicodeslot=0x131D, category='lo', description='ETHIOPIC SYLLABLE GGE' },
	[0x131E] = { unicodeslot=0x131E, category='lo', description='ETHIOPIC SYLLABLE GGO' },
	[0x131F] = { unicodeslot=0x131F, category='lo', description='ETHIOPIC SYLLABLE GGWAA' },
	[0x1320] = { unicodeslot=0x1320, category='lo', description='ETHIOPIC SYLLABLE THA' },
	[0x1321] = { unicodeslot=0x1321, category='lo', description='ETHIOPIC SYLLABLE THU' },
	[0x1322] = { unicodeslot=0x1322, category='lo', description='ETHIOPIC SYLLABLE THI' },
	[0x1323] = { unicodeslot=0x1323, category='lo', description='ETHIOPIC SYLLABLE THAA' },
	[0x1324] = { unicodeslot=0x1324, category='lo', description='ETHIOPIC SYLLABLE THEE' },
	[0x1325] = { unicodeslot=0x1325, category='lo', description='ETHIOPIC SYLLABLE THE' },
	[0x1326] = { unicodeslot=0x1326, category='lo', description='ETHIOPIC SYLLABLE THO' },
	[0x1327] = { unicodeslot=0x1327, category='lo', description='ETHIOPIC SYLLABLE THWA' },
	[0x1328] = { unicodeslot=0x1328, category='lo', description='ETHIOPIC SYLLABLE CHA' },
	[0x1329] = { unicodeslot=0x1329, category='lo', description='ETHIOPIC SYLLABLE CHU' },
	[0x132A] = { unicodeslot=0x132A, category='lo', description='ETHIOPIC SYLLABLE CHI' },
	[0x132B] = { unicodeslot=0x132B, category='lo', description='ETHIOPIC SYLLABLE CHAA' },
	[0x132C] = { unicodeslot=0x132C, category='lo', description='ETHIOPIC SYLLABLE CHEE' },
	[0x132D] = { unicodeslot=0x132D, category='lo', description='ETHIOPIC SYLLABLE CHE' },
	[0x132E] = { unicodeslot=0x132E, category='lo', description='ETHIOPIC SYLLABLE CHO' },
	[0x132F] = { unicodeslot=0x132F, category='lo', description='ETHIOPIC SYLLABLE CHWA' },
	[0x1330] = { unicodeslot=0x1330, category='lo', description='ETHIOPIC SYLLABLE PHA' },
	[0x1331] = { unicodeslot=0x1331, category='lo', description='ETHIOPIC SYLLABLE PHU' },
	[0x1332] = { unicodeslot=0x1332, category='lo', description='ETHIOPIC SYLLABLE PHI' },
	[0x1333] = { unicodeslot=0x1333, category='lo', description='ETHIOPIC SYLLABLE PHAA' },
	[0x1334] = { unicodeslot=0x1334, category='lo', description='ETHIOPIC SYLLABLE PHEE' },
	[0x1335] = { unicodeslot=0x1335, category='lo', description='ETHIOPIC SYLLABLE PHE' },
	[0x1336] = { unicodeslot=0x1336, category='lo', description='ETHIOPIC SYLLABLE PHO' },
	[0x1337] = { unicodeslot=0x1337, category='lo', description='ETHIOPIC SYLLABLE PHWA' },
	[0x1338] = { unicodeslot=0x1338, category='lo', description='ETHIOPIC SYLLABLE TSA' },
	[0x1339] = { unicodeslot=0x1339, category='lo', description='ETHIOPIC SYLLABLE TSU' },
	[0x133A] = { unicodeslot=0x133A, category='lo', description='ETHIOPIC SYLLABLE TSI' },
	[0x133B] = { unicodeslot=0x133B, category='lo', description='ETHIOPIC SYLLABLE TSAA' },
	[0x133C] = { unicodeslot=0x133C, category='lo', description='ETHIOPIC SYLLABLE TSEE' },
	[0x133D] = { unicodeslot=0x133D, category='lo', description='ETHIOPIC SYLLABLE TSE' },
	[0x133E] = { unicodeslot=0x133E, category='lo', description='ETHIOPIC SYLLABLE TSO' },
	[0x133F] = { unicodeslot=0x133F, category='lo', description='ETHIOPIC SYLLABLE TSWA' },
	[0x1340] = { unicodeslot=0x1340, category='lo', description='ETHIOPIC SYLLABLE TZA' },
	[0x1341] = { unicodeslot=0x1341, category='lo', description='ETHIOPIC SYLLABLE TZU' },
	[0x1342] = { unicodeslot=0x1342, category='lo', description='ETHIOPIC SYLLABLE TZI' },
	[0x1343] = { unicodeslot=0x1343, category='lo', description='ETHIOPIC SYLLABLE TZAA' },
	[0x1344] = { unicodeslot=0x1344, category='lo', description='ETHIOPIC SYLLABLE TZEE' },
	[0x1345] = { unicodeslot=0x1345, category='lo', description='ETHIOPIC SYLLABLE TZE' },
	[0x1346] = { unicodeslot=0x1346, category='lo', description='ETHIOPIC SYLLABLE TZO' },
	[0x1347] = { unicodeslot=0x1347, category='lo', description='ETHIOPIC SYLLABLE TZOA' },
	[0x1348] = { unicodeslot=0x1348, category='lo', description='ETHIOPIC SYLLABLE FA' },
	[0x1349] = { unicodeslot=0x1349, category='lo', description='ETHIOPIC SYLLABLE FU' },
	[0x134A] = { unicodeslot=0x134A, category='lo', description='ETHIOPIC SYLLABLE FI' },
	[0x134B] = { unicodeslot=0x134B, category='lo', description='ETHIOPIC SYLLABLE FAA' },
	[0x134C] = { unicodeslot=0x134C, category='lo', description='ETHIOPIC SYLLABLE FEE' },
	[0x134D] = { unicodeslot=0x134D, category='lo', description='ETHIOPIC SYLLABLE FE' },
	[0x134E] = { unicodeslot=0x134E, category='lo', description='ETHIOPIC SYLLABLE FO' },
	[0x134F] = { unicodeslot=0x134F, category='lo', description='ETHIOPIC SYLLABLE FWA' },
	[0x1350] = { unicodeslot=0x1350, category='lo', description='ETHIOPIC SYLLABLE PA' },
	[0x1351] = { unicodeslot=0x1351, category='lo', description='ETHIOPIC SYLLABLE PU' },
	[0x1352] = { unicodeslot=0x1352, category='lo', description='ETHIOPIC SYLLABLE PI' },
	[0x1353] = { unicodeslot=0x1353, category='lo', description='ETHIOPIC SYLLABLE PAA' },
	[0x1354] = { unicodeslot=0x1354, category='lo', description='ETHIOPIC SYLLABLE PEE' },
	[0x1355] = { unicodeslot=0x1355, category='lo', description='ETHIOPIC SYLLABLE PE' },
	[0x1356] = { unicodeslot=0x1356, category='lo', description='ETHIOPIC SYLLABLE PO' },
	[0x1357] = { unicodeslot=0x1357, category='lo', description='ETHIOPIC SYLLABLE PWA' },
	[0x1358] = { unicodeslot=0x1358, category='lo', description='ETHIOPIC SYLLABLE RYA' },
	[0x1359] = { unicodeslot=0x1359, category='lo', description='ETHIOPIC SYLLABLE MYA' },
	[0x135A] = { unicodeslot=0x135A, category='lo', description='ETHIOPIC SYLLABLE FYA' },
	[0x135F] = { unicodeslot=0x135F, category='mn', description='ETHIOPIC COMBINING GEMINATION MARK' },
	[0x1360] = { unicodeslot=0x1360, category='so', description='ETHIOPIC SECTION MARK' },
	[0x1361] = { unicodeslot=0x1361, category='po', description='ETHIOPIC WORDSPACE' },
	[0x1362] = { unicodeslot=0x1362, category='po', description='ETHIOPIC FULL STOP' },
	[0x1363] = { unicodeslot=0x1363, category='po', description='ETHIOPIC COMMA' },
	[0x1364] = { unicodeslot=0x1364, category='po', description='ETHIOPIC SEMICOLON' },
	[0x1365] = { unicodeslot=0x1365, category='po', description='ETHIOPIC COLON' },
	[0x1366] = { unicodeslot=0x1366, category='po', description='ETHIOPIC PREFACE COLON' },
	[0x1367] = { unicodeslot=0x1367, category='po', description='ETHIOPIC QUESTION MARK' },
	[0x1368] = { unicodeslot=0x1368, category='po', description='ETHIOPIC PARAGRAPH SEPARATOR' },
	[0x1369] = { unicodeslot=0x1369, category='no', description='ETHIOPIC DIGIT ONE' },
	[0x136A] = { unicodeslot=0x136A, category='no', description='ETHIOPIC DIGIT TWO' },
	[0x136B] = { unicodeslot=0x136B, category='no', description='ETHIOPIC DIGIT THREE' },
	[0x136C] = { unicodeslot=0x136C, category='no', description='ETHIOPIC DIGIT FOUR' },
	[0x136D] = { unicodeslot=0x136D, category='no', description='ETHIOPIC DIGIT FIVE' },
	[0x136E] = { unicodeslot=0x136E, category='no', description='ETHIOPIC DIGIT SIX' },
	[0x136F] = { unicodeslot=0x136F, category='no', description='ETHIOPIC DIGIT SEVEN' },
	[0x1370] = { unicodeslot=0x1370, category='no', description='ETHIOPIC DIGIT EIGHT' },
	[0x1371] = { unicodeslot=0x1371, category='no', description='ETHIOPIC DIGIT NINE' },
	[0x1372] = { unicodeslot=0x1372, category='no', description='ETHIOPIC NUMBER TEN' },
	[0x1373] = { unicodeslot=0x1373, category='no', description='ETHIOPIC NUMBER TWENTY' },
	[0x1374] = { unicodeslot=0x1374, category='no', description='ETHIOPIC NUMBER THIRTY' },
	[0x1375] = { unicodeslot=0x1375, category='no', description='ETHIOPIC NUMBER FORTY' },
	[0x1376] = { unicodeslot=0x1376, category='no', description='ETHIOPIC NUMBER FIFTY' },
	[0x1377] = { unicodeslot=0x1377, category='no', description='ETHIOPIC NUMBER SIXTY' },
	[0x1378] = { unicodeslot=0x1378, category='no', description='ETHIOPIC NUMBER SEVENTY' },
	[0x1379] = { unicodeslot=0x1379, category='no', description='ETHIOPIC NUMBER EIGHTY' },
	[0x137A] = { unicodeslot=0x137A, category='no', description='ETHIOPIC NUMBER NINETY' },
	[0x137B] = { unicodeslot=0x137B, category='no', description='ETHIOPIC NUMBER HUNDRED' },
	[0x137C] = { unicodeslot=0x137C, category='no', description='ETHIOPIC NUMBER TEN THOUSAND' },
	[0x1380] = { unicodeslot=0x1380, category='lo', description='ETHIOPIC SYLLABLE SEBATBEIT MWA' },
	[0x1381] = { unicodeslot=0x1381, category='lo', description='ETHIOPIC SYLLABLE MWI' },
	[0x1382] = { unicodeslot=0x1382, category='lo', description='ETHIOPIC SYLLABLE MWEE' },
	[0x1383] = { unicodeslot=0x1383, category='lo', description='ETHIOPIC SYLLABLE MWE' },
	[0x1384] = { unicodeslot=0x1384, category='lo', description='ETHIOPIC SYLLABLE SEBATBEIT BWA' },
	[0x1385] = { unicodeslot=0x1385, category='lo', description='ETHIOPIC SYLLABLE BWI' },
	[0x1386] = { unicodeslot=0x1386, category='lo', description='ETHIOPIC SYLLABLE BWEE' },
	[0x1387] = { unicodeslot=0x1387, category='lo', description='ETHIOPIC SYLLABLE BWE' },
	[0x1388] = { unicodeslot=0x1388, category='lo', description='ETHIOPIC SYLLABLE SEBATBEIT FWA' },
	[0x1389] = { unicodeslot=0x1389, category='lo', description='ETHIOPIC SYLLABLE FWI' },
	[0x138A] = { unicodeslot=0x138A, category='lo', description='ETHIOPIC SYLLABLE FWEE' },
	[0x138B] = { unicodeslot=0x138B, category='lo', description='ETHIOPIC SYLLABLE FWE' },
	[0x138C] = { unicodeslot=0x138C, category='lo', description='ETHIOPIC SYLLABLE SEBATBEIT PWA' },
	[0x138D] = { unicodeslot=0x138D, category='lo', description='ETHIOPIC SYLLABLE PWI' },
	[0x138E] = { unicodeslot=0x138E, category='lo', description='ETHIOPIC SYLLABLE PWEE' },
	[0x138F] = { unicodeslot=0x138F, category='lo', description='ETHIOPIC SYLLABLE PWE' },
	[0x1390] = { unicodeslot=0x1390, category='so', description='ETHIOPIC TONAL MARK YIZET' },
	[0x1391] = { unicodeslot=0x1391, category='so', description='ETHIOPIC TONAL MARK DERET' },
	[0x1392] = { unicodeslot=0x1392, category='so', description='ETHIOPIC TONAL MARK RIKRIK' },
	[0x1393] = { unicodeslot=0x1393, category='so', description='ETHIOPIC TONAL MARK SHORT RIKRIK' },
	[0x1394] = { unicodeslot=0x1394, category='so', description='ETHIOPIC TONAL MARK DIFAT' },
	[0x1395] = { unicodeslot=0x1395, category='so', description='ETHIOPIC TONAL MARK KENAT' },
	[0x1396] = { unicodeslot=0x1396, category='so', description='ETHIOPIC TONAL MARK CHIRET' },
	[0x1397] = { unicodeslot=0x1397, category='so', description='ETHIOPIC TONAL MARK HIDET' },
	[0x1398] = { unicodeslot=0x1398, category='so', description='ETHIOPIC TONAL MARK DERET-HIDET' },
	[0x1399] = { unicodeslot=0x1399, category='so', description='ETHIOPIC TONAL MARK KURT' },
	[0x13A0] = { unicodeslot=0x13A0, category='lo', description='CHEROKEE LETTER A' },
	[0x13A1] = { unicodeslot=0x13A1, category='lo', description='CHEROKEE LETTER E' },
	[0x13A2] = { unicodeslot=0x13A2, category='lo', description='CHEROKEE LETTER I' },
	[0x13A3] = { unicodeslot=0x13A3, category='lo', description='CHEROKEE LETTER O' },
	[0x13A4] = { unicodeslot=0x13A4, category='lo', description='CHEROKEE LETTER U' },
	[0x13A5] = { unicodeslot=0x13A5, category='lo', description='CHEROKEE LETTER V' },
	[0x13A6] = { unicodeslot=0x13A6, category='lo', description='CHEROKEE LETTER GA' },
	[0x13A7] = { unicodeslot=0x13A7, category='lo', description='CHEROKEE LETTER KA' },
	[0x13A8] = { unicodeslot=0x13A8, category='lo', description='CHEROKEE LETTER GE' },
	[0x13A9] = { unicodeslot=0x13A9, category='lo', description='CHEROKEE LETTER GI' },
	[0x13AA] = { unicodeslot=0x13AA, category='lo', description='CHEROKEE LETTER GO' },
	[0x13AB] = { unicodeslot=0x13AB, category='lo', description='CHEROKEE LETTER GU' },
	[0x13AC] = { unicodeslot=0x13AC, category='lo', description='CHEROKEE LETTER GV' },
	[0x13AD] = { unicodeslot=0x13AD, category='lo', description='CHEROKEE LETTER HA' },
	[0x13AE] = { unicodeslot=0x13AE, category='lo', description='CHEROKEE LETTER HE' },
	[0x13AF] = { unicodeslot=0x13AF, category='lo', description='CHEROKEE LETTER HI' },
	[0x13B0] = { unicodeslot=0x13B0, category='lo', description='CHEROKEE LETTER HO' },
	[0x13B1] = { unicodeslot=0x13B1, category='lo', description='CHEROKEE LETTER HU' },
	[0x13B2] = { unicodeslot=0x13B2, category='lo', description='CHEROKEE LETTER HV' },
	[0x13B3] = { unicodeslot=0x13B3, category='lo', description='CHEROKEE LETTER LA' },
	[0x13B4] = { unicodeslot=0x13B4, category='lo', description='CHEROKEE LETTER LE' },
	[0x13B5] = { unicodeslot=0x13B5, category='lo', description='CHEROKEE LETTER LI' },
	[0x13B6] = { unicodeslot=0x13B6, category='lo', description='CHEROKEE LETTER LO' },
	[0x13B7] = { unicodeslot=0x13B7, category='lo', description='CHEROKEE LETTER LU' },
	[0x13B8] = { unicodeslot=0x13B8, category='lo', description='CHEROKEE LETTER LV' },
	[0x13B9] = { unicodeslot=0x13B9, category='lo', description='CHEROKEE LETTER MA' },
	[0x13BA] = { unicodeslot=0x13BA, category='lo', description='CHEROKEE LETTER ME' },
	[0x13BB] = { unicodeslot=0x13BB, category='lo', description='CHEROKEE LETTER MI' },
	[0x13BC] = { unicodeslot=0x13BC, category='lo', description='CHEROKEE LETTER MO' },
	[0x13BD] = { unicodeslot=0x13BD, category='lo', description='CHEROKEE LETTER MU' },
	[0x13BE] = { unicodeslot=0x13BE, category='lo', description='CHEROKEE LETTER NA' },
	[0x13BF] = { unicodeslot=0x13BF, category='lo', description='CHEROKEE LETTER HNA' },
	[0x13C0] = { unicodeslot=0x13C0, category='lo', description='CHEROKEE LETTER NAH' },
	[0x13C1] = { unicodeslot=0x13C1, category='lo', description='CHEROKEE LETTER NE' },
	[0x13C2] = { unicodeslot=0x13C2, category='lo', description='CHEROKEE LETTER NI' },
	[0x13C3] = { unicodeslot=0x13C3, category='lo', description='CHEROKEE LETTER NO' },
	[0x13C4] = { unicodeslot=0x13C4, category='lo', description='CHEROKEE LETTER NU' },
	[0x13C5] = { unicodeslot=0x13C5, category='lo', description='CHEROKEE LETTER NV' },
	[0x13C6] = { unicodeslot=0x13C6, category='lo', description='CHEROKEE LETTER QUA' },
	[0x13C7] = { unicodeslot=0x13C7, category='lo', description='CHEROKEE LETTER QUE' },
	[0x13C8] = { unicodeslot=0x13C8, category='lo', description='CHEROKEE LETTER QUI' },
	[0x13C9] = { unicodeslot=0x13C9, category='lo', description='CHEROKEE LETTER QUO' },
	[0x13CA] = { unicodeslot=0x13CA, category='lo', description='CHEROKEE LETTER QUU' },
	[0x13CB] = { unicodeslot=0x13CB, category='lo', description='CHEROKEE LETTER QUV' },
	[0x13CC] = { unicodeslot=0x13CC, category='lo', description='CHEROKEE LETTER SA' },
	[0x13CD] = { unicodeslot=0x13CD, category='lo', description='CHEROKEE LETTER S' },
	[0x13CE] = { unicodeslot=0x13CE, category='lo', description='CHEROKEE LETTER SE' },
	[0x13CF] = { unicodeslot=0x13CF, category='lo', description='CHEROKEE LETTER SI' },
	[0x13D0] = { unicodeslot=0x13D0, category='lo', description='CHEROKEE LETTER SO' },
	[0x13D1] = { unicodeslot=0x13D1, category='lo', description='CHEROKEE LETTER SU' },
	[0x13D2] = { unicodeslot=0x13D2, category='lo', description='CHEROKEE LETTER SV' },
	[0x13D3] = { unicodeslot=0x13D3, category='lo', description='CHEROKEE LETTER DA' },
	[0x13D4] = { unicodeslot=0x13D4, category='lo', description='CHEROKEE LETTER TA' },
	[0x13D5] = { unicodeslot=0x13D5, category='lo', description='CHEROKEE LETTER DE' },
	[0x13D6] = { unicodeslot=0x13D6, category='lo', description='CHEROKEE LETTER TE' },
	[0x13D7] = { unicodeslot=0x13D7, category='lo', description='CHEROKEE LETTER DI' },
	[0x13D8] = { unicodeslot=0x13D8, category='lo', description='CHEROKEE LETTER TI' },
	[0x13D9] = { unicodeslot=0x13D9, category='lo', description='CHEROKEE LETTER DO' },
	[0x13DA] = { unicodeslot=0x13DA, category='lo', description='CHEROKEE LETTER DU' },
	[0x13DB] = { unicodeslot=0x13DB, category='lo', description='CHEROKEE LETTER DV' },
	[0x13DC] = { unicodeslot=0x13DC, category='lo', description='CHEROKEE LETTER DLA' },
	[0x13DD] = { unicodeslot=0x13DD, category='lo', description='CHEROKEE LETTER TLA' },
	[0x13DE] = { unicodeslot=0x13DE, category='lo', description='CHEROKEE LETTER TLE' },
	[0x13DF] = { unicodeslot=0x13DF, category='lo', description='CHEROKEE LETTER TLI' },
	[0x13E0] = { unicodeslot=0x13E0, category='lo', description='CHEROKEE LETTER TLO' },
	[0x13E1] = { unicodeslot=0x13E1, category='lo', description='CHEROKEE LETTER TLU' },
	[0x13E2] = { unicodeslot=0x13E2, category='lo', description='CHEROKEE LETTER TLV' },
	[0x13E3] = { unicodeslot=0x13E3, category='lo', description='CHEROKEE LETTER TSA' },
	[0x13E4] = { unicodeslot=0x13E4, category='lo', description='CHEROKEE LETTER TSE' },
	[0x13E5] = { unicodeslot=0x13E5, category='lo', description='CHEROKEE LETTER TSI' },
	[0x13E6] = { unicodeslot=0x13E6, category='lo', description='CHEROKEE LETTER TSO' },
	[0x13E7] = { unicodeslot=0x13E7, category='lo', description='CHEROKEE LETTER TSU' },
	[0x13E8] = { unicodeslot=0x13E8, category='lo', description='CHEROKEE LETTER TSV' },
	[0x13E9] = { unicodeslot=0x13E9, category='lo', description='CHEROKEE LETTER WA' },
	[0x13EA] = { unicodeslot=0x13EA, category='lo', description='CHEROKEE LETTER WE' },
	[0x13EB] = { unicodeslot=0x13EB, category='lo', description='CHEROKEE LETTER WI' },
	[0x13EC] = { unicodeslot=0x13EC, category='lo', description='CHEROKEE LETTER WO' },
	[0x13ED] = { unicodeslot=0x13ED, category='lo', description='CHEROKEE LETTER WU' },
	[0x13EE] = { unicodeslot=0x13EE, category='lo', description='CHEROKEE LETTER WV' },
	[0x13EF] = { unicodeslot=0x13EF, category='lo', description='CHEROKEE LETTER YA' },
	[0x13F0] = { unicodeslot=0x13F0, category='lo', description='CHEROKEE LETTER YE' },
	[0x13F1] = { unicodeslot=0x13F1, category='lo', description='CHEROKEE LETTER YI' },
	[0x13F2] = { unicodeslot=0x13F2, category='lo', description='CHEROKEE LETTER YO' },
	[0x13F3] = { unicodeslot=0x13F3, category='lo', description='CHEROKEE LETTER YU' },
	[0x13F4] = { unicodeslot=0x13F4, category='lo', description='CHEROKEE LETTER YV' },
	[0x1401] = { unicodeslot=0x1401, category='lo', description='CANADIAN SYLLABICS E' },
	[0x1402] = { unicodeslot=0x1402, category='lo', description='CANADIAN SYLLABICS AAI' },
	[0x1403] = { unicodeslot=0x1403, category='lo', description='CANADIAN SYLLABICS I' },
	[0x1404] = { unicodeslot=0x1404, category='lo', description='CANADIAN SYLLABICS II' },
	[0x1405] = { unicodeslot=0x1405, category='lo', description='CANADIAN SYLLABICS O' },
	[0x1406] = { unicodeslot=0x1406, category='lo', description='CANADIAN SYLLABICS OO' },
	[0x1407] = { unicodeslot=0x1407, category='lo', description='CANADIAN SYLLABICS Y-CREE OO' },
	[0x1408] = { unicodeslot=0x1408, category='lo', description='CANADIAN SYLLABICS CARRIER EE' },
	[0x1409] = { unicodeslot=0x1409, category='lo', description='CANADIAN SYLLABICS CARRIER I' },
	[0x140A] = { unicodeslot=0x140A, category='lo', description='CANADIAN SYLLABICS A' },
	[0x140B] = { unicodeslot=0x140B, category='lo', description='CANADIAN SYLLABICS AA' },
	[0x140C] = { unicodeslot=0x140C, category='lo', description='CANADIAN SYLLABICS WE' },
	[0x140D] = { unicodeslot=0x140D, category='lo', description='CANADIAN SYLLABICS WEST-CREE WE' },
	[0x140E] = { unicodeslot=0x140E, category='lo', description='CANADIAN SYLLABICS WI' },
	[0x140F] = { unicodeslot=0x140F, category='lo', description='CANADIAN SYLLABICS WEST-CREE WI' },
	[0x1410] = { unicodeslot=0x1410, category='lo', description='CANADIAN SYLLABICS WII' },
	[0x1411] = { unicodeslot=0x1411, category='lo', description='CANADIAN SYLLABICS WEST-CREE WII' },
	[0x1412] = { unicodeslot=0x1412, category='lo', description='CANADIAN SYLLABICS WO' },
	[0x1413] = { unicodeslot=0x1413, category='lo', description='CANADIAN SYLLABICS WEST-CREE WO' },
	[0x1414] = { unicodeslot=0x1414, category='lo', description='CANADIAN SYLLABICS WOO' },
	[0x1415] = { unicodeslot=0x1415, category='lo', description='CANADIAN SYLLABICS WEST-CREE WOO' },
	[0x1416] = { unicodeslot=0x1416, category='lo', description='CANADIAN SYLLABICS NASKAPI WOO' },
	[0x1417] = { unicodeslot=0x1417, category='lo', description='CANADIAN SYLLABICS WA' },
	[0x1418] = { unicodeslot=0x1418, category='lo', description='CANADIAN SYLLABICS WEST-CREE WA' },
	[0x1419] = { unicodeslot=0x1419, category='lo', description='CANADIAN SYLLABICS WAA' },
	[0x141A] = { unicodeslot=0x141A, category='lo', description='CANADIAN SYLLABICS WEST-CREE WAA' },
	[0x141B] = { unicodeslot=0x141B, category='lo', description='CANADIAN SYLLABICS NASKAPI WAA' },
	[0x141C] = { unicodeslot=0x141C, category='lo', description='CANADIAN SYLLABICS AI' },
	[0x141D] = { unicodeslot=0x141D, category='lo', description='CANADIAN SYLLABICS Y-CREE W' },
	[0x141E] = { unicodeslot=0x141E, category='lo', description='CANADIAN SYLLABICS GLOTTAL STOP' },
	[0x141F] = { unicodeslot=0x141F, category='lo', description='CANADIAN SYLLABICS FINAL ACUTE' },
	[0x1420] = { unicodeslot=0x1420, category='lo', description='CANADIAN SYLLABICS FINAL GRAVE' },
	[0x1421] = { unicodeslot=0x1421, category='lo', description='CANADIAN SYLLABICS FINAL BOTTOM HALF RING' },
	[0x1422] = { unicodeslot=0x1422, category='lo', description='CANADIAN SYLLABICS FINAL TOP HALF RING' },
	[0x1423] = { unicodeslot=0x1423, category='lo', description='CANADIAN SYLLABICS FINAL RIGHT HALF RING' },
	[0x1424] = { unicodeslot=0x1424, category='lo', description='CANADIAN SYLLABICS FINAL RING' },
	[0x1425] = { unicodeslot=0x1425, category='lo', description='CANADIAN SYLLABICS FINAL DOUBLE ACUTE' },
	[0x1426] = { unicodeslot=0x1426, category='lo', description='CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES' },
	[0x1427] = { unicodeslot=0x1427, category='lo', description='CANADIAN SYLLABICS FINAL MIDDLE DOT' },
	[0x1428] = { unicodeslot=0x1428, category='lo', description='CANADIAN SYLLABICS FINAL SHORT HORIZONTAL STROKE' },
	[0x1429] = { unicodeslot=0x1429, category='lo', description='CANADIAN SYLLABICS FINAL PLUS' },
	[0x142A] = { unicodeslot=0x142A, category='lo', description='CANADIAN SYLLABICS FINAL DOWN TACK' },
	[0x142B] = { unicodeslot=0x142B, category='lo', description='CANADIAN SYLLABICS EN' },
	[0x142C] = { unicodeslot=0x142C, category='lo', description='CANADIAN SYLLABICS IN' },
	[0x142D] = { unicodeslot=0x142D, category='lo', description='CANADIAN SYLLABICS ON' },
	[0x142E] = { unicodeslot=0x142E, category='lo', description='CANADIAN SYLLABICS AN' },
	[0x142F] = { unicodeslot=0x142F, category='lo', description='CANADIAN SYLLABICS PE' },
	[0x1430] = { unicodeslot=0x1430, category='lo', description='CANADIAN SYLLABICS PAAI' },
	[0x1431] = { unicodeslot=0x1431, category='lo', description='CANADIAN SYLLABICS PI' },
	[0x1432] = { unicodeslot=0x1432, category='lo', description='CANADIAN SYLLABICS PII' },
	[0x1433] = { unicodeslot=0x1433, category='lo', description='CANADIAN SYLLABICS PO' },
	[0x1434] = { unicodeslot=0x1434, category='lo', description='CANADIAN SYLLABICS POO' },
	[0x1435] = { unicodeslot=0x1435, category='lo', description='CANADIAN SYLLABICS Y-CREE POO' },
	[0x1436] = { unicodeslot=0x1436, category='lo', description='CANADIAN SYLLABICS CARRIER HEE' },
	[0x1437] = { unicodeslot=0x1437, category='lo', description='CANADIAN SYLLABICS CARRIER HI' },
	[0x1438] = { unicodeslot=0x1438, category='lo', description='CANADIAN SYLLABICS PA' },
	[0x1439] = { unicodeslot=0x1439, category='lo', description='CANADIAN SYLLABICS PAA' },
	[0x143A] = { unicodeslot=0x143A, category='lo', description='CANADIAN SYLLABICS PWE' },
	[0x143B] = { unicodeslot=0x143B, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWE' },
	[0x143C] = { unicodeslot=0x143C, category='lo', description='CANADIAN SYLLABICS PWI' },
	[0x143D] = { unicodeslot=0x143D, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWI' },
	[0x143E] = { unicodeslot=0x143E, category='lo', description='CANADIAN SYLLABICS PWII' },
	[0x143F] = { unicodeslot=0x143F, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWII' },
	[0x1440] = { unicodeslot=0x1440, category='lo', description='CANADIAN SYLLABICS PWO' },
	[0x1441] = { unicodeslot=0x1441, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWO' },
	[0x1442] = { unicodeslot=0x1442, category='lo', description='CANADIAN SYLLABICS PWOO' },
	[0x1443] = { unicodeslot=0x1443, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWOO' },
	[0x1444] = { unicodeslot=0x1444, category='lo', description='CANADIAN SYLLABICS PWA' },
	[0x1445] = { unicodeslot=0x1445, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWA' },
	[0x1446] = { unicodeslot=0x1446, category='lo', description='CANADIAN SYLLABICS PWAA' },
	[0x1447] = { unicodeslot=0x1447, category='lo', description='CANADIAN SYLLABICS WEST-CREE PWAA' },
	[0x1448] = { unicodeslot=0x1448, category='lo', description='CANADIAN SYLLABICS Y-CREE PWAA' },
	[0x1449] = { unicodeslot=0x1449, category='lo', description='CANADIAN SYLLABICS P' },
	[0x144A] = { unicodeslot=0x144A, category='lo', description='CANADIAN SYLLABICS WEST-CREE P' },
	[0x144B] = { unicodeslot=0x144B, category='lo', description='CANADIAN SYLLABICS CARRIER H' },
	[0x144C] = { unicodeslot=0x144C, category='lo', description='CANADIAN SYLLABICS TE' },
	[0x144D] = { unicodeslot=0x144D, category='lo', description='CANADIAN SYLLABICS TAAI' },
	[0x144E] = { unicodeslot=0x144E, category='lo', description='CANADIAN SYLLABICS TI' },
	[0x144F] = { unicodeslot=0x144F, category='lo', description='CANADIAN SYLLABICS TII' },
	[0x1450] = { unicodeslot=0x1450, category='lo', description='CANADIAN SYLLABICS TO' },
	[0x1451] = { unicodeslot=0x1451, category='lo', description='CANADIAN SYLLABICS TOO' },
	[0x1452] = { unicodeslot=0x1452, category='lo', description='CANADIAN SYLLABICS Y-CREE TOO' },
	[0x1453] = { unicodeslot=0x1453, category='lo', description='CANADIAN SYLLABICS CARRIER DEE' },
	[0x1454] = { unicodeslot=0x1454, category='lo', description='CANADIAN SYLLABICS CARRIER DI' },
	[0x1455] = { unicodeslot=0x1455, category='lo', description='CANADIAN SYLLABICS TA' },
	[0x1456] = { unicodeslot=0x1456, category='lo', description='CANADIAN SYLLABICS TAA' },
	[0x1457] = { unicodeslot=0x1457, category='lo', description='CANADIAN SYLLABICS TWE' },
	[0x1458] = { unicodeslot=0x1458, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWE' },
	[0x1459] = { unicodeslot=0x1459, category='lo', description='CANADIAN SYLLABICS TWI' },
	[0x145A] = { unicodeslot=0x145A, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWI' },
	[0x145B] = { unicodeslot=0x145B, category='lo', description='CANADIAN SYLLABICS TWII' },
	[0x145C] = { unicodeslot=0x145C, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWII' },
	[0x145D] = { unicodeslot=0x145D, category='lo', description='CANADIAN SYLLABICS TWO' },
	[0x145E] = { unicodeslot=0x145E, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWO' },
	[0x145F] = { unicodeslot=0x145F, category='lo', description='CANADIAN SYLLABICS TWOO' },
	[0x1460] = { unicodeslot=0x1460, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWOO' },
	[0x1461] = { unicodeslot=0x1461, category='lo', description='CANADIAN SYLLABICS TWA' },
	[0x1462] = { unicodeslot=0x1462, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWA' },
	[0x1463] = { unicodeslot=0x1463, category='lo', description='CANADIAN SYLLABICS TWAA' },
	[0x1464] = { unicodeslot=0x1464, category='lo', description='CANADIAN SYLLABICS WEST-CREE TWAA' },
	[0x1465] = { unicodeslot=0x1465, category='lo', description='CANADIAN SYLLABICS NASKAPI TWAA' },
	[0x1466] = { unicodeslot=0x1466, category='lo', description='CANADIAN SYLLABICS T' },
	[0x1467] = { unicodeslot=0x1467, category='lo', description='CANADIAN SYLLABICS TTE' },
	[0x1468] = { unicodeslot=0x1468, category='lo', description='CANADIAN SYLLABICS TTI' },
	[0x1469] = { unicodeslot=0x1469, category='lo', description='CANADIAN SYLLABICS TTO' },
	[0x146A] = { unicodeslot=0x146A, category='lo', description='CANADIAN SYLLABICS TTA' },
	[0x146B] = { unicodeslot=0x146B, category='lo', description='CANADIAN SYLLABICS KE' },
	[0x146C] = { unicodeslot=0x146C, category='lo', description='CANADIAN SYLLABICS KAAI' },
	[0x146D] = { unicodeslot=0x146D, category='lo', description='CANADIAN SYLLABICS KI' },
	[0x146E] = { unicodeslot=0x146E, category='lo', description='CANADIAN SYLLABICS KII' },
	[0x146F] = { unicodeslot=0x146F, category='lo', description='CANADIAN SYLLABICS KO' },
	[0x1470] = { unicodeslot=0x1470, category='lo', description='CANADIAN SYLLABICS KOO' },
	[0x1471] = { unicodeslot=0x1471, category='lo', description='CANADIAN SYLLABICS Y-CREE KOO' },
	[0x1472] = { unicodeslot=0x1472, category='lo', description='CANADIAN SYLLABICS KA' },
	[0x1473] = { unicodeslot=0x1473, category='lo', description='CANADIAN SYLLABICS KAA' },
	[0x1474] = { unicodeslot=0x1474, category='lo', description='CANADIAN SYLLABICS KWE' },
	[0x1475] = { unicodeslot=0x1475, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWE' },
	[0x1476] = { unicodeslot=0x1476, category='lo', description='CANADIAN SYLLABICS KWI' },
	[0x1477] = { unicodeslot=0x1477, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWI' },
	[0x1478] = { unicodeslot=0x1478, category='lo', description='CANADIAN SYLLABICS KWII' },
	[0x1479] = { unicodeslot=0x1479, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWII' },
	[0x147A] = { unicodeslot=0x147A, category='lo', description='CANADIAN SYLLABICS KWO' },
	[0x147B] = { unicodeslot=0x147B, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWO' },
	[0x147C] = { unicodeslot=0x147C, category='lo', description='CANADIAN SYLLABICS KWOO' },
	[0x147D] = { unicodeslot=0x147D, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWOO' },
	[0x147E] = { unicodeslot=0x147E, category='lo', description='CANADIAN SYLLABICS KWA' },
	[0x147F] = { unicodeslot=0x147F, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWA' },
	[0x1480] = { unicodeslot=0x1480, category='lo', description='CANADIAN SYLLABICS KWAA' },
	[0x1481] = { unicodeslot=0x1481, category='lo', description='CANADIAN SYLLABICS WEST-CREE KWAA' },
	[0x1482] = { unicodeslot=0x1482, category='lo', description='CANADIAN SYLLABICS NASKAPI KWAA' },
	[0x1483] = { unicodeslot=0x1483, category='lo', description='CANADIAN SYLLABICS K' },
	[0x1484] = { unicodeslot=0x1484, category='lo', description='CANADIAN SYLLABICS KW' },
	[0x1485] = { unicodeslot=0x1485, category='lo', description='CANADIAN SYLLABICS SOUTH-SLAVEY KEH' },
	[0x1486] = { unicodeslot=0x1486, category='lo', description='CANADIAN SYLLABICS SOUTH-SLAVEY KIH' },
	[0x1487] = { unicodeslot=0x1487, category='lo', description='CANADIAN SYLLABICS SOUTH-SLAVEY KOH' },
	[0x1488] = { unicodeslot=0x1488, category='lo', description='CANADIAN SYLLABICS SOUTH-SLAVEY KAH' },
	[0x1489] = { unicodeslot=0x1489, category='lo', description='CANADIAN SYLLABICS CE' },
	[0x148A] = { unicodeslot=0x148A, category='lo', description='CANADIAN SYLLABICS CAAI' },
	[0x148B] = { unicodeslot=0x148B, category='lo', description='CANADIAN SYLLABICS CI' },
	[0x148C] = { unicodeslot=0x148C, category='lo', description='CANADIAN SYLLABICS CII' },
	[0x148D] = { unicodeslot=0x148D, category='lo', description='CANADIAN SYLLABICS CO' },
	[0x148E] = { unicodeslot=0x148E, category='lo', description='CANADIAN SYLLABICS COO' },
	[0x148F] = { unicodeslot=0x148F, category='lo', description='CANADIAN SYLLABICS Y-CREE COO' },
	[0x1490] = { unicodeslot=0x1490, category='lo', description='CANADIAN SYLLABICS CA' },
	[0x1491] = { unicodeslot=0x1491, category='lo', description='CANADIAN SYLLABICS CAA' },
	[0x1492] = { unicodeslot=0x1492, category='lo', description='CANADIAN SYLLABICS CWE' },
	[0x1493] = { unicodeslot=0x1493, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWE' },
	[0x1494] = { unicodeslot=0x1494, category='lo', description='CANADIAN SYLLABICS CWI' },
	[0x1495] = { unicodeslot=0x1495, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWI' },
	[0x1496] = { unicodeslot=0x1496, category='lo', description='CANADIAN SYLLABICS CWII' },
	[0x1497] = { unicodeslot=0x1497, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWII' },
	[0x1498] = { unicodeslot=0x1498, category='lo', description='CANADIAN SYLLABICS CWO' },
	[0x1499] = { unicodeslot=0x1499, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWO' },
	[0x149A] = { unicodeslot=0x149A, category='lo', description='CANADIAN SYLLABICS CWOO' },
	[0x149B] = { unicodeslot=0x149B, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWOO' },
	[0x149C] = { unicodeslot=0x149C, category='lo', description='CANADIAN SYLLABICS CWA' },
	[0x149D] = { unicodeslot=0x149D, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWA' },
	[0x149E] = { unicodeslot=0x149E, category='lo', description='CANADIAN SYLLABICS CWAA' },
	[0x149F] = { unicodeslot=0x149F, category='lo', description='CANADIAN SYLLABICS WEST-CREE CWAA' },
	[0x14A0] = { unicodeslot=0x14A0, category='lo', description='CANADIAN SYLLABICS NASKAPI CWAA' },
	[0x14A1] = { unicodeslot=0x14A1, category='lo', description='CANADIAN SYLLABICS C' },
	[0x14A2] = { unicodeslot=0x14A2, category='lo', description='CANADIAN SYLLABICS SAYISI TH' },
	[0x14A3] = { unicodeslot=0x14A3, category='lo', description='CANADIAN SYLLABICS ME' },
	[0x14A4] = { unicodeslot=0x14A4, category='lo', description='CANADIAN SYLLABICS MAAI' },
	[0x14A5] = { unicodeslot=0x14A5, category='lo', description='CANADIAN SYLLABICS MI' },
	[0x14A6] = { unicodeslot=0x14A6, category='lo', description='CANADIAN SYLLABICS MII' },
	[0x14A7] = { unicodeslot=0x14A7, category='lo', description='CANADIAN SYLLABICS MO' },
	[0x14A8] = { unicodeslot=0x14A8, category='lo', description='CANADIAN SYLLABICS MOO' },
	[0x14A9] = { unicodeslot=0x14A9, category='lo', description='CANADIAN SYLLABICS Y-CREE MOO' },
	[0x14AA] = { unicodeslot=0x14AA, category='lo', description='CANADIAN SYLLABICS MA' },
	[0x14AB] = { unicodeslot=0x14AB, category='lo', description='CANADIAN SYLLABICS MAA' },
	[0x14AC] = { unicodeslot=0x14AC, category='lo', description='CANADIAN SYLLABICS MWE' },
	[0x14AD] = { unicodeslot=0x14AD, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWE' },
	[0x14AE] = { unicodeslot=0x14AE, category='lo', description='CANADIAN SYLLABICS MWI' },
	[0x14AF] = { unicodeslot=0x14AF, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWI' },
	[0x14B0] = { unicodeslot=0x14B0, category='lo', description='CANADIAN SYLLABICS MWII' },
	[0x14B1] = { unicodeslot=0x14B1, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWII' },
	[0x14B2] = { unicodeslot=0x14B2, category='lo', description='CANADIAN SYLLABICS MWO' },
	[0x14B3] = { unicodeslot=0x14B3, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWO' },
	[0x14B4] = { unicodeslot=0x14B4, category='lo', description='CANADIAN SYLLABICS MWOO' },
	[0x14B5] = { unicodeslot=0x14B5, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWOO' },
	[0x14B6] = { unicodeslot=0x14B6, category='lo', description='CANADIAN SYLLABICS MWA' },
	[0x14B7] = { unicodeslot=0x14B7, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWA' },
	[0x14B8] = { unicodeslot=0x14B8, category='lo', description='CANADIAN SYLLABICS MWAA' },
	[0x14B9] = { unicodeslot=0x14B9, category='lo', description='CANADIAN SYLLABICS WEST-CREE MWAA' },
	[0x14BA] = { unicodeslot=0x14BA, category='lo', description='CANADIAN SYLLABICS NASKAPI MWAA' },
	[0x14BB] = { unicodeslot=0x14BB, category='lo', description='CANADIAN SYLLABICS M' },
	[0x14BC] = { unicodeslot=0x14BC, category='lo', description='CANADIAN SYLLABICS WEST-CREE M' },
	[0x14BD] = { unicodeslot=0x14BD, category='lo', description='CANADIAN SYLLABICS MH' },
	[0x14BE] = { unicodeslot=0x14BE, category='lo', description='CANADIAN SYLLABICS ATHAPASCAN M' },
	[0x14BF] = { unicodeslot=0x14BF, category='lo', description='CANADIAN SYLLABICS SAYISI M' },
	[0x14C0] = { unicodeslot=0x14C0, category='lo', description='CANADIAN SYLLABICS NE' },
	[0x14C1] = { unicodeslot=0x14C1, category='lo', description='CANADIAN SYLLABICS NAAI' },
	[0x14C2] = { unicodeslot=0x14C2, category='lo', description='CANADIAN SYLLABICS NI' },
	[0x14C3] = { unicodeslot=0x14C3, category='lo', description='CANADIAN SYLLABICS NII' },
	[0x14C4] = { unicodeslot=0x14C4, category='lo', description='CANADIAN SYLLABICS NO' },
	[0x14C5] = { unicodeslot=0x14C5, category='lo', description='CANADIAN SYLLABICS NOO' },
	[0x14C6] = { unicodeslot=0x14C6, category='lo', description='CANADIAN SYLLABICS Y-CREE NOO' },
	[0x14C7] = { unicodeslot=0x14C7, category='lo', description='CANADIAN SYLLABICS NA' },
	[0x14C8] = { unicodeslot=0x14C8, category='lo', description='CANADIAN SYLLABICS NAA' },
	[0x14C9] = { unicodeslot=0x14C9, category='lo', description='CANADIAN SYLLABICS NWE' },
	[0x14CA] = { unicodeslot=0x14CA, category='lo', description='CANADIAN SYLLABICS WEST-CREE NWE' },
	[0x14CB] = { unicodeslot=0x14CB, category='lo', description='CANADIAN SYLLABICS NWA' },
	[0x14CC] = { unicodeslot=0x14CC, category='lo', description='CANADIAN SYLLABICS WEST-CREE NWA' },
	[0x14CD] = { unicodeslot=0x14CD, category='lo', description='CANADIAN SYLLABICS NWAA' },
	[0x14CE] = { unicodeslot=0x14CE, category='lo', description='CANADIAN SYLLABICS WEST-CREE NWAA' },
	[0x14CF] = { unicodeslot=0x14CF, category='lo', description='CANADIAN SYLLABICS NASKAPI NWAA' },
	[0x14D0] = { unicodeslot=0x14D0, category='lo', description='CANADIAN SYLLABICS N' },
	[0x14D1] = { unicodeslot=0x14D1, category='lo', description='CANADIAN SYLLABICS CARRIER NG' },
	[0x14D2] = { unicodeslot=0x14D2, category='lo', description='CANADIAN SYLLABICS NH' },
	[0x14D3] = { unicodeslot=0x14D3, category='lo', description='CANADIAN SYLLABICS LE' },
	[0x14D4] = { unicodeslot=0x14D4, category='lo', description='CANADIAN SYLLABICS LAAI' },
	[0x14D5] = { unicodeslot=0x14D5, category='lo', description='CANADIAN SYLLABICS LI' },
	[0x14D6] = { unicodeslot=0x14D6, category='lo', description='CANADIAN SYLLABICS LII' },
	[0x14D7] = { unicodeslot=0x14D7, category='lo', description='CANADIAN SYLLABICS LO' },
	[0x14D8] = { unicodeslot=0x14D8, category='lo', description='CANADIAN SYLLABICS LOO' },
	[0x14D9] = { unicodeslot=0x14D9, category='lo', description='CANADIAN SYLLABICS Y-CREE LOO' },
	[0x14DA] = { unicodeslot=0x14DA, category='lo', description='CANADIAN SYLLABICS LA' },
	[0x14DB] = { unicodeslot=0x14DB, category='lo', description='CANADIAN SYLLABICS LAA' },
	[0x14DC] = { unicodeslot=0x14DC, category='lo', description='CANADIAN SYLLABICS LWE' },
	[0x14DD] = { unicodeslot=0x14DD, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWE' },
	[0x14DE] = { unicodeslot=0x14DE, category='lo', description='CANADIAN SYLLABICS LWI' },
	[0x14DF] = { unicodeslot=0x14DF, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWI' },
	[0x14E0] = { unicodeslot=0x14E0, category='lo', description='CANADIAN SYLLABICS LWII' },
	[0x14E1] = { unicodeslot=0x14E1, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWII' },
	[0x14E2] = { unicodeslot=0x14E2, category='lo', description='CANADIAN SYLLABICS LWO' },
	[0x14E3] = { unicodeslot=0x14E3, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWO' },
	[0x14E4] = { unicodeslot=0x14E4, category='lo', description='CANADIAN SYLLABICS LWOO' },
	[0x14E5] = { unicodeslot=0x14E5, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWOO' },
	[0x14E6] = { unicodeslot=0x14E6, category='lo', description='CANADIAN SYLLABICS LWA' },
	[0x14E7] = { unicodeslot=0x14E7, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWA' },
	[0x14E8] = { unicodeslot=0x14E8, category='lo', description='CANADIAN SYLLABICS LWAA' },
	[0x14E9] = { unicodeslot=0x14E9, category='lo', description='CANADIAN SYLLABICS WEST-CREE LWAA' },
	[0x14EA] = { unicodeslot=0x14EA, category='lo', description='CANADIAN SYLLABICS L' },
	[0x14EB] = { unicodeslot=0x14EB, category='lo', description='CANADIAN SYLLABICS WEST-CREE L' },
	[0x14EC] = { unicodeslot=0x14EC, category='lo', description='CANADIAN SYLLABICS MEDIAL L' },
	[0x14ED] = { unicodeslot=0x14ED, category='lo', description='CANADIAN SYLLABICS SE' },
	[0x14EE] = { unicodeslot=0x14EE, category='lo', description='CANADIAN SYLLABICS SAAI' },
	[0x14EF] = { unicodeslot=0x14EF, category='lo', description='CANADIAN SYLLABICS SI' },
	[0x14F0] = { unicodeslot=0x14F0, category='lo', description='CANADIAN SYLLABICS SII' },
	[0x14F1] = { unicodeslot=0x14F1, category='lo', description='CANADIAN SYLLABICS SO' },
	[0x14F2] = { unicodeslot=0x14F2, category='lo', description='CANADIAN SYLLABICS SOO' },
	[0x14F3] = { unicodeslot=0x14F3, category='lo', description='CANADIAN SYLLABICS Y-CREE SOO' },
	[0x14F4] = { unicodeslot=0x14F4, category='lo', description='CANADIAN SYLLABICS SA' },
	[0x14F5] = { unicodeslot=0x14F5, category='lo', description='CANADIAN SYLLABICS SAA' },
	[0x14F6] = { unicodeslot=0x14F6, category='lo', description='CANADIAN SYLLABICS SWE' },
	[0x14F7] = { unicodeslot=0x14F7, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWE' },
	[0x14F8] = { unicodeslot=0x14F8, category='lo', description='CANADIAN SYLLABICS SWI' },
	[0x14F9] = { unicodeslot=0x14F9, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWI' },
	[0x14FA] = { unicodeslot=0x14FA, category='lo', description='CANADIAN SYLLABICS SWII' },
	[0x14FB] = { unicodeslot=0x14FB, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWII' },
	[0x14FC] = { unicodeslot=0x14FC, category='lo', description='CANADIAN SYLLABICS SWO' },
	[0x14FD] = { unicodeslot=0x14FD, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWO' },
	[0x14FE] = { unicodeslot=0x14FE, category='lo', description='CANADIAN SYLLABICS SWOO' },
	[0x14FF] = { unicodeslot=0x14FF, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWOO' },
	[0x1500] = { unicodeslot=0x1500, category='lo', description='CANADIAN SYLLABICS SWA' },
	[0x1501] = { unicodeslot=0x1501, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWA' },
	[0x1502] = { unicodeslot=0x1502, category='lo', description='CANADIAN SYLLABICS SWAA' },
	[0x1503] = { unicodeslot=0x1503, category='lo', description='CANADIAN SYLLABICS WEST-CREE SWAA' },
	[0x1504] = { unicodeslot=0x1504, category='lo', description='CANADIAN SYLLABICS NASKAPI SWAA' },
	[0x1505] = { unicodeslot=0x1505, category='lo', description='CANADIAN SYLLABICS S' },
	[0x1506] = { unicodeslot=0x1506, category='lo', description='CANADIAN SYLLABICS ATHAPASCAN S' },
	[0x1507] = { unicodeslot=0x1507, category='lo', description='CANADIAN SYLLABICS SW' },
	[0x1508] = { unicodeslot=0x1508, category='lo', description='CANADIAN SYLLABICS BLACKFOOT S' },
	[0x1509] = { unicodeslot=0x1509, category='lo', description='CANADIAN SYLLABICS MOOSE-CREE SK' },
	[0x150A] = { unicodeslot=0x150A, category='lo', description='CANADIAN SYLLABICS NASKAPI SKW' },
	[0x150B] = { unicodeslot=0x150B, category='lo', description='CANADIAN SYLLABICS NASKAPI S-W' },
	[0x150C] = { unicodeslot=0x150C, category='lo', description='CANADIAN SYLLABICS NASKAPI SPWA' },
	[0x150D] = { unicodeslot=0x150D, category='lo', description='CANADIAN SYLLABICS NASKAPI STWA' },
	[0x150E] = { unicodeslot=0x150E, category='lo', description='CANADIAN SYLLABICS NASKAPI SKWA' },
	[0x150F] = { unicodeslot=0x150F, category='lo', description='CANADIAN SYLLABICS NASKAPI SCWA' },
	[0x1510] = { unicodeslot=0x1510, category='lo', description='CANADIAN SYLLABICS SHE' },
	[0x1511] = { unicodeslot=0x1511, category='lo', description='CANADIAN SYLLABICS SHI' },
	[0x1512] = { unicodeslot=0x1512, category='lo', description='CANADIAN SYLLABICS SHII' },
	[0x1513] = { unicodeslot=0x1513, category='lo', description='CANADIAN SYLLABICS SHO' },
	[0x1514] = { unicodeslot=0x1514, category='lo', description='CANADIAN SYLLABICS SHOO' },
	[0x1515] = { unicodeslot=0x1515, category='lo', description='CANADIAN SYLLABICS SHA' },
	[0x1516] = { unicodeslot=0x1516, category='lo', description='CANADIAN SYLLABICS SHAA' },
	[0x1517] = { unicodeslot=0x1517, category='lo', description='CANADIAN SYLLABICS SHWE' },
	[0x1518] = { unicodeslot=0x1518, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWE' },
	[0x1519] = { unicodeslot=0x1519, category='lo', description='CANADIAN SYLLABICS SHWI' },
	[0x151A] = { unicodeslot=0x151A, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWI' },
	[0x151B] = { unicodeslot=0x151B, category='lo', description='CANADIAN SYLLABICS SHWII' },
	[0x151C] = { unicodeslot=0x151C, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWII' },
	[0x151D] = { unicodeslot=0x151D, category='lo', description='CANADIAN SYLLABICS SHWO' },
	[0x151E] = { unicodeslot=0x151E, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWO' },
	[0x151F] = { unicodeslot=0x151F, category='lo', description='CANADIAN SYLLABICS SHWOO' },
	[0x1520] = { unicodeslot=0x1520, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWOO' },
	[0x1521] = { unicodeslot=0x1521, category='lo', description='CANADIAN SYLLABICS SHWA' },
	[0x1522] = { unicodeslot=0x1522, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWA' },
	[0x1523] = { unicodeslot=0x1523, category='lo', description='CANADIAN SYLLABICS SHWAA' },
	[0x1524] = { unicodeslot=0x1524, category='lo', description='CANADIAN SYLLABICS WEST-CREE SHWAA' },
	[0x1525] = { unicodeslot=0x1525, category='lo', description='CANADIAN SYLLABICS SH' },
	[0x1526] = { unicodeslot=0x1526, category='lo', description='CANADIAN SYLLABICS YE' },
	[0x1527] = { unicodeslot=0x1527, category='lo', description='CANADIAN SYLLABICS YAAI' },
	[0x1528] = { unicodeslot=0x1528, category='lo', description='CANADIAN SYLLABICS YI' },
	[0x1529] = { unicodeslot=0x1529, category='lo', description='CANADIAN SYLLABICS YII' },
	[0x152A] = { unicodeslot=0x152A, category='lo', description='CANADIAN SYLLABICS YO' },
	[0x152B] = { unicodeslot=0x152B, category='lo', description='CANADIAN SYLLABICS YOO' },
	[0x152C] = { unicodeslot=0x152C, category='lo', description='CANADIAN SYLLABICS Y-CREE YOO' },
	[0x152D] = { unicodeslot=0x152D, category='lo', description='CANADIAN SYLLABICS YA' },
	[0x152E] = { unicodeslot=0x152E, category='lo', description='CANADIAN SYLLABICS YAA' },
	[0x152F] = { unicodeslot=0x152F, category='lo', description='CANADIAN SYLLABICS YWE' },
	[0x1530] = { unicodeslot=0x1530, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWE' },
	[0x1531] = { unicodeslot=0x1531, category='lo', description='CANADIAN SYLLABICS YWI' },
	[0x1532] = { unicodeslot=0x1532, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWI' },
	[0x1533] = { unicodeslot=0x1533, category='lo', description='CANADIAN SYLLABICS YWII' },
	[0x1534] = { unicodeslot=0x1534, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWII' },
	[0x1535] = { unicodeslot=0x1535, category='lo', description='CANADIAN SYLLABICS YWO' },
	[0x1536] = { unicodeslot=0x1536, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWO' },
	[0x1537] = { unicodeslot=0x1537, category='lo', description='CANADIAN SYLLABICS YWOO' },
	[0x1538] = { unicodeslot=0x1538, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWOO' },
	[0x1539] = { unicodeslot=0x1539, category='lo', description='CANADIAN SYLLABICS YWA' },
	[0x153A] = { unicodeslot=0x153A, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWA' },
	[0x153B] = { unicodeslot=0x153B, category='lo', description='CANADIAN SYLLABICS YWAA' },
	[0x153C] = { unicodeslot=0x153C, category='lo', description='CANADIAN SYLLABICS WEST-CREE YWAA' },
	[0x153D] = { unicodeslot=0x153D, category='lo', description='CANADIAN SYLLABICS NASKAPI YWAA' },
	[0x153E] = { unicodeslot=0x153E, category='lo', description='CANADIAN SYLLABICS Y' },
	[0x153F] = { unicodeslot=0x153F, category='lo', description='CANADIAN SYLLABICS BIBLE-CREE Y' },
	[0x1540] = { unicodeslot=0x1540, category='lo', description='CANADIAN SYLLABICS WEST-CREE Y' },
	[0x1541] = { unicodeslot=0x1541, category='lo', description='CANADIAN SYLLABICS SAYISI YI' },
	[0x1542] = { unicodeslot=0x1542, category='lo', description='CANADIAN SYLLABICS RE' },
	[0x1543] = { unicodeslot=0x1543, category='lo', description='CANADIAN SYLLABICS R-CREE RE' },
	[0x1544] = { unicodeslot=0x1544, category='lo', description='CANADIAN SYLLABICS WEST-CREE LE' },
	[0x1545] = { unicodeslot=0x1545, category='lo', description='CANADIAN SYLLABICS RAAI' },
	[0x1546] = { unicodeslot=0x1546, category='lo', description='CANADIAN SYLLABICS RI' },
	[0x1547] = { unicodeslot=0x1547, category='lo', description='CANADIAN SYLLABICS RII' },
	[0x1548] = { unicodeslot=0x1548, category='lo', description='CANADIAN SYLLABICS RO' },
	[0x1549] = { unicodeslot=0x1549, category='lo', description='CANADIAN SYLLABICS ROO' },
	[0x154A] = { unicodeslot=0x154A, category='lo', description='CANADIAN SYLLABICS WEST-CREE LO' },
	[0x154B] = { unicodeslot=0x154B, category='lo', description='CANADIAN SYLLABICS RA' },
	[0x154C] = { unicodeslot=0x154C, category='lo', description='CANADIAN SYLLABICS RAA' },
	[0x154D] = { unicodeslot=0x154D, category='lo', description='CANADIAN SYLLABICS WEST-CREE LA' },
	[0x154E] = { unicodeslot=0x154E, category='lo', description='CANADIAN SYLLABICS RWAA' },
	[0x154F] = { unicodeslot=0x154F, category='lo', description='CANADIAN SYLLABICS WEST-CREE RWAA' },
	[0x1550] = { unicodeslot=0x1550, category='lo', description='CANADIAN SYLLABICS R' },
	[0x1551] = { unicodeslot=0x1551, category='lo', description='CANADIAN SYLLABICS WEST-CREE R' },
	[0x1552] = { unicodeslot=0x1552, category='lo', description='CANADIAN SYLLABICS MEDIAL R' },
	[0x1553] = { unicodeslot=0x1553, category='lo', description='CANADIAN SYLLABICS FE' },
	[0x1554] = { unicodeslot=0x1554, category='lo', description='CANADIAN SYLLABICS FAAI' },
	[0x1555] = { unicodeslot=0x1555, category='lo', description='CANADIAN SYLLABICS FI' },
	[0x1556] = { unicodeslot=0x1556, category='lo', description='CANADIAN SYLLABICS FII' },
	[0x1557] = { unicodeslot=0x1557, category='lo', description='CANADIAN SYLLABICS FO' },
	[0x1558] = { unicodeslot=0x1558, category='lo', description='CANADIAN SYLLABICS FOO' },
	[0x1559] = { unicodeslot=0x1559, category='lo', description='CANADIAN SYLLABICS FA' },
	[0x155A] = { unicodeslot=0x155A, category='lo', description='CANADIAN SYLLABICS FAA' },
	[0x155B] = { unicodeslot=0x155B, category='lo', description='CANADIAN SYLLABICS FWAA' },
	[0x155C] = { unicodeslot=0x155C, category='lo', description='CANADIAN SYLLABICS WEST-CREE FWAA' },
	[0x155D] = { unicodeslot=0x155D, category='lo', description='CANADIAN SYLLABICS F' },
	[0x155E] = { unicodeslot=0x155E, category='lo', description='CANADIAN SYLLABICS THE' },
	[0x155F] = { unicodeslot=0x155F, category='lo', description='CANADIAN SYLLABICS N-CREE THE' },
	[0x1560] = { unicodeslot=0x1560, category='lo', description='CANADIAN SYLLABICS THI' },
	[0x1561] = { unicodeslot=0x1561, category='lo', description='CANADIAN SYLLABICS N-CREE THI' },
	[0x1562] = { unicodeslot=0x1562, category='lo', description='CANADIAN SYLLABICS THII' },
	[0x1563] = { unicodeslot=0x1563, category='lo', description='CANADIAN SYLLABICS N-CREE THII' },
	[0x1564] = { unicodeslot=0x1564, category='lo', description='CANADIAN SYLLABICS THO' },
	[0x1565] = { unicodeslot=0x1565, category='lo', description='CANADIAN SYLLABICS THOO' },
	[0x1566] = { unicodeslot=0x1566, category='lo', description='CANADIAN SYLLABICS THA' },
	[0x1567] = { unicodeslot=0x1567, category='lo', description='CANADIAN SYLLABICS THAA' },
	[0x1568] = { unicodeslot=0x1568, category='lo', description='CANADIAN SYLLABICS THWAA' },
	[0x1569] = { unicodeslot=0x1569, category='lo', description='CANADIAN SYLLABICS WEST-CREE THWAA' },
	[0x156A] = { unicodeslot=0x156A, category='lo', description='CANADIAN SYLLABICS TH' },
	[0x156B] = { unicodeslot=0x156B, category='lo', description='CANADIAN SYLLABICS TTHE' },
	[0x156C] = { unicodeslot=0x156C, category='lo', description='CANADIAN SYLLABICS TTHI' },
	[0x156D] = { unicodeslot=0x156D, category='lo', description='CANADIAN SYLLABICS TTHO' },
	[0x156E] = { unicodeslot=0x156E, category='lo', description='CANADIAN SYLLABICS TTHA' },
	[0x156F] = { unicodeslot=0x156F, category='lo', description='CANADIAN SYLLABICS TTH' },
	[0x1570] = { unicodeslot=0x1570, category='lo', description='CANADIAN SYLLABICS TYE' },
	[0x1571] = { unicodeslot=0x1571, category='lo', description='CANADIAN SYLLABICS TYI' },
	[0x1572] = { unicodeslot=0x1572, category='lo', description='CANADIAN SYLLABICS TYO' },
	[0x1573] = { unicodeslot=0x1573, category='lo', description='CANADIAN SYLLABICS TYA' },
	[0x1574] = { unicodeslot=0x1574, category='lo', description='CANADIAN SYLLABICS NUNAVIK HE' },
	[0x1575] = { unicodeslot=0x1575, category='lo', description='CANADIAN SYLLABICS NUNAVIK HI' },
	[0x1576] = { unicodeslot=0x1576, category='lo', description='CANADIAN SYLLABICS NUNAVIK HII' },
	[0x1577] = { unicodeslot=0x1577, category='lo', description='CANADIAN SYLLABICS NUNAVIK HO' },
	[0x1578] = { unicodeslot=0x1578, category='lo', description='CANADIAN SYLLABICS NUNAVIK HOO' },
	[0x1579] = { unicodeslot=0x1579, category='lo', description='CANADIAN SYLLABICS NUNAVIK HA' },
	[0x157A] = { unicodeslot=0x157A, category='lo', description='CANADIAN SYLLABICS NUNAVIK HAA' },
	[0x157B] = { unicodeslot=0x157B, category='lo', description='CANADIAN SYLLABICS NUNAVIK H' },
	[0x157C] = { unicodeslot=0x157C, category='lo', description='CANADIAN SYLLABICS NUNAVUT H' },
	[0x157D] = { unicodeslot=0x157D, category='lo', description='CANADIAN SYLLABICS HK' },
	[0x157E] = { unicodeslot=0x157E, category='lo', description='CANADIAN SYLLABICS QAAI' },
	[0x157F] = { unicodeslot=0x157F, category='lo', description='CANADIAN SYLLABICS QI' },
	[0x1580] = { unicodeslot=0x1580, category='lo', description='CANADIAN SYLLABICS QII' },
	[0x1581] = { unicodeslot=0x1581, category='lo', description='CANADIAN SYLLABICS QO' },
	[0x1582] = { unicodeslot=0x1582, category='lo', description='CANADIAN SYLLABICS QOO' },
	[0x1583] = { unicodeslot=0x1583, category='lo', description='CANADIAN SYLLABICS QA' },
	[0x1584] = { unicodeslot=0x1584, category='lo', description='CANADIAN SYLLABICS QAA' },
	[0x1585] = { unicodeslot=0x1585, category='lo', description='CANADIAN SYLLABICS Q' },
	[0x1586] = { unicodeslot=0x1586, category='lo', description='CANADIAN SYLLABICS TLHE' },
	[0x1587] = { unicodeslot=0x1587, category='lo', description='CANADIAN SYLLABICS TLHI' },
	[0x1588] = { unicodeslot=0x1588, category='lo', description='CANADIAN SYLLABICS TLHO' },
	[0x1589] = { unicodeslot=0x1589, category='lo', description='CANADIAN SYLLABICS TLHA' },
	[0x158A] = { unicodeslot=0x158A, category='lo', description='CANADIAN SYLLABICS WEST-CREE RE' },
	[0x158B] = { unicodeslot=0x158B, category='lo', description='CANADIAN SYLLABICS WEST-CREE RI' },
	[0x158C] = { unicodeslot=0x158C, category='lo', description='CANADIAN SYLLABICS WEST-CREE RO' },
	[0x158D] = { unicodeslot=0x158D, category='lo', description='CANADIAN SYLLABICS WEST-CREE RA' },
	[0x158E] = { unicodeslot=0x158E, category='lo', description='CANADIAN SYLLABICS NGAAI' },
	[0x158F] = { unicodeslot=0x158F, category='lo', description='CANADIAN SYLLABICS NGI' },
	[0x1590] = { unicodeslot=0x1590, category='lo', description='CANADIAN SYLLABICS NGII' },
	[0x1591] = { unicodeslot=0x1591, category='lo', description='CANADIAN SYLLABICS NGO' },
	[0x1592] = { unicodeslot=0x1592, category='lo', description='CANADIAN SYLLABICS NGOO' },
	[0x1593] = { unicodeslot=0x1593, category='lo', description='CANADIAN SYLLABICS NGA' },
	[0x1594] = { unicodeslot=0x1594, category='lo', description='CANADIAN SYLLABICS NGAA' },
	[0x1595] = { unicodeslot=0x1595, category='lo', description='CANADIAN SYLLABICS NG' },
	[0x1596] = { unicodeslot=0x1596, category='lo', description='CANADIAN SYLLABICS NNG' },
	[0x1597] = { unicodeslot=0x1597, category='lo', description='CANADIAN SYLLABICS SAYISI SHE' },
	[0x1598] = { unicodeslot=0x1598, category='lo', description='CANADIAN SYLLABICS SAYISI SHI' },
	[0x1599] = { unicodeslot=0x1599, category='lo', description='CANADIAN SYLLABICS SAYISI SHO' },
	[0x159A] = { unicodeslot=0x159A, category='lo', description='CANADIAN SYLLABICS SAYISI SHA' },
	[0x159B] = { unicodeslot=0x159B, category='lo', description='CANADIAN SYLLABICS WOODS-CREE THE' },
	[0x159C] = { unicodeslot=0x159C, category='lo', description='CANADIAN SYLLABICS WOODS-CREE THI' },
	[0x159D] = { unicodeslot=0x159D, category='lo', description='CANADIAN SYLLABICS WOODS-CREE THO' },
	[0x159E] = { unicodeslot=0x159E, category='lo', description='CANADIAN SYLLABICS WOODS-CREE THA' },
	[0x159F] = { unicodeslot=0x159F, category='lo', description='CANADIAN SYLLABICS WOODS-CREE TH' },
	[0x15A0] = { unicodeslot=0x15A0, category='lo', description='CANADIAN SYLLABICS LHI' },
	[0x15A1] = { unicodeslot=0x15A1, category='lo', description='CANADIAN SYLLABICS LHII' },
	[0x15A2] = { unicodeslot=0x15A2, category='lo', description='CANADIAN SYLLABICS LHO' },
	[0x15A3] = { unicodeslot=0x15A3, category='lo', description='CANADIAN SYLLABICS LHOO' },
	[0x15A4] = { unicodeslot=0x15A4, category='lo', description='CANADIAN SYLLABICS LHA' },
	[0x15A5] = { unicodeslot=0x15A5, category='lo', description='CANADIAN SYLLABICS LHAA' },
	[0x15A6] = { unicodeslot=0x15A6, category='lo', description='CANADIAN SYLLABICS LH' },
	[0x15A7] = { unicodeslot=0x15A7, category='lo', description='CANADIAN SYLLABICS TH-CREE THE' },
	[0x15A8] = { unicodeslot=0x15A8, category='lo', description='CANADIAN SYLLABICS TH-CREE THI' },
	[0x15A9] = { unicodeslot=0x15A9, category='lo', description='CANADIAN SYLLABICS TH-CREE THII' },
	[0x15AA] = { unicodeslot=0x15AA, category='lo', description='CANADIAN SYLLABICS TH-CREE THO' },
	[0x15AB] = { unicodeslot=0x15AB, category='lo', description='CANADIAN SYLLABICS TH-CREE THOO' },
	[0x15AC] = { unicodeslot=0x15AC, category='lo', description='CANADIAN SYLLABICS TH-CREE THA' },
	[0x15AD] = { unicodeslot=0x15AD, category='lo', description='CANADIAN SYLLABICS TH-CREE THAA' },
	[0x15AE] = { unicodeslot=0x15AE, category='lo', description='CANADIAN SYLLABICS TH-CREE TH' },
	[0x15AF] = { unicodeslot=0x15AF, category='lo', description='CANADIAN SYLLABICS AIVILIK B' },
	[0x15B0] = { unicodeslot=0x15B0, category='lo', description='CANADIAN SYLLABICS BLACKFOOT E' },
	[0x15B1] = { unicodeslot=0x15B1, category='lo', description='CANADIAN SYLLABICS BLACKFOOT I' },
	[0x15B2] = { unicodeslot=0x15B2, category='lo', description='CANADIAN SYLLABICS BLACKFOOT O' },
	[0x15B3] = { unicodeslot=0x15B3, category='lo', description='CANADIAN SYLLABICS BLACKFOOT A' },
	[0x15B4] = { unicodeslot=0x15B4, category='lo', description='CANADIAN SYLLABICS BLACKFOOT WE' },
	[0x15B5] = { unicodeslot=0x15B5, category='lo', description='CANADIAN SYLLABICS BLACKFOOT WI' },
	[0x15B6] = { unicodeslot=0x15B6, category='lo', description='CANADIAN SYLLABICS BLACKFOOT WO' },
	[0x15B7] = { unicodeslot=0x15B7, category='lo', description='CANADIAN SYLLABICS BLACKFOOT WA' },
	[0x15B8] = { unicodeslot=0x15B8, category='lo', description='CANADIAN SYLLABICS BLACKFOOT NE' },
	[0x15B9] = { unicodeslot=0x15B9, category='lo', description='CANADIAN SYLLABICS BLACKFOOT NI' },
	[0x15BA] = { unicodeslot=0x15BA, category='lo', description='CANADIAN SYLLABICS BLACKFOOT NO' },
	[0x15BB] = { unicodeslot=0x15BB, category='lo', description='CANADIAN SYLLABICS BLACKFOOT NA' },
	[0x15BC] = { unicodeslot=0x15BC, category='lo', description='CANADIAN SYLLABICS BLACKFOOT KE' },
	[0x15BD] = { unicodeslot=0x15BD, category='lo', description='CANADIAN SYLLABICS BLACKFOOT KI' },
	[0x15BE] = { unicodeslot=0x15BE, category='lo', description='CANADIAN SYLLABICS BLACKFOOT KO' },
	[0x15BF] = { unicodeslot=0x15BF, category='lo', description='CANADIAN SYLLABICS BLACKFOOT KA' },
	[0x15C0] = { unicodeslot=0x15C0, category='lo', description='CANADIAN SYLLABICS SAYISI HE' },
	[0x15C1] = { unicodeslot=0x15C1, category='lo', description='CANADIAN SYLLABICS SAYISI HI' },
	[0x15C2] = { unicodeslot=0x15C2, category='lo', description='CANADIAN SYLLABICS SAYISI HO' },
	[0x15C3] = { unicodeslot=0x15C3, category='lo', description='CANADIAN SYLLABICS SAYISI HA' },
	[0x15C4] = { unicodeslot=0x15C4, category='lo', description='CANADIAN SYLLABICS CARRIER GHU' },
	[0x15C5] = { unicodeslot=0x15C5, category='lo', description='CANADIAN SYLLABICS CARRIER GHO' },
	[0x15C6] = { unicodeslot=0x15C6, category='lo', description='CANADIAN SYLLABICS CARRIER GHE' },
	[0x15C7] = { unicodeslot=0x15C7, category='lo', description='CANADIAN SYLLABICS CARRIER GHEE' },
	[0x15C8] = { unicodeslot=0x15C8, category='lo', description='CANADIAN SYLLABICS CARRIER GHI' },
	[0x15C9] = { unicodeslot=0x15C9, category='lo', description='CANADIAN SYLLABICS CARRIER GHA' },
	[0x15CA] = { unicodeslot=0x15CA, category='lo', description='CANADIAN SYLLABICS CARRIER RU' },
	[0x15CB] = { unicodeslot=0x15CB, category='lo', description='CANADIAN SYLLABICS CARRIER RO' },
	[0x15CC] = { unicodeslot=0x15CC, category='lo', description='CANADIAN SYLLABICS CARRIER RE' },
	[0x15CD] = { unicodeslot=0x15CD, category='lo', description='CANADIAN SYLLABICS CARRIER REE' },
	[0x15CE] = { unicodeslot=0x15CE, category='lo', description='CANADIAN SYLLABICS CARRIER RI' },
	[0x15CF] = { unicodeslot=0x15CF, category='lo', description='CANADIAN SYLLABICS CARRIER RA' },
	[0x15D0] = { unicodeslot=0x15D0, category='lo', description='CANADIAN SYLLABICS CARRIER WU' },
	[0x15D1] = { unicodeslot=0x15D1, category='lo', description='CANADIAN SYLLABICS CARRIER WO' },
	[0x15D2] = { unicodeslot=0x15D2, category='lo', description='CANADIAN SYLLABICS CARRIER WE' },
	[0x15D3] = { unicodeslot=0x15D3, category='lo', description='CANADIAN SYLLABICS CARRIER WEE' },
	[0x15D4] = { unicodeslot=0x15D4, category='lo', description='CANADIAN SYLLABICS CARRIER WI' },
	[0x15D5] = { unicodeslot=0x15D5, category='lo', description='CANADIAN SYLLABICS CARRIER WA' },
	[0x15D6] = { unicodeslot=0x15D6, category='lo', description='CANADIAN SYLLABICS CARRIER HWU' },
	[0x15D7] = { unicodeslot=0x15D7, category='lo', description='CANADIAN SYLLABICS CARRIER HWO' },
	[0x15D8] = { unicodeslot=0x15D8, category='lo', description='CANADIAN SYLLABICS CARRIER HWE' },
	[0x15D9] = { unicodeslot=0x15D9, category='lo', description='CANADIAN SYLLABICS CARRIER HWEE' },
	[0x15DA] = { unicodeslot=0x15DA, category='lo', description='CANADIAN SYLLABICS CARRIER HWI' },
	[0x15DB] = { unicodeslot=0x15DB, category='lo', description='CANADIAN SYLLABICS CARRIER HWA' },
	[0x15DC] = { unicodeslot=0x15DC, category='lo', description='CANADIAN SYLLABICS CARRIER THU' },
	[0x15DD] = { unicodeslot=0x15DD, category='lo', description='CANADIAN SYLLABICS CARRIER THO' },
	[0x15DE] = { unicodeslot=0x15DE, category='lo', description='CANADIAN SYLLABICS CARRIER THE' },
	[0x15DF] = { unicodeslot=0x15DF, category='lo', description='CANADIAN SYLLABICS CARRIER THEE' },
	[0x15E0] = { unicodeslot=0x15E0, category='lo', description='CANADIAN SYLLABICS CARRIER THI' },
	[0x15E1] = { unicodeslot=0x15E1, category='lo', description='CANADIAN SYLLABICS CARRIER THA' },
	[0x15E2] = { unicodeslot=0x15E2, category='lo', description='CANADIAN SYLLABICS CARRIER TTU' },
	[0x15E3] = { unicodeslot=0x15E3, category='lo', description='CANADIAN SYLLABICS CARRIER TTO' },
	[0x15E4] = { unicodeslot=0x15E4, category='lo', description='CANADIAN SYLLABICS CARRIER TTE' },
	[0x15E5] = { unicodeslot=0x15E5, category='lo', description='CANADIAN SYLLABICS CARRIER TTEE' },
	[0x15E6] = { unicodeslot=0x15E6, category='lo', description='CANADIAN SYLLABICS CARRIER TTI' },
	[0x15E7] = { unicodeslot=0x15E7, category='lo', description='CANADIAN SYLLABICS CARRIER TTA' },
	[0x15E8] = { unicodeslot=0x15E8, category='lo', description='CANADIAN SYLLABICS CARRIER PU' },
	[0x15E9] = { unicodeslot=0x15E9, category='lo', description='CANADIAN SYLLABICS CARRIER PO' },
	[0x15EA] = { unicodeslot=0x15EA, category='lo', description='CANADIAN SYLLABICS CARRIER PE' },
	[0x15EB] = { unicodeslot=0x15EB, category='lo', description='CANADIAN SYLLABICS CARRIER PEE' },
	[0x15EC] = { unicodeslot=0x15EC, category='lo', description='CANADIAN SYLLABICS CARRIER PI' },
	[0x15ED] = { unicodeslot=0x15ED, category='lo', description='CANADIAN SYLLABICS CARRIER PA' },
	[0x15EE] = { unicodeslot=0x15EE, category='lo', description='CANADIAN SYLLABICS CARRIER P' },
	[0x15EF] = { unicodeslot=0x15EF, category='lo', description='CANADIAN SYLLABICS CARRIER GU' },
	[0x15F0] = { unicodeslot=0x15F0, category='lo', description='CANADIAN SYLLABICS CARRIER GO' },
	[0x15F1] = { unicodeslot=0x15F1, category='lo', description='CANADIAN SYLLABICS CARRIER GE' },
	[0x15F2] = { unicodeslot=0x15F2, category='lo', description='CANADIAN SYLLABICS CARRIER GEE' },
	[0x15F3] = { unicodeslot=0x15F3, category='lo', description='CANADIAN SYLLABICS CARRIER GI' },
	[0x15F4] = { unicodeslot=0x15F4, category='lo', description='CANADIAN SYLLABICS CARRIER GA' },
	[0x15F5] = { unicodeslot=0x15F5, category='lo', description='CANADIAN SYLLABICS CARRIER KHU' },
	[0x15F6] = { unicodeslot=0x15F6, category='lo', description='CANADIAN SYLLABICS CARRIER KHO' },
	[0x15F7] = { unicodeslot=0x15F7, category='lo', description='CANADIAN SYLLABICS CARRIER KHE' },
	[0x15F8] = { unicodeslot=0x15F8, category='lo', description='CANADIAN SYLLABICS CARRIER KHEE' },
	[0x15F9] = { unicodeslot=0x15F9, category='lo', description='CANADIAN SYLLABICS CARRIER KHI' },
	[0x15FA] = { unicodeslot=0x15FA, category='lo', description='CANADIAN SYLLABICS CARRIER KHA' },
	[0x15FB] = { unicodeslot=0x15FB, category='lo', description='CANADIAN SYLLABICS CARRIER KKU' },
	[0x15FC] = { unicodeslot=0x15FC, category='lo', description='CANADIAN SYLLABICS CARRIER KKO' },
	[0x15FD] = { unicodeslot=0x15FD, category='lo', description='CANADIAN SYLLABICS CARRIER KKE' },
	[0x15FE] = { unicodeslot=0x15FE, category='lo', description='CANADIAN SYLLABICS CARRIER KKEE' },
	[0x15FF] = { unicodeslot=0x15FF, category='lo', description='CANADIAN SYLLABICS CARRIER KKI' },
	[0x1600] = { unicodeslot=0x1600, category='lo', description='CANADIAN SYLLABICS CARRIER KKA' },
	[0x1601] = { unicodeslot=0x1601, category='lo', description='CANADIAN SYLLABICS CARRIER KK' },
	[0x1602] = { unicodeslot=0x1602, category='lo', description='CANADIAN SYLLABICS CARRIER NU' },
	[0x1603] = { unicodeslot=0x1603, category='lo', description='CANADIAN SYLLABICS CARRIER NO' },
	[0x1604] = { unicodeslot=0x1604, category='lo', description='CANADIAN SYLLABICS CARRIER NE' },
	[0x1605] = { unicodeslot=0x1605, category='lo', description='CANADIAN SYLLABICS CARRIER NEE' },
	[0x1606] = { unicodeslot=0x1606, category='lo', description='CANADIAN SYLLABICS CARRIER NI' },
	[0x1607] = { unicodeslot=0x1607, category='lo', description='CANADIAN SYLLABICS CARRIER NA' },
	[0x1608] = { unicodeslot=0x1608, category='lo', description='CANADIAN SYLLABICS CARRIER MU' },
	[0x1609] = { unicodeslot=0x1609, category='lo', description='CANADIAN SYLLABICS CARRIER MO' },
	[0x160A] = { unicodeslot=0x160A, category='lo', description='CANADIAN SYLLABICS CARRIER ME' },
	[0x160B] = { unicodeslot=0x160B, category='lo', description='CANADIAN SYLLABICS CARRIER MEE' },
	[0x160C] = { unicodeslot=0x160C, category='lo', description='CANADIAN SYLLABICS CARRIER MI' },
	[0x160D] = { unicodeslot=0x160D, category='lo', description='CANADIAN SYLLABICS CARRIER MA' },
	[0x160E] = { unicodeslot=0x160E, category='lo', description='CANADIAN SYLLABICS CARRIER YU' },
	[0x160F] = { unicodeslot=0x160F, category='lo', description='CANADIAN SYLLABICS CARRIER YO' },
	[0x1610] = { unicodeslot=0x1610, category='lo', description='CANADIAN SYLLABICS CARRIER YE' },
	[0x1611] = { unicodeslot=0x1611, category='lo', description='CANADIAN SYLLABICS CARRIER YEE' },
	[0x1612] = { unicodeslot=0x1612, category='lo', description='CANADIAN SYLLABICS CARRIER YI' },
	[0x1613] = { unicodeslot=0x1613, category='lo', description='CANADIAN SYLLABICS CARRIER YA' },
	[0x1614] = { unicodeslot=0x1614, category='lo', description='CANADIAN SYLLABICS CARRIER JU' },
	[0x1615] = { unicodeslot=0x1615, category='lo', description='CANADIAN SYLLABICS SAYISI JU' },
	[0x1616] = { unicodeslot=0x1616, category='lo', description='CANADIAN SYLLABICS CARRIER JO' },
	[0x1617] = { unicodeslot=0x1617, category='lo', description='CANADIAN SYLLABICS CARRIER JE' },
	[0x1618] = { unicodeslot=0x1618, category='lo', description='CANADIAN SYLLABICS CARRIER JEE' },
	[0x1619] = { unicodeslot=0x1619, category='lo', description='CANADIAN SYLLABICS CARRIER JI' },
	[0x161A] = { unicodeslot=0x161A, category='lo', description='CANADIAN SYLLABICS SAYISI JI' },
	[0x161B] = { unicodeslot=0x161B, category='lo', description='CANADIAN SYLLABICS CARRIER JA' },
	[0x161C] = { unicodeslot=0x161C, category='lo', description='CANADIAN SYLLABICS CARRIER JJU' },
	[0x161D] = { unicodeslot=0x161D, category='lo', description='CANADIAN SYLLABICS CARRIER JJO' },
	[0x161E] = { unicodeslot=0x161E, category='lo', description='CANADIAN SYLLABICS CARRIER JJE' },
	[0x161F] = { unicodeslot=0x161F, category='lo', description='CANADIAN SYLLABICS CARRIER JJEE' },
	[0x1620] = { unicodeslot=0x1620, category='lo', description='CANADIAN SYLLABICS CARRIER JJI' },
	[0x1621] = { unicodeslot=0x1621, category='lo', description='CANADIAN SYLLABICS CARRIER JJA' },
	[0x1622] = { unicodeslot=0x1622, category='lo', description='CANADIAN SYLLABICS CARRIER LU' },
	[0x1623] = { unicodeslot=0x1623, category='lo', description='CANADIAN SYLLABICS CARRIER LO' },
	[0x1624] = { unicodeslot=0x1624, category='lo', description='CANADIAN SYLLABICS CARRIER LE' },
	[0x1625] = { unicodeslot=0x1625, category='lo', description='CANADIAN SYLLABICS CARRIER LEE' },
	[0x1626] = { unicodeslot=0x1626, category='lo', description='CANADIAN SYLLABICS CARRIER LI' },
	[0x1627] = { unicodeslot=0x1627, category='lo', description='CANADIAN SYLLABICS CARRIER LA' },
	[0x1628] = { unicodeslot=0x1628, category='lo', description='CANADIAN SYLLABICS CARRIER DLU' },
	[0x1629] = { unicodeslot=0x1629, category='lo', description='CANADIAN SYLLABICS CARRIER DLO' },
	[0x162A] = { unicodeslot=0x162A, category='lo', description='CANADIAN SYLLABICS CARRIER DLE' },
	[0x162B] = { unicodeslot=0x162B, category='lo', description='CANADIAN SYLLABICS CARRIER DLEE' },
	[0x162C] = { unicodeslot=0x162C, category='lo', description='CANADIAN SYLLABICS CARRIER DLI' },
	[0x162D] = { unicodeslot=0x162D, category='lo', description='CANADIAN SYLLABICS CARRIER DLA' },
	[0x162E] = { unicodeslot=0x162E, category='lo', description='CANADIAN SYLLABICS CARRIER LHU' },
	[0x162F] = { unicodeslot=0x162F, category='lo', description='CANADIAN SYLLABICS CARRIER LHO' },
	[0x1630] = { unicodeslot=0x1630, category='lo', description='CANADIAN SYLLABICS CARRIER LHE' },
	[0x1631] = { unicodeslot=0x1631, category='lo', description='CANADIAN SYLLABICS CARRIER LHEE' },
	[0x1632] = { unicodeslot=0x1632, category='lo', description='CANADIAN SYLLABICS CARRIER LHI' },
	[0x1633] = { unicodeslot=0x1633, category='lo', description='CANADIAN SYLLABICS CARRIER LHA' },
	[0x1634] = { unicodeslot=0x1634, category='lo', description='CANADIAN SYLLABICS CARRIER TLHU' },
	[0x1635] = { unicodeslot=0x1635, category='lo', description='CANADIAN SYLLABICS CARRIER TLHO' },
	[0x1636] = { unicodeslot=0x1636, category='lo', description='CANADIAN SYLLABICS CARRIER TLHE' },
	[0x1637] = { unicodeslot=0x1637, category='lo', description='CANADIAN SYLLABICS CARRIER TLHEE' },
	[0x1638] = { unicodeslot=0x1638, category='lo', description='CANADIAN SYLLABICS CARRIER TLHI' },
	[0x1639] = { unicodeslot=0x1639, category='lo', description='CANADIAN SYLLABICS CARRIER TLHA' },
	[0x163A] = { unicodeslot=0x163A, category='lo', description='CANADIAN SYLLABICS CARRIER TLU' },
	[0x163B] = { unicodeslot=0x163B, category='lo', description='CANADIAN SYLLABICS CARRIER TLO' },
	[0x163C] = { unicodeslot=0x163C, category='lo', description='CANADIAN SYLLABICS CARRIER TLE' },
	[0x163D] = { unicodeslot=0x163D, category='lo', description='CANADIAN SYLLABICS CARRIER TLEE' },
	[0x163E] = { unicodeslot=0x163E, category='lo', description='CANADIAN SYLLABICS CARRIER TLI' },
	[0x163F] = { unicodeslot=0x163F, category='lo', description='CANADIAN SYLLABICS CARRIER TLA' },
	[0x1640] = { unicodeslot=0x1640, category='lo', description='CANADIAN SYLLABICS CARRIER ZU' },
	[0x1641] = { unicodeslot=0x1641, category='lo', description='CANADIAN SYLLABICS CARRIER ZO' },
	[0x1642] = { unicodeslot=0x1642, category='lo', description='CANADIAN SYLLABICS CARRIER ZE' },
	[0x1643] = { unicodeslot=0x1643, category='lo', description='CANADIAN SYLLABICS CARRIER ZEE' },
	[0x1644] = { unicodeslot=0x1644, category='lo', description='CANADIAN SYLLABICS CARRIER ZI' },
	[0x1645] = { unicodeslot=0x1645, category='lo', description='CANADIAN SYLLABICS CARRIER ZA' },
	[0x1646] = { unicodeslot=0x1646, category='lo', description='CANADIAN SYLLABICS CARRIER Z' },
	[0x1647] = { unicodeslot=0x1647, category='lo', description='CANADIAN SYLLABICS CARRIER INITIAL Z' },
	[0x1648] = { unicodeslot=0x1648, category='lo', description='CANADIAN SYLLABICS CARRIER DZU' },
	[0x1649] = { unicodeslot=0x1649, category='lo', description='CANADIAN SYLLABICS CARRIER DZO' },
	[0x164A] = { unicodeslot=0x164A, category='lo', description='CANADIAN SYLLABICS CARRIER DZE' },
	[0x164B] = { unicodeslot=0x164B, category='lo', description='CANADIAN SYLLABICS CARRIER DZEE' },
	[0x164C] = { unicodeslot=0x164C, category='lo', description='CANADIAN SYLLABICS CARRIER DZI' },
	[0x164D] = { unicodeslot=0x164D, category='lo', description='CANADIAN SYLLABICS CARRIER DZA' },
	[0x164E] = { unicodeslot=0x164E, category='lo', description='CANADIAN SYLLABICS CARRIER SU' },
	[0x164F] = { unicodeslot=0x164F, category='lo', description='CANADIAN SYLLABICS CARRIER SO' },
	[0x1650] = { unicodeslot=0x1650, category='lo', description='CANADIAN SYLLABICS CARRIER SE' },
	[0x1651] = { unicodeslot=0x1651, category='lo', description='CANADIAN SYLLABICS CARRIER SEE' },
	[0x1652] = { unicodeslot=0x1652, category='lo', description='CANADIAN SYLLABICS CARRIER SI' },
	[0x1653] = { unicodeslot=0x1653, category='lo', description='CANADIAN SYLLABICS CARRIER SA' },
	[0x1654] = { unicodeslot=0x1654, category='lo', description='CANADIAN SYLLABICS CARRIER SHU' },
	[0x1655] = { unicodeslot=0x1655, category='lo', description='CANADIAN SYLLABICS CARRIER SHO' },
	[0x1656] = { unicodeslot=0x1656, category='lo', description='CANADIAN SYLLABICS CARRIER SHE' },
	[0x1657] = { unicodeslot=0x1657, category='lo', description='CANADIAN SYLLABICS CARRIER SHEE' },
	[0x1658] = { unicodeslot=0x1658, category='lo', description='CANADIAN SYLLABICS CARRIER SHI' },
	[0x1659] = { unicodeslot=0x1659, category='lo', description='CANADIAN SYLLABICS CARRIER SHA' },
	[0x165A] = { unicodeslot=0x165A, category='lo', description='CANADIAN SYLLABICS CARRIER SH' },
	[0x165B] = { unicodeslot=0x165B, category='lo', description='CANADIAN SYLLABICS CARRIER TSU' },
	[0x165C] = { unicodeslot=0x165C, category='lo', description='CANADIAN SYLLABICS CARRIER TSO' },
	[0x165D] = { unicodeslot=0x165D, category='lo', description='CANADIAN SYLLABICS CARRIER TSE' },
	[0x165E] = { unicodeslot=0x165E, category='lo', description='CANADIAN SYLLABICS CARRIER TSEE' },
	[0x165F] = { unicodeslot=0x165F, category='lo', description='CANADIAN SYLLABICS CARRIER TSI' },
	[0x1660] = { unicodeslot=0x1660, category='lo', description='CANADIAN SYLLABICS CARRIER TSA' },
	[0x1661] = { unicodeslot=0x1661, category='lo', description='CANADIAN SYLLABICS CARRIER CHU' },
	[0x1662] = { unicodeslot=0x1662, category='lo', description='CANADIAN SYLLABICS CARRIER CHO' },
	[0x1663] = { unicodeslot=0x1663, category='lo', description='CANADIAN SYLLABICS CARRIER CHE' },
	[0x1664] = { unicodeslot=0x1664, category='lo', description='CANADIAN SYLLABICS CARRIER CHEE' },
	[0x1665] = { unicodeslot=0x1665, category='lo', description='CANADIAN SYLLABICS CARRIER CHI' },
	[0x1666] = { unicodeslot=0x1666, category='lo', description='CANADIAN SYLLABICS CARRIER CHA' },
	[0x1667] = { unicodeslot=0x1667, category='lo', description='CANADIAN SYLLABICS CARRIER TTSU' },
	[0x1668] = { unicodeslot=0x1668, category='lo', description='CANADIAN SYLLABICS CARRIER TTSO' },
	[0x1669] = { unicodeslot=0x1669, category='lo', description='CANADIAN SYLLABICS CARRIER TTSE' },
	[0x166A] = { unicodeslot=0x166A, category='lo', description='CANADIAN SYLLABICS CARRIER TTSEE' },
	[0x166B] = { unicodeslot=0x166B, category='lo', description='CANADIAN SYLLABICS CARRIER TTSI' },
	[0x166C] = { unicodeslot=0x166C, category='lo', description='CANADIAN SYLLABICS CARRIER TTSA' },
	[0x166D] = { unicodeslot=0x166D, category='po', description='CANADIAN SYLLABICS CHI SIGN' },
	[0x166E] = { unicodeslot=0x166E, category='po', description='CANADIAN SYLLABICS FULL STOP' },
	[0x166F] = { unicodeslot=0x166F, category='lo', description='CANADIAN SYLLABICS QAI' },
	[0x1670] = { unicodeslot=0x1670, category='lo', description='CANADIAN SYLLABICS NGAI' },
	[0x1671] = { unicodeslot=0x1671, category='lo', description='CANADIAN SYLLABICS NNGI' },
	[0x1672] = { unicodeslot=0x1672, category='lo', description='CANADIAN SYLLABICS NNGII' },
	[0x1673] = { unicodeslot=0x1673, category='lo', description='CANADIAN SYLLABICS NNGO' },
	[0x1674] = { unicodeslot=0x1674, category='lo', description='CANADIAN SYLLABICS NNGOO' },
	[0x1675] = { unicodeslot=0x1675, category='lo', description='CANADIAN SYLLABICS NNGA' },
	[0x1676] = { unicodeslot=0x1676, category='lo', description='CANADIAN SYLLABICS NNGAA' },
	[0x1680] = { unicodeslot=0x1680, category='zs', description='OGHAM SPACE MARK' },
	[0x1681] = { unicodeslot=0x1681, category='lo', description='OGHAM LETTER BEITH' },
	[0x1682] = { unicodeslot=0x1682, category='lo', description='OGHAM LETTER LUIS' },
	[0x1683] = { unicodeslot=0x1683, category='lo', description='OGHAM LETTER FEARN' },
	[0x1684] = { unicodeslot=0x1684, category='lo', description='OGHAM LETTER SAIL' },
	[0x1685] = { unicodeslot=0x1685, category='lo', description='OGHAM LETTER NION' },
	[0x1686] = { unicodeslot=0x1686, category='lo', description='OGHAM LETTER UATH' },
	[0x1687] = { unicodeslot=0x1687, category='lo', description='OGHAM LETTER DAIR' },
	[0x1688] = { unicodeslot=0x1688, category='lo', description='OGHAM LETTER TINNE' },
	[0x1689] = { unicodeslot=0x1689, category='lo', description='OGHAM LETTER COLL' },
	[0x168A] = { unicodeslot=0x168A, category='lo', description='OGHAM LETTER CEIRT' },
	[0x168B] = { unicodeslot=0x168B, category='lo', description='OGHAM LETTER MUIN' },
	[0x168C] = { unicodeslot=0x168C, category='lo', description='OGHAM LETTER GORT' },
	[0x168D] = { unicodeslot=0x168D, category='lo', description='OGHAM LETTER NGEADAL' },
	[0x168E] = { unicodeslot=0x168E, category='lo', description='OGHAM LETTER STRAIF' },
	[0x168F] = { unicodeslot=0x168F, category='lo', description='OGHAM LETTER RUIS' },
	[0x1690] = { unicodeslot=0x1690, category='lo', description='OGHAM LETTER AILM' },
	[0x1691] = { unicodeslot=0x1691, category='lo', description='OGHAM LETTER ONN' },
	[0x1692] = { unicodeslot=0x1692, category='lo', description='OGHAM LETTER UR' },
	[0x1693] = { unicodeslot=0x1693, category='lo', description='OGHAM LETTER EADHADH' },
	[0x1694] = { unicodeslot=0x1694, category='lo', description='OGHAM LETTER IODHADH' },
	[0x1695] = { unicodeslot=0x1695, category='lo', description='OGHAM LETTER EABHADH' },
	[0x1696] = { unicodeslot=0x1696, category='lo', description='OGHAM LETTER OR' },
	[0x1697] = { unicodeslot=0x1697, category='lo', description='OGHAM LETTER UILLEANN' },
	[0x1698] = { unicodeslot=0x1698, category='lo', description='OGHAM LETTER IFIN' },
	[0x1699] = { unicodeslot=0x1699, category='lo', description='OGHAM LETTER EAMHANCHOLL' },
	[0x169A] = { unicodeslot=0x169A, category='lo', description='OGHAM LETTER PEITH' },
	[0x169B] = { unicodeslot=0x169B, category='ps', description='OGHAM FEATHER MARK' },
	[0x169C] = { unicodeslot=0x169C, category='pe', description='OGHAM REVERSED FEATHER MARK' },
	[0x16A0] = { unicodeslot=0x16A0, category='lo', description='RUNIC LETTER FEHU FEOH FE F' },
	[0x16A1] = { unicodeslot=0x16A1, category='lo', description='RUNIC LETTER V' },
	[0x16A2] = { unicodeslot=0x16A2, category='lo', description='RUNIC LETTER URUZ UR U' },
	[0x16A3] = { unicodeslot=0x16A3, category='lo', description='RUNIC LETTER YR' },
	[0x16A4] = { unicodeslot=0x16A4, category='lo', description='RUNIC LETTER Y' },
	[0x16A5] = { unicodeslot=0x16A5, category='lo', description='RUNIC LETTER W' },
	[0x16A6] = { unicodeslot=0x16A6, category='lo', description='RUNIC LETTER THURISAZ THURS THORN' },
	[0x16A7] = { unicodeslot=0x16A7, category='lo', description='RUNIC LETTER ETH' },
	[0x16A8] = { unicodeslot=0x16A8, category='lo', description='RUNIC LETTER ANSUZ A' },
	[0x16A9] = { unicodeslot=0x16A9, category='lo', description='RUNIC LETTER OS O' },
	[0x16AA] = { unicodeslot=0x16AA, category='lo', description='RUNIC LETTER AC A' },
	[0x16AB] = { unicodeslot=0x16AB, category='lo', description='RUNIC LETTER AESC' },
	[0x16AC] = { unicodeslot=0x16AC, category='lo', description='RUNIC LETTER LONG-BRANCH-OSS O' },
	[0x16AD] = { unicodeslot=0x16AD, category='lo', description='RUNIC LETTER SHORT-TWIG-OSS O' },
	[0x16AE] = { unicodeslot=0x16AE, category='lo', description='RUNIC LETTER O' },
	[0x16AF] = { unicodeslot=0x16AF, category='lo', description='RUNIC LETTER OE' },
	[0x16B0] = { unicodeslot=0x16B0, category='lo', description='RUNIC LETTER ON' },
	[0x16B1] = { unicodeslot=0x16B1, category='lo', description='RUNIC LETTER RAIDO RAD REID R' },
	[0x16B2] = { unicodeslot=0x16B2, category='lo', description='RUNIC LETTER KAUNA' },
	[0x16B3] = { unicodeslot=0x16B3, category='lo', description='RUNIC LETTER CEN' },
	[0x16B4] = { unicodeslot=0x16B4, category='lo', description='RUNIC LETTER KAUN K' },
	[0x16B5] = { unicodeslot=0x16B5, category='lo', description='RUNIC LETTER G' },
	[0x16B6] = { unicodeslot=0x16B6, category='lo', description='RUNIC LETTER ENG' },
	[0x16B7] = { unicodeslot=0x16B7, category='lo', description='RUNIC LETTER GEBO GYFU G' },
	[0x16B8] = { unicodeslot=0x16B8, category='lo', description='RUNIC LETTER GAR' },
	[0x16B9] = { unicodeslot=0x16B9, category='lo', description='RUNIC LETTER WUNJO WYNN W' },
	[0x16BA] = { unicodeslot=0x16BA, category='lo', description='RUNIC LETTER HAGLAZ H' },
	[0x16BB] = { unicodeslot=0x16BB, category='lo', description='RUNIC LETTER HAEGL H' },
	[0x16BC] = { unicodeslot=0x16BC, category='lo', description='RUNIC LETTER LONG-BRANCH-HAGALL H' },
	[0x16BD] = { unicodeslot=0x16BD, category='lo', description='RUNIC LETTER SHORT-TWIG-HAGALL H' },
	[0x16BE] = { unicodeslot=0x16BE, category='lo', description='RUNIC LETTER NAUDIZ NYD NAUD N' },
	[0x16BF] = { unicodeslot=0x16BF, category='lo', description='RUNIC LETTER SHORT-TWIG-NAUD N' },
	[0x16C0] = { unicodeslot=0x16C0, category='lo', description='RUNIC LETTER DOTTED-N' },
	[0x16C1] = { unicodeslot=0x16C1, category='lo', description='RUNIC LETTER ISAZ IS ISS I' },
	[0x16C2] = { unicodeslot=0x16C2, category='lo', description='RUNIC LETTER E' },
	[0x16C3] = { unicodeslot=0x16C3, category='lo', description='RUNIC LETTER JERAN J' },
	[0x16C4] = { unicodeslot=0x16C4, category='lo', description='RUNIC LETTER GER' },
	[0x16C5] = { unicodeslot=0x16C5, category='lo', description='RUNIC LETTER LONG-BRANCH-AR AE' },
	[0x16C6] = { unicodeslot=0x16C6, category='lo', description='RUNIC LETTER SHORT-TWIG-AR A' },
	[0x16C7] = { unicodeslot=0x16C7, category='lo', description='RUNIC LETTER IWAZ EOH' },
	[0x16C8] = { unicodeslot=0x16C8, category='lo', description='RUNIC LETTER PERTHO PEORTH P' },
	[0x16C9] = { unicodeslot=0x16C9, category='lo', description='RUNIC LETTER ALGIZ EOLHX' },
	[0x16CA] = { unicodeslot=0x16CA, category='lo', description='RUNIC LETTER SOWILO S' },
	[0x16CB] = { unicodeslot=0x16CB, category='lo', description='RUNIC LETTER SIGEL LONG-BRANCH-SOL S' },
	[0x16CC] = { unicodeslot=0x16CC, category='lo', description='RUNIC LETTER SHORT-TWIG-SOL S' },
	[0x16CD] = { unicodeslot=0x16CD, category='lo', description='RUNIC LETTER C' },
	[0x16CE] = { unicodeslot=0x16CE, category='lo', description='RUNIC LETTER Z' },
	[0x16CF] = { unicodeslot=0x16CF, category='lo', description='RUNIC LETTER TIWAZ TIR TYR T' },
	[0x16D0] = { unicodeslot=0x16D0, category='lo', description='RUNIC LETTER SHORT-TWIG-TYR T' },
	[0x16D1] = { unicodeslot=0x16D1, category='lo', description='RUNIC LETTER D' },
	[0x16D2] = { unicodeslot=0x16D2, category='lo', description='RUNIC LETTER BERKANAN BEORC BJARKAN B' },
	[0x16D3] = { unicodeslot=0x16D3, category='lo', description='RUNIC LETTER SHORT-TWIG-BJARKAN B' },
	[0x16D4] = { unicodeslot=0x16D4, category='lo', description='RUNIC LETTER DOTTED-P' },
	[0x16D5] = { unicodeslot=0x16D5, category='lo', description='RUNIC LETTER OPEN-P' },
	[0x16D6] = { unicodeslot=0x16D6, category='lo', description='RUNIC LETTER EHWAZ EH E' },
	[0x16D7] = { unicodeslot=0x16D7, category='lo', description='RUNIC LETTER MANNAZ MAN M' },
	[0x16D8] = { unicodeslot=0x16D8, category='lo', description='RUNIC LETTER LONG-BRANCH-MADR M' },
	[0x16D9] = { unicodeslot=0x16D9, category='lo', description='RUNIC LETTER SHORT-TWIG-MADR M' },
	[0x16DA] = { unicodeslot=0x16DA, category='lo', description='RUNIC LETTER LAUKAZ LAGU LOGR L' },
	[0x16DB] = { unicodeslot=0x16DB, category='lo', description='RUNIC LETTER DOTTED-L' },
	[0x16DC] = { unicodeslot=0x16DC, category='lo', description='RUNIC LETTER INGWAZ' },
	[0x16DD] = { unicodeslot=0x16DD, category='lo', description='RUNIC LETTER ING' },
	[0x16DE] = { unicodeslot=0x16DE, category='lo', description='RUNIC LETTER DAGAZ DAEG D' },
	[0x16DF] = { unicodeslot=0x16DF, category='lo', description='RUNIC LETTER OTHALAN ETHEL O' },
	[0x16E0] = { unicodeslot=0x16E0, category='lo', description='RUNIC LETTER EAR' },
	[0x16E1] = { unicodeslot=0x16E1, category='lo', description='RUNIC LETTER IOR' },
	[0x16E2] = { unicodeslot=0x16E2, category='lo', description='RUNIC LETTER CWEORTH' },
	[0x16E3] = { unicodeslot=0x16E3, category='lo', description='RUNIC LETTER CALC' },
	[0x16E4] = { unicodeslot=0x16E4, category='lo', description='RUNIC LETTER CEALC' },
	[0x16E5] = { unicodeslot=0x16E5, category='lo', description='RUNIC LETTER STAN' },
	[0x16E6] = { unicodeslot=0x16E6, category='lo', description='RUNIC LETTER LONG-BRANCH-YR' },
	[0x16E7] = { unicodeslot=0x16E7, category='lo', description='RUNIC LETTER SHORT-TWIG-YR' },
	[0x16E8] = { unicodeslot=0x16E8, category='lo', description='RUNIC LETTER ICELANDIC-YR' },
	[0x16E9] = { unicodeslot=0x16E9, category='lo', description='RUNIC LETTER Q' },
	[0x16EA] = { unicodeslot=0x16EA, category='lo', description='RUNIC LETTER X' },
	[0x16EB] = { unicodeslot=0x16EB, category='po', description='RUNIC SINGLE PUNCTUATION' },
	[0x16EC] = { unicodeslot=0x16EC, category='po', description='RUNIC MULTIPLE PUNCTUATION' },
	[0x16ED] = { unicodeslot=0x16ED, category='po', description='RUNIC CROSS PUNCTUATION' },
	[0x16EE] = { unicodeslot=0x16EE, category='nl', description='RUNIC ARLAUG SYMBOL' },
	[0x16EF] = { unicodeslot=0x16EF, category='nl', description='RUNIC TVIMADUR SYMBOL' },
	[0x16F0] = { unicodeslot=0x16F0, category='nl', description='RUNIC BELGTHOR SYMBOL' },
	[0x1700] = { unicodeslot=0x1700, category='lo', description='TAGALOG LETTER A' },
	[0x1701] = { unicodeslot=0x1701, category='lo', description='TAGALOG LETTER I' },
	[0x1702] = { unicodeslot=0x1702, category='lo', description='TAGALOG LETTER U' },
	[0x1703] = { unicodeslot=0x1703, category='lo', description='TAGALOG LETTER KA' },
	[0x1704] = { unicodeslot=0x1704, category='lo', description='TAGALOG LETTER GA' },
	[0x1705] = { unicodeslot=0x1705, category='lo', description='TAGALOG LETTER NGA' },
	[0x1706] = { unicodeslot=0x1706, category='lo', description='TAGALOG LETTER TA' },
	[0x1707] = { unicodeslot=0x1707, category='lo', description='TAGALOG LETTER DA' },
	[0x1708] = { unicodeslot=0x1708, category='lo', description='TAGALOG LETTER NA' },
	[0x1709] = { unicodeslot=0x1709, category='lo', description='TAGALOG LETTER PA' },
	[0x170A] = { unicodeslot=0x170A, category='lo', description='TAGALOG LETTER BA' },
	[0x170B] = { unicodeslot=0x170B, category='lo', description='TAGALOG LETTER MA' },
	[0x170C] = { unicodeslot=0x170C, category='lo', description='TAGALOG LETTER YA' },
	[0x170E] = { unicodeslot=0x170E, category='lo', description='TAGALOG LETTER LA' },
	[0x170F] = { unicodeslot=0x170F, category='lo', description='TAGALOG LETTER WA' },
	[0x1710] = { unicodeslot=0x1710, category='lo', description='TAGALOG LETTER SA' },
	[0x1711] = { unicodeslot=0x1711, category='lo', description='TAGALOG LETTER HA' },
	[0x1712] = { unicodeslot=0x1712, category='mn', description='TAGALOG VOWEL SIGN I' },
	[0x1713] = { unicodeslot=0x1713, category='mn', description='TAGALOG VOWEL SIGN U' },
	[0x1714] = { unicodeslot=0x1714, category='mn', description='TAGALOG SIGN VIRAMA' },
	[0x1720] = { unicodeslot=0x1720, category='lo', description='HANUNOO LETTER A' },
	[0x1721] = { unicodeslot=0x1721, category='lo', description='HANUNOO LETTER I' },
	[0x1722] = { unicodeslot=0x1722, category='lo', description='HANUNOO LETTER U' },
	[0x1723] = { unicodeslot=0x1723, category='lo', description='HANUNOO LETTER KA' },
	[0x1724] = { unicodeslot=0x1724, category='lo', description='HANUNOO LETTER GA' },
	[0x1725] = { unicodeslot=0x1725, category='lo', description='HANUNOO LETTER NGA' },
	[0x1726] = { unicodeslot=0x1726, category='lo', description='HANUNOO LETTER TA' },
	[0x1727] = { unicodeslot=0x1727, category='lo', description='HANUNOO LETTER DA' },
	[0x1728] = { unicodeslot=0x1728, category='lo', description='HANUNOO LETTER NA' },
	[0x1729] = { unicodeslot=0x1729, category='lo', description='HANUNOO LETTER PA' },
	[0x172A] = { unicodeslot=0x172A, category='lo', description='HANUNOO LETTER BA' },
	[0x172B] = { unicodeslot=0x172B, category='lo', description='HANUNOO LETTER MA' },
	[0x172C] = { unicodeslot=0x172C, category='lo', description='HANUNOO LETTER YA' },
	[0x172D] = { unicodeslot=0x172D, category='lo', description='HANUNOO LETTER RA' },
	[0x172E] = { unicodeslot=0x172E, category='lo', description='HANUNOO LETTER LA' },
	[0x172F] = { unicodeslot=0x172F, category='lo', description='HANUNOO LETTER WA' },
	[0x1730] = { unicodeslot=0x1730, category='lo', description='HANUNOO LETTER SA' },
	[0x1731] = { unicodeslot=0x1731, category='lo', description='HANUNOO LETTER HA' },
	[0x1732] = { unicodeslot=0x1732, category='mn', description='HANUNOO VOWEL SIGN I' },
	[0x1733] = { unicodeslot=0x1733, category='mn', description='HANUNOO VOWEL SIGN U' },
	[0x1734] = { unicodeslot=0x1734, category='mn', description='HANUNOO SIGN PAMUDPOD' },
	[0x1735] = { unicodeslot=0x1735, category='po', description='PHILIPPINE SINGLE PUNCTUATION' },
	[0x1736] = { unicodeslot=0x1736, category='po', description='PHILIPPINE DOUBLE PUNCTUATION' },
	[0x1740] = { unicodeslot=0x1740, category='lo', description='BUHID LETTER A' },
	[0x1741] = { unicodeslot=0x1741, category='lo', description='BUHID LETTER I' },
	[0x1742] = { unicodeslot=0x1742, category='lo', description='BUHID LETTER U' },
	[0x1743] = { unicodeslot=0x1743, category='lo', description='BUHID LETTER KA' },
	[0x1744] = { unicodeslot=0x1744, category='lo', description='BUHID LETTER GA' },
	[0x1745] = { unicodeslot=0x1745, category='lo', description='BUHID LETTER NGA' },
	[0x1746] = { unicodeslot=0x1746, category='lo', description='BUHID LETTER TA' },
	[0x1747] = { unicodeslot=0x1747, category='lo', description='BUHID LETTER DA' },
	[0x1748] = { unicodeslot=0x1748, category='lo', description='BUHID LETTER NA' },
	[0x1749] = { unicodeslot=0x1749, category='lo', description='BUHID LETTER PA' },
	[0x174A] = { unicodeslot=0x174A, category='lo', description='BUHID LETTER BA' },
	[0x174B] = { unicodeslot=0x174B, category='lo', description='BUHID LETTER MA' },
	[0x174C] = { unicodeslot=0x174C, category='lo', description='BUHID LETTER YA' },
	[0x174D] = { unicodeslot=0x174D, category='lo', description='BUHID LETTER RA' },
	[0x174E] = { unicodeslot=0x174E, category='lo', description='BUHID LETTER LA' },
	[0x174F] = { unicodeslot=0x174F, category='lo', description='BUHID LETTER WA' },
	[0x1750] = { unicodeslot=0x1750, category='lo', description='BUHID LETTER SA' },
	[0x1751] = { unicodeslot=0x1751, category='lo', description='BUHID LETTER HA' },
	[0x1752] = { unicodeslot=0x1752, category='mn', description='BUHID VOWEL SIGN I' },
	[0x1753] = { unicodeslot=0x1753, category='mn', description='BUHID VOWEL SIGN U' },
	[0x1760] = { unicodeslot=0x1760, category='lo', description='TAGBANWA LETTER A' },
	[0x1761] = { unicodeslot=0x1761, category='lo', description='TAGBANWA LETTER I' },
	[0x1762] = { unicodeslot=0x1762, category='lo', description='TAGBANWA LETTER U' },
	[0x1763] = { unicodeslot=0x1763, category='lo', description='TAGBANWA LETTER KA' },
	[0x1764] = { unicodeslot=0x1764, category='lo', description='TAGBANWA LETTER GA' },
	[0x1765] = { unicodeslot=0x1765, category='lo', description='TAGBANWA LETTER NGA' },
	[0x1766] = { unicodeslot=0x1766, category='lo', description='TAGBANWA LETTER TA' },
	[0x1767] = { unicodeslot=0x1767, category='lo', description='TAGBANWA LETTER DA' },
	[0x1768] = { unicodeslot=0x1768, category='lo', description='TAGBANWA LETTER NA' },
	[0x1769] = { unicodeslot=0x1769, category='lo', description='TAGBANWA LETTER PA' },
	[0x176A] = { unicodeslot=0x176A, category='lo', description='TAGBANWA LETTER BA' },
	[0x176B] = { unicodeslot=0x176B, category='lo', description='TAGBANWA LETTER MA' },
	[0x176C] = { unicodeslot=0x176C, category='lo', description='TAGBANWA LETTER YA' },
	[0x176E] = { unicodeslot=0x176E, category='lo', description='TAGBANWA LETTER LA' },
	[0x176F] = { unicodeslot=0x176F, category='lo', description='TAGBANWA LETTER WA' },
	[0x1770] = { unicodeslot=0x1770, category='lo', description='TAGBANWA LETTER SA' },
	[0x1772] = { unicodeslot=0x1772, category='mn', description='TAGBANWA VOWEL SIGN I' },
	[0x1773] = { unicodeslot=0x1773, category='mn', description='TAGBANWA VOWEL SIGN U' },
	[0x1780] = { unicodeslot=0x1780, category='lo', description='KHMER LETTER KA' },
	[0x1781] = { unicodeslot=0x1781, category='lo', description='KHMER LETTER KHA' },
	[0x1782] = { unicodeslot=0x1782, category='lo', description='KHMER LETTER KO' },
	[0x1783] = { unicodeslot=0x1783, category='lo', description='KHMER LETTER KHO' },
	[0x1784] = { unicodeslot=0x1784, category='lo', description='KHMER LETTER NGO' },
	[0x1785] = { unicodeslot=0x1785, category='lo', description='KHMER LETTER CA' },
	[0x1786] = { unicodeslot=0x1786, category='lo', description='KHMER LETTER CHA' },
	[0x1787] = { unicodeslot=0x1787, category='lo', description='KHMER LETTER CO' },
	[0x1788] = { unicodeslot=0x1788, category='lo', description='KHMER LETTER CHO' },
	[0x1789] = { unicodeslot=0x1789, category='lo', description='KHMER LETTER NYO' },
	[0x178A] = { unicodeslot=0x178A, category='lo', description='KHMER LETTER DA' },
	[0x178B] = { unicodeslot=0x178B, category='lo', description='KHMER LETTER TTHA' },
	[0x178C] = { unicodeslot=0x178C, category='lo', description='KHMER LETTER DO' },
	[0x178D] = { unicodeslot=0x178D, category='lo', description='KHMER LETTER TTHO' },
	[0x178E] = { unicodeslot=0x178E, category='lo', description='KHMER LETTER NNO' },
	[0x178F] = { unicodeslot=0x178F, category='lo', description='KHMER LETTER TA' },
	[0x1790] = { unicodeslot=0x1790, category='lo', description='KHMER LETTER THA' },
	[0x1791] = { unicodeslot=0x1791, category='lo', description='KHMER LETTER TO' },
	[0x1792] = { unicodeslot=0x1792, category='lo', description='KHMER LETTER THO' },
	[0x1793] = { unicodeslot=0x1793, category='lo', description='KHMER LETTER NO' },
	[0x1794] = { unicodeslot=0x1794, category='lo', description='KHMER LETTER BA' },
	[0x1795] = { unicodeslot=0x1795, category='lo', description='KHMER LETTER PHA' },
	[0x1796] = { unicodeslot=0x1796, category='lo', description='KHMER LETTER PO' },
	[0x1797] = { unicodeslot=0x1797, category='lo', description='KHMER LETTER PHO' },
	[0x1798] = { unicodeslot=0x1798, category='lo', description='KHMER LETTER MO' },
	[0x1799] = { unicodeslot=0x1799, category='lo', description='KHMER LETTER YO' },
	[0x179A] = { unicodeslot=0x179A, category='lo', description='KHMER LETTER RO' },
	[0x179B] = { unicodeslot=0x179B, category='lo', description='KHMER LETTER LO' },
	[0x179C] = { unicodeslot=0x179C, category='lo', description='KHMER LETTER VO' },
	[0x179D] = { unicodeslot=0x179D, category='lo', description='KHMER LETTER SHA' },
	[0x179E] = { unicodeslot=0x179E, category='lo', description='KHMER LETTER SSO' },
	[0x179F] = { unicodeslot=0x179F, category='lo', description='KHMER LETTER SA' },
	[0x17A0] = { unicodeslot=0x17A0, category='lo', description='KHMER LETTER HA' },
	[0x17A1] = { unicodeslot=0x17A1, category='lo', description='KHMER LETTER LA' },
	[0x17A2] = { unicodeslot=0x17A2, category='lo', description='KHMER LETTER QA' },
	[0x17A3] = { unicodeslot=0x17A3, category='lo', description='KHMER INDEPENDENT VOWEL QAQ' },
	[0x17A4] = { unicodeslot=0x17A4, category='lo', description='KHMER INDEPENDENT VOWEL QAA' },
	[0x17A5] = { unicodeslot=0x17A5, category='lo', description='KHMER INDEPENDENT VOWEL QI' },
	[0x17A6] = { unicodeslot=0x17A6, category='lo', description='KHMER INDEPENDENT VOWEL QII' },
	[0x17A7] = { unicodeslot=0x17A7, category='lo', description='KHMER INDEPENDENT VOWEL QU' },
	[0x17A8] = { unicodeslot=0x17A8, category='lo', description='KHMER INDEPENDENT VOWEL QUK' },
	[0x17A9] = { unicodeslot=0x17A9, category='lo', description='KHMER INDEPENDENT VOWEL QUU' },
	[0x17AA] = { unicodeslot=0x17AA, category='lo', description='KHMER INDEPENDENT VOWEL QUUV' },
	[0x17AB] = { unicodeslot=0x17AB, category='lo', description='KHMER INDEPENDENT VOWEL RY' },
	[0x17AC] = { unicodeslot=0x17AC, category='lo', description='KHMER INDEPENDENT VOWEL RYY' },
	[0x17AD] = { unicodeslot=0x17AD, category='lo', description='KHMER INDEPENDENT VOWEL LY' },
	[0x17AE] = { unicodeslot=0x17AE, category='lo', description='KHMER INDEPENDENT VOWEL LYY' },
	[0x17AF] = { unicodeslot=0x17AF, category='lo', description='KHMER INDEPENDENT VOWEL QE' },
	[0x17B0] = { unicodeslot=0x17B0, category='lo', description='KHMER INDEPENDENT VOWEL QAI' },
	[0x17B1] = { unicodeslot=0x17B1, category='lo', description='KHMER INDEPENDENT VOWEL QOO TYPE ONE' },
	[0x17B2] = { unicodeslot=0x17B2, category='lo', description='KHMER INDEPENDENT VOWEL QOO TYPE TWO' },
	[0x17B3] = { unicodeslot=0x17B3, category='lo', description='KHMER INDEPENDENT VOWEL QAU' },
	[0x17B4] = { unicodeslot=0x17B4, category='cf', description='KHMER VOWEL INHERENT AQ' },
	[0x17B5] = { unicodeslot=0x17B5, category='cf', description='KHMER VOWEL INHERENT AA' },
	[0x17B6] = { unicodeslot=0x17B6, category='mc', description='KHMER VOWEL SIGN AA' },
	[0x17B7] = { unicodeslot=0x17B7, category='mn', description='KHMER VOWEL SIGN I' },
	[0x17B8] = { unicodeslot=0x17B8, category='mn', description='KHMER VOWEL SIGN II' },
	[0x17B9] = { unicodeslot=0x17B9, category='mn', description='KHMER VOWEL SIGN Y' },
	[0x17BA] = { unicodeslot=0x17BA, category='mn', description='KHMER VOWEL SIGN YY' },
	[0x17BB] = { unicodeslot=0x17BB, category='mn', description='KHMER VOWEL SIGN U' },
	[0x17BC] = { unicodeslot=0x17BC, category='mn', description='KHMER VOWEL SIGN UU' },
	[0x17BD] = { unicodeslot=0x17BD, category='mn', description='KHMER VOWEL SIGN UA' },
	[0x17BE] = { unicodeslot=0x17BE, category='mc', description='KHMER VOWEL SIGN OE' },
	[0x17BF] = { unicodeslot=0x17BF, category='mc', description='KHMER VOWEL SIGN YA' },
	[0x17C0] = { unicodeslot=0x17C0, category='mc', description='KHMER VOWEL SIGN IE' },
	[0x17C1] = { unicodeslot=0x17C1, category='mc', description='KHMER VOWEL SIGN E' },
	[0x17C2] = { unicodeslot=0x17C2, category='mc', description='KHMER VOWEL SIGN AE' },
	[0x17C3] = { unicodeslot=0x17C3, category='mc', description='KHMER VOWEL SIGN AI' },
	[0x17C4] = { unicodeslot=0x17C4, category='mc', description='KHMER VOWEL SIGN OO' },
	[0x17C5] = { unicodeslot=0x17C5, category='mc', description='KHMER VOWEL SIGN AU' },
	[0x17C6] = { unicodeslot=0x17C6, category='mn', description='KHMER SIGN NIKAHIT' },
	[0x17C7] = { unicodeslot=0x17C7, category='mc', description='KHMER SIGN REAHMUK' },
	[0x17C8] = { unicodeslot=0x17C8, category='mc', description='KHMER SIGN YUUKALEAPINTU' },
	[0x17C9] = { unicodeslot=0x17C9, category='mn', description='KHMER SIGN MUUSIKATOAN' },
	[0x17CA] = { unicodeslot=0x17CA, category='mn', description='KHMER SIGN TRIISAP' },
	[0x17CB] = { unicodeslot=0x17CB, category='mn', description='KHMER SIGN BANTOC' },
	[0x17CC] = { unicodeslot=0x17CC, category='mn', description='KHMER SIGN ROBAT' },
	[0x17CD] = { unicodeslot=0x17CD, category='mn', description='KHMER SIGN TOANDAKHIAT' },
	[0x17CE] = { unicodeslot=0x17CE, category='mn', description='KHMER SIGN KAKABAT' },
	[0x17CF] = { unicodeslot=0x17CF, category='mn', description='KHMER SIGN AHSDA' },
	[0x17D0] = { unicodeslot=0x17D0, category='mn', description='KHMER SIGN SAMYOK SANNYA' },
	[0x17D1] = { unicodeslot=0x17D1, category='mn', description='KHMER SIGN VIRIAM' },
	[0x17D2] = { unicodeslot=0x17D2, category='mn', description='KHMER SIGN COENG' },
	[0x17D3] = { unicodeslot=0x17D3, category='mn', description='KHMER SIGN BATHAMASAT' },
	[0x17D4] = { unicodeslot=0x17D4, category='po', description='KHMER SIGN KHAN' },
	[0x17D5] = { unicodeslot=0x17D5, category='po', description='KHMER SIGN BARIYOOSAN' },
	[0x17D6] = { unicodeslot=0x17D6, category='po', description='KHMER SIGN CAMNUC PII KUUH' },
	[0x17D7] = { unicodeslot=0x17D7, category='lm', description='KHMER SIGN LEK TOO' },
	[0x17D8] = { unicodeslot=0x17D8, category='po', description='KHMER SIGN BEYYAL' },
	[0x17D9] = { unicodeslot=0x17D9, category='po', description='KHMER SIGN PHNAEK MUAN' },
	[0x17DA] = { unicodeslot=0x17DA, category='po', description='KHMER SIGN KOOMUUT' },
	[0x17DB] = { unicodeslot=0x17DB, category='sc', description='KHMER CURRENCY SYMBOL RIEL' },
	[0x17DC] = { unicodeslot=0x17DC, category='lo', description='KHMER SIGN AVAKRAHASANYA' },
	[0x17DD] = { unicodeslot=0x17DD, category='mn', description='KHMER SIGN ATTHACAN' },
	[0x17E0] = { unicodeslot=0x17E0, category='nd', description='KHMER DIGIT ZERO' },
	[0x17E1] = { unicodeslot=0x17E1, category='nd', description='KHMER DIGIT ONE' },
	[0x17E2] = { unicodeslot=0x17E2, category='nd', description='KHMER DIGIT TWO' },
	[0x17E3] = { unicodeslot=0x17E3, category='nd', description='KHMER DIGIT THREE' },
	[0x17E4] = { unicodeslot=0x17E4, category='nd', description='KHMER DIGIT FOUR' },
	[0x17E5] = { unicodeslot=0x17E5, category='nd', description='KHMER DIGIT FIVE' },
	[0x17E6] = { unicodeslot=0x17E6, category='nd', description='KHMER DIGIT SIX' },
	[0x17E7] = { unicodeslot=0x17E7, category='nd', description='KHMER DIGIT SEVEN' },
	[0x17E8] = { unicodeslot=0x17E8, category='nd', description='KHMER DIGIT EIGHT' },
	[0x17E9] = { unicodeslot=0x17E9, category='nd', description='KHMER DIGIT NINE' },
	[0x17F0] = { unicodeslot=0x17F0, category='no', description='KHMER SYMBOL LEK ATTAK SON' },
	[0x17F1] = { unicodeslot=0x17F1, category='no', description='KHMER SYMBOL LEK ATTAK MUOY' },
	[0x17F2] = { unicodeslot=0x17F2, category='no', description='KHMER SYMBOL LEK ATTAK PII' },
	[0x17F3] = { unicodeslot=0x17F3, category='no', description='KHMER SYMBOL LEK ATTAK BEI' },
	[0x17F4] = { unicodeslot=0x17F4, category='no', description='KHMER SYMBOL LEK ATTAK BUON' },
	[0x17F5] = { unicodeslot=0x17F5, category='no', description='KHMER SYMBOL LEK ATTAK PRAM' },
	[0x17F6] = { unicodeslot=0x17F6, category='no', description='KHMER SYMBOL LEK ATTAK PRAM-MUOY' },
	[0x17F7] = { unicodeslot=0x17F7, category='no', description='KHMER SYMBOL LEK ATTAK PRAM-PII' },
	[0x17F8] = { unicodeslot=0x17F8, category='no', description='KHMER SYMBOL LEK ATTAK PRAM-BEI' },
	[0x17F9] = { unicodeslot=0x17F9, category='no', description='KHMER SYMBOL LEK ATTAK PRAM-BUON' },
	[0x1800] = { unicodeslot=0x1800, category='po', description='MONGOLIAN BIRGA' },
	[0x1801] = { unicodeslot=0x1801, category='po', description='MONGOLIAN ELLIPSIS' },
	[0x1802] = { unicodeslot=0x1802, category='po', description='MONGOLIAN COMMA' },
	[0x1803] = { unicodeslot=0x1803, category='po', description='MONGOLIAN FULL STOP' },
	[0x1804] = { unicodeslot=0x1804, category='po', description='MONGOLIAN COLON' },
	[0x1805] = { unicodeslot=0x1805, category='po', description='MONGOLIAN FOUR DOTS' },
	[0x1806] = { unicodeslot=0x1806, category='pd', description='MONGOLIAN TODO SOFT HYPHEN' },
	[0x1807] = { unicodeslot=0x1807, category='po', description='MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER' },
	[0x1808] = { unicodeslot=0x1808, category='po', description='MONGOLIAN MANCHU COMMA' },
	[0x1809] = { unicodeslot=0x1809, category='po', description='MONGOLIAN MANCHU FULL STOP' },
	[0x180A] = { unicodeslot=0x180A, category='po', description='MONGOLIAN NIRUGU' },
	[0x180B] = { unicodeslot=0x180B, category='mn', description='MONGOLIAN FREE VARIATION SELECTOR ONE' },
	[0x180C] = { unicodeslot=0x180C, category='mn', description='MONGOLIAN FREE VARIATION SELECTOR TWO' },
	[0x180D] = { unicodeslot=0x180D, category='mn', description='MONGOLIAN FREE VARIATION SELECTOR THREE' },
	[0x180E] = { unicodeslot=0x180E, category='zs', description='MONGOLIAN VOWEL SEPARATOR' },
	[0x1810] = { unicodeslot=0x1810, category='nd', description='MONGOLIAN DIGIT ZERO' },
	[0x1811] = { unicodeslot=0x1811, category='nd', description='MONGOLIAN DIGIT ONE' },
	[0x1812] = { unicodeslot=0x1812, category='nd', description='MONGOLIAN DIGIT TWO' },
	[0x1813] = { unicodeslot=0x1813, category='nd', description='MONGOLIAN DIGIT THREE' },
	[0x1814] = { unicodeslot=0x1814, category='nd', description='MONGOLIAN DIGIT FOUR' },
	[0x1815] = { unicodeslot=0x1815, category='nd', description='MONGOLIAN DIGIT FIVE' },
	[0x1816] = { unicodeslot=0x1816, category='nd', description='MONGOLIAN DIGIT SIX' },
	[0x1817] = { unicodeslot=0x1817, category='nd', description='MONGOLIAN DIGIT SEVEN' },
	[0x1818] = { unicodeslot=0x1818, category='nd', description='MONGOLIAN DIGIT EIGHT' },
	[0x1819] = { unicodeslot=0x1819, category='nd', description='MONGOLIAN DIGIT NINE' },
	[0x1820] = { unicodeslot=0x1820, category='lo', description='MONGOLIAN LETTER A' },
	[0x1821] = { unicodeslot=0x1821, category='lo', description='MONGOLIAN LETTER E' },
	[0x1822] = { unicodeslot=0x1822, category='lo', description='MONGOLIAN LETTER I' },
	[0x1823] = { unicodeslot=0x1823, category='lo', description='MONGOLIAN LETTER O' },
	[0x1824] = { unicodeslot=0x1824, category='lo', description='MONGOLIAN LETTER U' },
	[0x1825] = { unicodeslot=0x1825, category='lo', description='MONGOLIAN LETTER OE' },
	[0x1826] = { unicodeslot=0x1826, category='lo', description='MONGOLIAN LETTER UE' },
	[0x1827] = { unicodeslot=0x1827, category='lo', description='MONGOLIAN LETTER EE' },
	[0x1828] = { unicodeslot=0x1828, category='lo', description='MONGOLIAN LETTER NA' },
	[0x1829] = { unicodeslot=0x1829, category='lo', description='MONGOLIAN LETTER ANG' },
	[0x182A] = { unicodeslot=0x182A, category='lo', description='MONGOLIAN LETTER BA' },
	[0x182B] = { unicodeslot=0x182B, category='lo', description='MONGOLIAN LETTER PA' },
	[0x182C] = { unicodeslot=0x182C, category='lo', description='MONGOLIAN LETTER QA' },
	[0x182D] = { unicodeslot=0x182D, category='lo', description='MONGOLIAN LETTER GA' },
	[0x182E] = { unicodeslot=0x182E, category='lo', description='MONGOLIAN LETTER MA' },
	[0x182F] = { unicodeslot=0x182F, category='lo', description='MONGOLIAN LETTER LA' },
	[0x1830] = { unicodeslot=0x1830, category='lo', description='MONGOLIAN LETTER SA' },
	[0x1831] = { unicodeslot=0x1831, category='lo', description='MONGOLIAN LETTER SHA' },
	[0x1832] = { unicodeslot=0x1832, category='lo', description='MONGOLIAN LETTER TA' },
	[0x1833] = { unicodeslot=0x1833, category='lo', description='MONGOLIAN LETTER DA' },
	[0x1834] = { unicodeslot=0x1834, category='lo', description='MONGOLIAN LETTER CHA' },
	[0x1835] = { unicodeslot=0x1835, category='lo', description='MONGOLIAN LETTER JA' },
	[0x1836] = { unicodeslot=0x1836, category='lo', description='MONGOLIAN LETTER YA' },
	[0x1837] = { unicodeslot=0x1837, category='lo', description='MONGOLIAN LETTER RA' },
	[0x1838] = { unicodeslot=0x1838, category='lo', description='MONGOLIAN LETTER WA' },
	[0x1839] = { unicodeslot=0x1839, category='lo', description='MONGOLIAN LETTER FA' },
	[0x183A] = { unicodeslot=0x183A, category='lo', description='MONGOLIAN LETTER KA' },
	[0x183B] = { unicodeslot=0x183B, category='lo', description='MONGOLIAN LETTER KHA' },
	[0x183C] = { unicodeslot=0x183C, category='lo', description='MONGOLIAN LETTER TSA' },
	[0x183D] = { unicodeslot=0x183D, category='lo', description='MONGOLIAN LETTER ZA' },
	[0x183E] = { unicodeslot=0x183E, category='lo', description='MONGOLIAN LETTER HAA' },
	[0x183F] = { unicodeslot=0x183F, category='lo', description='MONGOLIAN LETTER ZRA' },
	[0x1840] = { unicodeslot=0x1840, category='lo', description='MONGOLIAN LETTER LHA' },
	[0x1841] = { unicodeslot=0x1841, category='lo', description='MONGOLIAN LETTER ZHI' },
	[0x1842] = { unicodeslot=0x1842, category='lo', description='MONGOLIAN LETTER CHI' },
	[0x1843] = { unicodeslot=0x1843, category='lm', description='MONGOLIAN LETTER TODO LONG VOWEL SIGN' },
	[0x1844] = { unicodeslot=0x1844, category='lo', description='MONGOLIAN LETTER TODO E' },
	[0x1845] = { unicodeslot=0x1845, category='lo', description='MONGOLIAN LETTER TODO I' },
	[0x1846] = { unicodeslot=0x1846, category='lo', description='MONGOLIAN LETTER TODO O' },
	[0x1847] = { unicodeslot=0x1847, category='lo', description='MONGOLIAN LETTER TODO U' },
	[0x1848] = { unicodeslot=0x1848, category='lo', description='MONGOLIAN LETTER TODO OE' },
	[0x1849] = { unicodeslot=0x1849, category='lo', description='MONGOLIAN LETTER TODO UE' },
	[0x184A] = { unicodeslot=0x184A, category='lo', description='MONGOLIAN LETTER TODO ANG' },
	[0x184B] = { unicodeslot=0x184B, category='lo', description='MONGOLIAN LETTER TODO BA' },
	[0x184C] = { unicodeslot=0x184C, category='lo', description='MONGOLIAN LETTER TODO PA' },
	[0x184D] = { unicodeslot=0x184D, category='lo', description='MONGOLIAN LETTER TODO QA' },
	[0x184E] = { unicodeslot=0x184E, category='lo', description='MONGOLIAN LETTER TODO GA' },
	[0x184F] = { unicodeslot=0x184F, category='lo', description='MONGOLIAN LETTER TODO MA' },
	[0x1850] = { unicodeslot=0x1850, category='lo', description='MONGOLIAN LETTER TODO TA' },
	[0x1851] = { unicodeslot=0x1851, category='lo', description='MONGOLIAN LETTER TODO DA' },
	[0x1852] = { unicodeslot=0x1852, category='lo', description='MONGOLIAN LETTER TODO CHA' },
	[0x1853] = { unicodeslot=0x1853, category='lo', description='MONGOLIAN LETTER TODO JA' },
	[0x1854] = { unicodeslot=0x1854, category='lo', description='MONGOLIAN LETTER TODO TSA' },
	[0x1855] = { unicodeslot=0x1855, category='lo', description='MONGOLIAN LETTER TODO YA' },
	[0x1856] = { unicodeslot=0x1856, category='lo', description='MONGOLIAN LETTER TODO WA' },
	[0x1857] = { unicodeslot=0x1857, category='lo', description='MONGOLIAN LETTER TODO KA' },
	[0x1858] = { unicodeslot=0x1858, category='lo', description='MONGOLIAN LETTER TODO GAA' },
	[0x1859] = { unicodeslot=0x1859, category='lo', description='MONGOLIAN LETTER TODO HAA' },
	[0x185A] = { unicodeslot=0x185A, category='lo', description='MONGOLIAN LETTER TODO JIA' },
	[0x185B] = { unicodeslot=0x185B, category='lo', description='MONGOLIAN LETTER TODO NIA' },
	[0x185C] = { unicodeslot=0x185C, category='lo', description='MONGOLIAN LETTER TODO DZA' },
	[0x185D] = { unicodeslot=0x185D, category='lo', description='MONGOLIAN LETTER SIBE E' },
	[0x185E] = { unicodeslot=0x185E, category='lo', description='MONGOLIAN LETTER SIBE I' },
	[0x185F] = { unicodeslot=0x185F, category='lo', description='MONGOLIAN LETTER SIBE IY' },
	[0x1860] = { unicodeslot=0x1860, category='lo', description='MONGOLIAN LETTER SIBE UE' },
	[0x1861] = { unicodeslot=0x1861, category='lo', description='MONGOLIAN LETTER SIBE U' },
	[0x1862] = { unicodeslot=0x1862, category='lo', description='MONGOLIAN LETTER SIBE ANG' },
	[0x1863] = { unicodeslot=0x1863, category='lo', description='MONGOLIAN LETTER SIBE KA' },
	[0x1864] = { unicodeslot=0x1864, category='lo', description='MONGOLIAN LETTER SIBE GA' },
	[0x1865] = { unicodeslot=0x1865, category='lo', description='MONGOLIAN LETTER SIBE HA' },
	[0x1866] = { unicodeslot=0x1866, category='lo', description='MONGOLIAN LETTER SIBE PA' },
	[0x1867] = { unicodeslot=0x1867, category='lo', description='MONGOLIAN LETTER SIBE SHA' },
	[0x1868] = { unicodeslot=0x1868, category='lo', description='MONGOLIAN LETTER SIBE TA' },
	[0x1869] = { unicodeslot=0x1869, category='lo', description='MONGOLIAN LETTER SIBE DA' },
	[0x186A] = { unicodeslot=0x186A, category='lo', description='MONGOLIAN LETTER SIBE JA' },
	[0x186B] = { unicodeslot=0x186B, category='lo', description='MONGOLIAN LETTER SIBE FA' },
	[0x186C] = { unicodeslot=0x186C, category='lo', description='MONGOLIAN LETTER SIBE GAA' },
	[0x186D] = { unicodeslot=0x186D, category='lo', description='MONGOLIAN LETTER SIBE HAA' },
	[0x186E] = { unicodeslot=0x186E, category='lo', description='MONGOLIAN LETTER SIBE TSA' },
	[0x186F] = { unicodeslot=0x186F, category='lo', description='MONGOLIAN LETTER SIBE ZA' },
	[0x1870] = { unicodeslot=0x1870, category='lo', description='MONGOLIAN LETTER SIBE RAA' },
	[0x1871] = { unicodeslot=0x1871, category='lo', description='MONGOLIAN LETTER SIBE CHA' },
	[0x1872] = { unicodeslot=0x1872, category='lo', description='MONGOLIAN LETTER SIBE ZHA' },
	[0x1873] = { unicodeslot=0x1873, category='lo', description='MONGOLIAN LETTER MANCHU I' },
	[0x1874] = { unicodeslot=0x1874, category='lo', description='MONGOLIAN LETTER MANCHU KA' },
	[0x1875] = { unicodeslot=0x1875, category='lo', description='MONGOLIAN LETTER MANCHU RA' },
	[0x1876] = { unicodeslot=0x1876, category='lo', description='MONGOLIAN LETTER MANCHU FA' },
	[0x1877] = { unicodeslot=0x1877, category='lo', description='MONGOLIAN LETTER MANCHU ZHA' },
	[0x1880] = { unicodeslot=0x1880, category='lo', description='MONGOLIAN LETTER ALI GALI ANUSVARA ONE' },
	[0x1881] = { unicodeslot=0x1881, category='lo', description='MONGOLIAN LETTER ALI GALI VISARGA ONE' },
	[0x1882] = { unicodeslot=0x1882, category='lo', description='MONGOLIAN LETTER ALI GALI DAMARU' },
	[0x1883] = { unicodeslot=0x1883, category='lo', description='MONGOLIAN LETTER ALI GALI UBADAMA' },
	[0x1884] = { unicodeslot=0x1884, category='lo', description='MONGOLIAN LETTER ALI GALI INVERTED UBADAMA' },
	[0x1885] = { unicodeslot=0x1885, category='lo', description='MONGOLIAN LETTER ALI GALI BALUDA' },
	[0x1886] = { unicodeslot=0x1886, category='lo', description='MONGOLIAN LETTER ALI GALI THREE BALUDA' },
	[0x1887] = { unicodeslot=0x1887, category='lo', description='MONGOLIAN LETTER ALI GALI A' },
	[0x1888] = { unicodeslot=0x1888, category='lo', description='MONGOLIAN LETTER ALI GALI I' },
	[0x1889] = { unicodeslot=0x1889, category='lo', description='MONGOLIAN LETTER ALI GALI KA' },
	[0x188A] = { unicodeslot=0x188A, category='lo', description='MONGOLIAN LETTER ALI GALI NGA' },
	[0x188B] = { unicodeslot=0x188B, category='lo', description='MONGOLIAN LETTER ALI GALI CA' },
	[0x188C] = { unicodeslot=0x188C, category='lo', description='MONGOLIAN LETTER ALI GALI TTA' },
	[0x188D] = { unicodeslot=0x188D, category='lo', description='MONGOLIAN LETTER ALI GALI TTHA' },
	[0x188E] = { unicodeslot=0x188E, category='lo', description='MONGOLIAN LETTER ALI GALI DDA' },
	[0x188F] = { unicodeslot=0x188F, category='lo', description='MONGOLIAN LETTER ALI GALI NNA' },
	[0x1890] = { unicodeslot=0x1890, category='lo', description='MONGOLIAN LETTER ALI GALI TA' },
	[0x1891] = { unicodeslot=0x1891, category='lo', description='MONGOLIAN LETTER ALI GALI DA' },
	[0x1892] = { unicodeslot=0x1892, category='lo', description='MONGOLIAN LETTER ALI GALI PA' },
	[0x1893] = { unicodeslot=0x1893, category='lo', description='MONGOLIAN LETTER ALI GALI PHA' },
	[0x1894] = { unicodeslot=0x1894, category='lo', description='MONGOLIAN LETTER ALI GALI SSA' },
	[0x1895] = { unicodeslot=0x1895, category='lo', description='MONGOLIAN LETTER ALI GALI ZHA' },
	[0x1896] = { unicodeslot=0x1896, category='lo', description='MONGOLIAN LETTER ALI GALI ZA' },
	[0x1897] = { unicodeslot=0x1897, category='lo', description='MONGOLIAN LETTER ALI GALI AH' },
	[0x1898] = { unicodeslot=0x1898, category='lo', description='MONGOLIAN LETTER TODO ALI GALI TA' },
	[0x1899] = { unicodeslot=0x1899, category='lo', description='MONGOLIAN LETTER TODO ALI GALI ZHA' },
	[0x189A] = { unicodeslot=0x189A, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI GHA' },
	[0x189B] = { unicodeslot=0x189B, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI NGA' },
	[0x189C] = { unicodeslot=0x189C, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI CA' },
	[0x189D] = { unicodeslot=0x189D, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI JHA' },
	[0x189E] = { unicodeslot=0x189E, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI TTA' },
	[0x189F] = { unicodeslot=0x189F, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI DDHA' },
	[0x18A0] = { unicodeslot=0x18A0, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI TA' },
	[0x18A1] = { unicodeslot=0x18A1, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI DHA' },
	[0x18A2] = { unicodeslot=0x18A2, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI SSA' },
	[0x18A3] = { unicodeslot=0x18A3, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI CYA' },
	[0x18A4] = { unicodeslot=0x18A4, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI ZHA' },
	[0x18A5] = { unicodeslot=0x18A5, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI ZA' },
	[0x18A6] = { unicodeslot=0x18A6, category='lo', description='MONGOLIAN LETTER ALI GALI HALF U' },
	[0x18A7] = { unicodeslot=0x18A7, category='lo', description='MONGOLIAN LETTER ALI GALI HALF YA' },
	[0x18A8] = { unicodeslot=0x18A8, category='lo', description='MONGOLIAN LETTER MANCHU ALI GALI BHA' },
	[0x18A9] = { unicodeslot=0x18A9, category='mn', description='MONGOLIAN LETTER ALI GALI DAGALGA' },
	[0x1900] = { unicodeslot=0x1900, category='lo', description='LIMBU VOWEL-CARRIER LETTER' },
	[0x1901] = { unicodeslot=0x1901, category='lo', description='LIMBU LETTER KA' },
	[0x1902] = { unicodeslot=0x1902, category='lo', description='LIMBU LETTER KHA' },
	[0x1903] = { unicodeslot=0x1903, category='lo', description='LIMBU LETTER GA' },
	[0x1904] = { unicodeslot=0x1904, category='lo', description='LIMBU LETTER GHA' },
	[0x1905] = { unicodeslot=0x1905, category='lo', description='LIMBU LETTER NGA' },
	[0x1906] = { unicodeslot=0x1906, category='lo', description='LIMBU LETTER CA' },
	[0x1907] = { unicodeslot=0x1907, category='lo', description='LIMBU LETTER CHA' },
	[0x1908] = { unicodeslot=0x1908, category='lo', description='LIMBU LETTER JA' },
	[0x1909] = { unicodeslot=0x1909, category='lo', description='LIMBU LETTER JHA' },
	[0x190A] = { unicodeslot=0x190A, category='lo', description='LIMBU LETTER YAN' },
	[0x190B] = { unicodeslot=0x190B, category='lo', description='LIMBU LETTER TA' },
	[0x190C] = { unicodeslot=0x190C, category='lo', description='LIMBU LETTER THA' },
	[0x190D] = { unicodeslot=0x190D, category='lo', description='LIMBU LETTER DA' },
	[0x190E] = { unicodeslot=0x190E, category='lo', description='LIMBU LETTER DHA' },
	[0x190F] = { unicodeslot=0x190F, category='lo', description='LIMBU LETTER NA' },
	[0x1910] = { unicodeslot=0x1910, category='lo', description='LIMBU LETTER PA' },
	[0x1911] = { unicodeslot=0x1911, category='lo', description='LIMBU LETTER PHA' },
	[0x1912] = { unicodeslot=0x1912, category='lo', description='LIMBU LETTER BA' },
	[0x1913] = { unicodeslot=0x1913, category='lo', description='LIMBU LETTER BHA' },
	[0x1914] = { unicodeslot=0x1914, category='lo', description='LIMBU LETTER MA' },
	[0x1915] = { unicodeslot=0x1915, category='lo', description='LIMBU LETTER YA' },
	[0x1916] = { unicodeslot=0x1916, category='lo', description='LIMBU LETTER RA' },
	[0x1917] = { unicodeslot=0x1917, category='lo', description='LIMBU LETTER LA' },
	[0x1918] = { unicodeslot=0x1918, category='lo', description='LIMBU LETTER WA' },
	[0x1919] = { unicodeslot=0x1919, category='lo', description='LIMBU LETTER SHA' },
	[0x191A] = { unicodeslot=0x191A, category='lo', description='LIMBU LETTER SSA' },
	[0x191B] = { unicodeslot=0x191B, category='lo', description='LIMBU LETTER SA' },
	[0x191C] = { unicodeslot=0x191C, category='lo', description='LIMBU LETTER HA' },
	[0x1920] = { unicodeslot=0x1920, category='mn', description='LIMBU VOWEL SIGN A' },
	[0x1921] = { unicodeslot=0x1921, category='mn', description='LIMBU VOWEL SIGN I' },
	[0x1922] = { unicodeslot=0x1922, category='mn', description='LIMBU VOWEL SIGN U' },
	[0x1923] = { unicodeslot=0x1923, category='mc', description='LIMBU VOWEL SIGN EE' },
	[0x1924] = { unicodeslot=0x1924, category='mc', description='LIMBU VOWEL SIGN AI' },
	[0x1925] = { unicodeslot=0x1925, category='mc', description='LIMBU VOWEL SIGN OO' },
	[0x1926] = { unicodeslot=0x1926, category='mc', description='LIMBU VOWEL SIGN AU' },
	[0x1927] = { unicodeslot=0x1927, category='mn', description='LIMBU VOWEL SIGN E' },
	[0x1928] = { unicodeslot=0x1928, category='mn', description='LIMBU VOWEL SIGN O' },
	[0x1929] = { unicodeslot=0x1929, category='mc', description='LIMBU SUBJOINED LETTER YA' },
	[0x192A] = { unicodeslot=0x192A, category='mc', description='LIMBU SUBJOINED LETTER RA' },
	[0x192B] = { unicodeslot=0x192B, category='mc', description='LIMBU SUBJOINED LETTER WA' },
	[0x1930] = { unicodeslot=0x1930, category='mc', description='LIMBU SMALL LETTER KA' },
	[0x1931] = { unicodeslot=0x1931, category='mc', description='LIMBU SMALL LETTER NGA' },
	[0x1932] = { unicodeslot=0x1932, category='mn', description='LIMBU SMALL LETTER ANUSVARA' },
	[0x1933] = { unicodeslot=0x1933, category='mc', description='LIMBU SMALL LETTER TA' },
	[0x1934] = { unicodeslot=0x1934, category='mc', description='LIMBU SMALL LETTER NA' },
	[0x1935] = { unicodeslot=0x1935, category='mc', description='LIMBU SMALL LETTER PA' },
	[0x1936] = { unicodeslot=0x1936, category='mc', description='LIMBU SMALL LETTER MA' },
	[0x1937] = { unicodeslot=0x1937, category='mc', description='LIMBU SMALL LETTER RA' },
	[0x1938] = { unicodeslot=0x1938, category='mc', description='LIMBU SMALL LETTER LA' },
	[0x1939] = { unicodeslot=0x1939, category='mn', description='LIMBU SIGN MUKPHRENG' },
	[0x193A] = { unicodeslot=0x193A, category='mn', description='LIMBU SIGN KEMPHRENG' },
	[0x193B] = { unicodeslot=0x193B, category='mn', description='LIMBU SIGN SA-I' },
	[0x1940] = { unicodeslot=0x1940, category='so', description='LIMBU SIGN LOO' },
	[0x1944] = { unicodeslot=0x1944, category='po', description='LIMBU EXCLAMATION MARK' },
	[0x1945] = { unicodeslot=0x1945, category='po', description='LIMBU QUESTION MARK' },
	[0x1946] = { unicodeslot=0x1946, category='nd', description='LIMBU DIGIT ZERO' },
	[0x1947] = { unicodeslot=0x1947, category='nd', description='LIMBU DIGIT ONE' },
	[0x1948] = { unicodeslot=0x1948, category='nd', description='LIMBU DIGIT TWO' },
	[0x1949] = { unicodeslot=0x1949, category='nd', description='LIMBU DIGIT THREE' },
	[0x194A] = { unicodeslot=0x194A, category='nd', description='LIMBU DIGIT FOUR' },
	[0x194B] = { unicodeslot=0x194B, category='nd', description='LIMBU DIGIT FIVE' },
	[0x194C] = { unicodeslot=0x194C, category='nd', description='LIMBU DIGIT SIX' },
	[0x194D] = { unicodeslot=0x194D, category='nd', description='LIMBU DIGIT SEVEN' },
	[0x194E] = { unicodeslot=0x194E, category='nd', description='LIMBU DIGIT EIGHT' },
	[0x194F] = { unicodeslot=0x194F, category='nd', description='LIMBU DIGIT NINE' },
	[0x1950] = { unicodeslot=0x1950, category='lo', description='TAI LE LETTER KA' },
	[0x1951] = { unicodeslot=0x1951, category='lo', description='TAI LE LETTER XA' },
	[0x1952] = { unicodeslot=0x1952, category='lo', description='TAI LE LETTER NGA' },
	[0x1953] = { unicodeslot=0x1953, category='lo', description='TAI LE LETTER TSA' },
	[0x1954] = { unicodeslot=0x1954, category='lo', description='TAI LE LETTER SA' },
	[0x1955] = { unicodeslot=0x1955, category='lo', description='TAI LE LETTER YA' },
	[0x1956] = { unicodeslot=0x1956, category='lo', description='TAI LE LETTER TA' },
	[0x1957] = { unicodeslot=0x1957, category='lo', description='TAI LE LETTER THA' },
	[0x1958] = { unicodeslot=0x1958, category='lo', description='TAI LE LETTER LA' },
	[0x1959] = { unicodeslot=0x1959, category='lo', description='TAI LE LETTER PA' },
	[0x195A] = { unicodeslot=0x195A, category='lo', description='TAI LE LETTER PHA' },
	[0x195B] = { unicodeslot=0x195B, category='lo', description='TAI LE LETTER MA' },
	[0x195C] = { unicodeslot=0x195C, category='lo', description='TAI LE LETTER FA' },
	[0x195D] = { unicodeslot=0x195D, category='lo', description='TAI LE LETTER VA' },
	[0x195E] = { unicodeslot=0x195E, category='lo', description='TAI LE LETTER HA' },
	[0x195F] = { unicodeslot=0x195F, category='lo', description='TAI LE LETTER QA' },
	[0x1960] = { unicodeslot=0x1960, category='lo', description='TAI LE LETTER KHA' },
	[0x1961] = { unicodeslot=0x1961, category='lo', description='TAI LE LETTER TSHA' },
	[0x1962] = { unicodeslot=0x1962, category='lo', description='TAI LE LETTER NA' },
	[0x1963] = { unicodeslot=0x1963, category='lo', description='TAI LE LETTER A' },
	[0x1964] = { unicodeslot=0x1964, category='lo', description='TAI LE LETTER I' },
	[0x1965] = { unicodeslot=0x1965, category='lo', description='TAI LE LETTER EE' },
	[0x1966] = { unicodeslot=0x1966, category='lo', description='TAI LE LETTER EH' },
	[0x1967] = { unicodeslot=0x1967, category='lo', description='TAI LE LETTER U' },
	[0x1968] = { unicodeslot=0x1968, category='lo', description='TAI LE LETTER OO' },
	[0x1969] = { unicodeslot=0x1969, category='lo', description='TAI LE LETTER O' },
	[0x196A] = { unicodeslot=0x196A, category='lo', description='TAI LE LETTER UE' },
	[0x196B] = { unicodeslot=0x196B, category='lo', description='TAI LE LETTER E' },
	[0x196C] = { unicodeslot=0x196C, category='lo', description='TAI LE LETTER AUE' },
	[0x196D] = { unicodeslot=0x196D, category='lo', description='TAI LE LETTER AI' },
	[0x1970] = { unicodeslot=0x1970, category='lo', description='TAI LE LETTER TONE-2' },
	[0x1971] = { unicodeslot=0x1971, category='lo', description='TAI LE LETTER TONE-3' },
	[0x1972] = { unicodeslot=0x1972, category='lo', description='TAI LE LETTER TONE-4' },
	[0x1973] = { unicodeslot=0x1973, category='lo', description='TAI LE LETTER TONE-5' },
	[0x1974] = { unicodeslot=0x1974, category='lo', description='TAI LE LETTER TONE-6' },
	[0x1980] = { unicodeslot=0x1980, category='lo', description='NEW TAI LUE LETTER HIGH QA' },
	[0x1981] = { unicodeslot=0x1981, category='lo', description='NEW TAI LUE LETTER LOW QA' },
	[0x1982] = { unicodeslot=0x1982, category='lo', description='NEW TAI LUE LETTER HIGH KA' },
	[0x1983] = { unicodeslot=0x1983, category='lo', description='NEW TAI LUE LETTER HIGH XA' },
	[0x1984] = { unicodeslot=0x1984, category='lo', description='NEW TAI LUE LETTER HIGH NGA' },
	[0x1985] = { unicodeslot=0x1985, category='lo', description='NEW TAI LUE LETTER LOW KA' },
	[0x1986] = { unicodeslot=0x1986, category='lo', description='NEW TAI LUE LETTER LOW XA' },
	[0x1987] = { unicodeslot=0x1987, category='lo', description='NEW TAI LUE LETTER LOW NGA' },
	[0x1988] = { unicodeslot=0x1988, category='lo', description='NEW TAI LUE LETTER HIGH TSA' },
	[0x1989] = { unicodeslot=0x1989, category='lo', description='NEW TAI LUE LETTER HIGH SA' },
	[0x198A] = { unicodeslot=0x198A, category='lo', description='NEW TAI LUE LETTER HIGH YA' },
	[0x198B] = { unicodeslot=0x198B, category='lo', description='NEW TAI LUE LETTER LOW TSA' },
	[0x198C] = { unicodeslot=0x198C, category='lo', description='NEW TAI LUE LETTER LOW SA' },
	[0x198D] = { unicodeslot=0x198D, category='lo', description='NEW TAI LUE LETTER LOW YA' },
	[0x198E] = { unicodeslot=0x198E, category='lo', description='NEW TAI LUE LETTER HIGH TA' },
	[0x198F] = { unicodeslot=0x198F, category='lo', description='NEW TAI LUE LETTER HIGH THA' },
	[0x1990] = { unicodeslot=0x1990, category='lo', description='NEW TAI LUE LETTER HIGH NA' },
	[0x1991] = { unicodeslot=0x1991, category='lo', description='NEW TAI LUE LETTER LOW TA' },
	[0x1992] = { unicodeslot=0x1992, category='lo', description='NEW TAI LUE LETTER LOW THA' },
	[0x1993] = { unicodeslot=0x1993, category='lo', description='NEW TAI LUE LETTER LOW NA' },
	[0x1994] = { unicodeslot=0x1994, category='lo', description='NEW TAI LUE LETTER HIGH PA' },
	[0x1995] = { unicodeslot=0x1995, category='lo', description='NEW TAI LUE LETTER HIGH PHA' },
	[0x1996] = { unicodeslot=0x1996, category='lo', description='NEW TAI LUE LETTER HIGH MA' },
	[0x1997] = { unicodeslot=0x1997, category='lo', description='NEW TAI LUE LETTER LOW PA' },
	[0x1998] = { unicodeslot=0x1998, category='lo', description='NEW TAI LUE LETTER LOW PHA' },
	[0x1999] = { unicodeslot=0x1999, category='lo', description='NEW TAI LUE LETTER LOW MA' },
	[0x199A] = { unicodeslot=0x199A, category='lo', description='NEW TAI LUE LETTER HIGH FA' },
	[0x199B] = { unicodeslot=0x199B, category='lo', description='NEW TAI LUE LETTER HIGH VA' },
	[0x199C] = { unicodeslot=0x199C, category='lo', description='NEW TAI LUE LETTER HIGH LA' },
	[0x199D] = { unicodeslot=0x199D, category='lo', description='NEW TAI LUE LETTER LOW FA' },
	[0x199E] = { unicodeslot=0x199E, category='lo', description='NEW TAI LUE LETTER LOW VA' },
	[0x199F] = { unicodeslot=0x199F, category='lo', description='NEW TAI LUE LETTER LOW LA' },
	[0x19A0] = { unicodeslot=0x19A0, category='lo', description='NEW TAI LUE LETTER HIGH HA' },
	[0x19A1] = { unicodeslot=0x19A1, category='lo', description='NEW TAI LUE LETTER HIGH DA' },
	[0x19A2] = { unicodeslot=0x19A2, category='lo', description='NEW TAI LUE LETTER HIGH BA' },
	[0x19A3] = { unicodeslot=0x19A3, category='lo', description='NEW TAI LUE LETTER LOW HA' },
	[0x19A4] = { unicodeslot=0x19A4, category='lo', description='NEW TAI LUE LETTER LOW DA' },
	[0x19A5] = { unicodeslot=0x19A5, category='lo', description='NEW TAI LUE LETTER LOW BA' },
	[0x19A6] = { unicodeslot=0x19A6, category='lo', description='NEW TAI LUE LETTER HIGH KVA' },
	[0x19A7] = { unicodeslot=0x19A7, category='lo', description='NEW TAI LUE LETTER HIGH XVA' },
	[0x19A8] = { unicodeslot=0x19A8, category='lo', description='NEW TAI LUE LETTER LOW KVA' },
	[0x19A9] = { unicodeslot=0x19A9, category='lo', description='NEW TAI LUE LETTER LOW XVA' },
	[0x19B0] = { unicodeslot=0x19B0, category='mc', description='NEW TAI LUE VOWEL SIGN VOWEL SHORTENER' },
	[0x19B1] = { unicodeslot=0x19B1, category='mc', description='NEW TAI LUE VOWEL SIGN AA' },
	[0x19B2] = { unicodeslot=0x19B2, category='mc', description='NEW TAI LUE VOWEL SIGN II' },
	[0x19B3] = { unicodeslot=0x19B3, category='mc', description='NEW TAI LUE VOWEL SIGN U' },
	[0x19B4] = { unicodeslot=0x19B4, category='mc', description='NEW TAI LUE VOWEL SIGN UU' },
	[0x19B5] = { unicodeslot=0x19B5, category='mc', description='NEW TAI LUE VOWEL SIGN E' },
	[0x19B6] = { unicodeslot=0x19B6, category='mc', description='NEW TAI LUE VOWEL SIGN AE' },
	[0x19B7] = { unicodeslot=0x19B7, category='mc', description='NEW TAI LUE VOWEL SIGN O' },
	[0x19B8] = { unicodeslot=0x19B8, category='mc', description='NEW TAI LUE VOWEL SIGN OA' },
	[0x19B9] = { unicodeslot=0x19B9, category='mc', description='NEW TAI LUE VOWEL SIGN UE' },
	[0x19BA] = { unicodeslot=0x19BA, category='mc', description='NEW TAI LUE VOWEL SIGN AY' },
	[0x19BB] = { unicodeslot=0x19BB, category='mc', description='NEW TAI LUE VOWEL SIGN AAY' },
	[0x19BC] = { unicodeslot=0x19BC, category='mc', description='NEW TAI LUE VOWEL SIGN UY' },
	[0x19BD] = { unicodeslot=0x19BD, category='mc', description='NEW TAI LUE VOWEL SIGN OY' },
	[0x19BE] = { unicodeslot=0x19BE, category='mc', description='NEW TAI LUE VOWEL SIGN OAY' },
	[0x19BF] = { unicodeslot=0x19BF, category='mc', description='NEW TAI LUE VOWEL SIGN UEY' },
	[0x19C0] = { unicodeslot=0x19C0, category='mc', description='NEW TAI LUE VOWEL SIGN IY' },
	[0x19C1] = { unicodeslot=0x19C1, category='lo', description='NEW TAI LUE LETTER FINAL V' },
	[0x19C2] = { unicodeslot=0x19C2, category='lo', description='NEW TAI LUE LETTER FINAL NG' },
	[0x19C3] = { unicodeslot=0x19C3, category='lo', description='NEW TAI LUE LETTER FINAL N' },
	[0x19C4] = { unicodeslot=0x19C4, category='lo', description='NEW TAI LUE LETTER FINAL M' },
	[0x19C5] = { unicodeslot=0x19C5, category='lo', description='NEW TAI LUE LETTER FINAL K' },
	[0x19C6] = { unicodeslot=0x19C6, category='lo', description='NEW TAI LUE LETTER FINAL D' },
	[0x19C7] = { unicodeslot=0x19C7, category='lo', description='NEW TAI LUE LETTER FINAL B' },
	[0x19C8] = { unicodeslot=0x19C8, category='mc', description='NEW TAI LUE TONE MARK-1' },
	[0x19C9] = { unicodeslot=0x19C9, category='mc', description='NEW TAI LUE TONE MARK-2' },
	[0x19D0] = { unicodeslot=0x19D0, category='nd', description='NEW TAI LUE DIGIT ZERO' },
	[0x19D1] = { unicodeslot=0x19D1, category='nd', description='NEW TAI LUE DIGIT ONE' },
	[0x19D2] = { unicodeslot=0x19D2, category='nd', description='NEW TAI LUE DIGIT TWO' },
	[0x19D3] = { unicodeslot=0x19D3, category='nd', description='NEW TAI LUE DIGIT THREE' },
	[0x19D4] = { unicodeslot=0x19D4, category='nd', description='NEW TAI LUE DIGIT FOUR' },
	[0x19D5] = { unicodeslot=0x19D5, category='nd', description='NEW TAI LUE DIGIT FIVE' },
	[0x19D6] = { unicodeslot=0x19D6, category='nd', description='NEW TAI LUE DIGIT SIX' },
	[0x19D7] = { unicodeslot=0x19D7, category='nd', description='NEW TAI LUE DIGIT SEVEN' },
	[0x19D8] = { unicodeslot=0x19D8, category='nd', description='NEW TAI LUE DIGIT EIGHT' },
	[0x19D9] = { unicodeslot=0x19D9, category='nd', description='NEW TAI LUE DIGIT NINE' },
	[0x19DE] = { unicodeslot=0x19DE, category='po', description='NEW TAI LUE SIGN LAE' },
	[0x19DF] = { unicodeslot=0x19DF, category='po', description='NEW TAI LUE SIGN LAEV' },
	[0x19E0] = { unicodeslot=0x19E0, category='so', description='KHMER SYMBOL PATHAMASAT' },
	[0x19E1] = { unicodeslot=0x19E1, category='so', description='KHMER SYMBOL MUOY KOET' },
	[0x19E2] = { unicodeslot=0x19E2, category='so', description='KHMER SYMBOL PII KOET' },
	[0x19E3] = { unicodeslot=0x19E3, category='so', description='KHMER SYMBOL BEI KOET' },
	[0x19E4] = { unicodeslot=0x19E4, category='so', description='KHMER SYMBOL BUON KOET' },
	[0x19E5] = { unicodeslot=0x19E5, category='so', description='KHMER SYMBOL PRAM KOET' },
	[0x19E6] = { unicodeslot=0x19E6, category='so', description='KHMER SYMBOL PRAM-MUOY KOET' },
	[0x19E7] = { unicodeslot=0x19E7, category='so', description='KHMER SYMBOL PRAM-PII KOET' },
	[0x19E8] = { unicodeslot=0x19E8, category='so', description='KHMER SYMBOL PRAM-BEI KOET' },
	[0x19E9] = { unicodeslot=0x19E9, category='so', description='KHMER SYMBOL PRAM-BUON KOET' },
	[0x19EA] = { unicodeslot=0x19EA, category='so', description='KHMER SYMBOL DAP KOET' },
	[0x19EB] = { unicodeslot=0x19EB, category='so', description='KHMER SYMBOL DAP-MUOY KOET' },
	[0x19EC] = { unicodeslot=0x19EC, category='so', description='KHMER SYMBOL DAP-PII KOET' },
	[0x19ED] = { unicodeslot=0x19ED, category='so', description='KHMER SYMBOL DAP-BEI KOET' },
	[0x19EE] = { unicodeslot=0x19EE, category='so', description='KHMER SYMBOL DAP-BUON KOET' },
	[0x19EF] = { unicodeslot=0x19EF, category='so', description='KHMER SYMBOL DAP-PRAM KOET' },
	[0x19F0] = { unicodeslot=0x19F0, category='so', description='KHMER SYMBOL TUTEYASAT' },
	[0x19F1] = { unicodeslot=0x19F1, category='so', description='KHMER SYMBOL MUOY ROC' },
	[0x19F2] = { unicodeslot=0x19F2, category='so', description='KHMER SYMBOL PII ROC' },
	[0x19F3] = { unicodeslot=0x19F3, category='so', description='KHMER SYMBOL BEI ROC' },
	[0x19F4] = { unicodeslot=0x19F4, category='so', description='KHMER SYMBOL BUON ROC' },
	[0x19F5] = { unicodeslot=0x19F5, category='so', description='KHMER SYMBOL PRAM ROC' },
	[0x19F6] = { unicodeslot=0x19F6, category='so', description='KHMER SYMBOL PRAM-MUOY ROC' },
	[0x19F7] = { unicodeslot=0x19F7, category='so', description='KHMER SYMBOL PRAM-PII ROC' },
	[0x19F8] = { unicodeslot=0x19F8, category='so', description='KHMER SYMBOL PRAM-BEI ROC' },
	[0x19F9] = { unicodeslot=0x19F9, category='so', description='KHMER SYMBOL PRAM-BUON ROC' },
	[0x19FA] = { unicodeslot=0x19FA, category='so', description='KHMER SYMBOL DAP ROC' },
	[0x19FB] = { unicodeslot=0x19FB, category='so', description='KHMER SYMBOL DAP-MUOY ROC' },
	[0x19FC] = { unicodeslot=0x19FC, category='so', description='KHMER SYMBOL DAP-PII ROC' },
	[0x19FD] = { unicodeslot=0x19FD, category='so', description='KHMER SYMBOL DAP-BEI ROC' },
	[0x19FE] = { unicodeslot=0x19FE, category='so', description='KHMER SYMBOL DAP-BUON ROC' },
	[0x19FF] = { unicodeslot=0x19FF, category='so', description='KHMER SYMBOL DAP-PRAM ROC' },
	[0x1A00] = { unicodeslot=0x1A00, category='lo', description='BUGINESE LETTER KA' },
	[0x1A01] = { unicodeslot=0x1A01, category='lo', description='BUGINESE LETTER GA' },
	[0x1A02] = { unicodeslot=0x1A02, category='lo', description='BUGINESE LETTER NGA' },
	[0x1A03] = { unicodeslot=0x1A03, category='lo', description='BUGINESE LETTER NGKA' },
	[0x1A04] = { unicodeslot=0x1A04, category='lo', description='BUGINESE LETTER PA' },
	[0x1A05] = { unicodeslot=0x1A05, category='lo', description='BUGINESE LETTER BA' },
	[0x1A06] = { unicodeslot=0x1A06, category='lo', description='BUGINESE LETTER MA' },
	[0x1A07] = { unicodeslot=0x1A07, category='lo', description='BUGINESE LETTER MPA' },
	[0x1A08] = { unicodeslot=0x1A08, category='lo', description='BUGINESE LETTER TA' },
	[0x1A09] = { unicodeslot=0x1A09, category='lo', description='BUGINESE LETTER DA' },
	[0x1A0A] = { unicodeslot=0x1A0A, category='lo', description='BUGINESE LETTER NA' },
	[0x1A0B] = { unicodeslot=0x1A0B, category='lo', description='BUGINESE LETTER NRA' },
	[0x1A0C] = { unicodeslot=0x1A0C, category='lo', description='BUGINESE LETTER CA' },
	[0x1A0D] = { unicodeslot=0x1A0D, category='lo', description='BUGINESE LETTER JA' },
	[0x1A0E] = { unicodeslot=0x1A0E, category='lo', description='BUGINESE LETTER NYA' },
	[0x1A0F] = { unicodeslot=0x1A0F, category='lo', description='BUGINESE LETTER NYCA' },
	[0x1A10] = { unicodeslot=0x1A10, category='lo', description='BUGINESE LETTER YA' },
	[0x1A11] = { unicodeslot=0x1A11, category='lo', description='BUGINESE LETTER RA' },
	[0x1A12] = { unicodeslot=0x1A12, category='lo', description='BUGINESE LETTER LA' },
	[0x1A13] = { unicodeslot=0x1A13, category='lo', description='BUGINESE LETTER VA' },
	[0x1A14] = { unicodeslot=0x1A14, category='lo', description='BUGINESE LETTER SA' },
	[0x1A15] = { unicodeslot=0x1A15, category='lo', description='BUGINESE LETTER A' },
	[0x1A16] = { unicodeslot=0x1A16, category='lo', description='BUGINESE LETTER HA' },
	[0x1A17] = { unicodeslot=0x1A17, category='mn', description='BUGINESE VOWEL SIGN I' },
	[0x1A18] = { unicodeslot=0x1A18, category='mn', description='BUGINESE VOWEL SIGN U' },
	[0x1A19] = { unicodeslot=0x1A19, category='mc', description='BUGINESE VOWEL SIGN E' },
	[0x1A1A] = { unicodeslot=0x1A1A, category='mc', description='BUGINESE VOWEL SIGN O' },
	[0x1A1B] = { unicodeslot=0x1A1B, category='mc', description='BUGINESE VOWEL SIGN AE' },
	[0x1A1E] = { unicodeslot=0x1A1E, category='po', description='BUGINESE PALLAWA' },
	[0x1A1F] = { unicodeslot=0x1A1F, category='po', description='BUGINESE END OF SECTION' },
	[0x1B00] = { unicodeslot=0x1B00, category='mn', description='BALINESE SIGN ULU RICEM' },
	[0x1B01] = { unicodeslot=0x1B01, category='mn', description='BALINESE SIGN ULU CANDRA' },
	[0x1B02] = { unicodeslot=0x1B02, category='mn', description='BALINESE SIGN CECEK' },
	[0x1B03] = { unicodeslot=0x1B03, category='mn', description='BALINESE SIGN SURANG' },
	[0x1B04] = { unicodeslot=0x1B04, category='mc', description='BALINESE SIGN BISAH' },
	[0x1B05] = { unicodeslot=0x1B05, category='lo', description='BALINESE LETTER AKARA' },
	[0x1B06] = { unicodeslot=0x1B06, category='lo', description='BALINESE LETTER AKARA TEDUNG', specials={'char',0x1B05,0x1B35} },
	[0x1B07] = { unicodeslot=0x1B07, category='lo', description='BALINESE LETTER IKARA' },
	[0x1B08] = { unicodeslot=0x1B08, category='lo', description='BALINESE LETTER IKARA TEDUNG', specials={'char',0x1B07,0x1B35} },
	[0x1B09] = { unicodeslot=0x1B09, category='lo', description='BALINESE LETTER UKARA' },
	[0x1B0A] = { unicodeslot=0x1B0A, category='lo', description='BALINESE LETTER UKARA TEDUNG', specials={'char',0x1B09,0x1B35} },
	[0x1B0B] = { unicodeslot=0x1B0B, category='lo', description='BALINESE LETTER RA REPA' },
	[0x1B0C] = { unicodeslot=0x1B0C, category='lo', description='BALINESE LETTER RA REPA TEDUNG', specials={'char',0x1B0B,0x1B35} },
	[0x1B0D] = { unicodeslot=0x1B0D, category='lo', description='BALINESE LETTER LA LENGA' },
	[0x1B0E] = { unicodeslot=0x1B0E, category='lo', description='BALINESE LETTER LA LENGA TEDUNG', specials={'char',0x1B0D,0x1B35} },
	[0x1B0F] = { unicodeslot=0x1B0F, category='lo', description='BALINESE LETTER EKARA' },
	[0x1B10] = { unicodeslot=0x1B10, category='lo', description='BALINESE LETTER AIKARA' },
	[0x1B11] = { unicodeslot=0x1B11, category='lo', description='BALINESE LETTER OKARA' },
	[0x1B12] = { unicodeslot=0x1B12, category='lo', description='BALINESE LETTER OKARA TEDUNG', specials={'char',0x1B11,0x1B35} },
	[0x1B13] = { unicodeslot=0x1B13, category='lo', description='BALINESE LETTER KA' },
	[0x1B14] = { unicodeslot=0x1B14, category='lo', description='BALINESE LETTER KA MAHAPRANA' },
	[0x1B15] = { unicodeslot=0x1B15, category='lo', description='BALINESE LETTER GA' },
	[0x1B16] = { unicodeslot=0x1B16, category='lo', description='BALINESE LETTER GA GORA' },
	[0x1B17] = { unicodeslot=0x1B17, category='lo', description='BALINESE LETTER NGA' },
	[0x1B18] = { unicodeslot=0x1B18, category='lo', description='BALINESE LETTER CA' },
	[0x1B19] = { unicodeslot=0x1B19, category='lo', description='BALINESE LETTER CA LACA' },
	[0x1B1A] = { unicodeslot=0x1B1A, category='lo', description='BALINESE LETTER JA' },
	[0x1B1B] = { unicodeslot=0x1B1B, category='lo', description='BALINESE LETTER JA JERA' },
	[0x1B1C] = { unicodeslot=0x1B1C, category='lo', description='BALINESE LETTER NYA' },
	[0x1B1D] = { unicodeslot=0x1B1D, category='lo', description='BALINESE LETTER TA LATIK' },
	[0x1B1E] = { unicodeslot=0x1B1E, category='lo', description='BALINESE LETTER TA MURDA MAHAPRANA' },
	[0x1B1F] = { unicodeslot=0x1B1F, category='lo', description='BALINESE LETTER DA MURDA ALPAPRANA' },
	[0x1B20] = { unicodeslot=0x1B20, category='lo', description='BALINESE LETTER DA MURDA MAHAPRANA' },
	[0x1B21] = { unicodeslot=0x1B21, category='lo', description='BALINESE LETTER NA RAMBAT' },
	[0x1B22] = { unicodeslot=0x1B22, category='lo', description='BALINESE LETTER TA' },
	[0x1B23] = { unicodeslot=0x1B23, category='lo', description='BALINESE LETTER TA TAWA' },
	[0x1B24] = { unicodeslot=0x1B24, category='lo', description='BALINESE LETTER DA' },
	[0x1B25] = { unicodeslot=0x1B25, category='lo', description='BALINESE LETTER DA MADU' },
	[0x1B26] = { unicodeslot=0x1B26, category='lo', description='BALINESE LETTER NA' },
	[0x1B27] = { unicodeslot=0x1B27, category='lo', description='BALINESE LETTER PA' },
	[0x1B28] = { unicodeslot=0x1B28, category='lo', description='BALINESE LETTER PA KAPAL' },
	[0x1B29] = { unicodeslot=0x1B29, category='lo', description='BALINESE LETTER BA' },
	[0x1B2A] = { unicodeslot=0x1B2A, category='lo', description='BALINESE LETTER BA KEMBANG' },
	[0x1B2B] = { unicodeslot=0x1B2B, category='lo', description='BALINESE LETTER MA' },
	[0x1B2C] = { unicodeslot=0x1B2C, category='lo', description='BALINESE LETTER YA' },
	[0x1B2D] = { unicodeslot=0x1B2D, category='lo', description='BALINESE LETTER RA' },
	[0x1B2E] = { unicodeslot=0x1B2E, category='lo', description='BALINESE LETTER LA' },
	[0x1B2F] = { unicodeslot=0x1B2F, category='lo', description='BALINESE LETTER WA' },
	[0x1B30] = { unicodeslot=0x1B30, category='lo', description='BALINESE LETTER SA SAGA' },
	[0x1B31] = { unicodeslot=0x1B31, category='lo', description='BALINESE LETTER SA SAPA' },
	[0x1B32] = { unicodeslot=0x1B32, category='lo', description='BALINESE LETTER SA' },
	[0x1B33] = { unicodeslot=0x1B33, category='lo', description='BALINESE LETTER HA' },
	[0x1B34] = { unicodeslot=0x1B34, category='mn', description='BALINESE SIGN REREKAN' },
	[0x1B35] = { unicodeslot=0x1B35, category='mc', description='BALINESE VOWEL SIGN TEDUNG' },
	[0x1B36] = { unicodeslot=0x1B36, category='mn', description='BALINESE VOWEL SIGN ULU' },
	[0x1B37] = { unicodeslot=0x1B37, category='mn', description='BALINESE VOWEL SIGN ULU SARI' },
	[0x1B38] = { unicodeslot=0x1B38, category='mn', description='BALINESE VOWEL SIGN SUKU' },
	[0x1B39] = { unicodeslot=0x1B39, category='mn', description='BALINESE VOWEL SIGN SUKU ILUT' },
	[0x1B3A] = { unicodeslot=0x1B3A, category='mn', description='BALINESE VOWEL SIGN RA REPA' },
	[0x1B3B] = { unicodeslot=0x1B3B, category='mc', description='BALINESE VOWEL SIGN RA REPA TEDUNG', specials={'char',0x1B3A,0x1B35} },
	[0x1B3C] = { unicodeslot=0x1B3C, category='mn', description='BALINESE VOWEL SIGN LA LENGA' },
	[0x1B3D] = { unicodeslot=0x1B3D, category='mc', description='BALINESE VOWEL SIGN LA LENGA TEDUNG', specials={'char',0x1B3C,0x1B35} },
	[0x1B3E] = { unicodeslot=0x1B3E, category='mc', description='BALINESE VOWEL SIGN TALING' },
	[0x1B3F] = { unicodeslot=0x1B3F, category='mc', description='BALINESE VOWEL SIGN TALING REPA' },
	[0x1B40] = { unicodeslot=0x1B40, category='mc', description='BALINESE VOWEL SIGN TALING TEDUNG', specials={'char',0x1B3E,0x1B35} },
	[0x1B41] = { unicodeslot=0x1B41, category='mc', description='BALINESE VOWEL SIGN TALING REPA TEDUNG', specials={'char',0x1B3F,0x1B35} },
	[0x1B42] = { unicodeslot=0x1B42, category='mn', description='BALINESE VOWEL SIGN PEPET' },
	[0x1B43] = { unicodeslot=0x1B43, category='mc', description='BALINESE VOWEL SIGN PEPET TEDUNG', specials={'char',0x1B42,0x1B35} },
	[0x1B44] = { unicodeslot=0x1B44, category='mc', description='BALINESE ADEG ADEG' },
	[0x1B45] = { unicodeslot=0x1B45, category='lo', description='BALINESE LETTER KAF SASAK' },
	[0x1B46] = { unicodeslot=0x1B46, category='lo', description='BALINESE LETTER KHOT SASAK' },
	[0x1B47] = { unicodeslot=0x1B47, category='lo', description='BALINESE LETTER TZIR SASAK' },
	[0x1B48] = { unicodeslot=0x1B48, category='lo', description='BALINESE LETTER EF SASAK' },
	[0x1B49] = { unicodeslot=0x1B49, category='lo', description='BALINESE LETTER VE SASAK' },
	[0x1B4A] = { unicodeslot=0x1B4A, category='lo', description='BALINESE LETTER ZAL SASAK' },
	[0x1B4B] = { unicodeslot=0x1B4B, category='lo', description='BALINESE LETTER ASYURA SASAK' },
	[0x1B50] = { unicodeslot=0x1B50, category='nd', description='BALINESE DIGIT ZERO' },
	[0x1B51] = { unicodeslot=0x1B51, category='nd', description='BALINESE DIGIT ONE' },
	[0x1B52] = { unicodeslot=0x1B52, category='nd', description='BALINESE DIGIT TWO' },
	[0x1B53] = { unicodeslot=0x1B53, category='nd', description='BALINESE DIGIT THREE' },
	[0x1B54] = { unicodeslot=0x1B54, category='nd', description='BALINESE DIGIT FOUR' },
	[0x1B55] = { unicodeslot=0x1B55, category='nd', description='BALINESE DIGIT FIVE' },
	[0x1B56] = { unicodeslot=0x1B56, category='nd', description='BALINESE DIGIT SIX' },
	[0x1B57] = { unicodeslot=0x1B57, category='nd', description='BALINESE DIGIT SEVEN' },
	[0x1B58] = { unicodeslot=0x1B58, category='nd', description='BALINESE DIGIT EIGHT' },
	[0x1B59] = { unicodeslot=0x1B59, category='nd', description='BALINESE DIGIT NINE' },
	[0x1B5A] = { unicodeslot=0x1B5A, category='po', description='BALINESE PANTI' },
	[0x1B5B] = { unicodeslot=0x1B5B, category='po', description='BALINESE PAMADA' },
	[0x1B5C] = { unicodeslot=0x1B5C, category='po', description='BALINESE WINDU' },
	[0x1B5D] = { unicodeslot=0x1B5D, category='po', description='BALINESE CARIK PAMUNGKAH' },
	[0x1B5E] = { unicodeslot=0x1B5E, category='po', description='BALINESE CARIK SIKI' },
	[0x1B5F] = { unicodeslot=0x1B5F, category='po', description='BALINESE CARIK PAREREN' },
	[0x1B60] = { unicodeslot=0x1B60, category='po', description='BALINESE PAMENENG' },
	[0x1B61] = { unicodeslot=0x1B61, category='so', description='BALINESE MUSICAL SYMBOL DONG' },
	[0x1B62] = { unicodeslot=0x1B62, category='so', description='BALINESE MUSICAL SYMBOL DENG' },
	[0x1B63] = { unicodeslot=0x1B63, category='so', description='BALINESE MUSICAL SYMBOL DUNG' },
	[0x1B64] = { unicodeslot=0x1B64, category='so', description='BALINESE MUSICAL SYMBOL DANG' },
	[0x1B65] = { unicodeslot=0x1B65, category='so', description='BALINESE MUSICAL SYMBOL DANG SURANG' },
	[0x1B66] = { unicodeslot=0x1B66, category='so', description='BALINESE MUSICAL SYMBOL DING' },
	[0x1B67] = { unicodeslot=0x1B67, category='so', description='BALINESE MUSICAL SYMBOL DAENG' },
	[0x1B68] = { unicodeslot=0x1B68, category='so', description='BALINESE MUSICAL SYMBOL DEUNG' },
	[0x1B69] = { unicodeslot=0x1B69, category='so', description='BALINESE MUSICAL SYMBOL DAING' },
	[0x1B6A] = { unicodeslot=0x1B6A, category='so', description='BALINESE MUSICAL SYMBOL DANG GEDE' },
	[0x1B6B] = { unicodeslot=0x1B6B, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING TEGEH' },
	[0x1B6C] = { unicodeslot=0x1B6C, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING ENDEP' },
	[0x1B6D] = { unicodeslot=0x1B6D, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING KEMPUL' },
	[0x1B6E] = { unicodeslot=0x1B6E, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING KEMPLI' },
	[0x1B6F] = { unicodeslot=0x1B6F, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING JEGOGAN' },
	[0x1B70] = { unicodeslot=0x1B70, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING KEMPUL WITH JEGOGAN' },
	[0x1B71] = { unicodeslot=0x1B71, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING KEMPLI WITH JEGOGAN' },
	[0x1B72] = { unicodeslot=0x1B72, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING BENDE' },
	[0x1B73] = { unicodeslot=0x1B73, category='mn', description='BALINESE MUSICAL SYMBOL COMBINING GONG' },
	[0x1B74] = { unicodeslot=0x1B74, category='so', description='BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DUG' },
	[0x1B75] = { unicodeslot=0x1B75, category='so', description='BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DAG' },
	[0x1B76] = { unicodeslot=0x1B76, category='so', description='BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TUK' },
	[0x1B77] = { unicodeslot=0x1B77, category='so', description='BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TAK' },
	[0x1B78] = { unicodeslot=0x1B78, category='so', description='BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PANG' },
	[0x1B79] = { unicodeslot=0x1B79, category='so', description='BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PUNG' },
	[0x1B7A] = { unicodeslot=0x1B7A, category='so', description='BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLAK' },
	[0x1B7B] = { unicodeslot=0x1B7B, category='so', description='BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLUK' },
	[0x1B7C] = { unicodeslot=0x1B7C, category='so', description='BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PING' },
	[0x1D00] = { unicodeslot=0x1D00, category='ll', description='LATIN LETTER SMALL CAPITAL A' },
	[0x1D01] = { unicodeslot=0x1D01, category='ll', description='LATIN LETTER SMALL CAPITAL AE' },
	[0x1D02] = { unicodeslot=0x1D02, category='ll', description='LATIN SMALL LETTER TURNED AE' },
	[0x1D03] = { unicodeslot=0x1D03, category='ll', description='LATIN LETTER SMALL CAPITAL BARRED B' },
	[0x1D04] = { unicodeslot=0x1D04, category='ll', description='LATIN LETTER SMALL CAPITAL C' },
	[0x1D05] = { unicodeslot=0x1D05, category='ll', description='LATIN LETTER SMALL CAPITAL D' },
	[0x1D06] = { unicodeslot=0x1D06, category='ll', description='LATIN LETTER SMALL CAPITAL ETH' },
	[0x1D07] = { unicodeslot=0x1D07, category='ll', description='LATIN LETTER SMALL CAPITAL E' },
	[0x1D08] = { unicodeslot=0x1D08, category='ll', description='LATIN SMALL LETTER TURNED OPEN E' },
	[0x1D09] = { unicodeslot=0x1D09, category='ll', description='LATIN SMALL LETTER TURNED I' },
	[0x1D0A] = { unicodeslot=0x1D0A, category='ll', description='LATIN LETTER SMALL CAPITAL J' },
	[0x1D0B] = { unicodeslot=0x1D0B, category='ll', description='LATIN LETTER SMALL CAPITAL K' },
	[0x1D0C] = { unicodeslot=0x1D0C, category='ll', description='LATIN LETTER SMALL CAPITAL L WITH STROKE' },
	[0x1D0D] = { unicodeslot=0x1D0D, category='ll', description='LATIN LETTER SMALL CAPITAL M' },
	[0x1D0E] = { unicodeslot=0x1D0E, category='ll', description='LATIN LETTER SMALL CAPITAL REVERSED N' },
	[0x1D0F] = { unicodeslot=0x1D0F, category='ll', description='LATIN LETTER SMALL CAPITAL O' },
	[0x1D10] = { unicodeslot=0x1D10, category='ll', description='LATIN LETTER SMALL CAPITAL OPEN O' },
	[0x1D11] = { unicodeslot=0x1D11, category='ll', description='LATIN SMALL LETTER SIDEWAYS O' },
	[0x1D12] = { unicodeslot=0x1D12, category='ll', description='LATIN SMALL LETTER SIDEWAYS OPEN O' },
	[0x1D13] = { unicodeslot=0x1D13, category='ll', description='LATIN SMALL LETTER SIDEWAYS O WITH STROKE' },
	[0x1D14] = { unicodeslot=0x1D14, category='ll', description='LATIN SMALL LETTER TURNED OE' },
	[0x1D15] = { unicodeslot=0x1D15, category='ll', description='LATIN LETTER SMALL CAPITAL OU' },
	[0x1D16] = { unicodeslot=0x1D16, category='ll', description='LATIN SMALL LETTER TOP HALF O' },
	[0x1D17] = { unicodeslot=0x1D17, category='ll', description='LATIN SMALL LETTER BOTTOM HALF O' },
	[0x1D18] = { unicodeslot=0x1D18, category='ll', description='LATIN LETTER SMALL CAPITAL P' },
	[0x1D19] = { unicodeslot=0x1D19, category='ll', description='LATIN LETTER SMALL CAPITAL REVERSED R' },
	[0x1D1A] = { unicodeslot=0x1D1A, category='ll', description='LATIN LETTER SMALL CAPITAL TURNED R' },
	[0x1D1B] = { unicodeslot=0x1D1B, category='ll', description='LATIN LETTER SMALL CAPITAL T' },
	[0x1D1C] = { unicodeslot=0x1D1C, category='ll', description='LATIN LETTER SMALL CAPITAL U' },
	[0x1D1D] = { unicodeslot=0x1D1D, category='ll', description='LATIN SMALL LETTER SIDEWAYS U' },
	[0x1D1E] = { unicodeslot=0x1D1E, category='ll', description='LATIN SMALL LETTER SIDEWAYS DIAERESIZED U' },
	[0x1D1F] = { unicodeslot=0x1D1F, category='ll', description='LATIN SMALL LETTER SIDEWAYS TURNED M' },
	[0x1D20] = { unicodeslot=0x1D20, category='ll', description='LATIN LETTER SMALL CAPITAL V' },
	[0x1D21] = { unicodeslot=0x1D21, category='ll', description='LATIN LETTER SMALL CAPITAL W' },
	[0x1D22] = { unicodeslot=0x1D22, category='ll', description='LATIN LETTER SMALL CAPITAL Z' },
	[0x1D23] = { unicodeslot=0x1D23, category='ll', description='LATIN LETTER SMALL CAPITAL EZH' },
	[0x1D24] = { unicodeslot=0x1D24, category='ll', description='LATIN LETTER VOICED LARYNGEAL SPIRANT' },
	[0x1D25] = { unicodeslot=0x1D25, category='ll', description='LATIN LETTER AIN' },
	[0x1D26] = { unicodeslot=0x1D26, category='ll', description='GREEK LETTER SMALL CAPITAL GAMMA' },
	[0x1D27] = { unicodeslot=0x1D27, category='ll', description='GREEK LETTER SMALL CAPITAL LAMDA' },
	[0x1D28] = { unicodeslot=0x1D28, category='ll', description='GREEK LETTER SMALL CAPITAL PI' },
	[0x1D29] = { unicodeslot=0x1D29, category='ll', description='GREEK LETTER SMALL CAPITAL RHO' },
	[0x1D2A] = { unicodeslot=0x1D2A, category='ll', description='GREEK LETTER SMALL CAPITAL PSI' },
	[0x1D2B] = { unicodeslot=0x1D2B, category='ll', description='CYRILLIC LETTER SMALL CAPITAL EL' },
	[0x1D2C] = { unicodeslot=0x1D2C, category='lm', description='MODIFIER LETTER CAPITAL A', specials={'super',0x0041} },
	[0x1D2D] = { unicodeslot=0x1D2D, category='lm', description='MODIFIER LETTER CAPITAL AE', specials={'super',0x00C6} },
	[0x1D2E] = { unicodeslot=0x1D2E, category='lm', description='MODIFIER LETTER CAPITAL B', specials={'super',0x0042} },
	[0x1D2F] = { unicodeslot=0x1D2F, category='lm', description='MODIFIER LETTER CAPITAL BARRED B' },
	[0x1D30] = { unicodeslot=0x1D30, category='lm', description='MODIFIER LETTER CAPITAL D', specials={'super',0x0044} },
	[0x1D31] = { unicodeslot=0x1D31, category='lm', description='MODIFIER LETTER CAPITAL E', specials={'super',0x0045} },
	[0x1D32] = { unicodeslot=0x1D32, category='lm', description='MODIFIER LETTER CAPITAL REVERSED E', specials={'super',0x018E} },
	[0x1D33] = { unicodeslot=0x1D33, category='lm', description='MODIFIER LETTER CAPITAL G', specials={'super',0x0047} },
	[0x1D34] = { unicodeslot=0x1D34, category='lm', description='MODIFIER LETTER CAPITAL H', specials={'super',0x0048} },
	[0x1D35] = { unicodeslot=0x1D35, category='lm', description='MODIFIER LETTER CAPITAL I', specials={'super',0x0049} },
	[0x1D36] = { unicodeslot=0x1D36, category='lm', description='MODIFIER LETTER CAPITAL J', specials={'super',0x004A} },
	[0x1D37] = { unicodeslot=0x1D37, category='lm', description='MODIFIER LETTER CAPITAL K', specials={'super',0x004B} },
	[0x1D38] = { unicodeslot=0x1D38, category='lm', description='MODIFIER LETTER CAPITAL L', specials={'super',0x004C} },
	[0x1D39] = { unicodeslot=0x1D39, category='lm', description='MODIFIER LETTER CAPITAL M', specials={'super',0x004D} },
	[0x1D3A] = { unicodeslot=0x1D3A, category='lm', description='MODIFIER LETTER CAPITAL N', specials={'super',0x004E} },
	[0x1D3B] = { unicodeslot=0x1D3B, category='lm', description='MODIFIER LETTER CAPITAL REVERSED N' },
	[0x1D3C] = { unicodeslot=0x1D3C, category='lm', description='MODIFIER LETTER CAPITAL O', specials={'super',0x004F} },
	[0x1D3D] = { unicodeslot=0x1D3D, category='lm', description='MODIFIER LETTER CAPITAL OU', specials={'super',0x0222} },
	[0x1D3E] = { unicodeslot=0x1D3E, category='lm', description='MODIFIER LETTER CAPITAL P', specials={'super',0x0050} },
	[0x1D3F] = { unicodeslot=0x1D3F, category='lm', description='MODIFIER LETTER CAPITAL R', specials={'super',0x0052} },
	[0x1D40] = { unicodeslot=0x1D40, category='lm', description='MODIFIER LETTER CAPITAL T', specials={'super',0x0054} },
	[0x1D41] = { unicodeslot=0x1D41, category='lm', description='MODIFIER LETTER CAPITAL U', specials={'super',0x0055} },
	[0x1D42] = { unicodeslot=0x1D42, category='lm', description='MODIFIER LETTER CAPITAL W', specials={'super',0x0057} },
	[0x1D43] = { unicodeslot=0x1D43, category='lm', description='MODIFIER LETTER SMALL A', specials={'super',0x0061} },
	[0x1D44] = { unicodeslot=0x1D44, category='lm', description='MODIFIER LETTER SMALL TURNED A', specials={'super',0x0250} },
	[0x1D45] = { unicodeslot=0x1D45, category='lm', description='MODIFIER LETTER SMALL ALPHA', specials={'super',0x0251} },
	[0x1D46] = { unicodeslot=0x1D46, category='lm', description='MODIFIER LETTER SMALL TURNED AE', specials={'super',0x1D02} },
	[0x1D47] = { unicodeslot=0x1D47, category='lm', description='MODIFIER LETTER SMALL B', specials={'super',0x0062} },
	[0x1D48] = { unicodeslot=0x1D48, category='lm', description='MODIFIER LETTER SMALL D', specials={'super',0x0064} },
	[0x1D49] = { unicodeslot=0x1D49, category='lm', description='MODIFIER LETTER SMALL E', specials={'super',0x0065} },
	[0x1D4A] = { unicodeslot=0x1D4A, category='lm', description='MODIFIER LETTER SMALL SCHWA', specials={'super',0x0259} },
	[0x1D4B] = { unicodeslot=0x1D4B, category='lm', description='MODIFIER LETTER SMALL OPEN E', specials={'super',0x025B} },
	[0x1D4C] = { unicodeslot=0x1D4C, category='lm', description='MODIFIER LETTER SMALL TURNED OPEN E', specials={'super',0x025C} },
	[0x1D4D] = { unicodeslot=0x1D4D, category='lm', description='MODIFIER LETTER SMALL G', specials={'super',0x0067} },
	[0x1D4E] = { unicodeslot=0x1D4E, category='lm', description='MODIFIER LETTER SMALL TURNED I' },
	[0x1D4F] = { unicodeslot=0x1D4F, category='lm', description='MODIFIER LETTER SMALL K', specials={'super',0x006B} },
	[0x1D50] = { unicodeslot=0x1D50, category='lm', description='MODIFIER LETTER SMALL M', specials={'super',0x006D} },
	[0x1D51] = { unicodeslot=0x1D51, category='lm', description='MODIFIER LETTER SMALL ENG', specials={'super',0x014B} },
	[0x1D52] = { unicodeslot=0x1D52, category='lm', description='MODIFIER LETTER SMALL O', specials={'super',0x006F} },
	[0x1D53] = { unicodeslot=0x1D53, category='lm', description='MODIFIER LETTER SMALL OPEN O', specials={'super',0x0254} },
	[0x1D54] = { unicodeslot=0x1D54, category='lm', description='MODIFIER LETTER SMALL TOP HALF O', specials={'super',0x1D16} },
	[0x1D55] = { unicodeslot=0x1D55, category='lm', description='MODIFIER LETTER SMALL BOTTOM HALF O', specials={'super',0x1D17} },
	[0x1D56] = { unicodeslot=0x1D56, category='lm', description='MODIFIER LETTER SMALL P', specials={'super',0x0070} },
	[0x1D57] = { unicodeslot=0x1D57, category='lm', description='MODIFIER LETTER SMALL T', specials={'super',0x0074} },
	[0x1D58] = { unicodeslot=0x1D58, category='lm', description='MODIFIER LETTER SMALL U', specials={'super',0x0075} },
	[0x1D59] = { unicodeslot=0x1D59, category='lm', description='MODIFIER LETTER SMALL SIDEWAYS U', specials={'super',0x1D1D} },
	[0x1D5A] = { unicodeslot=0x1D5A, category='lm', description='MODIFIER LETTER SMALL TURNED M', specials={'super',0x026F} },
	[0x1D5B] = { unicodeslot=0x1D5B, category='lm', description='MODIFIER LETTER SMALL V', specials={'super',0x0076} },
	[0x1D5C] = { unicodeslot=0x1D5C, category='lm', description='MODIFIER LETTER SMALL AIN', specials={'super',0x1D25} },
	[0x1D5D] = { unicodeslot=0x1D5D, category='lm', description='MODIFIER LETTER SMALL BETA', specials={'super',0x03B2} },
	[0x1D5E] = { unicodeslot=0x1D5E, category='lm', description='MODIFIER LETTER SMALL GREEK GAMMA', specials={'super',0x03B3} },
	[0x1D5F] = { unicodeslot=0x1D5F, category='lm', description='MODIFIER LETTER SMALL DELTA', specials={'super',0x03B4} },
	[0x1D60] = { unicodeslot=0x1D60, category='lm', description='MODIFIER LETTER SMALL GREEK PHI', specials={'super',0x03C6} },
	[0x1D61] = { unicodeslot=0x1D61, category='lm', description='MODIFIER LETTER SMALL CHI', specials={'super',0x03C7} },
	[0x1D62] = { unicodeslot=0x1D62, category='ll', description='LATIN SUBSCRIPT SMALL LETTER I', specials={'sub',0x0069} },
	[0x1D63] = { unicodeslot=0x1D63, category='ll', description='LATIN SUBSCRIPT SMALL LETTER R', specials={'sub',0x0072} },
	[0x1D64] = { unicodeslot=0x1D64, category='ll', description='LATIN SUBSCRIPT SMALL LETTER U', specials={'sub',0x0075} },
	[0x1D65] = { unicodeslot=0x1D65, category='ll', description='LATIN SUBSCRIPT SMALL LETTER V', specials={'sub',0x0076} },
	[0x1D66] = { unicodeslot=0x1D66, category='ll', description='GREEK SUBSCRIPT SMALL LETTER BETA', specials={'sub',0x03B2} },
	[0x1D67] = { unicodeslot=0x1D67, category='ll', description='GREEK SUBSCRIPT SMALL LETTER GAMMA', specials={'sub',0x03B3} },
	[0x1D68] = { unicodeslot=0x1D68, category='ll', description='GREEK SUBSCRIPT SMALL LETTER RHO', specials={'sub',0x03C1} },
	[0x1D69] = { unicodeslot=0x1D69, category='ll', description='GREEK SUBSCRIPT SMALL LETTER PHI', specials={'sub',0x03C6} },
	[0x1D6A] = { unicodeslot=0x1D6A, category='ll', description='GREEK SUBSCRIPT SMALL LETTER CHI', specials={'sub',0x03C7} },
	[0x1D6B] = { unicodeslot=0x1D6B, category='ll', description='LATIN SMALL LETTER UE' },
	[0x1D6C] = { unicodeslot=0x1D6C, category='ll', description='LATIN SMALL LETTER B WITH MIDDLE TILDE', shcode=0x0062 },
	[0x1D6D] = { unicodeslot=0x1D6D, category='ll', description='LATIN SMALL LETTER D WITH MIDDLE TILDE', shcode=0x0064 },
	[0x1D6E] = { unicodeslot=0x1D6E, category='ll', description='LATIN SMALL LETTER F WITH MIDDLE TILDE', shcode=0x0066 },
	[0x1D6F] = { unicodeslot=0x1D6F, category='ll', description='LATIN SMALL LETTER M WITH MIDDLE TILDE', shcode=0x006D },
	[0x1D70] = { unicodeslot=0x1D70, category='ll', description='LATIN SMALL LETTER N WITH MIDDLE TILDE', shcode=0x006E },
	[0x1D71] = { unicodeslot=0x1D71, category='ll', description='LATIN SMALL LETTER P WITH MIDDLE TILDE', shcode=0x0070 },
	[0x1D72] = { unicodeslot=0x1D72, category='ll', description='LATIN SMALL LETTER R WITH MIDDLE TILDE', shcode=0x0072 },
	[0x1D73] = { unicodeslot=0x1D73, category='ll', description='LATIN SMALL LETTER R WITH FISHHOOK AND MIDDLE TILDE', shcode=0x0072 },
	[0x1D74] = { unicodeslot=0x1D74, category='ll', description='LATIN SMALL LETTER S WITH MIDDLE TILDE', shcode=0x0073 },
	[0x1D75] = { unicodeslot=0x1D75, category='ll', description='LATIN SMALL LETTER T WITH MIDDLE TILDE', shcode=0x0074 },
	[0x1D76] = { unicodeslot=0x1D76, category='ll', description='LATIN SMALL LETTER Z WITH MIDDLE TILDE', shcode=0x007A },
	[0x1D77] = { unicodeslot=0x1D77, category='ll', description='LATIN SMALL LETTER TURNED G' },
	[0x1D78] = { unicodeslot=0x1D78, category='lm', description='MODIFIER LETTER CYRILLIC EN', specials={'super',0x043D} },
	[0x1D79] = { unicodeslot=0x1D79, category='ll', description='LATIN SMALL LETTER INSULAR G' },
	[0x1D7A] = { unicodeslot=0x1D7A, category='ll', description='LATIN SMALL LETTER TH WITH STRIKETHROUGH' },
	[0x1D7B] = { unicodeslot=0x1D7B, category='ll', description='LATIN SMALL CAPITAL LETTER I WITH STROKE' },
	[0x1D7C] = { unicodeslot=0x1D7C, category='ll', description='LATIN SMALL LETTER IOTA WITH STROKE', shcode=0x0269 },
	[0x1D7D] = { unicodeslot=0x1D7D, category='ll', description='LATIN SMALL LETTER P WITH STROKE', shcode=0x0070, uccode=0x2C63 },
	[0x1D7E] = { unicodeslot=0x1D7E, category='ll', description='LATIN SMALL CAPITAL LETTER U WITH STROKE' },
	[0x1D7F] = { unicodeslot=0x1D7F, category='ll', description='LATIN SMALL LETTER UPSILON WITH STROKE', shcode=0x028A },
	[0x1D80] = { unicodeslot=0x1D80, category='ll', description='LATIN SMALL LETTER B WITH PALATAL HOOK', shcode=0x0062 },
	[0x1D81] = { unicodeslot=0x1D81, category='ll', description='LATIN SMALL LETTER D WITH PALATAL HOOK', shcode=0x0064 },
	[0x1D82] = { unicodeslot=0x1D82, category='ll', description='LATIN SMALL LETTER F WITH PALATAL HOOK', shcode=0x0066 },
	[0x1D83] = { unicodeslot=0x1D83, category='ll', description='LATIN SMALL LETTER G WITH PALATAL HOOK', shcode=0x0067 },
	[0x1D84] = { unicodeslot=0x1D84, category='ll', description='LATIN SMALL LETTER K WITH PALATAL HOOK', shcode=0x006B },
	[0x1D85] = { unicodeslot=0x1D85, category='ll', description='LATIN SMALL LETTER L WITH PALATAL HOOK', shcode=0x006C },
	[0x1D86] = { unicodeslot=0x1D86, category='ll', description='LATIN SMALL LETTER M WITH PALATAL HOOK', shcode=0x006D },
	[0x1D87] = { unicodeslot=0x1D87, category='ll', description='LATIN SMALL LETTER N WITH PALATAL HOOK', shcode=0x006E },
	[0x1D88] = { unicodeslot=0x1D88, category='ll', description='LATIN SMALL LETTER P WITH PALATAL HOOK', shcode=0x0070 },
	[0x1D89] = { unicodeslot=0x1D89, category='ll', description='LATIN SMALL LETTER R WITH PALATAL HOOK', shcode=0x0072 },
	[0x1D8A] = { unicodeslot=0x1D8A, category='ll', description='LATIN SMALL LETTER S WITH PALATAL HOOK', shcode=0x0073 },
	[0x1D8B] = { unicodeslot=0x1D8B, category='ll', description='LATIN SMALL LETTER ESH WITH PALATAL HOOK', shcode=0x0283 },
	[0x1D8C] = { unicodeslot=0x1D8C, category='ll', description='LATIN SMALL LETTER V WITH PALATAL HOOK', shcode=0x0076 },
	[0x1D8D] = { unicodeslot=0x1D8D, category='ll', description='LATIN SMALL LETTER X WITH PALATAL HOOK', shcode=0x0078 },
	[0x1D8E] = { unicodeslot=0x1D8E, category='ll', description='LATIN SMALL LETTER Z WITH PALATAL HOOK', shcode=0x007A },
	[0x1D8F] = { unicodeslot=0x1D8F, category='ll', description='LATIN SMALL LETTER A WITH RETROFLEX HOOK', shcode=0x0061 },
	[0x1D90] = { unicodeslot=0x1D90, category='ll', description='LATIN SMALL LETTER ALPHA WITH RETROFLEX HOOK', shcode=0x0251 },
	[0x1D91] = { unicodeslot=0x1D91, category='ll', description='LATIN SMALL LETTER D WITH HOOK AND TAIL', shcode=0x0064 },
	[0x1D92] = { unicodeslot=0x1D92, category='ll', description='LATIN SMALL LETTER E WITH RETROFLEX HOOK', shcode=0x0065 },
	[0x1D93] = { unicodeslot=0x1D93, category='ll', description='LATIN SMALL LETTER OPEN E WITH RETROFLEX HOOK' },
	[0x1D94] = { unicodeslot=0x1D94, category='ll', description='LATIN SMALL LETTER REVERSED OPEN E WITH RETROFLEX HOOK' },
	[0x1D95] = { unicodeslot=0x1D95, category='ll', description='LATIN SMALL LETTER SCHWA WITH RETROFLEX HOOK', shcode=0x0259 },
	[0x1D96] = { unicodeslot=0x1D96, category='ll', description='LATIN SMALL LETTER I WITH RETROFLEX HOOK', shcode=0x0069 },
	[0x1D97] = { unicodeslot=0x1D97, category='ll', description='LATIN SMALL LETTER OPEN O WITH RETROFLEX HOOK' },
	[0x1D98] = { unicodeslot=0x1D98, category='ll', description='LATIN SMALL LETTER ESH WITH RETROFLEX HOOK', shcode=0x0283 },
	[0x1D99] = { unicodeslot=0x1D99, category='ll', description='LATIN SMALL LETTER U WITH RETROFLEX HOOK', shcode=0x0075 },
	[0x1D9A] = { unicodeslot=0x1D9A, category='ll', description='LATIN SMALL LETTER EZH WITH RETROFLEX HOOK', shcode=0x0292 },
	[0x1D9B] = { unicodeslot=0x1D9B, category='lm', description='MODIFIER LETTER SMALL TURNED ALPHA', specials={'super',0x0252} },
	[0x1D9C] = { unicodeslot=0x1D9C, category='lm', description='MODIFIER LETTER SMALL C', specials={'super',0x0063} },
	[0x1D9D] = { unicodeslot=0x1D9D, category='lm', description='MODIFIER LETTER SMALL C WITH CURL', specials={'super',0x0255} },
	[0x1D9E] = { unicodeslot=0x1D9E, category='lm', description='MODIFIER LETTER SMALL ETH', specials={'super',0x00F0} },
	[0x1D9F] = { unicodeslot=0x1D9F, category='lm', description='MODIFIER LETTER SMALL REVERSED OPEN E', specials={'super',0x025C} },
	[0x1DA0] = { unicodeslot=0x1DA0, category='lm', description='MODIFIER LETTER SMALL F', specials={'super',0x0066} },
	[0x1DA1] = { unicodeslot=0x1DA1, category='lm', description='MODIFIER LETTER SMALL DOTLESS J WITH STROKE', specials={'super',0x025F} },
	[0x1DA2] = { unicodeslot=0x1DA2, category='lm', description='MODIFIER LETTER SMALL SCRIPT G', specials={'super',0x0261} },
	[0x1DA3] = { unicodeslot=0x1DA3, category='lm', description='MODIFIER LETTER SMALL TURNED H', specials={'super',0x0265} },
	[0x1DA4] = { unicodeslot=0x1DA4, category='lm', description='MODIFIER LETTER SMALL I WITH STROKE', specials={'super',0x0268} },
	[0x1DA5] = { unicodeslot=0x1DA5, category='lm', description='MODIFIER LETTER SMALL IOTA', specials={'super',0x0269} },
	[0x1DA6] = { unicodeslot=0x1DA6, category='lm', description='MODIFIER LETTER SMALL CAPITAL I', specials={'super',0x026A} },
	[0x1DA7] = { unicodeslot=0x1DA7, category='lm', description='MODIFIER LETTER SMALL CAPITAL I WITH STROKE', specials={'super',0x1D7B} },
	[0x1DA8] = { unicodeslot=0x1DA8, category='lm', description='MODIFIER LETTER SMALL J WITH CROSSED-TAIL', specials={'super',0x029D} },
	[0x1DA9] = { unicodeslot=0x1DA9, category='lm', description='MODIFIER LETTER SMALL L WITH RETROFLEX HOOK', specials={'super',0x026D} },
	[0x1DAA] = { unicodeslot=0x1DAA, category='lm', description='MODIFIER LETTER SMALL L WITH PALATAL HOOK', specials={'super',0x1D85} },
	[0x1DAB] = { unicodeslot=0x1DAB, category='lm', description='MODIFIER LETTER SMALL CAPITAL L', specials={'super',0x029F} },
	[0x1DAC] = { unicodeslot=0x1DAC, category='lm', description='MODIFIER LETTER SMALL M WITH HOOK', specials={'super',0x0271} },
	[0x1DAD] = { unicodeslot=0x1DAD, category='lm', description='MODIFIER LETTER SMALL TURNED M WITH LONG LEG', specials={'super',0x0270} },
	[0x1DAE] = { unicodeslot=0x1DAE, category='lm', description='MODIFIER LETTER SMALL N WITH LEFT HOOK', specials={'super',0x0272} },
	[0x1DAF] = { unicodeslot=0x1DAF, category='lm', description='MODIFIER LETTER SMALL N WITH RETROFLEX HOOK', specials={'super',0x0273} },
	[0x1DB0] = { unicodeslot=0x1DB0, category='lm', description='MODIFIER LETTER SMALL CAPITAL N', specials={'super',0x0274} },
	[0x1DB1] = { unicodeslot=0x1DB1, category='lm', description='MODIFIER LETTER SMALL BARRED O', specials={'super',0x0275} },
	[0x1DB2] = { unicodeslot=0x1DB2, category='lm', description='MODIFIER LETTER SMALL PHI', specials={'super',0x0278} },
	[0x1DB3] = { unicodeslot=0x1DB3, category='lm', description='MODIFIER LETTER SMALL S WITH HOOK', specials={'super',0x0282} },
	[0x1DB4] = { unicodeslot=0x1DB4, category='lm', description='MODIFIER LETTER SMALL ESH', specials={'super',0x0283} },
	[0x1DB5] = { unicodeslot=0x1DB5, category='lm', description='MODIFIER LETTER SMALL T WITH PALATAL HOOK', specials={'super',0x01AB} },
	[0x1DB6] = { unicodeslot=0x1DB6, category='lm', description='MODIFIER LETTER SMALL U BAR', specials={'super',0x0289} },
	[0x1DB7] = { unicodeslot=0x1DB7, category='lm', description='MODIFIER LETTER SMALL UPSILON', specials={'super',0x028A} },
	[0x1DB8] = { unicodeslot=0x1DB8, category='lm', description='MODIFIER LETTER SMALL CAPITAL U', specials={'super',0x1D1C} },
	[0x1DB9] = { unicodeslot=0x1DB9, category='lm', description='MODIFIER LETTER SMALL V WITH HOOK', specials={'super',0x028B} },
	[0x1DBA] = { unicodeslot=0x1DBA, category='lm', description='MODIFIER LETTER SMALL TURNED V', specials={'super',0x028C} },
	[0x1DBB] = { unicodeslot=0x1DBB, category='lm', description='MODIFIER LETTER SMALL Z', specials={'super',0x007A} },
	[0x1DBC] = { unicodeslot=0x1DBC, category='lm', description='MODIFIER LETTER SMALL Z WITH RETROFLEX HOOK', specials={'super',0x0290} },
	[0x1DBD] = { unicodeslot=0x1DBD, category='lm', description='MODIFIER LETTER SMALL Z WITH CURL', specials={'super',0x0291} },
	[0x1DBE] = { unicodeslot=0x1DBE, category='lm', description='MODIFIER LETTER SMALL EZH', specials={'super',0x0292} },
	[0x1DBF] = { unicodeslot=0x1DBF, category='lm', description='MODIFIER LETTER SMALL THETA', specials={'super',0x03B8} },
	[0x1DC0] = { unicodeslot=0x1DC0, category='mn', description='COMBINING DOTTED GRAVE ACCENT' },
	[0x1DC1] = { unicodeslot=0x1DC1, category='mn', description='COMBINING DOTTED ACUTE ACCENT' },
	[0x1DC2] = { unicodeslot=0x1DC2, category='mn', description='COMBINING SNAKE BELOW' },
	[0x1DC3] = { unicodeslot=0x1DC3, category='mn', description='COMBINING SUSPENSION MARK' },
	[0x1DC4] = { unicodeslot=0x1DC4, category='mn', description='COMBINING MACRON-ACUTE' },
	[0x1DC5] = { unicodeslot=0x1DC5, category='mn', description='COMBINING GRAVE-MACRON' },
	[0x1DC6] = { unicodeslot=0x1DC6, category='mn', description='COMBINING MACRON-GRAVE' },
	[0x1DC7] = { unicodeslot=0x1DC7, category='mn', description='COMBINING ACUTE-MACRON' },
	[0x1DC8] = { unicodeslot=0x1DC8, category='mn', description='COMBINING GRAVE-ACUTE-GRAVE' },
	[0x1DC9] = { unicodeslot=0x1DC9, category='mn', description='COMBINING ACUTE-GRAVE-ACUTE' },
	[0x1DCA] = { unicodeslot=0x1DCA, category='mn', description='COMBINING LATIN SMALL LETTER R BELOW' },
	[0x1DFE] = { unicodeslot=0x1DFE, category='mn', description='COMBINING LEFT ARROWHEAD ABOVE' },
	[0x1DFF] = { unicodeslot=0x1DFF, category='mn', description='COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW' },
	[0x1E00] = { unicodeslot=0x1E00, category='lu', description='LATIN CAPITAL LETTER A WITH RING BELOW', shcode=0x0041, lccode=0x1E01, specials={'char',0x0041,0x0325} },
	[0x1E01] = { unicodeslot=0x1E01, category='ll', description='LATIN SMALL LETTER A WITH RING BELOW', shcode=0x0061, uccode=0x1E00, specials={'char',0x0061,0x0325} },
	[0x1E02] = { unicodeslot=0x1E02, category='lu', description='LATIN CAPITAL LETTER B WITH DOT ABOVE', shcode=0x0042, lccode=0x1E03, specials={'char',0x0042,0x0307} },
	[0x1E03] = { unicodeslot=0x1E03, category='ll', description='LATIN SMALL LETTER B WITH DOT ABOVE', shcode=0x0062, uccode=0x1E02, specials={'char',0x0062,0x0307} },
	[0x1E04] = { unicodeslot=0x1E04, category='lu', description='LATIN CAPITAL LETTER B WITH DOT BELOW', shcode=0x0042, lccode=0x1E05, specials={'char',0x0042,0x0323} },
	[0x1E05] = { unicodeslot=0x1E05, category='ll', description='LATIN SMALL LETTER B WITH DOT BELOW', shcode=0x0062, uccode=0x1E04, specials={'char',0x0062,0x0323} },
	[0x1E06] = { unicodeslot=0x1E06, category='lu', description='LATIN CAPITAL LETTER B WITH LINE BELOW', shcode=0x0042, lccode=0x1E07, specials={'char',0x0042,0x0331} },
	[0x1E07] = { unicodeslot=0x1E07, category='ll', description='LATIN SMALL LETTER B WITH LINE BELOW', shcode=0x0062, uccode=0x1E06, specials={'char',0x0062,0x0331} },
	[0x1E08] = { unicodeslot=0x1E08, category='lu', description='LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE', shcode=0x0043, lccode=0x1E09, specials={'char',0x00C7,0x0301} },
	[0x1E09] = { unicodeslot=0x1E09, category='ll', description='LATIN SMALL LETTER C WITH CEDILLA AND ACUTE', shcode=0x0063, uccode=0x1E08, specials={'char',0x00E7,0x0301} },
	[0x1E0A] = { unicodeslot=0x1E0A, category='lu', description='LATIN CAPITAL LETTER D WITH DOT ABOVE', shcode=0x0044, lccode=0x1E0B, specials={'char',0x0044,0x0307} },
	[0x1E0B] = { unicodeslot=0x1E0B, category='ll', description='LATIN SMALL LETTER D WITH DOT ABOVE', shcode=0x0064, uccode=0x1E0A, specials={'char',0x0064,0x0307} },
	[0x1E0C] = { unicodeslot=0x1E0C, category='lu', description='LATIN CAPITAL LETTER D WITH DOT BELOW', shcode=0x0044, lccode=0x1E0D, specials={'char',0x0044,0x0323} },
	[0x1E0D] = { unicodeslot=0x1E0D, category='ll', description='LATIN SMALL LETTER D WITH DOT BELOW', shcode=0x0064, uccode=0x1E0C, specials={'char',0x0064,0x0323} },
	[0x1E0E] = { unicodeslot=0x1E0E, category='lu', description='LATIN CAPITAL LETTER D WITH LINE BELOW', shcode=0x0044, lccode=0x1E0F, specials={'char',0x0044,0x0331} },
	[0x1E0F] = { unicodeslot=0x1E0F, category='ll', description='LATIN SMALL LETTER D WITH LINE BELOW', shcode=0x0064, uccode=0x1E0E, specials={'char',0x0064,0x0331} },
	[0x1E10] = { unicodeslot=0x1E10, category='lu', description='LATIN CAPITAL LETTER D WITH CEDILLA', shcode=0x0044, lccode=0x1E11, specials={'char',0x0044,0x0327} },
	[0x1E11] = { unicodeslot=0x1E11, category='ll', description='LATIN SMALL LETTER D WITH CEDILLA', shcode=0x0064, uccode=0x1E10, specials={'char',0x0064,0x0327} },
	[0x1E12] = { unicodeslot=0x1E12, category='lu', description='LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW', shcode=0x0044, lccode=0x1E13, specials={'char',0x0044,0x032D} },
	[0x1E13] = { unicodeslot=0x1E13, category='ll', description='LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW', shcode=0x0064, uccode=0x1E12, specials={'char',0x0064,0x032D} },
	[0x1E14] = { unicodeslot=0x1E14, category='lu', description='LATIN CAPITAL LETTER E WITH MACRON AND GRAVE', shcode=0x0045, lccode=0x1E15, specials={'char',0x0112,0x0300} },
	[0x1E15] = { unicodeslot=0x1E15, category='ll', description='LATIN SMALL LETTER E WITH MACRON AND GRAVE', shcode=0x0065, uccode=0x1E14, specials={'char',0x0113,0x0300} },
	[0x1E16] = { unicodeslot=0x1E16, category='lu', description='LATIN CAPITAL LETTER E WITH MACRON AND ACUTE', shcode=0x0045, lccode=0x1E17, specials={'char',0x0112,0x0301} },
	[0x1E17] = { unicodeslot=0x1E17, category='ll', description='LATIN SMALL LETTER E WITH MACRON AND ACUTE', shcode=0x0065, uccode=0x1E16, specials={'char',0x0113,0x0301} },
	[0x1E18] = { unicodeslot=0x1E18, category='lu', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW', shcode=0x0045, lccode=0x1E19, specials={'char',0x0045,0x032D} },
	[0x1E19] = { unicodeslot=0x1E19, category='ll', description='LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW', shcode=0x0065, uccode=0x1E18, specials={'char',0x0065,0x032D} },
	[0x1E1A] = { unicodeslot=0x1E1A, category='lu', description='LATIN CAPITAL LETTER E WITH TILDE BELOW', shcode=0x0045, lccode=0x1E1B, specials={'char',0x0045,0x0330} },
	[0x1E1B] = { unicodeslot=0x1E1B, category='ll', description='LATIN SMALL LETTER E WITH TILDE BELOW', shcode=0x0065, uccode=0x1E1A, specials={'char',0x0065,0x0330} },
	[0x1E1C] = { unicodeslot=0x1E1C, category='lu', description='LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE', shcode=0x0045, lccode=0x1E1D, specials={'char',0x0228,0x0306} },
	[0x1E1D] = { unicodeslot=0x1E1D, category='ll', description='LATIN SMALL LETTER E WITH CEDILLA AND BREVE', shcode=0x0065, uccode=0x1E1C, specials={'char',0x0229,0x0306} },
	[0x1E1E] = { unicodeslot=0x1E1E, category='lu', description='LATIN CAPITAL LETTER F WITH DOT ABOVE', shcode=0x0046, lccode=0x1E1F, specials={'char',0x0046,0x0307} },
	[0x1E1F] = { unicodeslot=0x1E1F, category='ll', description='LATIN SMALL LETTER F WITH DOT ABOVE', shcode=0x0066, uccode=0x1E1E, specials={'char',0x0066,0x0307} },
	[0x1E20] = { unicodeslot=0x1E20, category='lu', description='LATIN CAPITAL LETTER G WITH MACRON', shcode=0x0047, lccode=0x1E21, specials={'char',0x0047,0x0304} },
	[0x1E21] = { unicodeslot=0x1E21, category='ll', description='LATIN SMALL LETTER G WITH MACRON', shcode=0x0067, uccode=0x1E20, specials={'char',0x0067,0x0304} },
	[0x1E22] = { unicodeslot=0x1E22, category='lu', description='LATIN CAPITAL LETTER H WITH DOT ABOVE', shcode=0x0048, lccode=0x1E23, specials={'char',0x0048,0x0307} },
	[0x1E23] = { unicodeslot=0x1E23, category='ll', description='LATIN SMALL LETTER H WITH DOT ABOVE', shcode=0x0068, uccode=0x1E22, specials={'char',0x0068,0x0307} },
	[0x1E24] = { unicodeslot=0x1E24, category='lu', description='LATIN CAPITAL LETTER H WITH DOT BELOW', shcode=0x0048, lccode=0x1E25, specials={'char',0x0048,0x0323} },
	[0x1E25] = { unicodeslot=0x1E25, category='ll', description='LATIN SMALL LETTER H WITH DOT BELOW', shcode=0x0068, uccode=0x1E24, specials={'char',0x0068,0x0323} },
	[0x1E26] = { unicodeslot=0x1E26, category='lu', description='LATIN CAPITAL LETTER H WITH DIAERESIS', shcode=0x0048, lccode=0x1E27, specials={'char',0x0048,0x0308} },
	[0x1E27] = { unicodeslot=0x1E27, category='ll', description='LATIN SMALL LETTER H WITH DIAERESIS', shcode=0x0068, uccode=0x1E26, specials={'char',0x0068,0x0308} },
	[0x1E28] = { unicodeslot=0x1E28, category='lu', description='LATIN CAPITAL LETTER H WITH CEDILLA', shcode=0x0048, lccode=0x1E29, specials={'char',0x0048,0x0327} },
	[0x1E29] = { unicodeslot=0x1E29, category='ll', description='LATIN SMALL LETTER H WITH CEDILLA', shcode=0x0068, uccode=0x1E28, specials={'char',0x0068,0x0327} },
	[0x1E2A] = { unicodeslot=0x1E2A, category='lu', description='LATIN CAPITAL LETTER H WITH BREVE BELOW', shcode=0x0048, lccode=0x1E2B, specials={'char',0x0048,0x032E} },
	[0x1E2B] = { unicodeslot=0x1E2B, category='ll', description='LATIN SMALL LETTER H WITH BREVE BELOW', shcode=0x0068, uccode=0x1E2A, specials={'char',0x0068,0x032E} },
	[0x1E2C] = { unicodeslot=0x1E2C, category='lu', description='LATIN CAPITAL LETTER I WITH TILDE BELOW', shcode=0x0049, lccode=0x1E2D, specials={'char',0x0049,0x0330} },
	[0x1E2D] = { unicodeslot=0x1E2D, category='ll', description='LATIN SMALL LETTER I WITH TILDE BELOW', shcode=0x0069, uccode=0x1E2C, specials={'char',0x0069,0x0330} },
	[0x1E2E] = { unicodeslot=0x1E2E, category='lu', description='LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE', shcode=0x0049, lccode=0x1E2F, specials={'char',0x00CF,0x0301} },
	[0x1E2F] = { unicodeslot=0x1E2F, category='ll', description='LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE', shcode=0x0069, uccode=0x1E2E, specials={'char',0x00EF,0x0301} },
	[0x1E30] = { unicodeslot=0x1E30, category='lu', description='LATIN CAPITAL LETTER K WITH ACUTE', shcode=0x004B, lccode=0x1E31, specials={'char',0x004B,0x0301} },
	[0x1E31] = { unicodeslot=0x1E31, category='ll', description='LATIN SMALL LETTER K WITH ACUTE', shcode=0x006B, uccode=0x1E30, specials={'char',0x006B,0x0301} },
	[0x1E32] = { unicodeslot=0x1E32, category='lu', description='LATIN CAPITAL LETTER K WITH DOT BELOW', shcode=0x004B, lccode=0x1E33, specials={'char',0x004B,0x0323} },
	[0x1E33] = { unicodeslot=0x1E33, category='ll', description='LATIN SMALL LETTER K WITH DOT BELOW', shcode=0x006B, uccode=0x1E32, specials={'char',0x006B,0x0323} },
	[0x1E34] = { unicodeslot=0x1E34, category='lu', description='LATIN CAPITAL LETTER K WITH LINE BELOW', shcode=0x004B, lccode=0x1E35, specials={'char',0x004B,0x0331} },
	[0x1E35] = { unicodeslot=0x1E35, category='ll', description='LATIN SMALL LETTER K WITH LINE BELOW', shcode=0x006B, uccode=0x1E34, specials={'char',0x006B,0x0331} },
	[0x1E36] = { unicodeslot=0x1E36, category='lu', description='LATIN CAPITAL LETTER L WITH DOT BELOW', shcode=0x004C, lccode=0x1E37, specials={'char',0x004C,0x0323} },
	[0x1E37] = { unicodeslot=0x1E37, category='ll', description='LATIN SMALL LETTER L WITH DOT BELOW', shcode=0x006C, uccode=0x1E36, specials={'char',0x006C,0x0323} },
	[0x1E38] = { unicodeslot=0x1E38, category='lu', description='LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON', shcode=0x004C, lccode=0x1E39, specials={'char',0x1E36,0x0304} },
	[0x1E39] = { unicodeslot=0x1E39, category='ll', description='LATIN SMALL LETTER L WITH DOT BELOW AND MACRON', shcode=0x006C, uccode=0x1E38, specials={'char',0x1E37,0x0304} },
	[0x1E3A] = { unicodeslot=0x1E3A, category='lu', description='LATIN CAPITAL LETTER L WITH LINE BELOW', shcode=0x004C, lccode=0x1E3B, specials={'char',0x004C,0x0331} },
	[0x1E3B] = { unicodeslot=0x1E3B, category='ll', description='LATIN SMALL LETTER L WITH LINE BELOW', shcode=0x006C, uccode=0x1E3A, specials={'char',0x006C,0x0331} },
	[0x1E3C] = { unicodeslot=0x1E3C, category='lu', description='LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW', shcode=0x004C, lccode=0x1E3D, specials={'char',0x004C,0x032D} },
	[0x1E3D] = { unicodeslot=0x1E3D, category='ll', description='LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW', shcode=0x006C, uccode=0x1E3C, specials={'char',0x006C,0x032D} },
	[0x1E3E] = { unicodeslot=0x1E3E, category='lu', description='LATIN CAPITAL LETTER M WITH ACUTE', shcode=0x004D, lccode=0x1E3F, specials={'char',0x004D,0x0301} },
	[0x1E3F] = { unicodeslot=0x1E3F, category='ll', description='LATIN SMALL LETTER M WITH ACUTE', shcode=0x006D, uccode=0x1E3E, specials={'char',0x006D,0x0301} },
	[0x1E40] = { unicodeslot=0x1E40, category='lu', description='LATIN CAPITAL LETTER M WITH DOT ABOVE', shcode=0x004D, lccode=0x1E41, specials={'char',0x004D,0x0307} },
	[0x1E41] = { unicodeslot=0x1E41, category='ll', description='LATIN SMALL LETTER M WITH DOT ABOVE', shcode=0x006D, uccode=0x1E40, specials={'char',0x006D,0x0307} },
	[0x1E42] = { unicodeslot=0x1E42, category='lu', description='LATIN CAPITAL LETTER M WITH DOT BELOW', shcode=0x004D, lccode=0x1E43, specials={'char',0x004D,0x0323} },
	[0x1E43] = { unicodeslot=0x1E43, category='ll', description='LATIN SMALL LETTER M WITH DOT BELOW', shcode=0x006D, uccode=0x1E42, specials={'char',0x006D,0x0323} },
	[0x1E44] = { unicodeslot=0x1E44, category='lu', description='LATIN CAPITAL LETTER N WITH DOT ABOVE', shcode=0x004E, lccode=0x1E45, specials={'char',0x004E,0x0307} },
	[0x1E45] = { unicodeslot=0x1E45, category='ll', description='LATIN SMALL LETTER N WITH DOT ABOVE', shcode=0x006E, uccode=0x1E44, specials={'char',0x006E,0x0307} },
	[0x1E46] = { unicodeslot=0x1E46, category='lu', description='LATIN CAPITAL LETTER N WITH DOT BELOW', shcode=0x004E, lccode=0x1E47, specials={'char',0x004E,0x0323} },
	[0x1E47] = { unicodeslot=0x1E47, category='ll', description='LATIN SMALL LETTER N WITH DOT BELOW', shcode=0x006E, uccode=0x1E46, specials={'char',0x006E,0x0323} },
	[0x1E48] = { unicodeslot=0x1E48, category='lu', description='LATIN CAPITAL LETTER N WITH LINE BELOW', shcode=0x004E, lccode=0x1E49, specials={'char',0x004E,0x0331} },
	[0x1E49] = { unicodeslot=0x1E49, category='ll', description='LATIN SMALL LETTER N WITH LINE BELOW', shcode=0x006E, uccode=0x1E48, specials={'char',0x006E,0x0331} },
	[0x1E4A] = { unicodeslot=0x1E4A, category='lu', description='LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW', shcode=0x004E, lccode=0x1E4B, specials={'char',0x004E,0x032D} },
	[0x1E4B] = { unicodeslot=0x1E4B, category='ll', description='LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW', shcode=0x006E, uccode=0x1E4A, specials={'char',0x006E,0x032D} },
	[0x1E4C] = { unicodeslot=0x1E4C, category='lu', description='LATIN CAPITAL LETTER O WITH TILDE AND ACUTE', shcode=0x004F, lccode=0x1E4D, specials={'char',0x00D5,0x0301} },
	[0x1E4D] = { unicodeslot=0x1E4D, category='ll', description='LATIN SMALL LETTER O WITH TILDE AND ACUTE', shcode=0x006F, uccode=0x1E4C, specials={'char',0x00F5,0x0301} },
	[0x1E4E] = { unicodeslot=0x1E4E, category='lu', description='LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS', shcode=0x004F, lccode=0x1E4F, specials={'char',0x00D5,0x0308} },
	[0x1E4F] = { unicodeslot=0x1E4F, category='ll', description='LATIN SMALL LETTER O WITH TILDE AND DIAERESIS', shcode=0x006F, uccode=0x1E4E, specials={'char',0x00F5,0x0308} },
	[0x1E50] = { unicodeslot=0x1E50, category='lu', description='LATIN CAPITAL LETTER O WITH MACRON AND GRAVE', shcode=0x004F, lccode=0x1E51, specials={'char',0x014C,0x0300} },
	[0x1E51] = { unicodeslot=0x1E51, category='ll', description='LATIN SMALL LETTER O WITH MACRON AND GRAVE', shcode=0x006F, uccode=0x1E50, specials={'char',0x014D,0x0300} },
	[0x1E52] = { unicodeslot=0x1E52, category='lu', description='LATIN CAPITAL LETTER O WITH MACRON AND ACUTE', shcode=0x004F, lccode=0x1E53, specials={'char',0x014C,0x0301} },
	[0x1E53] = { unicodeslot=0x1E53, category='ll', description='LATIN SMALL LETTER O WITH MACRON AND ACUTE', shcode=0x006F, uccode=0x1E52, specials={'char',0x014D,0x0301} },
	[0x1E54] = { unicodeslot=0x1E54, category='lu', description='LATIN CAPITAL LETTER P WITH ACUTE', shcode=0x0050, lccode=0x1E55, specials={'char',0x0050,0x0301} },
	[0x1E55] = { unicodeslot=0x1E55, category='ll', description='LATIN SMALL LETTER P WITH ACUTE', shcode=0x0070, uccode=0x1E54, specials={'char',0x0070,0x0301} },
	[0x1E56] = { unicodeslot=0x1E56, category='lu', description='LATIN CAPITAL LETTER P WITH DOT ABOVE', shcode=0x0050, lccode=0x1E57, specials={'char',0x0050,0x0307} },
	[0x1E57] = { unicodeslot=0x1E57, category='ll', description='LATIN SMALL LETTER P WITH DOT ABOVE', shcode=0x0070, uccode=0x1E56, specials={'char',0x0070,0x0307} },
	[0x1E58] = { unicodeslot=0x1E58, category='lu', description='LATIN CAPITAL LETTER R WITH DOT ABOVE', shcode=0x0052, lccode=0x1E59, specials={'char',0x0052,0x0307} },
	[0x1E59] = { unicodeslot=0x1E59, category='ll', description='LATIN SMALL LETTER R WITH DOT ABOVE', shcode=0x0072, uccode=0x1E58, specials={'char',0x0072,0x0307} },
	[0x1E5A] = { unicodeslot=0x1E5A, category='lu', description='LATIN CAPITAL LETTER R WITH DOT BELOW', shcode=0x0052, lccode=0x1E5B, specials={'char',0x0052,0x0323} },
	[0x1E5B] = { unicodeslot=0x1E5B, category='ll', description='LATIN SMALL LETTER R WITH DOT BELOW', shcode=0x0072, uccode=0x1E5A, specials={'char',0x0072,0x0323} },
	[0x1E5C] = { unicodeslot=0x1E5C, category='lu', description='LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON', shcode=0x0052, lccode=0x1E5D, specials={'char',0x1E5A,0x0304} },
	[0x1E5D] = { unicodeslot=0x1E5D, category='ll', description='LATIN SMALL LETTER R WITH DOT BELOW AND MACRON', shcode=0x0072, uccode=0x1E5C, specials={'char',0x1E5B,0x0304} },
	[0x1E5E] = { unicodeslot=0x1E5E, category='lu', description='LATIN CAPITAL LETTER R WITH LINE BELOW', shcode=0x0052, lccode=0x1E5F, specials={'char',0x0052,0x0331} },
	[0x1E5F] = { unicodeslot=0x1E5F, category='ll', description='LATIN SMALL LETTER R WITH LINE BELOW', shcode=0x0072, uccode=0x1E5E, specials={'char',0x0072,0x0331} },
	[0x1E60] = { unicodeslot=0x1E60, category='lu', description='LATIN CAPITAL LETTER S WITH DOT ABOVE', shcode=0x0053, lccode=0x1E61, specials={'char',0x0053,0x0307} },
	[0x1E61] = { unicodeslot=0x1E61, category='ll', description='LATIN SMALL LETTER S WITH DOT ABOVE', shcode=0x0073, uccode=0x1E60, specials={'char',0x0073,0x0307} },
	[0x1E62] = { unicodeslot=0x1E62, category='lu', description='LATIN CAPITAL LETTER S WITH DOT BELOW', shcode=0x0053, lccode=0x1E63, specials={'char',0x0053,0x0323} },
	[0x1E63] = { unicodeslot=0x1E63, category='ll', description='LATIN SMALL LETTER S WITH DOT BELOW', shcode=0x0073, uccode=0x1E62, specials={'char',0x0073,0x0323} },
	[0x1E64] = { unicodeslot=0x1E64, category='lu', description='LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE', shcode=0x0053, lccode=0x1E65, specials={'char',0x015A,0x0307} },
	[0x1E65] = { unicodeslot=0x1E65, category='ll', description='LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE', shcode=0x0073, uccode=0x1E64, specials={'char',0x015B,0x0307} },
	[0x1E66] = { unicodeslot=0x1E66, category='lu', description='LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE', shcode=0x0053, lccode=0x1E67, specials={'char',0x0160,0x0307} },
	[0x1E67] = { unicodeslot=0x1E67, category='ll', description='LATIN SMALL LETTER S WITH CARON AND DOT ABOVE', shcode=0x0073, uccode=0x1E66, specials={'char',0x0161,0x0307} },
	[0x1E68] = { unicodeslot=0x1E68, category='lu', description='LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE', shcode=0x0053, lccode=0x1E69, specials={'char',0x1E62,0x0307} },
	[0x1E69] = { unicodeslot=0x1E69, category='ll', description='LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE', shcode=0x0073, uccode=0x1E68, specials={'char',0x1E63,0x0307} },
	[0x1E6A] = { unicodeslot=0x1E6A, category='lu', description='LATIN CAPITAL LETTER T WITH DOT ABOVE', shcode=0x0054, lccode=0x1E6B, specials={'char',0x0054,0x0307} },
	[0x1E6B] = { unicodeslot=0x1E6B, category='ll', description='LATIN SMALL LETTER T WITH DOT ABOVE', shcode=0x0074, uccode=0x1E6A, specials={'char',0x0074,0x0307} },
	[0x1E6C] = { unicodeslot=0x1E6C, category='lu', description='LATIN CAPITAL LETTER T WITH DOT BELOW', shcode=0x0054, lccode=0x1E6D, specials={'char',0x0054,0x0323} },
	[0x1E6D] = { unicodeslot=0x1E6D, category='ll', description='LATIN SMALL LETTER T WITH DOT BELOW', shcode=0x0074, uccode=0x1E6C, specials={'char',0x0074,0x0323} },
	[0x1E6E] = { unicodeslot=0x1E6E, category='lu', description='LATIN CAPITAL LETTER T WITH LINE BELOW', shcode=0x0054, lccode=0x1E6F, specials={'char',0x0054,0x0331} },
	[0x1E6F] = { unicodeslot=0x1E6F, category='ll', description='LATIN SMALL LETTER T WITH LINE BELOW', shcode=0x0074, uccode=0x1E6E, specials={'char',0x0074,0x0331} },
	[0x1E70] = { unicodeslot=0x1E70, category='lu', description='LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW', shcode=0x0054, lccode=0x1E71, specials={'char',0x0054,0x032D} },
	[0x1E71] = { unicodeslot=0x1E71, category='ll', description='LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW', shcode=0x0074, uccode=0x1E70, specials={'char',0x0074,0x032D} },
	[0x1E72] = { unicodeslot=0x1E72, category='lu', description='LATIN CAPITAL LETTER U WITH DIAERESIS BELOW', shcode=0x0055, lccode=0x1E73, specials={'char',0x0055,0x0324} },
	[0x1E73] = { unicodeslot=0x1E73, category='ll', description='LATIN SMALL LETTER U WITH DIAERESIS BELOW', shcode=0x0075, uccode=0x1E72, specials={'char',0x0075,0x0324} },
	[0x1E74] = { unicodeslot=0x1E74, category='lu', description='LATIN CAPITAL LETTER U WITH TILDE BELOW', shcode=0x0055, lccode=0x1E75, specials={'char',0x0055,0x0330} },
	[0x1E75] = { unicodeslot=0x1E75, category='ll', description='LATIN SMALL LETTER U WITH TILDE BELOW', shcode=0x0075, uccode=0x1E74, specials={'char',0x0075,0x0330} },
	[0x1E76] = { unicodeslot=0x1E76, category='lu', description='LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW', shcode=0x0055, lccode=0x1E77, specials={'char',0x0055,0x032D} },
	[0x1E77] = { unicodeslot=0x1E77, category='ll', description='LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW', shcode=0x0075, uccode=0x1E76, specials={'char',0x0075,0x032D} },
	[0x1E78] = { unicodeslot=0x1E78, category='lu', description='LATIN CAPITAL LETTER U WITH TILDE AND ACUTE', shcode=0x0055, lccode=0x1E79, specials={'char',0x0168,0x0301} },
	[0x1E79] = { unicodeslot=0x1E79, category='ll', description='LATIN SMALL LETTER U WITH TILDE AND ACUTE', shcode=0x0075, uccode=0x1E78, specials={'char',0x0169,0x0301} },
	[0x1E7A] = { unicodeslot=0x1E7A, category='lu', description='LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS', shcode=0x0055, lccode=0x1E7B, specials={'char',0x016A,0x0308} },
	[0x1E7B] = { unicodeslot=0x1E7B, category='ll', description='LATIN SMALL LETTER U WITH MACRON AND DIAERESIS', shcode=0x0075, uccode=0x1E7A, specials={'char',0x016B,0x0308} },
	[0x1E7C] = { unicodeslot=0x1E7C, category='lu', description='LATIN CAPITAL LETTER V WITH TILDE', shcode=0x0056, lccode=0x1E7D, specials={'char',0x0056,0x0303} },
	[0x1E7D] = { unicodeslot=0x1E7D, category='ll', description='LATIN SMALL LETTER V WITH TILDE', shcode=0x0076, uccode=0x1E7C, specials={'char',0x0076,0x0303} },
	[0x1E7E] = { unicodeslot=0x1E7E, category='lu', description='LATIN CAPITAL LETTER V WITH DOT BELOW', shcode=0x0056, lccode=0x1E7F, specials={'char',0x0056,0x0323} },
	[0x1E7F] = { unicodeslot=0x1E7F, category='ll', description='LATIN SMALL LETTER V WITH DOT BELOW', shcode=0x0076, uccode=0x1E7E, specials={'char',0x0076,0x0323} },
	[0x1E80] = { unicodeslot=0x1E80, category='lu', adobename='Wgrave', description='LATIN CAPITAL LETTER W WITH GRAVE', shcode=0x0057, lccode=0x1E81, specials={'char',0x0057,0x0300} },
	[0x1E81] = { unicodeslot=0x1E81, category='ll', adobename='wgrave', description='LATIN SMALL LETTER W WITH GRAVE', shcode=0x0077, uccode=0x1E80, specials={'char',0x0077,0x0300} },
	[0x1E82] = { unicodeslot=0x1E82, category='lu', adobename='Wacute', description='LATIN CAPITAL LETTER W WITH ACUTE', shcode=0x0057, lccode=0x1E83, specials={'char',0x0057,0x0301} },
	[0x1E83] = { unicodeslot=0x1E83, category='ll', adobename='wacute', description='LATIN SMALL LETTER W WITH ACUTE', shcode=0x0077, uccode=0x1E82, specials={'char',0x0077,0x0301} },
	[0x1E84] = { unicodeslot=0x1E84, category='lu', adobename='Wdieresis', description='LATIN CAPITAL LETTER W WITH DIAERESIS', shcode=0x0057, lccode=0x1E85, specials={'char',0x0057,0x0308} },
	[0x1E85] = { unicodeslot=0x1E85, category='ll', adobename='wdieresis', description='LATIN SMALL LETTER W WITH DIAERESIS', shcode=0x0077, uccode=0x1E84, specials={'char',0x0077,0x0308} },
	[0x1E86] = { unicodeslot=0x1E86, category='lu', description='LATIN CAPITAL LETTER W WITH DOT ABOVE', shcode=0x0057, lccode=0x1E87, specials={'char',0x0057,0x0307} },
	[0x1E87] = { unicodeslot=0x1E87, category='ll', description='LATIN SMALL LETTER W WITH DOT ABOVE', shcode=0x0077, uccode=0x1E86, specials={'char',0x0077,0x0307} },
	[0x1E88] = { unicodeslot=0x1E88, category='lu', description='LATIN CAPITAL LETTER W WITH DOT BELOW', shcode=0x0057, lccode=0x1E89, specials={'char',0x0057,0x0323} },
	[0x1E89] = { unicodeslot=0x1E89, category='ll', description='LATIN SMALL LETTER W WITH DOT BELOW', shcode=0x0077, uccode=0x1E88, specials={'char',0x0077,0x0323} },
	[0x1E8A] = { unicodeslot=0x1E8A, category='lu', description='LATIN CAPITAL LETTER X WITH DOT ABOVE', shcode=0x0058, lccode=0x1E8B, specials={'char',0x0058,0x0307} },
	[0x1E8B] = { unicodeslot=0x1E8B, category='ll', description='LATIN SMALL LETTER X WITH DOT ABOVE', shcode=0x0078, uccode=0x1E8A, specials={'char',0x0078,0x0307} },
	[0x1E8C] = { unicodeslot=0x1E8C, category='lu', description='LATIN CAPITAL LETTER X WITH DIAERESIS', shcode=0x0058, lccode=0x1E8D, specials={'char',0x0058,0x0308} },
	[0x1E8D] = { unicodeslot=0x1E8D, category='ll', description='LATIN SMALL LETTER X WITH DIAERESIS', shcode=0x0078, uccode=0x1E8C, specials={'char',0x0078,0x0308} },
	[0x1E8E] = { unicodeslot=0x1E8E, category='lu', description='LATIN CAPITAL LETTER Y WITH DOT ABOVE', shcode=0x0059, lccode=0x1E8F, specials={'char',0x0059,0x0307} },
	[0x1E8F] = { unicodeslot=0x1E8F, category='ll', description='LATIN SMALL LETTER Y WITH DOT ABOVE', shcode=0x0079, uccode=0x1E8E, specials={'char',0x0079,0x0307} },
	[0x1E90] = { unicodeslot=0x1E90, category='lu', description='LATIN CAPITAL LETTER Z WITH CIRCUMFLEX', shcode=0x005A, lccode=0x1E91, specials={'char',0x005A,0x0302} },
	[0x1E91] = { unicodeslot=0x1E91, category='ll', description='LATIN SMALL LETTER Z WITH CIRCUMFLEX', shcode=0x007A, uccode=0x1E90, specials={'char',0x007A,0x0302} },
	[0x1E92] = { unicodeslot=0x1E92, category='lu', description='LATIN CAPITAL LETTER Z WITH DOT BELOW', shcode=0x005A, lccode=0x1E93, specials={'char',0x005A,0x0323} },
	[0x1E93] = { unicodeslot=0x1E93, category='ll', description='LATIN SMALL LETTER Z WITH DOT BELOW', shcode=0x007A, uccode=0x1E92, specials={'char',0x007A,0x0323} },
	[0x1E94] = { unicodeslot=0x1E94, category='lu', description='LATIN CAPITAL LETTER Z WITH LINE BELOW', shcode=0x005A, lccode=0x1E95, specials={'char',0x005A,0x0331} },
	[0x1E95] = { unicodeslot=0x1E95, category='ll', description='LATIN SMALL LETTER Z WITH LINE BELOW', shcode=0x007A, uccode=0x1E94, specials={'char',0x007A,0x0331} },
	[0x1E96] = { unicodeslot=0x1E96, category='ll', description='LATIN SMALL LETTER H WITH LINE BELOW', shcode=0x0068, specials={'char',0x0068,0x0331} },
	[0x1E97] = { unicodeslot=0x1E97, category='ll', description='LATIN SMALL LETTER T WITH DIAERESIS', shcode=0x0074, specials={'char',0x0074,0x0308} },
	[0x1E98] = { unicodeslot=0x1E98, category='ll', description='LATIN SMALL LETTER W WITH RING ABOVE', shcode=0x0077, specials={'char',0x0077,0x030A} },
	[0x1E99] = { unicodeslot=0x1E99, category='ll', description='LATIN SMALL LETTER Y WITH RING ABOVE', shcode=0x0079, specials={'char',0x0079,0x030A} },
	[0x1E9A] = { unicodeslot=0x1E9A, category='ll', description='LATIN SMALL LETTER A WITH RIGHT HALF RING', shcode=0x0061, specials={'compat',0x0061,0x02BE} },
	[0x1E9B] = { unicodeslot=0x1E9B, category='ll', description='LATIN SMALL LETTER LONG S WITH DOT ABOVE', uccode=0x1E60, specials={'char',0x017F,0x0307} },
	[0x1EA0] = { unicodeslot=0x1EA0, category='lu', contextname='Adotbelow', description='LATIN CAPITAL LETTER A WITH DOT BELOW', shcode=0x0041, lccode=0x1EA1, specials={'char',0x0041,0x0323} },
	[0x1EA1] = { unicodeslot=0x1EA1, category='ll', contextname='adotbelow', description='LATIN SMALL LETTER A WITH DOT BELOW', shcode=0x0061, uccode=0x1EA0, specials={'char',0x0061,0x0323} },
	[0x1EA2] = { unicodeslot=0x1EA2, category='lu', contextname='Ahook', description='LATIN CAPITAL LETTER A WITH HOOK ABOVE', shcode=0x0041, lccode=0x1EA3, specials={'char',0x0041,0x0309} },
	[0x1EA3] = { unicodeslot=0x1EA3, category='ll', contextname='ahook', description='LATIN SMALL LETTER A WITH HOOK ABOVE', shcode=0x0061, uccode=0x1EA2, specials={'char',0x0061,0x0309} },
	[0x1EA4] = { unicodeslot=0x1EA4, category='lu', contextname='Acircumflexacute', description='LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE', shcode=0x0041, lccode=0x1EA5, specials={'char',0x00C2,0x0301} },
	[0x1EA5] = { unicodeslot=0x1EA5, category='ll', contextname='acircumflexacute', description='LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE', shcode=0x0061, uccode=0x1EA4, specials={'char',0x00E2,0x0301} },
	[0x1EA6] = { unicodeslot=0x1EA6, category='lu', contextname='Acircumflexgrave', description='LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE', shcode=0x0041, lccode=0x1EA7, specials={'char',0x00C2,0x0300} },
	[0x1EA7] = { unicodeslot=0x1EA7, category='ll', contextname='acircumflexgrave', description='LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE', shcode=0x0061, uccode=0x1EA6, specials={'char',0x00E2,0x0300} },
	[0x1EA8] = { unicodeslot=0x1EA8, category='lu', contextname='Acircumflexhook', description='LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE', shcode=0x0041, lccode=0x1EA9, specials={'char',0x00C2,0x0309} },
	[0x1EA9] = { unicodeslot=0x1EA9, category='ll', contextname='acircumflexhook', description='LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE', shcode=0x0061, uccode=0x1EA8, specials={'char',0x00E2,0x0309} },
	[0x1EAA] = { unicodeslot=0x1EAA, category='lu', contextname='Acircumflextilde', description='LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE', shcode=0x0041, lccode=0x1EAB, specials={'char',0x00C2,0x0303} },
	[0x1EAB] = { unicodeslot=0x1EAB, category='ll', contextname='acircumflextilde', description='LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE', shcode=0x0061, uccode=0x1EAA, specials={'char',0x00E2,0x0303} },
	[0x1EAC] = { unicodeslot=0x1EAC, category='lu', contextname='Acircumflexdotbelow', description='LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW', shcode=0x0041, lccode=0x1EAD, specials={'char',0x1EA0,0x0302} },
	[0x1EAD] = { unicodeslot=0x1EAD, category='ll', contextname='acircumflexdotbelow', description='LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW', shcode=0x0061, uccode=0x1EAC, specials={'char',0x1EA1,0x0302} },
	[0x1EAE] = { unicodeslot=0x1EAE, category='lu', contextname='Abreveacute', description='LATIN CAPITAL LETTER A WITH BREVE AND ACUTE', shcode=0x0041, lccode=0x1EAF, specials={'char',0x0102,0x0301} },
	[0x1EAF] = { unicodeslot=0x1EAF, category='ll', contextname='abreveacute', description='LATIN SMALL LETTER A WITH BREVE AND ACUTE', shcode=0x0061, uccode=0x1EAE, specials={'char',0x0103,0x0301} },
	[0x1EB0] = { unicodeslot=0x1EB0, category='lu', contextname='Abrevegrave', description='LATIN CAPITAL LETTER A WITH BREVE AND GRAVE', shcode=0x0041, lccode=0x1EB1, specials={'char',0x0102,0x0300} },
	[0x1EB1] = { unicodeslot=0x1EB1, category='ll', contextname='abrevegrave', description='LATIN SMALL LETTER A WITH BREVE AND GRAVE', shcode=0x0061, uccode=0x1EB0, specials={'char',0x0103,0x0300} },
	[0x1EB2] = { unicodeslot=0x1EB2, category='lu', contextname='Abrevehook', description='LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE', shcode=0x0041, lccode=0x1EB3, specials={'char',0x0102,0x0309} },
	[0x1EB3] = { unicodeslot=0x1EB3, category='ll', contextname='abrevehook', description='LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE', shcode=0x0061, uccode=0x1EB2, specials={'char',0x0103,0x0309} },
	[0x1EB4] = { unicodeslot=0x1EB4, category='lu', contextname='Abrevetilde', description='LATIN CAPITAL LETTER A WITH BREVE AND TILDE', shcode=0x0041, lccode=0x1EB5, specials={'char',0x0102,0x0303} },
	[0x1EB5] = { unicodeslot=0x1EB5, category='ll', contextname='abrevetilde', description='LATIN SMALL LETTER A WITH BREVE AND TILDE', shcode=0x0061, uccode=0x1EB4, specials={'char',0x0103,0x0303} },
	[0x1EB6] = { unicodeslot=0x1EB6, category='lu', contextname='Abrevedotbelow', description='LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW', shcode=0x0041, lccode=0x1EB7, specials={'char',0x1EA0,0x0306} },
	[0x1EB7] = { unicodeslot=0x1EB7, category='ll', contextname='abrevedotbelow', description='LATIN SMALL LETTER A WITH BREVE AND DOT BELOW', shcode=0x0061, uccode=0x1EB6, specials={'char',0x1EA1,0x0306} },
	[0x1EB8] = { unicodeslot=0x1EB8, category='lu', contextname='Edotbelow', description='LATIN CAPITAL LETTER E WITH DOT BELOW', shcode=0x0045, lccode=0x1EB9, specials={'char',0x0045,0x0323} },
	[0x1EB9] = { unicodeslot=0x1EB9, category='ll', contextname='edotbelow', description='LATIN SMALL LETTER E WITH DOT BELOW', shcode=0x0065, uccode=0x1EB8, specials={'char',0x0065,0x0323} },
	[0x1EBA] = { unicodeslot=0x1EBA, category='lu', contextname='Ehook', description='LATIN CAPITAL LETTER E WITH HOOK ABOVE', shcode=0x0045, lccode=0x1EBB, specials={'char',0x0045,0x0309} },
	[0x1EBB] = { unicodeslot=0x1EBB, category='ll', contextname='ehook', description='LATIN SMALL LETTER E WITH HOOK ABOVE', shcode=0x0065, uccode=0x1EBA, specials={'char',0x0065,0x0309} },
	[0x1EBC] = { unicodeslot=0x1EBC, category='lu', contextname='Etilde', description='LATIN CAPITAL LETTER E WITH TILDE', shcode=0x0045, lccode=0x1EBD, specials={'char',0x0045,0x0303} },
	[0x1EBD] = { unicodeslot=0x1EBD, category='ll', contextname='etilde', description='LATIN SMALL LETTER E WITH TILDE', shcode=0x0065, uccode=0x1EBC, specials={'char',0x0065,0x0303} },
	[0x1EBE] = { unicodeslot=0x1EBE, category='lu', contextname='Ecircumflexacute', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE', shcode=0x0045, lccode=0x1EBF, specials={'char',0x00CA,0x0301} },
	[0x1EBF] = { unicodeslot=0x1EBF, category='ll', contextname='ecircumflexacute', description='LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE', shcode=0x0065, uccode=0x1EBE, specials={'char',0x00EA,0x0301} },
	[0x1EC0] = { unicodeslot=0x1EC0, category='lu', contextname='Ecircumflexgrave', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE', shcode=0x0045, lccode=0x1EC1, specials={'char',0x00CA,0x0300} },
	[0x1EC1] = { unicodeslot=0x1EC1, category='ll', contextname='ecircumflexgrave', description='LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE', shcode=0x0065, uccode=0x1EC0, specials={'char',0x00EA,0x0300} },
	[0x1EC2] = { unicodeslot=0x1EC2, category='lu', contextname='Ecircumflexhook', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE', shcode=0x0045, lccode=0x1EC3, specials={'char',0x00CA,0x0309} },
	[0x1EC3] = { unicodeslot=0x1EC3, category='ll', contextname='ecircumflexhook', description='LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE', shcode=0x0065, uccode=0x1EC2, specials={'char',0x00EA,0x0309} },
	[0x1EC4] = { unicodeslot=0x1EC4, category='lu', contextname='Ecircumflextilde', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE', shcode=0x0045, lccode=0x1EC5, specials={'char',0x00CA,0x0303} },
	[0x1EC5] = { unicodeslot=0x1EC5, category='ll', contextname='ecircumflextilde', description='LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE', shcode=0x0065, uccode=0x1EC4, specials={'char',0x00EA,0x0303} },
	[0x1EC6] = { unicodeslot=0x1EC6, category='lu', contextname='Ecircumflexdotbelow', description='LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW', shcode=0x0045, lccode=0x1EC7, specials={'char',0x1EB8,0x0302} },
	[0x1EC7] = { unicodeslot=0x1EC7, category='ll', contextname='ecircumflexdotbelow', description='LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW', shcode=0x0065, uccode=0x1EC6, specials={'char',0x1EB9,0x0302} },
	[0x1EC8] = { unicodeslot=0x1EC8, category='lu', contextname='Ihook', description='LATIN CAPITAL LETTER I WITH HOOK ABOVE', shcode=0x0049, lccode=0x1EC9, specials={'char',0x0049,0x0309} },
	[0x1EC9] = { unicodeslot=0x1EC9, category='ll', contextname='ihook', description='LATIN SMALL LETTER I WITH HOOK ABOVE', shcode=0x0069, uccode=0x1EC8, specials={'char',0x0069,0x0309} },
	[0x1ECA] = { unicodeslot=0x1ECA, category='lu', contextname='Idotbelow', description='LATIN CAPITAL LETTER I WITH DOT BELOW', shcode=0x0049, lccode=0x1ECB, specials={'char',0x0049,0x0323} },
	[0x1ECB] = { unicodeslot=0x1ECB, category='ll', contextname='idotbelow', description='LATIN SMALL LETTER I WITH DOT BELOW', shcode=0x0069, uccode=0x1ECA, specials={'char',0x0069,0x0323} },
	[0x1ECC] = { unicodeslot=0x1ECC, category='lu', contextname='Odotbelow', description='LATIN CAPITAL LETTER O WITH DOT BELOW', shcode=0x004F, lccode=0x1ECD, specials={'char',0x004F,0x0323} },
	[0x1ECD] = { unicodeslot=0x1ECD, category='ll', contextname='odotbelow', description='LATIN SMALL LETTER O WITH DOT BELOW', shcode=0x006F, uccode=0x1ECC, specials={'char',0x006F,0x0323} },
	[0x1ECE] = { unicodeslot=0x1ECE, category='lu', contextname='Ohook', description='LATIN CAPITAL LETTER O WITH HOOK ABOVE', shcode=0x004F, lccode=0x1ECF, specials={'char',0x004F,0x0309} },
	[0x1ECF] = { unicodeslot=0x1ECF, category='ll', contextname='ohook', description='LATIN SMALL LETTER O WITH HOOK ABOVE', shcode=0x006F, uccode=0x1ECE, specials={'char',0x006F,0x0309} },
	[0x1ED0] = { unicodeslot=0x1ED0, category='lu', contextname='Ocircumflexacute', description='LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE', shcode=0x004F, lccode=0x1ED1, specials={'char',0x00D4,0x0301} },
	[0x1ED1] = { unicodeslot=0x1ED1, category='ll', contextname='ocircumflexacute', description='LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE', shcode=0x006F, uccode=0x1ED0, specials={'char',0x00F4,0x0301} },
	[0x1ED2] = { unicodeslot=0x1ED2, category='lu', contextname='Ocircumflexgrave', description='LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE', shcode=0x004F, lccode=0x1ED3, specials={'char',0x00D4,0x0300} },
	[0x1ED3] = { unicodeslot=0x1ED3, category='ll', contextname='ocircumflexgrave', description='LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE', shcode=0x006F, uccode=0x1ED2, specials={'char',0x00F4,0x0300} },
	[0x1ED4] = { unicodeslot=0x1ED4, category='lu', contextname='Ocircumflexhook', description='LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE', shcode=0x004F, lccode=0x1ED5, specials={'char',0x00D4,0x0309} },
	[0x1ED5] = { unicodeslot=0x1ED5, category='ll', contextname='ocircumflexhook', description='LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE', shcode=0x006F, uccode=0x1ED4, specials={'char',0x00F4,0x0309} },
	[0x1ED6] = { unicodeslot=0x1ED6, category='lu', contextname='Ocircumflextilde', description='LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE', shcode=0x004F, lccode=0x1ED7, specials={'char',0x00D4,0x0303} },
	[0x1ED7] = { unicodeslot=0x1ED7, category='ll', contextname='ocircumflextilde', description='LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE', shcode=0x006F, uccode=0x1ED6, specials={'char',0x00F4,0x0303} },
	[0x1ED8] = { unicodeslot=0x1ED8, category='lu', contextname='Ocircumflexdotbelow', description='LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW', shcode=0x004F, lccode=0x1ED9, specials={'char',0x1ECC,0x0302} },
	[0x1ED9] = { unicodeslot=0x1ED9, category='ll', contextname='ocircumflexdotbelow', description='LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW', shcode=0x006F, uccode=0x1ED8, specials={'char',0x1ECD,0x0302} },
	[0x1EDA] = { unicodeslot=0x1EDA, category='lu', contextname='Ohornacute', description='LATIN CAPITAL LETTER O WITH HORN AND ACUTE', shcode=0x004F, lccode=0x1EDB, specials={'char',0x01A0,0x0301} },
	[0x1EDB] = { unicodeslot=0x1EDB, category='ll', contextname='ohornacute', description='LATIN SMALL LETTER O WITH HORN AND ACUTE', shcode=0x006F, uccode=0x1EDA, specials={'char',0x01A1,0x0301} },
	[0x1EDC] = { unicodeslot=0x1EDC, category='lu', contextname='Ohorngrave', description='LATIN CAPITAL LETTER O WITH HORN AND GRAVE', shcode=0x004F, lccode=0x1EDD, specials={'char',0x01A0,0x0300} },
	[0x1EDD] = { unicodeslot=0x1EDD, category='ll', contextname='ohorngrave', description='LATIN SMALL LETTER O WITH HORN AND GRAVE', shcode=0x006F, uccode=0x1EDC, specials={'char',0x01A1,0x0300} },
	[0x1EDE] = { unicodeslot=0x1EDE, category='lu', contextname='Ohornhook', description='LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE', shcode=0x004F, lccode=0x1EDF, specials={'char',0x01A0,0x0309} },
	[0x1EDF] = { unicodeslot=0x1EDF, category='ll', contextname='ohornhook', description='LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE', shcode=0x006F, uccode=0x1EDE, specials={'char',0x01A1,0x0309} },
	[0x1EE0] = { unicodeslot=0x1EE0, category='lu', contextname='Ohorntilde', description='LATIN CAPITAL LETTER O WITH HORN AND TILDE', shcode=0x004F, lccode=0x1EE1, specials={'char',0x01A0,0x0303} },
	[0x1EE1] = { unicodeslot=0x1EE1, category='ll', contextname='ohorntilde', description='LATIN SMALL LETTER O WITH HORN AND TILDE', shcode=0x006F, uccode=0x1EE0, specials={'char',0x01A1,0x0303} },
	[0x1EE2] = { unicodeslot=0x1EE2, category='lu', contextname='Ohorndotbelow', description='LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW', shcode=0x004F, lccode=0x1EE3, specials={'char',0x01A0,0x0323} },
	[0x1EE3] = { unicodeslot=0x1EE3, category='ll', contextname='ohorndotbelow', description='LATIN SMALL LETTER O WITH HORN AND DOT BELOW', shcode=0x006F, uccode=0x1EE2, specials={'char',0x01A1,0x0323} },
	[0x1EE4] = { unicodeslot=0x1EE4, category='lu', contextname='Udotbelow', description='LATIN CAPITAL LETTER U WITH DOT BELOW', shcode=0x0055, lccode=0x1EE5, specials={'char',0x0055,0x0323} },
	[0x1EE5] = { unicodeslot=0x1EE5, category='ll', contextname='udotbelow', description='LATIN SMALL LETTER U WITH DOT BELOW', shcode=0x0075, uccode=0x1EE4, specials={'char',0x0075,0x0323} },
	[0x1EE6] = { unicodeslot=0x1EE6, category='lu', contextname='Uhook', description='LATIN CAPITAL LETTER U WITH HOOK ABOVE', shcode=0x0055, lccode=0x1EE7, specials={'char',0x0055,0x0309} },
	[0x1EE7] = { unicodeslot=0x1EE7, category='ll', contextname='uhook', description='LATIN SMALL LETTER U WITH HOOK ABOVE', shcode=0x0075, uccode=0x1EE6, specials={'char',0x0075,0x0309} },
	[0x1EE8] = { unicodeslot=0x1EE8, category='lu', contextname='Uhornacute', description='LATIN CAPITAL LETTER U WITH HORN AND ACUTE', shcode=0x0055, lccode=0x1EE9, specials={'char',0x01AF,0x0301} },
	[0x1EE9] = { unicodeslot=0x1EE9, category='ll', contextname='uhornacute', description='LATIN SMALL LETTER U WITH HORN AND ACUTE', shcode=0x0075, uccode=0x1EE8, specials={'char',0x01B0,0x0301} },
	[0x1EEA] = { unicodeslot=0x1EEA, category='lu', contextname='Uhorngrave', description='LATIN CAPITAL LETTER U WITH HORN AND GRAVE', shcode=0x0055, lccode=0x1EEB, specials={'char',0x01AF,0x0300} },
	[0x1EEB] = { unicodeslot=0x1EEB, category='ll', contextname='uhorngrave', description='LATIN SMALL LETTER U WITH HORN AND GRAVE', shcode=0x0075, uccode=0x1EEA, specials={'char',0x01B0,0x0300} },
	[0x1EEC] = { unicodeslot=0x1EEC, category='lu', contextname='Uhornhook', description='LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE', shcode=0x0055, lccode=0x1EED, specials={'char',0x01AF,0x0309} },
	[0x1EED] = { unicodeslot=0x1EED, category='ll', contextname='uhornhook', description='LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE', shcode=0x0075, uccode=0x1EEC, specials={'char',0x01B0,0x0309} },
	[0x1EEE] = { unicodeslot=0x1EEE, category='lu', contextname='Uhorntilde', description='LATIN CAPITAL LETTER U WITH HORN AND TILDE', shcode=0x0055, lccode=0x1EEF, specials={'char',0x01AF,0x0303} },
	[0x1EEF] = { unicodeslot=0x1EEF, category='ll', contextname='uhorntilde', description='LATIN SMALL LETTER U WITH HORN AND TILDE', shcode=0x0075, uccode=0x1EEE, specials={'char',0x01B0,0x0303} },
	[0x1EF0] = { unicodeslot=0x1EF0, category='lu', contextname='Uhorndotbelow', description='LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW', shcode=0x0055, lccode=0x1EF1, specials={'char',0x01AF,0x0323} },
	[0x1EF1] = { unicodeslot=0x1EF1, category='ll', contextname='uhorndotbelow', description='LATIN SMALL LETTER U WITH HORN AND DOT BELOW', shcode=0x0075, uccode=0x1EF0, specials={'char',0x01B0,0x0323} },
	[0x1EF2] = { unicodeslot=0x1EF2, category='lu', adobename='Ygrave', contextname='Ygrave', description='LATIN CAPITAL LETTER Y WITH GRAVE', shcode=0x0059, lccode=0x1EF3, specials={'char',0x0059,0x0300} },
	[0x1EF3] = { unicodeslot=0x1EF3, category='ll', adobename='ygrave', contextname='ygrave', description='LATIN SMALL LETTER Y WITH GRAVE', shcode=0x0079, uccode=0x1EF2, specials={'char',0x0079,0x0300} },
	[0x1EF4] = { unicodeslot=0x1EF4, category='lu', contextname='Ydotbelow', description='LATIN CAPITAL LETTER Y WITH DOT BELOW', shcode=0x0059, lccode=0x1EF5, specials={'char',0x0059,0x0323} },
	[0x1EF5] = { unicodeslot=0x1EF5, category='ll', contextname='ydotbelow', description='LATIN SMALL LETTER Y WITH DOT BELOW', shcode=0x0079, uccode=0x1EF4, specials={'char',0x0079,0x0323} },
	[0x1EF6] = { unicodeslot=0x1EF6, category='lu', contextname='Yhook', description='LATIN CAPITAL LETTER Y WITH HOOK ABOVE', shcode=0x0059, lccode=0x1EF7, specials={'char',0x0059,0x0309} },
	[0x1EF7] = { unicodeslot=0x1EF7, category='ll', contextname='yhook', description='LATIN SMALL LETTER Y WITH HOOK ABOVE', shcode=0x0079, uccode=0x1EF6, specials={'char',0x0079,0x0309} },
	[0x1EF8] = { unicodeslot=0x1EF8, category='lu', contextname='Ytilde', description='LATIN CAPITAL LETTER Y WITH TILDE', shcode=0x0059, lccode=0x1EF9, specials={'char',0x0059,0x0303} },
	[0x1EF9] = { unicodeslot=0x1EF9, category='ll', contextname='ytilde', description='LATIN SMALL LETTER Y WITH TILDE', shcode=0x0079, uccode=0x1EF8, specials={'char',0x0079,0x0303} },
	[0x1F00] = { unicodeslot=0x1F00, category='ll', contextname='greekalphapsili', description='GREEK SMALL LETTER ALPHA WITH PSILI', shcode=0x03B1, uccode=0x1F08, specials={'char',0x03B1,0x0313} },
	[0x1F01] = { unicodeslot=0x1F01, category='ll', contextname='greekalphadasia', description='GREEK SMALL LETTER ALPHA WITH DASIA', shcode=0x03B1, uccode=0x1F09, specials={'char',0x03B1,0x0314} },
	[0x1F02] = { unicodeslot=0x1F02, category='ll', contextname='greekalphapsilivaria', description='GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA', shcode=0x03B1, uccode=0x1F0A, specials={'char',0x1F00,0x0300} },
	[0x1F03] = { unicodeslot=0x1F03, category='ll', contextname='greekalphadasiavaria', description='GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA', shcode=0x03B1, uccode=0x1F0B, specials={'char',0x1F01,0x0300} },
	[0x1F04] = { unicodeslot=0x1F04, category='ll', contextname='greekalphapsilitonos', description='GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA', shcode=0x03B1, uccode=0x1F0C, specials={'char',0x1F00,0x0301} },
	[0x1F05] = { unicodeslot=0x1F05, category='ll', contextname='greekalphadasiatonos', description='GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA', shcode=0x03B1, uccode=0x1F0D, specials={'char',0x1F01,0x0301} },
	[0x1F06] = { unicodeslot=0x1F06, category='ll', contextname='greekalphapsiliperispomeni', description='GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI', shcode=0x03B1, uccode=0x1F0E, specials={'char',0x1F00,0x0342} },
	[0x1F07] = { unicodeslot=0x1F07, category='ll', contextname='greekalphadasiaperispomeni', description='GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI', shcode=0x03B1, uccode=0x1F0F, specials={'char',0x1F01,0x0342} },
	[0x1F08] = { unicodeslot=0x1F08, category='lu', contextname='greekAlphapsili', description='GREEK CAPITAL LETTER ALPHA WITH PSILI', shcode=0x0391, lccode=0x1F00, specials={'char',0x0391,0x0313} },
	[0x1F09] = { unicodeslot=0x1F09, category='lu', contextname='greekAlphadasia', description='GREEK CAPITAL LETTER ALPHA WITH DASIA', shcode=0x0391, lccode=0x1F01, specials={'char',0x0391,0x0314} },
	[0x1F0A] = { unicodeslot=0x1F0A, category='lu', contextname='greekAlphapsilivaria', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA', shcode=0x0391, lccode=0x1F02, specials={'char',0x1F08,0x0300} },
	[0x1F0B] = { unicodeslot=0x1F0B, category='lu', contextname='greekAlphadasiavaria', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA', shcode=0x0391, lccode=0x1F03, specials={'char',0x1F09,0x0300} },
	[0x1F0C] = { unicodeslot=0x1F0C, category='lu', contextname='greekAlphapsilitonos', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA', shcode=0x0391, lccode=0x1F04, specials={'char',0x1F08,0x0301} },
	[0x1F0D] = { unicodeslot=0x1F0D, category='lu', contextname='greekAlphadasiatonos', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA', shcode=0x0391, lccode=0x1F05, specials={'char',0x1F09,0x0301} },
	[0x1F0E] = { unicodeslot=0x1F0E, category='lu', contextname='greekAlphapsiliperispomeni', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI', shcode=0x0391, lccode=0x1F06, specials={'char',0x1F08,0x0342} },
	[0x1F0F] = { unicodeslot=0x1F0F, category='lu', contextname='greekAlphadasiaperispomeni', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI', shcode=0x0391, lccode=0x1F07, specials={'char',0x1F09,0x0342} },
	[0x1F10] = { unicodeslot=0x1F10, category='ll', contextname='greekepsilonpsili', description='GREEK SMALL LETTER EPSILON WITH PSILI', shcode=0x03B5, uccode=0x1F18, specials={'char',0x03B5,0x0313} },
	[0x1F11] = { unicodeslot=0x1F11, category='ll', contextname='greekepsilondasia', description='GREEK SMALL LETTER EPSILON WITH DASIA', shcode=0x03B5, uccode=0x1F19, specials={'char',0x03B5,0x0314} },
	[0x1F12] = { unicodeslot=0x1F12, category='ll', contextname='greekepsilonpsilivaria', description='GREEK SMALL LETTER EPSILON WITH PSILI AND VARIA', shcode=0x03B5, uccode=0x1F1A, specials={'char',0x1F10,0x0300} },
	[0x1F13] = { unicodeslot=0x1F13, category='ll', contextname='greekepsilondasiavaria', description='GREEK SMALL LETTER EPSILON WITH DASIA AND VARIA', shcode=0x03B5, uccode=0x1F1B, specials={'char',0x1F11,0x0300} },
	[0x1F14] = { unicodeslot=0x1F14, category='ll', contextname='greekepsilonpsilitonos', description='GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA', shcode=0x03B5, uccode=0x1F1C, specials={'char',0x1F10,0x0301} },
	[0x1F15] = { unicodeslot=0x1F15, category='ll', contextname='greekepsilondasiatonos', description='GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA', shcode=0x03B5, uccode=0x1F1D, specials={'char',0x1F11,0x0301} },
	[0x1F18] = { unicodeslot=0x1F18, category='lu', contextname='greekEpsilonpsili', description='GREEK CAPITAL LETTER EPSILON WITH PSILI', shcode=0x0395, lccode=0x1F10, specials={'char',0x0395,0x0313} },
	[0x1F19] = { unicodeslot=0x1F19, category='lu', contextname='greekEpsilondasia', description='GREEK CAPITAL LETTER EPSILON WITH DASIA', shcode=0x0395, lccode=0x1F11, specials={'char',0x0395,0x0314} },
	[0x1F1A] = { unicodeslot=0x1F1A, category='lu', contextname='greekEpsilonpsilivaria', description='GREEK CAPITAL LETTER EPSILON WITH PSILI AND VARIA', shcode=0x0395, lccode=0x1F12, specials={'char',0x1F18,0x0300} },
	[0x1F1B] = { unicodeslot=0x1F1B, category='lu', contextname='greekEpsilondasiavaria', description='GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA', shcode=0x0395, lccode=0x1F13, specials={'char',0x1F19,0x0300} },
	[0x1F1C] = { unicodeslot=0x1F1C, category='lu', contextname='greekEpsilonpsilitonos', description='GREEK CAPITAL LETTER EPSILON WITH PSILI AND OXIA', shcode=0x0395, lccode=0x1F14, specials={'char',0x1F18,0x0301} },
	[0x1F1D] = { unicodeslot=0x1F1D, category='lu', contextname='greekEpsilondasiatonos', description='GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA', shcode=0x0395, lccode=0x1F15, specials={'char',0x1F19,0x0301} },
	[0x1F20] = { unicodeslot=0x1F20, category='ll', contextname='greeketapsili', description='GREEK SMALL LETTER ETA WITH PSILI', shcode=0x03B7, uccode=0x1F28, specials={'char',0x03B7,0x0313} },
	[0x1F21] = { unicodeslot=0x1F21, category='ll', contextname='greeketadasia', description='GREEK SMALL LETTER ETA WITH DASIA', shcode=0x03B7, uccode=0x1F29, specials={'char',0x03B7,0x0314} },
	[0x1F22] = { unicodeslot=0x1F22, category='ll', contextname='greeketapsilivaria', description='GREEK SMALL LETTER ETA WITH PSILI AND VARIA', shcode=0x03B7, uccode=0x1F2A, specials={'char',0x1F20,0x0300} },
	[0x1F23] = { unicodeslot=0x1F23, category='ll', contextname='greeketadasiavaria', description='GREEK SMALL LETTER ETA WITH DASIA AND VARIA', shcode=0x03B7, uccode=0x1F2B, specials={'char',0x1F21,0x0300} },
	[0x1F24] = { unicodeslot=0x1F24, category='ll', contextname='greeketapsilitonos', description='GREEK SMALL LETTER ETA WITH PSILI AND OXIA', shcode=0x03B7, uccode=0x1F2C, specials={'char',0x1F20,0x0301} },
	[0x1F25] = { unicodeslot=0x1F25, category='ll', contextname='greeketadasiatonos', description='GREEK SMALL LETTER ETA WITH DASIA AND OXIA', shcode=0x03B7, uccode=0x1F2D, specials={'char',0x1F21,0x0301} },
	[0x1F26] = { unicodeslot=0x1F26, category='ll', contextname='greeketapsiliperispomeni', description='GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI', shcode=0x03B7, uccode=0x1F2E, specials={'char',0x1F20,0x0342} },
	[0x1F27] = { unicodeslot=0x1F27, category='ll', contextname='greeketadasiaperispomeni', description='GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI', shcode=0x03B7, uccode=0x1F2F, specials={'char',0x1F21,0x0342} },
	[0x1F28] = { unicodeslot=0x1F28, category='lu', contextname='greekEtapsili', description='GREEK CAPITAL LETTER ETA WITH PSILI', shcode=0x0397, lccode=0x1F20, specials={'char',0x0397,0x0313} },
	[0x1F29] = { unicodeslot=0x1F29, category='lu', contextname='greekEtadasia', description='GREEK CAPITAL LETTER ETA WITH DASIA', shcode=0x0397, lccode=0x1F21, specials={'char',0x0397,0x0314} },
	[0x1F2A] = { unicodeslot=0x1F2A, category='lu', contextname='greekEtapsilivaria', description='GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA', shcode=0x0397, lccode=0x1F22, specials={'char',0x1F28,0x0300} },
	[0x1F2B] = { unicodeslot=0x1F2B, category='lu', contextname='greekEtadasiavaria', description='GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA', shcode=0x0397, lccode=0x1F23, specials={'char',0x1F29,0x0300} },
	[0x1F2C] = { unicodeslot=0x1F2C, category='lu', contextname='greekEtapsilitonos', description='GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA', shcode=0x0397, lccode=0x1F24, specials={'char',0x1F28,0x0301} },
	[0x1F2D] = { unicodeslot=0x1F2D, category='lu', contextname='greekEtadasiatonos', description='GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA', shcode=0x0397, lccode=0x1F25, specials={'char',0x1F29,0x0301} },
	[0x1F2E] = { unicodeslot=0x1F2E, category='lu', contextname='greekEtapsiliperispomeni', description='GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI', shcode=0x0397, lccode=0x1F26, specials={'char',0x1F28,0x0342} },
	[0x1F2F] = { unicodeslot=0x1F2F, category='lu', contextname='greekEtadasiaperispomeni', description='GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI', shcode=0x0397, lccode=0x1F27, specials={'char',0x1F29,0x0342} },
	[0x1F30] = { unicodeslot=0x1F30, category='ll', contextname='greekiotapsili', description='GREEK SMALL LETTER IOTA WITH PSILI', shcode=0x03B9, uccode=0x1F38, specials={'char',0x03B9,0x0313} },
	[0x1F31] = { unicodeslot=0x1F31, category='ll', contextname='greekiotadasia', description='GREEK SMALL LETTER IOTA WITH DASIA', shcode=0x03B9, uccode=0x1F39, specials={'char',0x03B9,0x0314} },
	[0x1F32] = { unicodeslot=0x1F32, category='ll', contextname='greekiotapsilivaria', description='GREEK SMALL LETTER IOTA WITH PSILI AND VARIA', shcode=0x03B9, uccode=0x1F3A, specials={'char',0x1F30,0x0300} },
	[0x1F33] = { unicodeslot=0x1F33, category='ll', contextname='greekiotadasiavaria', description='GREEK SMALL LETTER IOTA WITH DASIA AND VARIA', shcode=0x03B9, uccode=0x1F3B, specials={'char',0x1F31,0x0300} },
	[0x1F34] = { unicodeslot=0x1F34, category='ll', contextname='greekiotapsilitonos', description='GREEK SMALL LETTER IOTA WITH PSILI AND OXIA', shcode=0x03B9, uccode=0x1F3C, specials={'char',0x1F30,0x0301} },
	[0x1F35] = { unicodeslot=0x1F35, category='ll', contextname='greekiotadasiatonos', description='GREEK SMALL LETTER IOTA WITH DASIA AND OXIA', shcode=0x03B9, uccode=0x1F3D, specials={'char',0x1F31,0x0301} },
	[0x1F36] = { unicodeslot=0x1F36, category='ll', contextname='greekiotapsiliperispomeni', description='GREEK SMALL LETTER IOTA WITH PSILI AND PERISPOMENI', shcode=0x03B9, uccode=0x1F3E, specials={'char',0x1F30,0x0342} },
	[0x1F37] = { unicodeslot=0x1F37, category='ll', contextname='greekiotadasiaperispomeni', description='GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI', shcode=0x03B9, uccode=0x1F3F, specials={'char',0x1F31,0x0342} },
	[0x1F38] = { unicodeslot=0x1F38, category='lu', contextname='greekIotapsili', description='GREEK CAPITAL LETTER IOTA WITH PSILI', shcode=0x0399, lccode=0x1F30, specials={'char',0x0399,0x0313} },
	[0x1F39] = { unicodeslot=0x1F39, category='lu', contextname='greekIotadasia', description='GREEK CAPITAL LETTER IOTA WITH DASIA', shcode=0x0399, lccode=0x1F31, specials={'char',0x0399,0x0314} },
	[0x1F3A] = { unicodeslot=0x1F3A, category='lu', contextname='greekIotapsilivaria', description='GREEK CAPITAL LETTER IOTA WITH PSILI AND VARIA', shcode=0x0399, lccode=0x1F32, specials={'char',0x1F38,0x0300} },
	[0x1F3B] = { unicodeslot=0x1F3B, category='lu', contextname='greekIotadasiavaria', description='GREEK CAPITAL LETTER IOTA WITH DASIA AND VARIA', shcode=0x0399, lccode=0x1F33, specials={'char',0x1F39,0x0300} },
	[0x1F3C] = { unicodeslot=0x1F3C, category='lu', contextname='greekIotapsilitonos', description='GREEK CAPITAL LETTER IOTA WITH PSILI AND OXIA', shcode=0x0399, lccode=0x1F34, specials={'char',0x1F38,0x0301} },
	[0x1F3D] = { unicodeslot=0x1F3D, category='lu', contextname='greekIotadasiatonos', description='GREEK CAPITAL LETTER IOTA WITH DASIA AND OXIA', shcode=0x0399, lccode=0x1F35, specials={'char',0x1F39,0x0301} },
	[0x1F3E] = { unicodeslot=0x1F3E, category='lu', contextname='greekIotapsiliperispomeni', description='GREEK CAPITAL LETTER IOTA WITH PSILI AND PERISPOMENI', shcode=0x0399, lccode=0x1F36, specials={'char',0x1F38,0x0342} },
	[0x1F3F] = { unicodeslot=0x1F3F, category='lu', contextname='greekIotadasiaperispomeni', description='GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI', shcode=0x0399, lccode=0x1F37, specials={'char',0x1F39,0x0342} },
	[0x1F40] = { unicodeslot=0x1F40, category='ll', contextname='greekomicronpsili', description='GREEK SMALL LETTER OMICRON WITH PSILI', shcode=0x03BF, uccode=0x1F48, specials={'char',0x03BF,0x0313} },
	[0x1F41] = { unicodeslot=0x1F41, category='ll', contextname='greekomicrondasia', description='GREEK SMALL LETTER OMICRON WITH DASIA', shcode=0x03BF, uccode=0x1F49, specials={'char',0x03BF,0x0314} },
	[0x1F42] = { unicodeslot=0x1F42, category='ll', contextname='greekomicronpsilivaria', description='GREEK SMALL LETTER OMICRON WITH PSILI AND VARIA', shcode=0x03BF, uccode=0x1F4A, specials={'char',0x1F40,0x0300} },
	[0x1F43] = { unicodeslot=0x1F43, category='ll', contextname='greekomicrondasiavaria', description='GREEK SMALL LETTER OMICRON WITH DASIA AND VARIA', shcode=0x03BF, uccode=0x1F4B, specials={'char',0x1F41,0x0300} },
	[0x1F44] = { unicodeslot=0x1F44, category='ll', contextname='greekomicronpsilitonos', description='GREEK SMALL LETTER OMICRON WITH PSILI AND OXIA', shcode=0x03BF, uccode=0x1F4C, specials={'char',0x1F40,0x0301} },
	[0x1F45] = { unicodeslot=0x1F45, category='ll', contextname='greekomicrondasiatonos', description='GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA', shcode=0x03BF, uccode=0x1F4D, specials={'char',0x1F41,0x0301} },
	[0x1F48] = { unicodeslot=0x1F48, category='lu', contextname='greekOmicronpsili', description='GREEK CAPITAL LETTER OMICRON WITH PSILI', shcode=0x039F, lccode=0x1F40, specials={'char',0x039F,0x0313} },
	[0x1F49] = { unicodeslot=0x1F49, category='lu', contextname='greekOmicrondasia', description='GREEK CAPITAL LETTER OMICRON WITH DASIA', shcode=0x039F, lccode=0x1F41, specials={'char',0x039F,0x0314} },
	[0x1F4A] = { unicodeslot=0x1F4A, category='lu', contextname='greekOmicronpsilivaria', description='GREEK CAPITAL LETTER OMICRON WITH PSILI AND VARIA', shcode=0x039F, lccode=0x1F42, specials={'char',0x1F48,0x0300} },
	[0x1F4B] = { unicodeslot=0x1F4B, category='lu', contextname='greekOmicrondasiavaria', description='GREEK CAPITAL LETTER OMICRON WITH DASIA AND VARIA', shcode=0x039F, lccode=0x1F43, specials={'char',0x1F49,0x0300} },
	[0x1F4C] = { unicodeslot=0x1F4C, category='lu', contextname='greekOmicronpsilitonos', description='GREEK CAPITAL LETTER OMICRON WITH PSILI AND OXIA', shcode=0x039F, lccode=0x1F44, specials={'char',0x1F48,0x0301} },
	[0x1F4D] = { unicodeslot=0x1F4D, category='lu', contextname='greekOmicrondasiatonos', description='GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA', shcode=0x039F, lccode=0x1F45, specials={'char',0x1F49,0x0301} },
	[0x1F50] = { unicodeslot=0x1F50, category='ll', contextname='greekupsilonpsili', description='GREEK SMALL LETTER UPSILON WITH PSILI', shcode=0x03C5, specials={'char',0x03C5,0x0313} },
	[0x1F51] = { unicodeslot=0x1F51, category='ll', contextname='greekupsilondasia', description='GREEK SMALL LETTER UPSILON WITH DASIA', shcode=0x03C5, uccode=0x1F59, specials={'char',0x03C5,0x0314} },
	[0x1F52] = { unicodeslot=0x1F52, category='ll', contextname='greekupsilonpsilivaria', description='GREEK SMALL LETTER UPSILON WITH PSILI AND VARIA', shcode=0x03C5, specials={'char',0x1F50,0x0300} },
	[0x1F53] = { unicodeslot=0x1F53, category='ll', contextname='greekupsilondasiavaria', description='GREEK SMALL LETTER UPSILON WITH DASIA AND VARIA', shcode=0x03C5, uccode=0x1F5B, specials={'char',0x1F51,0x0300} },
	[0x1F54] = { unicodeslot=0x1F54, category='ll', contextname='greekupsilonpsilitonos', description='GREEK SMALL LETTER UPSILON WITH PSILI AND OXIA', shcode=0x03C5, specials={'char',0x1F50,0x0301} },
	[0x1F55] = { unicodeslot=0x1F55, category='ll', contextname='greekupsilondasiatonos', description='GREEK SMALL LETTER UPSILON WITH DASIA AND OXIA', shcode=0x03C5, uccode=0x1F5D, specials={'char',0x1F51,0x0301} },
	[0x1F56] = { unicodeslot=0x1F56, category='ll', contextname='greekupsilonpsiliperispomeni', description='GREEK SMALL LETTER UPSILON WITH PSILI AND PERISPOMENI', shcode=0x03C5, specials={'char',0x1F50,0x0342} },
	[0x1F57] = { unicodeslot=0x1F57, category='ll', contextname='greekupsilondasiaperispomeni', description='GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI', shcode=0x03C5, uccode=0x1F5F, specials={'char',0x1F51,0x0342} },
	[0x1F59] = { unicodeslot=0x1F59, category='lu', contextname='greekUpsilondasia', description='GREEK CAPITAL LETTER UPSILON WITH DASIA', shcode=0x03A5, lccode=0x1F51, specials={'char',0x03A5,0x0314} },
	[0x1F5B] = { unicodeslot=0x1F5B, category='lu', contextname='greekUpsilondasiavaria', description='GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA', shcode=0x03A5, lccode=0x1F53, specials={'char',0x1F59,0x0300} },
	[0x1F5D] = { unicodeslot=0x1F5D, category='lu', contextname='greekUpsilondasiatonos', description='GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA', shcode=0x03A5, lccode=0x1F55, specials={'char',0x1F59,0x0301} },
	[0x1F5F] = { unicodeslot=0x1F5F, category='lu', contextname='greekUpsilondasiaperispomeni', description='GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI', shcode=0x03A5, lccode=0x1F57, specials={'char',0x1F59,0x0342} },
	[0x1F60] = { unicodeslot=0x1F60, category='ll', contextname='greekomegapsili', description='GREEK SMALL LETTER OMEGA WITH PSILI', shcode=0x03C9, uccode=0x1F68, specials={'char',0x03C9,0x0313} },
	[0x1F61] = { unicodeslot=0x1F61, category='ll', contextname='greekomegadasia', description='GREEK SMALL LETTER OMEGA WITH DASIA', shcode=0x03C9, uccode=0x1F69, specials={'char',0x03C9,0x0314} },
	[0x1F62] = { unicodeslot=0x1F62, category='ll', contextname='greekomegapsilivaria', description='GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA', shcode=0x03C9, uccode=0x1F6A, specials={'char',0x1F60,0x0300} },
	[0x1F63] = { unicodeslot=0x1F63, category='ll', contextname='greekomegadasiavaria', description='GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA', shcode=0x03C9, uccode=0x1F6B, specials={'char',0x1F61,0x0300} },
	[0x1F64] = { unicodeslot=0x1F64, category='ll', contextname='greekomegapsilitonos', description='GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA', shcode=0x03C9, uccode=0x1F6C, specials={'char',0x1F60,0x0301} },
	[0x1F65] = { unicodeslot=0x1F65, category='ll', contextname='greekomegadasiatonos', description='GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA', shcode=0x03C9, uccode=0x1F6D, specials={'char',0x1F61,0x0301} },
	[0x1F66] = { unicodeslot=0x1F66, category='ll', contextname='greekomegapsiliperispomeni', description='GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI', shcode=0x03C9, uccode=0x1F6E, specials={'char',0x1F60,0x0342} },
	[0x1F67] = { unicodeslot=0x1F67, category='ll', contextname='greekomegadasiaperispomeni', description='GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI', shcode=0x03C9, uccode=0x1F6F, specials={'char',0x1F61,0x0342} },
	[0x1F68] = { unicodeslot=0x1F68, category='lu', contextname='greekOmegapsili', description='GREEK CAPITAL LETTER OMEGA WITH PSILI', shcode=0x03A9, lccode=0x1F60, specials={'char',0x03A9,0x0313} },
	[0x1F69] = { unicodeslot=0x1F69, category='lu', contextname='greekOmegadasia', description='GREEK CAPITAL LETTER OMEGA WITH DASIA', shcode=0x03A9, lccode=0x1F61, specials={'char',0x03A9,0x0314} },
	[0x1F6A] = { unicodeslot=0x1F6A, category='lu', contextname='greekOmegapsilivaria', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA', shcode=0x03A9, lccode=0x1F62, specials={'char',0x1F68,0x0300} },
	[0x1F6B] = { unicodeslot=0x1F6B, category='lu', contextname='greekOmegadasiavaria', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA', shcode=0x03A9, lccode=0x1F63, specials={'char',0x1F69,0x0300} },
	[0x1F6C] = { unicodeslot=0x1F6C, category='lu', contextname='greekOmegapsilitonos', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA', shcode=0x03A9, lccode=0x1F64, specials={'char',0x1F68,0x0301} },
	[0x1F6D] = { unicodeslot=0x1F6D, category='lu', contextname='greekOmegadasiatonos', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA', shcode=0x03A9, lccode=0x1F65, specials={'char',0x1F69,0x0301} },
	[0x1F6E] = { unicodeslot=0x1F6E, category='lu', contextname='greekOmegapsiliperispomeni', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI', shcode=0x03A9, lccode=0x1F66, specials={'char',0x1F68,0x0342} },
	[0x1F6F] = { unicodeslot=0x1F6F, category='lu', contextname='greekOmegadasiaperispomeni', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI', shcode=0x03A9, lccode=0x1F67, specials={'char',0x1F69,0x0342} },
	[0x1F70] = { unicodeslot=0x1F70, category='ll', contextname='greekalphavaria', description='GREEK SMALL LETTER ALPHA WITH VARIA', shcode=0x03B1, uccode=0x1FBA, specials={'char',0x03B1,0x0300} },
	[0x1F71] = { unicodeslot=0x1F71, category='ll', contextname='greekalphaoxia', description='GREEK SMALL LETTER ALPHA WITH OXIA', shcode=0x03B1, uccode=0x1FBB, specials={'char',0x03AC} },
	[0x1F72] = { unicodeslot=0x1F72, category='ll', contextname='greekepsilonvaria', description='GREEK SMALL LETTER EPSILON WITH VARIA', shcode=0x03B5, uccode=0x1FC8, specials={'char',0x03B5,0x0300} },
	[0x1F73] = { unicodeslot=0x1F73, category='ll', contextname='greekepsilonoxia', description='GREEK SMALL LETTER EPSILON WITH OXIA', shcode=0x03B5, uccode=0x1FC9, specials={'char',0x03AD} },
	[0x1F74] = { unicodeslot=0x1F74, category='ll', contextname='greeketavaria', description='GREEK SMALL LETTER ETA WITH VARIA', shcode=0x03B7, uccode=0x1FCA, specials={'char',0x03B7,0x0300} },
	[0x1F75] = { unicodeslot=0x1F75, category='ll', contextname='greeketaoxia', description='GREEK SMALL LETTER ETA WITH OXIA', shcode=0x03B7, uccode=0x1FCB, specials={'char',0x03AE} },
	[0x1F76] = { unicodeslot=0x1F76, category='ll', contextname='greekiotavaria', description='GREEK SMALL LETTER IOTA WITH VARIA', shcode=0x03B9, uccode=0x1FDA, specials={'char',0x03B9,0x0300} },
	[0x1F77] = { unicodeslot=0x1F77, category='ll', contextname='greekiotaoxia', description='GREEK SMALL LETTER IOTA WITH OXIA', shcode=0x03B9, uccode=0x1FDB, specials={'char',0x03AF} },
	[0x1F78] = { unicodeslot=0x1F78, category='ll', contextname='greekomicronvaria', description='GREEK SMALL LETTER OMICRON WITH VARIA', shcode=0x03BF, uccode=0x1FF8, specials={'char',0x03BF,0x0300} },
	[0x1F79] = { unicodeslot=0x1F79, category='ll', contextname='greekomicronoxia', description='GREEK SMALL LETTER OMICRON WITH OXIA', shcode=0x03BF, uccode=0x1FF9, specials={'char',0x03CC} },
	[0x1F7A] = { unicodeslot=0x1F7A, category='ll', contextname='greekupsilonvaria', description='GREEK SMALL LETTER UPSILON WITH VARIA', shcode=0x03C5, uccode=0x1FEA, specials={'char',0x03C5,0x0300} },
	[0x1F7B] = { unicodeslot=0x1F7B, category='ll', contextname='greekupsilonoxia', description='GREEK SMALL LETTER UPSILON WITH OXIA', shcode=0x03C5, uccode=0x1FEB, specials={'char',0x03CD} },
	[0x1F7C] = { unicodeslot=0x1F7C, category='ll', contextname='greekomegavaria', description='GREEK SMALL LETTER OMEGA WITH VARIA', shcode=0x03C9, uccode=0x1FFA, specials={'char',0x03C9,0x0300} },
	[0x1F7D] = { unicodeslot=0x1F7D, category='ll', contextname='greekomegaoxia', description='GREEK SMALL LETTER OMEGA WITH OXIA', shcode=0x03C9, uccode=0x1FFB, specials={'char',0x03CE} },
	[0x1F80] = { unicodeslot=0x1F80, category='ll', contextname='greekalphaiotasubpsili', description='GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F88, specials={'char',0x1F00,0x0345} },
	[0x1F81] = { unicodeslot=0x1F81, category='ll', contextname='greekalphaiotasubdasia', description='GREEK SMALL LETTER ALPHA WITH DASIA AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F89, specials={'char',0x1F01,0x0345} },
	[0x1F82] = { unicodeslot=0x1F82, category='ll', contextname='greekalphaiotasubpsilivaria', description='GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F8A, specials={'char',0x1F02,0x0345} },
	[0x1F83] = { unicodeslot=0x1F83, category='ll', contextname='greekalphaiotasubdasiavaria', description='GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F8B, specials={'char',0x1F03,0x0345} },
	[0x1F84] = { unicodeslot=0x1F84, category='ll', contextname='greekalphaiotasubpsilitonos', description='GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F8C, specials={'char',0x1F04,0x0345} },
	[0x1F85] = { unicodeslot=0x1F85, category='ll', contextname='greekalphaiotasubdasiatonos', description='GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F8D, specials={'char',0x1F05,0x0345} },
	[0x1F86] = { unicodeslot=0x1F86, category='ll', contextname='greekalphaiotasubpsiliperispomeni', description='GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F8E, specials={'char',0x1F06,0x0345} },
	[0x1F87] = { unicodeslot=0x1F87, category='ll', contextname='greekalphaiotasubdasiaperispomeni', description='GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1F8F, specials={'char',0x1F07,0x0345} },
	[0x1F88] = { unicodeslot=0x1F88, category='lt', contextname='greekAlphaiotasubpsili', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F80, specials={'char',0x1F08,0x0345} },
	[0x1F89] = { unicodeslot=0x1F89, category='lt', contextname='greekAlphaiotasubdasia', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F81, specials={'char',0x1F09,0x0345} },
	[0x1F8A] = { unicodeslot=0x1F8A, category='lt', contextname='greekAlphaiotasubpsilivaria', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F82, specials={'char',0x1F0A,0x0345} },
	[0x1F8B] = { unicodeslot=0x1F8B, category='lt', contextname='greekAlphaiotasubdasiavaria', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F83, specials={'char',0x1F0B,0x0345} },
	[0x1F8C] = { unicodeslot=0x1F8C, category='lt', contextname='greekAlphaiotasubpsilitonos', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F84, specials={'char',0x1F0C,0x0345} },
	[0x1F8D] = { unicodeslot=0x1F8D, category='lt', contextname='greekAlphaiotasubdasiatonos', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F85, specials={'char',0x1F0D,0x0345} },
	[0x1F8E] = { unicodeslot=0x1F8E, category='lt', contextname='greekAlphaiotasubpsiliperispomeni', description='GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F86, specials={'char',0x1F0E,0x0345} },
	[0x1F8F] = { unicodeslot=0x1F8F, category='lt', contextname='greekAlphaiotasubdasiaperispomeni', description='GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI', shcode=0x0391, lccode=0x1F87, specials={'char',0x1F0F,0x0345} },
	[0x1F90] = { unicodeslot=0x1F90, category='ll', contextname='greeketaiotasubpsili', description='GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F98, specials={'char',0x1F20,0x0345} },
	[0x1F91] = { unicodeslot=0x1F91, category='ll', contextname='greeketaiotasubdasia', description='GREEK SMALL LETTER ETA WITH DASIA AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F99, specials={'char',0x1F21,0x0345} },
	[0x1F92] = { unicodeslot=0x1F92, category='ll', contextname='greeketaiotasubpsilivaria', description='GREEK SMALL LETTER ETA WITH PSILI AND VARIA AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F9A, specials={'char',0x1F22,0x0345} },
	[0x1F93] = { unicodeslot=0x1F93, category='ll', contextname='greeketaiotasubdasiavaria', description='GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F9B, specials={'char',0x1F23,0x0345} },
	[0x1F94] = { unicodeslot=0x1F94, category='ll', contextname='greeketaiotasubpsilitonos', description='GREEK SMALL LETTER ETA WITH PSILI AND OXIA AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F9C, specials={'char',0x1F24,0x0345} },
	[0x1F95] = { unicodeslot=0x1F95, category='ll', contextname='greeketaiotasubdasiatonos', description='GREEK SMALL LETTER ETA WITH DASIA AND OXIA AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F9D, specials={'char',0x1F25,0x0345} },
	[0x1F96] = { unicodeslot=0x1F96, category='ll', contextname='greeketaiotasubpsiliperispomeni', description='GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F9E, specials={'char',0x1F26,0x0345} },
	[0x1F97] = { unicodeslot=0x1F97, category='ll', contextname='greeketaiotasubdasiaperispomeni', description='GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1F9F, specials={'char',0x1F27,0x0345} },
	[0x1F98] = { unicodeslot=0x1F98, category='lt', contextname='greekEtaiotasubpsili', description='GREEK CAPITAL LETTER ETA WITH PSILI AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F90, specials={'char',0x1F28,0x0345} },
	[0x1F99] = { unicodeslot=0x1F99, category='lt', contextname='greekEtaiotasubdasia', description='GREEK CAPITAL LETTER ETA WITH DASIA AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F91, specials={'char',0x1F29,0x0345} },
	[0x1F9A] = { unicodeslot=0x1F9A, category='lt', contextname='greekEtaiotasubpsilivaria', description='GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F92, specials={'char',0x1F2A,0x0345} },
	[0x1F9B] = { unicodeslot=0x1F9B, category='lt', contextname='greekEtaiotasubdasiavaria', description='GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F93, specials={'char',0x1F2B,0x0345} },
	[0x1F9C] = { unicodeslot=0x1F9C, category='lt', contextname='greekEtaiotasubpsilitonos', description='GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F94, specials={'char',0x1F2C,0x0345} },
	[0x1F9D] = { unicodeslot=0x1F9D, category='lt', contextname='greekEtaiotasubdasiatonos', description='GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F95, specials={'char',0x1F2D,0x0345} },
	[0x1F9E] = { unicodeslot=0x1F9E, category='lt', contextname='greekEtaiotasubpsiliperispomeni', description='GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F96, specials={'char',0x1F2E,0x0345} },
	[0x1F9F] = { unicodeslot=0x1F9F, category='lt', contextname='greekEtaiotasubdasiaperispomeni', description='GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI', shcode=0x0397, lccode=0x1F97, specials={'char',0x1F2F,0x0345} },
	[0x1FA0] = { unicodeslot=0x1FA0, category='ll', contextname='greekomegaiotasubpsili', description='GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FA8, specials={'char',0x1F60,0x0345} },
	[0x1FA1] = { unicodeslot=0x1FA1, category='ll', contextname='greekomegaiotasubdasia', description='GREEK SMALL LETTER OMEGA WITH DASIA AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FA9, specials={'char',0x1F61,0x0345} },
	[0x1FA2] = { unicodeslot=0x1FA2, category='ll', contextname='greekomegaiotasubpsilivaria', description='GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FAA, specials={'char',0x1F62,0x0345} },
	[0x1FA3] = { unicodeslot=0x1FA3, category='ll', contextname='greekomegaiotasubdasiavaria', description='GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FAB, specials={'char',0x1F63,0x0345} },
	[0x1FA4] = { unicodeslot=0x1FA4, category='ll', contextname='greekomegaiotasubpsilitonos', description='GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FAC, specials={'char',0x1F64,0x0345} },
	[0x1FA5] = { unicodeslot=0x1FA5, category='ll', contextname='greekomegaiotasubdasiatonos', description='GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FAD, specials={'char',0x1F65,0x0345} },
	[0x1FA6] = { unicodeslot=0x1FA6, category='ll', contextname='greekomegaiotasubpsiliperispomeni', description='GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FAE, specials={'char',0x1F66,0x0345} },
	[0x1FA7] = { unicodeslot=0x1FA7, category='ll', contextname='greekomegaiotasubdasiaperispomeni', description='GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FAF, specials={'char',0x1F67,0x0345} },
	[0x1FA8] = { unicodeslot=0x1FA8, category='lt', contextname='greekOmegaiotasubpsili', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA0, specials={'char',0x1F68,0x0345} },
	[0x1FA9] = { unicodeslot=0x1FA9, category='lt', contextname='greekOmegaiotasubdasia', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA1, specials={'char',0x1F69,0x0345} },
	[0x1FAA] = { unicodeslot=0x1FAA, category='lt', contextname='greekOmegaiotasubpsilivaria', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA2, specials={'char',0x1F6A,0x0345} },
	[0x1FAB] = { unicodeslot=0x1FAB, category='lt', contextname='greekOmegaiotasubdasiavaria', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA3, specials={'char',0x1F6B,0x0345} },
	[0x1FAC] = { unicodeslot=0x1FAC, category='lt', contextname='greekOmegaiotasubpsilitonos', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA4, specials={'char',0x1F6C,0x0345} },
	[0x1FAD] = { unicodeslot=0x1FAD, category='lt', contextname='greekOmegaiotasubdasiatonos', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA5, specials={'char',0x1F6D,0x0345} },
	[0x1FAE] = { unicodeslot=0x1FAE, category='lt', contextname='greekOmegaiotasubpsiliperispomeni', description='GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA6, specials={'char',0x1F6E,0x0345} },
	[0x1FAF] = { unicodeslot=0x1FAF, category='lt', contextname='greekOmegaiotasubdasiaperispomeni', description='GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FA7, specials={'char',0x1F6F,0x0345} },
	[0x1FB0] = { unicodeslot=0x1FB0, category='ll', contextname='greekalphavrachy', description='GREEK SMALL LETTER ALPHA WITH VRACHY', shcode=0x03B1, uccode=0x1FB8, specials={'char',0x03B1,0x0306} },
	[0x1FB1] = { unicodeslot=0x1FB1, category='ll', contextname='greekalphamacron', description='GREEK SMALL LETTER ALPHA WITH MACRON', shcode=0x03B1, uccode=0x1FB9, specials={'char',0x03B1,0x0304} },
	[0x1FB2] = { unicodeslot=0x1FB2, category='ll', contextname='greekalphaiotasubvaria', description='GREEK SMALL LETTER ALPHA WITH VARIA AND YPOGEGRAMMENI', shcode=0x03B1, specials={'char',0x1F70,0x0345} },
	[0x1FB3] = { unicodeslot=0x1FB3, category='ll', contextname='greekalphaiotasub', description='GREEK SMALL LETTER ALPHA WITH YPOGEGRAMMENI', shcode=0x03B1, uccode=0x1FBC, specials={'char',0x03B1,0x0345} },
	[0x1FB4] = { unicodeslot=0x1FB4, category='ll', contextname='greekalphaiotasubtonos', description='GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI', shcode=0x03B1, specials={'char',0x03AC,0x0345} },
	[0x1FB6] = { unicodeslot=0x1FB6, category='ll', contextname='greekalphaperispomeni', description='GREEK SMALL LETTER ALPHA WITH PERISPOMENI', shcode=0x03B1, specials={'char',0x03B1,0x0342} },
	[0x1FB7] = { unicodeslot=0x1FB7, category='ll', contextname='greekalphaiotasubperispomeni', description='GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03B1, specials={'char',0x1FB6,0x0345} },
	[0x1FB8] = { unicodeslot=0x1FB8, category='lu', contextname='greekAlphavrachy', description='GREEK CAPITAL LETTER ALPHA WITH VRACHY', shcode=0x0391, lccode=0x1FB0, specials={'char',0x0391,0x0306} },
	[0x1FB9] = { unicodeslot=0x1FB9, category='lu', contextname='greekAlphamacron', description='GREEK CAPITAL LETTER ALPHA WITH MACRON', shcode=0x0391, lccode=0x1FB1, specials={'char',0x0391,0x0304} },
	[0x1FBA] = { unicodeslot=0x1FBA, category='lu', contextname='greekAlphavaria', description='GREEK CAPITAL LETTER ALPHA WITH VARIA', shcode=0x0391, lccode=0x1F70, specials={'char',0x0391,0x0300} },
	[0x1FBB] = { unicodeslot=0x1FBB, category='lu', contextname='greekAlphatonos', description='GREEK CAPITAL LETTER ALPHA WITH OXIA', shcode=0x0391, lccode=0x1F71, specials={'char',0x0386} },
	[0x1FBC] = { unicodeslot=0x1FBC, category='lt', contextname='greekAlphaiotasub', description='GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI', shcode=0x0391, lccode=0x1FB3, specials={'char',0x0391,0x0345} },
	[0x1FBD] = { unicodeslot=0x1FBD, category='sk', contextname='greekCoronis', description='GREEK KORONIS', specials={'compat',0x0020,0x0313} },
	[0x1FBE] = { unicodeslot=0x1FBE, category='ll', contextname='greekprosgegrammeni', description='GREEK PROSGEGRAMMENI', uccode=0x0399, specials={'char',0x03B9} },
	[0x1FBF] = { unicodeslot=0x1FBF, category='sk', contextname='greekpsili', description='GREEK PSILI', specials={'compat',0x0020,0x0313} },
	[0x1FC0] = { unicodeslot=0x1FC0, category='sk', contextname='greekperispomeni', description='GREEK PERISPOMENI', specials={'compat',0x0020,0x0342} },
	[0x1FC1] = { unicodeslot=0x1FC1, category='sk', contextname='greekdialytikaperispomeni', description='GREEK DIALYTIKA AND PERISPOMENI', specials={'char',0x00A8,0x0342} },
	[0x1FC2] = { unicodeslot=0x1FC2, category='ll', contextname='greeketaiotasubvaria', description='GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI', shcode=0x03B7, specials={'char',0x1F74,0x0345} },
	[0x1FC3] = { unicodeslot=0x1FC3, category='ll', contextname='greeketaiotasub', description='GREEK SMALL LETTER ETA WITH YPOGEGRAMMENI', shcode=0x03B7, uccode=0x1FCC, specials={'char',0x03B7,0x0345} },
	[0x1FC4] = { unicodeslot=0x1FC4, category='ll', contextname='greeketaiotasubtonos', description='GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI', shcode=0x03B7, specials={'char',0x03AE,0x0345} },
	[0x1FC6] = { unicodeslot=0x1FC6, category='ll', contextname='greeketaperispomeni', description='GREEK SMALL LETTER ETA WITH PERISPOMENI', shcode=0x03B7, specials={'char',0x03B7,0x0342} },
	[0x1FC7] = { unicodeslot=0x1FC7, category='ll', contextname='greeketaiotasubperispomeni', description='GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03B7, specials={'char',0x1FC6,0x0345} },
	[0x1FC8] = { unicodeslot=0x1FC8, category='lu', contextname='greekEpsilonvaria', description='GREEK CAPITAL LETTER EPSILON WITH VARIA', shcode=0x0395, lccode=0x1F72, specials={'char',0x0395,0x0300} },
	[0x1FC9] = { unicodeslot=0x1FC9, category='lu', contextname='greekEpsilontonos', description='GREEK CAPITAL LETTER EPSILON WITH OXIA', shcode=0x0395, lccode=0x1F73, specials={'char',0x0388} },
	[0x1FCA] = { unicodeslot=0x1FCA, category='lu', contextname='greekEtavaria', description='GREEK CAPITAL LETTER ETA WITH VARIA', shcode=0x0397, lccode=0x1F74, specials={'char',0x0397,0x0300} },
	[0x1FCB] = { unicodeslot=0x1FCB, category='lu', contextname='greekEtatonos', description='GREEK CAPITAL LETTER ETA WITH OXIA', shcode=0x0397, lccode=0x1F75, specials={'char',0x0389} },
	[0x1FCC] = { unicodeslot=0x1FCC, category='lt', contextname='greekEtaiotasub', description='GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI', shcode=0x0397, lccode=0x1FC3, specials={'char',0x0397,0x0345} },
	[0x1FCD] = { unicodeslot=0x1FCD, category='sk', contextname='greekpsilivaria', description='GREEK PSILI AND VARIA', specials={'char',0x1FBF,0x0300} },
	[0x1FCE] = { unicodeslot=0x1FCE, category='sk', contextname='greekpsilitonos', description='GREEK PSILI AND OXIA', specials={'char',0x1FBF,0x0301} },
	[0x1FCF] = { unicodeslot=0x1FCF, category='sk', contextname='greekpsiliperispomeni', description='GREEK PSILI AND PERISPOMENI', specials={'char',0x1FBF,0x0342} },
	[0x1FD0] = { unicodeslot=0x1FD0, category='ll', contextname='greekiotavrachy', description='GREEK SMALL LETTER IOTA WITH VRACHY', shcode=0x03B9, uccode=0x1FD8, specials={'char',0x03B9,0x0306} },
	[0x1FD1] = { unicodeslot=0x1FD1, category='ll', contextname='greekiotamacron', description='GREEK SMALL LETTER IOTA WITH MACRON', shcode=0x03B9, uccode=0x1FD9, specials={'char',0x03B9,0x0304} },
	[0x1FD2] = { unicodeslot=0x1FD2, category='ll', contextname='greekiotadialytikavaria', description='GREEK SMALL LETTER IOTA WITH DIALYTIKA AND VARIA', shcode=0x03B9, specials={'char',0x03CA,0x0300} },
	[0x1FD3] = { unicodeslot=0x1FD3, category='ll', contextname='greekiotadialytikatonos', description='GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA', shcode=0x03B9, specials={'char',0x0390} },
	[0x1FD6] = { unicodeslot=0x1FD6, category='ll', contextname='greekiotaperispomeni', description='GREEK SMALL LETTER IOTA WITH PERISPOMENI', shcode=0x03B9, specials={'char',0x03B9,0x0342} },
	[0x1FD7] = { unicodeslot=0x1FD7, category='ll', contextname='greekiotadialytikaperispomeni', description='GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI', shcode=0x03B9, specials={'char',0x03CA,0x0342} },
	[0x1FD8] = { unicodeslot=0x1FD8, category='lu', contextname='greekIotavrachy', description='GREEK CAPITAL LETTER IOTA WITH VRACHY', shcode=0x0399, lccode=0x1FD0, specials={'char',0x0399,0x0306} },
	[0x1FD9] = { unicodeslot=0x1FD9, category='lu', contextname='greekIotamacron', description='GREEK CAPITAL LETTER IOTA WITH MACRON', shcode=0x0399, lccode=0x1FD1, specials={'char',0x0399,0x0304} },
	[0x1FDA] = { unicodeslot=0x1FDA, category='lu', contextname='greekIotavaria', description='GREEK CAPITAL LETTER IOTA WITH VARIA', shcode=0x0399, lccode=0x1F76, specials={'char',0x0399,0x0300} },
	[0x1FDB] = { unicodeslot=0x1FDB, category='lu', contextname='greekIotatonos', description='GREEK CAPITAL LETTER IOTA WITH OXIA', shcode=0x0399, lccode=0x1F77, specials={'char',0x038A} },
	[0x1FDD] = { unicodeslot=0x1FDD, category='sk', contextname='greekdasiavaria', description='GREEK DASIA AND VARIA', specials={'char',0x1FFE,0x0300} },
	[0x1FDE] = { unicodeslot=0x1FDE, category='sk', contextname='greekdasiatonos', description='GREEK DASIA AND OXIA', specials={'char',0x1FFE,0x0301} },
	[0x1FDF] = { unicodeslot=0x1FDF, category='sk', contextname='greekdasiaperispomeni', description='GREEK DASIA AND PERISPOMENI', specials={'char',0x1FFE,0x0342} },
	[0x1FE0] = { unicodeslot=0x1FE0, category='ll', contextname='greekupsilonvrachy', description='GREEK SMALL LETTER UPSILON WITH VRACHY', shcode=0x03C5, uccode=0x1FE8, specials={'char',0x03C5,0x0306} },
	[0x1FE1] = { unicodeslot=0x1FE1, category='ll', contextname='greekupsilonmacron', description='GREEK SMALL LETTER UPSILON WITH MACRON', shcode=0x03C5, uccode=0x1FE9, specials={'char',0x03C5,0x0304} },
	[0x1FE2] = { unicodeslot=0x1FE2, category='ll', contextname='greekupsilondialytikavaria', description='GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND VARIA', shcode=0x03C5, specials={'char',0x03CB,0x0300} },
	[0x1FE3] = { unicodeslot=0x1FE3, category='ll', contextname='greekupsilondialytikatonos', description='GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND OXIA', shcode=0x03C5, specials={'char',0x03B0} },
	[0x1FE4] = { unicodeslot=0x1FE4, category='ll', contextname='greekrhopsili', description='GREEK SMALL LETTER RHO WITH PSILI', shcode=0x03C1, specials={'char',0x03C1,0x0313} },
	[0x1FE5] = { unicodeslot=0x1FE5, category='ll', contextname='greekrhodasia', description='GREEK SMALL LETTER RHO WITH DASIA', shcode=0x03C1, uccode=0x1FEC, specials={'char',0x03C1,0x0314} },
	[0x1FE6] = { unicodeslot=0x1FE6, category='ll', contextname='greekupsilonperispomeni', description='GREEK SMALL LETTER UPSILON WITH PERISPOMENI', shcode=0x03C5, specials={'char',0x03C5,0x0342} },
	[0x1FE7] = { unicodeslot=0x1FE7, category='ll', contextname='greekupsilondialytikaperispomeni', description='GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI', shcode=0x03C5, specials={'char',0x03CB,0x0342} },
	[0x1FE8] = { unicodeslot=0x1FE8, category='lu', contextname='greekUpsilonvrachy', description='GREEK CAPITAL LETTER UPSILON WITH VRACHY', shcode=0x03A5, lccode=0x1FE0, specials={'char',0x03A5,0x0306} },
	[0x1FE9] = { unicodeslot=0x1FE9, category='lu', contextname='greekUpsilonmacron', description='GREEK CAPITAL LETTER UPSILON WITH MACRON', shcode=0x03A5, lccode=0x1FE1, specials={'char',0x03A5,0x0304} },
	[0x1FEA] = { unicodeslot=0x1FEA, category='lu', contextname='greekUpsilonvaria', description='GREEK CAPITAL LETTER UPSILON WITH VARIA', shcode=0x03A5, lccode=0x1F7A, specials={'char',0x03A5,0x0300} },
	[0x1FEB] = { unicodeslot=0x1FEB, category='lu', contextname='greekUpsilontonos', description='GREEK CAPITAL LETTER UPSILON WITH OXIA', shcode=0x03A5, lccode=0x1F7B, specials={'char',0x038E} },
	[0x1FEC] = { unicodeslot=0x1FEC, category='lu', contextname='greekRhodasia', description='GREEK CAPITAL LETTER RHO WITH DASIA', shcode=0x03A1, lccode=0x1FE5, specials={'char',0x03A1,0x0314} },
	[0x1FED] = { unicodeslot=0x1FED, category='sk', contextname='greekdialytikavaria', description='GREEK DIALYTIKA AND VARIA', specials={'char',0x00A8,0x0300} },
	[0x1FEE] = { unicodeslot=0x1FEE, category='sk', contextname='greekdialytikatonos', description='GREEK DIALYTIKA AND OXIA', specials={'char',0x0385} },
	[0x1FEF] = { unicodeslot=0x1FEF, category='sk', contextname='greekvaria', description='GREEK VARIA', specials={'char',0x0060} },
	[0x1FF2] = { unicodeslot=0x1FF2, category='ll', contextname='greekomegaiotasubvaria', description='GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI', shcode=0x03C9, specials={'char',0x1F7C,0x0345} },
	[0x1FF3] = { unicodeslot=0x1FF3, category='ll', contextname='greekomegaiotasub', description='GREEK SMALL LETTER OMEGA WITH YPOGEGRAMMENI', shcode=0x03C9, uccode=0x1FFC, specials={'char',0x03C9,0x0345} },
	[0x1FF4] = { unicodeslot=0x1FF4, category='ll', contextname='greekomegaiotasubtonos', description='GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI', shcode=0x03C9, specials={'char',0x03CE,0x0345} },
	[0x1FF6] = { unicodeslot=0x1FF6, category='ll', contextname='greekomegaperispomeni', description='GREEK SMALL LETTER OMEGA WITH PERISPOMENI', shcode=0x03C9, specials={'char',0x03C9,0x0342} },
	[0x1FF7] = { unicodeslot=0x1FF7, category='ll', contextname='greekomegaiotasubperispomeni', description='GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI', shcode=0x03C9, specials={'char',0x1FF6,0x0345} },
	[0x1FF8] = { unicodeslot=0x1FF8, category='lu', contextname='greekOmicronvaria', description='GREEK CAPITAL LETTER OMICRON WITH VARIA', shcode=0x039F, lccode=0x1F78, specials={'char',0x039F,0x0300} },
	[0x1FF9] = { unicodeslot=0x1FF9, category='lu', contextname='greekOmicrontonos', description='GREEK CAPITAL LETTER OMICRON WITH OXIA', shcode=0x039F, lccode=0x1F79, specials={'char',0x038C} },
	[0x1FFA] = { unicodeslot=0x1FFA, category='lu', contextname='greekOmegavaria', description='GREEK CAPITAL LETTER OMEGA WITH VARIA', shcode=0x03A9, lccode=0x1F7C, specials={'char',0x03A9,0x0300} },
	[0x1FFB] = { unicodeslot=0x1FFB, category='lu', contextname='greekOmegatonos', description='GREEK CAPITAL LETTER OMEGA WITH OXIA', shcode=0x03A9, lccode=0x1F7D, specials={'char',0x038F} },
	[0x1FFC] = { unicodeslot=0x1FFC, category='lt', contextname='greekOmegaiotasub', description='GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI', shcode=0x03A9, lccode=0x1FF3, specials={'char',0x03A9,0x0345} },
	[0x1FFD] = { unicodeslot=0x1FFD, category='sk', contextname='greekoxia', description='GREEK OXIA', specials={'char',0x00B4} },
	[0x1FFE] = { unicodeslot=0x1FFE, category='sk', contextname='greekdasia', description='GREEK DASIA', specials={'compat',0x0020,0x0314} },
	[0x2000] = { unicodeslot=0x2000, category='zs', description='EN QUAD', specials={'char',0x2002} },
	[0x2001] = { unicodeslot=0x2001, category='zs', description='EM QUAD', specials={'char',0x2003} },
	[0x2002] = { unicodeslot=0x2002, category='zs', description='EN SPACE', specials={'compat',0x0020} },
	[0x2003] = { unicodeslot=0x2003, category='zs', description='EM SPACE', specials={'compat',0x0020} },
	[0x2004] = { unicodeslot=0x2004, category='zs', description='THREE-PER-EM SPACE', specials={'compat',0x0020} },
	[0x2005] = { unicodeslot=0x2005, category='zs', description='FOUR-PER-EM SPACE', specials={'compat',0x0020} },
	[0x2006] = { unicodeslot=0x2006, category='zs', description='SIX-PER-EM SPACE', specials={'compat',0x0020} },
	[0x2007] = { unicodeslot=0x2007, category='zs', description='FIGURE SPACE', specials={'nobreak',0x0020} },
	[0x2008] = { unicodeslot=0x2008, category='zs', description='PUNCTUATION SPACE', specials={'compat',0x0020} },
	[0x2009] = { unicodeslot=0x2009, category='zs', description='THIN SPACE', specials={'compat',0x0020} },
	[0x200A] = { unicodeslot=0x200A, category='zs', description='HAIR SPACE', specials={'compat',0x0020} },
	[0x200B] = { unicodeslot=0x200B, category='cf', description='ZERO WIDTH SPACE' },
	[0x200C] = { unicodeslot=0x200C, category='cf', adobename='afii61664', description='ZERO WIDTH NON-JOINER' },
	[0x200D] = { unicodeslot=0x200D, category='cf', adobename='afii301', description='ZERO WIDTH JOINER' },
	[0x200E] = { unicodeslot=0x200E, category='cf', adobename='afii299', description='LEFT-TO-RIGHT MARK' },
	[0x200F] = { unicodeslot=0x200F, category='cf', adobename='afii300', description='RIGHT-TO-LEFT MARK' },
	[0x2010] = { unicodeslot=0x2010, category='pd', description='HYPHEN' },
	[0x2011] = { unicodeslot=0x2011, category='pd', description='NON-BREAKING HYPHEN', specials={'nobreak',0x2010} },
	[0x2012] = { unicodeslot=0x2012, category='pd', adobename='figuredash', contextname='textminus', description='FIGURE DASH' },
	[0x2013] = { unicodeslot=0x2013, category='pd', adobename='endash', contextname='endash', description='EN DASH' },
	[0x2014] = { unicodeslot=0x2014, category='pd', adobename='emdash', contextname='emdash', description='EM DASH' },
	[0x2015] = { unicodeslot=0x2015, category='pd', adobename='afii00208', contextname='texthorizontalbar', description='HORIZONTAL BAR' },
	[0x2016] = { unicodeslot=0x2016, category='po', description='DOUBLE VERTICAL LINE' },
	[0x2017] = { unicodeslot=0x2017, category='po', adobename='underscoredbl', description='DOUBLE LOW LINE', specials={'compat',0x0020,0x0333} },
	[0x2018] = { unicodeslot=0x2018, category='pi', adobename='quoteleft', contextname='quoteleft', description='LEFT SINGLE QUOTATION MARK' },
	[0x2019] = { unicodeslot=0x2019, category='pf', adobename='quoteright', contextname='quoteright', description='RIGHT SINGLE QUOTATION MARK' },
	[0x201A] = { unicodeslot=0x201A, category='ps', adobename='quotesinglbase', contextname='quotesinglebase', description='SINGLE LOW-9 QUOTATION MARK' },
	[0x201B] = { unicodeslot=0x201B, category='pi', adobename='quotereversed', description='SINGLE HIGH-REVERSED-9 QUOTATION MARK' },
	[0x201C] = { unicodeslot=0x201C, category='pi', adobename='quotedblleft', contextname='quotedblleft', description='LEFT DOUBLE QUOTATION MARK' },
	[0x201D] = { unicodeslot=0x201D, category='pf', adobename='quotedblright', contextname='quotedblright', description='RIGHT DOUBLE QUOTATION MARK' },
	[0x201E] = { unicodeslot=0x201E, category='ps', adobename='quotedblbase', contextname='quotedblbase', description='DOUBLE LOW-9 QUOTATION MARK' },
	[0x201F] = { unicodeslot=0x201F, category='pi', description='DOUBLE HIGH-REVERSED-9 QUOTATION MARK' },
	[0x2020] = { unicodeslot=0x2020, category='po', adobename='dagger', contextname='textdag', description='DAGGER' },
	[0x2021] = { unicodeslot=0x2021, category='po', adobename='daggerdbl', contextname='textddag', description='DOUBLE DAGGER' },
	[0x2022] = { unicodeslot=0x2022, category='po', adobename='bullet', contextname='textbullet', description='BULLET' },
	[0x2023] = { unicodeslot=0x2023, category='po', description='TRIANGULAR BULLET' },
	[0x2024] = { unicodeslot=0x2024, category='po', adobename='onedotenleader', description='ONE DOT LEADER', specials={'compat',0x002E} },
	[0x2025] = { unicodeslot=0x2025, category='po', adobename='twodotenleader', description='TWO DOT LEADER', specials={'compat',0x002E,0x002E} },
	[0x2026] = { unicodeslot=0x2026, category='po', adobename='ellipsis', contextname='textellipsis', description='HORIZONTAL ELLIPSIS', specials={'compat',0x002E,0x002E,0x002E} },
	[0x2027] = { unicodeslot=0x2027, category='po', description='HYPHENATION POINT' },
	[0x2028] = { unicodeslot=0x2028, category='zl', description='LINE SEPARATOR' },
	[0x2029] = { unicodeslot=0x2029, category='zp', description='PARAGRAPH SEPARATOR' },
	[0x202A] = { unicodeslot=0x202A, category='cf', description='LEFT-TO-RIGHT EMBEDDING' },
	[0x202B] = { unicodeslot=0x202B, category='cf', description='RIGHT-TO-LEFT EMBEDDING' },
	[0x202C] = { unicodeslot=0x202C, category='cf', adobename='afii61573', description='POP DIRECTIONAL FORMATTING' },
	[0x202D] = { unicodeslot=0x202D, category='cf', adobename='afii61574', description='LEFT-TO-RIGHT OVERRIDE' },
	[0x202E] = { unicodeslot=0x202E, category='cf', adobename='afii61575', description='RIGHT-TO-LEFT OVERRIDE' },
	[0x202F] = { unicodeslot=0x202F, category='zs', description='NARROW NO-BREAK SPACE', specials={'nobreak',0x0020} },
	[0x2030] = { unicodeslot=0x2030, category='po', adobename='perthousand', contextname='perthousand', description='PER MILLE SIGN' },
	[0x2031] = { unicodeslot=0x2031, category='po', description='PER TEN THOUSAND SIGN' },
	[0x2032] = { unicodeslot=0x2032, category='po', adobename='minute', description='PRIME' },
	[0x2033] = { unicodeslot=0x2033, category='po', adobename='second', description='DOUBLE PRIME', specials={'compat',0x2032,0x2032} },
	[0x2034] = { unicodeslot=0x2034, category='po', description='TRIPLE PRIME', specials={'compat',0x2032,0x2032,0x2032} },
	[0x2035] = { unicodeslot=0x2035, category='po', description='REVERSED PRIME' },
	[0x2036] = { unicodeslot=0x2036, category='po', description='REVERSED DOUBLE PRIME', specials={'compat',0x2035,0x2035} },
	[0x2037] = { unicodeslot=0x2037, category='po', description='REVERSED TRIPLE PRIME', specials={'compat',0x2035,0x2035,0x2035} },
	[0x2038] = { unicodeslot=0x2038, category='po', description='CARET' },
	[0x2039] = { unicodeslot=0x2039, category='pi', adobename='guilsinglleft', contextname='guilsingleleft', description='SINGLE LEFT-POINTING ANGLE QUOTATION MARK' },
	[0x203A] = { unicodeslot=0x203A, category='pf', adobename='guilsinglright', contextname='guilsingleright', description='SINGLE RIGHT-POINTING ANGLE QUOTATION MARK' },
	[0x203B] = { unicodeslot=0x203B, category='po', description='REFERENCE MARK' },
	[0x203C] = { unicodeslot=0x203C, category='po', adobename='exclamdbl', description='DOUBLE EXCLAMATION MARK', specials={'compat',0x0021,0x0021} },
	[0x203D] = { unicodeslot=0x203D, category='po', description='INTERROBANG' },
	[0x203E] = { unicodeslot=0x203E, category='po', description='OVERLINE', specials={'compat',0x0020,0x0305} },
	[0x203F] = { unicodeslot=0x203F, category='pc', description='UNDERTIE' },
	[0x2040] = { unicodeslot=0x2040, category='pc', description='CHARACTER TIE' },
	[0x2041] = { unicodeslot=0x2041, category='po', description='CARET INSERTION POINT' },
	[0x2042] = { unicodeslot=0x2042, category='po', description='ASTERISM' },
	[0x2043] = { unicodeslot=0x2043, category='po', description='HYPHEN BULLET' },
	[0x2044] = { unicodeslot=0x2044, category='sm', adobename='fraction', description='FRACTION SLASH' },
	[0x2045] = { unicodeslot=0x2045, category='ps', description='LEFT SQUARE BRACKET WITH QUILL' },
	[0x2046] = { unicodeslot=0x2046, category='pe', description='RIGHT SQUARE BRACKET WITH QUILL' },
	[0x2047] = { unicodeslot=0x2047, category='po', description='DOUBLE QUESTION MARK', specials={'compat',0x003F,0x003F} },
	[0x2048] = { unicodeslot=0x2048, category='po', description='QUESTION EXCLAMATION MARK', specials={'compat',0x003F,0x0021} },
	[0x2049] = { unicodeslot=0x2049, category='po', description='EXCLAMATION QUESTION MARK', specials={'compat',0x0021,0x003F} },
	[0x204A] = { unicodeslot=0x204A, category='po', description='TIRONIAN SIGN ET' },
	[0x204B] = { unicodeslot=0x204B, category='po', description='REVERSED PILCROW SIGN' },
	[0x204C] = { unicodeslot=0x204C, category='po', description='BLACK LEFTWARDS BULLET' },
	[0x204D] = { unicodeslot=0x204D, category='po', description='BLACK RIGHTWARDS BULLET' },
	[0x204E] = { unicodeslot=0x204E, category='po', description='LOW ASTERISK' },
	[0x204F] = { unicodeslot=0x204F, category='po', description='REVERSED SEMICOLON' },
	[0x2050] = { unicodeslot=0x2050, category='po', description='CLOSE UP' },
	[0x2051] = { unicodeslot=0x2051, category='po', description='TWO ASTERISKS ALIGNED VERTICALLY' },
	[0x2052] = { unicodeslot=0x2052, category='sm', description='COMMERCIAL MINUS SIGN' },
	[0x2053] = { unicodeslot=0x2053, category='po', description='SWUNG DASH' },
	[0x2054] = { unicodeslot=0x2054, category='pc', description='INVERTED UNDERTIE' },
	[0x2055] = { unicodeslot=0x2055, category='po', description='FLOWER PUNCTUATION MARK' },
	[0x2056] = { unicodeslot=0x2056, category='po', description='THREE DOT PUNCTUATION' },
	[0x2057] = { unicodeslot=0x2057, category='po', description='QUADRUPLE PRIME', specials={'compat',0x2032,0x2032,0x2032,0x2032} },
	[0x2058] = { unicodeslot=0x2058, category='po', description='FOUR DOT PUNCTUATION' },
	[0x2059] = { unicodeslot=0x2059, category='po', description='FIVE DOT PUNCTUATION' },
	[0x205A] = { unicodeslot=0x205A, category='po', description='TWO DOT PUNCTUATION' },
	[0x205B] = { unicodeslot=0x205B, category='po', description='FOUR DOT MARK' },
	[0x205C] = { unicodeslot=0x205C, category='po', description='DOTTED CROSS' },
	[0x205D] = { unicodeslot=0x205D, category='po', description='TRICOLON' },
	[0x205E] = { unicodeslot=0x205E, category='po', description='VERTICAL FOUR DOTS' },
	[0x205F] = { unicodeslot=0x205F, category='zs', description='MEDIUM MATHEMATICAL SPACE', specials={'compat',0x0020} },
	[0x2060] = { unicodeslot=0x2060, category='cf', description='WORD JOINER' },
	[0x2061] = { unicodeslot=0x2061, category='cf', description='FUNCTION APPLICATION' },
	[0x2062] = { unicodeslot=0x2062, category='cf', description='INVISIBLE TIMES' },
	[0x2063] = { unicodeslot=0x2063, category='cf', description='INVISIBLE SEPARATOR' },
	[0x206A] = { unicodeslot=0x206A, category='cf', description='INHIBIT SYMMETRIC SWAPPING' },
	[0x206B] = { unicodeslot=0x206B, category='cf', description='ACTIVATE SYMMETRIC SWAPPING' },
	[0x206C] = { unicodeslot=0x206C, category='cf', description='INHIBIT ARABIC FORM SHAPING' },
	[0x206D] = { unicodeslot=0x206D, category='cf', description='ACTIVATE ARABIC FORM SHAPING' },
	[0x206E] = { unicodeslot=0x206E, category='cf', description='NATIONAL DIGIT SHAPES' },
	[0x206F] = { unicodeslot=0x206F, category='cf', description='NOMINAL DIGIT SHAPES' },
	[0x2070] = { unicodeslot=0x2070, category='no', description='SUPERSCRIPT ZERO', specials={'super',0x0030} },
	[0x2071] = { unicodeslot=0x2071, category='ll', description='SUPERSCRIPT LATIN SMALL LETTER I', specials={'super',0x0069} },
	[0x2074] = { unicodeslot=0x2074, category='no', description='SUPERSCRIPT FOUR', specials={'super',0x0034} },
	[0x2075] = { unicodeslot=0x2075, category='no', description='SUPERSCRIPT FIVE', specials={'super',0x0035} },
	[0x2076] = { unicodeslot=0x2076, category='no', description='SUPERSCRIPT SIX', specials={'super',0x0036} },
	[0x2077] = { unicodeslot=0x2077, category='no', description='SUPERSCRIPT SEVEN', specials={'super',0x0037} },
	[0x2078] = { unicodeslot=0x2078, category='no', description='SUPERSCRIPT EIGHT', specials={'super',0x0038} },
	[0x2079] = { unicodeslot=0x2079, category='no', description='SUPERSCRIPT NINE', specials={'super',0x0039} },
	[0x207A] = { unicodeslot=0x207A, category='sm', description='SUPERSCRIPT PLUS SIGN', specials={'super',0x002B} },
	[0x207B] = { unicodeslot=0x207B, category='sm', description='SUPERSCRIPT MINUS', specials={'super',0x2212} },
	[0x207C] = { unicodeslot=0x207C, category='sm', description='SUPERSCRIPT EQUALS SIGN', specials={'super',0x003D} },
	[0x207D] = { unicodeslot=0x207D, category='ps', description='SUPERSCRIPT LEFT PARENTHESIS', specials={'super',0x0028} },
	[0x207E] = { unicodeslot=0x207E, category='pe', description='SUPERSCRIPT RIGHT PARENTHESIS', specials={'super',0x0029} },
	[0x207F] = { unicodeslot=0x207F, category='ll', description='SUPERSCRIPT LATIN SMALL LETTER N', specials={'super',0x006E} },
	[0x2080] = { unicodeslot=0x2080, category='no', description='SUBSCRIPT ZERO', specials={'sub',0x0030} },
	[0x2081] = { unicodeslot=0x2081, category='no', description='SUBSCRIPT ONE', specials={'sub',0x0031} },
	[0x2082] = { unicodeslot=0x2082, category='no', description='SUBSCRIPT TWO', specials={'sub',0x0032} },
	[0x2083] = { unicodeslot=0x2083, category='no', description='SUBSCRIPT THREE', specials={'sub',0x0033} },
	[0x2084] = { unicodeslot=0x2084, category='no', description='SUBSCRIPT FOUR', specials={'sub',0x0034} },
	[0x2085] = { unicodeslot=0x2085, category='no', description='SUBSCRIPT FIVE', specials={'sub',0x0035} },
	[0x2086] = { unicodeslot=0x2086, category='no', description='SUBSCRIPT SIX', specials={'sub',0x0036} },
	[0x2087] = { unicodeslot=0x2087, category='no', description='SUBSCRIPT SEVEN', specials={'sub',0x0037} },
	[0x2088] = { unicodeslot=0x2088, category='no', description='SUBSCRIPT EIGHT', specials={'sub',0x0038} },
	[0x2089] = { unicodeslot=0x2089, category='no', description='SUBSCRIPT NINE', specials={'sub',0x0039} },
	[0x208A] = { unicodeslot=0x208A, category='sm', description='SUBSCRIPT PLUS SIGN', specials={'sub',0x002B} },
	[0x208B] = { unicodeslot=0x208B, category='sm', description='SUBSCRIPT MINUS', specials={'sub',0x2212} },
	[0x208C] = { unicodeslot=0x208C, category='sm', description='SUBSCRIPT EQUALS SIGN', specials={'sub',0x003D} },
	[0x208D] = { unicodeslot=0x208D, category='ps', description='SUBSCRIPT LEFT PARENTHESIS', specials={'sub',0x0028} },
	[0x208E] = { unicodeslot=0x208E, category='pe', description='SUBSCRIPT RIGHT PARENTHESIS', specials={'sub',0x0029} },
	[0x2090] = { unicodeslot=0x2090, category='lm', description='LATIN SUBSCRIPT SMALL LETTER A', specials={'sub',0x0061} },
	[0x2091] = { unicodeslot=0x2091, category='lm', description='LATIN SUBSCRIPT SMALL LETTER E', specials={'sub',0x0065} },
	[0x2092] = { unicodeslot=0x2092, category='lm', description='LATIN SUBSCRIPT SMALL LETTER O', specials={'sub',0x006F} },
	[0x2093] = { unicodeslot=0x2093, category='lm', description='LATIN SUBSCRIPT SMALL LETTER X', specials={'sub',0x0078} },
	[0x2094] = { unicodeslot=0x2094, category='lm', description='LATIN SUBSCRIPT SMALL LETTER SCHWA', specials={'sub',0x0259} },
	[0x20A0] = { unicodeslot=0x20A0, category='sc', description='EURO-CURRENCY SIGN' },
	[0x20A1] = { unicodeslot=0x20A1, category='sc', adobename='colonmonetary', description='COLON SIGN' },
	[0x20A2] = { unicodeslot=0x20A2, category='sc', description='CRUZEIRO SIGN' },
	[0x20A3] = { unicodeslot=0x20A3, category='sc', adobename='franc', description='FRENCH FRANC SIGN' },
	[0x20A4] = { unicodeslot=0x20A4, category='sc', adobename='lira', description='LIRA SIGN' },
	[0x20A5] = { unicodeslot=0x20A5, category='sc', description='MILL SIGN' },
	[0x20A6] = { unicodeslot=0x20A6, category='sc', description='NAIRA SIGN' },
	[0x20A7] = { unicodeslot=0x20A7, category='sc', adobename='peseta', description='PESETA SIGN' },
	[0x20A8] = { unicodeslot=0x20A8, category='sc', description='RUPEE SIGN', specials={'compat',0x0052,0x0073} },
	[0x20A9] = { unicodeslot=0x20A9, category='sc', description='WON SIGN' },
	[0x20AA] = { unicodeslot=0x20AA, category='sc', adobename='afii57636', description='NEW SHEQEL SIGN' },
	[0x20AB] = { unicodeslot=0x20AB, category='sc', adobename='dong', contextname='textdong', description='DONG SIGN' },
	[0x20AC] = { unicodeslot=0x20AC, category='sc', adobename='Euro', contextname='texteuro', description='EURO SIGN' },
	[0x20AD] = { unicodeslot=0x20AD, category='sc', description='KIP SIGN' },
	[0x20AE] = { unicodeslot=0x20AE, category='sc', description='TUGRIK SIGN' },
	[0x20AF] = { unicodeslot=0x20AF, category='sc', description='DRACHMA SIGN' },
	[0x20B0] = { unicodeslot=0x20B0, category='sc', description='GERMAN PENNY SIGN' },
	[0x20B1] = { unicodeslot=0x20B1, category='sc', description='PESO SIGN' },
	[0x20B2] = { unicodeslot=0x20B2, category='sc', description='GUARANI SIGN' },
	[0x20B3] = { unicodeslot=0x20B3, category='sc', description='AUSTRAL SIGN' },
	[0x20B4] = { unicodeslot=0x20B4, category='sc', description='HRYVNIA SIGN' },
	[0x20B5] = { unicodeslot=0x20B5, category='sc', description='CEDI SIGN' },
	[0x20D0] = { unicodeslot=0x20D0, category='mn', description='COMBINING LEFT HARPOON ABOVE' },
	[0x20D1] = { unicodeslot=0x20D1, category='mn', description='COMBINING RIGHT HARPOON ABOVE' },
	[0x20D2] = { unicodeslot=0x20D2, category='mn', description='COMBINING LONG VERTICAL LINE OVERLAY' },
	[0x20D3] = { unicodeslot=0x20D3, category='mn', description='COMBINING SHORT VERTICAL LINE OVERLAY' },
	[0x20D4] = { unicodeslot=0x20D4, category='mn', description='COMBINING ANTICLOCKWISE ARROW ABOVE' },
	[0x20D5] = { unicodeslot=0x20D5, category='mn', description='COMBINING CLOCKWISE ARROW ABOVE' },
	[0x20D6] = { unicodeslot=0x20D6, category='mn', description='COMBINING LEFT ARROW ABOVE' },
	[0x20D7] = { unicodeslot=0x20D7, category='mn', description='COMBINING RIGHT ARROW ABOVE' },
	[0x20D8] = { unicodeslot=0x20D8, category='mn', description='COMBINING RING OVERLAY' },
	[0x20D9] = { unicodeslot=0x20D9, category='mn', description='COMBINING CLOCKWISE RING OVERLAY' },
	[0x20DA] = { unicodeslot=0x20DA, category='mn', description='COMBINING ANTICLOCKWISE RING OVERLAY' },
	[0x20DB] = { unicodeslot=0x20DB, category='mn', description='COMBINING THREE DOTS ABOVE' },
	[0x20DC] = { unicodeslot=0x20DC, category='mn', description='COMBINING FOUR DOTS ABOVE' },
	[0x20DD] = { unicodeslot=0x20DD, category='me', description='COMBINING ENCLOSING CIRCLE' },
	[0x20DE] = { unicodeslot=0x20DE, category='me', description='COMBINING ENCLOSING SQUARE' },
	[0x20DF] = { unicodeslot=0x20DF, category='me', description='COMBINING ENCLOSING DIAMOND' },
	[0x20E0] = { unicodeslot=0x20E0, category='me', description='COMBINING ENCLOSING CIRCLE BACKSLASH' },
	[0x20E1] = { unicodeslot=0x20E1, category='mn', description='COMBINING LEFT RIGHT ARROW ABOVE' },
	[0x20E2] = { unicodeslot=0x20E2, category='me', description='COMBINING ENCLOSING SCREEN' },
	[0x20E3] = { unicodeslot=0x20E3, category='me', description='COMBINING ENCLOSING KEYCAP' },
	[0x20E4] = { unicodeslot=0x20E4, category='me', description='COMBINING ENCLOSING UPWARD POINTING TRIANGLE' },
	[0x20E5] = { unicodeslot=0x20E5, category='mn', description='COMBINING REVERSE SOLIDUS OVERLAY' },
	[0x20E6] = { unicodeslot=0x20E6, category='mn', description='COMBINING DOUBLE VERTICAL STROKE OVERLAY' },
	[0x20E7] = { unicodeslot=0x20E7, category='mn', description='COMBINING ANNUITY SYMBOL' },
	[0x20E8] = { unicodeslot=0x20E8, category='mn', description='COMBINING TRIPLE UNDERDOT' },
	[0x20E9] = { unicodeslot=0x20E9, category='mn', description='COMBINING WIDE BRIDGE ABOVE' },
	[0x20EA] = { unicodeslot=0x20EA, category='mn', description='COMBINING LEFTWARDS ARROW OVERLAY' },
	[0x20EB] = { unicodeslot=0x20EB, category='mn', description='COMBINING LONG DOUBLE SOLIDUS OVERLAY' },
	[0x20EC] = { unicodeslot=0x20EC, category='mn', description='COMBINING RIGHTWARDS HARPOON WITH BARB DOWNWARDS' },
	[0x20ED] = { unicodeslot=0x20ED, category='mn', description='COMBINING LEFTWARDS HARPOON WITH BARB DOWNWARDS' },
	[0x20EE] = { unicodeslot=0x20EE, category='mn', description='COMBINING LEFT ARROW BELOW' },
	[0x20EF] = { unicodeslot=0x20EF, category='mn', description='COMBINING RIGHT ARROW BELOW' },
	[0x2100] = { unicodeslot=0x2100, category='so', description='ACCOUNT OF', specials={'compat',0x0061,0x002F,0x0063} },
	[0x2101] = { unicodeslot=0x2101, category='so', description='ADDRESSED TO THE SUBJECT', specials={'compat',0x0061,0x002F,0x0073} },
	[0x2102] = { unicodeslot=0x2102, category='lu', description='DOUBLE-STRUCK CAPITAL C', specials={'font',0x0043} },
	[0x2103] = { unicodeslot=0x2103, category='so', description='DEGREE CELSIUS', specials={'compat',0x00B0,0x0043} },
	[0x2104] = { unicodeslot=0x2104, category='so', description='CENTRE LINE SYMBOL' },
	[0x2105] = { unicodeslot=0x2105, category='so', adobename='afii61248', description='CARE OF', specials={'compat',0x0063,0x002F,0x006F} },
	[0x2106] = { unicodeslot=0x2106, category='so', description='CADA UNA', specials={'compat',0x0063,0x002F,0x0075} },
	[0x2107] = { unicodeslot=0x2107, category='lu', description='EULER CONSTANT', specials={'compat',0x0190} },
	[0x2108] = { unicodeslot=0x2108, category='so', description='SCRUPLE' },
	[0x2109] = { unicodeslot=0x2109, category='so', description='DEGREE FAHRENHEIT', specials={'compat',0x00B0,0x0046} },
	[0x210A] = { unicodeslot=0x210A, category='ll', description='SCRIPT SMALL G', specials={'font',0x0067} },
	[0x210B] = { unicodeslot=0x210B, category='lu', description='SCRIPT CAPITAL H', specials={'font',0x0048} },
	[0x210C] = { unicodeslot=0x210C, category='lu', description='BLACK-LETTER CAPITAL H', specials={'font',0x0048} },
	[0x210D] = { unicodeslot=0x210D, category='lu', description='DOUBLE-STRUCK CAPITAL H', specials={'font',0x0048} },
	[0x210E] = { unicodeslot=0x210E, category='ll', description='PLANCK CONSTANT', specials={'font',0x0068} },
	[0x210F] = { unicodeslot=0x210F, category='ll', description='PLANCK CONSTANT OVER TWO PI', specials={'font',0x0127} },
	[0x2110] = { unicodeslot=0x2110, category='lu', description='SCRIPT CAPITAL I', specials={'font',0x0049} },
	[0x2111] = { unicodeslot=0x2111, category='lu', adobename='Ifraktur', description='BLACK-LETTER CAPITAL I', specials={'font',0x0049} },
	[0x2112] = { unicodeslot=0x2112, category='lu', description='SCRIPT CAPITAL L', specials={'font',0x004C} },
	[0x2113] = { unicodeslot=0x2113, category='ll', adobename='afii61289', description='SCRIPT SMALL L', specials={'font',0x006C} },
	[0x2114] = { unicodeslot=0x2114, category='so', description='L B BAR SYMBOL' },
	[0x2115] = { unicodeslot=0x2115, category='lu', description='DOUBLE-STRUCK CAPITAL N', specials={'font',0x004E} },
	[0x2116] = { unicodeslot=0x2116, category='so', adobename='afii61352', contextname='textnumero', description='NUMERO SIGN', specials={'compat',0x004E,0x006F} },
	[0x2117] = { unicodeslot=0x2117, category='so', description='SOUND RECORDING COPYRIGHT' },
	[0x2118] = { unicodeslot=0x2118, category='so', adobename='weierstrass', description='SCRIPT CAPITAL P' },
	[0x2119] = { unicodeslot=0x2119, category='lu', description='DOUBLE-STRUCK CAPITAL P', specials={'font',0x0050} },
	[0x211A] = { unicodeslot=0x211A, category='lu', description='DOUBLE-STRUCK CAPITAL Q', specials={'font',0x0051} },
	[0x211B] = { unicodeslot=0x211B, category='lu', description='SCRIPT CAPITAL R', specials={'font',0x0052} },
	[0x211C] = { unicodeslot=0x211C, category='lu', adobename='Rfraktur', description='BLACK-LETTER CAPITAL R', specials={'font',0x0052} },
	[0x211D] = { unicodeslot=0x211D, category='lu', description='DOUBLE-STRUCK CAPITAL R', specials={'font',0x0052} },
	[0x211E] = { unicodeslot=0x211E, category='so', adobename='prescription', description='PRESCRIPTION TAKE' },
	[0x211F] = { unicodeslot=0x211F, category='so', description='RESPONSE' },
	[0x2120] = { unicodeslot=0x2120, category='so', description='SERVICE MARK', specials={'super',0x0053,0x004D} },
	[0x2121] = { unicodeslot=0x2121, category='so', description='TELEPHONE SIGN', specials={'compat',0x0054,0x0045,0x004C} },
	[0x2122] = { unicodeslot=0x2122, category='so', adobename='trademark', contextname='trademark', description='TRADE MARK SIGN', specials={'super',0x0054,0x004D} },
	[0x2123] = { unicodeslot=0x2123, category='so', description='VERSICLE' },
	[0x2124] = { unicodeslot=0x2124, category='lu', description='DOUBLE-STRUCK CAPITAL Z', specials={'font',0x005A} },
	[0x2125] = { unicodeslot=0x2125, category='so', description='OUNCE SIGN' },
	[0x2126] = { unicodeslot=0x2126, category='lu', adobename='Omega', description='OHM SIGN', lccode=0x03C9, specials={'char',0x03A9} },
	[0x2127] = { unicodeslot=0x2127, category='so', description='INVERTED OHM SIGN' },
	[0x2128] = { unicodeslot=0x2128, category='lu', description='BLACK-LETTER CAPITAL Z', specials={'font',0x005A} },
	[0x2129] = { unicodeslot=0x2129, category='so', description='TURNED GREEK SMALL LETTER IOTA' },
	[0x212A] = { unicodeslot=0x212A, category='lu', description='KELVIN SIGN', lccode=0x006B, specials={'char',0x004B} },
	[0x212B] = { unicodeslot=0x212B, category='lu', description='ANGSTROM SIGN', lccode=0x00E5, specials={'char',0x00C5} },
	[0x212C] = { unicodeslot=0x212C, category='lu', description='SCRIPT CAPITAL B', specials={'font',0x0042} },
	[0x212D] = { unicodeslot=0x212D, category='lu', description='BLACK-LETTER CAPITAL C', specials={'font',0x0043} },
	[0x212E] = { unicodeslot=0x212E, category='so', adobename='estimated', description='ESTIMATED SYMBOL' },
	[0x212F] = { unicodeslot=0x212F, category='ll', description='SCRIPT SMALL E', specials={'font',0x0065} },
	[0x2130] = { unicodeslot=0x2130, category='lu', description='SCRIPT CAPITAL E', specials={'font',0x0045} },
	[0x2131] = { unicodeslot=0x2131, category='lu', description='SCRIPT CAPITAL F', specials={'font',0x0046} },
	[0x2132] = { unicodeslot=0x2132, category='lu', description='TURNED CAPITAL F', lccode=0x214E },
	[0x2133] = { unicodeslot=0x2133, category='lu', description='SCRIPT CAPITAL M', specials={'font',0x004D} },
	[0x2134] = { unicodeslot=0x2134, category='ll', description='SCRIPT SMALL O', specials={'font',0x006F} },
	[0x2135] = { unicodeslot=0x2135, category='lo', adobename='aleph', description='ALEF SYMBOL', specials={'compat',0x05D0} },
	[0x2136] = { unicodeslot=0x2136, category='lo', description='BET SYMBOL', specials={'compat',0x05D1} },
	[0x2137] = { unicodeslot=0x2137, category='lo', description='GIMEL SYMBOL', specials={'compat',0x05D2} },
	[0x2138] = { unicodeslot=0x2138, category='lo', description='DALET SYMBOL', specials={'compat',0x05D3} },
	[0x2139] = { unicodeslot=0x2139, category='ll', description='INFORMATION SOURCE', specials={'font',0x0069} },
	[0x213A] = { unicodeslot=0x213A, category='so', description='ROTATED CAPITAL Q' },
	[0x213B] = { unicodeslot=0x213B, category='so', description='FACSIMILE SIGN', specials={'compat',0x0046,0x0041,0x0058} },
	[0x213C] = { unicodeslot=0x213C, category='ll', description='DOUBLE-STRUCK SMALL PI', specials={'font',0x03C0} },
	[0x213D] = { unicodeslot=0x213D, category='ll', description='DOUBLE-STRUCK SMALL GAMMA', specials={'font',0x03B3} },
	[0x213E] = { unicodeslot=0x213E, category='lu', description='DOUBLE-STRUCK CAPITAL GAMMA', specials={'font',0x0393} },
	[0x213F] = { unicodeslot=0x213F, category='lu', description='DOUBLE-STRUCK CAPITAL PI', specials={'font',0x03A0} },
	[0x2140] = { unicodeslot=0x2140, category='sm', description='DOUBLE-STRUCK N-ARY SUMMATION', specials={'font',0x2211} },
	[0x2141] = { unicodeslot=0x2141, category='sm', description='TURNED SANS-SERIF CAPITAL G' },
	[0x2142] = { unicodeslot=0x2142, category='sm', description='TURNED SANS-SERIF CAPITAL L' },
	[0x2143] = { unicodeslot=0x2143, category='sm', description='REVERSED SANS-SERIF CAPITAL L' },
	[0x2144] = { unicodeslot=0x2144, category='sm', description='TURNED SANS-SERIF CAPITAL Y' },
	[0x2145] = { unicodeslot=0x2145, category='lu', description='DOUBLE-STRUCK ITALIC CAPITAL D', specials={'font',0x0044} },
	[0x2146] = { unicodeslot=0x2146, category='ll', description='DOUBLE-STRUCK ITALIC SMALL D', specials={'font',0x0064} },
	[0x2147] = { unicodeslot=0x2147, category='ll', description='DOUBLE-STRUCK ITALIC SMALL E', specials={'font',0x0065} },
	[0x2148] = { unicodeslot=0x2148, category='ll', description='DOUBLE-STRUCK ITALIC SMALL I', specials={'font',0x0069} },
	[0x2149] = { unicodeslot=0x2149, category='ll', description='DOUBLE-STRUCK ITALIC SMALL J', specials={'font',0x006A} },
	[0x214A] = { unicodeslot=0x214A, category='so', description='PROPERTY LINE' },
	[0x214B] = { unicodeslot=0x214B, category='sm', description='TURNED AMPERSAND' },
	[0x214C] = { unicodeslot=0x214C, category='so', description='PER SIGN' },
	[0x214D] = { unicodeslot=0x214D, category='so', description='AKTIESELSKAB' },
	[0x214E] = { unicodeslot=0x214E, category='ll', description='TURNED SMALL F', uccode=0x2132 },
	[0x2153] = { unicodeslot=0x2153, category='no', adobename='onethird', contextname='onethird', description='VULGAR FRACTION ONE THIRD', specials={'fraction',0x0031,0x2044,0x0033} },
	[0x2154] = { unicodeslot=0x2154, category='no', adobename='twothirds', contextname='twothirds', description='VULGAR FRACTION TWO THIRDS', specials={'fraction',0x0032,0x2044,0x0033} },
	[0x2155] = { unicodeslot=0x2155, category='no', contextname='onefifth', description='VULGAR FRACTION ONE FIFTH', specials={'fraction',0x0031,0x2044,0x0035} },
	[0x2156] = { unicodeslot=0x2156, category='no', contextname='twofifths', description='VULGAR FRACTION TWO FIFTHS', specials={'fraction',0x0032,0x2044,0x0035} },
	[0x2157] = { unicodeslot=0x2157, category='no', contextname='threefifths', description='VULGAR FRACTION THREE FIFTHS', specials={'fraction',0x0033,0x2044,0x0035} },
	[0x2158] = { unicodeslot=0x2158, category='no', contextname='fourfifths', description='VULGAR FRACTION FOUR FIFTHS', specials={'fraction',0x0034,0x2044,0x0035} },
	[0x2159] = { unicodeslot=0x2159, category='no', contextname='onesixth', description='VULGAR FRACTION ONE SIXTH', specials={'fraction',0x0031,0x2044,0x0036} },
	[0x215A] = { unicodeslot=0x215A, category='no', contextname='fivesixths', description='VULGAR FRACTION FIVE SIXTHS', specials={'fraction',0x0035,0x2044,0x0036} },
	[0x215B] = { unicodeslot=0x215B, category='no', adobename='oneeighth', contextname='oneeighth', description='VULGAR FRACTION ONE EIGHTH', specials={'fraction',0x0031,0x2044,0x0038} },
	[0x215C] = { unicodeslot=0x215C, category='no', adobename='threeeighths', contextname='threeeighths', description='VULGAR FRACTION THREE EIGHTHS', specials={'fraction',0x0033,0x2044,0x0038} },
	[0x215D] = { unicodeslot=0x215D, category='no', adobename='fiveeighths', contextname='fiveeighths', description='VULGAR FRACTION FIVE EIGHTHS', specials={'fraction',0x0035,0x2044,0x0038} },
	[0x215E] = { unicodeslot=0x215E, category='no', adobename='seveneighths', contextname='seveneighths', description='VULGAR FRACTION SEVEN EIGHTHS', specials={'fraction',0x0037,0x2044,0x0038} },
	[0x215F] = { unicodeslot=0x215F, category='no', description='FRACTION NUMERATOR ONE', specials={'fraction',0x0031,0x2044} },
	[0x2160] = { unicodeslot=0x2160, category='nl', contextname='romanI', description='ROMAN NUMERAL ONE', lccode=0x2170, specials={'compat',0x0049} },
	[0x2161] = { unicodeslot=0x2161, category='nl', contextname='romanII', description='ROMAN NUMERAL TWO', lccode=0x2171, specials={'compat',0x0049,0x0049} },
	[0x2162] = { unicodeslot=0x2162, category='nl', contextname='romanIII', description='ROMAN NUMERAL THREE', lccode=0x2172, specials={'compat',0x0049,0x0049,0x0049} },
	[0x2163] = { unicodeslot=0x2163, category='nl', contextname='romanIV', description='ROMAN NUMERAL FOUR', lccode=0x2173, specials={'compat',0x0049,0x0056} },
	[0x2164] = { unicodeslot=0x2164, category='nl', contextname='romanV', description='ROMAN NUMERAL FIVE', lccode=0x2174, specials={'compat',0x0056} },
	[0x2165] = { unicodeslot=0x2165, category='nl', contextname='romanVI', description='ROMAN NUMERAL SIX', lccode=0x2175, specials={'compat',0x0056,0x0049} },
	[0x2166] = { unicodeslot=0x2166, category='nl', contextname='romanVII', description='ROMAN NUMERAL SEVEN', lccode=0x2176, specials={'compat',0x0056,0x0049,0x0049} },
	[0x2167] = { unicodeslot=0x2167, category='nl', contextname='romanVIII', description='ROMAN NUMERAL EIGHT', lccode=0x2177, specials={'compat',0x0056,0x0049,0x0049,0x0049} },
	[0x2168] = { unicodeslot=0x2168, category='nl', contextname='romanIX', description='ROMAN NUMERAL NINE', lccode=0x2178, specials={'compat',0x0049,0x0058} },
	[0x2169] = { unicodeslot=0x2169, category='nl', contextname='romanX', description='ROMAN NUMERAL TEN', lccode=0x2179, specials={'compat',0x0058} },
	[0x216A] = { unicodeslot=0x216A, category='nl', contextname='romanXI', description='ROMAN NUMERAL ELEVEN', lccode=0x217A, specials={'compat',0x0058,0x0049} },
	[0x216B] = { unicodeslot=0x216B, category='nl', contextname='romanXII', description='ROMAN NUMERAL TWELVE', lccode=0x217B, specials={'compat',0x0058,0x0049,0x0049} },
	[0x216C] = { unicodeslot=0x216C, category='nl', contextname='romanL', description='ROMAN NUMERAL FIFTY', lccode=0x217C, specials={'compat',0x004C} },
	[0x216D] = { unicodeslot=0x216D, category='nl', contextname='romanC', description='ROMAN NUMERAL ONE HUNDRED', lccode=0x217D, specials={'compat',0x0043} },
	[0x216E] = { unicodeslot=0x216E, category='nl', contextname='romanD', description='ROMAN NUMERAL FIVE HUNDRED', lccode=0x217E, specials={'compat',0x0044} },
	[0x216F] = { unicodeslot=0x216F, category='nl', contextname='romanM', description='ROMAN NUMERAL ONE THOUSAND', lccode=0x217F, specials={'compat',0x004D} },
	[0x2170] = { unicodeslot=0x2170, category='nl', contextname='romani', description='SMALL ROMAN NUMERAL ONE', uccode=0x2160, specials={'compat',0x0069} },
	[0x2171] = { unicodeslot=0x2171, category='nl', contextname='romanii', description='SMALL ROMAN NUMERAL TWO', uccode=0x2161, specials={'compat',0x0069,0x0069} },
	[0x2172] = { unicodeslot=0x2172, category='nl', contextname='romaniii', description='SMALL ROMAN NUMERAL THREE', uccode=0x2162, specials={'compat',0x0069,0x0069,0x0069} },
	[0x2173] = { unicodeslot=0x2173, category='nl', contextname='romaniv', description='SMALL ROMAN NUMERAL FOUR', uccode=0x2163, specials={'compat',0x0069,0x0076} },
	[0x2174] = { unicodeslot=0x2174, category='nl', contextname='romanv', description='SMALL ROMAN NUMERAL FIVE', uccode=0x2164, specials={'compat',0x0076} },
	[0x2175] = { unicodeslot=0x2175, category='nl', contextname='romanvi', description='SMALL ROMAN NUMERAL SIX', uccode=0x2165, specials={'compat',0x0076,0x0069} },
	[0x2176] = { unicodeslot=0x2176, category='nl', contextname='romanvii', description='SMALL ROMAN NUMERAL SEVEN', uccode=0x2166, specials={'compat',0x0076,0x0069,0x0069} },
	[0x2177] = { unicodeslot=0x2177, category='nl', contextname='romanviii', description='SMALL ROMAN NUMERAL EIGHT', uccode=0x2167, specials={'compat',0x0076,0x0069,0x0069,0x0069} },
	[0x2178] = { unicodeslot=0x2178, category='nl', contextname='romanix', description='SMALL ROMAN NUMERAL NINE', uccode=0x2168, specials={'compat',0x0069,0x0078} },
	[0x2179] = { unicodeslot=0x2179, category='nl', contextname='romanx', description='SMALL ROMAN NUMERAL TEN', uccode=0x2169, specials={'compat',0x0078} },
	[0x217A] = { unicodeslot=0x217A, category='nl', contextname='romanxi', description='SMALL ROMAN NUMERAL ELEVEN', uccode=0x216A, specials={'compat',0x0078,0x0069} },
	[0x217B] = { unicodeslot=0x217B, category='nl', contextname='romanxii', description='SMALL ROMAN NUMERAL TWELVE', uccode=0x216B, specials={'compat',0x0078,0x0069,0x0069} },
	[0x217C] = { unicodeslot=0x217C, category='nl', contextname='romanl', description='SMALL ROMAN NUMERAL FIFTY', uccode=0x216C, specials={'compat',0x006C} },
	[0x217D] = { unicodeslot=0x217D, category='nl', contextname='romanc', description='SMALL ROMAN NUMERAL ONE HUNDRED', uccode=0x216D, specials={'compat',0x0063} },
	[0x217E] = { unicodeslot=0x217E, category='nl', contextname='romand', description='SMALL ROMAN NUMERAL FIVE HUNDRED', uccode=0x216E, specials={'compat',0x0064} },
	[0x217F] = { unicodeslot=0x217F, category='nl', contextname='romanm', description='SMALL ROMAN NUMERAL ONE THOUSAND', uccode=0x216F, specials={'compat',0x006D} },
	[0x2180] = { unicodeslot=0x2180, category='nl', description='ROMAN NUMERAL ONE THOUSAND C D' },
	[0x2181] = { unicodeslot=0x2181, category='nl', description='ROMAN NUMERAL FIVE THOUSAND' },
	[0x2182] = { unicodeslot=0x2182, category='nl', description='ROMAN NUMERAL TEN THOUSAND' },
	[0x2183] = { unicodeslot=0x2183, category='lu', description='ROMAN NUMERAL REVERSED ONE HUNDRED', lccode=0x2184 },
	[0x2184] = { unicodeslot=0x2184, category='ll', description='LATIN SMALL LETTER REVERSED C', uccode=0x2183 },
	[0x2190] = { unicodeslot=0x2190, category='sm', adobename='arrowleft', description='LEFTWARDS ARROW' },
	[0x2191] = { unicodeslot=0x2191, category='sm', adobename='arrowup', description='UPWARDS ARROW' },
	[0x2192] = { unicodeslot=0x2192, category='sm', adobename='arrowright', description='RIGHTWARDS ARROW' },
	[0x2193] = { unicodeslot=0x2193, category='sm', adobename='arrowdown', description='DOWNWARDS ARROW' },
	[0x2194] = { unicodeslot=0x2194, category='sm', adobename='arrowboth', description='LEFT RIGHT ARROW' },
	[0x2195] = { unicodeslot=0x2195, category='so', adobename='arrowupdn', description='UP DOWN ARROW' },
	[0x2196] = { unicodeslot=0x2196, category='so', description='NORTH WEST ARROW' },
	[0x2197] = { unicodeslot=0x2197, category='so', description='NORTH EAST ARROW' },
	[0x2198] = { unicodeslot=0x2198, category='so', description='SOUTH EAST ARROW' },
	[0x2199] = { unicodeslot=0x2199, category='so', description='SOUTH WEST ARROW' },
	[0x219A] = { unicodeslot=0x219A, category='sm', description='LEFTWARDS ARROW WITH STROKE', specials={'char',0x2190,0x0338} },
	[0x219B] = { unicodeslot=0x219B, category='sm', description='RIGHTWARDS ARROW WITH STROKE', specials={'char',0x2192,0x0338} },
	[0x219C] = { unicodeslot=0x219C, category='so', description='LEFTWARDS WAVE ARROW' },
	[0x219D] = { unicodeslot=0x219D, category='so', description='RIGHTWARDS WAVE ARROW' },
	[0x219E] = { unicodeslot=0x219E, category='so', description='LEFTWARDS TWO HEADED ARROW' },
	[0x219F] = { unicodeslot=0x219F, category='so', description='UPWARDS TWO HEADED ARROW' },
	[0x21A0] = { unicodeslot=0x21A0, category='sm', description='RIGHTWARDS TWO HEADED ARROW' },
	[0x21A1] = { unicodeslot=0x21A1, category='so', description='DOWNWARDS TWO HEADED ARROW' },
	[0x21A2] = { unicodeslot=0x21A2, category='so', description='LEFTWARDS ARROW WITH TAIL' },
	[0x21A3] = { unicodeslot=0x21A3, category='sm', description='RIGHTWARDS ARROW WITH TAIL' },
	[0x21A4] = { unicodeslot=0x21A4, category='so', description='LEFTWARDS ARROW FROM BAR' },
	[0x21A5] = { unicodeslot=0x21A5, category='so', description='UPWARDS ARROW FROM BAR' },
	[0x21A6] = { unicodeslot=0x21A6, category='sm', description='RIGHTWARDS ARROW FROM BAR' },
	[0x21A7] = { unicodeslot=0x21A7, category='so', description='DOWNWARDS ARROW FROM BAR' },
	[0x21A8] = { unicodeslot=0x21A8, category='so', adobename='arrowupdnbse', description='UP DOWN ARROW WITH BASE' },
	[0x21A9] = { unicodeslot=0x21A9, category='so', description='LEFTWARDS ARROW WITH HOOK' },
	[0x21AA] = { unicodeslot=0x21AA, category='so', description='RIGHTWARDS ARROW WITH HOOK' },
	[0x21AB] = { unicodeslot=0x21AB, category='so', description='LEFTWARDS ARROW WITH LOOP' },
	[0x21AC] = { unicodeslot=0x21AC, category='so', description='RIGHTWARDS ARROW WITH LOOP' },
	[0x21AD] = { unicodeslot=0x21AD, category='so', description='LEFT RIGHT WAVE ARROW' },
	[0x21AE] = { unicodeslot=0x21AE, category='sm', description='LEFT RIGHT ARROW WITH STROKE', specials={'char',0x2194,0x0338} },
	[0x21AF] = { unicodeslot=0x21AF, category='so', description='DOWNWARDS ZIGZAG ARROW' },
	[0x21B0] = { unicodeslot=0x21B0, category='so', description='UPWARDS ARROW WITH TIP LEFTWARDS' },
	[0x21B1] = { unicodeslot=0x21B1, category='so', description='UPWARDS ARROW WITH TIP RIGHTWARDS' },
	[0x21B2] = { unicodeslot=0x21B2, category='so', description='DOWNWARDS ARROW WITH TIP LEFTWARDS' },
	[0x21B3] = { unicodeslot=0x21B3, category='so', description='DOWNWARDS ARROW WITH TIP RIGHTWARDS' },
	[0x21B4] = { unicodeslot=0x21B4, category='so', description='RIGHTWARDS ARROW WITH CORNER DOWNWARDS' },
	[0x21B5] = { unicodeslot=0x21B5, category='so', adobename='carriagereturn', description='DOWNWARDS ARROW WITH CORNER LEFTWARDS' },
	[0x21B6] = { unicodeslot=0x21B6, category='so', description='ANTICLOCKWISE TOP SEMICIRCLE ARROW' },
	[0x21B7] = { unicodeslot=0x21B7, category='so', description='CLOCKWISE TOP SEMICIRCLE ARROW' },
	[0x21B8] = { unicodeslot=0x21B8, category='so', description='NORTH WEST ARROW TO LONG BAR' },
	[0x21B9] = { unicodeslot=0x21B9, category='so', description='LEFTWARDS ARROW TO BAR OVER RIGHTWARDS ARROW TO BAR' },
	[0x21BA] = { unicodeslot=0x21BA, category='so', description='ANTICLOCKWISE OPEN CIRCLE ARROW' },
	[0x21BB] = { unicodeslot=0x21BB, category='so', description='CLOCKWISE OPEN CIRCLE ARROW' },
	[0x21BC] = { unicodeslot=0x21BC, category='so', description='LEFTWARDS HARPOON WITH BARB UPWARDS' },
	[0x21BD] = { unicodeslot=0x21BD, category='so', description='LEFTWARDS HARPOON WITH BARB DOWNWARDS' },
	[0x21BE] = { unicodeslot=0x21BE, category='so', description='UPWARDS HARPOON WITH BARB RIGHTWARDS' },
	[0x21BF] = { unicodeslot=0x21BF, category='so', description='UPWARDS HARPOON WITH BARB LEFTWARDS' },
	[0x21C0] = { unicodeslot=0x21C0, category='so', description='RIGHTWARDS HARPOON WITH BARB UPWARDS' },
	[0x21C1] = { unicodeslot=0x21C1, category='so', description='RIGHTWARDS HARPOON WITH BARB DOWNWARDS' },
	[0x21C2] = { unicodeslot=0x21C2, category='so', description='DOWNWARDS HARPOON WITH BARB RIGHTWARDS' },
	[0x21C3] = { unicodeslot=0x21C3, category='so', description='DOWNWARDS HARPOON WITH BARB LEFTWARDS' },
	[0x21C4] = { unicodeslot=0x21C4, category='so', description='RIGHTWARDS ARROW OVER LEFTWARDS ARROW' },
	[0x21C5] = { unicodeslot=0x21C5, category='so', description='UPWARDS ARROW LEFTWARDS OF DOWNWARDS ARROW' },
	[0x21C6] = { unicodeslot=0x21C6, category='so', description='LEFTWARDS ARROW OVER RIGHTWARDS ARROW' },
	[0x21C7] = { unicodeslot=0x21C7, category='so', description='LEFTWARDS PAIRED ARROWS' },
	[0x21C8] = { unicodeslot=0x21C8, category='so', description='UPWARDS PAIRED ARROWS' },
	[0x21C9] = { unicodeslot=0x21C9, category='so', description='RIGHTWARDS PAIRED ARROWS' },
	[0x21CA] = { unicodeslot=0x21CA, category='so', description='DOWNWARDS PAIRED ARROWS' },
	[0x21CB] = { unicodeslot=0x21CB, category='so', description='LEFTWARDS HARPOON OVER RIGHTWARDS HARPOON' },
	[0x21CC] = { unicodeslot=0x21CC, category='so', description='RIGHTWARDS HARPOON OVER LEFTWARDS HARPOON' },
	[0x21CD] = { unicodeslot=0x21CD, category='so', description='LEFTWARDS DOUBLE ARROW WITH STROKE', specials={'char',0x21D0,0x0338} },
	[0x21CE] = { unicodeslot=0x21CE, category='sm', description='LEFT RIGHT DOUBLE ARROW WITH STROKE', specials={'char',0x21D4,0x0338} },
	[0x21CF] = { unicodeslot=0x21CF, category='sm', description='RIGHTWARDS DOUBLE ARROW WITH STROKE', specials={'char',0x21D2,0x0338} },
	[0x21D0] = { unicodeslot=0x21D0, category='so', adobename='arrowdblleft', description='LEFTWARDS DOUBLE ARROW' },
	[0x21D1] = { unicodeslot=0x21D1, category='so', adobename='arrowdblup', description='UPWARDS DOUBLE ARROW' },
	[0x21D2] = { unicodeslot=0x21D2, category='sm', adobename='arrowdblright', description='RIGHTWARDS DOUBLE ARROW' },
	[0x21D3] = { unicodeslot=0x21D3, category='so', adobename='arrowdbldown', description='DOWNWARDS DOUBLE ARROW' },
	[0x21D4] = { unicodeslot=0x21D4, category='sm', adobename='arrowdblboth', description='LEFT RIGHT DOUBLE ARROW' },
	[0x21D5] = { unicodeslot=0x21D5, category='so', description='UP DOWN DOUBLE ARROW' },
	[0x21D6] = { unicodeslot=0x21D6, category='so', description='NORTH WEST DOUBLE ARROW' },
	[0x21D7] = { unicodeslot=0x21D7, category='so', description='NORTH EAST DOUBLE ARROW' },
	[0x21D8] = { unicodeslot=0x21D8, category='so', description='SOUTH EAST DOUBLE ARROW' },
	[0x21D9] = { unicodeslot=0x21D9, category='so', description='SOUTH WEST DOUBLE ARROW' },
	[0x21DA] = { unicodeslot=0x21DA, category='so', description='LEFTWARDS TRIPLE ARROW' },
	[0x21DB] = { unicodeslot=0x21DB, category='so', description='RIGHTWARDS TRIPLE ARROW' },
	[0x21DC] = { unicodeslot=0x21DC, category='so', description='LEFTWARDS SQUIGGLE ARROW' },
	[0x21DD] = { unicodeslot=0x21DD, category='so', description='RIGHTWARDS SQUIGGLE ARROW' },
	[0x21DE] = { unicodeslot=0x21DE, category='so', description='UPWARDS ARROW WITH DOUBLE STROKE' },
	[0x21DF] = { unicodeslot=0x21DF, category='so', description='DOWNWARDS ARROW WITH DOUBLE STROKE' },
	[0x21E0] = { unicodeslot=0x21E0, category='so', description='LEFTWARDS DASHED ARROW' },
	[0x21E1] = { unicodeslot=0x21E1, category='so', description='UPWARDS DASHED ARROW' },
	[0x21E2] = { unicodeslot=0x21E2, category='so', description='RIGHTWARDS DASHED ARROW' },
	[0x21E3] = { unicodeslot=0x21E3, category='so', description='DOWNWARDS DASHED ARROW' },
	[0x21E4] = { unicodeslot=0x21E4, category='so', description='LEFTWARDS ARROW TO BAR' },
	[0x21E5] = { unicodeslot=0x21E5, category='so', description='RIGHTWARDS ARROW TO BAR' },
	[0x21E6] = { unicodeslot=0x21E6, category='so', description='LEFTWARDS WHITE ARROW' },
	[0x21E7] = { unicodeslot=0x21E7, category='so', description='UPWARDS WHITE ARROW' },
	[0x21E8] = { unicodeslot=0x21E8, category='so', description='RIGHTWARDS WHITE ARROW' },
	[0x21E9] = { unicodeslot=0x21E9, category='so', description='DOWNWARDS WHITE ARROW' },
	[0x21EA] = { unicodeslot=0x21EA, category='so', description='UPWARDS WHITE ARROW FROM BAR' },
	[0x21EB] = { unicodeslot=0x21EB, category='so', description='UPWARDS WHITE ARROW ON PEDESTAL' },
	[0x21EC] = { unicodeslot=0x21EC, category='so', description='UPWARDS WHITE ARROW ON PEDESTAL WITH HORIZONTAL BAR' },
	[0x21ED] = { unicodeslot=0x21ED, category='so', description='UPWARDS WHITE ARROW ON PEDESTAL WITH VERTICAL BAR' },
	[0x21EE] = { unicodeslot=0x21EE, category='so', description='UPWARDS WHITE DOUBLE ARROW' },
	[0x21EF] = { unicodeslot=0x21EF, category='so', description='UPWARDS WHITE DOUBLE ARROW ON PEDESTAL' },
	[0x21F0] = { unicodeslot=0x21F0, category='so', description='RIGHTWARDS WHITE ARROW FROM WALL' },
	[0x21F1] = { unicodeslot=0x21F1, category='so', description='NORTH WEST ARROW TO CORNER' },
	[0x21F2] = { unicodeslot=0x21F2, category='so', description='SOUTH EAST ARROW TO CORNER' },
	[0x21F3] = { unicodeslot=0x21F3, category='so', description='UP DOWN WHITE ARROW' },
	[0x21F4] = { unicodeslot=0x21F4, category='sm', description='RIGHT ARROW WITH SMALL CIRCLE' },
	[0x21F5] = { unicodeslot=0x21F5, category='sm', description='DOWNWARDS ARROW LEFTWARDS OF UPWARDS ARROW' },
	[0x21F6] = { unicodeslot=0x21F6, category='sm', description='THREE RIGHTWARDS ARROWS' },
	[0x21F7] = { unicodeslot=0x21F7, category='sm', description='LEFTWARDS ARROW WITH VERTICAL STROKE' },
	[0x21F8] = { unicodeslot=0x21F8, category='sm', description='RIGHTWARDS ARROW WITH VERTICAL STROKE' },
	[0x21F9] = { unicodeslot=0x21F9, category='sm', description='LEFT RIGHT ARROW WITH VERTICAL STROKE' },
	[0x21FA] = { unicodeslot=0x21FA, category='sm', description='LEFTWARDS ARROW WITH DOUBLE VERTICAL STROKE' },
	[0x21FB] = { unicodeslot=0x21FB, category='sm', description='RIGHTWARDS ARROW WITH DOUBLE VERTICAL STROKE' },
	[0x21FC] = { unicodeslot=0x21FC, category='sm', description='LEFT RIGHT ARROW WITH DOUBLE VERTICAL STROKE' },
	[0x21FD] = { unicodeslot=0x21FD, category='sm', description='LEFTWARDS OPEN-HEADED ARROW' },
	[0x21FE] = { unicodeslot=0x21FE, category='sm', description='RIGHTWARDS OPEN-HEADED ARROW' },
	[0x21FF] = { unicodeslot=0x21FF, category='sm', description='LEFT RIGHT OPEN-HEADED ARROW' },
	[0x2200] = { unicodeslot=0x2200, category='sm', adobename='universal', description='FOR ALL' },
	[0x2201] = { unicodeslot=0x2201, category='sm', description='COMPLEMENT' },
	[0x2202] = { unicodeslot=0x2202, category='sm', adobename='partialdiff', description='PARTIAL DIFFERENTIAL' },
	[0x2203] = { unicodeslot=0x2203, category='sm', adobename='existential', description='THERE EXISTS' },
	[0x2204] = { unicodeslot=0x2204, category='sm', description='THERE DOES NOT EXIST', specials={'char',0x2203,0x0338} },
	[0x2205] = { unicodeslot=0x2205, category='sm', adobename='emptyset', description='EMPTY SET' },
	[0x2206] = { unicodeslot=0x2206, category='sm', adobename='Delta', description='INCREMENT' },
	[0x2207] = { unicodeslot=0x2207, category='sm', adobename='gradient', description='NABLA' },
	[0x2208] = { unicodeslot=0x2208, category='sm', adobename='element', description='ELEMENT OF' },
	[0x2209] = { unicodeslot=0x2209, category='sm', adobename='notelement', description='NOT AN ELEMENT OF', specials={'char',0x2208,0x0338} },
	[0x220A] = { unicodeslot=0x220A, category='sm', description='SMALL ELEMENT OF' },
	[0x220B] = { unicodeslot=0x220B, category='sm', adobename='suchthat', description='CONTAINS AS MEMBER' },
	[0x220C] = { unicodeslot=0x220C, category='sm', description='DOES NOT CONTAIN AS MEMBER', specials={'char',0x220B,0x0338} },
	[0x220D] = { unicodeslot=0x220D, category='sm', description='SMALL CONTAINS AS MEMBER' },
	[0x220E] = { unicodeslot=0x220E, category='sm', description='END OF PROOF' },
	[0x220F] = { unicodeslot=0x220F, category='sm', adobename='product', description='N-ARY PRODUCT' },
	[0x2210] = { unicodeslot=0x2210, category='sm', description='N-ARY COPRODUCT' },
	[0x2211] = { unicodeslot=0x2211, category='sm', adobename='summation', description='N-ARY SUMMATION' },
	[0x2212] = { unicodeslot=0x2212, category='sm', adobename='minus', description='MINUS SIGN' },
	[0x2213] = { unicodeslot=0x2213, category='sm', description='MINUS-OR-PLUS SIGN' },
	[0x2214] = { unicodeslot=0x2214, category='sm', description='DOT PLUS' },
	[0x2215] = { unicodeslot=0x2215, category='sm', description='DIVISION SLASH' },
	[0x2216] = { unicodeslot=0x2216, category='sm', description='SET MINUS' },
	[0x2217] = { unicodeslot=0x2217, category='sm', adobename='asteriskmath', description='ASTERISK OPERATOR' },
	[0x2218] = { unicodeslot=0x2218, category='sm', description='RING OPERATOR' },
	[0x2219] = { unicodeslot=0x2219, category='sm', description='BULLET OPERATOR' },
	[0x221A] = { unicodeslot=0x221A, category='sm', adobename='radical', description='SQUARE ROOT' },
	[0x221B] = { unicodeslot=0x221B, category='sm', description='CUBE ROOT' },
	[0x221C] = { unicodeslot=0x221C, category='sm', description='FOURTH ROOT' },
	[0x221D] = { unicodeslot=0x221D, category='sm', adobename='proportional', description='PROPORTIONAL TO' },
	[0x221E] = { unicodeslot=0x221E, category='sm', adobename='infinity', description='INFINITY' },
	[0x221F] = { unicodeslot=0x221F, category='sm', adobename='orthogonal', description='RIGHT ANGLE' },
	[0x2220] = { unicodeslot=0x2220, category='sm', adobename='angle', description='ANGLE' },
	[0x2221] = { unicodeslot=0x2221, category='sm', description='MEASURED ANGLE' },
	[0x2222] = { unicodeslot=0x2222, category='sm', description='SPHERICAL ANGLE' },
	[0x2223] = { unicodeslot=0x2223, category='sm', description='DIVIDES' },
	[0x2224] = { unicodeslot=0x2224, category='sm', description='DOES NOT DIVIDE', specials={'char',0x2223,0x0338} },
	[0x2225] = { unicodeslot=0x2225, category='sm', description='PARALLEL TO' },
	[0x2226] = { unicodeslot=0x2226, category='sm', description='NOT PARALLEL TO', specials={'char',0x2225,0x0338} },
	[0x2227] = { unicodeslot=0x2227, category='sm', adobename='logicaland', description='LOGICAL AND' },
	[0x2228] = { unicodeslot=0x2228, category='sm', adobename='logicalor', description='LOGICAL OR' },
	[0x2229] = { unicodeslot=0x2229, category='sm', adobename='intersection', description='INTERSECTION' },
	[0x222A] = { unicodeslot=0x222A, category='sm', adobename='union', description='UNION' },
	[0x222B] = { unicodeslot=0x222B, category='sm', adobename='integral', description='INTEGRAL' },
	[0x222C] = { unicodeslot=0x222C, category='sm', description='DOUBLE INTEGRAL', specials={'compat',0x222B,0x222B} },
	[0x222D] = { unicodeslot=0x222D, category='sm', description='TRIPLE INTEGRAL', specials={'compat',0x222B,0x222B,0x222B} },
	[0x222E] = { unicodeslot=0x222E, category='sm', description='CONTOUR INTEGRAL' },
	[0x222F] = { unicodeslot=0x222F, category='sm', description='SURFACE INTEGRAL', specials={'compat',0x222E,0x222E} },
	[0x2230] = { unicodeslot=0x2230, category='sm', description='VOLUME INTEGRAL', specials={'compat',0x222E,0x222E,0x222E} },
	[0x2231] = { unicodeslot=0x2231, category='sm', description='CLOCKWISE INTEGRAL' },
	[0x2232] = { unicodeslot=0x2232, category='sm', description='CLOCKWISE CONTOUR INTEGRAL' },
	[0x2233] = { unicodeslot=0x2233, category='sm', description='ANTICLOCKWISE CONTOUR INTEGRAL' },
	[0x2234] = { unicodeslot=0x2234, category='sm', adobename='therefore', description='THEREFORE' },
	[0x2235] = { unicodeslot=0x2235, category='sm', description='BECAUSE' },
	[0x2236] = { unicodeslot=0x2236, category='sm', description='RATIO' },
	[0x2237] = { unicodeslot=0x2237, category='sm', description='PROPORTION' },
	[0x2238] = { unicodeslot=0x2238, category='sm', description='DOT MINUS' },
	[0x2239] = { unicodeslot=0x2239, category='sm', description='EXCESS' },
	[0x223A] = { unicodeslot=0x223A, category='sm', description='GEOMETRIC PROPORTION' },
	[0x223B] = { unicodeslot=0x223B, category='sm', description='HOMOTHETIC' },
	[0x223C] = { unicodeslot=0x223C, category='sm', adobename='similar', description='TILDE OPERATOR' },
	[0x223D] = { unicodeslot=0x223D, category='sm', description='REVERSED TILDE' },
	[0x223E] = { unicodeslot=0x223E, category='sm', description='INVERTED LAZY S' },
	[0x223F] = { unicodeslot=0x223F, category='sm', description='SINE WAVE' },
	[0x2240] = { unicodeslot=0x2240, category='sm', description='WREATH PRODUCT' },
	[0x2241] = { unicodeslot=0x2241, category='sm', description='NOT TILDE', specials={'char',0x223C,0x0338} },
	[0x2242] = { unicodeslot=0x2242, category='sm', description='MINUS TILDE' },
	[0x2243] = { unicodeslot=0x2243, category='sm', description='ASYMPTOTICALLY EQUAL TO' },
	[0x2244] = { unicodeslot=0x2244, category='sm', description='NOT ASYMPTOTICALLY EQUAL TO', specials={'char',0x2243,0x0338} },
	[0x2245] = { unicodeslot=0x2245, category='sm', adobename='congruent', description='APPROXIMATELY EQUAL TO' },
	[0x2246] = { unicodeslot=0x2246, category='sm', description='APPROXIMATELY BUT NOT ACTUALLY EQUAL TO' },
	[0x2247] = { unicodeslot=0x2247, category='sm', description='NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO', specials={'char',0x2245,0x0338} },
	[0x2248] = { unicodeslot=0x2248, category='sm', adobename='approxequal', description='ALMOST EQUAL TO' },
	[0x2249] = { unicodeslot=0x2249, category='sm', description='NOT ALMOST EQUAL TO', specials={'char',0x2248,0x0338} },
	[0x224A] = { unicodeslot=0x224A, category='sm', description='ALMOST EQUAL OR EQUAL TO' },
	[0x224B] = { unicodeslot=0x224B, category='sm', description='TRIPLE TILDE' },
	[0x224C] = { unicodeslot=0x224C, category='sm', description='ALL EQUAL TO' },
	[0x224D] = { unicodeslot=0x224D, category='sm', description='EQUIVALENT TO' },
	[0x224E] = { unicodeslot=0x224E, category='sm', description='GEOMETRICALLY EQUIVALENT TO' },
	[0x224F] = { unicodeslot=0x224F, category='sm', description='DIFFERENCE BETWEEN' },
	[0x2250] = { unicodeslot=0x2250, category='sm', description='APPROACHES THE LIMIT' },
	[0x2251] = { unicodeslot=0x2251, category='sm', description='GEOMETRICALLY EQUAL TO' },
	[0x2252] = { unicodeslot=0x2252, category='sm', description='APPROXIMATELY EQUAL TO OR THE IMAGE OF' },
	[0x2253] = { unicodeslot=0x2253, category='sm', description='IMAGE OF OR APPROXIMATELY EQUAL TO' },
	[0x2254] = { unicodeslot=0x2254, category='sm', description='COLON EQUALS' },
	[0x2255] = { unicodeslot=0x2255, category='sm', description='EQUALS COLON' },
	[0x2256] = { unicodeslot=0x2256, category='sm', description='RING IN EQUAL TO' },
	[0x2257] = { unicodeslot=0x2257, category='sm', description='RING EQUAL TO' },
	[0x2258] = { unicodeslot=0x2258, category='sm', description='CORRESPONDS TO' },
	[0x2259] = { unicodeslot=0x2259, category='sm', description='ESTIMATES' },
	[0x225A] = { unicodeslot=0x225A, category='sm', description='EQUIANGULAR TO' },
	[0x225B] = { unicodeslot=0x225B, category='sm', description='STAR EQUALS' },
	[0x225C] = { unicodeslot=0x225C, category='sm', description='DELTA EQUAL TO' },
	[0x225D] = { unicodeslot=0x225D, category='sm', description='EQUAL TO BY DEFINITION' },
	[0x225E] = { unicodeslot=0x225E, category='sm', description='MEASURED BY' },
	[0x225F] = { unicodeslot=0x225F, category='sm', description='QUESTIONED EQUAL TO' },
	[0x2260] = { unicodeslot=0x2260, category='sm', adobename='notequal', description='NOT EQUAL TO', specials={'char',0x003D,0x0338} },
	[0x2261] = { unicodeslot=0x2261, category='sm', adobename='equivalence', description='IDENTICAL TO' },
	[0x2262] = { unicodeslot=0x2262, category='sm', description='NOT IDENTICAL TO', specials={'char',0x2261,0x0338} },
	[0x2263] = { unicodeslot=0x2263, category='sm', description='STRICTLY EQUIVALENT TO' },
	[0x2264] = { unicodeslot=0x2264, category='sm', adobename='lessequal', description='LESS-THAN OR EQUAL TO' },
	[0x2265] = { unicodeslot=0x2265, category='sm', adobename='greaterequal', description='GREATER-THAN OR EQUAL TO' },
	[0x2266] = { unicodeslot=0x2266, category='sm', description='LESS-THAN OVER EQUAL TO' },
	[0x2267] = { unicodeslot=0x2267, category='sm', description='GREATER-THAN OVER EQUAL TO' },
	[0x2268] = { unicodeslot=0x2268, category='sm', description='LESS-THAN BUT NOT EQUAL TO' },
	[0x2269] = { unicodeslot=0x2269, category='sm', description='GREATER-THAN BUT NOT EQUAL TO' },
	[0x226A] = { unicodeslot=0x226A, category='sm', description='MUCH LESS-THAN' },
	[0x226B] = { unicodeslot=0x226B, category='sm', description='MUCH GREATER-THAN' },
	[0x226C] = { unicodeslot=0x226C, category='sm', description='BETWEEN' },
	[0x226D] = { unicodeslot=0x226D, category='sm', description='NOT EQUIVALENT TO', specials={'char',0x224D,0x0338} },
	[0x226E] = { unicodeslot=0x226E, category='sm', description='NOT LESS-THAN', specials={'char',0x003C,0x0338} },
	[0x226F] = { unicodeslot=0x226F, category='sm', description='NOT GREATER-THAN', specials={'char',0x003E,0x0338} },
	[0x2270] = { unicodeslot=0x2270, category='sm', description='NEITHER LESS-THAN NOR EQUAL TO', specials={'char',0x2264,0x0338} },
	[0x2271] = { unicodeslot=0x2271, category='sm', description='NEITHER GREATER-THAN NOR EQUAL TO', specials={'char',0x2265,0x0338} },
	[0x2272] = { unicodeslot=0x2272, category='sm', description='LESS-THAN OR EQUIVALENT TO' },
	[0x2273] = { unicodeslot=0x2273, category='sm', description='GREATER-THAN OR EQUIVALENT TO' },
	[0x2274] = { unicodeslot=0x2274, category='sm', description='NEITHER LESS-THAN NOR EQUIVALENT TO', specials={'char',0x2272,0x0338} },
	[0x2275] = { unicodeslot=0x2275, category='sm', description='NEITHER GREATER-THAN NOR EQUIVALENT TO', specials={'char',0x2273,0x0338} },
	[0x2276] = { unicodeslot=0x2276, category='sm', description='LESS-THAN OR GREATER-THAN' },
	[0x2277] = { unicodeslot=0x2277, category='sm', description='GREATER-THAN OR LESS-THAN' },
	[0x2278] = { unicodeslot=0x2278, category='sm', description='NEITHER LESS-THAN NOR GREATER-THAN', specials={'char',0x2276,0x0338} },
	[0x2279] = { unicodeslot=0x2279, category='sm', description='NEITHER GREATER-THAN NOR LESS-THAN', specials={'char',0x2277,0x0338} },
	[0x227A] = { unicodeslot=0x227A, category='sm', description='PRECEDES' },
	[0x227B] = { unicodeslot=0x227B, category='sm', description='SUCCEEDS' },
	[0x227C] = { unicodeslot=0x227C, category='sm', description='PRECEDES OR EQUAL TO' },
	[0x227D] = { unicodeslot=0x227D, category='sm', description='SUCCEEDS OR EQUAL TO' },
	[0x227E] = { unicodeslot=0x227E, category='sm', description='PRECEDES OR EQUIVALENT TO' },
	[0x227F] = { unicodeslot=0x227F, category='sm', description='SUCCEEDS OR EQUIVALENT TO' },
	[0x2280] = { unicodeslot=0x2280, category='sm', description='DOES NOT PRECEDE', specials={'char',0x227A,0x0338} },
	[0x2281] = { unicodeslot=0x2281, category='sm', description='DOES NOT SUCCEED', specials={'char',0x227B,0x0338} },
	[0x2282] = { unicodeslot=0x2282, category='sm', adobename='propersubset', description='SUBSET OF' },
	[0x2283] = { unicodeslot=0x2283, category='sm', adobename='propersuperset', description='SUPERSET OF' },
	[0x2284] = { unicodeslot=0x2284, category='sm', adobename='notsubset', description='NOT A SUBSET OF', specials={'char',0x2282,0x0338} },
	[0x2285] = { unicodeslot=0x2285, category='sm', description='NOT A SUPERSET OF', specials={'char',0x2283,0x0338} },
	[0x2286] = { unicodeslot=0x2286, category='sm', adobename='reflexsubset', description='SUBSET OF OR EQUAL TO' },
	[0x2287] = { unicodeslot=0x2287, category='sm', adobename='reflexsuperset', description='SUPERSET OF OR EQUAL TO' },
	[0x2288] = { unicodeslot=0x2288, category='sm', description='NEITHER A SUBSET OF NOR EQUAL TO', specials={'char',0x2286,0x0338} },
	[0x2289] = { unicodeslot=0x2289, category='sm', description='NEITHER A SUPERSET OF NOR EQUAL TO', specials={'char',0x2287,0x0338} },
	[0x228A] = { unicodeslot=0x228A, category='sm', description='SUBSET OF WITH NOT EQUAL TO' },
	[0x228B] = { unicodeslot=0x228B, category='sm', description='SUPERSET OF WITH NOT EQUAL TO' },
	[0x228C] = { unicodeslot=0x228C, category='sm', description='MULTISET' },
	[0x228D] = { unicodeslot=0x228D, category='sm', description='MULTISET MULTIPLICATION' },
	[0x228E] = { unicodeslot=0x228E, category='sm', description='MULTISET UNION' },
	[0x228F] = { unicodeslot=0x228F, category='sm', description='SQUARE IMAGE OF' },
	[0x2290] = { unicodeslot=0x2290, category='sm', description='SQUARE ORIGINAL OF' },
	[0x2291] = { unicodeslot=0x2291, category='sm', description='SQUARE IMAGE OF OR EQUAL TO' },
	[0x2292] = { unicodeslot=0x2292, category='sm', description='SQUARE ORIGINAL OF OR EQUAL TO' },
	[0x2293] = { unicodeslot=0x2293, category='sm', description='SQUARE CAP' },
	[0x2294] = { unicodeslot=0x2294, category='sm', description='SQUARE CUP' },
	[0x2295] = { unicodeslot=0x2295, category='sm', adobename='circleplus', description='CIRCLED PLUS' },
	[0x2296] = { unicodeslot=0x2296, category='sm', description='CIRCLED MINUS' },
	[0x2297] = { unicodeslot=0x2297, category='sm', adobename='circlemultiply', description='CIRCLED TIMES' },
	[0x2298] = { unicodeslot=0x2298, category='sm', description='CIRCLED DIVISION SLASH' },
	[0x2299] = { unicodeslot=0x2299, category='sm', description='CIRCLED DOT OPERATOR' },
	[0x229A] = { unicodeslot=0x229A, category='sm', description='CIRCLED RING OPERATOR' },
	[0x229B] = { unicodeslot=0x229B, category='sm', description='CIRCLED ASTERISK OPERATOR' },
	[0x229C] = { unicodeslot=0x229C, category='sm', description='CIRCLED EQUALS' },
	[0x229D] = { unicodeslot=0x229D, category='sm', description='CIRCLED DASH' },
	[0x229E] = { unicodeslot=0x229E, category='sm', description='SQUARED PLUS' },
	[0x229F] = { unicodeslot=0x229F, category='sm', description='SQUARED MINUS' },
	[0x22A0] = { unicodeslot=0x22A0, category='sm', description='SQUARED TIMES' },
	[0x22A1] = { unicodeslot=0x22A1, category='sm', description='SQUARED DOT OPERATOR' },
	[0x22A2] = { unicodeslot=0x22A2, category='sm', description='RIGHT TACK' },
	[0x22A3] = { unicodeslot=0x22A3, category='sm', description='LEFT TACK' },
	[0x22A4] = { unicodeslot=0x22A4, category='sm', description='DOWN TACK' },
	[0x22A5] = { unicodeslot=0x22A5, category='sm', adobename='perpendicular', description='UP TACK' },
	[0x22A6] = { unicodeslot=0x22A6, category='sm', description='ASSERTION' },
	[0x22A7] = { unicodeslot=0x22A7, category='sm', description='MODELS' },
	[0x22A8] = { unicodeslot=0x22A8, category='sm', description='TRUE' },
	[0x22A9] = { unicodeslot=0x22A9, category='sm', description='FORCES' },
	[0x22AA] = { unicodeslot=0x22AA, category='sm', description='TRIPLE VERTICAL BAR RIGHT TURNSTILE' },
	[0x22AB] = { unicodeslot=0x22AB, category='sm', description='DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE' },
	[0x22AC] = { unicodeslot=0x22AC, category='sm', description='DOES NOT PROVE', specials={'char',0x22A2,0x0338} },
	[0x22AD] = { unicodeslot=0x22AD, category='sm', description='NOT TRUE', specials={'char',0x22A8,0x0338} },
	[0x22AE] = { unicodeslot=0x22AE, category='sm', description='DOES NOT FORCE', specials={'char',0x22A9,0x0338} },
	[0x22AF] = { unicodeslot=0x22AF, category='sm', description='NEGATED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE', specials={'char',0x22AB,0x0338} },
	[0x22B0] = { unicodeslot=0x22B0, category='sm', description='PRECEDES UNDER RELATION' },
	[0x22B1] = { unicodeslot=0x22B1, category='sm', description='SUCCEEDS UNDER RELATION' },
	[0x22B2] = { unicodeslot=0x22B2, category='sm', description='NORMAL SUBGROUP OF' },
	[0x22B3] = { unicodeslot=0x22B3, category='sm', description='CONTAINS AS NORMAL SUBGROUP' },
	[0x22B4] = { unicodeslot=0x22B4, category='sm', description='NORMAL SUBGROUP OF OR EQUAL TO' },
	[0x22B5] = { unicodeslot=0x22B5, category='sm', description='CONTAINS AS NORMAL SUBGROUP OR EQUAL TO' },
	[0x22B6] = { unicodeslot=0x22B6, category='sm', description='ORIGINAL OF' },
	[0x22B7] = { unicodeslot=0x22B7, category='sm', description='IMAGE OF' },
	[0x22B8] = { unicodeslot=0x22B8, category='sm', description='MULTIMAP' },
	[0x22B9] = { unicodeslot=0x22B9, category='sm', description='HERMITIAN CONJUGATE MATRIX' },
	[0x22BA] = { unicodeslot=0x22BA, category='sm', description='INTERCALATE' },
	[0x22BB] = { unicodeslot=0x22BB, category='sm', description='XOR' },
	[0x22BC] = { unicodeslot=0x22BC, category='sm', description='NAND' },
	[0x22BD] = { unicodeslot=0x22BD, category='sm', description='NOR' },
	[0x22BE] = { unicodeslot=0x22BE, category='sm', description='RIGHT ANGLE WITH ARC' },
	[0x22BF] = { unicodeslot=0x22BF, category='sm', description='RIGHT TRIANGLE' },
	[0x22C0] = { unicodeslot=0x22C0, category='sm', description='N-ARY LOGICAL AND' },
	[0x22C1] = { unicodeslot=0x22C1, category='sm', description='N-ARY LOGICAL OR' },
	[0x22C2] = { unicodeslot=0x22C2, category='sm', description='N-ARY INTERSECTION' },
	[0x22C3] = { unicodeslot=0x22C3, category='sm', description='N-ARY UNION' },
	[0x22C4] = { unicodeslot=0x22C4, category='sm', description='DIAMOND OPERATOR' },
	[0x22C5] = { unicodeslot=0x22C5, category='sm', adobename='dotmath', description='DOT OPERATOR' },
	[0x22C6] = { unicodeslot=0x22C6, category='sm', description='STAR OPERATOR' },
	[0x22C7] = { unicodeslot=0x22C7, category='sm', description='DIVISION TIMES' },
	[0x22C8] = { unicodeslot=0x22C8, category='sm', description='BOWTIE' },
	[0x22C9] = { unicodeslot=0x22C9, category='sm', description='LEFT NORMAL FACTOR SEMIDIRECT PRODUCT' },
	[0x22CA] = { unicodeslot=0x22CA, category='sm', description='RIGHT NORMAL FACTOR SEMIDIRECT PRODUCT' },
	[0x22CB] = { unicodeslot=0x22CB, category='sm', description='LEFT SEMIDIRECT PRODUCT' },
	[0x22CC] = { unicodeslot=0x22CC, category='sm', description='RIGHT SEMIDIRECT PRODUCT' },
	[0x22CD] = { unicodeslot=0x22CD, category='sm', description='REVERSED TILDE EQUALS' },
	[0x22CE] = { unicodeslot=0x22CE, category='sm', description='CURLY LOGICAL OR' },
	[0x22CF] = { unicodeslot=0x22CF, category='sm', description='CURLY LOGICAL AND' },
	[0x22D0] = { unicodeslot=0x22D0, category='sm', description='DOUBLE SUBSET' },
	[0x22D1] = { unicodeslot=0x22D1, category='sm', description='DOUBLE SUPERSET' },
	[0x22D2] = { unicodeslot=0x22D2, category='sm', description='DOUBLE INTERSECTION' },
	[0x22D3] = { unicodeslot=0x22D3, category='sm', description='DOUBLE UNION' },
	[0x22D4] = { unicodeslot=0x22D4, category='sm', description='PITCHFORK' },
	[0x22D5] = { unicodeslot=0x22D5, category='sm', description='EQUAL AND PARALLEL TO' },
	[0x22D6] = { unicodeslot=0x22D6, category='sm', description='LESS-THAN WITH DOT' },
	[0x22D7] = { unicodeslot=0x22D7, category='sm', description='GREATER-THAN WITH DOT' },
	[0x22D8] = { unicodeslot=0x22D8, category='sm', description='VERY MUCH LESS-THAN' },
	[0x22D9] = { unicodeslot=0x22D9, category='sm', description='VERY MUCH GREATER-THAN' },
	[0x22DA] = { unicodeslot=0x22DA, category='sm', description='LESS-THAN EQUAL TO OR GREATER-THAN' },
	[0x22DB] = { unicodeslot=0x22DB, category='sm', description='GREATER-THAN EQUAL TO OR LESS-THAN' },
	[0x22DC] = { unicodeslot=0x22DC, category='sm', description='EQUAL TO OR LESS-THAN' },
	[0x22DD] = { unicodeslot=0x22DD, category='sm', description='EQUAL TO OR GREATER-THAN' },
	[0x22DE] = { unicodeslot=0x22DE, category='sm', description='EQUAL TO OR PRECEDES' },
	[0x22DF] = { unicodeslot=0x22DF, category='sm', description='EQUAL TO OR SUCCEEDS' },
	[0x22E0] = { unicodeslot=0x22E0, category='sm', description='DOES NOT PRECEDE OR EQUAL', specials={'char',0x227C,0x0338} },
	[0x22E1] = { unicodeslot=0x22E1, category='sm', description='DOES NOT SUCCEED OR EQUAL', specials={'char',0x227D,0x0338} },
	[0x22E2] = { unicodeslot=0x22E2, category='sm', description='NOT SQUARE IMAGE OF OR EQUAL TO', specials={'char',0x2291,0x0338} },
	[0x22E3] = { unicodeslot=0x22E3, category='sm', description='NOT SQUARE ORIGINAL OF OR EQUAL TO', specials={'char',0x2292,0x0338} },
	[0x22E4] = { unicodeslot=0x22E4, category='sm', description='SQUARE IMAGE OF OR NOT EQUAL TO' },
	[0x22E5] = { unicodeslot=0x22E5, category='sm', description='SQUARE ORIGINAL OF OR NOT EQUAL TO' },
	[0x22E6] = { unicodeslot=0x22E6, category='sm', description='LESS-THAN BUT NOT EQUIVALENT TO' },
	[0x22E7] = { unicodeslot=0x22E7, category='sm', description='GREATER-THAN BUT NOT EQUIVALENT TO' },
	[0x22E8] = { unicodeslot=0x22E8, category='sm', description='PRECEDES BUT NOT EQUIVALENT TO' },
	[0x22E9] = { unicodeslot=0x22E9, category='sm', description='SUCCEEDS BUT NOT EQUIVALENT TO' },
	[0x22EA] = { unicodeslot=0x22EA, category='sm', description='NOT NORMAL SUBGROUP OF', specials={'char',0x22B2,0x0338} },
	[0x22EB] = { unicodeslot=0x22EB, category='sm', description='DOES NOT CONTAIN AS NORMAL SUBGROUP', specials={'char',0x22B3,0x0338} },
	[0x22EC] = { unicodeslot=0x22EC, category='sm', description='NOT NORMAL SUBGROUP OF OR EQUAL TO', specials={'char',0x22B4,0x0338} },
	[0x22ED] = { unicodeslot=0x22ED, category='sm', description='DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL', specials={'char',0x22B5,0x0338} },
	[0x22EE] = { unicodeslot=0x22EE, category='sm', description='VERTICAL ELLIPSIS' },
	[0x22EF] = { unicodeslot=0x22EF, category='sm', description='MIDLINE HORIZONTAL ELLIPSIS' },
	[0x22F0] = { unicodeslot=0x22F0, category='sm', description='UP RIGHT DIAGONAL ELLIPSIS' },
	[0x22F1] = { unicodeslot=0x22F1, category='sm', description='DOWN RIGHT DIAGONAL ELLIPSIS' },
	[0x22F2] = { unicodeslot=0x22F2, category='sm', description='ELEMENT OF WITH LONG HORIZONTAL STROKE' },
	[0x22F3] = { unicodeslot=0x22F3, category='sm', description='ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE' },
	[0x22F4] = { unicodeslot=0x22F4, category='sm', description='SMALL ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE' },
	[0x22F5] = { unicodeslot=0x22F5, category='sm', description='ELEMENT OF WITH DOT ABOVE' },
	[0x22F6] = { unicodeslot=0x22F6, category='sm', description='ELEMENT OF WITH OVERBAR' },
	[0x22F7] = { unicodeslot=0x22F7, category='sm', description='SMALL ELEMENT OF WITH OVERBAR' },
	[0x22F8] = { unicodeslot=0x22F8, category='sm', description='ELEMENT OF WITH UNDERBAR' },
	[0x22F9] = { unicodeslot=0x22F9, category='sm', description='ELEMENT OF WITH TWO HORIZONTAL STROKES' },
	[0x22FA] = { unicodeslot=0x22FA, category='sm', description='CONTAINS WITH LONG HORIZONTAL STROKE' },
	[0x22FB] = { unicodeslot=0x22FB, category='sm', description='CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE' },
	[0x22FC] = { unicodeslot=0x22FC, category='sm', description='SMALL CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE' },
	[0x22FD] = { unicodeslot=0x22FD, category='sm', description='CONTAINS WITH OVERBAR' },
	[0x22FE] = { unicodeslot=0x22FE, category='sm', description='SMALL CONTAINS WITH OVERBAR' },
	[0x22FF] = { unicodeslot=0x22FF, category='sm', description='Z NOTATION BAG MEMBERSHIP' },
	[0x2300] = { unicodeslot=0x2300, category='so', description='DIAMETER SIGN' },
	[0x2301] = { unicodeslot=0x2301, category='so', description='ELECTRIC ARROW' },
	[0x2302] = { unicodeslot=0x2302, category='so', adobename='house', description='HOUSE' },
	[0x2303] = { unicodeslot=0x2303, category='so', description='UP ARROWHEAD' },
	[0x2304] = { unicodeslot=0x2304, category='so', description='DOWN ARROWHEAD' },
	[0x2305] = { unicodeslot=0x2305, category='so', description='PROJECTIVE' },
	[0x2306] = { unicodeslot=0x2306, category='so', description='PERSPECTIVE' },
	[0x2307] = { unicodeslot=0x2307, category='so', description='WAVY LINE' },
	[0x2308] = { unicodeslot=0x2308, category='sm', description='LEFT CEILING' },
	[0x2309] = { unicodeslot=0x2309, category='sm', description='RIGHT CEILING' },
	[0x230A] = { unicodeslot=0x230A, category='sm', description='LEFT FLOOR' },
	[0x230B] = { unicodeslot=0x230B, category='sm', description='RIGHT FLOOR' },
	[0x230C] = { unicodeslot=0x230C, category='so', description='BOTTOM RIGHT CROP' },
	[0x230D] = { unicodeslot=0x230D, category='so', description='BOTTOM LEFT CROP' },
	[0x230E] = { unicodeslot=0x230E, category='so', description='TOP RIGHT CROP' },
	[0x230F] = { unicodeslot=0x230F, category='so', description='TOP LEFT CROP' },
	[0x2310] = { unicodeslot=0x2310, category='so', adobename='revlogicalnot', description='REVERSED NOT SIGN' },
	[0x2311] = { unicodeslot=0x2311, category='so', description='SQUARE LOZENGE' },
	[0x2312] = { unicodeslot=0x2312, category='so', description='ARC' },
	[0x2313] = { unicodeslot=0x2313, category='so', description='SEGMENT' },
	[0x2314] = { unicodeslot=0x2314, category='so', description='SECTOR' },
	[0x2315] = { unicodeslot=0x2315, category='so', description='TELEPHONE RECORDER' },
	[0x2316] = { unicodeslot=0x2316, category='so', description='POSITION INDICATOR' },
	[0x2317] = { unicodeslot=0x2317, category='so', description='VIEWDATA SQUARE' },
	[0x2318] = { unicodeslot=0x2318, category='so', description='PLACE OF INTEREST SIGN' },
	[0x2319] = { unicodeslot=0x2319, category='so', description='TURNED NOT SIGN' },
	[0x231A] = { unicodeslot=0x231A, category='so', description='WATCH' },
	[0x231B] = { unicodeslot=0x231B, category='so', description='HOURGLASS' },
	[0x231C] = { unicodeslot=0x231C, category='so', description='TOP LEFT CORNER' },
	[0x231D] = { unicodeslot=0x231D, category='so', description='TOP RIGHT CORNER' },
	[0x231E] = { unicodeslot=0x231E, category='so', description='BOTTOM LEFT CORNER' },
	[0x231F] = { unicodeslot=0x231F, category='so', description='BOTTOM RIGHT CORNER' },
	[0x2320] = { unicodeslot=0x2320, category='sm', adobename='integraltp', description='TOP HALF INTEGRAL' },
	[0x2321] = { unicodeslot=0x2321, category='sm', adobename='integralbt', description='BOTTOM HALF INTEGRAL' },
	[0x2322] = { unicodeslot=0x2322, category='so', description='FROWN' },
	[0x2323] = { unicodeslot=0x2323, category='so', description='SMILE' },
	[0x2324] = { unicodeslot=0x2324, category='so', description='UP ARROWHEAD BETWEEN TWO HORIZONTAL BARS' },
	[0x2325] = { unicodeslot=0x2325, category='so', description='OPTION KEY' },
	[0x2326] = { unicodeslot=0x2326, category='so', description='ERASE TO THE RIGHT' },
	[0x2327] = { unicodeslot=0x2327, category='so', description='X IN A RECTANGLE BOX' },
	[0x2328] = { unicodeslot=0x2328, category='so', description='KEYBOARD' },
	[0x2329] = { unicodeslot=0x2329, category='ps', adobename='angleleft', description='LEFT-POINTING ANGLE BRACKET', specials={'char',0x3008} },
	[0x232A] = { unicodeslot=0x232A, category='pe', adobename='angleright', description='RIGHT-POINTING ANGLE BRACKET', specials={'char',0x3009} },
	[0x232B] = { unicodeslot=0x232B, category='so', description='ERASE TO THE LEFT' },
	[0x232C] = { unicodeslot=0x232C, category='so', description='BENZENE RING' },
	[0x232D] = { unicodeslot=0x232D, category='so', description='CYLINDRICITY' },
	[0x232E] = { unicodeslot=0x232E, category='so', description='ALL AROUND-PROFILE' },
	[0x232F] = { unicodeslot=0x232F, category='so', description='SYMMETRY' },
	[0x2330] = { unicodeslot=0x2330, category='so', description='TOTAL RUNOUT' },
	[0x2331] = { unicodeslot=0x2331, category='so', description='DIMENSION ORIGIN' },
	[0x2332] = { unicodeslot=0x2332, category='so', description='CONICAL TAPER' },
	[0x2333] = { unicodeslot=0x2333, category='so', description='SLOPE' },
	[0x2334] = { unicodeslot=0x2334, category='so', description='COUNTERBORE' },
	[0x2335] = { unicodeslot=0x2335, category='so', description='COUNTERSINK' },
	[0x2336] = { unicodeslot=0x2336, category='so', description='APL FUNCTIONAL SYMBOL I-BEAM' },
	[0x2337] = { unicodeslot=0x2337, category='so', description='APL FUNCTIONAL SYMBOL SQUISH QUAD' },
	[0x2338] = { unicodeslot=0x2338, category='so', description='APL FUNCTIONAL SYMBOL QUAD EQUAL' },
	[0x2339] = { unicodeslot=0x2339, category='so', description='APL FUNCTIONAL SYMBOL QUAD DIVIDE' },
	[0x233A] = { unicodeslot=0x233A, category='so', description='APL FUNCTIONAL SYMBOL QUAD DIAMOND' },
	[0x233B] = { unicodeslot=0x233B, category='so', description='APL FUNCTIONAL SYMBOL QUAD JOT' },
	[0x233C] = { unicodeslot=0x233C, category='so', description='APL FUNCTIONAL SYMBOL QUAD CIRCLE' },
	[0x233D] = { unicodeslot=0x233D, category='so', description='APL FUNCTIONAL SYMBOL CIRCLE STILE' },
	[0x233E] = { unicodeslot=0x233E, category='so', description='APL FUNCTIONAL SYMBOL CIRCLE JOT' },
	[0x233F] = { unicodeslot=0x233F, category='so', description='APL FUNCTIONAL SYMBOL SLASH BAR' },
	[0x2340] = { unicodeslot=0x2340, category='so', description='APL FUNCTIONAL SYMBOL BACKSLASH BAR' },
	[0x2341] = { unicodeslot=0x2341, category='so', description='APL FUNCTIONAL SYMBOL QUAD SLASH' },
	[0x2342] = { unicodeslot=0x2342, category='so', description='APL FUNCTIONAL SYMBOL QUAD BACKSLASH' },
	[0x2343] = { unicodeslot=0x2343, category='so', description='APL FUNCTIONAL SYMBOL QUAD LESS-THAN' },
	[0x2344] = { unicodeslot=0x2344, category='so', description='APL FUNCTIONAL SYMBOL QUAD GREATER-THAN' },
	[0x2345] = { unicodeslot=0x2345, category='so', description='APL FUNCTIONAL SYMBOL LEFTWARDS VANE' },
	[0x2346] = { unicodeslot=0x2346, category='so', description='APL FUNCTIONAL SYMBOL RIGHTWARDS VANE' },
	[0x2347] = { unicodeslot=0x2347, category='so', description='APL FUNCTIONAL SYMBOL QUAD LEFTWARDS ARROW' },
	[0x2348] = { unicodeslot=0x2348, category='so', description='APL FUNCTIONAL SYMBOL QUAD RIGHTWARDS ARROW' },
	[0x2349] = { unicodeslot=0x2349, category='so', description='APL FUNCTIONAL SYMBOL CIRCLE BACKSLASH' },
	[0x234A] = { unicodeslot=0x234A, category='so', description='APL FUNCTIONAL SYMBOL DOWN TACK UNDERBAR' },
	[0x234B] = { unicodeslot=0x234B, category='so', description='APL FUNCTIONAL SYMBOL DELTA STILE' },
	[0x234C] = { unicodeslot=0x234C, category='so', description='APL FUNCTIONAL SYMBOL QUAD DOWN CARET' },
	[0x234D] = { unicodeslot=0x234D, category='so', description='APL FUNCTIONAL SYMBOL QUAD DELTA' },
	[0x234E] = { unicodeslot=0x234E, category='so', description='APL FUNCTIONAL SYMBOL DOWN TACK JOT' },
	[0x234F] = { unicodeslot=0x234F, category='so', description='APL FUNCTIONAL SYMBOL UPWARDS VANE' },
	[0x2350] = { unicodeslot=0x2350, category='so', description='APL FUNCTIONAL SYMBOL QUAD UPWARDS ARROW' },
	[0x2351] = { unicodeslot=0x2351, category='so', description='APL FUNCTIONAL SYMBOL UP TACK OVERBAR' },
	[0x2352] = { unicodeslot=0x2352, category='so', description='APL FUNCTIONAL SYMBOL DEL STILE' },
	[0x2353] = { unicodeslot=0x2353, category='so', description='APL FUNCTIONAL SYMBOL QUAD UP CARET' },
	[0x2354] = { unicodeslot=0x2354, category='so', description='APL FUNCTIONAL SYMBOL QUAD DEL' },
	[0x2355] = { unicodeslot=0x2355, category='so', description='APL FUNCTIONAL SYMBOL UP TACK JOT' },
	[0x2356] = { unicodeslot=0x2356, category='so', description='APL FUNCTIONAL SYMBOL DOWNWARDS VANE' },
	[0x2357] = { unicodeslot=0x2357, category='so', description='APL FUNCTIONAL SYMBOL QUAD DOWNWARDS ARROW' },
	[0x2358] = { unicodeslot=0x2358, category='so', description='APL FUNCTIONAL SYMBOL QUOTE UNDERBAR' },
	[0x2359] = { unicodeslot=0x2359, category='so', description='APL FUNCTIONAL SYMBOL DELTA UNDERBAR' },
	[0x235A] = { unicodeslot=0x235A, category='so', description='APL FUNCTIONAL SYMBOL DIAMOND UNDERBAR' },
	[0x235B] = { unicodeslot=0x235B, category='so', description='APL FUNCTIONAL SYMBOL JOT UNDERBAR' },
	[0x235C] = { unicodeslot=0x235C, category='so', description='APL FUNCTIONAL SYMBOL CIRCLE UNDERBAR' },
	[0x235D] = { unicodeslot=0x235D, category='so', description='APL FUNCTIONAL SYMBOL UP SHOE JOT' },
	[0x235E] = { unicodeslot=0x235E, category='so', description='APL FUNCTIONAL SYMBOL QUOTE QUAD' },
	[0x235F] = { unicodeslot=0x235F, category='so', description='APL FUNCTIONAL SYMBOL CIRCLE STAR' },
	[0x2360] = { unicodeslot=0x2360, category='so', description='APL FUNCTIONAL SYMBOL QUAD COLON' },
	[0x2361] = { unicodeslot=0x2361, category='so', description='APL FUNCTIONAL SYMBOL UP TACK DIAERESIS' },
	[0x2362] = { unicodeslot=0x2362, category='so', description='APL FUNCTIONAL SYMBOL DEL DIAERESIS' },
	[0x2363] = { unicodeslot=0x2363, category='so', description='APL FUNCTIONAL SYMBOL STAR DIAERESIS' },
	[0x2364] = { unicodeslot=0x2364, category='so', description='APL FUNCTIONAL SYMBOL JOT DIAERESIS' },
	[0x2365] = { unicodeslot=0x2365, category='so', description='APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS' },
	[0x2366] = { unicodeslot=0x2366, category='so', description='APL FUNCTIONAL SYMBOL DOWN SHOE STILE' },
	[0x2367] = { unicodeslot=0x2367, category='so', description='APL FUNCTIONAL SYMBOL LEFT SHOE STILE' },
	[0x2368] = { unicodeslot=0x2368, category='so', description='APL FUNCTIONAL SYMBOL TILDE DIAERESIS' },
	[0x2369] = { unicodeslot=0x2369, category='so', description='APL FUNCTIONAL SYMBOL GREATER-THAN DIAERESIS' },
	[0x236A] = { unicodeslot=0x236A, category='so', description='APL FUNCTIONAL SYMBOL COMMA BAR' },
	[0x236B] = { unicodeslot=0x236B, category='so', description='APL FUNCTIONAL SYMBOL DEL TILDE' },
	[0x236C] = { unicodeslot=0x236C, category='so', description='APL FUNCTIONAL SYMBOL ZILDE' },
	[0x236D] = { unicodeslot=0x236D, category='so', description='APL FUNCTIONAL SYMBOL STILE TILDE' },
	[0x236E] = { unicodeslot=0x236E, category='so', description='APL FUNCTIONAL SYMBOL SEMICOLON UNDERBAR' },
	[0x236F] = { unicodeslot=0x236F, category='so', description='APL FUNCTIONAL SYMBOL QUAD NOT EQUAL' },
	[0x2370] = { unicodeslot=0x2370, category='so', description='APL FUNCTIONAL SYMBOL QUAD QUESTION' },
	[0x2371] = { unicodeslot=0x2371, category='so', description='APL FUNCTIONAL SYMBOL DOWN CARET TILDE' },
	[0x2372] = { unicodeslot=0x2372, category='so', description='APL FUNCTIONAL SYMBOL UP CARET TILDE' },
	[0x2373] = { unicodeslot=0x2373, category='so', description='APL FUNCTIONAL SYMBOL IOTA' },
	[0x2374] = { unicodeslot=0x2374, category='so', description='APL FUNCTIONAL SYMBOL RHO' },
	[0x2375] = { unicodeslot=0x2375, category='so', description='APL FUNCTIONAL SYMBOL OMEGA' },
	[0x2376] = { unicodeslot=0x2376, category='so', description='APL FUNCTIONAL SYMBOL ALPHA UNDERBAR' },
	[0x2377] = { unicodeslot=0x2377, category='so', description='APL FUNCTIONAL SYMBOL EPSILON UNDERBAR' },
	[0x2378] = { unicodeslot=0x2378, category='so', description='APL FUNCTIONAL SYMBOL IOTA UNDERBAR' },
	[0x2379] = { unicodeslot=0x2379, category='so', description='APL FUNCTIONAL SYMBOL OMEGA UNDERBAR' },
	[0x237A] = { unicodeslot=0x237A, category='so', description='APL FUNCTIONAL SYMBOL ALPHA' },
	[0x237B] = { unicodeslot=0x237B, category='so', description='NOT CHECK MARK' },
	[0x237C] = { unicodeslot=0x237C, category='sm', description='RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW' },
	[0x237D] = { unicodeslot=0x237D, category='so', description='SHOULDERED OPEN BOX' },
	[0x237E] = { unicodeslot=0x237E, category='so', description='BELL SYMBOL' },
	[0x237F] = { unicodeslot=0x237F, category='so', description='VERTICAL LINE WITH MIDDLE DOT' },
	[0x2380] = { unicodeslot=0x2380, category='so', description='INSERTION SYMBOL' },
	[0x2381] = { unicodeslot=0x2381, category='so', description='CONTINUOUS UNDERLINE SYMBOL' },
	[0x2382] = { unicodeslot=0x2382, category='so', description='DISCONTINUOUS UNDERLINE SYMBOL' },
	[0x2383] = { unicodeslot=0x2383, category='so', description='EMPHASIS SYMBOL' },
	[0x2384] = { unicodeslot=0x2384, category='so', description='COMPOSITION SYMBOL' },
	[0x2385] = { unicodeslot=0x2385, category='so', description='WHITE SQUARE WITH CENTRE VERTICAL LINE' },
	[0x2386] = { unicodeslot=0x2386, category='so', description='ENTER SYMBOL' },
	[0x2387] = { unicodeslot=0x2387, category='so', description='ALTERNATIVE KEY SYMBOL' },
	[0x2388] = { unicodeslot=0x2388, category='so', description='HELM SYMBOL' },
	[0x2389] = { unicodeslot=0x2389, category='so', description='CIRCLED HORIZONTAL BAR WITH NOTCH' },
	[0x238A] = { unicodeslot=0x238A, category='so', description='CIRCLED TRIANGLE DOWN' },
	[0x238B] = { unicodeslot=0x238B, category='so', description='BROKEN CIRCLE WITH NORTHWEST ARROW' },
	[0x238C] = { unicodeslot=0x238C, category='so', description='UNDO SYMBOL' },
	[0x238D] = { unicodeslot=0x238D, category='so', description='MONOSTABLE SYMBOL' },
	[0x238E] = { unicodeslot=0x238E, category='so', description='HYSTERESIS SYMBOL' },
	[0x238F] = { unicodeslot=0x238F, category='so', description='OPEN-CIRCUIT-OUTPUT H-TYPE SYMBOL' },
	[0x2390] = { unicodeslot=0x2390, category='so', description='OPEN-CIRCUIT-OUTPUT L-TYPE SYMBOL' },
	[0x2391] = { unicodeslot=0x2391, category='so', description='PASSIVE-PULL-DOWN-OUTPUT SYMBOL' },
	[0x2392] = { unicodeslot=0x2392, category='so', description='PASSIVE-PULL-UP-OUTPUT SYMBOL' },
	[0x2393] = { unicodeslot=0x2393, category='so', description='DIRECT CURRENT SYMBOL FORM TWO' },
	[0x2394] = { unicodeslot=0x2394, category='so', description='SOFTWARE-FUNCTION SYMBOL' },
	[0x2395] = { unicodeslot=0x2395, category='so', description='APL FUNCTIONAL SYMBOL QUAD' },
	[0x2396] = { unicodeslot=0x2396, category='so', description='DECIMAL SEPARATOR KEY SYMBOL' },
	[0x2397] = { unicodeslot=0x2397, category='so', description='PREVIOUS PAGE' },
	[0x2398] = { unicodeslot=0x2398, category='so', description='NEXT PAGE' },
	[0x2399] = { unicodeslot=0x2399, category='so', description='PRINT SCREEN SYMBOL' },
	[0x239A] = { unicodeslot=0x239A, category='so', description='CLEAR SCREEN SYMBOL' },
	[0x239B] = { unicodeslot=0x239B, category='sm', description='LEFT PARENTHESIS UPPER HOOK' },
	[0x239C] = { unicodeslot=0x239C, category='sm', description='LEFT PARENTHESIS EXTENSION' },
	[0x239D] = { unicodeslot=0x239D, category='sm', description='LEFT PARENTHESIS LOWER HOOK' },
	[0x239E] = { unicodeslot=0x239E, category='sm', description='RIGHT PARENTHESIS UPPER HOOK' },
	[0x239F] = { unicodeslot=0x239F, category='sm', description='RIGHT PARENTHESIS EXTENSION' },
	[0x23A0] = { unicodeslot=0x23A0, category='sm', description='RIGHT PARENTHESIS LOWER HOOK' },
	[0x23A1] = { unicodeslot=0x23A1, category='sm', description='LEFT SQUARE BRACKET UPPER CORNER' },
	[0x23A2] = { unicodeslot=0x23A2, category='sm', description='LEFT SQUARE BRACKET EXTENSION' },
	[0x23A3] = { unicodeslot=0x23A3, category='sm', description='LEFT SQUARE BRACKET LOWER CORNER' },
	[0x23A4] = { unicodeslot=0x23A4, category='sm', description='RIGHT SQUARE BRACKET UPPER CORNER' },
	[0x23A5] = { unicodeslot=0x23A5, category='sm', description='RIGHT SQUARE BRACKET EXTENSION' },
	[0x23A6] = { unicodeslot=0x23A6, category='sm', description='RIGHT SQUARE BRACKET LOWER CORNER' },
	[0x23A7] = { unicodeslot=0x23A7, category='sm', description='LEFT CURLY BRACKET UPPER HOOK' },
	[0x23A8] = { unicodeslot=0x23A8, category='sm', description='LEFT CURLY BRACKET MIDDLE PIECE' },
	[0x23A9] = { unicodeslot=0x23A9, category='sm', description='LEFT CURLY BRACKET LOWER HOOK' },
	[0x23AA] = { unicodeslot=0x23AA, category='sm', description='CURLY BRACKET EXTENSION' },
	[0x23AB] = { unicodeslot=0x23AB, category='sm', description='RIGHT CURLY BRACKET UPPER HOOK' },
	[0x23AC] = { unicodeslot=0x23AC, category='sm', description='RIGHT CURLY BRACKET MIDDLE PIECE' },
	[0x23AD] = { unicodeslot=0x23AD, category='sm', description='RIGHT CURLY BRACKET LOWER HOOK' },
	[0x23AE] = { unicodeslot=0x23AE, category='sm', description='INTEGRAL EXTENSION' },
	[0x23AF] = { unicodeslot=0x23AF, category='sm', description='HORIZONTAL LINE EXTENSION' },
	[0x23B0] = { unicodeslot=0x23B0, category='sm', description='UPPER LEFT OR LOWER RIGHT CURLY BRACKET SECTION' },
	[0x23B1] = { unicodeslot=0x23B1, category='sm', description='UPPER RIGHT OR LOWER LEFT CURLY BRACKET SECTION' },
	[0x23B2] = { unicodeslot=0x23B2, category='sm', description='SUMMATION TOP' },
	[0x23B3] = { unicodeslot=0x23B3, category='sm', description='SUMMATION BOTTOM' },
	[0x23B4] = { unicodeslot=0x23B4, category='so', description='TOP SQUARE BRACKET' },
	[0x23B5] = { unicodeslot=0x23B5, category='so', description='BOTTOM SQUARE BRACKET' },
	[0x23B6] = { unicodeslot=0x23B6, category='so', description='BOTTOM SQUARE BRACKET OVER TOP SQUARE BRACKET' },
	[0x23B7] = { unicodeslot=0x23B7, category='so', description='RADICAL SYMBOL BOTTOM' },
	[0x23B8] = { unicodeslot=0x23B8, category='so', description='LEFT VERTICAL BOX LINE' },
	[0x23B9] = { unicodeslot=0x23B9, category='so', description='RIGHT VERTICAL BOX LINE' },
	[0x23BA] = { unicodeslot=0x23BA, category='so', description='HORIZONTAL SCAN LINE-1' },
	[0x23BB] = { unicodeslot=0x23BB, category='so', description='HORIZONTAL SCAN LINE-3' },
	[0x23BC] = { unicodeslot=0x23BC, category='so', description='HORIZONTAL SCAN LINE-7' },
	[0x23BD] = { unicodeslot=0x23BD, category='so', description='HORIZONTAL SCAN LINE-9' },
	[0x23BE] = { unicodeslot=0x23BE, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL AND TOP RIGHT' },
	[0x23BF] = { unicodeslot=0x23BF, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM RIGHT' },
	[0x23C0] = { unicodeslot=0x23C0, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL WITH CIRCLE' },
	[0x23C1] = { unicodeslot=0x23C1, category='so', description='DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH CIRCLE' },
	[0x23C2] = { unicodeslot=0x23C2, category='so', description='DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH CIRCLE' },
	[0x23C3] = { unicodeslot=0x23C3, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL WITH TRIANGLE' },
	[0x23C4] = { unicodeslot=0x23C4, category='so', description='DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH TRIANGLE' },
	[0x23C5] = { unicodeslot=0x23C5, category='so', description='DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH TRIANGLE' },
	[0x23C6] = { unicodeslot=0x23C6, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE' },
	[0x23C7] = { unicodeslot=0x23C7, category='so', description='DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH WAVE' },
	[0x23C8] = { unicodeslot=0x23C8, category='so', description='DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH WAVE' },
	[0x23C9] = { unicodeslot=0x23C9, category='so', description='DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL' },
	[0x23CA] = { unicodeslot=0x23CA, category='so', description='DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL' },
	[0x23CB] = { unicodeslot=0x23CB, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL AND TOP LEFT' },
	[0x23CC] = { unicodeslot=0x23CC, category='so', description='DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM LEFT' },
	[0x23CD] = { unicodeslot=0x23CD, category='so', description='SQUARE FOOT' },
	[0x23CE] = { unicodeslot=0x23CE, category='so', description='RETURN SYMBOL' },
	[0x23CF] = { unicodeslot=0x23CF, category='so', description='EJECT SYMBOL' },
	[0x23D0] = { unicodeslot=0x23D0, category='so', description='VERTICAL LINE EXTENSION' },
	[0x23D1] = { unicodeslot=0x23D1, category='so', description='METRICAL BREVE' },
	[0x23D2] = { unicodeslot=0x23D2, category='so', description='METRICAL LONG OVER SHORT' },
	[0x23D3] = { unicodeslot=0x23D3, category='so', description='METRICAL SHORT OVER LONG' },
	[0x23D4] = { unicodeslot=0x23D4, category='so', description='METRICAL LONG OVER TWO SHORTS' },
	[0x23D5] = { unicodeslot=0x23D5, category='so', description='METRICAL TWO SHORTS OVER LONG' },
	[0x23D6] = { unicodeslot=0x23D6, category='so', description='METRICAL TWO SHORTS JOINED' },
	[0x23D7] = { unicodeslot=0x23D7, category='so', description='METRICAL TRISEME' },
	[0x23D8] = { unicodeslot=0x23D8, category='so', description='METRICAL TETRASEME' },
	[0x23D9] = { unicodeslot=0x23D9, category='so', description='METRICAL PENTASEME' },
	[0x23DA] = { unicodeslot=0x23DA, category='so', description='EARTH GROUND' },
	[0x23DB] = { unicodeslot=0x23DB, category='so', description='FUSE' },
	[0x23DC] = { unicodeslot=0x23DC, category='sm', description='TOP PARENTHESIS' },
	[0x23DD] = { unicodeslot=0x23DD, category='sm', description='BOTTOM PARENTHESIS' },
	[0x23DE] = { unicodeslot=0x23DE, category='sm', description='TOP CURLY BRACKET' },
	[0x23DF] = { unicodeslot=0x23DF, category='sm', description='BOTTOM CURLY BRACKET' },
	[0x23E0] = { unicodeslot=0x23E0, category='sm', description='TOP TORTOISE SHELL BRACKET' },
	[0x23E1] = { unicodeslot=0x23E1, category='sm', description='BOTTOM TORTOISE SHELL BRACKET' },
	[0x23E2] = { unicodeslot=0x23E2, category='so', description='WHITE TRAPEZIUM' },
	[0x23E3] = { unicodeslot=0x23E3, category='so', description='BENZENE RING WITH CIRCLE' },
	[0x23E4] = { unicodeslot=0x23E4, category='so', description='STRAIGHTNESS' },
	[0x23E5] = { unicodeslot=0x23E5, category='so', description='FLATNESS' },
	[0x23E6] = { unicodeslot=0x23E6, category='so', description='AC CURRENT' },
	[0x23E7] = { unicodeslot=0x23E7, category='so', description='ELECTRICAL INTERSECTION' },
	[0x2400] = { unicodeslot=0x2400, category='so', description='SYMBOL FOR NULL' },
	[0x2401] = { unicodeslot=0x2401, category='so', description='SYMBOL FOR START OF HEADING' },
	[0x2402] = { unicodeslot=0x2402, category='so', description='SYMBOL FOR START OF TEXT' },
	[0x2403] = { unicodeslot=0x2403, category='so', description='SYMBOL FOR END OF TEXT' },
	[0x2404] = { unicodeslot=0x2404, category='so', description='SYMBOL FOR END OF TRANSMISSION' },
	[0x2405] = { unicodeslot=0x2405, category='so', description='SYMBOL FOR ENQUIRY' },
	[0x2406] = { unicodeslot=0x2406, category='so', description='SYMBOL FOR ACKNOWLEDGE' },
	[0x2407] = { unicodeslot=0x2407, category='so', description='SYMBOL FOR BELL' },
	[0x2408] = { unicodeslot=0x2408, category='so', description='SYMBOL FOR BACKSPACE' },
	[0x2409] = { unicodeslot=0x2409, category='so', description='SYMBOL FOR HORIZONTAL TABULATION' },
	[0x240A] = { unicodeslot=0x240A, category='so', description='SYMBOL FOR LINE FEED' },
	[0x240B] = { unicodeslot=0x240B, category='so', description='SYMBOL FOR VERTICAL TABULATION' },
	[0x240C] = { unicodeslot=0x240C, category='so', description='SYMBOL FOR FORM FEED' },
	[0x240D] = { unicodeslot=0x240D, category='so', description='SYMBOL FOR CARRIAGE RETURN' },
	[0x240E] = { unicodeslot=0x240E, category='so', description='SYMBOL FOR SHIFT OUT' },
	[0x240F] = { unicodeslot=0x240F, category='so', description='SYMBOL FOR SHIFT IN' },
	[0x2410] = { unicodeslot=0x2410, category='so', description='SYMBOL FOR DATA LINK ESCAPE' },
	[0x2411] = { unicodeslot=0x2411, category='so', description='SYMBOL FOR DEVICE CONTROL ONE' },
	[0x2412] = { unicodeslot=0x2412, category='so', description='SYMBOL FOR DEVICE CONTROL TWO' },
	[0x2413] = { unicodeslot=0x2413, category='so', description='SYMBOL FOR DEVICE CONTROL THREE' },
	[0x2414] = { unicodeslot=0x2414, category='so', description='SYMBOL FOR DEVICE CONTROL FOUR' },
	[0x2415] = { unicodeslot=0x2415, category='so', description='SYMBOL FOR NEGATIVE ACKNOWLEDGE' },
	[0x2416] = { unicodeslot=0x2416, category='so', description='SYMBOL FOR SYNCHRONOUS IDLE' },
	[0x2417] = { unicodeslot=0x2417, category='so', description='SYMBOL FOR END OF TRANSMISSION BLOCK' },
	[0x2418] = { unicodeslot=0x2418, category='so', description='SYMBOL FOR CANCEL' },
	[0x2419] = { unicodeslot=0x2419, category='so', description='SYMBOL FOR END OF MEDIUM' },
	[0x241A] = { unicodeslot=0x241A, category='so', description='SYMBOL FOR SUBSTITUTE' },
	[0x241B] = { unicodeslot=0x241B, category='so', description='SYMBOL FOR ESCAPE' },
	[0x241C] = { unicodeslot=0x241C, category='so', description='SYMBOL FOR FILE SEPARATOR' },
	[0x241D] = { unicodeslot=0x241D, category='so', description='SYMBOL FOR GROUP SEPARATOR' },
	[0x241E] = { unicodeslot=0x241E, category='so', description='SYMBOL FOR RECORD SEPARATOR' },
	[0x241F] = { unicodeslot=0x241F, category='so', description='SYMBOL FOR UNIT SEPARATOR' },
	[0x2420] = { unicodeslot=0x2420, category='so', description='SYMBOL FOR SPACE' },
	[0x2421] = { unicodeslot=0x2421, category='so', description='SYMBOL FOR DELETE' },
	[0x2422] = { unicodeslot=0x2422, category='so', description='BLANK SYMBOL' },
	[0x2423] = { unicodeslot=0x2423, category='so', description='OPEN BOX' },
	[0x2424] = { unicodeslot=0x2424, category='so', description='SYMBOL FOR NEWLINE' },
	[0x2425] = { unicodeslot=0x2425, category='so', description='SYMBOL FOR DELETE FORM TWO' },
	[0x2426] = { unicodeslot=0x2426, category='so', description='SYMBOL FOR SUBSTITUTE FORM TWO' },
	[0x2440] = { unicodeslot=0x2440, category='so', description='OCR HOOK' },
	[0x2441] = { unicodeslot=0x2441, category='so', description='OCR CHAIR' },
	[0x2442] = { unicodeslot=0x2442, category='so', description='OCR FORK' },
	[0x2443] = { unicodeslot=0x2443, category='so', description='OCR INVERTED FORK' },
	[0x2444] = { unicodeslot=0x2444, category='so', description='OCR BELT BUCKLE' },
	[0x2445] = { unicodeslot=0x2445, category='so', description='OCR BOW TIE' },
	[0x2446] = { unicodeslot=0x2446, category='so', description='OCR BRANCH BANK IDENTIFICATION' },
	[0x2447] = { unicodeslot=0x2447, category='so', description='OCR AMOUNT OF CHECK' },
	[0x2448] = { unicodeslot=0x2448, category='so', description='OCR DASH' },
	[0x2449] = { unicodeslot=0x2449, category='so', description='OCR CUSTOMER ACCOUNT NUMBER' },
	[0x244A] = { unicodeslot=0x244A, category='so', description='OCR DOUBLE BACKSLASH' },
	[0x2460] = { unicodeslot=0x2460, category='no', description='CIRCLED DIGIT ONE', specials={'circle',0x0031} },
	[0x2461] = { unicodeslot=0x2461, category='no', description='CIRCLED DIGIT TWO', specials={'circle',0x0032} },
	[0x2462] = { unicodeslot=0x2462, category='no', description='CIRCLED DIGIT THREE', specials={'circle',0x0033} },
	[0x2463] = { unicodeslot=0x2463, category='no', description='CIRCLED DIGIT FOUR', specials={'circle',0x0034} },
	[0x2464] = { unicodeslot=0x2464, category='no', description='CIRCLED DIGIT FIVE', specials={'circle',0x0035} },
	[0x2465] = { unicodeslot=0x2465, category='no', description='CIRCLED DIGIT SIX', specials={'circle',0x0036} },
	[0x2466] = { unicodeslot=0x2466, category='no', description='CIRCLED DIGIT SEVEN', specials={'circle',0x0037} },
	[0x2467] = { unicodeslot=0x2467, category='no', description='CIRCLED DIGIT EIGHT', specials={'circle',0x0038} },
	[0x2468] = { unicodeslot=0x2468, category='no', description='CIRCLED DIGIT NINE', specials={'circle',0x0039} },
	[0x2469] = { unicodeslot=0x2469, category='no', description='CIRCLED NUMBER TEN', specials={'circle',0x0031,0x0030} },
	[0x246A] = { unicodeslot=0x246A, category='no', description='CIRCLED NUMBER ELEVEN', specials={'circle',0x0031,0x0031} },
	[0x246B] = { unicodeslot=0x246B, category='no', description='CIRCLED NUMBER TWELVE', specials={'circle',0x0031,0x0032} },
	[0x246C] = { unicodeslot=0x246C, category='no', description='CIRCLED NUMBER THIRTEEN', specials={'circle',0x0031,0x0033} },
	[0x246D] = { unicodeslot=0x246D, category='no', description='CIRCLED NUMBER FOURTEEN', specials={'circle',0x0031,0x0034} },
	[0x246E] = { unicodeslot=0x246E, category='no', description='CIRCLED NUMBER FIFTEEN', specials={'circle',0x0031,0x0035} },
	[0x246F] = { unicodeslot=0x246F, category='no', description='CIRCLED NUMBER SIXTEEN', specials={'circle',0x0031,0x0036} },
	[0x2470] = { unicodeslot=0x2470, category='no', description='CIRCLED NUMBER SEVENTEEN', specials={'circle',0x0031,0x0037} },
	[0x2471] = { unicodeslot=0x2471, category='no', description='CIRCLED NUMBER EIGHTEEN', specials={'circle',0x0031,0x0038} },
	[0x2472] = { unicodeslot=0x2472, category='no', description='CIRCLED NUMBER NINETEEN', specials={'circle',0x0031,0x0039} },
	[0x2473] = { unicodeslot=0x2473, category='no', description='CIRCLED NUMBER TWENTY', specials={'circle',0x0032,0x0030} },
	[0x2474] = { unicodeslot=0x2474, category='no', description='PARENTHESIZED DIGIT ONE', specials={'compat',0x0028,0x0031,0x0029} },
	[0x2475] = { unicodeslot=0x2475, category='no', description='PARENTHESIZED DIGIT TWO', specials={'compat',0x0028,0x0032,0x0029} },
	[0x2476] = { unicodeslot=0x2476, category='no', description='PARENTHESIZED DIGIT THREE', specials={'compat',0x0028,0x0033,0x0029} },
	[0x2477] = { unicodeslot=0x2477, category='no', description='PARENTHESIZED DIGIT FOUR', specials={'compat',0x0028,0x0034,0x0029} },
	[0x2478] = { unicodeslot=0x2478, category='no', description='PARENTHESIZED DIGIT FIVE', specials={'compat',0x0028,0x0035,0x0029} },
	[0x2479] = { unicodeslot=0x2479, category='no', description='PARENTHESIZED DIGIT SIX', specials={'compat',0x0028,0x0036,0x0029} },
	[0x247A] = { unicodeslot=0x247A, category='no', description='PARENTHESIZED DIGIT SEVEN', specials={'compat',0x0028,0x0037,0x0029} },
	[0x247B] = { unicodeslot=0x247B, category='no', description='PARENTHESIZED DIGIT EIGHT', specials={'compat',0x0028,0x0038,0x0029} },
	[0x247C] = { unicodeslot=0x247C, category='no', description='PARENTHESIZED DIGIT NINE', specials={'compat',0x0028,0x0039,0x0029} },
	[0x247D] = { unicodeslot=0x247D, category='no', description='PARENTHESIZED NUMBER TEN', specials={'compat',0x0028,0x0031,0x0030,0x0029} },
	[0x247E] = { unicodeslot=0x247E, category='no', description='PARENTHESIZED NUMBER ELEVEN', specials={'compat',0x0028,0x0031,0x0031,0x0029} },
	[0x247F] = { unicodeslot=0x247F, category='no', description='PARENTHESIZED NUMBER TWELVE', specials={'compat',0x0028,0x0031,0x0032,0x0029} },
	[0x2480] = { unicodeslot=0x2480, category='no', description='PARENTHESIZED NUMBER THIRTEEN', specials={'compat',0x0028,0x0031,0x0033,0x0029} },
	[0x2481] = { unicodeslot=0x2481, category='no', description='PARENTHESIZED NUMBER FOURTEEN', specials={'compat',0x0028,0x0031,0x0034,0x0029} },
	[0x2482] = { unicodeslot=0x2482, category='no', description='PARENTHESIZED NUMBER FIFTEEN', specials={'compat',0x0028,0x0031,0x0035,0x0029} },
	[0x2483] = { unicodeslot=0x2483, category='no', description='PARENTHESIZED NUMBER SIXTEEN', specials={'compat',0x0028,0x0031,0x0036,0x0029} },
	[0x2484] = { unicodeslot=0x2484, category='no', description='PARENTHESIZED NUMBER SEVENTEEN', specials={'compat',0x0028,0x0031,0x0037,0x0029} },
	[0x2485] = { unicodeslot=0x2485, category='no', description='PARENTHESIZED NUMBER EIGHTEEN', specials={'compat',0x0028,0x0031,0x0038,0x0029} },
	[0x2486] = { unicodeslot=0x2486, category='no', description='PARENTHESIZED NUMBER NINETEEN', specials={'compat',0x0028,0x0031,0x0039,0x0029} },
	[0x2487] = { unicodeslot=0x2487, category='no', description='PARENTHESIZED NUMBER TWENTY', specials={'compat',0x0028,0x0032,0x0030,0x0029} },
	[0x2488] = { unicodeslot=0x2488, category='no', description='DIGIT ONE FULL STOP', specials={'compat',0x0031,0x002E} },
	[0x2489] = { unicodeslot=0x2489, category='no', description='DIGIT TWO FULL STOP', specials={'compat',0x0032,0x002E} },
	[0x248A] = { unicodeslot=0x248A, category='no', description='DIGIT THREE FULL STOP', specials={'compat',0x0033,0x002E} },
	[0x248B] = { unicodeslot=0x248B, category='no', description='DIGIT FOUR FULL STOP', specials={'compat',0x0034,0x002E} },
	[0x248C] = { unicodeslot=0x248C, category='no', description='DIGIT FIVE FULL STOP', specials={'compat',0x0035,0x002E} },
	[0x248D] = { unicodeslot=0x248D, category='no', description='DIGIT SIX FULL STOP', specials={'compat',0x0036,0x002E} },
	[0x248E] = { unicodeslot=0x248E, category='no', description='DIGIT SEVEN FULL STOP', specials={'compat',0x0037,0x002E} },
	[0x248F] = { unicodeslot=0x248F, category='no', description='DIGIT EIGHT FULL STOP', specials={'compat',0x0038,0x002E} },
	[0x2490] = { unicodeslot=0x2490, category='no', description='DIGIT NINE FULL STOP', specials={'compat',0x0039,0x002E} },
	[0x2491] = { unicodeslot=0x2491, category='no', description='NUMBER TEN FULL STOP', specials={'compat',0x0031,0x0030,0x002E} },
	[0x2492] = { unicodeslot=0x2492, category='no', description='NUMBER ELEVEN FULL STOP', specials={'compat',0x0031,0x0031,0x002E} },
	[0x2493] = { unicodeslot=0x2493, category='no', description='NUMBER TWELVE FULL STOP', specials={'compat',0x0031,0x0032,0x002E} },
	[0x2494] = { unicodeslot=0x2494, category='no', description='NUMBER THIRTEEN FULL STOP', specials={'compat',0x0031,0x0033,0x002E} },
	[0x2495] = { unicodeslot=0x2495, category='no', description='NUMBER FOURTEEN FULL STOP', specials={'compat',0x0031,0x0034,0x002E} },
	[0x2496] = { unicodeslot=0x2496, category='no', description='NUMBER FIFTEEN FULL STOP', specials={'compat',0x0031,0x0035,0x002E} },
	[0x2497] = { unicodeslot=0x2497, category='no', description='NUMBER SIXTEEN FULL STOP', specials={'compat',0x0031,0x0036,0x002E} },
	[0x2498] = { unicodeslot=0x2498, category='no', description='NUMBER SEVENTEEN FULL STOP', specials={'compat',0x0031,0x0037,0x002E} },
	[0x2499] = { unicodeslot=0x2499, category='no', description='NUMBER EIGHTEEN FULL STOP', specials={'compat',0x0031,0x0038,0x002E} },
	[0x249A] = { unicodeslot=0x249A, category='no', description='NUMBER NINETEEN FULL STOP', specials={'compat',0x0031,0x0039,0x002E} },
	[0x249B] = { unicodeslot=0x249B, category='no', description='NUMBER TWENTY FULL STOP', specials={'compat',0x0032,0x0030,0x002E} },
	[0x249C] = { unicodeslot=0x249C, category='so', description='PARENTHESIZED LATIN SMALL LETTER A', specials={'compat',0x0028,0x0061,0x0029} },
	[0x249D] = { unicodeslot=0x249D, category='so', description='PARENTHESIZED LATIN SMALL LETTER B', specials={'compat',0x0028,0x0062,0x0029} },
	[0x249E] = { unicodeslot=0x249E, category='so', description='PARENTHESIZED LATIN SMALL LETTER C', specials={'compat',0x0028,0x0063,0x0029} },
	[0x249F] = { unicodeslot=0x249F, category='so', description='PARENTHESIZED LATIN SMALL LETTER D', specials={'compat',0x0028,0x0064,0x0029} },
	[0x24A0] = { unicodeslot=0x24A0, category='so', description='PARENTHESIZED LATIN SMALL LETTER E', specials={'compat',0x0028,0x0065,0x0029} },
	[0x24A1] = { unicodeslot=0x24A1, category='so', description='PARENTHESIZED LATIN SMALL LETTER F', specials={'compat',0x0028,0x0066,0x0029} },
	[0x24A2] = { unicodeslot=0x24A2, category='so', description='PARENTHESIZED LATIN SMALL LETTER G', specials={'compat',0x0028,0x0067,0x0029} },
	[0x24A3] = { unicodeslot=0x24A3, category='so', description='PARENTHESIZED LATIN SMALL LETTER H', specials={'compat',0x0028,0x0068,0x0029} },
	[0x24A4] = { unicodeslot=0x24A4, category='so', description='PARENTHESIZED LATIN SMALL LETTER I', specials={'compat',0x0028,0x0069,0x0029} },
	[0x24A5] = { unicodeslot=0x24A5, category='so', description='PARENTHESIZED LATIN SMALL LETTER J', specials={'compat',0x0028,0x006A,0x0029} },
	[0x24A6] = { unicodeslot=0x24A6, category='so', description='PARENTHESIZED LATIN SMALL LETTER K', specials={'compat',0x0028,0x006B,0x0029} },
	[0x24A7] = { unicodeslot=0x24A7, category='so', description='PARENTHESIZED LATIN SMALL LETTER L', specials={'compat',0x0028,0x006C,0x0029} },
	[0x24A8] = { unicodeslot=0x24A8, category='so', description='PARENTHESIZED LATIN SMALL LETTER M', specials={'compat',0x0028,0x006D,0x0029} },
	[0x24A9] = { unicodeslot=0x24A9, category='so', description='PARENTHESIZED LATIN SMALL LETTER N', specials={'compat',0x0028,0x006E,0x0029} },
	[0x24AA] = { unicodeslot=0x24AA, category='so', description='PARENTHESIZED LATIN SMALL LETTER O', specials={'compat',0x0028,0x006F,0x0029} },
	[0x24AB] = { unicodeslot=0x24AB, category='so', description='PARENTHESIZED LATIN SMALL LETTER P', specials={'compat',0x0028,0x0070,0x0029} },
	[0x24AC] = { unicodeslot=0x24AC, category='so', description='PARENTHESIZED LATIN SMALL LETTER Q', specials={'compat',0x0028,0x0071,0x0029} },
	[0x24AD] = { unicodeslot=0x24AD, category='so', description='PARENTHESIZED LATIN SMALL LETTER R', specials={'compat',0x0028,0x0072,0x0029} },
	[0x24AE] = { unicodeslot=0x24AE, category='so', description='PARENTHESIZED LATIN SMALL LETTER S', specials={'compat',0x0028,0x0073,0x0029} },
	[0x24AF] = { unicodeslot=0x24AF, category='so', description='PARENTHESIZED LATIN SMALL LETTER T', specials={'compat',0x0028,0x0074,0x0029} },
	[0x24B0] = { unicodeslot=0x24B0, category='so', description='PARENTHESIZED LATIN SMALL LETTER U', specials={'compat',0x0028,0x0075,0x0029} },
	[0x24B1] = { unicodeslot=0x24B1, category='so', description='PARENTHESIZED LATIN SMALL LETTER V', specials={'compat',0x0028,0x0076,0x0029} },
	[0x24B2] = { unicodeslot=0x24B2, category='so', description='PARENTHESIZED LATIN SMALL LETTER W', specials={'compat',0x0028,0x0077,0x0029} },
	[0x24B3] = { unicodeslot=0x24B3, category='so', description='PARENTHESIZED LATIN SMALL LETTER X', specials={'compat',0x0028,0x0078,0x0029} },
	[0x24B4] = { unicodeslot=0x24B4, category='so', description='PARENTHESIZED LATIN SMALL LETTER Y', specials={'compat',0x0028,0x0079,0x0029} },
	[0x24B5] = { unicodeslot=0x24B5, category='so', description='PARENTHESIZED LATIN SMALL LETTER Z', specials={'compat',0x0028,0x007A,0x0029} },
	[0x24B6] = { unicodeslot=0x24B6, category='so', description='CIRCLED LATIN CAPITAL LETTER A', lccode=0x24D0, specials={'circle',0x0041} },
	[0x24B7] = { unicodeslot=0x24B7, category='so', description='CIRCLED LATIN CAPITAL LETTER B', lccode=0x24D1, specials={'circle',0x0042} },
	[0x24B8] = { unicodeslot=0x24B8, category='so', description='CIRCLED LATIN CAPITAL LETTER C', lccode=0x24D2, specials={'circle',0x0043} },
	[0x24B9] = { unicodeslot=0x24B9, category='so', description='CIRCLED LATIN CAPITAL LETTER D', lccode=0x24D3, specials={'circle',0x0044} },
	[0x24BA] = { unicodeslot=0x24BA, category='so', description='CIRCLED LATIN CAPITAL LETTER E', lccode=0x24D4, specials={'circle',0x0045} },
	[0x24BB] = { unicodeslot=0x24BB, category='so', description='CIRCLED LATIN CAPITAL LETTER F', lccode=0x24D5, specials={'circle',0x0046} },
	[0x24BC] = { unicodeslot=0x24BC, category='so', description='CIRCLED LATIN CAPITAL LETTER G', lccode=0x24D6, specials={'circle',0x0047} },
	[0x24BD] = { unicodeslot=0x24BD, category='so', description='CIRCLED LATIN CAPITAL LETTER H', lccode=0x24D7, specials={'circle',0x0048} },
	[0x24BE] = { unicodeslot=0x24BE, category='so', description='CIRCLED LATIN CAPITAL LETTER I', lccode=0x24D8, specials={'circle',0x0049} },
	[0x24BF] = { unicodeslot=0x24BF, category='so', description='CIRCLED LATIN CAPITAL LETTER J', lccode=0x24D9, specials={'circle',0x004A} },
	[0x24C0] = { unicodeslot=0x24C0, category='so', description='CIRCLED LATIN CAPITAL LETTER K', lccode=0x24DA, specials={'circle',0x004B} },
	[0x24C1] = { unicodeslot=0x24C1, category='so', description='CIRCLED LATIN CAPITAL LETTER L', lccode=0x24DB, specials={'circle',0x004C} },
	[0x24C2] = { unicodeslot=0x24C2, category='so', description='CIRCLED LATIN CAPITAL LETTER M', lccode=0x24DC, specials={'circle',0x004D} },
	[0x24C3] = { unicodeslot=0x24C3, category='so', description='CIRCLED LATIN CAPITAL LETTER N', lccode=0x24DD, specials={'circle',0x004E} },
	[0x24C4] = { unicodeslot=0x24C4, category='so', description='CIRCLED LATIN CAPITAL LETTER O', lccode=0x24DE, specials={'circle',0x004F} },
	[0x24C5] = { unicodeslot=0x24C5, category='so', description='CIRCLED LATIN CAPITAL LETTER P', lccode=0x24DF, specials={'circle',0x0050} },
	[0x24C6] = { unicodeslot=0x24C6, category='so', description='CIRCLED LATIN CAPITAL LETTER Q', lccode=0x24E0, specials={'circle',0x0051} },
	[0x24C7] = { unicodeslot=0x24C7, category='so', description='CIRCLED LATIN CAPITAL LETTER R', lccode=0x24E1, specials={'circle',0x0052} },
	[0x24C8] = { unicodeslot=0x24C8, category='so', description='CIRCLED LATIN CAPITAL LETTER S', lccode=0x24E2, specials={'circle',0x0053} },
	[0x24C9] = { unicodeslot=0x24C9, category='so', description='CIRCLED LATIN CAPITAL LETTER T', lccode=0x24E3, specials={'circle',0x0054} },
	[0x24CA] = { unicodeslot=0x24CA, category='so', description='CIRCLED LATIN CAPITAL LETTER U', lccode=0x24E4, specials={'circle',0x0055} },
	[0x24CB] = { unicodeslot=0x24CB, category='so', description='CIRCLED LATIN CAPITAL LETTER V', lccode=0x24E5, specials={'circle',0x0056} },
	[0x24CC] = { unicodeslot=0x24CC, category='so', description='CIRCLED LATIN CAPITAL LETTER W', lccode=0x24E6, specials={'circle',0x0057} },
	[0x24CD] = { unicodeslot=0x24CD, category='so', description='CIRCLED LATIN CAPITAL LETTER X', lccode=0x24E7, specials={'circle',0x0058} },
	[0x24CE] = { unicodeslot=0x24CE, category='so', description='CIRCLED LATIN CAPITAL LETTER Y', lccode=0x24E8, specials={'circle',0x0059} },
	[0x24CF] = { unicodeslot=0x24CF, category='so', description='CIRCLED LATIN CAPITAL LETTER Z', lccode=0x24E9, specials={'circle',0x005A} },
	[0x24D0] = { unicodeslot=0x24D0, category='so', description='CIRCLED LATIN SMALL LETTER A', uccode=0x24B6, specials={'circle',0x0061} },
	[0x24D1] = { unicodeslot=0x24D1, category='so', description='CIRCLED LATIN SMALL LETTER B', uccode=0x24B7, specials={'circle',0x0062} },
	[0x24D2] = { unicodeslot=0x24D2, category='so', description='CIRCLED LATIN SMALL LETTER C', uccode=0x24B8, specials={'circle',0x0063} },
	[0x24D3] = { unicodeslot=0x24D3, category='so', description='CIRCLED LATIN SMALL LETTER D', uccode=0x24B9, specials={'circle',0x0064} },
	[0x24D4] = { unicodeslot=0x24D4, category='so', description='CIRCLED LATIN SMALL LETTER E', uccode=0x24BA, specials={'circle',0x0065} },
	[0x24D5] = { unicodeslot=0x24D5, category='so', description='CIRCLED LATIN SMALL LETTER F', uccode=0x24BB, specials={'circle',0x0066} },
	[0x24D6] = { unicodeslot=0x24D6, category='so', description='CIRCLED LATIN SMALL LETTER G', uccode=0x24BC, specials={'circle',0x0067} },
	[0x24D7] = { unicodeslot=0x24D7, category='so', description='CIRCLED LATIN SMALL LETTER H', uccode=0x24BD, specials={'circle',0x0068} },
	[0x24D8] = { unicodeslot=0x24D8, category='so', description='CIRCLED LATIN SMALL LETTER I', uccode=0x24BE, specials={'circle',0x0069} },
	[0x24D9] = { unicodeslot=0x24D9, category='so', description='CIRCLED LATIN SMALL LETTER J', uccode=0x24BF, specials={'circle',0x006A} },
	[0x24DA] = { unicodeslot=0x24DA, category='so', description='CIRCLED LATIN SMALL LETTER K', uccode=0x24C0, specials={'circle',0x006B} },
	[0x24DB] = { unicodeslot=0x24DB, category='so', description='CIRCLED LATIN SMALL LETTER L', uccode=0x24C1, specials={'circle',0x006C} },
	[0x24DC] = { unicodeslot=0x24DC, category='so', description='CIRCLED LATIN SMALL LETTER M', uccode=0x24C2, specials={'circle',0x006D} },
	[0x24DD] = { unicodeslot=0x24DD, category='so', description='CIRCLED LATIN SMALL LETTER N', uccode=0x24C3, specials={'circle',0x006E} },
	[0x24DE] = { unicodeslot=0x24DE, category='so', description='CIRCLED LATIN SMALL LETTER O', uccode=0x24C4, specials={'circle',0x006F} },
	[0x24DF] = { unicodeslot=0x24DF, category='so', description='CIRCLED LATIN SMALL LETTER P', uccode=0x24C5, specials={'circle',0x0070} },
	[0x24E0] = { unicodeslot=0x24E0, category='so', description='CIRCLED LATIN SMALL LETTER Q', uccode=0x24C6, specials={'circle',0x0071} },
	[0x24E1] = { unicodeslot=0x24E1, category='so', description='CIRCLED LATIN SMALL LETTER R', uccode=0x24C7, specials={'circle',0x0072} },
	[0x24E2] = { unicodeslot=0x24E2, category='so', description='CIRCLED LATIN SMALL LETTER S', uccode=0x24C8, specials={'circle',0x0073} },
	[0x24E3] = { unicodeslot=0x24E3, category='so', description='CIRCLED LATIN SMALL LETTER T', uccode=0x24C9, specials={'circle',0x0074} },
	[0x24E4] = { unicodeslot=0x24E4, category='so', description='CIRCLED LATIN SMALL LETTER U', uccode=0x24CA, specials={'circle',0x0075} },
	[0x24E5] = { unicodeslot=0x24E5, category='so', description='CIRCLED LATIN SMALL LETTER V', uccode=0x24CB, specials={'circle',0x0076} },
	[0x24E6] = { unicodeslot=0x24E6, category='so', description='CIRCLED LATIN SMALL LETTER W', uccode=0x24CC, specials={'circle',0x0077} },
	[0x24E7] = { unicodeslot=0x24E7, category='so', description='CIRCLED LATIN SMALL LETTER X', uccode=0x24CD, specials={'circle',0x0078} },
	[0x24E8] = { unicodeslot=0x24E8, category='so', description='CIRCLED LATIN SMALL LETTER Y', uccode=0x24CE, specials={'circle',0x0079} },
	[0x24E9] = { unicodeslot=0x24E9, category='so', description='CIRCLED LATIN SMALL LETTER Z', uccode=0x24CF, specials={'circle',0x007A} },
	[0x24EA] = { unicodeslot=0x24EA, category='no', description='CIRCLED DIGIT ZERO', specials={'circle',0x0030} },
	[0x24EB] = { unicodeslot=0x24EB, category='no', description='NEGATIVE CIRCLED NUMBER ELEVEN' },
	[0x24EC] = { unicodeslot=0x24EC, category='no', description='NEGATIVE CIRCLED NUMBER TWELVE' },
	[0x24ED] = { unicodeslot=0x24ED, category='no', description='NEGATIVE CIRCLED NUMBER THIRTEEN' },
	[0x24EE] = { unicodeslot=0x24EE, category='no', description='NEGATIVE CIRCLED NUMBER FOURTEEN' },
	[0x24EF] = { unicodeslot=0x24EF, category='no', description='NEGATIVE CIRCLED NUMBER FIFTEEN' },
	[0x24F0] = { unicodeslot=0x24F0, category='no', description='NEGATIVE CIRCLED NUMBER SIXTEEN' },
	[0x24F1] = { unicodeslot=0x24F1, category='no', description='NEGATIVE CIRCLED NUMBER SEVENTEEN' },
	[0x24F2] = { unicodeslot=0x24F2, category='no', description='NEGATIVE CIRCLED NUMBER EIGHTEEN' },
	[0x24F3] = { unicodeslot=0x24F3, category='no', description='NEGATIVE CIRCLED NUMBER NINETEEN' },
	[0x24F4] = { unicodeslot=0x24F4, category='no', description='NEGATIVE CIRCLED NUMBER TWENTY' },
	[0x24F5] = { unicodeslot=0x24F5, category='no', description='DOUBLE CIRCLED DIGIT ONE' },
	[0x24F6] = { unicodeslot=0x24F6, category='no', description='DOUBLE CIRCLED DIGIT TWO' },
	[0x24F7] = { unicodeslot=0x24F7, category='no', description='DOUBLE CIRCLED DIGIT THREE' },
	[0x24F8] = { unicodeslot=0x24F8, category='no', description='DOUBLE CIRCLED DIGIT FOUR' },
	[0x24F9] = { unicodeslot=0x24F9, category='no', description='DOUBLE CIRCLED DIGIT FIVE' },
	[0x24FA] = { unicodeslot=0x24FA, category='no', description='DOUBLE CIRCLED DIGIT SIX' },
	[0x24FB] = { unicodeslot=0x24FB, category='no', description='DOUBLE CIRCLED DIGIT SEVEN' },
	[0x24FC] = { unicodeslot=0x24FC, category='no', description='DOUBLE CIRCLED DIGIT EIGHT' },
	[0x24FD] = { unicodeslot=0x24FD, category='no', description='DOUBLE CIRCLED DIGIT NINE' },
	[0x24FE] = { unicodeslot=0x24FE, category='no', description='DOUBLE CIRCLED NUMBER TEN' },
	[0x24FF] = { unicodeslot=0x24FF, category='no', description='NEGATIVE CIRCLED DIGIT ZERO' },
	[0x2500] = { unicodeslot=0x2500, category='so', adobename='SF100000', description='BOX DRAWINGS LIGHT HORIZONTAL' },
	[0x2501] = { unicodeslot=0x2501, category='so', description='BOX DRAWINGS HEAVY HORIZONTAL' },
	[0x2502] = { unicodeslot=0x2502, category='so', adobename='SF110000', description='BOX DRAWINGS LIGHT VERTICAL' },
	[0x2503] = { unicodeslot=0x2503, category='so', description='BOX DRAWINGS HEAVY VERTICAL' },
	[0x2504] = { unicodeslot=0x2504, category='so', description='BOX DRAWINGS LIGHT TRIPLE DASH HORIZONTAL' },
	[0x2505] = { unicodeslot=0x2505, category='so', description='BOX DRAWINGS HEAVY TRIPLE DASH HORIZONTAL' },
	[0x2506] = { unicodeslot=0x2506, category='so', description='BOX DRAWINGS LIGHT TRIPLE DASH VERTICAL' },
	[0x2507] = { unicodeslot=0x2507, category='so', description='BOX DRAWINGS HEAVY TRIPLE DASH VERTICAL' },
	[0x2508] = { unicodeslot=0x2508, category='so', description='BOX DRAWINGS LIGHT QUADRUPLE DASH HORIZONTAL' },
	[0x2509] = { unicodeslot=0x2509, category='so', description='BOX DRAWINGS HEAVY QUADRUPLE DASH HORIZONTAL' },
	[0x250A] = { unicodeslot=0x250A, category='so', description='BOX DRAWINGS LIGHT QUADRUPLE DASH VERTICAL' },
	[0x250B] = { unicodeslot=0x250B, category='so', description='BOX DRAWINGS HEAVY QUADRUPLE DASH VERTICAL' },
	[0x250C] = { unicodeslot=0x250C, category='so', adobename='SF010000', description='BOX DRAWINGS LIGHT DOWN AND RIGHT' },
	[0x250D] = { unicodeslot=0x250D, category='so', description='BOX DRAWINGS DOWN LIGHT AND RIGHT HEAVY' },
	[0x250E] = { unicodeslot=0x250E, category='so', description='BOX DRAWINGS DOWN HEAVY AND RIGHT LIGHT' },
	[0x250F] = { unicodeslot=0x250F, category='so', description='BOX DRAWINGS HEAVY DOWN AND RIGHT' },
	[0x2510] = { unicodeslot=0x2510, category='so', adobename='SF030000', description='BOX DRAWINGS LIGHT DOWN AND LEFT' },
	[0x2511] = { unicodeslot=0x2511, category='so', description='BOX DRAWINGS DOWN LIGHT AND LEFT HEAVY' },
	[0x2512] = { unicodeslot=0x2512, category='so', description='BOX DRAWINGS DOWN HEAVY AND LEFT LIGHT' },
	[0x2513] = { unicodeslot=0x2513, category='so', description='BOX DRAWINGS HEAVY DOWN AND LEFT' },
	[0x2514] = { unicodeslot=0x2514, category='so', adobename='SF020000', description='BOX DRAWINGS LIGHT UP AND RIGHT' },
	[0x2515] = { unicodeslot=0x2515, category='so', description='BOX DRAWINGS UP LIGHT AND RIGHT HEAVY' },
	[0x2516] = { unicodeslot=0x2516, category='so', description='BOX DRAWINGS UP HEAVY AND RIGHT LIGHT' },
	[0x2517] = { unicodeslot=0x2517, category='so', description='BOX DRAWINGS HEAVY UP AND RIGHT' },
	[0x2518] = { unicodeslot=0x2518, category='so', adobename='SF040000', description='BOX DRAWINGS LIGHT UP AND LEFT' },
	[0x2519] = { unicodeslot=0x2519, category='so', description='BOX DRAWINGS UP LIGHT AND LEFT HEAVY' },
	[0x251A] = { unicodeslot=0x251A, category='so', description='BOX DRAWINGS UP HEAVY AND LEFT LIGHT' },
	[0x251B] = { unicodeslot=0x251B, category='so', description='BOX DRAWINGS HEAVY UP AND LEFT' },
	[0x251C] = { unicodeslot=0x251C, category='so', adobename='SF080000', description='BOX DRAWINGS LIGHT VERTICAL AND RIGHT' },
	[0x251D] = { unicodeslot=0x251D, category='so', description='BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY' },
	[0x251E] = { unicodeslot=0x251E, category='so', description='BOX DRAWINGS UP HEAVY AND RIGHT DOWN LIGHT' },
	[0x251F] = { unicodeslot=0x251F, category='so', description='BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT' },
	[0x2520] = { unicodeslot=0x2520, category='so', description='BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT' },
	[0x2521] = { unicodeslot=0x2521, category='so', description='BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY' },
	[0x2522] = { unicodeslot=0x2522, category='so', description='BOX DRAWINGS UP LIGHT AND RIGHT DOWN HEAVY' },
	[0x2523] = { unicodeslot=0x2523, category='so', description='BOX DRAWINGS HEAVY VERTICAL AND RIGHT' },
	[0x2524] = { unicodeslot=0x2524, category='so', adobename='SF090000', description='BOX DRAWINGS LIGHT VERTICAL AND LEFT' },
	[0x2525] = { unicodeslot=0x2525, category='so', description='BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY' },
	[0x2526] = { unicodeslot=0x2526, category='so', description='BOX DRAWINGS UP HEAVY AND LEFT DOWN LIGHT' },
	[0x2527] = { unicodeslot=0x2527, category='so', description='BOX DRAWINGS DOWN HEAVY AND LEFT UP LIGHT' },
	[0x2528] = { unicodeslot=0x2528, category='so', description='BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT' },
	[0x2529] = { unicodeslot=0x2529, category='so', description='BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY' },
	[0x252A] = { unicodeslot=0x252A, category='so', description='BOX DRAWINGS UP LIGHT AND LEFT DOWN HEAVY' },
	[0x252B] = { unicodeslot=0x252B, category='so', description='BOX DRAWINGS HEAVY VERTICAL AND LEFT' },
	[0x252C] = { unicodeslot=0x252C, category='so', adobename='SF060000', description='BOX DRAWINGS LIGHT DOWN AND HORIZONTAL' },
	[0x252D] = { unicodeslot=0x252D, category='so', description='BOX DRAWINGS LEFT HEAVY AND RIGHT DOWN LIGHT' },
	[0x252E] = { unicodeslot=0x252E, category='so', description='BOX DRAWINGS RIGHT HEAVY AND LEFT DOWN LIGHT' },
	[0x252F] = { unicodeslot=0x252F, category='so', description='BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY' },
	[0x2530] = { unicodeslot=0x2530, category='so', description='BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT' },
	[0x2531] = { unicodeslot=0x2531, category='so', description='BOX DRAWINGS RIGHT LIGHT AND LEFT DOWN HEAVY' },
	[0x2532] = { unicodeslot=0x2532, category='so', description='BOX DRAWINGS LEFT LIGHT AND RIGHT DOWN HEAVY' },
	[0x2533] = { unicodeslot=0x2533, category='so', description='BOX DRAWINGS HEAVY DOWN AND HORIZONTAL' },
	[0x2534] = { unicodeslot=0x2534, category='so', adobename='SF070000', description='BOX DRAWINGS LIGHT UP AND HORIZONTAL' },
	[0x2535] = { unicodeslot=0x2535, category='so', description='BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT' },
	[0x2536] = { unicodeslot=0x2536, category='so', description='BOX DRAWINGS RIGHT HEAVY AND LEFT UP LIGHT' },
	[0x2537] = { unicodeslot=0x2537, category='so', description='BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY' },
	[0x2538] = { unicodeslot=0x2538, category='so', description='BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT' },
	[0x2539] = { unicodeslot=0x2539, category='so', description='BOX DRAWINGS RIGHT LIGHT AND LEFT UP HEAVY' },
	[0x253A] = { unicodeslot=0x253A, category='so', description='BOX DRAWINGS LEFT LIGHT AND RIGHT UP HEAVY' },
	[0x253B] = { unicodeslot=0x253B, category='so', description='BOX DRAWINGS HEAVY UP AND HORIZONTAL' },
	[0x253C] = { unicodeslot=0x253C, category='so', adobename='SF050000', description='BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL' },
	[0x253D] = { unicodeslot=0x253D, category='so', description='BOX DRAWINGS LEFT HEAVY AND RIGHT VERTICAL LIGHT' },
	[0x253E] = { unicodeslot=0x253E, category='so', description='BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT' },
	[0x253F] = { unicodeslot=0x253F, category='so', description='BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY' },
	[0x2540] = { unicodeslot=0x2540, category='so', description='BOX DRAWINGS UP HEAVY AND DOWN HORIZONTAL LIGHT' },
	[0x2541] = { unicodeslot=0x2541, category='so', description='BOX DRAWINGS DOWN HEAVY AND UP HORIZONTAL LIGHT' },
	[0x2542] = { unicodeslot=0x2542, category='so', description='BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT' },
	[0x2543] = { unicodeslot=0x2543, category='so', description='BOX DRAWINGS LEFT UP HEAVY AND RIGHT DOWN LIGHT' },
	[0x2544] = { unicodeslot=0x2544, category='so', description='BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT' },
	[0x2545] = { unicodeslot=0x2545, category='so', description='BOX DRAWINGS LEFT DOWN HEAVY AND RIGHT UP LIGHT' },
	[0x2546] = { unicodeslot=0x2546, category='so', description='BOX DRAWINGS RIGHT DOWN HEAVY AND LEFT UP LIGHT' },
	[0x2547] = { unicodeslot=0x2547, category='so', description='BOX DRAWINGS DOWN LIGHT AND UP HORIZONTAL HEAVY' },
	[0x2548] = { unicodeslot=0x2548, category='so', description='BOX DRAWINGS UP LIGHT AND DOWN HORIZONTAL HEAVY' },
	[0x2549] = { unicodeslot=0x2549, category='so', description='BOX DRAWINGS RIGHT LIGHT AND LEFT VERTICAL HEAVY' },
	[0x254A] = { unicodeslot=0x254A, category='so', description='BOX DRAWINGS LEFT LIGHT AND RIGHT VERTICAL HEAVY' },
	[0x254B] = { unicodeslot=0x254B, category='so', description='BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL' },
	[0x254C] = { unicodeslot=0x254C, category='so', description='BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL' },
	[0x254D] = { unicodeslot=0x254D, category='so', description='BOX DRAWINGS HEAVY DOUBLE DASH HORIZONTAL' },
	[0x254E] = { unicodeslot=0x254E, category='so', description='BOX DRAWINGS LIGHT DOUBLE DASH VERTICAL' },
	[0x254F] = { unicodeslot=0x254F, category='so', description='BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL' },
	[0x2550] = { unicodeslot=0x2550, category='so', adobename='SF430000', description='BOX DRAWINGS DOUBLE HORIZONTAL' },
	[0x2551] = { unicodeslot=0x2551, category='so', adobename='SF240000', description='BOX DRAWINGS DOUBLE VERTICAL' },
	[0x2552] = { unicodeslot=0x2552, category='so', adobename='SF510000', description='BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE' },
	[0x2553] = { unicodeslot=0x2553, category='so', adobename='SF520000', description='BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE' },
	[0x2554] = { unicodeslot=0x2554, category='so', adobename='SF390000', description='BOX DRAWINGS DOUBLE DOWN AND RIGHT' },
	[0x2555] = { unicodeslot=0x2555, category='so', adobename='SF220000', description='BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE' },
	[0x2556] = { unicodeslot=0x2556, category='so', adobename='SF210000', description='BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE' },
	[0x2557] = { unicodeslot=0x2557, category='so', adobename='SF250000', description='BOX DRAWINGS DOUBLE DOWN AND LEFT' },
	[0x2558] = { unicodeslot=0x2558, category='so', adobename='SF500000', description='BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE' },
	[0x2559] = { unicodeslot=0x2559, category='so', adobename='SF490000', description='BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE' },
	[0x255A] = { unicodeslot=0x255A, category='so', adobename='SF380000', description='BOX DRAWINGS DOUBLE UP AND RIGHT' },
	[0x255B] = { unicodeslot=0x255B, category='so', adobename='SF280000', description='BOX DRAWINGS UP SINGLE AND LEFT DOUBLE' },
	[0x255C] = { unicodeslot=0x255C, category='so', adobename='SF270000', description='BOX DRAWINGS UP DOUBLE AND LEFT SINGLE' },
	[0x255D] = { unicodeslot=0x255D, category='so', adobename='SF260000', description='BOX DRAWINGS DOUBLE UP AND LEFT' },
	[0x255E] = { unicodeslot=0x255E, category='so', adobename='SF360000', description='BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE' },
	[0x255F] = { unicodeslot=0x255F, category='so', adobename='SF370000', description='BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE' },
	[0x2560] = { unicodeslot=0x2560, category='so', adobename='SF420000', description='BOX DRAWINGS DOUBLE VERTICAL AND RIGHT' },
	[0x2561] = { unicodeslot=0x2561, category='so', adobename='SF190000', description='BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE' },
	[0x2562] = { unicodeslot=0x2562, category='so', adobename='SF200000', description='BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE' },
	[0x2563] = { unicodeslot=0x2563, category='so', adobename='SF230000', description='BOX DRAWINGS DOUBLE VERTICAL AND LEFT' },
	[0x2564] = { unicodeslot=0x2564, category='so', adobename='SF470000', description='BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE' },
	[0x2565] = { unicodeslot=0x2565, category='so', adobename='SF480000', description='BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE' },
	[0x2566] = { unicodeslot=0x2566, category='so', adobename='SF410000', description='BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL' },
	[0x2567] = { unicodeslot=0x2567, category='so', adobename='SF450000', description='BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE' },
	[0x2568] = { unicodeslot=0x2568, category='so', adobename='SF460000', description='BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE' },
	[0x2569] = { unicodeslot=0x2569, category='so', adobename='SF400000', description='BOX DRAWINGS DOUBLE UP AND HORIZONTAL' },
	[0x256A] = { unicodeslot=0x256A, category='so', adobename='SF540000', description='BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE' },
	[0x256B] = { unicodeslot=0x256B, category='so', adobename='SF530000', description='BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE' },
	[0x256C] = { unicodeslot=0x256C, category='so', adobename='SF440000', description='BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL' },
	[0x256D] = { unicodeslot=0x256D, category='so', description='BOX DRAWINGS LIGHT ARC DOWN AND RIGHT' },
	[0x256E] = { unicodeslot=0x256E, category='so', description='BOX DRAWINGS LIGHT ARC DOWN AND LEFT' },
	[0x256F] = { unicodeslot=0x256F, category='so', description='BOX DRAWINGS LIGHT ARC UP AND LEFT' },
	[0x2570] = { unicodeslot=0x2570, category='so', description='BOX DRAWINGS LIGHT ARC UP AND RIGHT' },
	[0x2571] = { unicodeslot=0x2571, category='so', description='BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT' },
	[0x2572] = { unicodeslot=0x2572, category='so', description='BOX DRAWINGS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT' },
	[0x2573] = { unicodeslot=0x2573, category='so', description='BOX DRAWINGS LIGHT DIAGONAL CROSS' },
	[0x2574] = { unicodeslot=0x2574, category='so', description='BOX DRAWINGS LIGHT LEFT' },
	[0x2575] = { unicodeslot=0x2575, category='so', description='BOX DRAWINGS LIGHT UP' },
	[0x2576] = { unicodeslot=0x2576, category='so', description='BOX DRAWINGS LIGHT RIGHT' },
	[0x2577] = { unicodeslot=0x2577, category='so', description='BOX DRAWINGS LIGHT DOWN' },
	[0x2578] = { unicodeslot=0x2578, category='so', description='BOX DRAWINGS HEAVY LEFT' },
	[0x2579] = { unicodeslot=0x2579, category='so', description='BOX DRAWINGS HEAVY UP' },
	[0x257A] = { unicodeslot=0x257A, category='so', description='BOX DRAWINGS HEAVY RIGHT' },
	[0x257B] = { unicodeslot=0x257B, category='so', description='BOX DRAWINGS HEAVY DOWN' },
	[0x257C] = { unicodeslot=0x257C, category='so', description='BOX DRAWINGS LIGHT LEFT AND HEAVY RIGHT' },
	[0x257D] = { unicodeslot=0x257D, category='so', description='BOX DRAWINGS LIGHT UP AND HEAVY DOWN' },
	[0x257E] = { unicodeslot=0x257E, category='so', description='BOX DRAWINGS HEAVY LEFT AND LIGHT RIGHT' },
	[0x257F] = { unicodeslot=0x257F, category='so', description='BOX DRAWINGS HEAVY UP AND LIGHT DOWN' },
	[0x2580] = { unicodeslot=0x2580, category='so', adobename='upblock', description='UPPER HALF BLOCK' },
	[0x2581] = { unicodeslot=0x2581, category='so', description='LOWER ONE EIGHTH BLOCK' },
	[0x2582] = { unicodeslot=0x2582, category='so', description='LOWER ONE QUARTER BLOCK' },
	[0x2583] = { unicodeslot=0x2583, category='so', description='LOWER THREE EIGHTHS BLOCK' },
	[0x2584] = { unicodeslot=0x2584, category='so', adobename='dnblock', description='LOWER HALF BLOCK' },
	[0x2585] = { unicodeslot=0x2585, category='so', description='LOWER FIVE EIGHTHS BLOCK' },
	[0x2586] = { unicodeslot=0x2586, category='so', description='LOWER THREE QUARTERS BLOCK' },
	[0x2587] = { unicodeslot=0x2587, category='so', description='LOWER SEVEN EIGHTHS BLOCK' },
	[0x2588] = { unicodeslot=0x2588, category='so', adobename='block', description='FULL BLOCK' },
	[0x2589] = { unicodeslot=0x2589, category='so', description='LEFT SEVEN EIGHTHS BLOCK' },
	[0x258A] = { unicodeslot=0x258A, category='so', description='LEFT THREE QUARTERS BLOCK' },
	[0x258B] = { unicodeslot=0x258B, category='so', description='LEFT FIVE EIGHTHS BLOCK' },
	[0x258C] = { unicodeslot=0x258C, category='so', adobename='lfblock', description='LEFT HALF BLOCK' },
	[0x258D] = { unicodeslot=0x258D, category='so', description='LEFT THREE EIGHTHS BLOCK' },
	[0x258E] = { unicodeslot=0x258E, category='so', description='LEFT ONE QUARTER BLOCK' },
	[0x258F] = { unicodeslot=0x258F, category='so', description='LEFT ONE EIGHTH BLOCK' },
	[0x2590] = { unicodeslot=0x2590, category='so', adobename='rtblock', description='RIGHT HALF BLOCK' },
	[0x2591] = { unicodeslot=0x2591, category='so', adobename='ltshade', description='LIGHT SHADE' },
	[0x2592] = { unicodeslot=0x2592, category='so', adobename='shade', description='MEDIUM SHADE' },
	[0x2593] = { unicodeslot=0x2593, category='so', adobename='dkshade', description='DARK SHADE' },
	[0x2594] = { unicodeslot=0x2594, category='so', description='UPPER ONE EIGHTH BLOCK' },
	[0x2595] = { unicodeslot=0x2595, category='so', description='RIGHT ONE EIGHTH BLOCK' },
	[0x2596] = { unicodeslot=0x2596, category='so', description='QUADRANT LOWER LEFT' },
	[0x2597] = { unicodeslot=0x2597, category='so', description='QUADRANT LOWER RIGHT' },
	[0x2598] = { unicodeslot=0x2598, category='so', description='QUADRANT UPPER LEFT' },
	[0x2599] = { unicodeslot=0x2599, category='so', description='QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT' },
	[0x259A] = { unicodeslot=0x259A, category='so', description='QUADRANT UPPER LEFT AND LOWER RIGHT' },
	[0x259B] = { unicodeslot=0x259B, category='so', description='QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT' },
	[0x259C] = { unicodeslot=0x259C, category='so', description='QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT' },
	[0x259D] = { unicodeslot=0x259D, category='so', description='QUADRANT UPPER RIGHT' },
	[0x259E] = { unicodeslot=0x259E, category='so', description='QUADRANT UPPER RIGHT AND LOWER LEFT' },
	[0x259F] = { unicodeslot=0x259F, category='so', description='QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT' },
	[0x25A0] = { unicodeslot=0x25A0, category='so', adobename='filledbox', description='BLACK SQUARE' },
	[0x25A1] = { unicodeslot=0x25A1, category='so', adobename='H22073', description='WHITE SQUARE' },
	[0x25A2] = { unicodeslot=0x25A2, category='so', description='WHITE SQUARE WITH ROUNDED CORNERS' },
	[0x25A3] = { unicodeslot=0x25A3, category='so', description='WHITE SQUARE CONTAINING BLACK SMALL SQUARE' },
	[0x25A4] = { unicodeslot=0x25A4, category='so', description='SQUARE WITH HORIZONTAL FILL' },
	[0x25A5] = { unicodeslot=0x25A5, category='so', description='SQUARE WITH VERTICAL FILL' },
	[0x25A6] = { unicodeslot=0x25A6, category='so', description='SQUARE WITH ORTHOGONAL CROSSHATCH FILL' },
	[0x25A7] = { unicodeslot=0x25A7, category='so', description='SQUARE WITH UPPER LEFT TO LOWER RIGHT FILL' },
	[0x25A8] = { unicodeslot=0x25A8, category='so', description='SQUARE WITH UPPER RIGHT TO LOWER LEFT FILL' },
	[0x25A9] = { unicodeslot=0x25A9, category='so', description='SQUARE WITH DIAGONAL CROSSHATCH FILL' },
	[0x25AA] = { unicodeslot=0x25AA, category='so', adobename='H18543', description='BLACK SMALL SQUARE' },
	[0x25AB] = { unicodeslot=0x25AB, category='so', adobename='H18551', description='WHITE SMALL SQUARE' },
	[0x25AC] = { unicodeslot=0x25AC, category='so', adobename='filledrect', description='BLACK RECTANGLE' },
	[0x25AD] = { unicodeslot=0x25AD, category='so', description='WHITE RECTANGLE' },
	[0x25AE] = { unicodeslot=0x25AE, category='so', description='BLACK VERTICAL RECTANGLE' },
	[0x25AF] = { unicodeslot=0x25AF, category='so', description='WHITE VERTICAL RECTANGLE' },
	[0x25B0] = { unicodeslot=0x25B0, category='so', description='BLACK PARALLELOGRAM' },
	[0x25B1] = { unicodeslot=0x25B1, category='so', description='WHITE PARALLELOGRAM' },
	[0x25B2] = { unicodeslot=0x25B2, category='so', adobename='triagup', description='BLACK UP-POINTING TRIANGLE' },
	[0x25B3] = { unicodeslot=0x25B3, category='so', description='WHITE UP-POINTING TRIANGLE' },
	[0x25B4] = { unicodeslot=0x25B4, category='so', description='BLACK UP-POINTING SMALL TRIANGLE' },
	[0x25B5] = { unicodeslot=0x25B5, category='so', description='WHITE UP-POINTING SMALL TRIANGLE' },
	[0x25B6] = { unicodeslot=0x25B6, category='so', description='BLACK RIGHT-POINTING TRIANGLE' },
	[0x25B7] = { unicodeslot=0x25B7, category='sm', description='WHITE RIGHT-POINTING TRIANGLE' },
	[0x25B8] = { unicodeslot=0x25B8, category='so', description='BLACK RIGHT-POINTING SMALL TRIANGLE' },
	[0x25B9] = { unicodeslot=0x25B9, category='so', description='WHITE RIGHT-POINTING SMALL TRIANGLE' },
	[0x25BA] = { unicodeslot=0x25BA, category='so', adobename='triagrt', description='BLACK RIGHT-POINTING POINTER' },
	[0x25BB] = { unicodeslot=0x25BB, category='so', description='WHITE RIGHT-POINTING POINTER' },
	[0x25BC] = { unicodeslot=0x25BC, category='so', adobename='triagdn', description='BLACK DOWN-POINTING TRIANGLE' },
	[0x25BD] = { unicodeslot=0x25BD, category='so', description='WHITE DOWN-POINTING TRIANGLE' },
	[0x25BE] = { unicodeslot=0x25BE, category='so', description='BLACK DOWN-POINTING SMALL TRIANGLE' },
	[0x25BF] = { unicodeslot=0x25BF, category='so', description='WHITE DOWN-POINTING SMALL TRIANGLE' },
	[0x25C0] = { unicodeslot=0x25C0, category='so', description='BLACK LEFT-POINTING TRIANGLE' },
	[0x25C1] = { unicodeslot=0x25C1, category='sm', description='WHITE LEFT-POINTING TRIANGLE' },
	[0x25C2] = { unicodeslot=0x25C2, category='so', description='BLACK LEFT-POINTING SMALL TRIANGLE' },
	[0x25C3] = { unicodeslot=0x25C3, category='so', description='WHITE LEFT-POINTING SMALL TRIANGLE' },
	[0x25C4] = { unicodeslot=0x25C4, category='so', adobename='triaglf', description='BLACK LEFT-POINTING POINTER' },
	[0x25C5] = { unicodeslot=0x25C5, category='so', description='WHITE LEFT-POINTING POINTER' },
	[0x25C6] = { unicodeslot=0x25C6, category='so', description='BLACK DIAMOND' },
	[0x25C7] = { unicodeslot=0x25C7, category='so', description='WHITE DIAMOND' },
	[0x25C8] = { unicodeslot=0x25C8, category='so', description='WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND' },
	[0x25C9] = { unicodeslot=0x25C9, category='so', description='FISHEYE' },
	[0x25CA] = { unicodeslot=0x25CA, category='so', adobename='lozenge', description='LOZENGE' },
	[0x25CB] = { unicodeslot=0x25CB, category='so', adobename='circle', description='WHITE CIRCLE' },
	[0x25CC] = { unicodeslot=0x25CC, category='so', description='DOTTED CIRCLE' },
	[0x25CD] = { unicodeslot=0x25CD, category='so', description='CIRCLE WITH VERTICAL FILL' },
	[0x25CE] = { unicodeslot=0x25CE, category='so', description='BULLSEYE' },
	[0x25CF] = { unicodeslot=0x25CF, category='so', adobename='H18533', description='BLACK CIRCLE' },
	[0x25D0] = { unicodeslot=0x25D0, category='so', description='CIRCLE WITH LEFT HALF BLACK' },
	[0x25D1] = { unicodeslot=0x25D1, category='so', description='CIRCLE WITH RIGHT HALF BLACK' },
	[0x25D2] = { unicodeslot=0x25D2, category='so', description='CIRCLE WITH LOWER HALF BLACK' },
	[0x25D3] = { unicodeslot=0x25D3, category='so', description='CIRCLE WITH UPPER HALF BLACK' },
	[0x25D4] = { unicodeslot=0x25D4, category='so', description='CIRCLE WITH UPPER RIGHT QUADRANT BLACK' },
	[0x25D5] = { unicodeslot=0x25D5, category='so', description='CIRCLE WITH ALL BUT UPPER LEFT QUADRANT BLACK' },
	[0x25D6] = { unicodeslot=0x25D6, category='so', description='LEFT HALF BLACK CIRCLE' },
	[0x25D7] = { unicodeslot=0x25D7, category='so', description='RIGHT HALF BLACK CIRCLE' },
	[0x25D8] = { unicodeslot=0x25D8, category='so', adobename='invbullet', description='INVERSE BULLET' },
	[0x25D9] = { unicodeslot=0x25D9, category='so', adobename='invcircle', description='INVERSE WHITE CIRCLE' },
	[0x25DA] = { unicodeslot=0x25DA, category='so', description='UPPER HALF INVERSE WHITE CIRCLE' },
	[0x25DB] = { unicodeslot=0x25DB, category='so', description='LOWER HALF INVERSE WHITE CIRCLE' },
	[0x25DC] = { unicodeslot=0x25DC, category='so', description='UPPER LEFT QUADRANT CIRCULAR ARC' },
	[0x25DD] = { unicodeslot=0x25DD, category='so', description='UPPER RIGHT QUADRANT CIRCULAR ARC' },
	[0x25DE] = { unicodeslot=0x25DE, category='so', description='LOWER RIGHT QUADRANT CIRCULAR ARC' },
	[0x25DF] = { unicodeslot=0x25DF, category='so', description='LOWER LEFT QUADRANT CIRCULAR ARC' },
	[0x25E0] = { unicodeslot=0x25E0, category='so', description='UPPER HALF CIRCLE' },
	[0x25E1] = { unicodeslot=0x25E1, category='so', description='LOWER HALF CIRCLE' },
	[0x25E2] = { unicodeslot=0x25E2, category='so', description='BLACK LOWER RIGHT TRIANGLE' },
	[0x25E3] = { unicodeslot=0x25E3, category='so', description='BLACK LOWER LEFT TRIANGLE' },
	[0x25E4] = { unicodeslot=0x25E4, category='so', description='BLACK UPPER LEFT TRIANGLE' },
	[0x25E5] = { unicodeslot=0x25E5, category='so', description='BLACK UPPER RIGHT TRIANGLE' },
	[0x25E6] = { unicodeslot=0x25E6, category='so', adobename='openbullet', description='WHITE BULLET' },
	[0x25E7] = { unicodeslot=0x25E7, category='so', description='SQUARE WITH LEFT HALF BLACK' },
	[0x25E8] = { unicodeslot=0x25E8, category='so', description='SQUARE WITH RIGHT HALF BLACK' },
	[0x25E9] = { unicodeslot=0x25E9, category='so', description='SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK' },
	[0x25EA] = { unicodeslot=0x25EA, category='so', description='SQUARE WITH LOWER RIGHT DIAGONAL HALF BLACK' },
	[0x25EB] = { unicodeslot=0x25EB, category='so', description='WHITE SQUARE WITH VERTICAL BISECTING LINE' },
	[0x25EC] = { unicodeslot=0x25EC, category='so', description='WHITE UP-POINTING TRIANGLE WITH DOT' },
	[0x25ED] = { unicodeslot=0x25ED, category='so', description='UP-POINTING TRIANGLE WITH LEFT HALF BLACK' },
	[0x25EE] = { unicodeslot=0x25EE, category='so', description='UP-POINTING TRIANGLE WITH RIGHT HALF BLACK' },
	[0x25EF] = { unicodeslot=0x25EF, category='so', description='LARGE CIRCLE' },
	[0x25F0] = { unicodeslot=0x25F0, category='so', description='WHITE SQUARE WITH UPPER LEFT QUADRANT' },
	[0x25F1] = { unicodeslot=0x25F1, category='so', description='WHITE SQUARE WITH LOWER LEFT QUADRANT' },
	[0x25F2] = { unicodeslot=0x25F2, category='so', description='WHITE SQUARE WITH LOWER RIGHT QUADRANT' },
	[0x25F3] = { unicodeslot=0x25F3, category='so', description='WHITE SQUARE WITH UPPER RIGHT QUADRANT' },
	[0x25F4] = { unicodeslot=0x25F4, category='so', description='WHITE CIRCLE WITH UPPER LEFT QUADRANT' },
	[0x25F5] = { unicodeslot=0x25F5, category='so', description='WHITE CIRCLE WITH LOWER LEFT QUADRANT' },
	[0x25F6] = { unicodeslot=0x25F6, category='so', description='WHITE CIRCLE WITH LOWER RIGHT QUADRANT' },
	[0x25F7] = { unicodeslot=0x25F7, category='so', description='WHITE CIRCLE WITH UPPER RIGHT QUADRANT' },
	[0x25F8] = { unicodeslot=0x25F8, category='sm', description='UPPER LEFT TRIANGLE' },
	[0x25F9] = { unicodeslot=0x25F9, category='sm', description='UPPER RIGHT TRIANGLE' },
	[0x25FA] = { unicodeslot=0x25FA, category='sm', description='LOWER LEFT TRIANGLE' },
	[0x25FB] = { unicodeslot=0x25FB, category='sm', description='WHITE MEDIUM SQUARE' },
	[0x25FC] = { unicodeslot=0x25FC, category='sm', description='BLACK MEDIUM SQUARE' },
	[0x25FD] = { unicodeslot=0x25FD, category='sm', description='WHITE MEDIUM SMALL SQUARE' },
	[0x25FE] = { unicodeslot=0x25FE, category='sm', description='BLACK MEDIUM SMALL SQUARE' },
	[0x25FF] = { unicodeslot=0x25FF, category='sm', description='LOWER RIGHT TRIANGLE' },
	[0x2600] = { unicodeslot=0x2600, category='so', description='BLACK SUN WITH RAYS' },
	[0x2601] = { unicodeslot=0x2601, category='so', description='CLOUD' },
	[0x2602] = { unicodeslot=0x2602, category='so', description='UMBRELLA' },
	[0x2603] = { unicodeslot=0x2603, category='so', description='SNOWMAN' },
	[0x2604] = { unicodeslot=0x2604, category='so', description='COMET' },
	[0x2605] = { unicodeslot=0x2605, category='so', description='BLACK STAR' },
	[0x2606] = { unicodeslot=0x2606, category='so', description='WHITE STAR' },
	[0x2607] = { unicodeslot=0x2607, category='so', description='LIGHTNING' },
	[0x2608] = { unicodeslot=0x2608, category='so', description='THUNDERSTORM' },
	[0x2609] = { unicodeslot=0x2609, category='so', description='SUN' },
	[0x260A] = { unicodeslot=0x260A, category='so', description='ASCENDING NODE' },
	[0x260B] = { unicodeslot=0x260B, category='so', description='DESCENDING NODE' },
	[0x260C] = { unicodeslot=0x260C, category='so', description='CONJUNCTION' },
	[0x260D] = { unicodeslot=0x260D, category='so', description='OPPOSITION' },
	[0x260E] = { unicodeslot=0x260E, category='so', description='BLACK TELEPHONE' },
	[0x260F] = { unicodeslot=0x260F, category='so', description='WHITE TELEPHONE' },
	[0x2610] = { unicodeslot=0x2610, category='so', description='BALLOT BOX' },
	[0x2611] = { unicodeslot=0x2611, category='so', description='BALLOT BOX WITH CHECK' },
	[0x2612] = { unicodeslot=0x2612, category='so', description='BALLOT BOX WITH X' },
	[0x2613] = { unicodeslot=0x2613, category='so', description='SALTIRE' },
	[0x2614] = { unicodeslot=0x2614, category='so', description='UMBRELLA WITH RAIN DROPS' },
	[0x2615] = { unicodeslot=0x2615, category='so', description='HOT BEVERAGE' },
	[0x2616] = { unicodeslot=0x2616, category='so', description='WHITE SHOGI PIECE' },
	[0x2617] = { unicodeslot=0x2617, category='so', description='BLACK SHOGI PIECE' },
	[0x2618] = { unicodeslot=0x2618, category='so', description='SHAMROCK' },
	[0x2619] = { unicodeslot=0x2619, category='so', description='REVERSED ROTATED FLORAL HEART BULLET' },
	[0x261A] = { unicodeslot=0x261A, category='so', description='BLACK LEFT POINTING INDEX' },
	[0x261B] = { unicodeslot=0x261B, category='so', description='BLACK RIGHT POINTING INDEX' },
	[0x261C] = { unicodeslot=0x261C, category='so', description='WHITE LEFT POINTING INDEX' },
	[0x261D] = { unicodeslot=0x261D, category='so', description='WHITE UP POINTING INDEX' },
	[0x261E] = { unicodeslot=0x261E, category='so', description='WHITE RIGHT POINTING INDEX' },
	[0x261F] = { unicodeslot=0x261F, category='so', description='WHITE DOWN POINTING INDEX' },
	[0x2620] = { unicodeslot=0x2620, category='so', description='SKULL AND CROSSBONES' },
	[0x2621] = { unicodeslot=0x2621, category='so', description='CAUTION SIGN' },
	[0x2622] = { unicodeslot=0x2622, category='so', description='RADIOACTIVE SIGN' },
	[0x2623] = { unicodeslot=0x2623, category='so', description='BIOHAZARD SIGN' },
	[0x2624] = { unicodeslot=0x2624, category='so', description='CADUCEUS' },
	[0x2625] = { unicodeslot=0x2625, category='so', description='ANKH' },
	[0x2626] = { unicodeslot=0x2626, category='so', description='ORTHODOX CROSS' },
	[0x2627] = { unicodeslot=0x2627, category='so', description='CHI RHO' },
	[0x2628] = { unicodeslot=0x2628, category='so', description='CROSS OF LORRAINE' },
	[0x2629] = { unicodeslot=0x2629, category='so', description='CROSS OF JERUSALEM' },
	[0x262A] = { unicodeslot=0x262A, category='so', description='STAR AND CRESCENT' },
	[0x262B] = { unicodeslot=0x262B, category='so', description='FARSI SYMBOL' },
	[0x262C] = { unicodeslot=0x262C, category='so', description='ADI SHAKTI' },
	[0x262D] = { unicodeslot=0x262D, category='so', description='HAMMER AND SICKLE' },
	[0x262E] = { unicodeslot=0x262E, category='so', description='PEACE SYMBOL' },
	[0x262F] = { unicodeslot=0x262F, category='so', description='YIN YANG' },
	[0x2630] = { unicodeslot=0x2630, category='so', description='TRIGRAM FOR HEAVEN' },
	[0x2631] = { unicodeslot=0x2631, category='so', description='TRIGRAM FOR LAKE' },
	[0x2632] = { unicodeslot=0x2632, category='so', description='TRIGRAM FOR FIRE' },
	[0x2633] = { unicodeslot=0x2633, category='so', description='TRIGRAM FOR THUNDER' },
	[0x2634] = { unicodeslot=0x2634, category='so', description='TRIGRAM FOR WIND' },
	[0x2635] = { unicodeslot=0x2635, category='so', description='TRIGRAM FOR WATER' },
	[0x2636] = { unicodeslot=0x2636, category='so', description='TRIGRAM FOR MOUNTAIN' },
	[0x2637] = { unicodeslot=0x2637, category='so', description='TRIGRAM FOR EARTH' },
	[0x2638] = { unicodeslot=0x2638, category='so', description='WHEEL OF DHARMA' },
	[0x2639] = { unicodeslot=0x2639, category='so', description='WHITE FROWNING FACE' },
	[0x263A] = { unicodeslot=0x263A, category='so', adobename='smileface', description='WHITE SMILING FACE' },
	[0x263B] = { unicodeslot=0x263B, category='so', adobename='invsmileface', description='BLACK SMILING FACE' },
	[0x263C] = { unicodeslot=0x263C, category='so', adobename='sun', description='WHITE SUN WITH RAYS' },
	[0x263D] = { unicodeslot=0x263D, category='so', description='FIRST QUARTER MOON' },
	[0x263E] = { unicodeslot=0x263E, category='so', description='LAST QUARTER MOON' },
	[0x263F] = { unicodeslot=0x263F, category='so', description='MERCURY' },
	[0x2640] = { unicodeslot=0x2640, category='so', adobename='female', description='FEMALE SIGN' },
	[0x2641] = { unicodeslot=0x2641, category='so', description='EARTH' },
	[0x2642] = { unicodeslot=0x2642, category='so', adobename='male', description='MALE SIGN' },
	[0x2643] = { unicodeslot=0x2643, category='so', description='JUPITER' },
	[0x2644] = { unicodeslot=0x2644, category='so', description='SATURN' },
	[0x2645] = { unicodeslot=0x2645, category='so', description='URANUS' },
	[0x2646] = { unicodeslot=0x2646, category='so', description='NEPTUNE' },
	[0x2647] = { unicodeslot=0x2647, category='so', description='PLUTO' },
	[0x2648] = { unicodeslot=0x2648, category='so', description='ARIES' },
	[0x2649] = { unicodeslot=0x2649, category='so', description='TAURUS' },
	[0x264A] = { unicodeslot=0x264A, category='so', description='GEMINI' },
	[0x264B] = { unicodeslot=0x264B, category='so', description='CANCER' },
	[0x264C] = { unicodeslot=0x264C, category='so', description='LEO' },
	[0x264D] = { unicodeslot=0x264D, category='so', description='VIRGO' },
	[0x264E] = { unicodeslot=0x264E, category='so', description='LIBRA' },
	[0x264F] = { unicodeslot=0x264F, category='so', description='SCORPIUS' },
	[0x2650] = { unicodeslot=0x2650, category='so', description='SAGITTARIUS' },
	[0x2651] = { unicodeslot=0x2651, category='so', description='CAPRICORN' },
	[0x2652] = { unicodeslot=0x2652, category='so', description='AQUARIUS' },
	[0x2653] = { unicodeslot=0x2653, category='so', description='PISCES' },
	[0x2654] = { unicodeslot=0x2654, category='so', description='WHITE CHESS KING' },
	[0x2655] = { unicodeslot=0x2655, category='so', description='WHITE CHESS QUEEN' },
	[0x2656] = { unicodeslot=0x2656, category='so', description='WHITE CHESS ROOK' },
	[0x2657] = { unicodeslot=0x2657, category='so', description='WHITE CHESS BISHOP' },
	[0x2658] = { unicodeslot=0x2658, category='so', description='WHITE CHESS KNIGHT' },
	[0x2659] = { unicodeslot=0x2659, category='so', description='WHITE CHESS PAWN' },
	[0x265A] = { unicodeslot=0x265A, category='so', description='BLACK CHESS KING' },
	[0x265B] = { unicodeslot=0x265B, category='so', description='BLACK CHESS QUEEN' },
	[0x265C] = { unicodeslot=0x265C, category='so', description='BLACK CHESS ROOK' },
	[0x265D] = { unicodeslot=0x265D, category='so', description='BLACK CHESS BISHOP' },
	[0x265E] = { unicodeslot=0x265E, category='so', description='BLACK CHESS KNIGHT' },
	[0x265F] = { unicodeslot=0x265F, category='so', description='BLACK CHESS PAWN' },
	[0x2660] = { unicodeslot=0x2660, category='so', adobename='spade', description='BLACK SPADE SUIT' },
	[0x2661] = { unicodeslot=0x2661, category='so', description='WHITE HEART SUIT' },
	[0x2662] = { unicodeslot=0x2662, category='so', description='WHITE DIAMOND SUIT' },
	[0x2663] = { unicodeslot=0x2663, category='so', adobename='club', description='BLACK CLUB SUIT' },
	[0x2664] = { unicodeslot=0x2664, category='so', description='WHITE SPADE SUIT' },
	[0x2665] = { unicodeslot=0x2665, category='so', adobename='heart', description='BLACK HEART SUIT' },
	[0x2666] = { unicodeslot=0x2666, category='so', adobename='diamond', description='BLACK DIAMOND SUIT' },
	[0x2667] = { unicodeslot=0x2667, category='so', description='WHITE CLUB SUIT' },
	[0x2668] = { unicodeslot=0x2668, category='so', description='HOT SPRINGS' },
	[0x2669] = { unicodeslot=0x2669, category='so', description='QUARTER NOTE' },
	[0x266A] = { unicodeslot=0x266A, category='so', adobename='musicalnote', description='EIGHTH NOTE' },
	[0x266B] = { unicodeslot=0x266B, category='so', adobename='musicalnotedbl', description='BEAMED EIGHTH NOTES' },
	[0x266C] = { unicodeslot=0x266C, category='so', description='BEAMED SIXTEENTH NOTES' },
	[0x266D] = { unicodeslot=0x266D, category='so', description='MUSIC FLAT SIGN' },
	[0x266E] = { unicodeslot=0x266E, category='so', description='MUSIC NATURAL SIGN' },
	[0x266F] = { unicodeslot=0x266F, category='sm', description='MUSIC SHARP SIGN' },
	[0x2670] = { unicodeslot=0x2670, category='so', description='WEST SYRIAC CROSS' },
	[0x2671] = { unicodeslot=0x2671, category='so', description='EAST SYRIAC CROSS' },
	[0x2672] = { unicodeslot=0x2672, category='so', description='UNIVERSAL RECYCLING SYMBOL' },
	[0x2673] = { unicodeslot=0x2673, category='so', description='RECYCLING SYMBOL FOR TYPE-1 PLASTICS' },
	[0x2674] = { unicodeslot=0x2674, category='so', description='RECYCLING SYMBOL FOR TYPE-2 PLASTICS' },
	[0x2675] = { unicodeslot=0x2675, category='so', description='RECYCLING SYMBOL FOR TYPE-3 PLASTICS' },
	[0x2676] = { unicodeslot=0x2676, category='so', description='RECYCLING SYMBOL FOR TYPE-4 PLASTICS' },
	[0x2677] = { unicodeslot=0x2677, category='so', description='RECYCLING SYMBOL FOR TYPE-5 PLASTICS' },
	[0x2678] = { unicodeslot=0x2678, category='so', description='RECYCLING SYMBOL FOR TYPE-6 PLASTICS' },
	[0x2679] = { unicodeslot=0x2679, category='so', description='RECYCLING SYMBOL FOR TYPE-7 PLASTICS' },
	[0x267A] = { unicodeslot=0x267A, category='so', description='RECYCLING SYMBOL FOR GENERIC MATERIALS' },
	[0x267B] = { unicodeslot=0x267B, category='so', description='BLACK UNIVERSAL RECYCLING SYMBOL' },
	[0x267C] = { unicodeslot=0x267C, category='so', description='RECYCLED PAPER SYMBOL' },
	[0x267D] = { unicodeslot=0x267D, category='so', description='PARTIALLY-RECYCLED PAPER SYMBOL' },
	[0x267E] = { unicodeslot=0x267E, category='so', description='PERMANENT PAPER SIGN' },
	[0x267F] = { unicodeslot=0x267F, category='so', description='WHEELCHAIR SYMBOL' },
	[0x2680] = { unicodeslot=0x2680, category='so', description='DIE FACE-1' },
	[0x2681] = { unicodeslot=0x2681, category='so', description='DIE FACE-2' },
	[0x2682] = { unicodeslot=0x2682, category='so', description='DIE FACE-3' },
	[0x2683] = { unicodeslot=0x2683, category='so', description='DIE FACE-4' },
	[0x2684] = { unicodeslot=0x2684, category='so', description='DIE FACE-5' },
	[0x2685] = { unicodeslot=0x2685, category='so', description='DIE FACE-6' },
	[0x2686] = { unicodeslot=0x2686, category='so', description='WHITE CIRCLE WITH DOT RIGHT' },
	[0x2687] = { unicodeslot=0x2687, category='so', description='WHITE CIRCLE WITH TWO DOTS' },
	[0x2688] = { unicodeslot=0x2688, category='so', description='BLACK CIRCLE WITH WHITE DOT RIGHT' },
	[0x2689] = { unicodeslot=0x2689, category='so', description='BLACK CIRCLE WITH TWO WHITE DOTS' },
	[0x268A] = { unicodeslot=0x268A, category='so', description='MONOGRAM FOR YANG' },
	[0x268B] = { unicodeslot=0x268B, category='so', description='MONOGRAM FOR YIN' },
	[0x268C] = { unicodeslot=0x268C, category='so', description='DIGRAM FOR GREATER YANG' },
	[0x268D] = { unicodeslot=0x268D, category='so', description='DIGRAM FOR LESSER YIN' },
	[0x268E] = { unicodeslot=0x268E, category='so', description='DIGRAM FOR LESSER YANG' },
	[0x268F] = { unicodeslot=0x268F, category='so', description='DIGRAM FOR GREATER YIN' },
	[0x2690] = { unicodeslot=0x2690, category='so', description='WHITE FLAG' },
	[0x2691] = { unicodeslot=0x2691, category='so', description='BLACK FLAG' },
	[0x2692] = { unicodeslot=0x2692, category='so', description='HAMMER AND PICK' },
	[0x2693] = { unicodeslot=0x2693, category='so', description='ANCHOR' },
	[0x2694] = { unicodeslot=0x2694, category='so', description='CROSSED SWORDS' },
	[0x2695] = { unicodeslot=0x2695, category='so', description='STAFF OF AESCULAPIUS' },
	[0x2696] = { unicodeslot=0x2696, category='so', description='SCALES' },
	[0x2697] = { unicodeslot=0x2697, category='so', description='ALEMBIC' },
	[0x2698] = { unicodeslot=0x2698, category='so', description='FLOWER' },
	[0x2699] = { unicodeslot=0x2699, category='so', description='GEAR' },
	[0x269A] = { unicodeslot=0x269A, category='so', description='STAFF OF HERMES' },
	[0x269B] = { unicodeslot=0x269B, category='so', description='ATOM SYMBOL' },
	[0x269C] = { unicodeslot=0x269C, category='so', description='FLEUR-DE-LIS' },
	[0x26A0] = { unicodeslot=0x26A0, category='so', description='WARNING SIGN' },
	[0x26A1] = { unicodeslot=0x26A1, category='so', description='HIGH VOLTAGE SIGN' },
	[0x26A2] = { unicodeslot=0x26A2, category='so', description='DOUBLED FEMALE SIGN' },
	[0x26A3] = { unicodeslot=0x26A3, category='so', description='DOUBLED MALE SIGN' },
	[0x26A4] = { unicodeslot=0x26A4, category='so', description='INTERLOCKED FEMALE AND MALE SIGN' },
	[0x26A5] = { unicodeslot=0x26A5, category='so', description='MALE AND FEMALE SIGN' },
	[0x26A6] = { unicodeslot=0x26A6, category='so', description='MALE WITH STROKE SIGN' },
	[0x26A7] = { unicodeslot=0x26A7, category='so', description='MALE WITH STROKE AND MALE AND FEMALE SIGN' },
	[0x26A8] = { unicodeslot=0x26A8, category='so', description='VERTICAL MALE WITH STROKE SIGN' },
	[0x26A9] = { unicodeslot=0x26A9, category='so', description='HORIZONTAL MALE WITH STROKE SIGN' },
	[0x26AA] = { unicodeslot=0x26AA, category='so', description='MEDIUM WHITE CIRCLE' },
	[0x26AB] = { unicodeslot=0x26AB, category='so', description='MEDIUM BLACK CIRCLE' },
	[0x26AC] = { unicodeslot=0x26AC, category='so', description='MEDIUM SMALL WHITE CIRCLE' },
	[0x26AD] = { unicodeslot=0x26AD, category='so', description='MARRIAGE SYMBOL' },
	[0x26AE] = { unicodeslot=0x26AE, category='so', description='DIVORCE SYMBOL' },
	[0x26AF] = { unicodeslot=0x26AF, category='so', description='UNMARRIED PARTNERSHIP SYMBOL' },
	[0x26B0] = { unicodeslot=0x26B0, category='so', description='COFFIN' },
	[0x26B1] = { unicodeslot=0x26B1, category='so', description='FUNERAL URN' },
	[0x26B2] = { unicodeslot=0x26B2, category='so', description='NEUTER' },
	[0x2701] = { unicodeslot=0x2701, category='so', description='UPPER BLADE SCISSORS' },
	[0x2702] = { unicodeslot=0x2702, category='so', description='BLACK SCISSORS' },
	[0x2703] = { unicodeslot=0x2703, category='so', description='LOWER BLADE SCISSORS' },
	[0x2704] = { unicodeslot=0x2704, category='so', description='WHITE SCISSORS' },
	[0x2706] = { unicodeslot=0x2706, category='so', description='TELEPHONE LOCATION SIGN' },
	[0x2707] = { unicodeslot=0x2707, category='so', description='TAPE DRIVE' },
	[0x2708] = { unicodeslot=0x2708, category='so', description='AIRPLANE' },
	[0x2709] = { unicodeslot=0x2709, category='so', description='ENVELOPE' },
	[0x270C] = { unicodeslot=0x270C, category='so', description='VICTORY HAND' },
	[0x270D] = { unicodeslot=0x270D, category='so', description='WRITING HAND' },
	[0x270E] = { unicodeslot=0x270E, category='so', description='LOWER RIGHT PENCIL' },
	[0x270F] = { unicodeslot=0x270F, category='so', description='PENCIL' },
	[0x2710] = { unicodeslot=0x2710, category='so', description='UPPER RIGHT PENCIL' },
	[0x2711] = { unicodeslot=0x2711, category='so', description='WHITE NIB' },
	[0x2712] = { unicodeslot=0x2712, category='so', description='BLACK NIB' },
	[0x2713] = { unicodeslot=0x2713, category='so', description='CHECK MARK' },
	[0x2714] = { unicodeslot=0x2714, category='so', description='HEAVY CHECK MARK' },
	[0x2715] = { unicodeslot=0x2715, category='so', description='MULTIPLICATION X' },
	[0x2716] = { unicodeslot=0x2716, category='so', description='HEAVY MULTIPLICATION X' },
	[0x2717] = { unicodeslot=0x2717, category='so', description='BALLOT X' },
	[0x2718] = { unicodeslot=0x2718, category='so', description='HEAVY BALLOT X' },
	[0x2719] = { unicodeslot=0x2719, category='so', description='OUTLINED GREEK CROSS' },
	[0x271A] = { unicodeslot=0x271A, category='so', description='HEAVY GREEK CROSS' },
	[0x271B] = { unicodeslot=0x271B, category='so', description='OPEN CENTRE CROSS' },
	[0x271C] = { unicodeslot=0x271C, category='so', description='HEAVY OPEN CENTRE CROSS' },
	[0x271D] = { unicodeslot=0x271D, category='so', description='LATIN CROSS' },
	[0x271E] = { unicodeslot=0x271E, category='so', description='SHADOWED WHITE LATIN CROSS' },
	[0x271F] = { unicodeslot=0x271F, category='so', description='OUTLINED LATIN CROSS' },
	[0x2720] = { unicodeslot=0x2720, category='so', description='MALTESE CROSS' },
	[0x2721] = { unicodeslot=0x2721, category='so', description='STAR OF DAVID' },
	[0x2722] = { unicodeslot=0x2722, category='so', description='FOUR TEARDROP-SPOKED ASTERISK' },
	[0x2723] = { unicodeslot=0x2723, category='so', description='FOUR BALLOON-SPOKED ASTERISK' },
	[0x2724] = { unicodeslot=0x2724, category='so', description='HEAVY FOUR BALLOON-SPOKED ASTERISK' },
	[0x2725] = { unicodeslot=0x2725, category='so', description='FOUR CLUB-SPOKED ASTERISK' },
	[0x2726] = { unicodeslot=0x2726, category='so', description='BLACK FOUR POINTED STAR' },
	[0x2727] = { unicodeslot=0x2727, category='so', description='WHITE FOUR POINTED STAR' },
	[0x2729] = { unicodeslot=0x2729, category='so', description='STRESS OUTLINED WHITE STAR' },
	[0x272A] = { unicodeslot=0x272A, category='so', description='CIRCLED WHITE STAR' },
	[0x272B] = { unicodeslot=0x272B, category='so', description='OPEN CENTRE BLACK STAR' },
	[0x272C] = { unicodeslot=0x272C, category='so', description='BLACK CENTRE WHITE STAR' },
	[0x272D] = { unicodeslot=0x272D, category='so', description='OUTLINED BLACK STAR' },
	[0x272E] = { unicodeslot=0x272E, category='so', description='HEAVY OUTLINED BLACK STAR' },
	[0x272F] = { unicodeslot=0x272F, category='so', description='PINWHEEL STAR' },
	[0x2730] = { unicodeslot=0x2730, category='so', description='SHADOWED WHITE STAR' },
	[0x2731] = { unicodeslot=0x2731, category='so', description='HEAVY ASTERISK' },
	[0x2732] = { unicodeslot=0x2732, category='so', description='OPEN CENTRE ASTERISK' },
	[0x2733] = { unicodeslot=0x2733, category='so', description='EIGHT SPOKED ASTERISK' },
	[0x2734] = { unicodeslot=0x2734, category='so', description='EIGHT POINTED BLACK STAR' },
	[0x2735] = { unicodeslot=0x2735, category='so', description='EIGHT POINTED PINWHEEL STAR' },
	[0x2736] = { unicodeslot=0x2736, category='so', description='SIX POINTED BLACK STAR' },
	[0x2737] = { unicodeslot=0x2737, category='so', description='EIGHT POINTED RECTILINEAR BLACK STAR' },
	[0x2738] = { unicodeslot=0x2738, category='so', description='HEAVY EIGHT POINTED RECTILINEAR BLACK STAR' },
	[0x2739] = { unicodeslot=0x2739, category='so', description='TWELVE POINTED BLACK STAR' },
	[0x273A] = { unicodeslot=0x273A, category='so', description='SIXTEEN POINTED ASTERISK' },
	[0x273B] = { unicodeslot=0x273B, category='so', description='TEARDROP-SPOKED ASTERISK' },
	[0x273C] = { unicodeslot=0x273C, category='so', description='OPEN CENTRE TEARDROP-SPOKED ASTERISK' },
	[0x273D] = { unicodeslot=0x273D, category='so', description='HEAVY TEARDROP-SPOKED ASTERISK' },
	[0x273E] = { unicodeslot=0x273E, category='so', description='SIX PETALLED BLACK AND WHITE FLORETTE' },
	[0x273F] = { unicodeslot=0x273F, category='so', description='BLACK FLORETTE' },
	[0x2740] = { unicodeslot=0x2740, category='so', description='WHITE FLORETTE' },
	[0x2741] = { unicodeslot=0x2741, category='so', description='EIGHT PETALLED OUTLINED BLACK FLORETTE' },
	[0x2742] = { unicodeslot=0x2742, category='so', description='CIRCLED OPEN CENTRE EIGHT POINTED STAR' },
	[0x2743] = { unicodeslot=0x2743, category='so', description='HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK' },
	[0x2744] = { unicodeslot=0x2744, category='so', description='SNOWFLAKE' },
	[0x2745] = { unicodeslot=0x2745, category='so', description='TIGHT TRIFOLIATE SNOWFLAKE' },
	[0x2746] = { unicodeslot=0x2746, category='so', description='HEAVY CHEVRON SNOWFLAKE' },
	[0x2747] = { unicodeslot=0x2747, category='so', description='SPARKLE' },
	[0x2748] = { unicodeslot=0x2748, category='so', description='HEAVY SPARKLE' },
	[0x2749] = { unicodeslot=0x2749, category='so', description='BALLOON-SPOKED ASTERISK' },
	[0x274A] = { unicodeslot=0x274A, category='so', description='EIGHT TEARDROP-SPOKED PROPELLER ASTERISK' },
	[0x274B] = { unicodeslot=0x274B, category='so', description='HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK' },
	[0x274D] = { unicodeslot=0x274D, category='so', description='SHADOWED WHITE CIRCLE' },
	[0x274F] = { unicodeslot=0x274F, category='so', description='LOWER RIGHT DROP-SHADOWED WHITE SQUARE' },
	[0x2750] = { unicodeslot=0x2750, category='so', description='UPPER RIGHT DROP-SHADOWED WHITE SQUARE' },
	[0x2751] = { unicodeslot=0x2751, category='so', description='LOWER RIGHT SHADOWED WHITE SQUARE' },
	[0x2752] = { unicodeslot=0x2752, category='so', description='UPPER RIGHT SHADOWED WHITE SQUARE' },
	[0x2756] = { unicodeslot=0x2756, category='so', description='BLACK DIAMOND MINUS WHITE X' },
	[0x2758] = { unicodeslot=0x2758, category='so', description='LIGHT VERTICAL BAR' },
	[0x2759] = { unicodeslot=0x2759, category='so', description='MEDIUM VERTICAL BAR' },
	[0x275A] = { unicodeslot=0x275A, category='so', description='HEAVY VERTICAL BAR' },
	[0x275B] = { unicodeslot=0x275B, category='so', description='HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT' },
	[0x275C] = { unicodeslot=0x275C, category='so', description='HEAVY SINGLE COMMA QUOTATION MARK ORNAMENT' },
	[0x275D] = { unicodeslot=0x275D, category='so', description='HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT' },
	[0x275E] = { unicodeslot=0x275E, category='so', description='HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT' },
	[0x2761] = { unicodeslot=0x2761, category='so', description='CURVED STEM PARAGRAPH SIGN ORNAMENT' },
	[0x2762] = { unicodeslot=0x2762, category='so', description='HEAVY EXCLAMATION MARK ORNAMENT' },
	[0x2763] = { unicodeslot=0x2763, category='so', description='HEAVY HEART EXCLAMATION MARK ORNAMENT' },
	[0x2764] = { unicodeslot=0x2764, category='so', description='HEAVY BLACK HEART' },
	[0x2765] = { unicodeslot=0x2765, category='so', description='ROTATED HEAVY BLACK HEART BULLET' },
	[0x2766] = { unicodeslot=0x2766, category='so', description='FLORAL HEART' },
	[0x2767] = { unicodeslot=0x2767, category='so', description='ROTATED FLORAL HEART BULLET' },
	[0x2768] = { unicodeslot=0x2768, category='ps', description='MEDIUM LEFT PARENTHESIS ORNAMENT' },
	[0x2769] = { unicodeslot=0x2769, category='pe', description='MEDIUM RIGHT PARENTHESIS ORNAMENT' },
	[0x276A] = { unicodeslot=0x276A, category='ps', description='MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT' },
	[0x276B] = { unicodeslot=0x276B, category='pe', description='MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT' },
	[0x276C] = { unicodeslot=0x276C, category='ps', description='MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT' },
	[0x276D] = { unicodeslot=0x276D, category='pe', description='MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT' },
	[0x276E] = { unicodeslot=0x276E, category='ps', description='HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT' },
	[0x276F] = { unicodeslot=0x276F, category='pe', description='HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT' },
	[0x2770] = { unicodeslot=0x2770, category='ps', description='HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT' },
	[0x2771] = { unicodeslot=0x2771, category='pe', description='HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT' },
	[0x2772] = { unicodeslot=0x2772, category='ps', description='LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT' },
	[0x2773] = { unicodeslot=0x2773, category='pe', description='LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT' },
	[0x2774] = { unicodeslot=0x2774, category='ps', description='MEDIUM LEFT CURLY BRACKET ORNAMENT' },
	[0x2775] = { unicodeslot=0x2775, category='pe', description='MEDIUM RIGHT CURLY BRACKET ORNAMENT' },
	[0x2776] = { unicodeslot=0x2776, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT ONE' },
	[0x2777] = { unicodeslot=0x2777, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT TWO' },
	[0x2778] = { unicodeslot=0x2778, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT THREE' },
	[0x2779] = { unicodeslot=0x2779, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT FOUR' },
	[0x277A] = { unicodeslot=0x277A, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT FIVE' },
	[0x277B] = { unicodeslot=0x277B, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT SIX' },
	[0x277C] = { unicodeslot=0x277C, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT SEVEN' },
	[0x277D] = { unicodeslot=0x277D, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT EIGHT' },
	[0x277E] = { unicodeslot=0x277E, category='no', description='DINGBAT NEGATIVE CIRCLED DIGIT NINE' },
	[0x277F] = { unicodeslot=0x277F, category='no', description='DINGBAT NEGATIVE CIRCLED NUMBER TEN' },
	[0x2780] = { unicodeslot=0x2780, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT ONE' },
	[0x2781] = { unicodeslot=0x2781, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT TWO' },
	[0x2782] = { unicodeslot=0x2782, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT THREE' },
	[0x2783] = { unicodeslot=0x2783, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT FOUR' },
	[0x2784] = { unicodeslot=0x2784, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT FIVE' },
	[0x2785] = { unicodeslot=0x2785, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT SIX' },
	[0x2786] = { unicodeslot=0x2786, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT SEVEN' },
	[0x2787] = { unicodeslot=0x2787, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT EIGHT' },
	[0x2788] = { unicodeslot=0x2788, category='no', description='DINGBAT CIRCLED SANS-SERIF DIGIT NINE' },
	[0x2789] = { unicodeslot=0x2789, category='no', description='DINGBAT CIRCLED SANS-SERIF NUMBER TEN' },
	[0x278A] = { unicodeslot=0x278A, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ONE' },
	[0x278B] = { unicodeslot=0x278B, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT TWO' },
	[0x278C] = { unicodeslot=0x278C, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT THREE' },
	[0x278D] = { unicodeslot=0x278D, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FOUR' },
	[0x278E] = { unicodeslot=0x278E, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE' },
	[0x278F] = { unicodeslot=0x278F, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SIX' },
	[0x2790] = { unicodeslot=0x2790, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SEVEN' },
	[0x2791] = { unicodeslot=0x2791, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT EIGHT' },
	[0x2792] = { unicodeslot=0x2792, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT NINE' },
	[0x2793] = { unicodeslot=0x2793, category='no', description='DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN' },
	[0x2794] = { unicodeslot=0x2794, category='so', description='HEAVY WIDE-HEADED RIGHTWARDS ARROW' },
	[0x2798] = { unicodeslot=0x2798, category='so', description='HEAVY SOUTH EAST ARROW' },
	[0x2799] = { unicodeslot=0x2799, category='so', description='HEAVY RIGHTWARDS ARROW' },
	[0x279A] = { unicodeslot=0x279A, category='so', description='HEAVY NORTH EAST ARROW' },
	[0x279B] = { unicodeslot=0x279B, category='so', description='DRAFTING POINT RIGHTWARDS ARROW' },
	[0x279C] = { unicodeslot=0x279C, category='so', description='HEAVY ROUND-TIPPED RIGHTWARDS ARROW' },
	[0x279D] = { unicodeslot=0x279D, category='so', description='TRIANGLE-HEADED RIGHTWARDS ARROW' },
	[0x279E] = { unicodeslot=0x279E, category='so', description='HEAVY TRIANGLE-HEADED RIGHTWARDS ARROW' },
	[0x279F] = { unicodeslot=0x279F, category='so', description='DASHED TRIANGLE-HEADED RIGHTWARDS ARROW' },
	[0x27A0] = { unicodeslot=0x27A0, category='so', description='HEAVY DASHED TRIANGLE-HEADED RIGHTWARDS ARROW' },
	[0x27A1] = { unicodeslot=0x27A1, category='so', description='BLACK RIGHTWARDS ARROW' },
	[0x27A2] = { unicodeslot=0x27A2, category='so', description='THREE-D TOP-LIGHTED RIGHTWARDS ARROWHEAD' },
	[0x27A3] = { unicodeslot=0x27A3, category='so', description='THREE-D BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD' },
	[0x27A4] = { unicodeslot=0x27A4, category='so', description='BLACK RIGHTWARDS ARROWHEAD' },
	[0x27A5] = { unicodeslot=0x27A5, category='so', description='HEAVY BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW' },
	[0x27A6] = { unicodeslot=0x27A6, category='so', description='HEAVY BLACK CURVED UPWARDS AND RIGHTWARDS ARROW' },
	[0x27A7] = { unicodeslot=0x27A7, category='so', description='SQUAT BLACK RIGHTWARDS ARROW' },
	[0x27A8] = { unicodeslot=0x27A8, category='so', description='HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW' },
	[0x27A9] = { unicodeslot=0x27A9, category='so', description='RIGHT-SHADED WHITE RIGHTWARDS ARROW' },
	[0x27AA] = { unicodeslot=0x27AA, category='so', description='LEFT-SHADED WHITE RIGHTWARDS ARROW' },
	[0x27AB] = { unicodeslot=0x27AB, category='so', description='BACK-TILTED SHADOWED WHITE RIGHTWARDS ARROW' },
	[0x27AC] = { unicodeslot=0x27AC, category='so', description='FRONT-TILTED SHADOWED WHITE RIGHTWARDS ARROW' },
	[0x27AD] = { unicodeslot=0x27AD, category='so', description='HEAVY LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW' },
	[0x27AE] = { unicodeslot=0x27AE, category='so', description='HEAVY UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW' },
	[0x27AF] = { unicodeslot=0x27AF, category='so', description='NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW' },
	[0x27B1] = { unicodeslot=0x27B1, category='so', description='NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW' },
	[0x27B2] = { unicodeslot=0x27B2, category='so', description='CIRCLED HEAVY WHITE RIGHTWARDS ARROW' },
	[0x27B3] = { unicodeslot=0x27B3, category='so', description='WHITE-FEATHERED RIGHTWARDS ARROW' },
	[0x27B4] = { unicodeslot=0x27B4, category='so', description='BLACK-FEATHERED SOUTH EAST ARROW' },
	[0x27B5] = { unicodeslot=0x27B5, category='so', description='BLACK-FEATHERED RIGHTWARDS ARROW' },
	[0x27B6] = { unicodeslot=0x27B6, category='so', description='BLACK-FEATHERED NORTH EAST ARROW' },
	[0x27B7] = { unicodeslot=0x27B7, category='so', description='HEAVY BLACK-FEATHERED SOUTH EAST ARROW' },
	[0x27B8] = { unicodeslot=0x27B8, category='so', description='HEAVY BLACK-FEATHERED RIGHTWARDS ARROW' },
	[0x27B9] = { unicodeslot=0x27B9, category='so', description='HEAVY BLACK-FEATHERED NORTH EAST ARROW' },
	[0x27BA] = { unicodeslot=0x27BA, category='so', description='TEARDROP-BARBED RIGHTWARDS ARROW' },
	[0x27BB] = { unicodeslot=0x27BB, category='so', description='HEAVY TEARDROP-SHANKED RIGHTWARDS ARROW' },
	[0x27BC] = { unicodeslot=0x27BC, category='so', description='WEDGE-TAILED RIGHTWARDS ARROW' },
	[0x27BD] = { unicodeslot=0x27BD, category='so', description='HEAVY WEDGE-TAILED RIGHTWARDS ARROW' },
	[0x27BE] = { unicodeslot=0x27BE, category='so', description='OPEN-OUTLINED RIGHTWARDS ARROW' },
	[0x27C0] = { unicodeslot=0x27C0, category='sm', description='THREE DIMENSIONAL ANGLE' },
	[0x27C1] = { unicodeslot=0x27C1, category='sm', description='WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE' },
	[0x27C2] = { unicodeslot=0x27C2, category='sm', description='PERPENDICULAR' },
	[0x27C3] = { unicodeslot=0x27C3, category='sm', description='OPEN SUBSET' },
	[0x27C4] = { unicodeslot=0x27C4, category='sm', description='OPEN SUPERSET' },
	[0x27C5] = { unicodeslot=0x27C5, category='ps', description='LEFT S-SHAPED BAG DELIMITER' },
	[0x27C6] = { unicodeslot=0x27C6, category='pe', description='RIGHT S-SHAPED BAG DELIMITER' },
	[0x27C7] = { unicodeslot=0x27C7, category='sm', description='OR WITH DOT INSIDE' },
	[0x27C8] = { unicodeslot=0x27C8, category='sm', description='REVERSE SOLIDUS PRECEDING SUBSET' },
	[0x27C9] = { unicodeslot=0x27C9, category='sm', description='SUPERSET PRECEDING SOLIDUS' },
	[0x27CA] = { unicodeslot=0x27CA, category='sm', description='VERTICAL BAR WITH HORIZONTAL STROKE' },
	[0x27D0] = { unicodeslot=0x27D0, category='sm', description='WHITE DIAMOND WITH CENTRED DOT' },
	[0x27D1] = { unicodeslot=0x27D1, category='sm', description='AND WITH DOT' },
	[0x27D2] = { unicodeslot=0x27D2, category='sm', description='ELEMENT OF OPENING UPWARDS' },
	[0x27D3] = { unicodeslot=0x27D3, category='sm', description='LOWER RIGHT CORNER WITH DOT' },
	[0x27D4] = { unicodeslot=0x27D4, category='sm', description='UPPER LEFT CORNER WITH DOT' },
	[0x27D5] = { unicodeslot=0x27D5, category='sm', description='LEFT OUTER JOIN' },
	[0x27D6] = { unicodeslot=0x27D6, category='sm', description='RIGHT OUTER JOIN' },
	[0x27D7] = { unicodeslot=0x27D7, category='sm', description='FULL OUTER JOIN' },
	[0x27D8] = { unicodeslot=0x27D8, category='sm', description='LARGE UP TACK' },
	[0x27D9] = { unicodeslot=0x27D9, category='sm', description='LARGE DOWN TACK' },
	[0x27DA] = { unicodeslot=0x27DA, category='sm', description='LEFT AND RIGHT DOUBLE TURNSTILE' },
	[0x27DB] = { unicodeslot=0x27DB, category='sm', description='LEFT AND RIGHT TACK' },
	[0x27DC] = { unicodeslot=0x27DC, category='sm', description='LEFT MULTIMAP' },
	[0x27DD] = { unicodeslot=0x27DD, category='sm', description='LONG RIGHT TACK' },
	[0x27DE] = { unicodeslot=0x27DE, category='sm', description='LONG LEFT TACK' },
	[0x27DF] = { unicodeslot=0x27DF, category='sm', description='UP TACK WITH CIRCLE ABOVE' },
	[0x27E0] = { unicodeslot=0x27E0, category='sm', description='LOZENGE DIVIDED BY HORIZONTAL RULE' },
	[0x27E1] = { unicodeslot=0x27E1, category='sm', description='WHITE CONCAVE-SIDED DIAMOND' },
	[0x27E2] = { unicodeslot=0x27E2, category='sm', description='WHITE CONCAVE-SIDED DIAMOND WITH LEFTWARDS TICK' },
	[0x27E3] = { unicodeslot=0x27E3, category='sm', description='WHITE CONCAVE-SIDED DIAMOND WITH RIGHTWARDS TICK' },
	[0x27E4] = { unicodeslot=0x27E4, category='sm', description='WHITE SQUARE WITH LEFTWARDS TICK' },
	[0x27E5] = { unicodeslot=0x27E5, category='sm', description='WHITE SQUARE WITH RIGHTWARDS TICK' },
	[0x27E6] = { unicodeslot=0x27E6, category='ps', description='MATHEMATICAL LEFT WHITE SQUARE BRACKET' },
	[0x27E7] = { unicodeslot=0x27E7, category='pe', description='MATHEMATICAL RIGHT WHITE SQUARE BRACKET' },
	[0x27E8] = { unicodeslot=0x27E8, category='ps', description='MATHEMATICAL LEFT ANGLE BRACKET' },
	[0x27E9] = { unicodeslot=0x27E9, category='pe', description='MATHEMATICAL RIGHT ANGLE BRACKET' },
	[0x27EA] = { unicodeslot=0x27EA, category='ps', description='MATHEMATICAL LEFT DOUBLE ANGLE BRACKET' },
	[0x27EB] = { unicodeslot=0x27EB, category='pe', description='MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET' },
	[0x27F0] = { unicodeslot=0x27F0, category='sm', description='UPWARDS QUADRUPLE ARROW' },
	[0x27F1] = { unicodeslot=0x27F1, category='sm', description='DOWNWARDS QUADRUPLE ARROW' },
	[0x27F2] = { unicodeslot=0x27F2, category='sm', description='ANTICLOCKWISE GAPPED CIRCLE ARROW' },
	[0x27F3] = { unicodeslot=0x27F3, category='sm', description='CLOCKWISE GAPPED CIRCLE ARROW' },
	[0x27F4] = { unicodeslot=0x27F4, category='sm', description='RIGHT ARROW WITH CIRCLED PLUS' },
	[0x27F5] = { unicodeslot=0x27F5, category='sm', description='LONG LEFTWARDS ARROW' },
	[0x27F6] = { unicodeslot=0x27F6, category='sm', description='LONG RIGHTWARDS ARROW' },
	[0x27F7] = { unicodeslot=0x27F7, category='sm', description='LONG LEFT RIGHT ARROW' },
	[0x27F8] = { unicodeslot=0x27F8, category='sm', description='LONG LEFTWARDS DOUBLE ARROW' },
	[0x27F9] = { unicodeslot=0x27F9, category='sm', description='LONG RIGHTWARDS DOUBLE ARROW' },
	[0x27FA] = { unicodeslot=0x27FA, category='sm', description='LONG LEFT RIGHT DOUBLE ARROW' },
	[0x27FB] = { unicodeslot=0x27FB, category='sm', description='LONG LEFTWARDS ARROW FROM BAR' },
	[0x27FC] = { unicodeslot=0x27FC, category='sm', description='LONG RIGHTWARDS ARROW FROM BAR' },
	[0x27FD] = { unicodeslot=0x27FD, category='sm', description='LONG LEFTWARDS DOUBLE ARROW FROM BAR' },
	[0x27FE] = { unicodeslot=0x27FE, category='sm', description='LONG RIGHTWARDS DOUBLE ARROW FROM BAR' },
	[0x27FF] = { unicodeslot=0x27FF, category='sm', description='LONG RIGHTWARDS SQUIGGLE ARROW' },
	[0x2800] = { unicodeslot=0x2800, category='so', description='BRAILLE PATTERN BLANK' },
	[0x2801] = { unicodeslot=0x2801, category='so', description='BRAILLE PATTERN DOTS-1' },
	[0x2802] = { unicodeslot=0x2802, category='so', description='BRAILLE PATTERN DOTS-2' },
	[0x2803] = { unicodeslot=0x2803, category='so', description='BRAILLE PATTERN DOTS-12' },
	[0x2804] = { unicodeslot=0x2804, category='so', description='BRAILLE PATTERN DOTS-3' },
	[0x2805] = { unicodeslot=0x2805, category='so', description='BRAILLE PATTERN DOTS-13' },
	[0x2806] = { unicodeslot=0x2806, category='so', description='BRAILLE PATTERN DOTS-23' },
	[0x2807] = { unicodeslot=0x2807, category='so', description='BRAILLE PATTERN DOTS-123' },
	[0x2808] = { unicodeslot=0x2808, category='so', description='BRAILLE PATTERN DOTS-4' },
	[0x2809] = { unicodeslot=0x2809, category='so', description='BRAILLE PATTERN DOTS-14' },
	[0x280A] = { unicodeslot=0x280A, category='so', description='BRAILLE PATTERN DOTS-24' },
	[0x280B] = { unicodeslot=0x280B, category='so', description='BRAILLE PATTERN DOTS-124' },
	[0x280C] = { unicodeslot=0x280C, category='so', description='BRAILLE PATTERN DOTS-34' },
	[0x280D] = { unicodeslot=0x280D, category='so', description='BRAILLE PATTERN DOTS-134' },
	[0x280E] = { unicodeslot=0x280E, category='so', description='BRAILLE PATTERN DOTS-234' },
	[0x280F] = { unicodeslot=0x280F, category='so', description='BRAILLE PATTERN DOTS-1234' },
	[0x2810] = { unicodeslot=0x2810, category='so', description='BRAILLE PATTERN DOTS-5' },
	[0x2811] = { unicodeslot=0x2811, category='so', description='BRAILLE PATTERN DOTS-15' },
	[0x2812] = { unicodeslot=0x2812, category='so', description='BRAILLE PATTERN DOTS-25' },
	[0x2813] = { unicodeslot=0x2813, category='so', description='BRAILLE PATTERN DOTS-125' },
	[0x2814] = { unicodeslot=0x2814, category='so', description='BRAILLE PATTERN DOTS-35' },
	[0x2815] = { unicodeslot=0x2815, category='so', description='BRAILLE PATTERN DOTS-135' },
	[0x2816] = { unicodeslot=0x2816, category='so', description='BRAILLE PATTERN DOTS-235' },
	[0x2817] = { unicodeslot=0x2817, category='so', description='BRAILLE PATTERN DOTS-1235' },
	[0x2818] = { unicodeslot=0x2818, category='so', description='BRAILLE PATTERN DOTS-45' },
	[0x2819] = { unicodeslot=0x2819, category='so', description='BRAILLE PATTERN DOTS-145' },
	[0x281A] = { unicodeslot=0x281A, category='so', description='BRAILLE PATTERN DOTS-245' },
	[0x281B] = { unicodeslot=0x281B, category='so', description='BRAILLE PATTERN DOTS-1245' },
	[0x281C] = { unicodeslot=0x281C, category='so', description='BRAILLE PATTERN DOTS-345' },
	[0x281D] = { unicodeslot=0x281D, category='so', description='BRAILLE PATTERN DOTS-1345' },
	[0x281E] = { unicodeslot=0x281E, category='so', description='BRAILLE PATTERN DOTS-2345' },
	[0x281F] = { unicodeslot=0x281F, category='so', description='BRAILLE PATTERN DOTS-12345' },
	[0x2820] = { unicodeslot=0x2820, category='so', description='BRAILLE PATTERN DOTS-6' },
	[0x2821] = { unicodeslot=0x2821, category='so', description='BRAILLE PATTERN DOTS-16' },
	[0x2822] = { unicodeslot=0x2822, category='so', description='BRAILLE PATTERN DOTS-26' },
	[0x2823] = { unicodeslot=0x2823, category='so', description='BRAILLE PATTERN DOTS-126' },
	[0x2824] = { unicodeslot=0x2824, category='so', description='BRAILLE PATTERN DOTS-36' },
	[0x2825] = { unicodeslot=0x2825, category='so', description='BRAILLE PATTERN DOTS-136' },
	[0x2826] = { unicodeslot=0x2826, category='so', description='BRAILLE PATTERN DOTS-236' },
	[0x2827] = { unicodeslot=0x2827, category='so', description='BRAILLE PATTERN DOTS-1236' },
	[0x2828] = { unicodeslot=0x2828, category='so', description='BRAILLE PATTERN DOTS-46' },
	[0x2829] = { unicodeslot=0x2829, category='so', description='BRAILLE PATTERN DOTS-146' },
	[0x282A] = { unicodeslot=0x282A, category='so', description='BRAILLE PATTERN DOTS-246' },
	[0x282B] = { unicodeslot=0x282B, category='so', description='BRAILLE PATTERN DOTS-1246' },
	[0x282C] = { unicodeslot=0x282C, category='so', description='BRAILLE PATTERN DOTS-346' },
	[0x282D] = { unicodeslot=0x282D, category='so', description='BRAILLE PATTERN DOTS-1346' },
	[0x282E] = { unicodeslot=0x282E, category='so', description='BRAILLE PATTERN DOTS-2346' },
	[0x282F] = { unicodeslot=0x282F, category='so', description='BRAILLE PATTERN DOTS-12346' },
	[0x2830] = { unicodeslot=0x2830, category='so', description='BRAILLE PATTERN DOTS-56' },
	[0x2831] = { unicodeslot=0x2831, category='so', description='BRAILLE PATTERN DOTS-156' },
	[0x2832] = { unicodeslot=0x2832, category='so', description='BRAILLE PATTERN DOTS-256' },
	[0x2833] = { unicodeslot=0x2833, category='so', description='BRAILLE PATTERN DOTS-1256' },
	[0x2834] = { unicodeslot=0x2834, category='so', description='BRAILLE PATTERN DOTS-356' },
	[0x2835] = { unicodeslot=0x2835, category='so', description='BRAILLE PATTERN DOTS-1356' },
	[0x2836] = { unicodeslot=0x2836, category='so', description='BRAILLE PATTERN DOTS-2356' },
	[0x2837] = { unicodeslot=0x2837, category='so', description='BRAILLE PATTERN DOTS-12356' },
	[0x2838] = { unicodeslot=0x2838, category='so', description='BRAILLE PATTERN DOTS-456' },
	[0x2839] = { unicodeslot=0x2839, category='so', description='BRAILLE PATTERN DOTS-1456' },
	[0x283A] = { unicodeslot=0x283A, category='so', description='BRAILLE PATTERN DOTS-2456' },
	[0x283B] = { unicodeslot=0x283B, category='so', description='BRAILLE PATTERN DOTS-12456' },
	[0x283C] = { unicodeslot=0x283C, category='so', description='BRAILLE PATTERN DOTS-3456' },
	[0x283D] = { unicodeslot=0x283D, category='so', description='BRAILLE PATTERN DOTS-13456' },
	[0x283E] = { unicodeslot=0x283E, category='so', description='BRAILLE PATTERN DOTS-23456' },
	[0x283F] = { unicodeslot=0x283F, category='so', description='BRAILLE PATTERN DOTS-123456' },
	[0x2840] = { unicodeslot=0x2840, category='so', description='BRAILLE PATTERN DOTS-7' },
	[0x2841] = { unicodeslot=0x2841, category='so', description='BRAILLE PATTERN DOTS-17' },
	[0x2842] = { unicodeslot=0x2842, category='so', description='BRAILLE PATTERN DOTS-27' },
	[0x2843] = { unicodeslot=0x2843, category='so', description='BRAILLE PATTERN DOTS-127' },
	[0x2844] = { unicodeslot=0x2844, category='so', description='BRAILLE PATTERN DOTS-37' },
	[0x2845] = { unicodeslot=0x2845, category='so', description='BRAILLE PATTERN DOTS-137' },
	[0x2846] = { unicodeslot=0x2846, category='so', description='BRAILLE PATTERN DOTS-237' },
	[0x2847] = { unicodeslot=0x2847, category='so', description='BRAILLE PATTERN DOTS-1237' },
	[0x2848] = { unicodeslot=0x2848, category='so', description='BRAILLE PATTERN DOTS-47' },
	[0x2849] = { unicodeslot=0x2849, category='so', description='BRAILLE PATTERN DOTS-147' },
	[0x284A] = { unicodeslot=0x284A, category='so', description='BRAILLE PATTERN DOTS-247' },
	[0x284B] = { unicodeslot=0x284B, category='so', description='BRAILLE PATTERN DOTS-1247' },
	[0x284C] = { unicodeslot=0x284C, category='so', description='BRAILLE PATTERN DOTS-347' },
	[0x284D] = { unicodeslot=0x284D, category='so', description='BRAILLE PATTERN DOTS-1347' },
	[0x284E] = { unicodeslot=0x284E, category='so', description='BRAILLE PATTERN DOTS-2347' },
	[0x284F] = { unicodeslot=0x284F, category='so', description='BRAILLE PATTERN DOTS-12347' },
	[0x2850] = { unicodeslot=0x2850, category='so', description='BRAILLE PATTERN DOTS-57' },
	[0x2851] = { unicodeslot=0x2851, category='so', description='BRAILLE PATTERN DOTS-157' },
	[0x2852] = { unicodeslot=0x2852, category='so', description='BRAILLE PATTERN DOTS-257' },
	[0x2853] = { unicodeslot=0x2853, category='so', description='BRAILLE PATTERN DOTS-1257' },
	[0x2854] = { unicodeslot=0x2854, category='so', description='BRAILLE PATTERN DOTS-357' },
	[0x2855] = { unicodeslot=0x2855, category='so', description='BRAILLE PATTERN DOTS-1357' },
	[0x2856] = { unicodeslot=0x2856, category='so', description='BRAILLE PATTERN DOTS-2357' },
	[0x2857] = { unicodeslot=0x2857, category='so', description='BRAILLE PATTERN DOTS-12357' },
	[0x2858] = { unicodeslot=0x2858, category='so', description='BRAILLE PATTERN DOTS-457' },
	[0x2859] = { unicodeslot=0x2859, category='so', description='BRAILLE PATTERN DOTS-1457' },
	[0x285A] = { unicodeslot=0x285A, category='so', description='BRAILLE PATTERN DOTS-2457' },
	[0x285B] = { unicodeslot=0x285B, category='so', description='BRAILLE PATTERN DOTS-12457' },
	[0x285C] = { unicodeslot=0x285C, category='so', description='BRAILLE PATTERN DOTS-3457' },
	[0x285D] = { unicodeslot=0x285D, category='so', description='BRAILLE PATTERN DOTS-13457' },
	[0x285E] = { unicodeslot=0x285E, category='so', description='BRAILLE PATTERN DOTS-23457' },
	[0x285F] = { unicodeslot=0x285F, category='so', description='BRAILLE PATTERN DOTS-123457' },
	[0x2860] = { unicodeslot=0x2860, category='so', description='BRAILLE PATTERN DOTS-67' },
	[0x2861] = { unicodeslot=0x2861, category='so', description='BRAILLE PATTERN DOTS-167' },
	[0x2862] = { unicodeslot=0x2862, category='so', description='BRAILLE PATTERN DOTS-267' },
	[0x2863] = { unicodeslot=0x2863, category='so', description='BRAILLE PATTERN DOTS-1267' },
	[0x2864] = { unicodeslot=0x2864, category='so', description='BRAILLE PATTERN DOTS-367' },
	[0x2865] = { unicodeslot=0x2865, category='so', description='BRAILLE PATTERN DOTS-1367' },
	[0x2866] = { unicodeslot=0x2866, category='so', description='BRAILLE PATTERN DOTS-2367' },
	[0x2867] = { unicodeslot=0x2867, category='so', description='BRAILLE PATTERN DOTS-12367' },
	[0x2868] = { unicodeslot=0x2868, category='so', description='BRAILLE PATTERN DOTS-467' },
	[0x2869] = { unicodeslot=0x2869, category='so', description='BRAILLE PATTERN DOTS-1467' },
	[0x286A] = { unicodeslot=0x286A, category='so', description='BRAILLE PATTERN DOTS-2467' },
	[0x286B] = { unicodeslot=0x286B, category='so', description='BRAILLE PATTERN DOTS-12467' },
	[0x286C] = { unicodeslot=0x286C, category='so', description='BRAILLE PATTERN DOTS-3467' },
	[0x286D] = { unicodeslot=0x286D, category='so', description='BRAILLE PATTERN DOTS-13467' },
	[0x286E] = { unicodeslot=0x286E, category='so', description='BRAILLE PATTERN DOTS-23467' },
	[0x286F] = { unicodeslot=0x286F, category='so', description='BRAILLE PATTERN DOTS-123467' },
	[0x2870] = { unicodeslot=0x2870, category='so', description='BRAILLE PATTERN DOTS-567' },
	[0x2871] = { unicodeslot=0x2871, category='so', description='BRAILLE PATTERN DOTS-1567' },
	[0x2872] = { unicodeslot=0x2872, category='so', description='BRAILLE PATTERN DOTS-2567' },
	[0x2873] = { unicodeslot=0x2873, category='so', description='BRAILLE PATTERN DOTS-12567' },
	[0x2874] = { unicodeslot=0x2874, category='so', description='BRAILLE PATTERN DOTS-3567' },
	[0x2875] = { unicodeslot=0x2875, category='so', description='BRAILLE PATTERN DOTS-13567' },
	[0x2876] = { unicodeslot=0x2876, category='so', description='BRAILLE PATTERN DOTS-23567' },
	[0x2877] = { unicodeslot=0x2877, category='so', description='BRAILLE PATTERN DOTS-123567' },
	[0x2878] = { unicodeslot=0x2878, category='so', description='BRAILLE PATTERN DOTS-4567' },
	[0x2879] = { unicodeslot=0x2879, category='so', description='BRAILLE PATTERN DOTS-14567' },
	[0x287A] = { unicodeslot=0x287A, category='so', description='BRAILLE PATTERN DOTS-24567' },
	[0x287B] = { unicodeslot=0x287B, category='so', description='BRAILLE PATTERN DOTS-124567' },
	[0x287C] = { unicodeslot=0x287C, category='so', description='BRAILLE PATTERN DOTS-34567' },
	[0x287D] = { unicodeslot=0x287D, category='so', description='BRAILLE PATTERN DOTS-134567' },
	[0x287E] = { unicodeslot=0x287E, category='so', description='BRAILLE PATTERN DOTS-234567' },
	[0x287F] = { unicodeslot=0x287F, category='so', description='BRAILLE PATTERN DOTS-1234567' },
	[0x2880] = { unicodeslot=0x2880, category='so', description='BRAILLE PATTERN DOTS-8' },
	[0x2881] = { unicodeslot=0x2881, category='so', description='BRAILLE PATTERN DOTS-18' },
	[0x2882] = { unicodeslot=0x2882, category='so', description='BRAILLE PATTERN DOTS-28' },
	[0x2883] = { unicodeslot=0x2883, category='so', description='BRAILLE PATTERN DOTS-128' },
	[0x2884] = { unicodeslot=0x2884, category='so', description='BRAILLE PATTERN DOTS-38' },
	[0x2885] = { unicodeslot=0x2885, category='so', description='BRAILLE PATTERN DOTS-138' },
	[0x2886] = { unicodeslot=0x2886, category='so', description='BRAILLE PATTERN DOTS-238' },
	[0x2887] = { unicodeslot=0x2887, category='so', description='BRAILLE PATTERN DOTS-1238' },
	[0x2888] = { unicodeslot=0x2888, category='so', description='BRAILLE PATTERN DOTS-48' },
	[0x2889] = { unicodeslot=0x2889, category='so', description='BRAILLE PATTERN DOTS-148' },
	[0x288A] = { unicodeslot=0x288A, category='so', description='BRAILLE PATTERN DOTS-248' },
	[0x288B] = { unicodeslot=0x288B, category='so', description='BRAILLE PATTERN DOTS-1248' },
	[0x288C] = { unicodeslot=0x288C, category='so', description='BRAILLE PATTERN DOTS-348' },
	[0x288D] = { unicodeslot=0x288D, category='so', description='BRAILLE PATTERN DOTS-1348' },
	[0x288E] = { unicodeslot=0x288E, category='so', description='BRAILLE PATTERN DOTS-2348' },
	[0x288F] = { unicodeslot=0x288F, category='so', description='BRAILLE PATTERN DOTS-12348' },
	[0x2890] = { unicodeslot=0x2890, category='so', description='BRAILLE PATTERN DOTS-58' },
	[0x2891] = { unicodeslot=0x2891, category='so', description='BRAILLE PATTERN DOTS-158' },
	[0x2892] = { unicodeslot=0x2892, category='so', description='BRAILLE PATTERN DOTS-258' },
	[0x2893] = { unicodeslot=0x2893, category='so', description='BRAILLE PATTERN DOTS-1258' },
	[0x2894] = { unicodeslot=0x2894, category='so', description='BRAILLE PATTERN DOTS-358' },
	[0x2895] = { unicodeslot=0x2895, category='so', description='BRAILLE PATTERN DOTS-1358' },
	[0x2896] = { unicodeslot=0x2896, category='so', description='BRAILLE PATTERN DOTS-2358' },
	[0x2897] = { unicodeslot=0x2897, category='so', description='BRAILLE PATTERN DOTS-12358' },
	[0x2898] = { unicodeslot=0x2898, category='so', description='BRAILLE PATTERN DOTS-458' },
	[0x2899] = { unicodeslot=0x2899, category='so', description='BRAILLE PATTERN DOTS-1458' },
	[0x289A] = { unicodeslot=0x289A, category='so', description='BRAILLE PATTERN DOTS-2458' },
	[0x289B] = { unicodeslot=0x289B, category='so', description='BRAILLE PATTERN DOTS-12458' },
	[0x289C] = { unicodeslot=0x289C, category='so', description='BRAILLE PATTERN DOTS-3458' },
	[0x289D] = { unicodeslot=0x289D, category='so', description='BRAILLE PATTERN DOTS-13458' },
	[0x289E] = { unicodeslot=0x289E, category='so', description='BRAILLE PATTERN DOTS-23458' },
	[0x289F] = { unicodeslot=0x289F, category='so', description='BRAILLE PATTERN DOTS-123458' },
	[0x28A0] = { unicodeslot=0x28A0, category='so', description='BRAILLE PATTERN DOTS-68' },
	[0x28A1] = { unicodeslot=0x28A1, category='so', description='BRAILLE PATTERN DOTS-168' },
	[0x28A2] = { unicodeslot=0x28A2, category='so', description='BRAILLE PATTERN DOTS-268' },
	[0x28A3] = { unicodeslot=0x28A3, category='so', description='BRAILLE PATTERN DOTS-1268' },
	[0x28A4] = { unicodeslot=0x28A4, category='so', description='BRAILLE PATTERN DOTS-368' },
	[0x28A5] = { unicodeslot=0x28A5, category='so', description='BRAILLE PATTERN DOTS-1368' },
	[0x28A6] = { unicodeslot=0x28A6, category='so', description='BRAILLE PATTERN DOTS-2368' },
	[0x28A7] = { unicodeslot=0x28A7, category='so', description='BRAILLE PATTERN DOTS-12368' },
	[0x28A8] = { unicodeslot=0x28A8, category='so', description='BRAILLE PATTERN DOTS-468' },
	[0x28A9] = { unicodeslot=0x28A9, category='so', description='BRAILLE PATTERN DOTS-1468' },
	[0x28AA] = { unicodeslot=0x28AA, category='so', description='BRAILLE PATTERN DOTS-2468' },
	[0x28AB] = { unicodeslot=0x28AB, category='so', description='BRAILLE PATTERN DOTS-12468' },
	[0x28AC] = { unicodeslot=0x28AC, category='so', description='BRAILLE PATTERN DOTS-3468' },
	[0x28AD] = { unicodeslot=0x28AD, category='so', description='BRAILLE PATTERN DOTS-13468' },
	[0x28AE] = { unicodeslot=0x28AE, category='so', description='BRAILLE PATTERN DOTS-23468' },
	[0x28AF] = { unicodeslot=0x28AF, category='so', description='BRAILLE PATTERN DOTS-123468' },
	[0x28B0] = { unicodeslot=0x28B0, category='so', description='BRAILLE PATTERN DOTS-568' },
	[0x28B1] = { unicodeslot=0x28B1, category='so', description='BRAILLE PATTERN DOTS-1568' },
	[0x28B2] = { unicodeslot=0x28B2, category='so', description='BRAILLE PATTERN DOTS-2568' },
	[0x28B3] = { unicodeslot=0x28B3, category='so', description='BRAILLE PATTERN DOTS-12568' },
	[0x28B4] = { unicodeslot=0x28B4, category='so', description='BRAILLE PATTERN DOTS-3568' },
	[0x28B5] = { unicodeslot=0x28B5, category='so', description='BRAILLE PATTERN DOTS-13568' },
	[0x28B6] = { unicodeslot=0x28B6, category='so', description='BRAILLE PATTERN DOTS-23568' },
	[0x28B7] = { unicodeslot=0x28B7, category='so', description='BRAILLE PATTERN DOTS-123568' },
	[0x28B8] = { unicodeslot=0x28B8, category='so', description='BRAILLE PATTERN DOTS-4568' },
	[0x28B9] = { unicodeslot=0x28B9, category='so', description='BRAILLE PATTERN DOTS-14568' },
	[0x28BA] = { unicodeslot=0x28BA, category='so', description='BRAILLE PATTERN DOTS-24568' },
	[0x28BB] = { unicodeslot=0x28BB, category='so', description='BRAILLE PATTERN DOTS-124568' },
	[0x28BC] = { unicodeslot=0x28BC, category='so', description='BRAILLE PATTERN DOTS-34568' },
	[0x28BD] = { unicodeslot=0x28BD, category='so', description='BRAILLE PATTERN DOTS-134568' },
	[0x28BE] = { unicodeslot=0x28BE, category='so', description='BRAILLE PATTERN DOTS-234568' },
	[0x28BF] = { unicodeslot=0x28BF, category='so', description='BRAILLE PATTERN DOTS-1234568' },
	[0x28C0] = { unicodeslot=0x28C0, category='so', description='BRAILLE PATTERN DOTS-78' },
	[0x28C1] = { unicodeslot=0x28C1, category='so', description='BRAILLE PATTERN DOTS-178' },
	[0x28C2] = { unicodeslot=0x28C2, category='so', description='BRAILLE PATTERN DOTS-278' },
	[0x28C3] = { unicodeslot=0x28C3, category='so', description='BRAILLE PATTERN DOTS-1278' },
	[0x28C4] = { unicodeslot=0x28C4, category='so', description='BRAILLE PATTERN DOTS-378' },
	[0x28C5] = { unicodeslot=0x28C5, category='so', description='BRAILLE PATTERN DOTS-1378' },
	[0x28C6] = { unicodeslot=0x28C6, category='so', description='BRAILLE PATTERN DOTS-2378' },
	[0x28C7] = { unicodeslot=0x28C7, category='so', description='BRAILLE PATTERN DOTS-12378' },
	[0x28C8] = { unicodeslot=0x28C8, category='so', description='BRAILLE PATTERN DOTS-478' },
	[0x28C9] = { unicodeslot=0x28C9, category='so', description='BRAILLE PATTERN DOTS-1478' },
	[0x28CA] = { unicodeslot=0x28CA, category='so', description='BRAILLE PATTERN DOTS-2478' },
	[0x28CB] = { unicodeslot=0x28CB, category='so', description='BRAILLE PATTERN DOTS-12478' },
	[0x28CC] = { unicodeslot=0x28CC, category='so', description='BRAILLE PATTERN DOTS-3478' },
	[0x28CD] = { unicodeslot=0x28CD, category='so', description='BRAILLE PATTERN DOTS-13478' },
	[0x28CE] = { unicodeslot=0x28CE, category='so', description='BRAILLE PATTERN DOTS-23478' },
	[0x28CF] = { unicodeslot=0x28CF, category='so', description='BRAILLE PATTERN DOTS-123478' },
	[0x28D0] = { unicodeslot=0x28D0, category='so', description='BRAILLE PATTERN DOTS-578' },
	[0x28D1] = { unicodeslot=0x28D1, category='so', description='BRAILLE PATTERN DOTS-1578' },
	[0x28D2] = { unicodeslot=0x28D2, category='so', description='BRAILLE PATTERN DOTS-2578' },
	[0x28D3] = { unicodeslot=0x28D3, category='so', description='BRAILLE PATTERN DOTS-12578' },
	[0x28D4] = { unicodeslot=0x28D4, category='so', description='BRAILLE PATTERN DOTS-3578' },
	[0x28D5] = { unicodeslot=0x28D5, category='so', description='BRAILLE PATTERN DOTS-13578' },
	[0x28D6] = { unicodeslot=0x28D6, category='so', description='BRAILLE PATTERN DOTS-23578' },
	[0x28D7] = { unicodeslot=0x28D7, category='so', description='BRAILLE PATTERN DOTS-123578' },
	[0x28D8] = { unicodeslot=0x28D8, category='so', description='BRAILLE PATTERN DOTS-4578' },
	[0x28D9] = { unicodeslot=0x28D9, category='so', description='BRAILLE PATTERN DOTS-14578' },
	[0x28DA] = { unicodeslot=0x28DA, category='so', description='BRAILLE PATTERN DOTS-24578' },
	[0x28DB] = { unicodeslot=0x28DB, category='so', description='BRAILLE PATTERN DOTS-124578' },
	[0x28DC] = { unicodeslot=0x28DC, category='so', description='BRAILLE PATTERN DOTS-34578' },
	[0x28DD] = { unicodeslot=0x28DD, category='so', description='BRAILLE PATTERN DOTS-134578' },
	[0x28DE] = { unicodeslot=0x28DE, category='so', description='BRAILLE PATTERN DOTS-234578' },
	[0x28DF] = { unicodeslot=0x28DF, category='so', description='BRAILLE PATTERN DOTS-1234578' },
	[0x28E0] = { unicodeslot=0x28E0, category='so', description='BRAILLE PATTERN DOTS-678' },
	[0x28E1] = { unicodeslot=0x28E1, category='so', description='BRAILLE PATTERN DOTS-1678' },
	[0x28E2] = { unicodeslot=0x28E2, category='so', description='BRAILLE PATTERN DOTS-2678' },
	[0x28E3] = { unicodeslot=0x28E3, category='so', description='BRAILLE PATTERN DOTS-12678' },
	[0x28E4] = { unicodeslot=0x28E4, category='so', description='BRAILLE PATTERN DOTS-3678' },
	[0x28E5] = { unicodeslot=0x28E5, category='so', description='BRAILLE PATTERN DOTS-13678' },
	[0x28E6] = { unicodeslot=0x28E6, category='so', description='BRAILLE PATTERN DOTS-23678' },
	[0x28E7] = { unicodeslot=0x28E7, category='so', description='BRAILLE PATTERN DOTS-123678' },
	[0x28E8] = { unicodeslot=0x28E8, category='so', description='BRAILLE PATTERN DOTS-4678' },
	[0x28E9] = { unicodeslot=0x28E9, category='so', description='BRAILLE PATTERN DOTS-14678' },
	[0x28EA] = { unicodeslot=0x28EA, category='so', description='BRAILLE PATTERN DOTS-24678' },
	[0x28EB] = { unicodeslot=0x28EB, category='so', description='BRAILLE PATTERN DOTS-124678' },
	[0x28EC] = { unicodeslot=0x28EC, category='so', description='BRAILLE PATTERN DOTS-34678' },
	[0x28ED] = { unicodeslot=0x28ED, category='so', description='BRAILLE PATTERN DOTS-134678' },
	[0x28EE] = { unicodeslot=0x28EE, category='so', description='BRAILLE PATTERN DOTS-234678' },
	[0x28EF] = { unicodeslot=0x28EF, category='so', description='BRAILLE PATTERN DOTS-1234678' },
	[0x28F0] = { unicodeslot=0x28F0, category='so', description='BRAILLE PATTERN DOTS-5678' },
	[0x28F1] = { unicodeslot=0x28F1, category='so', description='BRAILLE PATTERN DOTS-15678' },
	[0x28F2] = { unicodeslot=0x28F2, category='so', description='BRAILLE PATTERN DOTS-25678' },
	[0x28F3] = { unicodeslot=0x28F3, category='so', description='BRAILLE PATTERN DOTS-125678' },
	[0x28F4] = { unicodeslot=0x28F4, category='so', description='BRAILLE PATTERN DOTS-35678' },
	[0x28F5] = { unicodeslot=0x28F5, category='so', description='BRAILLE PATTERN DOTS-135678' },
	[0x28F6] = { unicodeslot=0x28F6, category='so', description='BRAILLE PATTERN DOTS-235678' },
	[0x28F7] = { unicodeslot=0x28F7, category='so', description='BRAILLE PATTERN DOTS-1235678' },
	[0x28F8] = { unicodeslot=0x28F8, category='so', description='BRAILLE PATTERN DOTS-45678' },
	[0x28F9] = { unicodeslot=0x28F9, category='so', description='BRAILLE PATTERN DOTS-145678' },
	[0x28FA] = { unicodeslot=0x28FA, category='so', description='BRAILLE PATTERN DOTS-245678' },
	[0x28FB] = { unicodeslot=0x28FB, category='so', description='BRAILLE PATTERN DOTS-1245678' },
	[0x28FC] = { unicodeslot=0x28FC, category='so', description='BRAILLE PATTERN DOTS-345678' },
	[0x28FD] = { unicodeslot=0x28FD, category='so', description='BRAILLE PATTERN DOTS-1345678' },
	[0x28FE] = { unicodeslot=0x28FE, category='so', description='BRAILLE PATTERN DOTS-2345678' },
	[0x28FF] = { unicodeslot=0x28FF, category='so', description='BRAILLE PATTERN DOTS-12345678' },
	[0x2900] = { unicodeslot=0x2900, category='sm', description='RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE' },
	[0x2901] = { unicodeslot=0x2901, category='sm', description='RIGHTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE' },
	[0x2902] = { unicodeslot=0x2902, category='sm', description='LEFTWARDS DOUBLE ARROW WITH VERTICAL STROKE' },
	[0x2903] = { unicodeslot=0x2903, category='sm', description='RIGHTWARDS DOUBLE ARROW WITH VERTICAL STROKE' },
	[0x2904] = { unicodeslot=0x2904, category='sm', description='LEFT RIGHT DOUBLE ARROW WITH VERTICAL STROKE' },
	[0x2905] = { unicodeslot=0x2905, category='sm', description='RIGHTWARDS TWO-HEADED ARROW FROM BAR' },
	[0x2906] = { unicodeslot=0x2906, category='sm', description='LEFTWARDS DOUBLE ARROW FROM BAR' },
	[0x2907] = { unicodeslot=0x2907, category='sm', description='RIGHTWARDS DOUBLE ARROW FROM BAR' },
	[0x2908] = { unicodeslot=0x2908, category='sm', description='DOWNWARDS ARROW WITH HORIZONTAL STROKE' },
	[0x2909] = { unicodeslot=0x2909, category='sm', description='UPWARDS ARROW WITH HORIZONTAL STROKE' },
	[0x290A] = { unicodeslot=0x290A, category='sm', description='UPWARDS TRIPLE ARROW' },
	[0x290B] = { unicodeslot=0x290B, category='sm', description='DOWNWARDS TRIPLE ARROW' },
	[0x290C] = { unicodeslot=0x290C, category='sm', description='LEFTWARDS DOUBLE DASH ARROW' },
	[0x290D] = { unicodeslot=0x290D, category='sm', description='RIGHTWARDS DOUBLE DASH ARROW' },
	[0x290E] = { unicodeslot=0x290E, category='sm', description='LEFTWARDS TRIPLE DASH ARROW' },
	[0x290F] = { unicodeslot=0x290F, category='sm', description='RIGHTWARDS TRIPLE DASH ARROW' },
	[0x2910] = { unicodeslot=0x2910, category='sm', description='RIGHTWARDS TWO-HEADED TRIPLE DASH ARROW' },
	[0x2911] = { unicodeslot=0x2911, category='sm', description='RIGHTWARDS ARROW WITH DOTTED STEM' },
	[0x2912] = { unicodeslot=0x2912, category='sm', description='UPWARDS ARROW TO BAR' },
	[0x2913] = { unicodeslot=0x2913, category='sm', description='DOWNWARDS ARROW TO BAR' },
	[0x2914] = { unicodeslot=0x2914, category='sm', description='RIGHTWARDS ARROW WITH TAIL WITH VERTICAL STROKE' },
	[0x2915] = { unicodeslot=0x2915, category='sm', description='RIGHTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE' },
	[0x2916] = { unicodeslot=0x2916, category='sm', description='RIGHTWARDS TWO-HEADED ARROW WITH TAIL' },
	[0x2917] = { unicodeslot=0x2917, category='sm', description='RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE' },
	[0x2918] = { unicodeslot=0x2918, category='sm', description='RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE' },
	[0x2919] = { unicodeslot=0x2919, category='sm', description='LEFTWARDS ARROW-TAIL' },
	[0x291A] = { unicodeslot=0x291A, category='sm', description='RIGHTWARDS ARROW-TAIL' },
	[0x291B] = { unicodeslot=0x291B, category='sm', description='LEFTWARDS DOUBLE ARROW-TAIL' },
	[0x291C] = { unicodeslot=0x291C, category='sm', description='RIGHTWARDS DOUBLE ARROW-TAIL' },
	[0x291D] = { unicodeslot=0x291D, category='sm', description='LEFTWARDS ARROW TO BLACK DIAMOND' },
	[0x291E] = { unicodeslot=0x291E, category='sm', description='RIGHTWARDS ARROW TO BLACK DIAMOND' },
	[0x291F] = { unicodeslot=0x291F, category='sm', description='LEFTWARDS ARROW FROM BAR TO BLACK DIAMOND' },
	[0x2920] = { unicodeslot=0x2920, category='sm', description='RIGHTWARDS ARROW FROM BAR TO BLACK DIAMOND' },
	[0x2921] = { unicodeslot=0x2921, category='sm', description='NORTH WEST AND SOUTH EAST ARROW' },
	[0x2922] = { unicodeslot=0x2922, category='sm', description='NORTH EAST AND SOUTH WEST ARROW' },
	[0x2923] = { unicodeslot=0x2923, category='sm', description='NORTH WEST ARROW WITH HOOK' },
	[0x2924] = { unicodeslot=0x2924, category='sm', description='NORTH EAST ARROW WITH HOOK' },
	[0x2925] = { unicodeslot=0x2925, category='sm', description='SOUTH EAST ARROW WITH HOOK' },
	[0x2926] = { unicodeslot=0x2926, category='sm', description='SOUTH WEST ARROW WITH HOOK' },
	[0x2927] = { unicodeslot=0x2927, category='sm', description='NORTH WEST ARROW AND NORTH EAST ARROW' },
	[0x2928] = { unicodeslot=0x2928, category='sm', description='NORTH EAST ARROW AND SOUTH EAST ARROW' },
	[0x2929] = { unicodeslot=0x2929, category='sm', description='SOUTH EAST ARROW AND SOUTH WEST ARROW' },
	[0x292A] = { unicodeslot=0x292A, category='sm', description='SOUTH WEST ARROW AND NORTH WEST ARROW' },
	[0x292B] = { unicodeslot=0x292B, category='sm', description='RISING DIAGONAL CROSSING FALLING DIAGONAL' },
	[0x292C] = { unicodeslot=0x292C, category='sm', description='FALLING DIAGONAL CROSSING RISING DIAGONAL' },
	[0x292D] = { unicodeslot=0x292D, category='sm', description='SOUTH EAST ARROW CROSSING NORTH EAST ARROW' },
	[0x292E] = { unicodeslot=0x292E, category='sm', description='NORTH EAST ARROW CROSSING SOUTH EAST ARROW' },
	[0x292F] = { unicodeslot=0x292F, category='sm', description='FALLING DIAGONAL CROSSING NORTH EAST ARROW' },
	[0x2930] = { unicodeslot=0x2930, category='sm', description='RISING DIAGONAL CROSSING SOUTH EAST ARROW' },
	[0x2931] = { unicodeslot=0x2931, category='sm', description='NORTH EAST ARROW CROSSING NORTH WEST ARROW' },
	[0x2932] = { unicodeslot=0x2932, category='sm', description='NORTH WEST ARROW CROSSING NORTH EAST ARROW' },
	[0x2933] = { unicodeslot=0x2933, category='sm', description='WAVE ARROW POINTING DIRECTLY RIGHT' },
	[0x2934] = { unicodeslot=0x2934, category='sm', description='ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS' },
	[0x2935] = { unicodeslot=0x2935, category='sm', description='ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS' },
	[0x2936] = { unicodeslot=0x2936, category='sm', description='ARROW POINTING DOWNWARDS THEN CURVING LEFTWARDS' },
	[0x2937] = { unicodeslot=0x2937, category='sm', description='ARROW POINTING DOWNWARDS THEN CURVING RIGHTWARDS' },
	[0x2938] = { unicodeslot=0x2938, category='sm', description='RIGHT-SIDE ARC CLOCKWISE ARROW' },
	[0x2939] = { unicodeslot=0x2939, category='sm', description='LEFT-SIDE ARC ANTICLOCKWISE ARROW' },
	[0x293A] = { unicodeslot=0x293A, category='sm', description='TOP ARC ANTICLOCKWISE ARROW' },
	[0x293B] = { unicodeslot=0x293B, category='sm', description='BOTTOM ARC ANTICLOCKWISE ARROW' },
	[0x293C] = { unicodeslot=0x293C, category='sm', description='TOP ARC CLOCKWISE ARROW WITH MINUS' },
	[0x293D] = { unicodeslot=0x293D, category='sm', description='TOP ARC ANTICLOCKWISE ARROW WITH PLUS' },
	[0x293E] = { unicodeslot=0x293E, category='sm', description='LOWER RIGHT SEMICIRCULAR CLOCKWISE ARROW' },
	[0x293F] = { unicodeslot=0x293F, category='sm', description='LOWER LEFT SEMICIRCULAR ANTICLOCKWISE ARROW' },
	[0x2940] = { unicodeslot=0x2940, category='sm', description='ANTICLOCKWISE CLOSED CIRCLE ARROW' },
	[0x2941] = { unicodeslot=0x2941, category='sm', description='CLOCKWISE CLOSED CIRCLE ARROW' },
	[0x2942] = { unicodeslot=0x2942, category='sm', description='RIGHTWARDS ARROW ABOVE SHORT LEFTWARDS ARROW' },
	[0x2943] = { unicodeslot=0x2943, category='sm', description='LEFTWARDS ARROW ABOVE SHORT RIGHTWARDS ARROW' },
	[0x2944] = { unicodeslot=0x2944, category='sm', description='SHORT RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW' },
	[0x2945] = { unicodeslot=0x2945, category='sm', description='RIGHTWARDS ARROW WITH PLUS BELOW' },
	[0x2946] = { unicodeslot=0x2946, category='sm', description='LEFTWARDS ARROW WITH PLUS BELOW' },
	[0x2947] = { unicodeslot=0x2947, category='sm', description='RIGHTWARDS ARROW THROUGH X' },
	[0x2948] = { unicodeslot=0x2948, category='sm', description='LEFT RIGHT ARROW THROUGH SMALL CIRCLE' },
	[0x2949] = { unicodeslot=0x2949, category='sm', description='UPWARDS TWO-HEADED ARROW FROM SMALL CIRCLE' },
	[0x294A] = { unicodeslot=0x294A, category='sm', description='LEFT BARB UP RIGHT BARB DOWN HARPOON' },
	[0x294B] = { unicodeslot=0x294B, category='sm', description='LEFT BARB DOWN RIGHT BARB UP HARPOON' },
	[0x294C] = { unicodeslot=0x294C, category='sm', description='UP BARB RIGHT DOWN BARB LEFT HARPOON' },
	[0x294D] = { unicodeslot=0x294D, category='sm', description='UP BARB LEFT DOWN BARB RIGHT HARPOON' },
	[0x294E] = { unicodeslot=0x294E, category='sm', description='LEFT BARB UP RIGHT BARB UP HARPOON' },
	[0x294F] = { unicodeslot=0x294F, category='sm', description='UP BARB RIGHT DOWN BARB RIGHT HARPOON' },
	[0x2950] = { unicodeslot=0x2950, category='sm', description='LEFT BARB DOWN RIGHT BARB DOWN HARPOON' },
	[0x2951] = { unicodeslot=0x2951, category='sm', description='UP BARB LEFT DOWN BARB LEFT HARPOON' },
	[0x2952] = { unicodeslot=0x2952, category='sm', description='LEFTWARDS HARPOON WITH BARB UP TO BAR' },
	[0x2953] = { unicodeslot=0x2953, category='sm', description='RIGHTWARDS HARPOON WITH BARB UP TO BAR' },
	[0x2954] = { unicodeslot=0x2954, category='sm', description='UPWARDS HARPOON WITH BARB RIGHT TO BAR' },
	[0x2955] = { unicodeslot=0x2955, category='sm', description='DOWNWARDS HARPOON WITH BARB RIGHT TO BAR' },
	[0x2956] = { unicodeslot=0x2956, category='sm', description='LEFTWARDS HARPOON WITH BARB DOWN TO BAR' },
	[0x2957] = { unicodeslot=0x2957, category='sm', description='RIGHTWARDS HARPOON WITH BARB DOWN TO BAR' },
	[0x2958] = { unicodeslot=0x2958, category='sm', description='UPWARDS HARPOON WITH BARB LEFT TO BAR' },
	[0x2959] = { unicodeslot=0x2959, category='sm', description='DOWNWARDS HARPOON WITH BARB LEFT TO BAR' },
	[0x295A] = { unicodeslot=0x295A, category='sm', description='LEFTWARDS HARPOON WITH BARB UP FROM BAR' },
	[0x295B] = { unicodeslot=0x295B, category='sm', description='RIGHTWARDS HARPOON WITH BARB UP FROM BAR' },
	[0x295C] = { unicodeslot=0x295C, category='sm', description='UPWARDS HARPOON WITH BARB RIGHT FROM BAR' },
	[0x295D] = { unicodeslot=0x295D, category='sm', description='DOWNWARDS HARPOON WITH BARB RIGHT FROM BAR' },
	[0x295E] = { unicodeslot=0x295E, category='sm', description='LEFTWARDS HARPOON WITH BARB DOWN FROM BAR' },
	[0x295F] = { unicodeslot=0x295F, category='sm', description='RIGHTWARDS HARPOON WITH BARB DOWN FROM BAR' },
	[0x2960] = { unicodeslot=0x2960, category='sm', description='UPWARDS HARPOON WITH BARB LEFT FROM BAR' },
	[0x2961] = { unicodeslot=0x2961, category='sm', description='DOWNWARDS HARPOON WITH BARB LEFT FROM BAR' },
	[0x2962] = { unicodeslot=0x2962, category='sm', description='LEFTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB DOWN' },
	[0x2963] = { unicodeslot=0x2963, category='sm', description='UPWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT' },
	[0x2964] = { unicodeslot=0x2964, category='sm', description='RIGHTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB DOWN' },
	[0x2965] = { unicodeslot=0x2965, category='sm', description='DOWNWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT' },
	[0x2966] = { unicodeslot=0x2966, category='sm', description='LEFTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB UP' },
	[0x2967] = { unicodeslot=0x2967, category='sm', description='LEFTWARDS HARPOON WITH BARB DOWN ABOVE RIGHTWARDS HARPOON WITH BARB DOWN' },
	[0x2968] = { unicodeslot=0x2968, category='sm', description='RIGHTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB UP' },
	[0x2969] = { unicodeslot=0x2969, category='sm', description='RIGHTWARDS HARPOON WITH BARB DOWN ABOVE LEFTWARDS HARPOON WITH BARB DOWN' },
	[0x296A] = { unicodeslot=0x296A, category='sm', description='LEFTWARDS HARPOON WITH BARB UP ABOVE LONG DASH' },
	[0x296B] = { unicodeslot=0x296B, category='sm', description='LEFTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH' },
	[0x296C] = { unicodeslot=0x296C, category='sm', description='RIGHTWARDS HARPOON WITH BARB UP ABOVE LONG DASH' },
	[0x296D] = { unicodeslot=0x296D, category='sm', description='RIGHTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH' },
	[0x296E] = { unicodeslot=0x296E, category='sm', description='UPWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT' },
	[0x296F] = { unicodeslot=0x296F, category='sm', description='DOWNWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT' },
	[0x2970] = { unicodeslot=0x2970, category='sm', description='RIGHT DOUBLE ARROW WITH ROUNDED HEAD' },
	[0x2971] = { unicodeslot=0x2971, category='sm', description='EQUALS SIGN ABOVE RIGHTWARDS ARROW' },
	[0x2972] = { unicodeslot=0x2972, category='sm', description='TILDE OPERATOR ABOVE RIGHTWARDS ARROW' },
	[0x2973] = { unicodeslot=0x2973, category='sm', description='LEFTWARDS ARROW ABOVE TILDE OPERATOR' },
	[0x2974] = { unicodeslot=0x2974, category='sm', description='RIGHTWARDS ARROW ABOVE TILDE OPERATOR' },
	[0x2975] = { unicodeslot=0x2975, category='sm', description='RIGHTWARDS ARROW ABOVE ALMOST EQUAL TO' },
	[0x2976] = { unicodeslot=0x2976, category='sm', description='LESS-THAN ABOVE LEFTWARDS ARROW' },
	[0x2977] = { unicodeslot=0x2977, category='sm', description='LEFTWARDS ARROW THROUGH LESS-THAN' },
	[0x2978] = { unicodeslot=0x2978, category='sm', description='GREATER-THAN ABOVE RIGHTWARDS ARROW' },
	[0x2979] = { unicodeslot=0x2979, category='sm', description='SUBSET ABOVE RIGHTWARDS ARROW' },
	[0x297A] = { unicodeslot=0x297A, category='sm', description='LEFTWARDS ARROW THROUGH SUBSET' },
	[0x297B] = { unicodeslot=0x297B, category='sm', description='SUPERSET ABOVE LEFTWARDS ARROW' },
	[0x297C] = { unicodeslot=0x297C, category='sm', description='LEFT FISH TAIL' },
	[0x297D] = { unicodeslot=0x297D, category='sm', description='RIGHT FISH TAIL' },
	[0x297E] = { unicodeslot=0x297E, category='sm', description='UP FISH TAIL' },
	[0x297F] = { unicodeslot=0x297F, category='sm', description='DOWN FISH TAIL' },
	[0x2980] = { unicodeslot=0x2980, category='sm', description='TRIPLE VERTICAL BAR DELIMITER' },
	[0x2981] = { unicodeslot=0x2981, category='sm', description='Z NOTATION SPOT' },
	[0x2982] = { unicodeslot=0x2982, category='sm', description='Z NOTATION TYPE COLON' },
	[0x2983] = { unicodeslot=0x2983, category='ps', description='LEFT WHITE CURLY BRACKET' },
	[0x2984] = { unicodeslot=0x2984, category='pe', description='RIGHT WHITE CURLY BRACKET' },
	[0x2985] = { unicodeslot=0x2985, category='ps', description='LEFT WHITE PARENTHESIS' },
	[0x2986] = { unicodeslot=0x2986, category='pe', description='RIGHT WHITE PARENTHESIS' },
	[0x2987] = { unicodeslot=0x2987, category='ps', description='Z NOTATION LEFT IMAGE BRACKET' },
	[0x2988] = { unicodeslot=0x2988, category='pe', description='Z NOTATION RIGHT IMAGE BRACKET' },
	[0x2989] = { unicodeslot=0x2989, category='ps', description='Z NOTATION LEFT BINDING BRACKET' },
	[0x298A] = { unicodeslot=0x298A, category='pe', description='Z NOTATION RIGHT BINDING BRACKET' },
	[0x298B] = { unicodeslot=0x298B, category='ps', description='LEFT SQUARE BRACKET WITH UNDERBAR' },
	[0x298C] = { unicodeslot=0x298C, category='pe', description='RIGHT SQUARE BRACKET WITH UNDERBAR' },
	[0x298D] = { unicodeslot=0x298D, category='ps', description='LEFT SQUARE BRACKET WITH TICK IN TOP CORNER' },
	[0x298E] = { unicodeslot=0x298E, category='pe', description='RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER' },
	[0x298F] = { unicodeslot=0x298F, category='ps', description='LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER' },
	[0x2990] = { unicodeslot=0x2990, category='pe', description='RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER' },
	[0x2991] = { unicodeslot=0x2991, category='ps', description='LEFT ANGLE BRACKET WITH DOT' },
	[0x2992] = { unicodeslot=0x2992, category='pe', description='RIGHT ANGLE BRACKET WITH DOT' },
	[0x2993] = { unicodeslot=0x2993, category='ps', description='LEFT ARC LESS-THAN BRACKET' },
	[0x2994] = { unicodeslot=0x2994, category='pe', description='RIGHT ARC GREATER-THAN BRACKET' },
	[0x2995] = { unicodeslot=0x2995, category='ps', description='DOUBLE LEFT ARC GREATER-THAN BRACKET' },
	[0x2996] = { unicodeslot=0x2996, category='pe', description='DOUBLE RIGHT ARC LESS-THAN BRACKET' },
	[0x2997] = { unicodeslot=0x2997, category='ps', description='LEFT BLACK TORTOISE SHELL BRACKET' },
	[0x2998] = { unicodeslot=0x2998, category='pe', description='RIGHT BLACK TORTOISE SHELL BRACKET' },
	[0x2999] = { unicodeslot=0x2999, category='sm', description='DOTTED FENCE' },
	[0x299A] = { unicodeslot=0x299A, category='sm', description='VERTICAL ZIGZAG LINE' },
	[0x299B] = { unicodeslot=0x299B, category='sm', description='MEASURED ANGLE OPENING LEFT' },
	[0x299C] = { unicodeslot=0x299C, category='sm', description='RIGHT ANGLE VARIANT WITH SQUARE' },
	[0x299D] = { unicodeslot=0x299D, category='sm', description='MEASURED RIGHT ANGLE WITH DOT' },
	[0x299E] = { unicodeslot=0x299E, category='sm', description='ANGLE WITH S INSIDE' },
	[0x299F] = { unicodeslot=0x299F, category='sm', description='ACUTE ANGLE' },
	[0x29A0] = { unicodeslot=0x29A0, category='sm', description='SPHERICAL ANGLE OPENING LEFT' },
	[0x29A1] = { unicodeslot=0x29A1, category='sm', description='SPHERICAL ANGLE OPENING UP' },
	[0x29A2] = { unicodeslot=0x29A2, category='sm', description='TURNED ANGLE' },
	[0x29A3] = { unicodeslot=0x29A3, category='sm', description='REVERSED ANGLE' },
	[0x29A4] = { unicodeslot=0x29A4, category='sm', description='ANGLE WITH UNDERBAR' },
	[0x29A5] = { unicodeslot=0x29A5, category='sm', description='REVERSED ANGLE WITH UNDERBAR' },
	[0x29A6] = { unicodeslot=0x29A6, category='sm', description='OBLIQUE ANGLE OPENING UP' },
	[0x29A7] = { unicodeslot=0x29A7, category='sm', description='OBLIQUE ANGLE OPENING DOWN' },
	[0x29A8] = { unicodeslot=0x29A8, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND RIGHT' },
	[0x29A9] = { unicodeslot=0x29A9, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND LEFT' },
	[0x29AA] = { unicodeslot=0x29AA, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND RIGHT' },
	[0x29AB] = { unicodeslot=0x29AB, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND LEFT' },
	[0x29AC] = { unicodeslot=0x29AC, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND UP' },
	[0x29AD] = { unicodeslot=0x29AD, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND UP' },
	[0x29AE] = { unicodeslot=0x29AE, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND DOWN' },
	[0x29AF] = { unicodeslot=0x29AF, category='sm', description='MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND DOWN' },
	[0x29B0] = { unicodeslot=0x29B0, category='sm', description='REVERSED EMPTY SET' },
	[0x29B1] = { unicodeslot=0x29B1, category='sm', description='EMPTY SET WITH OVERBAR' },
	[0x29B2] = { unicodeslot=0x29B2, category='sm', description='EMPTY SET WITH SMALL CIRCLE ABOVE' },
	[0x29B3] = { unicodeslot=0x29B3, category='sm', description='EMPTY SET WITH RIGHT ARROW ABOVE' },
	[0x29B4] = { unicodeslot=0x29B4, category='sm', description='EMPTY SET WITH LEFT ARROW ABOVE' },
	[0x29B5] = { unicodeslot=0x29B5, category='sm', description='CIRCLE WITH HORIZONTAL BAR' },
	[0x29B6] = { unicodeslot=0x29B6, category='sm', description='CIRCLED VERTICAL BAR' },
	[0x29B7] = { unicodeslot=0x29B7, category='sm', description='CIRCLED PARALLEL' },
	[0x29B8] = { unicodeslot=0x29B8, category='sm', description='CIRCLED REVERSE SOLIDUS' },
	[0x29B9] = { unicodeslot=0x29B9, category='sm', description='CIRCLED PERPENDICULAR' },
	[0x29BA] = { unicodeslot=0x29BA, category='sm', description='CIRCLE DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR' },
	[0x29BB] = { unicodeslot=0x29BB, category='sm', description='CIRCLE WITH SUPERIMPOSED X' },
	[0x29BC] = { unicodeslot=0x29BC, category='sm', description='CIRCLED ANTICLOCKWISE-ROTATED DIVISION SIGN' },
	[0x29BD] = { unicodeslot=0x29BD, category='sm', description='UP ARROW THROUGH CIRCLE' },
	[0x29BE] = { unicodeslot=0x29BE, category='sm', description='CIRCLED WHITE BULLET' },
	[0x29BF] = { unicodeslot=0x29BF, category='sm', description='CIRCLED BULLET' },
	[0x29C0] = { unicodeslot=0x29C0, category='sm', description='CIRCLED LESS-THAN' },
	[0x29C1] = { unicodeslot=0x29C1, category='sm', description='CIRCLED GREATER-THAN' },
	[0x29C2] = { unicodeslot=0x29C2, category='sm', description='CIRCLE WITH SMALL CIRCLE TO THE RIGHT' },
	[0x29C3] = { unicodeslot=0x29C3, category='sm', description='CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT' },
	[0x29C4] = { unicodeslot=0x29C4, category='sm', description='SQUARED RISING DIAGONAL SLASH' },
	[0x29C5] = { unicodeslot=0x29C5, category='sm', description='SQUARED FALLING DIAGONAL SLASH' },
	[0x29C6] = { unicodeslot=0x29C6, category='sm', description='SQUARED ASTERISK' },
	[0x29C7] = { unicodeslot=0x29C7, category='sm', description='SQUARED SMALL CIRCLE' },
	[0x29C8] = { unicodeslot=0x29C8, category='sm', description='SQUARED SQUARE' },
	[0x29C9] = { unicodeslot=0x29C9, category='sm', description='TWO JOINED SQUARES' },
	[0x29CA] = { unicodeslot=0x29CA, category='sm', description='TRIANGLE WITH DOT ABOVE' },
	[0x29CB] = { unicodeslot=0x29CB, category='sm', description='TRIANGLE WITH UNDERBAR' },
	[0x29CC] = { unicodeslot=0x29CC, category='sm', description='S IN TRIANGLE' },
	[0x29CD] = { unicodeslot=0x29CD, category='sm', description='TRIANGLE WITH SERIFS AT BOTTOM' },
	[0x29CE] = { unicodeslot=0x29CE, category='sm', description='RIGHT TRIANGLE ABOVE LEFT TRIANGLE' },
	[0x29CF] = { unicodeslot=0x29CF, category='sm', description='LEFT TRIANGLE BESIDE VERTICAL BAR' },
	[0x29D0] = { unicodeslot=0x29D0, category='sm', description='VERTICAL BAR BESIDE RIGHT TRIANGLE' },
	[0x29D1] = { unicodeslot=0x29D1, category='sm', description='BOWTIE WITH LEFT HALF BLACK' },
	[0x29D2] = { unicodeslot=0x29D2, category='sm', description='BOWTIE WITH RIGHT HALF BLACK' },
	[0x29D3] = { unicodeslot=0x29D3, category='sm', description='BLACK BOWTIE' },
	[0x29D4] = { unicodeslot=0x29D4, category='sm', description='TIMES WITH LEFT HALF BLACK' },
	[0x29D5] = { unicodeslot=0x29D5, category='sm', description='TIMES WITH RIGHT HALF BLACK' },
	[0x29D6] = { unicodeslot=0x29D6, category='sm', description='WHITE HOURGLASS' },
	[0x29D7] = { unicodeslot=0x29D7, category='sm', description='BLACK HOURGLASS' },
	[0x29D8] = { unicodeslot=0x29D8, category='ps', description='LEFT WIGGLY FENCE' },
	[0x29D9] = { unicodeslot=0x29D9, category='pe', description='RIGHT WIGGLY FENCE' },
	[0x29DA] = { unicodeslot=0x29DA, category='ps', description='LEFT DOUBLE WIGGLY FENCE' },
	[0x29DB] = { unicodeslot=0x29DB, category='pe', description='RIGHT DOUBLE WIGGLY FENCE' },
	[0x29DC] = { unicodeslot=0x29DC, category='sm', description='INCOMPLETE INFINITY' },
	[0x29DD] = { unicodeslot=0x29DD, category='sm', description='TIE OVER INFINITY' },
	[0x29DE] = { unicodeslot=0x29DE, category='sm', description='INFINITY NEGATED WITH VERTICAL BAR' },
	[0x29DF] = { unicodeslot=0x29DF, category='sm', description='DOUBLE-ENDED MULTIMAP' },
	[0x29E0] = { unicodeslot=0x29E0, category='sm', description='SQUARE WITH CONTOURED OUTLINE' },
	[0x29E1] = { unicodeslot=0x29E1, category='sm', description='INCREASES AS' },
	[0x29E2] = { unicodeslot=0x29E2, category='sm', description='SHUFFLE PRODUCT' },
	[0x29E3] = { unicodeslot=0x29E3, category='sm', description='EQUALS SIGN AND SLANTED PARALLEL' },
	[0x29E4] = { unicodeslot=0x29E4, category='sm', description='EQUALS SIGN AND SLANTED PARALLEL WITH TILDE ABOVE' },
	[0x29E5] = { unicodeslot=0x29E5, category='sm', description='IDENTICAL TO AND SLANTED PARALLEL' },
	[0x29E6] = { unicodeslot=0x29E6, category='sm', description='GLEICH STARK' },
	[0x29E7] = { unicodeslot=0x29E7, category='sm', description='THERMODYNAMIC' },
	[0x29E8] = { unicodeslot=0x29E8, category='sm', description='DOWN-POINTING TRIANGLE WITH LEFT HALF BLACK' },
	[0x29E9] = { unicodeslot=0x29E9, category='sm', description='DOWN-POINTING TRIANGLE WITH RIGHT HALF BLACK' },
	[0x29EA] = { unicodeslot=0x29EA, category='sm', description='BLACK DIAMOND WITH DOWN ARROW' },
	[0x29EB] = { unicodeslot=0x29EB, category='sm', description='BLACK LOZENGE' },
	[0x29EC] = { unicodeslot=0x29EC, category='sm', description='WHITE CIRCLE WITH DOWN ARROW' },
	[0x29ED] = { unicodeslot=0x29ED, category='sm', description='BLACK CIRCLE WITH DOWN ARROW' },
	[0x29EE] = { unicodeslot=0x29EE, category='sm', description='ERROR-BARRED WHITE SQUARE' },
	[0x29EF] = { unicodeslot=0x29EF, category='sm', description='ERROR-BARRED BLACK SQUARE' },
	[0x29F0] = { unicodeslot=0x29F0, category='sm', description='ERROR-BARRED WHITE DIAMOND' },
	[0x29F1] = { unicodeslot=0x29F1, category='sm', description='ERROR-BARRED BLACK DIAMOND' },
	[0x29F2] = { unicodeslot=0x29F2, category='sm', description='ERROR-BARRED WHITE CIRCLE' },
	[0x29F3] = { unicodeslot=0x29F3, category='sm', description='ERROR-BARRED BLACK CIRCLE' },
	[0x29F4] = { unicodeslot=0x29F4, category='sm', description='RULE-DELAYED' },
	[0x29F5] = { unicodeslot=0x29F5, category='sm', description='REVERSE SOLIDUS OPERATOR' },
	[0x29F6] = { unicodeslot=0x29F6, category='sm', description='SOLIDUS WITH OVERBAR' },
	[0x29F7] = { unicodeslot=0x29F7, category='sm', description='REVERSE SOLIDUS WITH HORIZONTAL STROKE' },
	[0x29F8] = { unicodeslot=0x29F8, category='sm', description='BIG SOLIDUS' },
	[0x29F9] = { unicodeslot=0x29F9, category='sm', description='BIG REVERSE SOLIDUS' },
	[0x29FA] = { unicodeslot=0x29FA, category='sm', description='DOUBLE PLUS' },
	[0x29FB] = { unicodeslot=0x29FB, category='sm', description='TRIPLE PLUS' },
	[0x29FC] = { unicodeslot=0x29FC, category='ps', description='LEFT-POINTING CURVED ANGLE BRACKET' },
	[0x29FD] = { unicodeslot=0x29FD, category='pe', description='RIGHT-POINTING CURVED ANGLE BRACKET' },
	[0x29FE] = { unicodeslot=0x29FE, category='sm', description='TINY' },
	[0x29FF] = { unicodeslot=0x29FF, category='sm', description='MINY' },
	[0x2A00] = { unicodeslot=0x2A00, category='sm', description='N-ARY CIRCLED DOT OPERATOR' },
	[0x2A01] = { unicodeslot=0x2A01, category='sm', description='N-ARY CIRCLED PLUS OPERATOR' },
	[0x2A02] = { unicodeslot=0x2A02, category='sm', description='N-ARY CIRCLED TIMES OPERATOR' },
	[0x2A03] = { unicodeslot=0x2A03, category='sm', description='N-ARY UNION OPERATOR WITH DOT' },
	[0x2A04] = { unicodeslot=0x2A04, category='sm', description='N-ARY UNION OPERATOR WITH PLUS' },
	[0x2A05] = { unicodeslot=0x2A05, category='sm', description='N-ARY SQUARE INTERSECTION OPERATOR' },
	[0x2A06] = { unicodeslot=0x2A06, category='sm', description='N-ARY SQUARE UNION OPERATOR' },
	[0x2A07] = { unicodeslot=0x2A07, category='sm', description='TWO LOGICAL AND OPERATOR' },
	[0x2A08] = { unicodeslot=0x2A08, category='sm', description='TWO LOGICAL OR OPERATOR' },
	[0x2A09] = { unicodeslot=0x2A09, category='sm', description='N-ARY TIMES OPERATOR' },
	[0x2A0A] = { unicodeslot=0x2A0A, category='sm', description='MODULO TWO SUM' },
	[0x2A0B] = { unicodeslot=0x2A0B, category='sm', description='SUMMATION WITH INTEGRAL' },
	[0x2A0C] = { unicodeslot=0x2A0C, category='sm', description='QUADRUPLE INTEGRAL OPERATOR', specials={'compat',0x222B,0x222B,0x222B,0x222B} },
	[0x2A0D] = { unicodeslot=0x2A0D, category='sm', description='FINITE PART INTEGRAL' },
	[0x2A0E] = { unicodeslot=0x2A0E, category='sm', description='INTEGRAL WITH DOUBLE STROKE' },
	[0x2A0F] = { unicodeslot=0x2A0F, category='sm', description='INTEGRAL AVERAGE WITH SLASH' },
	[0x2A10] = { unicodeslot=0x2A10, category='sm', description='CIRCULATION FUNCTION' },
	[0x2A11] = { unicodeslot=0x2A11, category='sm', description='ANTICLOCKWISE INTEGRATION' },
	[0x2A12] = { unicodeslot=0x2A12, category='sm', description='LINE INTEGRATION WITH RECTANGULAR PATH AROUND POLE' },
	[0x2A13] = { unicodeslot=0x2A13, category='sm', description='LINE INTEGRATION WITH SEMICIRCULAR PATH AROUND POLE' },
	[0x2A14] = { unicodeslot=0x2A14, category='sm', description='LINE INTEGRATION NOT INCLUDING THE POLE' },
	[0x2A15] = { unicodeslot=0x2A15, category='sm', description='INTEGRAL AROUND A POINT OPERATOR' },
	[0x2A16] = { unicodeslot=0x2A16, category='sm', description='QUATERNION INTEGRAL OPERATOR' },
	[0x2A17] = { unicodeslot=0x2A17, category='sm', description='INTEGRAL WITH LEFTWARDS ARROW WITH HOOK' },
	[0x2A18] = { unicodeslot=0x2A18, category='sm', description='INTEGRAL WITH TIMES SIGN' },
	[0x2A19] = { unicodeslot=0x2A19, category='sm', description='INTEGRAL WITH INTERSECTION' },
	[0x2A1A] = { unicodeslot=0x2A1A, category='sm', description='INTEGRAL WITH UNION' },
	[0x2A1B] = { unicodeslot=0x2A1B, category='sm', description='INTEGRAL WITH OVERBAR' },
	[0x2A1C] = { unicodeslot=0x2A1C, category='sm', description='INTEGRAL WITH UNDERBAR' },
	[0x2A1D] = { unicodeslot=0x2A1D, category='sm', description='JOIN' },
	[0x2A1E] = { unicodeslot=0x2A1E, category='sm', description='LARGE LEFT TRIANGLE OPERATOR' },
	[0x2A1F] = { unicodeslot=0x2A1F, category='sm', description='Z NOTATION SCHEMA COMPOSITION' },
	[0x2A20] = { unicodeslot=0x2A20, category='sm', description='Z NOTATION SCHEMA PIPING' },
	[0x2A21] = { unicodeslot=0x2A21, category='sm', description='Z NOTATION SCHEMA PROJECTION' },
	[0x2A22] = { unicodeslot=0x2A22, category='sm', description='PLUS SIGN WITH SMALL CIRCLE ABOVE' },
	[0x2A23] = { unicodeslot=0x2A23, category='sm', description='PLUS SIGN WITH CIRCUMFLEX ACCENT ABOVE' },
	[0x2A24] = { unicodeslot=0x2A24, category='sm', description='PLUS SIGN WITH TILDE ABOVE' },
	[0x2A25] = { unicodeslot=0x2A25, category='sm', description='PLUS SIGN WITH DOT BELOW' },
	[0x2A26] = { unicodeslot=0x2A26, category='sm', description='PLUS SIGN WITH TILDE BELOW' },
	[0x2A27] = { unicodeslot=0x2A27, category='sm', description='PLUS SIGN WITH SUBSCRIPT TWO' },
	[0x2A28] = { unicodeslot=0x2A28, category='sm', description='PLUS SIGN WITH BLACK TRIANGLE' },
	[0x2A29] = { unicodeslot=0x2A29, category='sm', description='MINUS SIGN WITH COMMA ABOVE' },
	[0x2A2A] = { unicodeslot=0x2A2A, category='sm', description='MINUS SIGN WITH DOT BELOW' },
	[0x2A2B] = { unicodeslot=0x2A2B, category='sm', description='MINUS SIGN WITH FALLING DOTS' },
	[0x2A2C] = { unicodeslot=0x2A2C, category='sm', description='MINUS SIGN WITH RISING DOTS' },
	[0x2A2D] = { unicodeslot=0x2A2D, category='sm', description='PLUS SIGN IN LEFT HALF CIRCLE' },
	[0x2A2E] = { unicodeslot=0x2A2E, category='sm', description='PLUS SIGN IN RIGHT HALF CIRCLE' },
	[0x2A2F] = { unicodeslot=0x2A2F, category='sm', description='VECTOR OR CROSS PRODUCT' },
	[0x2A30] = { unicodeslot=0x2A30, category='sm', description='MULTIPLICATION SIGN WITH DOT ABOVE' },
	[0x2A31] = { unicodeslot=0x2A31, category='sm', description='MULTIPLICATION SIGN WITH UNDERBAR' },
	[0x2A32] = { unicodeslot=0x2A32, category='sm', description='SEMIDIRECT PRODUCT WITH BOTTOM CLOSED' },
	[0x2A33] = { unicodeslot=0x2A33, category='sm', description='SMASH PRODUCT' },
	[0x2A34] = { unicodeslot=0x2A34, category='sm', description='MULTIPLICATION SIGN IN LEFT HALF CIRCLE' },
	[0x2A35] = { unicodeslot=0x2A35, category='sm', description='MULTIPLICATION SIGN IN RIGHT HALF CIRCLE' },
	[0x2A36] = { unicodeslot=0x2A36, category='sm', description='CIRCLED MULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT' },
	[0x2A37] = { unicodeslot=0x2A37, category='sm', description='MULTIPLICATION SIGN IN DOUBLE CIRCLE' },
	[0x2A38] = { unicodeslot=0x2A38, category='sm', description='CIRCLED DIVISION SIGN' },
	[0x2A39] = { unicodeslot=0x2A39, category='sm', description='PLUS SIGN IN TRIANGLE' },
	[0x2A3A] = { unicodeslot=0x2A3A, category='sm', description='MINUS SIGN IN TRIANGLE' },
	[0x2A3B] = { unicodeslot=0x2A3B, category='sm', description='MULTIPLICATION SIGN IN TRIANGLE' },
	[0x2A3C] = { unicodeslot=0x2A3C, category='sm', description='INTERIOR PRODUCT' },
	[0x2A3D] = { unicodeslot=0x2A3D, category='sm', description='RIGHTHAND INTERIOR PRODUCT' },
	[0x2A3E] = { unicodeslot=0x2A3E, category='sm', description='Z NOTATION RELATIONAL COMPOSITION' },
	[0x2A3F] = { unicodeslot=0x2A3F, category='sm', description='AMALGAMATION OR COPRODUCT' },
	[0x2A40] = { unicodeslot=0x2A40, category='sm', description='INTERSECTION WITH DOT' },
	[0x2A41] = { unicodeslot=0x2A41, category='sm', description='UNION WITH MINUS SIGN' },
	[0x2A42] = { unicodeslot=0x2A42, category='sm', description='UNION WITH OVERBAR' },
	[0x2A43] = { unicodeslot=0x2A43, category='sm', description='INTERSECTION WITH OVERBAR' },
	[0x2A44] = { unicodeslot=0x2A44, category='sm', description='INTERSECTION WITH LOGICAL AND' },
	[0x2A45] = { unicodeslot=0x2A45, category='sm', description='UNION WITH LOGICAL OR' },
	[0x2A46] = { unicodeslot=0x2A46, category='sm', description='UNION ABOVE INTERSECTION' },
	[0x2A47] = { unicodeslot=0x2A47, category='sm', description='INTERSECTION ABOVE UNION' },
	[0x2A48] = { unicodeslot=0x2A48, category='sm', description='UNION ABOVE BAR ABOVE INTERSECTION' },
	[0x2A49] = { unicodeslot=0x2A49, category='sm', description='INTERSECTION ABOVE BAR ABOVE UNION' },
	[0x2A4A] = { unicodeslot=0x2A4A, category='sm', description='UNION BESIDE AND JOINED WITH UNION' },
	[0x2A4B] = { unicodeslot=0x2A4B, category='sm', description='INTERSECTION BESIDE AND JOINED WITH INTERSECTION' },
	[0x2A4C] = { unicodeslot=0x2A4C, category='sm', description='CLOSED UNION WITH SERIFS' },
	[0x2A4D] = { unicodeslot=0x2A4D, category='sm', description='CLOSED INTERSECTION WITH SERIFS' },
	[0x2A4E] = { unicodeslot=0x2A4E, category='sm', description='DOUBLE SQUARE INTERSECTION' },
	[0x2A4F] = { unicodeslot=0x2A4F, category='sm', description='DOUBLE SQUARE UNION' },
	[0x2A50] = { unicodeslot=0x2A50, category='sm', description='CLOSED UNION WITH SERIFS AND SMASH PRODUCT' },
	[0x2A51] = { unicodeslot=0x2A51, category='sm', description='LOGICAL AND WITH DOT ABOVE' },
	[0x2A52] = { unicodeslot=0x2A52, category='sm', description='LOGICAL OR WITH DOT ABOVE' },
	[0x2A53] = { unicodeslot=0x2A53, category='sm', description='DOUBLE LOGICAL AND' },
	[0x2A54] = { unicodeslot=0x2A54, category='sm', description='DOUBLE LOGICAL OR' },
	[0x2A55] = { unicodeslot=0x2A55, category='sm', description='TWO INTERSECTING LOGICAL AND' },
	[0x2A56] = { unicodeslot=0x2A56, category='sm', description='TWO INTERSECTING LOGICAL OR' },
	[0x2A57] = { unicodeslot=0x2A57, category='sm', description='SLOPING LARGE OR' },
	[0x2A58] = { unicodeslot=0x2A58, category='sm', description='SLOPING LARGE AND' },
	[0x2A59] = { unicodeslot=0x2A59, category='sm', description='LOGICAL OR OVERLAPPING LOGICAL AND' },
	[0x2A5A] = { unicodeslot=0x2A5A, category='sm', description='LOGICAL AND WITH MIDDLE STEM' },
	[0x2A5B] = { unicodeslot=0x2A5B, category='sm', description='LOGICAL OR WITH MIDDLE STEM' },
	[0x2A5C] = { unicodeslot=0x2A5C, category='sm', description='LOGICAL AND WITH HORIZONTAL DASH' },
	[0x2A5D] = { unicodeslot=0x2A5D, category='sm', description='LOGICAL OR WITH HORIZONTAL DASH' },
	[0x2A5E] = { unicodeslot=0x2A5E, category='sm', description='LOGICAL AND WITH DOUBLE OVERBAR' },
	[0x2A5F] = { unicodeslot=0x2A5F, category='sm', description='LOGICAL AND WITH UNDERBAR' },
	[0x2A60] = { unicodeslot=0x2A60, category='sm', description='LOGICAL AND WITH DOUBLE UNDERBAR' },
	[0x2A61] = { unicodeslot=0x2A61, category='sm', description='SMALL VEE WITH UNDERBAR' },
	[0x2A62] = { unicodeslot=0x2A62, category='sm', description='LOGICAL OR WITH DOUBLE OVERBAR' },
	[0x2A63] = { unicodeslot=0x2A63, category='sm', description='LOGICAL OR WITH DOUBLE UNDERBAR' },
	[0x2A64] = { unicodeslot=0x2A64, category='sm', description='Z NOTATION DOMAIN ANTIRESTRICTION' },
	[0x2A65] = { unicodeslot=0x2A65, category='sm', description='Z NOTATION RANGE ANTIRESTRICTION' },
	[0x2A66] = { unicodeslot=0x2A66, category='sm', description='EQUALS SIGN WITH DOT BELOW' },
	[0x2A67] = { unicodeslot=0x2A67, category='sm', description='IDENTICAL WITH DOT ABOVE' },
	[0x2A68] = { unicodeslot=0x2A68, category='sm', description='TRIPLE HORIZONTAL BAR WITH DOUBLE VERTICAL STROKE' },
	[0x2A69] = { unicodeslot=0x2A69, category='sm', description='TRIPLE HORIZONTAL BAR WITH TRIPLE VERTICAL STROKE' },
	[0x2A6A] = { unicodeslot=0x2A6A, category='sm', description='TILDE OPERATOR WITH DOT ABOVE' },
	[0x2A6B] = { unicodeslot=0x2A6B, category='sm', description='TILDE OPERATOR WITH RISING DOTS' },
	[0x2A6C] = { unicodeslot=0x2A6C, category='sm', description='SIMILAR MINUS SIMILAR' },
	[0x2A6D] = { unicodeslot=0x2A6D, category='sm', description='CONGRUENT WITH DOT ABOVE' },
	[0x2A6E] = { unicodeslot=0x2A6E, category='sm', description='EQUALS WITH ASTERISK' },
	[0x2A6F] = { unicodeslot=0x2A6F, category='sm', description='ALMOST EQUAL TO WITH CIRCUMFLEX ACCENT' },
	[0x2A70] = { unicodeslot=0x2A70, category='sm', description='APPROXIMATELY EQUAL OR EQUAL TO' },
	[0x2A71] = { unicodeslot=0x2A71, category='sm', description='EQUALS SIGN ABOVE PLUS SIGN' },
	[0x2A72] = { unicodeslot=0x2A72, category='sm', description='PLUS SIGN ABOVE EQUALS SIGN' },
	[0x2A73] = { unicodeslot=0x2A73, category='sm', description='EQUALS SIGN ABOVE TILDE OPERATOR' },
	[0x2A74] = { unicodeslot=0x2A74, category='sm', description='DOUBLE COLON EQUAL', specials={'compat',0x003A,0x003A,0x003D} },
	[0x2A75] = { unicodeslot=0x2A75, category='sm', description='TWO CONSECUTIVE EQUALS SIGNS', specials={'compat',0x003D,0x003D} },
	[0x2A76] = { unicodeslot=0x2A76, category='sm', description='THREE CONSECUTIVE EQUALS SIGNS', specials={'compat',0x003D,0x003D,0x003D} },
	[0x2A77] = { unicodeslot=0x2A77, category='sm', description='EQUALS SIGN WITH TWO DOTS ABOVE AND TWO DOTS BELOW' },
	[0x2A78] = { unicodeslot=0x2A78, category='sm', description='EQUIVALENT WITH FOUR DOTS ABOVE' },
	[0x2A79] = { unicodeslot=0x2A79, category='sm', description='LESS-THAN WITH CIRCLE INSIDE' },
	[0x2A7A] = { unicodeslot=0x2A7A, category='sm', description='GREATER-THAN WITH CIRCLE INSIDE' },
	[0x2A7B] = { unicodeslot=0x2A7B, category='sm', description='LESS-THAN WITH QUESTION MARK ABOVE' },
	[0x2A7C] = { unicodeslot=0x2A7C, category='sm', description='GREATER-THAN WITH QUESTION MARK ABOVE' },
	[0x2A7D] = { unicodeslot=0x2A7D, category='sm', description='LESS-THAN OR SLANTED EQUAL TO' },
	[0x2A7E] = { unicodeslot=0x2A7E, category='sm', description='GREATER-THAN OR SLANTED EQUAL TO' },
	[0x2A7F] = { unicodeslot=0x2A7F, category='sm', description='LESS-THAN OR SLANTED EQUAL TO WITH DOT INSIDE' },
	[0x2A80] = { unicodeslot=0x2A80, category='sm', description='GREATER-THAN OR SLANTED EQUAL TO WITH DOT INSIDE' },
	[0x2A81] = { unicodeslot=0x2A81, category='sm', description='LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE' },
	[0x2A82] = { unicodeslot=0x2A82, category='sm', description='GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE' },
	[0x2A83] = { unicodeslot=0x2A83, category='sm', description='LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT' },
	[0x2A84] = { unicodeslot=0x2A84, category='sm', description='GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE LEFT' },
	[0x2A85] = { unicodeslot=0x2A85, category='sm', description='LESS-THAN OR APPROXIMATE' },
	[0x2A86] = { unicodeslot=0x2A86, category='sm', description='GREATER-THAN OR APPROXIMATE' },
	[0x2A87] = { unicodeslot=0x2A87, category='sm', description='LESS-THAN AND SINGLE-LINE NOT EQUAL TO' },
	[0x2A88] = { unicodeslot=0x2A88, category='sm', description='GREATER-THAN AND SINGLE-LINE NOT EQUAL TO' },
	[0x2A89] = { unicodeslot=0x2A89, category='sm', description='LESS-THAN AND NOT APPROXIMATE' },
	[0x2A8A] = { unicodeslot=0x2A8A, category='sm', description='GREATER-THAN AND NOT APPROXIMATE' },
	[0x2A8B] = { unicodeslot=0x2A8B, category='sm', description='LESS-THAN ABOVE DOUBLE-LINE EQUAL ABOVE GREATER-THAN' },
	[0x2A8C] = { unicodeslot=0x2A8C, category='sm', description='GREATER-THAN ABOVE DOUBLE-LINE EQUAL ABOVE LESS-THAN' },
	[0x2A8D] = { unicodeslot=0x2A8D, category='sm', description='LESS-THAN ABOVE SIMILAR OR EQUAL' },
	[0x2A8E] = { unicodeslot=0x2A8E, category='sm', description='GREATER-THAN ABOVE SIMILAR OR EQUAL' },
	[0x2A8F] = { unicodeslot=0x2A8F, category='sm', description='LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN' },
	[0x2A90] = { unicodeslot=0x2A90, category='sm', description='GREATER-THAN ABOVE SIMILAR ABOVE LESS-THAN' },
	[0x2A91] = { unicodeslot=0x2A91, category='sm', description='LESS-THAN ABOVE GREATER-THAN ABOVE DOUBLE-LINE EQUAL' },
	[0x2A92] = { unicodeslot=0x2A92, category='sm', description='GREATER-THAN ABOVE LESS-THAN ABOVE DOUBLE-LINE EQUAL' },
	[0x2A93] = { unicodeslot=0x2A93, category='sm', description='LESS-THAN ABOVE SLANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL' },
	[0x2A94] = { unicodeslot=0x2A94, category='sm', description='GREATER-THAN ABOVE SLANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL' },
	[0x2A95] = { unicodeslot=0x2A95, category='sm', description='SLANTED EQUAL TO OR LESS-THAN' },
	[0x2A96] = { unicodeslot=0x2A96, category='sm', description='SLANTED EQUAL TO OR GREATER-THAN' },
	[0x2A97] = { unicodeslot=0x2A97, category='sm', description='SLANTED EQUAL TO OR LESS-THAN WITH DOT INSIDE' },
	[0x2A98] = { unicodeslot=0x2A98, category='sm', description='SLANTED EQUAL TO OR GREATER-THAN WITH DOT INSIDE' },
	[0x2A99] = { unicodeslot=0x2A99, category='sm', description='DOUBLE-LINE EQUAL TO OR LESS-THAN' },
	[0x2A9A] = { unicodeslot=0x2A9A, category='sm', description='DOUBLE-LINE EQUAL TO OR GREATER-THAN' },
	[0x2A9B] = { unicodeslot=0x2A9B, category='sm', description='DOUBLE-LINE SLANTED EQUAL TO OR LESS-THAN' },
	[0x2A9C] = { unicodeslot=0x2A9C, category='sm', description='DOUBLE-LINE SLANTED EQUAL TO OR GREATER-THAN' },
	[0x2A9D] = { unicodeslot=0x2A9D, category='sm', description='SIMILAR OR LESS-THAN' },
	[0x2A9E] = { unicodeslot=0x2A9E, category='sm', description='SIMILAR OR GREATER-THAN' },
	[0x2A9F] = { unicodeslot=0x2A9F, category='sm', description='SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN' },
	[0x2AA0] = { unicodeslot=0x2AA0, category='sm', description='SIMILAR ABOVE GREATER-THAN ABOVE EQUALS SIGN' },
	[0x2AA1] = { unicodeslot=0x2AA1, category='sm', description='DOUBLE NESTED LESS-THAN' },
	[0x2AA2] = { unicodeslot=0x2AA2, category='sm', description='DOUBLE NESTED GREATER-THAN' },
	[0x2AA3] = { unicodeslot=0x2AA3, category='sm', description='DOUBLE NESTED LESS-THAN WITH UNDERBAR' },
	[0x2AA4] = { unicodeslot=0x2AA4, category='sm', description='GREATER-THAN OVERLAPPING LESS-THAN' },
	[0x2AA5] = { unicodeslot=0x2AA5, category='sm', description='GREATER-THAN BESIDE LESS-THAN' },
	[0x2AA6] = { unicodeslot=0x2AA6, category='sm', description='LESS-THAN CLOSED BY CURVE' },
	[0x2AA7] = { unicodeslot=0x2AA7, category='sm', description='GREATER-THAN CLOSED BY CURVE' },
	[0x2AA8] = { unicodeslot=0x2AA8, category='sm', description='LESS-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL' },
	[0x2AA9] = { unicodeslot=0x2AA9, category='sm', description='GREATER-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL' },
	[0x2AAA] = { unicodeslot=0x2AAA, category='sm', description='SMALLER THAN' },
	[0x2AAB] = { unicodeslot=0x2AAB, category='sm', description='LARGER THAN' },
	[0x2AAC] = { unicodeslot=0x2AAC, category='sm', description='SMALLER THAN OR EQUAL TO' },
	[0x2AAD] = { unicodeslot=0x2AAD, category='sm', description='LARGER THAN OR EQUAL TO' },
	[0x2AAE] = { unicodeslot=0x2AAE, category='sm', description='EQUALS SIGN WITH BUMPY ABOVE' },
	[0x2AAF] = { unicodeslot=0x2AAF, category='sm', description='PRECEDES ABOVE SINGLE-LINE EQUALS SIGN' },
	[0x2AB0] = { unicodeslot=0x2AB0, category='sm', description='SUCCEEDS ABOVE SINGLE-LINE EQUALS SIGN' },
	[0x2AB1] = { unicodeslot=0x2AB1, category='sm', description='PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO' },
	[0x2AB2] = { unicodeslot=0x2AB2, category='sm', description='SUCCEEDS ABOVE SINGLE-LINE NOT EQUAL TO' },
	[0x2AB3] = { unicodeslot=0x2AB3, category='sm', description='PRECEDES ABOVE EQUALS SIGN' },
	[0x2AB4] = { unicodeslot=0x2AB4, category='sm', description='SUCCEEDS ABOVE EQUALS SIGN' },
	[0x2AB5] = { unicodeslot=0x2AB5, category='sm', description='PRECEDES ABOVE NOT EQUAL TO' },
	[0x2AB6] = { unicodeslot=0x2AB6, category='sm', description='SUCCEEDS ABOVE NOT EQUAL TO' },
	[0x2AB7] = { unicodeslot=0x2AB7, category='sm', description='PRECEDES ABOVE ALMOST EQUAL TO' },
	[0x2AB8] = { unicodeslot=0x2AB8, category='sm', description='SUCCEEDS ABOVE ALMOST EQUAL TO' },
	[0x2AB9] = { unicodeslot=0x2AB9, category='sm', description='PRECEDES ABOVE NOT ALMOST EQUAL TO' },
	[0x2ABA] = { unicodeslot=0x2ABA, category='sm', description='SUCCEEDS ABOVE NOT ALMOST EQUAL TO' },
	[0x2ABB] = { unicodeslot=0x2ABB, category='sm', description='DOUBLE PRECEDES' },
	[0x2ABC] = { unicodeslot=0x2ABC, category='sm', description='DOUBLE SUCCEEDS' },
	[0x2ABD] = { unicodeslot=0x2ABD, category='sm', description='SUBSET WITH DOT' },
	[0x2ABE] = { unicodeslot=0x2ABE, category='sm', description='SUPERSET WITH DOT' },
	[0x2ABF] = { unicodeslot=0x2ABF, category='sm', description='SUBSET WITH PLUS SIGN BELOW' },
	[0x2AC0] = { unicodeslot=0x2AC0, category='sm', description='SUPERSET WITH PLUS SIGN BELOW' },
	[0x2AC1] = { unicodeslot=0x2AC1, category='sm', description='SUBSET WITH MULTIPLICATION SIGN BELOW' },
	[0x2AC2] = { unicodeslot=0x2AC2, category='sm', description='SUPERSET WITH MULTIPLICATION SIGN BELOW' },
	[0x2AC3] = { unicodeslot=0x2AC3, category='sm', description='SUBSET OF OR EQUAL TO WITH DOT ABOVE' },
	[0x2AC4] = { unicodeslot=0x2AC4, category='sm', description='SUPERSET OF OR EQUAL TO WITH DOT ABOVE' },
	[0x2AC5] = { unicodeslot=0x2AC5, category='sm', description='SUBSET OF ABOVE EQUALS SIGN' },
	[0x2AC6] = { unicodeslot=0x2AC6, category='sm', description='SUPERSET OF ABOVE EQUALS SIGN' },
	[0x2AC7] = { unicodeslot=0x2AC7, category='sm', description='SUBSET OF ABOVE TILDE OPERATOR' },
	[0x2AC8] = { unicodeslot=0x2AC8, category='sm', description='SUPERSET OF ABOVE TILDE OPERATOR' },
	[0x2AC9] = { unicodeslot=0x2AC9, category='sm', description='SUBSET OF ABOVE ALMOST EQUAL TO' },
	[0x2ACA] = { unicodeslot=0x2ACA, category='sm', description='SUPERSET OF ABOVE ALMOST EQUAL TO' },
	[0x2ACB] = { unicodeslot=0x2ACB, category='sm', description='SUBSET OF ABOVE NOT EQUAL TO' },
	[0x2ACC] = { unicodeslot=0x2ACC, category='sm', description='SUPERSET OF ABOVE NOT EQUAL TO' },
	[0x2ACD] = { unicodeslot=0x2ACD, category='sm', description='SQUARE LEFT OPEN BOX OPERATOR' },
	[0x2ACE] = { unicodeslot=0x2ACE, category='sm', description='SQUARE RIGHT OPEN BOX OPERATOR' },
	[0x2ACF] = { unicodeslot=0x2ACF, category='sm', description='CLOSED SUBSET' },
	[0x2AD0] = { unicodeslot=0x2AD0, category='sm', description='CLOSED SUPERSET' },
	[0x2AD1] = { unicodeslot=0x2AD1, category='sm', description='CLOSED SUBSET OR EQUAL TO' },
	[0x2AD2] = { unicodeslot=0x2AD2, category='sm', description='CLOSED SUPERSET OR EQUAL TO' },
	[0x2AD3] = { unicodeslot=0x2AD3, category='sm', description='SUBSET ABOVE SUPERSET' },
	[0x2AD4] = { unicodeslot=0x2AD4, category='sm', description='SUPERSET ABOVE SUBSET' },
	[0x2AD5] = { unicodeslot=0x2AD5, category='sm', description='SUBSET ABOVE SUBSET' },
	[0x2AD6] = { unicodeslot=0x2AD6, category='sm', description='SUPERSET ABOVE SUPERSET' },
	[0x2AD7] = { unicodeslot=0x2AD7, category='sm', description='SUPERSET BESIDE SUBSET' },
	[0x2AD8] = { unicodeslot=0x2AD8, category='sm', description='SUPERSET BESIDE AND JOINED BY DASH WITH SUBSET' },
	[0x2AD9] = { unicodeslot=0x2AD9, category='sm', description='ELEMENT OF OPENING DOWNWARDS' },
	[0x2ADA] = { unicodeslot=0x2ADA, category='sm', description='PITCHFORK WITH TEE TOP' },
	[0x2ADB] = { unicodeslot=0x2ADB, category='sm', description='TRANSVERSAL INTERSECTION' },
	[0x2ADC] = { unicodeslot=0x2ADC, category='sm', description='FORKING', specials={'char',0x2ADD,0x0338} },
	[0x2ADD] = { unicodeslot=0x2ADD, category='sm', description='NONFORKING' },
	[0x2ADE] = { unicodeslot=0x2ADE, category='sm', description='SHORT LEFT TACK' },
	[0x2ADF] = { unicodeslot=0x2ADF, category='sm', description='SHORT DOWN TACK' },
	[0x2AE0] = { unicodeslot=0x2AE0, category='sm', description='SHORT UP TACK' },
	[0x2AE1] = { unicodeslot=0x2AE1, category='sm', description='PERPENDICULAR WITH S' },
	[0x2AE2] = { unicodeslot=0x2AE2, category='sm', description='VERTICAL BAR TRIPLE RIGHT TURNSTILE' },
	[0x2AE3] = { unicodeslot=0x2AE3, category='sm', description='DOUBLE VERTICAL BAR LEFT TURNSTILE' },
	[0x2AE4] = { unicodeslot=0x2AE4, category='sm', description='VERTICAL BAR DOUBLE LEFT TURNSTILE' },
	[0x2AE5] = { unicodeslot=0x2AE5, category='sm', description='DOUBLE VERTICAL BAR DOUBLE LEFT TURNSTILE' },
	[0x2AE6] = { unicodeslot=0x2AE6, category='sm', description='LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL' },
	[0x2AE7] = { unicodeslot=0x2AE7, category='sm', description='SHORT DOWN TACK WITH OVERBAR' },
	[0x2AE8] = { unicodeslot=0x2AE8, category='sm', description='SHORT UP TACK WITH UNDERBAR' },
	[0x2AE9] = { unicodeslot=0x2AE9, category='sm', description='SHORT UP TACK ABOVE SHORT DOWN TACK' },
	[0x2AEA] = { unicodeslot=0x2AEA, category='sm', description='DOUBLE DOWN TACK' },
	[0x2AEB] = { unicodeslot=0x2AEB, category='sm', description='DOUBLE UP TACK' },
	[0x2AEC] = { unicodeslot=0x2AEC, category='sm', description='DOUBLE STROKE NOT SIGN' },
	[0x2AED] = { unicodeslot=0x2AED, category='sm', description='REVERSED DOUBLE STROKE NOT SIGN' },
	[0x2AEE] = { unicodeslot=0x2AEE, category='sm', description='DOES NOT DIVIDE WITH REVERSED NEGATION SLASH' },
	[0x2AEF] = { unicodeslot=0x2AEF, category='sm', description='VERTICAL LINE WITH CIRCLE ABOVE' },
	[0x2AF0] = { unicodeslot=0x2AF0, category='sm', description='VERTICAL LINE WITH CIRCLE BELOW' },
	[0x2AF1] = { unicodeslot=0x2AF1, category='sm', description='DOWN TACK WITH CIRCLE BELOW' },
	[0x2AF2] = { unicodeslot=0x2AF2, category='sm', description='PARALLEL WITH HORIZONTAL STROKE' },
	[0x2AF3] = { unicodeslot=0x2AF3, category='sm', description='PARALLEL WITH TILDE OPERATOR' },
	[0x2AF4] = { unicodeslot=0x2AF4, category='sm', description='TRIPLE VERTICAL BAR BINARY RELATION' },
	[0x2AF5] = { unicodeslot=0x2AF5, category='sm', description='TRIPLE VERTICAL BAR WITH HORIZONTAL STROKE' },
	[0x2AF6] = { unicodeslot=0x2AF6, category='sm', description='TRIPLE COLON OPERATOR' },
	[0x2AF7] = { unicodeslot=0x2AF7, category='sm', description='TRIPLE NESTED LESS-THAN' },
	[0x2AF8] = { unicodeslot=0x2AF8, category='sm', description='TRIPLE NESTED GREATER-THAN' },
	[0x2AF9] = { unicodeslot=0x2AF9, category='sm', description='DOUBLE-LINE SLANTED LESS-THAN OR EQUAL TO' },
	[0x2AFA] = { unicodeslot=0x2AFA, category='sm', description='DOUBLE-LINE SLANTED GREATER-THAN OR EQUAL TO' },
	[0x2AFB] = { unicodeslot=0x2AFB, category='sm', description='TRIPLE SOLIDUS BINARY RELATION' },
	[0x2AFC] = { unicodeslot=0x2AFC, category='sm', description='LARGE TRIPLE VERTICAL BAR OPERATOR' },
	[0x2AFD] = { unicodeslot=0x2AFD, category='sm', description='DOUBLE SOLIDUS OPERATOR' },
	[0x2AFE] = { unicodeslot=0x2AFE, category='sm', description='WHITE VERTICAL BAR' },
	[0x2AFF] = { unicodeslot=0x2AFF, category='sm', description='N-ARY WHITE VERTICAL BAR' },
	[0x2B00] = { unicodeslot=0x2B00, category='so', description='NORTH EAST WHITE ARROW' },
	[0x2B01] = { unicodeslot=0x2B01, category='so', description='NORTH WEST WHITE ARROW' },
	[0x2B02] = { unicodeslot=0x2B02, category='so', description='SOUTH EAST WHITE ARROW' },
	[0x2B03] = { unicodeslot=0x2B03, category='so', description='SOUTH WEST WHITE ARROW' },
	[0x2B04] = { unicodeslot=0x2B04, category='so', description='LEFT RIGHT WHITE ARROW' },
	[0x2B05] = { unicodeslot=0x2B05, category='so', description='LEFTWARDS BLACK ARROW' },
	[0x2B06] = { unicodeslot=0x2B06, category='so', description='UPWARDS BLACK ARROW' },
	[0x2B07] = { unicodeslot=0x2B07, category='so', description='DOWNWARDS BLACK ARROW' },
	[0x2B08] = { unicodeslot=0x2B08, category='so', description='NORTH EAST BLACK ARROW' },
	[0x2B09] = { unicodeslot=0x2B09, category='so', description='NORTH WEST BLACK ARROW' },
	[0x2B0A] = { unicodeslot=0x2B0A, category='so', description='SOUTH EAST BLACK ARROW' },
	[0x2B0B] = { unicodeslot=0x2B0B, category='so', description='SOUTH WEST BLACK ARROW' },
	[0x2B0C] = { unicodeslot=0x2B0C, category='so', description='LEFT RIGHT BLACK ARROW' },
	[0x2B0D] = { unicodeslot=0x2B0D, category='so', description='UP DOWN BLACK ARROW' },
	[0x2B0E] = { unicodeslot=0x2B0E, category='so', description='RIGHTWARDS ARROW WITH TIP DOWNWARDS' },
	[0x2B0F] = { unicodeslot=0x2B0F, category='so', description='RIGHTWARDS ARROW WITH TIP UPWARDS' },
	[0x2B10] = { unicodeslot=0x2B10, category='so', description='LEFTWARDS ARROW WITH TIP DOWNWARDS' },
	[0x2B11] = { unicodeslot=0x2B11, category='so', description='LEFTWARDS ARROW WITH TIP UPWARDS' },
	[0x2B12] = { unicodeslot=0x2B12, category='so', description='SQUARE WITH TOP HALF BLACK' },
	[0x2B13] = { unicodeslot=0x2B13, category='so', description='SQUARE WITH BOTTOM HALF BLACK' },
	[0x2B14] = { unicodeslot=0x2B14, category='so', description='SQUARE WITH UPPER RIGHT DIAGONAL HALF BLACK' },
	[0x2B15] = { unicodeslot=0x2B15, category='so', description='SQUARE WITH LOWER LEFT DIAGONAL HALF BLACK' },
	[0x2B16] = { unicodeslot=0x2B16, category='so', description='DIAMOND WITH LEFT HALF BLACK' },
	[0x2B17] = { unicodeslot=0x2B17, category='so', description='DIAMOND WITH RIGHT HALF BLACK' },
	[0x2B18] = { unicodeslot=0x2B18, category='so', description='DIAMOND WITH TOP HALF BLACK' },
	[0x2B19] = { unicodeslot=0x2B19, category='so', description='DIAMOND WITH BOTTOM HALF BLACK' },
	[0x2B1A] = { unicodeslot=0x2B1A, category='so', description='DOTTED SQUARE' },
	[0x2B20] = { unicodeslot=0x2B20, category='so', description='WHITE PENTAGON' },
	[0x2B21] = { unicodeslot=0x2B21, category='so', description='WHITE HEXAGON' },
	[0x2B22] = { unicodeslot=0x2B22, category='so', description='BLACK HEXAGON' },
	[0x2B23] = { unicodeslot=0x2B23, category='so', description='HORIZONTAL BLACK HEXAGON' },
	[0x2C00] = { unicodeslot=0x2C00, category='lu', description='GLAGOLITIC CAPITAL LETTER AZU', lccode=0x2C30 },
	[0x2C01] = { unicodeslot=0x2C01, category='lu', description='GLAGOLITIC CAPITAL LETTER BUKY', lccode=0x2C31 },
	[0x2C02] = { unicodeslot=0x2C02, category='lu', description='GLAGOLITIC CAPITAL LETTER VEDE', lccode=0x2C32 },
	[0x2C03] = { unicodeslot=0x2C03, category='lu', description='GLAGOLITIC CAPITAL LETTER GLAGOLI', lccode=0x2C33 },
	[0x2C04] = { unicodeslot=0x2C04, category='lu', description='GLAGOLITIC CAPITAL LETTER DOBRO', lccode=0x2C34 },
	[0x2C05] = { unicodeslot=0x2C05, category='lu', description='GLAGOLITIC CAPITAL LETTER YESTU', lccode=0x2C35 },
	[0x2C06] = { unicodeslot=0x2C06, category='lu', description='GLAGOLITIC CAPITAL LETTER ZHIVETE', lccode=0x2C36 },
	[0x2C07] = { unicodeslot=0x2C07, category='lu', description='GLAGOLITIC CAPITAL LETTER DZELO', lccode=0x2C37 },
	[0x2C08] = { unicodeslot=0x2C08, category='lu', description='GLAGOLITIC CAPITAL LETTER ZEMLJA', lccode=0x2C38 },
	[0x2C09] = { unicodeslot=0x2C09, category='lu', description='GLAGOLITIC CAPITAL LETTER IZHE', lccode=0x2C39 },
	[0x2C0A] = { unicodeslot=0x2C0A, category='lu', description='GLAGOLITIC CAPITAL LETTER INITIAL IZHE', lccode=0x2C3A },
	[0x2C0B] = { unicodeslot=0x2C0B, category='lu', description='GLAGOLITIC CAPITAL LETTER I', lccode=0x2C3B },
	[0x2C0C] = { unicodeslot=0x2C0C, category='lu', description='GLAGOLITIC CAPITAL LETTER DJERVI', lccode=0x2C3C },
	[0x2C0D] = { unicodeslot=0x2C0D, category='lu', description='GLAGOLITIC CAPITAL LETTER KAKO', lccode=0x2C3D },
	[0x2C0E] = { unicodeslot=0x2C0E, category='lu', description='GLAGOLITIC CAPITAL LETTER LJUDIJE', lccode=0x2C3E },
	[0x2C0F] = { unicodeslot=0x2C0F, category='lu', description='GLAGOLITIC CAPITAL LETTER MYSLITE', lccode=0x2C3F },
	[0x2C10] = { unicodeslot=0x2C10, category='lu', description='GLAGOLITIC CAPITAL LETTER NASHI', lccode=0x2C40 },
	[0x2C11] = { unicodeslot=0x2C11, category='lu', description='GLAGOLITIC CAPITAL LETTER ONU', lccode=0x2C41 },
	[0x2C12] = { unicodeslot=0x2C12, category='lu', description='GLAGOLITIC CAPITAL LETTER POKOJI', lccode=0x2C42 },
	[0x2C13] = { unicodeslot=0x2C13, category='lu', description='GLAGOLITIC CAPITAL LETTER RITSI', lccode=0x2C43 },
	[0x2C14] = { unicodeslot=0x2C14, category='lu', description='GLAGOLITIC CAPITAL LETTER SLOVO', lccode=0x2C44 },
	[0x2C15] = { unicodeslot=0x2C15, category='lu', description='GLAGOLITIC CAPITAL LETTER TVRIDO', lccode=0x2C45 },
	[0x2C16] = { unicodeslot=0x2C16, category='lu', description='GLAGOLITIC CAPITAL LETTER UKU', lccode=0x2C46 },
	[0x2C17] = { unicodeslot=0x2C17, category='lu', description='GLAGOLITIC CAPITAL LETTER FRITU', lccode=0x2C47 },
	[0x2C18] = { unicodeslot=0x2C18, category='lu', description='GLAGOLITIC CAPITAL LETTER HERU', lccode=0x2C48 },
	[0x2C19] = { unicodeslot=0x2C19, category='lu', description='GLAGOLITIC CAPITAL LETTER OTU', lccode=0x2C49 },
	[0x2C1A] = { unicodeslot=0x2C1A, category='lu', description='GLAGOLITIC CAPITAL LETTER PE', lccode=0x2C4A },
	[0x2C1B] = { unicodeslot=0x2C1B, category='lu', description='GLAGOLITIC CAPITAL LETTER SHTA', lccode=0x2C4B },
	[0x2C1C] = { unicodeslot=0x2C1C, category='lu', description='GLAGOLITIC CAPITAL LETTER TSI', lccode=0x2C4C },
	[0x2C1D] = { unicodeslot=0x2C1D, category='lu', description='GLAGOLITIC CAPITAL LETTER CHRIVI', lccode=0x2C4D },
	[0x2C1E] = { unicodeslot=0x2C1E, category='lu', description='GLAGOLITIC CAPITAL LETTER SHA', lccode=0x2C4E },
	[0x2C1F] = { unicodeslot=0x2C1F, category='lu', description='GLAGOLITIC CAPITAL LETTER YERU', lccode=0x2C4F },
	[0x2C20] = { unicodeslot=0x2C20, category='lu', description='GLAGOLITIC CAPITAL LETTER YERI', lccode=0x2C50 },
	[0x2C21] = { unicodeslot=0x2C21, category='lu', description='GLAGOLITIC CAPITAL LETTER YATI', lccode=0x2C51 },
	[0x2C22] = { unicodeslot=0x2C22, category='lu', description='GLAGOLITIC CAPITAL LETTER SPIDERY HA', lccode=0x2C52 },
	[0x2C23] = { unicodeslot=0x2C23, category='lu', description='GLAGOLITIC CAPITAL LETTER YU', lccode=0x2C53 },
	[0x2C24] = { unicodeslot=0x2C24, category='lu', description='GLAGOLITIC CAPITAL LETTER SMALL YUS', lccode=0x2C54 },
	[0x2C25] = { unicodeslot=0x2C25, category='lu', description='GLAGOLITIC CAPITAL LETTER SMALL YUS WITH TAIL', lccode=0x2C55 },
	[0x2C26] = { unicodeslot=0x2C26, category='lu', description='GLAGOLITIC CAPITAL LETTER YO', lccode=0x2C56 },
	[0x2C27] = { unicodeslot=0x2C27, category='lu', description='GLAGOLITIC CAPITAL LETTER IOTATED SMALL YUS', lccode=0x2C57 },
	[0x2C28] = { unicodeslot=0x2C28, category='lu', description='GLAGOLITIC CAPITAL LETTER BIG YUS', lccode=0x2C58 },
	[0x2C29] = { unicodeslot=0x2C29, category='lu', description='GLAGOLITIC CAPITAL LETTER IOTATED BIG YUS', lccode=0x2C59 },
	[0x2C2A] = { unicodeslot=0x2C2A, category='lu', description='GLAGOLITIC CAPITAL LETTER FITA', lccode=0x2C5A },
	[0x2C2B] = { unicodeslot=0x2C2B, category='lu', description='GLAGOLITIC CAPITAL LETTER IZHITSA', lccode=0x2C5B },
	[0x2C2C] = { unicodeslot=0x2C2C, category='lu', description='GLAGOLITIC CAPITAL LETTER SHTAPIC', lccode=0x2C5C },
	[0x2C2D] = { unicodeslot=0x2C2D, category='lu', description='GLAGOLITIC CAPITAL LETTER TROKUTASTI A', lccode=0x2C5D },
	[0x2C2E] = { unicodeslot=0x2C2E, category='lu', description='GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE', lccode=0x2C5E },
	[0x2C30] = { unicodeslot=0x2C30, category='ll', description='GLAGOLITIC SMALL LETTER AZU', uccode=0x2C00 },
	[0x2C31] = { unicodeslot=0x2C31, category='ll', description='GLAGOLITIC SMALL LETTER BUKY', uccode=0x2C01 },
	[0x2C32] = { unicodeslot=0x2C32, category='ll', description='GLAGOLITIC SMALL LETTER VEDE', uccode=0x2C02 },
	[0x2C33] = { unicodeslot=0x2C33, category='ll', description='GLAGOLITIC SMALL LETTER GLAGOLI', uccode=0x2C03 },
	[0x2C34] = { unicodeslot=0x2C34, category='ll', description='GLAGOLITIC SMALL LETTER DOBRO', uccode=0x2C04 },
	[0x2C35] = { unicodeslot=0x2C35, category='ll', description='GLAGOLITIC SMALL LETTER YESTU', uccode=0x2C05 },
	[0x2C36] = { unicodeslot=0x2C36, category='ll', description='GLAGOLITIC SMALL LETTER ZHIVETE', uccode=0x2C06 },
	[0x2C37] = { unicodeslot=0x2C37, category='ll', description='GLAGOLITIC SMALL LETTER DZELO', uccode=0x2C07 },
	[0x2C38] = { unicodeslot=0x2C38, category='ll', description='GLAGOLITIC SMALL LETTER ZEMLJA', uccode=0x2C08 },
	[0x2C39] = { unicodeslot=0x2C39, category='ll', description='GLAGOLITIC SMALL LETTER IZHE', uccode=0x2C09 },
	[0x2C3A] = { unicodeslot=0x2C3A, category='ll', description='GLAGOLITIC SMALL LETTER INITIAL IZHE', uccode=0x2C0A },
	[0x2C3B] = { unicodeslot=0x2C3B, category='ll', description='GLAGOLITIC SMALL LETTER I', uccode=0x2C0B },
	[0x2C3C] = { unicodeslot=0x2C3C, category='ll', description='GLAGOLITIC SMALL LETTER DJERVI', uccode=0x2C0C },
	[0x2C3D] = { unicodeslot=0x2C3D, category='ll', description='GLAGOLITIC SMALL LETTER KAKO', uccode=0x2C0D },
	[0x2C3E] = { unicodeslot=0x2C3E, category='ll', description='GLAGOLITIC SMALL LETTER LJUDIJE', uccode=0x2C0E },
	[0x2C3F] = { unicodeslot=0x2C3F, category='ll', description='GLAGOLITIC SMALL LETTER MYSLITE', uccode=0x2C0F },
	[0x2C40] = { unicodeslot=0x2C40, category='ll', description='GLAGOLITIC SMALL LETTER NASHI', uccode=0x2C10 },
	[0x2C41] = { unicodeslot=0x2C41, category='ll', description='GLAGOLITIC SMALL LETTER ONU', uccode=0x2C11 },
	[0x2C42] = { unicodeslot=0x2C42, category='ll', description='GLAGOLITIC SMALL LETTER POKOJI', uccode=0x2C12 },
	[0x2C43] = { unicodeslot=0x2C43, category='ll', description='GLAGOLITIC SMALL LETTER RITSI', uccode=0x2C13 },
	[0x2C44] = { unicodeslot=0x2C44, category='ll', description='GLAGOLITIC SMALL LETTER SLOVO', uccode=0x2C14 },
	[0x2C45] = { unicodeslot=0x2C45, category='ll', description='GLAGOLITIC SMALL LETTER TVRIDO', uccode=0x2C15 },
	[0x2C46] = { unicodeslot=0x2C46, category='ll', description='GLAGOLITIC SMALL LETTER UKU', uccode=0x2C16 },
	[0x2C47] = { unicodeslot=0x2C47, category='ll', description='GLAGOLITIC SMALL LETTER FRITU', uccode=0x2C17 },
	[0x2C48] = { unicodeslot=0x2C48, category='ll', description='GLAGOLITIC SMALL LETTER HERU', uccode=0x2C18 },
	[0x2C49] = { unicodeslot=0x2C49, category='ll', description='GLAGOLITIC SMALL LETTER OTU', uccode=0x2C19 },
	[0x2C4A] = { unicodeslot=0x2C4A, category='ll', description='GLAGOLITIC SMALL LETTER PE', uccode=0x2C1A },
	[0x2C4B] = { unicodeslot=0x2C4B, category='ll', description='GLAGOLITIC SMALL LETTER SHTA', uccode=0x2C1B },
	[0x2C4C] = { unicodeslot=0x2C4C, category='ll', description='GLAGOLITIC SMALL LETTER TSI', uccode=0x2C1C },
	[0x2C4D] = { unicodeslot=0x2C4D, category='ll', description='GLAGOLITIC SMALL LETTER CHRIVI', uccode=0x2C1D },
	[0x2C4E] = { unicodeslot=0x2C4E, category='ll', description='GLAGOLITIC SMALL LETTER SHA', uccode=0x2C1E },
	[0x2C4F] = { unicodeslot=0x2C4F, category='ll', description='GLAGOLITIC SMALL LETTER YERU', uccode=0x2C1F },
	[0x2C50] = { unicodeslot=0x2C50, category='ll', description='GLAGOLITIC SMALL LETTER YERI', uccode=0x2C20 },
	[0x2C51] = { unicodeslot=0x2C51, category='ll', description='GLAGOLITIC SMALL LETTER YATI', uccode=0x2C21 },
	[0x2C52] = { unicodeslot=0x2C52, category='ll', description='GLAGOLITIC SMALL LETTER SPIDERY HA', uccode=0x2C22 },
	[0x2C53] = { unicodeslot=0x2C53, category='ll', description='GLAGOLITIC SMALL LETTER YU', uccode=0x2C23 },
	[0x2C54] = { unicodeslot=0x2C54, category='ll', description='GLAGOLITIC SMALL LETTER SMALL YUS', uccode=0x2C24 },
	[0x2C55] = { unicodeslot=0x2C55, category='ll', description='GLAGOLITIC SMALL LETTER SMALL YUS WITH TAIL', uccode=0x2C25 },
	[0x2C56] = { unicodeslot=0x2C56, category='ll', description='GLAGOLITIC SMALL LETTER YO', uccode=0x2C26 },
	[0x2C57] = { unicodeslot=0x2C57, category='ll', description='GLAGOLITIC SMALL LETTER IOTATED SMALL YUS', uccode=0x2C27 },
	[0x2C58] = { unicodeslot=0x2C58, category='ll', description='GLAGOLITIC SMALL LETTER BIG YUS', uccode=0x2C28 },
	[0x2C59] = { unicodeslot=0x2C59, category='ll', description='GLAGOLITIC SMALL LETTER IOTATED BIG YUS', uccode=0x2C29 },
	[0x2C5A] = { unicodeslot=0x2C5A, category='ll', description='GLAGOLITIC SMALL LETTER FITA', uccode=0x2C2A },
	[0x2C5B] = { unicodeslot=0x2C5B, category='ll', description='GLAGOLITIC SMALL LETTER IZHITSA', uccode=0x2C2B },
	[0x2C5C] = { unicodeslot=0x2C5C, category='ll', description='GLAGOLITIC SMALL LETTER SHTAPIC', uccode=0x2C2C },
	[0x2C5D] = { unicodeslot=0x2C5D, category='ll', description='GLAGOLITIC SMALL LETTER TROKUTASTI A', uccode=0x2C2D },
	[0x2C5E] = { unicodeslot=0x2C5E, category='ll', description='GLAGOLITIC SMALL LETTER LATINATE MYSLITE', uccode=0x2C2E },
	[0x2C60] = { unicodeslot=0x2C60, category='lu', description='LATIN CAPITAL LETTER L WITH DOUBLE BAR', shcode=0x004C, lccode=0x2C61 },
	[0x2C61] = { unicodeslot=0x2C61, category='ll', description='LATIN SMALL LETTER L WITH DOUBLE BAR', shcode=0x006C, uccode=0x2C60 },
	[0x2C62] = { unicodeslot=0x2C62, category='lu', description='LATIN CAPITAL LETTER L WITH MIDDLE TILDE', shcode=0x004C, lccode=0x026B },
	[0x2C63] = { unicodeslot=0x2C63, category='lu', description='LATIN CAPITAL LETTER P WITH STROKE', shcode=0x0050, lccode=0x1D7D },
	[0x2C64] = { unicodeslot=0x2C64, category='lu', description='LATIN CAPITAL LETTER R WITH TAIL', shcode=0x0052, lccode=0x027D },
	[0x2C65] = { unicodeslot=0x2C65, category='ll', description='LATIN SMALL LETTER A WITH STROKE', shcode=0x0061, uccode=0x023A },
	[0x2C66] = { unicodeslot=0x2C66, category='ll', description='LATIN SMALL LETTER T WITH DIAGONAL STROKE', shcode=0x0074, uccode=0x023E },
	[0x2C67] = { unicodeslot=0x2C67, category='lu', description='LATIN CAPITAL LETTER H WITH DESCENDER', shcode=0x0048, lccode=0x2C68 },
	[0x2C68] = { unicodeslot=0x2C68, category='ll', description='LATIN SMALL LETTER H WITH DESCENDER', shcode=0x0068, uccode=0x2C67 },
	[0x2C69] = { unicodeslot=0x2C69, category='lu', description='LATIN CAPITAL LETTER K WITH DESCENDER', shcode=0x004B, lccode=0x2C6A },
	[0x2C6A] = { unicodeslot=0x2C6A, category='ll', description='LATIN SMALL LETTER K WITH DESCENDER', shcode=0x006B, uccode=0x2C69 },
	[0x2C6B] = { unicodeslot=0x2C6B, category='lu', description='LATIN CAPITAL LETTER Z WITH DESCENDER', shcode=0x005A, lccode=0x2C6C },
	[0x2C6C] = { unicodeslot=0x2C6C, category='ll', description='LATIN SMALL LETTER Z WITH DESCENDER', shcode=0x007A, uccode=0x2C6B },
	[0x2C74] = { unicodeslot=0x2C74, category='ll', description='LATIN SMALL LETTER V WITH CURL', shcode=0x0076 },
	[0x2C75] = { unicodeslot=0x2C75, category='lu', description='LATIN CAPITAL LETTER HALF H', lccode=0x2C76 },
	[0x2C76] = { unicodeslot=0x2C76, category='ll', description='LATIN SMALL LETTER HALF H', uccode=0x2C75 },
	[0x2C77] = { unicodeslot=0x2C77, category='ll', description='LATIN SMALL LETTER TAILLESS PHI' },
	[0x2C80] = { unicodeslot=0x2C80, category='lu', description='COPTIC CAPITAL LETTER ALFA', lccode=0x2C81 },
	[0x2C81] = { unicodeslot=0x2C81, category='ll', description='COPTIC SMALL LETTER ALFA', uccode=0x2C80 },
	[0x2C82] = { unicodeslot=0x2C82, category='lu', description='COPTIC CAPITAL LETTER VIDA', lccode=0x2C83 },
	[0x2C83] = { unicodeslot=0x2C83, category='ll', description='COPTIC SMALL LETTER VIDA', uccode=0x2C82 },
	[0x2C84] = { unicodeslot=0x2C84, category='lu', description='COPTIC CAPITAL LETTER GAMMA', lccode=0x2C85 },
	[0x2C85] = { unicodeslot=0x2C85, category='ll', description='COPTIC SMALL LETTER GAMMA', uccode=0x2C84 },
	[0x2C86] = { unicodeslot=0x2C86, category='lu', description='COPTIC CAPITAL LETTER DALDA', lccode=0x2C87 },
	[0x2C87] = { unicodeslot=0x2C87, category='ll', description='COPTIC SMALL LETTER DALDA', uccode=0x2C86 },
	[0x2C88] = { unicodeslot=0x2C88, category='lu', description='COPTIC CAPITAL LETTER EIE', lccode=0x2C89 },
	[0x2C89] = { unicodeslot=0x2C89, category='ll', description='COPTIC SMALL LETTER EIE', uccode=0x2C88 },
	[0x2C8A] = { unicodeslot=0x2C8A, category='lu', description='COPTIC CAPITAL LETTER SOU', lccode=0x2C8B },
	[0x2C8B] = { unicodeslot=0x2C8B, category='ll', description='COPTIC SMALL LETTER SOU', uccode=0x2C8A },
	[0x2C8C] = { unicodeslot=0x2C8C, category='lu', description='COPTIC CAPITAL LETTER ZATA', lccode=0x2C8D },
	[0x2C8D] = { unicodeslot=0x2C8D, category='ll', description='COPTIC SMALL LETTER ZATA', uccode=0x2C8C },
	[0x2C8E] = { unicodeslot=0x2C8E, category='lu', description='COPTIC CAPITAL LETTER HATE', lccode=0x2C8F },
	[0x2C8F] = { unicodeslot=0x2C8F, category='ll', description='COPTIC SMALL LETTER HATE', uccode=0x2C8E },
	[0x2C90] = { unicodeslot=0x2C90, category='lu', description='COPTIC CAPITAL LETTER THETHE', lccode=0x2C91 },
	[0x2C91] = { unicodeslot=0x2C91, category='ll', description='COPTIC SMALL LETTER THETHE', uccode=0x2C90 },
	[0x2C92] = { unicodeslot=0x2C92, category='lu', description='COPTIC CAPITAL LETTER IAUDA', lccode=0x2C93 },
	[0x2C93] = { unicodeslot=0x2C93, category='ll', description='COPTIC SMALL LETTER IAUDA', uccode=0x2C92 },
	[0x2C94] = { unicodeslot=0x2C94, category='lu', description='COPTIC CAPITAL LETTER KAPA', lccode=0x2C95 },
	[0x2C95] = { unicodeslot=0x2C95, category='ll', description='COPTIC SMALL LETTER KAPA', uccode=0x2C94 },
	[0x2C96] = { unicodeslot=0x2C96, category='lu', description='COPTIC CAPITAL LETTER LAULA', lccode=0x2C97 },
	[0x2C97] = { unicodeslot=0x2C97, category='ll', description='COPTIC SMALL LETTER LAULA', uccode=0x2C96 },
	[0x2C98] = { unicodeslot=0x2C98, category='lu', description='COPTIC CAPITAL LETTER MI', lccode=0x2C99 },
	[0x2C99] = { unicodeslot=0x2C99, category='ll', description='COPTIC SMALL LETTER MI', uccode=0x2C98 },
	[0x2C9A] = { unicodeslot=0x2C9A, category='lu', description='COPTIC CAPITAL LETTER NI', lccode=0x2C9B },
	[0x2C9B] = { unicodeslot=0x2C9B, category='ll', description='COPTIC SMALL LETTER NI', uccode=0x2C9A },
	[0x2C9C] = { unicodeslot=0x2C9C, category='lu', description='COPTIC CAPITAL LETTER KSI', lccode=0x2C9D },
	[0x2C9D] = { unicodeslot=0x2C9D, category='ll', description='COPTIC SMALL LETTER KSI', uccode=0x2C9C },
	[0x2C9E] = { unicodeslot=0x2C9E, category='lu', description='COPTIC CAPITAL LETTER O', lccode=0x2C9F },
	[0x2C9F] = { unicodeslot=0x2C9F, category='ll', description='COPTIC SMALL LETTER O', uccode=0x2C9E },
	[0x2CA0] = { unicodeslot=0x2CA0, category='lu', description='COPTIC CAPITAL LETTER PI', lccode=0x2CA1 },
	[0x2CA1] = { unicodeslot=0x2CA1, category='ll', description='COPTIC SMALL LETTER PI', uccode=0x2CA0 },
	[0x2CA2] = { unicodeslot=0x2CA2, category='lu', description='COPTIC CAPITAL LETTER RO', lccode=0x2CA3 },
	[0x2CA3] = { unicodeslot=0x2CA3, category='ll', description='COPTIC SMALL LETTER RO', uccode=0x2CA2 },
	[0x2CA4] = { unicodeslot=0x2CA4, category='lu', description='COPTIC CAPITAL LETTER SIMA', lccode=0x2CA5 },
	[0x2CA5] = { unicodeslot=0x2CA5, category='ll', description='COPTIC SMALL LETTER SIMA', uccode=0x2CA4 },
	[0x2CA6] = { unicodeslot=0x2CA6, category='lu', description='COPTIC CAPITAL LETTER TAU', lccode=0x2CA7 },
	[0x2CA7] = { unicodeslot=0x2CA7, category='ll', description='COPTIC SMALL LETTER TAU', uccode=0x2CA6 },
	[0x2CA8] = { unicodeslot=0x2CA8, category='lu', description='COPTIC CAPITAL LETTER UA', lccode=0x2CA9 },
	[0x2CA9] = { unicodeslot=0x2CA9, category='ll', description='COPTIC SMALL LETTER UA', uccode=0x2CA8 },
	[0x2CAA] = { unicodeslot=0x2CAA, category='lu', description='COPTIC CAPITAL LETTER FI', lccode=0x2CAB },
	[0x2CAB] = { unicodeslot=0x2CAB, category='ll', description='COPTIC SMALL LETTER FI', uccode=0x2CAA },
	[0x2CAC] = { unicodeslot=0x2CAC, category='lu', description='COPTIC CAPITAL LETTER KHI', lccode=0x2CAD },
	[0x2CAD] = { unicodeslot=0x2CAD, category='ll', description='COPTIC SMALL LETTER KHI', uccode=0x2CAC },
	[0x2CAE] = { unicodeslot=0x2CAE, category='lu', description='COPTIC CAPITAL LETTER PSI', lccode=0x2CAF },
	[0x2CAF] = { unicodeslot=0x2CAF, category='ll', description='COPTIC SMALL LETTER PSI', uccode=0x2CAE },
	[0x2CB0] = { unicodeslot=0x2CB0, category='lu', description='COPTIC CAPITAL LETTER OOU', lccode=0x2CB1 },
	[0x2CB1] = { unicodeslot=0x2CB1, category='ll', description='COPTIC SMALL LETTER OOU', uccode=0x2CB0 },
	[0x2CB2] = { unicodeslot=0x2CB2, category='lu', description='COPTIC CAPITAL LETTER DIALECT-P ALEF', lccode=0x2CB3 },
	[0x2CB3] = { unicodeslot=0x2CB3, category='ll', description='COPTIC SMALL LETTER DIALECT-P ALEF', uccode=0x2CB2 },
	[0x2CB4] = { unicodeslot=0x2CB4, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC AIN', lccode=0x2CB5 },
	[0x2CB5] = { unicodeslot=0x2CB5, category='ll', description='COPTIC SMALL LETTER OLD COPTIC AIN', uccode=0x2CB4 },
	[0x2CB6] = { unicodeslot=0x2CB6, category='lu', description='COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE', lccode=0x2CB7 },
	[0x2CB7] = { unicodeslot=0x2CB7, category='ll', description='COPTIC SMALL LETTER CRYPTOGRAMMIC EIE', uccode=0x2CB6 },
	[0x2CB8] = { unicodeslot=0x2CB8, category='lu', description='COPTIC CAPITAL LETTER DIALECT-P KAPA', lccode=0x2CB9 },
	[0x2CB9] = { unicodeslot=0x2CB9, category='ll', description='COPTIC SMALL LETTER DIALECT-P KAPA', uccode=0x2CB8 },
	[0x2CBA] = { unicodeslot=0x2CBA, category='lu', description='COPTIC CAPITAL LETTER DIALECT-P NI', lccode=0x2CBB },
	[0x2CBB] = { unicodeslot=0x2CBB, category='ll', description='COPTIC SMALL LETTER DIALECT-P NI', uccode=0x2CBA },
	[0x2CBC] = { unicodeslot=0x2CBC, category='lu', description='COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI', lccode=0x2CBD },
	[0x2CBD] = { unicodeslot=0x2CBD, category='ll', description='COPTIC SMALL LETTER CRYPTOGRAMMIC NI', uccode=0x2CBC },
	[0x2CBE] = { unicodeslot=0x2CBE, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC OOU', lccode=0x2CBF },
	[0x2CBF] = { unicodeslot=0x2CBF, category='ll', description='COPTIC SMALL LETTER OLD COPTIC OOU', uccode=0x2CBE },
	[0x2CC0] = { unicodeslot=0x2CC0, category='lu', description='COPTIC CAPITAL LETTER SAMPI', lccode=0x2CC1 },
	[0x2CC1] = { unicodeslot=0x2CC1, category='ll', description='COPTIC SMALL LETTER SAMPI', uccode=0x2CC0 },
	[0x2CC2] = { unicodeslot=0x2CC2, category='lu', description='COPTIC CAPITAL LETTER CROSSED SHEI', lccode=0x2CC3 },
	[0x2CC3] = { unicodeslot=0x2CC3, category='ll', description='COPTIC SMALL LETTER CROSSED SHEI', uccode=0x2CC2 },
	[0x2CC4] = { unicodeslot=0x2CC4, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC SHEI', lccode=0x2CC5 },
	[0x2CC5] = { unicodeslot=0x2CC5, category='ll', description='COPTIC SMALL LETTER OLD COPTIC SHEI', uccode=0x2CC4 },
	[0x2CC6] = { unicodeslot=0x2CC6, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC ESH', lccode=0x2CC7 },
	[0x2CC7] = { unicodeslot=0x2CC7, category='ll', description='COPTIC SMALL LETTER OLD COPTIC ESH', uccode=0x2CC6 },
	[0x2CC8] = { unicodeslot=0x2CC8, category='lu', description='COPTIC CAPITAL LETTER AKHMIMIC KHEI', lccode=0x2CC9 },
	[0x2CC9] = { unicodeslot=0x2CC9, category='ll', description='COPTIC SMALL LETTER AKHMIMIC KHEI', uccode=0x2CC8 },
	[0x2CCA] = { unicodeslot=0x2CCA, category='lu', description='COPTIC CAPITAL LETTER DIALECT-P HORI', lccode=0x2CCB },
	[0x2CCB] = { unicodeslot=0x2CCB, category='ll', description='COPTIC SMALL LETTER DIALECT-P HORI', uccode=0x2CCA },
	[0x2CCC] = { unicodeslot=0x2CCC, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC HORI', lccode=0x2CCD },
	[0x2CCD] = { unicodeslot=0x2CCD, category='ll', description='COPTIC SMALL LETTER OLD COPTIC HORI', uccode=0x2CCC },
	[0x2CCE] = { unicodeslot=0x2CCE, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC HA', lccode=0x2CCF },
	[0x2CCF] = { unicodeslot=0x2CCF, category='ll', description='COPTIC SMALL LETTER OLD COPTIC HA', uccode=0x2CCE },
	[0x2CD0] = { unicodeslot=0x2CD0, category='lu', description='COPTIC CAPITAL LETTER L-SHAPED HA', lccode=0x2CD1 },
	[0x2CD1] = { unicodeslot=0x2CD1, category='ll', description='COPTIC SMALL LETTER L-SHAPED HA', uccode=0x2CD0 },
	[0x2CD2] = { unicodeslot=0x2CD2, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC HEI', lccode=0x2CD3 },
	[0x2CD3] = { unicodeslot=0x2CD3, category='ll', description='COPTIC SMALL LETTER OLD COPTIC HEI', uccode=0x2CD2 },
	[0x2CD4] = { unicodeslot=0x2CD4, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC HAT', lccode=0x2CD5 },
	[0x2CD5] = { unicodeslot=0x2CD5, category='ll', description='COPTIC SMALL LETTER OLD COPTIC HAT', uccode=0x2CD4 },
	[0x2CD6] = { unicodeslot=0x2CD6, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC GANGIA', lccode=0x2CD7 },
	[0x2CD7] = { unicodeslot=0x2CD7, category='ll', description='COPTIC SMALL LETTER OLD COPTIC GANGIA', uccode=0x2CD6 },
	[0x2CD8] = { unicodeslot=0x2CD8, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC DJA', lccode=0x2CD9 },
	[0x2CD9] = { unicodeslot=0x2CD9, category='ll', description='COPTIC SMALL LETTER OLD COPTIC DJA', uccode=0x2CD8 },
	[0x2CDA] = { unicodeslot=0x2CDA, category='lu', description='COPTIC CAPITAL LETTER OLD COPTIC SHIMA', lccode=0x2CDB },
	[0x2CDB] = { unicodeslot=0x2CDB, category='ll', description='COPTIC SMALL LETTER OLD COPTIC SHIMA', uccode=0x2CDA },
	[0x2CDC] = { unicodeslot=0x2CDC, category='lu', description='COPTIC CAPITAL LETTER OLD NUBIAN SHIMA', lccode=0x2CDD },
	[0x2CDD] = { unicodeslot=0x2CDD, category='ll', description='COPTIC SMALL LETTER OLD NUBIAN SHIMA', uccode=0x2CDC },
	[0x2CDE] = { unicodeslot=0x2CDE, category='lu', description='COPTIC CAPITAL LETTER OLD NUBIAN NGI', lccode=0x2CDF },
	[0x2CDF] = { unicodeslot=0x2CDF, category='ll', description='COPTIC SMALL LETTER OLD NUBIAN NGI', uccode=0x2CDE },
	[0x2CE0] = { unicodeslot=0x2CE0, category='lu', description='COPTIC CAPITAL LETTER OLD NUBIAN NYI', lccode=0x2CE1 },
	[0x2CE1] = { unicodeslot=0x2CE1, category='ll', description='COPTIC SMALL LETTER OLD NUBIAN NYI', uccode=0x2CE0 },
	[0x2CE2] = { unicodeslot=0x2CE2, category='lu', description='COPTIC CAPITAL LETTER OLD NUBIAN WAU', lccode=0x2CE3 },
	[0x2CE3] = { unicodeslot=0x2CE3, category='ll', description='COPTIC SMALL LETTER OLD NUBIAN WAU', uccode=0x2CE2 },
	[0x2CE4] = { unicodeslot=0x2CE4, category='ll', description='COPTIC SYMBOL KAI' },
	[0x2CE5] = { unicodeslot=0x2CE5, category='so', description='COPTIC SYMBOL MI RO' },
	[0x2CE6] = { unicodeslot=0x2CE6, category='so', description='COPTIC SYMBOL PI RO' },
	[0x2CE7] = { unicodeslot=0x2CE7, category='so', description='COPTIC SYMBOL STAUROS' },
	[0x2CE8] = { unicodeslot=0x2CE8, category='so', description='COPTIC SYMBOL TAU RO' },
	[0x2CE9] = { unicodeslot=0x2CE9, category='so', description='COPTIC SYMBOL KHI RO' },
	[0x2CEA] = { unicodeslot=0x2CEA, category='so', description='COPTIC SYMBOL SHIMA SIMA' },
	[0x2CF9] = { unicodeslot=0x2CF9, category='po', description='COPTIC OLD NUBIAN FULL STOP' },
	[0x2CFA] = { unicodeslot=0x2CFA, category='po', description='COPTIC OLD NUBIAN DIRECT QUESTION MARK' },
	[0x2CFB] = { unicodeslot=0x2CFB, category='po', description='COPTIC OLD NUBIAN INDIRECT QUESTION MARK' },
	[0x2CFC] = { unicodeslot=0x2CFC, category='po', description='COPTIC OLD NUBIAN VERSE DIVIDER' },
	[0x2CFD] = { unicodeslot=0x2CFD, category='no', description='COPTIC FRACTION ONE HALF' },
	[0x2CFE] = { unicodeslot=0x2CFE, category='po', description='COPTIC FULL STOP' },
	[0x2CFF] = { unicodeslot=0x2CFF, category='po', description='COPTIC MORPHOLOGICAL DIVIDER' },
	[0x2D00] = { unicodeslot=0x2D00, category='ll', description='GEORGIAN SMALL LETTER AN', uccode=0x10A0 },
	[0x2D01] = { unicodeslot=0x2D01, category='ll', description='GEORGIAN SMALL LETTER BAN', uccode=0x10A1 },
	[0x2D02] = { unicodeslot=0x2D02, category='ll', description='GEORGIAN SMALL LETTER GAN', uccode=0x10A2 },
	[0x2D03] = { unicodeslot=0x2D03, category='ll', description='GEORGIAN SMALL LETTER DON', uccode=0x10A3 },
	[0x2D04] = { unicodeslot=0x2D04, category='ll', description='GEORGIAN SMALL LETTER EN', uccode=0x10A4 },
	[0x2D05] = { unicodeslot=0x2D05, category='ll', description='GEORGIAN SMALL LETTER VIN', uccode=0x10A5 },
	[0x2D06] = { unicodeslot=0x2D06, category='ll', description='GEORGIAN SMALL LETTER ZEN', uccode=0x10A6 },
	[0x2D07] = { unicodeslot=0x2D07, category='ll', description='GEORGIAN SMALL LETTER TAN', uccode=0x10A7 },
	[0x2D08] = { unicodeslot=0x2D08, category='ll', description='GEORGIAN SMALL LETTER IN', uccode=0x10A8 },
	[0x2D09] = { unicodeslot=0x2D09, category='ll', description='GEORGIAN SMALL LETTER KAN', uccode=0x10A9 },
	[0x2D0A] = { unicodeslot=0x2D0A, category='ll', description='GEORGIAN SMALL LETTER LAS', uccode=0x10AA },
	[0x2D0B] = { unicodeslot=0x2D0B, category='ll', description='GEORGIAN SMALL LETTER MAN', uccode=0x10AB },
	[0x2D0C] = { unicodeslot=0x2D0C, category='ll', description='GEORGIAN SMALL LETTER NAR', uccode=0x10AC },
	[0x2D0D] = { unicodeslot=0x2D0D, category='ll', description='GEORGIAN SMALL LETTER ON', uccode=0x10AD },
	[0x2D0E] = { unicodeslot=0x2D0E, category='ll', description='GEORGIAN SMALL LETTER PAR', uccode=0x10AE },
	[0x2D0F] = { unicodeslot=0x2D0F, category='ll', description='GEORGIAN SMALL LETTER ZHAR', uccode=0x10AF },
	[0x2D10] = { unicodeslot=0x2D10, category='ll', description='GEORGIAN SMALL LETTER RAE', uccode=0x10B0 },
	[0x2D11] = { unicodeslot=0x2D11, category='ll', description='GEORGIAN SMALL LETTER SAN', uccode=0x10B1 },
	[0x2D12] = { unicodeslot=0x2D12, category='ll', description='GEORGIAN SMALL LETTER TAR', uccode=0x10B2 },
	[0x2D13] = { unicodeslot=0x2D13, category='ll', description='GEORGIAN SMALL LETTER UN', uccode=0x10B3 },
	[0x2D14] = { unicodeslot=0x2D14, category='ll', description='GEORGIAN SMALL LETTER PHAR', uccode=0x10B4 },
	[0x2D15] = { unicodeslot=0x2D15, category='ll', description='GEORGIAN SMALL LETTER KHAR', uccode=0x10B5 },
	[0x2D16] = { unicodeslot=0x2D16, category='ll', description='GEORGIAN SMALL LETTER GHAN', uccode=0x10B6 },
	[0x2D17] = { unicodeslot=0x2D17, category='ll', description='GEORGIAN SMALL LETTER QAR', uccode=0x10B7 },
	[0x2D18] = { unicodeslot=0x2D18, category='ll', description='GEORGIAN SMALL LETTER SHIN', uccode=0x10B8 },
	[0x2D19] = { unicodeslot=0x2D19, category='ll', description='GEORGIAN SMALL LETTER CHIN', uccode=0x10B9 },
	[0x2D1A] = { unicodeslot=0x2D1A, category='ll', description='GEORGIAN SMALL LETTER CAN', uccode=0x10BA },
	[0x2D1B] = { unicodeslot=0x2D1B, category='ll', description='GEORGIAN SMALL LETTER JIL', uccode=0x10BB },
	[0x2D1C] = { unicodeslot=0x2D1C, category='ll', description='GEORGIAN SMALL LETTER CIL', uccode=0x10BC },
	[0x2D1D] = { unicodeslot=0x2D1D, category='ll', description='GEORGIAN SMALL LETTER CHAR', uccode=0x10BD },
	[0x2D1E] = { unicodeslot=0x2D1E, category='ll', description='GEORGIAN SMALL LETTER XAN', uccode=0x10BE },
	[0x2D1F] = { unicodeslot=0x2D1F, category='ll', description='GEORGIAN SMALL LETTER JHAN', uccode=0x10BF },
	[0x2D20] = { unicodeslot=0x2D20, category='ll', description='GEORGIAN SMALL LETTER HAE', uccode=0x10C0 },
	[0x2D21] = { unicodeslot=0x2D21, category='ll', description='GEORGIAN SMALL LETTER HE', uccode=0x10C1 },
	[0x2D22] = { unicodeslot=0x2D22, category='ll', description='GEORGIAN SMALL LETTER HIE', uccode=0x10C2 },
	[0x2D23] = { unicodeslot=0x2D23, category='ll', description='GEORGIAN SMALL LETTER WE', uccode=0x10C3 },
	[0x2D24] = { unicodeslot=0x2D24, category='ll', description='GEORGIAN SMALL LETTER HAR', uccode=0x10C4 },
	[0x2D25] = { unicodeslot=0x2D25, category='ll', description='GEORGIAN SMALL LETTER HOE', uccode=0x10C5 },
	[0x2D30] = { unicodeslot=0x2D30, category='lo', description='TIFINAGH LETTER YA' },
	[0x2D31] = { unicodeslot=0x2D31, category='lo', description='TIFINAGH LETTER YAB' },
	[0x2D32] = { unicodeslot=0x2D32, category='lo', description='TIFINAGH LETTER YABH' },
	[0x2D33] = { unicodeslot=0x2D33, category='lo', description='TIFINAGH LETTER YAG' },
	[0x2D34] = { unicodeslot=0x2D34, category='lo', description='TIFINAGH LETTER YAGHH' },
	[0x2D35] = { unicodeslot=0x2D35, category='lo', description='TIFINAGH LETTER BERBER ACADEMY YAJ' },
	[0x2D36] = { unicodeslot=0x2D36, category='lo', description='TIFINAGH LETTER YAJ' },
	[0x2D37] = { unicodeslot=0x2D37, category='lo', description='TIFINAGH LETTER YAD' },
	[0x2D38] = { unicodeslot=0x2D38, category='lo', description='TIFINAGH LETTER YADH' },
	[0x2D39] = { unicodeslot=0x2D39, category='lo', description='TIFINAGH LETTER YADD' },
	[0x2D3A] = { unicodeslot=0x2D3A, category='lo', description='TIFINAGH LETTER YADDH' },
	[0x2D3B] = { unicodeslot=0x2D3B, category='lo', description='TIFINAGH LETTER YEY' },
	[0x2D3C] = { unicodeslot=0x2D3C, category='lo', description='TIFINAGH LETTER YAF' },
	[0x2D3D] = { unicodeslot=0x2D3D, category='lo', description='TIFINAGH LETTER YAK' },
	[0x2D3E] = { unicodeslot=0x2D3E, category='lo', description='TIFINAGH LETTER TUAREG YAK' },
	[0x2D3F] = { unicodeslot=0x2D3F, category='lo', description='TIFINAGH LETTER YAKHH' },
	[0x2D40] = { unicodeslot=0x2D40, category='lo', description='TIFINAGH LETTER YAH' },
	[0x2D41] = { unicodeslot=0x2D41, category='lo', description='TIFINAGH LETTER BERBER ACADEMY YAH' },
	[0x2D42] = { unicodeslot=0x2D42, category='lo', description='TIFINAGH LETTER TUAREG YAH' },
	[0x2D43] = { unicodeslot=0x2D43, category='lo', description='TIFINAGH LETTER YAHH' },
	[0x2D44] = { unicodeslot=0x2D44, category='lo', description='TIFINAGH LETTER YAA' },
	[0x2D45] = { unicodeslot=0x2D45, category='lo', description='TIFINAGH LETTER YAKH' },
	[0x2D46] = { unicodeslot=0x2D46, category='lo', description='TIFINAGH LETTER TUAREG YAKH' },
	[0x2D47] = { unicodeslot=0x2D47, category='lo', description='TIFINAGH LETTER YAQ' },
	[0x2D48] = { unicodeslot=0x2D48, category='lo', description='TIFINAGH LETTER TUAREG YAQ' },
	[0x2D49] = { unicodeslot=0x2D49, category='lo', description='TIFINAGH LETTER YI' },
	[0x2D4A] = { unicodeslot=0x2D4A, category='lo', description='TIFINAGH LETTER YAZH' },
	[0x2D4B] = { unicodeslot=0x2D4B, category='lo', description='TIFINAGH LETTER AHAGGAR YAZH' },
	[0x2D4C] = { unicodeslot=0x2D4C, category='lo', description='TIFINAGH LETTER TUAREG YAZH' },
	[0x2D4D] = { unicodeslot=0x2D4D, category='lo', description='TIFINAGH LETTER YAL' },
	[0x2D4E] = { unicodeslot=0x2D4E, category='lo', description='TIFINAGH LETTER YAM' },
	[0x2D4F] = { unicodeslot=0x2D4F, category='lo', description='TIFINAGH LETTER YAN' },
	[0x2D50] = { unicodeslot=0x2D50, category='lo', description='TIFINAGH LETTER TUAREG YAGN' },
	[0x2D51] = { unicodeslot=0x2D51, category='lo', description='TIFINAGH LETTER TUAREG YANG' },
	[0x2D52] = { unicodeslot=0x2D52, category='lo', description='TIFINAGH LETTER YAP' },
	[0x2D53] = { unicodeslot=0x2D53, category='lo', description='TIFINAGH LETTER YU' },
	[0x2D54] = { unicodeslot=0x2D54, category='lo', description='TIFINAGH LETTER YAR' },
	[0x2D55] = { unicodeslot=0x2D55, category='lo', description='TIFINAGH LETTER YARR' },
	[0x2D56] = { unicodeslot=0x2D56, category='lo', description='TIFINAGH LETTER YAGH' },
	[0x2D57] = { unicodeslot=0x2D57, category='lo', description='TIFINAGH LETTER TUAREG YAGH' },
	[0x2D58] = { unicodeslot=0x2D58, category='lo', description='TIFINAGH LETTER AYER YAGH' },
	[0x2D59] = { unicodeslot=0x2D59, category='lo', description='TIFINAGH LETTER YAS' },
	[0x2D5A] = { unicodeslot=0x2D5A, category='lo', description='TIFINAGH LETTER YASS' },
	[0x2D5B] = { unicodeslot=0x2D5B, category='lo', description='TIFINAGH LETTER YASH' },
	[0x2D5C] = { unicodeslot=0x2D5C, category='lo', description='TIFINAGH LETTER YAT' },
	[0x2D5D] = { unicodeslot=0x2D5D, category='lo', description='TIFINAGH LETTER YATH' },
	[0x2D5E] = { unicodeslot=0x2D5E, category='lo', description='TIFINAGH LETTER YACH' },
	[0x2D5F] = { unicodeslot=0x2D5F, category='lo', description='TIFINAGH LETTER YATT' },
	[0x2D60] = { unicodeslot=0x2D60, category='lo', description='TIFINAGH LETTER YAV' },
	[0x2D61] = { unicodeslot=0x2D61, category='lo', description='TIFINAGH LETTER YAW' },
	[0x2D62] = { unicodeslot=0x2D62, category='lo', description='TIFINAGH LETTER YAY' },
	[0x2D63] = { unicodeslot=0x2D63, category='lo', description='TIFINAGH LETTER YAZ' },
	[0x2D64] = { unicodeslot=0x2D64, category='lo', description='TIFINAGH LETTER TAWELLEMET YAZ' },
	[0x2D65] = { unicodeslot=0x2D65, category='lo', description='TIFINAGH LETTER YAZZ' },
	[0x2D6F] = { unicodeslot=0x2D6F, category='lm', description='TIFINAGH MODIFIER LETTER LABIALIZATION MARK', specials={'super',0x2D61} },
	[0x2D80] = { unicodeslot=0x2D80, category='lo', description='ETHIOPIC SYLLABLE LOA' },
	[0x2D81] = { unicodeslot=0x2D81, category='lo', description='ETHIOPIC SYLLABLE MOA' },
	[0x2D82] = { unicodeslot=0x2D82, category='lo', description='ETHIOPIC SYLLABLE ROA' },
	[0x2D83] = { unicodeslot=0x2D83, category='lo', description='ETHIOPIC SYLLABLE SOA' },
	[0x2D84] = { unicodeslot=0x2D84, category='lo', description='ETHIOPIC SYLLABLE SHOA' },
	[0x2D85] = { unicodeslot=0x2D85, category='lo', description='ETHIOPIC SYLLABLE BOA' },
	[0x2D86] = { unicodeslot=0x2D86, category='lo', description='ETHIOPIC SYLLABLE TOA' },
	[0x2D87] = { unicodeslot=0x2D87, category='lo', description='ETHIOPIC SYLLABLE COA' },
	[0x2D88] = { unicodeslot=0x2D88, category='lo', description='ETHIOPIC SYLLABLE NOA' },
	[0x2D89] = { unicodeslot=0x2D89, category='lo', description='ETHIOPIC SYLLABLE NYOA' },
	[0x2D8A] = { unicodeslot=0x2D8A, category='lo', description='ETHIOPIC SYLLABLE GLOTTAL OA' },
	[0x2D8B] = { unicodeslot=0x2D8B, category='lo', description='ETHIOPIC SYLLABLE ZOA' },
	[0x2D8C] = { unicodeslot=0x2D8C, category='lo', description='ETHIOPIC SYLLABLE DOA' },
	[0x2D8D] = { unicodeslot=0x2D8D, category='lo', description='ETHIOPIC SYLLABLE DDOA' },
	[0x2D8E] = { unicodeslot=0x2D8E, category='lo', description='ETHIOPIC SYLLABLE JOA' },
	[0x2D8F] = { unicodeslot=0x2D8F, category='lo', description='ETHIOPIC SYLLABLE THOA' },
	[0x2D90] = { unicodeslot=0x2D90, category='lo', description='ETHIOPIC SYLLABLE CHOA' },
	[0x2D91] = { unicodeslot=0x2D91, category='lo', description='ETHIOPIC SYLLABLE PHOA' },
	[0x2D92] = { unicodeslot=0x2D92, category='lo', description='ETHIOPIC SYLLABLE POA' },
	[0x2D93] = { unicodeslot=0x2D93, category='lo', description='ETHIOPIC SYLLABLE GGWA' },
	[0x2D94] = { unicodeslot=0x2D94, category='lo', description='ETHIOPIC SYLLABLE GGWI' },
	[0x2D95] = { unicodeslot=0x2D95, category='lo', description='ETHIOPIC SYLLABLE GGWEE' },
	[0x2D96] = { unicodeslot=0x2D96, category='lo', description='ETHIOPIC SYLLABLE GGWE' },
	[0x2DA0] = { unicodeslot=0x2DA0, category='lo', description='ETHIOPIC SYLLABLE SSA' },
	[0x2DA1] = { unicodeslot=0x2DA1, category='lo', description='ETHIOPIC SYLLABLE SSU' },
	[0x2DA2] = { unicodeslot=0x2DA2, category='lo', description='ETHIOPIC SYLLABLE SSI' },
	[0x2DA3] = { unicodeslot=0x2DA3, category='lo', description='ETHIOPIC SYLLABLE SSAA' },
	[0x2DA4] = { unicodeslot=0x2DA4, category='lo', description='ETHIOPIC SYLLABLE SSEE' },
	[0x2DA5] = { unicodeslot=0x2DA5, category='lo', description='ETHIOPIC SYLLABLE SSE' },
	[0x2DA6] = { unicodeslot=0x2DA6, category='lo', description='ETHIOPIC SYLLABLE SSO' },
	[0x2DA8] = { unicodeslot=0x2DA8, category='lo', description='ETHIOPIC SYLLABLE CCA' },
	[0x2DA9] = { unicodeslot=0x2DA9, category='lo', description='ETHIOPIC SYLLABLE CCU' },
	[0x2DAA] = { unicodeslot=0x2DAA, category='lo', description='ETHIOPIC SYLLABLE CCI' },
	[0x2DAB] = { unicodeslot=0x2DAB, category='lo', description='ETHIOPIC SYLLABLE CCAA' },
	[0x2DAC] = { unicodeslot=0x2DAC, category='lo', description='ETHIOPIC SYLLABLE CCEE' },
	[0x2DAD] = { unicodeslot=0x2DAD, category='lo', description='ETHIOPIC SYLLABLE CCE' },
	[0x2DAE] = { unicodeslot=0x2DAE, category='lo', description='ETHIOPIC SYLLABLE CCO' },
	[0x2DB0] = { unicodeslot=0x2DB0, category='lo', description='ETHIOPIC SYLLABLE ZZA' },
	[0x2DB1] = { unicodeslot=0x2DB1, category='lo', description='ETHIOPIC SYLLABLE ZZU' },
	[0x2DB2] = { unicodeslot=0x2DB2, category='lo', description='ETHIOPIC SYLLABLE ZZI' },
	[0x2DB3] = { unicodeslot=0x2DB3, category='lo', description='ETHIOPIC SYLLABLE ZZAA' },
	[0x2DB4] = { unicodeslot=0x2DB4, category='lo', description='ETHIOPIC SYLLABLE ZZEE' },
	[0x2DB5] = { unicodeslot=0x2DB5, category='lo', description='ETHIOPIC SYLLABLE ZZE' },
	[0x2DB6] = { unicodeslot=0x2DB6, category='lo', description='ETHIOPIC SYLLABLE ZZO' },
	[0x2DB8] = { unicodeslot=0x2DB8, category='lo', description='ETHIOPIC SYLLABLE CCHA' },
	[0x2DB9] = { unicodeslot=0x2DB9, category='lo', description='ETHIOPIC SYLLABLE CCHU' },
	[0x2DBA] = { unicodeslot=0x2DBA, category='lo', description='ETHIOPIC SYLLABLE CCHI' },
	[0x2DBB] = { unicodeslot=0x2DBB, category='lo', description='ETHIOPIC SYLLABLE CCHAA' },
	[0x2DBC] = { unicodeslot=0x2DBC, category='lo', description='ETHIOPIC SYLLABLE CCHEE' },
	[0x2DBD] = { unicodeslot=0x2DBD, category='lo', description='ETHIOPIC SYLLABLE CCHE' },
	[0x2DBE] = { unicodeslot=0x2DBE, category='lo', description='ETHIOPIC SYLLABLE CCHO' },
	[0x2DC0] = { unicodeslot=0x2DC0, category='lo', description='ETHIOPIC SYLLABLE QYA' },
	[0x2DC1] = { unicodeslot=0x2DC1, category='lo', description='ETHIOPIC SYLLABLE QYU' },
	[0x2DC2] = { unicodeslot=0x2DC2, category='lo', description='ETHIOPIC SYLLABLE QYI' },
	[0x2DC3] = { unicodeslot=0x2DC3, category='lo', description='ETHIOPIC SYLLABLE QYAA' },
	[0x2DC4] = { unicodeslot=0x2DC4, category='lo', description='ETHIOPIC SYLLABLE QYEE' },
	[0x2DC5] = { unicodeslot=0x2DC5, category='lo', description='ETHIOPIC SYLLABLE QYE' },
	[0x2DC6] = { unicodeslot=0x2DC6, category='lo', description='ETHIOPIC SYLLABLE QYO' },
	[0x2DC8] = { unicodeslot=0x2DC8, category='lo', description='ETHIOPIC SYLLABLE KYA' },
	[0x2DC9] = { unicodeslot=0x2DC9, category='lo', description='ETHIOPIC SYLLABLE KYU' },
	[0x2DCA] = { unicodeslot=0x2DCA, category='lo', description='ETHIOPIC SYLLABLE KYI' },
	[0x2DCB] = { unicodeslot=0x2DCB, category='lo', description='ETHIOPIC SYLLABLE KYAA' },
	[0x2DCC] = { unicodeslot=0x2DCC, category='lo', description='ETHIOPIC SYLLABLE KYEE' },
	[0x2DCD] = { unicodeslot=0x2DCD, category='lo', description='ETHIOPIC SYLLABLE KYE' },
	[0x2DCE] = { unicodeslot=0x2DCE, category='lo', description='ETHIOPIC SYLLABLE KYO' },
	[0x2DD0] = { unicodeslot=0x2DD0, category='lo', description='ETHIOPIC SYLLABLE XYA' },
	[0x2DD1] = { unicodeslot=0x2DD1, category='lo', description='ETHIOPIC SYLLABLE XYU' },
	[0x2DD2] = { unicodeslot=0x2DD2, category='lo', description='ETHIOPIC SYLLABLE XYI' },
	[0x2DD3] = { unicodeslot=0x2DD3, category='lo', description='ETHIOPIC SYLLABLE XYAA' },
	[0x2DD4] = { unicodeslot=0x2DD4, category='lo', description='ETHIOPIC SYLLABLE XYEE' },
	[0x2DD5] = { unicodeslot=0x2DD5, category='lo', description='ETHIOPIC SYLLABLE XYE' },
	[0x2DD6] = { unicodeslot=0x2DD6, category='lo', description='ETHIOPIC SYLLABLE XYO' },
	[0x2DD8] = { unicodeslot=0x2DD8, category='lo', description='ETHIOPIC SYLLABLE GYA' },
	[0x2DD9] = { unicodeslot=0x2DD9, category='lo', description='ETHIOPIC SYLLABLE GYU' },
	[0x2DDA] = { unicodeslot=0x2DDA, category='lo', description='ETHIOPIC SYLLABLE GYI' },
	[0x2DDB] = { unicodeslot=0x2DDB, category='lo', description='ETHIOPIC SYLLABLE GYAA' },
	[0x2DDC] = { unicodeslot=0x2DDC, category='lo', description='ETHIOPIC SYLLABLE GYEE' },
	[0x2DDD] = { unicodeslot=0x2DDD, category='lo', description='ETHIOPIC SYLLABLE GYE' },
	[0x2DDE] = { unicodeslot=0x2DDE, category='lo', description='ETHIOPIC SYLLABLE GYO' },
	[0x2E00] = { unicodeslot=0x2E00, category='po', description='RIGHT ANGLE SUBSTITUTION MARKER' },
	[0x2E01] = { unicodeslot=0x2E01, category='po', description='RIGHT ANGLE DOTTED SUBSTITUTION MARKER' },
	[0x2E02] = { unicodeslot=0x2E02, category='pi', description='LEFT SUBSTITUTION BRACKET' },
	[0x2E03] = { unicodeslot=0x2E03, category='pf', description='RIGHT SUBSTITUTION BRACKET' },
	[0x2E04] = { unicodeslot=0x2E04, category='pi', description='LEFT DOTTED SUBSTITUTION BRACKET' },
	[0x2E05] = { unicodeslot=0x2E05, category='pf', description='RIGHT DOTTED SUBSTITUTION BRACKET' },
	[0x2E06] = { unicodeslot=0x2E06, category='po', description='RAISED INTERPOLATION MARKER' },
	[0x2E07] = { unicodeslot=0x2E07, category='po', description='RAISED DOTTED INTERPOLATION MARKER' },
	[0x2E08] = { unicodeslot=0x2E08, category='po', description='DOTTED TRANSPOSITION MARKER' },
	[0x2E09] = { unicodeslot=0x2E09, category='pi', description='LEFT TRANSPOSITION BRACKET' },
	[0x2E0A] = { unicodeslot=0x2E0A, category='pf', description='RIGHT TRANSPOSITION BRACKET' },
	[0x2E0B] = { unicodeslot=0x2E0B, category='po', description='RAISED SQUARE' },
	[0x2E0C] = { unicodeslot=0x2E0C, category='pi', description='LEFT RAISED OMISSION BRACKET' },
	[0x2E0D] = { unicodeslot=0x2E0D, category='pf', description='RIGHT RAISED OMISSION BRACKET' },
	[0x2E0E] = { unicodeslot=0x2E0E, category='po', description='EDITORIAL CORONIS' },
	[0x2E0F] = { unicodeslot=0x2E0F, category='po', description='PARAGRAPHOS' },
	[0x2E10] = { unicodeslot=0x2E10, category='po', description='FORKED PARAGRAPHOS' },
	[0x2E11] = { unicodeslot=0x2E11, category='po', description='REVERSED FORKED PARAGRAPHOS' },
	[0x2E12] = { unicodeslot=0x2E12, category='po', description='HYPODIASTOLE' },
	[0x2E13] = { unicodeslot=0x2E13, category='po', description='DOTTED OBELOS' },
	[0x2E14] = { unicodeslot=0x2E14, category='po', description='DOWNWARDS ANCORA' },
	[0x2E15] = { unicodeslot=0x2E15, category='po', description='UPWARDS ANCORA' },
	[0x2E16] = { unicodeslot=0x2E16, category='po', description='DOTTED RIGHT-POINTING ANGLE' },
	[0x2E17] = { unicodeslot=0x2E17, category='pd', description='DOUBLE OBLIQUE HYPHEN' },
	[0x2E1C] = { unicodeslot=0x2E1C, category='pi', description='LEFT LOW PARAPHRASE BRACKET' },
	[0x2E1D] = { unicodeslot=0x2E1D, category='pf', description='RIGHT LOW PARAPHRASE BRACKET' },
	[0x2E80] = { unicodeslot=0x2E80, category='so', description='CJK RADICAL REPEAT' },
	[0x2E81] = { unicodeslot=0x2E81, category='so', description='CJK RADICAL CLIFF' },
	[0x2E82] = { unicodeslot=0x2E82, category='so', description='CJK RADICAL SECOND ONE' },
	[0x2E83] = { unicodeslot=0x2E83, category='so', description='CJK RADICAL SECOND TWO' },
	[0x2E84] = { unicodeslot=0x2E84, category='so', description='CJK RADICAL SECOND THREE' },
	[0x2E85] = { unicodeslot=0x2E85, category='so', description='CJK RADICAL PERSON' },
	[0x2E86] = { unicodeslot=0x2E86, category='so', description='CJK RADICAL BOX' },
	[0x2E87] = { unicodeslot=0x2E87, category='so', description='CJK RADICAL TABLE' },
	[0x2E88] = { unicodeslot=0x2E88, category='so', description='CJK RADICAL KNIFE ONE' },
	[0x2E89] = { unicodeslot=0x2E89, category='so', description='CJK RADICAL KNIFE TWO' },
	[0x2E8A] = { unicodeslot=0x2E8A, category='so', description='CJK RADICAL DIVINATION' },
	[0x2E8B] = { unicodeslot=0x2E8B, category='so', description='CJK RADICAL SEAL' },
	[0x2E8C] = { unicodeslot=0x2E8C, category='so', description='CJK RADICAL SMALL ONE' },
	[0x2E8D] = { unicodeslot=0x2E8D, category='so', description='CJK RADICAL SMALL TWO' },
	[0x2E8E] = { unicodeslot=0x2E8E, category='so', description='CJK RADICAL LAME ONE' },
	[0x2E8F] = { unicodeslot=0x2E8F, category='so', description='CJK RADICAL LAME TWO' },
	[0x2E90] = { unicodeslot=0x2E90, category='so', description='CJK RADICAL LAME THREE' },
	[0x2E91] = { unicodeslot=0x2E91, category='so', description='CJK RADICAL LAME FOUR' },
	[0x2E92] = { unicodeslot=0x2E92, category='so', description='CJK RADICAL SNAKE' },
	[0x2E93] = { unicodeslot=0x2E93, category='so', description='CJK RADICAL THREAD' },
	[0x2E94] = { unicodeslot=0x2E94, category='so', description='CJK RADICAL SNOUT ONE' },
	[0x2E95] = { unicodeslot=0x2E95, category='so', description='CJK RADICAL SNOUT TWO' },
	[0x2E96] = { unicodeslot=0x2E96, category='so', description='CJK RADICAL HEART ONE' },
	[0x2E97] = { unicodeslot=0x2E97, category='so', description='CJK RADICAL HEART TWO' },
	[0x2E98] = { unicodeslot=0x2E98, category='so', description='CJK RADICAL HAND' },
	[0x2E99] = { unicodeslot=0x2E99, category='so', description='CJK RADICAL RAP' },
	[0x2E9B] = { unicodeslot=0x2E9B, category='so', description='CJK RADICAL CHOKE' },
	[0x2E9C] = { unicodeslot=0x2E9C, category='so', description='CJK RADICAL SUN' },
	[0x2E9D] = { unicodeslot=0x2E9D, category='so', description='CJK RADICAL MOON' },
	[0x2E9E] = { unicodeslot=0x2E9E, category='so', description='CJK RADICAL DEATH' },
	[0x2E9F] = { unicodeslot=0x2E9F, category='so', description='CJK RADICAL MOTHER', specials={'compat',0x6BCD} },
	[0x2EA0] = { unicodeslot=0x2EA0, category='so', description='CJK RADICAL CIVILIAN' },
	[0x2EA1] = { unicodeslot=0x2EA1, category='so', description='CJK RADICAL WATER ONE' },
	[0x2EA2] = { unicodeslot=0x2EA2, category='so', description='CJK RADICAL WATER TWO' },
	[0x2EA3] = { unicodeslot=0x2EA3, category='so', description='CJK RADICAL FIRE' },
	[0x2EA4] = { unicodeslot=0x2EA4, category='so', description='CJK RADICAL PAW ONE' },
	[0x2EA5] = { unicodeslot=0x2EA5, category='so', description='CJK RADICAL PAW TWO' },
	[0x2EA6] = { unicodeslot=0x2EA6, category='so', description='CJK RADICAL SIMPLIFIED HALF TREE TRUNK' },
	[0x2EA7] = { unicodeslot=0x2EA7, category='so', description='CJK RADICAL COW' },
	[0x2EA8] = { unicodeslot=0x2EA8, category='so', description='CJK RADICAL DOG' },
	[0x2EA9] = { unicodeslot=0x2EA9, category='so', description='CJK RADICAL JADE' },
	[0x2EAA] = { unicodeslot=0x2EAA, category='so', description='CJK RADICAL BOLT OF CLOTH' },
	[0x2EAB] = { unicodeslot=0x2EAB, category='so', description='CJK RADICAL EYE' },
	[0x2EAC] = { unicodeslot=0x2EAC, category='so', description='CJK RADICAL SPIRIT ONE' },
	[0x2EAD] = { unicodeslot=0x2EAD, category='so', description='CJK RADICAL SPIRIT TWO' },
	[0x2EAE] = { unicodeslot=0x2EAE, category='so', description='CJK RADICAL BAMBOO' },
	[0x2EAF] = { unicodeslot=0x2EAF, category='so', description='CJK RADICAL SILK' },
	[0x2EB0] = { unicodeslot=0x2EB0, category='so', description='CJK RADICAL C-SIMPLIFIED SILK' },
	[0x2EB1] = { unicodeslot=0x2EB1, category='so', description='CJK RADICAL NET ONE' },
	[0x2EB2] = { unicodeslot=0x2EB2, category='so', description='CJK RADICAL NET TWO' },
	[0x2EB3] = { unicodeslot=0x2EB3, category='so', description='CJK RADICAL NET THREE' },
	[0x2EB4] = { unicodeslot=0x2EB4, category='so', description='CJK RADICAL NET FOUR' },
	[0x2EB5] = { unicodeslot=0x2EB5, category='so', description='CJK RADICAL MESH' },
	[0x2EB6] = { unicodeslot=0x2EB6, category='so', description='CJK RADICAL SHEEP' },
	[0x2EB7] = { unicodeslot=0x2EB7, category='so', description='CJK RADICAL RAM' },
	[0x2EB8] = { unicodeslot=0x2EB8, category='so', description='CJK RADICAL EWE' },
	[0x2EB9] = { unicodeslot=0x2EB9, category='so', description='CJK RADICAL OLD' },
	[0x2EBA] = { unicodeslot=0x2EBA, category='so', description='CJK RADICAL BRUSH ONE' },
	[0x2EBB] = { unicodeslot=0x2EBB, category='so', description='CJK RADICAL BRUSH TWO' },
	[0x2EBC] = { unicodeslot=0x2EBC, category='so', description='CJK RADICAL MEAT' },
	[0x2EBD] = { unicodeslot=0x2EBD, category='so', description='CJK RADICAL MORTAR' },
	[0x2EBE] = { unicodeslot=0x2EBE, category='so', description='CJK RADICAL GRASS ONE' },
	[0x2EBF] = { unicodeslot=0x2EBF, category='so', description='CJK RADICAL GRASS TWO' },
	[0x2EC0] = { unicodeslot=0x2EC0, category='so', description='CJK RADICAL GRASS THREE' },
	[0x2EC1] = { unicodeslot=0x2EC1, category='so', description='CJK RADICAL TIGER' },
	[0x2EC2] = { unicodeslot=0x2EC2, category='so', description='CJK RADICAL CLOTHES' },
	[0x2EC3] = { unicodeslot=0x2EC3, category='so', description='CJK RADICAL WEST ONE' },
	[0x2EC4] = { unicodeslot=0x2EC4, category='so', description='CJK RADICAL WEST TWO' },
	[0x2EC5] = { unicodeslot=0x2EC5, category='so', description='CJK RADICAL C-SIMPLIFIED SEE' },
	[0x2EC6] = { unicodeslot=0x2EC6, category='so', description='CJK RADICAL SIMPLIFIED HORN' },
	[0x2EC7] = { unicodeslot=0x2EC7, category='so', description='CJK RADICAL HORN' },
	[0x2EC8] = { unicodeslot=0x2EC8, category='so', description='CJK RADICAL C-SIMPLIFIED SPEECH' },
	[0x2EC9] = { unicodeslot=0x2EC9, category='so', description='CJK RADICAL C-SIMPLIFIED SHELL' },
	[0x2ECA] = { unicodeslot=0x2ECA, category='so', description='CJK RADICAL FOOT' },
	[0x2ECB] = { unicodeslot=0x2ECB, category='so', description='CJK RADICAL C-SIMPLIFIED CART' },
	[0x2ECC] = { unicodeslot=0x2ECC, category='so', description='CJK RADICAL SIMPLIFIED WALK' },
	[0x2ECD] = { unicodeslot=0x2ECD, category='so', description='CJK RADICAL WALK ONE' },
	[0x2ECE] = { unicodeslot=0x2ECE, category='so', description='CJK RADICAL WALK TWO' },
	[0x2ECF] = { unicodeslot=0x2ECF, category='so', description='CJK RADICAL CITY' },
	[0x2ED0] = { unicodeslot=0x2ED0, category='so', description='CJK RADICAL C-SIMPLIFIED GOLD' },
	[0x2ED1] = { unicodeslot=0x2ED1, category='so', description='CJK RADICAL LONG ONE' },
	[0x2ED2] = { unicodeslot=0x2ED2, category='so', description='CJK RADICAL LONG TWO' },
	[0x2ED3] = { unicodeslot=0x2ED3, category='so', description='CJK RADICAL C-SIMPLIFIED LONG' },
	[0x2ED4] = { unicodeslot=0x2ED4, category='so', description='CJK RADICAL C-SIMPLIFIED GATE' },
	[0x2ED5] = { unicodeslot=0x2ED5, category='so', description='CJK RADICAL MOUND ONE' },
	[0x2ED6] = { unicodeslot=0x2ED6, category='so', description='CJK RADICAL MOUND TWO' },
	[0x2ED7] = { unicodeslot=0x2ED7, category='so', description='CJK RADICAL RAIN' },
	[0x2ED8] = { unicodeslot=0x2ED8, category='so', description='CJK RADICAL BLUE' },
	[0x2ED9] = { unicodeslot=0x2ED9, category='so', description='CJK RADICAL C-SIMPLIFIED TANNED LEATHER' },
	[0x2EDA] = { unicodeslot=0x2EDA, category='so', description='CJK RADICAL C-SIMPLIFIED LEAF' },
	[0x2EDB] = { unicodeslot=0x2EDB, category='so', description='CJK RADICAL C-SIMPLIFIED WIND' },
	[0x2EDC] = { unicodeslot=0x2EDC, category='so', description='CJK RADICAL C-SIMPLIFIED FLY' },
	[0x2EDD] = { unicodeslot=0x2EDD, category='so', description='CJK RADICAL EAT ONE' },
	[0x2EDE] = { unicodeslot=0x2EDE, category='so', description='CJK RADICAL EAT TWO' },
	[0x2EDF] = { unicodeslot=0x2EDF, category='so', description='CJK RADICAL EAT THREE' },
	[0x2EE0] = { unicodeslot=0x2EE0, category='so', description='CJK RADICAL C-SIMPLIFIED EAT' },
	[0x2EE1] = { unicodeslot=0x2EE1, category='so', description='CJK RADICAL HEAD' },
	[0x2EE2] = { unicodeslot=0x2EE2, category='so', description='CJK RADICAL C-SIMPLIFIED HORSE' },
	[0x2EE3] = { unicodeslot=0x2EE3, category='so', description='CJK RADICAL BONE' },
	[0x2EE4] = { unicodeslot=0x2EE4, category='so', description='CJK RADICAL GHOST' },
	[0x2EE5] = { unicodeslot=0x2EE5, category='so', description='CJK RADICAL C-SIMPLIFIED FISH' },
	[0x2EE6] = { unicodeslot=0x2EE6, category='so', description='CJK RADICAL C-SIMPLIFIED BIRD' },
	[0x2EE7] = { unicodeslot=0x2EE7, category='so', description='CJK RADICAL C-SIMPLIFIED SALT' },
	[0x2EE8] = { unicodeslot=0x2EE8, category='so', description='CJK RADICAL SIMPLIFIED WHEAT' },
	[0x2EE9] = { unicodeslot=0x2EE9, category='so', description='CJK RADICAL SIMPLIFIED YELLOW' },
	[0x2EEA] = { unicodeslot=0x2EEA, category='so', description='CJK RADICAL C-SIMPLIFIED FROG' },
	[0x2EEB] = { unicodeslot=0x2EEB, category='so', description='CJK RADICAL J-SIMPLIFIED EVEN' },
	[0x2EEC] = { unicodeslot=0x2EEC, category='so', description='CJK RADICAL C-SIMPLIFIED EVEN' },
	[0x2EED] = { unicodeslot=0x2EED, category='so', description='CJK RADICAL J-SIMPLIFIED TOOTH' },
	[0x2EEE] = { unicodeslot=0x2EEE, category='so', description='CJK RADICAL C-SIMPLIFIED TOOTH' },
	[0x2EEF] = { unicodeslot=0x2EEF, category='so', description='CJK RADICAL J-SIMPLIFIED DRAGON' },
	[0x2EF0] = { unicodeslot=0x2EF0, category='so', description='CJK RADICAL C-SIMPLIFIED DRAGON' },
	[0x2EF1] = { unicodeslot=0x2EF1, category='so', description='CJK RADICAL TURTLE' },
	[0x2EF2] = { unicodeslot=0x2EF2, category='so', description='CJK RADICAL J-SIMPLIFIED TURTLE' },
	[0x2EF3] = { unicodeslot=0x2EF3, category='so', description='CJK RADICAL C-SIMPLIFIED TURTLE', specials={'compat',0x9F9F} },
	[0x2F00] = { unicodeslot=0x2F00, category='so', description='KANGXI RADICAL ONE', specials={'compat',0x4E00} },
	[0x2F01] = { unicodeslot=0x2F01, category='so', description='KANGXI RADICAL LINE', specials={'compat',0x4E28} },
	[0x2F02] = { unicodeslot=0x2F02, category='so', description='KANGXI RADICAL DOT', specials={'compat',0x4E36} },
	[0x2F03] = { unicodeslot=0x2F03, category='so', description='KANGXI RADICAL SLASH', specials={'compat',0x4E3F} },
	[0x2F04] = { unicodeslot=0x2F04, category='so', description='KANGXI RADICAL SECOND', specials={'compat',0x4E59} },
	[0x2F05] = { unicodeslot=0x2F05, category='so', description='KANGXI RADICAL HOOK', specials={'compat',0x4E85} },
	[0x2F06] = { unicodeslot=0x2F06, category='so', description='KANGXI RADICAL TWO', specials={'compat',0x4E8C} },
	[0x2F07] = { unicodeslot=0x2F07, category='so', description='KANGXI RADICAL LID', specials={'compat',0x4EA0} },
	[0x2F08] = { unicodeslot=0x2F08, category='so', description='KANGXI RADICAL MAN', specials={'compat',0x4EBA} },
	[0x2F09] = { unicodeslot=0x2F09, category='so', description='KANGXI RADICAL LEGS', specials={'compat',0x513F} },
	[0x2F0A] = { unicodeslot=0x2F0A, category='so', description='KANGXI RADICAL ENTER', specials={'compat',0x5165} },
	[0x2F0B] = { unicodeslot=0x2F0B, category='so', description='KANGXI RADICAL EIGHT', specials={'compat',0x516B} },
	[0x2F0C] = { unicodeslot=0x2F0C, category='so', description='KANGXI RADICAL DOWN BOX', specials={'compat',0x5182} },
	[0x2F0D] = { unicodeslot=0x2F0D, category='so', description='KANGXI RADICAL COVER', specials={'compat',0x5196} },
	[0x2F0E] = { unicodeslot=0x2F0E, category='so', description='KANGXI RADICAL ICE', specials={'compat',0x51AB} },
	[0x2F0F] = { unicodeslot=0x2F0F, category='so', description='KANGXI RADICAL TABLE', specials={'compat',0x51E0} },
	[0x2F10] = { unicodeslot=0x2F10, category='so', description='KANGXI RADICAL OPEN BOX', specials={'compat',0x51F5} },
	[0x2F11] = { unicodeslot=0x2F11, category='so', description='KANGXI RADICAL KNIFE', specials={'compat',0x5200} },
	[0x2F12] = { unicodeslot=0x2F12, category='so', description='KANGXI RADICAL POWER', specials={'compat',0x529B} },
	[0x2F13] = { unicodeslot=0x2F13, category='so', description='KANGXI RADICAL WRAP', specials={'compat',0x52F9} },
	[0x2F14] = { unicodeslot=0x2F14, category='so', description='KANGXI RADICAL SPOON', specials={'compat',0x5315} },
	[0x2F15] = { unicodeslot=0x2F15, category='so', description='KANGXI RADICAL RIGHT OPEN BOX', specials={'compat',0x531A} },
	[0x2F16] = { unicodeslot=0x2F16, category='so', description='KANGXI RADICAL HIDING ENCLOSURE', specials={'compat',0x5338} },
	[0x2F17] = { unicodeslot=0x2F17, category='so', description='KANGXI RADICAL TEN', specials={'compat',0x5341} },
	[0x2F18] = { unicodeslot=0x2F18, category='so', description='KANGXI RADICAL DIVINATION', specials={'compat',0x535C} },
	[0x2F19] = { unicodeslot=0x2F19, category='so', description='KANGXI RADICAL SEAL', specials={'compat',0x5369} },
	[0x2F1A] = { unicodeslot=0x2F1A, category='so', description='KANGXI RADICAL CLIFF', specials={'compat',0x5382} },
	[0x2F1B] = { unicodeslot=0x2F1B, category='so', description='KANGXI RADICAL PRIVATE', specials={'compat',0x53B6} },
	[0x2F1C] = { unicodeslot=0x2F1C, category='so', description='KANGXI RADICAL AGAIN', specials={'compat',0x53C8} },
	[0x2F1D] = { unicodeslot=0x2F1D, category='so', description='KANGXI RADICAL MOUTH', specials={'compat',0x53E3} },
	[0x2F1E] = { unicodeslot=0x2F1E, category='so', description='KANGXI RADICAL ENCLOSURE', specials={'compat',0x56D7} },
	[0x2F1F] = { unicodeslot=0x2F1F, category='so', description='KANGXI RADICAL EARTH', specials={'compat',0x571F} },
	[0x2F20] = { unicodeslot=0x2F20, category='so', description='KANGXI RADICAL SCHOLAR', specials={'compat',0x58EB} },
	[0x2F21] = { unicodeslot=0x2F21, category='so', description='KANGXI RADICAL GO', specials={'compat',0x5902} },
	[0x2F22] = { unicodeslot=0x2F22, category='so', description='KANGXI RADICAL GO SLOWLY', specials={'compat',0x590A} },
	[0x2F23] = { unicodeslot=0x2F23, category='so', description='KANGXI RADICAL EVENING', specials={'compat',0x5915} },
	[0x2F24] = { unicodeslot=0x2F24, category='so', description='KANGXI RADICAL BIG', specials={'compat',0x5927} },
	[0x2F25] = { unicodeslot=0x2F25, category='so', description='KANGXI RADICAL WOMAN', specials={'compat',0x5973} },
	[0x2F26] = { unicodeslot=0x2F26, category='so', description='KANGXI RADICAL CHILD', specials={'compat',0x5B50} },
	[0x2F27] = { unicodeslot=0x2F27, category='so', description='KANGXI RADICAL ROOF', specials={'compat',0x5B80} },
	[0x2F28] = { unicodeslot=0x2F28, category='so', description='KANGXI RADICAL INCH', specials={'compat',0x5BF8} },
	[0x2F29] = { unicodeslot=0x2F29, category='so', description='KANGXI RADICAL SMALL', specials={'compat',0x5C0F} },
	[0x2F2A] = { unicodeslot=0x2F2A, category='so', description='KANGXI RADICAL LAME', specials={'compat',0x5C22} },
	[0x2F2B] = { unicodeslot=0x2F2B, category='so', description='KANGXI RADICAL CORPSE', specials={'compat',0x5C38} },
	[0x2F2C] = { unicodeslot=0x2F2C, category='so', description='KANGXI RADICAL SPROUT', specials={'compat',0x5C6E} },
	[0x2F2D] = { unicodeslot=0x2F2D, category='so', description='KANGXI RADICAL MOUNTAIN', specials={'compat',0x5C71} },
	[0x2F2E] = { unicodeslot=0x2F2E, category='so', description='KANGXI RADICAL RIVER', specials={'compat',0x5DDB} },
	[0x2F2F] = { unicodeslot=0x2F2F, category='so', description='KANGXI RADICAL WORK', specials={'compat',0x5DE5} },
	[0x2F30] = { unicodeslot=0x2F30, category='so', description='KANGXI RADICAL ONESELF', specials={'compat',0x5DF1} },
	[0x2F31] = { unicodeslot=0x2F31, category='so', description='KANGXI RADICAL TURBAN', specials={'compat',0x5DFE} },
	[0x2F32] = { unicodeslot=0x2F32, category='so', description='KANGXI RADICAL DRY', specials={'compat',0x5E72} },
	[0x2F33] = { unicodeslot=0x2F33, category='so', description='KANGXI RADICAL SHORT THREAD', specials={'compat',0x5E7A} },
	[0x2F34] = { unicodeslot=0x2F34, category='so', description='KANGXI RADICAL DOTTED CLIFF', specials={'compat',0x5E7F} },
	[0x2F35] = { unicodeslot=0x2F35, category='so', description='KANGXI RADICAL LONG STRIDE', specials={'compat',0x5EF4} },
	[0x2F36] = { unicodeslot=0x2F36, category='so', description='KANGXI RADICAL TWO HANDS', specials={'compat',0x5EFE} },
	[0x2F37] = { unicodeslot=0x2F37, category='so', description='KANGXI RADICAL SHOOT', specials={'compat',0x5F0B} },
	[0x2F38] = { unicodeslot=0x2F38, category='so', description='KANGXI RADICAL BOW', specials={'compat',0x5F13} },
	[0x2F39] = { unicodeslot=0x2F39, category='so', description='KANGXI RADICAL SNOUT', specials={'compat',0x5F50} },
	[0x2F3A] = { unicodeslot=0x2F3A, category='so', description='KANGXI RADICAL BRISTLE', specials={'compat',0x5F61} },
	[0x2F3B] = { unicodeslot=0x2F3B, category='so', description='KANGXI RADICAL STEP', specials={'compat',0x5F73} },
	[0x2F3C] = { unicodeslot=0x2F3C, category='so', description='KANGXI RADICAL HEART', specials={'compat',0x5FC3} },
	[0x2F3D] = { unicodeslot=0x2F3D, category='so', description='KANGXI RADICAL HALBERD', specials={'compat',0x6208} },
	[0x2F3E] = { unicodeslot=0x2F3E, category='so', description='KANGXI RADICAL DOOR', specials={'compat',0x6236} },
	[0x2F3F] = { unicodeslot=0x2F3F, category='so', description='KANGXI RADICAL HAND', specials={'compat',0x624B} },
	[0x2F40] = { unicodeslot=0x2F40, category='so', description='KANGXI RADICAL BRANCH', specials={'compat',0x652F} },
	[0x2F41] = { unicodeslot=0x2F41, category='so', description='KANGXI RADICAL RAP', specials={'compat',0x6534} },
	[0x2F42] = { unicodeslot=0x2F42, category='so', description='KANGXI RADICAL SCRIPT', specials={'compat',0x6587} },
	[0x2F43] = { unicodeslot=0x2F43, category='so', description='KANGXI RADICAL DIPPER', specials={'compat',0x6597} },
	[0x2F44] = { unicodeslot=0x2F44, category='so', description='KANGXI RADICAL AXE', specials={'compat',0x65A4} },
	[0x2F45] = { unicodeslot=0x2F45, category='so', description='KANGXI RADICAL SQUARE', specials={'compat',0x65B9} },
	[0x2F46] = { unicodeslot=0x2F46, category='so', description='KANGXI RADICAL NOT', specials={'compat',0x65E0} },
	[0x2F47] = { unicodeslot=0x2F47, category='so', description='KANGXI RADICAL SUN', specials={'compat',0x65E5} },
	[0x2F48] = { unicodeslot=0x2F48, category='so', description='KANGXI RADICAL SAY', specials={'compat',0x66F0} },
	[0x2F49] = { unicodeslot=0x2F49, category='so', description='KANGXI RADICAL MOON', specials={'compat',0x6708} },
	[0x2F4A] = { unicodeslot=0x2F4A, category='so', description='KANGXI RADICAL TREE', specials={'compat',0x6728} },
	[0x2F4B] = { unicodeslot=0x2F4B, category='so', description='KANGXI RADICAL LACK', specials={'compat',0x6B20} },
	[0x2F4C] = { unicodeslot=0x2F4C, category='so', description='KANGXI RADICAL STOP', specials={'compat',0x6B62} },
	[0x2F4D] = { unicodeslot=0x2F4D, category='so', description='KANGXI RADICAL DEATH', specials={'compat',0x6B79} },
	[0x2F4E] = { unicodeslot=0x2F4E, category='so', description='KANGXI RADICAL WEAPON', specials={'compat',0x6BB3} },
	[0x2F4F] = { unicodeslot=0x2F4F, category='so', description='KANGXI RADICAL DO NOT', specials={'compat',0x6BCB} },
	[0x2F50] = { unicodeslot=0x2F50, category='so', description='KANGXI RADICAL COMPARE', specials={'compat',0x6BD4} },
	[0x2F51] = { unicodeslot=0x2F51, category='so', description='KANGXI RADICAL FUR', specials={'compat',0x6BDB} },
	[0x2F52] = { unicodeslot=0x2F52, category='so', description='KANGXI RADICAL CLAN', specials={'compat',0x6C0F} },
	[0x2F53] = { unicodeslot=0x2F53, category='so', description='KANGXI RADICAL STEAM', specials={'compat',0x6C14} },
	[0x2F54] = { unicodeslot=0x2F54, category='so', description='KANGXI RADICAL WATER', specials={'compat',0x6C34} },
	[0x2F55] = { unicodeslot=0x2F55, category='so', description='KANGXI RADICAL FIRE', specials={'compat',0x706B} },
	[0x2F56] = { unicodeslot=0x2F56, category='so', description='KANGXI RADICAL CLAW', specials={'compat',0x722A} },
	[0x2F57] = { unicodeslot=0x2F57, category='so', description='KANGXI RADICAL FATHER', specials={'compat',0x7236} },
	[0x2F58] = { unicodeslot=0x2F58, category='so', description='KANGXI RADICAL DOUBLE X', specials={'compat',0x723B} },
	[0x2F59] = { unicodeslot=0x2F59, category='so', description='KANGXI RADICAL HALF TREE TRUNK', specials={'compat',0x723F} },
	[0x2F5A] = { unicodeslot=0x2F5A, category='so', description='KANGXI RADICAL SLICE', specials={'compat',0x7247} },
	[0x2F5B] = { unicodeslot=0x2F5B, category='so', description='KANGXI RADICAL FANG', specials={'compat',0x7259} },
	[0x2F5C] = { unicodeslot=0x2F5C, category='so', description='KANGXI RADICAL COW', specials={'compat',0x725B} },
	[0x2F5D] = { unicodeslot=0x2F5D, category='so', description='KANGXI RADICAL DOG', specials={'compat',0x72AC} },
	[0x2F5E] = { unicodeslot=0x2F5E, category='so', description='KANGXI RADICAL PROFOUND', specials={'compat',0x7384} },
	[0x2F5F] = { unicodeslot=0x2F5F, category='so', description='KANGXI RADICAL JADE', specials={'compat',0x7389} },
	[0x2F60] = { unicodeslot=0x2F60, category='so', description='KANGXI RADICAL MELON', specials={'compat',0x74DC} },
	[0x2F61] = { unicodeslot=0x2F61, category='so', description='KANGXI RADICAL TILE', specials={'compat',0x74E6} },
	[0x2F62] = { unicodeslot=0x2F62, category='so', description='KANGXI RADICAL SWEET', specials={'compat',0x7518} },
	[0x2F63] = { unicodeslot=0x2F63, category='so', description='KANGXI RADICAL LIFE', specials={'compat',0x751F} },
	[0x2F64] = { unicodeslot=0x2F64, category='so', description='KANGXI RADICAL USE', specials={'compat',0x7528} },
	[0x2F65] = { unicodeslot=0x2F65, category='so', description='KANGXI RADICAL FIELD', specials={'compat',0x7530} },
	[0x2F66] = { unicodeslot=0x2F66, category='so', description='KANGXI RADICAL BOLT OF CLOTH', specials={'compat',0x758B} },
	[0x2F67] = { unicodeslot=0x2F67, category='so', description='KANGXI RADICAL SICKNESS', specials={'compat',0x7592} },
	[0x2F68] = { unicodeslot=0x2F68, category='so', description='KANGXI RADICAL DOTTED TENT', specials={'compat',0x7676} },
	[0x2F69] = { unicodeslot=0x2F69, category='so', description='KANGXI RADICAL WHITE', specials={'compat',0x767D} },
	[0x2F6A] = { unicodeslot=0x2F6A, category='so', description='KANGXI RADICAL SKIN', specials={'compat',0x76AE} },
	[0x2F6B] = { unicodeslot=0x2F6B, category='so', description='KANGXI RADICAL DISH', specials={'compat',0x76BF} },
	[0x2F6C] = { unicodeslot=0x2F6C, category='so', description='KANGXI RADICAL EYE', specials={'compat',0x76EE} },
	[0x2F6D] = { unicodeslot=0x2F6D, category='so', description='KANGXI RADICAL SPEAR', specials={'compat',0x77DB} },
	[0x2F6E] = { unicodeslot=0x2F6E, category='so', description='KANGXI RADICAL ARROW', specials={'compat',0x77E2} },
	[0x2F6F] = { unicodeslot=0x2F6F, category='so', description='KANGXI RADICAL STONE', specials={'compat',0x77F3} },
	[0x2F70] = { unicodeslot=0x2F70, category='so', description='KANGXI RADICAL SPIRIT', specials={'compat',0x793A} },
	[0x2F71] = { unicodeslot=0x2F71, category='so', description='KANGXI RADICAL TRACK', specials={'compat',0x79B8} },
	[0x2F72] = { unicodeslot=0x2F72, category='so', description='KANGXI RADICAL GRAIN', specials={'compat',0x79BE} },
	[0x2F73] = { unicodeslot=0x2F73, category='so', description='KANGXI RADICAL CAVE', specials={'compat',0x7A74} },
	[0x2F74] = { unicodeslot=0x2F74, category='so', description='KANGXI RADICAL STAND', specials={'compat',0x7ACB} },
	[0x2F75] = { unicodeslot=0x2F75, category='so', description='KANGXI RADICAL BAMBOO', specials={'compat',0x7AF9} },
	[0x2F76] = { unicodeslot=0x2F76, category='so', description='KANGXI RADICAL RICE', specials={'compat',0x7C73} },
	[0x2F77] = { unicodeslot=0x2F77, category='so', description='KANGXI RADICAL SILK', specials={'compat',0x7CF8} },
	[0x2F78] = { unicodeslot=0x2F78, category='so', description='KANGXI RADICAL JAR', specials={'compat',0x7F36} },
	[0x2F79] = { unicodeslot=0x2F79, category='so', description='KANGXI RADICAL NET', specials={'compat',0x7F51} },
	[0x2F7A] = { unicodeslot=0x2F7A, category='so', description='KANGXI RADICAL SHEEP', specials={'compat',0x7F8A} },
	[0x2F7B] = { unicodeslot=0x2F7B, category='so', description='KANGXI RADICAL FEATHER', specials={'compat',0x7FBD} },
	[0x2F7C] = { unicodeslot=0x2F7C, category='so', description='KANGXI RADICAL OLD', specials={'compat',0x8001} },
	[0x2F7D] = { unicodeslot=0x2F7D, category='so', description='KANGXI RADICAL AND', specials={'compat',0x800C} },
	[0x2F7E] = { unicodeslot=0x2F7E, category='so', description='KANGXI RADICAL PLOW', specials={'compat',0x8012} },
	[0x2F7F] = { unicodeslot=0x2F7F, category='so', description='KANGXI RADICAL EAR', specials={'compat',0x8033} },
	[0x2F80] = { unicodeslot=0x2F80, category='so', description='KANGXI RADICAL BRUSH', specials={'compat',0x807F} },
	[0x2F81] = { unicodeslot=0x2F81, category='so', description='KANGXI RADICAL MEAT', specials={'compat',0x8089} },
	[0x2F82] = { unicodeslot=0x2F82, category='so', description='KANGXI RADICAL MINISTER', specials={'compat',0x81E3} },
	[0x2F83] = { unicodeslot=0x2F83, category='so', description='KANGXI RADICAL SELF', specials={'compat',0x81EA} },
	[0x2F84] = { unicodeslot=0x2F84, category='so', description='KANGXI RADICAL ARRIVE', specials={'compat',0x81F3} },
	[0x2F85] = { unicodeslot=0x2F85, category='so', description='KANGXI RADICAL MORTAR', specials={'compat',0x81FC} },
	[0x2F86] = { unicodeslot=0x2F86, category='so', description='KANGXI RADICAL TONGUE', specials={'compat',0x820C} },
	[0x2F87] = { unicodeslot=0x2F87, category='so', description='KANGXI RADICAL OPPOSE', specials={'compat',0x821B} },
	[0x2F88] = { unicodeslot=0x2F88, category='so', description='KANGXI RADICAL BOAT', specials={'compat',0x821F} },
	[0x2F89] = { unicodeslot=0x2F89, category='so', description='KANGXI RADICAL STOPPING', specials={'compat',0x826E} },
	[0x2F8A] = { unicodeslot=0x2F8A, category='so', description='KANGXI RADICAL COLOR', specials={'compat',0x8272} },
	[0x2F8B] = { unicodeslot=0x2F8B, category='so', description='KANGXI RADICAL GRASS', specials={'compat',0x8278} },
	[0x2F8C] = { unicodeslot=0x2F8C, category='so', description='KANGXI RADICAL TIGER', specials={'compat',0x864D} },
	[0x2F8D] = { unicodeslot=0x2F8D, category='so', description='KANGXI RADICAL INSECT', specials={'compat',0x866B} },
	[0x2F8E] = { unicodeslot=0x2F8E, category='so', description='KANGXI RADICAL BLOOD', specials={'compat',0x8840} },
	[0x2F8F] = { unicodeslot=0x2F8F, category='so', description='KANGXI RADICAL WALK ENCLOSURE', specials={'compat',0x884C} },
	[0x2F90] = { unicodeslot=0x2F90, category='so', description='KANGXI RADICAL CLOTHES', specials={'compat',0x8863} },
	[0x2F91] = { unicodeslot=0x2F91, category='so', description='KANGXI RADICAL WEST', specials={'compat',0x897E} },
	[0x2F92] = { unicodeslot=0x2F92, category='so', description='KANGXI RADICAL SEE', specials={'compat',0x898B} },
	[0x2F93] = { unicodeslot=0x2F93, category='so', description='KANGXI RADICAL HORN', specials={'compat',0x89D2} },
	[0x2F94] = { unicodeslot=0x2F94, category='so', description='KANGXI RADICAL SPEECH', specials={'compat',0x8A00} },
	[0x2F95] = { unicodeslot=0x2F95, category='so', description='KANGXI RADICAL VALLEY', specials={'compat',0x8C37} },
	[0x2F96] = { unicodeslot=0x2F96, category='so', description='KANGXI RADICAL BEAN', specials={'compat',0x8C46} },
	[0x2F97] = { unicodeslot=0x2F97, category='so', description='KANGXI RADICAL PIG', specials={'compat',0x8C55} },
	[0x2F98] = { unicodeslot=0x2F98, category='so', description='KANGXI RADICAL BADGER', specials={'compat',0x8C78} },
	[0x2F99] = { unicodeslot=0x2F99, category='so', description='KANGXI RADICAL SHELL', specials={'compat',0x8C9D} },
	[0x2F9A] = { unicodeslot=0x2F9A, category='so', description='KANGXI RADICAL RED', specials={'compat',0x8D64} },
	[0x2F9B] = { unicodeslot=0x2F9B, category='so', description='KANGXI RADICAL RUN', specials={'compat',0x8D70} },
	[0x2F9C] = { unicodeslot=0x2F9C, category='so', description='KANGXI RADICAL FOOT', specials={'compat',0x8DB3} },
	[0x2F9D] = { unicodeslot=0x2F9D, category='so', description='KANGXI RADICAL BODY', specials={'compat',0x8EAB} },
	[0x2F9E] = { unicodeslot=0x2F9E, category='so', description='KANGXI RADICAL CART', specials={'compat',0x8ECA} },
	[0x2F9F] = { unicodeslot=0x2F9F, category='so', description='KANGXI RADICAL BITTER', specials={'compat',0x8F9B} },
	[0x2FA0] = { unicodeslot=0x2FA0, category='so', description='KANGXI RADICAL MORNING', specials={'compat',0x8FB0} },
	[0x2FA1] = { unicodeslot=0x2FA1, category='so', description='KANGXI RADICAL WALK', specials={'compat',0x8FB5} },
	[0x2FA2] = { unicodeslot=0x2FA2, category='so', description='KANGXI RADICAL CITY', specials={'compat',0x9091} },
	[0x2FA3] = { unicodeslot=0x2FA3, category='so', description='KANGXI RADICAL WINE', specials={'compat',0x9149} },
	[0x2FA4] = { unicodeslot=0x2FA4, category='so', description='KANGXI RADICAL DISTINGUISH', specials={'compat',0x91C6} },
	[0x2FA5] = { unicodeslot=0x2FA5, category='so', description='KANGXI RADICAL VILLAGE', specials={'compat',0x91CC} },
	[0x2FA6] = { unicodeslot=0x2FA6, category='so', description='KANGXI RADICAL GOLD', specials={'compat',0x91D1} },
	[0x2FA7] = { unicodeslot=0x2FA7, category='so', description='KANGXI RADICAL LONG', specials={'compat',0x9577} },
	[0x2FA8] = { unicodeslot=0x2FA8, category='so', description='KANGXI RADICAL GATE', specials={'compat',0x9580} },
	[0x2FA9] = { unicodeslot=0x2FA9, category='so', description='KANGXI RADICAL MOUND', specials={'compat',0x961C} },
	[0x2FAA] = { unicodeslot=0x2FAA, category='so', description='KANGXI RADICAL SLAVE', specials={'compat',0x96B6} },
	[0x2FAB] = { unicodeslot=0x2FAB, category='so', description='KANGXI RADICAL SHORT TAILED BIRD', specials={'compat',0x96B9} },
	[0x2FAC] = { unicodeslot=0x2FAC, category='so', description='KANGXI RADICAL RAIN', specials={'compat',0x96E8} },
	[0x2FAD] = { unicodeslot=0x2FAD, category='so', description='KANGXI RADICAL BLUE', specials={'compat',0x9751} },
	[0x2FAE] = { unicodeslot=0x2FAE, category='so', description='KANGXI RADICAL WRONG', specials={'compat',0x975E} },
	[0x2FAF] = { unicodeslot=0x2FAF, category='so', description='KANGXI RADICAL FACE', specials={'compat',0x9762} },
	[0x2FB0] = { unicodeslot=0x2FB0, category='so', description='KANGXI RADICAL LEATHER', specials={'compat',0x9769} },
	[0x2FB1] = { unicodeslot=0x2FB1, category='so', description='KANGXI RADICAL TANNED LEATHER', specials={'compat',0x97CB} },
	[0x2FB2] = { unicodeslot=0x2FB2, category='so', description='KANGXI RADICAL LEEK', specials={'compat',0x97ED} },
	[0x2FB3] = { unicodeslot=0x2FB3, category='so', description='KANGXI RADICAL SOUND', specials={'compat',0x97F3} },
	[0x2FB4] = { unicodeslot=0x2FB4, category='so', description='KANGXI RADICAL LEAF', specials={'compat',0x9801} },
	[0x2FB5] = { unicodeslot=0x2FB5, category='so', description='KANGXI RADICAL WIND', specials={'compat',0x98A8} },
	[0x2FB6] = { unicodeslot=0x2FB6, category='so', description='KANGXI RADICAL FLY', specials={'compat',0x98DB} },
	[0x2FB7] = { unicodeslot=0x2FB7, category='so', description='KANGXI RADICAL EAT', specials={'compat',0x98DF} },
	[0x2FB8] = { unicodeslot=0x2FB8, category='so', description='KANGXI RADICAL HEAD', specials={'compat',0x9996} },
	[0x2FB9] = { unicodeslot=0x2FB9, category='so', description='KANGXI RADICAL FRAGRANT', specials={'compat',0x9999} },
	[0x2FBA] = { unicodeslot=0x2FBA, category='so', description='KANGXI RADICAL HORSE', specials={'compat',0x99AC} },
	[0x2FBB] = { unicodeslot=0x2FBB, category='so', description='KANGXI RADICAL BONE', specials={'compat',0x9AA8} },
	[0x2FBC] = { unicodeslot=0x2FBC, category='so', description='KANGXI RADICAL TALL', specials={'compat',0x9AD8} },
	[0x2FBD] = { unicodeslot=0x2FBD, category='so', description='KANGXI RADICAL HAIR', specials={'compat',0x9ADF} },
	[0x2FBE] = { unicodeslot=0x2FBE, category='so', description='KANGXI RADICAL FIGHT', specials={'compat',0x9B25} },
	[0x2FBF] = { unicodeslot=0x2FBF, category='so', description='KANGXI RADICAL SACRIFICIAL WINE', specials={'compat',0x9B2F} },
	[0x2FC0] = { unicodeslot=0x2FC0, category='so', description='KANGXI RADICAL CAULDRON', specials={'compat',0x9B32} },
	[0x2FC1] = { unicodeslot=0x2FC1, category='so', description='KANGXI RADICAL GHOST', specials={'compat',0x9B3C} },
	[0x2FC2] = { unicodeslot=0x2FC2, category='so', description='KANGXI RADICAL FISH', specials={'compat',0x9B5A} },
	[0x2FC3] = { unicodeslot=0x2FC3, category='so', description='KANGXI RADICAL BIRD', specials={'compat',0x9CE5} },
	[0x2FC4] = { unicodeslot=0x2FC4, category='so', description='KANGXI RADICAL SALT', specials={'compat',0x9E75} },
	[0x2FC5] = { unicodeslot=0x2FC5, category='so', description='KANGXI RADICAL DEER', specials={'compat',0x9E7F} },
	[0x2FC6] = { unicodeslot=0x2FC6, category='so', description='KANGXI RADICAL WHEAT', specials={'compat',0x9EA5} },
	[0x2FC7] = { unicodeslot=0x2FC7, category='so', description='KANGXI RADICAL HEMP', specials={'compat',0x9EBB} },
	[0x2FC8] = { unicodeslot=0x2FC8, category='so', description='KANGXI RADICAL YELLOW', specials={'compat',0x9EC3} },
	[0x2FC9] = { unicodeslot=0x2FC9, category='so', description='KANGXI RADICAL MILLET', specials={'compat',0x9ECD} },
	[0x2FCA] = { unicodeslot=0x2FCA, category='so', description='KANGXI RADICAL BLACK', specials={'compat',0x9ED1} },
	[0x2FCB] = { unicodeslot=0x2FCB, category='so', description='KANGXI RADICAL EMBROIDERY', specials={'compat',0x9EF9} },
	[0x2FCC] = { unicodeslot=0x2FCC, category='so', description='KANGXI RADICAL FROG', specials={'compat',0x9EFD} },
	[0x2FCD] = { unicodeslot=0x2FCD, category='so', description='KANGXI RADICAL TRIPOD', specials={'compat',0x9F0E} },
	[0x2FCE] = { unicodeslot=0x2FCE, category='so', description='KANGXI RADICAL DRUM', specials={'compat',0x9F13} },
	[0x2FCF] = { unicodeslot=0x2FCF, category='so', description='KANGXI RADICAL RAT', specials={'compat',0x9F20} },
	[0x2FD0] = { unicodeslot=0x2FD0, category='so', description='KANGXI RADICAL NOSE', specials={'compat',0x9F3B} },
	[0x2FD1] = { unicodeslot=0x2FD1, category='so', description='KANGXI RADICAL EVEN', specials={'compat',0x9F4A} },
	[0x2FD2] = { unicodeslot=0x2FD2, category='so', description='KANGXI RADICAL TOOTH', specials={'compat',0x9F52} },
	[0x2FD3] = { unicodeslot=0x2FD3, category='so', description='KANGXI RADICAL DRAGON', specials={'compat',0x9F8D} },
	[0x2FD4] = { unicodeslot=0x2FD4, category='so', description='KANGXI RADICAL TURTLE', specials={'compat',0x9F9C} },
	[0x2FD5] = { unicodeslot=0x2FD5, category='so', description='KANGXI RADICAL FLUTE', specials={'compat',0x9FA0} },
	[0x2FF0] = { unicodeslot=0x2FF0, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT' },
	[0x2FF1] = { unicodeslot=0x2FF1, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO BELOW' },
	[0x2FF2] = { unicodeslot=0x2FF2, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO MIDDLE AND RIGHT' },
	[0x2FF3] = { unicodeslot=0x2FF3, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO MIDDLE AND BELOW' },
	[0x2FF4] = { unicodeslot=0x2FF4, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER FULL SURROUND' },
	[0x2FF5] = { unicodeslot=0x2FF5, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM ABOVE' },
	[0x2FF6] = { unicodeslot=0x2FF6, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM BELOW' },
	[0x2FF7] = { unicodeslot=0x2FF7, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LEFT' },
	[0x2FF8] = { unicodeslot=0x2FF8, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER LEFT' },
	[0x2FF9] = { unicodeslot=0x2FF9, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER RIGHT' },
	[0x2FFA] = { unicodeslot=0x2FFA, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LOWER LEFT' },
	[0x2FFB] = { unicodeslot=0x2FFB, category='so', description='IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID' },
	[0x3000] = { unicodeslot=0x3000, category='zs', description='IDEOGRAPHIC SPACE', specials={'wide',0x0020} },
	[0x3001] = { unicodeslot=0x3001, category='po', description='IDEOGRAPHIC COMMA' },
	[0x3002] = { unicodeslot=0x3002, category='po', description='IDEOGRAPHIC FULL STOP' },
	[0x3003] = { unicodeslot=0x3003, category='po', description='DITTO MARK' },
	[0x3004] = { unicodeslot=0x3004, category='so', description='JAPANESE INDUSTRIAL STANDARD SYMBOL' },
	[0x3005] = { unicodeslot=0x3005, category='lm', description='IDEOGRAPHIC ITERATION MARK' },
	[0x3006] = { unicodeslot=0x3006, category='lo', description='IDEOGRAPHIC CLOSING MARK' },
	[0x3007] = { unicodeslot=0x3007, category='nl', description='IDEOGRAPHIC NUMBER ZERO' },
	[0x3008] = { unicodeslot=0x3008, category='ps', description='LEFT ANGLE BRACKET' },
	[0x3009] = { unicodeslot=0x3009, category='pe', description='RIGHT ANGLE BRACKET' },
	[0x300A] = { unicodeslot=0x300A, category='ps', description='LEFT DOUBLE ANGLE BRACKET' },
	[0x300B] = { unicodeslot=0x300B, category='pe', description='RIGHT DOUBLE ANGLE BRACKET' },
	[0x300C] = { unicodeslot=0x300C, category='ps', description='LEFT CORNER BRACKET' },
	[0x300D] = { unicodeslot=0x300D, category='pe', description='RIGHT CORNER BRACKET' },
	[0x300E] = { unicodeslot=0x300E, category='ps', description='LEFT WHITE CORNER BRACKET' },
	[0x300F] = { unicodeslot=0x300F, category='pe', description='RIGHT WHITE CORNER BRACKET' },
	[0x3010] = { unicodeslot=0x3010, category='ps', description='LEFT BLACK LENTICULAR BRACKET' },
	[0x3011] = { unicodeslot=0x3011, category='pe', description='RIGHT BLACK LENTICULAR BRACKET' },
	[0x3012] = { unicodeslot=0x3012, category='so', description='POSTAL MARK' },
	[0x3013] = { unicodeslot=0x3013, category='so', description='GETA MARK' },
	[0x3014] = { unicodeslot=0x3014, category='ps', description='LEFT TORTOISE SHELL BRACKET' },
	[0x3015] = { unicodeslot=0x3015, category='pe', description='RIGHT TORTOISE SHELL BRACKET' },
	[0x3016] = { unicodeslot=0x3016, category='ps', description='LEFT WHITE LENTICULAR BRACKET' },
	[0x3017] = { unicodeslot=0x3017, category='pe', description='RIGHT WHITE LENTICULAR BRACKET' },
	[0x3018] = { unicodeslot=0x3018, category='ps', description='LEFT WHITE TORTOISE SHELL BRACKET' },
	[0x3019] = { unicodeslot=0x3019, category='pe', description='RIGHT WHITE TORTOISE SHELL BRACKET' },
	[0x301A] = { unicodeslot=0x301A, category='ps', description='LEFT WHITE SQUARE BRACKET' },
	[0x301B] = { unicodeslot=0x301B, category='pe', description='RIGHT WHITE SQUARE BRACKET' },
	[0x301C] = { unicodeslot=0x301C, category='pd', description='WAVE DASH' },
	[0x301D] = { unicodeslot=0x301D, category='ps', description='REVERSED DOUBLE PRIME QUOTATION MARK' },
	[0x301E] = { unicodeslot=0x301E, category='pe', description='DOUBLE PRIME QUOTATION MARK' },
	[0x301F] = { unicodeslot=0x301F, category='pe', description='LOW DOUBLE PRIME QUOTATION MARK' },
	[0x3020] = { unicodeslot=0x3020, category='so', description='POSTAL MARK FACE' },
	[0x3021] = { unicodeslot=0x3021, category='nl', description='HANGZHOU NUMERAL ONE' },
	[0x3022] = { unicodeslot=0x3022, category='nl', description='HANGZHOU NUMERAL TWO' },
	[0x3023] = { unicodeslot=0x3023, category='nl', description='HANGZHOU NUMERAL THREE' },
	[0x3024] = { unicodeslot=0x3024, category='nl', description='HANGZHOU NUMERAL FOUR' },
	[0x3025] = { unicodeslot=0x3025, category='nl', description='HANGZHOU NUMERAL FIVE' },
	[0x3026] = { unicodeslot=0x3026, category='nl', description='HANGZHOU NUMERAL SIX' },
	[0x3027] = { unicodeslot=0x3027, category='nl', description='HANGZHOU NUMERAL SEVEN' },
	[0x3028] = { unicodeslot=0x3028, category='nl', description='HANGZHOU NUMERAL EIGHT' },
	[0x3029] = { unicodeslot=0x3029, category='nl', description='HANGZHOU NUMERAL NINE' },
	[0x302A] = { unicodeslot=0x302A, category='mn', description='IDEOGRAPHIC LEVEL TONE MARK' },
	[0x302B] = { unicodeslot=0x302B, category='mn', description='IDEOGRAPHIC RISING TONE MARK' },
	[0x302C] = { unicodeslot=0x302C, category='mn', description='IDEOGRAPHIC DEPARTING TONE MARK' },
	[0x302D] = { unicodeslot=0x302D, category='mn', description='IDEOGRAPHIC ENTERING TONE MARK' },
	[0x302E] = { unicodeslot=0x302E, category='mn', description='HANGUL SINGLE DOT TONE MARK' },
	[0x302F] = { unicodeslot=0x302F, category='mn', description='HANGUL DOUBLE DOT TONE MARK' },
	[0x3030] = { unicodeslot=0x3030, category='pd', description='WAVY DASH' },
	[0x3031] = { unicodeslot=0x3031, category='lm', description='VERTICAL KANA REPEAT MARK' },
	[0x3032] = { unicodeslot=0x3032, category='lm', description='VERTICAL KANA REPEAT WITH VOICED SOUND MARK' },
	[0x3033] = { unicodeslot=0x3033, category='lm', description='VERTICAL KANA REPEAT MARK UPPER HALF' },
	[0x3034] = { unicodeslot=0x3034, category='lm', description='VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF' },
	[0x3035] = { unicodeslot=0x3035, category='lm', description='VERTICAL KANA REPEAT MARK LOWER HALF' },
	[0x3036] = { unicodeslot=0x3036, category='so', description='CIRCLED POSTAL MARK', specials={'compat',0x3012} },
	[0x3037] = { unicodeslot=0x3037, category='so', description='IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL' },
	[0x3038] = { unicodeslot=0x3038, category='nl', description='HANGZHOU NUMERAL TEN', specials={'compat',0x5341} },
	[0x3039] = { unicodeslot=0x3039, category='nl', description='HANGZHOU NUMERAL TWENTY', specials={'compat',0x5344} },
	[0x303A] = { unicodeslot=0x303A, category='nl', description='HANGZHOU NUMERAL THIRTY', specials={'compat',0x5345} },
	[0x303B] = { unicodeslot=0x303B, category='lm', description='VERTICAL IDEOGRAPHIC ITERATION MARK' },
	[0x303C] = { unicodeslot=0x303C, category='lo', description='MASU MARK' },
	[0x303D] = { unicodeslot=0x303D, category='po', description='PART ALTERNATION MARK' },
	[0x303E] = { unicodeslot=0x303E, category='so', description='IDEOGRAPHIC VARIATION INDICATOR' },
	[0x303F] = { unicodeslot=0x303F, category='so', description='IDEOGRAPHIC HALF FILL SPACE' },
	[0x3041] = { unicodeslot=0x3041, category='lo', description='HIRAGANA LETTER SMALL A' },
	[0x3042] = { unicodeslot=0x3042, category='lo', description='HIRAGANA LETTER A' },
	[0x3043] = { unicodeslot=0x3043, category='lo', description='HIRAGANA LETTER SMALL I' },
	[0x3044] = { unicodeslot=0x3044, category='lo', description='HIRAGANA LETTER I' },
	[0x3045] = { unicodeslot=0x3045, category='lo', description='HIRAGANA LETTER SMALL U' },
	[0x3046] = { unicodeslot=0x3046, category='lo', description='HIRAGANA LETTER U' },
	[0x3047] = { unicodeslot=0x3047, category='lo', description='HIRAGANA LETTER SMALL E' },
	[0x3048] = { unicodeslot=0x3048, category='lo', description='HIRAGANA LETTER E' },
	[0x3049] = { unicodeslot=0x3049, category='lo', description='HIRAGANA LETTER SMALL O' },
	[0x304A] = { unicodeslot=0x304A, category='lo', description='HIRAGANA LETTER O' },
	[0x304B] = { unicodeslot=0x304B, category='lo', description='HIRAGANA LETTER KA' },
	[0x304C] = { unicodeslot=0x304C, category='lo', description='HIRAGANA LETTER GA', specials={'char',0x304B,0x3099} },
	[0x304D] = { unicodeslot=0x304D, category='lo', description='HIRAGANA LETTER KI' },
	[0x304E] = { unicodeslot=0x304E, category='lo', description='HIRAGANA LETTER GI', specials={'char',0x304D,0x3099} },
	[0x304F] = { unicodeslot=0x304F, category='lo', description='HIRAGANA LETTER KU' },
	[0x3050] = { unicodeslot=0x3050, category='lo', description='HIRAGANA LETTER GU', specials={'char',0x304F,0x3099} },
	[0x3051] = { unicodeslot=0x3051, category='lo', description='HIRAGANA LETTER KE' },
	[0x3052] = { unicodeslot=0x3052, category='lo', description='HIRAGANA LETTER GE', specials={'char',0x3051,0x3099} },
	[0x3053] = { unicodeslot=0x3053, category='lo', description='HIRAGANA LETTER KO' },
	[0x3054] = { unicodeslot=0x3054, category='lo', description='HIRAGANA LETTER GO', specials={'char',0x3053,0x3099} },
	[0x3055] = { unicodeslot=0x3055, category='lo', description='HIRAGANA LETTER SA' },
	[0x3056] = { unicodeslot=0x3056, category='lo', description='HIRAGANA LETTER ZA', specials={'char',0x3055,0x3099} },
	[0x3057] = { unicodeslot=0x3057, category='lo', description='HIRAGANA LETTER SI' },
	[0x3058] = { unicodeslot=0x3058, category='lo', description='HIRAGANA LETTER ZI', specials={'char',0x3057,0x3099} },
	[0x3059] = { unicodeslot=0x3059, category='lo', description='HIRAGANA LETTER SU' },
	[0x305A] = { unicodeslot=0x305A, category='lo', description='HIRAGANA LETTER ZU', specials={'char',0x3059,0x3099} },
	[0x305B] = { unicodeslot=0x305B, category='lo', description='HIRAGANA LETTER SE' },
	[0x305C] = { unicodeslot=0x305C, category='lo', description='HIRAGANA LETTER ZE', specials={'char',0x305B,0x3099} },
	[0x305D] = { unicodeslot=0x305D, category='lo', description='HIRAGANA LETTER SO' },
	[0x305E] = { unicodeslot=0x305E, category='lo', description='HIRAGANA LETTER ZO', specials={'char',0x305D,0x3099} },
	[0x305F] = { unicodeslot=0x305F, category='lo', description='HIRAGANA LETTER TA' },
	[0x3060] = { unicodeslot=0x3060, category='lo', description='HIRAGANA LETTER DA', specials={'char',0x305F,0x3099} },
	[0x3061] = { unicodeslot=0x3061, category='lo', description='HIRAGANA LETTER TI' },
	[0x3062] = { unicodeslot=0x3062, category='lo', description='HIRAGANA LETTER DI', specials={'char',0x3061,0x3099} },
	[0x3063] = { unicodeslot=0x3063, category='lo', description='HIRAGANA LETTER SMALL TU' },
	[0x3064] = { unicodeslot=0x3064, category='lo', description='HIRAGANA LETTER TU' },
	[0x3065] = { unicodeslot=0x3065, category='lo', description='HIRAGANA LETTER DU', specials={'char',0x3064,0x3099} },
	[0x3066] = { unicodeslot=0x3066, category='lo', description='HIRAGANA LETTER TE' },
	[0x3067] = { unicodeslot=0x3067, category='lo', description='HIRAGANA LETTER DE', specials={'char',0x3066,0x3099} },
	[0x3068] = { unicodeslot=0x3068, category='lo', description='HIRAGANA LETTER TO' },
	[0x3069] = { unicodeslot=0x3069, category='lo', description='HIRAGANA LETTER DO', specials={'char',0x3068,0x3099} },
	[0x306A] = { unicodeslot=0x306A, category='lo', description='HIRAGANA LETTER NA' },
	[0x306B] = { unicodeslot=0x306B, category='lo', description='HIRAGANA LETTER NI' },
	[0x306C] = { unicodeslot=0x306C, category='lo', description='HIRAGANA LETTER NU' },
	[0x306D] = { unicodeslot=0x306D, category='lo', description='HIRAGANA LETTER NE' },
	[0x306E] = { unicodeslot=0x306E, category='lo', description='HIRAGANA LETTER NO' },
	[0x306F] = { unicodeslot=0x306F, category='lo', description='HIRAGANA LETTER HA' },
	[0x3070] = { unicodeslot=0x3070, category='lo', description='HIRAGANA LETTER BA', specials={'char',0x306F,0x3099} },
	[0x3071] = { unicodeslot=0x3071, category='lo', description='HIRAGANA LETTER PA', specials={'char',0x306F,0x309A} },
	[0x3072] = { unicodeslot=0x3072, category='lo', description='HIRAGANA LETTER HI' },
	[0x3073] = { unicodeslot=0x3073, category='lo', description='HIRAGANA LETTER BI', specials={'char',0x3072,0x3099} },
	[0x3074] = { unicodeslot=0x3074, category='lo', description='HIRAGANA LETTER PI', specials={'char',0x3072,0x309A} },
	[0x3075] = { unicodeslot=0x3075, category='lo', description='HIRAGANA LETTER HU' },
	[0x3076] = { unicodeslot=0x3076, category='lo', description='HIRAGANA LETTER BU', specials={'char',0x3075,0x3099} },
	[0x3077] = { unicodeslot=0x3077, category='lo', description='HIRAGANA LETTER PU', specials={'char',0x3075,0x309A} },
	[0x3078] = { unicodeslot=0x3078, category='lo', description='HIRAGANA LETTER HE' },
	[0x3079] = { unicodeslot=0x3079, category='lo', description='HIRAGANA LETTER BE', specials={'char',0x3078,0x3099} },
	[0x307A] = { unicodeslot=0x307A, category='lo', description='HIRAGANA LETTER PE', specials={'char',0x3078,0x309A} },
	[0x307B] = { unicodeslot=0x307B, category='lo', description='HIRAGANA LETTER HO' },
	[0x307C] = { unicodeslot=0x307C, category='lo', description='HIRAGANA LETTER BO', specials={'char',0x307B,0x3099} },
	[0x307D] = { unicodeslot=0x307D, category='lo', description='HIRAGANA LETTER PO', specials={'char',0x307B,0x309A} },
	[0x307E] = { unicodeslot=0x307E, category='lo', description='HIRAGANA LETTER MA' },
	[0x307F] = { unicodeslot=0x307F, category='lo', description='HIRAGANA LETTER MI' },
	[0x3080] = { unicodeslot=0x3080, category='lo', description='HIRAGANA LETTER MU' },
	[0x3081] = { unicodeslot=0x3081, category='lo', description='HIRAGANA LETTER ME' },
	[0x3082] = { unicodeslot=0x3082, category='lo', description='HIRAGANA LETTER MO' },
	[0x3083] = { unicodeslot=0x3083, category='lo', description='HIRAGANA LETTER SMALL YA' },
	[0x3084] = { unicodeslot=0x3084, category='lo', description='HIRAGANA LETTER YA' },
	[0x3085] = { unicodeslot=0x3085, category='lo', description='HIRAGANA LETTER SMALL YU' },
	[0x3086] = { unicodeslot=0x3086, category='lo', description='HIRAGANA LETTER YU' },
	[0x3087] = { unicodeslot=0x3087, category='lo', description='HIRAGANA LETTER SMALL YO' },
	[0x3088] = { unicodeslot=0x3088, category='lo', description='HIRAGANA LETTER YO' },
	[0x3089] = { unicodeslot=0x3089, category='lo', description='HIRAGANA LETTER RA' },
	[0x308A] = { unicodeslot=0x308A, category='lo', description='HIRAGANA LETTER RI' },
	[0x308B] = { unicodeslot=0x308B, category='lo', description='HIRAGANA LETTER RU' },
	[0x308C] = { unicodeslot=0x308C, category='lo', description='HIRAGANA LETTER RE' },
	[0x308D] = { unicodeslot=0x308D, category='lo', description='HIRAGANA LETTER RO' },
	[0x308E] = { unicodeslot=0x308E, category='lo', description='HIRAGANA LETTER SMALL WA' },
	[0x308F] = { unicodeslot=0x308F, category='lo', description='HIRAGANA LETTER WA' },
	[0x3090] = { unicodeslot=0x3090, category='lo', description='HIRAGANA LETTER WI' },
	[0x3091] = { unicodeslot=0x3091, category='lo', description='HIRAGANA LETTER WE' },
	[0x3092] = { unicodeslot=0x3092, category='lo', description='HIRAGANA LETTER WO' },
	[0x3093] = { unicodeslot=0x3093, category='lo', description='HIRAGANA LETTER N' },
	[0x3094] = { unicodeslot=0x3094, category='lo', description='HIRAGANA LETTER VU', specials={'char',0x3046,0x3099} },
	[0x3095] = { unicodeslot=0x3095, category='lo', description='HIRAGANA LETTER SMALL KA' },
	[0x3096] = { unicodeslot=0x3096, category='lo', description='HIRAGANA LETTER SMALL KE' },
	[0x3099] = { unicodeslot=0x3099, category='mn', description='COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK' },
	[0x309A] = { unicodeslot=0x309A, category='mn', description='COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK' },
	[0x309B] = { unicodeslot=0x309B, category='sk', description='KATAKANA-HIRAGANA VOICED SOUND MARK', specials={'compat',0x0020,0x3099} },
	[0x309C] = { unicodeslot=0x309C, category='sk', description='KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK', specials={'compat',0x0020,0x309A} },
	[0x309D] = { unicodeslot=0x309D, category='lm', description='HIRAGANA ITERATION MARK' },
	[0x309E] = { unicodeslot=0x309E, category='lm', description='HIRAGANA VOICED ITERATION MARK', specials={'char',0x309D,0x3099} },
	[0x309F] = { unicodeslot=0x309F, category='lo', description='HIRAGANA DIGRAPH YORI', specials={'vertical',0x3088,0x308A} },
	[0x30A0] = { unicodeslot=0x30A0, category='pd', description='KATAKANA-HIRAGANA DOUBLE HYPHEN' },
	[0x30A1] = { unicodeslot=0x30A1, category='lo', description='KATAKANA LETTER SMALL A' },
	[0x30A2] = { unicodeslot=0x30A2, category='lo', description='KATAKANA LETTER A' },
	[0x30A3] = { unicodeslot=0x30A3, category='lo', description='KATAKANA LETTER SMALL I' },
	[0x30A4] = { unicodeslot=0x30A4, category='lo', description='KATAKANA LETTER I' },
	[0x30A5] = { unicodeslot=0x30A5, category='lo', description='KATAKANA LETTER SMALL U' },
	[0x30A6] = { unicodeslot=0x30A6, category='lo', description='KATAKANA LETTER U' },
	[0x30A7] = { unicodeslot=0x30A7, category='lo', description='KATAKANA LETTER SMALL E' },
	[0x30A8] = { unicodeslot=0x30A8, category='lo', description='KATAKANA LETTER E' },
	[0x30A9] = { unicodeslot=0x30A9, category='lo', description='KATAKANA LETTER SMALL O' },
	[0x30AA] = { unicodeslot=0x30AA, category='lo', description='KATAKANA LETTER O' },
	[0x30AB] = { unicodeslot=0x30AB, category='lo', description='KATAKANA LETTER KA' },
	[0x30AC] = { unicodeslot=0x30AC, category='lo', description='KATAKANA LETTER GA', specials={'char',0x30AB,0x3099} },
	[0x30AD] = { unicodeslot=0x30AD, category='lo', description='KATAKANA LETTER KI' },
	[0x30AE] = { unicodeslot=0x30AE, category='lo', description='KATAKANA LETTER GI', specials={'char',0x30AD,0x3099} },
	[0x30AF] = { unicodeslot=0x30AF, category='lo', description='KATAKANA LETTER KU' },
	[0x30B0] = { unicodeslot=0x30B0, category='lo', description='KATAKANA LETTER GU', specials={'char',0x30AF,0x3099} },
	[0x30B1] = { unicodeslot=0x30B1, category='lo', description='KATAKANA LETTER KE' },
	[0x30B2] = { unicodeslot=0x30B2, category='lo', description='KATAKANA LETTER GE', specials={'char',0x30B1,0x3099} },
	[0x30B3] = { unicodeslot=0x30B3, category='lo', description='KATAKANA LETTER KO' },
	[0x30B4] = { unicodeslot=0x30B4, category='lo', description='KATAKANA LETTER GO', specials={'char',0x30B3,0x3099} },
	[0x30B5] = { unicodeslot=0x30B5, category='lo', description='KATAKANA LETTER SA' },
	[0x30B6] = { unicodeslot=0x30B6, category='lo', description='KATAKANA LETTER ZA', specials={'char',0x30B5,0x3099} },
	[0x30B7] = { unicodeslot=0x30B7, category='lo', description='KATAKANA LETTER SI' },
	[0x30B8] = { unicodeslot=0x30B8, category='lo', description='KATAKANA LETTER ZI', specials={'char',0x30B7,0x3099} },
	[0x30B9] = { unicodeslot=0x30B9, category='lo', description='KATAKANA LETTER SU' },
	[0x30BA] = { unicodeslot=0x30BA, category='lo', description='KATAKANA LETTER ZU', specials={'char',0x30B9,0x3099} },
	[0x30BB] = { unicodeslot=0x30BB, category='lo', description='KATAKANA LETTER SE' },
	[0x30BC] = { unicodeslot=0x30BC, category='lo', description='KATAKANA LETTER ZE', specials={'char',0x30BB,0x3099} },
	[0x30BD] = { unicodeslot=0x30BD, category='lo', description='KATAKANA LETTER SO' },
	[0x30BE] = { unicodeslot=0x30BE, category='lo', description='KATAKANA LETTER ZO', specials={'char',0x30BD,0x3099} },
	[0x30BF] = { unicodeslot=0x30BF, category='lo', description='KATAKANA LETTER TA' },
	[0x30C0] = { unicodeslot=0x30C0, category='lo', description='KATAKANA LETTER DA', specials={'char',0x30BF,0x3099} },
	[0x30C1] = { unicodeslot=0x30C1, category='lo', description='KATAKANA LETTER TI' },
	[0x30C2] = { unicodeslot=0x30C2, category='lo', description='KATAKANA LETTER DI', specials={'char',0x30C1,0x3099} },
	[0x30C3] = { unicodeslot=0x30C3, category='lo', description='KATAKANA LETTER SMALL TU' },
	[0x30C4] = { unicodeslot=0x30C4, category='lo', description='KATAKANA LETTER TU' },
	[0x30C5] = { unicodeslot=0x30C5, category='lo', description='KATAKANA LETTER DU', specials={'char',0x30C4,0x3099} },
	[0x30C6] = { unicodeslot=0x30C6, category='lo', description='KATAKANA LETTER TE' },
	[0x30C7] = { unicodeslot=0x30C7, category='lo', description='KATAKANA LETTER DE', specials={'char',0x30C6,0x3099} },
	[0x30C8] = { unicodeslot=0x30C8, category='lo', description='KATAKANA LETTER TO' },
	[0x30C9] = { unicodeslot=0x30C9, category='lo', description='KATAKANA LETTER DO', specials={'char',0x30C8,0x3099} },
	[0x30CA] = { unicodeslot=0x30CA, category='lo', description='KATAKANA LETTER NA' },
	[0x30CB] = { unicodeslot=0x30CB, category='lo', description='KATAKANA LETTER NI' },
	[0x30CC] = { unicodeslot=0x30CC, category='lo', description='KATAKANA LETTER NU' },
	[0x30CD] = { unicodeslot=0x30CD, category='lo', description='KATAKANA LETTER NE' },
	[0x30CE] = { unicodeslot=0x30CE, category='lo', description='KATAKANA LETTER NO' },
	[0x30CF] = { unicodeslot=0x30CF, category='lo', description='KATAKANA LETTER HA' },
	[0x30D0] = { unicodeslot=0x30D0, category='lo', description='KATAKANA LETTER BA', specials={'char',0x30CF,0x3099} },
	[0x30D1] = { unicodeslot=0x30D1, category='lo', description='KATAKANA LETTER PA', specials={'char',0x30CF,0x309A} },
	[0x30D2] = { unicodeslot=0x30D2, category='lo', description='KATAKANA LETTER HI' },
	[0x30D3] = { unicodeslot=0x30D3, category='lo', description='KATAKANA LETTER BI', specials={'char',0x30D2,0x3099} },
	[0x30D4] = { unicodeslot=0x30D4, category='lo', description='KATAKANA LETTER PI', specials={'char',0x30D2,0x309A} },
	[0x30D5] = { unicodeslot=0x30D5, category='lo', description='KATAKANA LETTER HU' },
	[0x30D6] = { unicodeslot=0x30D6, category='lo', description='KATAKANA LETTER BU', specials={'char',0x30D5,0x3099} },
	[0x30D7] = { unicodeslot=0x30D7, category='lo', description='KATAKANA LETTER PU', specials={'char',0x30D5,0x309A} },
	[0x30D8] = { unicodeslot=0x30D8, category='lo', description='KATAKANA LETTER HE' },
	[0x30D9] = { unicodeslot=0x30D9, category='lo', description='KATAKANA LETTER BE', specials={'char',0x30D8,0x3099} },
	[0x30DA] = { unicodeslot=0x30DA, category='lo', description='KATAKANA LETTER PE', specials={'char',0x30D8,0x309A} },
	[0x30DB] = { unicodeslot=0x30DB, category='lo', description='KATAKANA LETTER HO' },
	[0x30DC] = { unicodeslot=0x30DC, category='lo', description='KATAKANA LETTER BO', specials={'char',0x30DB,0x3099} },
	[0x30DD] = { unicodeslot=0x30DD, category='lo', description='KATAKANA LETTER PO', specials={'char',0x30DB,0x309A} },
	[0x30DE] = { unicodeslot=0x30DE, category='lo', description='KATAKANA LETTER MA' },
	[0x30DF] = { unicodeslot=0x30DF, category='lo', description='KATAKANA LETTER MI' },
	[0x30E0] = { unicodeslot=0x30E0, category='lo', description='KATAKANA LETTER MU' },
	[0x30E1] = { unicodeslot=0x30E1, category='lo', description='KATAKANA LETTER ME' },
	[0x30E2] = { unicodeslot=0x30E2, category='lo', description='KATAKANA LETTER MO' },
	[0x30E3] = { unicodeslot=0x30E3, category='lo', description='KATAKANA LETTER SMALL YA' },
	[0x30E4] = { unicodeslot=0x30E4, category='lo', description='KATAKANA LETTER YA' },
	[0x30E5] = { unicodeslot=0x30E5, category='lo', description='KATAKANA LETTER SMALL YU' },
	[0x30E6] = { unicodeslot=0x30E6, category='lo', description='KATAKANA LETTER YU' },
	[0x30E7] = { unicodeslot=0x30E7, category='lo', description='KATAKANA LETTER SMALL YO' },
	[0x30E8] = { unicodeslot=0x30E8, category='lo', description='KATAKANA LETTER YO' },
	[0x30E9] = { unicodeslot=0x30E9, category='lo', description='KATAKANA LETTER RA' },
	[0x30EA] = { unicodeslot=0x30EA, category='lo', description='KATAKANA LETTER RI' },
	[0x30EB] = { unicodeslot=0x30EB, category='lo', description='KATAKANA LETTER RU' },
	[0x30EC] = { unicodeslot=0x30EC, category='lo', description='KATAKANA LETTER RE' },
	[0x30ED] = { unicodeslot=0x30ED, category='lo', description='KATAKANA LETTER RO' },
	[0x30EE] = { unicodeslot=0x30EE, category='lo', description='KATAKANA LETTER SMALL WA' },
	[0x30EF] = { unicodeslot=0x30EF, category='lo', description='KATAKANA LETTER WA' },
	[0x30F0] = { unicodeslot=0x30F0, category='lo', description='KATAKANA LETTER WI' },
	[0x30F1] = { unicodeslot=0x30F1, category='lo', description='KATAKANA LETTER WE' },
	[0x30F2] = { unicodeslot=0x30F2, category='lo', description='KATAKANA LETTER WO' },
	[0x30F3] = { unicodeslot=0x30F3, category='lo', description='KATAKANA LETTER N' },
	[0x30F4] = { unicodeslot=0x30F4, category='lo', description='KATAKANA LETTER VU', specials={'char',0x30A6,0x3099} },
	[0x30F5] = { unicodeslot=0x30F5, category='lo', description='KATAKANA LETTER SMALL KA' },
	[0x30F6] = { unicodeslot=0x30F6, category='lo', description='KATAKANA LETTER SMALL KE' },
	[0x30F7] = { unicodeslot=0x30F7, category='lo', description='KATAKANA LETTER VA', specials={'char',0x30EF,0x3099} },
	[0x30F8] = { unicodeslot=0x30F8, category='lo', description='KATAKANA LETTER VI', specials={'char',0x30F0,0x3099} },
	[0x30F9] = { unicodeslot=0x30F9, category='lo', description='KATAKANA LETTER VE', specials={'char',0x30F1,0x3099} },
	[0x30FA] = { unicodeslot=0x30FA, category='lo', description='KATAKANA LETTER VO', specials={'char',0x30F2,0x3099} },
	[0x30FB] = { unicodeslot=0x30FB, category='po', description='KATAKANA MIDDLE DOT' },
	[0x30FC] = { unicodeslot=0x30FC, category='lm', description='KATAKANA-HIRAGANA PROLONGED SOUND MARK' },
	[0x30FD] = { unicodeslot=0x30FD, category='lm', description='KATAKANA ITERATION MARK' },
	[0x30FE] = { unicodeslot=0x30FE, category='lm', description='KATAKANA VOICED ITERATION MARK', specials={'char',0x30FD,0x3099} },
	[0x30FF] = { unicodeslot=0x30FF, category='lo', description='KATAKANA DIGRAPH KOTO', specials={'vertical',0x30B3,0x30C8} },
	[0x3105] = { unicodeslot=0x3105, category='lo', description='BOPOMOFO LETTER B' },
	[0x3106] = { unicodeslot=0x3106, category='lo', description='BOPOMOFO LETTER P' },
	[0x3107] = { unicodeslot=0x3107, category='lo', description='BOPOMOFO LETTER M' },
	[0x3108] = { unicodeslot=0x3108, category='lo', description='BOPOMOFO LETTER F' },
	[0x3109] = { unicodeslot=0x3109, category='lo', description='BOPOMOFO LETTER D' },
	[0x310A] = { unicodeslot=0x310A, category='lo', description='BOPOMOFO LETTER T' },
	[0x310B] = { unicodeslot=0x310B, category='lo', description='BOPOMOFO LETTER N' },
	[0x310C] = { unicodeslot=0x310C, category='lo', description='BOPOMOFO LETTER L' },
	[0x310D] = { unicodeslot=0x310D, category='lo', description='BOPOMOFO LETTER G' },
	[0x310E] = { unicodeslot=0x310E, category='lo', description='BOPOMOFO LETTER K' },
	[0x310F] = { unicodeslot=0x310F, category='lo', description='BOPOMOFO LETTER H' },
	[0x3110] = { unicodeslot=0x3110, category='lo', description='BOPOMOFO LETTER J' },
	[0x3111] = { unicodeslot=0x3111, category='lo', description='BOPOMOFO LETTER Q' },
	[0x3112] = { unicodeslot=0x3112, category='lo', description='BOPOMOFO LETTER X' },
	[0x3113] = { unicodeslot=0x3113, category='lo', description='BOPOMOFO LETTER ZH' },
	[0x3114] = { unicodeslot=0x3114, category='lo', description='BOPOMOFO LETTER CH' },
	[0x3115] = { unicodeslot=0x3115, category='lo', description='BOPOMOFO LETTER SH' },
	[0x3116] = { unicodeslot=0x3116, category='lo', description='BOPOMOFO LETTER R' },
	[0x3117] = { unicodeslot=0x3117, category='lo', description='BOPOMOFO LETTER Z' },
	[0x3118] = { unicodeslot=0x3118, category='lo', description='BOPOMOFO LETTER C' },
	[0x3119] = { unicodeslot=0x3119, category='lo', description='BOPOMOFO LETTER S' },
	[0x311A] = { unicodeslot=0x311A, category='lo', description='BOPOMOFO LETTER A' },
	[0x311B] = { unicodeslot=0x311B, category='lo', description='BOPOMOFO LETTER O' },
	[0x311C] = { unicodeslot=0x311C, category='lo', description='BOPOMOFO LETTER E' },
	[0x311D] = { unicodeslot=0x311D, category='lo', description='BOPOMOFO LETTER EH' },
	[0x311E] = { unicodeslot=0x311E, category='lo', description='BOPOMOFO LETTER AI' },
	[0x311F] = { unicodeslot=0x311F, category='lo', description='BOPOMOFO LETTER EI' },
	[0x3120] = { unicodeslot=0x3120, category='lo', description='BOPOMOFO LETTER AU' },
	[0x3121] = { unicodeslot=0x3121, category='lo', description='BOPOMOFO LETTER OU' },
	[0x3122] = { unicodeslot=0x3122, category='lo', description='BOPOMOFO LETTER AN' },
	[0x3123] = { unicodeslot=0x3123, category='lo', description='BOPOMOFO LETTER EN' },
	[0x3124] = { unicodeslot=0x3124, category='lo', description='BOPOMOFO LETTER ANG' },
	[0x3125] = { unicodeslot=0x3125, category='lo', description='BOPOMOFO LETTER ENG' },
	[0x3126] = { unicodeslot=0x3126, category='lo', description='BOPOMOFO LETTER ER' },
	[0x3127] = { unicodeslot=0x3127, category='lo', description='BOPOMOFO LETTER I' },
	[0x3128] = { unicodeslot=0x3128, category='lo', description='BOPOMOFO LETTER U' },
	[0x3129] = { unicodeslot=0x3129, category='lo', description='BOPOMOFO LETTER IU' },
	[0x312A] = { unicodeslot=0x312A, category='lo', description='BOPOMOFO LETTER V' },
	[0x312B] = { unicodeslot=0x312B, category='lo', description='BOPOMOFO LETTER NG' },
	[0x312C] = { unicodeslot=0x312C, category='lo', description='BOPOMOFO LETTER GN' },
	[0x3131] = { unicodeslot=0x3131, category='lo', description='HANGUL LETTER KIYEOK', specials={'compat',0x1100} },
	[0x3132] = { unicodeslot=0x3132, category='lo', description='HANGUL LETTER SSANGKIYEOK', specials={'compat',0x1101} },
	[0x3133] = { unicodeslot=0x3133, category='lo', description='HANGUL LETTER KIYEOK-SIOS', specials={'compat',0x11AA} },
	[0x3134] = { unicodeslot=0x3134, category='lo', description='HANGUL LETTER NIEUN', specials={'compat',0x1102} },
	[0x3135] = { unicodeslot=0x3135, category='lo', description='HANGUL LETTER NIEUN-CIEUC', specials={'compat',0x11AC} },
	[0x3136] = { unicodeslot=0x3136, category='lo', description='HANGUL LETTER NIEUN-HIEUH', specials={'compat',0x11AD} },
	[0x3137] = { unicodeslot=0x3137, category='lo', description='HANGUL LETTER TIKEUT', specials={'compat',0x1103} },
	[0x3138] = { unicodeslot=0x3138, category='lo', description='HANGUL LETTER SSANGTIKEUT', specials={'compat',0x1104} },
	[0x3139] = { unicodeslot=0x3139, category='lo', description='HANGUL LETTER RIEUL', specials={'compat',0x1105} },
	[0x313A] = { unicodeslot=0x313A, category='lo', description='HANGUL LETTER RIEUL-KIYEOK', specials={'compat',0x11B0} },
	[0x313B] = { unicodeslot=0x313B, category='lo', description='HANGUL LETTER RIEUL-MIEUM', specials={'compat',0x11B1} },
	[0x313C] = { unicodeslot=0x313C, category='lo', description='HANGUL LETTER RIEUL-PIEUP', specials={'compat',0x11B2} },
	[0x313D] = { unicodeslot=0x313D, category='lo', description='HANGUL LETTER RIEUL-SIOS', specials={'compat',0x11B3} },
	[0x313E] = { unicodeslot=0x313E, category='lo', description='HANGUL LETTER RIEUL-THIEUTH', specials={'compat',0x11B4} },
	[0x313F] = { unicodeslot=0x313F, category='lo', description='HANGUL LETTER RIEUL-PHIEUPH', specials={'compat',0x11B5} },
	[0x3140] = { unicodeslot=0x3140, category='lo', description='HANGUL LETTER RIEUL-HIEUH', specials={'compat',0x111A} },
	[0x3141] = { unicodeslot=0x3141, category='lo', description='HANGUL LETTER MIEUM', specials={'compat',0x1106} },
	[0x3142] = { unicodeslot=0x3142, category='lo', description='HANGUL LETTER PIEUP', specials={'compat',0x1107} },
	[0x3143] = { unicodeslot=0x3143, category='lo', description='HANGUL LETTER SSANGPIEUP', specials={'compat',0x1108} },
	[0x3144] = { unicodeslot=0x3144, category='lo', description='HANGUL LETTER PIEUP-SIOS', specials={'compat',0x1121} },
	[0x3145] = { unicodeslot=0x3145, category='lo', description='HANGUL LETTER SIOS', specials={'compat',0x1109} },
	[0x3146] = { unicodeslot=0x3146, category='lo', description='HANGUL LETTER SSANGSIOS', specials={'compat',0x110A} },
	[0x3147] = { unicodeslot=0x3147, category='lo', description='HANGUL LETTER IEUNG', specials={'compat',0x110B} },
	[0x3148] = { unicodeslot=0x3148, category='lo', description='HANGUL LETTER CIEUC', specials={'compat',0x110C} },
	[0x3149] = { unicodeslot=0x3149, category='lo', description='HANGUL LETTER SSANGCIEUC', specials={'compat',0x110D} },
	[0x314A] = { unicodeslot=0x314A, category='lo', description='HANGUL LETTER CHIEUCH', specials={'compat',0x110E} },
	[0x314B] = { unicodeslot=0x314B, category='lo', description='HANGUL LETTER KHIEUKH', specials={'compat',0x110F} },
	[0x314C] = { unicodeslot=0x314C, category='lo', description='HANGUL LETTER THIEUTH', specials={'compat',0x1110} },
	[0x314D] = { unicodeslot=0x314D, category='lo', description='HANGUL LETTER PHIEUPH', specials={'compat',0x1111} },
	[0x314E] = { unicodeslot=0x314E, category='lo', description='HANGUL LETTER HIEUH', specials={'compat',0x1112} },
	[0x314F] = { unicodeslot=0x314F, category='lo', description='HANGUL LETTER A', specials={'compat',0x1161} },
	[0x3150] = { unicodeslot=0x3150, category='lo', description='HANGUL LETTER AE', specials={'compat',0x1162} },
	[0x3151] = { unicodeslot=0x3151, category='lo', description='HANGUL LETTER YA', specials={'compat',0x1163} },
	[0x3152] = { unicodeslot=0x3152, category='lo', description='HANGUL LETTER YAE', specials={'compat',0x1164} },
	[0x3153] = { unicodeslot=0x3153, category='lo', description='HANGUL LETTER EO', specials={'compat',0x1165} },
	[0x3154] = { unicodeslot=0x3154, category='lo', description='HANGUL LETTER E', specials={'compat',0x1166} },
	[0x3155] = { unicodeslot=0x3155, category='lo', description='HANGUL LETTER YEO', specials={'compat',0x1167} },
	[0x3156] = { unicodeslot=0x3156, category='lo', description='HANGUL LETTER YE', specials={'compat',0x1168} },
	[0x3157] = { unicodeslot=0x3157, category='lo', description='HANGUL LETTER O', specials={'compat',0x1169} },
	[0x3158] = { unicodeslot=0x3158, category='lo', description='HANGUL LETTER WA', specials={'compat',0x116A} },
	[0x3159] = { unicodeslot=0x3159, category='lo', description='HANGUL LETTER WAE', specials={'compat',0x116B} },
	[0x315A] = { unicodeslot=0x315A, category='lo', description='HANGUL LETTER OE', specials={'compat',0x116C} },
	[0x315B] = { unicodeslot=0x315B, category='lo', description='HANGUL LETTER YO', specials={'compat',0x116D} },
	[0x315C] = { unicodeslot=0x315C, category='lo', description='HANGUL LETTER U', specials={'compat',0x116E} },
	[0x315D] = { unicodeslot=0x315D, category='lo', description='HANGUL LETTER WEO', specials={'compat',0x116F} },
	[0x315E] = { unicodeslot=0x315E, category='lo', description='HANGUL LETTER WE', specials={'compat',0x1170} },
	[0x315F] = { unicodeslot=0x315F, category='lo', description='HANGUL LETTER WI', specials={'compat',0x1171} },
	[0x3160] = { unicodeslot=0x3160, category='lo', description='HANGUL LETTER YU', specials={'compat',0x1172} },
	[0x3161] = { unicodeslot=0x3161, category='lo', description='HANGUL LETTER EU', specials={'compat',0x1173} },
	[0x3162] = { unicodeslot=0x3162, category='lo', description='HANGUL LETTER YI', specials={'compat',0x1174} },
	[0x3163] = { unicodeslot=0x3163, category='lo', description='HANGUL LETTER I', specials={'compat',0x1175} },
	[0x3164] = { unicodeslot=0x3164, category='lo', description='HANGUL FILLER', specials={'compat',0x1160} },
	[0x3165] = { unicodeslot=0x3165, category='lo', description='HANGUL LETTER SSANGNIEUN', specials={'compat',0x1114} },
	[0x3166] = { unicodeslot=0x3166, category='lo', description='HANGUL LETTER NIEUN-TIKEUT', specials={'compat',0x1115} },
	[0x3167] = { unicodeslot=0x3167, category='lo', description='HANGUL LETTER NIEUN-SIOS', specials={'compat',0x11C7} },
	[0x3168] = { unicodeslot=0x3168, category='lo', description='HANGUL LETTER NIEUN-PANSIOS', specials={'compat',0x11C8} },
	[0x3169] = { unicodeslot=0x3169, category='lo', description='HANGUL LETTER RIEUL-KIYEOK-SIOS', specials={'compat',0x11CC} },
	[0x316A] = { unicodeslot=0x316A, category='lo', description='HANGUL LETTER RIEUL-TIKEUT', specials={'compat',0x11CE} },
	[0x316B] = { unicodeslot=0x316B, category='lo', description='HANGUL LETTER RIEUL-PIEUP-SIOS', specials={'compat',0x11D3} },
	[0x316C] = { unicodeslot=0x316C, category='lo', description='HANGUL LETTER RIEUL-PANSIOS', specials={'compat',0x11D7} },
	[0x316D] = { unicodeslot=0x316D, category='lo', description='HANGUL LETTER RIEUL-YEORINHIEUH', specials={'compat',0x11D9} },
	[0x316E] = { unicodeslot=0x316E, category='lo', description='HANGUL LETTER MIEUM-PIEUP', specials={'compat',0x111C} },
	[0x316F] = { unicodeslot=0x316F, category='lo', description='HANGUL LETTER MIEUM-SIOS', specials={'compat',0x11DD} },
	[0x3170] = { unicodeslot=0x3170, category='lo', description='HANGUL LETTER MIEUM-PANSIOS', specials={'compat',0x11DF} },
	[0x3171] = { unicodeslot=0x3171, category='lo', description='HANGUL LETTER KAPYEOUNMIEUM', specials={'compat',0x111D} },
	[0x3172] = { unicodeslot=0x3172, category='lo', description='HANGUL LETTER PIEUP-KIYEOK', specials={'compat',0x111E} },
	[0x3173] = { unicodeslot=0x3173, category='lo', description='HANGUL LETTER PIEUP-TIKEUT', specials={'compat',0x1120} },
	[0x3174] = { unicodeslot=0x3174, category='lo', description='HANGUL LETTER PIEUP-SIOS-KIYEOK', specials={'compat',0x1122} },
	[0x3175] = { unicodeslot=0x3175, category='lo', description='HANGUL LETTER PIEUP-SIOS-TIKEUT', specials={'compat',0x1123} },
	[0x3176] = { unicodeslot=0x3176, category='lo', description='HANGUL LETTER PIEUP-CIEUC', specials={'compat',0x1127} },
	[0x3177] = { unicodeslot=0x3177, category='lo', description='HANGUL LETTER PIEUP-THIEUTH', specials={'compat',0x1129} },
	[0x3178] = { unicodeslot=0x3178, category='lo', description='HANGUL LETTER KAPYEOUNPIEUP', specials={'compat',0x112B} },
	[0x3179] = { unicodeslot=0x3179, category='lo', description='HANGUL LETTER KAPYEOUNSSANGPIEUP', specials={'compat',0x112C} },
	[0x317A] = { unicodeslot=0x317A, category='lo', description='HANGUL LETTER SIOS-KIYEOK', specials={'compat',0x112D} },
	[0x317B] = { unicodeslot=0x317B, category='lo', description='HANGUL LETTER SIOS-NIEUN', specials={'compat',0x112E} },
	[0x317C] = { unicodeslot=0x317C, category='lo', description='HANGUL LETTER SIOS-TIKEUT', specials={'compat',0x112F} },
	[0x317D] = { unicodeslot=0x317D, category='lo', description='HANGUL LETTER SIOS-PIEUP', specials={'compat',0x1132} },
	[0x317E] = { unicodeslot=0x317E, category='lo', description='HANGUL LETTER SIOS-CIEUC', specials={'compat',0x1136} },
	[0x317F] = { unicodeslot=0x317F, category='lo', description='HANGUL LETTER PANSIOS', specials={'compat',0x1140} },
	[0x3180] = { unicodeslot=0x3180, category='lo', description='HANGUL LETTER SSANGIEUNG', specials={'compat',0x1147} },
	[0x3181] = { unicodeslot=0x3181, category='lo', description='HANGUL LETTER YESIEUNG', specials={'compat',0x114C} },
	[0x3182] = { unicodeslot=0x3182, category='lo', description='HANGUL LETTER YESIEUNG-SIOS', specials={'compat',0x11F1} },
	[0x3183] = { unicodeslot=0x3183, category='lo', description='HANGUL LETTER YESIEUNG-PANSIOS', specials={'compat',0x11F2} },
	[0x3184] = { unicodeslot=0x3184, category='lo', description='HANGUL LETTER KAPYEOUNPHIEUPH', specials={'compat',0x1157} },
	[0x3185] = { unicodeslot=0x3185, category='lo', description='HANGUL LETTER SSANGHIEUH', specials={'compat',0x1158} },
	[0x3186] = { unicodeslot=0x3186, category='lo', description='HANGUL LETTER YEORINHIEUH', specials={'compat',0x1159} },
	[0x3187] = { unicodeslot=0x3187, category='lo', description='HANGUL LETTER YO-YA', specials={'compat',0x1184} },
	[0x3188] = { unicodeslot=0x3188, category='lo', description='HANGUL LETTER YO-YAE', specials={'compat',0x1185} },
	[0x3189] = { unicodeslot=0x3189, category='lo', description='HANGUL LETTER YO-I', specials={'compat',0x1188} },
	[0x318A] = { unicodeslot=0x318A, category='lo', description='HANGUL LETTER YU-YEO', specials={'compat',0x1191} },
	[0x318B] = { unicodeslot=0x318B, category='lo', description='HANGUL LETTER YU-YE', specials={'compat',0x1192} },
	[0x318C] = { unicodeslot=0x318C, category='lo', description='HANGUL LETTER YU-I', specials={'compat',0x1194} },
	[0x318D] = { unicodeslot=0x318D, category='lo', description='HANGUL LETTER ARAEA', specials={'compat',0x119E} },
	[0x318E] = { unicodeslot=0x318E, category='lo', description='HANGUL LETTER ARAEAE', specials={'compat',0x11A1} },
	[0x3190] = { unicodeslot=0x3190, category='so', description='IDEOGRAPHIC ANNOTATION LINKING MARK' },
	[0x3191] = { unicodeslot=0x3191, category='so', description='IDEOGRAPHIC ANNOTATION REVERSE MARK' },
	[0x3192] = { unicodeslot=0x3192, category='no', description='IDEOGRAPHIC ANNOTATION ONE MARK', specials={'super',0x4E00} },
	[0x3193] = { unicodeslot=0x3193, category='no', description='IDEOGRAPHIC ANNOTATION TWO MARK', specials={'super',0x4E8C} },
	[0x3194] = { unicodeslot=0x3194, category='no', description='IDEOGRAPHIC ANNOTATION THREE MARK', specials={'super',0x4E09} },
	[0x3195] = { unicodeslot=0x3195, category='no', description='IDEOGRAPHIC ANNOTATION FOUR MARK', specials={'super',0x56DB} },
	[0x3196] = { unicodeslot=0x3196, category='so', description='IDEOGRAPHIC ANNOTATION TOP MARK', specials={'super',0x4E0A} },
	[0x3197] = { unicodeslot=0x3197, category='so', description='IDEOGRAPHIC ANNOTATION MIDDLE MARK', specials={'super',0x4E2D} },
	[0x3198] = { unicodeslot=0x3198, category='so', description='IDEOGRAPHIC ANNOTATION BOTTOM MARK', specials={'super',0x4E0B} },
	[0x3199] = { unicodeslot=0x3199, category='so', description='IDEOGRAPHIC ANNOTATION FIRST MARK', specials={'super',0x7532} },
	[0x319A] = { unicodeslot=0x319A, category='so', description='IDEOGRAPHIC ANNOTATION SECOND MARK', specials={'super',0x4E59} },
	[0x319B] = { unicodeslot=0x319B, category='so', description='IDEOGRAPHIC ANNOTATION THIRD MARK', specials={'super',0x4E19} },
	[0x319C] = { unicodeslot=0x319C, category='so', description='IDEOGRAPHIC ANNOTATION FOURTH MARK', specials={'super',0x4E01} },
	[0x319D] = { unicodeslot=0x319D, category='so', description='IDEOGRAPHIC ANNOTATION HEAVEN MARK', specials={'super',0x5929} },
	[0x319E] = { unicodeslot=0x319E, category='so', description='IDEOGRAPHIC ANNOTATION EARTH MARK', specials={'super',0x5730} },
	[0x319F] = { unicodeslot=0x319F, category='so', description='IDEOGRAPHIC ANNOTATION MAN MARK', specials={'super',0x4EBA} },
	[0x31A0] = { unicodeslot=0x31A0, category='lo', description='BOPOMOFO LETTER BU' },
	[0x31A1] = { unicodeslot=0x31A1, category='lo', description='BOPOMOFO LETTER ZI' },
	[0x31A2] = { unicodeslot=0x31A2, category='lo', description='BOPOMOFO LETTER JI' },
	[0x31A3] = { unicodeslot=0x31A3, category='lo', description='BOPOMOFO LETTER GU' },
	[0x31A4] = { unicodeslot=0x31A4, category='lo', description='BOPOMOFO LETTER EE' },
	[0x31A5] = { unicodeslot=0x31A5, category='lo', description='BOPOMOFO LETTER ENN' },
	[0x31A6] = { unicodeslot=0x31A6, category='lo', description='BOPOMOFO LETTER OO' },
	[0x31A7] = { unicodeslot=0x31A7, category='lo', description='BOPOMOFO LETTER ONN' },
	[0x31A8] = { unicodeslot=0x31A8, category='lo', description='BOPOMOFO LETTER IR' },
	[0x31A9] = { unicodeslot=0x31A9, category='lo', description='BOPOMOFO LETTER ANN' },
	[0x31AA] = { unicodeslot=0x31AA, category='lo', description='BOPOMOFO LETTER INN' },
	[0x31AB] = { unicodeslot=0x31AB, category='lo', description='BOPOMOFO LETTER UNN' },
	[0x31AC] = { unicodeslot=0x31AC, category='lo', description='BOPOMOFO LETTER IM' },
	[0x31AD] = { unicodeslot=0x31AD, category='lo', description='BOPOMOFO LETTER NGG' },
	[0x31AE] = { unicodeslot=0x31AE, category='lo', description='BOPOMOFO LETTER AINN' },
	[0x31AF] = { unicodeslot=0x31AF, category='lo', description='BOPOMOFO LETTER AUNN' },
	[0x31B0] = { unicodeslot=0x31B0, category='lo', description='BOPOMOFO LETTER AM' },
	[0x31B1] = { unicodeslot=0x31B1, category='lo', description='BOPOMOFO LETTER OM' },
	[0x31B2] = { unicodeslot=0x31B2, category='lo', description='BOPOMOFO LETTER ONG' },
	[0x31B3] = { unicodeslot=0x31B3, category='lo', description='BOPOMOFO LETTER INNN' },
	[0x31B4] = { unicodeslot=0x31B4, category='lo', description='BOPOMOFO FINAL LETTER P' },
	[0x31B5] = { unicodeslot=0x31B5, category='lo', description='BOPOMOFO FINAL LETTER T' },
	[0x31B6] = { unicodeslot=0x31B6, category='lo', description='BOPOMOFO FINAL LETTER K' },
	[0x31B7] = { unicodeslot=0x31B7, category='lo', description='BOPOMOFO FINAL LETTER H' },
	[0x31C0] = { unicodeslot=0x31C0, category='so', description='CJK STROKE T' },
	[0x31C1] = { unicodeslot=0x31C1, category='so', description='CJK STROKE WG' },
	[0x31C2] = { unicodeslot=0x31C2, category='so', description='CJK STROKE XG' },
	[0x31C3] = { unicodeslot=0x31C3, category='so', description='CJK STROKE BXG' },
	[0x31C4] = { unicodeslot=0x31C4, category='so', description='CJK STROKE SW' },
	[0x31C5] = { unicodeslot=0x31C5, category='so', description='CJK STROKE HZZ' },
	[0x31C6] = { unicodeslot=0x31C6, category='so', description='CJK STROKE HZG' },
	[0x31C7] = { unicodeslot=0x31C7, category='so', description='CJK STROKE HP' },
	[0x31C8] = { unicodeslot=0x31C8, category='so', description='CJK STROKE HZWG' },
	[0x31C9] = { unicodeslot=0x31C9, category='so', description='CJK STROKE SZWG' },
	[0x31CA] = { unicodeslot=0x31CA, category='so', description='CJK STROKE HZT' },
	[0x31CB] = { unicodeslot=0x31CB, category='so', description='CJK STROKE HZZP' },
	[0x31CC] = { unicodeslot=0x31CC, category='so', description='CJK STROKE HPWG' },
	[0x31CD] = { unicodeslot=0x31CD, category='so', description='CJK STROKE HZW' },
	[0x31CE] = { unicodeslot=0x31CE, category='so', description='CJK STROKE HZZZ' },
	[0x31CF] = { unicodeslot=0x31CF, category='so', description='CJK STROKE N' },
	[0x31F0] = { unicodeslot=0x31F0, category='lo', description='KATAKANA LETTER SMALL KU' },
	[0x31F1] = { unicodeslot=0x31F1, category='lo', description='KATAKANA LETTER SMALL SI' },
	[0x31F2] = { unicodeslot=0x31F2, category='lo', description='KATAKANA LETTER SMALL SU' },
	[0x31F3] = { unicodeslot=0x31F3, category='lo', description='KATAKANA LETTER SMALL TO' },
	[0x31F4] = { unicodeslot=0x31F4, category='lo', description='KATAKANA LETTER SMALL NU' },
	[0x31F5] = { unicodeslot=0x31F5, category='lo', description='KATAKANA LETTER SMALL HA' },
	[0x31F6] = { unicodeslot=0x31F6, category='lo', description='KATAKANA LETTER SMALL HI' },
	[0x31F7] = { unicodeslot=0x31F7, category='lo', description='KATAKANA LETTER SMALL HU' },
	[0x31F8] = { unicodeslot=0x31F8, category='lo', description='KATAKANA LETTER SMALL HE' },
	[0x31F9] = { unicodeslot=0x31F9, category='lo', description='KATAKANA LETTER SMALL HO' },
	[0x31FA] = { unicodeslot=0x31FA, category='lo', description='KATAKANA LETTER SMALL MU' },
	[0x31FB] = { unicodeslot=0x31FB, category='lo', description='KATAKANA LETTER SMALL RA' },
	[0x31FC] = { unicodeslot=0x31FC, category='lo', description='KATAKANA LETTER SMALL RI' },
	[0x31FD] = { unicodeslot=0x31FD, category='lo', description='KATAKANA LETTER SMALL RU' },
	[0x31FE] = { unicodeslot=0x31FE, category='lo', description='KATAKANA LETTER SMALL RE' },
	[0x31FF] = { unicodeslot=0x31FF, category='lo', description='KATAKANA LETTER SMALL RO' },
	[0x3200] = { unicodeslot=0x3200, category='so', description='PARENTHESIZED HANGUL KIYEOK', specials={'compat',0x0028,0x1100,0x0029} },
	[0x3201] = { unicodeslot=0x3201, category='so', description='PARENTHESIZED HANGUL NIEUN', specials={'compat',0x0028,0x1102,0x0029} },
	[0x3202] = { unicodeslot=0x3202, category='so', description='PARENTHESIZED HANGUL TIKEUT', specials={'compat',0x0028,0x1103,0x0029} },
	[0x3203] = { unicodeslot=0x3203, category='so', description='PARENTHESIZED HANGUL RIEUL', specials={'compat',0x0028,0x1105,0x0029} },
	[0x3204] = { unicodeslot=0x3204, category='so', description='PARENTHESIZED HANGUL MIEUM', specials={'compat',0x0028,0x1106,0x0029} },
	[0x3205] = { unicodeslot=0x3205, category='so', description='PARENTHESIZED HANGUL PIEUP', specials={'compat',0x0028,0x1107,0x0029} },
	[0x3206] = { unicodeslot=0x3206, category='so', description='PARENTHESIZED HANGUL SIOS', specials={'compat',0x0028,0x1109,0x0029} },
	[0x3207] = { unicodeslot=0x3207, category='so', description='PARENTHESIZED HANGUL IEUNG', specials={'compat',0x0028,0x110B,0x0029} },
	[0x3208] = { unicodeslot=0x3208, category='so', description='PARENTHESIZED HANGUL CIEUC', specials={'compat',0x0028,0x110C,0x0029} },
	[0x3209] = { unicodeslot=0x3209, category='so', description='PARENTHESIZED HANGUL CHIEUCH', specials={'compat',0x0028,0x110E,0x0029} },
	[0x320A] = { unicodeslot=0x320A, category='so', description='PARENTHESIZED HANGUL KHIEUKH', specials={'compat',0x0028,0x110F,0x0029} },
	[0x320B] = { unicodeslot=0x320B, category='so', description='PARENTHESIZED HANGUL THIEUTH', specials={'compat',0x0028,0x1110,0x0029} },
	[0x320C] = { unicodeslot=0x320C, category='so', description='PARENTHESIZED HANGUL PHIEUPH', specials={'compat',0x0028,0x1111,0x0029} },
	[0x320D] = { unicodeslot=0x320D, category='so', description='PARENTHESIZED HANGUL HIEUH', specials={'compat',0x0028,0x1112,0x0029} },
	[0x320E] = { unicodeslot=0x320E, category='so', description='PARENTHESIZED HANGUL KIYEOK A', specials={'compat',0x0028,0x1100,0x1161,0x0029} },
	[0x320F] = { unicodeslot=0x320F, category='so', description='PARENTHESIZED HANGUL NIEUN A', specials={'compat',0x0028,0x1102,0x1161,0x0029} },
	[0x3210] = { unicodeslot=0x3210, category='so', description='PARENTHESIZED HANGUL TIKEUT A', specials={'compat',0x0028,0x1103,0x1161,0x0029} },
	[0x3211] = { unicodeslot=0x3211, category='so', description='PARENTHESIZED HANGUL RIEUL A', specials={'compat',0x0028,0x1105,0x1161,0x0029} },
	[0x3212] = { unicodeslot=0x3212, category='so', description='PARENTHESIZED HANGUL MIEUM A', specials={'compat',0x0028,0x1106,0x1161,0x0029} },
	[0x3213] = { unicodeslot=0x3213, category='so', description='PARENTHESIZED HANGUL PIEUP A', specials={'compat',0x0028,0x1107,0x1161,0x0029} },
	[0x3214] = { unicodeslot=0x3214, category='so', description='PARENTHESIZED HANGUL SIOS A', specials={'compat',0x0028,0x1109,0x1161,0x0029} },
	[0x3215] = { unicodeslot=0x3215, category='so', description='PARENTHESIZED HANGUL IEUNG A', specials={'compat',0x0028,0x110B,0x1161,0x0029} },
	[0x3216] = { unicodeslot=0x3216, category='so', description='PARENTHESIZED HANGUL CIEUC A', specials={'compat',0x0028,0x110C,0x1161,0x0029} },
	[0x3217] = { unicodeslot=0x3217, category='so', description='PARENTHESIZED HANGUL CHIEUCH A', specials={'compat',0x0028,0x110E,0x1161,0x0029} },
	[0x3218] = { unicodeslot=0x3218, category='so', description='PARENTHESIZED HANGUL KHIEUKH A', specials={'compat',0x0028,0x110F,0x1161,0x0029} },
	[0x3219] = { unicodeslot=0x3219, category='so', description='PARENTHESIZED HANGUL THIEUTH A', specials={'compat',0x0028,0x1110,0x1161,0x0029} },
	[0x321A] = { unicodeslot=0x321A, category='so', description='PARENTHESIZED HANGUL PHIEUPH A', specials={'compat',0x0028,0x1111,0x1161,0x0029} },
	[0x321B] = { unicodeslot=0x321B, category='so', description='PARENTHESIZED HANGUL HIEUH A', specials={'compat',0x0028,0x1112,0x1161,0x0029} },
	[0x321C] = { unicodeslot=0x321C, category='so', description='PARENTHESIZED HANGUL CIEUC U', specials={'compat',0x0028,0x110C,0x116E,0x0029} },
	[0x321D] = { unicodeslot=0x321D, category='so', description='PARENTHESIZED KOREAN CHARACTER OJEON', specials={'compat',0x0028,0x110B,0x1169,0x110C,0x1165,0x11AB,0x0029} },
	[0x321E] = { unicodeslot=0x321E, category='so', description='PARENTHESIZED KOREAN CHARACTER O HU', specials={'compat',0x0028,0x110B,0x1169,0x1112,0x116E,0x0029} },
	[0x3220] = { unicodeslot=0x3220, category='no', description='PARENTHESIZED IDEOGRAPH ONE', specials={'compat',0x0028,0x4E00,0x0029} },
	[0x3221] = { unicodeslot=0x3221, category='no', description='PARENTHESIZED IDEOGRAPH TWO', specials={'compat',0x0028,0x4E8C,0x0029} },
	[0x3222] = { unicodeslot=0x3222, category='no', description='PARENTHESIZED IDEOGRAPH THREE', specials={'compat',0x0028,0x4E09,0x0029} },
	[0x3223] = { unicodeslot=0x3223, category='no', description='PARENTHESIZED IDEOGRAPH FOUR', specials={'compat',0x0028,0x56DB,0x0029} },
	[0x3224] = { unicodeslot=0x3224, category='no', description='PARENTHESIZED IDEOGRAPH FIVE', specials={'compat',0x0028,0x4E94,0x0029} },
	[0x3225] = { unicodeslot=0x3225, category='no', description='PARENTHESIZED IDEOGRAPH SIX', specials={'compat',0x0028,0x516D,0x0029} },
	[0x3226] = { unicodeslot=0x3226, category='no', description='PARENTHESIZED IDEOGRAPH SEVEN', specials={'compat',0x0028,0x4E03,0x0029} },
	[0x3227] = { unicodeslot=0x3227, category='no', description='PARENTHESIZED IDEOGRAPH EIGHT', specials={'compat',0x0028,0x516B,0x0029} },
	[0x3228] = { unicodeslot=0x3228, category='no', description='PARENTHESIZED IDEOGRAPH NINE', specials={'compat',0x0028,0x4E5D,0x0029} },
	[0x3229] = { unicodeslot=0x3229, category='no', description='PARENTHESIZED IDEOGRAPH TEN', specials={'compat',0x0028,0x5341,0x0029} },
	[0x322A] = { unicodeslot=0x322A, category='so', description='PARENTHESIZED IDEOGRAPH MOON', specials={'compat',0x0028,0x6708,0x0029} },
	[0x322B] = { unicodeslot=0x322B, category='so', description='PARENTHESIZED IDEOGRAPH FIRE', specials={'compat',0x0028,0x706B,0x0029} },
	[0x322C] = { unicodeslot=0x322C, category='so', description='PARENTHESIZED IDEOGRAPH WATER', specials={'compat',0x0028,0x6C34,0x0029} },
	[0x322D] = { unicodeslot=0x322D, category='so', description='PARENTHESIZED IDEOGRAPH WOOD', specials={'compat',0x0028,0x6728,0x0029} },
	[0x322E] = { unicodeslot=0x322E, category='so', description='PARENTHESIZED IDEOGRAPH METAL', specials={'compat',0x0028,0x91D1,0x0029} },
	[0x322F] = { unicodeslot=0x322F, category='so', description='PARENTHESIZED IDEOGRAPH EARTH', specials={'compat',0x0028,0x571F,0x0029} },
	[0x3230] = { unicodeslot=0x3230, category='so', description='PARENTHESIZED IDEOGRAPH SUN', specials={'compat',0x0028,0x65E5,0x0029} },
	[0x3231] = { unicodeslot=0x3231, category='so', description='PARENTHESIZED IDEOGRAPH STOCK', specials={'compat',0x0028,0x682A,0x0029} },
	[0x3232] = { unicodeslot=0x3232, category='so', description='PARENTHESIZED IDEOGRAPH HAVE', specials={'compat',0x0028,0x6709,0x0029} },
	[0x3233] = { unicodeslot=0x3233, category='so', description='PARENTHESIZED IDEOGRAPH SOCIETY', specials={'compat',0x0028,0x793E,0x0029} },
	[0x3234] = { unicodeslot=0x3234, category='so', description='PARENTHESIZED IDEOGRAPH NAME', specials={'compat',0x0028,0x540D,0x0029} },
	[0x3235] = { unicodeslot=0x3235, category='so', description='PARENTHESIZED IDEOGRAPH SPECIAL', specials={'compat',0x0028,0x7279,0x0029} },
	[0x3236] = { unicodeslot=0x3236, category='so', description='PARENTHESIZED IDEOGRAPH FINANCIAL', specials={'compat',0x0028,0x8CA1,0x0029} },
	[0x3237] = { unicodeslot=0x3237, category='so', description='PARENTHESIZED IDEOGRAPH CONGRATULATION', specials={'compat',0x0028,0x795D,0x0029} },
	[0x3238] = { unicodeslot=0x3238, category='so', description='PARENTHESIZED IDEOGRAPH LABOR', specials={'compat',0x0028,0x52B4,0x0029} },
	[0x3239] = { unicodeslot=0x3239, category='so', description='PARENTHESIZED IDEOGRAPH REPRESENT', specials={'compat',0x0028,0x4EE3,0x0029} },
	[0x323A] = { unicodeslot=0x323A, category='so', description='PARENTHESIZED IDEOGRAPH CALL', specials={'compat',0x0028,0x547C,0x0029} },
	[0x323B] = { unicodeslot=0x323B, category='so', description='PARENTHESIZED IDEOGRAPH STUDY', specials={'compat',0x0028,0x5B66,0x0029} },
	[0x323C] = { unicodeslot=0x323C, category='so', description='PARENTHESIZED IDEOGRAPH SUPERVISE', specials={'compat',0x0028,0x76E3,0x0029} },
	[0x323D] = { unicodeslot=0x323D, category='so', description='PARENTHESIZED IDEOGRAPH ENTERPRISE', specials={'compat',0x0028,0x4F01,0x0029} },
	[0x323E] = { unicodeslot=0x323E, category='so', description='PARENTHESIZED IDEOGRAPH RESOURCE', specials={'compat',0x0028,0x8CC7,0x0029} },
	[0x323F] = { unicodeslot=0x323F, category='so', description='PARENTHESIZED IDEOGRAPH ALLIANCE', specials={'compat',0x0028,0x5354,0x0029} },
	[0x3240] = { unicodeslot=0x3240, category='so', description='PARENTHESIZED IDEOGRAPH FESTIVAL', specials={'compat',0x0028,0x796D,0x0029} },
	[0x3241] = { unicodeslot=0x3241, category='so', description='PARENTHESIZED IDEOGRAPH REST', specials={'compat',0x0028,0x4F11,0x0029} },
	[0x3242] = { unicodeslot=0x3242, category='so', description='PARENTHESIZED IDEOGRAPH SELF', specials={'compat',0x0028,0x81EA,0x0029} },
	[0x3243] = { unicodeslot=0x3243, category='so', description='PARENTHESIZED IDEOGRAPH REACH', specials={'compat',0x0028,0x81F3,0x0029} },
	[0x3250] = { unicodeslot=0x3250, category='so', description='PARTNERSHIP SIGN', specials={'square',0x0050,0x0054,0x0045} },
	[0x3251] = { unicodeslot=0x3251, category='no', description='CIRCLED NUMBER TWENTY ONE', specials={'circle',0x0032,0x0031} },
	[0x3252] = { unicodeslot=0x3252, category='no', description='CIRCLED NUMBER TWENTY TWO', specials={'circle',0x0032,0x0032} },
	[0x3253] = { unicodeslot=0x3253, category='no', description='CIRCLED NUMBER TWENTY THREE', specials={'circle',0x0032,0x0033} },
	[0x3254] = { unicodeslot=0x3254, category='no', description='CIRCLED NUMBER TWENTY FOUR', specials={'circle',0x0032,0x0034} },
	[0x3255] = { unicodeslot=0x3255, category='no', description='CIRCLED NUMBER TWENTY FIVE', specials={'circle',0x0032,0x0035} },
	[0x3256] = { unicodeslot=0x3256, category='no', description='CIRCLED NUMBER TWENTY SIX', specials={'circle',0x0032,0x0036} },
	[0x3257] = { unicodeslot=0x3257, category='no', description='CIRCLED NUMBER TWENTY SEVEN', specials={'circle',0x0032,0x0037} },
	[0x3258] = { unicodeslot=0x3258, category='no', description='CIRCLED NUMBER TWENTY EIGHT', specials={'circle',0x0032,0x0038} },
	[0x3259] = { unicodeslot=0x3259, category='no', description='CIRCLED NUMBER TWENTY NINE', specials={'circle',0x0032,0x0039} },
	[0x325A] = { unicodeslot=0x325A, category='no', description='CIRCLED NUMBER THIRTY', specials={'circle',0x0033,0x0030} },
	[0x325B] = { unicodeslot=0x325B, category='no', description='CIRCLED NUMBER THIRTY ONE', specials={'circle',0x0033,0x0031} },
	[0x325C] = { unicodeslot=0x325C, category='no', description='CIRCLED NUMBER THIRTY TWO', specials={'circle',0x0033,0x0032} },
	[0x325D] = { unicodeslot=0x325D, category='no', description='CIRCLED NUMBER THIRTY THREE', specials={'circle',0x0033,0x0033} },
	[0x325E] = { unicodeslot=0x325E, category='no', description='CIRCLED NUMBER THIRTY FOUR', specials={'circle',0x0033,0x0034} },
	[0x325F] = { unicodeslot=0x325F, category='no', description='CIRCLED NUMBER THIRTY FIVE', specials={'circle',0x0033,0x0035} },
	[0x3260] = { unicodeslot=0x3260, category='so', description='CIRCLED HANGUL KIYEOK', specials={'circle',0x1100} },
	[0x3261] = { unicodeslot=0x3261, category='so', description='CIRCLED HANGUL NIEUN', specials={'circle',0x1102} },
	[0x3262] = { unicodeslot=0x3262, category='so', description='CIRCLED HANGUL TIKEUT', specials={'circle',0x1103} },
	[0x3263] = { unicodeslot=0x3263, category='so', description='CIRCLED HANGUL RIEUL', specials={'circle',0x1105} },
	[0x3264] = { unicodeslot=0x3264, category='so', description='CIRCLED HANGUL MIEUM', specials={'circle',0x1106} },
	[0x3265] = { unicodeslot=0x3265, category='so', description='CIRCLED HANGUL PIEUP', specials={'circle',0x1107} },
	[0x3266] = { unicodeslot=0x3266, category='so', description='CIRCLED HANGUL SIOS', specials={'circle',0x1109} },
	[0x3267] = { unicodeslot=0x3267, category='so', description='CIRCLED HANGUL IEUNG', specials={'circle',0x110B} },
	[0x3268] = { unicodeslot=0x3268, category='so', description='CIRCLED HANGUL CIEUC', specials={'circle',0x110C} },
	[0x3269] = { unicodeslot=0x3269, category='so', description='CIRCLED HANGUL CHIEUCH', specials={'circle',0x110E} },
	[0x326A] = { unicodeslot=0x326A, category='so', description='CIRCLED HANGUL KHIEUKH', specials={'circle',0x110F} },
	[0x326B] = { unicodeslot=0x326B, category='so', description='CIRCLED HANGUL THIEUTH', specials={'circle',0x1110} },
	[0x326C] = { unicodeslot=0x326C, category='so', description='CIRCLED HANGUL PHIEUPH', specials={'circle',0x1111} },
	[0x326D] = { unicodeslot=0x326D, category='so', description='CIRCLED HANGUL HIEUH', specials={'circle',0x1112} },
	[0x326E] = { unicodeslot=0x326E, category='so', description='CIRCLED HANGUL KIYEOK A', specials={'circle',0x1100,0x1161} },
	[0x326F] = { unicodeslot=0x326F, category='so', description='CIRCLED HANGUL NIEUN A', specials={'circle',0x1102,0x1161} },
	[0x3270] = { unicodeslot=0x3270, category='so', description='CIRCLED HANGUL TIKEUT A', specials={'circle',0x1103,0x1161} },
	[0x3271] = { unicodeslot=0x3271, category='so', description='CIRCLED HANGUL RIEUL A', specials={'circle',0x1105,0x1161} },
	[0x3272] = { unicodeslot=0x3272, category='so', description='CIRCLED HANGUL MIEUM A', specials={'circle',0x1106,0x1161} },
	[0x3273] = { unicodeslot=0x3273, category='so', description='CIRCLED HANGUL PIEUP A', specials={'circle',0x1107,0x1161} },
	[0x3274] = { unicodeslot=0x3274, category='so', description='CIRCLED HANGUL SIOS A', specials={'circle',0x1109,0x1161} },
	[0x3275] = { unicodeslot=0x3275, category='so', description='CIRCLED HANGUL IEUNG A', specials={'circle',0x110B,0x1161} },
	[0x3276] = { unicodeslot=0x3276, category='so', description='CIRCLED HANGUL CIEUC A', specials={'circle',0x110C,0x1161} },
	[0x3277] = { unicodeslot=0x3277, category='so', description='CIRCLED HANGUL CHIEUCH A', specials={'circle',0x110E,0x1161} },
	[0x3278] = { unicodeslot=0x3278, category='so', description='CIRCLED HANGUL KHIEUKH A', specials={'circle',0x110F,0x1161} },
	[0x3279] = { unicodeslot=0x3279, category='so', description='CIRCLED HANGUL THIEUTH A', specials={'circle',0x1110,0x1161} },
	[0x327A] = { unicodeslot=0x327A, category='so', description='CIRCLED HANGUL PHIEUPH A', specials={'circle',0x1111,0x1161} },
	[0x327B] = { unicodeslot=0x327B, category='so', description='CIRCLED HANGUL HIEUH A', specials={'circle',0x1112,0x1161} },
	[0x327C] = { unicodeslot=0x327C, category='so', description='CIRCLED KOREAN CHARACTER CHAMKO', specials={'circle',0x110E,0x1161,0x11B7,0x1100,0x1169} },
	[0x327D] = { unicodeslot=0x327D, category='so', description='CIRCLED KOREAN CHARACTER JUEUI', specials={'circle',0x110C,0x116E,0x110B,0x1174} },
	[0x327E] = { unicodeslot=0x327E, category='so', description='CIRCLED HANGUL IEUNG U', specials={'circle',0x110B,0x116E} },
	[0x327F] = { unicodeslot=0x327F, category='so', description='KOREAN STANDARD SYMBOL' },
	[0x3280] = { unicodeslot=0x3280, category='no', description='CIRCLED IDEOGRAPH ONE', specials={'circle',0x4E00} },
	[0x3281] = { unicodeslot=0x3281, category='no', description='CIRCLED IDEOGRAPH TWO', specials={'circle',0x4E8C} },
	[0x3282] = { unicodeslot=0x3282, category='no', description='CIRCLED IDEOGRAPH THREE', specials={'circle',0x4E09} },
	[0x3283] = { unicodeslot=0x3283, category='no', description='CIRCLED IDEOGRAPH FOUR', specials={'circle',0x56DB} },
	[0x3284] = { unicodeslot=0x3284, category='no', description='CIRCLED IDEOGRAPH FIVE', specials={'circle',0x4E94} },
	[0x3285] = { unicodeslot=0x3285, category='no', description='CIRCLED IDEOGRAPH SIX', specials={'circle',0x516D} },
	[0x3286] = { unicodeslot=0x3286, category='no', description='CIRCLED IDEOGRAPH SEVEN', specials={'circle',0x4E03} },
	[0x3287] = { unicodeslot=0x3287, category='no', description='CIRCLED IDEOGRAPH EIGHT', specials={'circle',0x516B} },
	[0x3288] = { unicodeslot=0x3288, category='no', description='CIRCLED IDEOGRAPH NINE', specials={'circle',0x4E5D} },
	[0x3289] = { unicodeslot=0x3289, category='no', description='CIRCLED IDEOGRAPH TEN', specials={'circle',0x5341} },
	[0x328A] = { unicodeslot=0x328A, category='so', description='CIRCLED IDEOGRAPH MOON', specials={'circle',0x6708} },
	[0x328B] = { unicodeslot=0x328B, category='so', description='CIRCLED IDEOGRAPH FIRE', specials={'circle',0x706B} },
	[0x328C] = { unicodeslot=0x328C, category='so', description='CIRCLED IDEOGRAPH WATER', specials={'circle',0x6C34} },
	[0x328D] = { unicodeslot=0x328D, category='so', description='CIRCLED IDEOGRAPH WOOD', specials={'circle',0x6728} },
	[0x328E] = { unicodeslot=0x328E, category='so', description='CIRCLED IDEOGRAPH METAL', specials={'circle',0x91D1} },
	[0x328F] = { unicodeslot=0x328F, category='so', description='CIRCLED IDEOGRAPH EARTH', specials={'circle',0x571F} },
	[0x3290] = { unicodeslot=0x3290, category='so', description='CIRCLED IDEOGRAPH SUN', specials={'circle',0x65E5} },
	[0x3291] = { unicodeslot=0x3291, category='so', description='CIRCLED IDEOGRAPH STOCK', specials={'circle',0x682A} },
	[0x3292] = { unicodeslot=0x3292, category='so', description='CIRCLED IDEOGRAPH HAVE', specials={'circle',0x6709} },
	[0x3293] = { unicodeslot=0x3293, category='so', description='CIRCLED IDEOGRAPH SOCIETY', specials={'circle',0x793E} },
	[0x3294] = { unicodeslot=0x3294, category='so', description='CIRCLED IDEOGRAPH NAME', specials={'circle',0x540D} },
	[0x3295] = { unicodeslot=0x3295, category='so', description='CIRCLED IDEOGRAPH SPECIAL', specials={'circle',0x7279} },
	[0x3296] = { unicodeslot=0x3296, category='so', description='CIRCLED IDEOGRAPH FINANCIAL', specials={'circle',0x8CA1} },
	[0x3297] = { unicodeslot=0x3297, category='so', description='CIRCLED IDEOGRAPH CONGRATULATION', specials={'circle',0x795D} },
	[0x3298] = { unicodeslot=0x3298, category='so', description='CIRCLED IDEOGRAPH LABOR', specials={'circle',0x52B4} },
	[0x3299] = { unicodeslot=0x3299, category='so', description='CIRCLED IDEOGRAPH SECRET', specials={'circle',0x79D8} },
	[0x329A] = { unicodeslot=0x329A, category='so', description='CIRCLED IDEOGRAPH MALE', specials={'circle',0x7537} },
	[0x329B] = { unicodeslot=0x329B, category='so', description='CIRCLED IDEOGRAPH FEMALE', specials={'circle',0x5973} },
	[0x329C] = { unicodeslot=0x329C, category='so', description='CIRCLED IDEOGRAPH SUITABLE', specials={'circle',0x9069} },
	[0x329D] = { unicodeslot=0x329D, category='so', description='CIRCLED IDEOGRAPH EXCELLENT', specials={'circle',0x512A} },
	[0x329E] = { unicodeslot=0x329E, category='so', description='CIRCLED IDEOGRAPH PRINT', specials={'circle',0x5370} },
	[0x329F] = { unicodeslot=0x329F, category='so', description='CIRCLED IDEOGRAPH ATTENTION', specials={'circle',0x6CE8} },
	[0x32A0] = { unicodeslot=0x32A0, category='so', description='CIRCLED IDEOGRAPH ITEM', specials={'circle',0x9805} },
	[0x32A1] = { unicodeslot=0x32A1, category='so', description='CIRCLED IDEOGRAPH REST', specials={'circle',0x4F11} },
	[0x32A2] = { unicodeslot=0x32A2, category='so', description='CIRCLED IDEOGRAPH COPY', specials={'circle',0x5199} },
	[0x32A3] = { unicodeslot=0x32A3, category='so', description='CIRCLED IDEOGRAPH CORRECT', specials={'circle',0x6B63} },
	[0x32A4] = { unicodeslot=0x32A4, category='so', description='CIRCLED IDEOGRAPH HIGH', specials={'circle',0x4E0A} },
	[0x32A5] = { unicodeslot=0x32A5, category='so', description='CIRCLED IDEOGRAPH CENTRE', specials={'circle',0x4E2D} },
	[0x32A6] = { unicodeslot=0x32A6, category='so', description='CIRCLED IDEOGRAPH LOW', specials={'circle',0x4E0B} },
	[0x32A7] = { unicodeslot=0x32A7, category='so', description='CIRCLED IDEOGRAPH LEFT', specials={'circle',0x5DE6} },
	[0x32A8] = { unicodeslot=0x32A8, category='so', description='CIRCLED IDEOGRAPH RIGHT', specials={'circle',0x53F3} },
	[0x32A9] = { unicodeslot=0x32A9, category='so', description='CIRCLED IDEOGRAPH MEDICINE', specials={'circle',0x533B} },
	[0x32AA] = { unicodeslot=0x32AA, category='so', description='CIRCLED IDEOGRAPH RELIGION', specials={'circle',0x5B97} },
	[0x32AB] = { unicodeslot=0x32AB, category='so', description='CIRCLED IDEOGRAPH STUDY', specials={'circle',0x5B66} },
	[0x32AC] = { unicodeslot=0x32AC, category='so', description='CIRCLED IDEOGRAPH SUPERVISE', specials={'circle',0x76E3} },
	[0x32AD] = { unicodeslot=0x32AD, category='so', description='CIRCLED IDEOGRAPH ENTERPRISE', specials={'circle',0x4F01} },
	[0x32AE] = { unicodeslot=0x32AE, category='so', description='CIRCLED IDEOGRAPH RESOURCE', specials={'circle',0x8CC7} },
	[0x32AF] = { unicodeslot=0x32AF, category='so', description='CIRCLED IDEOGRAPH ALLIANCE', specials={'circle',0x5354} },
	[0x32B0] = { unicodeslot=0x32B0, category='so', description='CIRCLED IDEOGRAPH NIGHT', specials={'circle',0x591C} },
	[0x32B1] = { unicodeslot=0x32B1, category='no', description='CIRCLED NUMBER THIRTY SIX', specials={'circle',0x0033,0x0036} },
	[0x32B2] = { unicodeslot=0x32B2, category='no', description='CIRCLED NUMBER THIRTY SEVEN', specials={'circle',0x0033,0x0037} },
	[0x32B3] = { unicodeslot=0x32B3, category='no', description='CIRCLED NUMBER THIRTY EIGHT', specials={'circle',0x0033,0x0038} },
	[0x32B4] = { unicodeslot=0x32B4, category='no', description='CIRCLED NUMBER THIRTY NINE', specials={'circle',0x0033,0x0039} },
	[0x32B5] = { unicodeslot=0x32B5, category='no', description='CIRCLED NUMBER FORTY', specials={'circle',0x0034,0x0030} },
	[0x32B6] = { unicodeslot=0x32B6, category='no', description='CIRCLED NUMBER FORTY ONE', specials={'circle',0x0034,0x0031} },
	[0x32B7] = { unicodeslot=0x32B7, category='no', description='CIRCLED NUMBER FORTY TWO', specials={'circle',0x0034,0x0032} },
	[0x32B8] = { unicodeslot=0x32B8, category='no', description='CIRCLED NUMBER FORTY THREE', specials={'circle',0x0034,0x0033} },
	[0x32B9] = { unicodeslot=0x32B9, category='no', description='CIRCLED NUMBER FORTY FOUR', specials={'circle',0x0034,0x0034} },
	[0x32BA] = { unicodeslot=0x32BA, category='no', description='CIRCLED NUMBER FORTY FIVE', specials={'circle',0x0034,0x0035} },
	[0x32BB] = { unicodeslot=0x32BB, category='no', description='CIRCLED NUMBER FORTY SIX', specials={'circle',0x0034,0x0036} },
	[0x32BC] = { unicodeslot=0x32BC, category='no', description='CIRCLED NUMBER FORTY SEVEN', specials={'circle',0x0034,0x0037} },
	[0x32BD] = { unicodeslot=0x32BD, category='no', description='CIRCLED NUMBER FORTY EIGHT', specials={'circle',0x0034,0x0038} },
	[0x32BE] = { unicodeslot=0x32BE, category='no', description='CIRCLED NUMBER FORTY NINE', specials={'circle',0x0034,0x0039} },
	[0x32BF] = { unicodeslot=0x32BF, category='no', description='CIRCLED NUMBER FIFTY', specials={'circle',0x0035,0x0030} },
	[0x32C0] = { unicodeslot=0x32C0, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY', specials={'compat',0x0031,0x6708} },
	[0x32C1] = { unicodeslot=0x32C1, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR FEBRUARY', specials={'compat',0x0032,0x6708} },
	[0x32C2] = { unicodeslot=0x32C2, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH', specials={'compat',0x0033,0x6708} },
	[0x32C3] = { unicodeslot=0x32C3, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL', specials={'compat',0x0034,0x6708} },
	[0x32C4] = { unicodeslot=0x32C4, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR MAY', specials={'compat',0x0035,0x6708} },
	[0x32C5] = { unicodeslot=0x32C5, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR JUNE', specials={'compat',0x0036,0x6708} },
	[0x32C6] = { unicodeslot=0x32C6, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR JULY', specials={'compat',0x0037,0x6708} },
	[0x32C7] = { unicodeslot=0x32C7, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR AUGUST', specials={'compat',0x0038,0x6708} },
	[0x32C8] = { unicodeslot=0x32C8, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR SEPTEMBER', specials={'compat',0x0039,0x6708} },
	[0x32C9] = { unicodeslot=0x32C9, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR OCTOBER', specials={'compat',0x0031,0x0030,0x6708} },
	[0x32CA] = { unicodeslot=0x32CA, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR NOVEMBER', specials={'compat',0x0031,0x0031,0x6708} },
	[0x32CB] = { unicodeslot=0x32CB, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DECEMBER', specials={'compat',0x0031,0x0032,0x6708} },
	[0x32CC] = { unicodeslot=0x32CC, category='so', description='SQUARE HG', specials={'square',0x0048,0x0067} },
	[0x32CD] = { unicodeslot=0x32CD, category='so', description='SQUARE ERG', specials={'square',0x0065,0x0072,0x0067} },
	[0x32CE] = { unicodeslot=0x32CE, category='so', description='SQUARE EV', specials={'square',0x0065,0x0056} },
	[0x32CF] = { unicodeslot=0x32CF, category='so', description='LIMITED LIABILITY SIGN', specials={'square',0x004C,0x0054,0x0044} },
	[0x32D0] = { unicodeslot=0x32D0, category='so', description='CIRCLED KATAKANA A', specials={'circle',0x30A2} },
	[0x32D1] = { unicodeslot=0x32D1, category='so', description='CIRCLED KATAKANA I', specials={'circle',0x30A4} },
	[0x32D2] = { unicodeslot=0x32D2, category='so', description='CIRCLED KATAKANA U', specials={'circle',0x30A6} },
	[0x32D3] = { unicodeslot=0x32D3, category='so', description='CIRCLED KATAKANA E', specials={'circle',0x30A8} },
	[0x32D4] = { unicodeslot=0x32D4, category='so', description='CIRCLED KATAKANA O', specials={'circle',0x30AA} },
	[0x32D5] = { unicodeslot=0x32D5, category='so', description='CIRCLED KATAKANA KA', specials={'circle',0x30AB} },
	[0x32D6] = { unicodeslot=0x32D6, category='so', description='CIRCLED KATAKANA KI', specials={'circle',0x30AD} },
	[0x32D7] = { unicodeslot=0x32D7, category='so', description='CIRCLED KATAKANA KU', specials={'circle',0x30AF} },
	[0x32D8] = { unicodeslot=0x32D8, category='so', description='CIRCLED KATAKANA KE', specials={'circle',0x30B1} },
	[0x32D9] = { unicodeslot=0x32D9, category='so', description='CIRCLED KATAKANA KO', specials={'circle',0x30B3} },
	[0x32DA] = { unicodeslot=0x32DA, category='so', description='CIRCLED KATAKANA SA', specials={'circle',0x30B5} },
	[0x32DB] = { unicodeslot=0x32DB, category='so', description='CIRCLED KATAKANA SI', specials={'circle',0x30B7} },
	[0x32DC] = { unicodeslot=0x32DC, category='so', description='CIRCLED KATAKANA SU', specials={'circle',0x30B9} },
	[0x32DD] = { unicodeslot=0x32DD, category='so', description='CIRCLED KATAKANA SE', specials={'circle',0x30BB} },
	[0x32DE] = { unicodeslot=0x32DE, category='so', description='CIRCLED KATAKANA SO', specials={'circle',0x30BD} },
	[0x32DF] = { unicodeslot=0x32DF, category='so', description='CIRCLED KATAKANA TA', specials={'circle',0x30BF} },
	[0x32E0] = { unicodeslot=0x32E0, category='so', description='CIRCLED KATAKANA TI', specials={'circle',0x30C1} },
	[0x32E1] = { unicodeslot=0x32E1, category='so', description='CIRCLED KATAKANA TU', specials={'circle',0x30C4} },
	[0x32E2] = { unicodeslot=0x32E2, category='so', description='CIRCLED KATAKANA TE', specials={'circle',0x30C6} },
	[0x32E3] = { unicodeslot=0x32E3, category='so', description='CIRCLED KATAKANA TO', specials={'circle',0x30C8} },
	[0x32E4] = { unicodeslot=0x32E4, category='so', description='CIRCLED KATAKANA NA', specials={'circle',0x30CA} },
	[0x32E5] = { unicodeslot=0x32E5, category='so', description='CIRCLED KATAKANA NI', specials={'circle',0x30CB} },
	[0x32E6] = { unicodeslot=0x32E6, category='so', description='CIRCLED KATAKANA NU', specials={'circle',0x30CC} },
	[0x32E7] = { unicodeslot=0x32E7, category='so', description='CIRCLED KATAKANA NE', specials={'circle',0x30CD} },
	[0x32E8] = { unicodeslot=0x32E8, category='so', description='CIRCLED KATAKANA NO', specials={'circle',0x30CE} },
	[0x32E9] = { unicodeslot=0x32E9, category='so', description='CIRCLED KATAKANA HA', specials={'circle',0x30CF} },
	[0x32EA] = { unicodeslot=0x32EA, category='so', description='CIRCLED KATAKANA HI', specials={'circle',0x30D2} },
	[0x32EB] = { unicodeslot=0x32EB, category='so', description='CIRCLED KATAKANA HU', specials={'circle',0x30D5} },
	[0x32EC] = { unicodeslot=0x32EC, category='so', description='CIRCLED KATAKANA HE', specials={'circle',0x30D8} },
	[0x32ED] = { unicodeslot=0x32ED, category='so', description='CIRCLED KATAKANA HO', specials={'circle',0x30DB} },
	[0x32EE] = { unicodeslot=0x32EE, category='so', description='CIRCLED KATAKANA MA', specials={'circle',0x30DE} },
	[0x32EF] = { unicodeslot=0x32EF, category='so', description='CIRCLED KATAKANA MI', specials={'circle',0x30DF} },
	[0x32F0] = { unicodeslot=0x32F0, category='so', description='CIRCLED KATAKANA MU', specials={'circle',0x30E0} },
	[0x32F1] = { unicodeslot=0x32F1, category='so', description='CIRCLED KATAKANA ME', specials={'circle',0x30E1} },
	[0x32F2] = { unicodeslot=0x32F2, category='so', description='CIRCLED KATAKANA MO', specials={'circle',0x30E2} },
	[0x32F3] = { unicodeslot=0x32F3, category='so', description='CIRCLED KATAKANA YA', specials={'circle',0x30E4} },
	[0x32F4] = { unicodeslot=0x32F4, category='so', description='CIRCLED KATAKANA YU', specials={'circle',0x30E6} },
	[0x32F5] = { unicodeslot=0x32F5, category='so', description='CIRCLED KATAKANA YO', specials={'circle',0x30E8} },
	[0x32F6] = { unicodeslot=0x32F6, category='so', description='CIRCLED KATAKANA RA', specials={'circle',0x30E9} },
	[0x32F7] = { unicodeslot=0x32F7, category='so', description='CIRCLED KATAKANA RI', specials={'circle',0x30EA} },
	[0x32F8] = { unicodeslot=0x32F8, category='so', description='CIRCLED KATAKANA RU', specials={'circle',0x30EB} },
	[0x32F9] = { unicodeslot=0x32F9, category='so', description='CIRCLED KATAKANA RE', specials={'circle',0x30EC} },
	[0x32FA] = { unicodeslot=0x32FA, category='so', description='CIRCLED KATAKANA RO', specials={'circle',0x30ED} },
	[0x32FB] = { unicodeslot=0x32FB, category='so', description='CIRCLED KATAKANA WA', specials={'circle',0x30EF} },
	[0x32FC] = { unicodeslot=0x32FC, category='so', description='CIRCLED KATAKANA WI', specials={'circle',0x30F0} },
	[0x32FD] = { unicodeslot=0x32FD, category='so', description='CIRCLED KATAKANA WE', specials={'circle',0x30F1} },
	[0x32FE] = { unicodeslot=0x32FE, category='so', description='CIRCLED KATAKANA WO', specials={'circle',0x30F2} },
	[0x3300] = { unicodeslot=0x3300, category='so', description='SQUARE APAATO', specials={'square',0x30A2,0x30D1,0x30FC,0x30C8} },
	[0x3301] = { unicodeslot=0x3301, category='so', description='SQUARE ARUHUA', specials={'square',0x30A2,0x30EB,0x30D5,0x30A1} },
	[0x3302] = { unicodeslot=0x3302, category='so', description='SQUARE ANPEA', specials={'square',0x30A2,0x30F3,0x30DA,0x30A2} },
	[0x3303] = { unicodeslot=0x3303, category='so', description='SQUARE AARU', specials={'square',0x30A2,0x30FC,0x30EB} },
	[0x3304] = { unicodeslot=0x3304, category='so', description='SQUARE ININGU', specials={'square',0x30A4,0x30CB,0x30F3,0x30B0} },
	[0x3305] = { unicodeslot=0x3305, category='so', description='SQUARE INTI', specials={'square',0x30A4,0x30F3,0x30C1} },
	[0x3306] = { unicodeslot=0x3306, category='so', description='SQUARE UON', specials={'square',0x30A6,0x30A9,0x30F3} },
	[0x3307] = { unicodeslot=0x3307, category='so', description='SQUARE ESUKUUDO', specials={'square',0x30A8,0x30B9,0x30AF,0x30FC,0x30C9} },
	[0x3308] = { unicodeslot=0x3308, category='so', description='SQUARE EEKAA', specials={'square',0x30A8,0x30FC,0x30AB,0x30FC} },
	[0x3309] = { unicodeslot=0x3309, category='so', description='SQUARE ONSU', specials={'square',0x30AA,0x30F3,0x30B9} },
	[0x330A] = { unicodeslot=0x330A, category='so', description='SQUARE OOMU', specials={'square',0x30AA,0x30FC,0x30E0} },
	[0x330B] = { unicodeslot=0x330B, category='so', description='SQUARE KAIRI', specials={'square',0x30AB,0x30A4,0x30EA} },
	[0x330C] = { unicodeslot=0x330C, category='so', description='SQUARE KARATTO', specials={'square',0x30AB,0x30E9,0x30C3,0x30C8} },
	[0x330D] = { unicodeslot=0x330D, category='so', description='SQUARE KARORII', specials={'square',0x30AB,0x30ED,0x30EA,0x30FC} },
	[0x330E] = { unicodeslot=0x330E, category='so', description='SQUARE GARON', specials={'square',0x30AC,0x30ED,0x30F3} },
	[0x330F] = { unicodeslot=0x330F, category='so', description='SQUARE GANMA', specials={'square',0x30AC,0x30F3,0x30DE} },
	[0x3310] = { unicodeslot=0x3310, category='so', description='SQUARE GIGA', specials={'square',0x30AE,0x30AC} },
	[0x3311] = { unicodeslot=0x3311, category='so', description='SQUARE GINII', specials={'square',0x30AE,0x30CB,0x30FC} },
	[0x3312] = { unicodeslot=0x3312, category='so', description='SQUARE KYURII', specials={'square',0x30AD,0x30E5,0x30EA,0x30FC} },
	[0x3313] = { unicodeslot=0x3313, category='so', description='SQUARE GIRUDAA', specials={'square',0x30AE,0x30EB,0x30C0,0x30FC} },
	[0x3314] = { unicodeslot=0x3314, category='so', description='SQUARE KIRO', specials={'square',0x30AD,0x30ED} },
	[0x3315] = { unicodeslot=0x3315, category='so', description='SQUARE KIROGURAMU', specials={'square',0x30AD,0x30ED,0x30B0,0x30E9,0x30E0} },
	[0x3316] = { unicodeslot=0x3316, category='so', description='SQUARE KIROMEETORU', specials={'square',0x30AD,0x30ED,0x30E1,0x30FC,0x30C8,0x30EB} },
	[0x3317] = { unicodeslot=0x3317, category='so', description='SQUARE KIROWATTO', specials={'square',0x30AD,0x30ED,0x30EF,0x30C3,0x30C8} },
	[0x3318] = { unicodeslot=0x3318, category='so', description='SQUARE GURAMU', specials={'square',0x30B0,0x30E9,0x30E0} },
	[0x3319] = { unicodeslot=0x3319, category='so', description='SQUARE GURAMUTON', specials={'square',0x30B0,0x30E9,0x30E0,0x30C8,0x30F3} },
	[0x331A] = { unicodeslot=0x331A, category='so', description='SQUARE KURUZEIRO', specials={'square',0x30AF,0x30EB,0x30BC,0x30A4,0x30ED} },
	[0x331B] = { unicodeslot=0x331B, category='so', description='SQUARE KUROONE', specials={'square',0x30AF,0x30ED,0x30FC,0x30CD} },
	[0x331C] = { unicodeslot=0x331C, category='so', description='SQUARE KEESU', specials={'square',0x30B1,0x30FC,0x30B9} },
	[0x331D] = { unicodeslot=0x331D, category='so', description='SQUARE KORUNA', specials={'square',0x30B3,0x30EB,0x30CA} },
	[0x331E] = { unicodeslot=0x331E, category='so', description='SQUARE KOOPO', specials={'square',0x30B3,0x30FC,0x30DD} },
	[0x331F] = { unicodeslot=0x331F, category='so', description='SQUARE SAIKURU', specials={'square',0x30B5,0x30A4,0x30AF,0x30EB} },
	[0x3320] = { unicodeslot=0x3320, category='so', description='SQUARE SANTIIMU', specials={'square',0x30B5,0x30F3,0x30C1,0x30FC,0x30E0} },
	[0x3321] = { unicodeslot=0x3321, category='so', description='SQUARE SIRINGU', specials={'square',0x30B7,0x30EA,0x30F3,0x30B0} },
	[0x3322] = { unicodeslot=0x3322, category='so', description='SQUARE SENTI', specials={'square',0x30BB,0x30F3,0x30C1} },
	[0x3323] = { unicodeslot=0x3323, category='so', description='SQUARE SENTO', specials={'square',0x30BB,0x30F3,0x30C8} },
	[0x3324] = { unicodeslot=0x3324, category='so', description='SQUARE DAASU', specials={'square',0x30C0,0x30FC,0x30B9} },
	[0x3325] = { unicodeslot=0x3325, category='so', description='SQUARE DESI', specials={'square',0x30C7,0x30B7} },
	[0x3326] = { unicodeslot=0x3326, category='so', description='SQUARE DORU', specials={'square',0x30C9,0x30EB} },
	[0x3327] = { unicodeslot=0x3327, category='so', description='SQUARE TON', specials={'square',0x30C8,0x30F3} },
	[0x3328] = { unicodeslot=0x3328, category='so', description='SQUARE NANO', specials={'square',0x30CA,0x30CE} },
	[0x3329] = { unicodeslot=0x3329, category='so', description='SQUARE NOTTO', specials={'square',0x30CE,0x30C3,0x30C8} },
	[0x332A] = { unicodeslot=0x332A, category='so', description='SQUARE HAITU', specials={'square',0x30CF,0x30A4,0x30C4} },
	[0x332B] = { unicodeslot=0x332B, category='so', description='SQUARE PAASENTO', specials={'square',0x30D1,0x30FC,0x30BB,0x30F3,0x30C8} },
	[0x332C] = { unicodeslot=0x332C, category='so', description='SQUARE PAATU', specials={'square',0x30D1,0x30FC,0x30C4} },
	[0x332D] = { unicodeslot=0x332D, category='so', description='SQUARE BAARERU', specials={'square',0x30D0,0x30FC,0x30EC,0x30EB} },
	[0x332E] = { unicodeslot=0x332E, category='so', description='SQUARE PIASUTORU', specials={'square',0x30D4,0x30A2,0x30B9,0x30C8,0x30EB} },
	[0x332F] = { unicodeslot=0x332F, category='so', description='SQUARE PIKURU', specials={'square',0x30D4,0x30AF,0x30EB} },
	[0x3330] = { unicodeslot=0x3330, category='so', description='SQUARE PIKO', specials={'square',0x30D4,0x30B3} },
	[0x3331] = { unicodeslot=0x3331, category='so', description='SQUARE BIRU', specials={'square',0x30D3,0x30EB} },
	[0x3332] = { unicodeslot=0x3332, category='so', description='SQUARE HUARADDO', specials={'square',0x30D5,0x30A1,0x30E9,0x30C3,0x30C9} },
	[0x3333] = { unicodeslot=0x3333, category='so', description='SQUARE HUIITO', specials={'square',0x30D5,0x30A3,0x30FC,0x30C8} },
	[0x3334] = { unicodeslot=0x3334, category='so', description='SQUARE BUSSYERU', specials={'square',0x30D6,0x30C3,0x30B7,0x30A7,0x30EB} },
	[0x3335] = { unicodeslot=0x3335, category='so', description='SQUARE HURAN', specials={'square',0x30D5,0x30E9,0x30F3} },
	[0x3336] = { unicodeslot=0x3336, category='so', description='SQUARE HEKUTAARU', specials={'square',0x30D8,0x30AF,0x30BF,0x30FC,0x30EB} },
	[0x3337] = { unicodeslot=0x3337, category='so', description='SQUARE PESO', specials={'square',0x30DA,0x30BD} },
	[0x3338] = { unicodeslot=0x3338, category='so', description='SQUARE PENIHI', specials={'square',0x30DA,0x30CB,0x30D2} },
	[0x3339] = { unicodeslot=0x3339, category='so', description='SQUARE HERUTU', specials={'square',0x30D8,0x30EB,0x30C4} },
	[0x333A] = { unicodeslot=0x333A, category='so', description='SQUARE PENSU', specials={'square',0x30DA,0x30F3,0x30B9} },
	[0x333B] = { unicodeslot=0x333B, category='so', description='SQUARE PEEZI', specials={'square',0x30DA,0x30FC,0x30B8} },
	[0x333C] = { unicodeslot=0x333C, category='so', description='SQUARE BEETA', specials={'square',0x30D9,0x30FC,0x30BF} },
	[0x333D] = { unicodeslot=0x333D, category='so', description='SQUARE POINTO', specials={'square',0x30DD,0x30A4,0x30F3,0x30C8} },
	[0x333E] = { unicodeslot=0x333E, category='so', description='SQUARE BORUTO', specials={'square',0x30DC,0x30EB,0x30C8} },
	[0x333F] = { unicodeslot=0x333F, category='so', description='SQUARE HON', specials={'square',0x30DB,0x30F3} },
	[0x3340] = { unicodeslot=0x3340, category='so', description='SQUARE PONDO', specials={'square',0x30DD,0x30F3,0x30C9} },
	[0x3341] = { unicodeslot=0x3341, category='so', description='SQUARE HOORU', specials={'square',0x30DB,0x30FC,0x30EB} },
	[0x3342] = { unicodeslot=0x3342, category='so', description='SQUARE HOON', specials={'square',0x30DB,0x30FC,0x30F3} },
	[0x3343] = { unicodeslot=0x3343, category='so', description='SQUARE MAIKURO', specials={'square',0x30DE,0x30A4,0x30AF,0x30ED} },
	[0x3344] = { unicodeslot=0x3344, category='so', description='SQUARE MAIRU', specials={'square',0x30DE,0x30A4,0x30EB} },
	[0x3345] = { unicodeslot=0x3345, category='so', description='SQUARE MAHHA', specials={'square',0x30DE,0x30C3,0x30CF} },
	[0x3346] = { unicodeslot=0x3346, category='so', description='SQUARE MARUKU', specials={'square',0x30DE,0x30EB,0x30AF} },
	[0x3347] = { unicodeslot=0x3347, category='so', description='SQUARE MANSYON', specials={'square',0x30DE,0x30F3,0x30B7,0x30E7,0x30F3} },
	[0x3348] = { unicodeslot=0x3348, category='so', description='SQUARE MIKURON', specials={'square',0x30DF,0x30AF,0x30ED,0x30F3} },
	[0x3349] = { unicodeslot=0x3349, category='so', description='SQUARE MIRI', specials={'square',0x30DF,0x30EA} },
	[0x334A] = { unicodeslot=0x334A, category='so', description='SQUARE MIRIBAARU', specials={'square',0x30DF,0x30EA,0x30D0,0x30FC,0x30EB} },
	[0x334B] = { unicodeslot=0x334B, category='so', description='SQUARE MEGA', specials={'square',0x30E1,0x30AC} },
	[0x334C] = { unicodeslot=0x334C, category='so', description='SQUARE MEGATON', specials={'square',0x30E1,0x30AC,0x30C8,0x30F3} },
	[0x334D] = { unicodeslot=0x334D, category='so', description='SQUARE MEETORU', specials={'square',0x30E1,0x30FC,0x30C8,0x30EB} },
	[0x334E] = { unicodeslot=0x334E, category='so', description='SQUARE YAADO', specials={'square',0x30E4,0x30FC,0x30C9} },
	[0x334F] = { unicodeslot=0x334F, category='so', description='SQUARE YAARU', specials={'square',0x30E4,0x30FC,0x30EB} },
	[0x3350] = { unicodeslot=0x3350, category='so', description='SQUARE YUAN', specials={'square',0x30E6,0x30A2,0x30F3} },
	[0x3351] = { unicodeslot=0x3351, category='so', description='SQUARE RITTORU', specials={'square',0x30EA,0x30C3,0x30C8,0x30EB} },
	[0x3352] = { unicodeslot=0x3352, category='so', description='SQUARE RIRA', specials={'square',0x30EA,0x30E9} },
	[0x3353] = { unicodeslot=0x3353, category='so', description='SQUARE RUPII', specials={'square',0x30EB,0x30D4,0x30FC} },
	[0x3354] = { unicodeslot=0x3354, category='so', description='SQUARE RUUBURU', specials={'square',0x30EB,0x30FC,0x30D6,0x30EB} },
	[0x3355] = { unicodeslot=0x3355, category='so', description='SQUARE REMU', specials={'square',0x30EC,0x30E0} },
	[0x3356] = { unicodeslot=0x3356, category='so', description='SQUARE RENTOGEN', specials={'square',0x30EC,0x30F3,0x30C8,0x30B2,0x30F3} },
	[0x3357] = { unicodeslot=0x3357, category='so', description='SQUARE WATTO', specials={'square',0x30EF,0x30C3,0x30C8} },
	[0x3358] = { unicodeslot=0x3358, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ZERO', specials={'compat',0x0030,0x70B9} },
	[0x3359] = { unicodeslot=0x3359, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ONE', specials={'compat',0x0031,0x70B9} },
	[0x335A] = { unicodeslot=0x335A, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWO', specials={'compat',0x0032,0x70B9} },
	[0x335B] = { unicodeslot=0x335B, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE', specials={'compat',0x0033,0x70B9} },
	[0x335C] = { unicodeslot=0x335C, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOUR', specials={'compat',0x0034,0x70B9} },
	[0x335D] = { unicodeslot=0x335D, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIVE', specials={'compat',0x0035,0x70B9} },
	[0x335E] = { unicodeslot=0x335E, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIX', specials={'compat',0x0036,0x70B9} },
	[0x335F] = { unicodeslot=0x335F, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN', specials={'compat',0x0037,0x70B9} },
	[0x3360] = { unicodeslot=0x3360, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHT', specials={'compat',0x0038,0x70B9} },
	[0x3361] = { unicodeslot=0x3361, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINE', specials={'compat',0x0039,0x70B9} },
	[0x3362] = { unicodeslot=0x3362, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TEN', specials={'compat',0x0031,0x0030,0x70B9} },
	[0x3363] = { unicodeslot=0x3363, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ELEVEN', specials={'compat',0x0031,0x0031,0x70B9} },
	[0x3364] = { unicodeslot=0x3364, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWELVE', specials={'compat',0x0031,0x0032,0x70B9} },
	[0x3365] = { unicodeslot=0x3365, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN', specials={'compat',0x0031,0x0033,0x70B9} },
	[0x3366] = { unicodeslot=0x3366, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOURTEEN', specials={'compat',0x0031,0x0034,0x70B9} },
	[0x3367] = { unicodeslot=0x3367, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIFTEEN', specials={'compat',0x0031,0x0035,0x70B9} },
	[0x3368] = { unicodeslot=0x3368, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIXTEEN', specials={'compat',0x0031,0x0036,0x70B9} },
	[0x3369] = { unicodeslot=0x3369, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVENTEEN', specials={'compat',0x0031,0x0037,0x70B9} },
	[0x336A] = { unicodeslot=0x336A, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHTEEN', specials={'compat',0x0031,0x0038,0x70B9} },
	[0x336B] = { unicodeslot=0x336B, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINETEEN', specials={'compat',0x0031,0x0039,0x70B9} },
	[0x336C] = { unicodeslot=0x336C, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY', specials={'compat',0x0032,0x0030,0x70B9} },
	[0x336D] = { unicodeslot=0x336D, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-ONE', specials={'compat',0x0032,0x0031,0x70B9} },
	[0x336E] = { unicodeslot=0x336E, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-TWO', specials={'compat',0x0032,0x0032,0x70B9} },
	[0x336F] = { unicodeslot=0x336F, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-THREE', specials={'compat',0x0032,0x0033,0x70B9} },
	[0x3370] = { unicodeslot=0x3370, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-FOUR', specials={'compat',0x0032,0x0034,0x70B9} },
	[0x3371] = { unicodeslot=0x3371, category='so', description='SQUARE HPA', specials={'square',0x0068,0x0050,0x0061} },
	[0x3372] = { unicodeslot=0x3372, category='so', description='SQUARE DA', specials={'square',0x0064,0x0061} },
	[0x3373] = { unicodeslot=0x3373, category='so', description='SQUARE AU', specials={'square',0x0041,0x0055} },
	[0x3374] = { unicodeslot=0x3374, category='so', description='SQUARE BAR', specials={'square',0x0062,0x0061,0x0072} },
	[0x3375] = { unicodeslot=0x3375, category='so', description='SQUARE OV', specials={'square',0x006F,0x0056} },
	[0x3376] = { unicodeslot=0x3376, category='so', description='SQUARE PC', specials={'square',0x0070,0x0063} },
	[0x3377] = { unicodeslot=0x3377, category='so', description='SQUARE DM', specials={'square',0x0064,0x006D} },
	[0x3378] = { unicodeslot=0x3378, category='so', description='SQUARE DM SQUARED', specials={'square',0x0064,0x006D,0x00B2} },
	[0x3379] = { unicodeslot=0x3379, category='so', description='SQUARE DM CUBED', specials={'square',0x0064,0x006D,0x00B3} },
	[0x337A] = { unicodeslot=0x337A, category='so', description='SQUARE IU', specials={'square',0x0049,0x0055} },
	[0x337B] = { unicodeslot=0x337B, category='so', description='SQUARE ERA NAME HEISEI', specials={'square',0x5E73,0x6210} },
	[0x337C] = { unicodeslot=0x337C, category='so', description='SQUARE ERA NAME SYOUWA', specials={'square',0x662D,0x548C} },
	[0x337D] = { unicodeslot=0x337D, category='so', description='SQUARE ERA NAME TAISYOU', specials={'square',0x5927,0x6B63} },
	[0x337E] = { unicodeslot=0x337E, category='so', description='SQUARE ERA NAME MEIZI', specials={'square',0x660E,0x6CBB} },
	[0x337F] = { unicodeslot=0x337F, category='so', description='SQUARE CORPORATION', specials={'square',0x682A,0x5F0F,0x4F1A,0x793E} },
	[0x3380] = { unicodeslot=0x3380, category='so', description='SQUARE PA AMPS', specials={'square',0x0070,0x0041} },
	[0x3381] = { unicodeslot=0x3381, category='so', description='SQUARE NA', specials={'square',0x006E,0x0041} },
	[0x3382] = { unicodeslot=0x3382, category='so', description='SQUARE MU A', specials={'square',0x03BC,0x0041} },
	[0x3383] = { unicodeslot=0x3383, category='so', description='SQUARE MA', specials={'square',0x006D,0x0041} },
	[0x3384] = { unicodeslot=0x3384, category='so', description='SQUARE KA', specials={'square',0x006B,0x0041} },
	[0x3385] = { unicodeslot=0x3385, category='so', description='SQUARE KB', specials={'square',0x004B,0x0042} },
	[0x3386] = { unicodeslot=0x3386, category='so', description='SQUARE MB', specials={'square',0x004D,0x0042} },
	[0x3387] = { unicodeslot=0x3387, category='so', description='SQUARE GB', specials={'square',0x0047,0x0042} },
	[0x3388] = { unicodeslot=0x3388, category='so', description='SQUARE CAL', specials={'square',0x0063,0x0061,0x006C} },
	[0x3389] = { unicodeslot=0x3389, category='so', description='SQUARE KCAL', specials={'square',0x006B,0x0063,0x0061,0x006C} },
	[0x338A] = { unicodeslot=0x338A, category='so', description='SQUARE PF', specials={'square',0x0070,0x0046} },
	[0x338B] = { unicodeslot=0x338B, category='so', description='SQUARE NF', specials={'square',0x006E,0x0046} },
	[0x338C] = { unicodeslot=0x338C, category='so', description='SQUARE MU F', specials={'square',0x03BC,0x0046} },
	[0x338D] = { unicodeslot=0x338D, category='so', description='SQUARE MU G', specials={'square',0x03BC,0x0067} },
	[0x338E] = { unicodeslot=0x338E, category='so', description='SQUARE MG', specials={'square',0x006D,0x0067} },
	[0x338F] = { unicodeslot=0x338F, category='so', description='SQUARE KG', specials={'square',0x006B,0x0067} },
	[0x3390] = { unicodeslot=0x3390, category='so', description='SQUARE HZ', specials={'square',0x0048,0x007A} },
	[0x3391] = { unicodeslot=0x3391, category='so', description='SQUARE KHZ', specials={'square',0x006B,0x0048,0x007A} },
	[0x3392] = { unicodeslot=0x3392, category='so', description='SQUARE MHZ', specials={'square',0x004D,0x0048,0x007A} },
	[0x3393] = { unicodeslot=0x3393, category='so', description='SQUARE GHZ', specials={'square',0x0047,0x0048,0x007A} },
	[0x3394] = { unicodeslot=0x3394, category='so', description='SQUARE THZ', specials={'square',0x0054,0x0048,0x007A} },
	[0x3395] = { unicodeslot=0x3395, category='so', description='SQUARE MU L', specials={'square',0x03BC,0x2113} },
	[0x3396] = { unicodeslot=0x3396, category='so', description='SQUARE ML', specials={'square',0x006D,0x2113} },
	[0x3397] = { unicodeslot=0x3397, category='so', description='SQUARE DL', specials={'square',0x0064,0x2113} },
	[0x3398] = { unicodeslot=0x3398, category='so', description='SQUARE KL', specials={'square',0x006B,0x2113} },
	[0x3399] = { unicodeslot=0x3399, category='so', description='SQUARE FM', specials={'square',0x0066,0x006D} },
	[0x339A] = { unicodeslot=0x339A, category='so', description='SQUARE NM', specials={'square',0x006E,0x006D} },
	[0x339B] = { unicodeslot=0x339B, category='so', description='SQUARE MU M', specials={'square',0x03BC,0x006D} },
	[0x339C] = { unicodeslot=0x339C, category='so', description='SQUARE MM', specials={'square',0x006D,0x006D} },
	[0x339D] = { unicodeslot=0x339D, category='so', description='SQUARE CM', specials={'square',0x0063,0x006D} },
	[0x339E] = { unicodeslot=0x339E, category='so', description='SQUARE KM', specials={'square',0x006B,0x006D} },
	[0x339F] = { unicodeslot=0x339F, category='so', description='SQUARE MM SQUARED', specials={'square',0x006D,0x006D,0x00B2} },
	[0x33A0] = { unicodeslot=0x33A0, category='so', description='SQUARE CM SQUARED', specials={'square',0x0063,0x006D,0x00B2} },
	[0x33A1] = { unicodeslot=0x33A1, category='so', description='SQUARE M SQUARED', specials={'square',0x006D,0x00B2} },
	[0x33A2] = { unicodeslot=0x33A2, category='so', description='SQUARE KM SQUARED', specials={'square',0x006B,0x006D,0x00B2} },
	[0x33A3] = { unicodeslot=0x33A3, category='so', description='SQUARE MM CUBED', specials={'square',0x006D,0x006D,0x00B3} },
	[0x33A4] = { unicodeslot=0x33A4, category='so', description='SQUARE CM CUBED', specials={'square',0x0063,0x006D,0x00B3} },
	[0x33A5] = { unicodeslot=0x33A5, category='so', description='SQUARE M CUBED', specials={'square',0x006D,0x00B3} },
	[0x33A6] = { unicodeslot=0x33A6, category='so', description='SQUARE KM CUBED', specials={'square',0x006B,0x006D,0x00B3} },
	[0x33A7] = { unicodeslot=0x33A7, category='so', description='SQUARE M OVER S', specials={'square',0x006D,0x2215,0x0073} },
	[0x33A8] = { unicodeslot=0x33A8, category='so', description='SQUARE M OVER S SQUARED', specials={'square',0x006D,0x2215,0x0073,0x00B2} },
	[0x33A9] = { unicodeslot=0x33A9, category='so', description='SQUARE PA', specials={'square',0x0050,0x0061} },
	[0x33AA] = { unicodeslot=0x33AA, category='so', description='SQUARE KPA', specials={'square',0x006B,0x0050,0x0061} },
	[0x33AB] = { unicodeslot=0x33AB, category='so', description='SQUARE MPA', specials={'square',0x004D,0x0050,0x0061} },
	[0x33AC] = { unicodeslot=0x33AC, category='so', description='SQUARE GPA', specials={'square',0x0047,0x0050,0x0061} },
	[0x33AD] = { unicodeslot=0x33AD, category='so', description='SQUARE RAD', specials={'square',0x0072,0x0061,0x0064} },
	[0x33AE] = { unicodeslot=0x33AE, category='so', description='SQUARE RAD OVER S', specials={'square',0x0072,0x0061,0x0064,0x2215,0x0073} },
	[0x33AF] = { unicodeslot=0x33AF, category='so', description='SQUARE RAD OVER S SQUARED', specials={'square',0x0072,0x0061,0x0064,0x2215,0x0073,0x00B2} },
	[0x33B0] = { unicodeslot=0x33B0, category='so', description='SQUARE PS', specials={'square',0x0070,0x0073} },
	[0x33B1] = { unicodeslot=0x33B1, category='so', description='SQUARE NS', specials={'square',0x006E,0x0073} },
	[0x33B2] = { unicodeslot=0x33B2, category='so', description='SQUARE MU S', specials={'square',0x03BC,0x0073} },
	[0x33B3] = { unicodeslot=0x33B3, category='so', description='SQUARE MS', specials={'square',0x006D,0x0073} },
	[0x33B4] = { unicodeslot=0x33B4, category='so', description='SQUARE PV', specials={'square',0x0070,0x0056} },
	[0x33B5] = { unicodeslot=0x33B5, category='so', description='SQUARE NV', specials={'square',0x006E,0x0056} },
	[0x33B6] = { unicodeslot=0x33B6, category='so', description='SQUARE MU V', specials={'square',0x03BC,0x0056} },
	[0x33B7] = { unicodeslot=0x33B7, category='so', description='SQUARE MV', specials={'square',0x006D,0x0056} },
	[0x33B8] = { unicodeslot=0x33B8, category='so', description='SQUARE KV', specials={'square',0x006B,0x0056} },
	[0x33B9] = { unicodeslot=0x33B9, category='so', description='SQUARE MV MEGA', specials={'square',0x004D,0x0056} },
	[0x33BA] = { unicodeslot=0x33BA, category='so', description='SQUARE PW', specials={'square',0x0070,0x0057} },
	[0x33BB] = { unicodeslot=0x33BB, category='so', description='SQUARE NW', specials={'square',0x006E,0x0057} },
	[0x33BC] = { unicodeslot=0x33BC, category='so', description='SQUARE MU W', specials={'square',0x03BC,0x0057} },
	[0x33BD] = { unicodeslot=0x33BD, category='so', description='SQUARE MW', specials={'square',0x006D,0x0057} },
	[0x33BE] = { unicodeslot=0x33BE, category='so', description='SQUARE KW', specials={'square',0x006B,0x0057} },
	[0x33BF] = { unicodeslot=0x33BF, category='so', description='SQUARE MW MEGA', specials={'square',0x004D,0x0057} },
	[0x33C0] = { unicodeslot=0x33C0, category='so', description='SQUARE K OHM', specials={'square',0x006B,0x03A9} },
	[0x33C1] = { unicodeslot=0x33C1, category='so', description='SQUARE M OHM', specials={'square',0x004D,0x03A9} },
	[0x33C2] = { unicodeslot=0x33C2, category='so', description='SQUARE AM', specials={'square',0x0061,0x002E,0x006D,0x002E} },
	[0x33C3] = { unicodeslot=0x33C3, category='so', description='SQUARE BQ', specials={'square',0x0042,0x0071} },
	[0x33C4] = { unicodeslot=0x33C4, category='so', description='SQUARE CC', specials={'square',0x0063,0x0063} },
	[0x33C5] = { unicodeslot=0x33C5, category='so', description='SQUARE CD', specials={'square',0x0063,0x0064} },
	[0x33C6] = { unicodeslot=0x33C6, category='so', description='SQUARE C OVER KG', specials={'square',0x0043,0x2215,0x006B,0x0067} },
	[0x33C7] = { unicodeslot=0x33C7, category='so', description='SQUARE CO', specials={'square',0x0043,0x006F,0x002E} },
	[0x33C8] = { unicodeslot=0x33C8, category='so', description='SQUARE DB', specials={'square',0x0064,0x0042} },
	[0x33C9] = { unicodeslot=0x33C9, category='so', description='SQUARE GY', specials={'square',0x0047,0x0079} },
	[0x33CA] = { unicodeslot=0x33CA, category='so', description='SQUARE HA', specials={'square',0x0068,0x0061} },
	[0x33CB] = { unicodeslot=0x33CB, category='so', description='SQUARE HP', specials={'square',0x0048,0x0050} },
	[0x33CC] = { unicodeslot=0x33CC, category='so', description='SQUARE IN', specials={'square',0x0069,0x006E} },
	[0x33CD] = { unicodeslot=0x33CD, category='so', description='SQUARE KK', specials={'square',0x004B,0x004B} },
	[0x33CE] = { unicodeslot=0x33CE, category='so', description='SQUARE KM CAPITAL', specials={'square',0x004B,0x004D} },
	[0x33CF] = { unicodeslot=0x33CF, category='so', description='SQUARE KT', specials={'square',0x006B,0x0074} },
	[0x33D0] = { unicodeslot=0x33D0, category='so', description='SQUARE LM', specials={'square',0x006C,0x006D} },
	[0x33D1] = { unicodeslot=0x33D1, category='so', description='SQUARE LN', specials={'square',0x006C,0x006E} },
	[0x33D2] = { unicodeslot=0x33D2, category='so', description='SQUARE LOG', specials={'square',0x006C,0x006F,0x0067} },
	[0x33D3] = { unicodeslot=0x33D3, category='so', description='SQUARE LX', specials={'square',0x006C,0x0078} },
	[0x33D4] = { unicodeslot=0x33D4, category='so', description='SQUARE MB SMALL', specials={'square',0x006D,0x0062} },
	[0x33D5] = { unicodeslot=0x33D5, category='so', description='SQUARE MIL', specials={'square',0x006D,0x0069,0x006C} },
	[0x33D6] = { unicodeslot=0x33D6, category='so', description='SQUARE MOL', specials={'square',0x006D,0x006F,0x006C} },
	[0x33D7] = { unicodeslot=0x33D7, category='so', description='SQUARE PH', specials={'square',0x0050,0x0048} },
	[0x33D8] = { unicodeslot=0x33D8, category='so', description='SQUARE PM', specials={'square',0x0070,0x002E,0x006D,0x002E} },
	[0x33D9] = { unicodeslot=0x33D9, category='so', description='SQUARE PPM', specials={'square',0x0050,0x0050,0x004D} },
	[0x33DA] = { unicodeslot=0x33DA, category='so', description='SQUARE PR', specials={'square',0x0050,0x0052} },
	[0x33DB] = { unicodeslot=0x33DB, category='so', description='SQUARE SR', specials={'square',0x0073,0x0072} },
	[0x33DC] = { unicodeslot=0x33DC, category='so', description='SQUARE SV', specials={'square',0x0053,0x0076} },
	[0x33DD] = { unicodeslot=0x33DD, category='so', description='SQUARE WB', specials={'square',0x0057,0x0062} },
	[0x33DE] = { unicodeslot=0x33DE, category='so', description='SQUARE V OVER M', specials={'square',0x0056,0x2215,0x006D} },
	[0x33DF] = { unicodeslot=0x33DF, category='so', description='SQUARE A OVER M', specials={'square',0x0041,0x2215,0x006D} },
	[0x33E0] = { unicodeslot=0x33E0, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ONE', specials={'compat',0x0031,0x65E5} },
	[0x33E1] = { unicodeslot=0x33E1, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWO', specials={'compat',0x0032,0x65E5} },
	[0x33E2] = { unicodeslot=0x33E2, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE', specials={'compat',0x0033,0x65E5} },
	[0x33E3] = { unicodeslot=0x33E3, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOUR', specials={'compat',0x0034,0x65E5} },
	[0x33E4] = { unicodeslot=0x33E4, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIVE', specials={'compat',0x0035,0x65E5} },
	[0x33E5] = { unicodeslot=0x33E5, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIX', specials={'compat',0x0036,0x65E5} },
	[0x33E6] = { unicodeslot=0x33E6, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN', specials={'compat',0x0037,0x65E5} },
	[0x33E7] = { unicodeslot=0x33E7, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHT', specials={'compat',0x0038,0x65E5} },
	[0x33E8] = { unicodeslot=0x33E8, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINE', specials={'compat',0x0039,0x65E5} },
	[0x33E9] = { unicodeslot=0x33E9, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TEN', specials={'compat',0x0031,0x0030,0x65E5} },
	[0x33EA] = { unicodeslot=0x33EA, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ELEVEN', specials={'compat',0x0031,0x0031,0x65E5} },
	[0x33EB] = { unicodeslot=0x33EB, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWELVE', specials={'compat',0x0031,0x0032,0x65E5} },
	[0x33EC] = { unicodeslot=0x33EC, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTEEN', specials={'compat',0x0031,0x0033,0x65E5} },
	[0x33ED] = { unicodeslot=0x33ED, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOURTEEN', specials={'compat',0x0031,0x0034,0x65E5} },
	[0x33EE] = { unicodeslot=0x33EE, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIFTEEN', specials={'compat',0x0031,0x0035,0x65E5} },
	[0x33EF] = { unicodeslot=0x33EF, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIXTEEN', specials={'compat',0x0031,0x0036,0x65E5} },
	[0x33F0] = { unicodeslot=0x33F0, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVENTEEN', specials={'compat',0x0031,0x0037,0x65E5} },
	[0x33F1] = { unicodeslot=0x33F1, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHTEEN', specials={'compat',0x0031,0x0038,0x65E5} },
	[0x33F2] = { unicodeslot=0x33F2, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINETEEN', specials={'compat',0x0031,0x0039,0x65E5} },
	[0x33F3] = { unicodeslot=0x33F3, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY', specials={'compat',0x0032,0x0030,0x65E5} },
	[0x33F4] = { unicodeslot=0x33F4, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-ONE', specials={'compat',0x0032,0x0031,0x65E5} },
	[0x33F5] = { unicodeslot=0x33F5, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO', specials={'compat',0x0032,0x0032,0x65E5} },
	[0x33F6] = { unicodeslot=0x33F6, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-THREE', specials={'compat',0x0032,0x0033,0x65E5} },
	[0x33F7] = { unicodeslot=0x33F7, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FOUR', specials={'compat',0x0032,0x0034,0x65E5} },
	[0x33F8] = { unicodeslot=0x33F8, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FIVE', specials={'compat',0x0032,0x0035,0x65E5} },
	[0x33F9] = { unicodeslot=0x33F9, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SIX', specials={'compat',0x0032,0x0036,0x65E5} },
	[0x33FA] = { unicodeslot=0x33FA, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SEVEN', specials={'compat',0x0032,0x0037,0x65E5} },
	[0x33FB] = { unicodeslot=0x33FB, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-EIGHT', specials={'compat',0x0032,0x0038,0x65E5} },
	[0x33FC] = { unicodeslot=0x33FC, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-NINE', specials={'compat',0x0032,0x0039,0x65E5} },
	[0x33FD] = { unicodeslot=0x33FD, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY', specials={'compat',0x0033,0x0030,0x65E5} },
	[0x33FE] = { unicodeslot=0x33FE, category='so', description='IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY-ONE', specials={'compat',0x0033,0x0031,0x65E5} },
	[0x33FF] = { unicodeslot=0x33FF, category='so', description='SQUARE GAL', specials={'square',0x0067,0x0061,0x006C} },
	[0x3400] = { unicodeslot=0x3400, category='lo', description='<CJK Ideograph Extension A, First>' },
	[0x4DB5] = { unicodeslot=0x4DB5, category='lo', description='<CJK Ideograph Extension A, Last>' },
	[0x4DC0] = { unicodeslot=0x4DC0, category='so', description='HEXAGRAM FOR THE CREATIVE HEAVEN' },
	[0x4DC1] = { unicodeslot=0x4DC1, category='so', description='HEXAGRAM FOR THE RECEPTIVE EARTH' },
	[0x4DC2] = { unicodeslot=0x4DC2, category='so', description='HEXAGRAM FOR DIFFICULTY AT THE BEGINNING' },
	[0x4DC3] = { unicodeslot=0x4DC3, category='so', description='HEXAGRAM FOR YOUTHFUL FOLLY' },
	[0x4DC4] = { unicodeslot=0x4DC4, category='so', description='HEXAGRAM FOR WAITING' },
	[0x4DC5] = { unicodeslot=0x4DC5, category='so', description='HEXAGRAM FOR CONFLICT' },
	[0x4DC6] = { unicodeslot=0x4DC6, category='so', description='HEXAGRAM FOR THE ARMY' },
	[0x4DC7] = { unicodeslot=0x4DC7, category='so', description='HEXAGRAM FOR HOLDING TOGETHER' },
	[0x4DC8] = { unicodeslot=0x4DC8, category='so', description='HEXAGRAM FOR SMALL TAMING' },
	[0x4DC9] = { unicodeslot=0x4DC9, category='so', description='HEXAGRAM FOR TREADING' },
	[0x4DCA] = { unicodeslot=0x4DCA, category='so', description='HEXAGRAM FOR PEACE' },
	[0x4DCB] = { unicodeslot=0x4DCB, category='so', description='HEXAGRAM FOR STANDSTILL' },
	[0x4DCC] = { unicodeslot=0x4DCC, category='so', description='HEXAGRAM FOR FELLOWSHIP' },
	[0x4DCD] = { unicodeslot=0x4DCD, category='so', description='HEXAGRAM FOR GREAT POSSESSION' },
	[0x4DCE] = { unicodeslot=0x4DCE, category='so', description='HEXAGRAM FOR MODESTY' },
	[0x4DCF] = { unicodeslot=0x4DCF, category='so', description='HEXAGRAM FOR ENTHUSIASM' },
	[0x4DD0] = { unicodeslot=0x4DD0, category='so', description='HEXAGRAM FOR FOLLOWING' },
	[0x4DD1] = { unicodeslot=0x4DD1, category='so', description='HEXAGRAM FOR WORK ON THE DECAYED' },
	[0x4DD2] = { unicodeslot=0x4DD2, category='so', description='HEXAGRAM FOR APPROACH' },
	[0x4DD3] = { unicodeslot=0x4DD3, category='so', description='HEXAGRAM FOR CONTEMPLATION' },
	[0x4DD4] = { unicodeslot=0x4DD4, category='so', description='HEXAGRAM FOR BITING THROUGH' },
	[0x4DD5] = { unicodeslot=0x4DD5, category='so', description='HEXAGRAM FOR GRACE' },
	[0x4DD6] = { unicodeslot=0x4DD6, category='so', description='HEXAGRAM FOR SPLITTING APART' },
	[0x4DD7] = { unicodeslot=0x4DD7, category='so', description='HEXAGRAM FOR RETURN' },
	[0x4DD8] = { unicodeslot=0x4DD8, category='so', description='HEXAGRAM FOR INNOCENCE' },
	[0x4DD9] = { unicodeslot=0x4DD9, category='so', description='HEXAGRAM FOR GREAT TAMING' },
	[0x4DDA] = { unicodeslot=0x4DDA, category='so', description='HEXAGRAM FOR MOUTH CORNERS' },
	[0x4DDB] = { unicodeslot=0x4DDB, category='so', description='HEXAGRAM FOR GREAT PREPONDERANCE' },
	[0x4DDC] = { unicodeslot=0x4DDC, category='so', description='HEXAGRAM FOR THE ABYSMAL WATER' },
	[0x4DDD] = { unicodeslot=0x4DDD, category='so', description='HEXAGRAM FOR THE CLINGING FIRE' },
	[0x4DDE] = { unicodeslot=0x4DDE, category='so', description='HEXAGRAM FOR INFLUENCE' },
	[0x4DDF] = { unicodeslot=0x4DDF, category='so', description='HEXAGRAM FOR DURATION' },
	[0x4DE0] = { unicodeslot=0x4DE0, category='so', description='HEXAGRAM FOR RETREAT' },
	[0x4DE1] = { unicodeslot=0x4DE1, category='so', description='HEXAGRAM FOR GREAT POWER' },
	[0x4DE2] = { unicodeslot=0x4DE2, category='so', description='HEXAGRAM FOR PROGRESS' },
	[0x4DE3] = { unicodeslot=0x4DE3, category='so', description='HEXAGRAM FOR DARKENING OF THE LIGHT' },
	[0x4DE4] = { unicodeslot=0x4DE4, category='so', description='HEXAGRAM FOR THE FAMILY' },
	[0x4DE5] = { unicodeslot=0x4DE5, category='so', description='HEXAGRAM FOR OPPOSITION' },
	[0x4DE6] = { unicodeslot=0x4DE6, category='so', description='HEXAGRAM FOR OBSTRUCTION' },
	[0x4DE7] = { unicodeslot=0x4DE7, category='so', description='HEXAGRAM FOR DELIVERANCE' },
	[0x4DE8] = { unicodeslot=0x4DE8, category='so', description='HEXAGRAM FOR DECREASE' },
	[0x4DE9] = { unicodeslot=0x4DE9, category='so', description='HEXAGRAM FOR INCREASE' },
	[0x4DEA] = { unicodeslot=0x4DEA, category='so', description='HEXAGRAM FOR BREAKTHROUGH' },
	[0x4DEB] = { unicodeslot=0x4DEB, category='so', description='HEXAGRAM FOR COMING TO MEET' },
	[0x4DEC] = { unicodeslot=0x4DEC, category='so', description='HEXAGRAM FOR GATHERING TOGETHER' },
	[0x4DED] = { unicodeslot=0x4DED, category='so', description='HEXAGRAM FOR PUSHING UPWARD' },
	[0x4DEE] = { unicodeslot=0x4DEE, category='so', description='HEXAGRAM FOR OPPRESSION' },
	[0x4DEF] = { unicodeslot=0x4DEF, category='so', description='HEXAGRAM FOR THE WELL' },
	[0x4DF0] = { unicodeslot=0x4DF0, category='so', description='HEXAGRAM FOR REVOLUTION' },
	[0x4DF1] = { unicodeslot=0x4DF1, category='so', description='HEXAGRAM FOR THE CAULDRON' },
	[0x4DF2] = { unicodeslot=0x4DF2, category='so', description='HEXAGRAM FOR THE AROUSING THUNDER' },
	[0x4DF3] = { unicodeslot=0x4DF3, category='so', description='HEXAGRAM FOR THE KEEPING STILL MOUNTAIN' },
	[0x4DF4] = { unicodeslot=0x4DF4, category='so', description='HEXAGRAM FOR DEVELOPMENT' },
	[0x4DF5] = { unicodeslot=0x4DF5, category='so', description='HEXAGRAM FOR THE MARRYING MAIDEN' },
	[0x4DF6] = { unicodeslot=0x4DF6, category='so', description='HEXAGRAM FOR ABUNDANCE' },
	[0x4DF7] = { unicodeslot=0x4DF7, category='so', description='HEXAGRAM FOR THE WANDERER' },
	[0x4DF8] = { unicodeslot=0x4DF8, category='so', description='HEXAGRAM FOR THE GENTLE WIND' },
	[0x4DF9] = { unicodeslot=0x4DF9, category='so', description='HEXAGRAM FOR THE JOYOUS LAKE' },
	[0x4DFA] = { unicodeslot=0x4DFA, category='so', description='HEXAGRAM FOR DISPERSION' },
	[0x4DFB] = { unicodeslot=0x4DFB, category='so', description='HEXAGRAM FOR LIMITATION' },
	[0x4DFC] = { unicodeslot=0x4DFC, category='so', description='HEXAGRAM FOR INNER TRUTH' },
	[0x4DFD] = { unicodeslot=0x4DFD, category='so', description='HEXAGRAM FOR SMALL PREPONDERANCE' },
	[0x4DFE] = { unicodeslot=0x4DFE, category='so', description='HEXAGRAM FOR AFTER COMPLETION' },
	[0x4DFF] = { unicodeslot=0x4DFF, category='so', description='HEXAGRAM FOR BEFORE COMPLETION' },
	[0x4E00] = { unicodeslot=0x4E00, category='lo', description='<CJK Ideograph, First>' },
	[0x9FBB] = { unicodeslot=0x9FBB, category='lo', description='<CJK Ideograph, Last>' },
	[0xA000] = { unicodeslot=0xA000, category='lo', description='YI SYLLABLE IT' },
	[0xA001] = { unicodeslot=0xA001, category='lo', description='YI SYLLABLE IX' },
	[0xA002] = { unicodeslot=0xA002, category='lo', description='YI SYLLABLE I' },
	[0xA003] = { unicodeslot=0xA003, category='lo', description='YI SYLLABLE IP' },
	[0xA004] = { unicodeslot=0xA004, category='lo', description='YI SYLLABLE IET' },
	[0xA005] = { unicodeslot=0xA005, category='lo', description='YI SYLLABLE IEX' },
	[0xA006] = { unicodeslot=0xA006, category='lo', description='YI SYLLABLE IE' },
	[0xA007] = { unicodeslot=0xA007, category='lo', description='YI SYLLABLE IEP' },
	[0xA008] = { unicodeslot=0xA008, category='lo', description='YI SYLLABLE AT' },
	[0xA009] = { unicodeslot=0xA009, category='lo', description='YI SYLLABLE AX' },
	[0xA00A] = { unicodeslot=0xA00A, category='lo', description='YI SYLLABLE A' },
	[0xA00B] = { unicodeslot=0xA00B, category='lo', description='YI SYLLABLE AP' },
	[0xA00C] = { unicodeslot=0xA00C, category='lo', description='YI SYLLABLE UOX' },
	[0xA00D] = { unicodeslot=0xA00D, category='lo', description='YI SYLLABLE UO' },
	[0xA00E] = { unicodeslot=0xA00E, category='lo', description='YI SYLLABLE UOP' },
	[0xA00F] = { unicodeslot=0xA00F, category='lo', description='YI SYLLABLE OT' },
	[0xA010] = { unicodeslot=0xA010, category='lo', description='YI SYLLABLE OX' },
	[0xA011] = { unicodeslot=0xA011, category='lo', description='YI SYLLABLE O' },
	[0xA012] = { unicodeslot=0xA012, category='lo', description='YI SYLLABLE OP' },
	[0xA013] = { unicodeslot=0xA013, category='lo', description='YI SYLLABLE EX' },
	[0xA014] = { unicodeslot=0xA014, category='lo', description='YI SYLLABLE E' },
	[0xA015] = { unicodeslot=0xA015, category='lm', description='YI SYLLABLE WU' },
	[0xA016] = { unicodeslot=0xA016, category='lo', description='YI SYLLABLE BIT' },
	[0xA017] = { unicodeslot=0xA017, category='lo', description='YI SYLLABLE BIX' },
	[0xA018] = { unicodeslot=0xA018, category='lo', description='YI SYLLABLE BI' },
	[0xA019] = { unicodeslot=0xA019, category='lo', description='YI SYLLABLE BIP' },
	[0xA01A] = { unicodeslot=0xA01A, category='lo', description='YI SYLLABLE BIET' },
	[0xA01B] = { unicodeslot=0xA01B, category='lo', description='YI SYLLABLE BIEX' },
	[0xA01C] = { unicodeslot=0xA01C, category='lo', description='YI SYLLABLE BIE' },
	[0xA01D] = { unicodeslot=0xA01D, category='lo', description='YI SYLLABLE BIEP' },
	[0xA01E] = { unicodeslot=0xA01E, category='lo', description='YI SYLLABLE BAT' },
	[0xA01F] = { unicodeslot=0xA01F, category='lo', description='YI SYLLABLE BAX' },
	[0xA020] = { unicodeslot=0xA020, category='lo', description='YI SYLLABLE BA' },
	[0xA021] = { unicodeslot=0xA021, category='lo', description='YI SYLLABLE BAP' },
	[0xA022] = { unicodeslot=0xA022, category='lo', description='YI SYLLABLE BUOX' },
	[0xA023] = { unicodeslot=0xA023, category='lo', description='YI SYLLABLE BUO' },
	[0xA024] = { unicodeslot=0xA024, category='lo', description='YI SYLLABLE BUOP' },
	[0xA025] = { unicodeslot=0xA025, category='lo', description='YI SYLLABLE BOT' },
	[0xA026] = { unicodeslot=0xA026, category='lo', description='YI SYLLABLE BOX' },
	[0xA027] = { unicodeslot=0xA027, category='lo', description='YI SYLLABLE BO' },
	[0xA028] = { unicodeslot=0xA028, category='lo', description='YI SYLLABLE BOP' },
	[0xA029] = { unicodeslot=0xA029, category='lo', description='YI SYLLABLE BEX' },
	[0xA02A] = { unicodeslot=0xA02A, category='lo', description='YI SYLLABLE BE' },
	[0xA02B] = { unicodeslot=0xA02B, category='lo', description='YI SYLLABLE BEP' },
	[0xA02C] = { unicodeslot=0xA02C, category='lo', description='YI SYLLABLE BUT' },
	[0xA02D] = { unicodeslot=0xA02D, category='lo', description='YI SYLLABLE BUX' },
	[0xA02E] = { unicodeslot=0xA02E, category='lo', description='YI SYLLABLE BU' },
	[0xA02F] = { unicodeslot=0xA02F, category='lo', description='YI SYLLABLE BUP' },
	[0xA030] = { unicodeslot=0xA030, category='lo', description='YI SYLLABLE BURX' },
	[0xA031] = { unicodeslot=0xA031, category='lo', description='YI SYLLABLE BUR' },
	[0xA032] = { unicodeslot=0xA032, category='lo', description='YI SYLLABLE BYT' },
	[0xA033] = { unicodeslot=0xA033, category='lo', description='YI SYLLABLE BYX' },
	[0xA034] = { unicodeslot=0xA034, category='lo', description='YI SYLLABLE BY' },
	[0xA035] = { unicodeslot=0xA035, category='lo', description='YI SYLLABLE BYP' },
	[0xA036] = { unicodeslot=0xA036, category='lo', description='YI SYLLABLE BYRX' },
	[0xA037] = { unicodeslot=0xA037, category='lo', description='YI SYLLABLE BYR' },
	[0xA038] = { unicodeslot=0xA038, category='lo', description='YI SYLLABLE PIT' },
	[0xA039] = { unicodeslot=0xA039, category='lo', description='YI SYLLABLE PIX' },
	[0xA03A] = { unicodeslot=0xA03A, category='lo', description='YI SYLLABLE PI' },
	[0xA03B] = { unicodeslot=0xA03B, category='lo', description='YI SYLLABLE PIP' },
	[0xA03C] = { unicodeslot=0xA03C, category='lo', description='YI SYLLABLE PIEX' },
	[0xA03D] = { unicodeslot=0xA03D, category='lo', description='YI SYLLABLE PIE' },
	[0xA03E] = { unicodeslot=0xA03E, category='lo', description='YI SYLLABLE PIEP' },
	[0xA03F] = { unicodeslot=0xA03F, category='lo', description='YI SYLLABLE PAT' },
	[0xA040] = { unicodeslot=0xA040, category='lo', description='YI SYLLABLE PAX' },
	[0xA041] = { unicodeslot=0xA041, category='lo', description='YI SYLLABLE PA' },
	[0xA042] = { unicodeslot=0xA042, category='lo', description='YI SYLLABLE PAP' },
	[0xA043] = { unicodeslot=0xA043, category='lo', description='YI SYLLABLE PUOX' },
	[0xA044] = { unicodeslot=0xA044, category='lo', description='YI SYLLABLE PUO' },
	[0xA045] = { unicodeslot=0xA045, category='lo', description='YI SYLLABLE PUOP' },
	[0xA046] = { unicodeslot=0xA046, category='lo', description='YI SYLLABLE POT' },
	[0xA047] = { unicodeslot=0xA047, category='lo', description='YI SYLLABLE POX' },
	[0xA048] = { unicodeslot=0xA048, category='lo', description='YI SYLLABLE PO' },
	[0xA049] = { unicodeslot=0xA049, category='lo', description='YI SYLLABLE POP' },
	[0xA04A] = { unicodeslot=0xA04A, category='lo', description='YI SYLLABLE PUT' },
	[0xA04B] = { unicodeslot=0xA04B, category='lo', description='YI SYLLABLE PUX' },
	[0xA04C] = { unicodeslot=0xA04C, category='lo', description='YI SYLLABLE PU' },
	[0xA04D] = { unicodeslot=0xA04D, category='lo', description='YI SYLLABLE PUP' },
	[0xA04E] = { unicodeslot=0xA04E, category='lo', description='YI SYLLABLE PURX' },
	[0xA04F] = { unicodeslot=0xA04F, category='lo', description='YI SYLLABLE PUR' },
	[0xA050] = { unicodeslot=0xA050, category='lo', description='YI SYLLABLE PYT' },
	[0xA051] = { unicodeslot=0xA051, category='lo', description='YI SYLLABLE PYX' },
	[0xA052] = { unicodeslot=0xA052, category='lo', description='YI SYLLABLE PY' },
	[0xA053] = { unicodeslot=0xA053, category='lo', description='YI SYLLABLE PYP' },
	[0xA054] = { unicodeslot=0xA054, category='lo', description='YI SYLLABLE PYRX' },
	[0xA055] = { unicodeslot=0xA055, category='lo', description='YI SYLLABLE PYR' },
	[0xA056] = { unicodeslot=0xA056, category='lo', description='YI SYLLABLE BBIT' },
	[0xA057] = { unicodeslot=0xA057, category='lo', description='YI SYLLABLE BBIX' },
	[0xA058] = { unicodeslot=0xA058, category='lo', description='YI SYLLABLE BBI' },
	[0xA059] = { unicodeslot=0xA059, category='lo', description='YI SYLLABLE BBIP' },
	[0xA05A] = { unicodeslot=0xA05A, category='lo', description='YI SYLLABLE BBIET' },
	[0xA05B] = { unicodeslot=0xA05B, category='lo', description='YI SYLLABLE BBIEX' },
	[0xA05C] = { unicodeslot=0xA05C, category='lo', description='YI SYLLABLE BBIE' },
	[0xA05D] = { unicodeslot=0xA05D, category='lo', description='YI SYLLABLE BBIEP' },
	[0xA05E] = { unicodeslot=0xA05E, category='lo', description='YI SYLLABLE BBAT' },
	[0xA05F] = { unicodeslot=0xA05F, category='lo', description='YI SYLLABLE BBAX' },
	[0xA060] = { unicodeslot=0xA060, category='lo', description='YI SYLLABLE BBA' },
	[0xA061] = { unicodeslot=0xA061, category='lo', description='YI SYLLABLE BBAP' },
	[0xA062] = { unicodeslot=0xA062, category='lo', description='YI SYLLABLE BBUOX' },
	[0xA063] = { unicodeslot=0xA063, category='lo', description='YI SYLLABLE BBUO' },
	[0xA064] = { unicodeslot=0xA064, category='lo', description='YI SYLLABLE BBUOP' },
	[0xA065] = { unicodeslot=0xA065, category='lo', description='YI SYLLABLE BBOT' },
	[0xA066] = { unicodeslot=0xA066, category='lo', description='YI SYLLABLE BBOX' },
	[0xA067] = { unicodeslot=0xA067, category='lo', description='YI SYLLABLE BBO' },
	[0xA068] = { unicodeslot=0xA068, category='lo', description='YI SYLLABLE BBOP' },
	[0xA069] = { unicodeslot=0xA069, category='lo', description='YI SYLLABLE BBEX' },
	[0xA06A] = { unicodeslot=0xA06A, category='lo', description='YI SYLLABLE BBE' },
	[0xA06B] = { unicodeslot=0xA06B, category='lo', description='YI SYLLABLE BBEP' },
	[0xA06C] = { unicodeslot=0xA06C, category='lo', description='YI SYLLABLE BBUT' },
	[0xA06D] = { unicodeslot=0xA06D, category='lo', description='YI SYLLABLE BBUX' },
	[0xA06E] = { unicodeslot=0xA06E, category='lo', description='YI SYLLABLE BBU' },
	[0xA06F] = { unicodeslot=0xA06F, category='lo', description='YI SYLLABLE BBUP' },
	[0xA070] = { unicodeslot=0xA070, category='lo', description='YI SYLLABLE BBURX' },
	[0xA071] = { unicodeslot=0xA071, category='lo', description='YI SYLLABLE BBUR' },
	[0xA072] = { unicodeslot=0xA072, category='lo', description='YI SYLLABLE BBYT' },
	[0xA073] = { unicodeslot=0xA073, category='lo', description='YI SYLLABLE BBYX' },
	[0xA074] = { unicodeslot=0xA074, category='lo', description='YI SYLLABLE BBY' },
	[0xA075] = { unicodeslot=0xA075, category='lo', description='YI SYLLABLE BBYP' },
	[0xA076] = { unicodeslot=0xA076, category='lo', description='YI SYLLABLE NBIT' },
	[0xA077] = { unicodeslot=0xA077, category='lo', description='YI SYLLABLE NBIX' },
	[0xA078] = { unicodeslot=0xA078, category='lo', description='YI SYLLABLE NBI' },
	[0xA079] = { unicodeslot=0xA079, category='lo', description='YI SYLLABLE NBIP' },
	[0xA07A] = { unicodeslot=0xA07A, category='lo', description='YI SYLLABLE NBIEX' },
	[0xA07B] = { unicodeslot=0xA07B, category='lo', description='YI SYLLABLE NBIE' },
	[0xA07C] = { unicodeslot=0xA07C, category='lo', description='YI SYLLABLE NBIEP' },
	[0xA07D] = { unicodeslot=0xA07D, category='lo', description='YI SYLLABLE NBAT' },
	[0xA07E] = { unicodeslot=0xA07E, category='lo', description='YI SYLLABLE NBAX' },
	[0xA07F] = { unicodeslot=0xA07F, category='lo', description='YI SYLLABLE NBA' },
	[0xA080] = { unicodeslot=0xA080, category='lo', description='YI SYLLABLE NBAP' },
	[0xA081] = { unicodeslot=0xA081, category='lo', description='YI SYLLABLE NBOT' },
	[0xA082] = { unicodeslot=0xA082, category='lo', description='YI SYLLABLE NBOX' },
	[0xA083] = { unicodeslot=0xA083, category='lo', description='YI SYLLABLE NBO' },
	[0xA084] = { unicodeslot=0xA084, category='lo', description='YI SYLLABLE NBOP' },
	[0xA085] = { unicodeslot=0xA085, category='lo', description='YI SYLLABLE NBUT' },
	[0xA086] = { unicodeslot=0xA086, category='lo', description='YI SYLLABLE NBUX' },
	[0xA087] = { unicodeslot=0xA087, category='lo', description='YI SYLLABLE NBU' },
	[0xA088] = { unicodeslot=0xA088, category='lo', description='YI SYLLABLE NBUP' },
	[0xA089] = { unicodeslot=0xA089, category='lo', description='YI SYLLABLE NBURX' },
	[0xA08A] = { unicodeslot=0xA08A, category='lo', description='YI SYLLABLE NBUR' },
	[0xA08B] = { unicodeslot=0xA08B, category='lo', description='YI SYLLABLE NBYT' },
	[0xA08C] = { unicodeslot=0xA08C, category='lo', description='YI SYLLABLE NBYX' },
	[0xA08D] = { unicodeslot=0xA08D, category='lo', description='YI SYLLABLE NBY' },
	[0xA08E] = { unicodeslot=0xA08E, category='lo', description='YI SYLLABLE NBYP' },
	[0xA08F] = { unicodeslot=0xA08F, category='lo', description='YI SYLLABLE NBYRX' },
	[0xA090] = { unicodeslot=0xA090, category='lo', description='YI SYLLABLE NBYR' },
	[0xA091] = { unicodeslot=0xA091, category='lo', description='YI SYLLABLE HMIT' },
	[0xA092] = { unicodeslot=0xA092, category='lo', description='YI SYLLABLE HMIX' },
	[0xA093] = { unicodeslot=0xA093, category='lo', description='YI SYLLABLE HMI' },
	[0xA094] = { unicodeslot=0xA094, category='lo', description='YI SYLLABLE HMIP' },
	[0xA095] = { unicodeslot=0xA095, category='lo', description='YI SYLLABLE HMIEX' },
	[0xA096] = { unicodeslot=0xA096, category='lo', description='YI SYLLABLE HMIE' },
	[0xA097] = { unicodeslot=0xA097, category='lo', description='YI SYLLABLE HMIEP' },
	[0xA098] = { unicodeslot=0xA098, category='lo', description='YI SYLLABLE HMAT' },
	[0xA099] = { unicodeslot=0xA099, category='lo', description='YI SYLLABLE HMAX' },
	[0xA09A] = { unicodeslot=0xA09A, category='lo', description='YI SYLLABLE HMA' },
	[0xA09B] = { unicodeslot=0xA09B, category='lo', description='YI SYLLABLE HMAP' },
	[0xA09C] = { unicodeslot=0xA09C, category='lo', description='YI SYLLABLE HMUOX' },
	[0xA09D] = { unicodeslot=0xA09D, category='lo', description='YI SYLLABLE HMUO' },
	[0xA09E] = { unicodeslot=0xA09E, category='lo', description='YI SYLLABLE HMUOP' },
	[0xA09F] = { unicodeslot=0xA09F, category='lo', description='YI SYLLABLE HMOT' },
	[0xA0A0] = { unicodeslot=0xA0A0, category='lo', description='YI SYLLABLE HMOX' },
	[0xA0A1] = { unicodeslot=0xA0A1, category='lo', description='YI SYLLABLE HMO' },
	[0xA0A2] = { unicodeslot=0xA0A2, category='lo', description='YI SYLLABLE HMOP' },
	[0xA0A3] = { unicodeslot=0xA0A3, category='lo', description='YI SYLLABLE HMUT' },
	[0xA0A4] = { unicodeslot=0xA0A4, category='lo', description='YI SYLLABLE HMUX' },
	[0xA0A5] = { unicodeslot=0xA0A5, category='lo', description='YI SYLLABLE HMU' },
	[0xA0A6] = { unicodeslot=0xA0A6, category='lo', description='YI SYLLABLE HMUP' },
	[0xA0A7] = { unicodeslot=0xA0A7, category='lo', description='YI SYLLABLE HMURX' },
	[0xA0A8] = { unicodeslot=0xA0A8, category='lo', description='YI SYLLABLE HMUR' },
	[0xA0A9] = { unicodeslot=0xA0A9, category='lo', description='YI SYLLABLE HMYX' },
	[0xA0AA] = { unicodeslot=0xA0AA, category='lo', description='YI SYLLABLE HMY' },
	[0xA0AB] = { unicodeslot=0xA0AB, category='lo', description='YI SYLLABLE HMYP' },
	[0xA0AC] = { unicodeslot=0xA0AC, category='lo', description='YI SYLLABLE HMYRX' },
	[0xA0AD] = { unicodeslot=0xA0AD, category='lo', description='YI SYLLABLE HMYR' },
	[0xA0AE] = { unicodeslot=0xA0AE, category='lo', description='YI SYLLABLE MIT' },
	[0xA0AF] = { unicodeslot=0xA0AF, category='lo', description='YI SYLLABLE MIX' },
	[0xA0B0] = { unicodeslot=0xA0B0, category='lo', description='YI SYLLABLE MI' },
	[0xA0B1] = { unicodeslot=0xA0B1, category='lo', description='YI SYLLABLE MIP' },
	[0xA0B2] = { unicodeslot=0xA0B2, category='lo', description='YI SYLLABLE MIEX' },
	[0xA0B3] = { unicodeslot=0xA0B3, category='lo', description='YI SYLLABLE MIE' },
	[0xA0B4] = { unicodeslot=0xA0B4, category='lo', description='YI SYLLABLE MIEP' },
	[0xA0B5] = { unicodeslot=0xA0B5, category='lo', description='YI SYLLABLE MAT' },
	[0xA0B6] = { unicodeslot=0xA0B6, category='lo', description='YI SYLLABLE MAX' },
	[0xA0B7] = { unicodeslot=0xA0B7, category='lo', description='YI SYLLABLE MA' },
	[0xA0B8] = { unicodeslot=0xA0B8, category='lo', description='YI SYLLABLE MAP' },
	[0xA0B9] = { unicodeslot=0xA0B9, category='lo', description='YI SYLLABLE MUOT' },
	[0xA0BA] = { unicodeslot=0xA0BA, category='lo', description='YI SYLLABLE MUOX' },
	[0xA0BB] = { unicodeslot=0xA0BB, category='lo', description='YI SYLLABLE MUO' },
	[0xA0BC] = { unicodeslot=0xA0BC, category='lo', description='YI SYLLABLE MUOP' },
	[0xA0BD] = { unicodeslot=0xA0BD, category='lo', description='YI SYLLABLE MOT' },
	[0xA0BE] = { unicodeslot=0xA0BE, category='lo', description='YI SYLLABLE MOX' },
	[0xA0BF] = { unicodeslot=0xA0BF, category='lo', description='YI SYLLABLE MO' },
	[0xA0C0] = { unicodeslot=0xA0C0, category='lo', description='YI SYLLABLE MOP' },
	[0xA0C1] = { unicodeslot=0xA0C1, category='lo', description='YI SYLLABLE MEX' },
	[0xA0C2] = { unicodeslot=0xA0C2, category='lo', description='YI SYLLABLE ME' },
	[0xA0C3] = { unicodeslot=0xA0C3, category='lo', description='YI SYLLABLE MUT' },
	[0xA0C4] = { unicodeslot=0xA0C4, category='lo', description='YI SYLLABLE MUX' },
	[0xA0C5] = { unicodeslot=0xA0C5, category='lo', description='YI SYLLABLE MU' },
	[0xA0C6] = { unicodeslot=0xA0C6, category='lo', description='YI SYLLABLE MUP' },
	[0xA0C7] = { unicodeslot=0xA0C7, category='lo', description='YI SYLLABLE MURX' },
	[0xA0C8] = { unicodeslot=0xA0C8, category='lo', description='YI SYLLABLE MUR' },
	[0xA0C9] = { unicodeslot=0xA0C9, category='lo', description='YI SYLLABLE MYT' },
	[0xA0CA] = { unicodeslot=0xA0CA, category='lo', description='YI SYLLABLE MYX' },
	[0xA0CB] = { unicodeslot=0xA0CB, category='lo', description='YI SYLLABLE MY' },
	[0xA0CC] = { unicodeslot=0xA0CC, category='lo', description='YI SYLLABLE MYP' },
	[0xA0CD] = { unicodeslot=0xA0CD, category='lo', description='YI SYLLABLE FIT' },
	[0xA0CE] = { unicodeslot=0xA0CE, category='lo', description='YI SYLLABLE FIX' },
	[0xA0CF] = { unicodeslot=0xA0CF, category='lo', description='YI SYLLABLE FI' },
	[0xA0D0] = { unicodeslot=0xA0D0, category='lo', description='YI SYLLABLE FIP' },
	[0xA0D1] = { unicodeslot=0xA0D1, category='lo', description='YI SYLLABLE FAT' },
	[0xA0D2] = { unicodeslot=0xA0D2, category='lo', description='YI SYLLABLE FAX' },
	[0xA0D3] = { unicodeslot=0xA0D3, category='lo', description='YI SYLLABLE FA' },
	[0xA0D4] = { unicodeslot=0xA0D4, category='lo', description='YI SYLLABLE FAP' },
	[0xA0D5] = { unicodeslot=0xA0D5, category='lo', description='YI SYLLABLE FOX' },
	[0xA0D6] = { unicodeslot=0xA0D6, category='lo', description='YI SYLLABLE FO' },
	[0xA0D7] = { unicodeslot=0xA0D7, category='lo', description='YI SYLLABLE FOP' },
	[0xA0D8] = { unicodeslot=0xA0D8, category='lo', description='YI SYLLABLE FUT' },
	[0xA0D9] = { unicodeslot=0xA0D9, category='lo', description='YI SYLLABLE FUX' },
	[0xA0DA] = { unicodeslot=0xA0DA, category='lo', description='YI SYLLABLE FU' },
	[0xA0DB] = { unicodeslot=0xA0DB, category='lo', description='YI SYLLABLE FUP' },
	[0xA0DC] = { unicodeslot=0xA0DC, category='lo', description='YI SYLLABLE FURX' },
	[0xA0DD] = { unicodeslot=0xA0DD, category='lo', description='YI SYLLABLE FUR' },
	[0xA0DE] = { unicodeslot=0xA0DE, category='lo', description='YI SYLLABLE FYT' },
	[0xA0DF] = { unicodeslot=0xA0DF, category='lo', description='YI SYLLABLE FYX' },
	[0xA0E0] = { unicodeslot=0xA0E0, category='lo', description='YI SYLLABLE FY' },
	[0xA0E1] = { unicodeslot=0xA0E1, category='lo', description='YI SYLLABLE FYP' },
	[0xA0E2] = { unicodeslot=0xA0E2, category='lo', description='YI SYLLABLE VIT' },
	[0xA0E3] = { unicodeslot=0xA0E3, category='lo', description='YI SYLLABLE VIX' },
	[0xA0E4] = { unicodeslot=0xA0E4, category='lo', description='YI SYLLABLE VI' },
	[0xA0E5] = { unicodeslot=0xA0E5, category='lo', description='YI SYLLABLE VIP' },
	[0xA0E6] = { unicodeslot=0xA0E6, category='lo', description='YI SYLLABLE VIET' },
	[0xA0E7] = { unicodeslot=0xA0E7, category='lo', description='YI SYLLABLE VIEX' },
	[0xA0E8] = { unicodeslot=0xA0E8, category='lo', description='YI SYLLABLE VIE' },
	[0xA0E9] = { unicodeslot=0xA0E9, category='lo', description='YI SYLLABLE VIEP' },
	[0xA0EA] = { unicodeslot=0xA0EA, category='lo', description='YI SYLLABLE VAT' },
	[0xA0EB] = { unicodeslot=0xA0EB, category='lo', description='YI SYLLABLE VAX' },
	[0xA0EC] = { unicodeslot=0xA0EC, category='lo', description='YI SYLLABLE VA' },
	[0xA0ED] = { unicodeslot=0xA0ED, category='lo', description='YI SYLLABLE VAP' },
	[0xA0EE] = { unicodeslot=0xA0EE, category='lo', description='YI SYLLABLE VOT' },
	[0xA0EF] = { unicodeslot=0xA0EF, category='lo', description='YI SYLLABLE VOX' },
	[0xA0F0] = { unicodeslot=0xA0F0, category='lo', description='YI SYLLABLE VO' },
	[0xA0F1] = { unicodeslot=0xA0F1, category='lo', description='YI SYLLABLE VOP' },
	[0xA0F2] = { unicodeslot=0xA0F2, category='lo', description='YI SYLLABLE VEX' },
	[0xA0F3] = { unicodeslot=0xA0F3, category='lo', description='YI SYLLABLE VEP' },
	[0xA0F4] = { unicodeslot=0xA0F4, category='lo', description='YI SYLLABLE VUT' },
	[0xA0F5] = { unicodeslot=0xA0F5, category='lo', description='YI SYLLABLE VUX' },
	[0xA0F6] = { unicodeslot=0xA0F6, category='lo', description='YI SYLLABLE VU' },
	[0xA0F7] = { unicodeslot=0xA0F7, category='lo', description='YI SYLLABLE VUP' },
	[0xA0F8] = { unicodeslot=0xA0F8, category='lo', description='YI SYLLABLE VURX' },
	[0xA0F9] = { unicodeslot=0xA0F9, category='lo', description='YI SYLLABLE VUR' },
	[0xA0FA] = { unicodeslot=0xA0FA, category='lo', description='YI SYLLABLE VYT' },
	[0xA0FB] = { unicodeslot=0xA0FB, category='lo', description='YI SYLLABLE VYX' },
	[0xA0FC] = { unicodeslot=0xA0FC, category='lo', description='YI SYLLABLE VY' },
	[0xA0FD] = { unicodeslot=0xA0FD, category='lo', description='YI SYLLABLE VYP' },
	[0xA0FE] = { unicodeslot=0xA0FE, category='lo', description='YI SYLLABLE VYRX' },
	[0xA0FF] = { unicodeslot=0xA0FF, category='lo', description='YI SYLLABLE VYR' },
	[0xA100] = { unicodeslot=0xA100, category='lo', description='YI SYLLABLE DIT' },
	[0xA101] = { unicodeslot=0xA101, category='lo', description='YI SYLLABLE DIX' },
	[0xA102] = { unicodeslot=0xA102, category='lo', description='YI SYLLABLE DI' },
	[0xA103] = { unicodeslot=0xA103, category='lo', description='YI SYLLABLE DIP' },
	[0xA104] = { unicodeslot=0xA104, category='lo', description='YI SYLLABLE DIEX' },
	[0xA105] = { unicodeslot=0xA105, category='lo', description='YI SYLLABLE DIE' },
	[0xA106] = { unicodeslot=0xA106, category='lo', description='YI SYLLABLE DIEP' },
	[0xA107] = { unicodeslot=0xA107, category='lo', description='YI SYLLABLE DAT' },
	[0xA108] = { unicodeslot=0xA108, category='lo', description='YI SYLLABLE DAX' },
	[0xA109] = { unicodeslot=0xA109, category='lo', description='YI SYLLABLE DA' },
	[0xA10A] = { unicodeslot=0xA10A, category='lo', description='YI SYLLABLE DAP' },
	[0xA10B] = { unicodeslot=0xA10B, category='lo', description='YI SYLLABLE DUOX' },
	[0xA10C] = { unicodeslot=0xA10C, category='lo', description='YI SYLLABLE DUO' },
	[0xA10D] = { unicodeslot=0xA10D, category='lo', description='YI SYLLABLE DOT' },
	[0xA10E] = { unicodeslot=0xA10E, category='lo', description='YI SYLLABLE DOX' },
	[0xA10F] = { unicodeslot=0xA10F, category='lo', description='YI SYLLABLE DO' },
	[0xA110] = { unicodeslot=0xA110, category='lo', description='YI SYLLABLE DOP' },
	[0xA111] = { unicodeslot=0xA111, category='lo', description='YI SYLLABLE DEX' },
	[0xA112] = { unicodeslot=0xA112, category='lo', description='YI SYLLABLE DE' },
	[0xA113] = { unicodeslot=0xA113, category='lo', description='YI SYLLABLE DEP' },
	[0xA114] = { unicodeslot=0xA114, category='lo', description='YI SYLLABLE DUT' },
	[0xA115] = { unicodeslot=0xA115, category='lo', description='YI SYLLABLE DUX' },
	[0xA116] = { unicodeslot=0xA116, category='lo', description='YI SYLLABLE DU' },
	[0xA117] = { unicodeslot=0xA117, category='lo', description='YI SYLLABLE DUP' },
	[0xA118] = { unicodeslot=0xA118, category='lo', description='YI SYLLABLE DURX' },
	[0xA119] = { unicodeslot=0xA119, category='lo', description='YI SYLLABLE DUR' },
	[0xA11A] = { unicodeslot=0xA11A, category='lo', description='YI SYLLABLE TIT' },
	[0xA11B] = { unicodeslot=0xA11B, category='lo', description='YI SYLLABLE TIX' },
	[0xA11C] = { unicodeslot=0xA11C, category='lo', description='YI SYLLABLE TI' },
	[0xA11D] = { unicodeslot=0xA11D, category='lo', description='YI SYLLABLE TIP' },
	[0xA11E] = { unicodeslot=0xA11E, category='lo', description='YI SYLLABLE TIEX' },
	[0xA11F] = { unicodeslot=0xA11F, category='lo', description='YI SYLLABLE TIE' },
	[0xA120] = { unicodeslot=0xA120, category='lo', description='YI SYLLABLE TIEP' },
	[0xA121] = { unicodeslot=0xA121, category='lo', description='YI SYLLABLE TAT' },
	[0xA122] = { unicodeslot=0xA122, category='lo', description='YI SYLLABLE TAX' },
	[0xA123] = { unicodeslot=0xA123, category='lo', description='YI SYLLABLE TA' },
	[0xA124] = { unicodeslot=0xA124, category='lo', description='YI SYLLABLE TAP' },
	[0xA125] = { unicodeslot=0xA125, category='lo', description='YI SYLLABLE TUOT' },
	[0xA126] = { unicodeslot=0xA126, category='lo', description='YI SYLLABLE TUOX' },
	[0xA127] = { unicodeslot=0xA127, category='lo', description='YI SYLLABLE TUO' },
	[0xA128] = { unicodeslot=0xA128, category='lo', description='YI SYLLABLE TUOP' },
	[0xA129] = { unicodeslot=0xA129, category='lo', description='YI SYLLABLE TOT' },
	[0xA12A] = { unicodeslot=0xA12A, category='lo', description='YI SYLLABLE TOX' },
	[0xA12B] = { unicodeslot=0xA12B, category='lo', description='YI SYLLABLE TO' },
	[0xA12C] = { unicodeslot=0xA12C, category='lo', description='YI SYLLABLE TOP' },
	[0xA12D] = { unicodeslot=0xA12D, category='lo', description='YI SYLLABLE TEX' },
	[0xA12E] = { unicodeslot=0xA12E, category='lo', description='YI SYLLABLE TE' },
	[0xA12F] = { unicodeslot=0xA12F, category='lo', description='YI SYLLABLE TEP' },
	[0xA130] = { unicodeslot=0xA130, category='lo', description='YI SYLLABLE TUT' },
	[0xA131] = { unicodeslot=0xA131, category='lo', description='YI SYLLABLE TUX' },
	[0xA132] = { unicodeslot=0xA132, category='lo', description='YI SYLLABLE TU' },
	[0xA133] = { unicodeslot=0xA133, category='lo', description='YI SYLLABLE TUP' },
	[0xA134] = { unicodeslot=0xA134, category='lo', description='YI SYLLABLE TURX' },
	[0xA135] = { unicodeslot=0xA135, category='lo', description='YI SYLLABLE TUR' },
	[0xA136] = { unicodeslot=0xA136, category='lo', description='YI SYLLABLE DDIT' },
	[0xA137] = { unicodeslot=0xA137, category='lo', description='YI SYLLABLE DDIX' },
	[0xA138] = { unicodeslot=0xA138, category='lo', description='YI SYLLABLE DDI' },
	[0xA139] = { unicodeslot=0xA139, category='lo', description='YI SYLLABLE DDIP' },
	[0xA13A] = { unicodeslot=0xA13A, category='lo', description='YI SYLLABLE DDIEX' },
	[0xA13B] = { unicodeslot=0xA13B, category='lo', description='YI SYLLABLE DDIE' },
	[0xA13C] = { unicodeslot=0xA13C, category='lo', description='YI SYLLABLE DDIEP' },
	[0xA13D] = { unicodeslot=0xA13D, category='lo', description='YI SYLLABLE DDAT' },
	[0xA13E] = { unicodeslot=0xA13E, category='lo', description='YI SYLLABLE DDAX' },
	[0xA13F] = { unicodeslot=0xA13F, category='lo', description='YI SYLLABLE DDA' },
	[0xA140] = { unicodeslot=0xA140, category='lo', description='YI SYLLABLE DDAP' },
	[0xA141] = { unicodeslot=0xA141, category='lo', description='YI SYLLABLE DDUOX' },
	[0xA142] = { unicodeslot=0xA142, category='lo', description='YI SYLLABLE DDUO' },
	[0xA143] = { unicodeslot=0xA143, category='lo', description='YI SYLLABLE DDUOP' },
	[0xA144] = { unicodeslot=0xA144, category='lo', description='YI SYLLABLE DDOT' },
	[0xA145] = { unicodeslot=0xA145, category='lo', description='YI SYLLABLE DDOX' },
	[0xA146] = { unicodeslot=0xA146, category='lo', description='YI SYLLABLE DDO' },
	[0xA147] = { unicodeslot=0xA147, category='lo', description='YI SYLLABLE DDOP' },
	[0xA148] = { unicodeslot=0xA148, category='lo', description='YI SYLLABLE DDEX' },
	[0xA149] = { unicodeslot=0xA149, category='lo', description='YI SYLLABLE DDE' },
	[0xA14A] = { unicodeslot=0xA14A, category='lo', description='YI SYLLABLE DDEP' },
	[0xA14B] = { unicodeslot=0xA14B, category='lo', description='YI SYLLABLE DDUT' },
	[0xA14C] = { unicodeslot=0xA14C, category='lo', description='YI SYLLABLE DDUX' },
	[0xA14D] = { unicodeslot=0xA14D, category='lo', description='YI SYLLABLE DDU' },
	[0xA14E] = { unicodeslot=0xA14E, category='lo', description='YI SYLLABLE DDUP' },
	[0xA14F] = { unicodeslot=0xA14F, category='lo', description='YI SYLLABLE DDURX' },
	[0xA150] = { unicodeslot=0xA150, category='lo', description='YI SYLLABLE DDUR' },
	[0xA151] = { unicodeslot=0xA151, category='lo', description='YI SYLLABLE NDIT' },
	[0xA152] = { unicodeslot=0xA152, category='lo', description='YI SYLLABLE NDIX' },
	[0xA153] = { unicodeslot=0xA153, category='lo', description='YI SYLLABLE NDI' },
	[0xA154] = { unicodeslot=0xA154, category='lo', description='YI SYLLABLE NDIP' },
	[0xA155] = { unicodeslot=0xA155, category='lo', description='YI SYLLABLE NDIEX' },
	[0xA156] = { unicodeslot=0xA156, category='lo', description='YI SYLLABLE NDIE' },
	[0xA157] = { unicodeslot=0xA157, category='lo', description='YI SYLLABLE NDAT' },
	[0xA158] = { unicodeslot=0xA158, category='lo', description='YI SYLLABLE NDAX' },
	[0xA159] = { unicodeslot=0xA159, category='lo', description='YI SYLLABLE NDA' },
	[0xA15A] = { unicodeslot=0xA15A, category='lo', description='YI SYLLABLE NDAP' },
	[0xA15B] = { unicodeslot=0xA15B, category='lo', description='YI SYLLABLE NDOT' },
	[0xA15C] = { unicodeslot=0xA15C, category='lo', description='YI SYLLABLE NDOX' },
	[0xA15D] = { unicodeslot=0xA15D, category='lo', description='YI SYLLABLE NDO' },
	[0xA15E] = { unicodeslot=0xA15E, category='lo', description='YI SYLLABLE NDOP' },
	[0xA15F] = { unicodeslot=0xA15F, category='lo', description='YI SYLLABLE NDEX' },
	[0xA160] = { unicodeslot=0xA160, category='lo', description='YI SYLLABLE NDE' },
	[0xA161] = { unicodeslot=0xA161, category='lo', description='YI SYLLABLE NDEP' },
	[0xA162] = { unicodeslot=0xA162, category='lo', description='YI SYLLABLE NDUT' },
	[0xA163] = { unicodeslot=0xA163, category='lo', description='YI SYLLABLE NDUX' },
	[0xA164] = { unicodeslot=0xA164, category='lo', description='YI SYLLABLE NDU' },
	[0xA165] = { unicodeslot=0xA165, category='lo', description='YI SYLLABLE NDUP' },
	[0xA166] = { unicodeslot=0xA166, category='lo', description='YI SYLLABLE NDURX' },
	[0xA167] = { unicodeslot=0xA167, category='lo', description='YI SYLLABLE NDUR' },
	[0xA168] = { unicodeslot=0xA168, category='lo', description='YI SYLLABLE HNIT' },
	[0xA169] = { unicodeslot=0xA169, category='lo', description='YI SYLLABLE HNIX' },
	[0xA16A] = { unicodeslot=0xA16A, category='lo', description='YI SYLLABLE HNI' },
	[0xA16B] = { unicodeslot=0xA16B, category='lo', description='YI SYLLABLE HNIP' },
	[0xA16C] = { unicodeslot=0xA16C, category='lo', description='YI SYLLABLE HNIET' },
	[0xA16D] = { unicodeslot=0xA16D, category='lo', description='YI SYLLABLE HNIEX' },
	[0xA16E] = { unicodeslot=0xA16E, category='lo', description='YI SYLLABLE HNIE' },
	[0xA16F] = { unicodeslot=0xA16F, category='lo', description='YI SYLLABLE HNIEP' },
	[0xA170] = { unicodeslot=0xA170, category='lo', description='YI SYLLABLE HNAT' },
	[0xA171] = { unicodeslot=0xA171, category='lo', description='YI SYLLABLE HNAX' },
	[0xA172] = { unicodeslot=0xA172, category='lo', description='YI SYLLABLE HNA' },
	[0xA173] = { unicodeslot=0xA173, category='lo', description='YI SYLLABLE HNAP' },
	[0xA174] = { unicodeslot=0xA174, category='lo', description='YI SYLLABLE HNUOX' },
	[0xA175] = { unicodeslot=0xA175, category='lo', description='YI SYLLABLE HNUO' },
	[0xA176] = { unicodeslot=0xA176, category='lo', description='YI SYLLABLE HNOT' },
	[0xA177] = { unicodeslot=0xA177, category='lo', description='YI SYLLABLE HNOX' },
	[0xA178] = { unicodeslot=0xA178, category='lo', description='YI SYLLABLE HNOP' },
	[0xA179] = { unicodeslot=0xA179, category='lo', description='YI SYLLABLE HNEX' },
	[0xA17A] = { unicodeslot=0xA17A, category='lo', description='YI SYLLABLE HNE' },
	[0xA17B] = { unicodeslot=0xA17B, category='lo', description='YI SYLLABLE HNEP' },
	[0xA17C] = { unicodeslot=0xA17C, category='lo', description='YI SYLLABLE HNUT' },
	[0xA17D] = { unicodeslot=0xA17D, category='lo', description='YI SYLLABLE NIT' },
	[0xA17E] = { unicodeslot=0xA17E, category='lo', description='YI SYLLABLE NIX' },
	[0xA17F] = { unicodeslot=0xA17F, category='lo', description='YI SYLLABLE NI' },
	[0xA180] = { unicodeslot=0xA180, category='lo', description='YI SYLLABLE NIP' },
	[0xA181] = { unicodeslot=0xA181, category='lo', description='YI SYLLABLE NIEX' },
	[0xA182] = { unicodeslot=0xA182, category='lo', description='YI SYLLABLE NIE' },
	[0xA183] = { unicodeslot=0xA183, category='lo', description='YI SYLLABLE NIEP' },
	[0xA184] = { unicodeslot=0xA184, category='lo', description='YI SYLLABLE NAX' },
	[0xA185] = { unicodeslot=0xA185, category='lo', description='YI SYLLABLE NA' },
	[0xA186] = { unicodeslot=0xA186, category='lo', description='YI SYLLABLE NAP' },
	[0xA187] = { unicodeslot=0xA187, category='lo', description='YI SYLLABLE NUOX' },
	[0xA188] = { unicodeslot=0xA188, category='lo', description='YI SYLLABLE NUO' },
	[0xA189] = { unicodeslot=0xA189, category='lo', description='YI SYLLABLE NUOP' },
	[0xA18A] = { unicodeslot=0xA18A, category='lo', description='YI SYLLABLE NOT' },
	[0xA18B] = { unicodeslot=0xA18B, category='lo', description='YI SYLLABLE NOX' },
	[0xA18C] = { unicodeslot=0xA18C, category='lo', description='YI SYLLABLE NO' },
	[0xA18D] = { unicodeslot=0xA18D, category='lo', description='YI SYLLABLE NOP' },
	[0xA18E] = { unicodeslot=0xA18E, category='lo', description='YI SYLLABLE NEX' },
	[0xA18F] = { unicodeslot=0xA18F, category='lo', description='YI SYLLABLE NE' },
	[0xA190] = { unicodeslot=0xA190, category='lo', description='YI SYLLABLE NEP' },
	[0xA191] = { unicodeslot=0xA191, category='lo', description='YI SYLLABLE NUT' },
	[0xA192] = { unicodeslot=0xA192, category='lo', description='YI SYLLABLE NUX' },
	[0xA193] = { unicodeslot=0xA193, category='lo', description='YI SYLLABLE NU' },
	[0xA194] = { unicodeslot=0xA194, category='lo', description='YI SYLLABLE NUP' },
	[0xA195] = { unicodeslot=0xA195, category='lo', description='YI SYLLABLE NURX' },
	[0xA196] = { unicodeslot=0xA196, category='lo', description='YI SYLLABLE NUR' },
	[0xA197] = { unicodeslot=0xA197, category='lo', description='YI SYLLABLE HLIT' },
	[0xA198] = { unicodeslot=0xA198, category='lo', description='YI SYLLABLE HLIX' },
	[0xA199] = { unicodeslot=0xA199, category='lo', description='YI SYLLABLE HLI' },
	[0xA19A] = { unicodeslot=0xA19A, category='lo', description='YI SYLLABLE HLIP' },
	[0xA19B] = { unicodeslot=0xA19B, category='lo', description='YI SYLLABLE HLIEX' },
	[0xA19C] = { unicodeslot=0xA19C, category='lo', description='YI SYLLABLE HLIE' },
	[0xA19D] = { unicodeslot=0xA19D, category='lo', description='YI SYLLABLE HLIEP' },
	[0xA19E] = { unicodeslot=0xA19E, category='lo', description='YI SYLLABLE HLAT' },
	[0xA19F] = { unicodeslot=0xA19F, category='lo', description='YI SYLLABLE HLAX' },
	[0xA1A0] = { unicodeslot=0xA1A0, category='lo', description='YI SYLLABLE HLA' },
	[0xA1A1] = { unicodeslot=0xA1A1, category='lo', description='YI SYLLABLE HLAP' },
	[0xA1A2] = { unicodeslot=0xA1A2, category='lo', description='YI SYLLABLE HLUOX' },
	[0xA1A3] = { unicodeslot=0xA1A3, category='lo', description='YI SYLLABLE HLUO' },
	[0xA1A4] = { unicodeslot=0xA1A4, category='lo', description='YI SYLLABLE HLUOP' },
	[0xA1A5] = { unicodeslot=0xA1A5, category='lo', description='YI SYLLABLE HLOX' },
	[0xA1A6] = { unicodeslot=0xA1A6, category='lo', description='YI SYLLABLE HLO' },
	[0xA1A7] = { unicodeslot=0xA1A7, category='lo', description='YI SYLLABLE HLOP' },
	[0xA1A8] = { unicodeslot=0xA1A8, category='lo', description='YI SYLLABLE HLEX' },
	[0xA1A9] = { unicodeslot=0xA1A9, category='lo', description='YI SYLLABLE HLE' },
	[0xA1AA] = { unicodeslot=0xA1AA, category='lo', description='YI SYLLABLE HLEP' },
	[0xA1AB] = { unicodeslot=0xA1AB, category='lo', description='YI SYLLABLE HLUT' },
	[0xA1AC] = { unicodeslot=0xA1AC, category='lo', description='YI SYLLABLE HLUX' },
	[0xA1AD] = { unicodeslot=0xA1AD, category='lo', description='YI SYLLABLE HLU' },
	[0xA1AE] = { unicodeslot=0xA1AE, category='lo', description='YI SYLLABLE HLUP' },
	[0xA1AF] = { unicodeslot=0xA1AF, category='lo', description='YI SYLLABLE HLURX' },
	[0xA1B0] = { unicodeslot=0xA1B0, category='lo', description='YI SYLLABLE HLUR' },
	[0xA1B1] = { unicodeslot=0xA1B1, category='lo', description='YI SYLLABLE HLYT' },
	[0xA1B2] = { unicodeslot=0xA1B2, category='lo', description='YI SYLLABLE HLYX' },
	[0xA1B3] = { unicodeslot=0xA1B3, category='lo', description='YI SYLLABLE HLY' },
	[0xA1B4] = { unicodeslot=0xA1B4, category='lo', description='YI SYLLABLE HLYP' },
	[0xA1B5] = { unicodeslot=0xA1B5, category='lo', description='YI SYLLABLE HLYRX' },
	[0xA1B6] = { unicodeslot=0xA1B6, category='lo', description='YI SYLLABLE HLYR' },
	[0xA1B7] = { unicodeslot=0xA1B7, category='lo', description='YI SYLLABLE LIT' },
	[0xA1B8] = { unicodeslot=0xA1B8, category='lo', description='YI SYLLABLE LIX' },
	[0xA1B9] = { unicodeslot=0xA1B9, category='lo', description='YI SYLLABLE LI' },
	[0xA1BA] = { unicodeslot=0xA1BA, category='lo', description='YI SYLLABLE LIP' },
	[0xA1BB] = { unicodeslot=0xA1BB, category='lo', description='YI SYLLABLE LIET' },
	[0xA1BC] = { unicodeslot=0xA1BC, category='lo', description='YI SYLLABLE LIEX' },
	[0xA1BD] = { unicodeslot=0xA1BD, category='lo', description='YI SYLLABLE LIE' },
	[0xA1BE] = { unicodeslot=0xA1BE, category='lo', description='YI SYLLABLE LIEP' },
	[0xA1BF] = { unicodeslot=0xA1BF, category='lo', description='YI SYLLABLE LAT' },
	[0xA1C0] = { unicodeslot=0xA1C0, category='lo', description='YI SYLLABLE LAX' },
	[0xA1C1] = { unicodeslot=0xA1C1, category='lo', description='YI SYLLABLE LA' },
	[0xA1C2] = { unicodeslot=0xA1C2, category='lo', description='YI SYLLABLE LAP' },
	[0xA1C3] = { unicodeslot=0xA1C3, category='lo', description='YI SYLLABLE LUOT' },
	[0xA1C4] = { unicodeslot=0xA1C4, category='lo', description='YI SYLLABLE LUOX' },
	[0xA1C5] = { unicodeslot=0xA1C5, category='lo', description='YI SYLLABLE LUO' },
	[0xA1C6] = { unicodeslot=0xA1C6, category='lo', description='YI SYLLABLE LUOP' },
	[0xA1C7] = { unicodeslot=0xA1C7, category='lo', description='YI SYLLABLE LOT' },
	[0xA1C8] = { unicodeslot=0xA1C8, category='lo', description='YI SYLLABLE LOX' },
	[0xA1C9] = { unicodeslot=0xA1C9, category='lo', description='YI SYLLABLE LO' },
	[0xA1CA] = { unicodeslot=0xA1CA, category='lo', description='YI SYLLABLE LOP' },
	[0xA1CB] = { unicodeslot=0xA1CB, category='lo', description='YI SYLLABLE LEX' },
	[0xA1CC] = { unicodeslot=0xA1CC, category='lo', description='YI SYLLABLE LE' },
	[0xA1CD] = { unicodeslot=0xA1CD, category='lo', description='YI SYLLABLE LEP' },
	[0xA1CE] = { unicodeslot=0xA1CE, category='lo', description='YI SYLLABLE LUT' },
	[0xA1CF] = { unicodeslot=0xA1CF, category='lo', description='YI SYLLABLE LUX' },
	[0xA1D0] = { unicodeslot=0xA1D0, category='lo', description='YI SYLLABLE LU' },
	[0xA1D1] = { unicodeslot=0xA1D1, category='lo', description='YI SYLLABLE LUP' },
	[0xA1D2] = { unicodeslot=0xA1D2, category='lo', description='YI SYLLABLE LURX' },
	[0xA1D3] = { unicodeslot=0xA1D3, category='lo', description='YI SYLLABLE LUR' },
	[0xA1D4] = { unicodeslot=0xA1D4, category='lo', description='YI SYLLABLE LYT' },
	[0xA1D5] = { unicodeslot=0xA1D5, category='lo', description='YI SYLLABLE LYX' },
	[0xA1D6] = { unicodeslot=0xA1D6, category='lo', description='YI SYLLABLE LY' },
	[0xA1D7] = { unicodeslot=0xA1D7, category='lo', description='YI SYLLABLE LYP' },
	[0xA1D8] = { unicodeslot=0xA1D8, category='lo', description='YI SYLLABLE LYRX' },
	[0xA1D9] = { unicodeslot=0xA1D9, category='lo', description='YI SYLLABLE LYR' },
	[0xA1DA] = { unicodeslot=0xA1DA, category='lo', description='YI SYLLABLE GIT' },
	[0xA1DB] = { unicodeslot=0xA1DB, category='lo', description='YI SYLLABLE GIX' },
	[0xA1DC] = { unicodeslot=0xA1DC, category='lo', description='YI SYLLABLE GI' },
	[0xA1DD] = { unicodeslot=0xA1DD, category='lo', description='YI SYLLABLE GIP' },
	[0xA1DE] = { unicodeslot=0xA1DE, category='lo', description='YI SYLLABLE GIET' },
	[0xA1DF] = { unicodeslot=0xA1DF, category='lo', description='YI SYLLABLE GIEX' },
	[0xA1E0] = { unicodeslot=0xA1E0, category='lo', description='YI SYLLABLE GIE' },
	[0xA1E1] = { unicodeslot=0xA1E1, category='lo', description='YI SYLLABLE GIEP' },
	[0xA1E2] = { unicodeslot=0xA1E2, category='lo', description='YI SYLLABLE GAT' },
	[0xA1E3] = { unicodeslot=0xA1E3, category='lo', description='YI SYLLABLE GAX' },
	[0xA1E4] = { unicodeslot=0xA1E4, category='lo', description='YI SYLLABLE GA' },
	[0xA1E5] = { unicodeslot=0xA1E5, category='lo', description='YI SYLLABLE GAP' },
	[0xA1E6] = { unicodeslot=0xA1E6, category='lo', description='YI SYLLABLE GUOT' },
	[0xA1E7] = { unicodeslot=0xA1E7, category='lo', description='YI SYLLABLE GUOX' },
	[0xA1E8] = { unicodeslot=0xA1E8, category='lo', description='YI SYLLABLE GUO' },
	[0xA1E9] = { unicodeslot=0xA1E9, category='lo', description='YI SYLLABLE GUOP' },
	[0xA1EA] = { unicodeslot=0xA1EA, category='lo', description='YI SYLLABLE GOT' },
	[0xA1EB] = { unicodeslot=0xA1EB, category='lo', description='YI SYLLABLE GOX' },
	[0xA1EC] = { unicodeslot=0xA1EC, category='lo', description='YI SYLLABLE GO' },
	[0xA1ED] = { unicodeslot=0xA1ED, category='lo', description='YI SYLLABLE GOP' },
	[0xA1EE] = { unicodeslot=0xA1EE, category='lo', description='YI SYLLABLE GET' },
	[0xA1EF] = { unicodeslot=0xA1EF, category='lo', description='YI SYLLABLE GEX' },
	[0xA1F0] = { unicodeslot=0xA1F0, category='lo', description='YI SYLLABLE GE' },
	[0xA1F1] = { unicodeslot=0xA1F1, category='lo', description='YI SYLLABLE GEP' },
	[0xA1F2] = { unicodeslot=0xA1F2, category='lo', description='YI SYLLABLE GUT' },
	[0xA1F3] = { unicodeslot=0xA1F3, category='lo', description='YI SYLLABLE GUX' },
	[0xA1F4] = { unicodeslot=0xA1F4, category='lo', description='YI SYLLABLE GU' },
	[0xA1F5] = { unicodeslot=0xA1F5, category='lo', description='YI SYLLABLE GUP' },
	[0xA1F6] = { unicodeslot=0xA1F6, category='lo', description='YI SYLLABLE GURX' },
	[0xA1F7] = { unicodeslot=0xA1F7, category='lo', description='YI SYLLABLE GUR' },
	[0xA1F8] = { unicodeslot=0xA1F8, category='lo', description='YI SYLLABLE KIT' },
	[0xA1F9] = { unicodeslot=0xA1F9, category='lo', description='YI SYLLABLE KIX' },
	[0xA1FA] = { unicodeslot=0xA1FA, category='lo', description='YI SYLLABLE KI' },
	[0xA1FB] = { unicodeslot=0xA1FB, category='lo', description='YI SYLLABLE KIP' },
	[0xA1FC] = { unicodeslot=0xA1FC, category='lo', description='YI SYLLABLE KIEX' },
	[0xA1FD] = { unicodeslot=0xA1FD, category='lo', description='YI SYLLABLE KIE' },
	[0xA1FE] = { unicodeslot=0xA1FE, category='lo', description='YI SYLLABLE KIEP' },
	[0xA1FF] = { unicodeslot=0xA1FF, category='lo', description='YI SYLLABLE KAT' },
	[0xA200] = { unicodeslot=0xA200, category='lo', description='YI SYLLABLE KAX' },
	[0xA201] = { unicodeslot=0xA201, category='lo', description='YI SYLLABLE KA' },
	[0xA202] = { unicodeslot=0xA202, category='lo', description='YI SYLLABLE KAP' },
	[0xA203] = { unicodeslot=0xA203, category='lo', description='YI SYLLABLE KUOX' },
	[0xA204] = { unicodeslot=0xA204, category='lo', description='YI SYLLABLE KUO' },
	[0xA205] = { unicodeslot=0xA205, category='lo', description='YI SYLLABLE KUOP' },
	[0xA206] = { unicodeslot=0xA206, category='lo', description='YI SYLLABLE KOT' },
	[0xA207] = { unicodeslot=0xA207, category='lo', description='YI SYLLABLE KOX' },
	[0xA208] = { unicodeslot=0xA208, category='lo', description='YI SYLLABLE KO' },
	[0xA209] = { unicodeslot=0xA209, category='lo', description='YI SYLLABLE KOP' },
	[0xA20A] = { unicodeslot=0xA20A, category='lo', description='YI SYLLABLE KET' },
	[0xA20B] = { unicodeslot=0xA20B, category='lo', description='YI SYLLABLE KEX' },
	[0xA20C] = { unicodeslot=0xA20C, category='lo', description='YI SYLLABLE KE' },
	[0xA20D] = { unicodeslot=0xA20D, category='lo', description='YI SYLLABLE KEP' },
	[0xA20E] = { unicodeslot=0xA20E, category='lo', description='YI SYLLABLE KUT' },
	[0xA20F] = { unicodeslot=0xA20F, category='lo', description='YI SYLLABLE KUX' },
	[0xA210] = { unicodeslot=0xA210, category='lo', description='YI SYLLABLE KU' },
	[0xA211] = { unicodeslot=0xA211, category='lo', description='YI SYLLABLE KUP' },
	[0xA212] = { unicodeslot=0xA212, category='lo', description='YI SYLLABLE KURX' },
	[0xA213] = { unicodeslot=0xA213, category='lo', description='YI SYLLABLE KUR' },
	[0xA214] = { unicodeslot=0xA214, category='lo', description='YI SYLLABLE GGIT' },
	[0xA215] = { unicodeslot=0xA215, category='lo', description='YI SYLLABLE GGIX' },
	[0xA216] = { unicodeslot=0xA216, category='lo', description='YI SYLLABLE GGI' },
	[0xA217] = { unicodeslot=0xA217, category='lo', description='YI SYLLABLE GGIEX' },
	[0xA218] = { unicodeslot=0xA218, category='lo', description='YI SYLLABLE GGIE' },
	[0xA219] = { unicodeslot=0xA219, category='lo', description='YI SYLLABLE GGIEP' },
	[0xA21A] = { unicodeslot=0xA21A, category='lo', description='YI SYLLABLE GGAT' },
	[0xA21B] = { unicodeslot=0xA21B, category='lo', description='YI SYLLABLE GGAX' },
	[0xA21C] = { unicodeslot=0xA21C, category='lo', description='YI SYLLABLE GGA' },
	[0xA21D] = { unicodeslot=0xA21D, category='lo', description='YI SYLLABLE GGAP' },
	[0xA21E] = { unicodeslot=0xA21E, category='lo', description='YI SYLLABLE GGUOT' },
	[0xA21F] = { unicodeslot=0xA21F, category='lo', description='YI SYLLABLE GGUOX' },
	[0xA220] = { unicodeslot=0xA220, category='lo', description='YI SYLLABLE GGUO' },
	[0xA221] = { unicodeslot=0xA221, category='lo', description='YI SYLLABLE GGUOP' },
	[0xA222] = { unicodeslot=0xA222, category='lo', description='YI SYLLABLE GGOT' },
	[0xA223] = { unicodeslot=0xA223, category='lo', description='YI SYLLABLE GGOX' },
	[0xA224] = { unicodeslot=0xA224, category='lo', description='YI SYLLABLE GGO' },
	[0xA225] = { unicodeslot=0xA225, category='lo', description='YI SYLLABLE GGOP' },
	[0xA226] = { unicodeslot=0xA226, category='lo', description='YI SYLLABLE GGET' },
	[0xA227] = { unicodeslot=0xA227, category='lo', description='YI SYLLABLE GGEX' },
	[0xA228] = { unicodeslot=0xA228, category='lo', description='YI SYLLABLE GGE' },
	[0xA229] = { unicodeslot=0xA229, category='lo', description='YI SYLLABLE GGEP' },
	[0xA22A] = { unicodeslot=0xA22A, category='lo', description='YI SYLLABLE GGUT' },
	[0xA22B] = { unicodeslot=0xA22B, category='lo', description='YI SYLLABLE GGUX' },
	[0xA22C] = { unicodeslot=0xA22C, category='lo', description='YI SYLLABLE GGU' },
	[0xA22D] = { unicodeslot=0xA22D, category='lo', description='YI SYLLABLE GGUP' },
	[0xA22E] = { unicodeslot=0xA22E, category='lo', description='YI SYLLABLE GGURX' },
	[0xA22F] = { unicodeslot=0xA22F, category='lo', description='YI SYLLABLE GGUR' },
	[0xA230] = { unicodeslot=0xA230, category='lo', description='YI SYLLABLE MGIEX' },
	[0xA231] = { unicodeslot=0xA231, category='lo', description='YI SYLLABLE MGIE' },
	[0xA232] = { unicodeslot=0xA232, category='lo', description='YI SYLLABLE MGAT' },
	[0xA233] = { unicodeslot=0xA233, category='lo', description='YI SYLLABLE MGAX' },
	[0xA234] = { unicodeslot=0xA234, category='lo', description='YI SYLLABLE MGA' },
	[0xA235] = { unicodeslot=0xA235, category='lo', description='YI SYLLABLE MGAP' },
	[0xA236] = { unicodeslot=0xA236, category='lo', description='YI SYLLABLE MGUOX' },
	[0xA237] = { unicodeslot=0xA237, category='lo', description='YI SYLLABLE MGUO' },
	[0xA238] = { unicodeslot=0xA238, category='lo', description='YI SYLLABLE MGUOP' },
	[0xA239] = { unicodeslot=0xA239, category='lo', description='YI SYLLABLE MGOT' },
	[0xA23A] = { unicodeslot=0xA23A, category='lo', description='YI SYLLABLE MGOX' },
	[0xA23B] = { unicodeslot=0xA23B, category='lo', description='YI SYLLABLE MGO' },
	[0xA23C] = { unicodeslot=0xA23C, category='lo', description='YI SYLLABLE MGOP' },
	[0xA23D] = { unicodeslot=0xA23D, category='lo', description='YI SYLLABLE MGEX' },
	[0xA23E] = { unicodeslot=0xA23E, category='lo', description='YI SYLLABLE MGE' },
	[0xA23F] = { unicodeslot=0xA23F, category='lo', description='YI SYLLABLE MGEP' },
	[0xA240] = { unicodeslot=0xA240, category='lo', description='YI SYLLABLE MGUT' },
	[0xA241] = { unicodeslot=0xA241, category='lo', description='YI SYLLABLE MGUX' },
	[0xA242] = { unicodeslot=0xA242, category='lo', description='YI SYLLABLE MGU' },
	[0xA243] = { unicodeslot=0xA243, category='lo', description='YI SYLLABLE MGUP' },
	[0xA244] = { unicodeslot=0xA244, category='lo', description='YI SYLLABLE MGURX' },
	[0xA245] = { unicodeslot=0xA245, category='lo', description='YI SYLLABLE MGUR' },
	[0xA246] = { unicodeslot=0xA246, category='lo', description='YI SYLLABLE HXIT' },
	[0xA247] = { unicodeslot=0xA247, category='lo', description='YI SYLLABLE HXIX' },
	[0xA248] = { unicodeslot=0xA248, category='lo', description='YI SYLLABLE HXI' },
	[0xA249] = { unicodeslot=0xA249, category='lo', description='YI SYLLABLE HXIP' },
	[0xA24A] = { unicodeslot=0xA24A, category='lo', description='YI SYLLABLE HXIET' },
	[0xA24B] = { unicodeslot=0xA24B, category='lo', description='YI SYLLABLE HXIEX' },
	[0xA24C] = { unicodeslot=0xA24C, category='lo', description='YI SYLLABLE HXIE' },
	[0xA24D] = { unicodeslot=0xA24D, category='lo', description='YI SYLLABLE HXIEP' },
	[0xA24E] = { unicodeslot=0xA24E, category='lo', description='YI SYLLABLE HXAT' },
	[0xA24F] = { unicodeslot=0xA24F, category='lo', description='YI SYLLABLE HXAX' },
	[0xA250] = { unicodeslot=0xA250, category='lo', description='YI SYLLABLE HXA' },
	[0xA251] = { unicodeslot=0xA251, category='lo', description='YI SYLLABLE HXAP' },
	[0xA252] = { unicodeslot=0xA252, category='lo', description='YI SYLLABLE HXUOT' },
	[0xA253] = { unicodeslot=0xA253, category='lo', description='YI SYLLABLE HXUOX' },
	[0xA254] = { unicodeslot=0xA254, category='lo', description='YI SYLLABLE HXUO' },
	[0xA255] = { unicodeslot=0xA255, category='lo', description='YI SYLLABLE HXUOP' },
	[0xA256] = { unicodeslot=0xA256, category='lo', description='YI SYLLABLE HXOT' },
	[0xA257] = { unicodeslot=0xA257, category='lo', description='YI SYLLABLE HXOX' },
	[0xA258] = { unicodeslot=0xA258, category='lo', description='YI SYLLABLE HXO' },
	[0xA259] = { unicodeslot=0xA259, category='lo', description='YI SYLLABLE HXOP' },
	[0xA25A] = { unicodeslot=0xA25A, category='lo', description='YI SYLLABLE HXEX' },
	[0xA25B] = { unicodeslot=0xA25B, category='lo', description='YI SYLLABLE HXE' },
	[0xA25C] = { unicodeslot=0xA25C, category='lo', description='YI SYLLABLE HXEP' },
	[0xA25D] = { unicodeslot=0xA25D, category='lo', description='YI SYLLABLE NGIEX' },
	[0xA25E] = { unicodeslot=0xA25E, category='lo', description='YI SYLLABLE NGIE' },
	[0xA25F] = { unicodeslot=0xA25F, category='lo', description='YI SYLLABLE NGIEP' },
	[0xA260] = { unicodeslot=0xA260, category='lo', description='YI SYLLABLE NGAT' },
	[0xA261] = { unicodeslot=0xA261, category='lo', description='YI SYLLABLE NGAX' },
	[0xA262] = { unicodeslot=0xA262, category='lo', description='YI SYLLABLE NGA' },
	[0xA263] = { unicodeslot=0xA263, category='lo', description='YI SYLLABLE NGAP' },
	[0xA264] = { unicodeslot=0xA264, category='lo', description='YI SYLLABLE NGUOT' },
	[0xA265] = { unicodeslot=0xA265, category='lo', description='YI SYLLABLE NGUOX' },
	[0xA266] = { unicodeslot=0xA266, category='lo', description='YI SYLLABLE NGUO' },
	[0xA267] = { unicodeslot=0xA267, category='lo', description='YI SYLLABLE NGOT' },
	[0xA268] = { unicodeslot=0xA268, category='lo', description='YI SYLLABLE NGOX' },
	[0xA269] = { unicodeslot=0xA269, category='lo', description='YI SYLLABLE NGO' },
	[0xA26A] = { unicodeslot=0xA26A, category='lo', description='YI SYLLABLE NGOP' },
	[0xA26B] = { unicodeslot=0xA26B, category='lo', description='YI SYLLABLE NGEX' },
	[0xA26C] = { unicodeslot=0xA26C, category='lo', description='YI SYLLABLE NGE' },
	[0xA26D] = { unicodeslot=0xA26D, category='lo', description='YI SYLLABLE NGEP' },
	[0xA26E] = { unicodeslot=0xA26E, category='lo', description='YI SYLLABLE HIT' },
	[0xA26F] = { unicodeslot=0xA26F, category='lo', description='YI SYLLABLE HIEX' },
	[0xA270] = { unicodeslot=0xA270, category='lo', description='YI SYLLABLE HIE' },
	[0xA271] = { unicodeslot=0xA271, category='lo', description='YI SYLLABLE HAT' },
	[0xA272] = { unicodeslot=0xA272, category='lo', description='YI SYLLABLE HAX' },
	[0xA273] = { unicodeslot=0xA273, category='lo', description='YI SYLLABLE HA' },
	[0xA274] = { unicodeslot=0xA274, category='lo', description='YI SYLLABLE HAP' },
	[0xA275] = { unicodeslot=0xA275, category='lo', description='YI SYLLABLE HUOT' },
	[0xA276] = { unicodeslot=0xA276, category='lo', description='YI SYLLABLE HUOX' },
	[0xA277] = { unicodeslot=0xA277, category='lo', description='YI SYLLABLE HUO' },
	[0xA278] = { unicodeslot=0xA278, category='lo', description='YI SYLLABLE HUOP' },
	[0xA279] = { unicodeslot=0xA279, category='lo', description='YI SYLLABLE HOT' },
	[0xA27A] = { unicodeslot=0xA27A, category='lo', description='YI SYLLABLE HOX' },
	[0xA27B] = { unicodeslot=0xA27B, category='lo', description='YI SYLLABLE HO' },
	[0xA27C] = { unicodeslot=0xA27C, category='lo', description='YI SYLLABLE HOP' },
	[0xA27D] = { unicodeslot=0xA27D, category='lo', description='YI SYLLABLE HEX' },
	[0xA27E] = { unicodeslot=0xA27E, category='lo', description='YI SYLLABLE HE' },
	[0xA27F] = { unicodeslot=0xA27F, category='lo', description='YI SYLLABLE HEP' },
	[0xA280] = { unicodeslot=0xA280, category='lo', description='YI SYLLABLE WAT' },
	[0xA281] = { unicodeslot=0xA281, category='lo', description='YI SYLLABLE WAX' },
	[0xA282] = { unicodeslot=0xA282, category='lo', description='YI SYLLABLE WA' },
	[0xA283] = { unicodeslot=0xA283, category='lo', description='YI SYLLABLE WAP' },
	[0xA284] = { unicodeslot=0xA284, category='lo', description='YI SYLLABLE WUOX' },
	[0xA285] = { unicodeslot=0xA285, category='lo', description='YI SYLLABLE WUO' },
	[0xA286] = { unicodeslot=0xA286, category='lo', description='YI SYLLABLE WUOP' },
	[0xA287] = { unicodeslot=0xA287, category='lo', description='YI SYLLABLE WOX' },
	[0xA288] = { unicodeslot=0xA288, category='lo', description='YI SYLLABLE WO' },
	[0xA289] = { unicodeslot=0xA289, category='lo', description='YI SYLLABLE WOP' },
	[0xA28A] = { unicodeslot=0xA28A, category='lo', description='YI SYLLABLE WEX' },
	[0xA28B] = { unicodeslot=0xA28B, category='lo', description='YI SYLLABLE WE' },
	[0xA28C] = { unicodeslot=0xA28C, category='lo', description='YI SYLLABLE WEP' },
	[0xA28D] = { unicodeslot=0xA28D, category='lo', description='YI SYLLABLE ZIT' },
	[0xA28E] = { unicodeslot=0xA28E, category='lo', description='YI SYLLABLE ZIX' },
	[0xA28F] = { unicodeslot=0xA28F, category='lo', description='YI SYLLABLE ZI' },
	[0xA290] = { unicodeslot=0xA290, category='lo', description='YI SYLLABLE ZIP' },
	[0xA291] = { unicodeslot=0xA291, category='lo', description='YI SYLLABLE ZIEX' },
	[0xA292] = { unicodeslot=0xA292, category='lo', description='YI SYLLABLE ZIE' },
	[0xA293] = { unicodeslot=0xA293, category='lo', description='YI SYLLABLE ZIEP' },
	[0xA294] = { unicodeslot=0xA294, category='lo', description='YI SYLLABLE ZAT' },
	[0xA295] = { unicodeslot=0xA295, category='lo', description='YI SYLLABLE ZAX' },
	[0xA296] = { unicodeslot=0xA296, category='lo', description='YI SYLLABLE ZA' },
	[0xA297] = { unicodeslot=0xA297, category='lo', description='YI SYLLABLE ZAP' },
	[0xA298] = { unicodeslot=0xA298, category='lo', description='YI SYLLABLE ZUOX' },
	[0xA299] = { unicodeslot=0xA299, category='lo', description='YI SYLLABLE ZUO' },
	[0xA29A] = { unicodeslot=0xA29A, category='lo', description='YI SYLLABLE ZUOP' },
	[0xA29B] = { unicodeslot=0xA29B, category='lo', description='YI SYLLABLE ZOT' },
	[0xA29C] = { unicodeslot=0xA29C, category='lo', description='YI SYLLABLE ZOX' },
	[0xA29D] = { unicodeslot=0xA29D, category='lo', description='YI SYLLABLE ZO' },
	[0xA29E] = { unicodeslot=0xA29E, category='lo', description='YI SYLLABLE ZOP' },
	[0xA29F] = { unicodeslot=0xA29F, category='lo', description='YI SYLLABLE ZEX' },
	[0xA2A0] = { unicodeslot=0xA2A0, category='lo', description='YI SYLLABLE ZE' },
	[0xA2A1] = { unicodeslot=0xA2A1, category='lo', description='YI SYLLABLE ZEP' },
	[0xA2A2] = { unicodeslot=0xA2A2, category='lo', description='YI SYLLABLE ZUT' },
	[0xA2A3] = { unicodeslot=0xA2A3, category='lo', description='YI SYLLABLE ZUX' },
	[0xA2A4] = { unicodeslot=0xA2A4, category='lo', description='YI SYLLABLE ZU' },
	[0xA2A5] = { unicodeslot=0xA2A5, category='lo', description='YI SYLLABLE ZUP' },
	[0xA2A6] = { unicodeslot=0xA2A6, category='lo', description='YI SYLLABLE ZURX' },
	[0xA2A7] = { unicodeslot=0xA2A7, category='lo', description='YI SYLLABLE ZUR' },
	[0xA2A8] = { unicodeslot=0xA2A8, category='lo', description='YI SYLLABLE ZYT' },
	[0xA2A9] = { unicodeslot=0xA2A9, category='lo', description='YI SYLLABLE ZYX' },
	[0xA2AA] = { unicodeslot=0xA2AA, category='lo', description='YI SYLLABLE ZY' },
	[0xA2AB] = { unicodeslot=0xA2AB, category='lo', description='YI SYLLABLE ZYP' },
	[0xA2AC] = { unicodeslot=0xA2AC, category='lo', description='YI SYLLABLE ZYRX' },
	[0xA2AD] = { unicodeslot=0xA2AD, category='lo', description='YI SYLLABLE ZYR' },
	[0xA2AE] = { unicodeslot=0xA2AE, category='lo', description='YI SYLLABLE CIT' },
	[0xA2AF] = { unicodeslot=0xA2AF, category='lo', description='YI SYLLABLE CIX' },
	[0xA2B0] = { unicodeslot=0xA2B0, category='lo', description='YI SYLLABLE CI' },
	[0xA2B1] = { unicodeslot=0xA2B1, category='lo', description='YI SYLLABLE CIP' },
	[0xA2B2] = { unicodeslot=0xA2B2, category='lo', description='YI SYLLABLE CIET' },
	[0xA2B3] = { unicodeslot=0xA2B3, category='lo', description='YI SYLLABLE CIEX' },
	[0xA2B4] = { unicodeslot=0xA2B4, category='lo', description='YI SYLLABLE CIE' },
	[0xA2B5] = { unicodeslot=0xA2B5, category='lo', description='YI SYLLABLE CIEP' },
	[0xA2B6] = { unicodeslot=0xA2B6, category='lo', description='YI SYLLABLE CAT' },
	[0xA2B7] = { unicodeslot=0xA2B7, category='lo', description='YI SYLLABLE CAX' },
	[0xA2B8] = { unicodeslot=0xA2B8, category='lo', description='YI SYLLABLE CA' },
	[0xA2B9] = { unicodeslot=0xA2B9, category='lo', description='YI SYLLABLE CAP' },
	[0xA2BA] = { unicodeslot=0xA2BA, category='lo', description='YI SYLLABLE CUOX' },
	[0xA2BB] = { unicodeslot=0xA2BB, category='lo', description='YI SYLLABLE CUO' },
	[0xA2BC] = { unicodeslot=0xA2BC, category='lo', description='YI SYLLABLE CUOP' },
	[0xA2BD] = { unicodeslot=0xA2BD, category='lo', description='YI SYLLABLE COT' },
	[0xA2BE] = { unicodeslot=0xA2BE, category='lo', description='YI SYLLABLE COX' },
	[0xA2BF] = { unicodeslot=0xA2BF, category='lo', description='YI SYLLABLE CO' },
	[0xA2C0] = { unicodeslot=0xA2C0, category='lo', description='YI SYLLABLE COP' },
	[0xA2C1] = { unicodeslot=0xA2C1, category='lo', description='YI SYLLABLE CEX' },
	[0xA2C2] = { unicodeslot=0xA2C2, category='lo', description='YI SYLLABLE CE' },
	[0xA2C3] = { unicodeslot=0xA2C3, category='lo', description='YI SYLLABLE CEP' },
	[0xA2C4] = { unicodeslot=0xA2C4, category='lo', description='YI SYLLABLE CUT' },
	[0xA2C5] = { unicodeslot=0xA2C5, category='lo', description='YI SYLLABLE CUX' },
	[0xA2C6] = { unicodeslot=0xA2C6, category='lo', description='YI SYLLABLE CU' },
	[0xA2C7] = { unicodeslot=0xA2C7, category='lo', description='YI SYLLABLE CUP' },
	[0xA2C8] = { unicodeslot=0xA2C8, category='lo', description='YI SYLLABLE CURX' },
	[0xA2C9] = { unicodeslot=0xA2C9, category='lo', description='YI SYLLABLE CUR' },
	[0xA2CA] = { unicodeslot=0xA2CA, category='lo', description='YI SYLLABLE CYT' },
	[0xA2CB] = { unicodeslot=0xA2CB, category='lo', description='YI SYLLABLE CYX' },
	[0xA2CC] = { unicodeslot=0xA2CC, category='lo', description='YI SYLLABLE CY' },
	[0xA2CD] = { unicodeslot=0xA2CD, category='lo', description='YI SYLLABLE CYP' },
	[0xA2CE] = { unicodeslot=0xA2CE, category='lo', description='YI SYLLABLE CYRX' },
	[0xA2CF] = { unicodeslot=0xA2CF, category='lo', description='YI SYLLABLE CYR' },
	[0xA2D0] = { unicodeslot=0xA2D0, category='lo', description='YI SYLLABLE ZZIT' },
	[0xA2D1] = { unicodeslot=0xA2D1, category='lo', description='YI SYLLABLE ZZIX' },
	[0xA2D2] = { unicodeslot=0xA2D2, category='lo', description='YI SYLLABLE ZZI' },
	[0xA2D3] = { unicodeslot=0xA2D3, category='lo', description='YI SYLLABLE ZZIP' },
	[0xA2D4] = { unicodeslot=0xA2D4, category='lo', description='YI SYLLABLE ZZIET' },
	[0xA2D5] = { unicodeslot=0xA2D5, category='lo', description='YI SYLLABLE ZZIEX' },
	[0xA2D6] = { unicodeslot=0xA2D6, category='lo', description='YI SYLLABLE ZZIE' },
	[0xA2D7] = { unicodeslot=0xA2D7, category='lo', description='YI SYLLABLE ZZIEP' },
	[0xA2D8] = { unicodeslot=0xA2D8, category='lo', description='YI SYLLABLE ZZAT' },
	[0xA2D9] = { unicodeslot=0xA2D9, category='lo', description='YI SYLLABLE ZZAX' },
	[0xA2DA] = { unicodeslot=0xA2DA, category='lo', description='YI SYLLABLE ZZA' },
	[0xA2DB] = { unicodeslot=0xA2DB, category='lo', description='YI SYLLABLE ZZAP' },
	[0xA2DC] = { unicodeslot=0xA2DC, category='lo', description='YI SYLLABLE ZZOX' },
	[0xA2DD] = { unicodeslot=0xA2DD, category='lo', description='YI SYLLABLE ZZO' },
	[0xA2DE] = { unicodeslot=0xA2DE, category='lo', description='YI SYLLABLE ZZOP' },
	[0xA2DF] = { unicodeslot=0xA2DF, category='lo', description='YI SYLLABLE ZZEX' },
	[0xA2E0] = { unicodeslot=0xA2E0, category='lo', description='YI SYLLABLE ZZE' },
	[0xA2E1] = { unicodeslot=0xA2E1, category='lo', description='YI SYLLABLE ZZEP' },
	[0xA2E2] = { unicodeslot=0xA2E2, category='lo', description='YI SYLLABLE ZZUX' },
	[0xA2E3] = { unicodeslot=0xA2E3, category='lo', description='YI SYLLABLE ZZU' },
	[0xA2E4] = { unicodeslot=0xA2E4, category='lo', description='YI SYLLABLE ZZUP' },
	[0xA2E5] = { unicodeslot=0xA2E5, category='lo', description='YI SYLLABLE ZZURX' },
	[0xA2E6] = { unicodeslot=0xA2E6, category='lo', description='YI SYLLABLE ZZUR' },
	[0xA2E7] = { unicodeslot=0xA2E7, category='lo', description='YI SYLLABLE ZZYT' },
	[0xA2E8] = { unicodeslot=0xA2E8, category='lo', description='YI SYLLABLE ZZYX' },
	[0xA2E9] = { unicodeslot=0xA2E9, category='lo', description='YI SYLLABLE ZZY' },
	[0xA2EA] = { unicodeslot=0xA2EA, category='lo', description='YI SYLLABLE ZZYP' },
	[0xA2EB] = { unicodeslot=0xA2EB, category='lo', description='YI SYLLABLE ZZYRX' },
	[0xA2EC] = { unicodeslot=0xA2EC, category='lo', description='YI SYLLABLE ZZYR' },
	[0xA2ED] = { unicodeslot=0xA2ED, category='lo', description='YI SYLLABLE NZIT' },
	[0xA2EE] = { unicodeslot=0xA2EE, category='lo', description='YI SYLLABLE NZIX' },
	[0xA2EF] = { unicodeslot=0xA2EF, category='lo', description='YI SYLLABLE NZI' },
	[0xA2F0] = { unicodeslot=0xA2F0, category='lo', description='YI SYLLABLE NZIP' },
	[0xA2F1] = { unicodeslot=0xA2F1, category='lo', description='YI SYLLABLE NZIEX' },
	[0xA2F2] = { unicodeslot=0xA2F2, category='lo', description='YI SYLLABLE NZIE' },
	[0xA2F3] = { unicodeslot=0xA2F3, category='lo', description='YI SYLLABLE NZIEP' },
	[0xA2F4] = { unicodeslot=0xA2F4, category='lo', description='YI SYLLABLE NZAT' },
	[0xA2F5] = { unicodeslot=0xA2F5, category='lo', description='YI SYLLABLE NZAX' },
	[0xA2F6] = { unicodeslot=0xA2F6, category='lo', description='YI SYLLABLE NZA' },
	[0xA2F7] = { unicodeslot=0xA2F7, category='lo', description='YI SYLLABLE NZAP' },
	[0xA2F8] = { unicodeslot=0xA2F8, category='lo', description='YI SYLLABLE NZUOX' },
	[0xA2F9] = { unicodeslot=0xA2F9, category='lo', description='YI SYLLABLE NZUO' },
	[0xA2FA] = { unicodeslot=0xA2FA, category='lo', description='YI SYLLABLE NZOX' },
	[0xA2FB] = { unicodeslot=0xA2FB, category='lo', description='YI SYLLABLE NZOP' },
	[0xA2FC] = { unicodeslot=0xA2FC, category='lo', description='YI SYLLABLE NZEX' },
	[0xA2FD] = { unicodeslot=0xA2FD, category='lo', description='YI SYLLABLE NZE' },
	[0xA2FE] = { unicodeslot=0xA2FE, category='lo', description='YI SYLLABLE NZUX' },
	[0xA2FF] = { unicodeslot=0xA2FF, category='lo', description='YI SYLLABLE NZU' },
	[0xA300] = { unicodeslot=0xA300, category='lo', description='YI SYLLABLE NZUP' },
	[0xA301] = { unicodeslot=0xA301, category='lo', description='YI SYLLABLE NZURX' },
	[0xA302] = { unicodeslot=0xA302, category='lo', description='YI SYLLABLE NZUR' },
	[0xA303] = { unicodeslot=0xA303, category='lo', description='YI SYLLABLE NZYT' },
	[0xA304] = { unicodeslot=0xA304, category='lo', description='YI SYLLABLE NZYX' },
	[0xA305] = { unicodeslot=0xA305, category='lo', description='YI SYLLABLE NZY' },
	[0xA306] = { unicodeslot=0xA306, category='lo', description='YI SYLLABLE NZYP' },
	[0xA307] = { unicodeslot=0xA307, category='lo', description='YI SYLLABLE NZYRX' },
	[0xA308] = { unicodeslot=0xA308, category='lo', description='YI SYLLABLE NZYR' },
	[0xA309] = { unicodeslot=0xA309, category='lo', description='YI SYLLABLE SIT' },
	[0xA30A] = { unicodeslot=0xA30A, category='lo', description='YI SYLLABLE SIX' },
	[0xA30B] = { unicodeslot=0xA30B, category='lo', description='YI SYLLABLE SI' },
	[0xA30C] = { unicodeslot=0xA30C, category='lo', description='YI SYLLABLE SIP' },
	[0xA30D] = { unicodeslot=0xA30D, category='lo', description='YI SYLLABLE SIEX' },
	[0xA30E] = { unicodeslot=0xA30E, category='lo', description='YI SYLLABLE SIE' },
	[0xA30F] = { unicodeslot=0xA30F, category='lo', description='YI SYLLABLE SIEP' },
	[0xA310] = { unicodeslot=0xA310, category='lo', description='YI SYLLABLE SAT' },
	[0xA311] = { unicodeslot=0xA311, category='lo', description='YI SYLLABLE SAX' },
	[0xA312] = { unicodeslot=0xA312, category='lo', description='YI SYLLABLE SA' },
	[0xA313] = { unicodeslot=0xA313, category='lo', description='YI SYLLABLE SAP' },
	[0xA314] = { unicodeslot=0xA314, category='lo', description='YI SYLLABLE SUOX' },
	[0xA315] = { unicodeslot=0xA315, category='lo', description='YI SYLLABLE SUO' },
	[0xA316] = { unicodeslot=0xA316, category='lo', description='YI SYLLABLE SUOP' },
	[0xA317] = { unicodeslot=0xA317, category='lo', description='YI SYLLABLE SOT' },
	[0xA318] = { unicodeslot=0xA318, category='lo', description='YI SYLLABLE SOX' },
	[0xA319] = { unicodeslot=0xA319, category='lo', description='YI SYLLABLE SO' },
	[0xA31A] = { unicodeslot=0xA31A, category='lo', description='YI SYLLABLE SOP' },
	[0xA31B] = { unicodeslot=0xA31B, category='lo', description='YI SYLLABLE SEX' },
	[0xA31C] = { unicodeslot=0xA31C, category='lo', description='YI SYLLABLE SE' },
	[0xA31D] = { unicodeslot=0xA31D, category='lo', description='YI SYLLABLE SEP' },
	[0xA31E] = { unicodeslot=0xA31E, category='lo', description='YI SYLLABLE SUT' },
	[0xA31F] = { unicodeslot=0xA31F, category='lo', description='YI SYLLABLE SUX' },
	[0xA320] = { unicodeslot=0xA320, category='lo', description='YI SYLLABLE SU' },
	[0xA321] = { unicodeslot=0xA321, category='lo', description='YI SYLLABLE SUP' },
	[0xA322] = { unicodeslot=0xA322, category='lo', description='YI SYLLABLE SURX' },
	[0xA323] = { unicodeslot=0xA323, category='lo', description='YI SYLLABLE SUR' },
	[0xA324] = { unicodeslot=0xA324, category='lo', description='YI SYLLABLE SYT' },
	[0xA325] = { unicodeslot=0xA325, category='lo', description='YI SYLLABLE SYX' },
	[0xA326] = { unicodeslot=0xA326, category='lo', description='YI SYLLABLE SY' },
	[0xA327] = { unicodeslot=0xA327, category='lo', description='YI SYLLABLE SYP' },
	[0xA328] = { unicodeslot=0xA328, category='lo', description='YI SYLLABLE SYRX' },
	[0xA329] = { unicodeslot=0xA329, category='lo', description='YI SYLLABLE SYR' },
	[0xA32A] = { unicodeslot=0xA32A, category='lo', description='YI SYLLABLE SSIT' },
	[0xA32B] = { unicodeslot=0xA32B, category='lo', description='YI SYLLABLE SSIX' },
	[0xA32C] = { unicodeslot=0xA32C, category='lo', description='YI SYLLABLE SSI' },
	[0xA32D] = { unicodeslot=0xA32D, category='lo', description='YI SYLLABLE SSIP' },
	[0xA32E] = { unicodeslot=0xA32E, category='lo', description='YI SYLLABLE SSIEX' },
	[0xA32F] = { unicodeslot=0xA32F, category='lo', description='YI SYLLABLE SSIE' },
	[0xA330] = { unicodeslot=0xA330, category='lo', description='YI SYLLABLE SSIEP' },
	[0xA331] = { unicodeslot=0xA331, category='lo', description='YI SYLLABLE SSAT' },
	[0xA332] = { unicodeslot=0xA332, category='lo', description='YI SYLLABLE SSAX' },
	[0xA333] = { unicodeslot=0xA333, category='lo', description='YI SYLLABLE SSA' },
	[0xA334] = { unicodeslot=0xA334, category='lo', description='YI SYLLABLE SSAP' },
	[0xA335] = { unicodeslot=0xA335, category='lo', description='YI SYLLABLE SSOT' },
	[0xA336] = { unicodeslot=0xA336, category='lo', description='YI SYLLABLE SSOX' },
	[0xA337] = { unicodeslot=0xA337, category='lo', description='YI SYLLABLE SSO' },
	[0xA338] = { unicodeslot=0xA338, category='lo', description='YI SYLLABLE SSOP' },
	[0xA339] = { unicodeslot=0xA339, category='lo', description='YI SYLLABLE SSEX' },
	[0xA33A] = { unicodeslot=0xA33A, category='lo', description='YI SYLLABLE SSE' },
	[0xA33B] = { unicodeslot=0xA33B, category='lo', description='YI SYLLABLE SSEP' },
	[0xA33C] = { unicodeslot=0xA33C, category='lo', description='YI SYLLABLE SSUT' },
	[0xA33D] = { unicodeslot=0xA33D, category='lo', description='YI SYLLABLE SSUX' },
	[0xA33E] = { unicodeslot=0xA33E, category='lo', description='YI SYLLABLE SSU' },
	[0xA33F] = { unicodeslot=0xA33F, category='lo', description='YI SYLLABLE SSUP' },
	[0xA340] = { unicodeslot=0xA340, category='lo', description='YI SYLLABLE SSYT' },
	[0xA341] = { unicodeslot=0xA341, category='lo', description='YI SYLLABLE SSYX' },
	[0xA342] = { unicodeslot=0xA342, category='lo', description='YI SYLLABLE SSY' },
	[0xA343] = { unicodeslot=0xA343, category='lo', description='YI SYLLABLE SSYP' },
	[0xA344] = { unicodeslot=0xA344, category='lo', description='YI SYLLABLE SSYRX' },
	[0xA345] = { unicodeslot=0xA345, category='lo', description='YI SYLLABLE SSYR' },
	[0xA346] = { unicodeslot=0xA346, category='lo', description='YI SYLLABLE ZHAT' },
	[0xA347] = { unicodeslot=0xA347, category='lo', description='YI SYLLABLE ZHAX' },
	[0xA348] = { unicodeslot=0xA348, category='lo', description='YI SYLLABLE ZHA' },
	[0xA349] = { unicodeslot=0xA349, category='lo', description='YI SYLLABLE ZHAP' },
	[0xA34A] = { unicodeslot=0xA34A, category='lo', description='YI SYLLABLE ZHUOX' },
	[0xA34B] = { unicodeslot=0xA34B, category='lo', description='YI SYLLABLE ZHUO' },
	[0xA34C] = { unicodeslot=0xA34C, category='lo', description='YI SYLLABLE ZHUOP' },
	[0xA34D] = { unicodeslot=0xA34D, category='lo', description='YI SYLLABLE ZHOT' },
	[0xA34E] = { unicodeslot=0xA34E, category='lo', description='YI SYLLABLE ZHOX' },
	[0xA34F] = { unicodeslot=0xA34F, category='lo', description='YI SYLLABLE ZHO' },
	[0xA350] = { unicodeslot=0xA350, category='lo', description='YI SYLLABLE ZHOP' },
	[0xA351] = { unicodeslot=0xA351, category='lo', description='YI SYLLABLE ZHET' },
	[0xA352] = { unicodeslot=0xA352, category='lo', description='YI SYLLABLE ZHEX' },
	[0xA353] = { unicodeslot=0xA353, category='lo', description='YI SYLLABLE ZHE' },
	[0xA354] = { unicodeslot=0xA354, category='lo', description='YI SYLLABLE ZHEP' },
	[0xA355] = { unicodeslot=0xA355, category='lo', description='YI SYLLABLE ZHUT' },
	[0xA356] = { unicodeslot=0xA356, category='lo', description='YI SYLLABLE ZHUX' },
	[0xA357] = { unicodeslot=0xA357, category='lo', description='YI SYLLABLE ZHU' },
	[0xA358] = { unicodeslot=0xA358, category='lo', description='YI SYLLABLE ZHUP' },
	[0xA359] = { unicodeslot=0xA359, category='lo', description='YI SYLLABLE ZHURX' },
	[0xA35A] = { unicodeslot=0xA35A, category='lo', description='YI SYLLABLE ZHUR' },
	[0xA35B] = { unicodeslot=0xA35B, category='lo', description='YI SYLLABLE ZHYT' },
	[0xA35C] = { unicodeslot=0xA35C, category='lo', description='YI SYLLABLE ZHYX' },
	[0xA35D] = { unicodeslot=0xA35D, category='lo', description='YI SYLLABLE ZHY' },
	[0xA35E] = { unicodeslot=0xA35E, category='lo', description='YI SYLLABLE ZHYP' },
	[0xA35F] = { unicodeslot=0xA35F, category='lo', description='YI SYLLABLE ZHYRX' },
	[0xA360] = { unicodeslot=0xA360, category='lo', description='YI SYLLABLE ZHYR' },
	[0xA361] = { unicodeslot=0xA361, category='lo', description='YI SYLLABLE CHAT' },
	[0xA362] = { unicodeslot=0xA362, category='lo', description='YI SYLLABLE CHAX' },
	[0xA363] = { unicodeslot=0xA363, category='lo', description='YI SYLLABLE CHA' },
	[0xA364] = { unicodeslot=0xA364, category='lo', description='YI SYLLABLE CHAP' },
	[0xA365] = { unicodeslot=0xA365, category='lo', description='YI SYLLABLE CHUOT' },
	[0xA366] = { unicodeslot=0xA366, category='lo', description='YI SYLLABLE CHUOX' },
	[0xA367] = { unicodeslot=0xA367, category='lo', description='YI SYLLABLE CHUO' },
	[0xA368] = { unicodeslot=0xA368, category='lo', description='YI SYLLABLE CHUOP' },
	[0xA369] = { unicodeslot=0xA369, category='lo', description='YI SYLLABLE CHOT' },
	[0xA36A] = { unicodeslot=0xA36A, category='lo', description='YI SYLLABLE CHOX' },
	[0xA36B] = { unicodeslot=0xA36B, category='lo', description='YI SYLLABLE CHO' },
	[0xA36C] = { unicodeslot=0xA36C, category='lo', description='YI SYLLABLE CHOP' },
	[0xA36D] = { unicodeslot=0xA36D, category='lo', description='YI SYLLABLE CHET' },
	[0xA36E] = { unicodeslot=0xA36E, category='lo', description='YI SYLLABLE CHEX' },
	[0xA36F] = { unicodeslot=0xA36F, category='lo', description='YI SYLLABLE CHE' },
	[0xA370] = { unicodeslot=0xA370, category='lo', description='YI SYLLABLE CHEP' },
	[0xA371] = { unicodeslot=0xA371, category='lo', description='YI SYLLABLE CHUX' },
	[0xA372] = { unicodeslot=0xA372, category='lo', description='YI SYLLABLE CHU' },
	[0xA373] = { unicodeslot=0xA373, category='lo', description='YI SYLLABLE CHUP' },
	[0xA374] = { unicodeslot=0xA374, category='lo', description='YI SYLLABLE CHURX' },
	[0xA375] = { unicodeslot=0xA375, category='lo', description='YI SYLLABLE CHUR' },
	[0xA376] = { unicodeslot=0xA376, category='lo', description='YI SYLLABLE CHYT' },
	[0xA377] = { unicodeslot=0xA377, category='lo', description='YI SYLLABLE CHYX' },
	[0xA378] = { unicodeslot=0xA378, category='lo', description='YI SYLLABLE CHY' },
	[0xA379] = { unicodeslot=0xA379, category='lo', description='YI SYLLABLE CHYP' },
	[0xA37A] = { unicodeslot=0xA37A, category='lo', description='YI SYLLABLE CHYRX' },
	[0xA37B] = { unicodeslot=0xA37B, category='lo', description='YI SYLLABLE CHYR' },
	[0xA37C] = { unicodeslot=0xA37C, category='lo', description='YI SYLLABLE RRAX' },
	[0xA37D] = { unicodeslot=0xA37D, category='lo', description='YI SYLLABLE RRA' },
	[0xA37E] = { unicodeslot=0xA37E, category='lo', description='YI SYLLABLE RRUOX' },
	[0xA37F] = { unicodeslot=0xA37F, category='lo', description='YI SYLLABLE RRUO' },
	[0xA380] = { unicodeslot=0xA380, category='lo', description='YI SYLLABLE RROT' },
	[0xA381] = { unicodeslot=0xA381, category='lo', description='YI SYLLABLE RROX' },
	[0xA382] = { unicodeslot=0xA382, category='lo', description='YI SYLLABLE RRO' },
	[0xA383] = { unicodeslot=0xA383, category='lo', description='YI SYLLABLE RROP' },
	[0xA384] = { unicodeslot=0xA384, category='lo', description='YI SYLLABLE RRET' },
	[0xA385] = { unicodeslot=0xA385, category='lo', description='YI SYLLABLE RREX' },
	[0xA386] = { unicodeslot=0xA386, category='lo', description='YI SYLLABLE RRE' },
	[0xA387] = { unicodeslot=0xA387, category='lo', description='YI SYLLABLE RREP' },
	[0xA388] = { unicodeslot=0xA388, category='lo', description='YI SYLLABLE RRUT' },
	[0xA389] = { unicodeslot=0xA389, category='lo', description='YI SYLLABLE RRUX' },
	[0xA38A] = { unicodeslot=0xA38A, category='lo', description='YI SYLLABLE RRU' },
	[0xA38B] = { unicodeslot=0xA38B, category='lo', description='YI SYLLABLE RRUP' },
	[0xA38C] = { unicodeslot=0xA38C, category='lo', description='YI SYLLABLE RRURX' },
	[0xA38D] = { unicodeslot=0xA38D, category='lo', description='YI SYLLABLE RRUR' },
	[0xA38E] = { unicodeslot=0xA38E, category='lo', description='YI SYLLABLE RRYT' },
	[0xA38F] = { unicodeslot=0xA38F, category='lo', description='YI SYLLABLE RRYX' },
	[0xA390] = { unicodeslot=0xA390, category='lo', description='YI SYLLABLE RRY' },
	[0xA391] = { unicodeslot=0xA391, category='lo', description='YI SYLLABLE RRYP' },
	[0xA392] = { unicodeslot=0xA392, category='lo', description='YI SYLLABLE RRYRX' },
	[0xA393] = { unicodeslot=0xA393, category='lo', description='YI SYLLABLE RRYR' },
	[0xA394] = { unicodeslot=0xA394, category='lo', description='YI SYLLABLE NRAT' },
	[0xA395] = { unicodeslot=0xA395, category='lo', description='YI SYLLABLE NRAX' },
	[0xA396] = { unicodeslot=0xA396, category='lo', description='YI SYLLABLE NRA' },
	[0xA397] = { unicodeslot=0xA397, category='lo', description='YI SYLLABLE NRAP' },
	[0xA398] = { unicodeslot=0xA398, category='lo', description='YI SYLLABLE NROX' },
	[0xA399] = { unicodeslot=0xA399, category='lo', description='YI SYLLABLE NRO' },
	[0xA39A] = { unicodeslot=0xA39A, category='lo', description='YI SYLLABLE NROP' },
	[0xA39B] = { unicodeslot=0xA39B, category='lo', description='YI SYLLABLE NRET' },
	[0xA39C] = { unicodeslot=0xA39C, category='lo', description='YI SYLLABLE NREX' },
	[0xA39D] = { unicodeslot=0xA39D, category='lo', description='YI SYLLABLE NRE' },
	[0xA39E] = { unicodeslot=0xA39E, category='lo', description='YI SYLLABLE NREP' },
	[0xA39F] = { unicodeslot=0xA39F, category='lo', description='YI SYLLABLE NRUT' },
	[0xA3A0] = { unicodeslot=0xA3A0, category='lo', description='YI SYLLABLE NRUX' },
	[0xA3A1] = { unicodeslot=0xA3A1, category='lo', description='YI SYLLABLE NRU' },
	[0xA3A2] = { unicodeslot=0xA3A2, category='lo', description='YI SYLLABLE NRUP' },
	[0xA3A3] = { unicodeslot=0xA3A3, category='lo', description='YI SYLLABLE NRURX' },
	[0xA3A4] = { unicodeslot=0xA3A4, category='lo', description='YI SYLLABLE NRUR' },
	[0xA3A5] = { unicodeslot=0xA3A5, category='lo', description='YI SYLLABLE NRYT' },
	[0xA3A6] = { unicodeslot=0xA3A6, category='lo', description='YI SYLLABLE NRYX' },
	[0xA3A7] = { unicodeslot=0xA3A7, category='lo', description='YI SYLLABLE NRY' },
	[0xA3A8] = { unicodeslot=0xA3A8, category='lo', description='YI SYLLABLE NRYP' },
	[0xA3A9] = { unicodeslot=0xA3A9, category='lo', description='YI SYLLABLE NRYRX' },
	[0xA3AA] = { unicodeslot=0xA3AA, category='lo', description='YI SYLLABLE NRYR' },
	[0xA3AB] = { unicodeslot=0xA3AB, category='lo', description='YI SYLLABLE SHAT' },
	[0xA3AC] = { unicodeslot=0xA3AC, category='lo', description='YI SYLLABLE SHAX' },
	[0xA3AD] = { unicodeslot=0xA3AD, category='lo', description='YI SYLLABLE SHA' },
	[0xA3AE] = { unicodeslot=0xA3AE, category='lo', description='YI SYLLABLE SHAP' },
	[0xA3AF] = { unicodeslot=0xA3AF, category='lo', description='YI SYLLABLE SHUOX' },
	[0xA3B0] = { unicodeslot=0xA3B0, category='lo', description='YI SYLLABLE SHUO' },
	[0xA3B1] = { unicodeslot=0xA3B1, category='lo', description='YI SYLLABLE SHUOP' },
	[0xA3B2] = { unicodeslot=0xA3B2, category='lo', description='YI SYLLABLE SHOT' },
	[0xA3B3] = { unicodeslot=0xA3B3, category='lo', description='YI SYLLABLE SHOX' },
	[0xA3B4] = { unicodeslot=0xA3B4, category='lo', description='YI SYLLABLE SHO' },
	[0xA3B5] = { unicodeslot=0xA3B5, category='lo', description='YI SYLLABLE SHOP' },
	[0xA3B6] = { unicodeslot=0xA3B6, category='lo', description='YI SYLLABLE SHET' },
	[0xA3B7] = { unicodeslot=0xA3B7, category='lo', description='YI SYLLABLE SHEX' },
	[0xA3B8] = { unicodeslot=0xA3B8, category='lo', description='YI SYLLABLE SHE' },
	[0xA3B9] = { unicodeslot=0xA3B9, category='lo', description='YI SYLLABLE SHEP' },
	[0xA3BA] = { unicodeslot=0xA3BA, category='lo', description='YI SYLLABLE SHUT' },
	[0xA3BB] = { unicodeslot=0xA3BB, category='lo', description='YI SYLLABLE SHUX' },
	[0xA3BC] = { unicodeslot=0xA3BC, category='lo', description='YI SYLLABLE SHU' },
	[0xA3BD] = { unicodeslot=0xA3BD, category='lo', description='YI SYLLABLE SHUP' },
	[0xA3BE] = { unicodeslot=0xA3BE, category='lo', description='YI SYLLABLE SHURX' },
	[0xA3BF] = { unicodeslot=0xA3BF, category='lo', description='YI SYLLABLE SHUR' },
	[0xA3C0] = { unicodeslot=0xA3C0, category='lo', description='YI SYLLABLE SHYT' },
	[0xA3C1] = { unicodeslot=0xA3C1, category='lo', description='YI SYLLABLE SHYX' },
	[0xA3C2] = { unicodeslot=0xA3C2, category='lo', description='YI SYLLABLE SHY' },
	[0xA3C3] = { unicodeslot=0xA3C3, category='lo', description='YI SYLLABLE SHYP' },
	[0xA3C4] = { unicodeslot=0xA3C4, category='lo', description='YI SYLLABLE SHYRX' },
	[0xA3C5] = { unicodeslot=0xA3C5, category='lo', description='YI SYLLABLE SHYR' },
	[0xA3C6] = { unicodeslot=0xA3C6, category='lo', description='YI SYLLABLE RAT' },
	[0xA3C7] = { unicodeslot=0xA3C7, category='lo', description='YI SYLLABLE RAX' },
	[0xA3C8] = { unicodeslot=0xA3C8, category='lo', description='YI SYLLABLE RA' },
	[0xA3C9] = { unicodeslot=0xA3C9, category='lo', description='YI SYLLABLE RAP' },
	[0xA3CA] = { unicodeslot=0xA3CA, category='lo', description='YI SYLLABLE RUOX' },
	[0xA3CB] = { unicodeslot=0xA3CB, category='lo', description='YI SYLLABLE RUO' },
	[0xA3CC] = { unicodeslot=0xA3CC, category='lo', description='YI SYLLABLE RUOP' },
	[0xA3CD] = { unicodeslot=0xA3CD, category='lo', description='YI SYLLABLE ROT' },
	[0xA3CE] = { unicodeslot=0xA3CE, category='lo', description='YI SYLLABLE ROX' },
	[0xA3CF] = { unicodeslot=0xA3CF, category='lo', description='YI SYLLABLE RO' },
	[0xA3D0] = { unicodeslot=0xA3D0, category='lo', description='YI SYLLABLE ROP' },
	[0xA3D1] = { unicodeslot=0xA3D1, category='lo', description='YI SYLLABLE REX' },
	[0xA3D2] = { unicodeslot=0xA3D2, category='lo', description='YI SYLLABLE RE' },
	[0xA3D3] = { unicodeslot=0xA3D3, category='lo', description='YI SYLLABLE REP' },
	[0xA3D4] = { unicodeslot=0xA3D4, category='lo', description='YI SYLLABLE RUT' },
	[0xA3D5] = { unicodeslot=0xA3D5, category='lo', description='YI SYLLABLE RUX' },
	[0xA3D6] = { unicodeslot=0xA3D6, category='lo', description='YI SYLLABLE RU' },
	[0xA3D7] = { unicodeslot=0xA3D7, category='lo', description='YI SYLLABLE RUP' },
	[0xA3D8] = { unicodeslot=0xA3D8, category='lo', description='YI SYLLABLE RURX' },
	[0xA3D9] = { unicodeslot=0xA3D9, category='lo', description='YI SYLLABLE RUR' },
	[0xA3DA] = { unicodeslot=0xA3DA, category='lo', description='YI SYLLABLE RYT' },
	[0xA3DB] = { unicodeslot=0xA3DB, category='lo', description='YI SYLLABLE RYX' },
	[0xA3DC] = { unicodeslot=0xA3DC, category='lo', description='YI SYLLABLE RY' },
	[0xA3DD] = { unicodeslot=0xA3DD, category='lo', description='YI SYLLABLE RYP' },
	[0xA3DE] = { unicodeslot=0xA3DE, category='lo', description='YI SYLLABLE RYRX' },
	[0xA3DF] = { unicodeslot=0xA3DF, category='lo', description='YI SYLLABLE RYR' },
	[0xA3E0] = { unicodeslot=0xA3E0, category='lo', description='YI SYLLABLE JIT' },
	[0xA3E1] = { unicodeslot=0xA3E1, category='lo', description='YI SYLLABLE JIX' },
	[0xA3E2] = { unicodeslot=0xA3E2, category='lo', description='YI SYLLABLE JI' },
	[0xA3E3] = { unicodeslot=0xA3E3, category='lo', description='YI SYLLABLE JIP' },
	[0xA3E4] = { unicodeslot=0xA3E4, category='lo', description='YI SYLLABLE JIET' },
	[0xA3E5] = { unicodeslot=0xA3E5, category='lo', description='YI SYLLABLE JIEX' },
	[0xA3E6] = { unicodeslot=0xA3E6, category='lo', description='YI SYLLABLE JIE' },
	[0xA3E7] = { unicodeslot=0xA3E7, category='lo', description='YI SYLLABLE JIEP' },
	[0xA3E8] = { unicodeslot=0xA3E8, category='lo', description='YI SYLLABLE JUOT' },
	[0xA3E9] = { unicodeslot=0xA3E9, category='lo', description='YI SYLLABLE JUOX' },
	[0xA3EA] = { unicodeslot=0xA3EA, category='lo', description='YI SYLLABLE JUO' },
	[0xA3EB] = { unicodeslot=0xA3EB, category='lo', description='YI SYLLABLE JUOP' },
	[0xA3EC] = { unicodeslot=0xA3EC, category='lo', description='YI SYLLABLE JOT' },
	[0xA3ED] = { unicodeslot=0xA3ED, category='lo', description='YI SYLLABLE JOX' },
	[0xA3EE] = { unicodeslot=0xA3EE, category='lo', description='YI SYLLABLE JO' },
	[0xA3EF] = { unicodeslot=0xA3EF, category='lo', description='YI SYLLABLE JOP' },
	[0xA3F0] = { unicodeslot=0xA3F0, category='lo', description='YI SYLLABLE JUT' },
	[0xA3F1] = { unicodeslot=0xA3F1, category='lo', description='YI SYLLABLE JUX' },
	[0xA3F2] = { unicodeslot=0xA3F2, category='lo', description='YI SYLLABLE JU' },
	[0xA3F3] = { unicodeslot=0xA3F3, category='lo', description='YI SYLLABLE JUP' },
	[0xA3F4] = { unicodeslot=0xA3F4, category='lo', description='YI SYLLABLE JURX' },
	[0xA3F5] = { unicodeslot=0xA3F5, category='lo', description='YI SYLLABLE JUR' },
	[0xA3F6] = { unicodeslot=0xA3F6, category='lo', description='YI SYLLABLE JYT' },
	[0xA3F7] = { unicodeslot=0xA3F7, category='lo', description='YI SYLLABLE JYX' },
	[0xA3F8] = { unicodeslot=0xA3F8, category='lo', description='YI SYLLABLE JY' },
	[0xA3F9] = { unicodeslot=0xA3F9, category='lo', description='YI SYLLABLE JYP' },
	[0xA3FA] = { unicodeslot=0xA3FA, category='lo', description='YI SYLLABLE JYRX' },
	[0xA3FB] = { unicodeslot=0xA3FB, category='lo', description='YI SYLLABLE JYR' },
	[0xA3FC] = { unicodeslot=0xA3FC, category='lo', description='YI SYLLABLE QIT' },
	[0xA3FD] = { unicodeslot=0xA3FD, category='lo', description='YI SYLLABLE QIX' },
	[0xA3FE] = { unicodeslot=0xA3FE, category='lo', description='YI SYLLABLE QI' },
	[0xA3FF] = { unicodeslot=0xA3FF, category='lo', description='YI SYLLABLE QIP' },
	[0xA400] = { unicodeslot=0xA400, category='lo', description='YI SYLLABLE QIET' },
	[0xA401] = { unicodeslot=0xA401, category='lo', description='YI SYLLABLE QIEX' },
	[0xA402] = { unicodeslot=0xA402, category='lo', description='YI SYLLABLE QIE' },
	[0xA403] = { unicodeslot=0xA403, category='lo', description='YI SYLLABLE QIEP' },
	[0xA404] = { unicodeslot=0xA404, category='lo', description='YI SYLLABLE QUOT' },
	[0xA405] = { unicodeslot=0xA405, category='lo', description='YI SYLLABLE QUOX' },
	[0xA406] = { unicodeslot=0xA406, category='lo', description='YI SYLLABLE QUO' },
	[0xA407] = { unicodeslot=0xA407, category='lo', description='YI SYLLABLE QUOP' },
	[0xA408] = { unicodeslot=0xA408, category='lo', description='YI SYLLABLE QOT' },
	[0xA409] = { unicodeslot=0xA409, category='lo', description='YI SYLLABLE QOX' },
	[0xA40A] = { unicodeslot=0xA40A, category='lo', description='YI SYLLABLE QO' },
	[0xA40B] = { unicodeslot=0xA40B, category='lo', description='YI SYLLABLE QOP' },
	[0xA40C] = { unicodeslot=0xA40C, category='lo', description='YI SYLLABLE QUT' },
	[0xA40D] = { unicodeslot=0xA40D, category='lo', description='YI SYLLABLE QUX' },
	[0xA40E] = { unicodeslot=0xA40E, category='lo', description='YI SYLLABLE QU' },
	[0xA40F] = { unicodeslot=0xA40F, category='lo', description='YI SYLLABLE QUP' },
	[0xA410] = { unicodeslot=0xA410, category='lo', description='YI SYLLABLE QURX' },
	[0xA411] = { unicodeslot=0xA411, category='lo', description='YI SYLLABLE QUR' },
	[0xA412] = { unicodeslot=0xA412, category='lo', description='YI SYLLABLE QYT' },
	[0xA413] = { unicodeslot=0xA413, category='lo', description='YI SYLLABLE QYX' },
	[0xA414] = { unicodeslot=0xA414, category='lo', description='YI SYLLABLE QY' },
	[0xA415] = { unicodeslot=0xA415, category='lo', description='YI SYLLABLE QYP' },
	[0xA416] = { unicodeslot=0xA416, category='lo', description='YI SYLLABLE QYRX' },
	[0xA417] = { unicodeslot=0xA417, category='lo', description='YI SYLLABLE QYR' },
	[0xA418] = { unicodeslot=0xA418, category='lo', description='YI SYLLABLE JJIT' },
	[0xA419] = { unicodeslot=0xA419, category='lo', description='YI SYLLABLE JJIX' },
	[0xA41A] = { unicodeslot=0xA41A, category='lo', description='YI SYLLABLE JJI' },
	[0xA41B] = { unicodeslot=0xA41B, category='lo', description='YI SYLLABLE JJIP' },
	[0xA41C] = { unicodeslot=0xA41C, category='lo', description='YI SYLLABLE JJIET' },
	[0xA41D] = { unicodeslot=0xA41D, category='lo', description='YI SYLLABLE JJIEX' },
	[0xA41E] = { unicodeslot=0xA41E, category='lo', description='YI SYLLABLE JJIE' },
	[0xA41F] = { unicodeslot=0xA41F, category='lo', description='YI SYLLABLE JJIEP' },
	[0xA420] = { unicodeslot=0xA420, category='lo', description='YI SYLLABLE JJUOX' },
	[0xA421] = { unicodeslot=0xA421, category='lo', description='YI SYLLABLE JJUO' },
	[0xA422] = { unicodeslot=0xA422, category='lo', description='YI SYLLABLE JJUOP' },
	[0xA423] = { unicodeslot=0xA423, category='lo', description='YI SYLLABLE JJOT' },
	[0xA424] = { unicodeslot=0xA424, category='lo', description='YI SYLLABLE JJOX' },
	[0xA425] = { unicodeslot=0xA425, category='lo', description='YI SYLLABLE JJO' },
	[0xA426] = { unicodeslot=0xA426, category='lo', description='YI SYLLABLE JJOP' },
	[0xA427] = { unicodeslot=0xA427, category='lo', description='YI SYLLABLE JJUT' },
	[0xA428] = { unicodeslot=0xA428, category='lo', description='YI SYLLABLE JJUX' },
	[0xA429] = { unicodeslot=0xA429, category='lo', description='YI SYLLABLE JJU' },
	[0xA42A] = { unicodeslot=0xA42A, category='lo', description='YI SYLLABLE JJUP' },
	[0xA42B] = { unicodeslot=0xA42B, category='lo', description='YI SYLLABLE JJURX' },
	[0xA42C] = { unicodeslot=0xA42C, category='lo', description='YI SYLLABLE JJUR' },
	[0xA42D] = { unicodeslot=0xA42D, category='lo', description='YI SYLLABLE JJYT' },
	[0xA42E] = { unicodeslot=0xA42E, category='lo', description='YI SYLLABLE JJYX' },
	[0xA42F] = { unicodeslot=0xA42F, category='lo', description='YI SYLLABLE JJY' },
	[0xA430] = { unicodeslot=0xA430, category='lo', description='YI SYLLABLE JJYP' },
	[0xA431] = { unicodeslot=0xA431, category='lo', description='YI SYLLABLE NJIT' },
	[0xA432] = { unicodeslot=0xA432, category='lo', description='YI SYLLABLE NJIX' },
	[0xA433] = { unicodeslot=0xA433, category='lo', description='YI SYLLABLE NJI' },
	[0xA434] = { unicodeslot=0xA434, category='lo', description='YI SYLLABLE NJIP' },
	[0xA435] = { unicodeslot=0xA435, category='lo', description='YI SYLLABLE NJIET' },
	[0xA436] = { unicodeslot=0xA436, category='lo', description='YI SYLLABLE NJIEX' },
	[0xA437] = { unicodeslot=0xA437, category='lo', description='YI SYLLABLE NJIE' },
	[0xA438] = { unicodeslot=0xA438, category='lo', description='YI SYLLABLE NJIEP' },
	[0xA439] = { unicodeslot=0xA439, category='lo', description='YI SYLLABLE NJUOX' },
	[0xA43A] = { unicodeslot=0xA43A, category='lo', description='YI SYLLABLE NJUO' },
	[0xA43B] = { unicodeslot=0xA43B, category='lo', description='YI SYLLABLE NJOT' },
	[0xA43C] = { unicodeslot=0xA43C, category='lo', description='YI SYLLABLE NJOX' },
	[0xA43D] = { unicodeslot=0xA43D, category='lo', description='YI SYLLABLE NJO' },
	[0xA43E] = { unicodeslot=0xA43E, category='lo', description='YI SYLLABLE NJOP' },
	[0xA43F] = { unicodeslot=0xA43F, category='lo', description='YI SYLLABLE NJUX' },
	[0xA440] = { unicodeslot=0xA440, category='lo', description='YI SYLLABLE NJU' },
	[0xA441] = { unicodeslot=0xA441, category='lo', description='YI SYLLABLE NJUP' },
	[0xA442] = { unicodeslot=0xA442, category='lo', description='YI SYLLABLE NJURX' },
	[0xA443] = { unicodeslot=0xA443, category='lo', description='YI SYLLABLE NJUR' },
	[0xA444] = { unicodeslot=0xA444, category='lo', description='YI SYLLABLE NJYT' },
	[0xA445] = { unicodeslot=0xA445, category='lo', description='YI SYLLABLE NJYX' },
	[0xA446] = { unicodeslot=0xA446, category='lo', description='YI SYLLABLE NJY' },
	[0xA447] = { unicodeslot=0xA447, category='lo', description='YI SYLLABLE NJYP' },
	[0xA448] = { unicodeslot=0xA448, category='lo', description='YI SYLLABLE NJYRX' },
	[0xA449] = { unicodeslot=0xA449, category='lo', description='YI SYLLABLE NJYR' },
	[0xA44A] = { unicodeslot=0xA44A, category='lo', description='YI SYLLABLE NYIT' },
	[0xA44B] = { unicodeslot=0xA44B, category='lo', description='YI SYLLABLE NYIX' },
	[0xA44C] = { unicodeslot=0xA44C, category='lo', description='YI SYLLABLE NYI' },
	[0xA44D] = { unicodeslot=0xA44D, category='lo', description='YI SYLLABLE NYIP' },
	[0xA44E] = { unicodeslot=0xA44E, category='lo', description='YI SYLLABLE NYIET' },
	[0xA44F] = { unicodeslot=0xA44F, category='lo', description='YI SYLLABLE NYIEX' },
	[0xA450] = { unicodeslot=0xA450, category='lo', description='YI SYLLABLE NYIE' },
	[0xA451] = { unicodeslot=0xA451, category='lo', description='YI SYLLABLE NYIEP' },
	[0xA452] = { unicodeslot=0xA452, category='lo', description='YI SYLLABLE NYUOX' },
	[0xA453] = { unicodeslot=0xA453, category='lo', description='YI SYLLABLE NYUO' },
	[0xA454] = { unicodeslot=0xA454, category='lo', description='YI SYLLABLE NYUOP' },
	[0xA455] = { unicodeslot=0xA455, category='lo', description='YI SYLLABLE NYOT' },
	[0xA456] = { unicodeslot=0xA456, category='lo', description='YI SYLLABLE NYOX' },
	[0xA457] = { unicodeslot=0xA457, category='lo', description='YI SYLLABLE NYO' },
	[0xA458] = { unicodeslot=0xA458, category='lo', description='YI SYLLABLE NYOP' },
	[0xA459] = { unicodeslot=0xA459, category='lo', description='YI SYLLABLE NYUT' },
	[0xA45A] = { unicodeslot=0xA45A, category='lo', description='YI SYLLABLE NYUX' },
	[0xA45B] = { unicodeslot=0xA45B, category='lo', description='YI SYLLABLE NYU' },
	[0xA45C] = { unicodeslot=0xA45C, category='lo', description='YI SYLLABLE NYUP' },
	[0xA45D] = { unicodeslot=0xA45D, category='lo', description='YI SYLLABLE XIT' },
	[0xA45E] = { unicodeslot=0xA45E, category='lo', description='YI SYLLABLE XIX' },
	[0xA45F] = { unicodeslot=0xA45F, category='lo', description='YI SYLLABLE XI' },
	[0xA460] = { unicodeslot=0xA460, category='lo', description='YI SYLLABLE XIP' },
	[0xA461] = { unicodeslot=0xA461, category='lo', description='YI SYLLABLE XIET' },
	[0xA462] = { unicodeslot=0xA462, category='lo', description='YI SYLLABLE XIEX' },
	[0xA463] = { unicodeslot=0xA463, category='lo', description='YI SYLLABLE XIE' },
	[0xA464] = { unicodeslot=0xA464, category='lo', description='YI SYLLABLE XIEP' },
	[0xA465] = { unicodeslot=0xA465, category='lo', description='YI SYLLABLE XUOX' },
	[0xA466] = { unicodeslot=0xA466, category='lo', description='YI SYLLABLE XUO' },
	[0xA467] = { unicodeslot=0xA467, category='lo', description='YI SYLLABLE XOT' },
	[0xA468] = { unicodeslot=0xA468, category='lo', description='YI SYLLABLE XOX' },
	[0xA469] = { unicodeslot=0xA469, category='lo', description='YI SYLLABLE XO' },
	[0xA46A] = { unicodeslot=0xA46A, category='lo', description='YI SYLLABLE XOP' },
	[0xA46B] = { unicodeslot=0xA46B, category='lo', description='YI SYLLABLE XYT' },
	[0xA46C] = { unicodeslot=0xA46C, category='lo', description='YI SYLLABLE XYX' },
	[0xA46D] = { unicodeslot=0xA46D, category='lo', description='YI SYLLABLE XY' },
	[0xA46E] = { unicodeslot=0xA46E, category='lo', description='YI SYLLABLE XYP' },
	[0xA46F] = { unicodeslot=0xA46F, category='lo', description='YI SYLLABLE XYRX' },
	[0xA470] = { unicodeslot=0xA470, category='lo', description='YI SYLLABLE XYR' },
	[0xA471] = { unicodeslot=0xA471, category='lo', description='YI SYLLABLE YIT' },
	[0xA472] = { unicodeslot=0xA472, category='lo', description='YI SYLLABLE YIX' },
	[0xA473] = { unicodeslot=0xA473, category='lo', description='YI SYLLABLE YI' },
	[0xA474] = { unicodeslot=0xA474, category='lo', description='YI SYLLABLE YIP' },
	[0xA475] = { unicodeslot=0xA475, category='lo', description='YI SYLLABLE YIET' },
	[0xA476] = { unicodeslot=0xA476, category='lo', description='YI SYLLABLE YIEX' },
	[0xA477] = { unicodeslot=0xA477, category='lo', description='YI SYLLABLE YIE' },
	[0xA478] = { unicodeslot=0xA478, category='lo', description='YI SYLLABLE YIEP' },
	[0xA479] = { unicodeslot=0xA479, category='lo', description='YI SYLLABLE YUOT' },
	[0xA47A] = { unicodeslot=0xA47A, category='lo', description='YI SYLLABLE YUOX' },
	[0xA47B] = { unicodeslot=0xA47B, category='lo', description='YI SYLLABLE YUO' },
	[0xA47C] = { unicodeslot=0xA47C, category='lo', description='YI SYLLABLE YUOP' },
	[0xA47D] = { unicodeslot=0xA47D, category='lo', description='YI SYLLABLE YOT' },
	[0xA47E] = { unicodeslot=0xA47E, category='lo', description='YI SYLLABLE YOX' },
	[0xA47F] = { unicodeslot=0xA47F, category='lo', description='YI SYLLABLE YO' },
	[0xA480] = { unicodeslot=0xA480, category='lo', description='YI SYLLABLE YOP' },
	[0xA481] = { unicodeslot=0xA481, category='lo', description='YI SYLLABLE YUT' },
	[0xA482] = { unicodeslot=0xA482, category='lo', description='YI SYLLABLE YUX' },
	[0xA483] = { unicodeslot=0xA483, category='lo', description='YI SYLLABLE YU' },
	[0xA484] = { unicodeslot=0xA484, category='lo', description='YI SYLLABLE YUP' },
	[0xA485] = { unicodeslot=0xA485, category='lo', description='YI SYLLABLE YURX' },
	[0xA486] = { unicodeslot=0xA486, category='lo', description='YI SYLLABLE YUR' },
	[0xA487] = { unicodeslot=0xA487, category='lo', description='YI SYLLABLE YYT' },
	[0xA488] = { unicodeslot=0xA488, category='lo', description='YI SYLLABLE YYX' },
	[0xA489] = { unicodeslot=0xA489, category='lo', description='YI SYLLABLE YY' },
	[0xA48A] = { unicodeslot=0xA48A, category='lo', description='YI SYLLABLE YYP' },
	[0xA48B] = { unicodeslot=0xA48B, category='lo', description='YI SYLLABLE YYRX' },
	[0xA48C] = { unicodeslot=0xA48C, category='lo', description='YI SYLLABLE YYR' },
	[0xA490] = { unicodeslot=0xA490, category='so', description='YI RADICAL QOT' },
	[0xA491] = { unicodeslot=0xA491, category='so', description='YI RADICAL LI' },
	[0xA492] = { unicodeslot=0xA492, category='so', description='YI RADICAL KIT' },
	[0xA493] = { unicodeslot=0xA493, category='so', description='YI RADICAL NYIP' },
	[0xA494] = { unicodeslot=0xA494, category='so', description='YI RADICAL CYP' },
	[0xA495] = { unicodeslot=0xA495, category='so', description='YI RADICAL SSI' },
	[0xA496] = { unicodeslot=0xA496, category='so', description='YI RADICAL GGOP' },
	[0xA497] = { unicodeslot=0xA497, category='so', description='YI RADICAL GEP' },
	[0xA498] = { unicodeslot=0xA498, category='so', description='YI RADICAL MI' },
	[0xA499] = { unicodeslot=0xA499, category='so', description='YI RADICAL HXIT' },
	[0xA49A] = { unicodeslot=0xA49A, category='so', description='YI RADICAL LYR' },
	[0xA49B] = { unicodeslot=0xA49B, category='so', description='YI RADICAL BBUT' },
	[0xA49C] = { unicodeslot=0xA49C, category='so', description='YI RADICAL MOP' },
	[0xA49D] = { unicodeslot=0xA49D, category='so', description='YI RADICAL YO' },
	[0xA49E] = { unicodeslot=0xA49E, category='so', description='YI RADICAL PUT' },
	[0xA49F] = { unicodeslot=0xA49F, category='so', description='YI RADICAL HXUO' },
	[0xA4A0] = { unicodeslot=0xA4A0, category='so', description='YI RADICAL TAT' },
	[0xA4A1] = { unicodeslot=0xA4A1, category='so', description='YI RADICAL GA' },
	[0xA4A2] = { unicodeslot=0xA4A2, category='so', description='YI RADICAL ZUP' },
	[0xA4A3] = { unicodeslot=0xA4A3, category='so', description='YI RADICAL CYT' },
	[0xA4A4] = { unicodeslot=0xA4A4, category='so', description='YI RADICAL DDUR' },
	[0xA4A5] = { unicodeslot=0xA4A5, category='so', description='YI RADICAL BUR' },
	[0xA4A6] = { unicodeslot=0xA4A6, category='so', description='YI RADICAL GGUO' },
	[0xA4A7] = { unicodeslot=0xA4A7, category='so', description='YI RADICAL NYOP' },
	[0xA4A8] = { unicodeslot=0xA4A8, category='so', description='YI RADICAL TU' },
	[0xA4A9] = { unicodeslot=0xA4A9, category='so', description='YI RADICAL OP' },
	[0xA4AA] = { unicodeslot=0xA4AA, category='so', description='YI RADICAL JJUT' },
	[0xA4AB] = { unicodeslot=0xA4AB, category='so', description='YI RADICAL ZOT' },
	[0xA4AC] = { unicodeslot=0xA4AC, category='so', description='YI RADICAL PYT' },
	[0xA4AD] = { unicodeslot=0xA4AD, category='so', description='YI RADICAL HMO' },
	[0xA4AE] = { unicodeslot=0xA4AE, category='so', description='YI RADICAL YIT' },
	[0xA4AF] = { unicodeslot=0xA4AF, category='so', description='YI RADICAL VUR' },
	[0xA4B0] = { unicodeslot=0xA4B0, category='so', description='YI RADICAL SHY' },
	[0xA4B1] = { unicodeslot=0xA4B1, category='so', description='YI RADICAL VEP' },
	[0xA4B2] = { unicodeslot=0xA4B2, category='so', description='YI RADICAL ZA' },
	[0xA4B3] = { unicodeslot=0xA4B3, category='so', description='YI RADICAL JO' },
	[0xA4B4] = { unicodeslot=0xA4B4, category='so', description='YI RADICAL NZUP' },
	[0xA4B5] = { unicodeslot=0xA4B5, category='so', description='YI RADICAL JJY' },
	[0xA4B6] = { unicodeslot=0xA4B6, category='so', description='YI RADICAL GOT' },
	[0xA4B7] = { unicodeslot=0xA4B7, category='so', description='YI RADICAL JJIE' },
	[0xA4B8] = { unicodeslot=0xA4B8, category='so', description='YI RADICAL WO' },
	[0xA4B9] = { unicodeslot=0xA4B9, category='so', description='YI RADICAL DU' },
	[0xA4BA] = { unicodeslot=0xA4BA, category='so', description='YI RADICAL SHUR' },
	[0xA4BB] = { unicodeslot=0xA4BB, category='so', description='YI RADICAL LIE' },
	[0xA4BC] = { unicodeslot=0xA4BC, category='so', description='YI RADICAL CY' },
	[0xA4BD] = { unicodeslot=0xA4BD, category='so', description='YI RADICAL CUOP' },
	[0xA4BE] = { unicodeslot=0xA4BE, category='so', description='YI RADICAL CIP' },
	[0xA4BF] = { unicodeslot=0xA4BF, category='so', description='YI RADICAL HXOP' },
	[0xA4C0] = { unicodeslot=0xA4C0, category='so', description='YI RADICAL SHAT' },
	[0xA4C1] = { unicodeslot=0xA4C1, category='so', description='YI RADICAL ZUR' },
	[0xA4C2] = { unicodeslot=0xA4C2, category='so', description='YI RADICAL SHOP' },
	[0xA4C3] = { unicodeslot=0xA4C3, category='so', description='YI RADICAL CHE' },
	[0xA4C4] = { unicodeslot=0xA4C4, category='so', description='YI RADICAL ZZIET' },
	[0xA4C5] = { unicodeslot=0xA4C5, category='so', description='YI RADICAL NBIE' },
	[0xA4C6] = { unicodeslot=0xA4C6, category='so', description='YI RADICAL KE' },
	[0xA700] = { unicodeslot=0xA700, category='sk', description='MODIFIER LETTER CHINESE TONE YIN PING' },
	[0xA701] = { unicodeslot=0xA701, category='sk', description='MODIFIER LETTER CHINESE TONE YANG PING' },
	[0xA702] = { unicodeslot=0xA702, category='sk', description='MODIFIER LETTER CHINESE TONE YIN SHANG' },
	[0xA703] = { unicodeslot=0xA703, category='sk', description='MODIFIER LETTER CHINESE TONE YANG SHANG' },
	[0xA704] = { unicodeslot=0xA704, category='sk', description='MODIFIER LETTER CHINESE TONE YIN QU' },
	[0xA705] = { unicodeslot=0xA705, category='sk', description='MODIFIER LETTER CHINESE TONE YANG QU' },
	[0xA706] = { unicodeslot=0xA706, category='sk', description='MODIFIER LETTER CHINESE TONE YIN RU' },
	[0xA707] = { unicodeslot=0xA707, category='sk', description='MODIFIER LETTER CHINESE TONE YANG RU' },
	[0xA708] = { unicodeslot=0xA708, category='sk', description='MODIFIER LETTER EXTRA-HIGH DOTTED TONE BAR' },
	[0xA709] = { unicodeslot=0xA709, category='sk', description='MODIFIER LETTER HIGH DOTTED TONE BAR' },
	[0xA70A] = { unicodeslot=0xA70A, category='sk', description='MODIFIER LETTER MID DOTTED TONE BAR' },
	[0xA70B] = { unicodeslot=0xA70B, category='sk', description='MODIFIER LETTER LOW DOTTED TONE BAR' },
	[0xA70C] = { unicodeslot=0xA70C, category='sk', description='MODIFIER LETTER EXTRA-LOW DOTTED TONE BAR' },
	[0xA70D] = { unicodeslot=0xA70D, category='sk', description='MODIFIER LETTER EXTRA-HIGH DOTTED LEFT-STEM TONE BAR' },
	[0xA70E] = { unicodeslot=0xA70E, category='sk', description='MODIFIER LETTER HIGH DOTTED LEFT-STEM TONE BAR' },
	[0xA70F] = { unicodeslot=0xA70F, category='sk', description='MODIFIER LETTER MID DOTTED LEFT-STEM TONE BAR' },
	[0xA710] = { unicodeslot=0xA710, category='sk', description='MODIFIER LETTER LOW DOTTED LEFT-STEM TONE BAR' },
	[0xA711] = { unicodeslot=0xA711, category='sk', description='MODIFIER LETTER EXTRA-LOW DOTTED LEFT-STEM TONE BAR' },
	[0xA712] = { unicodeslot=0xA712, category='sk', description='MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR' },
	[0xA713] = { unicodeslot=0xA713, category='sk', description='MODIFIER LETTER HIGH LEFT-STEM TONE BAR' },
	[0xA714] = { unicodeslot=0xA714, category='sk', description='MODIFIER LETTER MID LEFT-STEM TONE BAR' },
	[0xA715] = { unicodeslot=0xA715, category='sk', description='MODIFIER LETTER LOW LEFT-STEM TONE BAR' },
	[0xA716] = { unicodeslot=0xA716, category='sk', description='MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR' },
	[0xA717] = { unicodeslot=0xA717, category='lm', description='MODIFIER LETTER DOT VERTICAL BAR' },
	[0xA718] = { unicodeslot=0xA718, category='lm', description='MODIFIER LETTER DOT SLASH' },
	[0xA719] = { unicodeslot=0xA719, category='lm', description='MODIFIER LETTER DOT HORIZONTAL BAR' },
	[0xA71A] = { unicodeslot=0xA71A, category='lm', description='MODIFIER LETTER LOWER RIGHT CORNER ANGLE' },
	[0xA720] = { unicodeslot=0xA720, category='sk', description='MODIFIER LETTER STRESS AND HIGH TONE' },
	[0xA721] = { unicodeslot=0xA721, category='sk', description='MODIFIER LETTER STRESS AND LOW TONE' },
	[0xA800] = { unicodeslot=0xA800, category='lo', description='SYLOTI NAGRI LETTER A' },
	[0xA801] = { unicodeslot=0xA801, category='lo', description='SYLOTI NAGRI LETTER I' },
	[0xA802] = { unicodeslot=0xA802, category='mc', description='SYLOTI NAGRI SIGN DVISVARA' },
	[0xA803] = { unicodeslot=0xA803, category='lo', description='SYLOTI NAGRI LETTER U' },
	[0xA804] = { unicodeslot=0xA804, category='lo', description='SYLOTI NAGRI LETTER E' },
	[0xA805] = { unicodeslot=0xA805, category='lo', description='SYLOTI NAGRI LETTER O' },
	[0xA806] = { unicodeslot=0xA806, category='mn', description='SYLOTI NAGRI SIGN HASANTA' },
	[0xA807] = { unicodeslot=0xA807, category='lo', description='SYLOTI NAGRI LETTER KO' },
	[0xA808] = { unicodeslot=0xA808, category='lo', description='SYLOTI NAGRI LETTER KHO' },
	[0xA809] = { unicodeslot=0xA809, category='lo', description='SYLOTI NAGRI LETTER GO' },
	[0xA80A] = { unicodeslot=0xA80A, category='lo', description='SYLOTI NAGRI LETTER GHO' },
	[0xA80B] = { unicodeslot=0xA80B, category='mn', description='SYLOTI NAGRI SIGN ANUSVARA' },
	[0xA80C] = { unicodeslot=0xA80C, category='lo', description='SYLOTI NAGRI LETTER CO' },
	[0xA80D] = { unicodeslot=0xA80D, category='lo', description='SYLOTI NAGRI LETTER CHO' },
	[0xA80E] = { unicodeslot=0xA80E, category='lo', description='SYLOTI NAGRI LETTER JO' },
	[0xA80F] = { unicodeslot=0xA80F, category='lo', description='SYLOTI NAGRI LETTER JHO' },
	[0xA810] = { unicodeslot=0xA810, category='lo', description='SYLOTI NAGRI LETTER TTO' },
	[0xA811] = { unicodeslot=0xA811, category='lo', description='SYLOTI NAGRI LETTER TTHO' },
	[0xA812] = { unicodeslot=0xA812, category='lo', description='SYLOTI NAGRI LETTER DDO' },
	[0xA813] = { unicodeslot=0xA813, category='lo', description='SYLOTI NAGRI LETTER DDHO' },
	[0xA814] = { unicodeslot=0xA814, category='lo', description='SYLOTI NAGRI LETTER TO' },
	[0xA815] = { unicodeslot=0xA815, category='lo', description='SYLOTI NAGRI LETTER THO' },
	[0xA816] = { unicodeslot=0xA816, category='lo', description='SYLOTI NAGRI LETTER DO' },
	[0xA817] = { unicodeslot=0xA817, category='lo', description='SYLOTI NAGRI LETTER DHO' },
	[0xA818] = { unicodeslot=0xA818, category='lo', description='SYLOTI NAGRI LETTER NO' },
	[0xA819] = { unicodeslot=0xA819, category='lo', description='SYLOTI NAGRI LETTER PO' },
	[0xA81A] = { unicodeslot=0xA81A, category='lo', description='SYLOTI NAGRI LETTER PHO' },
	[0xA81B] = { unicodeslot=0xA81B, category='lo', description='SYLOTI NAGRI LETTER BO' },
	[0xA81C] = { unicodeslot=0xA81C, category='lo', description='SYLOTI NAGRI LETTER BHO' },
	[0xA81D] = { unicodeslot=0xA81D, category='lo', description='SYLOTI NAGRI LETTER MO' },
	[0xA81E] = { unicodeslot=0xA81E, category='lo', description='SYLOTI NAGRI LETTER RO' },
	[0xA81F] = { unicodeslot=0xA81F, category='lo', description='SYLOTI NAGRI LETTER LO' },
	[0xA820] = { unicodeslot=0xA820, category='lo', description='SYLOTI NAGRI LETTER RRO' },
	[0xA821] = { unicodeslot=0xA821, category='lo', description='SYLOTI NAGRI LETTER SO' },
	[0xA822] = { unicodeslot=0xA822, category='lo', description='SYLOTI NAGRI LETTER HO' },
	[0xA823] = { unicodeslot=0xA823, category='mc', description='SYLOTI NAGRI VOWEL SIGN A' },
	[0xA824] = { unicodeslot=0xA824, category='mc', description='SYLOTI NAGRI VOWEL SIGN I' },
	[0xA825] = { unicodeslot=0xA825, category='mn', description='SYLOTI NAGRI VOWEL SIGN U' },
	[0xA826] = { unicodeslot=0xA826, category='mn', description='SYLOTI NAGRI VOWEL SIGN E' },
	[0xA827] = { unicodeslot=0xA827, category='mc', description='SYLOTI NAGRI VOWEL SIGN OO' },
	[0xA828] = { unicodeslot=0xA828, category='so', description='SYLOTI NAGRI POETRY MARK-1' },
	[0xA829] = { unicodeslot=0xA829, category='so', description='SYLOTI NAGRI POETRY MARK-2' },
	[0xA82A] = { unicodeslot=0xA82A, category='so', description='SYLOTI NAGRI POETRY MARK-3' },
	[0xA82B] = { unicodeslot=0xA82B, category='so', description='SYLOTI NAGRI POETRY MARK-4' },
	[0xA840] = { unicodeslot=0xA840, category='lo', description='PHAGS-PA LETTER KA' },
	[0xA841] = { unicodeslot=0xA841, category='lo', description='PHAGS-PA LETTER KHA' },
	[0xA842] = { unicodeslot=0xA842, category='lo', description='PHAGS-PA LETTER GA' },
	[0xA843] = { unicodeslot=0xA843, category='lo', description='PHAGS-PA LETTER NGA' },
	[0xA844] = { unicodeslot=0xA844, category='lo', description='PHAGS-PA LETTER CA' },
	[0xA845] = { unicodeslot=0xA845, category='lo', description='PHAGS-PA LETTER CHA' },
	[0xA846] = { unicodeslot=0xA846, category='lo', description='PHAGS-PA LETTER JA' },
	[0xA847] = { unicodeslot=0xA847, category='lo', description='PHAGS-PA LETTER NYA' },
	[0xA848] = { unicodeslot=0xA848, category='lo', description='PHAGS-PA LETTER TA' },
	[0xA849] = { unicodeslot=0xA849, category='lo', description='PHAGS-PA LETTER THA' },
	[0xA84A] = { unicodeslot=0xA84A, category='lo', description='PHAGS-PA LETTER DA' },
	[0xA84B] = { unicodeslot=0xA84B, category='lo', description='PHAGS-PA LETTER NA' },
	[0xA84C] = { unicodeslot=0xA84C, category='lo', description='PHAGS-PA LETTER PA' },
	[0xA84D] = { unicodeslot=0xA84D, category='lo', description='PHAGS-PA LETTER PHA' },
	[0xA84E] = { unicodeslot=0xA84E, category='lo', description='PHAGS-PA LETTER BA' },
	[0xA84F] = { unicodeslot=0xA84F, category='lo', description='PHAGS-PA LETTER MA' },
	[0xA850] = { unicodeslot=0xA850, category='lo', description='PHAGS-PA LETTER TSA' },
	[0xA851] = { unicodeslot=0xA851, category='lo', description='PHAGS-PA LETTER TSHA' },
	[0xA852] = { unicodeslot=0xA852, category='lo', description='PHAGS-PA LETTER DZA' },
	[0xA853] = { unicodeslot=0xA853, category='lo', description='PHAGS-PA LETTER WA' },
	[0xA854] = { unicodeslot=0xA854, category='lo', description='PHAGS-PA LETTER ZHA' },
	[0xA855] = { unicodeslot=0xA855, category='lo', description='PHAGS-PA LETTER ZA' },
	[0xA856] = { unicodeslot=0xA856, category='lo', description='PHAGS-PA LETTER SMALL A' },
	[0xA857] = { unicodeslot=0xA857, category='lo', description='PHAGS-PA LETTER YA' },
	[0xA858] = { unicodeslot=0xA858, category='lo', description='PHAGS-PA LETTER RA' },
	[0xA859] = { unicodeslot=0xA859, category='lo', description='PHAGS-PA LETTER LA' },
	[0xA85A] = { unicodeslot=0xA85A, category='lo', description='PHAGS-PA LETTER SHA' },
	[0xA85B] = { unicodeslot=0xA85B, category='lo', description='PHAGS-PA LETTER SA' },
	[0xA85C] = { unicodeslot=0xA85C, category='lo', description='PHAGS-PA LETTER HA' },
	[0xA85D] = { unicodeslot=0xA85D, category='lo', description='PHAGS-PA LETTER A' },
	[0xA85E] = { unicodeslot=0xA85E, category='lo', description='PHAGS-PA LETTER I' },
	[0xA85F] = { unicodeslot=0xA85F, category='lo', description='PHAGS-PA LETTER U' },
	[0xA860] = { unicodeslot=0xA860, category='lo', description='PHAGS-PA LETTER E' },
	[0xA861] = { unicodeslot=0xA861, category='lo', description='PHAGS-PA LETTER O' },
	[0xA862] = { unicodeslot=0xA862, category='lo', description='PHAGS-PA LETTER QA' },
	[0xA863] = { unicodeslot=0xA863, category='lo', description='PHAGS-PA LETTER XA' },
	[0xA864] = { unicodeslot=0xA864, category='lo', description='PHAGS-PA LETTER FA' },
	[0xA865] = { unicodeslot=0xA865, category='lo', description='PHAGS-PA LETTER GGA' },
	[0xA866] = { unicodeslot=0xA866, category='lo', description='PHAGS-PA LETTER EE' },
	[0xA867] = { unicodeslot=0xA867, category='lo', description='PHAGS-PA SUBJOINED LETTER WA' },
	[0xA868] = { unicodeslot=0xA868, category='lo', description='PHAGS-PA SUBJOINED LETTER YA' },
	[0xA869] = { unicodeslot=0xA869, category='lo', description='PHAGS-PA LETTER TTA' },
	[0xA86A] = { unicodeslot=0xA86A, category='lo', description='PHAGS-PA LETTER TTHA' },
	[0xA86B] = { unicodeslot=0xA86B, category='lo', description='PHAGS-PA LETTER DDA' },
	[0xA86C] = { unicodeslot=0xA86C, category='lo', description='PHAGS-PA LETTER NNA' },
	[0xA86D] = { unicodeslot=0xA86D, category='lo', description='PHAGS-PA LETTER ALTERNATE YA' },
	[0xA86E] = { unicodeslot=0xA86E, category='lo', description='PHAGS-PA LETTER VOICELESS SHA' },
	[0xA86F] = { unicodeslot=0xA86F, category='lo', description='PHAGS-PA LETTER VOICED HA' },
	[0xA870] = { unicodeslot=0xA870, category='lo', description='PHAGS-PA LETTER ASPIRATED FA' },
	[0xA871] = { unicodeslot=0xA871, category='lo', description='PHAGS-PA SUBJOINED LETTER RA' },
	[0xA872] = { unicodeslot=0xA872, category='lo', description='PHAGS-PA SUPERFIXED LETTER RA' },
	[0xA873] = { unicodeslot=0xA873, category='lo', description='PHAGS-PA LETTER CANDRABINDU' },
	[0xA874] = { unicodeslot=0xA874, category='po', description='PHAGS-PA SINGLE HEAD MARK' },
	[0xA875] = { unicodeslot=0xA875, category='po', description='PHAGS-PA DOUBLE HEAD MARK' },
	[0xA876] = { unicodeslot=0xA876, category='po', description='PHAGS-PA MARK SHAD' },
	[0xA877] = { unicodeslot=0xA877, category='po', description='PHAGS-PA MARK DOUBLE SHAD' },
	[0xAC00] = { unicodeslot=0xAC00, category='lo', description='<Hangul Syllable, First>' },
	[0xD7A3] = { unicodeslot=0xD7A3, category='lo', description='<Hangul Syllable, Last>' },
	[0xD800] = { unicodeslot=0xD800, category='cs', description='<Non Private Use High Surrogate, First>' },
	[0xDB7F] = { unicodeslot=0xDB7F, category='cs', description='<Non Private Use High Surrogate, Last>' },
	[0xDB80] = { unicodeslot=0xDB80, category='cs', description='<Private Use High Surrogate, First>' },
	[0xDBFF] = { unicodeslot=0xDBFF, category='cs', description='<Private Use High Surrogate, Last>' },
	[0xDC00] = { unicodeslot=0xDC00, category='cs', description='<Low Surrogate, First>' },
	[0xDFFF] = { unicodeslot=0xDFFF, category='cs', description='<Low Surrogate, Last>' },
	[0xE000] = { unicodeslot=0xE000, category='co', description='<Private Use, First>' },
	[0xF8FF] = { unicodeslot=0xF8FF, category='co', description='<Private Use, Last>' },
	[0xF900] = { unicodeslot=0xF900, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F900', specials={'char',0x8C48} },
	[0xF901] = { unicodeslot=0xF901, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F901', specials={'char',0x66F4} },
	[0xF902] = { unicodeslot=0xF902, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F902', specials={'char',0x8ECA} },
	[0xF903] = { unicodeslot=0xF903, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F903', specials={'char',0x8CC8} },
	[0xF904] = { unicodeslot=0xF904, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F904', specials={'char',0x6ED1} },
	[0xF905] = { unicodeslot=0xF905, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F905', specials={'char',0x4E32} },
	[0xF906] = { unicodeslot=0xF906, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F906', specials={'char',0x53E5} },
	[0xF907] = { unicodeslot=0xF907, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F907', specials={'char',0x9F9C} },
	[0xF908] = { unicodeslot=0xF908, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F908', specials={'char',0x9F9C} },
	[0xF909] = { unicodeslot=0xF909, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F909', specials={'char',0x5951} },
	[0xF90A] = { unicodeslot=0xF90A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F90A', specials={'char',0x91D1} },
	[0xF90B] = { unicodeslot=0xF90B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F90B', specials={'char',0x5587} },
	[0xF90C] = { unicodeslot=0xF90C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F90C', specials={'char',0x5948} },
	[0xF90D] = { unicodeslot=0xF90D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F90D', specials={'char',0x61F6} },
	[0xF90E] = { unicodeslot=0xF90E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F90E', specials={'char',0x7669} },
	[0xF90F] = { unicodeslot=0xF90F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F90F', specials={'char',0x7F85} },
	[0xF910] = { unicodeslot=0xF910, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F910', specials={'char',0x863F} },
	[0xF911] = { unicodeslot=0xF911, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F911', specials={'char',0x87BA} },
	[0xF912] = { unicodeslot=0xF912, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F912', specials={'char',0x88F8} },
	[0xF913] = { unicodeslot=0xF913, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F913', specials={'char',0x908F} },
	[0xF914] = { unicodeslot=0xF914, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F914', specials={'char',0x6A02} },
	[0xF915] = { unicodeslot=0xF915, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F915', specials={'char',0x6D1B} },
	[0xF916] = { unicodeslot=0xF916, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F916', specials={'char',0x70D9} },
	[0xF917] = { unicodeslot=0xF917, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F917', specials={'char',0x73DE} },
	[0xF918] = { unicodeslot=0xF918, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F918', specials={'char',0x843D} },
	[0xF919] = { unicodeslot=0xF919, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F919', specials={'char',0x916A} },
	[0xF91A] = { unicodeslot=0xF91A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F91A', specials={'char',0x99F1} },
	[0xF91B] = { unicodeslot=0xF91B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F91B', specials={'char',0x4E82} },
	[0xF91C] = { unicodeslot=0xF91C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F91C', specials={'char',0x5375} },
	[0xF91D] = { unicodeslot=0xF91D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F91D', specials={'char',0x6B04} },
	[0xF91E] = { unicodeslot=0xF91E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F91E', specials={'char',0x721B} },
	[0xF91F] = { unicodeslot=0xF91F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F91F', specials={'char',0x862D} },
	[0xF920] = { unicodeslot=0xF920, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F920', specials={'char',0x9E1E} },
	[0xF921] = { unicodeslot=0xF921, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F921', specials={'char',0x5D50} },
	[0xF922] = { unicodeslot=0xF922, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F922', specials={'char',0x6FEB} },
	[0xF923] = { unicodeslot=0xF923, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F923', specials={'char',0x85CD} },
	[0xF924] = { unicodeslot=0xF924, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F924', specials={'char',0x8964} },
	[0xF925] = { unicodeslot=0xF925, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F925', specials={'char',0x62C9} },
	[0xF926] = { unicodeslot=0xF926, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F926', specials={'char',0x81D8} },
	[0xF927] = { unicodeslot=0xF927, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F927', specials={'char',0x881F} },
	[0xF928] = { unicodeslot=0xF928, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F928', specials={'char',0x5ECA} },
	[0xF929] = { unicodeslot=0xF929, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F929', specials={'char',0x6717} },
	[0xF92A] = { unicodeslot=0xF92A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F92A', specials={'char',0x6D6A} },
	[0xF92B] = { unicodeslot=0xF92B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F92B', specials={'char',0x72FC} },
	[0xF92C] = { unicodeslot=0xF92C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F92C', specials={'char',0x90CE} },
	[0xF92D] = { unicodeslot=0xF92D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F92D', specials={'char',0x4F86} },
	[0xF92E] = { unicodeslot=0xF92E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F92E', specials={'char',0x51B7} },
	[0xF92F] = { unicodeslot=0xF92F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F92F', specials={'char',0x52DE} },
	[0xF930] = { unicodeslot=0xF930, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F930', specials={'char',0x64C4} },
	[0xF931] = { unicodeslot=0xF931, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F931', specials={'char',0x6AD3} },
	[0xF932] = { unicodeslot=0xF932, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F932', specials={'char',0x7210} },
	[0xF933] = { unicodeslot=0xF933, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F933', specials={'char',0x76E7} },
	[0xF934] = { unicodeslot=0xF934, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F934', specials={'char',0x8001} },
	[0xF935] = { unicodeslot=0xF935, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F935', specials={'char',0x8606} },
	[0xF936] = { unicodeslot=0xF936, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F936', specials={'char',0x865C} },
	[0xF937] = { unicodeslot=0xF937, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F937', specials={'char',0x8DEF} },
	[0xF938] = { unicodeslot=0xF938, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F938', specials={'char',0x9732} },
	[0xF939] = { unicodeslot=0xF939, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F939', specials={'char',0x9B6F} },
	[0xF93A] = { unicodeslot=0xF93A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F93A', specials={'char',0x9DFA} },
	[0xF93B] = { unicodeslot=0xF93B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F93B', specials={'char',0x788C} },
	[0xF93C] = { unicodeslot=0xF93C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F93C', specials={'char',0x797F} },
	[0xF93D] = { unicodeslot=0xF93D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F93D', specials={'char',0x7DA0} },
	[0xF93E] = { unicodeslot=0xF93E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F93E', specials={'char',0x83C9} },
	[0xF93F] = { unicodeslot=0xF93F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F93F', specials={'char',0x9304} },
	[0xF940] = { unicodeslot=0xF940, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F940', specials={'char',0x9E7F} },
	[0xF941] = { unicodeslot=0xF941, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F941', specials={'char',0x8AD6} },
	[0xF942] = { unicodeslot=0xF942, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F942', specials={'char',0x58DF} },
	[0xF943] = { unicodeslot=0xF943, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F943', specials={'char',0x5F04} },
	[0xF944] = { unicodeslot=0xF944, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F944', specials={'char',0x7C60} },
	[0xF945] = { unicodeslot=0xF945, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F945', specials={'char',0x807E} },
	[0xF946] = { unicodeslot=0xF946, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F946', specials={'char',0x7262} },
	[0xF947] = { unicodeslot=0xF947, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F947', specials={'char',0x78CA} },
	[0xF948] = { unicodeslot=0xF948, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F948', specials={'char',0x8CC2} },
	[0xF949] = { unicodeslot=0xF949, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F949', specials={'char',0x96F7} },
	[0xF94A] = { unicodeslot=0xF94A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F94A', specials={'char',0x58D8} },
	[0xF94B] = { unicodeslot=0xF94B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F94B', specials={'char',0x5C62} },
	[0xF94C] = { unicodeslot=0xF94C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F94C', specials={'char',0x6A13} },
	[0xF94D] = { unicodeslot=0xF94D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F94D', specials={'char',0x6DDA} },
	[0xF94E] = { unicodeslot=0xF94E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F94E', specials={'char',0x6F0F} },
	[0xF94F] = { unicodeslot=0xF94F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F94F', specials={'char',0x7D2F} },
	[0xF950] = { unicodeslot=0xF950, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F950', specials={'char',0x7E37} },
	[0xF951] = { unicodeslot=0xF951, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F951', specials={'char',0x964B} },
	[0xF952] = { unicodeslot=0xF952, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F952', specials={'char',0x52D2} },
	[0xF953] = { unicodeslot=0xF953, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F953', specials={'char',0x808B} },
	[0xF954] = { unicodeslot=0xF954, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F954', specials={'char',0x51DC} },
	[0xF955] = { unicodeslot=0xF955, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F955', specials={'char',0x51CC} },
	[0xF956] = { unicodeslot=0xF956, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F956', specials={'char',0x7A1C} },
	[0xF957] = { unicodeslot=0xF957, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F957', specials={'char',0x7DBE} },
	[0xF958] = { unicodeslot=0xF958, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F958', specials={'char',0x83F1} },
	[0xF959] = { unicodeslot=0xF959, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F959', specials={'char',0x9675} },
	[0xF95A] = { unicodeslot=0xF95A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F95A', specials={'char',0x8B80} },
	[0xF95B] = { unicodeslot=0xF95B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F95B', specials={'char',0x62CF} },
	[0xF95C] = { unicodeslot=0xF95C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F95C', specials={'char',0x6A02} },
	[0xF95D] = { unicodeslot=0xF95D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F95D', specials={'char',0x8AFE} },
	[0xF95E] = { unicodeslot=0xF95E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F95E', specials={'char',0x4E39} },
	[0xF95F] = { unicodeslot=0xF95F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F95F', specials={'char',0x5BE7} },
	[0xF960] = { unicodeslot=0xF960, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F960', specials={'char',0x6012} },
	[0xF961] = { unicodeslot=0xF961, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F961', specials={'char',0x7387} },
	[0xF962] = { unicodeslot=0xF962, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F962', specials={'char',0x7570} },
	[0xF963] = { unicodeslot=0xF963, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F963', specials={'char',0x5317} },
	[0xF964] = { unicodeslot=0xF964, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F964', specials={'char',0x78FB} },
	[0xF965] = { unicodeslot=0xF965, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F965', specials={'char',0x4FBF} },
	[0xF966] = { unicodeslot=0xF966, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F966', specials={'char',0x5FA9} },
	[0xF967] = { unicodeslot=0xF967, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F967', specials={'char',0x4E0D} },
	[0xF968] = { unicodeslot=0xF968, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F968', specials={'char',0x6CCC} },
	[0xF969] = { unicodeslot=0xF969, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F969', specials={'char',0x6578} },
	[0xF96A] = { unicodeslot=0xF96A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F96A', specials={'char',0x7D22} },
	[0xF96B] = { unicodeslot=0xF96B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F96B', specials={'char',0x53C3} },
	[0xF96C] = { unicodeslot=0xF96C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F96C', specials={'char',0x585E} },
	[0xF96D] = { unicodeslot=0xF96D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F96D', specials={'char',0x7701} },
	[0xF96E] = { unicodeslot=0xF96E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F96E', specials={'char',0x8449} },
	[0xF96F] = { unicodeslot=0xF96F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F96F', specials={'char',0x8AAA} },
	[0xF970] = { unicodeslot=0xF970, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F970', specials={'char',0x6BBA} },
	[0xF971] = { unicodeslot=0xF971, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F971', specials={'char',0x8FB0} },
	[0xF972] = { unicodeslot=0xF972, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F972', specials={'char',0x6C88} },
	[0xF973] = { unicodeslot=0xF973, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F973', specials={'char',0x62FE} },
	[0xF974] = { unicodeslot=0xF974, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F974', specials={'char',0x82E5} },
	[0xF975] = { unicodeslot=0xF975, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F975', specials={'char',0x63A0} },
	[0xF976] = { unicodeslot=0xF976, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F976', specials={'char',0x7565} },
	[0xF977] = { unicodeslot=0xF977, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F977', specials={'char',0x4EAE} },
	[0xF978] = { unicodeslot=0xF978, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F978', specials={'char',0x5169} },
	[0xF979] = { unicodeslot=0xF979, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F979', specials={'char',0x51C9} },
	[0xF97A] = { unicodeslot=0xF97A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F97A', specials={'char',0x6881} },
	[0xF97B] = { unicodeslot=0xF97B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F97B', specials={'char',0x7CE7} },
	[0xF97C] = { unicodeslot=0xF97C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F97C', specials={'char',0x826F} },
	[0xF97D] = { unicodeslot=0xF97D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F97D', specials={'char',0x8AD2} },
	[0xF97E] = { unicodeslot=0xF97E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F97E', specials={'char',0x91CF} },
	[0xF97F] = { unicodeslot=0xF97F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F97F', specials={'char',0x52F5} },
	[0xF980] = { unicodeslot=0xF980, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F980', specials={'char',0x5442} },
	[0xF981] = { unicodeslot=0xF981, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F981', specials={'char',0x5973} },
	[0xF982] = { unicodeslot=0xF982, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F982', specials={'char',0x5EEC} },
	[0xF983] = { unicodeslot=0xF983, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F983', specials={'char',0x65C5} },
	[0xF984] = { unicodeslot=0xF984, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F984', specials={'char',0x6FFE} },
	[0xF985] = { unicodeslot=0xF985, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F985', specials={'char',0x792A} },
	[0xF986] = { unicodeslot=0xF986, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F986', specials={'char',0x95AD} },
	[0xF987] = { unicodeslot=0xF987, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F987', specials={'char',0x9A6A} },
	[0xF988] = { unicodeslot=0xF988, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F988', specials={'char',0x9E97} },
	[0xF989] = { unicodeslot=0xF989, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F989', specials={'char',0x9ECE} },
	[0xF98A] = { unicodeslot=0xF98A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F98A', specials={'char',0x529B} },
	[0xF98B] = { unicodeslot=0xF98B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F98B', specials={'char',0x66C6} },
	[0xF98C] = { unicodeslot=0xF98C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F98C', specials={'char',0x6B77} },
	[0xF98D] = { unicodeslot=0xF98D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F98D', specials={'char',0x8F62} },
	[0xF98E] = { unicodeslot=0xF98E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F98E', specials={'char',0x5E74} },
	[0xF98F] = { unicodeslot=0xF98F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F98F', specials={'char',0x6190} },
	[0xF990] = { unicodeslot=0xF990, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F990', specials={'char',0x6200} },
	[0xF991] = { unicodeslot=0xF991, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F991', specials={'char',0x649A} },
	[0xF992] = { unicodeslot=0xF992, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F992', specials={'char',0x6F23} },
	[0xF993] = { unicodeslot=0xF993, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F993', specials={'char',0x7149} },
	[0xF994] = { unicodeslot=0xF994, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F994', specials={'char',0x7489} },
	[0xF995] = { unicodeslot=0xF995, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F995', specials={'char',0x79CA} },
	[0xF996] = { unicodeslot=0xF996, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F996', specials={'char',0x7DF4} },
	[0xF997] = { unicodeslot=0xF997, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F997', specials={'char',0x806F} },
	[0xF998] = { unicodeslot=0xF998, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F998', specials={'char',0x8F26} },
	[0xF999] = { unicodeslot=0xF999, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F999', specials={'char',0x84EE} },
	[0xF99A] = { unicodeslot=0xF99A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F99A', specials={'char',0x9023} },
	[0xF99B] = { unicodeslot=0xF99B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F99B', specials={'char',0x934A} },
	[0xF99C] = { unicodeslot=0xF99C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F99C', specials={'char',0x5217} },
	[0xF99D] = { unicodeslot=0xF99D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F99D', specials={'char',0x52A3} },
	[0xF99E] = { unicodeslot=0xF99E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F99E', specials={'char',0x54BD} },
	[0xF99F] = { unicodeslot=0xF99F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F99F', specials={'char',0x70C8} },
	[0xF9A0] = { unicodeslot=0xF9A0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A0', specials={'char',0x88C2} },
	[0xF9A1] = { unicodeslot=0xF9A1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A1', specials={'char',0x8AAA} },
	[0xF9A2] = { unicodeslot=0xF9A2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A2', specials={'char',0x5EC9} },
	[0xF9A3] = { unicodeslot=0xF9A3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A3', specials={'char',0x5FF5} },
	[0xF9A4] = { unicodeslot=0xF9A4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A4', specials={'char',0x637B} },
	[0xF9A5] = { unicodeslot=0xF9A5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A5', specials={'char',0x6BAE} },
	[0xF9A6] = { unicodeslot=0xF9A6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A6', specials={'char',0x7C3E} },
	[0xF9A7] = { unicodeslot=0xF9A7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A7', specials={'char',0x7375} },
	[0xF9A8] = { unicodeslot=0xF9A8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A8', specials={'char',0x4EE4} },
	[0xF9A9] = { unicodeslot=0xF9A9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9A9', specials={'char',0x56F9} },
	[0xF9AA] = { unicodeslot=0xF9AA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9AA', specials={'char',0x5BE7} },
	[0xF9AB] = { unicodeslot=0xF9AB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9AB', specials={'char',0x5DBA} },
	[0xF9AC] = { unicodeslot=0xF9AC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9AC', specials={'char',0x601C} },
	[0xF9AD] = { unicodeslot=0xF9AD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9AD', specials={'char',0x73B2} },
	[0xF9AE] = { unicodeslot=0xF9AE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9AE', specials={'char',0x7469} },
	[0xF9AF] = { unicodeslot=0xF9AF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9AF', specials={'char',0x7F9A} },
	[0xF9B0] = { unicodeslot=0xF9B0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B0', specials={'char',0x8046} },
	[0xF9B1] = { unicodeslot=0xF9B1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B1', specials={'char',0x9234} },
	[0xF9B2] = { unicodeslot=0xF9B2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B2', specials={'char',0x96F6} },
	[0xF9B3] = { unicodeslot=0xF9B3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B3', specials={'char',0x9748} },
	[0xF9B4] = { unicodeslot=0xF9B4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B4', specials={'char',0x9818} },
	[0xF9B5] = { unicodeslot=0xF9B5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B5', specials={'char',0x4F8B} },
	[0xF9B6] = { unicodeslot=0xF9B6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B6', specials={'char',0x79AE} },
	[0xF9B7] = { unicodeslot=0xF9B7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B7', specials={'char',0x91B4} },
	[0xF9B8] = { unicodeslot=0xF9B8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B8', specials={'char',0x96B8} },
	[0xF9B9] = { unicodeslot=0xF9B9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9B9', specials={'char',0x60E1} },
	[0xF9BA] = { unicodeslot=0xF9BA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9BA', specials={'char',0x4E86} },
	[0xF9BB] = { unicodeslot=0xF9BB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9BB', specials={'char',0x50DA} },
	[0xF9BC] = { unicodeslot=0xF9BC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9BC', specials={'char',0x5BEE} },
	[0xF9BD] = { unicodeslot=0xF9BD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9BD', specials={'char',0x5C3F} },
	[0xF9BE] = { unicodeslot=0xF9BE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9BE', specials={'char',0x6599} },
	[0xF9BF] = { unicodeslot=0xF9BF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9BF', specials={'char',0x6A02} },
	[0xF9C0] = { unicodeslot=0xF9C0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C0', specials={'char',0x71CE} },
	[0xF9C1] = { unicodeslot=0xF9C1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C1', specials={'char',0x7642} },
	[0xF9C2] = { unicodeslot=0xF9C2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C2', specials={'char',0x84FC} },
	[0xF9C3] = { unicodeslot=0xF9C3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C3', specials={'char',0x907C} },
	[0xF9C4] = { unicodeslot=0xF9C4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C4', specials={'char',0x9F8D} },
	[0xF9C5] = { unicodeslot=0xF9C5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C5', specials={'char',0x6688} },
	[0xF9C6] = { unicodeslot=0xF9C6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C6', specials={'char',0x962E} },
	[0xF9C7] = { unicodeslot=0xF9C7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C7', specials={'char',0x5289} },
	[0xF9C8] = { unicodeslot=0xF9C8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C8', specials={'char',0x677B} },
	[0xF9C9] = { unicodeslot=0xF9C9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9C9', specials={'char',0x67F3} },
	[0xF9CA] = { unicodeslot=0xF9CA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9CA', specials={'char',0x6D41} },
	[0xF9CB] = { unicodeslot=0xF9CB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9CB', specials={'char',0x6E9C} },
	[0xF9CC] = { unicodeslot=0xF9CC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9CC', specials={'char',0x7409} },
	[0xF9CD] = { unicodeslot=0xF9CD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9CD', specials={'char',0x7559} },
	[0xF9CE] = { unicodeslot=0xF9CE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9CE', specials={'char',0x786B} },
	[0xF9CF] = { unicodeslot=0xF9CF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9CF', specials={'char',0x7D10} },
	[0xF9D0] = { unicodeslot=0xF9D0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D0', specials={'char',0x985E} },
	[0xF9D1] = { unicodeslot=0xF9D1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D1', specials={'char',0x516D} },
	[0xF9D2] = { unicodeslot=0xF9D2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D2', specials={'char',0x622E} },
	[0xF9D3] = { unicodeslot=0xF9D3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D3', specials={'char',0x9678} },
	[0xF9D4] = { unicodeslot=0xF9D4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D4', specials={'char',0x502B} },
	[0xF9D5] = { unicodeslot=0xF9D5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D5', specials={'char',0x5D19} },
	[0xF9D6] = { unicodeslot=0xF9D6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D6', specials={'char',0x6DEA} },
	[0xF9D7] = { unicodeslot=0xF9D7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D7', specials={'char',0x8F2A} },
	[0xF9D8] = { unicodeslot=0xF9D8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D8', specials={'char',0x5F8B} },
	[0xF9D9] = { unicodeslot=0xF9D9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9D9', specials={'char',0x6144} },
	[0xF9DA] = { unicodeslot=0xF9DA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9DA', specials={'char',0x6817} },
	[0xF9DB] = { unicodeslot=0xF9DB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9DB', specials={'char',0x7387} },
	[0xF9DC] = { unicodeslot=0xF9DC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9DC', specials={'char',0x9686} },
	[0xF9DD] = { unicodeslot=0xF9DD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9DD', specials={'char',0x5229} },
	[0xF9DE] = { unicodeslot=0xF9DE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9DE', specials={'char',0x540F} },
	[0xF9DF] = { unicodeslot=0xF9DF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9DF', specials={'char',0x5C65} },
	[0xF9E0] = { unicodeslot=0xF9E0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E0', specials={'char',0x6613} },
	[0xF9E1] = { unicodeslot=0xF9E1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E1', specials={'char',0x674E} },
	[0xF9E2] = { unicodeslot=0xF9E2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E2', specials={'char',0x68A8} },
	[0xF9E3] = { unicodeslot=0xF9E3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E3', specials={'char',0x6CE5} },
	[0xF9E4] = { unicodeslot=0xF9E4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E4', specials={'char',0x7406} },
	[0xF9E5] = { unicodeslot=0xF9E5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E5', specials={'char',0x75E2} },
	[0xF9E6] = { unicodeslot=0xF9E6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E6', specials={'char',0x7F79} },
	[0xF9E7] = { unicodeslot=0xF9E7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E7', specials={'char',0x88CF} },
	[0xF9E8] = { unicodeslot=0xF9E8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E8', specials={'char',0x88E1} },
	[0xF9E9] = { unicodeslot=0xF9E9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9E9', specials={'char',0x91CC} },
	[0xF9EA] = { unicodeslot=0xF9EA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9EA', specials={'char',0x96E2} },
	[0xF9EB] = { unicodeslot=0xF9EB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9EB', specials={'char',0x533F} },
	[0xF9EC] = { unicodeslot=0xF9EC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9EC', specials={'char',0x6EBA} },
	[0xF9ED] = { unicodeslot=0xF9ED, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9ED', specials={'char',0x541D} },
	[0xF9EE] = { unicodeslot=0xF9EE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9EE', specials={'char',0x71D0} },
	[0xF9EF] = { unicodeslot=0xF9EF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9EF', specials={'char',0x7498} },
	[0xF9F0] = { unicodeslot=0xF9F0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F0', specials={'char',0x85FA} },
	[0xF9F1] = { unicodeslot=0xF9F1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F1', specials={'char',0x96A3} },
	[0xF9F2] = { unicodeslot=0xF9F2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F2', specials={'char',0x9C57} },
	[0xF9F3] = { unicodeslot=0xF9F3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F3', specials={'char',0x9E9F} },
	[0xF9F4] = { unicodeslot=0xF9F4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F4', specials={'char',0x6797} },
	[0xF9F5] = { unicodeslot=0xF9F5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F5', specials={'char',0x6DCB} },
	[0xF9F6] = { unicodeslot=0xF9F6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F6', specials={'char',0x81E8} },
	[0xF9F7] = { unicodeslot=0xF9F7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F7', specials={'char',0x7ACB} },
	[0xF9F8] = { unicodeslot=0xF9F8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F8', specials={'char',0x7B20} },
	[0xF9F9] = { unicodeslot=0xF9F9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9F9', specials={'char',0x7C92} },
	[0xF9FA] = { unicodeslot=0xF9FA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9FA', specials={'char',0x72C0} },
	[0xF9FB] = { unicodeslot=0xF9FB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9FB', specials={'char',0x7099} },
	[0xF9FC] = { unicodeslot=0xF9FC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9FC', specials={'char',0x8B58} },
	[0xF9FD] = { unicodeslot=0xF9FD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9FD', specials={'char',0x4EC0} },
	[0xF9FE] = { unicodeslot=0xF9FE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9FE', specials={'char',0x8336} },
	[0xF9FF] = { unicodeslot=0xF9FF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-F9FF', specials={'char',0x523A} },
	[0xFA00] = { unicodeslot=0xFA00, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA00', specials={'char',0x5207} },
	[0xFA01] = { unicodeslot=0xFA01, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA01', specials={'char',0x5EA6} },
	[0xFA02] = { unicodeslot=0xFA02, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA02', specials={'char',0x62D3} },
	[0xFA03] = { unicodeslot=0xFA03, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA03', specials={'char',0x7CD6} },
	[0xFA04] = { unicodeslot=0xFA04, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA04', specials={'char',0x5B85} },
	[0xFA05] = { unicodeslot=0xFA05, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA05', specials={'char',0x6D1E} },
	[0xFA06] = { unicodeslot=0xFA06, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA06', specials={'char',0x66B4} },
	[0xFA07] = { unicodeslot=0xFA07, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA07', specials={'char',0x8F3B} },
	[0xFA08] = { unicodeslot=0xFA08, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA08', specials={'char',0x884C} },
	[0xFA09] = { unicodeslot=0xFA09, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA09', specials={'char',0x964D} },
	[0xFA0A] = { unicodeslot=0xFA0A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA0A', specials={'char',0x898B} },
	[0xFA0B] = { unicodeslot=0xFA0B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA0B', specials={'char',0x5ED3} },
	[0xFA0C] = { unicodeslot=0xFA0C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA0C', specials={'char',0x5140} },
	[0xFA0D] = { unicodeslot=0xFA0D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA0D', specials={'char',0x55C0} },
	[0xFA0E] = { unicodeslot=0xFA0E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA0E' },
	[0xFA0F] = { unicodeslot=0xFA0F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA0F' },
	[0xFA10] = { unicodeslot=0xFA10, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA10', specials={'char',0x585A} },
	[0xFA11] = { unicodeslot=0xFA11, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA11' },
	[0xFA12] = { unicodeslot=0xFA12, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA12', specials={'char',0x6674} },
	[0xFA13] = { unicodeslot=0xFA13, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA13' },
	[0xFA14] = { unicodeslot=0xFA14, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA14' },
	[0xFA15] = { unicodeslot=0xFA15, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA15', specials={'char',0x51DE} },
	[0xFA16] = { unicodeslot=0xFA16, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA16', specials={'char',0x732A} },
	[0xFA17] = { unicodeslot=0xFA17, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA17', specials={'char',0x76CA} },
	[0xFA18] = { unicodeslot=0xFA18, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA18', specials={'char',0x793C} },
	[0xFA19] = { unicodeslot=0xFA19, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA19', specials={'char',0x795E} },
	[0xFA1A] = { unicodeslot=0xFA1A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA1A', specials={'char',0x7965} },
	[0xFA1B] = { unicodeslot=0xFA1B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA1B', specials={'char',0x798F} },
	[0xFA1C] = { unicodeslot=0xFA1C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA1C', specials={'char',0x9756} },
	[0xFA1D] = { unicodeslot=0xFA1D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA1D', specials={'char',0x7CBE} },
	[0xFA1E] = { unicodeslot=0xFA1E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA1E', specials={'char',0x7FBD} },
	[0xFA1F] = { unicodeslot=0xFA1F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA1F' },
	[0xFA20] = { unicodeslot=0xFA20, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA20', specials={'char',0x8612} },
	[0xFA21] = { unicodeslot=0xFA21, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA21' },
	[0xFA22] = { unicodeslot=0xFA22, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA22', specials={'char',0x8AF8} },
	[0xFA23] = { unicodeslot=0xFA23, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA23' },
	[0xFA24] = { unicodeslot=0xFA24, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA24' },
	[0xFA25] = { unicodeslot=0xFA25, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA25', specials={'char',0x9038} },
	[0xFA26] = { unicodeslot=0xFA26, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA26', specials={'char',0x90FD} },
	[0xFA27] = { unicodeslot=0xFA27, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA27' },
	[0xFA28] = { unicodeslot=0xFA28, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA28' },
	[0xFA29] = { unicodeslot=0xFA29, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA29' },
	[0xFA2A] = { unicodeslot=0xFA2A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA2A', specials={'char',0x98EF} },
	[0xFA2B] = { unicodeslot=0xFA2B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA2B', specials={'char',0x98FC} },
	[0xFA2C] = { unicodeslot=0xFA2C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA2C', specials={'char',0x9928} },
	[0xFA2D] = { unicodeslot=0xFA2D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA2D', specials={'char',0x9DB4} },
	[0xFA30] = { unicodeslot=0xFA30, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA30', specials={'char',0x4FAE} },
	[0xFA31] = { unicodeslot=0xFA31, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA31', specials={'char',0x50E7} },
	[0xFA32] = { unicodeslot=0xFA32, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA32', specials={'char',0x514D} },
	[0xFA33] = { unicodeslot=0xFA33, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA33', specials={'char',0x52C9} },
	[0xFA34] = { unicodeslot=0xFA34, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA34', specials={'char',0x52E4} },
	[0xFA35] = { unicodeslot=0xFA35, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA35', specials={'char',0x5351} },
	[0xFA36] = { unicodeslot=0xFA36, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA36', specials={'char',0x559D} },
	[0xFA37] = { unicodeslot=0xFA37, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA37', specials={'char',0x5606} },
	[0xFA38] = { unicodeslot=0xFA38, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA38', specials={'char',0x5668} },
	[0xFA39] = { unicodeslot=0xFA39, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA39', specials={'char',0x5840} },
	[0xFA3A] = { unicodeslot=0xFA3A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA3A', specials={'char',0x58A8} },
	[0xFA3B] = { unicodeslot=0xFA3B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA3B', specials={'char',0x5C64} },
	[0xFA3C] = { unicodeslot=0xFA3C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA3C', specials={'char',0x5C6E} },
	[0xFA3D] = { unicodeslot=0xFA3D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA3D', specials={'char',0x6094} },
	[0xFA3E] = { unicodeslot=0xFA3E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA3E', specials={'char',0x6168} },
	[0xFA3F] = { unicodeslot=0xFA3F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA3F', specials={'char',0x618E} },
	[0xFA40] = { unicodeslot=0xFA40, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA40', specials={'char',0x61F2} },
	[0xFA41] = { unicodeslot=0xFA41, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA41', specials={'char',0x654F} },
	[0xFA42] = { unicodeslot=0xFA42, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA42', specials={'char',0x65E2} },
	[0xFA43] = { unicodeslot=0xFA43, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA43', specials={'char',0x6691} },
	[0xFA44] = { unicodeslot=0xFA44, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA44', specials={'char',0x6885} },
	[0xFA45] = { unicodeslot=0xFA45, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA45', specials={'char',0x6D77} },
	[0xFA46] = { unicodeslot=0xFA46, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA46', specials={'char',0x6E1A} },
	[0xFA47] = { unicodeslot=0xFA47, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA47', specials={'char',0x6F22} },
	[0xFA48] = { unicodeslot=0xFA48, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA48', specials={'char',0x716E} },
	[0xFA49] = { unicodeslot=0xFA49, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA49', specials={'char',0x722B} },
	[0xFA4A] = { unicodeslot=0xFA4A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA4A', specials={'char',0x7422} },
	[0xFA4B] = { unicodeslot=0xFA4B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA4B', specials={'char',0x7891} },
	[0xFA4C] = { unicodeslot=0xFA4C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA4C', specials={'char',0x793E} },
	[0xFA4D] = { unicodeslot=0xFA4D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA4D', specials={'char',0x7949} },
	[0xFA4E] = { unicodeslot=0xFA4E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA4E', specials={'char',0x7948} },
	[0xFA4F] = { unicodeslot=0xFA4F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA4F', specials={'char',0x7950} },
	[0xFA50] = { unicodeslot=0xFA50, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA50', specials={'char',0x7956} },
	[0xFA51] = { unicodeslot=0xFA51, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA51', specials={'char',0x795D} },
	[0xFA52] = { unicodeslot=0xFA52, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA52', specials={'char',0x798D} },
	[0xFA53] = { unicodeslot=0xFA53, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA53', specials={'char',0x798E} },
	[0xFA54] = { unicodeslot=0xFA54, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA54', specials={'char',0x7A40} },
	[0xFA55] = { unicodeslot=0xFA55, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA55', specials={'char',0x7A81} },
	[0xFA56] = { unicodeslot=0xFA56, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA56', specials={'char',0x7BC0} },
	[0xFA57] = { unicodeslot=0xFA57, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA57', specials={'char',0x7DF4} },
	[0xFA58] = { unicodeslot=0xFA58, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA58', specials={'char',0x7E09} },
	[0xFA59] = { unicodeslot=0xFA59, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA59', specials={'char',0x7E41} },
	[0xFA5A] = { unicodeslot=0xFA5A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA5A', specials={'char',0x7F72} },
	[0xFA5B] = { unicodeslot=0xFA5B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA5B', specials={'char',0x8005} },
	[0xFA5C] = { unicodeslot=0xFA5C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA5C', specials={'char',0x81ED} },
	[0xFA5D] = { unicodeslot=0xFA5D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA5D', specials={'char',0x8279} },
	[0xFA5E] = { unicodeslot=0xFA5E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA5E', specials={'char',0x8279} },
	[0xFA5F] = { unicodeslot=0xFA5F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA5F', specials={'char',0x8457} },
	[0xFA60] = { unicodeslot=0xFA60, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA60', specials={'char',0x8910} },
	[0xFA61] = { unicodeslot=0xFA61, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA61', specials={'char',0x8996} },
	[0xFA62] = { unicodeslot=0xFA62, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA62', specials={'char',0x8B01} },
	[0xFA63] = { unicodeslot=0xFA63, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA63', specials={'char',0x8B39} },
	[0xFA64] = { unicodeslot=0xFA64, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA64', specials={'char',0x8CD3} },
	[0xFA65] = { unicodeslot=0xFA65, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA65', specials={'char',0x8D08} },
	[0xFA66] = { unicodeslot=0xFA66, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA66', specials={'char',0x8FB6} },
	[0xFA67] = { unicodeslot=0xFA67, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA67', specials={'char',0x9038} },
	[0xFA68] = { unicodeslot=0xFA68, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA68', specials={'char',0x96E3} },
	[0xFA69] = { unicodeslot=0xFA69, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA69', specials={'char',0x97FF} },
	[0xFA6A] = { unicodeslot=0xFA6A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA6A', specials={'char',0x983B} },
	[0xFA70] = { unicodeslot=0xFA70, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA70', specials={'char',0x4E26} },
	[0xFA71] = { unicodeslot=0xFA71, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA71', specials={'char',0x51B5} },
	[0xFA72] = { unicodeslot=0xFA72, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA72', specials={'char',0x5168} },
	[0xFA73] = { unicodeslot=0xFA73, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA73', specials={'char',0x4F80} },
	[0xFA74] = { unicodeslot=0xFA74, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA74', specials={'char',0x5145} },
	[0xFA75] = { unicodeslot=0xFA75, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA75', specials={'char',0x5180} },
	[0xFA76] = { unicodeslot=0xFA76, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA76', specials={'char',0x52C7} },
	[0xFA77] = { unicodeslot=0xFA77, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA77', specials={'char',0x52FA} },
	[0xFA78] = { unicodeslot=0xFA78, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA78', specials={'char',0x559D} },
	[0xFA79] = { unicodeslot=0xFA79, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA79', specials={'char',0x5555} },
	[0xFA7A] = { unicodeslot=0xFA7A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA7A', specials={'char',0x5599} },
	[0xFA7B] = { unicodeslot=0xFA7B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA7B', specials={'char',0x55E2} },
	[0xFA7C] = { unicodeslot=0xFA7C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA7C', specials={'char',0x585A} },
	[0xFA7D] = { unicodeslot=0xFA7D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA7D', specials={'char',0x58B3} },
	[0xFA7E] = { unicodeslot=0xFA7E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA7E', specials={'char',0x5944} },
	[0xFA7F] = { unicodeslot=0xFA7F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA7F', specials={'char',0x5954} },
	[0xFA80] = { unicodeslot=0xFA80, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA80', specials={'char',0x5A62} },
	[0xFA81] = { unicodeslot=0xFA81, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA81', specials={'char',0x5B28} },
	[0xFA82] = { unicodeslot=0xFA82, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA82', specials={'char',0x5ED2} },
	[0xFA83] = { unicodeslot=0xFA83, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA83', specials={'char',0x5ED9} },
	[0xFA84] = { unicodeslot=0xFA84, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA84', specials={'char',0x5F69} },
	[0xFA85] = { unicodeslot=0xFA85, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA85', specials={'char',0x5FAD} },
	[0xFA86] = { unicodeslot=0xFA86, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA86', specials={'char',0x60D8} },
	[0xFA87] = { unicodeslot=0xFA87, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA87', specials={'char',0x614E} },
	[0xFA88] = { unicodeslot=0xFA88, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA88', specials={'char',0x6108} },
	[0xFA89] = { unicodeslot=0xFA89, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA89', specials={'char',0x618E} },
	[0xFA8A] = { unicodeslot=0xFA8A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA8A', specials={'char',0x6160} },
	[0xFA8B] = { unicodeslot=0xFA8B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA8B', specials={'char',0x61F2} },
	[0xFA8C] = { unicodeslot=0xFA8C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA8C', specials={'char',0x6234} },
	[0xFA8D] = { unicodeslot=0xFA8D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA8D', specials={'char',0x63C4} },
	[0xFA8E] = { unicodeslot=0xFA8E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA8E', specials={'char',0x641C} },
	[0xFA8F] = { unicodeslot=0xFA8F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA8F', specials={'char',0x6452} },
	[0xFA90] = { unicodeslot=0xFA90, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA90', specials={'char',0x6556} },
	[0xFA91] = { unicodeslot=0xFA91, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA91', specials={'char',0x6674} },
	[0xFA92] = { unicodeslot=0xFA92, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA92', specials={'char',0x6717} },
	[0xFA93] = { unicodeslot=0xFA93, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA93', specials={'char',0x671B} },
	[0xFA94] = { unicodeslot=0xFA94, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA94', specials={'char',0x6756} },
	[0xFA95] = { unicodeslot=0xFA95, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA95', specials={'char',0x6B79} },
	[0xFA96] = { unicodeslot=0xFA96, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA96', specials={'char',0x6BBA} },
	[0xFA97] = { unicodeslot=0xFA97, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA97', specials={'char',0x6D41} },
	[0xFA98] = { unicodeslot=0xFA98, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA98', specials={'char',0x6EDB} },
	[0xFA99] = { unicodeslot=0xFA99, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA99', specials={'char',0x6ECB} },
	[0xFA9A] = { unicodeslot=0xFA9A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA9A', specials={'char',0x6F22} },
	[0xFA9B] = { unicodeslot=0xFA9B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA9B', specials={'char',0x701E} },
	[0xFA9C] = { unicodeslot=0xFA9C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA9C', specials={'char',0x716E} },
	[0xFA9D] = { unicodeslot=0xFA9D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA9D', specials={'char',0x77A7} },
	[0xFA9E] = { unicodeslot=0xFA9E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA9E', specials={'char',0x7235} },
	[0xFA9F] = { unicodeslot=0xFA9F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FA9F', specials={'char',0x72AF} },
	[0xFAA0] = { unicodeslot=0xFAA0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA0', specials={'char',0x732A} },
	[0xFAA1] = { unicodeslot=0xFAA1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA1', specials={'char',0x7471} },
	[0xFAA2] = { unicodeslot=0xFAA2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA2', specials={'char',0x7506} },
	[0xFAA3] = { unicodeslot=0xFAA3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA3', specials={'char',0x753B} },
	[0xFAA4] = { unicodeslot=0xFAA4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA4', specials={'char',0x761D} },
	[0xFAA5] = { unicodeslot=0xFAA5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA5', specials={'char',0x761F} },
	[0xFAA6] = { unicodeslot=0xFAA6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA6', specials={'char',0x76CA} },
	[0xFAA7] = { unicodeslot=0xFAA7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA7', specials={'char',0x76DB} },
	[0xFAA8] = { unicodeslot=0xFAA8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA8', specials={'char',0x76F4} },
	[0xFAA9] = { unicodeslot=0xFAA9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAA9', specials={'char',0x774A} },
	[0xFAAA] = { unicodeslot=0xFAAA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAAA', specials={'char',0x7740} },
	[0xFAAB] = { unicodeslot=0xFAAB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAAB', specials={'char',0x78CC} },
	[0xFAAC] = { unicodeslot=0xFAAC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAAC', specials={'char',0x7AB1} },
	[0xFAAD] = { unicodeslot=0xFAAD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAAD', specials={'char',0x7BC0} },
	[0xFAAE] = { unicodeslot=0xFAAE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAAE', specials={'char',0x7C7B} },
	[0xFAAF] = { unicodeslot=0xFAAF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAAF', specials={'char',0x7D5B} },
	[0xFAB0] = { unicodeslot=0xFAB0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB0', specials={'char',0x7DF4} },
	[0xFAB1] = { unicodeslot=0xFAB1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB1', specials={'char',0x7F3E} },
	[0xFAB2] = { unicodeslot=0xFAB2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB2', specials={'char',0x8005} },
	[0xFAB3] = { unicodeslot=0xFAB3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB3', specials={'char',0x8352} },
	[0xFAB4] = { unicodeslot=0xFAB4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB4', specials={'char',0x83EF} },
	[0xFAB5] = { unicodeslot=0xFAB5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB5', specials={'char',0x8779} },
	[0xFAB6] = { unicodeslot=0xFAB6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB6', specials={'char',0x8941} },
	[0xFAB7] = { unicodeslot=0xFAB7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB7', specials={'char',0x8986} },
	[0xFAB8] = { unicodeslot=0xFAB8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB8', specials={'char',0x8996} },
	[0xFAB9] = { unicodeslot=0xFAB9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAB9', specials={'char',0x8ABF} },
	[0xFABA] = { unicodeslot=0xFABA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FABA', specials={'char',0x8AF8} },
	[0xFABB] = { unicodeslot=0xFABB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FABB', specials={'char',0x8ACB} },
	[0xFABC] = { unicodeslot=0xFABC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FABC', specials={'char',0x8B01} },
	[0xFABD] = { unicodeslot=0xFABD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FABD', specials={'char',0x8AFE} },
	[0xFABE] = { unicodeslot=0xFABE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FABE', specials={'char',0x8AED} },
	[0xFABF] = { unicodeslot=0xFABF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FABF', specials={'char',0x8B39} },
	[0xFAC0] = { unicodeslot=0xFAC0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC0', specials={'char',0x8B8A} },
	[0xFAC1] = { unicodeslot=0xFAC1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC1', specials={'char',0x8D08} },
	[0xFAC2] = { unicodeslot=0xFAC2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC2', specials={'char',0x8F38} },
	[0xFAC3] = { unicodeslot=0xFAC3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC3', specials={'char',0x9072} },
	[0xFAC4] = { unicodeslot=0xFAC4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC4', specials={'char',0x9199} },
	[0xFAC5] = { unicodeslot=0xFAC5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC5', specials={'char',0x9276} },
	[0xFAC6] = { unicodeslot=0xFAC6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC6', specials={'char',0x967C} },
	[0xFAC7] = { unicodeslot=0xFAC7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC7', specials={'char',0x96E3} },
	[0xFAC8] = { unicodeslot=0xFAC8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC8', specials={'char',0x9756} },
	[0xFAC9] = { unicodeslot=0xFAC9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAC9', specials={'char',0x97DB} },
	[0xFACA] = { unicodeslot=0xFACA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FACA', specials={'char',0x97FF} },
	[0xFACB] = { unicodeslot=0xFACB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FACB', specials={'char',0x980B} },
	[0xFACC] = { unicodeslot=0xFACC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FACC', specials={'char',0x983B} },
	[0xFACD] = { unicodeslot=0xFACD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FACD', specials={'char',0x9B12} },
	[0xFACE] = { unicodeslot=0xFACE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FACE', specials={'char',0x9F9C} },
	[0xFACF] = { unicodeslot=0xFACF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FACF', specials={'char',0x2284A} },
	[0xFAD0] = { unicodeslot=0xFAD0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD0', specials={'char',0x22844} },
	[0xFAD1] = { unicodeslot=0xFAD1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD1', specials={'char',0x233D5} },
	[0xFAD2] = { unicodeslot=0xFAD2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD2', specials={'char',0x3B9D} },
	[0xFAD3] = { unicodeslot=0xFAD3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD3', specials={'char',0x4018} },
	[0xFAD4] = { unicodeslot=0xFAD4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD4', specials={'char',0x4039} },
	[0xFAD5] = { unicodeslot=0xFAD5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD5', specials={'char',0x25249} },
	[0xFAD6] = { unicodeslot=0xFAD6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD6', specials={'char',0x25CD0} },
	[0xFAD7] = { unicodeslot=0xFAD7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD7', specials={'char',0x27ED3} },
	[0xFAD8] = { unicodeslot=0xFAD8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD8', specials={'char',0x9F43} },
	[0xFAD9] = { unicodeslot=0xFAD9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-FAD9', specials={'char',0x9F8E} },
	[0xFB00] = { unicodeslot=0xFB00, category='ll', contextname='ffligature', description='LATIN SMALL LIGATURE FF', specials={'compat',0x0066,0x0066} },
	[0xFB01] = { unicodeslot=0xFB01, category='ll', contextname='filigature', description='LATIN SMALL LIGATURE FI', specials={'compat',0x0066,0x0069} },
	[0xFB02] = { unicodeslot=0xFB02, category='ll', contextname='flligature', description='LATIN SMALL LIGATURE FL', specials={'compat',0x0066,0x006C} },
	[0xFB03] = { unicodeslot=0xFB03, category='ll', contextname='ffiligature', description='LATIN SMALL LIGATURE FFI', specials={'compat',0x0066,0x0066,0x0069} },
	[0xFB04] = { unicodeslot=0xFB04, category='ll', contextname='fflligature', description='LATIN SMALL LIGATURE FFL', specials={'compat',0x0066,0x0066,0x006C} },
	[0xFB05] = { unicodeslot=0xFB05, category='ll', description='LATIN SMALL LIGATURE LONG S T', specials={'compat',0x017F,0x0074} },
	[0xFB06] = { unicodeslot=0xFB06, category='ll', contextname='stligature', description='LATIN SMALL LIGATURE ST', specials={'compat',0x0073,0x0074} },
	[0xFB13] = { unicodeslot=0xFB13, category='ll', description='ARMENIAN SMALL LIGATURE MEN NOW', specials={'compat',0x0574,0x0576} },
	[0xFB14] = { unicodeslot=0xFB14, category='ll', description='ARMENIAN SMALL LIGATURE MEN ECH', specials={'compat',0x0574,0x0565} },
	[0xFB15] = { unicodeslot=0xFB15, category='ll', description='ARMENIAN SMALL LIGATURE MEN INI', specials={'compat',0x0574,0x056B} },
	[0xFB16] = { unicodeslot=0xFB16, category='ll', description='ARMENIAN SMALL LIGATURE VEW NOW', specials={'compat',0x057E,0x0576} },
	[0xFB17] = { unicodeslot=0xFB17, category='ll', description='ARMENIAN SMALL LIGATURE MEN XEH', specials={'compat',0x0574,0x056D} },
	[0xFB1D] = { unicodeslot=0xFB1D, category='lo', description='HEBREW LETTER YOD WITH HIRIQ', shcode=0x05D9, specials={'char',0x05D9,0x05B4} },
	[0xFB1E] = { unicodeslot=0xFB1E, category='mn', description='HEBREW POINT JUDEO-SPANISH VARIKA' },
	[0xFB1F] = { unicodeslot=0xFB1F, category='lo', description='HEBREW LIGATURE YIDDISH YOD YOD PATAH', specials={'char',0x05F2,0x05B7} },
	[0xFB20] = { unicodeslot=0xFB20, category='lo', description='HEBREW LETTER ALTERNATIVE AYIN', specials={'font',0x05E2} },
	[0xFB21] = { unicodeslot=0xFB21, category='lo', description='HEBREW LETTER WIDE ALEF', specials={'font',0x05D0} },
	[0xFB22] = { unicodeslot=0xFB22, category='lo', description='HEBREW LETTER WIDE DALET', specials={'font',0x05D3} },
	[0xFB23] = { unicodeslot=0xFB23, category='lo', description='HEBREW LETTER WIDE HE', specials={'font',0x05D4} },
	[0xFB24] = { unicodeslot=0xFB24, category='lo', description='HEBREW LETTER WIDE KAF', specials={'font',0x05DB} },
	[0xFB25] = { unicodeslot=0xFB25, category='lo', description='HEBREW LETTER WIDE LAMED', specials={'font',0x05DC} },
	[0xFB26] = { unicodeslot=0xFB26, category='lo', description='HEBREW LETTER WIDE FINAL MEM', specials={'font',0x05DD} },
	[0xFB27] = { unicodeslot=0xFB27, category='lo', description='HEBREW LETTER WIDE RESH', specials={'font',0x05E8} },
	[0xFB28] = { unicodeslot=0xFB28, category='lo', description='HEBREW LETTER WIDE TAV', specials={'font',0x05EA} },
	[0xFB29] = { unicodeslot=0xFB29, category='sm', description='HEBREW LETTER ALTERNATIVE PLUS SIGN', specials={'font',0x002B} },
	[0xFB2A] = { unicodeslot=0xFB2A, category='lo', description='HEBREW LETTER SHIN WITH SHIN DOT', shcode=0x05E9, specials={'char',0x05E9,0x05C1} },
	[0xFB2B] = { unicodeslot=0xFB2B, category='lo', description='HEBREW LETTER SHIN WITH SIN DOT', shcode=0x05E9, specials={'char',0x05E9,0x05C2} },
	[0xFB2C] = { unicodeslot=0xFB2C, category='lo', description='HEBREW LETTER SHIN WITH DAGESH AND SHIN DOT', shcode=0x05E9, specials={'char',0xFB49,0x05C1} },
	[0xFB2D] = { unicodeslot=0xFB2D, category='lo', description='HEBREW LETTER SHIN WITH DAGESH AND SIN DOT', shcode=0x05E9, specials={'char',0xFB49,0x05C2} },
	[0xFB2E] = { unicodeslot=0xFB2E, category='lo', description='HEBREW LETTER ALEF WITH PATAH', shcode=0x05D0, specials={'char',0x05D0,0x05B7} },
	[0xFB2F] = { unicodeslot=0xFB2F, category='lo', description='HEBREW LETTER ALEF WITH QAMATS', shcode=0x05D0, specials={'char',0x05D0,0x05B8} },
	[0xFB30] = { unicodeslot=0xFB30, category='lo', description='HEBREW LETTER ALEF WITH MAPIQ', shcode=0x05D0, specials={'char',0x05D0,0x05BC} },
	[0xFB31] = { unicodeslot=0xFB31, category='lo', description='HEBREW LETTER BET WITH DAGESH', shcode=0x05D1, specials={'char',0x05D1,0x05BC} },
	[0xFB32] = { unicodeslot=0xFB32, category='lo', description='HEBREW LETTER GIMEL WITH DAGESH', shcode=0x05D2, specials={'char',0x05D2,0x05BC} },
	[0xFB33] = { unicodeslot=0xFB33, category='lo', description='HEBREW LETTER DALET WITH DAGESH', shcode=0x05D3, specials={'char',0x05D3,0x05BC} },
	[0xFB34] = { unicodeslot=0xFB34, category='lo', description='HEBREW LETTER HE WITH MAPIQ', shcode=0x05D4, specials={'char',0x05D4,0x05BC} },
	[0xFB35] = { unicodeslot=0xFB35, category='lo', description='HEBREW LETTER VAV WITH DAGESH', shcode=0x05D5, specials={'char',0x05D5,0x05BC} },
	[0xFB36] = { unicodeslot=0xFB36, category='lo', description='HEBREW LETTER ZAYIN WITH DAGESH', shcode=0x05D6, specials={'char',0x05D6,0x05BC} },
	[0xFB38] = { unicodeslot=0xFB38, category='lo', description='HEBREW LETTER TET WITH DAGESH', shcode=0x05D8, specials={'char',0x05D8,0x05BC} },
	[0xFB39] = { unicodeslot=0xFB39, category='lo', description='HEBREW LETTER YOD WITH DAGESH', shcode=0x05D9, specials={'char',0x05D9,0x05BC} },
	[0xFB3A] = { unicodeslot=0xFB3A, category='lo', description='HEBREW LETTER FINAL KAF WITH DAGESH', specials={'char',0x05DA,0x05BC} },
	[0xFB3B] = { unicodeslot=0xFB3B, category='lo', description='HEBREW LETTER KAF WITH DAGESH', shcode=0x05DB, specials={'char',0x05DB,0x05BC} },
	[0xFB3C] = { unicodeslot=0xFB3C, category='lo', description='HEBREW LETTER LAMED WITH DAGESH', shcode=0x05DC, specials={'char',0x05DC,0x05BC} },
	[0xFB3E] = { unicodeslot=0xFB3E, category='lo', description='HEBREW LETTER MEM WITH DAGESH', shcode=0x05DE, specials={'char',0x05DE,0x05BC} },
	[0xFB40] = { unicodeslot=0xFB40, category='lo', description='HEBREW LETTER NUN WITH DAGESH', shcode=0x05E0, specials={'char',0x05E0,0x05BC} },
	[0xFB41] = { unicodeslot=0xFB41, category='lo', description='HEBREW LETTER SAMEKH WITH DAGESH', shcode=0x05E1, specials={'char',0x05E1,0x05BC} },
	[0xFB43] = { unicodeslot=0xFB43, category='lo', description='HEBREW LETTER FINAL PE WITH DAGESH', specials={'char',0x05E3,0x05BC} },
	[0xFB44] = { unicodeslot=0xFB44, category='lo', description='HEBREW LETTER PE WITH DAGESH', shcode=0x05E4, specials={'char',0x05E4,0x05BC} },
	[0xFB46] = { unicodeslot=0xFB46, category='lo', description='HEBREW LETTER TSADI WITH DAGESH', shcode=0x05E6, specials={'char',0x05E6,0x05BC} },
	[0xFB47] = { unicodeslot=0xFB47, category='lo', description='HEBREW LETTER QOF WITH DAGESH', shcode=0x05E7, specials={'char',0x05E7,0x05BC} },
	[0xFB48] = { unicodeslot=0xFB48, category='lo', description='HEBREW LETTER RESH WITH DAGESH', shcode=0x05E8, specials={'char',0x05E8,0x05BC} },
	[0xFB49] = { unicodeslot=0xFB49, category='lo', description='HEBREW LETTER SHIN WITH DAGESH', shcode=0x05E9, specials={'char',0x05E9,0x05BC} },
	[0xFB4A] = { unicodeslot=0xFB4A, category='lo', description='HEBREW LETTER TAV WITH DAGESH', shcode=0x05EA, specials={'char',0x05EA,0x05BC} },
	[0xFB4B] = { unicodeslot=0xFB4B, category='lo', description='HEBREW LETTER VAV WITH HOLAM', shcode=0x05D5, specials={'char',0x05D5,0x05B9} },
	[0xFB4C] = { unicodeslot=0xFB4C, category='lo', description='HEBREW LETTER BET WITH RAFE', shcode=0x05D1, specials={'char',0x05D1,0x05BF} },
	[0xFB4D] = { unicodeslot=0xFB4D, category='lo', description='HEBREW LETTER KAF WITH RAFE', shcode=0x05DB, specials={'char',0x05DB,0x05BF} },
	[0xFB4E] = { unicodeslot=0xFB4E, category='lo', description='HEBREW LETTER PE WITH RAFE', shcode=0x05E4, specials={'char',0x05E4,0x05BF} },
	[0xFB4F] = { unicodeslot=0xFB4F, category='lo', description='HEBREW LIGATURE ALEF LAMED', specials={'compat',0x05D0,0x05DC} },
	[0xFB50] = { unicodeslot=0xFB50, category='lo', description='ARABIC LETTER ALEF WASLA ISOLATED FORM', specials={'isolated',0x0671} },
	[0xFB51] = { unicodeslot=0xFB51, category='lo', description='ARABIC LETTER ALEF WASLA FINAL FORM', specials={'final',0x0671} },
	[0xFB52] = { unicodeslot=0xFB52, category='lo', description='ARABIC LETTER BEEH ISOLATED FORM', specials={'isolated',0x067B} },
	[0xFB53] = { unicodeslot=0xFB53, category='lo', description='ARABIC LETTER BEEH FINAL FORM', specials={'final',0x067B} },
	[0xFB54] = { unicodeslot=0xFB54, category='lo', description='ARABIC LETTER BEEH INITIAL FORM', specials={'initial',0x067B} },
	[0xFB55] = { unicodeslot=0xFB55, category='lo', description='ARABIC LETTER BEEH MEDIAL FORM', specials={'medial',0x067B} },
	[0xFB56] = { unicodeslot=0xFB56, category='lo', description='ARABIC LETTER PEH ISOLATED FORM', specials={'isolated',0x067E} },
	[0xFB57] = { unicodeslot=0xFB57, category='lo', description='ARABIC LETTER PEH FINAL FORM', specials={'final',0x067E} },
	[0xFB58] = { unicodeslot=0xFB58, category='lo', description='ARABIC LETTER PEH INITIAL FORM', specials={'initial',0x067E} },
	[0xFB59] = { unicodeslot=0xFB59, category='lo', description='ARABIC LETTER PEH MEDIAL FORM', specials={'medial',0x067E} },
	[0xFB5A] = { unicodeslot=0xFB5A, category='lo', description='ARABIC LETTER BEHEH ISOLATED FORM', specials={'isolated',0x0680} },
	[0xFB5B] = { unicodeslot=0xFB5B, category='lo', description='ARABIC LETTER BEHEH FINAL FORM', specials={'final',0x0680} },
	[0xFB5C] = { unicodeslot=0xFB5C, category='lo', description='ARABIC LETTER BEHEH INITIAL FORM', specials={'initial',0x0680} },
	[0xFB5D] = { unicodeslot=0xFB5D, category='lo', description='ARABIC LETTER BEHEH MEDIAL FORM', specials={'medial',0x0680} },
	[0xFB5E] = { unicodeslot=0xFB5E, category='lo', description='ARABIC LETTER TTEHEH ISOLATED FORM', specials={'isolated',0x067A} },
	[0xFB5F] = { unicodeslot=0xFB5F, category='lo', description='ARABIC LETTER TTEHEH FINAL FORM', specials={'final',0x067A} },
	[0xFB60] = { unicodeslot=0xFB60, category='lo', description='ARABIC LETTER TTEHEH INITIAL FORM', specials={'initial',0x067A} },
	[0xFB61] = { unicodeslot=0xFB61, category='lo', description='ARABIC LETTER TTEHEH MEDIAL FORM', specials={'medial',0x067A} },
	[0xFB62] = { unicodeslot=0xFB62, category='lo', description='ARABIC LETTER TEHEH ISOLATED FORM', specials={'isolated',0x067F} },
	[0xFB63] = { unicodeslot=0xFB63, category='lo', description='ARABIC LETTER TEHEH FINAL FORM', specials={'final',0x067F} },
	[0xFB64] = { unicodeslot=0xFB64, category='lo', description='ARABIC LETTER TEHEH INITIAL FORM', specials={'initial',0x067F} },
	[0xFB65] = { unicodeslot=0xFB65, category='lo', description='ARABIC LETTER TEHEH MEDIAL FORM', specials={'medial',0x067F} },
	[0xFB66] = { unicodeslot=0xFB66, category='lo', description='ARABIC LETTER TTEH ISOLATED FORM', specials={'isolated',0x0679} },
	[0xFB67] = { unicodeslot=0xFB67, category='lo', description='ARABIC LETTER TTEH FINAL FORM', specials={'final',0x0679} },
	[0xFB68] = { unicodeslot=0xFB68, category='lo', description='ARABIC LETTER TTEH INITIAL FORM', specials={'initial',0x0679} },
	[0xFB69] = { unicodeslot=0xFB69, category='lo', description='ARABIC LETTER TTEH MEDIAL FORM', specials={'medial',0x0679} },
	[0xFB6A] = { unicodeslot=0xFB6A, category='lo', description='ARABIC LETTER VEH ISOLATED FORM', specials={'isolated',0x06A4} },
	[0xFB6B] = { unicodeslot=0xFB6B, category='lo', description='ARABIC LETTER VEH FINAL FORM', specials={'final',0x06A4} },
	[0xFB6C] = { unicodeslot=0xFB6C, category='lo', description='ARABIC LETTER VEH INITIAL FORM', specials={'initial',0x06A4} },
	[0xFB6D] = { unicodeslot=0xFB6D, category='lo', description='ARABIC LETTER VEH MEDIAL FORM', specials={'medial',0x06A4} },
	[0xFB6E] = { unicodeslot=0xFB6E, category='lo', description='ARABIC LETTER PEHEH ISOLATED FORM', specials={'isolated',0x06A6} },
	[0xFB6F] = { unicodeslot=0xFB6F, category='lo', description='ARABIC LETTER PEHEH FINAL FORM', specials={'final',0x06A6} },
	[0xFB70] = { unicodeslot=0xFB70, category='lo', description='ARABIC LETTER PEHEH INITIAL FORM', specials={'initial',0x06A6} },
	[0xFB71] = { unicodeslot=0xFB71, category='lo', description='ARABIC LETTER PEHEH MEDIAL FORM', specials={'medial',0x06A6} },
	[0xFB72] = { unicodeslot=0xFB72, category='lo', description='ARABIC LETTER DYEH ISOLATED FORM', specials={'isolated',0x0684} },
	[0xFB73] = { unicodeslot=0xFB73, category='lo', description='ARABIC LETTER DYEH FINAL FORM', specials={'final',0x0684} },
	[0xFB74] = { unicodeslot=0xFB74, category='lo', description='ARABIC LETTER DYEH INITIAL FORM', specials={'initial',0x0684} },
	[0xFB75] = { unicodeslot=0xFB75, category='lo', description='ARABIC LETTER DYEH MEDIAL FORM', specials={'medial',0x0684} },
	[0xFB76] = { unicodeslot=0xFB76, category='lo', description='ARABIC LETTER NYEH ISOLATED FORM', specials={'isolated',0x0683} },
	[0xFB77] = { unicodeslot=0xFB77, category='lo', description='ARABIC LETTER NYEH FINAL FORM', specials={'final',0x0683} },
	[0xFB78] = { unicodeslot=0xFB78, category='lo', description='ARABIC LETTER NYEH INITIAL FORM', specials={'initial',0x0683} },
	[0xFB79] = { unicodeslot=0xFB79, category='lo', description='ARABIC LETTER NYEH MEDIAL FORM', specials={'medial',0x0683} },
	[0xFB7A] = { unicodeslot=0xFB7A, category='lo', description='ARABIC LETTER TCHEH ISOLATED FORM', specials={'isolated',0x0686} },
	[0xFB7B] = { unicodeslot=0xFB7B, category='lo', description='ARABIC LETTER TCHEH FINAL FORM', specials={'final',0x0686} },
	[0xFB7C] = { unicodeslot=0xFB7C, category='lo', description='ARABIC LETTER TCHEH INITIAL FORM', specials={'initial',0x0686} },
	[0xFB7D] = { unicodeslot=0xFB7D, category='lo', description='ARABIC LETTER TCHEH MEDIAL FORM', specials={'medial',0x0686} },
	[0xFB7E] = { unicodeslot=0xFB7E, category='lo', description='ARABIC LETTER TCHEHEH ISOLATED FORM', specials={'isolated',0x0687} },
	[0xFB7F] = { unicodeslot=0xFB7F, category='lo', description='ARABIC LETTER TCHEHEH FINAL FORM', specials={'final',0x0687} },
	[0xFB80] = { unicodeslot=0xFB80, category='lo', description='ARABIC LETTER TCHEHEH INITIAL FORM', specials={'initial',0x0687} },
	[0xFB81] = { unicodeslot=0xFB81, category='lo', description='ARABIC LETTER TCHEHEH MEDIAL FORM', specials={'medial',0x0687} },
	[0xFB82] = { unicodeslot=0xFB82, category='lo', description='ARABIC LETTER DDAHAL ISOLATED FORM', specials={'isolated',0x068D} },
	[0xFB83] = { unicodeslot=0xFB83, category='lo', description='ARABIC LETTER DDAHAL FINAL FORM', specials={'final',0x068D} },
	[0xFB84] = { unicodeslot=0xFB84, category='lo', description='ARABIC LETTER DAHAL ISOLATED FORM', specials={'isolated',0x068C} },
	[0xFB85] = { unicodeslot=0xFB85, category='lo', description='ARABIC LETTER DAHAL FINAL FORM', specials={'final',0x068C} },
	[0xFB86] = { unicodeslot=0xFB86, category='lo', description='ARABIC LETTER DUL ISOLATED FORM', specials={'isolated',0x068E} },
	[0xFB87] = { unicodeslot=0xFB87, category='lo', description='ARABIC LETTER DUL FINAL FORM', specials={'final',0x068E} },
	[0xFB88] = { unicodeslot=0xFB88, category='lo', description='ARABIC LETTER DDAL ISOLATED FORM', specials={'isolated',0x0688} },
	[0xFB89] = { unicodeslot=0xFB89, category='lo', description='ARABIC LETTER DDAL FINAL FORM', specials={'final',0x0688} },
	[0xFB8A] = { unicodeslot=0xFB8A, category='lo', description='ARABIC LETTER JEH ISOLATED FORM', specials={'isolated',0x0698} },
	[0xFB8B] = { unicodeslot=0xFB8B, category='lo', description='ARABIC LETTER JEH FINAL FORM', specials={'final',0x0698} },
	[0xFB8C] = { unicodeslot=0xFB8C, category='lo', description='ARABIC LETTER RREH ISOLATED FORM', specials={'isolated',0x0691} },
	[0xFB8D] = { unicodeslot=0xFB8D, category='lo', description='ARABIC LETTER RREH FINAL FORM', specials={'final',0x0691} },
	[0xFB8E] = { unicodeslot=0xFB8E, category='lo', description='ARABIC LETTER KEHEH ISOLATED FORM', specials={'isolated',0x06A9} },
	[0xFB8F] = { unicodeslot=0xFB8F, category='lo', description='ARABIC LETTER KEHEH FINAL FORM', specials={'final',0x06A9} },
	[0xFB90] = { unicodeslot=0xFB90, category='lo', description='ARABIC LETTER KEHEH INITIAL FORM', specials={'initial',0x06A9} },
	[0xFB91] = { unicodeslot=0xFB91, category='lo', description='ARABIC LETTER KEHEH MEDIAL FORM', specials={'medial',0x06A9} },
	[0xFB92] = { unicodeslot=0xFB92, category='lo', description='ARABIC LETTER GAF ISOLATED FORM', specials={'isolated',0x06AF} },
	[0xFB93] = { unicodeslot=0xFB93, category='lo', description='ARABIC LETTER GAF FINAL FORM', specials={'final',0x06AF} },
	[0xFB94] = { unicodeslot=0xFB94, category='lo', description='ARABIC LETTER GAF INITIAL FORM', specials={'initial',0x06AF} },
	[0xFB95] = { unicodeslot=0xFB95, category='lo', description='ARABIC LETTER GAF MEDIAL FORM', specials={'medial',0x06AF} },
	[0xFB96] = { unicodeslot=0xFB96, category='lo', description='ARABIC LETTER GUEH ISOLATED FORM', specials={'isolated',0x06B3} },
	[0xFB97] = { unicodeslot=0xFB97, category='lo', description='ARABIC LETTER GUEH FINAL FORM', specials={'final',0x06B3} },
	[0xFB98] = { unicodeslot=0xFB98, category='lo', description='ARABIC LETTER GUEH INITIAL FORM', specials={'initial',0x06B3} },
	[0xFB99] = { unicodeslot=0xFB99, category='lo', description='ARABIC LETTER GUEH MEDIAL FORM', specials={'medial',0x06B3} },
	[0xFB9A] = { unicodeslot=0xFB9A, category='lo', description='ARABIC LETTER NGOEH ISOLATED FORM', specials={'isolated',0x06B1} },
	[0xFB9B] = { unicodeslot=0xFB9B, category='lo', description='ARABIC LETTER NGOEH FINAL FORM', specials={'final',0x06B1} },
	[0xFB9C] = { unicodeslot=0xFB9C, category='lo', description='ARABIC LETTER NGOEH INITIAL FORM', specials={'initial',0x06B1} },
	[0xFB9D] = { unicodeslot=0xFB9D, category='lo', description='ARABIC LETTER NGOEH MEDIAL FORM', specials={'medial',0x06B1} },
	[0xFB9E] = { unicodeslot=0xFB9E, category='lo', description='ARABIC LETTER NOON GHUNNA ISOLATED FORM', specials={'isolated',0x06BA} },
	[0xFB9F] = { unicodeslot=0xFB9F, category='lo', description='ARABIC LETTER NOON GHUNNA FINAL FORM', specials={'final',0x06BA} },
	[0xFBA0] = { unicodeslot=0xFBA0, category='lo', description='ARABIC LETTER RNOON ISOLATED FORM', specials={'isolated',0x06BB} },
	[0xFBA1] = { unicodeslot=0xFBA1, category='lo', description='ARABIC LETTER RNOON FINAL FORM', specials={'final',0x06BB} },
	[0xFBA2] = { unicodeslot=0xFBA2, category='lo', description='ARABIC LETTER RNOON INITIAL FORM', specials={'initial',0x06BB} },
	[0xFBA3] = { unicodeslot=0xFBA3, category='lo', description='ARABIC LETTER RNOON MEDIAL FORM', specials={'medial',0x06BB} },
	[0xFBA4] = { unicodeslot=0xFBA4, category='lo', description='ARABIC LETTER HEH WITH YEH ABOVE ISOLATED FORM', shcode=0x0647, specials={'isolated',0x06C0} },
	[0xFBA5] = { unicodeslot=0xFBA5, category='lo', description='ARABIC LETTER HEH WITH YEH ABOVE FINAL FORM', shcode=0x0647, specials={'final',0x06C0} },
	[0xFBA6] = { unicodeslot=0xFBA6, category='lo', description='ARABIC LETTER HEH GOAL ISOLATED FORM', specials={'isolated',0x06C1} },
	[0xFBA7] = { unicodeslot=0xFBA7, category='lo', description='ARABIC LETTER HEH GOAL FINAL FORM', specials={'final',0x06C1} },
	[0xFBA8] = { unicodeslot=0xFBA8, category='lo', description='ARABIC LETTER HEH GOAL INITIAL FORM', specials={'initial',0x06C1} },
	[0xFBA9] = { unicodeslot=0xFBA9, category='lo', description='ARABIC LETTER HEH GOAL MEDIAL FORM', specials={'medial',0x06C1} },
	[0xFBAA] = { unicodeslot=0xFBAA, category='lo', description='ARABIC LETTER HEH DOACHASHMEE ISOLATED FORM', specials={'isolated',0x06BE} },
	[0xFBAB] = { unicodeslot=0xFBAB, category='lo', description='ARABIC LETTER HEH DOACHASHMEE FINAL FORM', specials={'final',0x06BE} },
	[0xFBAC] = { unicodeslot=0xFBAC, category='lo', description='ARABIC LETTER HEH DOACHASHMEE INITIAL FORM', specials={'initial',0x06BE} },
	[0xFBAD] = { unicodeslot=0xFBAD, category='lo', description='ARABIC LETTER HEH DOACHASHMEE MEDIAL FORM', specials={'medial',0x06BE} },
	[0xFBAE] = { unicodeslot=0xFBAE, category='lo', description='ARABIC LETTER YEH BARREE ISOLATED FORM', specials={'isolated',0x06D2} },
	[0xFBAF] = { unicodeslot=0xFBAF, category='lo', description='ARABIC LETTER YEH BARREE FINAL FORM', specials={'final',0x06D2} },
	[0xFBB0] = { unicodeslot=0xFBB0, category='lo', description='ARABIC LETTER YEH BARREE WITH HAMZA ABOVE ISOLATED FORM', specials={'isolated',0x06D3} },
	[0xFBB1] = { unicodeslot=0xFBB1, category='lo', description='ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM', specials={'final',0x06D3} },
	[0xFBD3] = { unicodeslot=0xFBD3, category='lo', description='ARABIC LETTER NG ISOLATED FORM', specials={'isolated',0x06AD} },
	[0xFBD4] = { unicodeslot=0xFBD4, category='lo', description='ARABIC LETTER NG FINAL FORM', specials={'final',0x06AD} },
	[0xFBD5] = { unicodeslot=0xFBD5, category='lo', description='ARABIC LETTER NG INITIAL FORM', specials={'initial',0x06AD} },
	[0xFBD6] = { unicodeslot=0xFBD6, category='lo', description='ARABIC LETTER NG MEDIAL FORM', specials={'medial',0x06AD} },
	[0xFBD7] = { unicodeslot=0xFBD7, category='lo', description='ARABIC LETTER U ISOLATED FORM', specials={'isolated',0x06C7} },
	[0xFBD8] = { unicodeslot=0xFBD8, category='lo', description='ARABIC LETTER U FINAL FORM', specials={'final',0x06C7} },
	[0xFBD9] = { unicodeslot=0xFBD9, category='lo', description='ARABIC LETTER OE ISOLATED FORM', specials={'isolated',0x06C6} },
	[0xFBDA] = { unicodeslot=0xFBDA, category='lo', description='ARABIC LETTER OE FINAL FORM', specials={'final',0x06C6} },
	[0xFBDB] = { unicodeslot=0xFBDB, category='lo', description='ARABIC LETTER YU ISOLATED FORM', specials={'isolated',0x06C8} },
	[0xFBDC] = { unicodeslot=0xFBDC, category='lo', description='ARABIC LETTER YU FINAL FORM', specials={'final',0x06C8} },
	[0xFBDD] = { unicodeslot=0xFBDD, category='lo', description='ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM', shcode=0x06C7, specials={'isolated',0x0677} },
	[0xFBDE] = { unicodeslot=0xFBDE, category='lo', description='ARABIC LETTER VE ISOLATED FORM', specials={'isolated',0x06CB} },
	[0xFBDF] = { unicodeslot=0xFBDF, category='lo', description='ARABIC LETTER VE FINAL FORM', specials={'final',0x06CB} },
	[0xFBE0] = { unicodeslot=0xFBE0, category='lo', description='ARABIC LETTER KIRGHIZ OE ISOLATED FORM', specials={'isolated',0x06C5} },
	[0xFBE1] = { unicodeslot=0xFBE1, category='lo', description='ARABIC LETTER KIRGHIZ OE FINAL FORM', specials={'final',0x06C5} },
	[0xFBE2] = { unicodeslot=0xFBE2, category='lo', description='ARABIC LETTER KIRGHIZ YU ISOLATED FORM', specials={'isolated',0x06C9} },
	[0xFBE3] = { unicodeslot=0xFBE3, category='lo', description='ARABIC LETTER KIRGHIZ YU FINAL FORM', specials={'final',0x06C9} },
	[0xFBE4] = { unicodeslot=0xFBE4, category='lo', description='ARABIC LETTER E ISOLATED FORM', specials={'isolated',0x06D0} },
	[0xFBE5] = { unicodeslot=0xFBE5, category='lo', description='ARABIC LETTER E FINAL FORM', specials={'final',0x06D0} },
	[0xFBE6] = { unicodeslot=0xFBE6, category='lo', description='ARABIC LETTER E INITIAL FORM', specials={'initial',0x06D0} },
	[0xFBE7] = { unicodeslot=0xFBE7, category='lo', description='ARABIC LETTER E MEDIAL FORM', specials={'medial',0x06D0} },
	[0xFBE8] = { unicodeslot=0xFBE8, category='lo', description='ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA INITIAL FORM', specials={'initial',0x0649} },
	[0xFBE9] = { unicodeslot=0xFBE9, category='lo', description='ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA MEDIAL FORM', specials={'medial',0x0649} },
	[0xFBEA] = { unicodeslot=0xFBEA, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF ISOLATED FORM', specials={'isolated',0x0626,0x0627} },
	[0xFBEB] = { unicodeslot=0xFBEB, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF FINAL FORM', specials={'final',0x0626,0x0627} },
	[0xFBEC] = { unicodeslot=0xFBEC, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM', specials={'isolated',0x0626,0x06D5} },
	[0xFBED] = { unicodeslot=0xFBED, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE FINAL FORM', specials={'final',0x0626,0x06D5} },
	[0xFBEE] = { unicodeslot=0xFBEE, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW ISOLATED FORM', specials={'isolated',0x0626,0x0648} },
	[0xFBEF] = { unicodeslot=0xFBEF, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW FINAL FORM', specials={'final',0x0626,0x0648} },
	[0xFBF0] = { unicodeslot=0xFBF0, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U ISOLATED FORM', specials={'isolated',0x0626,0x06C7} },
	[0xFBF1] = { unicodeslot=0xFBF1, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U FINAL FORM', specials={'final',0x0626,0x06C7} },
	[0xFBF2] = { unicodeslot=0xFBF2, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE ISOLATED FORM', specials={'isolated',0x0626,0x06C6} },
	[0xFBF3] = { unicodeslot=0xFBF3, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE FINAL FORM', specials={'final',0x0626,0x06C6} },
	[0xFBF4] = { unicodeslot=0xFBF4, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU ISOLATED FORM', specials={'isolated',0x0626,0x06C8} },
	[0xFBF5] = { unicodeslot=0xFBF5, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU FINAL FORM', specials={'final',0x0626,0x06C8} },
	[0xFBF6] = { unicodeslot=0xFBF6, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E ISOLATED FORM', specials={'isolated',0x0626,0x06D0} },
	[0xFBF7] = { unicodeslot=0xFBF7, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E FINAL FORM', specials={'final',0x0626,0x06D0} },
	[0xFBF8] = { unicodeslot=0xFBF8, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E INITIAL FORM', specials={'initial',0x0626,0x06D0} },
	[0xFBF9] = { unicodeslot=0xFBF9, category='lo', description='ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0626,0x0649} },
	[0xFBFA] = { unicodeslot=0xFBFA, category='lo', description='ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0626,0x0649} },
	[0xFBFB] = { unicodeslot=0xFBFB, category='lo', description='ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA INITIAL FORM', specials={'initial',0x0626,0x0649} },
	[0xFBFC] = { unicodeslot=0xFBFC, category='lo', description='ARABIC LETTER FARSI YEH ISOLATED FORM', specials={'isolated',0x06CC} },
	[0xFBFD] = { unicodeslot=0xFBFD, category='lo', description='ARABIC LETTER FARSI YEH FINAL FORM', specials={'final',0x06CC} },
	[0xFBFE] = { unicodeslot=0xFBFE, category='lo', description='ARABIC LETTER FARSI YEH INITIAL FORM', specials={'initial',0x06CC} },
	[0xFBFF] = { unicodeslot=0xFBFF, category='lo', description='ARABIC LETTER FARSI YEH MEDIAL FORM', specials={'medial',0x06CC} },
	[0xFC00] = { unicodeslot=0xFC00, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM ISOLATED FORM', specials={'isolated',0x0626,0x062C} },
	[0xFC01] = { unicodeslot=0xFC01, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH ISOLATED FORM', specials={'isolated',0x0626,0x062D} },
	[0xFC02] = { unicodeslot=0xFC02, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM ISOLATED FORM', specials={'isolated',0x0626,0x0645} },
	[0xFC03] = { unicodeslot=0xFC03, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0626,0x0649} },
	[0xFC04] = { unicodeslot=0xFC04, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH ISOLATED FORM', specials={'isolated',0x0626,0x064A} },
	[0xFC05] = { unicodeslot=0xFC05, category='lo', description='ARABIC LIGATURE BEH WITH JEEM ISOLATED FORM', specials={'isolated',0x0628,0x062C} },
	[0xFC06] = { unicodeslot=0xFC06, category='lo', description='ARABIC LIGATURE BEH WITH HAH ISOLATED FORM', specials={'isolated',0x0628,0x062D} },
	[0xFC07] = { unicodeslot=0xFC07, category='lo', description='ARABIC LIGATURE BEH WITH KHAH ISOLATED FORM', specials={'isolated',0x0628,0x062E} },
	[0xFC08] = { unicodeslot=0xFC08, category='lo', description='ARABIC LIGATURE BEH WITH MEEM ISOLATED FORM', specials={'isolated',0x0628,0x0645} },
	[0xFC09] = { unicodeslot=0xFC09, category='lo', description='ARABIC LIGATURE BEH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0628,0x0649} },
	[0xFC0A] = { unicodeslot=0xFC0A, category='lo', description='ARABIC LIGATURE BEH WITH YEH ISOLATED FORM', specials={'isolated',0x0628,0x064A} },
	[0xFC0B] = { unicodeslot=0xFC0B, category='lo', description='ARABIC LIGATURE TEH WITH JEEM ISOLATED FORM', specials={'isolated',0x062A,0x062C} },
	[0xFC0C] = { unicodeslot=0xFC0C, category='lo', description='ARABIC LIGATURE TEH WITH HAH ISOLATED FORM', specials={'isolated',0x062A,0x062D} },
	[0xFC0D] = { unicodeslot=0xFC0D, category='lo', description='ARABIC LIGATURE TEH WITH KHAH ISOLATED FORM', specials={'isolated',0x062A,0x062E} },
	[0xFC0E] = { unicodeslot=0xFC0E, category='lo', description='ARABIC LIGATURE TEH WITH MEEM ISOLATED FORM', specials={'isolated',0x062A,0x0645} },
	[0xFC0F] = { unicodeslot=0xFC0F, category='lo', description='ARABIC LIGATURE TEH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x062A,0x0649} },
	[0xFC10] = { unicodeslot=0xFC10, category='lo', description='ARABIC LIGATURE TEH WITH YEH ISOLATED FORM', specials={'isolated',0x062A,0x064A} },
	[0xFC11] = { unicodeslot=0xFC11, category='lo', description='ARABIC LIGATURE THEH WITH JEEM ISOLATED FORM', specials={'isolated',0x062B,0x062C} },
	[0xFC12] = { unicodeslot=0xFC12, category='lo', description='ARABIC LIGATURE THEH WITH MEEM ISOLATED FORM', specials={'isolated',0x062B,0x0645} },
	[0xFC13] = { unicodeslot=0xFC13, category='lo', description='ARABIC LIGATURE THEH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x062B,0x0649} },
	[0xFC14] = { unicodeslot=0xFC14, category='lo', description='ARABIC LIGATURE THEH WITH YEH ISOLATED FORM', specials={'isolated',0x062B,0x064A} },
	[0xFC15] = { unicodeslot=0xFC15, category='lo', description='ARABIC LIGATURE JEEM WITH HAH ISOLATED FORM', specials={'isolated',0x062C,0x062D} },
	[0xFC16] = { unicodeslot=0xFC16, category='lo', description='ARABIC LIGATURE JEEM WITH MEEM ISOLATED FORM', specials={'isolated',0x062C,0x0645} },
	[0xFC17] = { unicodeslot=0xFC17, category='lo', description='ARABIC LIGATURE HAH WITH JEEM ISOLATED FORM', specials={'isolated',0x062D,0x062C} },
	[0xFC18] = { unicodeslot=0xFC18, category='lo', description='ARABIC LIGATURE HAH WITH MEEM ISOLATED FORM', specials={'isolated',0x062D,0x0645} },
	[0xFC19] = { unicodeslot=0xFC19, category='lo', description='ARABIC LIGATURE KHAH WITH JEEM ISOLATED FORM', specials={'isolated',0x062E,0x062C} },
	[0xFC1A] = { unicodeslot=0xFC1A, category='lo', description='ARABIC LIGATURE KHAH WITH HAH ISOLATED FORM', specials={'isolated',0x062E,0x062D} },
	[0xFC1B] = { unicodeslot=0xFC1B, category='lo', description='ARABIC LIGATURE KHAH WITH MEEM ISOLATED FORM', specials={'isolated',0x062E,0x0645} },
	[0xFC1C] = { unicodeslot=0xFC1C, category='lo', description='ARABIC LIGATURE SEEN WITH JEEM ISOLATED FORM', specials={'isolated',0x0633,0x062C} },
	[0xFC1D] = { unicodeslot=0xFC1D, category='lo', description='ARABIC LIGATURE SEEN WITH HAH ISOLATED FORM', specials={'isolated',0x0633,0x062D} },
	[0xFC1E] = { unicodeslot=0xFC1E, category='lo', description='ARABIC LIGATURE SEEN WITH KHAH ISOLATED FORM', specials={'isolated',0x0633,0x062E} },
	[0xFC1F] = { unicodeslot=0xFC1F, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM ISOLATED FORM', specials={'isolated',0x0633,0x0645} },
	[0xFC20] = { unicodeslot=0xFC20, category='lo', description='ARABIC LIGATURE SAD WITH HAH ISOLATED FORM', specials={'isolated',0x0635,0x062D} },
	[0xFC21] = { unicodeslot=0xFC21, category='lo', description='ARABIC LIGATURE SAD WITH MEEM ISOLATED FORM', specials={'isolated',0x0635,0x0645} },
	[0xFC22] = { unicodeslot=0xFC22, category='lo', description='ARABIC LIGATURE DAD WITH JEEM ISOLATED FORM', specials={'isolated',0x0636,0x062C} },
	[0xFC23] = { unicodeslot=0xFC23, category='lo', description='ARABIC LIGATURE DAD WITH HAH ISOLATED FORM', specials={'isolated',0x0636,0x062D} },
	[0xFC24] = { unicodeslot=0xFC24, category='lo', description='ARABIC LIGATURE DAD WITH KHAH ISOLATED FORM', specials={'isolated',0x0636,0x062E} },
	[0xFC25] = { unicodeslot=0xFC25, category='lo', description='ARABIC LIGATURE DAD WITH MEEM ISOLATED FORM', specials={'isolated',0x0636,0x0645} },
	[0xFC26] = { unicodeslot=0xFC26, category='lo', description='ARABIC LIGATURE TAH WITH HAH ISOLATED FORM', specials={'isolated',0x0637,0x062D} },
	[0xFC27] = { unicodeslot=0xFC27, category='lo', description='ARABIC LIGATURE TAH WITH MEEM ISOLATED FORM', specials={'isolated',0x0637,0x0645} },
	[0xFC28] = { unicodeslot=0xFC28, category='lo', description='ARABIC LIGATURE ZAH WITH MEEM ISOLATED FORM', specials={'isolated',0x0638,0x0645} },
	[0xFC29] = { unicodeslot=0xFC29, category='lo', description='ARABIC LIGATURE AIN WITH JEEM ISOLATED FORM', specials={'isolated',0x0639,0x062C} },
	[0xFC2A] = { unicodeslot=0xFC2A, category='lo', description='ARABIC LIGATURE AIN WITH MEEM ISOLATED FORM', specials={'isolated',0x0639,0x0645} },
	[0xFC2B] = { unicodeslot=0xFC2B, category='lo', description='ARABIC LIGATURE GHAIN WITH JEEM ISOLATED FORM', specials={'isolated',0x063A,0x062C} },
	[0xFC2C] = { unicodeslot=0xFC2C, category='lo', description='ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM', specials={'isolated',0x063A,0x0645} },
	[0xFC2D] = { unicodeslot=0xFC2D, category='lo', description='ARABIC LIGATURE FEH WITH JEEM ISOLATED FORM', specials={'isolated',0x0641,0x062C} },
	[0xFC2E] = { unicodeslot=0xFC2E, category='lo', description='ARABIC LIGATURE FEH WITH HAH ISOLATED FORM', specials={'isolated',0x0641,0x062D} },
	[0xFC2F] = { unicodeslot=0xFC2F, category='lo', description='ARABIC LIGATURE FEH WITH KHAH ISOLATED FORM', specials={'isolated',0x0641,0x062E} },
	[0xFC30] = { unicodeslot=0xFC30, category='lo', description='ARABIC LIGATURE FEH WITH MEEM ISOLATED FORM', specials={'isolated',0x0641,0x0645} },
	[0xFC31] = { unicodeslot=0xFC31, category='lo', description='ARABIC LIGATURE FEH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0641,0x0649} },
	[0xFC32] = { unicodeslot=0xFC32, category='lo', description='ARABIC LIGATURE FEH WITH YEH ISOLATED FORM', specials={'isolated',0x0641,0x064A} },
	[0xFC33] = { unicodeslot=0xFC33, category='lo', description='ARABIC LIGATURE QAF WITH HAH ISOLATED FORM', specials={'isolated',0x0642,0x062D} },
	[0xFC34] = { unicodeslot=0xFC34, category='lo', description='ARABIC LIGATURE QAF WITH MEEM ISOLATED FORM', specials={'isolated',0x0642,0x0645} },
	[0xFC35] = { unicodeslot=0xFC35, category='lo', description='ARABIC LIGATURE QAF WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0642,0x0649} },
	[0xFC36] = { unicodeslot=0xFC36, category='lo', description='ARABIC LIGATURE QAF WITH YEH ISOLATED FORM', specials={'isolated',0x0642,0x064A} },
	[0xFC37] = { unicodeslot=0xFC37, category='lo', description='ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM', specials={'isolated',0x0643,0x0627} },
	[0xFC38] = { unicodeslot=0xFC38, category='lo', description='ARABIC LIGATURE KAF WITH JEEM ISOLATED FORM', specials={'isolated',0x0643,0x062C} },
	[0xFC39] = { unicodeslot=0xFC39, category='lo', description='ARABIC LIGATURE KAF WITH HAH ISOLATED FORM', specials={'isolated',0x0643,0x062D} },
	[0xFC3A] = { unicodeslot=0xFC3A, category='lo', description='ARABIC LIGATURE KAF WITH KHAH ISOLATED FORM', specials={'isolated',0x0643,0x062E} },
	[0xFC3B] = { unicodeslot=0xFC3B, category='lo', description='ARABIC LIGATURE KAF WITH LAM ISOLATED FORM', specials={'isolated',0x0643,0x0644} },
	[0xFC3C] = { unicodeslot=0xFC3C, category='lo', description='ARABIC LIGATURE KAF WITH MEEM ISOLATED FORM', specials={'isolated',0x0643,0x0645} },
	[0xFC3D] = { unicodeslot=0xFC3D, category='lo', description='ARABIC LIGATURE KAF WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0643,0x0649} },
	[0xFC3E] = { unicodeslot=0xFC3E, category='lo', description='ARABIC LIGATURE KAF WITH YEH ISOLATED FORM', specials={'isolated',0x0643,0x064A} },
	[0xFC3F] = { unicodeslot=0xFC3F, category='lo', description='ARABIC LIGATURE LAM WITH JEEM ISOLATED FORM', specials={'isolated',0x0644,0x062C} },
	[0xFC40] = { unicodeslot=0xFC40, category='lo', description='ARABIC LIGATURE LAM WITH HAH ISOLATED FORM', specials={'isolated',0x0644,0x062D} },
	[0xFC41] = { unicodeslot=0xFC41, category='lo', description='ARABIC LIGATURE LAM WITH KHAH ISOLATED FORM', specials={'isolated',0x0644,0x062E} },
	[0xFC42] = { unicodeslot=0xFC42, category='lo', description='ARABIC LIGATURE LAM WITH MEEM ISOLATED FORM', specials={'isolated',0x0644,0x0645} },
	[0xFC43] = { unicodeslot=0xFC43, category='lo', description='ARABIC LIGATURE LAM WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0644,0x0649} },
	[0xFC44] = { unicodeslot=0xFC44, category='lo', description='ARABIC LIGATURE LAM WITH YEH ISOLATED FORM', specials={'isolated',0x0644,0x064A} },
	[0xFC45] = { unicodeslot=0xFC45, category='lo', description='ARABIC LIGATURE MEEM WITH JEEM ISOLATED FORM', specials={'isolated',0x0645,0x062C} },
	[0xFC46] = { unicodeslot=0xFC46, category='lo', description='ARABIC LIGATURE MEEM WITH HAH ISOLATED FORM', specials={'isolated',0x0645,0x062D} },
	[0xFC47] = { unicodeslot=0xFC47, category='lo', description='ARABIC LIGATURE MEEM WITH KHAH ISOLATED FORM', specials={'isolated',0x0645,0x062E} },
	[0xFC48] = { unicodeslot=0xFC48, category='lo', description='ARABIC LIGATURE MEEM WITH MEEM ISOLATED FORM', specials={'isolated',0x0645,0x0645} },
	[0xFC49] = { unicodeslot=0xFC49, category='lo', description='ARABIC LIGATURE MEEM WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0645,0x0649} },
	[0xFC4A] = { unicodeslot=0xFC4A, category='lo', description='ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM', specials={'isolated',0x0645,0x064A} },
	[0xFC4B] = { unicodeslot=0xFC4B, category='lo', description='ARABIC LIGATURE NOON WITH JEEM ISOLATED FORM', specials={'isolated',0x0646,0x062C} },
	[0xFC4C] = { unicodeslot=0xFC4C, category='lo', description='ARABIC LIGATURE NOON WITH HAH ISOLATED FORM', specials={'isolated',0x0646,0x062D} },
	[0xFC4D] = { unicodeslot=0xFC4D, category='lo', description='ARABIC LIGATURE NOON WITH KHAH ISOLATED FORM', specials={'isolated',0x0646,0x062E} },
	[0xFC4E] = { unicodeslot=0xFC4E, category='lo', description='ARABIC LIGATURE NOON WITH MEEM ISOLATED FORM', specials={'isolated',0x0646,0x0645} },
	[0xFC4F] = { unicodeslot=0xFC4F, category='lo', description='ARABIC LIGATURE NOON WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0646,0x0649} },
	[0xFC50] = { unicodeslot=0xFC50, category='lo', description='ARABIC LIGATURE NOON WITH YEH ISOLATED FORM', specials={'isolated',0x0646,0x064A} },
	[0xFC51] = { unicodeslot=0xFC51, category='lo', description='ARABIC LIGATURE HEH WITH JEEM ISOLATED FORM', specials={'isolated',0x0647,0x062C} },
	[0xFC52] = { unicodeslot=0xFC52, category='lo', description='ARABIC LIGATURE HEH WITH MEEM ISOLATED FORM', specials={'isolated',0x0647,0x0645} },
	[0xFC53] = { unicodeslot=0xFC53, category='lo', description='ARABIC LIGATURE HEH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0647,0x0649} },
	[0xFC54] = { unicodeslot=0xFC54, category='lo', description='ARABIC LIGATURE HEH WITH YEH ISOLATED FORM', specials={'isolated',0x0647,0x064A} },
	[0xFC55] = { unicodeslot=0xFC55, category='lo', description='ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM', specials={'isolated',0x064A,0x062C} },
	[0xFC56] = { unicodeslot=0xFC56, category='lo', description='ARABIC LIGATURE YEH WITH HAH ISOLATED FORM', specials={'isolated',0x064A,0x062D} },
	[0xFC57] = { unicodeslot=0xFC57, category='lo', description='ARABIC LIGATURE YEH WITH KHAH ISOLATED FORM', specials={'isolated',0x064A,0x062E} },
	[0xFC58] = { unicodeslot=0xFC58, category='lo', description='ARABIC LIGATURE YEH WITH MEEM ISOLATED FORM', specials={'isolated',0x064A,0x0645} },
	[0xFC59] = { unicodeslot=0xFC59, category='lo', description='ARABIC LIGATURE YEH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x064A,0x0649} },
	[0xFC5A] = { unicodeslot=0xFC5A, category='lo', description='ARABIC LIGATURE YEH WITH YEH ISOLATED FORM', specials={'isolated',0x064A,0x064A} },
	[0xFC5B] = { unicodeslot=0xFC5B, category='lo', description='ARABIC LIGATURE THAL WITH SUPERSCRIPT ALEF ISOLATED FORM', specials={'isolated',0x0630,0x0670} },
	[0xFC5C] = { unicodeslot=0xFC5C, category='lo', description='ARABIC LIGATURE REH WITH SUPERSCRIPT ALEF ISOLATED FORM', specials={'isolated',0x0631,0x0670} },
	[0xFC5D] = { unicodeslot=0xFC5D, category='lo', description='ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF ISOLATED FORM', specials={'isolated',0x0649,0x0670} },
	[0xFC5E] = { unicodeslot=0xFC5E, category='lo', description='ARABIC LIGATURE SHADDA WITH DAMMATAN ISOLATED FORM', specials={'isolated',0x0020,0x064C,0x0651} },
	[0xFC5F] = { unicodeslot=0xFC5F, category='lo', description='ARABIC LIGATURE SHADDA WITH KASRATAN ISOLATED FORM', specials={'isolated',0x0020,0x064D,0x0651} },
	[0xFC60] = { unicodeslot=0xFC60, category='lo', description='ARABIC LIGATURE SHADDA WITH FATHA ISOLATED FORM', specials={'isolated',0x0020,0x064E,0x0651} },
	[0xFC61] = { unicodeslot=0xFC61, category='lo', description='ARABIC LIGATURE SHADDA WITH DAMMA ISOLATED FORM', specials={'isolated',0x0020,0x064F,0x0651} },
	[0xFC62] = { unicodeslot=0xFC62, category='lo', description='ARABIC LIGATURE SHADDA WITH KASRA ISOLATED FORM', specials={'isolated',0x0020,0x0650,0x0651} },
	[0xFC63] = { unicodeslot=0xFC63, category='lo', description='ARABIC LIGATURE SHADDA WITH SUPERSCRIPT ALEF ISOLATED FORM', specials={'isolated',0x0020,0x0651,0x0670} },
	[0xFC64] = { unicodeslot=0xFC64, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH REH FINAL FORM', specials={'final',0x0626,0x0631} },
	[0xFC65] = { unicodeslot=0xFC65, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ZAIN FINAL FORM', specials={'final',0x0626,0x0632} },
	[0xFC66] = { unicodeslot=0xFC66, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM FINAL FORM', specials={'final',0x0626,0x0645} },
	[0xFC67] = { unicodeslot=0xFC67, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH NOON FINAL FORM', specials={'final',0x0626,0x0646} },
	[0xFC68] = { unicodeslot=0xFC68, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0626,0x0649} },
	[0xFC69] = { unicodeslot=0xFC69, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH FINAL FORM', specials={'final',0x0626,0x064A} },
	[0xFC6A] = { unicodeslot=0xFC6A, category='lo', description='ARABIC LIGATURE BEH WITH REH FINAL FORM', specials={'final',0x0628,0x0631} },
	[0xFC6B] = { unicodeslot=0xFC6B, category='lo', description='ARABIC LIGATURE BEH WITH ZAIN FINAL FORM', specials={'final',0x0628,0x0632} },
	[0xFC6C] = { unicodeslot=0xFC6C, category='lo', description='ARABIC LIGATURE BEH WITH MEEM FINAL FORM', specials={'final',0x0628,0x0645} },
	[0xFC6D] = { unicodeslot=0xFC6D, category='lo', description='ARABIC LIGATURE BEH WITH NOON FINAL FORM', specials={'final',0x0628,0x0646} },
	[0xFC6E] = { unicodeslot=0xFC6E, category='lo', description='ARABIC LIGATURE BEH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0628,0x0649} },
	[0xFC6F] = { unicodeslot=0xFC6F, category='lo', description='ARABIC LIGATURE BEH WITH YEH FINAL FORM', specials={'final',0x0628,0x064A} },
	[0xFC70] = { unicodeslot=0xFC70, category='lo', description='ARABIC LIGATURE TEH WITH REH FINAL FORM', specials={'final',0x062A,0x0631} },
	[0xFC71] = { unicodeslot=0xFC71, category='lo', description='ARABIC LIGATURE TEH WITH ZAIN FINAL FORM', specials={'final',0x062A,0x0632} },
	[0xFC72] = { unicodeslot=0xFC72, category='lo', description='ARABIC LIGATURE TEH WITH MEEM FINAL FORM', specials={'final',0x062A,0x0645} },
	[0xFC73] = { unicodeslot=0xFC73, category='lo', description='ARABIC LIGATURE TEH WITH NOON FINAL FORM', specials={'final',0x062A,0x0646} },
	[0xFC74] = { unicodeslot=0xFC74, category='lo', description='ARABIC LIGATURE TEH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062A,0x0649} },
	[0xFC75] = { unicodeslot=0xFC75, category='lo', description='ARABIC LIGATURE TEH WITH YEH FINAL FORM', specials={'final',0x062A,0x064A} },
	[0xFC76] = { unicodeslot=0xFC76, category='lo', description='ARABIC LIGATURE THEH WITH REH FINAL FORM', specials={'final',0x062B,0x0631} },
	[0xFC77] = { unicodeslot=0xFC77, category='lo', description='ARABIC LIGATURE THEH WITH ZAIN FINAL FORM', specials={'final',0x062B,0x0632} },
	[0xFC78] = { unicodeslot=0xFC78, category='lo', description='ARABIC LIGATURE THEH WITH MEEM FINAL FORM', specials={'final',0x062B,0x0645} },
	[0xFC79] = { unicodeslot=0xFC79, category='lo', description='ARABIC LIGATURE THEH WITH NOON FINAL FORM', specials={'final',0x062B,0x0646} },
	[0xFC7A] = { unicodeslot=0xFC7A, category='lo', description='ARABIC LIGATURE THEH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062B,0x0649} },
	[0xFC7B] = { unicodeslot=0xFC7B, category='lo', description='ARABIC LIGATURE THEH WITH YEH FINAL FORM', specials={'final',0x062B,0x064A} },
	[0xFC7C] = { unicodeslot=0xFC7C, category='lo', description='ARABIC LIGATURE FEH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0641,0x0649} },
	[0xFC7D] = { unicodeslot=0xFC7D, category='lo', description='ARABIC LIGATURE FEH WITH YEH FINAL FORM', specials={'final',0x0641,0x064A} },
	[0xFC7E] = { unicodeslot=0xFC7E, category='lo', description='ARABIC LIGATURE QAF WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0642,0x0649} },
	[0xFC7F] = { unicodeslot=0xFC7F, category='lo', description='ARABIC LIGATURE QAF WITH YEH FINAL FORM', specials={'final',0x0642,0x064A} },
	[0xFC80] = { unicodeslot=0xFC80, category='lo', description='ARABIC LIGATURE KAF WITH ALEF FINAL FORM', specials={'final',0x0643,0x0627} },
	[0xFC81] = { unicodeslot=0xFC81, category='lo', description='ARABIC LIGATURE KAF WITH LAM FINAL FORM', specials={'final',0x0643,0x0644} },
	[0xFC82] = { unicodeslot=0xFC82, category='lo', description='ARABIC LIGATURE KAF WITH MEEM FINAL FORM', specials={'final',0x0643,0x0645} },
	[0xFC83] = { unicodeslot=0xFC83, category='lo', description='ARABIC LIGATURE KAF WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0643,0x0649} },
	[0xFC84] = { unicodeslot=0xFC84, category='lo', description='ARABIC LIGATURE KAF WITH YEH FINAL FORM', specials={'final',0x0643,0x064A} },
	[0xFC85] = { unicodeslot=0xFC85, category='lo', description='ARABIC LIGATURE LAM WITH MEEM FINAL FORM', specials={'final',0x0644,0x0645} },
	[0xFC86] = { unicodeslot=0xFC86, category='lo', description='ARABIC LIGATURE LAM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0644,0x0649} },
	[0xFC87] = { unicodeslot=0xFC87, category='lo', description='ARABIC LIGATURE LAM WITH YEH FINAL FORM', specials={'final',0x0644,0x064A} },
	[0xFC88] = { unicodeslot=0xFC88, category='lo', description='ARABIC LIGATURE MEEM WITH ALEF FINAL FORM', specials={'final',0x0645,0x0627} },
	[0xFC89] = { unicodeslot=0xFC89, category='lo', description='ARABIC LIGATURE MEEM WITH MEEM FINAL FORM', specials={'final',0x0645,0x0645} },
	[0xFC8A] = { unicodeslot=0xFC8A, category='lo', description='ARABIC LIGATURE NOON WITH REH FINAL FORM', specials={'final',0x0646,0x0631} },
	[0xFC8B] = { unicodeslot=0xFC8B, category='lo', description='ARABIC LIGATURE NOON WITH ZAIN FINAL FORM', specials={'final',0x0646,0x0632} },
	[0xFC8C] = { unicodeslot=0xFC8C, category='lo', description='ARABIC LIGATURE NOON WITH MEEM FINAL FORM', specials={'final',0x0646,0x0645} },
	[0xFC8D] = { unicodeslot=0xFC8D, category='lo', description='ARABIC LIGATURE NOON WITH NOON FINAL FORM', specials={'final',0x0646,0x0646} },
	[0xFC8E] = { unicodeslot=0xFC8E, category='lo', description='ARABIC LIGATURE NOON WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0646,0x0649} },
	[0xFC8F] = { unicodeslot=0xFC8F, category='lo', description='ARABIC LIGATURE NOON WITH YEH FINAL FORM', specials={'final',0x0646,0x064A} },
	[0xFC90] = { unicodeslot=0xFC90, category='lo', description='ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF FINAL FORM', specials={'final',0x0649,0x0670} },
	[0xFC91] = { unicodeslot=0xFC91, category='lo', description='ARABIC LIGATURE YEH WITH REH FINAL FORM', specials={'final',0x064A,0x0631} },
	[0xFC92] = { unicodeslot=0xFC92, category='lo', description='ARABIC LIGATURE YEH WITH ZAIN FINAL FORM', specials={'final',0x064A,0x0632} },
	[0xFC93] = { unicodeslot=0xFC93, category='lo', description='ARABIC LIGATURE YEH WITH MEEM FINAL FORM', specials={'final',0x064A,0x0645} },
	[0xFC94] = { unicodeslot=0xFC94, category='lo', description='ARABIC LIGATURE YEH WITH NOON FINAL FORM', specials={'final',0x064A,0x0646} },
	[0xFC95] = { unicodeslot=0xFC95, category='lo', description='ARABIC LIGATURE YEH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x064A,0x0649} },
	[0xFC96] = { unicodeslot=0xFC96, category='lo', description='ARABIC LIGATURE YEH WITH YEH FINAL FORM', specials={'final',0x064A,0x064A} },
	[0xFC97] = { unicodeslot=0xFC97, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM INITIAL FORM', specials={'initial',0x0626,0x062C} },
	[0xFC98] = { unicodeslot=0xFC98, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH INITIAL FORM', specials={'initial',0x0626,0x062D} },
	[0xFC99] = { unicodeslot=0xFC99, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM', specials={'initial',0x0626,0x062E} },
	[0xFC9A] = { unicodeslot=0xFC9A, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM INITIAL FORM', specials={'initial',0x0626,0x0645} },
	[0xFC9B] = { unicodeslot=0xFC9B, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH INITIAL FORM', specials={'initial',0x0626,0x0647} },
	[0xFC9C] = { unicodeslot=0xFC9C, category='lo', description='ARABIC LIGATURE BEH WITH JEEM INITIAL FORM', specials={'initial',0x0628,0x062C} },
	[0xFC9D] = { unicodeslot=0xFC9D, category='lo', description='ARABIC LIGATURE BEH WITH HAH INITIAL FORM', specials={'initial',0x0628,0x062D} },
	[0xFC9E] = { unicodeslot=0xFC9E, category='lo', description='ARABIC LIGATURE BEH WITH KHAH INITIAL FORM', specials={'initial',0x0628,0x062E} },
	[0xFC9F] = { unicodeslot=0xFC9F, category='lo', description='ARABIC LIGATURE BEH WITH MEEM INITIAL FORM', specials={'initial',0x0628,0x0645} },
	[0xFCA0] = { unicodeslot=0xFCA0, category='lo', description='ARABIC LIGATURE BEH WITH HEH INITIAL FORM', specials={'initial',0x0628,0x0647} },
	[0xFCA1] = { unicodeslot=0xFCA1, category='lo', description='ARABIC LIGATURE TEH WITH JEEM INITIAL FORM', specials={'initial',0x062A,0x062C} },
	[0xFCA2] = { unicodeslot=0xFCA2, category='lo', description='ARABIC LIGATURE TEH WITH HAH INITIAL FORM', specials={'initial',0x062A,0x062D} },
	[0xFCA3] = { unicodeslot=0xFCA3, category='lo', description='ARABIC LIGATURE TEH WITH KHAH INITIAL FORM', specials={'initial',0x062A,0x062E} },
	[0xFCA4] = { unicodeslot=0xFCA4, category='lo', description='ARABIC LIGATURE TEH WITH MEEM INITIAL FORM', specials={'initial',0x062A,0x0645} },
	[0xFCA5] = { unicodeslot=0xFCA5, category='lo', description='ARABIC LIGATURE TEH WITH HEH INITIAL FORM', specials={'initial',0x062A,0x0647} },
	[0xFCA6] = { unicodeslot=0xFCA6, category='lo', description='ARABIC LIGATURE THEH WITH MEEM INITIAL FORM', specials={'initial',0x062B,0x0645} },
	[0xFCA7] = { unicodeslot=0xFCA7, category='lo', description='ARABIC LIGATURE JEEM WITH HAH INITIAL FORM', specials={'initial',0x062C,0x062D} },
	[0xFCA8] = { unicodeslot=0xFCA8, category='lo', description='ARABIC LIGATURE JEEM WITH MEEM INITIAL FORM', specials={'initial',0x062C,0x0645} },
	[0xFCA9] = { unicodeslot=0xFCA9, category='lo', description='ARABIC LIGATURE HAH WITH JEEM INITIAL FORM', specials={'initial',0x062D,0x062C} },
	[0xFCAA] = { unicodeslot=0xFCAA, category='lo', description='ARABIC LIGATURE HAH WITH MEEM INITIAL FORM', specials={'initial',0x062D,0x0645} },
	[0xFCAB] = { unicodeslot=0xFCAB, category='lo', description='ARABIC LIGATURE KHAH WITH JEEM INITIAL FORM', specials={'initial',0x062E,0x062C} },
	[0xFCAC] = { unicodeslot=0xFCAC, category='lo', description='ARABIC LIGATURE KHAH WITH MEEM INITIAL FORM', specials={'initial',0x062E,0x0645} },
	[0xFCAD] = { unicodeslot=0xFCAD, category='lo', description='ARABIC LIGATURE SEEN WITH JEEM INITIAL FORM', specials={'initial',0x0633,0x062C} },
	[0xFCAE] = { unicodeslot=0xFCAE, category='lo', description='ARABIC LIGATURE SEEN WITH HAH INITIAL FORM', specials={'initial',0x0633,0x062D} },
	[0xFCAF] = { unicodeslot=0xFCAF, category='lo', description='ARABIC LIGATURE SEEN WITH KHAH INITIAL FORM', specials={'initial',0x0633,0x062E} },
	[0xFCB0] = { unicodeslot=0xFCB0, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM INITIAL FORM', specials={'initial',0x0633,0x0645} },
	[0xFCB1] = { unicodeslot=0xFCB1, category='lo', description='ARABIC LIGATURE SAD WITH HAH INITIAL FORM', specials={'initial',0x0635,0x062D} },
	[0xFCB2] = { unicodeslot=0xFCB2, category='lo', description='ARABIC LIGATURE SAD WITH KHAH INITIAL FORM', specials={'initial',0x0635,0x062E} },
	[0xFCB3] = { unicodeslot=0xFCB3, category='lo', description='ARABIC LIGATURE SAD WITH MEEM INITIAL FORM', specials={'initial',0x0635,0x0645} },
	[0xFCB4] = { unicodeslot=0xFCB4, category='lo', description='ARABIC LIGATURE DAD WITH JEEM INITIAL FORM', specials={'initial',0x0636,0x062C} },
	[0xFCB5] = { unicodeslot=0xFCB5, category='lo', description='ARABIC LIGATURE DAD WITH HAH INITIAL FORM', specials={'initial',0x0636,0x062D} },
	[0xFCB6] = { unicodeslot=0xFCB6, category='lo', description='ARABIC LIGATURE DAD WITH KHAH INITIAL FORM', specials={'initial',0x0636,0x062E} },
	[0xFCB7] = { unicodeslot=0xFCB7, category='lo', description='ARABIC LIGATURE DAD WITH MEEM INITIAL FORM', specials={'initial',0x0636,0x0645} },
	[0xFCB8] = { unicodeslot=0xFCB8, category='lo', description='ARABIC LIGATURE TAH WITH HAH INITIAL FORM', specials={'initial',0x0637,0x062D} },
	[0xFCB9] = { unicodeslot=0xFCB9, category='lo', description='ARABIC LIGATURE ZAH WITH MEEM INITIAL FORM', specials={'initial',0x0638,0x0645} },
	[0xFCBA] = { unicodeslot=0xFCBA, category='lo', description='ARABIC LIGATURE AIN WITH JEEM INITIAL FORM', specials={'initial',0x0639,0x062C} },
	[0xFCBB] = { unicodeslot=0xFCBB, category='lo', description='ARABIC LIGATURE AIN WITH MEEM INITIAL FORM', specials={'initial',0x0639,0x0645} },
	[0xFCBC] = { unicodeslot=0xFCBC, category='lo', description='ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM', specials={'initial',0x063A,0x062C} },
	[0xFCBD] = { unicodeslot=0xFCBD, category='lo', description='ARABIC LIGATURE GHAIN WITH MEEM INITIAL FORM', specials={'initial',0x063A,0x0645} },
	[0xFCBE] = { unicodeslot=0xFCBE, category='lo', description='ARABIC LIGATURE FEH WITH JEEM INITIAL FORM', specials={'initial',0x0641,0x062C} },
	[0xFCBF] = { unicodeslot=0xFCBF, category='lo', description='ARABIC LIGATURE FEH WITH HAH INITIAL FORM', specials={'initial',0x0641,0x062D} },
	[0xFCC0] = { unicodeslot=0xFCC0, category='lo', description='ARABIC LIGATURE FEH WITH KHAH INITIAL FORM', specials={'initial',0x0641,0x062E} },
	[0xFCC1] = { unicodeslot=0xFCC1, category='lo', description='ARABIC LIGATURE FEH WITH MEEM INITIAL FORM', specials={'initial',0x0641,0x0645} },
	[0xFCC2] = { unicodeslot=0xFCC2, category='lo', description='ARABIC LIGATURE QAF WITH HAH INITIAL FORM', specials={'initial',0x0642,0x062D} },
	[0xFCC3] = { unicodeslot=0xFCC3, category='lo', description='ARABIC LIGATURE QAF WITH MEEM INITIAL FORM', specials={'initial',0x0642,0x0645} },
	[0xFCC4] = { unicodeslot=0xFCC4, category='lo', description='ARABIC LIGATURE KAF WITH JEEM INITIAL FORM', specials={'initial',0x0643,0x062C} },
	[0xFCC5] = { unicodeslot=0xFCC5, category='lo', description='ARABIC LIGATURE KAF WITH HAH INITIAL FORM', specials={'initial',0x0643,0x062D} },
	[0xFCC6] = { unicodeslot=0xFCC6, category='lo', description='ARABIC LIGATURE KAF WITH KHAH INITIAL FORM', specials={'initial',0x0643,0x062E} },
	[0xFCC7] = { unicodeslot=0xFCC7, category='lo', description='ARABIC LIGATURE KAF WITH LAM INITIAL FORM', specials={'initial',0x0643,0x0644} },
	[0xFCC8] = { unicodeslot=0xFCC8, category='lo', description='ARABIC LIGATURE KAF WITH MEEM INITIAL FORM', specials={'initial',0x0643,0x0645} },
	[0xFCC9] = { unicodeslot=0xFCC9, category='lo', description='ARABIC LIGATURE LAM WITH JEEM INITIAL FORM', specials={'initial',0x0644,0x062C} },
	[0xFCCA] = { unicodeslot=0xFCCA, category='lo', description='ARABIC LIGATURE LAM WITH HAH INITIAL FORM', specials={'initial',0x0644,0x062D} },
	[0xFCCB] = { unicodeslot=0xFCCB, category='lo', description='ARABIC LIGATURE LAM WITH KHAH INITIAL FORM', specials={'initial',0x0644,0x062E} },
	[0xFCCC] = { unicodeslot=0xFCCC, category='lo', description='ARABIC LIGATURE LAM WITH MEEM INITIAL FORM', specials={'initial',0x0644,0x0645} },
	[0xFCCD] = { unicodeslot=0xFCCD, category='lo', description='ARABIC LIGATURE LAM WITH HEH INITIAL FORM', specials={'initial',0x0644,0x0647} },
	[0xFCCE] = { unicodeslot=0xFCCE, category='lo', description='ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM', specials={'initial',0x0645,0x062C} },
	[0xFCCF] = { unicodeslot=0xFCCF, category='lo', description='ARABIC LIGATURE MEEM WITH HAH INITIAL FORM', specials={'initial',0x0645,0x062D} },
	[0xFCD0] = { unicodeslot=0xFCD0, category='lo', description='ARABIC LIGATURE MEEM WITH KHAH INITIAL FORM', specials={'initial',0x0645,0x062E} },
	[0xFCD1] = { unicodeslot=0xFCD1, category='lo', description='ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0645,0x0645} },
	[0xFCD2] = { unicodeslot=0xFCD2, category='lo', description='ARABIC LIGATURE NOON WITH JEEM INITIAL FORM', specials={'initial',0x0646,0x062C} },
	[0xFCD3] = { unicodeslot=0xFCD3, category='lo', description='ARABIC LIGATURE NOON WITH HAH INITIAL FORM', specials={'initial',0x0646,0x062D} },
	[0xFCD4] = { unicodeslot=0xFCD4, category='lo', description='ARABIC LIGATURE NOON WITH KHAH INITIAL FORM', specials={'initial',0x0646,0x062E} },
	[0xFCD5] = { unicodeslot=0xFCD5, category='lo', description='ARABIC LIGATURE NOON WITH MEEM INITIAL FORM', specials={'initial',0x0646,0x0645} },
	[0xFCD6] = { unicodeslot=0xFCD6, category='lo', description='ARABIC LIGATURE NOON WITH HEH INITIAL FORM', specials={'initial',0x0646,0x0647} },
	[0xFCD7] = { unicodeslot=0xFCD7, category='lo', description='ARABIC LIGATURE HEH WITH JEEM INITIAL FORM', specials={'initial',0x0647,0x062C} },
	[0xFCD8] = { unicodeslot=0xFCD8, category='lo', description='ARABIC LIGATURE HEH WITH MEEM INITIAL FORM', specials={'initial',0x0647,0x0645} },
	[0xFCD9] = { unicodeslot=0xFCD9, category='lo', description='ARABIC LIGATURE HEH WITH SUPERSCRIPT ALEF INITIAL FORM', specials={'initial',0x0647,0x0670} },
	[0xFCDA] = { unicodeslot=0xFCDA, category='lo', description='ARABIC LIGATURE YEH WITH JEEM INITIAL FORM', specials={'initial',0x064A,0x062C} },
	[0xFCDB] = { unicodeslot=0xFCDB, category='lo', description='ARABIC LIGATURE YEH WITH HAH INITIAL FORM', specials={'initial',0x064A,0x062D} },
	[0xFCDC] = { unicodeslot=0xFCDC, category='lo', description='ARABIC LIGATURE YEH WITH KHAH INITIAL FORM', specials={'initial',0x064A,0x062E} },
	[0xFCDD] = { unicodeslot=0xFCDD, category='lo', description='ARABIC LIGATURE YEH WITH MEEM INITIAL FORM', specials={'initial',0x064A,0x0645} },
	[0xFCDE] = { unicodeslot=0xFCDE, category='lo', description='ARABIC LIGATURE YEH WITH HEH INITIAL FORM', specials={'initial',0x064A,0x0647} },
	[0xFCDF] = { unicodeslot=0xFCDF, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM MEDIAL FORM', specials={'medial',0x0626,0x0645} },
	[0xFCE0] = { unicodeslot=0xFCE0, category='lo', description='ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH MEDIAL FORM', specials={'medial',0x0626,0x0647} },
	[0xFCE1] = { unicodeslot=0xFCE1, category='lo', description='ARABIC LIGATURE BEH WITH MEEM MEDIAL FORM', specials={'medial',0x0628,0x0645} },
	[0xFCE2] = { unicodeslot=0xFCE2, category='lo', description='ARABIC LIGATURE BEH WITH HEH MEDIAL FORM', specials={'medial',0x0628,0x0647} },
	[0xFCE3] = { unicodeslot=0xFCE3, category='lo', description='ARABIC LIGATURE TEH WITH MEEM MEDIAL FORM', specials={'medial',0x062A,0x0645} },
	[0xFCE4] = { unicodeslot=0xFCE4, category='lo', description='ARABIC LIGATURE TEH WITH HEH MEDIAL FORM', specials={'medial',0x062A,0x0647} },
	[0xFCE5] = { unicodeslot=0xFCE5, category='lo', description='ARABIC LIGATURE THEH WITH MEEM MEDIAL FORM', specials={'medial',0x062B,0x0645} },
	[0xFCE6] = { unicodeslot=0xFCE6, category='lo', description='ARABIC LIGATURE THEH WITH HEH MEDIAL FORM', specials={'medial',0x062B,0x0647} },
	[0xFCE7] = { unicodeslot=0xFCE7, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM MEDIAL FORM', specials={'medial',0x0633,0x0645} },
	[0xFCE8] = { unicodeslot=0xFCE8, category='lo', description='ARABIC LIGATURE SEEN WITH HEH MEDIAL FORM', specials={'medial',0x0633,0x0647} },
	[0xFCE9] = { unicodeslot=0xFCE9, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM MEDIAL FORM', specials={'medial',0x0634,0x0645} },
	[0xFCEA] = { unicodeslot=0xFCEA, category='lo', description='ARABIC LIGATURE SHEEN WITH HEH MEDIAL FORM', specials={'medial',0x0634,0x0647} },
	[0xFCEB] = { unicodeslot=0xFCEB, category='lo', description='ARABIC LIGATURE KAF WITH LAM MEDIAL FORM', specials={'medial',0x0643,0x0644} },
	[0xFCEC] = { unicodeslot=0xFCEC, category='lo', description='ARABIC LIGATURE KAF WITH MEEM MEDIAL FORM', specials={'medial',0x0643,0x0645} },
	[0xFCED] = { unicodeslot=0xFCED, category='lo', description='ARABIC LIGATURE LAM WITH MEEM MEDIAL FORM', specials={'medial',0x0644,0x0645} },
	[0xFCEE] = { unicodeslot=0xFCEE, category='lo', description='ARABIC LIGATURE NOON WITH MEEM MEDIAL FORM', specials={'medial',0x0646,0x0645} },
	[0xFCEF] = { unicodeslot=0xFCEF, category='lo', description='ARABIC LIGATURE NOON WITH HEH MEDIAL FORM', specials={'medial',0x0646,0x0647} },
	[0xFCF0] = { unicodeslot=0xFCF0, category='lo', description='ARABIC LIGATURE YEH WITH MEEM MEDIAL FORM', specials={'medial',0x064A,0x0645} },
	[0xFCF1] = { unicodeslot=0xFCF1, category='lo', description='ARABIC LIGATURE YEH WITH HEH MEDIAL FORM', specials={'medial',0x064A,0x0647} },
	[0xFCF2] = { unicodeslot=0xFCF2, category='lo', description='ARABIC LIGATURE SHADDA WITH FATHA MEDIAL FORM', specials={'medial',0x0640,0x064E,0x0651} },
	[0xFCF3] = { unicodeslot=0xFCF3, category='lo', description='ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM', specials={'medial',0x0640,0x064F,0x0651} },
	[0xFCF4] = { unicodeslot=0xFCF4, category='lo', description='ARABIC LIGATURE SHADDA WITH KASRA MEDIAL FORM', specials={'medial',0x0640,0x0650,0x0651} },
	[0xFCF5] = { unicodeslot=0xFCF5, category='lo', description='ARABIC LIGATURE TAH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0637,0x0649} },
	[0xFCF6] = { unicodeslot=0xFCF6, category='lo', description='ARABIC LIGATURE TAH WITH YEH ISOLATED FORM', specials={'isolated',0x0637,0x064A} },
	[0xFCF7] = { unicodeslot=0xFCF7, category='lo', description='ARABIC LIGATURE AIN WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0639,0x0649} },
	[0xFCF8] = { unicodeslot=0xFCF8, category='lo', description='ARABIC LIGATURE AIN WITH YEH ISOLATED FORM', specials={'isolated',0x0639,0x064A} },
	[0xFCF9] = { unicodeslot=0xFCF9, category='lo', description='ARABIC LIGATURE GHAIN WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x063A,0x0649} },
	[0xFCFA] = { unicodeslot=0xFCFA, category='lo', description='ARABIC LIGATURE GHAIN WITH YEH ISOLATED FORM', specials={'isolated',0x063A,0x064A} },
	[0xFCFB] = { unicodeslot=0xFCFB, category='lo', description='ARABIC LIGATURE SEEN WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0633,0x0649} },
	[0xFCFC] = { unicodeslot=0xFCFC, category='lo', description='ARABIC LIGATURE SEEN WITH YEH ISOLATED FORM', specials={'isolated',0x0633,0x064A} },
	[0xFCFD] = { unicodeslot=0xFCFD, category='lo', description='ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0634,0x0649} },
	[0xFCFE] = { unicodeslot=0xFCFE, category='lo', description='ARABIC LIGATURE SHEEN WITH YEH ISOLATED FORM', specials={'isolated',0x0634,0x064A} },
	[0xFCFF] = { unicodeslot=0xFCFF, category='lo', description='ARABIC LIGATURE HAH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x062D,0x0649} },
	[0xFD00] = { unicodeslot=0xFD00, category='lo', description='ARABIC LIGATURE HAH WITH YEH ISOLATED FORM', specials={'isolated',0x062D,0x064A} },
	[0xFD01] = { unicodeslot=0xFD01, category='lo', description='ARABIC LIGATURE JEEM WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x062C,0x0649} },
	[0xFD02] = { unicodeslot=0xFD02, category='lo', description='ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM', specials={'isolated',0x062C,0x064A} },
	[0xFD03] = { unicodeslot=0xFD03, category='lo', description='ARABIC LIGATURE KHAH WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x062E,0x0649} },
	[0xFD04] = { unicodeslot=0xFD04, category='lo', description='ARABIC LIGATURE KHAH WITH YEH ISOLATED FORM', specials={'isolated',0x062E,0x064A} },
	[0xFD05] = { unicodeslot=0xFD05, category='lo', description='ARABIC LIGATURE SAD WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0635,0x0649} },
	[0xFD06] = { unicodeslot=0xFD06, category='lo', description='ARABIC LIGATURE SAD WITH YEH ISOLATED FORM', specials={'isolated',0x0635,0x064A} },
	[0xFD07] = { unicodeslot=0xFD07, category='lo', description='ARABIC LIGATURE DAD WITH ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0636,0x0649} },
	[0xFD08] = { unicodeslot=0xFD08, category='lo', description='ARABIC LIGATURE DAD WITH YEH ISOLATED FORM', specials={'isolated',0x0636,0x064A} },
	[0xFD09] = { unicodeslot=0xFD09, category='lo', description='ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM', specials={'isolated',0x0634,0x062C} },
	[0xFD0A] = { unicodeslot=0xFD0A, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH ISOLATED FORM', specials={'isolated',0x0634,0x062D} },
	[0xFD0B] = { unicodeslot=0xFD0B, category='lo', description='ARABIC LIGATURE SHEEN WITH KHAH ISOLATED FORM', specials={'isolated',0x0634,0x062E} },
	[0xFD0C] = { unicodeslot=0xFD0C, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM ISOLATED FORM', specials={'isolated',0x0634,0x0645} },
	[0xFD0D] = { unicodeslot=0xFD0D, category='lo', description='ARABIC LIGATURE SHEEN WITH REH ISOLATED FORM', specials={'isolated',0x0634,0x0631} },
	[0xFD0E] = { unicodeslot=0xFD0E, category='lo', description='ARABIC LIGATURE SEEN WITH REH ISOLATED FORM', specials={'isolated',0x0633,0x0631} },
	[0xFD0F] = { unicodeslot=0xFD0F, category='lo', description='ARABIC LIGATURE SAD WITH REH ISOLATED FORM', specials={'isolated',0x0635,0x0631} },
	[0xFD10] = { unicodeslot=0xFD10, category='lo', description='ARABIC LIGATURE DAD WITH REH ISOLATED FORM', specials={'isolated',0x0636,0x0631} },
	[0xFD11] = { unicodeslot=0xFD11, category='lo', description='ARABIC LIGATURE TAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0637,0x0649} },
	[0xFD12] = { unicodeslot=0xFD12, category='lo', description='ARABIC LIGATURE TAH WITH YEH FINAL FORM', specials={'final',0x0637,0x064A} },
	[0xFD13] = { unicodeslot=0xFD13, category='lo', description='ARABIC LIGATURE AIN WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0639,0x0649} },
	[0xFD14] = { unicodeslot=0xFD14, category='lo', description='ARABIC LIGATURE AIN WITH YEH FINAL FORM', specials={'final',0x0639,0x064A} },
	[0xFD15] = { unicodeslot=0xFD15, category='lo', description='ARABIC LIGATURE GHAIN WITH ALEF MAKSURA FINAL FORM', specials={'final',0x063A,0x0649} },
	[0xFD16] = { unicodeslot=0xFD16, category='lo', description='ARABIC LIGATURE GHAIN WITH YEH FINAL FORM', specials={'final',0x063A,0x064A} },
	[0xFD17] = { unicodeslot=0xFD17, category='lo', description='ARABIC LIGATURE SEEN WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0633,0x0649} },
	[0xFD18] = { unicodeslot=0xFD18, category='lo', description='ARABIC LIGATURE SEEN WITH YEH FINAL FORM', specials={'final',0x0633,0x064A} },
	[0xFD19] = { unicodeslot=0xFD19, category='lo', description='ARABIC LIGATURE SHEEN WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0634,0x0649} },
	[0xFD1A] = { unicodeslot=0xFD1A, category='lo', description='ARABIC LIGATURE SHEEN WITH YEH FINAL FORM', specials={'final',0x0634,0x064A} },
	[0xFD1B] = { unicodeslot=0xFD1B, category='lo', description='ARABIC LIGATURE HAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062D,0x0649} },
	[0xFD1C] = { unicodeslot=0xFD1C, category='lo', description='ARABIC LIGATURE HAH WITH YEH FINAL FORM', specials={'final',0x062D,0x064A} },
	[0xFD1D] = { unicodeslot=0xFD1D, category='lo', description='ARABIC LIGATURE JEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062C,0x0649} },
	[0xFD1E] = { unicodeslot=0xFD1E, category='lo', description='ARABIC LIGATURE JEEM WITH YEH FINAL FORM', specials={'final',0x062C,0x064A} },
	[0xFD1F] = { unicodeslot=0xFD1F, category='lo', description='ARABIC LIGATURE KHAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062E,0x0649} },
	[0xFD20] = { unicodeslot=0xFD20, category='lo', description='ARABIC LIGATURE KHAH WITH YEH FINAL FORM', specials={'final',0x062E,0x064A} },
	[0xFD21] = { unicodeslot=0xFD21, category='lo', description='ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0635,0x0649} },
	[0xFD22] = { unicodeslot=0xFD22, category='lo', description='ARABIC LIGATURE SAD WITH YEH FINAL FORM', specials={'final',0x0635,0x064A} },
	[0xFD23] = { unicodeslot=0xFD23, category='lo', description='ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0636,0x0649} },
	[0xFD24] = { unicodeslot=0xFD24, category='lo', description='ARABIC LIGATURE DAD WITH YEH FINAL FORM', specials={'final',0x0636,0x064A} },
	[0xFD25] = { unicodeslot=0xFD25, category='lo', description='ARABIC LIGATURE SHEEN WITH JEEM FINAL FORM', specials={'final',0x0634,0x062C} },
	[0xFD26] = { unicodeslot=0xFD26, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH FINAL FORM', specials={'final',0x0634,0x062D} },
	[0xFD27] = { unicodeslot=0xFD27, category='lo', description='ARABIC LIGATURE SHEEN WITH KHAH FINAL FORM', specials={'final',0x0634,0x062E} },
	[0xFD28] = { unicodeslot=0xFD28, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM FINAL FORM', specials={'final',0x0634,0x0645} },
	[0xFD29] = { unicodeslot=0xFD29, category='lo', description='ARABIC LIGATURE SHEEN WITH REH FINAL FORM', specials={'final',0x0634,0x0631} },
	[0xFD2A] = { unicodeslot=0xFD2A, category='lo', description='ARABIC LIGATURE SEEN WITH REH FINAL FORM', specials={'final',0x0633,0x0631} },
	[0xFD2B] = { unicodeslot=0xFD2B, category='lo', description='ARABIC LIGATURE SAD WITH REH FINAL FORM', specials={'final',0x0635,0x0631} },
	[0xFD2C] = { unicodeslot=0xFD2C, category='lo', description='ARABIC LIGATURE DAD WITH REH FINAL FORM', specials={'final',0x0636,0x0631} },
	[0xFD2D] = { unicodeslot=0xFD2D, category='lo', description='ARABIC LIGATURE SHEEN WITH JEEM INITIAL FORM', specials={'initial',0x0634,0x062C} },
	[0xFD2E] = { unicodeslot=0xFD2E, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH INITIAL FORM', specials={'initial',0x0634,0x062D} },
	[0xFD2F] = { unicodeslot=0xFD2F, category='lo', description='ARABIC LIGATURE SHEEN WITH KHAH INITIAL FORM', specials={'initial',0x0634,0x062E} },
	[0xFD30] = { unicodeslot=0xFD30, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM INITIAL FORM', specials={'initial',0x0634,0x0645} },
	[0xFD31] = { unicodeslot=0xFD31, category='lo', description='ARABIC LIGATURE SEEN WITH HEH INITIAL FORM', specials={'initial',0x0633,0x0647} },
	[0xFD32] = { unicodeslot=0xFD32, category='lo', description='ARABIC LIGATURE SHEEN WITH HEH INITIAL FORM', specials={'initial',0x0634,0x0647} },
	[0xFD33] = { unicodeslot=0xFD33, category='lo', description='ARABIC LIGATURE TAH WITH MEEM INITIAL FORM', specials={'initial',0x0637,0x0645} },
	[0xFD34] = { unicodeslot=0xFD34, category='lo', description='ARABIC LIGATURE SEEN WITH JEEM MEDIAL FORM', specials={'medial',0x0633,0x062C} },
	[0xFD35] = { unicodeslot=0xFD35, category='lo', description='ARABIC LIGATURE SEEN WITH HAH MEDIAL FORM', specials={'medial',0x0633,0x062D} },
	[0xFD36] = { unicodeslot=0xFD36, category='lo', description='ARABIC LIGATURE SEEN WITH KHAH MEDIAL FORM', specials={'medial',0x0633,0x062E} },
	[0xFD37] = { unicodeslot=0xFD37, category='lo', description='ARABIC LIGATURE SHEEN WITH JEEM MEDIAL FORM', specials={'medial',0x0634,0x062C} },
	[0xFD38] = { unicodeslot=0xFD38, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH MEDIAL FORM', specials={'medial',0x0634,0x062D} },
	[0xFD39] = { unicodeslot=0xFD39, category='lo', description='ARABIC LIGATURE SHEEN WITH KHAH MEDIAL FORM', specials={'medial',0x0634,0x062E} },
	[0xFD3A] = { unicodeslot=0xFD3A, category='lo', description='ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM', specials={'medial',0x0637,0x0645} },
	[0xFD3B] = { unicodeslot=0xFD3B, category='lo', description='ARABIC LIGATURE ZAH WITH MEEM MEDIAL FORM', specials={'medial',0x0638,0x0645} },
	[0xFD3C] = { unicodeslot=0xFD3C, category='lo', description='ARABIC LIGATURE ALEF WITH FATHATAN FINAL FORM', specials={'final',0x0627,0x064B} },
	[0xFD3D] = { unicodeslot=0xFD3D, category='lo', description='ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM', specials={'isolated',0x0627,0x064B} },
	[0xFD3E] = { unicodeslot=0xFD3E, category='ps', description='ORNATE LEFT PARENTHESIS' },
	[0xFD3F] = { unicodeslot=0xFD3F, category='pe', description='ORNATE RIGHT PARENTHESIS' },
	[0xFD50] = { unicodeslot=0xFD50, category='lo', description='ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM', specials={'initial',0x062A,0x062C,0x0645} },
	[0xFD51] = { unicodeslot=0xFD51, category='lo', description='ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM', specials={'final',0x062A,0x062D,0x062C} },
	[0xFD52] = { unicodeslot=0xFD52, category='lo', description='ARABIC LIGATURE TEH WITH HAH WITH JEEM INITIAL FORM', specials={'initial',0x062A,0x062D,0x062C} },
	[0xFD53] = { unicodeslot=0xFD53, category='lo', description='ARABIC LIGATURE TEH WITH HAH WITH MEEM INITIAL FORM', specials={'initial',0x062A,0x062D,0x0645} },
	[0xFD54] = { unicodeslot=0xFD54, category='lo', description='ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM', specials={'initial',0x062A,0x062E,0x0645} },
	[0xFD55] = { unicodeslot=0xFD55, category='lo', description='ARABIC LIGATURE TEH WITH MEEM WITH JEEM INITIAL FORM', specials={'initial',0x062A,0x0645,0x062C} },
	[0xFD56] = { unicodeslot=0xFD56, category='lo', description='ARABIC LIGATURE TEH WITH MEEM WITH HAH INITIAL FORM', specials={'initial',0x062A,0x0645,0x062D} },
	[0xFD57] = { unicodeslot=0xFD57, category='lo', description='ARABIC LIGATURE TEH WITH MEEM WITH KHAH INITIAL FORM', specials={'initial',0x062A,0x0645,0x062E} },
	[0xFD58] = { unicodeslot=0xFD58, category='lo', description='ARABIC LIGATURE JEEM WITH MEEM WITH HAH FINAL FORM', specials={'final',0x062C,0x0645,0x062D} },
	[0xFD59] = { unicodeslot=0xFD59, category='lo', description='ARABIC LIGATURE JEEM WITH MEEM WITH HAH INITIAL FORM', specials={'initial',0x062C,0x0645,0x062D} },
	[0xFD5A] = { unicodeslot=0xFD5A, category='lo', description='ARABIC LIGATURE HAH WITH MEEM WITH YEH FINAL FORM', specials={'final',0x062D,0x0645,0x064A} },
	[0xFD5B] = { unicodeslot=0xFD5B, category='lo', description='ARABIC LIGATURE HAH WITH MEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062D,0x0645,0x0649} },
	[0xFD5C] = { unicodeslot=0xFD5C, category='lo', description='ARABIC LIGATURE SEEN WITH HAH WITH JEEM INITIAL FORM', specials={'initial',0x0633,0x062D,0x062C} },
	[0xFD5D] = { unicodeslot=0xFD5D, category='lo', description='ARABIC LIGATURE SEEN WITH JEEM WITH HAH INITIAL FORM', specials={'initial',0x0633,0x062C,0x062D} },
	[0xFD5E] = { unicodeslot=0xFD5E, category='lo', description='ARABIC LIGATURE SEEN WITH JEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0633,0x062C,0x0649} },
	[0xFD5F] = { unicodeslot=0xFD5F, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM WITH HAH FINAL FORM', specials={'final',0x0633,0x0645,0x062D} },
	[0xFD60] = { unicodeslot=0xFD60, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM WITH HAH INITIAL FORM', specials={'initial',0x0633,0x0645,0x062D} },
	[0xFD61] = { unicodeslot=0xFD61, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM WITH JEEM INITIAL FORM', specials={'initial',0x0633,0x0645,0x062C} },
	[0xFD62] = { unicodeslot=0xFD62, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x0633,0x0645,0x0645} },
	[0xFD63] = { unicodeslot=0xFD63, category='lo', description='ARABIC LIGATURE SEEN WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0633,0x0645,0x0645} },
	[0xFD64] = { unicodeslot=0xFD64, category='lo', description='ARABIC LIGATURE SAD WITH HAH WITH HAH FINAL FORM', specials={'final',0x0635,0x062D,0x062D} },
	[0xFD65] = { unicodeslot=0xFD65, category='lo', description='ARABIC LIGATURE SAD WITH HAH WITH HAH INITIAL FORM', specials={'initial',0x0635,0x062D,0x062D} },
	[0xFD66] = { unicodeslot=0xFD66, category='lo', description='ARABIC LIGATURE SAD WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x0635,0x0645,0x0645} },
	[0xFD67] = { unicodeslot=0xFD67, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM', specials={'final',0x0634,0x062D,0x0645} },
	[0xFD68] = { unicodeslot=0xFD68, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH WITH MEEM INITIAL FORM', specials={'initial',0x0634,0x062D,0x0645} },
	[0xFD69] = { unicodeslot=0xFD69, category='lo', description='ARABIC LIGATURE SHEEN WITH JEEM WITH YEH FINAL FORM', specials={'final',0x0634,0x062C,0x064A} },
	[0xFD6A] = { unicodeslot=0xFD6A, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH FINAL FORM', specials={'final',0x0634,0x0645,0x062E} },
	[0xFD6B] = { unicodeslot=0xFD6B, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH INITIAL FORM', specials={'initial',0x0634,0x0645,0x062E} },
	[0xFD6C] = { unicodeslot=0xFD6C, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x0634,0x0645,0x0645} },
	[0xFD6D] = { unicodeslot=0xFD6D, category='lo', description='ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0634,0x0645,0x0645} },
	[0xFD6E] = { unicodeslot=0xFD6E, category='lo', description='ARABIC LIGATURE DAD WITH HAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0636,0x062D,0x0649} },
	[0xFD6F] = { unicodeslot=0xFD6F, category='lo', description='ARABIC LIGATURE DAD WITH KHAH WITH MEEM FINAL FORM', specials={'final',0x0636,0x062E,0x0645} },
	[0xFD70] = { unicodeslot=0xFD70, category='lo', description='ARABIC LIGATURE DAD WITH KHAH WITH MEEM INITIAL FORM', specials={'initial',0x0636,0x062E,0x0645} },
	[0xFD71] = { unicodeslot=0xFD71, category='lo', description='ARABIC LIGATURE TAH WITH MEEM WITH HAH FINAL FORM', specials={'final',0x0637,0x0645,0x062D} },
	[0xFD72] = { unicodeslot=0xFD72, category='lo', description='ARABIC LIGATURE TAH WITH MEEM WITH HAH INITIAL FORM', specials={'initial',0x0637,0x0645,0x062D} },
	[0xFD73] = { unicodeslot=0xFD73, category='lo', description='ARABIC LIGATURE TAH WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0637,0x0645,0x0645} },
	[0xFD74] = { unicodeslot=0xFD74, category='lo', description='ARABIC LIGATURE TAH WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0637,0x0645,0x064A} },
	[0xFD75] = { unicodeslot=0xFD75, category='lo', description='ARABIC LIGATURE AIN WITH JEEM WITH MEEM FINAL FORM', specials={'final',0x0639,0x062C,0x0645} },
	[0xFD76] = { unicodeslot=0xFD76, category='lo', description='ARABIC LIGATURE AIN WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x0639,0x0645,0x0645} },
	[0xFD77] = { unicodeslot=0xFD77, category='lo', description='ARABIC LIGATURE AIN WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0639,0x0645,0x0645} },
	[0xFD78] = { unicodeslot=0xFD78, category='lo', description='ARABIC LIGATURE AIN WITH MEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0639,0x0645,0x0649} },
	[0xFD79] = { unicodeslot=0xFD79, category='lo', description='ARABIC LIGATURE GHAIN WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x063A,0x0645,0x0645} },
	[0xFD7A] = { unicodeslot=0xFD7A, category='lo', description='ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM', specials={'final',0x063A,0x0645,0x064A} },
	[0xFD7B] = { unicodeslot=0xFD7B, category='lo', description='ARABIC LIGATURE GHAIN WITH MEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x063A,0x0645,0x0649} },
	[0xFD7C] = { unicodeslot=0xFD7C, category='lo', description='ARABIC LIGATURE FEH WITH KHAH WITH MEEM FINAL FORM', specials={'final',0x0641,0x062E,0x0645} },
	[0xFD7D] = { unicodeslot=0xFD7D, category='lo', description='ARABIC LIGATURE FEH WITH KHAH WITH MEEM INITIAL FORM', specials={'initial',0x0641,0x062E,0x0645} },
	[0xFD7E] = { unicodeslot=0xFD7E, category='lo', description='ARABIC LIGATURE QAF WITH MEEM WITH HAH FINAL FORM', specials={'final',0x0642,0x0645,0x062D} },
	[0xFD7F] = { unicodeslot=0xFD7F, category='lo', description='ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x0642,0x0645,0x0645} },
	[0xFD80] = { unicodeslot=0xFD80, category='lo', description='ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM', specials={'final',0x0644,0x062D,0x0645} },
	[0xFD81] = { unicodeslot=0xFD81, category='lo', description='ARABIC LIGATURE LAM WITH HAH WITH YEH FINAL FORM', specials={'final',0x0644,0x062D,0x064A} },
	[0xFD82] = { unicodeslot=0xFD82, category='lo', description='ARABIC LIGATURE LAM WITH HAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0644,0x062D,0x0649} },
	[0xFD83] = { unicodeslot=0xFD83, category='lo', description='ARABIC LIGATURE LAM WITH JEEM WITH JEEM INITIAL FORM', specials={'initial',0x0644,0x062C,0x062C} },
	[0xFD84] = { unicodeslot=0xFD84, category='lo', description='ARABIC LIGATURE LAM WITH JEEM WITH JEEM FINAL FORM', specials={'final',0x0644,0x062C,0x062C} },
	[0xFD85] = { unicodeslot=0xFD85, category='lo', description='ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM', specials={'final',0x0644,0x062E,0x0645} },
	[0xFD86] = { unicodeslot=0xFD86, category='lo', description='ARABIC LIGATURE LAM WITH KHAH WITH MEEM INITIAL FORM', specials={'initial',0x0644,0x062E,0x0645} },
	[0xFD87] = { unicodeslot=0xFD87, category='lo', description='ARABIC LIGATURE LAM WITH MEEM WITH HAH FINAL FORM', specials={'final',0x0644,0x0645,0x062D} },
	[0xFD88] = { unicodeslot=0xFD88, category='lo', description='ARABIC LIGATURE LAM WITH MEEM WITH HAH INITIAL FORM', specials={'initial',0x0644,0x0645,0x062D} },
	[0xFD89] = { unicodeslot=0xFD89, category='lo', description='ARABIC LIGATURE MEEM WITH HAH WITH JEEM INITIAL FORM', specials={'initial',0x0645,0x062D,0x062C} },
	[0xFD8A] = { unicodeslot=0xFD8A, category='lo', description='ARABIC LIGATURE MEEM WITH HAH WITH MEEM INITIAL FORM', specials={'initial',0x0645,0x062D,0x0645} },
	[0xFD8B] = { unicodeslot=0xFD8B, category='lo', description='ARABIC LIGATURE MEEM WITH HAH WITH YEH FINAL FORM', specials={'final',0x0645,0x062D,0x064A} },
	[0xFD8C] = { unicodeslot=0xFD8C, category='lo', description='ARABIC LIGATURE MEEM WITH JEEM WITH HAH INITIAL FORM', specials={'initial',0x0645,0x062C,0x062D} },
	[0xFD8D] = { unicodeslot=0xFD8D, category='lo', description='ARABIC LIGATURE MEEM WITH JEEM WITH MEEM INITIAL FORM', specials={'initial',0x0645,0x062C,0x0645} },
	[0xFD8E] = { unicodeslot=0xFD8E, category='lo', description='ARABIC LIGATURE MEEM WITH KHAH WITH JEEM INITIAL FORM', specials={'initial',0x0645,0x062E,0x062C} },
	[0xFD8F] = { unicodeslot=0xFD8F, category='lo', description='ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM', specials={'initial',0x0645,0x062E,0x0645} },
	[0xFD92] = { unicodeslot=0xFD92, category='lo', description='ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM', specials={'initial',0x0645,0x062C,0x062E} },
	[0xFD93] = { unicodeslot=0xFD93, category='lo', description='ARABIC LIGATURE HEH WITH MEEM WITH JEEM INITIAL FORM', specials={'initial',0x0647,0x0645,0x062C} },
	[0xFD94] = { unicodeslot=0xFD94, category='lo', description='ARABIC LIGATURE HEH WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0647,0x0645,0x0645} },
	[0xFD95] = { unicodeslot=0xFD95, category='lo', description='ARABIC LIGATURE NOON WITH HAH WITH MEEM INITIAL FORM', specials={'initial',0x0646,0x062D,0x0645} },
	[0xFD96] = { unicodeslot=0xFD96, category='lo', description='ARABIC LIGATURE NOON WITH HAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0646,0x062D,0x0649} },
	[0xFD97] = { unicodeslot=0xFD97, category='lo', description='ARABIC LIGATURE NOON WITH JEEM WITH MEEM FINAL FORM', specials={'final',0x0646,0x062C,0x0645} },
	[0xFD98] = { unicodeslot=0xFD98, category='lo', description='ARABIC LIGATURE NOON WITH JEEM WITH MEEM INITIAL FORM', specials={'initial',0x0646,0x062C,0x0645} },
	[0xFD99] = { unicodeslot=0xFD99, category='lo', description='ARABIC LIGATURE NOON WITH JEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0646,0x062C,0x0649} },
	[0xFD9A] = { unicodeslot=0xFD9A, category='lo', description='ARABIC LIGATURE NOON WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0646,0x0645,0x064A} },
	[0xFD9B] = { unicodeslot=0xFD9B, category='lo', description='ARABIC LIGATURE NOON WITH MEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0646,0x0645,0x0649} },
	[0xFD9C] = { unicodeslot=0xFD9C, category='lo', description='ARABIC LIGATURE YEH WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x064A,0x0645,0x0645} },
	[0xFD9D] = { unicodeslot=0xFD9D, category='lo', description='ARABIC LIGATURE YEH WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x064A,0x0645,0x0645} },
	[0xFD9E] = { unicodeslot=0xFD9E, category='lo', description='ARABIC LIGATURE BEH WITH KHAH WITH YEH FINAL FORM', specials={'final',0x0628,0x062E,0x064A} },
	[0xFD9F] = { unicodeslot=0xFD9F, category='lo', description='ARABIC LIGATURE TEH WITH JEEM WITH YEH FINAL FORM', specials={'final',0x062A,0x062C,0x064A} },
	[0xFDA0] = { unicodeslot=0xFDA0, category='lo', description='ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062A,0x062C,0x0649} },
	[0xFDA1] = { unicodeslot=0xFDA1, category='lo', description='ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM', specials={'final',0x062A,0x062E,0x064A} },
	[0xFDA2] = { unicodeslot=0xFDA2, category='lo', description='ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062A,0x062E,0x0649} },
	[0xFDA3] = { unicodeslot=0xFDA3, category='lo', description='ARABIC LIGATURE TEH WITH MEEM WITH YEH FINAL FORM', specials={'final',0x062A,0x0645,0x064A} },
	[0xFDA4] = { unicodeslot=0xFDA4, category='lo', description='ARABIC LIGATURE TEH WITH MEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062A,0x0645,0x0649} },
	[0xFDA5] = { unicodeslot=0xFDA5, category='lo', description='ARABIC LIGATURE JEEM WITH MEEM WITH YEH FINAL FORM', specials={'final',0x062C,0x0645,0x064A} },
	[0xFDA6] = { unicodeslot=0xFDA6, category='lo', description='ARABIC LIGATURE JEEM WITH HAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062C,0x062D,0x0649} },
	[0xFDA7] = { unicodeslot=0xFDA7, category='lo', description='ARABIC LIGATURE JEEM WITH MEEM WITH ALEF MAKSURA FINAL FORM', specials={'final',0x062C,0x0645,0x0649} },
	[0xFDA8] = { unicodeslot=0xFDA8, category='lo', description='ARABIC LIGATURE SEEN WITH KHAH WITH ALEF MAKSURA FINAL FORM', specials={'final',0x0633,0x062E,0x0649} },
	[0xFDA9] = { unicodeslot=0xFDA9, category='lo', description='ARABIC LIGATURE SAD WITH HAH WITH YEH FINAL FORM', specials={'final',0x0635,0x062D,0x064A} },
	[0xFDAA] = { unicodeslot=0xFDAA, category='lo', description='ARABIC LIGATURE SHEEN WITH HAH WITH YEH FINAL FORM', specials={'final',0x0634,0x062D,0x064A} },
	[0xFDAB] = { unicodeslot=0xFDAB, category='lo', description='ARABIC LIGATURE DAD WITH HAH WITH YEH FINAL FORM', specials={'final',0x0636,0x062D,0x064A} },
	[0xFDAC] = { unicodeslot=0xFDAC, category='lo', description='ARABIC LIGATURE LAM WITH JEEM WITH YEH FINAL FORM', specials={'final',0x0644,0x062C,0x064A} },
	[0xFDAD] = { unicodeslot=0xFDAD, category='lo', description='ARABIC LIGATURE LAM WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0644,0x0645,0x064A} },
	[0xFDAE] = { unicodeslot=0xFDAE, category='lo', description='ARABIC LIGATURE YEH WITH HAH WITH YEH FINAL FORM', specials={'final',0x064A,0x062D,0x064A} },
	[0xFDAF] = { unicodeslot=0xFDAF, category='lo', description='ARABIC LIGATURE YEH WITH JEEM WITH YEH FINAL FORM', specials={'final',0x064A,0x062C,0x064A} },
	[0xFDB0] = { unicodeslot=0xFDB0, category='lo', description='ARABIC LIGATURE YEH WITH MEEM WITH YEH FINAL FORM', specials={'final',0x064A,0x0645,0x064A} },
	[0xFDB1] = { unicodeslot=0xFDB1, category='lo', description='ARABIC LIGATURE MEEM WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0645,0x0645,0x064A} },
	[0xFDB2] = { unicodeslot=0xFDB2, category='lo', description='ARABIC LIGATURE QAF WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0642,0x0645,0x064A} },
	[0xFDB3] = { unicodeslot=0xFDB3, category='lo', description='ARABIC LIGATURE NOON WITH HAH WITH YEH FINAL FORM', specials={'final',0x0646,0x062D,0x064A} },
	[0xFDB4] = { unicodeslot=0xFDB4, category='lo', description='ARABIC LIGATURE QAF WITH MEEM WITH HAH INITIAL FORM', specials={'initial',0x0642,0x0645,0x062D} },
	[0xFDB5] = { unicodeslot=0xFDB5, category='lo', description='ARABIC LIGATURE LAM WITH HAH WITH MEEM INITIAL FORM', specials={'initial',0x0644,0x062D,0x0645} },
	[0xFDB6] = { unicodeslot=0xFDB6, category='lo', description='ARABIC LIGATURE AIN WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0639,0x0645,0x064A} },
	[0xFDB7] = { unicodeslot=0xFDB7, category='lo', description='ARABIC LIGATURE KAF WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0643,0x0645,0x064A} },
	[0xFDB8] = { unicodeslot=0xFDB8, category='lo', description='ARABIC LIGATURE NOON WITH JEEM WITH HAH INITIAL FORM', specials={'initial',0x0646,0x062C,0x062D} },
	[0xFDB9] = { unicodeslot=0xFDB9, category='lo', description='ARABIC LIGATURE MEEM WITH KHAH WITH YEH FINAL FORM', specials={'final',0x0645,0x062E,0x064A} },
	[0xFDBA] = { unicodeslot=0xFDBA, category='lo', description='ARABIC LIGATURE LAM WITH JEEM WITH MEEM INITIAL FORM', specials={'initial',0x0644,0x062C,0x0645} },
	[0xFDBB] = { unicodeslot=0xFDBB, category='lo', description='ARABIC LIGATURE KAF WITH MEEM WITH MEEM FINAL FORM', specials={'final',0x0643,0x0645,0x0645} },
	[0xFDBC] = { unicodeslot=0xFDBC, category='lo', description='ARABIC LIGATURE LAM WITH JEEM WITH MEEM FINAL FORM', specials={'final',0x0644,0x062C,0x0645} },
	[0xFDBD] = { unicodeslot=0xFDBD, category='lo', description='ARABIC LIGATURE NOON WITH JEEM WITH HAH FINAL FORM', specials={'final',0x0646,0x062C,0x062D} },
	[0xFDBE] = { unicodeslot=0xFDBE, category='lo', description='ARABIC LIGATURE JEEM WITH HAH WITH YEH FINAL FORM', specials={'final',0x062C,0x062D,0x064A} },
	[0xFDBF] = { unicodeslot=0xFDBF, category='lo', description='ARABIC LIGATURE HAH WITH JEEM WITH YEH FINAL FORM', specials={'final',0x062D,0x062C,0x064A} },
	[0xFDC0] = { unicodeslot=0xFDC0, category='lo', description='ARABIC LIGATURE MEEM WITH JEEM WITH YEH FINAL FORM', specials={'final',0x0645,0x062C,0x064A} },
	[0xFDC1] = { unicodeslot=0xFDC1, category='lo', description='ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM', specials={'final',0x0641,0x0645,0x064A} },
	[0xFDC2] = { unicodeslot=0xFDC2, category='lo', description='ARABIC LIGATURE BEH WITH HAH WITH YEH FINAL FORM', specials={'final',0x0628,0x062D,0x064A} },
	[0xFDC3] = { unicodeslot=0xFDC3, category='lo', description='ARABIC LIGATURE KAF WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0643,0x0645,0x0645} },
	[0xFDC4] = { unicodeslot=0xFDC4, category='lo', description='ARABIC LIGATURE AIN WITH JEEM WITH MEEM INITIAL FORM', specials={'initial',0x0639,0x062C,0x0645} },
	[0xFDC5] = { unicodeslot=0xFDC5, category='lo', description='ARABIC LIGATURE SAD WITH MEEM WITH MEEM INITIAL FORM', specials={'initial',0x0635,0x0645,0x0645} },
	[0xFDC6] = { unicodeslot=0xFDC6, category='lo', description='ARABIC LIGATURE SEEN WITH KHAH WITH YEH FINAL FORM', specials={'final',0x0633,0x062E,0x064A} },
	[0xFDC7] = { unicodeslot=0xFDC7, category='lo', description='ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM', specials={'final',0x0646,0x062C,0x064A} },
	[0xFDF0] = { unicodeslot=0xFDF0, category='lo', description='ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM', specials={'isolated',0x0635,0x0644,0x06D2} },
	[0xFDF1] = { unicodeslot=0xFDF1, category='lo', description='ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM', specials={'isolated',0x0642,0x0644,0x06D2} },
	[0xFDF2] = { unicodeslot=0xFDF2, category='lo', description='ARABIC LIGATURE ALLAH ISOLATED FORM', specials={'isolated',0x0627,0x0644,0x0644,0x0647} },
	[0xFDF3] = { unicodeslot=0xFDF3, category='lo', description='ARABIC LIGATURE AKBAR ISOLATED FORM', specials={'isolated',0x0627,0x0643,0x0628,0x0631} },
	[0xFDF4] = { unicodeslot=0xFDF4, category='lo', description='ARABIC LIGATURE MOHAMMAD ISOLATED FORM', specials={'isolated',0x0645,0x062D,0x0645,0x062F} },
	[0xFDF5] = { unicodeslot=0xFDF5, category='lo', description='ARABIC LIGATURE SALAM ISOLATED FORM', specials={'isolated',0x0635,0x0644,0x0639,0x0645} },
	[0xFDF6] = { unicodeslot=0xFDF6, category='lo', description='ARABIC LIGATURE RASOUL ISOLATED FORM', specials={'isolated',0x0631,0x0633,0x0648,0x0644} },
	[0xFDF7] = { unicodeslot=0xFDF7, category='lo', description='ARABIC LIGATURE ALAYHE ISOLATED FORM', specials={'isolated',0x0639,0x0644,0x064A,0x0647} },
	[0xFDF8] = { unicodeslot=0xFDF8, category='lo', description='ARABIC LIGATURE WASALLAM ISOLATED FORM', specials={'isolated',0x0648,0x0633,0x0644,0x0645} },
	[0xFDF9] = { unicodeslot=0xFDF9, category='lo', description='ARABIC LIGATURE SALLA ISOLATED FORM', specials={'isolated',0x0635,0x0644,0x0649} },
	[0xFDFA] = { unicodeslot=0xFDFA, category='lo', description='ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM', specials={'isolated',0x0635,0x0644,0x0649,0x0020,0x0627,0x0644,0x0644,0x0647,0x0020,0x0639,0x0644,0x064A,0x0647,0x0020,0x0648,0x0633,0x0644,0x0645} },
	[0xFDFB] = { unicodeslot=0xFDFB, category='lo', description='ARABIC LIGATURE JALLAJALALOUHOU', specials={'isolated',0x062C,0x0644,0x0020,0x062C,0x0644,0x0627,0x0644,0x0647} },
	[0xFDFC] = { unicodeslot=0xFDFC, category='sc', description='RIAL SIGN', specials={'isolated',0x0631,0x06CC,0x0627,0x0644} },
	[0xFDFD] = { unicodeslot=0xFDFD, category='so', description='ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM' },
	[0xFE00] = { unicodeslot=0xFE00, category='mn', description='VARIATION SELECTOR-1' },
	[0xFE01] = { unicodeslot=0xFE01, category='mn', description='VARIATION SELECTOR-2' },
	[0xFE02] = { unicodeslot=0xFE02, category='mn', description='VARIATION SELECTOR-3' },
	[0xFE03] = { unicodeslot=0xFE03, category='mn', description='VARIATION SELECTOR-4' },
	[0xFE04] = { unicodeslot=0xFE04, category='mn', description='VARIATION SELECTOR-5' },
	[0xFE05] = { unicodeslot=0xFE05, category='mn', description='VARIATION SELECTOR-6' },
	[0xFE06] = { unicodeslot=0xFE06, category='mn', description='VARIATION SELECTOR-7' },
	[0xFE07] = { unicodeslot=0xFE07, category='mn', description='VARIATION SELECTOR-8' },
	[0xFE08] = { unicodeslot=0xFE08, category='mn', description='VARIATION SELECTOR-9' },
	[0xFE09] = { unicodeslot=0xFE09, category='mn', description='VARIATION SELECTOR-10' },
	[0xFE0A] = { unicodeslot=0xFE0A, category='mn', description='VARIATION SELECTOR-11' },
	[0xFE0B] = { unicodeslot=0xFE0B, category='mn', description='VARIATION SELECTOR-12' },
	[0xFE0C] = { unicodeslot=0xFE0C, category='mn', description='VARIATION SELECTOR-13' },
	[0xFE0D] = { unicodeslot=0xFE0D, category='mn', description='VARIATION SELECTOR-14' },
	[0xFE0E] = { unicodeslot=0xFE0E, category='mn', description='VARIATION SELECTOR-15' },
	[0xFE0F] = { unicodeslot=0xFE0F, category='mn', description='VARIATION SELECTOR-16' },
	[0xFE10] = { unicodeslot=0xFE10, category='po', description='PRESENTATION FORM FOR VERTICAL COMMA', specials={'vertical',0x002C} },
	[0xFE11] = { unicodeslot=0xFE11, category='po', description='PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA', specials={'vertical',0x3001} },
	[0xFE12] = { unicodeslot=0xFE12, category='po', description='PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP', specials={'vertical',0x3002} },
	[0xFE13] = { unicodeslot=0xFE13, category='po', description='PRESENTATION FORM FOR VERTICAL COLON', specials={'vertical',0x003A} },
	[0xFE14] = { unicodeslot=0xFE14, category='po', description='PRESENTATION FORM FOR VERTICAL SEMICOLON', specials={'vertical',0x003B} },
	[0xFE15] = { unicodeslot=0xFE15, category='po', description='PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK', specials={'vertical',0x0021} },
	[0xFE16] = { unicodeslot=0xFE16, category='po', description='PRESENTATION FORM FOR VERTICAL QUESTION MARK', specials={'vertical',0x003F} },
	[0xFE17] = { unicodeslot=0xFE17, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET', specials={'vertical',0x3016} },
	[0xFE18] = { unicodeslot=0xFE18, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET', specials={'vertical',0x3017} },
	[0xFE19] = { unicodeslot=0xFE19, category='po', description='PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS', specials={'vertical',0x2026} },
	[0xFE20] = { unicodeslot=0xFE20, category='mn', description='COMBINING LIGATURE LEFT HALF' },
	[0xFE21] = { unicodeslot=0xFE21, category='mn', description='COMBINING LIGATURE RIGHT HALF' },
	[0xFE22] = { unicodeslot=0xFE22, category='mn', description='COMBINING DOUBLE TILDE LEFT HALF' },
	[0xFE23] = { unicodeslot=0xFE23, category='mn', description='COMBINING DOUBLE TILDE RIGHT HALF' },
	[0xFE30] = { unicodeslot=0xFE30, category='po', description='PRESENTATION FORM FOR VERTICAL TWO DOT LEADER', specials={'vertical',0x2025} },
	[0xFE31] = { unicodeslot=0xFE31, category='pd', description='PRESENTATION FORM FOR VERTICAL EM DASH', specials={'vertical',0x2014} },
	[0xFE32] = { unicodeslot=0xFE32, category='pd', description='PRESENTATION FORM FOR VERTICAL EN DASH', specials={'vertical',0x2013} },
	[0xFE33] = { unicodeslot=0xFE33, category='pc', description='PRESENTATION FORM FOR VERTICAL LOW LINE', specials={'vertical',0x005F} },
	[0xFE34] = { unicodeslot=0xFE34, category='pc', description='PRESENTATION FORM FOR VERTICAL WAVY LOW LINE', specials={'vertical',0x005F} },
	[0xFE35] = { unicodeslot=0xFE35, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS', specials={'vertical',0x0028} },
	[0xFE36] = { unicodeslot=0xFE36, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS', specials={'vertical',0x0029} },
	[0xFE37] = { unicodeslot=0xFE37, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET', specials={'vertical',0x007B} },
	[0xFE38] = { unicodeslot=0xFE38, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET', specials={'vertical',0x007D} },
	[0xFE39] = { unicodeslot=0xFE39, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET', specials={'vertical',0x3014} },
	[0xFE3A] = { unicodeslot=0xFE3A, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET', specials={'vertical',0x3015} },
	[0xFE3B] = { unicodeslot=0xFE3B, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET', specials={'vertical',0x3010} },
	[0xFE3C] = { unicodeslot=0xFE3C, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET', specials={'vertical',0x3011} },
	[0xFE3D] = { unicodeslot=0xFE3D, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET', specials={'vertical',0x300A} },
	[0xFE3E] = { unicodeslot=0xFE3E, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET', specials={'vertical',0x300B} },
	[0xFE3F] = { unicodeslot=0xFE3F, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET', specials={'vertical',0x3008} },
	[0xFE40] = { unicodeslot=0xFE40, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET', specials={'vertical',0x3009} },
	[0xFE41] = { unicodeslot=0xFE41, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET', specials={'vertical',0x300C} },
	[0xFE42] = { unicodeslot=0xFE42, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET', specials={'vertical',0x300D} },
	[0xFE43] = { unicodeslot=0xFE43, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET', specials={'vertical',0x300E} },
	[0xFE44] = { unicodeslot=0xFE44, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET', specials={'vertical',0x300F} },
	[0xFE45] = { unicodeslot=0xFE45, category='po', description='SESAME DOT' },
	[0xFE46] = { unicodeslot=0xFE46, category='po', description='WHITE SESAME DOT' },
	[0xFE47] = { unicodeslot=0xFE47, category='ps', description='PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET', specials={'vertical',0x005B} },
	[0xFE48] = { unicodeslot=0xFE48, category='pe', description='PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET', specials={'vertical',0x005D} },
	[0xFE49] = { unicodeslot=0xFE49, category='po', description='DASHED OVERLINE', specials={'compat',0x203E} },
	[0xFE4A] = { unicodeslot=0xFE4A, category='po', description='CENTRELINE OVERLINE', specials={'compat',0x203E} },
	[0xFE4B] = { unicodeslot=0xFE4B, category='po', description='WAVY OVERLINE', specials={'compat',0x203E} },
	[0xFE4C] = { unicodeslot=0xFE4C, category='po', description='DOUBLE WAVY OVERLINE', specials={'compat',0x203E} },
	[0xFE4D] = { unicodeslot=0xFE4D, category='pc', description='DASHED LOW LINE', specials={'compat',0x005F} },
	[0xFE4E] = { unicodeslot=0xFE4E, category='pc', description='CENTRELINE LOW LINE', specials={'compat',0x005F} },
	[0xFE4F] = { unicodeslot=0xFE4F, category='pc', description='WAVY LOW LINE', specials={'compat',0x005F} },
	[0xFE50] = { unicodeslot=0xFE50, category='po', description='SMALL COMMA', specials={'small',0x002C} },
	[0xFE51] = { unicodeslot=0xFE51, category='po', description='SMALL IDEOGRAPHIC COMMA', specials={'small',0x3001} },
	[0xFE52] = { unicodeslot=0xFE52, category='po', description='SMALL FULL STOP', specials={'small',0x002E} },
	[0xFE54] = { unicodeslot=0xFE54, category='po', description='SMALL SEMICOLON', specials={'small',0x003B} },
	[0xFE55] = { unicodeslot=0xFE55, category='po', description='SMALL COLON', specials={'small',0x003A} },
	[0xFE56] = { unicodeslot=0xFE56, category='po', description='SMALL QUESTION MARK', specials={'small',0x003F} },
	[0xFE57] = { unicodeslot=0xFE57, category='po', description='SMALL EXCLAMATION MARK', specials={'small',0x0021} },
	[0xFE58] = { unicodeslot=0xFE58, category='pd', description='SMALL EM DASH', specials={'small',0x2014} },
	[0xFE59] = { unicodeslot=0xFE59, category='ps', description='SMALL LEFT PARENTHESIS', specials={'small',0x0028} },
	[0xFE5A] = { unicodeslot=0xFE5A, category='pe', description='SMALL RIGHT PARENTHESIS', specials={'small',0x0029} },
	[0xFE5B] = { unicodeslot=0xFE5B, category='ps', description='SMALL LEFT CURLY BRACKET', specials={'small',0x007B} },
	[0xFE5C] = { unicodeslot=0xFE5C, category='pe', description='SMALL RIGHT CURLY BRACKET', specials={'small',0x007D} },
	[0xFE5D] = { unicodeslot=0xFE5D, category='ps', description='SMALL LEFT TORTOISE SHELL BRACKET', specials={'small',0x3014} },
	[0xFE5E] = { unicodeslot=0xFE5E, category='pe', description='SMALL RIGHT TORTOISE SHELL BRACKET', specials={'small',0x3015} },
	[0xFE5F] = { unicodeslot=0xFE5F, category='po', description='SMALL NUMBER SIGN', specials={'small',0x0023} },
	[0xFE60] = { unicodeslot=0xFE60, category='po', description='SMALL AMPERSAND', specials={'small',0x0026} },
	[0xFE61] = { unicodeslot=0xFE61, category='po', description='SMALL ASTERISK', specials={'small',0x002A} },
	[0xFE62] = { unicodeslot=0xFE62, category='sm', description='SMALL PLUS SIGN', specials={'small',0x002B} },
	[0xFE63] = { unicodeslot=0xFE63, category='pd', description='SMALL HYPHEN-MINUS', specials={'small',0x002D} },
	[0xFE64] = { unicodeslot=0xFE64, category='sm', description='SMALL LESS-THAN SIGN', specials={'small',0x003C} },
	[0xFE65] = { unicodeslot=0xFE65, category='sm', description='SMALL GREATER-THAN SIGN', specials={'small',0x003E} },
	[0xFE66] = { unicodeslot=0xFE66, category='sm', description='SMALL EQUALS SIGN', specials={'small',0x003D} },
	[0xFE68] = { unicodeslot=0xFE68, category='po', description='SMALL REVERSE SOLIDUS', specials={'small',0x005C} },
	[0xFE69] = { unicodeslot=0xFE69, category='sc', description='SMALL DOLLAR SIGN', specials={'small',0x0024} },
	[0xFE6A] = { unicodeslot=0xFE6A, category='po', description='SMALL PERCENT SIGN', specials={'small',0x0025} },
	[0xFE6B] = { unicodeslot=0xFE6B, category='po', description='SMALL COMMERCIAL AT', specials={'small',0x0040} },
	[0xFE70] = { unicodeslot=0xFE70, category='lo', description='ARABIC FATHATAN ISOLATED FORM', specials={'isolated',0x0020,0x064B} },
	[0xFE71] = { unicodeslot=0xFE71, category='lo', description='ARABIC TATWEEL WITH FATHATAN ABOVE', specials={'medial',0x0640,0x064B} },
	[0xFE72] = { unicodeslot=0xFE72, category='lo', description='ARABIC DAMMATAN ISOLATED FORM', specials={'isolated',0x0020,0x064C} },
	[0xFE73] = { unicodeslot=0xFE73, category='lo', description='ARABIC TAIL FRAGMENT' },
	[0xFE74] = { unicodeslot=0xFE74, category='lo', description='ARABIC KASRATAN ISOLATED FORM', specials={'isolated',0x0020,0x064D} },
	[0xFE76] = { unicodeslot=0xFE76, category='lo', description='ARABIC FATHA ISOLATED FORM', specials={'isolated',0x0020,0x064E} },
	[0xFE77] = { unicodeslot=0xFE77, category='lo', description='ARABIC FATHA MEDIAL FORM', specials={'medial',0x0640,0x064E} },
	[0xFE78] = { unicodeslot=0xFE78, category='lo', description='ARABIC DAMMA ISOLATED FORM', specials={'isolated',0x0020,0x064F} },
	[0xFE79] = { unicodeslot=0xFE79, category='lo', description='ARABIC DAMMA MEDIAL FORM', specials={'medial',0x0640,0x064F} },
	[0xFE7A] = { unicodeslot=0xFE7A, category='lo', description='ARABIC KASRA ISOLATED FORM', specials={'isolated',0x0020,0x0650} },
	[0xFE7B] = { unicodeslot=0xFE7B, category='lo', description='ARABIC KASRA MEDIAL FORM', specials={'medial',0x0640,0x0650} },
	[0xFE7C] = { unicodeslot=0xFE7C, category='lo', description='ARABIC SHADDA ISOLATED FORM', specials={'isolated',0x0020,0x0651} },
	[0xFE7D] = { unicodeslot=0xFE7D, category='lo', description='ARABIC SHADDA MEDIAL FORM', specials={'medial',0x0640,0x0651} },
	[0xFE7E] = { unicodeslot=0xFE7E, category='lo', description='ARABIC SUKUN ISOLATED FORM', specials={'isolated',0x0020,0x0652} },
	[0xFE7F] = { unicodeslot=0xFE7F, category='lo', description='ARABIC SUKUN MEDIAL FORM', specials={'medial',0x0640,0x0652} },
	[0xFE80] = { unicodeslot=0xFE80, category='lo', description='ARABIC LETTER HAMZA ISOLATED FORM', specials={'isolated',0x0621} },
	[0xFE81] = { unicodeslot=0xFE81, category='lo', description='ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM', shcode=0x0627, specials={'isolated',0x0622} },
	[0xFE82] = { unicodeslot=0xFE82, category='lo', description='ARABIC LETTER ALEF WITH MADDA ABOVE FINAL FORM', shcode=0x0627, specials={'final',0x0622} },
	[0xFE83] = { unicodeslot=0xFE83, category='lo', description='ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM', shcode=0x0627, specials={'isolated',0x0623} },
	[0xFE84] = { unicodeslot=0xFE84, category='lo', description='ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM', shcode=0x0627, specials={'final',0x0623} },
	[0xFE85] = { unicodeslot=0xFE85, category='lo', description='ARABIC LETTER WAW WITH HAMZA ABOVE ISOLATED FORM', shcode=0x0648, specials={'isolated',0x0624} },
	[0xFE86] = { unicodeslot=0xFE86, category='lo', description='ARABIC LETTER WAW WITH HAMZA ABOVE FINAL FORM', shcode=0x0648, specials={'final',0x0624} },
	[0xFE87] = { unicodeslot=0xFE87, category='lo', description='ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM', shcode=0x0627, specials={'isolated',0x0625} },
	[0xFE88] = { unicodeslot=0xFE88, category='lo', description='ARABIC LETTER ALEF WITH HAMZA BELOW FINAL FORM', shcode=0x0627, specials={'final',0x0625} },
	[0xFE89] = { unicodeslot=0xFE89, category='lo', description='ARABIC LETTER YEH WITH HAMZA ABOVE ISOLATED FORM', shcode=0x064A, specials={'isolated',0x0626} },
	[0xFE8A] = { unicodeslot=0xFE8A, category='lo', description='ARABIC LETTER YEH WITH HAMZA ABOVE FINAL FORM', shcode=0x064A, specials={'final',0x0626} },
	[0xFE8B] = { unicodeslot=0xFE8B, category='lo', description='ARABIC LETTER YEH WITH HAMZA ABOVE INITIAL FORM', shcode=0x064A, specials={'initial',0x0626} },
	[0xFE8C] = { unicodeslot=0xFE8C, category='lo', description='ARABIC LETTER YEH WITH HAMZA ABOVE MEDIAL FORM', shcode=0x064A, specials={'medial',0x0626} },
	[0xFE8D] = { unicodeslot=0xFE8D, category='lo', description='ARABIC LETTER ALEF ISOLATED FORM', specials={'isolated',0x0627} },
	[0xFE8E] = { unicodeslot=0xFE8E, category='lo', description='ARABIC LETTER ALEF FINAL FORM', specials={'final',0x0627} },
	[0xFE8F] = { unicodeslot=0xFE8F, category='lo', description='ARABIC LETTER BEH ISOLATED FORM', specials={'isolated',0x0628} },
	[0xFE90] = { unicodeslot=0xFE90, category='lo', description='ARABIC LETTER BEH FINAL FORM', specials={'final',0x0628} },
	[0xFE91] = { unicodeslot=0xFE91, category='lo', description='ARABIC LETTER BEH INITIAL FORM', specials={'initial',0x0628} },
	[0xFE92] = { unicodeslot=0xFE92, category='lo', description='ARABIC LETTER BEH MEDIAL FORM', specials={'medial',0x0628} },
	[0xFE93] = { unicodeslot=0xFE93, category='lo', description='ARABIC LETTER TEH MARBUTA ISOLATED FORM', specials={'isolated',0x0629} },
	[0xFE94] = { unicodeslot=0xFE94, category='lo', description='ARABIC LETTER TEH MARBUTA FINAL FORM', specials={'final',0x0629} },
	[0xFE95] = { unicodeslot=0xFE95, category='lo', description='ARABIC LETTER TEH ISOLATED FORM', specials={'isolated',0x062A} },
	[0xFE96] = { unicodeslot=0xFE96, category='lo', description='ARABIC LETTER TEH FINAL FORM', specials={'final',0x062A} },
	[0xFE97] = { unicodeslot=0xFE97, category='lo', description='ARABIC LETTER TEH INITIAL FORM', specials={'initial',0x062A} },
	[0xFE98] = { unicodeslot=0xFE98, category='lo', description='ARABIC LETTER TEH MEDIAL FORM', specials={'medial',0x062A} },
	[0xFE99] = { unicodeslot=0xFE99, category='lo', description='ARABIC LETTER THEH ISOLATED FORM', specials={'isolated',0x062B} },
	[0xFE9A] = { unicodeslot=0xFE9A, category='lo', description='ARABIC LETTER THEH FINAL FORM', specials={'final',0x062B} },
	[0xFE9B] = { unicodeslot=0xFE9B, category='lo', description='ARABIC LETTER THEH INITIAL FORM', specials={'initial',0x062B} },
	[0xFE9C] = { unicodeslot=0xFE9C, category='lo', description='ARABIC LETTER THEH MEDIAL FORM', specials={'medial',0x062B} },
	[0xFE9D] = { unicodeslot=0xFE9D, category='lo', description='ARABIC LETTER JEEM ISOLATED FORM', specials={'isolated',0x062C} },
	[0xFE9E] = { unicodeslot=0xFE9E, category='lo', description='ARABIC LETTER JEEM FINAL FORM', specials={'final',0x062C} },
	[0xFE9F] = { unicodeslot=0xFE9F, category='lo', description='ARABIC LETTER JEEM INITIAL FORM', specials={'initial',0x062C} },
	[0xFEA0] = { unicodeslot=0xFEA0, category='lo', description='ARABIC LETTER JEEM MEDIAL FORM', specials={'medial',0x062C} },
	[0xFEA1] = { unicodeslot=0xFEA1, category='lo', description='ARABIC LETTER HAH ISOLATED FORM', specials={'isolated',0x062D} },
	[0xFEA2] = { unicodeslot=0xFEA2, category='lo', description='ARABIC LETTER HAH FINAL FORM', specials={'final',0x062D} },
	[0xFEA3] = { unicodeslot=0xFEA3, category='lo', description='ARABIC LETTER HAH INITIAL FORM', specials={'initial',0x062D} },
	[0xFEA4] = { unicodeslot=0xFEA4, category='lo', description='ARABIC LETTER HAH MEDIAL FORM', specials={'medial',0x062D} },
	[0xFEA5] = { unicodeslot=0xFEA5, category='lo', description='ARABIC LETTER KHAH ISOLATED FORM', specials={'isolated',0x062E} },
	[0xFEA6] = { unicodeslot=0xFEA6, category='lo', description='ARABIC LETTER KHAH FINAL FORM', specials={'final',0x062E} },
	[0xFEA7] = { unicodeslot=0xFEA7, category='lo', description='ARABIC LETTER KHAH INITIAL FORM', specials={'initial',0x062E} },
	[0xFEA8] = { unicodeslot=0xFEA8, category='lo', description='ARABIC LETTER KHAH MEDIAL FORM', specials={'medial',0x062E} },
	[0xFEA9] = { unicodeslot=0xFEA9, category='lo', description='ARABIC LETTER DAL ISOLATED FORM', specials={'isolated',0x062F} },
	[0xFEAA] = { unicodeslot=0xFEAA, category='lo', description='ARABIC LETTER DAL FINAL FORM', specials={'final',0x062F} },
	[0xFEAB] = { unicodeslot=0xFEAB, category='lo', description='ARABIC LETTER THAL ISOLATED FORM', specials={'isolated',0x0630} },
	[0xFEAC] = { unicodeslot=0xFEAC, category='lo', description='ARABIC LETTER THAL FINAL FORM', specials={'final',0x0630} },
	[0xFEAD] = { unicodeslot=0xFEAD, category='lo', description='ARABIC LETTER REH ISOLATED FORM', specials={'isolated',0x0631} },
	[0xFEAE] = { unicodeslot=0xFEAE, category='lo', description='ARABIC LETTER REH FINAL FORM', specials={'final',0x0631} },
	[0xFEAF] = { unicodeslot=0xFEAF, category='lo', description='ARABIC LETTER ZAIN ISOLATED FORM', specials={'isolated',0x0632} },
	[0xFEB0] = { unicodeslot=0xFEB0, category='lo', description='ARABIC LETTER ZAIN FINAL FORM', specials={'final',0x0632} },
	[0xFEB1] = { unicodeslot=0xFEB1, category='lo', description='ARABIC LETTER SEEN ISOLATED FORM', specials={'isolated',0x0633} },
	[0xFEB2] = { unicodeslot=0xFEB2, category='lo', description='ARABIC LETTER SEEN FINAL FORM', specials={'final',0x0633} },
	[0xFEB3] = { unicodeslot=0xFEB3, category='lo', description='ARABIC LETTER SEEN INITIAL FORM', specials={'initial',0x0633} },
	[0xFEB4] = { unicodeslot=0xFEB4, category='lo', description='ARABIC LETTER SEEN MEDIAL FORM', specials={'medial',0x0633} },
	[0xFEB5] = { unicodeslot=0xFEB5, category='lo', description='ARABIC LETTER SHEEN ISOLATED FORM', specials={'isolated',0x0634} },
	[0xFEB6] = { unicodeslot=0xFEB6, category='lo', description='ARABIC LETTER SHEEN FINAL FORM', specials={'final',0x0634} },
	[0xFEB7] = { unicodeslot=0xFEB7, category='lo', description='ARABIC LETTER SHEEN INITIAL FORM', specials={'initial',0x0634} },
	[0xFEB8] = { unicodeslot=0xFEB8, category='lo', description='ARABIC LETTER SHEEN MEDIAL FORM', specials={'medial',0x0634} },
	[0xFEB9] = { unicodeslot=0xFEB9, category='lo', description='ARABIC LETTER SAD ISOLATED FORM', specials={'isolated',0x0635} },
	[0xFEBA] = { unicodeslot=0xFEBA, category='lo', description='ARABIC LETTER SAD FINAL FORM', specials={'final',0x0635} },
	[0xFEBB] = { unicodeslot=0xFEBB, category='lo', description='ARABIC LETTER SAD INITIAL FORM', specials={'initial',0x0635} },
	[0xFEBC] = { unicodeslot=0xFEBC, category='lo', description='ARABIC LETTER SAD MEDIAL FORM', specials={'medial',0x0635} },
	[0xFEBD] = { unicodeslot=0xFEBD, category='lo', description='ARABIC LETTER DAD ISOLATED FORM', specials={'isolated',0x0636} },
	[0xFEBE] = { unicodeslot=0xFEBE, category='lo', description='ARABIC LETTER DAD FINAL FORM', specials={'final',0x0636} },
	[0xFEBF] = { unicodeslot=0xFEBF, category='lo', description='ARABIC LETTER DAD INITIAL FORM', specials={'initial',0x0636} },
	[0xFEC0] = { unicodeslot=0xFEC0, category='lo', description='ARABIC LETTER DAD MEDIAL FORM', specials={'medial',0x0636} },
	[0xFEC1] = { unicodeslot=0xFEC1, category='lo', description='ARABIC LETTER TAH ISOLATED FORM', specials={'isolated',0x0637} },
	[0xFEC2] = { unicodeslot=0xFEC2, category='lo', description='ARABIC LETTER TAH FINAL FORM', specials={'final',0x0637} },
	[0xFEC3] = { unicodeslot=0xFEC3, category='lo', description='ARABIC LETTER TAH INITIAL FORM', specials={'initial',0x0637} },
	[0xFEC4] = { unicodeslot=0xFEC4, category='lo', description='ARABIC LETTER TAH MEDIAL FORM', specials={'medial',0x0637} },
	[0xFEC5] = { unicodeslot=0xFEC5, category='lo', description='ARABIC LETTER ZAH ISOLATED FORM', specials={'isolated',0x0638} },
	[0xFEC6] = { unicodeslot=0xFEC6, category='lo', description='ARABIC LETTER ZAH FINAL FORM', specials={'final',0x0638} },
	[0xFEC7] = { unicodeslot=0xFEC7, category='lo', description='ARABIC LETTER ZAH INITIAL FORM', specials={'initial',0x0638} },
	[0xFEC8] = { unicodeslot=0xFEC8, category='lo', description='ARABIC LETTER ZAH MEDIAL FORM', specials={'medial',0x0638} },
	[0xFEC9] = { unicodeslot=0xFEC9, category='lo', description='ARABIC LETTER AIN ISOLATED FORM', specials={'isolated',0x0639} },
	[0xFECA] = { unicodeslot=0xFECA, category='lo', description='ARABIC LETTER AIN FINAL FORM', specials={'final',0x0639} },
	[0xFECB] = { unicodeslot=0xFECB, category='lo', description='ARABIC LETTER AIN INITIAL FORM', specials={'initial',0x0639} },
	[0xFECC] = { unicodeslot=0xFECC, category='lo', description='ARABIC LETTER AIN MEDIAL FORM', specials={'medial',0x0639} },
	[0xFECD] = { unicodeslot=0xFECD, category='lo', description='ARABIC LETTER GHAIN ISOLATED FORM', specials={'isolated',0x063A} },
	[0xFECE] = { unicodeslot=0xFECE, category='lo', description='ARABIC LETTER GHAIN FINAL FORM', specials={'final',0x063A} },
	[0xFECF] = { unicodeslot=0xFECF, category='lo', description='ARABIC LETTER GHAIN INITIAL FORM', specials={'initial',0x063A} },
	[0xFED0] = { unicodeslot=0xFED0, category='lo', description='ARABIC LETTER GHAIN MEDIAL FORM', specials={'medial',0x063A} },
	[0xFED1] = { unicodeslot=0xFED1, category='lo', description='ARABIC LETTER FEH ISOLATED FORM', specials={'isolated',0x0641} },
	[0xFED2] = { unicodeslot=0xFED2, category='lo', description='ARABIC LETTER FEH FINAL FORM', specials={'final',0x0641} },
	[0xFED3] = { unicodeslot=0xFED3, category='lo', description='ARABIC LETTER FEH INITIAL FORM', specials={'initial',0x0641} },
	[0xFED4] = { unicodeslot=0xFED4, category='lo', description='ARABIC LETTER FEH MEDIAL FORM', specials={'medial',0x0641} },
	[0xFED5] = { unicodeslot=0xFED5, category='lo', description='ARABIC LETTER QAF ISOLATED FORM', specials={'isolated',0x0642} },
	[0xFED6] = { unicodeslot=0xFED6, category='lo', description='ARABIC LETTER QAF FINAL FORM', specials={'final',0x0642} },
	[0xFED7] = { unicodeslot=0xFED7, category='lo', description='ARABIC LETTER QAF INITIAL FORM', specials={'initial',0x0642} },
	[0xFED8] = { unicodeslot=0xFED8, category='lo', description='ARABIC LETTER QAF MEDIAL FORM', specials={'medial',0x0642} },
	[0xFED9] = { unicodeslot=0xFED9, category='lo', description='ARABIC LETTER KAF ISOLATED FORM', specials={'isolated',0x0643} },
	[0xFEDA] = { unicodeslot=0xFEDA, category='lo', description='ARABIC LETTER KAF FINAL FORM', specials={'final',0x0643} },
	[0xFEDB] = { unicodeslot=0xFEDB, category='lo', description='ARABIC LETTER KAF INITIAL FORM', specials={'initial',0x0643} },
	[0xFEDC] = { unicodeslot=0xFEDC, category='lo', description='ARABIC LETTER KAF MEDIAL FORM', specials={'medial',0x0643} },
	[0xFEDD] = { unicodeslot=0xFEDD, category='lo', description='ARABIC LETTER LAM ISOLATED FORM', specials={'isolated',0x0644} },
	[0xFEDE] = { unicodeslot=0xFEDE, category='lo', description='ARABIC LETTER LAM FINAL FORM', specials={'final',0x0644} },
	[0xFEDF] = { unicodeslot=0xFEDF, category='lo', description='ARABIC LETTER LAM INITIAL FORM', specials={'initial',0x0644} },
	[0xFEE0] = { unicodeslot=0xFEE0, category='lo', description='ARABIC LETTER LAM MEDIAL FORM', specials={'medial',0x0644} },
	[0xFEE1] = { unicodeslot=0xFEE1, category='lo', description='ARABIC LETTER MEEM ISOLATED FORM', specials={'isolated',0x0645} },
	[0xFEE2] = { unicodeslot=0xFEE2, category='lo', description='ARABIC LETTER MEEM FINAL FORM', specials={'final',0x0645} },
	[0xFEE3] = { unicodeslot=0xFEE3, category='lo', description='ARABIC LETTER MEEM INITIAL FORM', specials={'initial',0x0645} },
	[0xFEE4] = { unicodeslot=0xFEE4, category='lo', description='ARABIC LETTER MEEM MEDIAL FORM', specials={'medial',0x0645} },
	[0xFEE5] = { unicodeslot=0xFEE5, category='lo', description='ARABIC LETTER NOON ISOLATED FORM', specials={'isolated',0x0646} },
	[0xFEE6] = { unicodeslot=0xFEE6, category='lo', description='ARABIC LETTER NOON FINAL FORM', specials={'final',0x0646} },
	[0xFEE7] = { unicodeslot=0xFEE7, category='lo', description='ARABIC LETTER NOON INITIAL FORM', specials={'initial',0x0646} },
	[0xFEE8] = { unicodeslot=0xFEE8, category='lo', description='ARABIC LETTER NOON MEDIAL FORM', specials={'medial',0x0646} },
	[0xFEE9] = { unicodeslot=0xFEE9, category='lo', description='ARABIC LETTER HEH ISOLATED FORM', specials={'isolated',0x0647} },
	[0xFEEA] = { unicodeslot=0xFEEA, category='lo', description='ARABIC LETTER HEH FINAL FORM', specials={'final',0x0647} },
	[0xFEEB] = { unicodeslot=0xFEEB, category='lo', description='ARABIC LETTER HEH INITIAL FORM', specials={'initial',0x0647} },
	[0xFEEC] = { unicodeslot=0xFEEC, category='lo', description='ARABIC LETTER HEH MEDIAL FORM', specials={'medial',0x0647} },
	[0xFEED] = { unicodeslot=0xFEED, category='lo', description='ARABIC LETTER WAW ISOLATED FORM', specials={'isolated',0x0648} },
	[0xFEEE] = { unicodeslot=0xFEEE, category='lo', description='ARABIC LETTER WAW FINAL FORM', specials={'final',0x0648} },
	[0xFEEF] = { unicodeslot=0xFEEF, category='lo', description='ARABIC LETTER ALEF MAKSURA ISOLATED FORM', specials={'isolated',0x0649} },
	[0xFEF0] = { unicodeslot=0xFEF0, category='lo', description='ARABIC LETTER ALEF MAKSURA FINAL FORM', specials={'final',0x0649} },
	[0xFEF1] = { unicodeslot=0xFEF1, category='lo', description='ARABIC LETTER YEH ISOLATED FORM', specials={'isolated',0x064A} },
	[0xFEF2] = { unicodeslot=0xFEF2, category='lo', description='ARABIC LETTER YEH FINAL FORM', specials={'final',0x064A} },
	[0xFEF3] = { unicodeslot=0xFEF3, category='lo', description='ARABIC LETTER YEH INITIAL FORM', specials={'initial',0x064A} },
	[0xFEF4] = { unicodeslot=0xFEF4, category='lo', description='ARABIC LETTER YEH MEDIAL FORM', specials={'medial',0x064A} },
	[0xFEF5] = { unicodeslot=0xFEF5, category='lo', description='ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE ISOLATED FORM', specials={'isolated',0x0644,0x0622} },
	[0xFEF6] = { unicodeslot=0xFEF6, category='lo', description='ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE FINAL FORM', specials={'final',0x0644,0x0622} },
	[0xFEF7] = { unicodeslot=0xFEF7, category='lo', description='ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE ISOLATED FORM', specials={'isolated',0x0644,0x0623} },
	[0xFEF8] = { unicodeslot=0xFEF8, category='lo', description='ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE FINAL FORM', specials={'final',0x0644,0x0623} },
	[0xFEF9] = { unicodeslot=0xFEF9, category='lo', description='ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW ISOLATED FORM', specials={'isolated',0x0644,0x0625} },
	[0xFEFA] = { unicodeslot=0xFEFA, category='lo', description='ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW FINAL FORM', specials={'final',0x0644,0x0625} },
	[0xFEFB] = { unicodeslot=0xFEFB, category='lo', description='ARABIC LIGATURE LAM WITH ALEF ISOLATED FORM', specials={'isolated',0x0644,0x0627} },
	[0xFEFC] = { unicodeslot=0xFEFC, category='lo', description='ARABIC LIGATURE LAM WITH ALEF FINAL FORM', specials={'final',0x0644,0x0627} },
	[0xFEFF] = { unicodeslot=0xFEFF, category='cf', description='ZERO WIDTH NO-BREAK SPACE' },
	[0xFF01] = { unicodeslot=0xFF01, category='po', description='FULLWIDTH EXCLAMATION MARK', specials={'wide',0x0021} },
	[0xFF02] = { unicodeslot=0xFF02, category='po', description='FULLWIDTH QUOTATION MARK', specials={'wide',0x0022} },
	[0xFF03] = { unicodeslot=0xFF03, category='po', description='FULLWIDTH NUMBER SIGN', specials={'wide',0x0023} },
	[0xFF04] = { unicodeslot=0xFF04, category='sc', description='FULLWIDTH DOLLAR SIGN', specials={'wide',0x0024} },
	[0xFF05] = { unicodeslot=0xFF05, category='po', description='FULLWIDTH PERCENT SIGN', specials={'wide',0x0025} },
	[0xFF06] = { unicodeslot=0xFF06, category='po', description='FULLWIDTH AMPERSAND', specials={'wide',0x0026} },
	[0xFF07] = { unicodeslot=0xFF07, category='po', description='FULLWIDTH APOSTROPHE', specials={'wide',0x0027} },
	[0xFF08] = { unicodeslot=0xFF08, category='ps', description='FULLWIDTH LEFT PARENTHESIS', specials={'wide',0x0028} },
	[0xFF09] = { unicodeslot=0xFF09, category='pe', description='FULLWIDTH RIGHT PARENTHESIS', specials={'wide',0x0029} },
	[0xFF0A] = { unicodeslot=0xFF0A, category='po', description='FULLWIDTH ASTERISK', specials={'wide',0x002A} },
	[0xFF0B] = { unicodeslot=0xFF0B, category='sm', description='FULLWIDTH PLUS SIGN', specials={'wide',0x002B} },
	[0xFF0C] = { unicodeslot=0xFF0C, category='po', description='FULLWIDTH COMMA', specials={'wide',0x002C} },
	[0xFF0D] = { unicodeslot=0xFF0D, category='pd', description='FULLWIDTH HYPHEN-MINUS', specials={'wide',0x002D} },
	[0xFF0E] = { unicodeslot=0xFF0E, category='po', description='FULLWIDTH FULL STOP', specials={'wide',0x002E} },
	[0xFF0F] = { unicodeslot=0xFF0F, category='po', description='FULLWIDTH SOLIDUS', specials={'wide',0x002F} },
	[0xFF10] = { unicodeslot=0xFF10, category='nd', description='FULLWIDTH DIGIT ZERO', specials={'wide',0x0030} },
	[0xFF11] = { unicodeslot=0xFF11, category='nd', description='FULLWIDTH DIGIT ONE', specials={'wide',0x0031} },
	[0xFF12] = { unicodeslot=0xFF12, category='nd', description='FULLWIDTH DIGIT TWO', specials={'wide',0x0032} },
	[0xFF13] = { unicodeslot=0xFF13, category='nd', description='FULLWIDTH DIGIT THREE', specials={'wide',0x0033} },
	[0xFF14] = { unicodeslot=0xFF14, category='nd', description='FULLWIDTH DIGIT FOUR', specials={'wide',0x0034} },
	[0xFF15] = { unicodeslot=0xFF15, category='nd', description='FULLWIDTH DIGIT FIVE', specials={'wide',0x0035} },
	[0xFF16] = { unicodeslot=0xFF16, category='nd', description='FULLWIDTH DIGIT SIX', specials={'wide',0x0036} },
	[0xFF17] = { unicodeslot=0xFF17, category='nd', description='FULLWIDTH DIGIT SEVEN', specials={'wide',0x0037} },
	[0xFF18] = { unicodeslot=0xFF18, category='nd', description='FULLWIDTH DIGIT EIGHT', specials={'wide',0x0038} },
	[0xFF19] = { unicodeslot=0xFF19, category='nd', description='FULLWIDTH DIGIT NINE', specials={'wide',0x0039} },
	[0xFF1A] = { unicodeslot=0xFF1A, category='po', description='FULLWIDTH COLON', specials={'wide',0x003A} },
	[0xFF1B] = { unicodeslot=0xFF1B, category='po', description='FULLWIDTH SEMICOLON', specials={'wide',0x003B} },
	[0xFF1C] = { unicodeslot=0xFF1C, category='sm', description='FULLWIDTH LESS-THAN SIGN', specials={'wide',0x003C} },
	[0xFF1D] = { unicodeslot=0xFF1D, category='sm', description='FULLWIDTH EQUALS SIGN', specials={'wide',0x003D} },
	[0xFF1E] = { unicodeslot=0xFF1E, category='sm', description='FULLWIDTH GREATER-THAN SIGN', specials={'wide',0x003E} },
	[0xFF1F] = { unicodeslot=0xFF1F, category='po', description='FULLWIDTH QUESTION MARK', specials={'wide',0x003F} },
	[0xFF20] = { unicodeslot=0xFF20, category='po', description='FULLWIDTH COMMERCIAL AT', specials={'wide',0x0040} },
	[0xFF21] = { unicodeslot=0xFF21, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER A', lccode=0xFF41, specials={'wide',0x0041} },
	[0xFF22] = { unicodeslot=0xFF22, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER B', lccode=0xFF42, specials={'wide',0x0042} },
	[0xFF23] = { unicodeslot=0xFF23, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER C', lccode=0xFF43, specials={'wide',0x0043} },
	[0xFF24] = { unicodeslot=0xFF24, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER D', lccode=0xFF44, specials={'wide',0x0044} },
	[0xFF25] = { unicodeslot=0xFF25, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER E', lccode=0xFF45, specials={'wide',0x0045} },
	[0xFF26] = { unicodeslot=0xFF26, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER F', lccode=0xFF46, specials={'wide',0x0046} },
	[0xFF27] = { unicodeslot=0xFF27, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER G', lccode=0xFF47, specials={'wide',0x0047} },
	[0xFF28] = { unicodeslot=0xFF28, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER H', lccode=0xFF48, specials={'wide',0x0048} },
	[0xFF29] = { unicodeslot=0xFF29, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER I', lccode=0xFF49, specials={'wide',0x0049} },
	[0xFF2A] = { unicodeslot=0xFF2A, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER J', lccode=0xFF4A, specials={'wide',0x004A} },
	[0xFF2B] = { unicodeslot=0xFF2B, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER K', lccode=0xFF4B, specials={'wide',0x004B} },
	[0xFF2C] = { unicodeslot=0xFF2C, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER L', lccode=0xFF4C, specials={'wide',0x004C} },
	[0xFF2D] = { unicodeslot=0xFF2D, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER M', lccode=0xFF4D, specials={'wide',0x004D} },
	[0xFF2E] = { unicodeslot=0xFF2E, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER N', lccode=0xFF4E, specials={'wide',0x004E} },
	[0xFF2F] = { unicodeslot=0xFF2F, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER O', lccode=0xFF4F, specials={'wide',0x004F} },
	[0xFF30] = { unicodeslot=0xFF30, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER P', lccode=0xFF50, specials={'wide',0x0050} },
	[0xFF31] = { unicodeslot=0xFF31, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER Q', lccode=0xFF51, specials={'wide',0x0051} },
	[0xFF32] = { unicodeslot=0xFF32, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER R', lccode=0xFF52, specials={'wide',0x0052} },
	[0xFF33] = { unicodeslot=0xFF33, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER S', lccode=0xFF53, specials={'wide',0x0053} },
	[0xFF34] = { unicodeslot=0xFF34, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER T', lccode=0xFF54, specials={'wide',0x0054} },
	[0xFF35] = { unicodeslot=0xFF35, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER U', lccode=0xFF55, specials={'wide',0x0055} },
	[0xFF36] = { unicodeslot=0xFF36, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER V', lccode=0xFF56, specials={'wide',0x0056} },
	[0xFF37] = { unicodeslot=0xFF37, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER W', lccode=0xFF57, specials={'wide',0x0057} },
	[0xFF38] = { unicodeslot=0xFF38, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER X', lccode=0xFF58, specials={'wide',0x0058} },
	[0xFF39] = { unicodeslot=0xFF39, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER Y', lccode=0xFF59, specials={'wide',0x0059} },
	[0xFF3A] = { unicodeslot=0xFF3A, category='lu', description='FULLWIDTH LATIN CAPITAL LETTER Z', lccode=0xFF5A, specials={'wide',0x005A} },
	[0xFF3B] = { unicodeslot=0xFF3B, category='ps', description='FULLWIDTH LEFT SQUARE BRACKET', specials={'wide',0x005B} },
	[0xFF3C] = { unicodeslot=0xFF3C, category='po', description='FULLWIDTH REVERSE SOLIDUS', specials={'wide',0x005C} },
	[0xFF3D] = { unicodeslot=0xFF3D, category='pe', description='FULLWIDTH RIGHT SQUARE BRACKET', specials={'wide',0x005D} },
	[0xFF3E] = { unicodeslot=0xFF3E, category='sk', description='FULLWIDTH CIRCUMFLEX ACCENT', specials={'wide',0x005E} },
	[0xFF3F] = { unicodeslot=0xFF3F, category='pc', description='FULLWIDTH LOW LINE', specials={'wide',0x005F} },
	[0xFF40] = { unicodeslot=0xFF40, category='sk', description='FULLWIDTH GRAVE ACCENT', specials={'wide',0x0060} },
	[0xFF41] = { unicodeslot=0xFF41, category='ll', description='FULLWIDTH LATIN SMALL LETTER A', uccode=0xFF21, specials={'wide',0x0061} },
	[0xFF42] = { unicodeslot=0xFF42, category='ll', description='FULLWIDTH LATIN SMALL LETTER B', uccode=0xFF22, specials={'wide',0x0062} },
	[0xFF43] = { unicodeslot=0xFF43, category='ll', description='FULLWIDTH LATIN SMALL LETTER C', uccode=0xFF23, specials={'wide',0x0063} },
	[0xFF44] = { unicodeslot=0xFF44, category='ll', description='FULLWIDTH LATIN SMALL LETTER D', uccode=0xFF24, specials={'wide',0x0064} },
	[0xFF45] = { unicodeslot=0xFF45, category='ll', description='FULLWIDTH LATIN SMALL LETTER E', uccode=0xFF25, specials={'wide',0x0065} },
	[0xFF46] = { unicodeslot=0xFF46, category='ll', description='FULLWIDTH LATIN SMALL LETTER F', uccode=0xFF26, specials={'wide',0x0066} },
	[0xFF47] = { unicodeslot=0xFF47, category='ll', description='FULLWIDTH LATIN SMALL LETTER G', uccode=0xFF27, specials={'wide',0x0067} },
	[0xFF48] = { unicodeslot=0xFF48, category='ll', description='FULLWIDTH LATIN SMALL LETTER H', uccode=0xFF28, specials={'wide',0x0068} },
	[0xFF49] = { unicodeslot=0xFF49, category='ll', description='FULLWIDTH LATIN SMALL LETTER I', uccode=0xFF29, specials={'wide',0x0069} },
	[0xFF4A] = { unicodeslot=0xFF4A, category='ll', description='FULLWIDTH LATIN SMALL LETTER J', uccode=0xFF2A, specials={'wide',0x006A} },
	[0xFF4B] = { unicodeslot=0xFF4B, category='ll', description='FULLWIDTH LATIN SMALL LETTER K', uccode=0xFF2B, specials={'wide',0x006B} },
	[0xFF4C] = { unicodeslot=0xFF4C, category='ll', description='FULLWIDTH LATIN SMALL LETTER L', uccode=0xFF2C, specials={'wide',0x006C} },
	[0xFF4D] = { unicodeslot=0xFF4D, category='ll', description='FULLWIDTH LATIN SMALL LETTER M', uccode=0xFF2D, specials={'wide',0x006D} },
	[0xFF4E] = { unicodeslot=0xFF4E, category='ll', description='FULLWIDTH LATIN SMALL LETTER N', uccode=0xFF2E, specials={'wide',0x006E} },
	[0xFF4F] = { unicodeslot=0xFF4F, category='ll', description='FULLWIDTH LATIN SMALL LETTER O', uccode=0xFF2F, specials={'wide',0x006F} },
	[0xFF50] = { unicodeslot=0xFF50, category='ll', description='FULLWIDTH LATIN SMALL LETTER P', uccode=0xFF30, specials={'wide',0x0070} },
	[0xFF51] = { unicodeslot=0xFF51, category='ll', description='FULLWIDTH LATIN SMALL LETTER Q', uccode=0xFF31, specials={'wide',0x0071} },
	[0xFF52] = { unicodeslot=0xFF52, category='ll', description='FULLWIDTH LATIN SMALL LETTER R', uccode=0xFF32, specials={'wide',0x0072} },
	[0xFF53] = { unicodeslot=0xFF53, category='ll', description='FULLWIDTH LATIN SMALL LETTER S', uccode=0xFF33, specials={'wide',0x0073} },
	[0xFF54] = { unicodeslot=0xFF54, category='ll', description='FULLWIDTH LATIN SMALL LETTER T', uccode=0xFF34, specials={'wide',0x0074} },
	[0xFF55] = { unicodeslot=0xFF55, category='ll', description='FULLWIDTH LATIN SMALL LETTER U', uccode=0xFF35, specials={'wide',0x0075} },
	[0xFF56] = { unicodeslot=0xFF56, category='ll', description='FULLWIDTH LATIN SMALL LETTER V', uccode=0xFF36, specials={'wide',0x0076} },
	[0xFF57] = { unicodeslot=0xFF57, category='ll', description='FULLWIDTH LATIN SMALL LETTER W', uccode=0xFF37, specials={'wide',0x0077} },
	[0xFF58] = { unicodeslot=0xFF58, category='ll', description='FULLWIDTH LATIN SMALL LETTER X', uccode=0xFF38, specials={'wide',0x0078} },
	[0xFF59] = { unicodeslot=0xFF59, category='ll', description='FULLWIDTH LATIN SMALL LETTER Y', uccode=0xFF39, specials={'wide',0x0079} },
	[0xFF5A] = { unicodeslot=0xFF5A, category='ll', description='FULLWIDTH LATIN SMALL LETTER Z', uccode=0xFF3A, specials={'wide',0x007A} },
	[0xFF5B] = { unicodeslot=0xFF5B, category='ps', description='FULLWIDTH LEFT CURLY BRACKET', specials={'wide',0x007B} },
	[0xFF5C] = { unicodeslot=0xFF5C, category='sm', description='FULLWIDTH VERTICAL LINE', specials={'wide',0x007C} },
	[0xFF5D] = { unicodeslot=0xFF5D, category='pe', description='FULLWIDTH RIGHT CURLY BRACKET', specials={'wide',0x007D} },
	[0xFF5E] = { unicodeslot=0xFF5E, category='sm', description='FULLWIDTH TILDE', specials={'wide',0x007E} },
	[0xFF5F] = { unicodeslot=0xFF5F, category='ps', description='FULLWIDTH LEFT WHITE PARENTHESIS', specials={'wide',0x2985} },
	[0xFF60] = { unicodeslot=0xFF60, category='pe', description='FULLWIDTH RIGHT WHITE PARENTHESIS', specials={'wide',0x2986} },
	[0xFF61] = { unicodeslot=0xFF61, category='po', description='HALFWIDTH IDEOGRAPHIC FULL STOP', specials={'narrow',0x3002} },
	[0xFF62] = { unicodeslot=0xFF62, category='ps', description='HALFWIDTH LEFT CORNER BRACKET', specials={'narrow',0x300C} },
	[0xFF63] = { unicodeslot=0xFF63, category='pe', description='HALFWIDTH RIGHT CORNER BRACKET', specials={'narrow',0x300D} },
	[0xFF64] = { unicodeslot=0xFF64, category='po', description='HALFWIDTH IDEOGRAPHIC COMMA', specials={'narrow',0x3001} },
	[0xFF65] = { unicodeslot=0xFF65, category='po', description='HALFWIDTH KATAKANA MIDDLE DOT', specials={'narrow',0x30FB} },
	[0xFF66] = { unicodeslot=0xFF66, category='lo', description='HALFWIDTH KATAKANA LETTER WO', specials={'narrow',0x30F2} },
	[0xFF67] = { unicodeslot=0xFF67, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL A', specials={'narrow',0x30A1} },
	[0xFF68] = { unicodeslot=0xFF68, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL I', specials={'narrow',0x30A3} },
	[0xFF69] = { unicodeslot=0xFF69, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL U', specials={'narrow',0x30A5} },
	[0xFF6A] = { unicodeslot=0xFF6A, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL E', specials={'narrow',0x30A7} },
	[0xFF6B] = { unicodeslot=0xFF6B, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL O', specials={'narrow',0x30A9} },
	[0xFF6C] = { unicodeslot=0xFF6C, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL YA', specials={'narrow',0x30E3} },
	[0xFF6D] = { unicodeslot=0xFF6D, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL YU', specials={'narrow',0x30E5} },
	[0xFF6E] = { unicodeslot=0xFF6E, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL YO', specials={'narrow',0x30E7} },
	[0xFF6F] = { unicodeslot=0xFF6F, category='lo', description='HALFWIDTH KATAKANA LETTER SMALL TU', specials={'narrow',0x30C3} },
	[0xFF70] = { unicodeslot=0xFF70, category='lm', description='HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK', specials={'narrow',0x30FC} },
	[0xFF71] = { unicodeslot=0xFF71, category='lo', description='HALFWIDTH KATAKANA LETTER A', specials={'narrow',0x30A2} },
	[0xFF72] = { unicodeslot=0xFF72, category='lo', description='HALFWIDTH KATAKANA LETTER I', specials={'narrow',0x30A4} },
	[0xFF73] = { unicodeslot=0xFF73, category='lo', description='HALFWIDTH KATAKANA LETTER U', specials={'narrow',0x30A6} },
	[0xFF74] = { unicodeslot=0xFF74, category='lo', description='HALFWIDTH KATAKANA LETTER E', specials={'narrow',0x30A8} },
	[0xFF75] = { unicodeslot=0xFF75, category='lo', description='HALFWIDTH KATAKANA LETTER O', specials={'narrow',0x30AA} },
	[0xFF76] = { unicodeslot=0xFF76, category='lo', description='HALFWIDTH KATAKANA LETTER KA', specials={'narrow',0x30AB} },
	[0xFF77] = { unicodeslot=0xFF77, category='lo', description='HALFWIDTH KATAKANA LETTER KI', specials={'narrow',0x30AD} },
	[0xFF78] = { unicodeslot=0xFF78, category='lo', description='HALFWIDTH KATAKANA LETTER KU', specials={'narrow',0x30AF} },
	[0xFF79] = { unicodeslot=0xFF79, category='lo', description='HALFWIDTH KATAKANA LETTER KE', specials={'narrow',0x30B1} },
	[0xFF7A] = { unicodeslot=0xFF7A, category='lo', description='HALFWIDTH KATAKANA LETTER KO', specials={'narrow',0x30B3} },
	[0xFF7B] = { unicodeslot=0xFF7B, category='lo', description='HALFWIDTH KATAKANA LETTER SA', specials={'narrow',0x30B5} },
	[0xFF7C] = { unicodeslot=0xFF7C, category='lo', description='HALFWIDTH KATAKANA LETTER SI', specials={'narrow',0x30B7} },
	[0xFF7D] = { unicodeslot=0xFF7D, category='lo', description='HALFWIDTH KATAKANA LETTER SU', specials={'narrow',0x30B9} },
	[0xFF7E] = { unicodeslot=0xFF7E, category='lo', description='HALFWIDTH KATAKANA LETTER SE', specials={'narrow',0x30BB} },
	[0xFF7F] = { unicodeslot=0xFF7F, category='lo', description='HALFWIDTH KATAKANA LETTER SO', specials={'narrow',0x30BD} },
	[0xFF80] = { unicodeslot=0xFF80, category='lo', description='HALFWIDTH KATAKANA LETTER TA', specials={'narrow',0x30BF} },
	[0xFF81] = { unicodeslot=0xFF81, category='lo', description='HALFWIDTH KATAKANA LETTER TI', specials={'narrow',0x30C1} },
	[0xFF82] = { unicodeslot=0xFF82, category='lo', description='HALFWIDTH KATAKANA LETTER TU', specials={'narrow',0x30C4} },
	[0xFF83] = { unicodeslot=0xFF83, category='lo', description='HALFWIDTH KATAKANA LETTER TE', specials={'narrow',0x30C6} },
	[0xFF84] = { unicodeslot=0xFF84, category='lo', description='HALFWIDTH KATAKANA LETTER TO', specials={'narrow',0x30C8} },
	[0xFF85] = { unicodeslot=0xFF85, category='lo', description='HALFWIDTH KATAKANA LETTER NA', specials={'narrow',0x30CA} },
	[0xFF86] = { unicodeslot=0xFF86, category='lo', description='HALFWIDTH KATAKANA LETTER NI', specials={'narrow',0x30CB} },
	[0xFF87] = { unicodeslot=0xFF87, category='lo', description='HALFWIDTH KATAKANA LETTER NU', specials={'narrow',0x30CC} },
	[0xFF88] = { unicodeslot=0xFF88, category='lo', description='HALFWIDTH KATAKANA LETTER NE', specials={'narrow',0x30CD} },
	[0xFF89] = { unicodeslot=0xFF89, category='lo', description='HALFWIDTH KATAKANA LETTER NO', specials={'narrow',0x30CE} },
	[0xFF8A] = { unicodeslot=0xFF8A, category='lo', description='HALFWIDTH KATAKANA LETTER HA', specials={'narrow',0x30CF} },
	[0xFF8B] = { unicodeslot=0xFF8B, category='lo', description='HALFWIDTH KATAKANA LETTER HI', specials={'narrow',0x30D2} },
	[0xFF8C] = { unicodeslot=0xFF8C, category='lo', description='HALFWIDTH KATAKANA LETTER HU', specials={'narrow',0x30D5} },
	[0xFF8D] = { unicodeslot=0xFF8D, category='lo', description='HALFWIDTH KATAKANA LETTER HE', specials={'narrow',0x30D8} },
	[0xFF8E] = { unicodeslot=0xFF8E, category='lo', description='HALFWIDTH KATAKANA LETTER HO', specials={'narrow',0x30DB} },
	[0xFF8F] = { unicodeslot=0xFF8F, category='lo', description='HALFWIDTH KATAKANA LETTER MA', specials={'narrow',0x30DE} },
	[0xFF90] = { unicodeslot=0xFF90, category='lo', description='HALFWIDTH KATAKANA LETTER MI', specials={'narrow',0x30DF} },
	[0xFF91] = { unicodeslot=0xFF91, category='lo', description='HALFWIDTH KATAKANA LETTER MU', specials={'narrow',0x30E0} },
	[0xFF92] = { unicodeslot=0xFF92, category='lo', description='HALFWIDTH KATAKANA LETTER ME', specials={'narrow',0x30E1} },
	[0xFF93] = { unicodeslot=0xFF93, category='lo', description='HALFWIDTH KATAKANA LETTER MO', specials={'narrow',0x30E2} },
	[0xFF94] = { unicodeslot=0xFF94, category='lo', description='HALFWIDTH KATAKANA LETTER YA', specials={'narrow',0x30E4} },
	[0xFF95] = { unicodeslot=0xFF95, category='lo', description='HALFWIDTH KATAKANA LETTER YU', specials={'narrow',0x30E6} },
	[0xFF96] = { unicodeslot=0xFF96, category='lo', description='HALFWIDTH KATAKANA LETTER YO', specials={'narrow',0x30E8} },
	[0xFF97] = { unicodeslot=0xFF97, category='lo', description='HALFWIDTH KATAKANA LETTER RA', specials={'narrow',0x30E9} },
	[0xFF98] = { unicodeslot=0xFF98, category='lo', description='HALFWIDTH KATAKANA LETTER RI', specials={'narrow',0x30EA} },
	[0xFF99] = { unicodeslot=0xFF99, category='lo', description='HALFWIDTH KATAKANA LETTER RU', specials={'narrow',0x30EB} },
	[0xFF9A] = { unicodeslot=0xFF9A, category='lo', description='HALFWIDTH KATAKANA LETTER RE', specials={'narrow',0x30EC} },
	[0xFF9B] = { unicodeslot=0xFF9B, category='lo', description='HALFWIDTH KATAKANA LETTER RO', specials={'narrow',0x30ED} },
	[0xFF9C] = { unicodeslot=0xFF9C, category='lo', description='HALFWIDTH KATAKANA LETTER WA', specials={'narrow',0x30EF} },
	[0xFF9D] = { unicodeslot=0xFF9D, category='lo', description='HALFWIDTH KATAKANA LETTER N', specials={'narrow',0x30F3} },
	[0xFF9E] = { unicodeslot=0xFF9E, category='lm', description='HALFWIDTH KATAKANA VOICED SOUND MARK', specials={'narrow',0x3099} },
	[0xFF9F] = { unicodeslot=0xFF9F, category='lm', description='HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK', specials={'narrow',0x309A} },
	[0xFFA0] = { unicodeslot=0xFFA0, category='lo', description='HALFWIDTH HANGUL FILLER', specials={'narrow',0x3164} },
	[0xFFA1] = { unicodeslot=0xFFA1, category='lo', description='HALFWIDTH HANGUL LETTER KIYEOK', specials={'narrow',0x3131} },
	[0xFFA2] = { unicodeslot=0xFFA2, category='lo', description='HALFWIDTH HANGUL LETTER SSANGKIYEOK', specials={'narrow',0x3132} },
	[0xFFA3] = { unicodeslot=0xFFA3, category='lo', description='HALFWIDTH HANGUL LETTER KIYEOK-SIOS', specials={'narrow',0x3133} },
	[0xFFA4] = { unicodeslot=0xFFA4, category='lo', description='HALFWIDTH HANGUL LETTER NIEUN', specials={'narrow',0x3134} },
	[0xFFA5] = { unicodeslot=0xFFA5, category='lo', description='HALFWIDTH HANGUL LETTER NIEUN-CIEUC', specials={'narrow',0x3135} },
	[0xFFA6] = { unicodeslot=0xFFA6, category='lo', description='HALFWIDTH HANGUL LETTER NIEUN-HIEUH', specials={'narrow',0x3136} },
	[0xFFA7] = { unicodeslot=0xFFA7, category='lo', description='HALFWIDTH HANGUL LETTER TIKEUT', specials={'narrow',0x3137} },
	[0xFFA8] = { unicodeslot=0xFFA8, category='lo', description='HALFWIDTH HANGUL LETTER SSANGTIKEUT', specials={'narrow',0x3138} },
	[0xFFA9] = { unicodeslot=0xFFA9, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL', specials={'narrow',0x3139} },
	[0xFFAA] = { unicodeslot=0xFFAA, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-KIYEOK', specials={'narrow',0x313A} },
	[0xFFAB] = { unicodeslot=0xFFAB, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-MIEUM', specials={'narrow',0x313B} },
	[0xFFAC] = { unicodeslot=0xFFAC, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-PIEUP', specials={'narrow',0x313C} },
	[0xFFAD] = { unicodeslot=0xFFAD, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-SIOS', specials={'narrow',0x313D} },
	[0xFFAE] = { unicodeslot=0xFFAE, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-THIEUTH', specials={'narrow',0x313E} },
	[0xFFAF] = { unicodeslot=0xFFAF, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH', specials={'narrow',0x313F} },
	[0xFFB0] = { unicodeslot=0xFFB0, category='lo', description='HALFWIDTH HANGUL LETTER RIEUL-HIEUH', specials={'narrow',0x3140} },
	[0xFFB1] = { unicodeslot=0xFFB1, category='lo', description='HALFWIDTH HANGUL LETTER MIEUM', specials={'narrow',0x3141} },
	[0xFFB2] = { unicodeslot=0xFFB2, category='lo', description='HALFWIDTH HANGUL LETTER PIEUP', specials={'narrow',0x3142} },
	[0xFFB3] = { unicodeslot=0xFFB3, category='lo', description='HALFWIDTH HANGUL LETTER SSANGPIEUP', specials={'narrow',0x3143} },
	[0xFFB4] = { unicodeslot=0xFFB4, category='lo', description='HALFWIDTH HANGUL LETTER PIEUP-SIOS', specials={'narrow',0x3144} },
	[0xFFB5] = { unicodeslot=0xFFB5, category='lo', description='HALFWIDTH HANGUL LETTER SIOS', specials={'narrow',0x3145} },
	[0xFFB6] = { unicodeslot=0xFFB6, category='lo', description='HALFWIDTH HANGUL LETTER SSANGSIOS', specials={'narrow',0x3146} },
	[0xFFB7] = { unicodeslot=0xFFB7, category='lo', description='HALFWIDTH HANGUL LETTER IEUNG', specials={'narrow',0x3147} },
	[0xFFB8] = { unicodeslot=0xFFB8, category='lo', description='HALFWIDTH HANGUL LETTER CIEUC', specials={'narrow',0x3148} },
	[0xFFB9] = { unicodeslot=0xFFB9, category='lo', description='HALFWIDTH HANGUL LETTER SSANGCIEUC', specials={'narrow',0x3149} },
	[0xFFBA] = { unicodeslot=0xFFBA, category='lo', description='HALFWIDTH HANGUL LETTER CHIEUCH', specials={'narrow',0x314A} },
	[0xFFBB] = { unicodeslot=0xFFBB, category='lo', description='HALFWIDTH HANGUL LETTER KHIEUKH', specials={'narrow',0x314B} },
	[0xFFBC] = { unicodeslot=0xFFBC, category='lo', description='HALFWIDTH HANGUL LETTER THIEUTH', specials={'narrow',0x314C} },
	[0xFFBD] = { unicodeslot=0xFFBD, category='lo', description='HALFWIDTH HANGUL LETTER PHIEUPH', specials={'narrow',0x314D} },
	[0xFFBE] = { unicodeslot=0xFFBE, category='lo', description='HALFWIDTH HANGUL LETTER HIEUH', specials={'narrow',0x314E} },
	[0xFFC2] = { unicodeslot=0xFFC2, category='lo', description='HALFWIDTH HANGUL LETTER A', specials={'narrow',0x314F} },
	[0xFFC3] = { unicodeslot=0xFFC3, category='lo', description='HALFWIDTH HANGUL LETTER AE', specials={'narrow',0x3150} },
	[0xFFC4] = { unicodeslot=0xFFC4, category='lo', description='HALFWIDTH HANGUL LETTER YA', specials={'narrow',0x3151} },
	[0xFFC5] = { unicodeslot=0xFFC5, category='lo', description='HALFWIDTH HANGUL LETTER YAE', specials={'narrow',0x3152} },
	[0xFFC6] = { unicodeslot=0xFFC6, category='lo', description='HALFWIDTH HANGUL LETTER EO', specials={'narrow',0x3153} },
	[0xFFC7] = { unicodeslot=0xFFC7, category='lo', description='HALFWIDTH HANGUL LETTER E', specials={'narrow',0x3154} },
	[0xFFCA] = { unicodeslot=0xFFCA, category='lo', description='HALFWIDTH HANGUL LETTER YEO', specials={'narrow',0x3155} },
	[0xFFCB] = { unicodeslot=0xFFCB, category='lo', description='HALFWIDTH HANGUL LETTER YE', specials={'narrow',0x3156} },
	[0xFFCC] = { unicodeslot=0xFFCC, category='lo', description='HALFWIDTH HANGUL LETTER O', specials={'narrow',0x3157} },
	[0xFFCD] = { unicodeslot=0xFFCD, category='lo', description='HALFWIDTH HANGUL LETTER WA', specials={'narrow',0x3158} },
	[0xFFCE] = { unicodeslot=0xFFCE, category='lo', description='HALFWIDTH HANGUL LETTER WAE', specials={'narrow',0x3159} },
	[0xFFCF] = { unicodeslot=0xFFCF, category='lo', description='HALFWIDTH HANGUL LETTER OE', specials={'narrow',0x315A} },
	[0xFFD2] = { unicodeslot=0xFFD2, category='lo', description='HALFWIDTH HANGUL LETTER YO', specials={'narrow',0x315B} },
	[0xFFD3] = { unicodeslot=0xFFD3, category='lo', description='HALFWIDTH HANGUL LETTER U', specials={'narrow',0x315C} },
	[0xFFD4] = { unicodeslot=0xFFD4, category='lo', description='HALFWIDTH HANGUL LETTER WEO', specials={'narrow',0x315D} },
	[0xFFD5] = { unicodeslot=0xFFD5, category='lo', description='HALFWIDTH HANGUL LETTER WE', specials={'narrow',0x315E} },
	[0xFFD6] = { unicodeslot=0xFFD6, category='lo', description='HALFWIDTH HANGUL LETTER WI', specials={'narrow',0x315F} },
	[0xFFD7] = { unicodeslot=0xFFD7, category='lo', description='HALFWIDTH HANGUL LETTER YU', specials={'narrow',0x3160} },
	[0xFFDA] = { unicodeslot=0xFFDA, category='lo', description='HALFWIDTH HANGUL LETTER EU', specials={'narrow',0x3161} },
	[0xFFDB] = { unicodeslot=0xFFDB, category='lo', description='HALFWIDTH HANGUL LETTER YI', specials={'narrow',0x3162} },
	[0xFFDC] = { unicodeslot=0xFFDC, category='lo', description='HALFWIDTH HANGUL LETTER I', specials={'narrow',0x3163} },
	[0xFFE0] = { unicodeslot=0xFFE0, category='sc', description='FULLWIDTH CENT SIGN', specials={'wide',0x00A2} },
	[0xFFE1] = { unicodeslot=0xFFE1, category='sc', description='FULLWIDTH POUND SIGN', specials={'wide',0x00A3} },
	[0xFFE2] = { unicodeslot=0xFFE2, category='sm', description='FULLWIDTH NOT SIGN', specials={'wide',0x00AC} },
	[0xFFE3] = { unicodeslot=0xFFE3, category='sk', description='FULLWIDTH MACRON', specials={'wide',0x00AF} },
	[0xFFE4] = { unicodeslot=0xFFE4, category='so', description='FULLWIDTH BROKEN BAR', specials={'wide',0x00A6} },
	[0xFFE5] = { unicodeslot=0xFFE5, category='sc', description='FULLWIDTH YEN SIGN', specials={'wide',0x00A5} },
	[0xFFE6] = { unicodeslot=0xFFE6, category='sc', description='FULLWIDTH WON SIGN', specials={'wide',0x20A9} },
	[0xFFE8] = { unicodeslot=0xFFE8, category='so', description='HALFWIDTH FORMS LIGHT VERTICAL', specials={'narrow',0x2502} },
	[0xFFE9] = { unicodeslot=0xFFE9, category='sm', description='HALFWIDTH LEFTWARDS ARROW', specials={'narrow',0x2190} },
	[0xFFEA] = { unicodeslot=0xFFEA, category='sm', description='HALFWIDTH UPWARDS ARROW', specials={'narrow',0x2191} },
	[0xFFEB] = { unicodeslot=0xFFEB, category='sm', description='HALFWIDTH RIGHTWARDS ARROW', specials={'narrow',0x2192} },
	[0xFFEC] = { unicodeslot=0xFFEC, category='sm', description='HALFWIDTH DOWNWARDS ARROW', specials={'narrow',0x2193} },
	[0xFFED] = { unicodeslot=0xFFED, category='so', description='HALFWIDTH BLACK SQUARE', specials={'narrow',0x25A0} },
	[0xFFEE] = { unicodeslot=0xFFEE, category='so', description='HALFWIDTH WHITE CIRCLE', specials={'narrow',0x25CB} },
	[0xFFF9] = { unicodeslot=0xFFF9, category='cf', description='INTERLINEAR ANNOTATION ANCHOR' },
	[0xFFFA] = { unicodeslot=0xFFFA, category='cf', description='INTERLINEAR ANNOTATION SEPARATOR' },
	[0xFFFB] = { unicodeslot=0xFFFB, category='cf', description='INTERLINEAR ANNOTATION TERMINATOR' },
	[0xFFFC] = { unicodeslot=0xFFFC, category='so', description='OBJECT REPLACEMENT CHARACTER' },
	[0xFFFD] = { unicodeslot=0xFFFD, category='so', description='REPLACEMENT CHARACTER' },
	[0x10000] = { unicodeslot=0x10000, category='lo', description='LINEAR B SYLLABLE B008 A' },
	[0x10001] = { unicodeslot=0x10001, category='lo', description='LINEAR B SYLLABLE B038 E' },
	[0x10002] = { unicodeslot=0x10002, category='lo', description='LINEAR B SYLLABLE B028 I' },
	[0x10003] = { unicodeslot=0x10003, category='lo', description='LINEAR B SYLLABLE B061 O' },
	[0x10004] = { unicodeslot=0x10004, category='lo', description='LINEAR B SYLLABLE B010 U' },
	[0x10005] = { unicodeslot=0x10005, category='lo', description='LINEAR B SYLLABLE B001 DA' },
	[0x10006] = { unicodeslot=0x10006, category='lo', description='LINEAR B SYLLABLE B045 DE' },
	[0x10007] = { unicodeslot=0x10007, category='lo', description='LINEAR B SYLLABLE B007 DI' },
	[0x10008] = { unicodeslot=0x10008, category='lo', description='LINEAR B SYLLABLE B014 DO' },
	[0x10009] = { unicodeslot=0x10009, category='lo', description='LINEAR B SYLLABLE B051 DU' },
	[0x1000A] = { unicodeslot=0x1000A, category='lo', description='LINEAR B SYLLABLE B057 JA' },
	[0x1000B] = { unicodeslot=0x1000B, category='lo', description='LINEAR B SYLLABLE B046 JE' },
	[0x1000D] = { unicodeslot=0x1000D, category='lo', description='LINEAR B SYLLABLE B036 JO' },
	[0x1000E] = { unicodeslot=0x1000E, category='lo', description='LINEAR B SYLLABLE B065 JU' },
	[0x1000F] = { unicodeslot=0x1000F, category='lo', description='LINEAR B SYLLABLE B077 KA' },
	[0x10010] = { unicodeslot=0x10010, category='lo', description='LINEAR B SYLLABLE B044 KE' },
	[0x10011] = { unicodeslot=0x10011, category='lo', description='LINEAR B SYLLABLE B067 KI' },
	[0x10012] = { unicodeslot=0x10012, category='lo', description='LINEAR B SYLLABLE B070 KO' },
	[0x10013] = { unicodeslot=0x10013, category='lo', description='LINEAR B SYLLABLE B081 KU' },
	[0x10014] = { unicodeslot=0x10014, category='lo', description='LINEAR B SYLLABLE B080 MA' },
	[0x10015] = { unicodeslot=0x10015, category='lo', description='LINEAR B SYLLABLE B013 ME' },
	[0x10016] = { unicodeslot=0x10016, category='lo', description='LINEAR B SYLLABLE B073 MI' },
	[0x10017] = { unicodeslot=0x10017, category='lo', description='LINEAR B SYLLABLE B015 MO' },
	[0x10018] = { unicodeslot=0x10018, category='lo', description='LINEAR B SYLLABLE B023 MU' },
	[0x10019] = { unicodeslot=0x10019, category='lo', description='LINEAR B SYLLABLE B006 NA' },
	[0x1001A] = { unicodeslot=0x1001A, category='lo', description='LINEAR B SYLLABLE B024 NE' },
	[0x1001B] = { unicodeslot=0x1001B, category='lo', description='LINEAR B SYLLABLE B030 NI' },
	[0x1001C] = { unicodeslot=0x1001C, category='lo', description='LINEAR B SYLLABLE B052 NO' },
	[0x1001D] = { unicodeslot=0x1001D, category='lo', description='LINEAR B SYLLABLE B055 NU' },
	[0x1001E] = { unicodeslot=0x1001E, category='lo', description='LINEAR B SYLLABLE B003 PA' },
	[0x1001F] = { unicodeslot=0x1001F, category='lo', description='LINEAR B SYLLABLE B072 PE' },
	[0x10020] = { unicodeslot=0x10020, category='lo', description='LINEAR B SYLLABLE B039 PI' },
	[0x10021] = { unicodeslot=0x10021, category='lo', description='LINEAR B SYLLABLE B011 PO' },
	[0x10022] = { unicodeslot=0x10022, category='lo', description='LINEAR B SYLLABLE B050 PU' },
	[0x10023] = { unicodeslot=0x10023, category='lo', description='LINEAR B SYLLABLE B016 QA' },
	[0x10024] = { unicodeslot=0x10024, category='lo', description='LINEAR B SYLLABLE B078 QE' },
	[0x10025] = { unicodeslot=0x10025, category='lo', description='LINEAR B SYLLABLE B021 QI' },
	[0x10026] = { unicodeslot=0x10026, category='lo', description='LINEAR B SYLLABLE B032 QO' },
	[0x10028] = { unicodeslot=0x10028, category='lo', description='LINEAR B SYLLABLE B060 RA' },
	[0x10029] = { unicodeslot=0x10029, category='lo', description='LINEAR B SYLLABLE B027 RE' },
	[0x1002A] = { unicodeslot=0x1002A, category='lo', description='LINEAR B SYLLABLE B053 RI' },
	[0x1002B] = { unicodeslot=0x1002B, category='lo', description='LINEAR B SYLLABLE B002 RO' },
	[0x1002C] = { unicodeslot=0x1002C, category='lo', description='LINEAR B SYLLABLE B026 RU' },
	[0x1002D] = { unicodeslot=0x1002D, category='lo', description='LINEAR B SYLLABLE B031 SA' },
	[0x1002E] = { unicodeslot=0x1002E, category='lo', description='LINEAR B SYLLABLE B009 SE' },
	[0x1002F] = { unicodeslot=0x1002F, category='lo', description='LINEAR B SYLLABLE B041 SI' },
	[0x10030] = { unicodeslot=0x10030, category='lo', description='LINEAR B SYLLABLE B012 SO' },
	[0x10031] = { unicodeslot=0x10031, category='lo', description='LINEAR B SYLLABLE B058 SU' },
	[0x10032] = { unicodeslot=0x10032, category='lo', description='LINEAR B SYLLABLE B059 TA' },
	[0x10033] = { unicodeslot=0x10033, category='lo', description='LINEAR B SYLLABLE B004 TE' },
	[0x10034] = { unicodeslot=0x10034, category='lo', description='LINEAR B SYLLABLE B037 TI' },
	[0x10035] = { unicodeslot=0x10035, category='lo', description='LINEAR B SYLLABLE B005 TO' },
	[0x10036] = { unicodeslot=0x10036, category='lo', description='LINEAR B SYLLABLE B069 TU' },
	[0x10037] = { unicodeslot=0x10037, category='lo', description='LINEAR B SYLLABLE B054 WA' },
	[0x10038] = { unicodeslot=0x10038, category='lo', description='LINEAR B SYLLABLE B075 WE' },
	[0x10039] = { unicodeslot=0x10039, category='lo', description='LINEAR B SYLLABLE B040 WI' },
	[0x1003A] = { unicodeslot=0x1003A, category='lo', description='LINEAR B SYLLABLE B042 WO' },
	[0x1003C] = { unicodeslot=0x1003C, category='lo', description='LINEAR B SYLLABLE B017 ZA' },
	[0x1003D] = { unicodeslot=0x1003D, category='lo', description='LINEAR B SYLLABLE B074 ZE' },
	[0x1003F] = { unicodeslot=0x1003F, category='lo', description='LINEAR B SYLLABLE B020 ZO' },
	[0x10040] = { unicodeslot=0x10040, category='lo', description='LINEAR B SYLLABLE B025 A2' },
	[0x10041] = { unicodeslot=0x10041, category='lo', description='LINEAR B SYLLABLE B043 A3' },
	[0x10042] = { unicodeslot=0x10042, category='lo', description='LINEAR B SYLLABLE B085 AU' },
	[0x10043] = { unicodeslot=0x10043, category='lo', description='LINEAR B SYLLABLE B071 DWE' },
	[0x10044] = { unicodeslot=0x10044, category='lo', description='LINEAR B SYLLABLE B090 DWO' },
	[0x10045] = { unicodeslot=0x10045, category='lo', description='LINEAR B SYLLABLE B048 NWA' },
	[0x10046] = { unicodeslot=0x10046, category='lo', description='LINEAR B SYLLABLE B029 PU2' },
	[0x10047] = { unicodeslot=0x10047, category='lo', description='LINEAR B SYLLABLE B062 PTE' },
	[0x10048] = { unicodeslot=0x10048, category='lo', description='LINEAR B SYLLABLE B076 RA2' },
	[0x10049] = { unicodeslot=0x10049, category='lo', description='LINEAR B SYLLABLE B033 RA3' },
	[0x1004A] = { unicodeslot=0x1004A, category='lo', description='LINEAR B SYLLABLE B068 RO2' },
	[0x1004B] = { unicodeslot=0x1004B, category='lo', description='LINEAR B SYLLABLE B066 TA2' },
	[0x1004C] = { unicodeslot=0x1004C, category='lo', description='LINEAR B SYLLABLE B087 TWE' },
	[0x1004D] = { unicodeslot=0x1004D, category='lo', description='LINEAR B SYLLABLE B091 TWO' },
	[0x10050] = { unicodeslot=0x10050, category='lo', description='LINEAR B SYMBOL B018' },
	[0x10051] = { unicodeslot=0x10051, category='lo', description='LINEAR B SYMBOL B019' },
	[0x10052] = { unicodeslot=0x10052, category='lo', description='LINEAR B SYMBOL B022' },
	[0x10053] = { unicodeslot=0x10053, category='lo', description='LINEAR B SYMBOL B034' },
	[0x10054] = { unicodeslot=0x10054, category='lo', description='LINEAR B SYMBOL B047' },
	[0x10055] = { unicodeslot=0x10055, category='lo', description='LINEAR B SYMBOL B049' },
	[0x10056] = { unicodeslot=0x10056, category='lo', description='LINEAR B SYMBOL B056' },
	[0x10057] = { unicodeslot=0x10057, category='lo', description='LINEAR B SYMBOL B063' },
	[0x10058] = { unicodeslot=0x10058, category='lo', description='LINEAR B SYMBOL B064' },
	[0x10059] = { unicodeslot=0x10059, category='lo', description='LINEAR B SYMBOL B079' },
	[0x1005A] = { unicodeslot=0x1005A, category='lo', description='LINEAR B SYMBOL B082' },
	[0x1005B] = { unicodeslot=0x1005B, category='lo', description='LINEAR B SYMBOL B083' },
	[0x1005C] = { unicodeslot=0x1005C, category='lo', description='LINEAR B SYMBOL B086' },
	[0x1005D] = { unicodeslot=0x1005D, category='lo', description='LINEAR B SYMBOL B089' },
	[0x10080] = { unicodeslot=0x10080, category='lo', description='LINEAR B IDEOGRAM B100 MAN' },
	[0x10081] = { unicodeslot=0x10081, category='lo', description='LINEAR B IDEOGRAM B102 WOMAN' },
	[0x10082] = { unicodeslot=0x10082, category='lo', description='LINEAR B IDEOGRAM B104 DEER' },
	[0x10083] = { unicodeslot=0x10083, category='lo', description='LINEAR B IDEOGRAM B105 EQUID' },
	[0x10084] = { unicodeslot=0x10084, category='lo', description='LINEAR B IDEOGRAM B105F MARE' },
	[0x10085] = { unicodeslot=0x10085, category='lo', description='LINEAR B IDEOGRAM B105M STALLION' },
	[0x10086] = { unicodeslot=0x10086, category='lo', description='LINEAR B IDEOGRAM B106F EWE' },
	[0x10087] = { unicodeslot=0x10087, category='lo', description='LINEAR B IDEOGRAM B106M RAM' },
	[0x10088] = { unicodeslot=0x10088, category='lo', description='LINEAR B IDEOGRAM B107F SHE-GOAT' },
	[0x10089] = { unicodeslot=0x10089, category='lo', description='LINEAR B IDEOGRAM B107M HE-GOAT' },
	[0x1008A] = { unicodeslot=0x1008A, category='lo', description='LINEAR B IDEOGRAM B108F SOW' },
	[0x1008B] = { unicodeslot=0x1008B, category='lo', description='LINEAR B IDEOGRAM B108M BOAR' },
	[0x1008C] = { unicodeslot=0x1008C, category='lo', description='LINEAR B IDEOGRAM B109F COW' },
	[0x1008D] = { unicodeslot=0x1008D, category='lo', description='LINEAR B IDEOGRAM B109M BULL' },
	[0x1008E] = { unicodeslot=0x1008E, category='lo', description='LINEAR B IDEOGRAM B120 WHEAT' },
	[0x1008F] = { unicodeslot=0x1008F, category='lo', description='LINEAR B IDEOGRAM B121 BARLEY' },
	[0x10090] = { unicodeslot=0x10090, category='lo', description='LINEAR B IDEOGRAM B122 OLIVE' },
	[0x10091] = { unicodeslot=0x10091, category='lo', description='LINEAR B IDEOGRAM B123 SPICE' },
	[0x10092] = { unicodeslot=0x10092, category='lo', description='LINEAR B IDEOGRAM B125 CYPERUS' },
	[0x10093] = { unicodeslot=0x10093, category='lo', description='LINEAR B MONOGRAM B127 KAPO' },
	[0x10094] = { unicodeslot=0x10094, category='lo', description='LINEAR B MONOGRAM B128 KANAKO' },
	[0x10095] = { unicodeslot=0x10095, category='lo', description='LINEAR B IDEOGRAM B130 OIL' },
	[0x10096] = { unicodeslot=0x10096, category='lo', description='LINEAR B IDEOGRAM B131 WINE' },
	[0x10097] = { unicodeslot=0x10097, category='lo', description='LINEAR B IDEOGRAM B132' },
	[0x10098] = { unicodeslot=0x10098, category='lo', description='LINEAR B MONOGRAM B133 AREPA' },
	[0x10099] = { unicodeslot=0x10099, category='lo', description='LINEAR B MONOGRAM B135 MERI' },
	[0x1009A] = { unicodeslot=0x1009A, category='lo', description='LINEAR B IDEOGRAM B140 BRONZE' },
	[0x1009B] = { unicodeslot=0x1009B, category='lo', description='LINEAR B IDEOGRAM B141 GOLD' },
	[0x1009C] = { unicodeslot=0x1009C, category='lo', description='LINEAR B IDEOGRAM B142' },
	[0x1009D] = { unicodeslot=0x1009D, category='lo', description='LINEAR B IDEOGRAM B145 WOOL' },
	[0x1009E] = { unicodeslot=0x1009E, category='lo', description='LINEAR B IDEOGRAM B146' },
	[0x1009F] = { unicodeslot=0x1009F, category='lo', description='LINEAR B IDEOGRAM B150' },
	[0x100A0] = { unicodeslot=0x100A0, category='lo', description='LINEAR B IDEOGRAM B151 HORN' },
	[0x100A1] = { unicodeslot=0x100A1, category='lo', description='LINEAR B IDEOGRAM B152' },
	[0x100A2] = { unicodeslot=0x100A2, category='lo', description='LINEAR B IDEOGRAM B153' },
	[0x100A3] = { unicodeslot=0x100A3, category='lo', description='LINEAR B IDEOGRAM B154' },
	[0x100A4] = { unicodeslot=0x100A4, category='lo', description='LINEAR B MONOGRAM B156 TURO2' },
	[0x100A5] = { unicodeslot=0x100A5, category='lo', description='LINEAR B IDEOGRAM B157' },
	[0x100A6] = { unicodeslot=0x100A6, category='lo', description='LINEAR B IDEOGRAM B158' },
	[0x100A7] = { unicodeslot=0x100A7, category='lo', description='LINEAR B IDEOGRAM B159 CLOTH' },
	[0x100A8] = { unicodeslot=0x100A8, category='lo', description='LINEAR B IDEOGRAM B160' },
	[0x100A9] = { unicodeslot=0x100A9, category='lo', description='LINEAR B IDEOGRAM B161' },
	[0x100AA] = { unicodeslot=0x100AA, category='lo', description='LINEAR B IDEOGRAM B162 GARMENT' },
	[0x100AB] = { unicodeslot=0x100AB, category='lo', description='LINEAR B IDEOGRAM B163 ARMOUR' },
	[0x100AC] = { unicodeslot=0x100AC, category='lo', description='LINEAR B IDEOGRAM B164' },
	[0x100AD] = { unicodeslot=0x100AD, category='lo', description='LINEAR B IDEOGRAM B165' },
	[0x100AE] = { unicodeslot=0x100AE, category='lo', description='LINEAR B IDEOGRAM B166' },
	[0x100AF] = { unicodeslot=0x100AF, category='lo', description='LINEAR B IDEOGRAM B167' },
	[0x100B0] = { unicodeslot=0x100B0, category='lo', description='LINEAR B IDEOGRAM B168' },
	[0x100B1] = { unicodeslot=0x100B1, category='lo', description='LINEAR B IDEOGRAM B169' },
	[0x100B2] = { unicodeslot=0x100B2, category='lo', description='LINEAR B IDEOGRAM B170' },
	[0x100B3] = { unicodeslot=0x100B3, category='lo', description='LINEAR B IDEOGRAM B171' },
	[0x100B4] = { unicodeslot=0x100B4, category='lo', description='LINEAR B IDEOGRAM B172' },
	[0x100B5] = { unicodeslot=0x100B5, category='lo', description='LINEAR B IDEOGRAM B173 MONTH' },
	[0x100B6] = { unicodeslot=0x100B6, category='lo', description='LINEAR B IDEOGRAM B174' },
	[0x100B7] = { unicodeslot=0x100B7, category='lo', description='LINEAR B IDEOGRAM B176 TREE' },
	[0x100B8] = { unicodeslot=0x100B8, category='lo', description='LINEAR B IDEOGRAM B177' },
	[0x100B9] = { unicodeslot=0x100B9, category='lo', description='LINEAR B IDEOGRAM B178' },
	[0x100BA] = { unicodeslot=0x100BA, category='lo', description='LINEAR B IDEOGRAM B179' },
	[0x100BB] = { unicodeslot=0x100BB, category='lo', description='LINEAR B IDEOGRAM B180' },
	[0x100BC] = { unicodeslot=0x100BC, category='lo', description='LINEAR B IDEOGRAM B181' },
	[0x100BD] = { unicodeslot=0x100BD, category='lo', description='LINEAR B IDEOGRAM B182' },
	[0x100BE] = { unicodeslot=0x100BE, category='lo', description='LINEAR B IDEOGRAM B183' },
	[0x100BF] = { unicodeslot=0x100BF, category='lo', description='LINEAR B IDEOGRAM B184' },
	[0x100C0] = { unicodeslot=0x100C0, category='lo', description='LINEAR B IDEOGRAM B185' },
	[0x100C1] = { unicodeslot=0x100C1, category='lo', description='LINEAR B IDEOGRAM B189' },
	[0x100C2] = { unicodeslot=0x100C2, category='lo', description='LINEAR B IDEOGRAM B190' },
	[0x100C3] = { unicodeslot=0x100C3, category='lo', description='LINEAR B IDEOGRAM B191 HELMET' },
	[0x100C4] = { unicodeslot=0x100C4, category='lo', description='LINEAR B IDEOGRAM B220 FOOTSTOOL' },
	[0x100C5] = { unicodeslot=0x100C5, category='lo', description='LINEAR B IDEOGRAM B225 BATHTUB' },
	[0x100C6] = { unicodeslot=0x100C6, category='lo', description='LINEAR B IDEOGRAM B230 SPEAR' },
	[0x100C7] = { unicodeslot=0x100C7, category='lo', description='LINEAR B IDEOGRAM B231 ARROW' },
	[0x100C8] = { unicodeslot=0x100C8, category='lo', description='LINEAR B IDEOGRAM B232' },
	[0x100C9] = { unicodeslot=0x100C9, category='lo', description='LINEAR B IDEOGRAM B233 SWORD' },
	[0x100CA] = { unicodeslot=0x100CA, category='lo', description='LINEAR B IDEOGRAM B234' },
	[0x100CB] = { unicodeslot=0x100CB, category='lo', description='LINEAR B IDEOGRAM B236' },
	[0x100CC] = { unicodeslot=0x100CC, category='lo', description='LINEAR B IDEOGRAM B240 WHEELED CHARIOT' },
	[0x100CD] = { unicodeslot=0x100CD, category='lo', description='LINEAR B IDEOGRAM B241 CHARIOT' },
	[0x100CE] = { unicodeslot=0x100CE, category='lo', description='LINEAR B IDEOGRAM B242 CHARIOT FRAME' },
	[0x100CF] = { unicodeslot=0x100CF, category='lo', description='LINEAR B IDEOGRAM B243 WHEEL' },
	[0x100D0] = { unicodeslot=0x100D0, category='lo', description='LINEAR B IDEOGRAM B245' },
	[0x100D1] = { unicodeslot=0x100D1, category='lo', description='LINEAR B IDEOGRAM B246' },
	[0x100D2] = { unicodeslot=0x100D2, category='lo', description='LINEAR B MONOGRAM B247 DIPTE' },
	[0x100D3] = { unicodeslot=0x100D3, category='lo', description='LINEAR B IDEOGRAM B248' },
	[0x100D4] = { unicodeslot=0x100D4, category='lo', description='LINEAR B IDEOGRAM B249' },
	[0x100D5] = { unicodeslot=0x100D5, category='lo', description='LINEAR B IDEOGRAM B251' },
	[0x100D6] = { unicodeslot=0x100D6, category='lo', description='LINEAR B IDEOGRAM B252' },
	[0x100D7] = { unicodeslot=0x100D7, category='lo', description='LINEAR B IDEOGRAM B253' },
	[0x100D8] = { unicodeslot=0x100D8, category='lo', description='LINEAR B IDEOGRAM B254 DART' },
	[0x100D9] = { unicodeslot=0x100D9, category='lo', description='LINEAR B IDEOGRAM B255' },
	[0x100DA] = { unicodeslot=0x100DA, category='lo', description='LINEAR B IDEOGRAM B256' },
	[0x100DB] = { unicodeslot=0x100DB, category='lo', description='LINEAR B IDEOGRAM B257' },
	[0x100DC] = { unicodeslot=0x100DC, category='lo', description='LINEAR B IDEOGRAM B258' },
	[0x100DD] = { unicodeslot=0x100DD, category='lo', description='LINEAR B IDEOGRAM B259' },
	[0x100DE] = { unicodeslot=0x100DE, category='lo', description='LINEAR B IDEOGRAM VESSEL B155' },
	[0x100DF] = { unicodeslot=0x100DF, category='lo', description='LINEAR B IDEOGRAM VESSEL B200' },
	[0x100E0] = { unicodeslot=0x100E0, category='lo', description='LINEAR B IDEOGRAM VESSEL B201' },
	[0x100E1] = { unicodeslot=0x100E1, category='lo', description='LINEAR B IDEOGRAM VESSEL B202' },
	[0x100E2] = { unicodeslot=0x100E2, category='lo', description='LINEAR B IDEOGRAM VESSEL B203' },
	[0x100E3] = { unicodeslot=0x100E3, category='lo', description='LINEAR B IDEOGRAM VESSEL B204' },
	[0x100E4] = { unicodeslot=0x100E4, category='lo', description='LINEAR B IDEOGRAM VESSEL B205' },
	[0x100E5] = { unicodeslot=0x100E5, category='lo', description='LINEAR B IDEOGRAM VESSEL B206' },
	[0x100E6] = { unicodeslot=0x100E6, category='lo', description='LINEAR B IDEOGRAM VESSEL B207' },
	[0x100E7] = { unicodeslot=0x100E7, category='lo', description='LINEAR B IDEOGRAM VESSEL B208' },
	[0x100E8] = { unicodeslot=0x100E8, category='lo', description='LINEAR B IDEOGRAM VESSEL B209' },
	[0x100E9] = { unicodeslot=0x100E9, category='lo', description='LINEAR B IDEOGRAM VESSEL B210' },
	[0x100EA] = { unicodeslot=0x100EA, category='lo', description='LINEAR B IDEOGRAM VESSEL B211' },
	[0x100EB] = { unicodeslot=0x100EB, category='lo', description='LINEAR B IDEOGRAM VESSEL B212' },
	[0x100EC] = { unicodeslot=0x100EC, category='lo', description='LINEAR B IDEOGRAM VESSEL B213' },
	[0x100ED] = { unicodeslot=0x100ED, category='lo', description='LINEAR B IDEOGRAM VESSEL B214' },
	[0x100EE] = { unicodeslot=0x100EE, category='lo', description='LINEAR B IDEOGRAM VESSEL B215' },
	[0x100EF] = { unicodeslot=0x100EF, category='lo', description='LINEAR B IDEOGRAM VESSEL B216' },
	[0x100F0] = { unicodeslot=0x100F0, category='lo', description='LINEAR B IDEOGRAM VESSEL B217' },
	[0x100F1] = { unicodeslot=0x100F1, category='lo', description='LINEAR B IDEOGRAM VESSEL B218' },
	[0x100F2] = { unicodeslot=0x100F2, category='lo', description='LINEAR B IDEOGRAM VESSEL B219' },
	[0x100F3] = { unicodeslot=0x100F3, category='lo', description='LINEAR B IDEOGRAM VESSEL B221' },
	[0x100F4] = { unicodeslot=0x100F4, category='lo', description='LINEAR B IDEOGRAM VESSEL B222' },
	[0x100F5] = { unicodeslot=0x100F5, category='lo', description='LINEAR B IDEOGRAM VESSEL B226' },
	[0x100F6] = { unicodeslot=0x100F6, category='lo', description='LINEAR B IDEOGRAM VESSEL B227' },
	[0x100F7] = { unicodeslot=0x100F7, category='lo', description='LINEAR B IDEOGRAM VESSEL B228' },
	[0x100F8] = { unicodeslot=0x100F8, category='lo', description='LINEAR B IDEOGRAM VESSEL B229' },
	[0x100F9] = { unicodeslot=0x100F9, category='lo', description='LINEAR B IDEOGRAM VESSEL B250' },
	[0x100FA] = { unicodeslot=0x100FA, category='lo', description='LINEAR B IDEOGRAM VESSEL B305' },
	[0x10100] = { unicodeslot=0x10100, category='po', description='AEGEAN WORD SEPARATOR LINE' },
	[0x10101] = { unicodeslot=0x10101, category='po', description='AEGEAN WORD SEPARATOR DOT' },
	[0x10102] = { unicodeslot=0x10102, category='so', description='AEGEAN CHECK MARK' },
	[0x10107] = { unicodeslot=0x10107, category='no', description='AEGEAN NUMBER ONE' },
	[0x10108] = { unicodeslot=0x10108, category='no', description='AEGEAN NUMBER TWO' },
	[0x10109] = { unicodeslot=0x10109, category='no', description='AEGEAN NUMBER THREE' },
	[0x1010A] = { unicodeslot=0x1010A, category='no', description='AEGEAN NUMBER FOUR' },
	[0x1010B] = { unicodeslot=0x1010B, category='no', description='AEGEAN NUMBER FIVE' },
	[0x1010C] = { unicodeslot=0x1010C, category='no', description='AEGEAN NUMBER SIX' },
	[0x1010D] = { unicodeslot=0x1010D, category='no', description='AEGEAN NUMBER SEVEN' },
	[0x1010E] = { unicodeslot=0x1010E, category='no', description='AEGEAN NUMBER EIGHT' },
	[0x1010F] = { unicodeslot=0x1010F, category='no', description='AEGEAN NUMBER NINE' },
	[0x10110] = { unicodeslot=0x10110, category='no', description='AEGEAN NUMBER TEN' },
	[0x10111] = { unicodeslot=0x10111, category='no', description='AEGEAN NUMBER TWENTY' },
	[0x10112] = { unicodeslot=0x10112, category='no', description='AEGEAN NUMBER THIRTY' },
	[0x10113] = { unicodeslot=0x10113, category='no', description='AEGEAN NUMBER FORTY' },
	[0x10114] = { unicodeslot=0x10114, category='no', description='AEGEAN NUMBER FIFTY' },
	[0x10115] = { unicodeslot=0x10115, category='no', description='AEGEAN NUMBER SIXTY' },
	[0x10116] = { unicodeslot=0x10116, category='no', description='AEGEAN NUMBER SEVENTY' },
	[0x10117] = { unicodeslot=0x10117, category='no', description='AEGEAN NUMBER EIGHTY' },
	[0x10118] = { unicodeslot=0x10118, category='no', description='AEGEAN NUMBER NINETY' },
	[0x10119] = { unicodeslot=0x10119, category='no', description='AEGEAN NUMBER ONE HUNDRED' },
	[0x1011A] = { unicodeslot=0x1011A, category='no', description='AEGEAN NUMBER TWO HUNDRED' },
	[0x1011B] = { unicodeslot=0x1011B, category='no', description='AEGEAN NUMBER THREE HUNDRED' },
	[0x1011C] = { unicodeslot=0x1011C, category='no', description='AEGEAN NUMBER FOUR HUNDRED' },
	[0x1011D] = { unicodeslot=0x1011D, category='no', description='AEGEAN NUMBER FIVE HUNDRED' },
	[0x1011E] = { unicodeslot=0x1011E, category='no', description='AEGEAN NUMBER SIX HUNDRED' },
	[0x1011F] = { unicodeslot=0x1011F, category='no', description='AEGEAN NUMBER SEVEN HUNDRED' },
	[0x10120] = { unicodeslot=0x10120, category='no', description='AEGEAN NUMBER EIGHT HUNDRED' },
	[0x10121] = { unicodeslot=0x10121, category='no', description='AEGEAN NUMBER NINE HUNDRED' },
	[0x10122] = { unicodeslot=0x10122, category='no', description='AEGEAN NUMBER ONE THOUSAND' },
	[0x10123] = { unicodeslot=0x10123, category='no', description='AEGEAN NUMBER TWO THOUSAND' },
	[0x10124] = { unicodeslot=0x10124, category='no', description='AEGEAN NUMBER THREE THOUSAND' },
	[0x10125] = { unicodeslot=0x10125, category='no', description='AEGEAN NUMBER FOUR THOUSAND' },
	[0x10126] = { unicodeslot=0x10126, category='no', description='AEGEAN NUMBER FIVE THOUSAND' },
	[0x10127] = { unicodeslot=0x10127, category='no', description='AEGEAN NUMBER SIX THOUSAND' },
	[0x10128] = { unicodeslot=0x10128, category='no', description='AEGEAN NUMBER SEVEN THOUSAND' },
	[0x10129] = { unicodeslot=0x10129, category='no', description='AEGEAN NUMBER EIGHT THOUSAND' },
	[0x1012A] = { unicodeslot=0x1012A, category='no', description='AEGEAN NUMBER NINE THOUSAND' },
	[0x1012B] = { unicodeslot=0x1012B, category='no', description='AEGEAN NUMBER TEN THOUSAND' },
	[0x1012C] = { unicodeslot=0x1012C, category='no', description='AEGEAN NUMBER TWENTY THOUSAND' },
	[0x1012D] = { unicodeslot=0x1012D, category='no', description='AEGEAN NUMBER THIRTY THOUSAND' },
	[0x1012E] = { unicodeslot=0x1012E, category='no', description='AEGEAN NUMBER FORTY THOUSAND' },
	[0x1012F] = { unicodeslot=0x1012F, category='no', description='AEGEAN NUMBER FIFTY THOUSAND' },
	[0x10130] = { unicodeslot=0x10130, category='no', description='AEGEAN NUMBER SIXTY THOUSAND' },
	[0x10131] = { unicodeslot=0x10131, category='no', description='AEGEAN NUMBER SEVENTY THOUSAND' },
	[0x10132] = { unicodeslot=0x10132, category='no', description='AEGEAN NUMBER EIGHTY THOUSAND' },
	[0x10133] = { unicodeslot=0x10133, category='no', description='AEGEAN NUMBER NINETY THOUSAND' },
	[0x10137] = { unicodeslot=0x10137, category='so', description='AEGEAN WEIGHT BASE UNIT' },
	[0x10138] = { unicodeslot=0x10138, category='so', description='AEGEAN WEIGHT FIRST SUBUNIT' },
	[0x10139] = { unicodeslot=0x10139, category='so', description='AEGEAN WEIGHT SECOND SUBUNIT' },
	[0x1013A] = { unicodeslot=0x1013A, category='so', description='AEGEAN WEIGHT THIRD SUBUNIT' },
	[0x1013B] = { unicodeslot=0x1013B, category='so', description='AEGEAN WEIGHT FOURTH SUBUNIT' },
	[0x1013C] = { unicodeslot=0x1013C, category='so', description='AEGEAN DRY MEASURE FIRST SUBUNIT' },
	[0x1013D] = { unicodeslot=0x1013D, category='so', description='AEGEAN LIQUID MEASURE FIRST SUBUNIT' },
	[0x1013E] = { unicodeslot=0x1013E, category='so', description='AEGEAN MEASURE SECOND SUBUNIT' },
	[0x1013F] = { unicodeslot=0x1013F, category='so', description='AEGEAN MEASURE THIRD SUBUNIT' },
	[0x10140] = { unicodeslot=0x10140, category='nl', description='GREEK ACROPHONIC ATTIC ONE QUARTER' },
	[0x10141] = { unicodeslot=0x10141, category='nl', description='GREEK ACROPHONIC ATTIC ONE HALF' },
	[0x10142] = { unicodeslot=0x10142, category='nl', description='GREEK ACROPHONIC ATTIC ONE DRACHMA' },
	[0x10143] = { unicodeslot=0x10143, category='nl', description='GREEK ACROPHONIC ATTIC FIVE' },
	[0x10144] = { unicodeslot=0x10144, category='nl', description='GREEK ACROPHONIC ATTIC FIFTY' },
	[0x10145] = { unicodeslot=0x10145, category='nl', description='GREEK ACROPHONIC ATTIC FIVE HUNDRED' },
	[0x10146] = { unicodeslot=0x10146, category='nl', description='GREEK ACROPHONIC ATTIC FIVE THOUSAND' },
	[0x10147] = { unicodeslot=0x10147, category='nl', description='GREEK ACROPHONIC ATTIC FIFTY THOUSAND' },
	[0x10148] = { unicodeslot=0x10148, category='nl', description='GREEK ACROPHONIC ATTIC FIVE TALENTS' },
	[0x10149] = { unicodeslot=0x10149, category='nl', description='GREEK ACROPHONIC ATTIC TEN TALENTS' },
	[0x1014A] = { unicodeslot=0x1014A, category='nl', description='GREEK ACROPHONIC ATTIC FIFTY TALENTS' },
	[0x1014B] = { unicodeslot=0x1014B, category='nl', description='GREEK ACROPHONIC ATTIC ONE HUNDRED TALENTS' },
	[0x1014C] = { unicodeslot=0x1014C, category='nl', description='GREEK ACROPHONIC ATTIC FIVE HUNDRED TALENTS' },
	[0x1014D] = { unicodeslot=0x1014D, category='nl', description='GREEK ACROPHONIC ATTIC ONE THOUSAND TALENTS' },
	[0x1014E] = { unicodeslot=0x1014E, category='nl', description='GREEK ACROPHONIC ATTIC FIVE THOUSAND TALENTS' },
	[0x1014F] = { unicodeslot=0x1014F, category='nl', description='GREEK ACROPHONIC ATTIC FIVE STATERS' },
	[0x10150] = { unicodeslot=0x10150, category='nl', description='GREEK ACROPHONIC ATTIC TEN STATERS' },
	[0x10151] = { unicodeslot=0x10151, category='nl', description='GREEK ACROPHONIC ATTIC FIFTY STATERS' },
	[0x10152] = { unicodeslot=0x10152, category='nl', description='GREEK ACROPHONIC ATTIC ONE HUNDRED STATERS' },
	[0x10153] = { unicodeslot=0x10153, category='nl', description='GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS' },
	[0x10154] = { unicodeslot=0x10154, category='nl', description='GREEK ACROPHONIC ATTIC ONE THOUSAND STATERS' },
	[0x10155] = { unicodeslot=0x10155, category='nl', description='GREEK ACROPHONIC ATTIC TEN THOUSAND STATERS' },
	[0x10156] = { unicodeslot=0x10156, category='nl', description='GREEK ACROPHONIC ATTIC FIFTY THOUSAND STATERS' },
	[0x10157] = { unicodeslot=0x10157, category='nl', description='GREEK ACROPHONIC ATTIC TEN MNAS' },
	[0x10158] = { unicodeslot=0x10158, category='nl', description='GREEK ACROPHONIC HERAEUM ONE PLETHRON' },
	[0x10159] = { unicodeslot=0x10159, category='nl', description='GREEK ACROPHONIC THESPIAN ONE' },
	[0x1015A] = { unicodeslot=0x1015A, category='nl', description='GREEK ACROPHONIC HERMIONIAN ONE' },
	[0x1015B] = { unicodeslot=0x1015B, category='nl', description='GREEK ACROPHONIC EPIDAUREAN TWO' },
	[0x1015C] = { unicodeslot=0x1015C, category='nl', description='GREEK ACROPHONIC THESPIAN TWO' },
	[0x1015D] = { unicodeslot=0x1015D, category='nl', description='GREEK ACROPHONIC CYRENAIC TWO DRACHMAS' },
	[0x1015E] = { unicodeslot=0x1015E, category='nl', description='GREEK ACROPHONIC EPIDAUREAN TWO DRACHMAS' },
	[0x1015F] = { unicodeslot=0x1015F, category='nl', description='GREEK ACROPHONIC TROEZENIAN FIVE' },
	[0x10160] = { unicodeslot=0x10160, category='nl', description='GREEK ACROPHONIC TROEZENIAN TEN' },
	[0x10161] = { unicodeslot=0x10161, category='nl', description='GREEK ACROPHONIC TROEZENIAN TEN ALTERNATE FORM' },
	[0x10162] = { unicodeslot=0x10162, category='nl', description='GREEK ACROPHONIC HERMIONIAN TEN' },
	[0x10163] = { unicodeslot=0x10163, category='nl', description='GREEK ACROPHONIC MESSENIAN TEN' },
	[0x10164] = { unicodeslot=0x10164, category='nl', description='GREEK ACROPHONIC THESPIAN TEN' },
	[0x10165] = { unicodeslot=0x10165, category='nl', description='GREEK ACROPHONIC THESPIAN THIRTY' },
	[0x10166] = { unicodeslot=0x10166, category='nl', description='GREEK ACROPHONIC TROEZENIAN FIFTY' },
	[0x10167] = { unicodeslot=0x10167, category='nl', description='GREEK ACROPHONIC TROEZENIAN FIFTY ALTERNATE FORM' },
	[0x10168] = { unicodeslot=0x10168, category='nl', description='GREEK ACROPHONIC HERMIONIAN FIFTY' },
	[0x10169] = { unicodeslot=0x10169, category='nl', description='GREEK ACROPHONIC THESPIAN FIFTY' },
	[0x1016A] = { unicodeslot=0x1016A, category='nl', description='GREEK ACROPHONIC THESPIAN ONE HUNDRED' },
	[0x1016B] = { unicodeslot=0x1016B, category='nl', description='GREEK ACROPHONIC THESPIAN THREE HUNDRED' },
	[0x1016C] = { unicodeslot=0x1016C, category='nl', description='GREEK ACROPHONIC EPIDAUREAN FIVE HUNDRED' },
	[0x1016D] = { unicodeslot=0x1016D, category='nl', description='GREEK ACROPHONIC TROEZENIAN FIVE HUNDRED' },
	[0x1016E] = { unicodeslot=0x1016E, category='nl', description='GREEK ACROPHONIC THESPIAN FIVE HUNDRED' },
	[0x1016F] = { unicodeslot=0x1016F, category='nl', description='GREEK ACROPHONIC CARYSTIAN FIVE HUNDRED' },
	[0x10170] = { unicodeslot=0x10170, category='nl', description='GREEK ACROPHONIC NAXIAN FIVE HUNDRED' },
	[0x10171] = { unicodeslot=0x10171, category='nl', description='GREEK ACROPHONIC THESPIAN ONE THOUSAND' },
	[0x10172] = { unicodeslot=0x10172, category='nl', description='GREEK ACROPHONIC THESPIAN FIVE THOUSAND' },
	[0x10173] = { unicodeslot=0x10173, category='nl', description='GREEK ACROPHONIC DELPHIC FIVE MNAS' },
	[0x10174] = { unicodeslot=0x10174, category='nl', description='GREEK ACROPHONIC STRATIAN FIFTY MNAS' },
	[0x10175] = { unicodeslot=0x10175, category='no', description='GREEK ONE HALF SIGN' },
	[0x10176] = { unicodeslot=0x10176, category='no', description='GREEK ONE HALF SIGN ALTERNATE FORM' },
	[0x10177] = { unicodeslot=0x10177, category='no', description='GREEK TWO THIRDS SIGN' },
	[0x10178] = { unicodeslot=0x10178, category='no', description='GREEK THREE QUARTERS SIGN' },
	[0x10179] = { unicodeslot=0x10179, category='so', description='GREEK YEAR SIGN' },
	[0x1017A] = { unicodeslot=0x1017A, category='so', description='GREEK TALENT SIGN' },
	[0x1017B] = { unicodeslot=0x1017B, category='so', description='GREEK DRACHMA SIGN' },
	[0x1017C] = { unicodeslot=0x1017C, category='so', description='GREEK OBOL SIGN' },
	[0x1017D] = { unicodeslot=0x1017D, category='so', description='GREEK TWO OBOLS SIGN' },
	[0x1017E] = { unicodeslot=0x1017E, category='so', description='GREEK THREE OBOLS SIGN' },
	[0x1017F] = { unicodeslot=0x1017F, category='so', description='GREEK FOUR OBOLS SIGN' },
	[0x10180] = { unicodeslot=0x10180, category='so', description='GREEK FIVE OBOLS SIGN' },
	[0x10181] = { unicodeslot=0x10181, category='so', description='GREEK METRETES SIGN' },
	[0x10182] = { unicodeslot=0x10182, category='so', description='GREEK KYATHOS BASE SIGN' },
	[0x10183] = { unicodeslot=0x10183, category='so', description='GREEK LITRA SIGN' },
	[0x10184] = { unicodeslot=0x10184, category='so', description='GREEK OUNKIA SIGN' },
	[0x10185] = { unicodeslot=0x10185, category='so', description='GREEK XESTES SIGN' },
	[0x10186] = { unicodeslot=0x10186, category='so', description='GREEK ARTABE SIGN' },
	[0x10187] = { unicodeslot=0x10187, category='so', description='GREEK AROURA SIGN' },
	[0x10188] = { unicodeslot=0x10188, category='so', description='GREEK GRAMMA SIGN' },
	[0x10189] = { unicodeslot=0x10189, category='so', description='GREEK TRYBLION BASE SIGN' },
	[0x1018A] = { unicodeslot=0x1018A, category='no', description='GREEK ZERO SIGN' },
	[0x10300] = { unicodeslot=0x10300, category='lo', description='OLD ITALIC LETTER A' },
	[0x10301] = { unicodeslot=0x10301, category='lo', description='OLD ITALIC LETTER BE' },
	[0x10302] = { unicodeslot=0x10302, category='lo', description='OLD ITALIC LETTER KE' },
	[0x10303] = { unicodeslot=0x10303, category='lo', description='OLD ITALIC LETTER DE' },
	[0x10304] = { unicodeslot=0x10304, category='lo', description='OLD ITALIC LETTER E' },
	[0x10305] = { unicodeslot=0x10305, category='lo', description='OLD ITALIC LETTER VE' },
	[0x10306] = { unicodeslot=0x10306, category='lo', description='OLD ITALIC LETTER ZE' },
	[0x10307] = { unicodeslot=0x10307, category='lo', description='OLD ITALIC LETTER HE' },
	[0x10308] = { unicodeslot=0x10308, category='lo', description='OLD ITALIC LETTER THE' },
	[0x10309] = { unicodeslot=0x10309, category='lo', description='OLD ITALIC LETTER I' },
	[0x1030A] = { unicodeslot=0x1030A, category='lo', description='OLD ITALIC LETTER KA' },
	[0x1030B] = { unicodeslot=0x1030B, category='lo', description='OLD ITALIC LETTER EL' },
	[0x1030C] = { unicodeslot=0x1030C, category='lo', description='OLD ITALIC LETTER EM' },
	[0x1030D] = { unicodeslot=0x1030D, category='lo', description='OLD ITALIC LETTER EN' },
	[0x1030E] = { unicodeslot=0x1030E, category='lo', description='OLD ITALIC LETTER ESH' },
	[0x1030F] = { unicodeslot=0x1030F, category='lo', description='OLD ITALIC LETTER O' },
	[0x10310] = { unicodeslot=0x10310, category='lo', description='OLD ITALIC LETTER PE' },
	[0x10311] = { unicodeslot=0x10311, category='lo', description='OLD ITALIC LETTER SHE' },
	[0x10312] = { unicodeslot=0x10312, category='lo', description='OLD ITALIC LETTER KU' },
	[0x10313] = { unicodeslot=0x10313, category='lo', description='OLD ITALIC LETTER ER' },
	[0x10314] = { unicodeslot=0x10314, category='lo', description='OLD ITALIC LETTER ES' },
	[0x10315] = { unicodeslot=0x10315, category='lo', description='OLD ITALIC LETTER TE' },
	[0x10316] = { unicodeslot=0x10316, category='lo', description='OLD ITALIC LETTER U' },
	[0x10317] = { unicodeslot=0x10317, category='lo', description='OLD ITALIC LETTER EKS' },
	[0x10318] = { unicodeslot=0x10318, category='lo', description='OLD ITALIC LETTER PHE' },
	[0x10319] = { unicodeslot=0x10319, category='lo', description='OLD ITALIC LETTER KHE' },
	[0x1031A] = { unicodeslot=0x1031A, category='lo', description='OLD ITALIC LETTER EF' },
	[0x1031B] = { unicodeslot=0x1031B, category='lo', description='OLD ITALIC LETTER ERS' },
	[0x1031C] = { unicodeslot=0x1031C, category='lo', description='OLD ITALIC LETTER CHE' },
	[0x1031D] = { unicodeslot=0x1031D, category='lo', description='OLD ITALIC LETTER II' },
	[0x1031E] = { unicodeslot=0x1031E, category='lo', description='OLD ITALIC LETTER UU' },
	[0x10320] = { unicodeslot=0x10320, category='no', description='OLD ITALIC NUMERAL ONE' },
	[0x10321] = { unicodeslot=0x10321, category='no', description='OLD ITALIC NUMERAL FIVE' },
	[0x10322] = { unicodeslot=0x10322, category='no', description='OLD ITALIC NUMERAL TEN' },
	[0x10323] = { unicodeslot=0x10323, category='no', description='OLD ITALIC NUMERAL FIFTY' },
	[0x10330] = { unicodeslot=0x10330, category='lo', description='GOTHIC LETTER AHSA' },
	[0x10331] = { unicodeslot=0x10331, category='lo', description='GOTHIC LETTER BAIRKAN' },
	[0x10332] = { unicodeslot=0x10332, category='lo', description='GOTHIC LETTER GIBA' },
	[0x10333] = { unicodeslot=0x10333, category='lo', description='GOTHIC LETTER DAGS' },
	[0x10334] = { unicodeslot=0x10334, category='lo', description='GOTHIC LETTER AIHVUS' },
	[0x10335] = { unicodeslot=0x10335, category='lo', description='GOTHIC LETTER QAIRTHRA' },
	[0x10336] = { unicodeslot=0x10336, category='lo', description='GOTHIC LETTER IUJA' },
	[0x10337] = { unicodeslot=0x10337, category='lo', description='GOTHIC LETTER HAGL' },
	[0x10338] = { unicodeslot=0x10338, category='lo', description='GOTHIC LETTER THIUTH' },
	[0x10339] = { unicodeslot=0x10339, category='lo', description='GOTHIC LETTER EIS' },
	[0x1033A] = { unicodeslot=0x1033A, category='lo', description='GOTHIC LETTER KUSMA' },
	[0x1033B] = { unicodeslot=0x1033B, category='lo', description='GOTHIC LETTER LAGUS' },
	[0x1033C] = { unicodeslot=0x1033C, category='lo', description='GOTHIC LETTER MANNA' },
	[0x1033D] = { unicodeslot=0x1033D, category='lo', description='GOTHIC LETTER NAUTHS' },
	[0x1033E] = { unicodeslot=0x1033E, category='lo', description='GOTHIC LETTER JER' },
	[0x1033F] = { unicodeslot=0x1033F, category='lo', description='GOTHIC LETTER URUS' },
	[0x10340] = { unicodeslot=0x10340, category='lo', description='GOTHIC LETTER PAIRTHRA' },
	[0x10341] = { unicodeslot=0x10341, category='nl', description='GOTHIC LETTER NINETY' },
	[0x10342] = { unicodeslot=0x10342, category='lo', description='GOTHIC LETTER RAIDA' },
	[0x10343] = { unicodeslot=0x10343, category='lo', description='GOTHIC LETTER SAUIL' },
	[0x10344] = { unicodeslot=0x10344, category='lo', description='GOTHIC LETTER TEIWS' },
	[0x10345] = { unicodeslot=0x10345, category='lo', description='GOTHIC LETTER WINJA' },
	[0x10346] = { unicodeslot=0x10346, category='lo', description='GOTHIC LETTER FAIHU' },
	[0x10347] = { unicodeslot=0x10347, category='lo', description='GOTHIC LETTER IGGWS' },
	[0x10348] = { unicodeslot=0x10348, category='lo', description='GOTHIC LETTER HWAIR' },
	[0x10349] = { unicodeslot=0x10349, category='lo', description='GOTHIC LETTER OTHAL' },
	[0x1034A] = { unicodeslot=0x1034A, category='nl', description='GOTHIC LETTER NINE HUNDRED' },
	[0x10380] = { unicodeslot=0x10380, category='lo', description='UGARITIC LETTER ALPA' },
	[0x10381] = { unicodeslot=0x10381, category='lo', description='UGARITIC LETTER BETA' },
	[0x10382] = { unicodeslot=0x10382, category='lo', description='UGARITIC LETTER GAMLA' },
	[0x10383] = { unicodeslot=0x10383, category='lo', description='UGARITIC LETTER KHA' },
	[0x10384] = { unicodeslot=0x10384, category='lo', description='UGARITIC LETTER DELTA' },
	[0x10385] = { unicodeslot=0x10385, category='lo', description='UGARITIC LETTER HO' },
	[0x10386] = { unicodeslot=0x10386, category='lo', description='UGARITIC LETTER WO' },
	[0x10387] = { unicodeslot=0x10387, category='lo', description='UGARITIC LETTER ZETA' },
	[0x10388] = { unicodeslot=0x10388, category='lo', description='UGARITIC LETTER HOTA' },
	[0x10389] = { unicodeslot=0x10389, category='lo', description='UGARITIC LETTER TET' },
	[0x1038A] = { unicodeslot=0x1038A, category='lo', description='UGARITIC LETTER YOD' },
	[0x1038B] = { unicodeslot=0x1038B, category='lo', description='UGARITIC LETTER KAF' },
	[0x1038C] = { unicodeslot=0x1038C, category='lo', description='UGARITIC LETTER SHIN' },
	[0x1038D] = { unicodeslot=0x1038D, category='lo', description='UGARITIC LETTER LAMDA' },
	[0x1038E] = { unicodeslot=0x1038E, category='lo', description='UGARITIC LETTER MEM' },
	[0x1038F] = { unicodeslot=0x1038F, category='lo', description='UGARITIC LETTER DHAL' },
	[0x10390] = { unicodeslot=0x10390, category='lo', description='UGARITIC LETTER NUN' },
	[0x10391] = { unicodeslot=0x10391, category='lo', description='UGARITIC LETTER ZU' },
	[0x10392] = { unicodeslot=0x10392, category='lo', description='UGARITIC LETTER SAMKA' },
	[0x10393] = { unicodeslot=0x10393, category='lo', description='UGARITIC LETTER AIN' },
	[0x10394] = { unicodeslot=0x10394, category='lo', description='UGARITIC LETTER PU' },
	[0x10395] = { unicodeslot=0x10395, category='lo', description='UGARITIC LETTER SADE' },
	[0x10396] = { unicodeslot=0x10396, category='lo', description='UGARITIC LETTER QOPA' },
	[0x10397] = { unicodeslot=0x10397, category='lo', description='UGARITIC LETTER RASHA' },
	[0x10398] = { unicodeslot=0x10398, category='lo', description='UGARITIC LETTER THANNA' },
	[0x10399] = { unicodeslot=0x10399, category='lo', description='UGARITIC LETTER GHAIN' },
	[0x1039A] = { unicodeslot=0x1039A, category='lo', description='UGARITIC LETTER TO' },
	[0x1039B] = { unicodeslot=0x1039B, category='lo', description='UGARITIC LETTER I' },
	[0x1039C] = { unicodeslot=0x1039C, category='lo', description='UGARITIC LETTER U' },
	[0x1039D] = { unicodeslot=0x1039D, category='lo', description='UGARITIC LETTER SSU' },
	[0x1039F] = { unicodeslot=0x1039F, category='po', description='UGARITIC WORD DIVIDER' },
	[0x103A0] = { unicodeslot=0x103A0, category='lo', description='OLD PERSIAN SIGN A' },
	[0x103A1] = { unicodeslot=0x103A1, category='lo', description='OLD PERSIAN SIGN I' },
	[0x103A2] = { unicodeslot=0x103A2, category='lo', description='OLD PERSIAN SIGN U' },
	[0x103A3] = { unicodeslot=0x103A3, category='lo', description='OLD PERSIAN SIGN KA' },
	[0x103A4] = { unicodeslot=0x103A4, category='lo', description='OLD PERSIAN SIGN KU' },
	[0x103A5] = { unicodeslot=0x103A5, category='lo', description='OLD PERSIAN SIGN GA' },
	[0x103A6] = { unicodeslot=0x103A6, category='lo', description='OLD PERSIAN SIGN GU' },
	[0x103A7] = { unicodeslot=0x103A7, category='lo', description='OLD PERSIAN SIGN XA' },
	[0x103A8] = { unicodeslot=0x103A8, category='lo', description='OLD PERSIAN SIGN CA' },
	[0x103A9] = { unicodeslot=0x103A9, category='lo', description='OLD PERSIAN SIGN JA' },
	[0x103AA] = { unicodeslot=0x103AA, category='lo', description='OLD PERSIAN SIGN JI' },
	[0x103AB] = { unicodeslot=0x103AB, category='lo', description='OLD PERSIAN SIGN TA' },
	[0x103AC] = { unicodeslot=0x103AC, category='lo', description='OLD PERSIAN SIGN TU' },
	[0x103AD] = { unicodeslot=0x103AD, category='lo', description='OLD PERSIAN SIGN DA' },
	[0x103AE] = { unicodeslot=0x103AE, category='lo', description='OLD PERSIAN SIGN DI' },
	[0x103AF] = { unicodeslot=0x103AF, category='lo', description='OLD PERSIAN SIGN DU' },
	[0x103B0] = { unicodeslot=0x103B0, category='lo', description='OLD PERSIAN SIGN THA' },
	[0x103B1] = { unicodeslot=0x103B1, category='lo', description='OLD PERSIAN SIGN PA' },
	[0x103B2] = { unicodeslot=0x103B2, category='lo', description='OLD PERSIAN SIGN BA' },
	[0x103B3] = { unicodeslot=0x103B3, category='lo', description='OLD PERSIAN SIGN FA' },
	[0x103B4] = { unicodeslot=0x103B4, category='lo', description='OLD PERSIAN SIGN NA' },
	[0x103B5] = { unicodeslot=0x103B5, category='lo', description='OLD PERSIAN SIGN NU' },
	[0x103B6] = { unicodeslot=0x103B6, category='lo', description='OLD PERSIAN SIGN MA' },
	[0x103B7] = { unicodeslot=0x103B7, category='lo', description='OLD PERSIAN SIGN MI' },
	[0x103B8] = { unicodeslot=0x103B8, category='lo', description='OLD PERSIAN SIGN MU' },
	[0x103B9] = { unicodeslot=0x103B9, category='lo', description='OLD PERSIAN SIGN YA' },
	[0x103BA] = { unicodeslot=0x103BA, category='lo', description='OLD PERSIAN SIGN VA' },
	[0x103BB] = { unicodeslot=0x103BB, category='lo', description='OLD PERSIAN SIGN VI' },
	[0x103BC] = { unicodeslot=0x103BC, category='lo', description='OLD PERSIAN SIGN RA' },
	[0x103BD] = { unicodeslot=0x103BD, category='lo', description='OLD PERSIAN SIGN RU' },
	[0x103BE] = { unicodeslot=0x103BE, category='lo', description='OLD PERSIAN SIGN LA' },
	[0x103BF] = { unicodeslot=0x103BF, category='lo', description='OLD PERSIAN SIGN SA' },
	[0x103C0] = { unicodeslot=0x103C0, category='lo', description='OLD PERSIAN SIGN ZA' },
	[0x103C1] = { unicodeslot=0x103C1, category='lo', description='OLD PERSIAN SIGN SHA' },
	[0x103C2] = { unicodeslot=0x103C2, category='lo', description='OLD PERSIAN SIGN SSA' },
	[0x103C3] = { unicodeslot=0x103C3, category='lo', description='OLD PERSIAN SIGN HA' },
	[0x103C8] = { unicodeslot=0x103C8, category='lo', description='OLD PERSIAN SIGN AURAMAZDAA' },
	[0x103C9] = { unicodeslot=0x103C9, category='lo', description='OLD PERSIAN SIGN AURAMAZDAA-2' },
	[0x103CA] = { unicodeslot=0x103CA, category='lo', description='OLD PERSIAN SIGN AURAMAZDAAHA' },
	[0x103CB] = { unicodeslot=0x103CB, category='lo', description='OLD PERSIAN SIGN XSHAAYATHIYA' },
	[0x103CC] = { unicodeslot=0x103CC, category='lo', description='OLD PERSIAN SIGN DAHYAAUSH' },
	[0x103CD] = { unicodeslot=0x103CD, category='lo', description='OLD PERSIAN SIGN DAHYAAUSH-2' },
	[0x103CE] = { unicodeslot=0x103CE, category='lo', description='OLD PERSIAN SIGN BAGA' },
	[0x103CF] = { unicodeslot=0x103CF, category='lo', description='OLD PERSIAN SIGN BUUMISH' },
	[0x103D0] = { unicodeslot=0x103D0, category='po', description='OLD PERSIAN WORD DIVIDER' },
	[0x103D1] = { unicodeslot=0x103D1, category='nl', description='OLD PERSIAN NUMBER ONE' },
	[0x103D2] = { unicodeslot=0x103D2, category='nl', description='OLD PERSIAN NUMBER TWO' },
	[0x103D3] = { unicodeslot=0x103D3, category='nl', description='OLD PERSIAN NUMBER TEN' },
	[0x103D4] = { unicodeslot=0x103D4, category='nl', description='OLD PERSIAN NUMBER TWENTY' },
	[0x103D5] = { unicodeslot=0x103D5, category='nl', description='OLD PERSIAN NUMBER HUNDRED' },
	[0x10400] = { unicodeslot=0x10400, category='lu', description='DESERET CAPITAL LETTER LONG I', lccode=0x10428 },
	[0x10401] = { unicodeslot=0x10401, category='lu', description='DESERET CAPITAL LETTER LONG E', lccode=0x10429 },
	[0x10402] = { unicodeslot=0x10402, category='lu', description='DESERET CAPITAL LETTER LONG A', lccode=0x1042A },
	[0x10403] = { unicodeslot=0x10403, category='lu', description='DESERET CAPITAL LETTER LONG AH', lccode=0x1042B },
	[0x10404] = { unicodeslot=0x10404, category='lu', description='DESERET CAPITAL LETTER LONG O', lccode=0x1042C },
	[0x10405] = { unicodeslot=0x10405, category='lu', description='DESERET CAPITAL LETTER LONG OO', lccode=0x1042D },
	[0x10406] = { unicodeslot=0x10406, category='lu', description='DESERET CAPITAL LETTER SHORT I', lccode=0x1042E },
	[0x10407] = { unicodeslot=0x10407, category='lu', description='DESERET CAPITAL LETTER SHORT E', lccode=0x1042F },
	[0x10408] = { unicodeslot=0x10408, category='lu', description='DESERET CAPITAL LETTER SHORT A', lccode=0x10430 },
	[0x10409] = { unicodeslot=0x10409, category='lu', description='DESERET CAPITAL LETTER SHORT AH', lccode=0x10431 },
	[0x1040A] = { unicodeslot=0x1040A, category='lu', description='DESERET CAPITAL LETTER SHORT O', lccode=0x10432 },
	[0x1040B] = { unicodeslot=0x1040B, category='lu', description='DESERET CAPITAL LETTER SHORT OO', lccode=0x10433 },
	[0x1040C] = { unicodeslot=0x1040C, category='lu', description='DESERET CAPITAL LETTER AY', lccode=0x10434 },
	[0x1040D] = { unicodeslot=0x1040D, category='lu', description='DESERET CAPITAL LETTER OW', lccode=0x10435 },
	[0x1040E] = { unicodeslot=0x1040E, category='lu', description='DESERET CAPITAL LETTER WU', lccode=0x10436 },
	[0x1040F] = { unicodeslot=0x1040F, category='lu', description='DESERET CAPITAL LETTER YEE', lccode=0x10437 },
	[0x10410] = { unicodeslot=0x10410, category='lu', description='DESERET CAPITAL LETTER H', lccode=0x10438 },
	[0x10411] = { unicodeslot=0x10411, category='lu', description='DESERET CAPITAL LETTER PEE', lccode=0x10439 },
	[0x10412] = { unicodeslot=0x10412, category='lu', description='DESERET CAPITAL LETTER BEE', lccode=0x1043A },
	[0x10413] = { unicodeslot=0x10413, category='lu', description='DESERET CAPITAL LETTER TEE', lccode=0x1043B },
	[0x10414] = { unicodeslot=0x10414, category='lu', description='DESERET CAPITAL LETTER DEE', lccode=0x1043C },
	[0x10415] = { unicodeslot=0x10415, category='lu', description='DESERET CAPITAL LETTER CHEE', lccode=0x1043D },
	[0x10416] = { unicodeslot=0x10416, category='lu', description='DESERET CAPITAL LETTER JEE', lccode=0x1043E },
	[0x10417] = { unicodeslot=0x10417, category='lu', description='DESERET CAPITAL LETTER KAY', lccode=0x1043F },
	[0x10418] = { unicodeslot=0x10418, category='lu', description='DESERET CAPITAL LETTER GAY', lccode=0x10440 },
	[0x10419] = { unicodeslot=0x10419, category='lu', description='DESERET CAPITAL LETTER EF', lccode=0x10441 },
	[0x1041A] = { unicodeslot=0x1041A, category='lu', description='DESERET CAPITAL LETTER VEE', lccode=0x10442 },
	[0x1041B] = { unicodeslot=0x1041B, category='lu', description='DESERET CAPITAL LETTER ETH', lccode=0x10443 },
	[0x1041C] = { unicodeslot=0x1041C, category='lu', description='DESERET CAPITAL LETTER THEE', lccode=0x10444 },
	[0x1041D] = { unicodeslot=0x1041D, category='lu', description='DESERET CAPITAL LETTER ES', lccode=0x10445 },
	[0x1041E] = { unicodeslot=0x1041E, category='lu', description='DESERET CAPITAL LETTER ZEE', lccode=0x10446 },
	[0x1041F] = { unicodeslot=0x1041F, category='lu', description='DESERET CAPITAL LETTER ESH', lccode=0x10447 },
	[0x10420] = { unicodeslot=0x10420, category='lu', description='DESERET CAPITAL LETTER ZHEE', lccode=0x10448 },
	[0x10421] = { unicodeslot=0x10421, category='lu', description='DESERET CAPITAL LETTER ER', lccode=0x10449 },
	[0x10422] = { unicodeslot=0x10422, category='lu', description='DESERET CAPITAL LETTER EL', lccode=0x1044A },
	[0x10423] = { unicodeslot=0x10423, category='lu', description='DESERET CAPITAL LETTER EM', lccode=0x1044B },
	[0x10424] = { unicodeslot=0x10424, category='lu', description='DESERET CAPITAL LETTER EN', lccode=0x1044C },
	[0x10425] = { unicodeslot=0x10425, category='lu', description='DESERET CAPITAL LETTER ENG', lccode=0x1044D },
	[0x10426] = { unicodeslot=0x10426, category='lu', description='DESERET CAPITAL LETTER OI', lccode=0x1044E },
	[0x10427] = { unicodeslot=0x10427, category='lu', description='DESERET CAPITAL LETTER EW', lccode=0x1044F },
	[0x10428] = { unicodeslot=0x10428, category='ll', description='DESERET SMALL LETTER LONG I', uccode=0x10400 },
	[0x10429] = { unicodeslot=0x10429, category='ll', description='DESERET SMALL LETTER LONG E', uccode=0x10401 },
	[0x1042A] = { unicodeslot=0x1042A, category='ll', description='DESERET SMALL LETTER LONG A', uccode=0x10402 },
	[0x1042B] = { unicodeslot=0x1042B, category='ll', description='DESERET SMALL LETTER LONG AH', uccode=0x10403 },
	[0x1042C] = { unicodeslot=0x1042C, category='ll', description='DESERET SMALL LETTER LONG O', uccode=0x10404 },
	[0x1042D] = { unicodeslot=0x1042D, category='ll', description='DESERET SMALL LETTER LONG OO', uccode=0x10405 },
	[0x1042E] = { unicodeslot=0x1042E, category='ll', description='DESERET SMALL LETTER SHORT I', uccode=0x10406 },
	[0x1042F] = { unicodeslot=0x1042F, category='ll', description='DESERET SMALL LETTER SHORT E', uccode=0x10407 },
	[0x10430] = { unicodeslot=0x10430, category='ll', description='DESERET SMALL LETTER SHORT A', uccode=0x10408 },
	[0x10431] = { unicodeslot=0x10431, category='ll', description='DESERET SMALL LETTER SHORT AH', uccode=0x10409 },
	[0x10432] = { unicodeslot=0x10432, category='ll', description='DESERET SMALL LETTER SHORT O', uccode=0x1040A },
	[0x10433] = { unicodeslot=0x10433, category='ll', description='DESERET SMALL LETTER SHORT OO', uccode=0x1040B },
	[0x10434] = { unicodeslot=0x10434, category='ll', description='DESERET SMALL LETTER AY', uccode=0x1040C },
	[0x10435] = { unicodeslot=0x10435, category='ll', description='DESERET SMALL LETTER OW', uccode=0x1040D },
	[0x10436] = { unicodeslot=0x10436, category='ll', description='DESERET SMALL LETTER WU', uccode=0x1040E },
	[0x10437] = { unicodeslot=0x10437, category='ll', description='DESERET SMALL LETTER YEE', uccode=0x1040F },
	[0x10438] = { unicodeslot=0x10438, category='ll', description='DESERET SMALL LETTER H', uccode=0x10410 },
	[0x10439] = { unicodeslot=0x10439, category='ll', description='DESERET SMALL LETTER PEE', uccode=0x10411 },
	[0x1043A] = { unicodeslot=0x1043A, category='ll', description='DESERET SMALL LETTER BEE', uccode=0x10412 },
	[0x1043B] = { unicodeslot=0x1043B, category='ll', description='DESERET SMALL LETTER TEE', uccode=0x10413 },
	[0x1043C] = { unicodeslot=0x1043C, category='ll', description='DESERET SMALL LETTER DEE', uccode=0x10414 },
	[0x1043D] = { unicodeslot=0x1043D, category='ll', description='DESERET SMALL LETTER CHEE', uccode=0x10415 },
	[0x1043E] = { unicodeslot=0x1043E, category='ll', description='DESERET SMALL LETTER JEE', uccode=0x10416 },
	[0x1043F] = { unicodeslot=0x1043F, category='ll', description='DESERET SMALL LETTER KAY', uccode=0x10417 },
	[0x10440] = { unicodeslot=0x10440, category='ll', description='DESERET SMALL LETTER GAY', uccode=0x10418 },
	[0x10441] = { unicodeslot=0x10441, category='ll', description='DESERET SMALL LETTER EF', uccode=0x10419 },
	[0x10442] = { unicodeslot=0x10442, category='ll', description='DESERET SMALL LETTER VEE', uccode=0x1041A },
	[0x10443] = { unicodeslot=0x10443, category='ll', description='DESERET SMALL LETTER ETH', uccode=0x1041B },
	[0x10444] = { unicodeslot=0x10444, category='ll', description='DESERET SMALL LETTER THEE', uccode=0x1041C },
	[0x10445] = { unicodeslot=0x10445, category='ll', description='DESERET SMALL LETTER ES', uccode=0x1041D },
	[0x10446] = { unicodeslot=0x10446, category='ll', description='DESERET SMALL LETTER ZEE', uccode=0x1041E },
	[0x10447] = { unicodeslot=0x10447, category='ll', description='DESERET SMALL LETTER ESH', uccode=0x1041F },
	[0x10448] = { unicodeslot=0x10448, category='ll', description='DESERET SMALL LETTER ZHEE', uccode=0x10420 },
	[0x10449] = { unicodeslot=0x10449, category='ll', description='DESERET SMALL LETTER ER', uccode=0x10421 },
	[0x1044A] = { unicodeslot=0x1044A, category='ll', description='DESERET SMALL LETTER EL', uccode=0x10422 },
	[0x1044B] = { unicodeslot=0x1044B, category='ll', description='DESERET SMALL LETTER EM', uccode=0x10423 },
	[0x1044C] = { unicodeslot=0x1044C, category='ll', description='DESERET SMALL LETTER EN', uccode=0x10424 },
	[0x1044D] = { unicodeslot=0x1044D, category='ll', description='DESERET SMALL LETTER ENG', uccode=0x10425 },
	[0x1044E] = { unicodeslot=0x1044E, category='ll', description='DESERET SMALL LETTER OI', uccode=0x10426 },
	[0x1044F] = { unicodeslot=0x1044F, category='ll', description='DESERET SMALL LETTER EW', uccode=0x10427 },
	[0x10450] = { unicodeslot=0x10450, category='lo', description='SHAVIAN LETTER PEEP' },
	[0x10451] = { unicodeslot=0x10451, category='lo', description='SHAVIAN LETTER TOT' },
	[0x10452] = { unicodeslot=0x10452, category='lo', description='SHAVIAN LETTER KICK' },
	[0x10453] = { unicodeslot=0x10453, category='lo', description='SHAVIAN LETTER FEE' },
	[0x10454] = { unicodeslot=0x10454, category='lo', description='SHAVIAN LETTER THIGH' },
	[0x10455] = { unicodeslot=0x10455, category='lo', description='SHAVIAN LETTER SO' },
	[0x10456] = { unicodeslot=0x10456, category='lo', description='SHAVIAN LETTER SURE' },
	[0x10457] = { unicodeslot=0x10457, category='lo', description='SHAVIAN LETTER CHURCH' },
	[0x10458] = { unicodeslot=0x10458, category='lo', description='SHAVIAN LETTER YEA' },
	[0x10459] = { unicodeslot=0x10459, category='lo', description='SHAVIAN LETTER HUNG' },
	[0x1045A] = { unicodeslot=0x1045A, category='lo', description='SHAVIAN LETTER BIB' },
	[0x1045B] = { unicodeslot=0x1045B, category='lo', description='SHAVIAN LETTER DEAD' },
	[0x1045C] = { unicodeslot=0x1045C, category='lo', description='SHAVIAN LETTER GAG' },
	[0x1045D] = { unicodeslot=0x1045D, category='lo', description='SHAVIAN LETTER VOW' },
	[0x1045E] = { unicodeslot=0x1045E, category='lo', description='SHAVIAN LETTER THEY' },
	[0x1045F] = { unicodeslot=0x1045F, category='lo', description='SHAVIAN LETTER ZOO' },
	[0x10460] = { unicodeslot=0x10460, category='lo', description='SHAVIAN LETTER MEASURE' },
	[0x10461] = { unicodeslot=0x10461, category='lo', description='SHAVIAN LETTER JUDGE' },
	[0x10462] = { unicodeslot=0x10462, category='lo', description='SHAVIAN LETTER WOE' },
	[0x10463] = { unicodeslot=0x10463, category='lo', description='SHAVIAN LETTER HA-HA' },
	[0x10464] = { unicodeslot=0x10464, category='lo', description='SHAVIAN LETTER LOLL' },
	[0x10465] = { unicodeslot=0x10465, category='lo', description='SHAVIAN LETTER MIME' },
	[0x10466] = { unicodeslot=0x10466, category='lo', description='SHAVIAN LETTER IF' },
	[0x10467] = { unicodeslot=0x10467, category='lo', description='SHAVIAN LETTER EGG' },
	[0x10468] = { unicodeslot=0x10468, category='lo', description='SHAVIAN LETTER ASH' },
	[0x10469] = { unicodeslot=0x10469, category='lo', description='SHAVIAN LETTER ADO' },
	[0x1046A] = { unicodeslot=0x1046A, category='lo', description='SHAVIAN LETTER ON' },
	[0x1046B] = { unicodeslot=0x1046B, category='lo', description='SHAVIAN LETTER WOOL' },
	[0x1046C] = { unicodeslot=0x1046C, category='lo', description='SHAVIAN LETTER OUT' },
	[0x1046D] = { unicodeslot=0x1046D, category='lo', description='SHAVIAN LETTER AH' },
	[0x1046E] = { unicodeslot=0x1046E, category='lo', description='SHAVIAN LETTER ROAR' },
	[0x1046F] = { unicodeslot=0x1046F, category='lo', description='SHAVIAN LETTER NUN' },
	[0x10470] = { unicodeslot=0x10470, category='lo', description='SHAVIAN LETTER EAT' },
	[0x10471] = { unicodeslot=0x10471, category='lo', description='SHAVIAN LETTER AGE' },
	[0x10472] = { unicodeslot=0x10472, category='lo', description='SHAVIAN LETTER ICE' },
	[0x10473] = { unicodeslot=0x10473, category='lo', description='SHAVIAN LETTER UP' },
	[0x10474] = { unicodeslot=0x10474, category='lo', description='SHAVIAN LETTER OAK' },
	[0x10475] = { unicodeslot=0x10475, category='lo', description='SHAVIAN LETTER OOZE' },
	[0x10476] = { unicodeslot=0x10476, category='lo', description='SHAVIAN LETTER OIL' },
	[0x10477] = { unicodeslot=0x10477, category='lo', description='SHAVIAN LETTER AWE' },
	[0x10478] = { unicodeslot=0x10478, category='lo', description='SHAVIAN LETTER ARE' },
	[0x10479] = { unicodeslot=0x10479, category='lo', description='SHAVIAN LETTER OR' },
	[0x1047A] = { unicodeslot=0x1047A, category='lo', description='SHAVIAN LETTER AIR' },
	[0x1047B] = { unicodeslot=0x1047B, category='lo', description='SHAVIAN LETTER ERR' },
	[0x1047C] = { unicodeslot=0x1047C, category='lo', description='SHAVIAN LETTER ARRAY' },
	[0x1047D] = { unicodeslot=0x1047D, category='lo', description='SHAVIAN LETTER EAR' },
	[0x1047E] = { unicodeslot=0x1047E, category='lo', description='SHAVIAN LETTER IAN' },
	[0x1047F] = { unicodeslot=0x1047F, category='lo', description='SHAVIAN LETTER YEW' },
	[0x10480] = { unicodeslot=0x10480, category='lo', description='OSMANYA LETTER ALEF' },
	[0x10481] = { unicodeslot=0x10481, category='lo', description='OSMANYA LETTER BA' },
	[0x10482] = { unicodeslot=0x10482, category='lo', description='OSMANYA LETTER TA' },
	[0x10483] = { unicodeslot=0x10483, category='lo', description='OSMANYA LETTER JA' },
	[0x10484] = { unicodeslot=0x10484, category='lo', description='OSMANYA LETTER XA' },
	[0x10485] = { unicodeslot=0x10485, category='lo', description='OSMANYA LETTER KHA' },
	[0x10486] = { unicodeslot=0x10486, category='lo', description='OSMANYA LETTER DEEL' },
	[0x10487] = { unicodeslot=0x10487, category='lo', description='OSMANYA LETTER RA' },
	[0x10488] = { unicodeslot=0x10488, category='lo', description='OSMANYA LETTER SA' },
	[0x10489] = { unicodeslot=0x10489, category='lo', description='OSMANYA LETTER SHIIN' },
	[0x1048A] = { unicodeslot=0x1048A, category='lo', description='OSMANYA LETTER DHA' },
	[0x1048B] = { unicodeslot=0x1048B, category='lo', description='OSMANYA LETTER CAYN' },
	[0x1048C] = { unicodeslot=0x1048C, category='lo', description='OSMANYA LETTER GA' },
	[0x1048D] = { unicodeslot=0x1048D, category='lo', description='OSMANYA LETTER FA' },
	[0x1048E] = { unicodeslot=0x1048E, category='lo', description='OSMANYA LETTER QAAF' },
	[0x1048F] = { unicodeslot=0x1048F, category='lo', description='OSMANYA LETTER KAAF' },
	[0x10490] = { unicodeslot=0x10490, category='lo', description='OSMANYA LETTER LAAN' },
	[0x10491] = { unicodeslot=0x10491, category='lo', description='OSMANYA LETTER MIIN' },
	[0x10492] = { unicodeslot=0x10492, category='lo', description='OSMANYA LETTER NUUN' },
	[0x10493] = { unicodeslot=0x10493, category='lo', description='OSMANYA LETTER WAW' },
	[0x10494] = { unicodeslot=0x10494, category='lo', description='OSMANYA LETTER HA' },
	[0x10495] = { unicodeslot=0x10495, category='lo', description='OSMANYA LETTER YA' },
	[0x10496] = { unicodeslot=0x10496, category='lo', description='OSMANYA LETTER A' },
	[0x10497] = { unicodeslot=0x10497, category='lo', description='OSMANYA LETTER E' },
	[0x10498] = { unicodeslot=0x10498, category='lo', description='OSMANYA LETTER I' },
	[0x10499] = { unicodeslot=0x10499, category='lo', description='OSMANYA LETTER O' },
	[0x1049A] = { unicodeslot=0x1049A, category='lo', description='OSMANYA LETTER U' },
	[0x1049B] = { unicodeslot=0x1049B, category='lo', description='OSMANYA LETTER AA' },
	[0x1049C] = { unicodeslot=0x1049C, category='lo', description='OSMANYA LETTER EE' },
	[0x1049D] = { unicodeslot=0x1049D, category='lo', description='OSMANYA LETTER OO' },
	[0x104A0] = { unicodeslot=0x104A0, category='nd', description='OSMANYA DIGIT ZERO' },
	[0x104A1] = { unicodeslot=0x104A1, category='nd', description='OSMANYA DIGIT ONE' },
	[0x104A2] = { unicodeslot=0x104A2, category='nd', description='OSMANYA DIGIT TWO' },
	[0x104A3] = { unicodeslot=0x104A3, category='nd', description='OSMANYA DIGIT THREE' },
	[0x104A4] = { unicodeslot=0x104A4, category='nd', description='OSMANYA DIGIT FOUR' },
	[0x104A5] = { unicodeslot=0x104A5, category='nd', description='OSMANYA DIGIT FIVE' },
	[0x104A6] = { unicodeslot=0x104A6, category='nd', description='OSMANYA DIGIT SIX' },
	[0x104A7] = { unicodeslot=0x104A7, category='nd', description='OSMANYA DIGIT SEVEN' },
	[0x104A8] = { unicodeslot=0x104A8, category='nd', description='OSMANYA DIGIT EIGHT' },
	[0x104A9] = { unicodeslot=0x104A9, category='nd', description='OSMANYA DIGIT NINE' },
	[0x10800] = { unicodeslot=0x10800, category='lo', description='CYPRIOT SYLLABLE A' },
	[0x10801] = { unicodeslot=0x10801, category='lo', description='CYPRIOT SYLLABLE E' },
	[0x10802] = { unicodeslot=0x10802, category='lo', description='CYPRIOT SYLLABLE I' },
	[0x10803] = { unicodeslot=0x10803, category='lo', description='CYPRIOT SYLLABLE O' },
	[0x10804] = { unicodeslot=0x10804, category='lo', description='CYPRIOT SYLLABLE U' },
	[0x10805] = { unicodeslot=0x10805, category='lo', description='CYPRIOT SYLLABLE JA' },
	[0x10808] = { unicodeslot=0x10808, category='lo', description='CYPRIOT SYLLABLE JO' },
	[0x1080A] = { unicodeslot=0x1080A, category='lo', description='CYPRIOT SYLLABLE KA' },
	[0x1080B] = { unicodeslot=0x1080B, category='lo', description='CYPRIOT SYLLABLE KE' },
	[0x1080C] = { unicodeslot=0x1080C, category='lo', description='CYPRIOT SYLLABLE KI' },
	[0x1080D] = { unicodeslot=0x1080D, category='lo', description='CYPRIOT SYLLABLE KO' },
	[0x1080E] = { unicodeslot=0x1080E, category='lo', description='CYPRIOT SYLLABLE KU' },
	[0x1080F] = { unicodeslot=0x1080F, category='lo', description='CYPRIOT SYLLABLE LA' },
	[0x10810] = { unicodeslot=0x10810, category='lo', description='CYPRIOT SYLLABLE LE' },
	[0x10811] = { unicodeslot=0x10811, category='lo', description='CYPRIOT SYLLABLE LI' },
	[0x10812] = { unicodeslot=0x10812, category='lo', description='CYPRIOT SYLLABLE LO' },
	[0x10813] = { unicodeslot=0x10813, category='lo', description='CYPRIOT SYLLABLE LU' },
	[0x10814] = { unicodeslot=0x10814, category='lo', description='CYPRIOT SYLLABLE MA' },
	[0x10815] = { unicodeslot=0x10815, category='lo', description='CYPRIOT SYLLABLE ME' },
	[0x10816] = { unicodeslot=0x10816, category='lo', description='CYPRIOT SYLLABLE MI' },
	[0x10817] = { unicodeslot=0x10817, category='lo', description='CYPRIOT SYLLABLE MO' },
	[0x10818] = { unicodeslot=0x10818, category='lo', description='CYPRIOT SYLLABLE MU' },
	[0x10819] = { unicodeslot=0x10819, category='lo', description='CYPRIOT SYLLABLE NA' },
	[0x1081A] = { unicodeslot=0x1081A, category='lo', description='CYPRIOT SYLLABLE NE' },
	[0x1081B] = { unicodeslot=0x1081B, category='lo', description='CYPRIOT SYLLABLE NI' },
	[0x1081C] = { unicodeslot=0x1081C, category='lo', description='CYPRIOT SYLLABLE NO' },
	[0x1081D] = { unicodeslot=0x1081D, category='lo', description='CYPRIOT SYLLABLE NU' },
	[0x1081E] = { unicodeslot=0x1081E, category='lo', description='CYPRIOT SYLLABLE PA' },
	[0x1081F] = { unicodeslot=0x1081F, category='lo', description='CYPRIOT SYLLABLE PE' },
	[0x10820] = { unicodeslot=0x10820, category='lo', description='CYPRIOT SYLLABLE PI' },
	[0x10821] = { unicodeslot=0x10821, category='lo', description='CYPRIOT SYLLABLE PO' },
	[0x10822] = { unicodeslot=0x10822, category='lo', description='CYPRIOT SYLLABLE PU' },
	[0x10823] = { unicodeslot=0x10823, category='lo', description='CYPRIOT SYLLABLE RA' },
	[0x10824] = { unicodeslot=0x10824, category='lo', description='CYPRIOT SYLLABLE RE' },
	[0x10825] = { unicodeslot=0x10825, category='lo', description='CYPRIOT SYLLABLE RI' },
	[0x10826] = { unicodeslot=0x10826, category='lo', description='CYPRIOT SYLLABLE RO' },
	[0x10827] = { unicodeslot=0x10827, category='lo', description='CYPRIOT SYLLABLE RU' },
	[0x10828] = { unicodeslot=0x10828, category='lo', description='CYPRIOT SYLLABLE SA' },
	[0x10829] = { unicodeslot=0x10829, category='lo', description='CYPRIOT SYLLABLE SE' },
	[0x1082A] = { unicodeslot=0x1082A, category='lo', description='CYPRIOT SYLLABLE SI' },
	[0x1082B] = { unicodeslot=0x1082B, category='lo', description='CYPRIOT SYLLABLE SO' },
	[0x1082C] = { unicodeslot=0x1082C, category='lo', description='CYPRIOT SYLLABLE SU' },
	[0x1082D] = { unicodeslot=0x1082D, category='lo', description='CYPRIOT SYLLABLE TA' },
	[0x1082E] = { unicodeslot=0x1082E, category='lo', description='CYPRIOT SYLLABLE TE' },
	[0x1082F] = { unicodeslot=0x1082F, category='lo', description='CYPRIOT SYLLABLE TI' },
	[0x10830] = { unicodeslot=0x10830, category='lo', description='CYPRIOT SYLLABLE TO' },
	[0x10831] = { unicodeslot=0x10831, category='lo', description='CYPRIOT SYLLABLE TU' },
	[0x10832] = { unicodeslot=0x10832, category='lo', description='CYPRIOT SYLLABLE WA' },
	[0x10833] = { unicodeslot=0x10833, category='lo', description='CYPRIOT SYLLABLE WE' },
	[0x10834] = { unicodeslot=0x10834, category='lo', description='CYPRIOT SYLLABLE WI' },
	[0x10835] = { unicodeslot=0x10835, category='lo', description='CYPRIOT SYLLABLE WO' },
	[0x10837] = { unicodeslot=0x10837, category='lo', description='CYPRIOT SYLLABLE XA' },
	[0x10838] = { unicodeslot=0x10838, category='lo', description='CYPRIOT SYLLABLE XE' },
	[0x1083C] = { unicodeslot=0x1083C, category='lo', description='CYPRIOT SYLLABLE ZA' },
	[0x1083F] = { unicodeslot=0x1083F, category='lo', description='CYPRIOT SYLLABLE ZO' },
	[0x10900] = { unicodeslot=0x10900, category='lo', description='PHOENICIAN LETTER ALF' },
	[0x10901] = { unicodeslot=0x10901, category='lo', description='PHOENICIAN LETTER BET' },
	[0x10902] = { unicodeslot=0x10902, category='lo', description='PHOENICIAN LETTER GAML' },
	[0x10903] = { unicodeslot=0x10903, category='lo', description='PHOENICIAN LETTER DELT' },
	[0x10904] = { unicodeslot=0x10904, category='lo', description='PHOENICIAN LETTER HE' },
	[0x10905] = { unicodeslot=0x10905, category='lo', description='PHOENICIAN LETTER WAU' },
	[0x10906] = { unicodeslot=0x10906, category='lo', description='PHOENICIAN LETTER ZAI' },
	[0x10907] = { unicodeslot=0x10907, category='lo', description='PHOENICIAN LETTER HET' },
	[0x10908] = { unicodeslot=0x10908, category='lo', description='PHOENICIAN LETTER TET' },
	[0x10909] = { unicodeslot=0x10909, category='lo', description='PHOENICIAN LETTER YOD' },
	[0x1090A] = { unicodeslot=0x1090A, category='lo', description='PHOENICIAN LETTER KAF' },
	[0x1090B] = { unicodeslot=0x1090B, category='lo', description='PHOENICIAN LETTER LAMD' },
	[0x1090C] = { unicodeslot=0x1090C, category='lo', description='PHOENICIAN LETTER MEM' },
	[0x1090D] = { unicodeslot=0x1090D, category='lo', description='PHOENICIAN LETTER NUN' },
	[0x1090E] = { unicodeslot=0x1090E, category='lo', description='PHOENICIAN LETTER SEMK' },
	[0x1090F] = { unicodeslot=0x1090F, category='lo', description='PHOENICIAN LETTER AIN' },
	[0x10910] = { unicodeslot=0x10910, category='lo', description='PHOENICIAN LETTER PE' },
	[0x10911] = { unicodeslot=0x10911, category='lo', description='PHOENICIAN LETTER SADE' },
	[0x10912] = { unicodeslot=0x10912, category='lo', description='PHOENICIAN LETTER QOF' },
	[0x10913] = { unicodeslot=0x10913, category='lo', description='PHOENICIAN LETTER ROSH' },
	[0x10914] = { unicodeslot=0x10914, category='lo', description='PHOENICIAN LETTER SHIN' },
	[0x10915] = { unicodeslot=0x10915, category='lo', description='PHOENICIAN LETTER TAU' },
	[0x10916] = { unicodeslot=0x10916, category='no', description='PHOENICIAN NUMBER ONE' },
	[0x10917] = { unicodeslot=0x10917, category='no', description='PHOENICIAN NUMBER TEN' },
	[0x10918] = { unicodeslot=0x10918, category='no', description='PHOENICIAN NUMBER TWENTY' },
	[0x10919] = { unicodeslot=0x10919, category='no', description='PHOENICIAN NUMBER ONE HUNDRED' },
	[0x1091F] = { unicodeslot=0x1091F, category='po', description='PHOENICIAN WORD SEPARATOR' },
	[0x10A00] = { unicodeslot=0x10A00, category='lo', description='KHAROSHTHI LETTER A' },
	[0x10A01] = { unicodeslot=0x10A01, category='mn', description='KHAROSHTHI VOWEL SIGN I' },
	[0x10A02] = { unicodeslot=0x10A02, category='mn', description='KHAROSHTHI VOWEL SIGN U' },
	[0x10A03] = { unicodeslot=0x10A03, category='mn', description='KHAROSHTHI VOWEL SIGN VOCALIC R' },
	[0x10A05] = { unicodeslot=0x10A05, category='mn', description='KHAROSHTHI VOWEL SIGN E' },
	[0x10A06] = { unicodeslot=0x10A06, category='mn', description='KHAROSHTHI VOWEL SIGN O' },
	[0x10A0C] = { unicodeslot=0x10A0C, category='mn', description='KHAROSHTHI VOWEL LENGTH MARK' },
	[0x10A0D] = { unicodeslot=0x10A0D, category='mn', description='KHAROSHTHI SIGN DOUBLE RING BELOW' },
	[0x10A0E] = { unicodeslot=0x10A0E, category='mn', description='KHAROSHTHI SIGN ANUSVARA' },
	[0x10A0F] = { unicodeslot=0x10A0F, category='mn', description='KHAROSHTHI SIGN VISARGA' },
	[0x10A10] = { unicodeslot=0x10A10, category='lo', description='KHAROSHTHI LETTER KA' },
	[0x10A11] = { unicodeslot=0x10A11, category='lo', description='KHAROSHTHI LETTER KHA' },
	[0x10A12] = { unicodeslot=0x10A12, category='lo', description='KHAROSHTHI LETTER GA' },
	[0x10A13] = { unicodeslot=0x10A13, category='lo', description='KHAROSHTHI LETTER GHA' },
	[0x10A15] = { unicodeslot=0x10A15, category='lo', description='KHAROSHTHI LETTER CA' },
	[0x10A16] = { unicodeslot=0x10A16, category='lo', description='KHAROSHTHI LETTER CHA' },
	[0x10A17] = { unicodeslot=0x10A17, category='lo', description='KHAROSHTHI LETTER JA' },
	[0x10A19] = { unicodeslot=0x10A19, category='lo', description='KHAROSHTHI LETTER NYA' },
	[0x10A1A] = { unicodeslot=0x10A1A, category='lo', description='KHAROSHTHI LETTER TTA' },
	[0x10A1B] = { unicodeslot=0x10A1B, category='lo', description='KHAROSHTHI LETTER TTHA' },
	[0x10A1C] = { unicodeslot=0x10A1C, category='lo', description='KHAROSHTHI LETTER DDA' },
	[0x10A1D] = { unicodeslot=0x10A1D, category='lo', description='KHAROSHTHI LETTER DDHA' },
	[0x10A1E] = { unicodeslot=0x10A1E, category='lo', description='KHAROSHTHI LETTER NNA' },
	[0x10A1F] = { unicodeslot=0x10A1F, category='lo', description='KHAROSHTHI LETTER TA' },
	[0x10A20] = { unicodeslot=0x10A20, category='lo', description='KHAROSHTHI LETTER THA' },
	[0x10A21] = { unicodeslot=0x10A21, category='lo', description='KHAROSHTHI LETTER DA' },
	[0x10A22] = { unicodeslot=0x10A22, category='lo', description='KHAROSHTHI LETTER DHA' },
	[0x10A23] = { unicodeslot=0x10A23, category='lo', description='KHAROSHTHI LETTER NA' },
	[0x10A24] = { unicodeslot=0x10A24, category='lo', description='KHAROSHTHI LETTER PA' },
	[0x10A25] = { unicodeslot=0x10A25, category='lo', description='KHAROSHTHI LETTER PHA' },
	[0x10A26] = { unicodeslot=0x10A26, category='lo', description='KHAROSHTHI LETTER BA' },
	[0x10A27] = { unicodeslot=0x10A27, category='lo', description='KHAROSHTHI LETTER BHA' },
	[0x10A28] = { unicodeslot=0x10A28, category='lo', description='KHAROSHTHI LETTER MA' },
	[0x10A29] = { unicodeslot=0x10A29, category='lo', description='KHAROSHTHI LETTER YA' },
	[0x10A2A] = { unicodeslot=0x10A2A, category='lo', description='KHAROSHTHI LETTER RA' },
	[0x10A2B] = { unicodeslot=0x10A2B, category='lo', description='KHAROSHTHI LETTER LA' },
	[0x10A2C] = { unicodeslot=0x10A2C, category='lo', description='KHAROSHTHI LETTER VA' },
	[0x10A2D] = { unicodeslot=0x10A2D, category='lo', description='KHAROSHTHI LETTER SHA' },
	[0x10A2E] = { unicodeslot=0x10A2E, category='lo', description='KHAROSHTHI LETTER SSA' },
	[0x10A2F] = { unicodeslot=0x10A2F, category='lo', description='KHAROSHTHI LETTER SA' },
	[0x10A30] = { unicodeslot=0x10A30, category='lo', description='KHAROSHTHI LETTER ZA' },
	[0x10A31] = { unicodeslot=0x10A31, category='lo', description='KHAROSHTHI LETTER HA' },
	[0x10A32] = { unicodeslot=0x10A32, category='lo', description='KHAROSHTHI LETTER KKA' },
	[0x10A33] = { unicodeslot=0x10A33, category='lo', description='KHAROSHTHI LETTER TTTHA' },
	[0x10A38] = { unicodeslot=0x10A38, category='mn', description='KHAROSHTHI SIGN BAR ABOVE' },
	[0x10A39] = { unicodeslot=0x10A39, category='mn', description='KHAROSHTHI SIGN CAUDA' },
	[0x10A3A] = { unicodeslot=0x10A3A, category='mn', description='KHAROSHTHI SIGN DOT BELOW' },
	[0x10A3F] = { unicodeslot=0x10A3F, category='mn', description='KHAROSHTHI VIRAMA' },
	[0x10A40] = { unicodeslot=0x10A40, category='no', description='KHAROSHTHI DIGIT ONE' },
	[0x10A41] = { unicodeslot=0x10A41, category='no', description='KHAROSHTHI DIGIT TWO' },
	[0x10A42] = { unicodeslot=0x10A42, category='no', description='KHAROSHTHI DIGIT THREE' },
	[0x10A43] = { unicodeslot=0x10A43, category='no', description='KHAROSHTHI DIGIT FOUR' },
	[0x10A44] = { unicodeslot=0x10A44, category='no', description='KHAROSHTHI NUMBER TEN' },
	[0x10A45] = { unicodeslot=0x10A45, category='no', description='KHAROSHTHI NUMBER TWENTY' },
	[0x10A46] = { unicodeslot=0x10A46, category='no', description='KHAROSHTHI NUMBER ONE HUNDRED' },
	[0x10A47] = { unicodeslot=0x10A47, category='no', description='KHAROSHTHI NUMBER ONE THOUSAND' },
	[0x10A50] = { unicodeslot=0x10A50, category='po', description='KHAROSHTHI PUNCTUATION DOT' },
	[0x10A51] = { unicodeslot=0x10A51, category='po', description='KHAROSHTHI PUNCTUATION SMALL CIRCLE' },
	[0x10A52] = { unicodeslot=0x10A52, category='po', description='KHAROSHTHI PUNCTUATION CIRCLE' },
	[0x10A53] = { unicodeslot=0x10A53, category='po', description='KHAROSHTHI PUNCTUATION CRESCENT BAR' },
	[0x10A54] = { unicodeslot=0x10A54, category='po', description='KHAROSHTHI PUNCTUATION MANGALAM' },
	[0x10A55] = { unicodeslot=0x10A55, category='po', description='KHAROSHTHI PUNCTUATION LOTUS' },
	[0x10A56] = { unicodeslot=0x10A56, category='po', description='KHAROSHTHI PUNCTUATION DANDA' },
	[0x10A57] = { unicodeslot=0x10A57, category='po', description='KHAROSHTHI PUNCTUATION DOUBLE DANDA' },
	[0x10A58] = { unicodeslot=0x10A58, category='po', description='KHAROSHTHI PUNCTUATION LINES' },
	[0x12000] = { unicodeslot=0x12000, category='lo', description='CUNEIFORM SIGN A' },
	[0x12001] = { unicodeslot=0x12001, category='lo', description='CUNEIFORM SIGN A TIMES A' },
	[0x12002] = { unicodeslot=0x12002, category='lo', description='CUNEIFORM SIGN A TIMES BAD' },
	[0x12003] = { unicodeslot=0x12003, category='lo', description='CUNEIFORM SIGN A TIMES GAN2 TENU' },
	[0x12004] = { unicodeslot=0x12004, category='lo', description='CUNEIFORM SIGN A TIMES HA' },
	[0x12005] = { unicodeslot=0x12005, category='lo', description='CUNEIFORM SIGN A TIMES IGI' },
	[0x12006] = { unicodeslot=0x12006, category='lo', description='CUNEIFORM SIGN A TIMES LAGAR GUNU' },
	[0x12007] = { unicodeslot=0x12007, category='lo', description='CUNEIFORM SIGN A TIMES MUSH' },
	[0x12008] = { unicodeslot=0x12008, category='lo', description='CUNEIFORM SIGN A TIMES SAG' },
	[0x12009] = { unicodeslot=0x12009, category='lo', description='CUNEIFORM SIGN A2' },
	[0x1200A] = { unicodeslot=0x1200A, category='lo', description='CUNEIFORM SIGN AB' },
	[0x1200B] = { unicodeslot=0x1200B, category='lo', description='CUNEIFORM SIGN AB TIMES ASH2' },
	[0x1200C] = { unicodeslot=0x1200C, category='lo', description='CUNEIFORM SIGN AB TIMES DUN3 GUNU' },
	[0x1200D] = { unicodeslot=0x1200D, category='lo', description='CUNEIFORM SIGN AB TIMES GAL' },
	[0x1200E] = { unicodeslot=0x1200E, category='lo', description='CUNEIFORM SIGN AB TIMES GAN2 TENU' },
	[0x1200F] = { unicodeslot=0x1200F, category='lo', description='CUNEIFORM SIGN AB TIMES HA' },
	[0x12010] = { unicodeslot=0x12010, category='lo', description='CUNEIFORM SIGN AB TIMES IGI GUNU' },
	[0x12011] = { unicodeslot=0x12011, category='lo', description='CUNEIFORM SIGN AB TIMES IMIN' },
	[0x12012] = { unicodeslot=0x12012, category='lo', description='CUNEIFORM SIGN AB TIMES LAGAB' },
	[0x12013] = { unicodeslot=0x12013, category='lo', description='CUNEIFORM SIGN AB TIMES SHESH' },
	[0x12014] = { unicodeslot=0x12014, category='lo', description='CUNEIFORM SIGN AB TIMES U PLUS U PLUS U' },
	[0x12015] = { unicodeslot=0x12015, category='lo', description='CUNEIFORM SIGN AB GUNU' },
	[0x12016] = { unicodeslot=0x12016, category='lo', description='CUNEIFORM SIGN AB2' },
	[0x12017] = { unicodeslot=0x12017, category='lo', description='CUNEIFORM SIGN AB2 TIMES BALAG' },
	[0x12018] = { unicodeslot=0x12018, category='lo', description='CUNEIFORM SIGN AB2 TIMES GAN2 TENU' },
	[0x12019] = { unicodeslot=0x12019, category='lo', description='CUNEIFORM SIGN AB2 TIMES ME PLUS EN' },
	[0x1201A] = { unicodeslot=0x1201A, category='lo', description='CUNEIFORM SIGN AB2 TIMES SHA3' },
	[0x1201B] = { unicodeslot=0x1201B, category='lo', description='CUNEIFORM SIGN AB2 TIMES TAK4' },
	[0x1201C] = { unicodeslot=0x1201C, category='lo', description='CUNEIFORM SIGN AD' },
	[0x1201D] = { unicodeslot=0x1201D, category='lo', description='CUNEIFORM SIGN AK' },
	[0x1201E] = { unicodeslot=0x1201E, category='lo', description='CUNEIFORM SIGN AK TIMES ERIN2' },
	[0x1201F] = { unicodeslot=0x1201F, category='lo', description='CUNEIFORM SIGN AK TIMES SHITA PLUS GISH' },
	[0x12020] = { unicodeslot=0x12020, category='lo', description='CUNEIFORM SIGN AL' },
	[0x12021] = { unicodeslot=0x12021, category='lo', description='CUNEIFORM SIGN AL TIMES AL' },
	[0x12022] = { unicodeslot=0x12022, category='lo', description='CUNEIFORM SIGN AL TIMES DIM2' },
	[0x12023] = { unicodeslot=0x12023, category='lo', description='CUNEIFORM SIGN AL TIMES GISH' },
	[0x12024] = { unicodeslot=0x12024, category='lo', description='CUNEIFORM SIGN AL TIMES HA' },
	[0x12025] = { unicodeslot=0x12025, category='lo', description='CUNEIFORM SIGN AL TIMES KAD3' },
	[0x12026] = { unicodeslot=0x12026, category='lo', description='CUNEIFORM SIGN AL TIMES KI' },
	[0x12027] = { unicodeslot=0x12027, category='lo', description='CUNEIFORM SIGN AL TIMES SHE' },
	[0x12028] = { unicodeslot=0x12028, category='lo', description='CUNEIFORM SIGN AL TIMES USH' },
	[0x12029] = { unicodeslot=0x12029, category='lo', description='CUNEIFORM SIGN ALAN' },
	[0x1202A] = { unicodeslot=0x1202A, category='lo', description='CUNEIFORM SIGN ALEPH' },
	[0x1202B] = { unicodeslot=0x1202B, category='lo', description='CUNEIFORM SIGN AMAR' },
	[0x1202C] = { unicodeslot=0x1202C, category='lo', description='CUNEIFORM SIGN AMAR TIMES SHE' },
	[0x1202D] = { unicodeslot=0x1202D, category='lo', description='CUNEIFORM SIGN AN' },
	[0x1202E] = { unicodeslot=0x1202E, category='lo', description='CUNEIFORM SIGN AN OVER AN' },
	[0x1202F] = { unicodeslot=0x1202F, category='lo', description='CUNEIFORM SIGN AN THREE TIMES' },
	[0x12030] = { unicodeslot=0x12030, category='lo', description='CUNEIFORM SIGN AN PLUS NAGA OPPOSING AN PLUS NAGA' },
	[0x12031] = { unicodeslot=0x12031, category='lo', description='CUNEIFORM SIGN AN PLUS NAGA SQUARED' },
	[0x12032] = { unicodeslot=0x12032, category='lo', description='CUNEIFORM SIGN ANSHE' },
	[0x12033] = { unicodeslot=0x12033, category='lo', description='CUNEIFORM SIGN APIN' },
	[0x12034] = { unicodeslot=0x12034, category='lo', description='CUNEIFORM SIGN ARAD' },
	[0x12035] = { unicodeslot=0x12035, category='lo', description='CUNEIFORM SIGN ARAD TIMES KUR' },
	[0x12036] = { unicodeslot=0x12036, category='lo', description='CUNEIFORM SIGN ARKAB' },
	[0x12037] = { unicodeslot=0x12037, category='lo', description='CUNEIFORM SIGN ASAL2' },
	[0x12038] = { unicodeslot=0x12038, category='lo', description='CUNEIFORM SIGN ASH' },
	[0x12039] = { unicodeslot=0x12039, category='lo', description='CUNEIFORM SIGN ASH ZIDA TENU' },
	[0x1203A] = { unicodeslot=0x1203A, category='lo', description='CUNEIFORM SIGN ASH KABA TENU' },
	[0x1203B] = { unicodeslot=0x1203B, category='lo', description='CUNEIFORM SIGN ASH OVER ASH TUG2 OVER TUG2 TUG2 OVER TUG2 PAP' },
	[0x1203C] = { unicodeslot=0x1203C, category='lo', description='CUNEIFORM SIGN ASH OVER ASH OVER ASH' },
	[0x1203D] = { unicodeslot=0x1203D, category='lo', description='CUNEIFORM SIGN ASH OVER ASH OVER ASH CROSSING ASH OVER ASH OVER ASH' },
	[0x1203E] = { unicodeslot=0x1203E, category='lo', description='CUNEIFORM SIGN ASH2' },
	[0x1203F] = { unicodeslot=0x1203F, category='lo', description='CUNEIFORM SIGN ASHGAB' },
	[0x12040] = { unicodeslot=0x12040, category='lo', description='CUNEIFORM SIGN BA' },
	[0x12041] = { unicodeslot=0x12041, category='lo', description='CUNEIFORM SIGN BAD' },
	[0x12042] = { unicodeslot=0x12042, category='lo', description='CUNEIFORM SIGN BAG3' },
	[0x12043] = { unicodeslot=0x12043, category='lo', description='CUNEIFORM SIGN BAHAR2' },
	[0x12044] = { unicodeslot=0x12044, category='lo', description='CUNEIFORM SIGN BAL' },
	[0x12045] = { unicodeslot=0x12045, category='lo', description='CUNEIFORM SIGN BAL OVER BAL' },
	[0x12046] = { unicodeslot=0x12046, category='lo', description='CUNEIFORM SIGN BALAG' },
	[0x12047] = { unicodeslot=0x12047, category='lo', description='CUNEIFORM SIGN BAR' },
	[0x12048] = { unicodeslot=0x12048, category='lo', description='CUNEIFORM SIGN BARA2' },
	[0x12049] = { unicodeslot=0x12049, category='lo', description='CUNEIFORM SIGN BI' },
	[0x1204A] = { unicodeslot=0x1204A, category='lo', description='CUNEIFORM SIGN BI TIMES A' },
	[0x1204B] = { unicodeslot=0x1204B, category='lo', description='CUNEIFORM SIGN BI TIMES GAR' },
	[0x1204C] = { unicodeslot=0x1204C, category='lo', description='CUNEIFORM SIGN BI TIMES IGI GUNU' },
	[0x1204D] = { unicodeslot=0x1204D, category='lo', description='CUNEIFORM SIGN BU' },
	[0x1204E] = { unicodeslot=0x1204E, category='lo', description='CUNEIFORM SIGN BU OVER BU AB' },
	[0x1204F] = { unicodeslot=0x1204F, category='lo', description='CUNEIFORM SIGN BU OVER BU UN' },
	[0x12050] = { unicodeslot=0x12050, category='lo', description='CUNEIFORM SIGN BU CROSSING BU' },
	[0x12051] = { unicodeslot=0x12051, category='lo', description='CUNEIFORM SIGN BULUG' },
	[0x12052] = { unicodeslot=0x12052, category='lo', description='CUNEIFORM SIGN BULUG OVER BULUG' },
	[0x12053] = { unicodeslot=0x12053, category='lo', description='CUNEIFORM SIGN BUR' },
	[0x12054] = { unicodeslot=0x12054, category='lo', description='CUNEIFORM SIGN BUR2' },
	[0x12055] = { unicodeslot=0x12055, category='lo', description='CUNEIFORM SIGN DA' },
	[0x12056] = { unicodeslot=0x12056, category='lo', description='CUNEIFORM SIGN DAG' },
	[0x12057] = { unicodeslot=0x12057, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES A PLUS MASH' },
	[0x12058] = { unicodeslot=0x12058, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES AMAR' },
	[0x12059] = { unicodeslot=0x12059, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES BALAG' },
	[0x1205A] = { unicodeslot=0x1205A, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES BI' },
	[0x1205B] = { unicodeslot=0x1205B, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES GA' },
	[0x1205C] = { unicodeslot=0x1205C, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES GA PLUS MASH' },
	[0x1205D] = { unicodeslot=0x1205D, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES GI' },
	[0x1205E] = { unicodeslot=0x1205E, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES GIR2' },
	[0x1205F] = { unicodeslot=0x1205F, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES GUD' },
	[0x12060] = { unicodeslot=0x12060, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES HA' },
	[0x12061] = { unicodeslot=0x12061, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES IR' },
	[0x12062] = { unicodeslot=0x12062, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES IR PLUS LU' },
	[0x12063] = { unicodeslot=0x12063, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES KAK' },
	[0x12064] = { unicodeslot=0x12064, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES LA' },
	[0x12065] = { unicodeslot=0x12065, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES LU' },
	[0x12066] = { unicodeslot=0x12066, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES LU PLUS MASH2' },
	[0x12067] = { unicodeslot=0x12067, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES LUM' },
	[0x12068] = { unicodeslot=0x12068, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES NE' },
	[0x12069] = { unicodeslot=0x12069, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES PAP PLUS PAP' },
	[0x1206A] = { unicodeslot=0x1206A, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES SI' },
	[0x1206B] = { unicodeslot=0x1206B, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES TAK4' },
	[0x1206C] = { unicodeslot=0x1206C, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES U2 PLUS GIR2' },
	[0x1206D] = { unicodeslot=0x1206D, category='lo', description='CUNEIFORM SIGN DAG KISIM5 TIMES USH' },
	[0x1206E] = { unicodeslot=0x1206E, category='lo', description='CUNEIFORM SIGN DAM' },
	[0x1206F] = { unicodeslot=0x1206F, category='lo', description='CUNEIFORM SIGN DAR' },
	[0x12070] = { unicodeslot=0x12070, category='lo', description='CUNEIFORM SIGN DARA3' },
	[0x12071] = { unicodeslot=0x12071, category='lo', description='CUNEIFORM SIGN DARA4' },
	[0x12072] = { unicodeslot=0x12072, category='lo', description='CUNEIFORM SIGN DI' },
	[0x12073] = { unicodeslot=0x12073, category='lo', description='CUNEIFORM SIGN DIB' },
	[0x12074] = { unicodeslot=0x12074, category='lo', description='CUNEIFORM SIGN DIM' },
	[0x12075] = { unicodeslot=0x12075, category='lo', description='CUNEIFORM SIGN DIM TIMES SHE' },
	[0x12076] = { unicodeslot=0x12076, category='lo', description='CUNEIFORM SIGN DIM2' },
	[0x12077] = { unicodeslot=0x12077, category='lo', description='CUNEIFORM SIGN DIN' },
	[0x12078] = { unicodeslot=0x12078, category='lo', description='CUNEIFORM SIGN DIN KASKAL U GUNU DISH' },
	[0x12079] = { unicodeslot=0x12079, category='lo', description='CUNEIFORM SIGN DISH' },
	[0x1207A] = { unicodeslot=0x1207A, category='lo', description='CUNEIFORM SIGN DU' },
	[0x1207B] = { unicodeslot=0x1207B, category='lo', description='CUNEIFORM SIGN DU OVER DU' },
	[0x1207C] = { unicodeslot=0x1207C, category='lo', description='CUNEIFORM SIGN DU GUNU' },
	[0x1207D] = { unicodeslot=0x1207D, category='lo', description='CUNEIFORM SIGN DU SHESHIG' },
	[0x1207E] = { unicodeslot=0x1207E, category='lo', description='CUNEIFORM SIGN DUB' },
	[0x1207F] = { unicodeslot=0x1207F, category='lo', description='CUNEIFORM SIGN DUB TIMES ESH2' },
	[0x12080] = { unicodeslot=0x12080, category='lo', description='CUNEIFORM SIGN DUB2' },
	[0x12081] = { unicodeslot=0x12081, category='lo', description='CUNEIFORM SIGN DUG' },
	[0x12082] = { unicodeslot=0x12082, category='lo', description='CUNEIFORM SIGN DUGUD' },
	[0x12083] = { unicodeslot=0x12083, category='lo', description='CUNEIFORM SIGN DUH' },
	[0x12084] = { unicodeslot=0x12084, category='lo', description='CUNEIFORM SIGN DUN' },
	[0x12085] = { unicodeslot=0x12085, category='lo', description='CUNEIFORM SIGN DUN3' },
	[0x12086] = { unicodeslot=0x12086, category='lo', description='CUNEIFORM SIGN DUN3 GUNU' },
	[0x12087] = { unicodeslot=0x12087, category='lo', description='CUNEIFORM SIGN DUN3 GUNU GUNU' },
	[0x12088] = { unicodeslot=0x12088, category='lo', description='CUNEIFORM SIGN DUN4' },
	[0x12089] = { unicodeslot=0x12089, category='lo', description='CUNEIFORM SIGN DUR2' },
	[0x1208A] = { unicodeslot=0x1208A, category='lo', description='CUNEIFORM SIGN E' },
	[0x1208B] = { unicodeslot=0x1208B, category='lo', description='CUNEIFORM SIGN E TIMES PAP' },
	[0x1208C] = { unicodeslot=0x1208C, category='lo', description='CUNEIFORM SIGN E OVER E NUN OVER NUN' },
	[0x1208D] = { unicodeslot=0x1208D, category='lo', description='CUNEIFORM SIGN E2' },
	[0x1208E] = { unicodeslot=0x1208E, category='lo', description='CUNEIFORM SIGN E2 TIMES A PLUS HA PLUS DA' },
	[0x1208F] = { unicodeslot=0x1208F, category='lo', description='CUNEIFORM SIGN E2 TIMES GAR' },
	[0x12090] = { unicodeslot=0x12090, category='lo', description='CUNEIFORM SIGN E2 TIMES MI' },
	[0x12091] = { unicodeslot=0x12091, category='lo', description='CUNEIFORM SIGN E2 TIMES SAL' },
	[0x12092] = { unicodeslot=0x12092, category='lo', description='CUNEIFORM SIGN E2 TIMES SHE' },
	[0x12093] = { unicodeslot=0x12093, category='lo', description='CUNEIFORM SIGN E2 TIMES U' },
	[0x12094] = { unicodeslot=0x12094, category='lo', description='CUNEIFORM SIGN EDIN' },
	[0x12095] = { unicodeslot=0x12095, category='lo', description='CUNEIFORM SIGN EGIR' },
	[0x12096] = { unicodeslot=0x12096, category='lo', description='CUNEIFORM SIGN EL' },
	[0x12097] = { unicodeslot=0x12097, category='lo', description='CUNEIFORM SIGN EN' },
	[0x12098] = { unicodeslot=0x12098, category='lo', description='CUNEIFORM SIGN EN TIMES GAN2' },
	[0x12099] = { unicodeslot=0x12099, category='lo', description='CUNEIFORM SIGN EN TIMES GAN2 TENU' },
	[0x1209A] = { unicodeslot=0x1209A, category='lo', description='CUNEIFORM SIGN EN TIMES ME' },
	[0x1209B] = { unicodeslot=0x1209B, category='lo', description='CUNEIFORM SIGN EN CROSSING EN' },
	[0x1209C] = { unicodeslot=0x1209C, category='lo', description='CUNEIFORM SIGN EN OPPOSING EN' },
	[0x1209D] = { unicodeslot=0x1209D, category='lo', description='CUNEIFORM SIGN EN SQUARED' },
	[0x1209E] = { unicodeslot=0x1209E, category='lo', description='CUNEIFORM SIGN EREN' },
	[0x1209F] = { unicodeslot=0x1209F, category='lo', description='CUNEIFORM SIGN ERIN2' },
	[0x120A0] = { unicodeslot=0x120A0, category='lo', description='CUNEIFORM SIGN ESH2' },
	[0x120A1] = { unicodeslot=0x120A1, category='lo', description='CUNEIFORM SIGN EZEN' },
	[0x120A2] = { unicodeslot=0x120A2, category='lo', description='CUNEIFORM SIGN EZEN TIMES A' },
	[0x120A3] = { unicodeslot=0x120A3, category='lo', description='CUNEIFORM SIGN EZEN TIMES A PLUS LAL' },
	[0x120A4] = { unicodeslot=0x120A4, category='lo', description='CUNEIFORM SIGN EZEN TIMES A PLUS LAL TIMES LAL' },
	[0x120A5] = { unicodeslot=0x120A5, category='lo', description='CUNEIFORM SIGN EZEN TIMES AN' },
	[0x120A6] = { unicodeslot=0x120A6, category='lo', description='CUNEIFORM SIGN EZEN TIMES BAD' },
	[0x120A7] = { unicodeslot=0x120A7, category='lo', description='CUNEIFORM SIGN EZEN TIMES DUN3 GUNU' },
	[0x120A8] = { unicodeslot=0x120A8, category='lo', description='CUNEIFORM SIGN EZEN TIMES DUN3 GUNU GUNU' },
	[0x120A9] = { unicodeslot=0x120A9, category='lo', description='CUNEIFORM SIGN EZEN TIMES HA' },
	[0x120AA] = { unicodeslot=0x120AA, category='lo', description='CUNEIFORM SIGN EZEN TIMES HA GUNU' },
	[0x120AB] = { unicodeslot=0x120AB, category='lo', description='CUNEIFORM SIGN EZEN TIMES IGI GUNU' },
	[0x120AC] = { unicodeslot=0x120AC, category='lo', description='CUNEIFORM SIGN EZEN TIMES KASKAL' },
	[0x120AD] = { unicodeslot=0x120AD, category='lo', description='CUNEIFORM SIGN EZEN TIMES KASKAL SQUARED' },
	[0x120AE] = { unicodeslot=0x120AE, category='lo', description='CUNEIFORM SIGN EZEN TIMES KU3' },
	[0x120AF] = { unicodeslot=0x120AF, category='lo', description='CUNEIFORM SIGN EZEN TIMES LA' },
	[0x120B0] = { unicodeslot=0x120B0, category='lo', description='CUNEIFORM SIGN EZEN TIMES LAL TIMES LAL' },
	[0x120B1] = { unicodeslot=0x120B1, category='lo', description='CUNEIFORM SIGN EZEN TIMES LI' },
	[0x120B2] = { unicodeslot=0x120B2, category='lo', description='CUNEIFORM SIGN EZEN TIMES LU' },
	[0x120B3] = { unicodeslot=0x120B3, category='lo', description='CUNEIFORM SIGN EZEN TIMES U2' },
	[0x120B4] = { unicodeslot=0x120B4, category='lo', description='CUNEIFORM SIGN EZEN TIMES UD' },
	[0x120B5] = { unicodeslot=0x120B5, category='lo', description='CUNEIFORM SIGN GA' },
	[0x120B6] = { unicodeslot=0x120B6, category='lo', description='CUNEIFORM SIGN GA GUNU' },
	[0x120B7] = { unicodeslot=0x120B7, category='lo', description='CUNEIFORM SIGN GA2' },
	[0x120B8] = { unicodeslot=0x120B8, category='lo', description='CUNEIFORM SIGN GA2 TIMES A PLUS DA PLUS HA' },
	[0x120B9] = { unicodeslot=0x120B9, category='lo', description='CUNEIFORM SIGN GA2 TIMES A PLUS HA' },
	[0x120BA] = { unicodeslot=0x120BA, category='lo', description='CUNEIFORM SIGN GA2 TIMES A PLUS IGI' },
	[0x120BB] = { unicodeslot=0x120BB, category='lo', description='CUNEIFORM SIGN GA2 TIMES AB2 TENU PLUS TAB' },
	[0x120BC] = { unicodeslot=0x120BC, category='lo', description='CUNEIFORM SIGN GA2 TIMES AN' },
	[0x120BD] = { unicodeslot=0x120BD, category='lo', description='CUNEIFORM SIGN GA2 TIMES ASH' },
	[0x120BE] = { unicodeslot=0x120BE, category='lo', description='CUNEIFORM SIGN GA2 TIMES ASH2 PLUS GAL' },
	[0x120BF] = { unicodeslot=0x120BF, category='lo', description='CUNEIFORM SIGN GA2 TIMES BAD' },
	[0x120C0] = { unicodeslot=0x120C0, category='lo', description='CUNEIFORM SIGN GA2 TIMES BAR PLUS RA' },
	[0x120C1] = { unicodeslot=0x120C1, category='lo', description='CUNEIFORM SIGN GA2 TIMES BUR' },
	[0x120C2] = { unicodeslot=0x120C2, category='lo', description='CUNEIFORM SIGN GA2 TIMES BUR PLUS RA' },
	[0x120C3] = { unicodeslot=0x120C3, category='lo', description='CUNEIFORM SIGN GA2 TIMES DA' },
	[0x120C4] = { unicodeslot=0x120C4, category='lo', description='CUNEIFORM SIGN GA2 TIMES DI' },
	[0x120C5] = { unicodeslot=0x120C5, category='lo', description='CUNEIFORM SIGN GA2 TIMES DIM TIMES SHE' },
	[0x120C6] = { unicodeslot=0x120C6, category='lo', description='CUNEIFORM SIGN GA2 TIMES DUB' },
	[0x120C7] = { unicodeslot=0x120C7, category='lo', description='CUNEIFORM SIGN GA2 TIMES EL' },
	[0x120C8] = { unicodeslot=0x120C8, category='lo', description='CUNEIFORM SIGN GA2 TIMES EL PLUS LA' },
	[0x120C9] = { unicodeslot=0x120C9, category='lo', description='CUNEIFORM SIGN GA2 TIMES EN' },
	[0x120CA] = { unicodeslot=0x120CA, category='lo', description='CUNEIFORM SIGN GA2 TIMES EN TIMES GAN2 TENU' },
	[0x120CB] = { unicodeslot=0x120CB, category='lo', description='CUNEIFORM SIGN GA2 TIMES GAN2 TENU' },
	[0x120CC] = { unicodeslot=0x120CC, category='lo', description='CUNEIFORM SIGN GA2 TIMES GAR' },
	[0x120CD] = { unicodeslot=0x120CD, category='lo', description='CUNEIFORM SIGN GA2 TIMES GI' },
	[0x120CE] = { unicodeslot=0x120CE, category='lo', description='CUNEIFORM SIGN GA2 TIMES GI4' },
	[0x120CF] = { unicodeslot=0x120CF, category='lo', description='CUNEIFORM SIGN GA2 TIMES GI4 PLUS A' },
	[0x120D0] = { unicodeslot=0x120D0, category='lo', description='CUNEIFORM SIGN GA2 TIMES GIR2 PLUS SU' },
	[0x120D1] = { unicodeslot=0x120D1, category='lo', description='CUNEIFORM SIGN GA2 TIMES HA PLUS LU PLUS ESH2' },
	[0x120D2] = { unicodeslot=0x120D2, category='lo', description='CUNEIFORM SIGN GA2 TIMES HAL' },
	[0x120D3] = { unicodeslot=0x120D3, category='lo', description='CUNEIFORM SIGN GA2 TIMES HAL PLUS LA' },
	[0x120D4] = { unicodeslot=0x120D4, category='lo', description='CUNEIFORM SIGN GA2 TIMES HI PLUS LI' },
	[0x120D5] = { unicodeslot=0x120D5, category='lo', description='CUNEIFORM SIGN GA2 TIMES HUB2' },
	[0x120D6] = { unicodeslot=0x120D6, category='lo', description='CUNEIFORM SIGN GA2 TIMES IGI GUNU' },
	[0x120D7] = { unicodeslot=0x120D7, category='lo', description='CUNEIFORM SIGN GA2 TIMES ISH PLUS HU PLUS ASH' },
	[0x120D8] = { unicodeslot=0x120D8, category='lo', description='CUNEIFORM SIGN GA2 TIMES KAK' },
	[0x120D9] = { unicodeslot=0x120D9, category='lo', description='CUNEIFORM SIGN GA2 TIMES KASKAL' },
	[0x120DA] = { unicodeslot=0x120DA, category='lo', description='CUNEIFORM SIGN GA2 TIMES KID' },
	[0x120DB] = { unicodeslot=0x120DB, category='lo', description='CUNEIFORM SIGN GA2 TIMES KID PLUS LAL' },
	[0x120DC] = { unicodeslot=0x120DC, category='lo', description='CUNEIFORM SIGN GA2 TIMES KU3 PLUS AN' },
	[0x120DD] = { unicodeslot=0x120DD, category='lo', description='CUNEIFORM SIGN GA2 TIMES LA' },
	[0x120DE] = { unicodeslot=0x120DE, category='lo', description='CUNEIFORM SIGN GA2 TIMES ME PLUS EN' },
	[0x120DF] = { unicodeslot=0x120DF, category='lo', description='CUNEIFORM SIGN GA2 TIMES MI' },
	[0x120E0] = { unicodeslot=0x120E0, category='lo', description='CUNEIFORM SIGN GA2 TIMES NUN' },
	[0x120E1] = { unicodeslot=0x120E1, category='lo', description='CUNEIFORM SIGN GA2 TIMES NUN OVER NUN' },
	[0x120E2] = { unicodeslot=0x120E2, category='lo', description='CUNEIFORM SIGN GA2 TIMES PA' },
	[0x120E3] = { unicodeslot=0x120E3, category='lo', description='CUNEIFORM SIGN GA2 TIMES SAL' },
	[0x120E4] = { unicodeslot=0x120E4, category='lo', description='CUNEIFORM SIGN GA2 TIMES SAR' },
	[0x120E5] = { unicodeslot=0x120E5, category='lo', description='CUNEIFORM SIGN GA2 TIMES SHE' },
	[0x120E6] = { unicodeslot=0x120E6, category='lo', description='CUNEIFORM SIGN GA2 TIMES SHE PLUS TUR' },
	[0x120E7] = { unicodeslot=0x120E7, category='lo', description='CUNEIFORM SIGN GA2 TIMES SHID' },
	[0x120E8] = { unicodeslot=0x120E8, category='lo', description='CUNEIFORM SIGN GA2 TIMES SUM' },
	[0x120E9] = { unicodeslot=0x120E9, category='lo', description='CUNEIFORM SIGN GA2 TIMES TAK4' },
	[0x120EA] = { unicodeslot=0x120EA, category='lo', description='CUNEIFORM SIGN GA2 TIMES U' },
	[0x120EB] = { unicodeslot=0x120EB, category='lo', description='CUNEIFORM SIGN GA2 TIMES UD' },
	[0x120EC] = { unicodeslot=0x120EC, category='lo', description='CUNEIFORM SIGN GA2 TIMES UD PLUS DU' },
	[0x120ED] = { unicodeslot=0x120ED, category='lo', description='CUNEIFORM SIGN GA2 OVER GA2' },
	[0x120EE] = { unicodeslot=0x120EE, category='lo', description='CUNEIFORM SIGN GABA' },
	[0x120EF] = { unicodeslot=0x120EF, category='lo', description='CUNEIFORM SIGN GABA CROSSING GABA' },
	[0x120F0] = { unicodeslot=0x120F0, category='lo', description='CUNEIFORM SIGN GAD' },
	[0x120F1] = { unicodeslot=0x120F1, category='lo', description='CUNEIFORM SIGN GAD OVER GAD GAR OVER GAR' },
	[0x120F2] = { unicodeslot=0x120F2, category='lo', description='CUNEIFORM SIGN GAL' },
	[0x120F3] = { unicodeslot=0x120F3, category='lo', description='CUNEIFORM SIGN GAL GAD OVER GAD GAR OVER GAR' },
	[0x120F4] = { unicodeslot=0x120F4, category='lo', description='CUNEIFORM SIGN GALAM' },
	[0x120F5] = { unicodeslot=0x120F5, category='lo', description='CUNEIFORM SIGN GAM' },
	[0x120F6] = { unicodeslot=0x120F6, category='lo', description='CUNEIFORM SIGN GAN' },
	[0x120F7] = { unicodeslot=0x120F7, category='lo', description='CUNEIFORM SIGN GAN2' },
	[0x120F8] = { unicodeslot=0x120F8, category='lo', description='CUNEIFORM SIGN GAN2 TENU' },
	[0x120F9] = { unicodeslot=0x120F9, category='lo', description='CUNEIFORM SIGN GAN2 OVER GAN2' },
	[0x120FA] = { unicodeslot=0x120FA, category='lo', description='CUNEIFORM SIGN GAN2 CROSSING GAN2' },
	[0x120FB] = { unicodeslot=0x120FB, category='lo', description='CUNEIFORM SIGN GAR' },
	[0x120FC] = { unicodeslot=0x120FC, category='lo', description='CUNEIFORM SIGN GAR3' },
	[0x120FD] = { unicodeslot=0x120FD, category='lo', description='CUNEIFORM SIGN GASHAN' },
	[0x120FE] = { unicodeslot=0x120FE, category='lo', description='CUNEIFORM SIGN GESHTIN' },
	[0x120FF] = { unicodeslot=0x120FF, category='lo', description='CUNEIFORM SIGN GESHTIN TIMES KUR' },
	[0x12100] = { unicodeslot=0x12100, category='lo', description='CUNEIFORM SIGN GI' },
	[0x12101] = { unicodeslot=0x12101, category='lo', description='CUNEIFORM SIGN GI TIMES E' },
	[0x12102] = { unicodeslot=0x12102, category='lo', description='CUNEIFORM SIGN GI TIMES U' },
	[0x12103] = { unicodeslot=0x12103, category='lo', description='CUNEIFORM SIGN GI CROSSING GI' },
	[0x12104] = { unicodeslot=0x12104, category='lo', description='CUNEIFORM SIGN GI4' },
	[0x12105] = { unicodeslot=0x12105, category='lo', description='CUNEIFORM SIGN GI4 OVER GI4' },
	[0x12106] = { unicodeslot=0x12106, category='lo', description='CUNEIFORM SIGN GI4 CROSSING GI4' },
	[0x12107] = { unicodeslot=0x12107, category='lo', description='CUNEIFORM SIGN GIDIM' },
	[0x12108] = { unicodeslot=0x12108, category='lo', description='CUNEIFORM SIGN GIR2' },
	[0x12109] = { unicodeslot=0x12109, category='lo', description='CUNEIFORM SIGN GIR2 GUNU' },
	[0x1210A] = { unicodeslot=0x1210A, category='lo', description='CUNEIFORM SIGN GIR3' },
	[0x1210B] = { unicodeslot=0x1210B, category='lo', description='CUNEIFORM SIGN GIR3 TIMES A PLUS IGI' },
	[0x1210C] = { unicodeslot=0x1210C, category='lo', description='CUNEIFORM SIGN GIR3 TIMES GAN2 TENU' },
	[0x1210D] = { unicodeslot=0x1210D, category='lo', description='CUNEIFORM SIGN GIR3 TIMES IGI' },
	[0x1210E] = { unicodeslot=0x1210E, category='lo', description='CUNEIFORM SIGN GIR3 TIMES LU PLUS IGI' },
	[0x1210F] = { unicodeslot=0x1210F, category='lo', description='CUNEIFORM SIGN GIR3 TIMES PA' },
	[0x12110] = { unicodeslot=0x12110, category='lo', description='CUNEIFORM SIGN GISAL' },
	[0x12111] = { unicodeslot=0x12111, category='lo', description='CUNEIFORM SIGN GISH' },
	[0x12112] = { unicodeslot=0x12112, category='lo', description='CUNEIFORM SIGN GISH CROSSING GISH' },
	[0x12113] = { unicodeslot=0x12113, category='lo', description='CUNEIFORM SIGN GISH TIMES BAD' },
	[0x12114] = { unicodeslot=0x12114, category='lo', description='CUNEIFORM SIGN GISH TIMES TAK4' },
	[0x12115] = { unicodeslot=0x12115, category='lo', description='CUNEIFORM SIGN GISH TENU' },
	[0x12116] = { unicodeslot=0x12116, category='lo', description='CUNEIFORM SIGN GU' },
	[0x12117] = { unicodeslot=0x12117, category='lo', description='CUNEIFORM SIGN GU CROSSING GU' },
	[0x12118] = { unicodeslot=0x12118, category='lo', description='CUNEIFORM SIGN GU2' },
	[0x12119] = { unicodeslot=0x12119, category='lo', description='CUNEIFORM SIGN GU2 TIMES KAK' },
	[0x1211A] = { unicodeslot=0x1211A, category='lo', description='CUNEIFORM SIGN GU2 TIMES KAK TIMES IGI GUNU' },
	[0x1211B] = { unicodeslot=0x1211B, category='lo', description='CUNEIFORM SIGN GU2 TIMES NUN' },
	[0x1211C] = { unicodeslot=0x1211C, category='lo', description='CUNEIFORM SIGN GU2 TIMES SAL PLUS TUG2' },
	[0x1211D] = { unicodeslot=0x1211D, category='lo', description='CUNEIFORM SIGN GU2 GUNU' },
	[0x1211E] = { unicodeslot=0x1211E, category='lo', description='CUNEIFORM SIGN GUD' },
	[0x1211F] = { unicodeslot=0x1211F, category='lo', description='CUNEIFORM SIGN GUD TIMES A PLUS KUR' },
	[0x12120] = { unicodeslot=0x12120, category='lo', description='CUNEIFORM SIGN GUD TIMES KUR' },
	[0x12121] = { unicodeslot=0x12121, category='lo', description='CUNEIFORM SIGN GUD OVER GUD LUGAL' },
	[0x12122] = { unicodeslot=0x12122, category='lo', description='CUNEIFORM SIGN GUL' },
	[0x12123] = { unicodeslot=0x12123, category='lo', description='CUNEIFORM SIGN GUM' },
	[0x12124] = { unicodeslot=0x12124, category='lo', description='CUNEIFORM SIGN GUM TIMES SHE' },
	[0x12125] = { unicodeslot=0x12125, category='lo', description='CUNEIFORM SIGN GUR' },
	[0x12126] = { unicodeslot=0x12126, category='lo', description='CUNEIFORM SIGN GUR7' },
	[0x12127] = { unicodeslot=0x12127, category='lo', description='CUNEIFORM SIGN GURUN' },
	[0x12128] = { unicodeslot=0x12128, category='lo', description='CUNEIFORM SIGN GURUSH' },
	[0x12129] = { unicodeslot=0x12129, category='lo', description='CUNEIFORM SIGN HA' },
	[0x1212A] = { unicodeslot=0x1212A, category='lo', description='CUNEIFORM SIGN HA TENU' },
	[0x1212B] = { unicodeslot=0x1212B, category='lo', description='CUNEIFORM SIGN HA GUNU' },
	[0x1212C] = { unicodeslot=0x1212C, category='lo', description='CUNEIFORM SIGN HAL' },
	[0x1212D] = { unicodeslot=0x1212D, category='lo', description='CUNEIFORM SIGN HI' },
	[0x1212E] = { unicodeslot=0x1212E, category='lo', description='CUNEIFORM SIGN HI TIMES ASH' },
	[0x1212F] = { unicodeslot=0x1212F, category='lo', description='CUNEIFORM SIGN HI TIMES ASH2' },
	[0x12130] = { unicodeslot=0x12130, category='lo', description='CUNEIFORM SIGN HI TIMES BAD' },
	[0x12131] = { unicodeslot=0x12131, category='lo', description='CUNEIFORM SIGN HI TIMES DISH' },
	[0x12132] = { unicodeslot=0x12132, category='lo', description='CUNEIFORM SIGN HI TIMES GAD' },
	[0x12133] = { unicodeslot=0x12133, category='lo', description='CUNEIFORM SIGN HI TIMES KIN' },
	[0x12134] = { unicodeslot=0x12134, category='lo', description='CUNEIFORM SIGN HI TIMES NUN' },
	[0x12135] = { unicodeslot=0x12135, category='lo', description='CUNEIFORM SIGN HI TIMES SHE' },
	[0x12136] = { unicodeslot=0x12136, category='lo', description='CUNEIFORM SIGN HI TIMES U' },
	[0x12137] = { unicodeslot=0x12137, category='lo', description='CUNEIFORM SIGN HU' },
	[0x12138] = { unicodeslot=0x12138, category='lo', description='CUNEIFORM SIGN HUB2' },
	[0x12139] = { unicodeslot=0x12139, category='lo', description='CUNEIFORM SIGN HUB2 TIMES AN' },
	[0x1213A] = { unicodeslot=0x1213A, category='lo', description='CUNEIFORM SIGN HUB2 TIMES HAL' },
	[0x1213B] = { unicodeslot=0x1213B, category='lo', description='CUNEIFORM SIGN HUB2 TIMES KASKAL' },
	[0x1213C] = { unicodeslot=0x1213C, category='lo', description='CUNEIFORM SIGN HUB2 TIMES LISH' },
	[0x1213D] = { unicodeslot=0x1213D, category='lo', description='CUNEIFORM SIGN HUB2 TIMES UD' },
	[0x1213E] = { unicodeslot=0x1213E, category='lo', description='CUNEIFORM SIGN HUL2' },
	[0x1213F] = { unicodeslot=0x1213F, category='lo', description='CUNEIFORM SIGN I' },
	[0x12140] = { unicodeslot=0x12140, category='lo', description='CUNEIFORM SIGN I A' },
	[0x12141] = { unicodeslot=0x12141, category='lo', description='CUNEIFORM SIGN IB' },
	[0x12142] = { unicodeslot=0x12142, category='lo', description='CUNEIFORM SIGN IDIM' },
	[0x12143] = { unicodeslot=0x12143, category='lo', description='CUNEIFORM SIGN IDIM OVER IDIM BUR' },
	[0x12144] = { unicodeslot=0x12144, category='lo', description='CUNEIFORM SIGN IDIM OVER IDIM SQUARED' },
	[0x12145] = { unicodeslot=0x12145, category='lo', description='CUNEIFORM SIGN IG' },
	[0x12146] = { unicodeslot=0x12146, category='lo', description='CUNEIFORM SIGN IGI' },
	[0x12147] = { unicodeslot=0x12147, category='lo', description='CUNEIFORM SIGN IGI DIB' },
	[0x12148] = { unicodeslot=0x12148, category='lo', description='CUNEIFORM SIGN IGI RI' },
	[0x12149] = { unicodeslot=0x12149, category='lo', description='CUNEIFORM SIGN IGI OVER IGI SHIR OVER SHIR UD OVER UD' },
	[0x1214A] = { unicodeslot=0x1214A, category='lo', description='CUNEIFORM SIGN IGI GUNU' },
	[0x1214B] = { unicodeslot=0x1214B, category='lo', description='CUNEIFORM SIGN IL' },
	[0x1214C] = { unicodeslot=0x1214C, category='lo', description='CUNEIFORM SIGN IL TIMES GAN2 TENU' },
	[0x1214D] = { unicodeslot=0x1214D, category='lo', description='CUNEIFORM SIGN IL2' },
	[0x1214E] = { unicodeslot=0x1214E, category='lo', description='CUNEIFORM SIGN IM' },
	[0x1214F] = { unicodeslot=0x1214F, category='lo', description='CUNEIFORM SIGN IM TIMES TAK4' },
	[0x12150] = { unicodeslot=0x12150, category='lo', description='CUNEIFORM SIGN IM CROSSING IM' },
	[0x12151] = { unicodeslot=0x12151, category='lo', description='CUNEIFORM SIGN IM OPPOSING IM' },
	[0x12152] = { unicodeslot=0x12152, category='lo', description='CUNEIFORM SIGN IM SQUARED' },
	[0x12153] = { unicodeslot=0x12153, category='lo', description='CUNEIFORM SIGN IMIN' },
	[0x12154] = { unicodeslot=0x12154, category='lo', description='CUNEIFORM SIGN IN' },
	[0x12155] = { unicodeslot=0x12155, category='lo', description='CUNEIFORM SIGN IR' },
	[0x12156] = { unicodeslot=0x12156, category='lo', description='CUNEIFORM SIGN ISH' },
	[0x12157] = { unicodeslot=0x12157, category='lo', description='CUNEIFORM SIGN KA' },
	[0x12158] = { unicodeslot=0x12158, category='lo', description='CUNEIFORM SIGN KA TIMES A' },
	[0x12159] = { unicodeslot=0x12159, category='lo', description='CUNEIFORM SIGN KA TIMES AD' },
	[0x1215A] = { unicodeslot=0x1215A, category='lo', description='CUNEIFORM SIGN KA TIMES AD PLUS KU3' },
	[0x1215B] = { unicodeslot=0x1215B, category='lo', description='CUNEIFORM SIGN KA TIMES ASH2' },
	[0x1215C] = { unicodeslot=0x1215C, category='lo', description='CUNEIFORM SIGN KA TIMES BAD' },
	[0x1215D] = { unicodeslot=0x1215D, category='lo', description='CUNEIFORM SIGN KA TIMES BALAG' },
	[0x1215E] = { unicodeslot=0x1215E, category='lo', description='CUNEIFORM SIGN KA TIMES BAR' },
	[0x1215F] = { unicodeslot=0x1215F, category='lo', description='CUNEIFORM SIGN KA TIMES BI' },
	[0x12160] = { unicodeslot=0x12160, category='lo', description='CUNEIFORM SIGN KA TIMES ERIN2' },
	[0x12161] = { unicodeslot=0x12161, category='lo', description='CUNEIFORM SIGN KA TIMES ESH2' },
	[0x12162] = { unicodeslot=0x12162, category='lo', description='CUNEIFORM SIGN KA TIMES GA' },
	[0x12163] = { unicodeslot=0x12163, category='lo', description='CUNEIFORM SIGN KA TIMES GAL' },
	[0x12164] = { unicodeslot=0x12164, category='lo', description='CUNEIFORM SIGN KA TIMES GAN2 TENU' },
	[0x12165] = { unicodeslot=0x12165, category='lo', description='CUNEIFORM SIGN KA TIMES GAR' },
	[0x12166] = { unicodeslot=0x12166, category='lo', description='CUNEIFORM SIGN KA TIMES GAR PLUS SHA3 PLUS A' },
	[0x12167] = { unicodeslot=0x12167, category='lo', description='CUNEIFORM SIGN KA TIMES GI' },
	[0x12168] = { unicodeslot=0x12168, category='lo', description='CUNEIFORM SIGN KA TIMES GIR2' },
	[0x12169] = { unicodeslot=0x12169, category='lo', description='CUNEIFORM SIGN KA TIMES GISH PLUS SAR' },
	[0x1216A] = { unicodeslot=0x1216A, category='lo', description='CUNEIFORM SIGN KA TIMES GISH CROSSING GISH' },
	[0x1216B] = { unicodeslot=0x1216B, category='lo', description='CUNEIFORM SIGN KA TIMES GU' },
	[0x1216C] = { unicodeslot=0x1216C, category='lo', description='CUNEIFORM SIGN KA TIMES GUR7' },
	[0x1216D] = { unicodeslot=0x1216D, category='lo', description='CUNEIFORM SIGN KA TIMES IGI' },
	[0x1216E] = { unicodeslot=0x1216E, category='lo', description='CUNEIFORM SIGN KA TIMES IM' },
	[0x1216F] = { unicodeslot=0x1216F, category='lo', description='CUNEIFORM SIGN KA TIMES KAK' },
	[0x12170] = { unicodeslot=0x12170, category='lo', description='CUNEIFORM SIGN KA TIMES KI' },
	[0x12171] = { unicodeslot=0x12171, category='lo', description='CUNEIFORM SIGN KA TIMES KID' },
	[0x12172] = { unicodeslot=0x12172, category='lo', description='CUNEIFORM SIGN KA TIMES LI' },
	[0x12173] = { unicodeslot=0x12173, category='lo', description='CUNEIFORM SIGN KA TIMES LU' },
	[0x12174] = { unicodeslot=0x12174, category='lo', description='CUNEIFORM SIGN KA TIMES ME' },
	[0x12175] = { unicodeslot=0x12175, category='lo', description='CUNEIFORM SIGN KA TIMES ME PLUS DU' },
	[0x12176] = { unicodeslot=0x12176, category='lo', description='CUNEIFORM SIGN KA TIMES ME PLUS GI' },
	[0x12177] = { unicodeslot=0x12177, category='lo', description='CUNEIFORM SIGN KA TIMES ME PLUS TE' },
	[0x12178] = { unicodeslot=0x12178, category='lo', description='CUNEIFORM SIGN KA TIMES MI' },
	[0x12179] = { unicodeslot=0x12179, category='lo', description='CUNEIFORM SIGN KA TIMES MI PLUS NUNUZ' },
	[0x1217A] = { unicodeslot=0x1217A, category='lo', description='CUNEIFORM SIGN KA TIMES NE' },
	[0x1217B] = { unicodeslot=0x1217B, category='lo', description='CUNEIFORM SIGN KA TIMES NUN' },
	[0x1217C] = { unicodeslot=0x1217C, category='lo', description='CUNEIFORM SIGN KA TIMES PI' },
	[0x1217D] = { unicodeslot=0x1217D, category='lo', description='CUNEIFORM SIGN KA TIMES RU' },
	[0x1217E] = { unicodeslot=0x1217E, category='lo', description='CUNEIFORM SIGN KA TIMES SA' },
	[0x1217F] = { unicodeslot=0x1217F, category='lo', description='CUNEIFORM SIGN KA TIMES SAR' },
	[0x12180] = { unicodeslot=0x12180, category='lo', description='CUNEIFORM SIGN KA TIMES SHA' },
	[0x12181] = { unicodeslot=0x12181, category='lo', description='CUNEIFORM SIGN KA TIMES SHE' },
	[0x12182] = { unicodeslot=0x12182, category='lo', description='CUNEIFORM SIGN KA TIMES SHID' },
	[0x12183] = { unicodeslot=0x12183, category='lo', description='CUNEIFORM SIGN KA TIMES SHU' },
	[0x12184] = { unicodeslot=0x12184, category='lo', description='CUNEIFORM SIGN KA TIMES SIG' },
	[0x12185] = { unicodeslot=0x12185, category='lo', description='CUNEIFORM SIGN KA TIMES SUHUR' },
	[0x12186] = { unicodeslot=0x12186, category='lo', description='CUNEIFORM SIGN KA TIMES TAR' },
	[0x12187] = { unicodeslot=0x12187, category='lo', description='CUNEIFORM SIGN KA TIMES U' },
	[0x12188] = { unicodeslot=0x12188, category='lo', description='CUNEIFORM SIGN KA TIMES U2' },
	[0x12189] = { unicodeslot=0x12189, category='lo', description='CUNEIFORM SIGN KA TIMES UD' },
	[0x1218A] = { unicodeslot=0x1218A, category='lo', description='CUNEIFORM SIGN KA TIMES UMUM TIMES PA' },
	[0x1218B] = { unicodeslot=0x1218B, category='lo', description='CUNEIFORM SIGN KA TIMES USH' },
	[0x1218C] = { unicodeslot=0x1218C, category='lo', description='CUNEIFORM SIGN KA TIMES ZI' },
	[0x1218D] = { unicodeslot=0x1218D, category='lo', description='CUNEIFORM SIGN KA2' },
	[0x1218E] = { unicodeslot=0x1218E, category='lo', description='CUNEIFORM SIGN KA2 CROSSING KA2' },
	[0x1218F] = { unicodeslot=0x1218F, category='lo', description='CUNEIFORM SIGN KAB' },
	[0x12190] = { unicodeslot=0x12190, category='lo', description='CUNEIFORM SIGN KAD2' },
	[0x12191] = { unicodeslot=0x12191, category='lo', description='CUNEIFORM SIGN KAD3' },
	[0x12192] = { unicodeslot=0x12192, category='lo', description='CUNEIFORM SIGN KAD4' },
	[0x12193] = { unicodeslot=0x12193, category='lo', description='CUNEIFORM SIGN KAD5' },
	[0x12194] = { unicodeslot=0x12194, category='lo', description='CUNEIFORM SIGN KAD5 OVER KAD5' },
	[0x12195] = { unicodeslot=0x12195, category='lo', description='CUNEIFORM SIGN KAK' },
	[0x12196] = { unicodeslot=0x12196, category='lo', description='CUNEIFORM SIGN KAK TIMES IGI GUNU' },
	[0x12197] = { unicodeslot=0x12197, category='lo', description='CUNEIFORM SIGN KAL' },
	[0x12198] = { unicodeslot=0x12198, category='lo', description='CUNEIFORM SIGN KAL TIMES BAD' },
	[0x12199] = { unicodeslot=0x12199, category='lo', description='CUNEIFORM SIGN KAL CROSSING KAL' },
	[0x1219A] = { unicodeslot=0x1219A, category='lo', description='CUNEIFORM SIGN KAM2' },
	[0x1219B] = { unicodeslot=0x1219B, category='lo', description='CUNEIFORM SIGN KAM4' },
	[0x1219C] = { unicodeslot=0x1219C, category='lo', description='CUNEIFORM SIGN KASKAL' },
	[0x1219D] = { unicodeslot=0x1219D, category='lo', description='CUNEIFORM SIGN KASKAL LAGAB TIMES U OVER LAGAB TIMES U' },
	[0x1219E] = { unicodeslot=0x1219E, category='lo', description='CUNEIFORM SIGN KASKAL OVER KASKAL LAGAB TIMES U OVER LAGAB TIMES U' },
	[0x1219F] = { unicodeslot=0x1219F, category='lo', description='CUNEIFORM SIGN KESH2' },
	[0x121A0] = { unicodeslot=0x121A0, category='lo', description='CUNEIFORM SIGN KI' },
	[0x121A1] = { unicodeslot=0x121A1, category='lo', description='CUNEIFORM SIGN KI TIMES BAD' },
	[0x121A2] = { unicodeslot=0x121A2, category='lo', description='CUNEIFORM SIGN KI TIMES U' },
	[0x121A3] = { unicodeslot=0x121A3, category='lo', description='CUNEIFORM SIGN KI TIMES UD' },
	[0x121A4] = { unicodeslot=0x121A4, category='lo', description='CUNEIFORM SIGN KID' },
	[0x121A5] = { unicodeslot=0x121A5, category='lo', description='CUNEIFORM SIGN KIN' },
	[0x121A6] = { unicodeslot=0x121A6, category='lo', description='CUNEIFORM SIGN KISAL' },
	[0x121A7] = { unicodeslot=0x121A7, category='lo', description='CUNEIFORM SIGN KISH' },
	[0x121A8] = { unicodeslot=0x121A8, category='lo', description='CUNEIFORM SIGN KISIM5' },
	[0x121A9] = { unicodeslot=0x121A9, category='lo', description='CUNEIFORM SIGN KISIM5 OVER KISIM5' },
	[0x121AA] = { unicodeslot=0x121AA, category='lo', description='CUNEIFORM SIGN KU' },
	[0x121AB] = { unicodeslot=0x121AB, category='lo', description='CUNEIFORM SIGN KU OVER HI TIMES ASH2 KU OVER HI TIMES ASH2' },
	[0x121AC] = { unicodeslot=0x121AC, category='lo', description='CUNEIFORM SIGN KU3' },
	[0x121AD] = { unicodeslot=0x121AD, category='lo', description='CUNEIFORM SIGN KU4' },
	[0x121AE] = { unicodeslot=0x121AE, category='lo', description='CUNEIFORM SIGN KU4 VARIANT FORM' },
	[0x121AF] = { unicodeslot=0x121AF, category='lo', description='CUNEIFORM SIGN KU7' },
	[0x121B0] = { unicodeslot=0x121B0, category='lo', description='CUNEIFORM SIGN KUL' },
	[0x121B1] = { unicodeslot=0x121B1, category='lo', description='CUNEIFORM SIGN KUL GUNU' },
	[0x121B2] = { unicodeslot=0x121B2, category='lo', description='CUNEIFORM SIGN KUN' },
	[0x121B3] = { unicodeslot=0x121B3, category='lo', description='CUNEIFORM SIGN KUR' },
	[0x121B4] = { unicodeslot=0x121B4, category='lo', description='CUNEIFORM SIGN KUR OPPOSING KUR' },
	[0x121B5] = { unicodeslot=0x121B5, category='lo', description='CUNEIFORM SIGN KUSHU2' },
	[0x121B6] = { unicodeslot=0x121B6, category='lo', description='CUNEIFORM SIGN KWU318' },
	[0x121B7] = { unicodeslot=0x121B7, category='lo', description='CUNEIFORM SIGN LA' },
	[0x121B8] = { unicodeslot=0x121B8, category='lo', description='CUNEIFORM SIGN LAGAB' },
	[0x121B9] = { unicodeslot=0x121B9, category='lo', description='CUNEIFORM SIGN LAGAB TIMES A' },
	[0x121BA] = { unicodeslot=0x121BA, category='lo', description='CUNEIFORM SIGN LAGAB TIMES A PLUS DA PLUS HA' },
	[0x121BB] = { unicodeslot=0x121BB, category='lo', description='CUNEIFORM SIGN LAGAB TIMES A PLUS GAR' },
	[0x121BC] = { unicodeslot=0x121BC, category='lo', description='CUNEIFORM SIGN LAGAB TIMES A PLUS LAL' },
	[0x121BD] = { unicodeslot=0x121BD, category='lo', description='CUNEIFORM SIGN LAGAB TIMES AL' },
	[0x121BE] = { unicodeslot=0x121BE, category='lo', description='CUNEIFORM SIGN LAGAB TIMES AN' },
	[0x121BF] = { unicodeslot=0x121BF, category='lo', description='CUNEIFORM SIGN LAGAB TIMES ASH ZIDA TENU' },
	[0x121C0] = { unicodeslot=0x121C0, category='lo', description='CUNEIFORM SIGN LAGAB TIMES BAD' },
	[0x121C1] = { unicodeslot=0x121C1, category='lo', description='CUNEIFORM SIGN LAGAB TIMES BI' },
	[0x121C2] = { unicodeslot=0x121C2, category='lo', description='CUNEIFORM SIGN LAGAB TIMES DAR' },
	[0x121C3] = { unicodeslot=0x121C3, category='lo', description='CUNEIFORM SIGN LAGAB TIMES EN' },
	[0x121C4] = { unicodeslot=0x121C4, category='lo', description='CUNEIFORM SIGN LAGAB TIMES GA' },
	[0x121C5] = { unicodeslot=0x121C5, category='lo', description='CUNEIFORM SIGN LAGAB TIMES GAR' },
	[0x121C6] = { unicodeslot=0x121C6, category='lo', description='CUNEIFORM SIGN LAGAB TIMES GUD' },
	[0x121C7] = { unicodeslot=0x121C7, category='lo', description='CUNEIFORM SIGN LAGAB TIMES GUD PLUS GUD' },
	[0x121C8] = { unicodeslot=0x121C8, category='lo', description='CUNEIFORM SIGN LAGAB TIMES HA' },
	[0x121C9] = { unicodeslot=0x121C9, category='lo', description='CUNEIFORM SIGN LAGAB TIMES HAL' },
	[0x121CA] = { unicodeslot=0x121CA, category='lo', description='CUNEIFORM SIGN LAGAB TIMES HI TIMES NUN' },
	[0x121CB] = { unicodeslot=0x121CB, category='lo', description='CUNEIFORM SIGN LAGAB TIMES IGI GUNU' },
	[0x121CC] = { unicodeslot=0x121CC, category='lo', description='CUNEIFORM SIGN LAGAB TIMES IM' },
	[0x121CD] = { unicodeslot=0x121CD, category='lo', description='CUNEIFORM SIGN LAGAB TIMES IM PLUS HA' },
	[0x121CE] = { unicodeslot=0x121CE, category='lo', description='CUNEIFORM SIGN LAGAB TIMES IM PLUS LU' },
	[0x121CF] = { unicodeslot=0x121CF, category='lo', description='CUNEIFORM SIGN LAGAB TIMES KI' },
	[0x121D0] = { unicodeslot=0x121D0, category='lo', description='CUNEIFORM SIGN LAGAB TIMES KIN' },
	[0x121D1] = { unicodeslot=0x121D1, category='lo', description='CUNEIFORM SIGN LAGAB TIMES KU3' },
	[0x121D2] = { unicodeslot=0x121D2, category='lo', description='CUNEIFORM SIGN LAGAB TIMES KUL' },
	[0x121D3] = { unicodeslot=0x121D3, category='lo', description='CUNEIFORM SIGN LAGAB TIMES KUL PLUS HI PLUS A' },
	[0x121D4] = { unicodeslot=0x121D4, category='lo', description='CUNEIFORM SIGN LAGAB TIMES LAGAB' },
	[0x121D5] = { unicodeslot=0x121D5, category='lo', description='CUNEIFORM SIGN LAGAB TIMES LISH' },
	[0x121D6] = { unicodeslot=0x121D6, category='lo', description='CUNEIFORM SIGN LAGAB TIMES LU' },
	[0x121D7] = { unicodeslot=0x121D7, category='lo', description='CUNEIFORM SIGN LAGAB TIMES LUL' },
	[0x121D8] = { unicodeslot=0x121D8, category='lo', description='CUNEIFORM SIGN LAGAB TIMES ME' },
	[0x121D9] = { unicodeslot=0x121D9, category='lo', description='CUNEIFORM SIGN LAGAB TIMES ME PLUS EN' },
	[0x121DA] = { unicodeslot=0x121DA, category='lo', description='CUNEIFORM SIGN LAGAB TIMES MUSH' },
	[0x121DB] = { unicodeslot=0x121DB, category='lo', description='CUNEIFORM SIGN LAGAB TIMES NE' },
	[0x121DC] = { unicodeslot=0x121DC, category='lo', description='CUNEIFORM SIGN LAGAB TIMES SHE PLUS SUM' },
	[0x121DD] = { unicodeslot=0x121DD, category='lo', description='CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH PLUS ERIN2' },
	[0x121DE] = { unicodeslot=0x121DE, category='lo', description='CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH TENU' },
	[0x121DF] = { unicodeslot=0x121DF, category='lo', description='CUNEIFORM SIGN LAGAB TIMES SHU2' },
	[0x121E0] = { unicodeslot=0x121E0, category='lo', description='CUNEIFORM SIGN LAGAB TIMES SHU2 PLUS SHU2' },
	[0x121E1] = { unicodeslot=0x121E1, category='lo', description='CUNEIFORM SIGN LAGAB TIMES SUM' },
	[0x121E2] = { unicodeslot=0x121E2, category='lo', description='CUNEIFORM SIGN LAGAB TIMES TAG' },
	[0x121E3] = { unicodeslot=0x121E3, category='lo', description='CUNEIFORM SIGN LAGAB TIMES TAK4' },
	[0x121E4] = { unicodeslot=0x121E4, category='lo', description='CUNEIFORM SIGN LAGAB TIMES TE PLUS A PLUS SU PLUS NA' },
	[0x121E5] = { unicodeslot=0x121E5, category='lo', description='CUNEIFORM SIGN LAGAB TIMES U' },
	[0x121E6] = { unicodeslot=0x121E6, category='lo', description='CUNEIFORM SIGN LAGAB TIMES U PLUS A' },
	[0x121E7] = { unicodeslot=0x121E7, category='lo', description='CUNEIFORM SIGN LAGAB TIMES U PLUS U PLUS U' },
	[0x121E8] = { unicodeslot=0x121E8, category='lo', description='CUNEIFORM SIGN LAGAB TIMES U2 PLUS ASH' },
	[0x121E9] = { unicodeslot=0x121E9, category='lo', description='CUNEIFORM SIGN LAGAB TIMES UD' },
	[0x121EA] = { unicodeslot=0x121EA, category='lo', description='CUNEIFORM SIGN LAGAB TIMES USH' },
	[0x121EB] = { unicodeslot=0x121EB, category='lo', description='CUNEIFORM SIGN LAGAB SQUARED' },
	[0x121EC] = { unicodeslot=0x121EC, category='lo', description='CUNEIFORM SIGN LAGAR' },
	[0x121ED] = { unicodeslot=0x121ED, category='lo', description='CUNEIFORM SIGN LAGAR TIMES SHE' },
	[0x121EE] = { unicodeslot=0x121EE, category='lo', description='CUNEIFORM SIGN LAGAR TIMES SHE PLUS SUM' },
	[0x121EF] = { unicodeslot=0x121EF, category='lo', description='CUNEIFORM SIGN LAGAR GUNU' },
	[0x121F0] = { unicodeslot=0x121F0, category='lo', description='CUNEIFORM SIGN LAGAR GUNU OVER LAGAR GUNU SHE' },
	[0x121F1] = { unicodeslot=0x121F1, category='lo', description='CUNEIFORM SIGN LAHSHU' },
	[0x121F2] = { unicodeslot=0x121F2, category='lo', description='CUNEIFORM SIGN LAL' },
	[0x121F3] = { unicodeslot=0x121F3, category='lo', description='CUNEIFORM SIGN LAL TIMES LAL' },
	[0x121F4] = { unicodeslot=0x121F4, category='lo', description='CUNEIFORM SIGN LAM' },
	[0x121F5] = { unicodeslot=0x121F5, category='lo', description='CUNEIFORM SIGN LAM TIMES KUR' },
	[0x121F6] = { unicodeslot=0x121F6, category='lo', description='CUNEIFORM SIGN LAM TIMES KUR PLUS RU' },
	[0x121F7] = { unicodeslot=0x121F7, category='lo', description='CUNEIFORM SIGN LI' },
	[0x121F8] = { unicodeslot=0x121F8, category='lo', description='CUNEIFORM SIGN LIL' },
	[0x121F9] = { unicodeslot=0x121F9, category='lo', description='CUNEIFORM SIGN LIMMU2' },
	[0x121FA] = { unicodeslot=0x121FA, category='lo', description='CUNEIFORM SIGN LISH' },
	[0x121FB] = { unicodeslot=0x121FB, category='lo', description='CUNEIFORM SIGN LU' },
	[0x121FC] = { unicodeslot=0x121FC, category='lo', description='CUNEIFORM SIGN LU TIMES BAD' },
	[0x121FD] = { unicodeslot=0x121FD, category='lo', description='CUNEIFORM SIGN LU2' },
	[0x121FE] = { unicodeslot=0x121FE, category='lo', description='CUNEIFORM SIGN LU2 TIMES AL' },
	[0x121FF] = { unicodeslot=0x121FF, category='lo', description='CUNEIFORM SIGN LU2 TIMES BAD' },
	[0x12200] = { unicodeslot=0x12200, category='lo', description='CUNEIFORM SIGN LU2 TIMES ESH2' },
	[0x12201] = { unicodeslot=0x12201, category='lo', description='CUNEIFORM SIGN LU2 TIMES ESH2 TENU' },
	[0x12202] = { unicodeslot=0x12202, category='lo', description='CUNEIFORM SIGN LU2 TIMES GAN2 TENU' },
	[0x12203] = { unicodeslot=0x12203, category='lo', description='CUNEIFORM SIGN LU2 TIMES HI TIMES BAD' },
	[0x12204] = { unicodeslot=0x12204, category='lo', description='CUNEIFORM SIGN LU2 TIMES IM' },
	[0x12205] = { unicodeslot=0x12205, category='lo', description='CUNEIFORM SIGN LU2 TIMES KAD2' },
	[0x12206] = { unicodeslot=0x12206, category='lo', description='CUNEIFORM SIGN LU2 TIMES KAD3' },
	[0x12207] = { unicodeslot=0x12207, category='lo', description='CUNEIFORM SIGN LU2 TIMES KAD3 PLUS ASH' },
	[0x12208] = { unicodeslot=0x12208, category='lo', description='CUNEIFORM SIGN LU2 TIMES KI' },
	[0x12209] = { unicodeslot=0x12209, category='lo', description='CUNEIFORM SIGN LU2 TIMES LA PLUS ASH' },
	[0x1220A] = { unicodeslot=0x1220A, category='lo', description='CUNEIFORM SIGN LU2 TIMES LAGAB' },
	[0x1220B] = { unicodeslot=0x1220B, category='lo', description='CUNEIFORM SIGN LU2 TIMES ME PLUS EN' },
	[0x1220C] = { unicodeslot=0x1220C, category='lo', description='CUNEIFORM SIGN LU2 TIMES NE' },
	[0x1220D] = { unicodeslot=0x1220D, category='lo', description='CUNEIFORM SIGN LU2 TIMES NU' },
	[0x1220E] = { unicodeslot=0x1220E, category='lo', description='CUNEIFORM SIGN LU2 TIMES SI PLUS ASH' },
	[0x1220F] = { unicodeslot=0x1220F, category='lo', description='CUNEIFORM SIGN LU2 TIMES SIK2 PLUS BU' },
	[0x12210] = { unicodeslot=0x12210, category='lo', description='CUNEIFORM SIGN LU2 TIMES TUG2' },
	[0x12211] = { unicodeslot=0x12211, category='lo', description='CUNEIFORM SIGN LU2 TENU' },
	[0x12212] = { unicodeslot=0x12212, category='lo', description='CUNEIFORM SIGN LU2 CROSSING LU2' },
	[0x12213] = { unicodeslot=0x12213, category='lo', description='CUNEIFORM SIGN LU2 OPPOSING LU2' },
	[0x12214] = { unicodeslot=0x12214, category='lo', description='CUNEIFORM SIGN LU2 SQUARED' },
	[0x12215] = { unicodeslot=0x12215, category='lo', description='CUNEIFORM SIGN LU2 SHESHIG' },
	[0x12216] = { unicodeslot=0x12216, category='lo', description='CUNEIFORM SIGN LU3' },
	[0x12217] = { unicodeslot=0x12217, category='lo', description='CUNEIFORM SIGN LUGAL' },
	[0x12218] = { unicodeslot=0x12218, category='lo', description='CUNEIFORM SIGN LUGAL OVER LUGAL' },
	[0x12219] = { unicodeslot=0x12219, category='lo', description='CUNEIFORM SIGN LUGAL OPPOSING LUGAL' },
	[0x1221A] = { unicodeslot=0x1221A, category='lo', description='CUNEIFORM SIGN LUGAL SHESHIG' },
	[0x1221B] = { unicodeslot=0x1221B, category='lo', description='CUNEIFORM SIGN LUH' },
	[0x1221C] = { unicodeslot=0x1221C, category='lo', description='CUNEIFORM SIGN LUL' },
	[0x1221D] = { unicodeslot=0x1221D, category='lo', description='CUNEIFORM SIGN LUM' },
	[0x1221E] = { unicodeslot=0x1221E, category='lo', description='CUNEIFORM SIGN LUM OVER LUM' },
	[0x1221F] = { unicodeslot=0x1221F, category='lo', description='CUNEIFORM SIGN LUM OVER LUM GAR OVER GAR' },
	[0x12220] = { unicodeslot=0x12220, category='lo', description='CUNEIFORM SIGN MA' },
	[0x12221] = { unicodeslot=0x12221, category='lo', description='CUNEIFORM SIGN MA TIMES TAK4' },
	[0x12222] = { unicodeslot=0x12222, category='lo', description='CUNEIFORM SIGN MA GUNU' },
	[0x12223] = { unicodeslot=0x12223, category='lo', description='CUNEIFORM SIGN MA2' },
	[0x12224] = { unicodeslot=0x12224, category='lo', description='CUNEIFORM SIGN MAH' },
	[0x12225] = { unicodeslot=0x12225, category='lo', description='CUNEIFORM SIGN MAR' },
	[0x12226] = { unicodeslot=0x12226, category='lo', description='CUNEIFORM SIGN MASH' },
	[0x12227] = { unicodeslot=0x12227, category='lo', description='CUNEIFORM SIGN MASH2' },
	[0x12228] = { unicodeslot=0x12228, category='lo', description='CUNEIFORM SIGN ME' },
	[0x12229] = { unicodeslot=0x12229, category='lo', description='CUNEIFORM SIGN MES' },
	[0x1222A] = { unicodeslot=0x1222A, category='lo', description='CUNEIFORM SIGN MI' },
	[0x1222B] = { unicodeslot=0x1222B, category='lo', description='CUNEIFORM SIGN MIN' },
	[0x1222C] = { unicodeslot=0x1222C, category='lo', description='CUNEIFORM SIGN MU' },
	[0x1222D] = { unicodeslot=0x1222D, category='lo', description='CUNEIFORM SIGN MU OVER MU' },
	[0x1222E] = { unicodeslot=0x1222E, category='lo', description='CUNEIFORM SIGN MUG' },
	[0x1222F] = { unicodeslot=0x1222F, category='lo', description='CUNEIFORM SIGN MUG GUNU' },
	[0x12230] = { unicodeslot=0x12230, category='lo', description='CUNEIFORM SIGN MUNSUB' },
	[0x12231] = { unicodeslot=0x12231, category='lo', description='CUNEIFORM SIGN MURGU2' },
	[0x12232] = { unicodeslot=0x12232, category='lo', description='CUNEIFORM SIGN MUSH' },
	[0x12233] = { unicodeslot=0x12233, category='lo', description='CUNEIFORM SIGN MUSH TIMES A' },
	[0x12234] = { unicodeslot=0x12234, category='lo', description='CUNEIFORM SIGN MUSH TIMES KUR' },
	[0x12235] = { unicodeslot=0x12235, category='lo', description='CUNEIFORM SIGN MUSH TIMES ZA' },
	[0x12236] = { unicodeslot=0x12236, category='lo', description='CUNEIFORM SIGN MUSH OVER MUSH' },
	[0x12237] = { unicodeslot=0x12237, category='lo', description='CUNEIFORM SIGN MUSH OVER MUSH TIMES A PLUS NA' },
	[0x12238] = { unicodeslot=0x12238, category='lo', description='CUNEIFORM SIGN MUSH CROSSING MUSH' },
	[0x12239] = { unicodeslot=0x12239, category='lo', description='CUNEIFORM SIGN MUSH3' },
	[0x1223A] = { unicodeslot=0x1223A, category='lo', description='CUNEIFORM SIGN MUSH3 TIMES A' },
	[0x1223B] = { unicodeslot=0x1223B, category='lo', description='CUNEIFORM SIGN MUSH3 TIMES A PLUS DI' },
	[0x1223C] = { unicodeslot=0x1223C, category='lo', description='CUNEIFORM SIGN MUSH3 TIMES DI' },
	[0x1223D] = { unicodeslot=0x1223D, category='lo', description='CUNEIFORM SIGN MUSH3 GUNU' },
	[0x1223E] = { unicodeslot=0x1223E, category='lo', description='CUNEIFORM SIGN NA' },
	[0x1223F] = { unicodeslot=0x1223F, category='lo', description='CUNEIFORM SIGN NA2' },
	[0x12240] = { unicodeslot=0x12240, category='lo', description='CUNEIFORM SIGN NAGA' },
	[0x12241] = { unicodeslot=0x12241, category='lo', description='CUNEIFORM SIGN NAGA INVERTED' },
	[0x12242] = { unicodeslot=0x12242, category='lo', description='CUNEIFORM SIGN NAGA TIMES SHU TENU' },
	[0x12243] = { unicodeslot=0x12243, category='lo', description='CUNEIFORM SIGN NAGA OPPOSING NAGA' },
	[0x12244] = { unicodeslot=0x12244, category='lo', description='CUNEIFORM SIGN NAGAR' },
	[0x12245] = { unicodeslot=0x12245, category='lo', description='CUNEIFORM SIGN NAM NUTILLU' },
	[0x12246] = { unicodeslot=0x12246, category='lo', description='CUNEIFORM SIGN NAM' },
	[0x12247] = { unicodeslot=0x12247, category='lo', description='CUNEIFORM SIGN NAM2' },
	[0x12248] = { unicodeslot=0x12248, category='lo', description='CUNEIFORM SIGN NE' },
	[0x12249] = { unicodeslot=0x12249, category='lo', description='CUNEIFORM SIGN NE TIMES A' },
	[0x1224A] = { unicodeslot=0x1224A, category='lo', description='CUNEIFORM SIGN NE TIMES UD' },
	[0x1224B] = { unicodeslot=0x1224B, category='lo', description='CUNEIFORM SIGN NE SHESHIG' },
	[0x1224C] = { unicodeslot=0x1224C, category='lo', description='CUNEIFORM SIGN NI' },
	[0x1224D] = { unicodeslot=0x1224D, category='lo', description='CUNEIFORM SIGN NI TIMES E' },
	[0x1224E] = { unicodeslot=0x1224E, category='lo', description='CUNEIFORM SIGN NI2' },
	[0x1224F] = { unicodeslot=0x1224F, category='lo', description='CUNEIFORM SIGN NIM' },
	[0x12250] = { unicodeslot=0x12250, category='lo', description='CUNEIFORM SIGN NIM TIMES GAN2 TENU' },
	[0x12251] = { unicodeslot=0x12251, category='lo', description='CUNEIFORM SIGN NIM TIMES GAR PLUS GAN2 TENU' },
	[0x12252] = { unicodeslot=0x12252, category='lo', description='CUNEIFORM SIGN NINDA2' },
	[0x12253] = { unicodeslot=0x12253, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES AN' },
	[0x12254] = { unicodeslot=0x12254, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES ASH' },
	[0x12255] = { unicodeslot=0x12255, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES ASH PLUS ASH' },
	[0x12256] = { unicodeslot=0x12256, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES GUD' },
	[0x12257] = { unicodeslot=0x12257, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES ME PLUS GAN2 TENU' },
	[0x12258] = { unicodeslot=0x12258, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES NE' },
	[0x12259] = { unicodeslot=0x12259, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES NUN' },
	[0x1225A] = { unicodeslot=0x1225A, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES SHE' },
	[0x1225B] = { unicodeslot=0x1225B, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES SHE PLUS A AN' },
	[0x1225C] = { unicodeslot=0x1225C, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH' },
	[0x1225D] = { unicodeslot=0x1225D, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH PLUS ASH' },
	[0x1225E] = { unicodeslot=0x1225E, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES U2 PLUS ASH' },
	[0x1225F] = { unicodeslot=0x1225F, category='lo', description='CUNEIFORM SIGN NINDA2 TIMES USH' },
	[0x12260] = { unicodeslot=0x12260, category='lo', description='CUNEIFORM SIGN NISAG' },
	[0x12261] = { unicodeslot=0x12261, category='lo', description='CUNEIFORM SIGN NU' },
	[0x12262] = { unicodeslot=0x12262, category='lo', description='CUNEIFORM SIGN NU11' },
	[0x12263] = { unicodeslot=0x12263, category='lo', description='CUNEIFORM SIGN NUN' },
	[0x12264] = { unicodeslot=0x12264, category='lo', description='CUNEIFORM SIGN NUN LAGAR TIMES GAR' },
	[0x12265] = { unicodeslot=0x12265, category='lo', description='CUNEIFORM SIGN NUN LAGAR TIMES MASH' },
	[0x12266] = { unicodeslot=0x12266, category='lo', description='CUNEIFORM SIGN NUN LAGAR TIMES SAL' },
	[0x12267] = { unicodeslot=0x12267, category='lo', description='CUNEIFORM SIGN NUN LAGAR TIMES SAL OVER NUN LAGAR TIMES SAL' },
	[0x12268] = { unicodeslot=0x12268, category='lo', description='CUNEIFORM SIGN NUN LAGAR TIMES USH' },
	[0x12269] = { unicodeslot=0x12269, category='lo', description='CUNEIFORM SIGN NUN TENU' },
	[0x1226A] = { unicodeslot=0x1226A, category='lo', description='CUNEIFORM SIGN NUN OVER NUN' },
	[0x1226B] = { unicodeslot=0x1226B, category='lo', description='CUNEIFORM SIGN NUN CROSSING NUN' },
	[0x1226C] = { unicodeslot=0x1226C, category='lo', description='CUNEIFORM SIGN NUN CROSSING NUN LAGAR OVER LAGAR' },
	[0x1226D] = { unicodeslot=0x1226D, category='lo', description='CUNEIFORM SIGN NUNUZ' },
	[0x1226E] = { unicodeslot=0x1226E, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES ASHGAB' },
	[0x1226F] = { unicodeslot=0x1226F, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES BI' },
	[0x12270] = { unicodeslot=0x12270, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES DUG' },
	[0x12271] = { unicodeslot=0x12271, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES GUD' },
	[0x12272] = { unicodeslot=0x12272, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES IGI GUNU' },
	[0x12273] = { unicodeslot=0x12273, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES KAD3' },
	[0x12274] = { unicodeslot=0x12274, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES LA' },
	[0x12275] = { unicodeslot=0x12275, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES NE' },
	[0x12276] = { unicodeslot=0x12276, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES SILA3' },
	[0x12277] = { unicodeslot=0x12277, category='lo', description='CUNEIFORM SIGN NUNUZ AB2 TIMES U2' },
	[0x12278] = { unicodeslot=0x12278, category='lo', description='CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI' },
	[0x12279] = { unicodeslot=0x12279, category='lo', description='CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI U' },
	[0x1227A] = { unicodeslot=0x1227A, category='lo', description='CUNEIFORM SIGN PA' },
	[0x1227B] = { unicodeslot=0x1227B, category='lo', description='CUNEIFORM SIGN PAD' },
	[0x1227C] = { unicodeslot=0x1227C, category='lo', description='CUNEIFORM SIGN PAN' },
	[0x1227D] = { unicodeslot=0x1227D, category='lo', description='CUNEIFORM SIGN PAP' },
	[0x1227E] = { unicodeslot=0x1227E, category='lo', description='CUNEIFORM SIGN PESH2' },
	[0x1227F] = { unicodeslot=0x1227F, category='lo', description='CUNEIFORM SIGN PI' },
	[0x12280] = { unicodeslot=0x12280, category='lo', description='CUNEIFORM SIGN PI TIMES A' },
	[0x12281] = { unicodeslot=0x12281, category='lo', description='CUNEIFORM SIGN PI TIMES AB' },
	[0x12282] = { unicodeslot=0x12282, category='lo', description='CUNEIFORM SIGN PI TIMES BI' },
	[0x12283] = { unicodeslot=0x12283, category='lo', description='CUNEIFORM SIGN PI TIMES BU' },
	[0x12284] = { unicodeslot=0x12284, category='lo', description='CUNEIFORM SIGN PI TIMES E' },
	[0x12285] = { unicodeslot=0x12285, category='lo', description='CUNEIFORM SIGN PI TIMES I' },
	[0x12286] = { unicodeslot=0x12286, category='lo', description='CUNEIFORM SIGN PI TIMES IB' },
	[0x12287] = { unicodeslot=0x12287, category='lo', description='CUNEIFORM SIGN PI TIMES U' },
	[0x12288] = { unicodeslot=0x12288, category='lo', description='CUNEIFORM SIGN PI TIMES U2' },
	[0x12289] = { unicodeslot=0x12289, category='lo', description='CUNEIFORM SIGN PI CROSSING PI' },
	[0x1228A] = { unicodeslot=0x1228A, category='lo', description='CUNEIFORM SIGN PIRIG' },
	[0x1228B] = { unicodeslot=0x1228B, category='lo', description='CUNEIFORM SIGN PIRIG TIMES KAL' },
	[0x1228C] = { unicodeslot=0x1228C, category='lo', description='CUNEIFORM SIGN PIRIG TIMES UD' },
	[0x1228D] = { unicodeslot=0x1228D, category='lo', description='CUNEIFORM SIGN PIRIG TIMES ZA' },
	[0x1228E] = { unicodeslot=0x1228E, category='lo', description='CUNEIFORM SIGN PIRIG OPPOSING PIRIG' },
	[0x1228F] = { unicodeslot=0x1228F, category='lo', description='CUNEIFORM SIGN RA' },
	[0x12290] = { unicodeslot=0x12290, category='lo', description='CUNEIFORM SIGN RAB' },
	[0x12291] = { unicodeslot=0x12291, category='lo', description='CUNEIFORM SIGN RI' },
	[0x12292] = { unicodeslot=0x12292, category='lo', description='CUNEIFORM SIGN RU' },
	[0x12293] = { unicodeslot=0x12293, category='lo', description='CUNEIFORM SIGN SA' },
	[0x12294] = { unicodeslot=0x12294, category='lo', description='CUNEIFORM SIGN SAG NUTILLU' },
	[0x12295] = { unicodeslot=0x12295, category='lo', description='CUNEIFORM SIGN SAG' },
	[0x12296] = { unicodeslot=0x12296, category='lo', description='CUNEIFORM SIGN SAG TIMES A' },
	[0x12297] = { unicodeslot=0x12297, category='lo', description='CUNEIFORM SIGN SAG TIMES DU' },
	[0x12298] = { unicodeslot=0x12298, category='lo', description='CUNEIFORM SIGN SAG TIMES DUB' },
	[0x12299] = { unicodeslot=0x12299, category='lo', description='CUNEIFORM SIGN SAG TIMES HA' },
	[0x1229A] = { unicodeslot=0x1229A, category='lo', description='CUNEIFORM SIGN SAG TIMES KAK' },
	[0x1229B] = { unicodeslot=0x1229B, category='lo', description='CUNEIFORM SIGN SAG TIMES KUR' },
	[0x1229C] = { unicodeslot=0x1229C, category='lo', description='CUNEIFORM SIGN SAG TIMES LUM' },
	[0x1229D] = { unicodeslot=0x1229D, category='lo', description='CUNEIFORM SIGN SAG TIMES MI' },
	[0x1229E] = { unicodeslot=0x1229E, category='lo', description='CUNEIFORM SIGN SAG TIMES NUN' },
	[0x1229F] = { unicodeslot=0x1229F, category='lo', description='CUNEIFORM SIGN SAG TIMES SAL' },
	[0x122A0] = { unicodeslot=0x122A0, category='lo', description='CUNEIFORM SIGN SAG TIMES SHID' },
	[0x122A1] = { unicodeslot=0x122A1, category='lo', description='CUNEIFORM SIGN SAG TIMES TAB' },
	[0x122A2] = { unicodeslot=0x122A2, category='lo', description='CUNEIFORM SIGN SAG TIMES U2' },
	[0x122A3] = { unicodeslot=0x122A3, category='lo', description='CUNEIFORM SIGN SAG TIMES UB' },
	[0x122A4] = { unicodeslot=0x122A4, category='lo', description='CUNEIFORM SIGN SAG TIMES UM' },
	[0x122A5] = { unicodeslot=0x122A5, category='lo', description='CUNEIFORM SIGN SAG TIMES UR' },
	[0x122A6] = { unicodeslot=0x122A6, category='lo', description='CUNEIFORM SIGN SAG TIMES USH' },
	[0x122A7] = { unicodeslot=0x122A7, category='lo', description='CUNEIFORM SIGN SAG OVER SAG' },
	[0x122A8] = { unicodeslot=0x122A8, category='lo', description='CUNEIFORM SIGN SAG GUNU' },
	[0x122A9] = { unicodeslot=0x122A9, category='lo', description='CUNEIFORM SIGN SAL' },
	[0x122AA] = { unicodeslot=0x122AA, category='lo', description='CUNEIFORM SIGN SAL LAGAB TIMES ASH2' },
	[0x122AB] = { unicodeslot=0x122AB, category='lo', description='CUNEIFORM SIGN SANGA2' },
	[0x122AC] = { unicodeslot=0x122AC, category='lo', description='CUNEIFORM SIGN SAR' },
	[0x122AD] = { unicodeslot=0x122AD, category='lo', description='CUNEIFORM SIGN SHA' },
	[0x122AE] = { unicodeslot=0x122AE, category='lo', description='CUNEIFORM SIGN SHA3' },
	[0x122AF] = { unicodeslot=0x122AF, category='lo', description='CUNEIFORM SIGN SHA3 TIMES A' },
	[0x122B0] = { unicodeslot=0x122B0, category='lo', description='CUNEIFORM SIGN SHA3 TIMES BAD' },
	[0x122B1] = { unicodeslot=0x122B1, category='lo', description='CUNEIFORM SIGN SHA3 TIMES GISH' },
	[0x122B2] = { unicodeslot=0x122B2, category='lo', description='CUNEIFORM SIGN SHA3 TIMES NE' },
	[0x122B3] = { unicodeslot=0x122B3, category='lo', description='CUNEIFORM SIGN SHA3 TIMES SHU2' },
	[0x122B4] = { unicodeslot=0x122B4, category='lo', description='CUNEIFORM SIGN SHA3 TIMES TUR' },
	[0x122B5] = { unicodeslot=0x122B5, category='lo', description='CUNEIFORM SIGN SHA3 TIMES U' },
	[0x122B6] = { unicodeslot=0x122B6, category='lo', description='CUNEIFORM SIGN SHA3 TIMES U PLUS A' },
	[0x122B7] = { unicodeslot=0x122B7, category='lo', description='CUNEIFORM SIGN SHA6' },
	[0x122B8] = { unicodeslot=0x122B8, category='lo', description='CUNEIFORM SIGN SHAB6' },
	[0x122B9] = { unicodeslot=0x122B9, category='lo', description='CUNEIFORM SIGN SHAR2' },
	[0x122BA] = { unicodeslot=0x122BA, category='lo', description='CUNEIFORM SIGN SHE' },
	[0x122BB] = { unicodeslot=0x122BB, category='lo', description='CUNEIFORM SIGN SHE HU' },
	[0x122BC] = { unicodeslot=0x122BC, category='lo', description='CUNEIFORM SIGN SHE OVER SHE GAD OVER GAD GAR OVER GAR' },
	[0x122BD] = { unicodeslot=0x122BD, category='lo', description='CUNEIFORM SIGN SHE OVER SHE TAB OVER TAB GAR OVER GAR' },
	[0x122BE] = { unicodeslot=0x122BE, category='lo', description='CUNEIFORM SIGN SHEG9' },
	[0x122BF] = { unicodeslot=0x122BF, category='lo', description='CUNEIFORM SIGN SHEN' },
	[0x122C0] = { unicodeslot=0x122C0, category='lo', description='CUNEIFORM SIGN SHESH' },
	[0x122C1] = { unicodeslot=0x122C1, category='lo', description='CUNEIFORM SIGN SHESH2' },
	[0x122C2] = { unicodeslot=0x122C2, category='lo', description='CUNEIFORM SIGN SHESHLAM' },
	[0x122C3] = { unicodeslot=0x122C3, category='lo', description='CUNEIFORM SIGN SHID' },
	[0x122C4] = { unicodeslot=0x122C4, category='lo', description='CUNEIFORM SIGN SHID TIMES A' },
	[0x122C5] = { unicodeslot=0x122C5, category='lo', description='CUNEIFORM SIGN SHID TIMES IM' },
	[0x122C6] = { unicodeslot=0x122C6, category='lo', description='CUNEIFORM SIGN SHIM' },
	[0x122C7] = { unicodeslot=0x122C7, category='lo', description='CUNEIFORM SIGN SHIM TIMES A' },
	[0x122C8] = { unicodeslot=0x122C8, category='lo', description='CUNEIFORM SIGN SHIM TIMES BAL' },
	[0x122C9] = { unicodeslot=0x122C9, category='lo', description='CUNEIFORM SIGN SHIM TIMES BULUG' },
	[0x122CA] = { unicodeslot=0x122CA, category='lo', description='CUNEIFORM SIGN SHIM TIMES DIN' },
	[0x122CB] = { unicodeslot=0x122CB, category='lo', description='CUNEIFORM SIGN SHIM TIMES GAR' },
	[0x122CC] = { unicodeslot=0x122CC, category='lo', description='CUNEIFORM SIGN SHIM TIMES IGI' },
	[0x122CD] = { unicodeslot=0x122CD, category='lo', description='CUNEIFORM SIGN SHIM TIMES IGI GUNU' },
	[0x122CE] = { unicodeslot=0x122CE, category='lo', description='CUNEIFORM SIGN SHIM TIMES KUSHU2' },
	[0x122CF] = { unicodeslot=0x122CF, category='lo', description='CUNEIFORM SIGN SHIM TIMES LUL' },
	[0x122D0] = { unicodeslot=0x122D0, category='lo', description='CUNEIFORM SIGN SHIM TIMES MUG' },
	[0x122D1] = { unicodeslot=0x122D1, category='lo', description='CUNEIFORM SIGN SHIM TIMES SAL' },
	[0x122D2] = { unicodeslot=0x122D2, category='lo', description='CUNEIFORM SIGN SHINIG' },
	[0x122D3] = { unicodeslot=0x122D3, category='lo', description='CUNEIFORM SIGN SHIR' },
	[0x122D4] = { unicodeslot=0x122D4, category='lo', description='CUNEIFORM SIGN SHIR TENU' },
	[0x122D5] = { unicodeslot=0x122D5, category='lo', description='CUNEIFORM SIGN SHIR OVER SHIR BUR OVER BUR' },
	[0x122D6] = { unicodeslot=0x122D6, category='lo', description='CUNEIFORM SIGN SHITA' },
	[0x122D7] = { unicodeslot=0x122D7, category='lo', description='CUNEIFORM SIGN SHU' },
	[0x122D8] = { unicodeslot=0x122D8, category='lo', description='CUNEIFORM SIGN SHU OVER INVERTED SHU' },
	[0x122D9] = { unicodeslot=0x122D9, category='lo', description='CUNEIFORM SIGN SHU2' },
	[0x122DA] = { unicodeslot=0x122DA, category='lo', description='CUNEIFORM SIGN SHUBUR' },
	[0x122DB] = { unicodeslot=0x122DB, category='lo', description='CUNEIFORM SIGN SI' },
	[0x122DC] = { unicodeslot=0x122DC, category='lo', description='CUNEIFORM SIGN SI GUNU' },
	[0x122DD] = { unicodeslot=0x122DD, category='lo', description='CUNEIFORM SIGN SIG' },
	[0x122DE] = { unicodeslot=0x122DE, category='lo', description='CUNEIFORM SIGN SIG4' },
	[0x122DF] = { unicodeslot=0x122DF, category='lo', description='CUNEIFORM SIGN SIG4 OVER SIG4 SHU2' },
	[0x122E0] = { unicodeslot=0x122E0, category='lo', description='CUNEIFORM SIGN SIK2' },
	[0x122E1] = { unicodeslot=0x122E1, category='lo', description='CUNEIFORM SIGN SILA3' },
	[0x122E2] = { unicodeslot=0x122E2, category='lo', description='CUNEIFORM SIGN SU' },
	[0x122E3] = { unicodeslot=0x122E3, category='lo', description='CUNEIFORM SIGN SU OVER SU' },
	[0x122E4] = { unicodeslot=0x122E4, category='lo', description='CUNEIFORM SIGN SUD' },
	[0x122E5] = { unicodeslot=0x122E5, category='lo', description='CUNEIFORM SIGN SUD2' },
	[0x122E6] = { unicodeslot=0x122E6, category='lo', description='CUNEIFORM SIGN SUHUR' },
	[0x122E7] = { unicodeslot=0x122E7, category='lo', description='CUNEIFORM SIGN SUM' },
	[0x122E8] = { unicodeslot=0x122E8, category='lo', description='CUNEIFORM SIGN SUMASH' },
	[0x122E9] = { unicodeslot=0x122E9, category='lo', description='CUNEIFORM SIGN SUR' },
	[0x122EA] = { unicodeslot=0x122EA, category='lo', description='CUNEIFORM SIGN SUR9' },
	[0x122EB] = { unicodeslot=0x122EB, category='lo', description='CUNEIFORM SIGN TA' },
	[0x122EC] = { unicodeslot=0x122EC, category='lo', description='CUNEIFORM SIGN TA ASTERISK' },
	[0x122ED] = { unicodeslot=0x122ED, category='lo', description='CUNEIFORM SIGN TA TIMES HI' },
	[0x122EE] = { unicodeslot=0x122EE, category='lo', description='CUNEIFORM SIGN TA TIMES MI' },
	[0x122EF] = { unicodeslot=0x122EF, category='lo', description='CUNEIFORM SIGN TA GUNU' },
	[0x122F0] = { unicodeslot=0x122F0, category='lo', description='CUNEIFORM SIGN TAB' },
	[0x122F1] = { unicodeslot=0x122F1, category='lo', description='CUNEIFORM SIGN TAB OVER TAB NI OVER NI DISH OVER DISH' },
	[0x122F2] = { unicodeslot=0x122F2, category='lo', description='CUNEIFORM SIGN TAB SQUARED' },
	[0x122F3] = { unicodeslot=0x122F3, category='lo', description='CUNEIFORM SIGN TAG' },
	[0x122F4] = { unicodeslot=0x122F4, category='lo', description='CUNEIFORM SIGN TAG TIMES BI' },
	[0x122F5] = { unicodeslot=0x122F5, category='lo', description='CUNEIFORM SIGN TAG TIMES GUD' },
	[0x122F6] = { unicodeslot=0x122F6, category='lo', description='CUNEIFORM SIGN TAG TIMES SHE' },
	[0x122F7] = { unicodeslot=0x122F7, category='lo', description='CUNEIFORM SIGN TAG TIMES SHU' },
	[0x122F8] = { unicodeslot=0x122F8, category='lo', description='CUNEIFORM SIGN TAG TIMES TUG2' },
	[0x122F9] = { unicodeslot=0x122F9, category='lo', description='CUNEIFORM SIGN TAG TIMES UD' },
	[0x122FA] = { unicodeslot=0x122FA, category='lo', description='CUNEIFORM SIGN TAK4' },
	[0x122FB] = { unicodeslot=0x122FB, category='lo', description='CUNEIFORM SIGN TAR' },
	[0x122FC] = { unicodeslot=0x122FC, category='lo', description='CUNEIFORM SIGN TE' },
	[0x122FD] = { unicodeslot=0x122FD, category='lo', description='CUNEIFORM SIGN TE GUNU' },
	[0x122FE] = { unicodeslot=0x122FE, category='lo', description='CUNEIFORM SIGN TI' },
	[0x122FF] = { unicodeslot=0x122FF, category='lo', description='CUNEIFORM SIGN TI TENU' },
	[0x12300] = { unicodeslot=0x12300, category='lo', description='CUNEIFORM SIGN TIL' },
	[0x12301] = { unicodeslot=0x12301, category='lo', description='CUNEIFORM SIGN TIR' },
	[0x12302] = { unicodeslot=0x12302, category='lo', description='CUNEIFORM SIGN TIR TIMES TAK4' },
	[0x12303] = { unicodeslot=0x12303, category='lo', description='CUNEIFORM SIGN TIR OVER TIR' },
	[0x12304] = { unicodeslot=0x12304, category='lo', description='CUNEIFORM SIGN TIR OVER TIR GAD OVER GAD GAR OVER GAR' },
	[0x12305] = { unicodeslot=0x12305, category='lo', description='CUNEIFORM SIGN TU' },
	[0x12306] = { unicodeslot=0x12306, category='lo', description='CUNEIFORM SIGN TUG2' },
	[0x12307] = { unicodeslot=0x12307, category='lo', description='CUNEIFORM SIGN TUK' },
	[0x12308] = { unicodeslot=0x12308, category='lo', description='CUNEIFORM SIGN TUM' },
	[0x12309] = { unicodeslot=0x12309, category='lo', description='CUNEIFORM SIGN TUR' },
	[0x1230A] = { unicodeslot=0x1230A, category='lo', description='CUNEIFORM SIGN TUR OVER TUR ZA OVER ZA' },
	[0x1230B] = { unicodeslot=0x1230B, category='lo', description='CUNEIFORM SIGN U' },
	[0x1230C] = { unicodeslot=0x1230C, category='lo', description='CUNEIFORM SIGN U GUD' },
	[0x1230D] = { unicodeslot=0x1230D, category='lo', description='CUNEIFORM SIGN U U U' },
	[0x1230E] = { unicodeslot=0x1230E, category='lo', description='CUNEIFORM SIGN U OVER U PA OVER PA GAR OVER GAR' },
	[0x1230F] = { unicodeslot=0x1230F, category='lo', description='CUNEIFORM SIGN U OVER U SUR OVER SUR' },
	[0x12310] = { unicodeslot=0x12310, category='lo', description='CUNEIFORM SIGN U OVER U U REVERSED OVER U REVERSED' },
	[0x12311] = { unicodeslot=0x12311, category='lo', description='CUNEIFORM SIGN U2' },
	[0x12312] = { unicodeslot=0x12312, category='lo', description='CUNEIFORM SIGN UB' },
	[0x12313] = { unicodeslot=0x12313, category='lo', description='CUNEIFORM SIGN UD' },
	[0x12314] = { unicodeslot=0x12314, category='lo', description='CUNEIFORM SIGN UD KUSHU2' },
	[0x12315] = { unicodeslot=0x12315, category='lo', description='CUNEIFORM SIGN UD TIMES BAD' },
	[0x12316] = { unicodeslot=0x12316, category='lo', description='CUNEIFORM SIGN UD TIMES MI' },
	[0x12317] = { unicodeslot=0x12317, category='lo', description='CUNEIFORM SIGN UD TIMES U PLUS U PLUS U' },
	[0x12318] = { unicodeslot=0x12318, category='lo', description='CUNEIFORM SIGN UD TIMES U PLUS U PLUS U GUNU' },
	[0x12319] = { unicodeslot=0x12319, category='lo', description='CUNEIFORM SIGN UD GUNU' },
	[0x1231A] = { unicodeslot=0x1231A, category='lo', description='CUNEIFORM SIGN UD SHESHIG' },
	[0x1231B] = { unicodeslot=0x1231B, category='lo', description='CUNEIFORM SIGN UD SHESHIG TIMES BAD' },
	[0x1231C] = { unicodeslot=0x1231C, category='lo', description='CUNEIFORM SIGN UDUG' },
	[0x1231D] = { unicodeslot=0x1231D, category='lo', description='CUNEIFORM SIGN UM' },
	[0x1231E] = { unicodeslot=0x1231E, category='lo', description='CUNEIFORM SIGN UM TIMES LAGAB' },
	[0x1231F] = { unicodeslot=0x1231F, category='lo', description='CUNEIFORM SIGN UM TIMES ME PLUS DA' },
	[0x12320] = { unicodeslot=0x12320, category='lo', description='CUNEIFORM SIGN UM TIMES SHA3' },
	[0x12321] = { unicodeslot=0x12321, category='lo', description='CUNEIFORM SIGN UM TIMES U' },
	[0x12322] = { unicodeslot=0x12322, category='lo', description='CUNEIFORM SIGN UMBIN' },
	[0x12323] = { unicodeslot=0x12323, category='lo', description='CUNEIFORM SIGN UMUM' },
	[0x12324] = { unicodeslot=0x12324, category='lo', description='CUNEIFORM SIGN UMUM TIMES KASKAL' },
	[0x12325] = { unicodeslot=0x12325, category='lo', description='CUNEIFORM SIGN UMUM TIMES PA' },
	[0x12326] = { unicodeslot=0x12326, category='lo', description='CUNEIFORM SIGN UN' },
	[0x12327] = { unicodeslot=0x12327, category='lo', description='CUNEIFORM SIGN UN GUNU' },
	[0x12328] = { unicodeslot=0x12328, category='lo', description='CUNEIFORM SIGN UR' },
	[0x12329] = { unicodeslot=0x12329, category='lo', description='CUNEIFORM SIGN UR CROSSING UR' },
	[0x1232A] = { unicodeslot=0x1232A, category='lo', description='CUNEIFORM SIGN UR SHESHIG' },
	[0x1232B] = { unicodeslot=0x1232B, category='lo', description='CUNEIFORM SIGN UR2' },
	[0x1232C] = { unicodeslot=0x1232C, category='lo', description='CUNEIFORM SIGN UR2 TIMES A PLUS HA' },
	[0x1232D] = { unicodeslot=0x1232D, category='lo', description='CUNEIFORM SIGN UR2 TIMES A PLUS NA' },
	[0x1232E] = { unicodeslot=0x1232E, category='lo', description='CUNEIFORM SIGN UR2 TIMES AL' },
	[0x1232F] = { unicodeslot=0x1232F, category='lo', description='CUNEIFORM SIGN UR2 TIMES HA' },
	[0x12330] = { unicodeslot=0x12330, category='lo', description='CUNEIFORM SIGN UR2 TIMES NUN' },
	[0x12331] = { unicodeslot=0x12331, category='lo', description='CUNEIFORM SIGN UR2 TIMES U2' },
	[0x12332] = { unicodeslot=0x12332, category='lo', description='CUNEIFORM SIGN UR2 TIMES U2 PLUS ASH' },
	[0x12333] = { unicodeslot=0x12333, category='lo', description='CUNEIFORM SIGN UR2 TIMES U2 PLUS BI' },
	[0x12334] = { unicodeslot=0x12334, category='lo', description='CUNEIFORM SIGN UR4' },
	[0x12335] = { unicodeslot=0x12335, category='lo', description='CUNEIFORM SIGN URI' },
	[0x12336] = { unicodeslot=0x12336, category='lo', description='CUNEIFORM SIGN URI3' },
	[0x12337] = { unicodeslot=0x12337, category='lo', description='CUNEIFORM SIGN URU' },
	[0x12338] = { unicodeslot=0x12338, category='lo', description='CUNEIFORM SIGN URU TIMES A' },
	[0x12339] = { unicodeslot=0x12339, category='lo', description='CUNEIFORM SIGN URU TIMES ASHGAB' },
	[0x1233A] = { unicodeslot=0x1233A, category='lo', description='CUNEIFORM SIGN URU TIMES BAR' },
	[0x1233B] = { unicodeslot=0x1233B, category='lo', description='CUNEIFORM SIGN URU TIMES DUN' },
	[0x1233C] = { unicodeslot=0x1233C, category='lo', description='CUNEIFORM SIGN URU TIMES GA' },
	[0x1233D] = { unicodeslot=0x1233D, category='lo', description='CUNEIFORM SIGN URU TIMES GAL' },
	[0x1233E] = { unicodeslot=0x1233E, category='lo', description='CUNEIFORM SIGN URU TIMES GAN2 TENU' },
	[0x1233F] = { unicodeslot=0x1233F, category='lo', description='CUNEIFORM SIGN URU TIMES GAR' },
	[0x12340] = { unicodeslot=0x12340, category='lo', description='CUNEIFORM SIGN URU TIMES GU' },
	[0x12341] = { unicodeslot=0x12341, category='lo', description='CUNEIFORM SIGN URU TIMES HA' },
	[0x12342] = { unicodeslot=0x12342, category='lo', description='CUNEIFORM SIGN URU TIMES IGI' },
	[0x12343] = { unicodeslot=0x12343, category='lo', description='CUNEIFORM SIGN URU TIMES IM' },
	[0x12344] = { unicodeslot=0x12344, category='lo', description='CUNEIFORM SIGN URU TIMES ISH' },
	[0x12345] = { unicodeslot=0x12345, category='lo', description='CUNEIFORM SIGN URU TIMES KI' },
	[0x12346] = { unicodeslot=0x12346, category='lo', description='CUNEIFORM SIGN URU TIMES LUM' },
	[0x12347] = { unicodeslot=0x12347, category='lo', description='CUNEIFORM SIGN URU TIMES MIN' },
	[0x12348] = { unicodeslot=0x12348, category='lo', description='CUNEIFORM SIGN URU TIMES PA' },
	[0x12349] = { unicodeslot=0x12349, category='lo', description='CUNEIFORM SIGN URU TIMES SHE' },
	[0x1234A] = { unicodeslot=0x1234A, category='lo', description='CUNEIFORM SIGN URU TIMES SIG4' },
	[0x1234B] = { unicodeslot=0x1234B, category='lo', description='CUNEIFORM SIGN URU TIMES TU' },
	[0x1234C] = { unicodeslot=0x1234C, category='lo', description='CUNEIFORM SIGN URU TIMES U PLUS GUD' },
	[0x1234D] = { unicodeslot=0x1234D, category='lo', description='CUNEIFORM SIGN URU TIMES UD' },
	[0x1234E] = { unicodeslot=0x1234E, category='lo', description='CUNEIFORM SIGN URU TIMES URUDA' },
	[0x1234F] = { unicodeslot=0x1234F, category='lo', description='CUNEIFORM SIGN URUDA' },
	[0x12350] = { unicodeslot=0x12350, category='lo', description='CUNEIFORM SIGN URUDA TIMES U' },
	[0x12351] = { unicodeslot=0x12351, category='lo', description='CUNEIFORM SIGN USH' },
	[0x12352] = { unicodeslot=0x12352, category='lo', description='CUNEIFORM SIGN USH TIMES A' },
	[0x12353] = { unicodeslot=0x12353, category='lo', description='CUNEIFORM SIGN USH TIMES KU' },
	[0x12354] = { unicodeslot=0x12354, category='lo', description='CUNEIFORM SIGN USH TIMES KUR' },
	[0x12355] = { unicodeslot=0x12355, category='lo', description='CUNEIFORM SIGN USH TIMES TAK4' },
	[0x12356] = { unicodeslot=0x12356, category='lo', description='CUNEIFORM SIGN USHX' },
	[0x12357] = { unicodeslot=0x12357, category='lo', description='CUNEIFORM SIGN USH2' },
	[0x12358] = { unicodeslot=0x12358, category='lo', description='CUNEIFORM SIGN USHUMX' },
	[0x12359] = { unicodeslot=0x12359, category='lo', description='CUNEIFORM SIGN UTUKI' },
	[0x1235A] = { unicodeslot=0x1235A, category='lo', description='CUNEIFORM SIGN UZ3' },
	[0x1235B] = { unicodeslot=0x1235B, category='lo', description='CUNEIFORM SIGN UZ3 TIMES KASKAL' },
	[0x1235C] = { unicodeslot=0x1235C, category='lo', description='CUNEIFORM SIGN UZU' },
	[0x1235D] = { unicodeslot=0x1235D, category='lo', description='CUNEIFORM SIGN ZA' },
	[0x1235E] = { unicodeslot=0x1235E, category='lo', description='CUNEIFORM SIGN ZA TENU' },
	[0x1235F] = { unicodeslot=0x1235F, category='lo', description='CUNEIFORM SIGN ZA SQUARED TIMES KUR' },
	[0x12360] = { unicodeslot=0x12360, category='lo', description='CUNEIFORM SIGN ZAG' },
	[0x12361] = { unicodeslot=0x12361, category='lo', description='CUNEIFORM SIGN ZAMX' },
	[0x12362] = { unicodeslot=0x12362, category='lo', description='CUNEIFORM SIGN ZE2' },
	[0x12363] = { unicodeslot=0x12363, category='lo', description='CUNEIFORM SIGN ZI' },
	[0x12364] = { unicodeslot=0x12364, category='lo', description='CUNEIFORM SIGN ZI OVER ZI' },
	[0x12365] = { unicodeslot=0x12365, category='lo', description='CUNEIFORM SIGN ZI3' },
	[0x12366] = { unicodeslot=0x12366, category='lo', description='CUNEIFORM SIGN ZIB' },
	[0x12367] = { unicodeslot=0x12367, category='lo', description='CUNEIFORM SIGN ZIB KABA TENU' },
	[0x12368] = { unicodeslot=0x12368, category='lo', description='CUNEIFORM SIGN ZIG' },
	[0x12369] = { unicodeslot=0x12369, category='lo', description='CUNEIFORM SIGN ZIZ2' },
	[0x1236A] = { unicodeslot=0x1236A, category='lo', description='CUNEIFORM SIGN ZU' },
	[0x1236B] = { unicodeslot=0x1236B, category='lo', description='CUNEIFORM SIGN ZU5' },
	[0x1236C] = { unicodeslot=0x1236C, category='lo', description='CUNEIFORM SIGN ZU5 TIMES A' },
	[0x1236D] = { unicodeslot=0x1236D, category='lo', description='CUNEIFORM SIGN ZUBUR' },
	[0x1236E] = { unicodeslot=0x1236E, category='lo', description='CUNEIFORM SIGN ZUM' },
	[0x12400] = { unicodeslot=0x12400, category='nl', description='CUNEIFORM NUMERIC SIGN TWO ASH' },
	[0x12401] = { unicodeslot=0x12401, category='nl', description='CUNEIFORM NUMERIC SIGN THREE ASH' },
	[0x12402] = { unicodeslot=0x12402, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR ASH' },
	[0x12403] = { unicodeslot=0x12403, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE ASH' },
	[0x12404] = { unicodeslot=0x12404, category='nl', description='CUNEIFORM NUMERIC SIGN SIX ASH' },
	[0x12405] = { unicodeslot=0x12405, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN ASH' },
	[0x12406] = { unicodeslot=0x12406, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT ASH' },
	[0x12407] = { unicodeslot=0x12407, category='nl', description='CUNEIFORM NUMERIC SIGN NINE ASH' },
	[0x12408] = { unicodeslot=0x12408, category='nl', description='CUNEIFORM NUMERIC SIGN THREE DISH' },
	[0x12409] = { unicodeslot=0x12409, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR DISH' },
	[0x1240A] = { unicodeslot=0x1240A, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE DISH' },
	[0x1240B] = { unicodeslot=0x1240B, category='nl', description='CUNEIFORM NUMERIC SIGN SIX DISH' },
	[0x1240C] = { unicodeslot=0x1240C, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN DISH' },
	[0x1240D] = { unicodeslot=0x1240D, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT DISH' },
	[0x1240E] = { unicodeslot=0x1240E, category='nl', description='CUNEIFORM NUMERIC SIGN NINE DISH' },
	[0x1240F] = { unicodeslot=0x1240F, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR U' },
	[0x12410] = { unicodeslot=0x12410, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE U' },
	[0x12411] = { unicodeslot=0x12411, category='nl', description='CUNEIFORM NUMERIC SIGN SIX U' },
	[0x12412] = { unicodeslot=0x12412, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN U' },
	[0x12413] = { unicodeslot=0x12413, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT U' },
	[0x12414] = { unicodeslot=0x12414, category='nl', description='CUNEIFORM NUMERIC SIGN NINE U' },
	[0x12415] = { unicodeslot=0x12415, category='nl', description='CUNEIFORM NUMERIC SIGN ONE GESH2' },
	[0x12416] = { unicodeslot=0x12416, category='nl', description='CUNEIFORM NUMERIC SIGN TWO GESH2' },
	[0x12417] = { unicodeslot=0x12417, category='nl', description='CUNEIFORM NUMERIC SIGN THREE GESH2' },
	[0x12418] = { unicodeslot=0x12418, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR GESH2' },
	[0x12419] = { unicodeslot=0x12419, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE GESH2' },
	[0x1241A] = { unicodeslot=0x1241A, category='nl', description='CUNEIFORM NUMERIC SIGN SIX GESH2' },
	[0x1241B] = { unicodeslot=0x1241B, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN GESH2' },
	[0x1241C] = { unicodeslot=0x1241C, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT GESH2' },
	[0x1241D] = { unicodeslot=0x1241D, category='nl', description='CUNEIFORM NUMERIC SIGN NINE GESH2' },
	[0x1241E] = { unicodeslot=0x1241E, category='nl', description='CUNEIFORM NUMERIC SIGN ONE GESHU' },
	[0x1241F] = { unicodeslot=0x1241F, category='nl', description='CUNEIFORM NUMERIC SIGN TWO GESHU' },
	[0x12420] = { unicodeslot=0x12420, category='nl', description='CUNEIFORM NUMERIC SIGN THREE GESHU' },
	[0x12421] = { unicodeslot=0x12421, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR GESHU' },
	[0x12422] = { unicodeslot=0x12422, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE GESHU' },
	[0x12423] = { unicodeslot=0x12423, category='nl', description='CUNEIFORM NUMERIC SIGN TWO SHAR2' },
	[0x12424] = { unicodeslot=0x12424, category='nl', description='CUNEIFORM NUMERIC SIGN THREE SHAR2' },
	[0x12425] = { unicodeslot=0x12425, category='nl', description='CUNEIFORM NUMERIC SIGN THREE SHAR2 VARIANT FORM' },
	[0x12426] = { unicodeslot=0x12426, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR SHAR2' },
	[0x12427] = { unicodeslot=0x12427, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE SHAR2' },
	[0x12428] = { unicodeslot=0x12428, category='nl', description='CUNEIFORM NUMERIC SIGN SIX SHAR2' },
	[0x12429] = { unicodeslot=0x12429, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN SHAR2' },
	[0x1242A] = { unicodeslot=0x1242A, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT SHAR2' },
	[0x1242B] = { unicodeslot=0x1242B, category='nl', description='CUNEIFORM NUMERIC SIGN NINE SHAR2' },
	[0x1242C] = { unicodeslot=0x1242C, category='nl', description='CUNEIFORM NUMERIC SIGN ONE SHARU' },
	[0x1242D] = { unicodeslot=0x1242D, category='nl', description='CUNEIFORM NUMERIC SIGN TWO SHARU' },
	[0x1242E] = { unicodeslot=0x1242E, category='nl', description='CUNEIFORM NUMERIC SIGN THREE SHARU' },
	[0x1242F] = { unicodeslot=0x1242F, category='nl', description='CUNEIFORM NUMERIC SIGN THREE SHARU VARIANT FORM' },
	[0x12430] = { unicodeslot=0x12430, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR SHARU' },
	[0x12431] = { unicodeslot=0x12431, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE SHARU' },
	[0x12432] = { unicodeslot=0x12432, category='nl', description='CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS DISH' },
	[0x12433] = { unicodeslot=0x12433, category='nl', description='CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS MIN' },
	[0x12434] = { unicodeslot=0x12434, category='nl', description='CUNEIFORM NUMERIC SIGN ONE BURU' },
	[0x12435] = { unicodeslot=0x12435, category='nl', description='CUNEIFORM NUMERIC SIGN TWO BURU' },
	[0x12436] = { unicodeslot=0x12436, category='nl', description='CUNEIFORM NUMERIC SIGN THREE BURU' },
	[0x12437] = { unicodeslot=0x12437, category='nl', description='CUNEIFORM NUMERIC SIGN THREE BURU VARIANT FORM' },
	[0x12438] = { unicodeslot=0x12438, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR BURU' },
	[0x12439] = { unicodeslot=0x12439, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE BURU' },
	[0x1243A] = { unicodeslot=0x1243A, category='nl', description='CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH16' },
	[0x1243B] = { unicodeslot=0x1243B, category='nl', description='CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH21' },
	[0x1243C] = { unicodeslot=0x1243C, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU' },
	[0x1243D] = { unicodeslot=0x1243D, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU4' },
	[0x1243E] = { unicodeslot=0x1243E, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU A' },
	[0x1243F] = { unicodeslot=0x1243F, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU B' },
	[0x12440] = { unicodeslot=0x12440, category='nl', description='CUNEIFORM NUMERIC SIGN SIX VARIANT FORM ASH9' },
	[0x12441] = { unicodeslot=0x12441, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN3' },
	[0x12442] = { unicodeslot=0x12442, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN A' },
	[0x12443] = { unicodeslot=0x12443, category='nl', description='CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN B' },
	[0x12444] = { unicodeslot=0x12444, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU' },
	[0x12445] = { unicodeslot=0x12445, category='nl', description='CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU3' },
	[0x12446] = { unicodeslot=0x12446, category='nl', description='CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU' },
	[0x12447] = { unicodeslot=0x12447, category='nl', description='CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU3' },
	[0x12448] = { unicodeslot=0x12448, category='nl', description='CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU4' },
	[0x12449] = { unicodeslot=0x12449, category='nl', description='CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU A' },
	[0x1244A] = { unicodeslot=0x1244A, category='nl', description='CUNEIFORM NUMERIC SIGN TWO ASH TENU' },
	[0x1244B] = { unicodeslot=0x1244B, category='nl', description='CUNEIFORM NUMERIC SIGN THREE ASH TENU' },
	[0x1244C] = { unicodeslot=0x1244C, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR ASH TENU' },
	[0x1244D] = { unicodeslot=0x1244D, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE ASH TENU' },
	[0x1244E] = { unicodeslot=0x1244E, category='nl', description='CUNEIFORM NUMERIC SIGN SIX ASH TENU' },
	[0x1244F] = { unicodeslot=0x1244F, category='nl', description='CUNEIFORM NUMERIC SIGN ONE BAN2' },
	[0x12450] = { unicodeslot=0x12450, category='nl', description='CUNEIFORM NUMERIC SIGN TWO BAN2' },
	[0x12451] = { unicodeslot=0x12451, category='nl', description='CUNEIFORM NUMERIC SIGN THREE BAN2' },
	[0x12452] = { unicodeslot=0x12452, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR BAN2' },
	[0x12453] = { unicodeslot=0x12453, category='nl', description='CUNEIFORM NUMERIC SIGN FOUR BAN2 VARIANT FORM' },
	[0x12454] = { unicodeslot=0x12454, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE BAN2' },
	[0x12455] = { unicodeslot=0x12455, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE BAN2 VARIANT FORM' },
	[0x12456] = { unicodeslot=0x12456, category='nl', description='CUNEIFORM NUMERIC SIGN NIGIDAMIN' },
	[0x12457] = { unicodeslot=0x12457, category='nl', description='CUNEIFORM NUMERIC SIGN NIGIDAESH' },
	[0x12458] = { unicodeslot=0x12458, category='nl', description='CUNEIFORM NUMERIC SIGN ONE ESHE3' },
	[0x12459] = { unicodeslot=0x12459, category='nl', description='CUNEIFORM NUMERIC SIGN TWO ESHE3' },
	[0x1245A] = { unicodeslot=0x1245A, category='nl', description='CUNEIFORM NUMERIC SIGN ONE THIRD DISH' },
	[0x1245B] = { unicodeslot=0x1245B, category='nl', description='CUNEIFORM NUMERIC SIGN TWO THIRDS DISH' },
	[0x1245C] = { unicodeslot=0x1245C, category='nl', description='CUNEIFORM NUMERIC SIGN FIVE SIXTHS DISH' },
	[0x1245D] = { unicodeslot=0x1245D, category='nl', description='CUNEIFORM NUMERIC SIGN ONE THIRD VARIANT FORM A' },
	[0x1245E] = { unicodeslot=0x1245E, category='nl', description='CUNEIFORM NUMERIC SIGN TWO THIRDS VARIANT FORM A' },
	[0x1245F] = { unicodeslot=0x1245F, category='nl', description='CUNEIFORM NUMERIC SIGN ONE EIGHTH ASH' },
	[0x12460] = { unicodeslot=0x12460, category='nl', description='CUNEIFORM NUMERIC SIGN ONE QUARTER ASH' },
	[0x12461] = { unicodeslot=0x12461, category='nl', description='CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE SIXTH' },
	[0x12462] = { unicodeslot=0x12462, category='nl', description='CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE QUARTER' },
	[0x12470] = { unicodeslot=0x12470, category='po', description='CUNEIFORM PUNCTUATION SIGN OLD ASSYRIAN WORD DIVIDER' },
	[0x12471] = { unicodeslot=0x12471, category='po', description='CUNEIFORM PUNCTUATION SIGN VERTICAL COLON' },
	[0x12472] = { unicodeslot=0x12472, category='po', description='CUNEIFORM PUNCTUATION SIGN DIAGONAL COLON' },
	[0x12473] = { unicodeslot=0x12473, category='po', description='CUNEIFORM PUNCTUATION SIGN DIAGONAL TRICOLON' },
	[0x1D000] = { unicodeslot=0x1D000, category='so', description='BYZANTINE MUSICAL SYMBOL PSILI' },
	[0x1D001] = { unicodeslot=0x1D001, category='so', description='BYZANTINE MUSICAL SYMBOL DASEIA' },
	[0x1D002] = { unicodeslot=0x1D002, category='so', description='BYZANTINE MUSICAL SYMBOL PERISPOMENI' },
	[0x1D003] = { unicodeslot=0x1D003, category='so', description='BYZANTINE MUSICAL SYMBOL OXEIA EKFONITIKON' },
	[0x1D004] = { unicodeslot=0x1D004, category='so', description='BYZANTINE MUSICAL SYMBOL OXEIA DIPLI' },
	[0x1D005] = { unicodeslot=0x1D005, category='so', description='BYZANTINE MUSICAL SYMBOL VAREIA EKFONITIKON' },
	[0x1D006] = { unicodeslot=0x1D006, category='so', description='BYZANTINE MUSICAL SYMBOL VAREIA DIPLI' },
	[0x1D007] = { unicodeslot=0x1D007, category='so', description='BYZANTINE MUSICAL SYMBOL KATHISTI' },
	[0x1D008] = { unicodeslot=0x1D008, category='so', description='BYZANTINE MUSICAL SYMBOL SYRMATIKI' },
	[0x1D009] = { unicodeslot=0x1D009, category='so', description='BYZANTINE MUSICAL SYMBOL PARAKLITIKI' },
	[0x1D00A] = { unicodeslot=0x1D00A, category='so', description='BYZANTINE MUSICAL SYMBOL YPOKRISIS' },
	[0x1D00B] = { unicodeslot=0x1D00B, category='so', description='BYZANTINE MUSICAL SYMBOL YPOKRISIS DIPLI' },
	[0x1D00C] = { unicodeslot=0x1D00C, category='so', description='BYZANTINE MUSICAL SYMBOL KREMASTI' },
	[0x1D00D] = { unicodeslot=0x1D00D, category='so', description='BYZANTINE MUSICAL SYMBOL APESO EKFONITIKON' },
	[0x1D00E] = { unicodeslot=0x1D00E, category='so', description='BYZANTINE MUSICAL SYMBOL EXO EKFONITIKON' },
	[0x1D00F] = { unicodeslot=0x1D00F, category='so', description='BYZANTINE MUSICAL SYMBOL TELEIA' },
	[0x1D010] = { unicodeslot=0x1D010, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMATA' },
	[0x1D011] = { unicodeslot=0x1D011, category='so', description='BYZANTINE MUSICAL SYMBOL APOSTROFOS' },
	[0x1D012] = { unicodeslot=0x1D012, category='so', description='BYZANTINE MUSICAL SYMBOL APOSTROFOS DIPLI' },
	[0x1D013] = { unicodeslot=0x1D013, category='so', description='BYZANTINE MUSICAL SYMBOL SYNEVMA' },
	[0x1D014] = { unicodeslot=0x1D014, category='so', description='BYZANTINE MUSICAL SYMBOL THITA' },
	[0x1D015] = { unicodeslot=0x1D015, category='so', description='BYZANTINE MUSICAL SYMBOL OLIGON ARCHAION' },
	[0x1D016] = { unicodeslot=0x1D016, category='so', description='BYZANTINE MUSICAL SYMBOL GORGON ARCHAION' },
	[0x1D017] = { unicodeslot=0x1D017, category='so', description='BYZANTINE MUSICAL SYMBOL PSILON' },
	[0x1D018] = { unicodeslot=0x1D018, category='so', description='BYZANTINE MUSICAL SYMBOL CHAMILON' },
	[0x1D019] = { unicodeslot=0x1D019, category='so', description='BYZANTINE MUSICAL SYMBOL VATHY' },
	[0x1D01A] = { unicodeslot=0x1D01A, category='so', description='BYZANTINE MUSICAL SYMBOL ISON ARCHAION' },
	[0x1D01B] = { unicodeslot=0x1D01B, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMA ARCHAION' },
	[0x1D01C] = { unicodeslot=0x1D01C, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMATA ARCHAION' },
	[0x1D01D] = { unicodeslot=0x1D01D, category='so', description='BYZANTINE MUSICAL SYMBOL SAXIMATA' },
	[0x1D01E] = { unicodeslot=0x1D01E, category='so', description='BYZANTINE MUSICAL SYMBOL PARICHON' },
	[0x1D01F] = { unicodeslot=0x1D01F, category='so', description='BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA' },
	[0x1D020] = { unicodeslot=0x1D020, category='so', description='BYZANTINE MUSICAL SYMBOL OXEIAI ARCHAION' },
	[0x1D021] = { unicodeslot=0x1D021, category='so', description='BYZANTINE MUSICAL SYMBOL VAREIAI ARCHAION' },
	[0x1D022] = { unicodeslot=0x1D022, category='so', description='BYZANTINE MUSICAL SYMBOL APODERMA ARCHAION' },
	[0x1D023] = { unicodeslot=0x1D023, category='so', description='BYZANTINE MUSICAL SYMBOL APOTHEMA' },
	[0x1D024] = { unicodeslot=0x1D024, category='so', description='BYZANTINE MUSICAL SYMBOL KLASMA' },
	[0x1D025] = { unicodeslot=0x1D025, category='so', description='BYZANTINE MUSICAL SYMBOL REVMA' },
	[0x1D026] = { unicodeslot=0x1D026, category='so', description='BYZANTINE MUSICAL SYMBOL PIASMA ARCHAION' },
	[0x1D027] = { unicodeslot=0x1D027, category='so', description='BYZANTINE MUSICAL SYMBOL TINAGMA' },
	[0x1D028] = { unicodeslot=0x1D028, category='so', description='BYZANTINE MUSICAL SYMBOL ANATRICHISMA' },
	[0x1D029] = { unicodeslot=0x1D029, category='so', description='BYZANTINE MUSICAL SYMBOL SEISMA' },
	[0x1D02A] = { unicodeslot=0x1D02A, category='so', description='BYZANTINE MUSICAL SYMBOL SYNAGMA ARCHAION' },
	[0x1D02B] = { unicodeslot=0x1D02B, category='so', description='BYZANTINE MUSICAL SYMBOL SYNAGMA META STAVROU' },
	[0x1D02C] = { unicodeslot=0x1D02C, category='so', description='BYZANTINE MUSICAL SYMBOL OYRANISMA ARCHAION' },
	[0x1D02D] = { unicodeslot=0x1D02D, category='so', description='BYZANTINE MUSICAL SYMBOL THEMA' },
	[0x1D02E] = { unicodeslot=0x1D02E, category='so', description='BYZANTINE MUSICAL SYMBOL LEMOI' },
	[0x1D02F] = { unicodeslot=0x1D02F, category='so', description='BYZANTINE MUSICAL SYMBOL DYO' },
	[0x1D030] = { unicodeslot=0x1D030, category='so', description='BYZANTINE MUSICAL SYMBOL TRIA' },
	[0x1D031] = { unicodeslot=0x1D031, category='so', description='BYZANTINE MUSICAL SYMBOL TESSERA' },
	[0x1D032] = { unicodeslot=0x1D032, category='so', description='BYZANTINE MUSICAL SYMBOL KRATIMATA' },
	[0x1D033] = { unicodeslot=0x1D033, category='so', description='BYZANTINE MUSICAL SYMBOL APESO EXO NEO' },
	[0x1D034] = { unicodeslot=0x1D034, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION' },
	[0x1D035] = { unicodeslot=0x1D035, category='so', description='BYZANTINE MUSICAL SYMBOL IMIFTHORA' },
	[0x1D036] = { unicodeslot=0x1D036, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKON ARCHAION' },
	[0x1D037] = { unicodeslot=0x1D037, category='so', description='BYZANTINE MUSICAL SYMBOL KATAVA TROMIKON' },
	[0x1D038] = { unicodeslot=0x1D038, category='so', description='BYZANTINE MUSICAL SYMBOL PELASTON' },
	[0x1D039] = { unicodeslot=0x1D039, category='so', description='BYZANTINE MUSICAL SYMBOL PSIFISTON' },
	[0x1D03A] = { unicodeslot=0x1D03A, category='so', description='BYZANTINE MUSICAL SYMBOL KONTEVMA' },
	[0x1D03B] = { unicodeslot=0x1D03B, category='so', description='BYZANTINE MUSICAL SYMBOL CHOREVMA ARCHAION' },
	[0x1D03C] = { unicodeslot=0x1D03C, category='so', description='BYZANTINE MUSICAL SYMBOL RAPISMA' },
	[0x1D03D] = { unicodeslot=0x1D03D, category='so', description='BYZANTINE MUSICAL SYMBOL PARAKALESMA ARCHAION' },
	[0x1D03E] = { unicodeslot=0x1D03E, category='so', description='BYZANTINE MUSICAL SYMBOL PARAKLITIKI ARCHAION' },
	[0x1D03F] = { unicodeslot=0x1D03F, category='so', description='BYZANTINE MUSICAL SYMBOL ICHADIN' },
	[0x1D040] = { unicodeslot=0x1D040, category='so', description='BYZANTINE MUSICAL SYMBOL NANA' },
	[0x1D041] = { unicodeslot=0x1D041, category='so', description='BYZANTINE MUSICAL SYMBOL PETASMA' },
	[0x1D042] = { unicodeslot=0x1D042, category='so', description='BYZANTINE MUSICAL SYMBOL KONTEVMA ALLO' },
	[0x1D043] = { unicodeslot=0x1D043, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKON ALLO' },
	[0x1D044] = { unicodeslot=0x1D044, category='so', description='BYZANTINE MUSICAL SYMBOL STRAGGISMATA' },
	[0x1D045] = { unicodeslot=0x1D045, category='so', description='BYZANTINE MUSICAL SYMBOL GRONTHISMATA' },
	[0x1D046] = { unicodeslot=0x1D046, category='so', description='BYZANTINE MUSICAL SYMBOL ISON NEO' },
	[0x1D047] = { unicodeslot=0x1D047, category='so', description='BYZANTINE MUSICAL SYMBOL OLIGON NEO' },
	[0x1D048] = { unicodeslot=0x1D048, category='so', description='BYZANTINE MUSICAL SYMBOL OXEIA NEO' },
	[0x1D049] = { unicodeslot=0x1D049, category='so', description='BYZANTINE MUSICAL SYMBOL PETASTI' },
	[0x1D04A] = { unicodeslot=0x1D04A, category='so', description='BYZANTINE MUSICAL SYMBOL KOUFISMA' },
	[0x1D04B] = { unicodeslot=0x1D04B, category='so', description='BYZANTINE MUSICAL SYMBOL PETASTOKOUFISMA' },
	[0x1D04C] = { unicodeslot=0x1D04C, category='so', description='BYZANTINE MUSICAL SYMBOL KRATIMOKOUFISMA' },
	[0x1D04D] = { unicodeslot=0x1D04D, category='so', description='BYZANTINE MUSICAL SYMBOL PELASTON NEO' },
	[0x1D04E] = { unicodeslot=0x1D04E, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMATA NEO ANO' },
	[0x1D04F] = { unicodeslot=0x1D04F, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMA NEO ANO' },
	[0x1D050] = { unicodeslot=0x1D050, category='so', description='BYZANTINE MUSICAL SYMBOL YPSILI' },
	[0x1D051] = { unicodeslot=0x1D051, category='so', description='BYZANTINE MUSICAL SYMBOL APOSTROFOS NEO' },
	[0x1D052] = { unicodeslot=0x1D052, category='so', description='BYZANTINE MUSICAL SYMBOL APOSTROFOI SYNDESMOS NEO' },
	[0x1D053] = { unicodeslot=0x1D053, category='so', description='BYZANTINE MUSICAL SYMBOL YPORROI' },
	[0x1D054] = { unicodeslot=0x1D054, category='so', description='BYZANTINE MUSICAL SYMBOL KRATIMOYPORROON' },
	[0x1D055] = { unicodeslot=0x1D055, category='so', description='BYZANTINE MUSICAL SYMBOL ELAFRON' },
	[0x1D056] = { unicodeslot=0x1D056, category='so', description='BYZANTINE MUSICAL SYMBOL CHAMILI' },
	[0x1D057] = { unicodeslot=0x1D057, category='so', description='BYZANTINE MUSICAL SYMBOL MIKRON ISON' },
	[0x1D058] = { unicodeslot=0x1D058, category='so', description='BYZANTINE MUSICAL SYMBOL VAREIA NEO' },
	[0x1D059] = { unicodeslot=0x1D059, category='so', description='BYZANTINE MUSICAL SYMBOL PIASMA NEO' },
	[0x1D05A] = { unicodeslot=0x1D05A, category='so', description='BYZANTINE MUSICAL SYMBOL PSIFISTON NEO' },
	[0x1D05B] = { unicodeslot=0x1D05B, category='so', description='BYZANTINE MUSICAL SYMBOL OMALON' },
	[0x1D05C] = { unicodeslot=0x1D05C, category='so', description='BYZANTINE MUSICAL SYMBOL ANTIKENOMA' },
	[0x1D05D] = { unicodeslot=0x1D05D, category='so', description='BYZANTINE MUSICAL SYMBOL LYGISMA' },
	[0x1D05E] = { unicodeslot=0x1D05E, category='so', description='BYZANTINE MUSICAL SYMBOL PARAKLITIKI NEO' },
	[0x1D05F] = { unicodeslot=0x1D05F, category='so', description='BYZANTINE MUSICAL SYMBOL PARAKALESMA NEO' },
	[0x1D060] = { unicodeslot=0x1D060, category='so', description='BYZANTINE MUSICAL SYMBOL ETERON PARAKALESMA' },
	[0x1D061] = { unicodeslot=0x1D061, category='so', description='BYZANTINE MUSICAL SYMBOL KYLISMA' },
	[0x1D062] = { unicodeslot=0x1D062, category='so', description='BYZANTINE MUSICAL SYMBOL ANTIKENOKYLISMA' },
	[0x1D063] = { unicodeslot=0x1D063, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKON NEO' },
	[0x1D064] = { unicodeslot=0x1D064, category='so', description='BYZANTINE MUSICAL SYMBOL EKSTREPTON' },
	[0x1D065] = { unicodeslot=0x1D065, category='so', description='BYZANTINE MUSICAL SYMBOL SYNAGMA NEO' },
	[0x1D066] = { unicodeslot=0x1D066, category='so', description='BYZANTINE MUSICAL SYMBOL SYRMA' },
	[0x1D067] = { unicodeslot=0x1D067, category='so', description='BYZANTINE MUSICAL SYMBOL CHOREVMA NEO' },
	[0x1D068] = { unicodeslot=0x1D068, category='so', description='BYZANTINE MUSICAL SYMBOL EPEGERMA' },
	[0x1D069] = { unicodeslot=0x1D069, category='so', description='BYZANTINE MUSICAL SYMBOL SEISMA NEO' },
	[0x1D06A] = { unicodeslot=0x1D06A, category='so', description='BYZANTINE MUSICAL SYMBOL XIRON KLASMA' },
	[0x1D06B] = { unicodeslot=0x1D06B, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKOPSIFISTON' },
	[0x1D06C] = { unicodeslot=0x1D06C, category='so', description='BYZANTINE MUSICAL SYMBOL PSIFISTOLYGISMA' },
	[0x1D06D] = { unicodeslot=0x1D06D, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKOLYGISMA' },
	[0x1D06E] = { unicodeslot=0x1D06E, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA' },
	[0x1D06F] = { unicodeslot=0x1D06F, category='so', description='BYZANTINE MUSICAL SYMBOL PSIFISTOPARAKALESMA' },
	[0x1D070] = { unicodeslot=0x1D070, category='so', description='BYZANTINE MUSICAL SYMBOL TROMIKOSYNAGMA' },
	[0x1D071] = { unicodeslot=0x1D071, category='so', description='BYZANTINE MUSICAL SYMBOL PSIFISTOSYNAGMA' },
	[0x1D072] = { unicodeslot=0x1D072, category='so', description='BYZANTINE MUSICAL SYMBOL GORGOSYNTHETON' },
	[0x1D073] = { unicodeslot=0x1D073, category='so', description='BYZANTINE MUSICAL SYMBOL ARGOSYNTHETON' },
	[0x1D074] = { unicodeslot=0x1D074, category='so', description='BYZANTINE MUSICAL SYMBOL ETERON ARGOSYNTHETON' },
	[0x1D075] = { unicodeslot=0x1D075, category='so', description='BYZANTINE MUSICAL SYMBOL OYRANISMA NEO' },
	[0x1D076] = { unicodeslot=0x1D076, category='so', description='BYZANTINE MUSICAL SYMBOL THEMATISMOS ESO' },
	[0x1D077] = { unicodeslot=0x1D077, category='so', description='BYZANTINE MUSICAL SYMBOL THEMATISMOS EXO' },
	[0x1D078] = { unicodeslot=0x1D078, category='so', description='BYZANTINE MUSICAL SYMBOL THEMA APLOUN' },
	[0x1D079] = { unicodeslot=0x1D079, category='so', description='BYZANTINE MUSICAL SYMBOL THES KAI APOTHES' },
	[0x1D07A] = { unicodeslot=0x1D07A, category='so', description='BYZANTINE MUSICAL SYMBOL KATAVASMA' },
	[0x1D07B] = { unicodeslot=0x1D07B, category='so', description='BYZANTINE MUSICAL SYMBOL ENDOFONON' },
	[0x1D07C] = { unicodeslot=0x1D07C, category='so', description='BYZANTINE MUSICAL SYMBOL YFEN KATO' },
	[0x1D07D] = { unicodeslot=0x1D07D, category='so', description='BYZANTINE MUSICAL SYMBOL YFEN ANO' },
	[0x1D07E] = { unicodeslot=0x1D07E, category='so', description='BYZANTINE MUSICAL SYMBOL STAVROS' },
	[0x1D07F] = { unicodeslot=0x1D07F, category='so', description='BYZANTINE MUSICAL SYMBOL KLASMA ANO' },
	[0x1D080] = { unicodeslot=0x1D080, category='so', description='BYZANTINE MUSICAL SYMBOL DIPLI ARCHAION' },
	[0x1D081] = { unicodeslot=0x1D081, category='so', description='BYZANTINE MUSICAL SYMBOL KRATIMA ARCHAION' },
	[0x1D082] = { unicodeslot=0x1D082, category='so', description='BYZANTINE MUSICAL SYMBOL KRATIMA ALLO' },
	[0x1D083] = { unicodeslot=0x1D083, category='so', description='BYZANTINE MUSICAL SYMBOL KRATIMA NEO' },
	[0x1D084] = { unicodeslot=0x1D084, category='so', description='BYZANTINE MUSICAL SYMBOL APODERMA NEO' },
	[0x1D085] = { unicodeslot=0x1D085, category='so', description='BYZANTINE MUSICAL SYMBOL APLI' },
	[0x1D086] = { unicodeslot=0x1D086, category='so', description='BYZANTINE MUSICAL SYMBOL DIPLI' },
	[0x1D087] = { unicodeslot=0x1D087, category='so', description='BYZANTINE MUSICAL SYMBOL TRIPLI' },
	[0x1D088] = { unicodeslot=0x1D088, category='so', description='BYZANTINE MUSICAL SYMBOL TETRAPLI' },
	[0x1D089] = { unicodeslot=0x1D089, category='so', description='BYZANTINE MUSICAL SYMBOL KORONIS' },
	[0x1D08A] = { unicodeslot=0x1D08A, category='so', description='BYZANTINE MUSICAL SYMBOL LEIMMA ENOS CHRONOU' },
	[0x1D08B] = { unicodeslot=0x1D08B, category='so', description='BYZANTINE MUSICAL SYMBOL LEIMMA DYO CHRONON' },
	[0x1D08C] = { unicodeslot=0x1D08C, category='so', description='BYZANTINE MUSICAL SYMBOL LEIMMA TRION CHRONON' },
	[0x1D08D] = { unicodeslot=0x1D08D, category='so', description='BYZANTINE MUSICAL SYMBOL LEIMMA TESSARON CHRONON' },
	[0x1D08E] = { unicodeslot=0x1D08E, category='so', description='BYZANTINE MUSICAL SYMBOL LEIMMA IMISEOS CHRONOU' },
	[0x1D08F] = { unicodeslot=0x1D08F, category='so', description='BYZANTINE MUSICAL SYMBOL GORGON NEO ANO' },
	[0x1D090] = { unicodeslot=0x1D090, category='so', description='BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON ARISTERA' },
	[0x1D091] = { unicodeslot=0x1D091, category='so', description='BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON DEXIA' },
	[0x1D092] = { unicodeslot=0x1D092, category='so', description='BYZANTINE MUSICAL SYMBOL DIGORGON' },
	[0x1D093] = { unicodeslot=0x1D093, category='so', description='BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA KATO' },
	[0x1D094] = { unicodeslot=0x1D094, category='so', description='BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO' },
	[0x1D095] = { unicodeslot=0x1D095, category='so', description='BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON DEXIA' },
	[0x1D096] = { unicodeslot=0x1D096, category='so', description='BYZANTINE MUSICAL SYMBOL TRIGORGON' },
	[0x1D097] = { unicodeslot=0x1D097, category='so', description='BYZANTINE MUSICAL SYMBOL ARGON' },
	[0x1D098] = { unicodeslot=0x1D098, category='so', description='BYZANTINE MUSICAL SYMBOL IMIDIARGON' },
	[0x1D099] = { unicodeslot=0x1D099, category='so', description='BYZANTINE MUSICAL SYMBOL DIARGON' },
	[0x1D09A] = { unicodeslot=0x1D09A, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI POLI ARGI' },
	[0x1D09B] = { unicodeslot=0x1D09B, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI ARGOTERI' },
	[0x1D09C] = { unicodeslot=0x1D09C, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI ARGI' },
	[0x1D09D] = { unicodeslot=0x1D09D, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI METRIA' },
	[0x1D09E] = { unicodeslot=0x1D09E, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI MESI' },
	[0x1D09F] = { unicodeslot=0x1D09F, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI GORGI' },
	[0x1D0A0] = { unicodeslot=0x1D0A0, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI GORGOTERI' },
	[0x1D0A1] = { unicodeslot=0x1D0A1, category='so', description='BYZANTINE MUSICAL SYMBOL AGOGI POLI GORGI' },
	[0x1D0A2] = { unicodeslot=0x1D0A2, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOS ICHOS' },
	[0x1D0A3] = { unicodeslot=0x1D0A3, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI PROTOS ICHOS' },
	[0x1D0A4] = { unicodeslot=0x1D0A4, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA DEYTEROS ICHOS' },
	[0x1D0A5] = { unicodeslot=0x1D0A5, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI DEYTEROS ICHOS' },
	[0x1D0A6] = { unicodeslot=0x1D0A6, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA TRITOS ICHOS' },
	[0x1D0A7] = { unicodeslot=0x1D0A7, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA TRIFONIAS' },
	[0x1D0A8] = { unicodeslot=0x1D0A8, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS ICHOS' },
	[0x1D0A9] = { unicodeslot=0x1D0A9, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS LEGETOS ICHOS' },
	[0x1D0AA] = { unicodeslot=0x1D0AA, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA LEGETOS ICHOS' },
	[0x1D0AB] = { unicodeslot=0x1D0AB, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS ICHOS' },
	[0x1D0AC] = { unicodeslot=0x1D0AC, category='so', description='BYZANTINE MUSICAL SYMBOL ISAKIA TELOUS ICHIMATOS' },
	[0x1D0AD] = { unicodeslot=0x1D0AD, category='so', description='BYZANTINE MUSICAL SYMBOL APOSTROFOI TELOUS ICHIMATOS' },
	[0x1D0AE] = { unicodeslot=0x1D0AE, category='so', description='BYZANTINE MUSICAL SYMBOL FANEROSIS TETRAFONIAS' },
	[0x1D0AF] = { unicodeslot=0x1D0AF, category='so', description='BYZANTINE MUSICAL SYMBOL FANEROSIS MONOFONIAS' },
	[0x1D0B0] = { unicodeslot=0x1D0B0, category='so', description='BYZANTINE MUSICAL SYMBOL FANEROSIS DIFONIAS' },
	[0x1D0B1] = { unicodeslot=0x1D0B1, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA VARYS ICHOS' },
	[0x1D0B2] = { unicodeslot=0x1D0B2, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOVARYS ICHOS' },
	[0x1D0B3] = { unicodeslot=0x1D0B3, category='so', description='BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS TETARTOS ICHOS' },
	[0x1D0B4] = { unicodeslot=0x1D0B4, category='so', description='BYZANTINE MUSICAL SYMBOL GORTHMIKON N APLOUN' },
	[0x1D0B5] = { unicodeslot=0x1D0B5, category='so', description='BYZANTINE MUSICAL SYMBOL GORTHMIKON N DIPLOUN' },
	[0x1D0B6] = { unicodeslot=0x1D0B6, category='so', description='BYZANTINE MUSICAL SYMBOL ENARXIS KAI FTHORA VOU' },
	[0x1D0B7] = { unicodeslot=0x1D0B7, category='so', description='BYZANTINE MUSICAL SYMBOL IMIFONON' },
	[0x1D0B8] = { unicodeslot=0x1D0B8, category='so', description='BYZANTINE MUSICAL SYMBOL IMIFTHORON' },
	[0x1D0B9] = { unicodeslot=0x1D0B9, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION DEYTEROU ICHOU' },
	[0x1D0BA] = { unicodeslot=0x1D0BA, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI PA' },
	[0x1D0BB] = { unicodeslot=0x1D0BB, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NANA' },
	[0x1D0BC] = { unicodeslot=0x1D0BC, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS' },
	[0x1D0BD] = { unicodeslot=0x1D0BD, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI DI' },
	[0x1D0BE] = { unicodeslot=0x1D0BE, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON DIATONON DI' },
	[0x1D0BF] = { unicodeslot=0x1D0BF, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI KE' },
	[0x1D0C0] = { unicodeslot=0x1D0C0, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI ZO' },
	[0x1D0C1] = { unicodeslot=0x1D0C1, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI KATO' },
	[0x1D0C2] = { unicodeslot=0x1D0C2, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI ANO' },
	[0x1D0C3] = { unicodeslot=0x1D0C3, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA DIFONIAS' },
	[0x1D0C4] = { unicodeslot=0x1D0C4, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA MONOFONIAS' },
	[0x1D0C5] = { unicodeslot=0x1D0C5, category='so', description='BYZANTINE MUSICAL SYMBOL FHTORA SKLIRON CHROMA VASIS' },
	[0x1D0C6] = { unicodeslot=0x1D0C6, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON CHROMA SYNAFI' },
	[0x1D0C7] = { unicodeslot=0x1D0C7, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA NENANO' },
	[0x1D0C8] = { unicodeslot=0x1D0C8, category='so', description='BYZANTINE MUSICAL SYMBOL CHROA ZYGOS' },
	[0x1D0C9] = { unicodeslot=0x1D0C9, category='so', description='BYZANTINE MUSICAL SYMBOL CHROA KLITON' },
	[0x1D0CA] = { unicodeslot=0x1D0CA, category='so', description='BYZANTINE MUSICAL SYMBOL CHROA SPATHI' },
	[0x1D0CB] = { unicodeslot=0x1D0CB, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA I YFESIS TETARTIMORION' },
	[0x1D0CC] = { unicodeslot=0x1D0CC, category='so', description='BYZANTINE MUSICAL SYMBOL FTHORA ENARMONIOS ANTIFONIA' },
	[0x1D0CD] = { unicodeslot=0x1D0CD, category='so', description='BYZANTINE MUSICAL SYMBOL YFESIS TRITIMORION' },
	[0x1D0CE] = { unicodeslot=0x1D0CE, category='so', description='BYZANTINE MUSICAL SYMBOL DIESIS TRITIMORION' },
	[0x1D0CF] = { unicodeslot=0x1D0CF, category='so', description='BYZANTINE MUSICAL SYMBOL DIESIS TETARTIMORION' },
	[0x1D0D0] = { unicodeslot=0x1D0D0, category='so', description='BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA' },
	[0x1D0D1] = { unicodeslot=0x1D0D1, category='so', description='BYZANTINE MUSICAL SYMBOL DIESIS MONOGRAMMOS TESSERA DODEKATA' },
	[0x1D0D2] = { unicodeslot=0x1D0D2, category='so', description='BYZANTINE MUSICAL SYMBOL DIESIS DIGRAMMOS EX DODEKATA' },
	[0x1D0D3] = { unicodeslot=0x1D0D3, category='so', description='BYZANTINE MUSICAL SYMBOL DIESIS TRIGRAMMOS OKTO DODEKATA' },
	[0x1D0D4] = { unicodeslot=0x1D0D4, category='so', description='BYZANTINE MUSICAL SYMBOL YFESIS APLI DYO DODEKATA' },
	[0x1D0D5] = { unicodeslot=0x1D0D5, category='so', description='BYZANTINE MUSICAL SYMBOL YFESIS MONOGRAMMOS TESSERA DODEKATA' },
	[0x1D0D6] = { unicodeslot=0x1D0D6, category='so', description='BYZANTINE MUSICAL SYMBOL YFESIS DIGRAMMOS EX DODEKATA' },
	[0x1D0D7] = { unicodeslot=0x1D0D7, category='so', description='BYZANTINE MUSICAL SYMBOL YFESIS TRIGRAMMOS OKTO DODEKATA' },
	[0x1D0D8] = { unicodeslot=0x1D0D8, category='so', description='BYZANTINE MUSICAL SYMBOL GENIKI DIESIS' },
	[0x1D0D9] = { unicodeslot=0x1D0D9, category='so', description='BYZANTINE MUSICAL SYMBOL GENIKI YFESIS' },
	[0x1D0DA] = { unicodeslot=0x1D0DA, category='so', description='BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI' },
	[0x1D0DB] = { unicodeslot=0x1D0DB, category='so', description='BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MEGALI' },
	[0x1D0DC] = { unicodeslot=0x1D0DC, category='so', description='BYZANTINE MUSICAL SYMBOL DIASTOLI DIPLI' },
	[0x1D0DD] = { unicodeslot=0x1D0DD, category='so', description='BYZANTINE MUSICAL SYMBOL DIASTOLI THESEOS' },
	[0x1D0DE] = { unicodeslot=0x1D0DE, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS' },
	[0x1D0DF] = { unicodeslot=0x1D0DF, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS DISIMOU' },
	[0x1D0E0] = { unicodeslot=0x1D0E0, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TRISIMOU' },
	[0x1D0E1] = { unicodeslot=0x1D0E1, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TETRASIMOU' },
	[0x1D0E2] = { unicodeslot=0x1D0E2, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS' },
	[0x1D0E3] = { unicodeslot=0x1D0E3, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS DISIMOU' },
	[0x1D0E4] = { unicodeslot=0x1D0E4, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TRISIMOU' },
	[0x1D0E5] = { unicodeslot=0x1D0E5, category='so', description='BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TETRASIMOU' },
	[0x1D0E6] = { unicodeslot=0x1D0E6, category='so', description='BYZANTINE MUSICAL SYMBOL DIGRAMMA GG' },
	[0x1D0E7] = { unicodeslot=0x1D0E7, category='so', description='BYZANTINE MUSICAL SYMBOL DIFTOGGOS OU' },
	[0x1D0E8] = { unicodeslot=0x1D0E8, category='so', description='BYZANTINE MUSICAL SYMBOL STIGMA' },
	[0x1D0E9] = { unicodeslot=0x1D0E9, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO PA' },
	[0x1D0EA] = { unicodeslot=0x1D0EA, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO VOU' },
	[0x1D0EB] = { unicodeslot=0x1D0EB, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO GA' },
	[0x1D0EC] = { unicodeslot=0x1D0EC, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO DI' },
	[0x1D0ED] = { unicodeslot=0x1D0ED, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO KE' },
	[0x1D0EE] = { unicodeslot=0x1D0EE, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO ZO' },
	[0x1D0EF] = { unicodeslot=0x1D0EF, category='so', description='BYZANTINE MUSICAL SYMBOL ARKTIKO NI' },
	[0x1D0F0] = { unicodeslot=0x1D0F0, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMATA NEO MESO' },
	[0x1D0F1] = { unicodeslot=0x1D0F1, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMA NEO MESO' },
	[0x1D0F2] = { unicodeslot=0x1D0F2, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMATA NEO KATO' },
	[0x1D0F3] = { unicodeslot=0x1D0F3, category='so', description='BYZANTINE MUSICAL SYMBOL KENTIMA NEO KATO' },
	[0x1D0F4] = { unicodeslot=0x1D0F4, category='so', description='BYZANTINE MUSICAL SYMBOL KLASMA KATO' },
	[0x1D0F5] = { unicodeslot=0x1D0F5, category='so', description='BYZANTINE MUSICAL SYMBOL GORGON NEO KATO' },
	[0x1D100] = { unicodeslot=0x1D100, category='so', description='MUSICAL SYMBOL SINGLE BARLINE' },
	[0x1D101] = { unicodeslot=0x1D101, category='so', description='MUSICAL SYMBOL DOUBLE BARLINE' },
	[0x1D102] = { unicodeslot=0x1D102, category='so', description='MUSICAL SYMBOL FINAL BARLINE' },
	[0x1D103] = { unicodeslot=0x1D103, category='so', description='MUSICAL SYMBOL REVERSE FINAL BARLINE' },
	[0x1D104] = { unicodeslot=0x1D104, category='so', description='MUSICAL SYMBOL DASHED BARLINE' },
	[0x1D105] = { unicodeslot=0x1D105, category='so', description='MUSICAL SYMBOL SHORT BARLINE' },
	[0x1D106] = { unicodeslot=0x1D106, category='so', description='MUSICAL SYMBOL LEFT REPEAT SIGN' },
	[0x1D107] = { unicodeslot=0x1D107, category='so', description='MUSICAL SYMBOL RIGHT REPEAT SIGN' },
	[0x1D108] = { unicodeslot=0x1D108, category='so', description='MUSICAL SYMBOL REPEAT DOTS' },
	[0x1D109] = { unicodeslot=0x1D109, category='so', description='MUSICAL SYMBOL DAL SEGNO' },
	[0x1D10A] = { unicodeslot=0x1D10A, category='so', description='MUSICAL SYMBOL DA CAPO' },
	[0x1D10B] = { unicodeslot=0x1D10B, category='so', description='MUSICAL SYMBOL SEGNO' },
	[0x1D10C] = { unicodeslot=0x1D10C, category='so', description='MUSICAL SYMBOL CODA' },
	[0x1D10D] = { unicodeslot=0x1D10D, category='so', description='MUSICAL SYMBOL REPEATED FIGURE-1' },
	[0x1D10E] = { unicodeslot=0x1D10E, category='so', description='MUSICAL SYMBOL REPEATED FIGURE-2' },
	[0x1D10F] = { unicodeslot=0x1D10F, category='so', description='MUSICAL SYMBOL REPEATED FIGURE-3' },
	[0x1D110] = { unicodeslot=0x1D110, category='so', description='MUSICAL SYMBOL FERMATA' },
	[0x1D111] = { unicodeslot=0x1D111, category='so', description='MUSICAL SYMBOL FERMATA BELOW' },
	[0x1D112] = { unicodeslot=0x1D112, category='so', description='MUSICAL SYMBOL BREATH MARK' },
	[0x1D113] = { unicodeslot=0x1D113, category='so', description='MUSICAL SYMBOL CAESURA' },
	[0x1D114] = { unicodeslot=0x1D114, category='so', description='MUSICAL SYMBOL BRACE' },
	[0x1D115] = { unicodeslot=0x1D115, category='so', description='MUSICAL SYMBOL BRACKET' },
	[0x1D116] = { unicodeslot=0x1D116, category='so', description='MUSICAL SYMBOL ONE-LINE STAFF' },
	[0x1D117] = { unicodeslot=0x1D117, category='so', description='MUSICAL SYMBOL TWO-LINE STAFF' },
	[0x1D118] = { unicodeslot=0x1D118, category='so', description='MUSICAL SYMBOL THREE-LINE STAFF' },
	[0x1D119] = { unicodeslot=0x1D119, category='so', description='MUSICAL SYMBOL FOUR-LINE STAFF' },
	[0x1D11A] = { unicodeslot=0x1D11A, category='so', description='MUSICAL SYMBOL FIVE-LINE STAFF' },
	[0x1D11B] = { unicodeslot=0x1D11B, category='so', description='MUSICAL SYMBOL SIX-LINE STAFF' },
	[0x1D11C] = { unicodeslot=0x1D11C, category='so', description='MUSICAL SYMBOL SIX-STRING FRETBOARD' },
	[0x1D11D] = { unicodeslot=0x1D11D, category='so', description='MUSICAL SYMBOL FOUR-STRING FRETBOARD' },
	[0x1D11E] = { unicodeslot=0x1D11E, category='so', description='MUSICAL SYMBOL G CLEF' },
	[0x1D11F] = { unicodeslot=0x1D11F, category='so', description='MUSICAL SYMBOL G CLEF OTTAVA ALTA' },
	[0x1D120] = { unicodeslot=0x1D120, category='so', description='MUSICAL SYMBOL G CLEF OTTAVA BASSA' },
	[0x1D121] = { unicodeslot=0x1D121, category='so', description='MUSICAL SYMBOL C CLEF' },
	[0x1D122] = { unicodeslot=0x1D122, category='so', description='MUSICAL SYMBOL F CLEF' },
	[0x1D123] = { unicodeslot=0x1D123, category='so', description='MUSICAL SYMBOL F CLEF OTTAVA ALTA' },
	[0x1D124] = { unicodeslot=0x1D124, category='so', description='MUSICAL SYMBOL F CLEF OTTAVA BASSA' },
	[0x1D125] = { unicodeslot=0x1D125, category='so', description='MUSICAL SYMBOL DRUM CLEF-1' },
	[0x1D126] = { unicodeslot=0x1D126, category='so', description='MUSICAL SYMBOL DRUM CLEF-2' },
	[0x1D12A] = { unicodeslot=0x1D12A, category='so', description='MUSICAL SYMBOL DOUBLE SHARP' },
	[0x1D12B] = { unicodeslot=0x1D12B, category='so', description='MUSICAL SYMBOL DOUBLE FLAT' },
	[0x1D12C] = { unicodeslot=0x1D12C, category='so', description='MUSICAL SYMBOL FLAT UP' },
	[0x1D12D] = { unicodeslot=0x1D12D, category='so', description='MUSICAL SYMBOL FLAT DOWN' },
	[0x1D12E] = { unicodeslot=0x1D12E, category='so', description='MUSICAL SYMBOL NATURAL UP' },
	[0x1D12F] = { unicodeslot=0x1D12F, category='so', description='MUSICAL SYMBOL NATURAL DOWN' },
	[0x1D130] = { unicodeslot=0x1D130, category='so', description='MUSICAL SYMBOL SHARP UP' },
	[0x1D131] = { unicodeslot=0x1D131, category='so', description='MUSICAL SYMBOL SHARP DOWN' },
	[0x1D132] = { unicodeslot=0x1D132, category='so', description='MUSICAL SYMBOL QUARTER TONE SHARP' },
	[0x1D133] = { unicodeslot=0x1D133, category='so', description='MUSICAL SYMBOL QUARTER TONE FLAT' },
	[0x1D134] = { unicodeslot=0x1D134, category='so', description='MUSICAL SYMBOL COMMON TIME' },
	[0x1D135] = { unicodeslot=0x1D135, category='so', description='MUSICAL SYMBOL CUT TIME' },
	[0x1D136] = { unicodeslot=0x1D136, category='so', description='MUSICAL SYMBOL OTTAVA ALTA' },
	[0x1D137] = { unicodeslot=0x1D137, category='so', description='MUSICAL SYMBOL OTTAVA BASSA' },
	[0x1D138] = { unicodeslot=0x1D138, category='so', description='MUSICAL SYMBOL QUINDICESIMA ALTA' },
	[0x1D139] = { unicodeslot=0x1D139, category='so', description='MUSICAL SYMBOL QUINDICESIMA BASSA' },
	[0x1D13A] = { unicodeslot=0x1D13A, category='so', description='MUSICAL SYMBOL MULTI REST' },
	[0x1D13B] = { unicodeslot=0x1D13B, category='so', description='MUSICAL SYMBOL WHOLE REST' },
	[0x1D13C] = { unicodeslot=0x1D13C, category='so', description='MUSICAL SYMBOL HALF REST' },
	[0x1D13D] = { unicodeslot=0x1D13D, category='so', description='MUSICAL SYMBOL QUARTER REST' },
	[0x1D13E] = { unicodeslot=0x1D13E, category='so', description='MUSICAL SYMBOL EIGHTH REST' },
	[0x1D13F] = { unicodeslot=0x1D13F, category='so', description='MUSICAL SYMBOL SIXTEENTH REST' },
	[0x1D140] = { unicodeslot=0x1D140, category='so', description='MUSICAL SYMBOL THIRTY-SECOND REST' },
	[0x1D141] = { unicodeslot=0x1D141, category='so', description='MUSICAL SYMBOL SIXTY-FOURTH REST' },
	[0x1D142] = { unicodeslot=0x1D142, category='so', description='MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST' },
	[0x1D143] = { unicodeslot=0x1D143, category='so', description='MUSICAL SYMBOL X NOTEHEAD' },
	[0x1D144] = { unicodeslot=0x1D144, category='so', description='MUSICAL SYMBOL PLUS NOTEHEAD' },
	[0x1D145] = { unicodeslot=0x1D145, category='so', description='MUSICAL SYMBOL CIRCLE X NOTEHEAD' },
	[0x1D146] = { unicodeslot=0x1D146, category='so', description='MUSICAL SYMBOL SQUARE NOTEHEAD WHITE' },
	[0x1D147] = { unicodeslot=0x1D147, category='so', description='MUSICAL SYMBOL SQUARE NOTEHEAD BLACK' },
	[0x1D148] = { unicodeslot=0x1D148, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD UP WHITE' },
	[0x1D149] = { unicodeslot=0x1D149, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD UP BLACK' },
	[0x1D14A] = { unicodeslot=0x1D14A, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT WHITE' },
	[0x1D14B] = { unicodeslot=0x1D14B, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT BLACK' },
	[0x1D14C] = { unicodeslot=0x1D14C, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT WHITE' },
	[0x1D14D] = { unicodeslot=0x1D14D, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT BLACK' },
	[0x1D14E] = { unicodeslot=0x1D14E, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN WHITE' },
	[0x1D14F] = { unicodeslot=0x1D14F, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN BLACK' },
	[0x1D150] = { unicodeslot=0x1D150, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT WHITE' },
	[0x1D151] = { unicodeslot=0x1D151, category='so', description='MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT BLACK' },
	[0x1D152] = { unicodeslot=0x1D152, category='so', description='MUSICAL SYMBOL MOON NOTEHEAD WHITE' },
	[0x1D153] = { unicodeslot=0x1D153, category='so', description='MUSICAL SYMBOL MOON NOTEHEAD BLACK' },
	[0x1D154] = { unicodeslot=0x1D154, category='so', description='MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN WHITE' },
	[0x1D155] = { unicodeslot=0x1D155, category='so', description='MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN BLACK' },
	[0x1D156] = { unicodeslot=0x1D156, category='so', description='MUSICAL SYMBOL PARENTHESIS NOTEHEAD' },
	[0x1D157] = { unicodeslot=0x1D157, category='so', description='MUSICAL SYMBOL VOID NOTEHEAD' },
	[0x1D158] = { unicodeslot=0x1D158, category='so', description='MUSICAL SYMBOL NOTEHEAD BLACK' },
	[0x1D159] = { unicodeslot=0x1D159, category='so', description='MUSICAL SYMBOL NULL NOTEHEAD' },
	[0x1D15A] = { unicodeslot=0x1D15A, category='so', description='MUSICAL SYMBOL CLUSTER NOTEHEAD WHITE' },
	[0x1D15B] = { unicodeslot=0x1D15B, category='so', description='MUSICAL SYMBOL CLUSTER NOTEHEAD BLACK' },
	[0x1D15C] = { unicodeslot=0x1D15C, category='so', description='MUSICAL SYMBOL BREVE' },
	[0x1D15D] = { unicodeslot=0x1D15D, category='so', description='MUSICAL SYMBOL WHOLE NOTE' },
	[0x1D15E] = { unicodeslot=0x1D15E, category='so', description='MUSICAL SYMBOL HALF NOTE', specials={'char',0x1D157,0x1D165} },
	[0x1D15F] = { unicodeslot=0x1D15F, category='so', description='MUSICAL SYMBOL QUARTER NOTE', specials={'char',0x1D158,0x1D165} },
	[0x1D160] = { unicodeslot=0x1D160, category='so', description='MUSICAL SYMBOL EIGHTH NOTE', specials={'char',0x1D15F,0x1D16E} },
	[0x1D161] = { unicodeslot=0x1D161, category='so', description='MUSICAL SYMBOL SIXTEENTH NOTE', specials={'char',0x1D15F,0x1D16F} },
	[0x1D162] = { unicodeslot=0x1D162, category='so', description='MUSICAL SYMBOL THIRTY-SECOND NOTE', specials={'char',0x1D15F,0x1D170} },
	[0x1D163] = { unicodeslot=0x1D163, category='so', description='MUSICAL SYMBOL SIXTY-FOURTH NOTE', specials={'char',0x1D15F,0x1D171} },
	[0x1D164] = { unicodeslot=0x1D164, category='so', description='MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE', specials={'char',0x1D15F,0x1D172} },
	[0x1D165] = { unicodeslot=0x1D165, category='mc', description='MUSICAL SYMBOL COMBINING STEM' },
	[0x1D166] = { unicodeslot=0x1D166, category='mc', description='MUSICAL SYMBOL COMBINING SPRECHGESANG STEM' },
	[0x1D167] = { unicodeslot=0x1D167, category='mn', description='MUSICAL SYMBOL COMBINING TREMOLO-1' },
	[0x1D168] = { unicodeslot=0x1D168, category='mn', description='MUSICAL SYMBOL COMBINING TREMOLO-2' },
	[0x1D169] = { unicodeslot=0x1D169, category='mn', description='MUSICAL SYMBOL COMBINING TREMOLO-3' },
	[0x1D16A] = { unicodeslot=0x1D16A, category='so', description='MUSICAL SYMBOL FINGERED TREMOLO-1' },
	[0x1D16B] = { unicodeslot=0x1D16B, category='so', description='MUSICAL SYMBOL FINGERED TREMOLO-2' },
	[0x1D16C] = { unicodeslot=0x1D16C, category='so', description='MUSICAL SYMBOL FINGERED TREMOLO-3' },
	[0x1D16D] = { unicodeslot=0x1D16D, category='mc', description='MUSICAL SYMBOL COMBINING AUGMENTATION DOT' },
	[0x1D16E] = { unicodeslot=0x1D16E, category='mc', description='MUSICAL SYMBOL COMBINING FLAG-1' },
	[0x1D16F] = { unicodeslot=0x1D16F, category='mc', description='MUSICAL SYMBOL COMBINING FLAG-2' },
	[0x1D170] = { unicodeslot=0x1D170, category='mc', description='MUSICAL SYMBOL COMBINING FLAG-3' },
	[0x1D171] = { unicodeslot=0x1D171, category='mc', description='MUSICAL SYMBOL COMBINING FLAG-4' },
	[0x1D172] = { unicodeslot=0x1D172, category='mc', description='MUSICAL SYMBOL COMBINING FLAG-5' },
	[0x1D173] = { unicodeslot=0x1D173, category='cf', description='MUSICAL SYMBOL BEGIN BEAM' },
	[0x1D174] = { unicodeslot=0x1D174, category='cf', description='MUSICAL SYMBOL END BEAM' },
	[0x1D175] = { unicodeslot=0x1D175, category='cf', description='MUSICAL SYMBOL BEGIN TIE' },
	[0x1D176] = { unicodeslot=0x1D176, category='cf', description='MUSICAL SYMBOL END TIE' },
	[0x1D177] = { unicodeslot=0x1D177, category='cf', description='MUSICAL SYMBOL BEGIN SLUR' },
	[0x1D178] = { unicodeslot=0x1D178, category='cf', description='MUSICAL SYMBOL END SLUR' },
	[0x1D179] = { unicodeslot=0x1D179, category='cf', description='MUSICAL SYMBOL BEGIN PHRASE' },
	[0x1D17A] = { unicodeslot=0x1D17A, category='cf', description='MUSICAL SYMBOL END PHRASE' },
	[0x1D17B] = { unicodeslot=0x1D17B, category='mn', description='MUSICAL SYMBOL COMBINING ACCENT' },
	[0x1D17C] = { unicodeslot=0x1D17C, category='mn', description='MUSICAL SYMBOL COMBINING STACCATO' },
	[0x1D17D] = { unicodeslot=0x1D17D, category='mn', description='MUSICAL SYMBOL COMBINING TENUTO' },
	[0x1D17E] = { unicodeslot=0x1D17E, category='mn', description='MUSICAL SYMBOL COMBINING STACCATISSIMO' },
	[0x1D17F] = { unicodeslot=0x1D17F, category='mn', description='MUSICAL SYMBOL COMBINING MARCATO' },
	[0x1D180] = { unicodeslot=0x1D180, category='mn', description='MUSICAL SYMBOL COMBINING MARCATO-STACCATO' },
	[0x1D181] = { unicodeslot=0x1D181, category='mn', description='MUSICAL SYMBOL COMBINING ACCENT-STACCATO' },
	[0x1D182] = { unicodeslot=0x1D182, category='mn', description='MUSICAL SYMBOL COMBINING LOURE' },
	[0x1D183] = { unicodeslot=0x1D183, category='so', description='MUSICAL SYMBOL ARPEGGIATO UP' },
	[0x1D184] = { unicodeslot=0x1D184, category='so', description='MUSICAL SYMBOL ARPEGGIATO DOWN' },
	[0x1D185] = { unicodeslot=0x1D185, category='mn', description='MUSICAL SYMBOL COMBINING DOIT' },
	[0x1D186] = { unicodeslot=0x1D186, category='mn', description='MUSICAL SYMBOL COMBINING RIP' },
	[0x1D187] = { unicodeslot=0x1D187, category='mn', description='MUSICAL SYMBOL COMBINING FLIP' },
	[0x1D188] = { unicodeslot=0x1D188, category='mn', description='MUSICAL SYMBOL COMBINING SMEAR' },
	[0x1D189] = { unicodeslot=0x1D189, category='mn', description='MUSICAL SYMBOL COMBINING BEND' },
	[0x1D18A] = { unicodeslot=0x1D18A, category='mn', description='MUSICAL SYMBOL COMBINING DOUBLE TONGUE' },
	[0x1D18B] = { unicodeslot=0x1D18B, category='mn', description='MUSICAL SYMBOL COMBINING TRIPLE TONGUE' },
	[0x1D18C] = { unicodeslot=0x1D18C, category='so', description='MUSICAL SYMBOL RINFORZANDO' },
	[0x1D18D] = { unicodeslot=0x1D18D, category='so', description='MUSICAL SYMBOL SUBITO' },
	[0x1D18E] = { unicodeslot=0x1D18E, category='so', description='MUSICAL SYMBOL Z' },
	[0x1D18F] = { unicodeslot=0x1D18F, category='so', description='MUSICAL SYMBOL PIANO' },
	[0x1D190] = { unicodeslot=0x1D190, category='so', description='MUSICAL SYMBOL MEZZO' },
	[0x1D191] = { unicodeslot=0x1D191, category='so', description='MUSICAL SYMBOL FORTE' },
	[0x1D192] = { unicodeslot=0x1D192, category='so', description='MUSICAL SYMBOL CRESCENDO' },
	[0x1D193] = { unicodeslot=0x1D193, category='so', description='MUSICAL SYMBOL DECRESCENDO' },
	[0x1D194] = { unicodeslot=0x1D194, category='so', description='MUSICAL SYMBOL GRACE NOTE SLASH' },
	[0x1D195] = { unicodeslot=0x1D195, category='so', description='MUSICAL SYMBOL GRACE NOTE NO SLASH' },
	[0x1D196] = { unicodeslot=0x1D196, category='so', description='MUSICAL SYMBOL TR' },
	[0x1D197] = { unicodeslot=0x1D197, category='so', description='MUSICAL SYMBOL TURN' },
	[0x1D198] = { unicodeslot=0x1D198, category='so', description='MUSICAL SYMBOL INVERTED TURN' },
	[0x1D199] = { unicodeslot=0x1D199, category='so', description='MUSICAL SYMBOL TURN SLASH' },
	[0x1D19A] = { unicodeslot=0x1D19A, category='so', description='MUSICAL SYMBOL TURN UP' },
	[0x1D19B] = { unicodeslot=0x1D19B, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-1' },
	[0x1D19C] = { unicodeslot=0x1D19C, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-2' },
	[0x1D19D] = { unicodeslot=0x1D19D, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-3' },
	[0x1D19E] = { unicodeslot=0x1D19E, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-4' },
	[0x1D19F] = { unicodeslot=0x1D19F, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-5' },
	[0x1D1A0] = { unicodeslot=0x1D1A0, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-6' },
	[0x1D1A1] = { unicodeslot=0x1D1A1, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-7' },
	[0x1D1A2] = { unicodeslot=0x1D1A2, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-8' },
	[0x1D1A3] = { unicodeslot=0x1D1A3, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-9' },
	[0x1D1A4] = { unicodeslot=0x1D1A4, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-10' },
	[0x1D1A5] = { unicodeslot=0x1D1A5, category='so', description='MUSICAL SYMBOL ORNAMENT STROKE-11' },
	[0x1D1A6] = { unicodeslot=0x1D1A6, category='so', description='MUSICAL SYMBOL HAUPTSTIMME' },
	[0x1D1A7] = { unicodeslot=0x1D1A7, category='so', description='MUSICAL SYMBOL NEBENSTIMME' },
	[0x1D1A8] = { unicodeslot=0x1D1A8, category='so', description='MUSICAL SYMBOL END OF STIMME' },
	[0x1D1A9] = { unicodeslot=0x1D1A9, category='so', description='MUSICAL SYMBOL DEGREE SLASH' },
	[0x1D1AA] = { unicodeslot=0x1D1AA, category='mn', description='MUSICAL SYMBOL COMBINING DOWN BOW' },
	[0x1D1AB] = { unicodeslot=0x1D1AB, category='mn', description='MUSICAL SYMBOL COMBINING UP BOW' },
	[0x1D1AC] = { unicodeslot=0x1D1AC, category='mn', description='MUSICAL SYMBOL COMBINING HARMONIC' },
	[0x1D1AD] = { unicodeslot=0x1D1AD, category='mn', description='MUSICAL SYMBOL COMBINING SNAP PIZZICATO' },
	[0x1D1AE] = { unicodeslot=0x1D1AE, category='so', description='MUSICAL SYMBOL PEDAL MARK' },
	[0x1D1AF] = { unicodeslot=0x1D1AF, category='so', description='MUSICAL SYMBOL PEDAL UP MARK' },
	[0x1D1B0] = { unicodeslot=0x1D1B0, category='so', description='MUSICAL SYMBOL HALF PEDAL MARK' },
	[0x1D1B1] = { unicodeslot=0x1D1B1, category='so', description='MUSICAL SYMBOL GLISSANDO UP' },
	[0x1D1B2] = { unicodeslot=0x1D1B2, category='so', description='MUSICAL SYMBOL GLISSANDO DOWN' },
	[0x1D1B3] = { unicodeslot=0x1D1B3, category='so', description='MUSICAL SYMBOL WITH FINGERNAILS' },
	[0x1D1B4] = { unicodeslot=0x1D1B4, category='so', description='MUSICAL SYMBOL DAMP' },
	[0x1D1B5] = { unicodeslot=0x1D1B5, category='so', description='MUSICAL SYMBOL DAMP ALL' },
	[0x1D1B6] = { unicodeslot=0x1D1B6, category='so', description='MUSICAL SYMBOL MAXIMA' },
	[0x1D1B7] = { unicodeslot=0x1D1B7, category='so', description='MUSICAL SYMBOL LONGA' },
	[0x1D1B8] = { unicodeslot=0x1D1B8, category='so', description='MUSICAL SYMBOL BREVIS' },
	[0x1D1B9] = { unicodeslot=0x1D1B9, category='so', description='MUSICAL SYMBOL SEMIBREVIS WHITE' },
	[0x1D1BA] = { unicodeslot=0x1D1BA, category='so', description='MUSICAL SYMBOL SEMIBREVIS BLACK' },
	[0x1D1BB] = { unicodeslot=0x1D1BB, category='so', description='MUSICAL SYMBOL MINIMA', specials={'char',0x1D1B9,0x1D165} },
	[0x1D1BC] = { unicodeslot=0x1D1BC, category='so', description='MUSICAL SYMBOL MINIMA BLACK', specials={'char',0x1D1BA,0x1D165} },
	[0x1D1BD] = { unicodeslot=0x1D1BD, category='so', description='MUSICAL SYMBOL SEMIMINIMA WHITE', specials={'char',0x1D1BB,0x1D16E} },
	[0x1D1BE] = { unicodeslot=0x1D1BE, category='so', description='MUSICAL SYMBOL SEMIMINIMA BLACK', specials={'char',0x1D1BC,0x1D16E} },
	[0x1D1BF] = { unicodeslot=0x1D1BF, category='so', description='MUSICAL SYMBOL FUSA WHITE', specials={'char',0x1D1BB,0x1D16F} },
	[0x1D1C0] = { unicodeslot=0x1D1C0, category='so', description='MUSICAL SYMBOL FUSA BLACK', specials={'char',0x1D1BC,0x1D16F} },
	[0x1D1C1] = { unicodeslot=0x1D1C1, category='so', description='MUSICAL SYMBOL LONGA PERFECTA REST' },
	[0x1D1C2] = { unicodeslot=0x1D1C2, category='so', description='MUSICAL SYMBOL LONGA IMPERFECTA REST' },
	[0x1D1C3] = { unicodeslot=0x1D1C3, category='so', description='MUSICAL SYMBOL BREVIS REST' },
	[0x1D1C4] = { unicodeslot=0x1D1C4, category='so', description='MUSICAL SYMBOL SEMIBREVIS REST' },
	[0x1D1C5] = { unicodeslot=0x1D1C5, category='so', description='MUSICAL SYMBOL MINIMA REST' },
	[0x1D1C6] = { unicodeslot=0x1D1C6, category='so', description='MUSICAL SYMBOL SEMIMINIMA REST' },
	[0x1D1C7] = { unicodeslot=0x1D1C7, category='so', description='MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA' },
	[0x1D1C8] = { unicodeslot=0x1D1C8, category='so', description='MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE IMPERFECTA' },
	[0x1D1C9] = { unicodeslot=0x1D1C9, category='so', description='MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA DIMINUTION-1' },
	[0x1D1CA] = { unicodeslot=0x1D1CA, category='so', description='MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE PERFECTA' },
	[0x1D1CB] = { unicodeslot=0x1D1CB, category='so', description='MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA' },
	[0x1D1CC] = { unicodeslot=0x1D1CC, category='so', description='MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-1' },
	[0x1D1CD] = { unicodeslot=0x1D1CD, category='so', description='MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-2' },
	[0x1D1CE] = { unicodeslot=0x1D1CE, category='so', description='MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-3' },
	[0x1D1CF] = { unicodeslot=0x1D1CF, category='so', description='MUSICAL SYMBOL CROIX' },
	[0x1D1D0] = { unicodeslot=0x1D1D0, category='so', description='MUSICAL SYMBOL GREGORIAN C CLEF' },
	[0x1D1D1] = { unicodeslot=0x1D1D1, category='so', description='MUSICAL SYMBOL GREGORIAN F CLEF' },
	[0x1D1D2] = { unicodeslot=0x1D1D2, category='so', description='MUSICAL SYMBOL SQUARE B' },
	[0x1D1D3] = { unicodeslot=0x1D1D3, category='so', description='MUSICAL SYMBOL VIRGA' },
	[0x1D1D4] = { unicodeslot=0x1D1D4, category='so', description='MUSICAL SYMBOL PODATUS' },
	[0x1D1D5] = { unicodeslot=0x1D1D5, category='so', description='MUSICAL SYMBOL CLIVIS' },
	[0x1D1D6] = { unicodeslot=0x1D1D6, category='so', description='MUSICAL SYMBOL SCANDICUS' },
	[0x1D1D7] = { unicodeslot=0x1D1D7, category='so', description='MUSICAL SYMBOL CLIMACUS' },
	[0x1D1D8] = { unicodeslot=0x1D1D8, category='so', description='MUSICAL SYMBOL TORCULUS' },
	[0x1D1D9] = { unicodeslot=0x1D1D9, category='so', description='MUSICAL SYMBOL PORRECTUS' },
	[0x1D1DA] = { unicodeslot=0x1D1DA, category='so', description='MUSICAL SYMBOL PORRECTUS FLEXUS' },
	[0x1D1DB] = { unicodeslot=0x1D1DB, category='so', description='MUSICAL SYMBOL SCANDICUS FLEXUS' },
	[0x1D1DC] = { unicodeslot=0x1D1DC, category='so', description='MUSICAL SYMBOL TORCULUS RESUPINUS' },
	[0x1D1DD] = { unicodeslot=0x1D1DD, category='so', description='MUSICAL SYMBOL PES SUBPUNCTIS' },
	[0x1D200] = { unicodeslot=0x1D200, category='so', description='GREEK VOCAL NOTATION SYMBOL-1' },
	[0x1D201] = { unicodeslot=0x1D201, category='so', description='GREEK VOCAL NOTATION SYMBOL-2' },
	[0x1D202] = { unicodeslot=0x1D202, category='so', description='GREEK VOCAL NOTATION SYMBOL-3' },
	[0x1D203] = { unicodeslot=0x1D203, category='so', description='GREEK VOCAL NOTATION SYMBOL-4' },
	[0x1D204] = { unicodeslot=0x1D204, category='so', description='GREEK VOCAL NOTATION SYMBOL-5' },
	[0x1D205] = { unicodeslot=0x1D205, category='so', description='GREEK VOCAL NOTATION SYMBOL-6' },
	[0x1D206] = { unicodeslot=0x1D206, category='so', description='GREEK VOCAL NOTATION SYMBOL-7' },
	[0x1D207] = { unicodeslot=0x1D207, category='so', description='GREEK VOCAL NOTATION SYMBOL-8' },
	[0x1D208] = { unicodeslot=0x1D208, category='so', description='GREEK VOCAL NOTATION SYMBOL-9' },
	[0x1D209] = { unicodeslot=0x1D209, category='so', description='GREEK VOCAL NOTATION SYMBOL-10' },
	[0x1D20A] = { unicodeslot=0x1D20A, category='so', description='GREEK VOCAL NOTATION SYMBOL-11' },
	[0x1D20B] = { unicodeslot=0x1D20B, category='so', description='GREEK VOCAL NOTATION SYMBOL-12' },
	[0x1D20C] = { unicodeslot=0x1D20C, category='so', description='GREEK VOCAL NOTATION SYMBOL-13' },
	[0x1D20D] = { unicodeslot=0x1D20D, category='so', description='GREEK VOCAL NOTATION SYMBOL-14' },
	[0x1D20E] = { unicodeslot=0x1D20E, category='so', description='GREEK VOCAL NOTATION SYMBOL-15' },
	[0x1D20F] = { unicodeslot=0x1D20F, category='so', description='GREEK VOCAL NOTATION SYMBOL-16' },
	[0x1D210] = { unicodeslot=0x1D210, category='so', description='GREEK VOCAL NOTATION SYMBOL-17' },
	[0x1D211] = { unicodeslot=0x1D211, category='so', description='GREEK VOCAL NOTATION SYMBOL-18' },
	[0x1D212] = { unicodeslot=0x1D212, category='so', description='GREEK VOCAL NOTATION SYMBOL-19' },
	[0x1D213] = { unicodeslot=0x1D213, category='so', description='GREEK VOCAL NOTATION SYMBOL-20' },
	[0x1D214] = { unicodeslot=0x1D214, category='so', description='GREEK VOCAL NOTATION SYMBOL-21' },
	[0x1D215] = { unicodeslot=0x1D215, category='so', description='GREEK VOCAL NOTATION SYMBOL-22' },
	[0x1D216] = { unicodeslot=0x1D216, category='so', description='GREEK VOCAL NOTATION SYMBOL-23' },
	[0x1D217] = { unicodeslot=0x1D217, category='so', description='GREEK VOCAL NOTATION SYMBOL-24' },
	[0x1D218] = { unicodeslot=0x1D218, category='so', description='GREEK VOCAL NOTATION SYMBOL-50' },
	[0x1D219] = { unicodeslot=0x1D219, category='so', description='GREEK VOCAL NOTATION SYMBOL-51' },
	[0x1D21A] = { unicodeslot=0x1D21A, category='so', description='GREEK VOCAL NOTATION SYMBOL-52' },
	[0x1D21B] = { unicodeslot=0x1D21B, category='so', description='GREEK VOCAL NOTATION SYMBOL-53' },
	[0x1D21C] = { unicodeslot=0x1D21C, category='so', description='GREEK VOCAL NOTATION SYMBOL-54' },
	[0x1D21D] = { unicodeslot=0x1D21D, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-1' },
	[0x1D21E] = { unicodeslot=0x1D21E, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-2' },
	[0x1D21F] = { unicodeslot=0x1D21F, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-4' },
	[0x1D220] = { unicodeslot=0x1D220, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-5' },
	[0x1D221] = { unicodeslot=0x1D221, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-7' },
	[0x1D222] = { unicodeslot=0x1D222, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-8' },
	[0x1D223] = { unicodeslot=0x1D223, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-11' },
	[0x1D224] = { unicodeslot=0x1D224, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-12' },
	[0x1D225] = { unicodeslot=0x1D225, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-13' },
	[0x1D226] = { unicodeslot=0x1D226, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-14' },
	[0x1D227] = { unicodeslot=0x1D227, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-17' },
	[0x1D228] = { unicodeslot=0x1D228, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-18' },
	[0x1D229] = { unicodeslot=0x1D229, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-19' },
	[0x1D22A] = { unicodeslot=0x1D22A, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-23' },
	[0x1D22B] = { unicodeslot=0x1D22B, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-24' },
	[0x1D22C] = { unicodeslot=0x1D22C, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-25' },
	[0x1D22D] = { unicodeslot=0x1D22D, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-26' },
	[0x1D22E] = { unicodeslot=0x1D22E, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-27' },
	[0x1D22F] = { unicodeslot=0x1D22F, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-29' },
	[0x1D230] = { unicodeslot=0x1D230, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-30' },
	[0x1D231] = { unicodeslot=0x1D231, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-32' },
	[0x1D232] = { unicodeslot=0x1D232, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-36' },
	[0x1D233] = { unicodeslot=0x1D233, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-37' },
	[0x1D234] = { unicodeslot=0x1D234, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-38' },
	[0x1D235] = { unicodeslot=0x1D235, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-39' },
	[0x1D236] = { unicodeslot=0x1D236, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-40' },
	[0x1D237] = { unicodeslot=0x1D237, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-42' },
	[0x1D238] = { unicodeslot=0x1D238, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-43' },
	[0x1D239] = { unicodeslot=0x1D239, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-45' },
	[0x1D23A] = { unicodeslot=0x1D23A, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-47' },
	[0x1D23B] = { unicodeslot=0x1D23B, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-48' },
	[0x1D23C] = { unicodeslot=0x1D23C, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-49' },
	[0x1D23D] = { unicodeslot=0x1D23D, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-50' },
	[0x1D23E] = { unicodeslot=0x1D23E, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-51' },
	[0x1D23F] = { unicodeslot=0x1D23F, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-52' },
	[0x1D240] = { unicodeslot=0x1D240, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-53' },
	[0x1D241] = { unicodeslot=0x1D241, category='so', description='GREEK INSTRUMENTAL NOTATION SYMBOL-54' },
	[0x1D242] = { unicodeslot=0x1D242, category='mn', description='COMBINING GREEK MUSICAL TRISEME' },
	[0x1D243] = { unicodeslot=0x1D243, category='mn', description='COMBINING GREEK MUSICAL TETRASEME' },
	[0x1D244] = { unicodeslot=0x1D244, category='mn', description='COMBINING GREEK MUSICAL PENTASEME' },
	[0x1D245] = { unicodeslot=0x1D245, category='so', description='GREEK MUSICAL LEIMMA' },
	[0x1D300] = { unicodeslot=0x1D300, category='so', description='MONOGRAM FOR EARTH' },
	[0x1D301] = { unicodeslot=0x1D301, category='so', description='DIGRAM FOR HEAVENLY EARTH' },
	[0x1D302] = { unicodeslot=0x1D302, category='so', description='DIGRAM FOR HUMAN EARTH' },
	[0x1D303] = { unicodeslot=0x1D303, category='so', description='DIGRAM FOR EARTHLY HEAVEN' },
	[0x1D304] = { unicodeslot=0x1D304, category='so', description='DIGRAM FOR EARTHLY HUMAN' },
	[0x1D305] = { unicodeslot=0x1D305, category='so', description='DIGRAM FOR EARTH' },
	[0x1D306] = { unicodeslot=0x1D306, category='so', description='TETRAGRAM FOR CENTRE' },
	[0x1D307] = { unicodeslot=0x1D307, category='so', description='TETRAGRAM FOR FULL CIRCLE' },
	[0x1D308] = { unicodeslot=0x1D308, category='so', description='TETRAGRAM FOR MIRED' },
	[0x1D309] = { unicodeslot=0x1D309, category='so', description='TETRAGRAM FOR BARRIER' },
	[0x1D30A] = { unicodeslot=0x1D30A, category='so', description='TETRAGRAM FOR KEEPING SMALL' },
	[0x1D30B] = { unicodeslot=0x1D30B, category='so', description='TETRAGRAM FOR CONTRARIETY' },
	[0x1D30C] = { unicodeslot=0x1D30C, category='so', description='TETRAGRAM FOR ASCENT' },
	[0x1D30D] = { unicodeslot=0x1D30D, category='so', description='TETRAGRAM FOR OPPOSITION' },
	[0x1D30E] = { unicodeslot=0x1D30E, category='so', description='TETRAGRAM FOR BRANCHING OUT' },
	[0x1D30F] = { unicodeslot=0x1D30F, category='so', description='TETRAGRAM FOR DEFECTIVENESS OR DISTORTION' },
	[0x1D310] = { unicodeslot=0x1D310, category='so', description='TETRAGRAM FOR DIVERGENCE' },
	[0x1D311] = { unicodeslot=0x1D311, category='so', description='TETRAGRAM FOR YOUTHFULNESS' },
	[0x1D312] = { unicodeslot=0x1D312, category='so', description='TETRAGRAM FOR INCREASE' },
	[0x1D313] = { unicodeslot=0x1D313, category='so', description='TETRAGRAM FOR PENETRATION' },
	[0x1D314] = { unicodeslot=0x1D314, category='so', description='TETRAGRAM FOR REACH' },
	[0x1D315] = { unicodeslot=0x1D315, category='so', description='TETRAGRAM FOR CONTACT' },
	[0x1D316] = { unicodeslot=0x1D316, category='so', description='TETRAGRAM FOR HOLDING BACK' },
	[0x1D317] = { unicodeslot=0x1D317, category='so', description='TETRAGRAM FOR WAITING' },
	[0x1D318] = { unicodeslot=0x1D318, category='so', description='TETRAGRAM FOR FOLLOWING' },
	[0x1D319] = { unicodeslot=0x1D319, category='so', description='TETRAGRAM FOR ADVANCE' },
	[0x1D31A] = { unicodeslot=0x1D31A, category='so', description='TETRAGRAM FOR RELEASE' },
	[0x1D31B] = { unicodeslot=0x1D31B, category='so', description='TETRAGRAM FOR RESISTANCE' },
	[0x1D31C] = { unicodeslot=0x1D31C, category='so', description='TETRAGRAM FOR EASE' },
	[0x1D31D] = { unicodeslot=0x1D31D, category='so', description='TETRAGRAM FOR JOY' },
	[0x1D31E] = { unicodeslot=0x1D31E, category='so', description='TETRAGRAM FOR CONTENTION' },
	[0x1D31F] = { unicodeslot=0x1D31F, category='so', description='TETRAGRAM FOR ENDEAVOUR' },
	[0x1D320] = { unicodeslot=0x1D320, category='so', description='TETRAGRAM FOR DUTIES' },
	[0x1D321] = { unicodeslot=0x1D321, category='so', description='TETRAGRAM FOR CHANGE' },
	[0x1D322] = { unicodeslot=0x1D322, category='so', description='TETRAGRAM FOR DECISIVENESS' },
	[0x1D323] = { unicodeslot=0x1D323, category='so', description='TETRAGRAM FOR BOLD RESOLUTION' },
	[0x1D324] = { unicodeslot=0x1D324, category='so', description='TETRAGRAM FOR PACKING' },
	[0x1D325] = { unicodeslot=0x1D325, category='so', description='TETRAGRAM FOR LEGION' },
	[0x1D326] = { unicodeslot=0x1D326, category='so', description='TETRAGRAM FOR CLOSENESS' },
	[0x1D327] = { unicodeslot=0x1D327, category='so', description='TETRAGRAM FOR KINSHIP' },
	[0x1D328] = { unicodeslot=0x1D328, category='so', description='TETRAGRAM FOR GATHERING' },
	[0x1D329] = { unicodeslot=0x1D329, category='so', description='TETRAGRAM FOR STRENGTH' },
	[0x1D32A] = { unicodeslot=0x1D32A, category='so', description='TETRAGRAM FOR PURITY' },
	[0x1D32B] = { unicodeslot=0x1D32B, category='so', description='TETRAGRAM FOR FULLNESS' },
	[0x1D32C] = { unicodeslot=0x1D32C, category='so', description='TETRAGRAM FOR RESIDENCE' },
	[0x1D32D] = { unicodeslot=0x1D32D, category='so', description='TETRAGRAM FOR LAW OR MODEL' },
	[0x1D32E] = { unicodeslot=0x1D32E, category='so', description='TETRAGRAM FOR RESPONSE' },
	[0x1D32F] = { unicodeslot=0x1D32F, category='so', description='TETRAGRAM FOR GOING TO MEET' },
	[0x1D330] = { unicodeslot=0x1D330, category='so', description='TETRAGRAM FOR ENCOUNTERS' },
	[0x1D331] = { unicodeslot=0x1D331, category='so', description='TETRAGRAM FOR STOVE' },
	[0x1D332] = { unicodeslot=0x1D332, category='so', description='TETRAGRAM FOR GREATNESS' },
	[0x1D333] = { unicodeslot=0x1D333, category='so', description='TETRAGRAM FOR ENLARGEMENT' },
	[0x1D334] = { unicodeslot=0x1D334, category='so', description='TETRAGRAM FOR PATTERN' },
	[0x1D335] = { unicodeslot=0x1D335, category='so', description='TETRAGRAM FOR RITUAL' },
	[0x1D336] = { unicodeslot=0x1D336, category='so', description='TETRAGRAM FOR FLIGHT' },
	[0x1D337] = { unicodeslot=0x1D337, category='so', description='TETRAGRAM FOR VASTNESS OR WASTING' },
	[0x1D338] = { unicodeslot=0x1D338, category='so', description='TETRAGRAM FOR CONSTANCY' },
	[0x1D339] = { unicodeslot=0x1D339, category='so', description='TETRAGRAM FOR MEASURE' },
	[0x1D33A] = { unicodeslot=0x1D33A, category='so', description='TETRAGRAM FOR ETERNITY' },
	[0x1D33B] = { unicodeslot=0x1D33B, category='so', description='TETRAGRAM FOR UNITY' },
	[0x1D33C] = { unicodeslot=0x1D33C, category='so', description='TETRAGRAM FOR DIMINISHMENT' },
	[0x1D33D] = { unicodeslot=0x1D33D, category='so', description='TETRAGRAM FOR CLOSED MOUTH' },
	[0x1D33E] = { unicodeslot=0x1D33E, category='so', description='TETRAGRAM FOR GUARDEDNESS' },
	[0x1D33F] = { unicodeslot=0x1D33F, category='so', description='TETRAGRAM FOR GATHERING IN' },
	[0x1D340] = { unicodeslot=0x1D340, category='so', description='TETRAGRAM FOR MASSING' },
	[0x1D341] = { unicodeslot=0x1D341, category='so', description='TETRAGRAM FOR ACCUMULATION' },
	[0x1D342] = { unicodeslot=0x1D342, category='so', description='TETRAGRAM FOR EMBELLISHMENT' },
	[0x1D343] = { unicodeslot=0x1D343, category='so', description='TETRAGRAM FOR DOUBT' },
	[0x1D344] = { unicodeslot=0x1D344, category='so', description='TETRAGRAM FOR WATCH' },
	[0x1D345] = { unicodeslot=0x1D345, category='so', description='TETRAGRAM FOR SINKING' },
	[0x1D346] = { unicodeslot=0x1D346, category='so', description='TETRAGRAM FOR INNER' },
	[0x1D347] = { unicodeslot=0x1D347, category='so', description='TETRAGRAM FOR DEPARTURE' },
	[0x1D348] = { unicodeslot=0x1D348, category='so', description='TETRAGRAM FOR DARKENING' },
	[0x1D349] = { unicodeslot=0x1D349, category='so', description='TETRAGRAM FOR DIMMING' },
	[0x1D34A] = { unicodeslot=0x1D34A, category='so', description='TETRAGRAM FOR EXHAUSTION' },
	[0x1D34B] = { unicodeslot=0x1D34B, category='so', description='TETRAGRAM FOR SEVERANCE' },
	[0x1D34C] = { unicodeslot=0x1D34C, category='so', description='TETRAGRAM FOR STOPPAGE' },
	[0x1D34D] = { unicodeslot=0x1D34D, category='so', description='TETRAGRAM FOR HARDNESS' },
	[0x1D34E] = { unicodeslot=0x1D34E, category='so', description='TETRAGRAM FOR COMPLETION' },
	[0x1D34F] = { unicodeslot=0x1D34F, category='so', description='TETRAGRAM FOR CLOSURE' },
	[0x1D350] = { unicodeslot=0x1D350, category='so', description='TETRAGRAM FOR FAILURE' },
	[0x1D351] = { unicodeslot=0x1D351, category='so', description='TETRAGRAM FOR AGGRAVATION' },
	[0x1D352] = { unicodeslot=0x1D352, category='so', description='TETRAGRAM FOR COMPLIANCE' },
	[0x1D353] = { unicodeslot=0x1D353, category='so', description='TETRAGRAM FOR ON THE VERGE' },
	[0x1D354] = { unicodeslot=0x1D354, category='so', description='TETRAGRAM FOR DIFFICULTIES' },
	[0x1D355] = { unicodeslot=0x1D355, category='so', description='TETRAGRAM FOR LABOURING' },
	[0x1D356] = { unicodeslot=0x1D356, category='so', description='TETRAGRAM FOR FOSTERING' },
	[0x1D360] = { unicodeslot=0x1D360, category='no', description='COUNTING ROD UNIT DIGIT ONE' },
	[0x1D361] = { unicodeslot=0x1D361, category='no', description='COUNTING ROD UNIT DIGIT TWO' },
	[0x1D362] = { unicodeslot=0x1D362, category='no', description='COUNTING ROD UNIT DIGIT THREE' },
	[0x1D363] = { unicodeslot=0x1D363, category='no', description='COUNTING ROD UNIT DIGIT FOUR' },
	[0x1D364] = { unicodeslot=0x1D364, category='no', description='COUNTING ROD UNIT DIGIT FIVE' },
	[0x1D365] = { unicodeslot=0x1D365, category='no', description='COUNTING ROD UNIT DIGIT SIX' },
	[0x1D366] = { unicodeslot=0x1D366, category='no', description='COUNTING ROD UNIT DIGIT SEVEN' },
	[0x1D367] = { unicodeslot=0x1D367, category='no', description='COUNTING ROD UNIT DIGIT EIGHT' },
	[0x1D368] = { unicodeslot=0x1D368, category='no', description='COUNTING ROD UNIT DIGIT NINE' },
	[0x1D369] = { unicodeslot=0x1D369, category='no', description='COUNTING ROD TENS DIGIT ONE' },
	[0x1D36A] = { unicodeslot=0x1D36A, category='no', description='COUNTING ROD TENS DIGIT TWO' },
	[0x1D36B] = { unicodeslot=0x1D36B, category='no', description='COUNTING ROD TENS DIGIT THREE' },
	[0x1D36C] = { unicodeslot=0x1D36C, category='no', description='COUNTING ROD TENS DIGIT FOUR' },
	[0x1D36D] = { unicodeslot=0x1D36D, category='no', description='COUNTING ROD TENS DIGIT FIVE' },
	[0x1D36E] = { unicodeslot=0x1D36E, category='no', description='COUNTING ROD TENS DIGIT SIX' },
	[0x1D36F] = { unicodeslot=0x1D36F, category='no', description='COUNTING ROD TENS DIGIT SEVEN' },
	[0x1D370] = { unicodeslot=0x1D370, category='no', description='COUNTING ROD TENS DIGIT EIGHT' },
	[0x1D371] = { unicodeslot=0x1D371, category='no', description='COUNTING ROD TENS DIGIT NINE' },
	[0x1D400] = { unicodeslot=0x1D400, category='lu', description='MATHEMATICAL BOLD CAPITAL A', specials={'font',0x0041} },
	[0x1D401] = { unicodeslot=0x1D401, category='lu', description='MATHEMATICAL BOLD CAPITAL B', specials={'font',0x0042} },
	[0x1D402] = { unicodeslot=0x1D402, category='lu', description='MATHEMATICAL BOLD CAPITAL C', specials={'font',0x0043} },
	[0x1D403] = { unicodeslot=0x1D403, category='lu', description='MATHEMATICAL BOLD CAPITAL D', specials={'font',0x0044} },
	[0x1D404] = { unicodeslot=0x1D404, category='lu', description='MATHEMATICAL BOLD CAPITAL E', specials={'font',0x0045} },
	[0x1D405] = { unicodeslot=0x1D405, category='lu', description='MATHEMATICAL BOLD CAPITAL F', specials={'font',0x0046} },
	[0x1D406] = { unicodeslot=0x1D406, category='lu', description='MATHEMATICAL BOLD CAPITAL G', specials={'font',0x0047} },
	[0x1D407] = { unicodeslot=0x1D407, category='lu', description='MATHEMATICAL BOLD CAPITAL H', specials={'font',0x0048} },
	[0x1D408] = { unicodeslot=0x1D408, category='lu', description='MATHEMATICAL BOLD CAPITAL I', specials={'font',0x0049} },
	[0x1D409] = { unicodeslot=0x1D409, category='lu', description='MATHEMATICAL BOLD CAPITAL J', specials={'font',0x004A} },
	[0x1D40A] = { unicodeslot=0x1D40A, category='lu', description='MATHEMATICAL BOLD CAPITAL K', specials={'font',0x004B} },
	[0x1D40B] = { unicodeslot=0x1D40B, category='lu', description='MATHEMATICAL BOLD CAPITAL L', specials={'font',0x004C} },
	[0x1D40C] = { unicodeslot=0x1D40C, category='lu', description='MATHEMATICAL BOLD CAPITAL M', specials={'font',0x004D} },
	[0x1D40D] = { unicodeslot=0x1D40D, category='lu', description='MATHEMATICAL BOLD CAPITAL N', specials={'font',0x004E} },
	[0x1D40E] = { unicodeslot=0x1D40E, category='lu', description='MATHEMATICAL BOLD CAPITAL O', specials={'font',0x004F} },
	[0x1D40F] = { unicodeslot=0x1D40F, category='lu', description='MATHEMATICAL BOLD CAPITAL P', specials={'font',0x0050} },
	[0x1D410] = { unicodeslot=0x1D410, category='lu', description='MATHEMATICAL BOLD CAPITAL Q', specials={'font',0x0051} },
	[0x1D411] = { unicodeslot=0x1D411, category='lu', description='MATHEMATICAL BOLD CAPITAL R', specials={'font',0x0052} },
	[0x1D412] = { unicodeslot=0x1D412, category='lu', description='MATHEMATICAL BOLD CAPITAL S', specials={'font',0x0053} },
	[0x1D413] = { unicodeslot=0x1D413, category='lu', description='MATHEMATICAL BOLD CAPITAL T', specials={'font',0x0054} },
	[0x1D414] = { unicodeslot=0x1D414, category='lu', description='MATHEMATICAL BOLD CAPITAL U', specials={'font',0x0055} },
	[0x1D415] = { unicodeslot=0x1D415, category='lu', description='MATHEMATICAL BOLD CAPITAL V', specials={'font',0x0056} },
	[0x1D416] = { unicodeslot=0x1D416, category='lu', description='MATHEMATICAL BOLD CAPITAL W', specials={'font',0x0057} },
	[0x1D417] = { unicodeslot=0x1D417, category='lu', description='MATHEMATICAL BOLD CAPITAL X', specials={'font',0x0058} },
	[0x1D418] = { unicodeslot=0x1D418, category='lu', description='MATHEMATICAL BOLD CAPITAL Y', specials={'font',0x0059} },
	[0x1D419] = { unicodeslot=0x1D419, category='lu', description='MATHEMATICAL BOLD CAPITAL Z', specials={'font',0x005A} },
	[0x1D41A] = { unicodeslot=0x1D41A, category='ll', description='MATHEMATICAL BOLD SMALL A', specials={'font',0x0061} },
	[0x1D41B] = { unicodeslot=0x1D41B, category='ll', description='MATHEMATICAL BOLD SMALL B', specials={'font',0x0062} },
	[0x1D41C] = { unicodeslot=0x1D41C, category='ll', description='MATHEMATICAL BOLD SMALL C', specials={'font',0x0063} },
	[0x1D41D] = { unicodeslot=0x1D41D, category='ll', description='MATHEMATICAL BOLD SMALL D', specials={'font',0x0064} },
	[0x1D41E] = { unicodeslot=0x1D41E, category='ll', description='MATHEMATICAL BOLD SMALL E', specials={'font',0x0065} },
	[0x1D41F] = { unicodeslot=0x1D41F, category='ll', description='MATHEMATICAL BOLD SMALL F', specials={'font',0x0066} },
	[0x1D420] = { unicodeslot=0x1D420, category='ll', description='MATHEMATICAL BOLD SMALL G', specials={'font',0x0067} },
	[0x1D421] = { unicodeslot=0x1D421, category='ll', description='MATHEMATICAL BOLD SMALL H', specials={'font',0x0068} },
	[0x1D422] = { unicodeslot=0x1D422, category='ll', description='MATHEMATICAL BOLD SMALL I', specials={'font',0x0069} },
	[0x1D423] = { unicodeslot=0x1D423, category='ll', description='MATHEMATICAL BOLD SMALL J', specials={'font',0x006A} },
	[0x1D424] = { unicodeslot=0x1D424, category='ll', description='MATHEMATICAL BOLD SMALL K', specials={'font',0x006B} },
	[0x1D425] = { unicodeslot=0x1D425, category='ll', description='MATHEMATICAL BOLD SMALL L', specials={'font',0x006C} },
	[0x1D426] = { unicodeslot=0x1D426, category='ll', description='MATHEMATICAL BOLD SMALL M', specials={'font',0x006D} },
	[0x1D427] = { unicodeslot=0x1D427, category='ll', description='MATHEMATICAL BOLD SMALL N', specials={'font',0x006E} },
	[0x1D428] = { unicodeslot=0x1D428, category='ll', description='MATHEMATICAL BOLD SMALL O', specials={'font',0x006F} },
	[0x1D429] = { unicodeslot=0x1D429, category='ll', description='MATHEMATICAL BOLD SMALL P', specials={'font',0x0070} },
	[0x1D42A] = { unicodeslot=0x1D42A, category='ll', description='MATHEMATICAL BOLD SMALL Q', specials={'font',0x0071} },
	[0x1D42B] = { unicodeslot=0x1D42B, category='ll', description='MATHEMATICAL BOLD SMALL R', specials={'font',0x0072} },
	[0x1D42C] = { unicodeslot=0x1D42C, category='ll', description='MATHEMATICAL BOLD SMALL S', specials={'font',0x0073} },
	[0x1D42D] = { unicodeslot=0x1D42D, category='ll', description='MATHEMATICAL BOLD SMALL T', specials={'font',0x0074} },
	[0x1D42E] = { unicodeslot=0x1D42E, category='ll', description='MATHEMATICAL BOLD SMALL U', specials={'font',0x0075} },
	[0x1D42F] = { unicodeslot=0x1D42F, category='ll', description='MATHEMATICAL BOLD SMALL V', specials={'font',0x0076} },
	[0x1D430] = { unicodeslot=0x1D430, category='ll', description='MATHEMATICAL BOLD SMALL W', specials={'font',0x0077} },
	[0x1D431] = { unicodeslot=0x1D431, category='ll', description='MATHEMATICAL BOLD SMALL X', specials={'font',0x0078} },
	[0x1D432] = { unicodeslot=0x1D432, category='ll', description='MATHEMATICAL BOLD SMALL Y', specials={'font',0x0079} },
	[0x1D433] = { unicodeslot=0x1D433, category='ll', description='MATHEMATICAL BOLD SMALL Z', specials={'font',0x007A} },
	[0x1D434] = { unicodeslot=0x1D434, category='lu', description='MATHEMATICAL ITALIC CAPITAL A', specials={'font',0x0041} },
	[0x1D435] = { unicodeslot=0x1D435, category='lu', description='MATHEMATICAL ITALIC CAPITAL B', specials={'font',0x0042} },
	[0x1D436] = { unicodeslot=0x1D436, category='lu', description='MATHEMATICAL ITALIC CAPITAL C', specials={'font',0x0043} },
	[0x1D437] = { unicodeslot=0x1D437, category='lu', description='MATHEMATICAL ITALIC CAPITAL D', specials={'font',0x0044} },
	[0x1D438] = { unicodeslot=0x1D438, category='lu', description='MATHEMATICAL ITALIC CAPITAL E', specials={'font',0x0045} },
	[0x1D439] = { unicodeslot=0x1D439, category='lu', description='MATHEMATICAL ITALIC CAPITAL F', specials={'font',0x0046} },
	[0x1D43A] = { unicodeslot=0x1D43A, category='lu', description='MATHEMATICAL ITALIC CAPITAL G', specials={'font',0x0047} },
	[0x1D43B] = { unicodeslot=0x1D43B, category='lu', description='MATHEMATICAL ITALIC CAPITAL H', specials={'font',0x0048} },
	[0x1D43C] = { unicodeslot=0x1D43C, category='lu', description='MATHEMATICAL ITALIC CAPITAL I', specials={'font',0x0049} },
	[0x1D43D] = { unicodeslot=0x1D43D, category='lu', description='MATHEMATICAL ITALIC CAPITAL J', specials={'font',0x004A} },
	[0x1D43E] = { unicodeslot=0x1D43E, category='lu', description='MATHEMATICAL ITALIC CAPITAL K', specials={'font',0x004B} },
	[0x1D43F] = { unicodeslot=0x1D43F, category='lu', description='MATHEMATICAL ITALIC CAPITAL L', specials={'font',0x004C} },
	[0x1D440] = { unicodeslot=0x1D440, category='lu', description='MATHEMATICAL ITALIC CAPITAL M', specials={'font',0x004D} },
	[0x1D441] = { unicodeslot=0x1D441, category='lu', description='MATHEMATICAL ITALIC CAPITAL N', specials={'font',0x004E} },
	[0x1D442] = { unicodeslot=0x1D442, category='lu', description='MATHEMATICAL ITALIC CAPITAL O', specials={'font',0x004F} },
	[0x1D443] = { unicodeslot=0x1D443, category='lu', description='MATHEMATICAL ITALIC CAPITAL P', specials={'font',0x0050} },
	[0x1D444] = { unicodeslot=0x1D444, category='lu', description='MATHEMATICAL ITALIC CAPITAL Q', specials={'font',0x0051} },
	[0x1D445] = { unicodeslot=0x1D445, category='lu', description='MATHEMATICAL ITALIC CAPITAL R', specials={'font',0x0052} },
	[0x1D446] = { unicodeslot=0x1D446, category='lu', description='MATHEMATICAL ITALIC CAPITAL S', specials={'font',0x0053} },
	[0x1D447] = { unicodeslot=0x1D447, category='lu', description='MATHEMATICAL ITALIC CAPITAL T', specials={'font',0x0054} },
	[0x1D448] = { unicodeslot=0x1D448, category='lu', description='MATHEMATICAL ITALIC CAPITAL U', specials={'font',0x0055} },
	[0x1D449] = { unicodeslot=0x1D449, category='lu', description='MATHEMATICAL ITALIC CAPITAL V', specials={'font',0x0056} },
	[0x1D44A] = { unicodeslot=0x1D44A, category='lu', description='MATHEMATICAL ITALIC CAPITAL W', specials={'font',0x0057} },
	[0x1D44B] = { unicodeslot=0x1D44B, category='lu', description='MATHEMATICAL ITALIC CAPITAL X', specials={'font',0x0058} },
	[0x1D44C] = { unicodeslot=0x1D44C, category='lu', description='MATHEMATICAL ITALIC CAPITAL Y', specials={'font',0x0059} },
	[0x1D44D] = { unicodeslot=0x1D44D, category='lu', description='MATHEMATICAL ITALIC CAPITAL Z', specials={'font',0x005A} },
	[0x1D44E] = { unicodeslot=0x1D44E, category='ll', description='MATHEMATICAL ITALIC SMALL A', specials={'font',0x0061} },
	[0x1D44F] = { unicodeslot=0x1D44F, category='ll', description='MATHEMATICAL ITALIC SMALL B', specials={'font',0x0062} },
	[0x1D450] = { unicodeslot=0x1D450, category='ll', description='MATHEMATICAL ITALIC SMALL C', specials={'font',0x0063} },
	[0x1D451] = { unicodeslot=0x1D451, category='ll', description='MATHEMATICAL ITALIC SMALL D', specials={'font',0x0064} },
	[0x1D452] = { unicodeslot=0x1D452, category='ll', description='MATHEMATICAL ITALIC SMALL E', specials={'font',0x0065} },
	[0x1D453] = { unicodeslot=0x1D453, category='ll', description='MATHEMATICAL ITALIC SMALL F', specials={'font',0x0066} },
	[0x1D454] = { unicodeslot=0x1D454, category='ll', description='MATHEMATICAL ITALIC SMALL G', specials={'font',0x0067} },
	[0x1D456] = { unicodeslot=0x1D456, category='ll', description='MATHEMATICAL ITALIC SMALL I', specials={'font',0x0069} },
	[0x1D457] = { unicodeslot=0x1D457, category='ll', description='MATHEMATICAL ITALIC SMALL J', specials={'font',0x006A} },
	[0x1D458] = { unicodeslot=0x1D458, category='ll', description='MATHEMATICAL ITALIC SMALL K', specials={'font',0x006B} },
	[0x1D459] = { unicodeslot=0x1D459, category='ll', description='MATHEMATICAL ITALIC SMALL L', specials={'font',0x006C} },
	[0x1D45A] = { unicodeslot=0x1D45A, category='ll', description='MATHEMATICAL ITALIC SMALL M', specials={'font',0x006D} },
	[0x1D45B] = { unicodeslot=0x1D45B, category='ll', description='MATHEMATICAL ITALIC SMALL N', specials={'font',0x006E} },
	[0x1D45C] = { unicodeslot=0x1D45C, category='ll', description='MATHEMATICAL ITALIC SMALL O', specials={'font',0x006F} },
	[0x1D45D] = { unicodeslot=0x1D45D, category='ll', description='MATHEMATICAL ITALIC SMALL P', specials={'font',0x0070} },
	[0x1D45E] = { unicodeslot=0x1D45E, category='ll', description='MATHEMATICAL ITALIC SMALL Q', specials={'font',0x0071} },
	[0x1D45F] = { unicodeslot=0x1D45F, category='ll', description='MATHEMATICAL ITALIC SMALL R', specials={'font',0x0072} },
	[0x1D460] = { unicodeslot=0x1D460, category='ll', description='MATHEMATICAL ITALIC SMALL S', specials={'font',0x0073} },
	[0x1D461] = { unicodeslot=0x1D461, category='ll', description='MATHEMATICAL ITALIC SMALL T', specials={'font',0x0074} },
	[0x1D462] = { unicodeslot=0x1D462, category='ll', description='MATHEMATICAL ITALIC SMALL U', specials={'font',0x0075} },
	[0x1D463] = { unicodeslot=0x1D463, category='ll', description='MATHEMATICAL ITALIC SMALL V', specials={'font',0x0076} },
	[0x1D464] = { unicodeslot=0x1D464, category='ll', description='MATHEMATICAL ITALIC SMALL W', specials={'font',0x0077} },
	[0x1D465] = { unicodeslot=0x1D465, category='ll', description='MATHEMATICAL ITALIC SMALL X', specials={'font',0x0078} },
	[0x1D466] = { unicodeslot=0x1D466, category='ll', description='MATHEMATICAL ITALIC SMALL Y', specials={'font',0x0079} },
	[0x1D467] = { unicodeslot=0x1D467, category='ll', description='MATHEMATICAL ITALIC SMALL Z', specials={'font',0x007A} },
	[0x1D468] = { unicodeslot=0x1D468, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL A', specials={'font',0x0041} },
	[0x1D469] = { unicodeslot=0x1D469, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL B', specials={'font',0x0042} },
	[0x1D46A] = { unicodeslot=0x1D46A, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL C', specials={'font',0x0043} },
	[0x1D46B] = { unicodeslot=0x1D46B, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL D', specials={'font',0x0044} },
	[0x1D46C] = { unicodeslot=0x1D46C, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL E', specials={'font',0x0045} },
	[0x1D46D] = { unicodeslot=0x1D46D, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL F', specials={'font',0x0046} },
	[0x1D46E] = { unicodeslot=0x1D46E, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL G', specials={'font',0x0047} },
	[0x1D46F] = { unicodeslot=0x1D46F, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL H', specials={'font',0x0048} },
	[0x1D470] = { unicodeslot=0x1D470, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL I', specials={'font',0x0049} },
	[0x1D471] = { unicodeslot=0x1D471, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL J', specials={'font',0x004A} },
	[0x1D472] = { unicodeslot=0x1D472, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL K', specials={'font',0x004B} },
	[0x1D473] = { unicodeslot=0x1D473, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL L', specials={'font',0x004C} },
	[0x1D474] = { unicodeslot=0x1D474, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL M', specials={'font',0x004D} },
	[0x1D475] = { unicodeslot=0x1D475, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL N', specials={'font',0x004E} },
	[0x1D476] = { unicodeslot=0x1D476, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL O', specials={'font',0x004F} },
	[0x1D477] = { unicodeslot=0x1D477, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL P', specials={'font',0x0050} },
	[0x1D478] = { unicodeslot=0x1D478, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL Q', specials={'font',0x0051} },
	[0x1D479] = { unicodeslot=0x1D479, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL R', specials={'font',0x0052} },
	[0x1D47A] = { unicodeslot=0x1D47A, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL S', specials={'font',0x0053} },
	[0x1D47B] = { unicodeslot=0x1D47B, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL T', specials={'font',0x0054} },
	[0x1D47C] = { unicodeslot=0x1D47C, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL U', specials={'font',0x0055} },
	[0x1D47D] = { unicodeslot=0x1D47D, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL V', specials={'font',0x0056} },
	[0x1D47E] = { unicodeslot=0x1D47E, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL W', specials={'font',0x0057} },
	[0x1D47F] = { unicodeslot=0x1D47F, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL X', specials={'font',0x0058} },
	[0x1D480] = { unicodeslot=0x1D480, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL Y', specials={'font',0x0059} },
	[0x1D481] = { unicodeslot=0x1D481, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL Z', specials={'font',0x005A} },
	[0x1D482] = { unicodeslot=0x1D482, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL A', specials={'font',0x0061} },
	[0x1D483] = { unicodeslot=0x1D483, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL B', specials={'font',0x0062} },
	[0x1D484] = { unicodeslot=0x1D484, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL C', specials={'font',0x0063} },
	[0x1D485] = { unicodeslot=0x1D485, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL D', specials={'font',0x0064} },
	[0x1D486] = { unicodeslot=0x1D486, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL E', specials={'font',0x0065} },
	[0x1D487] = { unicodeslot=0x1D487, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL F', specials={'font',0x0066} },
	[0x1D488] = { unicodeslot=0x1D488, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL G', specials={'font',0x0067} },
	[0x1D489] = { unicodeslot=0x1D489, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL H', specials={'font',0x0068} },
	[0x1D48A] = { unicodeslot=0x1D48A, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL I', specials={'font',0x0069} },
	[0x1D48B] = { unicodeslot=0x1D48B, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL J', specials={'font',0x006A} },
	[0x1D48C] = { unicodeslot=0x1D48C, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL K', specials={'font',0x006B} },
	[0x1D48D] = { unicodeslot=0x1D48D, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL L', specials={'font',0x006C} },
	[0x1D48E] = { unicodeslot=0x1D48E, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL M', specials={'font',0x006D} },
	[0x1D48F] = { unicodeslot=0x1D48F, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL N', specials={'font',0x006E} },
	[0x1D490] = { unicodeslot=0x1D490, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL O', specials={'font',0x006F} },
	[0x1D491] = { unicodeslot=0x1D491, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL P', specials={'font',0x0070} },
	[0x1D492] = { unicodeslot=0x1D492, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL Q', specials={'font',0x0071} },
	[0x1D493] = { unicodeslot=0x1D493, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL R', specials={'font',0x0072} },
	[0x1D494] = { unicodeslot=0x1D494, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL S', specials={'font',0x0073} },
	[0x1D495] = { unicodeslot=0x1D495, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL T', specials={'font',0x0074} },
	[0x1D496] = { unicodeslot=0x1D496, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL U', specials={'font',0x0075} },
	[0x1D497] = { unicodeslot=0x1D497, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL V', specials={'font',0x0076} },
	[0x1D498] = { unicodeslot=0x1D498, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL W', specials={'font',0x0077} },
	[0x1D499] = { unicodeslot=0x1D499, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL X', specials={'font',0x0078} },
	[0x1D49A] = { unicodeslot=0x1D49A, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL Y', specials={'font',0x0079} },
	[0x1D49B] = { unicodeslot=0x1D49B, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL Z', specials={'font',0x007A} },
	[0x1D49C] = { unicodeslot=0x1D49C, category='lu', description='MATHEMATICAL SCRIPT CAPITAL A', specials={'font',0x0041} },
	[0x1D49E] = { unicodeslot=0x1D49E, category='lu', description='MATHEMATICAL SCRIPT CAPITAL C', specials={'font',0x0043} },
	[0x1D49F] = { unicodeslot=0x1D49F, category='lu', description='MATHEMATICAL SCRIPT CAPITAL D', specials={'font',0x0044} },
	[0x1D4A2] = { unicodeslot=0x1D4A2, category='lu', description='MATHEMATICAL SCRIPT CAPITAL G', specials={'font',0x0047} },
	[0x1D4A5] = { unicodeslot=0x1D4A5, category='lu', description='MATHEMATICAL SCRIPT CAPITAL J', specials={'font',0x004A} },
	[0x1D4A6] = { unicodeslot=0x1D4A6, category='lu', description='MATHEMATICAL SCRIPT CAPITAL K', specials={'font',0x004B} },
	[0x1D4A9] = { unicodeslot=0x1D4A9, category='lu', description='MATHEMATICAL SCRIPT CAPITAL N', specials={'font',0x004E} },
	[0x1D4AA] = { unicodeslot=0x1D4AA, category='lu', description='MATHEMATICAL SCRIPT CAPITAL O', specials={'font',0x004F} },
	[0x1D4AB] = { unicodeslot=0x1D4AB, category='lu', description='MATHEMATICAL SCRIPT CAPITAL P', specials={'font',0x0050} },
	[0x1D4AC] = { unicodeslot=0x1D4AC, category='lu', description='MATHEMATICAL SCRIPT CAPITAL Q', specials={'font',0x0051} },
	[0x1D4AE] = { unicodeslot=0x1D4AE, category='lu', description='MATHEMATICAL SCRIPT CAPITAL S', specials={'font',0x0053} },
	[0x1D4AF] = { unicodeslot=0x1D4AF, category='lu', description='MATHEMATICAL SCRIPT CAPITAL T', specials={'font',0x0054} },
	[0x1D4B0] = { unicodeslot=0x1D4B0, category='lu', description='MATHEMATICAL SCRIPT CAPITAL U', specials={'font',0x0055} },
	[0x1D4B1] = { unicodeslot=0x1D4B1, category='lu', description='MATHEMATICAL SCRIPT CAPITAL V', specials={'font',0x0056} },
	[0x1D4B2] = { unicodeslot=0x1D4B2, category='lu', description='MATHEMATICAL SCRIPT CAPITAL W', specials={'font',0x0057} },
	[0x1D4B3] = { unicodeslot=0x1D4B3, category='lu', description='MATHEMATICAL SCRIPT CAPITAL X', specials={'font',0x0058} },
	[0x1D4B4] = { unicodeslot=0x1D4B4, category='lu', description='MATHEMATICAL SCRIPT CAPITAL Y', specials={'font',0x0059} },
	[0x1D4B5] = { unicodeslot=0x1D4B5, category='lu', description='MATHEMATICAL SCRIPT CAPITAL Z', specials={'font',0x005A} },
	[0x1D4B6] = { unicodeslot=0x1D4B6, category='ll', description='MATHEMATICAL SCRIPT SMALL A', specials={'font',0x0061} },
	[0x1D4B7] = { unicodeslot=0x1D4B7, category='ll', description='MATHEMATICAL SCRIPT SMALL B', specials={'font',0x0062} },
	[0x1D4B8] = { unicodeslot=0x1D4B8, category='ll', description='MATHEMATICAL SCRIPT SMALL C', specials={'font',0x0063} },
	[0x1D4B9] = { unicodeslot=0x1D4B9, category='ll', description='MATHEMATICAL SCRIPT SMALL D', specials={'font',0x0064} },
	[0x1D4BB] = { unicodeslot=0x1D4BB, category='ll', description='MATHEMATICAL SCRIPT SMALL F', specials={'font',0x0066} },
	[0x1D4BD] = { unicodeslot=0x1D4BD, category='ll', description='MATHEMATICAL SCRIPT SMALL H', specials={'font',0x0068} },
	[0x1D4BE] = { unicodeslot=0x1D4BE, category='ll', description='MATHEMATICAL SCRIPT SMALL I', specials={'font',0x0069} },
	[0x1D4BF] = { unicodeslot=0x1D4BF, category='ll', description='MATHEMATICAL SCRIPT SMALL J', specials={'font',0x006A} },
	[0x1D4C0] = { unicodeslot=0x1D4C0, category='ll', description='MATHEMATICAL SCRIPT SMALL K', specials={'font',0x006B} },
	[0x1D4C1] = { unicodeslot=0x1D4C1, category='ll', description='MATHEMATICAL SCRIPT SMALL L', specials={'font',0x006C} },
	[0x1D4C2] = { unicodeslot=0x1D4C2, category='ll', description='MATHEMATICAL SCRIPT SMALL M', specials={'font',0x006D} },
	[0x1D4C3] = { unicodeslot=0x1D4C3, category='ll', description='MATHEMATICAL SCRIPT SMALL N', specials={'font',0x006E} },
	[0x1D4C5] = { unicodeslot=0x1D4C5, category='ll', description='MATHEMATICAL SCRIPT SMALL P', specials={'font',0x0070} },
	[0x1D4C6] = { unicodeslot=0x1D4C6, category='ll', description='MATHEMATICAL SCRIPT SMALL Q', specials={'font',0x0071} },
	[0x1D4C7] = { unicodeslot=0x1D4C7, category='ll', description='MATHEMATICAL SCRIPT SMALL R', specials={'font',0x0072} },
	[0x1D4C8] = { unicodeslot=0x1D4C8, category='ll', description='MATHEMATICAL SCRIPT SMALL S', specials={'font',0x0073} },
	[0x1D4C9] = { unicodeslot=0x1D4C9, category='ll', description='MATHEMATICAL SCRIPT SMALL T', specials={'font',0x0074} },
	[0x1D4CA] = { unicodeslot=0x1D4CA, category='ll', description='MATHEMATICAL SCRIPT SMALL U', specials={'font',0x0075} },
	[0x1D4CB] = { unicodeslot=0x1D4CB, category='ll', description='MATHEMATICAL SCRIPT SMALL V', specials={'font',0x0076} },
	[0x1D4CC] = { unicodeslot=0x1D4CC, category='ll', description='MATHEMATICAL SCRIPT SMALL W', specials={'font',0x0077} },
	[0x1D4CD] = { unicodeslot=0x1D4CD, category='ll', description='MATHEMATICAL SCRIPT SMALL X', specials={'font',0x0078} },
	[0x1D4CE] = { unicodeslot=0x1D4CE, category='ll', description='MATHEMATICAL SCRIPT SMALL Y', specials={'font',0x0079} },
	[0x1D4CF] = { unicodeslot=0x1D4CF, category='ll', description='MATHEMATICAL SCRIPT SMALL Z', specials={'font',0x007A} },
	[0x1D4D0] = { unicodeslot=0x1D4D0, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL A', specials={'font',0x0041} },
	[0x1D4D1] = { unicodeslot=0x1D4D1, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL B', specials={'font',0x0042} },
	[0x1D4D2] = { unicodeslot=0x1D4D2, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL C', specials={'font',0x0043} },
	[0x1D4D3] = { unicodeslot=0x1D4D3, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL D', specials={'font',0x0044} },
	[0x1D4D4] = { unicodeslot=0x1D4D4, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL E', specials={'font',0x0045} },
	[0x1D4D5] = { unicodeslot=0x1D4D5, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL F', specials={'font',0x0046} },
	[0x1D4D6] = { unicodeslot=0x1D4D6, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL G', specials={'font',0x0047} },
	[0x1D4D7] = { unicodeslot=0x1D4D7, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL H', specials={'font',0x0048} },
	[0x1D4D8] = { unicodeslot=0x1D4D8, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL I', specials={'font',0x0049} },
	[0x1D4D9] = { unicodeslot=0x1D4D9, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL J', specials={'font',0x004A} },
	[0x1D4DA] = { unicodeslot=0x1D4DA, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL K', specials={'font',0x004B} },
	[0x1D4DB] = { unicodeslot=0x1D4DB, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL L', specials={'font',0x004C} },
	[0x1D4DC] = { unicodeslot=0x1D4DC, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL M', specials={'font',0x004D} },
	[0x1D4DD] = { unicodeslot=0x1D4DD, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL N', specials={'font',0x004E} },
	[0x1D4DE] = { unicodeslot=0x1D4DE, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL O', specials={'font',0x004F} },
	[0x1D4DF] = { unicodeslot=0x1D4DF, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL P', specials={'font',0x0050} },
	[0x1D4E0] = { unicodeslot=0x1D4E0, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL Q', specials={'font',0x0051} },
	[0x1D4E1] = { unicodeslot=0x1D4E1, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL R', specials={'font',0x0052} },
	[0x1D4E2] = { unicodeslot=0x1D4E2, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL S', specials={'font',0x0053} },
	[0x1D4E3] = { unicodeslot=0x1D4E3, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL T', specials={'font',0x0054} },
	[0x1D4E4] = { unicodeslot=0x1D4E4, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL U', specials={'font',0x0055} },
	[0x1D4E5] = { unicodeslot=0x1D4E5, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL V', specials={'font',0x0056} },
	[0x1D4E6] = { unicodeslot=0x1D4E6, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL W', specials={'font',0x0057} },
	[0x1D4E7] = { unicodeslot=0x1D4E7, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL X', specials={'font',0x0058} },
	[0x1D4E8] = { unicodeslot=0x1D4E8, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL Y', specials={'font',0x0059} },
	[0x1D4E9] = { unicodeslot=0x1D4E9, category='lu', description='MATHEMATICAL BOLD SCRIPT CAPITAL Z', specials={'font',0x005A} },
	[0x1D4EA] = { unicodeslot=0x1D4EA, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL A', specials={'font',0x0061} },
	[0x1D4EB] = { unicodeslot=0x1D4EB, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL B', specials={'font',0x0062} },
	[0x1D4EC] = { unicodeslot=0x1D4EC, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL C', specials={'font',0x0063} },
	[0x1D4ED] = { unicodeslot=0x1D4ED, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL D', specials={'font',0x0064} },
	[0x1D4EE] = { unicodeslot=0x1D4EE, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL E', specials={'font',0x0065} },
	[0x1D4EF] = { unicodeslot=0x1D4EF, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL F', specials={'font',0x0066} },
	[0x1D4F0] = { unicodeslot=0x1D4F0, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL G', specials={'font',0x0067} },
	[0x1D4F1] = { unicodeslot=0x1D4F1, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL H', specials={'font',0x0068} },
	[0x1D4F2] = { unicodeslot=0x1D4F2, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL I', specials={'font',0x0069} },
	[0x1D4F3] = { unicodeslot=0x1D4F3, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL J', specials={'font',0x006A} },
	[0x1D4F4] = { unicodeslot=0x1D4F4, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL K', specials={'font',0x006B} },
	[0x1D4F5] = { unicodeslot=0x1D4F5, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL L', specials={'font',0x006C} },
	[0x1D4F6] = { unicodeslot=0x1D4F6, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL M', specials={'font',0x006D} },
	[0x1D4F7] = { unicodeslot=0x1D4F7, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL N', specials={'font',0x006E} },
	[0x1D4F8] = { unicodeslot=0x1D4F8, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL O', specials={'font',0x006F} },
	[0x1D4F9] = { unicodeslot=0x1D4F9, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL P', specials={'font',0x0070} },
	[0x1D4FA] = { unicodeslot=0x1D4FA, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL Q', specials={'font',0x0071} },
	[0x1D4FB] = { unicodeslot=0x1D4FB, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL R', specials={'font',0x0072} },
	[0x1D4FC] = { unicodeslot=0x1D4FC, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL S', specials={'font',0x0073} },
	[0x1D4FD] = { unicodeslot=0x1D4FD, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL T', specials={'font',0x0074} },
	[0x1D4FE] = { unicodeslot=0x1D4FE, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL U', specials={'font',0x0075} },
	[0x1D4FF] = { unicodeslot=0x1D4FF, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL V', specials={'font',0x0076} },
	[0x1D500] = { unicodeslot=0x1D500, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL W', specials={'font',0x0077} },
	[0x1D501] = { unicodeslot=0x1D501, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL X', specials={'font',0x0078} },
	[0x1D502] = { unicodeslot=0x1D502, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL Y', specials={'font',0x0079} },
	[0x1D503] = { unicodeslot=0x1D503, category='ll', description='MATHEMATICAL BOLD SCRIPT SMALL Z', specials={'font',0x007A} },
	[0x1D504] = { unicodeslot=0x1D504, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL A', specials={'font',0x0041} },
	[0x1D505] = { unicodeslot=0x1D505, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL B', specials={'font',0x0042} },
	[0x1D507] = { unicodeslot=0x1D507, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL D', specials={'font',0x0044} },
	[0x1D508] = { unicodeslot=0x1D508, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL E', specials={'font',0x0045} },
	[0x1D509] = { unicodeslot=0x1D509, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL F', specials={'font',0x0046} },
	[0x1D50A] = { unicodeslot=0x1D50A, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL G', specials={'font',0x0047} },
	[0x1D50D] = { unicodeslot=0x1D50D, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL J', specials={'font',0x004A} },
	[0x1D50E] = { unicodeslot=0x1D50E, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL K', specials={'font',0x004B} },
	[0x1D50F] = { unicodeslot=0x1D50F, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL L', specials={'font',0x004C} },
	[0x1D510] = { unicodeslot=0x1D510, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL M', specials={'font',0x004D} },
	[0x1D511] = { unicodeslot=0x1D511, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL N', specials={'font',0x004E} },
	[0x1D512] = { unicodeslot=0x1D512, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL O', specials={'font',0x004F} },
	[0x1D513] = { unicodeslot=0x1D513, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL P', specials={'font',0x0050} },
	[0x1D514] = { unicodeslot=0x1D514, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL Q', specials={'font',0x0051} },
	[0x1D516] = { unicodeslot=0x1D516, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL S', specials={'font',0x0053} },
	[0x1D517] = { unicodeslot=0x1D517, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL T', specials={'font',0x0054} },
	[0x1D518] = { unicodeslot=0x1D518, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL U', specials={'font',0x0055} },
	[0x1D519] = { unicodeslot=0x1D519, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL V', specials={'font',0x0056} },
	[0x1D51A] = { unicodeslot=0x1D51A, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL W', specials={'font',0x0057} },
	[0x1D51B] = { unicodeslot=0x1D51B, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL X', specials={'font',0x0058} },
	[0x1D51C] = { unicodeslot=0x1D51C, category='lu', description='MATHEMATICAL FRAKTUR CAPITAL Y', specials={'font',0x0059} },
	[0x1D51E] = { unicodeslot=0x1D51E, category='ll', description='MATHEMATICAL FRAKTUR SMALL A', specials={'font',0x0061} },
	[0x1D51F] = { unicodeslot=0x1D51F, category='ll', description='MATHEMATICAL FRAKTUR SMALL B', specials={'font',0x0062} },
	[0x1D520] = { unicodeslot=0x1D520, category='ll', description='MATHEMATICAL FRAKTUR SMALL C', specials={'font',0x0063} },
	[0x1D521] = { unicodeslot=0x1D521, category='ll', description='MATHEMATICAL FRAKTUR SMALL D', specials={'font',0x0064} },
	[0x1D522] = { unicodeslot=0x1D522, category='ll', description='MATHEMATICAL FRAKTUR SMALL E', specials={'font',0x0065} },
	[0x1D523] = { unicodeslot=0x1D523, category='ll', description='MATHEMATICAL FRAKTUR SMALL F', specials={'font',0x0066} },
	[0x1D524] = { unicodeslot=0x1D524, category='ll', description='MATHEMATICAL FRAKTUR SMALL G', specials={'font',0x0067} },
	[0x1D525] = { unicodeslot=0x1D525, category='ll', description='MATHEMATICAL FRAKTUR SMALL H', specials={'font',0x0068} },
	[0x1D526] = { unicodeslot=0x1D526, category='ll', description='MATHEMATICAL FRAKTUR SMALL I', specials={'font',0x0069} },
	[0x1D527] = { unicodeslot=0x1D527, category='ll', description='MATHEMATICAL FRAKTUR SMALL J', specials={'font',0x006A} },
	[0x1D528] = { unicodeslot=0x1D528, category='ll', description='MATHEMATICAL FRAKTUR SMALL K', specials={'font',0x006B} },
	[0x1D529] = { unicodeslot=0x1D529, category='ll', description='MATHEMATICAL FRAKTUR SMALL L', specials={'font',0x006C} },
	[0x1D52A] = { unicodeslot=0x1D52A, category='ll', description='MATHEMATICAL FRAKTUR SMALL M', specials={'font',0x006D} },
	[0x1D52B] = { unicodeslot=0x1D52B, category='ll', description='MATHEMATICAL FRAKTUR SMALL N', specials={'font',0x006E} },
	[0x1D52C] = { unicodeslot=0x1D52C, category='ll', description='MATHEMATICAL FRAKTUR SMALL O', specials={'font',0x006F} },
	[0x1D52D] = { unicodeslot=0x1D52D, category='ll', description='MATHEMATICAL FRAKTUR SMALL P', specials={'font',0x0070} },
	[0x1D52E] = { unicodeslot=0x1D52E, category='ll', description='MATHEMATICAL FRAKTUR SMALL Q', specials={'font',0x0071} },
	[0x1D52F] = { unicodeslot=0x1D52F, category='ll', description='MATHEMATICAL FRAKTUR SMALL R', specials={'font',0x0072} },
	[0x1D530] = { unicodeslot=0x1D530, category='ll', description='MATHEMATICAL FRAKTUR SMALL S', specials={'font',0x0073} },
	[0x1D531] = { unicodeslot=0x1D531, category='ll', description='MATHEMATICAL FRAKTUR SMALL T', specials={'font',0x0074} },
	[0x1D532] = { unicodeslot=0x1D532, category='ll', description='MATHEMATICAL FRAKTUR SMALL U', specials={'font',0x0075} },
	[0x1D533] = { unicodeslot=0x1D533, category='ll', description='MATHEMATICAL FRAKTUR SMALL V', specials={'font',0x0076} },
	[0x1D534] = { unicodeslot=0x1D534, category='ll', description='MATHEMATICAL FRAKTUR SMALL W', specials={'font',0x0077} },
	[0x1D535] = { unicodeslot=0x1D535, category='ll', description='MATHEMATICAL FRAKTUR SMALL X', specials={'font',0x0078} },
	[0x1D536] = { unicodeslot=0x1D536, category='ll', description='MATHEMATICAL FRAKTUR SMALL Y', specials={'font',0x0079} },
	[0x1D537] = { unicodeslot=0x1D537, category='ll', description='MATHEMATICAL FRAKTUR SMALL Z', specials={'font',0x007A} },
	[0x1D538] = { unicodeslot=0x1D538, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL A', specials={'font',0x0041} },
	[0x1D539] = { unicodeslot=0x1D539, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL B', specials={'font',0x0042} },
	[0x1D53B] = { unicodeslot=0x1D53B, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL D', specials={'font',0x0044} },
	[0x1D53C] = { unicodeslot=0x1D53C, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL E', specials={'font',0x0045} },
	[0x1D53D] = { unicodeslot=0x1D53D, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL F', specials={'font',0x0046} },
	[0x1D53E] = { unicodeslot=0x1D53E, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL G', specials={'font',0x0047} },
	[0x1D540] = { unicodeslot=0x1D540, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL I', specials={'font',0x0049} },
	[0x1D541] = { unicodeslot=0x1D541, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL J', specials={'font',0x004A} },
	[0x1D542] = { unicodeslot=0x1D542, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL K', specials={'font',0x004B} },
	[0x1D543] = { unicodeslot=0x1D543, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL L', specials={'font',0x004C} },
	[0x1D544] = { unicodeslot=0x1D544, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL M', specials={'font',0x004D} },
	[0x1D546] = { unicodeslot=0x1D546, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL O', specials={'font',0x004F} },
	[0x1D54A] = { unicodeslot=0x1D54A, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL S', specials={'font',0x0053} },
	[0x1D54B] = { unicodeslot=0x1D54B, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL T', specials={'font',0x0054} },
	[0x1D54C] = { unicodeslot=0x1D54C, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL U', specials={'font',0x0055} },
	[0x1D54D] = { unicodeslot=0x1D54D, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL V', specials={'font',0x0056} },
	[0x1D54E] = { unicodeslot=0x1D54E, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL W', specials={'font',0x0057} },
	[0x1D54F] = { unicodeslot=0x1D54F, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL X', specials={'font',0x0058} },
	[0x1D550] = { unicodeslot=0x1D550, category='lu', description='MATHEMATICAL DOUBLE-STRUCK CAPITAL Y', specials={'font',0x0059} },
	[0x1D552] = { unicodeslot=0x1D552, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL A', specials={'font',0x0061} },
	[0x1D553] = { unicodeslot=0x1D553, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL B', specials={'font',0x0062} },
	[0x1D554] = { unicodeslot=0x1D554, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL C', specials={'font',0x0063} },
	[0x1D555] = { unicodeslot=0x1D555, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL D', specials={'font',0x0064} },
	[0x1D556] = { unicodeslot=0x1D556, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL E', specials={'font',0x0065} },
	[0x1D557] = { unicodeslot=0x1D557, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL F', specials={'font',0x0066} },
	[0x1D558] = { unicodeslot=0x1D558, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL G', specials={'font',0x0067} },
	[0x1D559] = { unicodeslot=0x1D559, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL H', specials={'font',0x0068} },
	[0x1D55A] = { unicodeslot=0x1D55A, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL I', specials={'font',0x0069} },
	[0x1D55B] = { unicodeslot=0x1D55B, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL J', specials={'font',0x006A} },
	[0x1D55C] = { unicodeslot=0x1D55C, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL K', specials={'font',0x006B} },
	[0x1D55D] = { unicodeslot=0x1D55D, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL L', specials={'font',0x006C} },
	[0x1D55E] = { unicodeslot=0x1D55E, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL M', specials={'font',0x006D} },
	[0x1D55F] = { unicodeslot=0x1D55F, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL N', specials={'font',0x006E} },
	[0x1D560] = { unicodeslot=0x1D560, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL O', specials={'font',0x006F} },
	[0x1D561] = { unicodeslot=0x1D561, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL P', specials={'font',0x0070} },
	[0x1D562] = { unicodeslot=0x1D562, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL Q', specials={'font',0x0071} },
	[0x1D563] = { unicodeslot=0x1D563, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL R', specials={'font',0x0072} },
	[0x1D564] = { unicodeslot=0x1D564, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL S', specials={'font',0x0073} },
	[0x1D565] = { unicodeslot=0x1D565, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL T', specials={'font',0x0074} },
	[0x1D566] = { unicodeslot=0x1D566, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL U', specials={'font',0x0075} },
	[0x1D567] = { unicodeslot=0x1D567, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL V', specials={'font',0x0076} },
	[0x1D568] = { unicodeslot=0x1D568, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL W', specials={'font',0x0077} },
	[0x1D569] = { unicodeslot=0x1D569, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL X', specials={'font',0x0078} },
	[0x1D56A] = { unicodeslot=0x1D56A, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL Y', specials={'font',0x0079} },
	[0x1D56B] = { unicodeslot=0x1D56B, category='ll', description='MATHEMATICAL DOUBLE-STRUCK SMALL Z', specials={'font',0x007A} },
	[0x1D56C] = { unicodeslot=0x1D56C, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL A', specials={'font',0x0041} },
	[0x1D56D] = { unicodeslot=0x1D56D, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL B', specials={'font',0x0042} },
	[0x1D56E] = { unicodeslot=0x1D56E, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL C', specials={'font',0x0043} },
	[0x1D56F] = { unicodeslot=0x1D56F, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL D', specials={'font',0x0044} },
	[0x1D570] = { unicodeslot=0x1D570, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL E', specials={'font',0x0045} },
	[0x1D571] = { unicodeslot=0x1D571, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL F', specials={'font',0x0046} },
	[0x1D572] = { unicodeslot=0x1D572, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL G', specials={'font',0x0047} },
	[0x1D573] = { unicodeslot=0x1D573, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL H', specials={'font',0x0048} },
	[0x1D574] = { unicodeslot=0x1D574, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL I', specials={'font',0x0049} },
	[0x1D575] = { unicodeslot=0x1D575, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL J', specials={'font',0x004A} },
	[0x1D576] = { unicodeslot=0x1D576, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL K', specials={'font',0x004B} },
	[0x1D577] = { unicodeslot=0x1D577, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL L', specials={'font',0x004C} },
	[0x1D578] = { unicodeslot=0x1D578, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL M', specials={'font',0x004D} },
	[0x1D579] = { unicodeslot=0x1D579, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL N', specials={'font',0x004E} },
	[0x1D57A] = { unicodeslot=0x1D57A, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL O', specials={'font',0x004F} },
	[0x1D57B] = { unicodeslot=0x1D57B, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL P', specials={'font',0x0050} },
	[0x1D57C] = { unicodeslot=0x1D57C, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL Q', specials={'font',0x0051} },
	[0x1D57D] = { unicodeslot=0x1D57D, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL R', specials={'font',0x0052} },
	[0x1D57E] = { unicodeslot=0x1D57E, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL S', specials={'font',0x0053} },
	[0x1D57F] = { unicodeslot=0x1D57F, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL T', specials={'font',0x0054} },
	[0x1D580] = { unicodeslot=0x1D580, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL U', specials={'font',0x0055} },
	[0x1D581] = { unicodeslot=0x1D581, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL V', specials={'font',0x0056} },
	[0x1D582] = { unicodeslot=0x1D582, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL W', specials={'font',0x0057} },
	[0x1D583] = { unicodeslot=0x1D583, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL X', specials={'font',0x0058} },
	[0x1D584] = { unicodeslot=0x1D584, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL Y', specials={'font',0x0059} },
	[0x1D585] = { unicodeslot=0x1D585, category='lu', description='MATHEMATICAL BOLD FRAKTUR CAPITAL Z', specials={'font',0x005A} },
	[0x1D586] = { unicodeslot=0x1D586, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL A', specials={'font',0x0061} },
	[0x1D587] = { unicodeslot=0x1D587, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL B', specials={'font',0x0062} },
	[0x1D588] = { unicodeslot=0x1D588, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL C', specials={'font',0x0063} },
	[0x1D589] = { unicodeslot=0x1D589, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL D', specials={'font',0x0064} },
	[0x1D58A] = { unicodeslot=0x1D58A, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL E', specials={'font',0x0065} },
	[0x1D58B] = { unicodeslot=0x1D58B, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL F', specials={'font',0x0066} },
	[0x1D58C] = { unicodeslot=0x1D58C, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL G', specials={'font',0x0067} },
	[0x1D58D] = { unicodeslot=0x1D58D, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL H', specials={'font',0x0068} },
	[0x1D58E] = { unicodeslot=0x1D58E, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL I', specials={'font',0x0069} },
	[0x1D58F] = { unicodeslot=0x1D58F, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL J', specials={'font',0x006A} },
	[0x1D590] = { unicodeslot=0x1D590, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL K', specials={'font',0x006B} },
	[0x1D591] = { unicodeslot=0x1D591, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL L', specials={'font',0x006C} },
	[0x1D592] = { unicodeslot=0x1D592, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL M', specials={'font',0x006D} },
	[0x1D593] = { unicodeslot=0x1D593, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL N', specials={'font',0x006E} },
	[0x1D594] = { unicodeslot=0x1D594, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL O', specials={'font',0x006F} },
	[0x1D595] = { unicodeslot=0x1D595, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL P', specials={'font',0x0070} },
	[0x1D596] = { unicodeslot=0x1D596, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL Q', specials={'font',0x0071} },
	[0x1D597] = { unicodeslot=0x1D597, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL R', specials={'font',0x0072} },
	[0x1D598] = { unicodeslot=0x1D598, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL S', specials={'font',0x0073} },
	[0x1D599] = { unicodeslot=0x1D599, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL T', specials={'font',0x0074} },
	[0x1D59A] = { unicodeslot=0x1D59A, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL U', specials={'font',0x0075} },
	[0x1D59B] = { unicodeslot=0x1D59B, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL V', specials={'font',0x0076} },
	[0x1D59C] = { unicodeslot=0x1D59C, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL W', specials={'font',0x0077} },
	[0x1D59D] = { unicodeslot=0x1D59D, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL X', specials={'font',0x0078} },
	[0x1D59E] = { unicodeslot=0x1D59E, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL Y', specials={'font',0x0079} },
	[0x1D59F] = { unicodeslot=0x1D59F, category='ll', description='MATHEMATICAL BOLD FRAKTUR SMALL Z', specials={'font',0x007A} },
	[0x1D5A0] = { unicodeslot=0x1D5A0, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL A', specials={'font',0x0041} },
	[0x1D5A1] = { unicodeslot=0x1D5A1, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL B', specials={'font',0x0042} },
	[0x1D5A2] = { unicodeslot=0x1D5A2, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL C', specials={'font',0x0043} },
	[0x1D5A3] = { unicodeslot=0x1D5A3, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL D', specials={'font',0x0044} },
	[0x1D5A4] = { unicodeslot=0x1D5A4, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL E', specials={'font',0x0045} },
	[0x1D5A5] = { unicodeslot=0x1D5A5, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL F', specials={'font',0x0046} },
	[0x1D5A6] = { unicodeslot=0x1D5A6, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL G', specials={'font',0x0047} },
	[0x1D5A7] = { unicodeslot=0x1D5A7, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL H', specials={'font',0x0048} },
	[0x1D5A8] = { unicodeslot=0x1D5A8, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL I', specials={'font',0x0049} },
	[0x1D5A9] = { unicodeslot=0x1D5A9, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL J', specials={'font',0x004A} },
	[0x1D5AA] = { unicodeslot=0x1D5AA, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL K', specials={'font',0x004B} },
	[0x1D5AB] = { unicodeslot=0x1D5AB, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL L', specials={'font',0x004C} },
	[0x1D5AC] = { unicodeslot=0x1D5AC, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL M', specials={'font',0x004D} },
	[0x1D5AD] = { unicodeslot=0x1D5AD, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL N', specials={'font',0x004E} },
	[0x1D5AE] = { unicodeslot=0x1D5AE, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL O', specials={'font',0x004F} },
	[0x1D5AF] = { unicodeslot=0x1D5AF, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL P', specials={'font',0x0050} },
	[0x1D5B0] = { unicodeslot=0x1D5B0, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL Q', specials={'font',0x0051} },
	[0x1D5B1] = { unicodeslot=0x1D5B1, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL R', specials={'font',0x0052} },
	[0x1D5B2] = { unicodeslot=0x1D5B2, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL S', specials={'font',0x0053} },
	[0x1D5B3] = { unicodeslot=0x1D5B3, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL T', specials={'font',0x0054} },
	[0x1D5B4] = { unicodeslot=0x1D5B4, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL U', specials={'font',0x0055} },
	[0x1D5B5] = { unicodeslot=0x1D5B5, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL V', specials={'font',0x0056} },
	[0x1D5B6] = { unicodeslot=0x1D5B6, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL W', specials={'font',0x0057} },
	[0x1D5B7] = { unicodeslot=0x1D5B7, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL X', specials={'font',0x0058} },
	[0x1D5B8] = { unicodeslot=0x1D5B8, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL Y', specials={'font',0x0059} },
	[0x1D5B9] = { unicodeslot=0x1D5B9, category='lu', description='MATHEMATICAL SANS-SERIF CAPITAL Z', specials={'font',0x005A} },
	[0x1D5BA] = { unicodeslot=0x1D5BA, category='ll', description='MATHEMATICAL SANS-SERIF SMALL A', specials={'font',0x0061} },
	[0x1D5BB] = { unicodeslot=0x1D5BB, category='ll', description='MATHEMATICAL SANS-SERIF SMALL B', specials={'font',0x0062} },
	[0x1D5BC] = { unicodeslot=0x1D5BC, category='ll', description='MATHEMATICAL SANS-SERIF SMALL C', specials={'font',0x0063} },
	[0x1D5BD] = { unicodeslot=0x1D5BD, category='ll', description='MATHEMATICAL SANS-SERIF SMALL D', specials={'font',0x0064} },
	[0x1D5BE] = { unicodeslot=0x1D5BE, category='ll', description='MATHEMATICAL SANS-SERIF SMALL E', specials={'font',0x0065} },
	[0x1D5BF] = { unicodeslot=0x1D5BF, category='ll', description='MATHEMATICAL SANS-SERIF SMALL F', specials={'font',0x0066} },
	[0x1D5C0] = { unicodeslot=0x1D5C0, category='ll', description='MATHEMATICAL SANS-SERIF SMALL G', specials={'font',0x0067} },
	[0x1D5C1] = { unicodeslot=0x1D5C1, category='ll', description='MATHEMATICAL SANS-SERIF SMALL H', specials={'font',0x0068} },
	[0x1D5C2] = { unicodeslot=0x1D5C2, category='ll', description='MATHEMATICAL SANS-SERIF SMALL I', specials={'font',0x0069} },
	[0x1D5C3] = { unicodeslot=0x1D5C3, category='ll', description='MATHEMATICAL SANS-SERIF SMALL J', specials={'font',0x006A} },
	[0x1D5C4] = { unicodeslot=0x1D5C4, category='ll', description='MATHEMATICAL SANS-SERIF SMALL K', specials={'font',0x006B} },
	[0x1D5C5] = { unicodeslot=0x1D5C5, category='ll', description='MATHEMATICAL SANS-SERIF SMALL L', specials={'font',0x006C} },
	[0x1D5C6] = { unicodeslot=0x1D5C6, category='ll', description='MATHEMATICAL SANS-SERIF SMALL M', specials={'font',0x006D} },
	[0x1D5C7] = { unicodeslot=0x1D5C7, category='ll', description='MATHEMATICAL SANS-SERIF SMALL N', specials={'font',0x006E} },
	[0x1D5C8] = { unicodeslot=0x1D5C8, category='ll', description='MATHEMATICAL SANS-SERIF SMALL O', specials={'font',0x006F} },
	[0x1D5C9] = { unicodeslot=0x1D5C9, category='ll', description='MATHEMATICAL SANS-SERIF SMALL P', specials={'font',0x0070} },
	[0x1D5CA] = { unicodeslot=0x1D5CA, category='ll', description='MATHEMATICAL SANS-SERIF SMALL Q', specials={'font',0x0071} },
	[0x1D5CB] = { unicodeslot=0x1D5CB, category='ll', description='MATHEMATICAL SANS-SERIF SMALL R', specials={'font',0x0072} },
	[0x1D5CC] = { unicodeslot=0x1D5CC, category='ll', description='MATHEMATICAL SANS-SERIF SMALL S', specials={'font',0x0073} },
	[0x1D5CD] = { unicodeslot=0x1D5CD, category='ll', description='MATHEMATICAL SANS-SERIF SMALL T', specials={'font',0x0074} },
	[0x1D5CE] = { unicodeslot=0x1D5CE, category='ll', description='MATHEMATICAL SANS-SERIF SMALL U', specials={'font',0x0075} },
	[0x1D5CF] = { unicodeslot=0x1D5CF, category='ll', description='MATHEMATICAL SANS-SERIF SMALL V', specials={'font',0x0076} },
	[0x1D5D0] = { unicodeslot=0x1D5D0, category='ll', description='MATHEMATICAL SANS-SERIF SMALL W', specials={'font',0x0077} },
	[0x1D5D1] = { unicodeslot=0x1D5D1, category='ll', description='MATHEMATICAL SANS-SERIF SMALL X', specials={'font',0x0078} },
	[0x1D5D2] = { unicodeslot=0x1D5D2, category='ll', description='MATHEMATICAL SANS-SERIF SMALL Y', specials={'font',0x0079} },
	[0x1D5D3] = { unicodeslot=0x1D5D3, category='ll', description='MATHEMATICAL SANS-SERIF SMALL Z', specials={'font',0x007A} },
	[0x1D5D4] = { unicodeslot=0x1D5D4, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL A', specials={'font',0x0041} },
	[0x1D5D5] = { unicodeslot=0x1D5D5, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL B', specials={'font',0x0042} },
	[0x1D5D6] = { unicodeslot=0x1D5D6, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL C', specials={'font',0x0043} },
	[0x1D5D7] = { unicodeslot=0x1D5D7, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL D', specials={'font',0x0044} },
	[0x1D5D8] = { unicodeslot=0x1D5D8, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL E', specials={'font',0x0045} },
	[0x1D5D9] = { unicodeslot=0x1D5D9, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL F', specials={'font',0x0046} },
	[0x1D5DA] = { unicodeslot=0x1D5DA, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL G', specials={'font',0x0047} },
	[0x1D5DB] = { unicodeslot=0x1D5DB, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL H', specials={'font',0x0048} },
	[0x1D5DC] = { unicodeslot=0x1D5DC, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL I', specials={'font',0x0049} },
	[0x1D5DD] = { unicodeslot=0x1D5DD, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL J', specials={'font',0x004A} },
	[0x1D5DE] = { unicodeslot=0x1D5DE, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL K', specials={'font',0x004B} },
	[0x1D5DF] = { unicodeslot=0x1D5DF, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL L', specials={'font',0x004C} },
	[0x1D5E0] = { unicodeslot=0x1D5E0, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL M', specials={'font',0x004D} },
	[0x1D5E1] = { unicodeslot=0x1D5E1, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL N', specials={'font',0x004E} },
	[0x1D5E2] = { unicodeslot=0x1D5E2, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL O', specials={'font',0x004F} },
	[0x1D5E3] = { unicodeslot=0x1D5E3, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL P', specials={'font',0x0050} },
	[0x1D5E4] = { unicodeslot=0x1D5E4, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL Q', specials={'font',0x0051} },
	[0x1D5E5] = { unicodeslot=0x1D5E5, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL R', specials={'font',0x0052} },
	[0x1D5E6] = { unicodeslot=0x1D5E6, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL S', specials={'font',0x0053} },
	[0x1D5E7] = { unicodeslot=0x1D5E7, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL T', specials={'font',0x0054} },
	[0x1D5E8] = { unicodeslot=0x1D5E8, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL U', specials={'font',0x0055} },
	[0x1D5E9] = { unicodeslot=0x1D5E9, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL V', specials={'font',0x0056} },
	[0x1D5EA] = { unicodeslot=0x1D5EA, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL W', specials={'font',0x0057} },
	[0x1D5EB] = { unicodeslot=0x1D5EB, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL X', specials={'font',0x0058} },
	[0x1D5EC] = { unicodeslot=0x1D5EC, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL Y', specials={'font',0x0059} },
	[0x1D5ED] = { unicodeslot=0x1D5ED, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL Z', specials={'font',0x005A} },
	[0x1D5EE] = { unicodeslot=0x1D5EE, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL A', specials={'font',0x0061} },
	[0x1D5EF] = { unicodeslot=0x1D5EF, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL B', specials={'font',0x0062} },
	[0x1D5F0] = { unicodeslot=0x1D5F0, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL C', specials={'font',0x0063} },
	[0x1D5F1] = { unicodeslot=0x1D5F1, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL D', specials={'font',0x0064} },
	[0x1D5F2] = { unicodeslot=0x1D5F2, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL E', specials={'font',0x0065} },
	[0x1D5F3] = { unicodeslot=0x1D5F3, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL F', specials={'font',0x0066} },
	[0x1D5F4] = { unicodeslot=0x1D5F4, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL G', specials={'font',0x0067} },
	[0x1D5F5] = { unicodeslot=0x1D5F5, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL H', specials={'font',0x0068} },
	[0x1D5F6] = { unicodeslot=0x1D5F6, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL I', specials={'font',0x0069} },
	[0x1D5F7] = { unicodeslot=0x1D5F7, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL J', specials={'font',0x006A} },
	[0x1D5F8] = { unicodeslot=0x1D5F8, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL K', specials={'font',0x006B} },
	[0x1D5F9] = { unicodeslot=0x1D5F9, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL L', specials={'font',0x006C} },
	[0x1D5FA] = { unicodeslot=0x1D5FA, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL M', specials={'font',0x006D} },
	[0x1D5FB] = { unicodeslot=0x1D5FB, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL N', specials={'font',0x006E} },
	[0x1D5FC] = { unicodeslot=0x1D5FC, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL O', specials={'font',0x006F} },
	[0x1D5FD] = { unicodeslot=0x1D5FD, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL P', specials={'font',0x0070} },
	[0x1D5FE] = { unicodeslot=0x1D5FE, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL Q', specials={'font',0x0071} },
	[0x1D5FF] = { unicodeslot=0x1D5FF, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL R', specials={'font',0x0072} },
	[0x1D600] = { unicodeslot=0x1D600, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL S', specials={'font',0x0073} },
	[0x1D601] = { unicodeslot=0x1D601, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL T', specials={'font',0x0074} },
	[0x1D602] = { unicodeslot=0x1D602, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL U', specials={'font',0x0075} },
	[0x1D603] = { unicodeslot=0x1D603, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL V', specials={'font',0x0076} },
	[0x1D604] = { unicodeslot=0x1D604, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL W', specials={'font',0x0077} },
	[0x1D605] = { unicodeslot=0x1D605, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL X', specials={'font',0x0078} },
	[0x1D606] = { unicodeslot=0x1D606, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL Y', specials={'font',0x0079} },
	[0x1D607] = { unicodeslot=0x1D607, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL Z', specials={'font',0x007A} },
	[0x1D608] = { unicodeslot=0x1D608, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL A', specials={'font',0x0041} },
	[0x1D609] = { unicodeslot=0x1D609, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL B', specials={'font',0x0042} },
	[0x1D60A] = { unicodeslot=0x1D60A, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL C', specials={'font',0x0043} },
	[0x1D60B] = { unicodeslot=0x1D60B, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL D', specials={'font',0x0044} },
	[0x1D60C] = { unicodeslot=0x1D60C, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL E', specials={'font',0x0045} },
	[0x1D60D] = { unicodeslot=0x1D60D, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL F', specials={'font',0x0046} },
	[0x1D60E] = { unicodeslot=0x1D60E, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL G', specials={'font',0x0047} },
	[0x1D60F] = { unicodeslot=0x1D60F, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL H', specials={'font',0x0048} },
	[0x1D610] = { unicodeslot=0x1D610, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL I', specials={'font',0x0049} },
	[0x1D611] = { unicodeslot=0x1D611, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL J', specials={'font',0x004A} },
	[0x1D612] = { unicodeslot=0x1D612, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL K', specials={'font',0x004B} },
	[0x1D613] = { unicodeslot=0x1D613, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL L', specials={'font',0x004C} },
	[0x1D614] = { unicodeslot=0x1D614, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL M', specials={'font',0x004D} },
	[0x1D615] = { unicodeslot=0x1D615, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL N', specials={'font',0x004E} },
	[0x1D616] = { unicodeslot=0x1D616, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL O', specials={'font',0x004F} },
	[0x1D617] = { unicodeslot=0x1D617, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL P', specials={'font',0x0050} },
	[0x1D618] = { unicodeslot=0x1D618, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q', specials={'font',0x0051} },
	[0x1D619] = { unicodeslot=0x1D619, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL R', specials={'font',0x0052} },
	[0x1D61A] = { unicodeslot=0x1D61A, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL S', specials={'font',0x0053} },
	[0x1D61B] = { unicodeslot=0x1D61B, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL T', specials={'font',0x0054} },
	[0x1D61C] = { unicodeslot=0x1D61C, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL U', specials={'font',0x0055} },
	[0x1D61D] = { unicodeslot=0x1D61D, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL V', specials={'font',0x0056} },
	[0x1D61E] = { unicodeslot=0x1D61E, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL W', specials={'font',0x0057} },
	[0x1D61F] = { unicodeslot=0x1D61F, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL X', specials={'font',0x0058} },
	[0x1D620] = { unicodeslot=0x1D620, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y', specials={'font',0x0059} },
	[0x1D621] = { unicodeslot=0x1D621, category='lu', description='MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z', specials={'font',0x005A} },
	[0x1D622] = { unicodeslot=0x1D622, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL A', specials={'font',0x0061} },
	[0x1D623] = { unicodeslot=0x1D623, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL B', specials={'font',0x0062} },
	[0x1D624] = { unicodeslot=0x1D624, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL C', specials={'font',0x0063} },
	[0x1D625] = { unicodeslot=0x1D625, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL D', specials={'font',0x0064} },
	[0x1D626] = { unicodeslot=0x1D626, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL E', specials={'font',0x0065} },
	[0x1D627] = { unicodeslot=0x1D627, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL F', specials={'font',0x0066} },
	[0x1D628] = { unicodeslot=0x1D628, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL G', specials={'font',0x0067} },
	[0x1D629] = { unicodeslot=0x1D629, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL H', specials={'font',0x0068} },
	[0x1D62A] = { unicodeslot=0x1D62A, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL I', specials={'font',0x0069} },
	[0x1D62B] = { unicodeslot=0x1D62B, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL J', specials={'font',0x006A} },
	[0x1D62C] = { unicodeslot=0x1D62C, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL K', specials={'font',0x006B} },
	[0x1D62D] = { unicodeslot=0x1D62D, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL L', specials={'font',0x006C} },
	[0x1D62E] = { unicodeslot=0x1D62E, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL M', specials={'font',0x006D} },
	[0x1D62F] = { unicodeslot=0x1D62F, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL N', specials={'font',0x006E} },
	[0x1D630] = { unicodeslot=0x1D630, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL O', specials={'font',0x006F} },
	[0x1D631] = { unicodeslot=0x1D631, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL P', specials={'font',0x0070} },
	[0x1D632] = { unicodeslot=0x1D632, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL Q', specials={'font',0x0071} },
	[0x1D633] = { unicodeslot=0x1D633, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL R', specials={'font',0x0072} },
	[0x1D634] = { unicodeslot=0x1D634, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL S', specials={'font',0x0073} },
	[0x1D635] = { unicodeslot=0x1D635, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL T', specials={'font',0x0074} },
	[0x1D636] = { unicodeslot=0x1D636, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL U', specials={'font',0x0075} },
	[0x1D637] = { unicodeslot=0x1D637, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL V', specials={'font',0x0076} },
	[0x1D638] = { unicodeslot=0x1D638, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL W', specials={'font',0x0077} },
	[0x1D639] = { unicodeslot=0x1D639, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL X', specials={'font',0x0078} },
	[0x1D63A] = { unicodeslot=0x1D63A, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL Y', specials={'font',0x0079} },
	[0x1D63B] = { unicodeslot=0x1D63B, category='ll', description='MATHEMATICAL SANS-SERIF ITALIC SMALL Z', specials={'font',0x007A} },
	[0x1D63C] = { unicodeslot=0x1D63C, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A', specials={'font',0x0041} },
	[0x1D63D] = { unicodeslot=0x1D63D, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL B', specials={'font',0x0042} },
	[0x1D63E] = { unicodeslot=0x1D63E, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL C', specials={'font',0x0043} },
	[0x1D63F] = { unicodeslot=0x1D63F, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D', specials={'font',0x0044} },
	[0x1D640] = { unicodeslot=0x1D640, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL E', specials={'font',0x0045} },
	[0x1D641] = { unicodeslot=0x1D641, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL F', specials={'font',0x0046} },
	[0x1D642] = { unicodeslot=0x1D642, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL G', specials={'font',0x0047} },
	[0x1D643] = { unicodeslot=0x1D643, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL H', specials={'font',0x0048} },
	[0x1D644] = { unicodeslot=0x1D644, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL I', specials={'font',0x0049} },
	[0x1D645] = { unicodeslot=0x1D645, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL J', specials={'font',0x004A} },
	[0x1D646] = { unicodeslot=0x1D646, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL K', specials={'font',0x004B} },
	[0x1D647] = { unicodeslot=0x1D647, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL L', specials={'font',0x004C} },
	[0x1D648] = { unicodeslot=0x1D648, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL M', specials={'font',0x004D} },
	[0x1D649] = { unicodeslot=0x1D649, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL N', specials={'font',0x004E} },
	[0x1D64A] = { unicodeslot=0x1D64A, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL O', specials={'font',0x004F} },
	[0x1D64B] = { unicodeslot=0x1D64B, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL P', specials={'font',0x0050} },
	[0x1D64C] = { unicodeslot=0x1D64C, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Q', specials={'font',0x0051} },
	[0x1D64D] = { unicodeslot=0x1D64D, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL R', specials={'font',0x0052} },
	[0x1D64E] = { unicodeslot=0x1D64E, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL S', specials={'font',0x0053} },
	[0x1D64F] = { unicodeslot=0x1D64F, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL T', specials={'font',0x0054} },
	[0x1D650] = { unicodeslot=0x1D650, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL U', specials={'font',0x0055} },
	[0x1D651] = { unicodeslot=0x1D651, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL V', specials={'font',0x0056} },
	[0x1D652] = { unicodeslot=0x1D652, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL W', specials={'font',0x0057} },
	[0x1D653] = { unicodeslot=0x1D653, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL X', specials={'font',0x0058} },
	[0x1D654] = { unicodeslot=0x1D654, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Y', specials={'font',0x0059} },
	[0x1D655] = { unicodeslot=0x1D655, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z', specials={'font',0x005A} },
	[0x1D656] = { unicodeslot=0x1D656, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A', specials={'font',0x0061} },
	[0x1D657] = { unicodeslot=0x1D657, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL B', specials={'font',0x0062} },
	[0x1D658] = { unicodeslot=0x1D658, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL C', specials={'font',0x0063} },
	[0x1D659] = { unicodeslot=0x1D659, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL D', specials={'font',0x0064} },
	[0x1D65A] = { unicodeslot=0x1D65A, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL E', specials={'font',0x0065} },
	[0x1D65B] = { unicodeslot=0x1D65B, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL F', specials={'font',0x0066} },
	[0x1D65C] = { unicodeslot=0x1D65C, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL G', specials={'font',0x0067} },
	[0x1D65D] = { unicodeslot=0x1D65D, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL H', specials={'font',0x0068} },
	[0x1D65E] = { unicodeslot=0x1D65E, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL I', specials={'font',0x0069} },
	[0x1D65F] = { unicodeslot=0x1D65F, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL J', specials={'font',0x006A} },
	[0x1D660] = { unicodeslot=0x1D660, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL K', specials={'font',0x006B} },
	[0x1D661] = { unicodeslot=0x1D661, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL L', specials={'font',0x006C} },
	[0x1D662] = { unicodeslot=0x1D662, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL M', specials={'font',0x006D} },
	[0x1D663] = { unicodeslot=0x1D663, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N', specials={'font',0x006E} },
	[0x1D664] = { unicodeslot=0x1D664, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL O', specials={'font',0x006F} },
	[0x1D665] = { unicodeslot=0x1D665, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL P', specials={'font',0x0070} },
	[0x1D666] = { unicodeslot=0x1D666, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Q', specials={'font',0x0071} },
	[0x1D667] = { unicodeslot=0x1D667, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL R', specials={'font',0x0072} },
	[0x1D668] = { unicodeslot=0x1D668, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL S', specials={'font',0x0073} },
	[0x1D669] = { unicodeslot=0x1D669, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL T', specials={'font',0x0074} },
	[0x1D66A] = { unicodeslot=0x1D66A, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL U', specials={'font',0x0075} },
	[0x1D66B] = { unicodeslot=0x1D66B, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL V', specials={'font',0x0076} },
	[0x1D66C] = { unicodeslot=0x1D66C, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL W', specials={'font',0x0077} },
	[0x1D66D] = { unicodeslot=0x1D66D, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL X', specials={'font',0x0078} },
	[0x1D66E] = { unicodeslot=0x1D66E, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Y', specials={'font',0x0079} },
	[0x1D66F] = { unicodeslot=0x1D66F, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z', specials={'font',0x007A} },
	[0x1D670] = { unicodeslot=0x1D670, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL A', specials={'font',0x0041} },
	[0x1D671] = { unicodeslot=0x1D671, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL B', specials={'font',0x0042} },
	[0x1D672] = { unicodeslot=0x1D672, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL C', specials={'font',0x0043} },
	[0x1D673] = { unicodeslot=0x1D673, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL D', specials={'font',0x0044} },
	[0x1D674] = { unicodeslot=0x1D674, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL E', specials={'font',0x0045} },
	[0x1D675] = { unicodeslot=0x1D675, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL F', specials={'font',0x0046} },
	[0x1D676] = { unicodeslot=0x1D676, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL G', specials={'font',0x0047} },
	[0x1D677] = { unicodeslot=0x1D677, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL H', specials={'font',0x0048} },
	[0x1D678] = { unicodeslot=0x1D678, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL I', specials={'font',0x0049} },
	[0x1D679] = { unicodeslot=0x1D679, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL J', specials={'font',0x004A} },
	[0x1D67A] = { unicodeslot=0x1D67A, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL K', specials={'font',0x004B} },
	[0x1D67B] = { unicodeslot=0x1D67B, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL L', specials={'font',0x004C} },
	[0x1D67C] = { unicodeslot=0x1D67C, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL M', specials={'font',0x004D} },
	[0x1D67D] = { unicodeslot=0x1D67D, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL N', specials={'font',0x004E} },
	[0x1D67E] = { unicodeslot=0x1D67E, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL O', specials={'font',0x004F} },
	[0x1D67F] = { unicodeslot=0x1D67F, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL P', specials={'font',0x0050} },
	[0x1D680] = { unicodeslot=0x1D680, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL Q', specials={'font',0x0051} },
	[0x1D681] = { unicodeslot=0x1D681, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL R', specials={'font',0x0052} },
	[0x1D682] = { unicodeslot=0x1D682, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL S', specials={'font',0x0053} },
	[0x1D683] = { unicodeslot=0x1D683, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL T', specials={'font',0x0054} },
	[0x1D684] = { unicodeslot=0x1D684, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL U', specials={'font',0x0055} },
	[0x1D685] = { unicodeslot=0x1D685, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL V', specials={'font',0x0056} },
	[0x1D686] = { unicodeslot=0x1D686, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL W', specials={'font',0x0057} },
	[0x1D687] = { unicodeslot=0x1D687, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL X', specials={'font',0x0058} },
	[0x1D688] = { unicodeslot=0x1D688, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL Y', specials={'font',0x0059} },
	[0x1D689] = { unicodeslot=0x1D689, category='lu', description='MATHEMATICAL MONOSPACE CAPITAL Z', specials={'font',0x005A} },
	[0x1D68A] = { unicodeslot=0x1D68A, category='ll', description='MATHEMATICAL MONOSPACE SMALL A', specials={'font',0x0061} },
	[0x1D68B] = { unicodeslot=0x1D68B, category='ll', description='MATHEMATICAL MONOSPACE SMALL B', specials={'font',0x0062} },
	[0x1D68C] = { unicodeslot=0x1D68C, category='ll', description='MATHEMATICAL MONOSPACE SMALL C', specials={'font',0x0063} },
	[0x1D68D] = { unicodeslot=0x1D68D, category='ll', description='MATHEMATICAL MONOSPACE SMALL D', specials={'font',0x0064} },
	[0x1D68E] = { unicodeslot=0x1D68E, category='ll', description='MATHEMATICAL MONOSPACE SMALL E', specials={'font',0x0065} },
	[0x1D68F] = { unicodeslot=0x1D68F, category='ll', description='MATHEMATICAL MONOSPACE SMALL F', specials={'font',0x0066} },
	[0x1D690] = { unicodeslot=0x1D690, category='ll', description='MATHEMATICAL MONOSPACE SMALL G', specials={'font',0x0067} },
	[0x1D691] = { unicodeslot=0x1D691, category='ll', description='MATHEMATICAL MONOSPACE SMALL H', specials={'font',0x0068} },
	[0x1D692] = { unicodeslot=0x1D692, category='ll', description='MATHEMATICAL MONOSPACE SMALL I', specials={'font',0x0069} },
	[0x1D693] = { unicodeslot=0x1D693, category='ll', description='MATHEMATICAL MONOSPACE SMALL J', specials={'font',0x006A} },
	[0x1D694] = { unicodeslot=0x1D694, category='ll', description='MATHEMATICAL MONOSPACE SMALL K', specials={'font',0x006B} },
	[0x1D695] = { unicodeslot=0x1D695, category='ll', description='MATHEMATICAL MONOSPACE SMALL L', specials={'font',0x006C} },
	[0x1D696] = { unicodeslot=0x1D696, category='ll', description='MATHEMATICAL MONOSPACE SMALL M', specials={'font',0x006D} },
	[0x1D697] = { unicodeslot=0x1D697, category='ll', description='MATHEMATICAL MONOSPACE SMALL N', specials={'font',0x006E} },
	[0x1D698] = { unicodeslot=0x1D698, category='ll', description='MATHEMATICAL MONOSPACE SMALL O', specials={'font',0x006F} },
	[0x1D699] = { unicodeslot=0x1D699, category='ll', description='MATHEMATICAL MONOSPACE SMALL P', specials={'font',0x0070} },
	[0x1D69A] = { unicodeslot=0x1D69A, category='ll', description='MATHEMATICAL MONOSPACE SMALL Q', specials={'font',0x0071} },
	[0x1D69B] = { unicodeslot=0x1D69B, category='ll', description='MATHEMATICAL MONOSPACE SMALL R', specials={'font',0x0072} },
	[0x1D69C] = { unicodeslot=0x1D69C, category='ll', description='MATHEMATICAL MONOSPACE SMALL S', specials={'font',0x0073} },
	[0x1D69D] = { unicodeslot=0x1D69D, category='ll', description='MATHEMATICAL MONOSPACE SMALL T', specials={'font',0x0074} },
	[0x1D69E] = { unicodeslot=0x1D69E, category='ll', description='MATHEMATICAL MONOSPACE SMALL U', specials={'font',0x0075} },
	[0x1D69F] = { unicodeslot=0x1D69F, category='ll', description='MATHEMATICAL MONOSPACE SMALL V', specials={'font',0x0076} },
	[0x1D6A0] = { unicodeslot=0x1D6A0, category='ll', description='MATHEMATICAL MONOSPACE SMALL W', specials={'font',0x0077} },
	[0x1D6A1] = { unicodeslot=0x1D6A1, category='ll', description='MATHEMATICAL MONOSPACE SMALL X', specials={'font',0x0078} },
	[0x1D6A2] = { unicodeslot=0x1D6A2, category='ll', description='MATHEMATICAL MONOSPACE SMALL Y', specials={'font',0x0079} },
	[0x1D6A3] = { unicodeslot=0x1D6A3, category='ll', description='MATHEMATICAL MONOSPACE SMALL Z', specials={'font',0x007A} },
	[0x1D6A4] = { unicodeslot=0x1D6A4, category='ll', description='MATHEMATICAL ITALIC SMALL DOTLESS I', specials={'font',0x0131} },
	[0x1D6A5] = { unicodeslot=0x1D6A5, category='ll', description='MATHEMATICAL ITALIC SMALL DOTLESS J', specials={'font',0x0237} },
	[0x1D6A8] = { unicodeslot=0x1D6A8, category='lu', description='MATHEMATICAL BOLD CAPITAL ALPHA', specials={'font',0x0391} },
	[0x1D6A9] = { unicodeslot=0x1D6A9, category='lu', description='MATHEMATICAL BOLD CAPITAL BETA', specials={'font',0x0392} },
	[0x1D6AA] = { unicodeslot=0x1D6AA, category='lu', description='MATHEMATICAL BOLD CAPITAL GAMMA', specials={'font',0x0393} },
	[0x1D6AB] = { unicodeslot=0x1D6AB, category='lu', description='MATHEMATICAL BOLD CAPITAL DELTA', specials={'font',0x0394} },
	[0x1D6AC] = { unicodeslot=0x1D6AC, category='lu', description='MATHEMATICAL BOLD CAPITAL EPSILON', specials={'font',0x0395} },
	[0x1D6AD] = { unicodeslot=0x1D6AD, category='lu', description='MATHEMATICAL BOLD CAPITAL ZETA', specials={'font',0x0396} },
	[0x1D6AE] = { unicodeslot=0x1D6AE, category='lu', description='MATHEMATICAL BOLD CAPITAL ETA', specials={'font',0x0397} },
	[0x1D6AF] = { unicodeslot=0x1D6AF, category='lu', description='MATHEMATICAL BOLD CAPITAL THETA', specials={'font',0x0398} },
	[0x1D6B0] = { unicodeslot=0x1D6B0, category='lu', description='MATHEMATICAL BOLD CAPITAL IOTA', specials={'font',0x0399} },
	[0x1D6B1] = { unicodeslot=0x1D6B1, category='lu', description='MATHEMATICAL BOLD CAPITAL KAPPA', specials={'font',0x039A} },
	[0x1D6B2] = { unicodeslot=0x1D6B2, category='lu', description='MATHEMATICAL BOLD CAPITAL LAMDA', specials={'font',0x039B} },
	[0x1D6B3] = { unicodeslot=0x1D6B3, category='lu', description='MATHEMATICAL BOLD CAPITAL MU', specials={'font',0x039C} },
	[0x1D6B4] = { unicodeslot=0x1D6B4, category='lu', description='MATHEMATICAL BOLD CAPITAL NU', specials={'font',0x039D} },
	[0x1D6B5] = { unicodeslot=0x1D6B5, category='lu', description='MATHEMATICAL BOLD CAPITAL XI', specials={'font',0x039E} },
	[0x1D6B6] = { unicodeslot=0x1D6B6, category='lu', description='MATHEMATICAL BOLD CAPITAL OMICRON', specials={'font',0x039F} },
	[0x1D6B7] = { unicodeslot=0x1D6B7, category='lu', description='MATHEMATICAL BOLD CAPITAL PI', specials={'font',0x03A0} },
	[0x1D6B8] = { unicodeslot=0x1D6B8, category='lu', description='MATHEMATICAL BOLD CAPITAL RHO', specials={'font',0x03A1} },
	[0x1D6B9] = { unicodeslot=0x1D6B9, category='lu', description='MATHEMATICAL BOLD CAPITAL THETA SYMBOL', specials={'font',0x03F4} },
	[0x1D6BA] = { unicodeslot=0x1D6BA, category='lu', description='MATHEMATICAL BOLD CAPITAL SIGMA', specials={'font',0x03A3} },
	[0x1D6BB] = { unicodeslot=0x1D6BB, category='lu', description='MATHEMATICAL BOLD CAPITAL TAU', specials={'font',0x03A4} },
	[0x1D6BC] = { unicodeslot=0x1D6BC, category='lu', description='MATHEMATICAL BOLD CAPITAL UPSILON', specials={'font',0x03A5} },
	[0x1D6BD] = { unicodeslot=0x1D6BD, category='lu', description='MATHEMATICAL BOLD CAPITAL PHI', specials={'font',0x03A6} },
	[0x1D6BE] = { unicodeslot=0x1D6BE, category='lu', description='MATHEMATICAL BOLD CAPITAL CHI', specials={'font',0x03A7} },
	[0x1D6BF] = { unicodeslot=0x1D6BF, category='lu', description='MATHEMATICAL BOLD CAPITAL PSI', specials={'font',0x03A8} },
	[0x1D6C0] = { unicodeslot=0x1D6C0, category='lu', description='MATHEMATICAL BOLD CAPITAL OMEGA', specials={'font',0x03A9} },
	[0x1D6C1] = { unicodeslot=0x1D6C1, category='sm', description='MATHEMATICAL BOLD NABLA', specials={'font',0x2207} },
	[0x1D6C2] = { unicodeslot=0x1D6C2, category='ll', description='MATHEMATICAL BOLD SMALL ALPHA', specials={'font',0x03B1} },
	[0x1D6C3] = { unicodeslot=0x1D6C3, category='ll', description='MATHEMATICAL BOLD SMALL BETA', specials={'font',0x03B2} },
	[0x1D6C4] = { unicodeslot=0x1D6C4, category='ll', description='MATHEMATICAL BOLD SMALL GAMMA', specials={'font',0x03B3} },
	[0x1D6C5] = { unicodeslot=0x1D6C5, category='ll', description='MATHEMATICAL BOLD SMALL DELTA', specials={'font',0x03B4} },
	[0x1D6C6] = { unicodeslot=0x1D6C6, category='ll', description='MATHEMATICAL BOLD SMALL EPSILON', specials={'font',0x03B5} },
	[0x1D6C7] = { unicodeslot=0x1D6C7, category='ll', description='MATHEMATICAL BOLD SMALL ZETA', specials={'font',0x03B6} },
	[0x1D6C8] = { unicodeslot=0x1D6C8, category='ll', description='MATHEMATICAL BOLD SMALL ETA', specials={'font',0x03B7} },
	[0x1D6C9] = { unicodeslot=0x1D6C9, category='ll', description='MATHEMATICAL BOLD SMALL THETA', specials={'font',0x03B8} },
	[0x1D6CA] = { unicodeslot=0x1D6CA, category='ll', description='MATHEMATICAL BOLD SMALL IOTA', specials={'font',0x03B9} },
	[0x1D6CB] = { unicodeslot=0x1D6CB, category='ll', description='MATHEMATICAL BOLD SMALL KAPPA', specials={'font',0x03BA} },
	[0x1D6CC] = { unicodeslot=0x1D6CC, category='ll', description='MATHEMATICAL BOLD SMALL LAMDA', specials={'font',0x03BB} },
	[0x1D6CD] = { unicodeslot=0x1D6CD, category='ll', description='MATHEMATICAL BOLD SMALL MU', specials={'font',0x03BC} },
	[0x1D6CE] = { unicodeslot=0x1D6CE, category='ll', description='MATHEMATICAL BOLD SMALL NU', specials={'font',0x03BD} },
	[0x1D6CF] = { unicodeslot=0x1D6CF, category='ll', description='MATHEMATICAL BOLD SMALL XI', specials={'font',0x03BE} },
	[0x1D6D0] = { unicodeslot=0x1D6D0, category='ll', description='MATHEMATICAL BOLD SMALL OMICRON', specials={'font',0x03BF} },
	[0x1D6D1] = { unicodeslot=0x1D6D1, category='ll', description='MATHEMATICAL BOLD SMALL PI', specials={'font',0x03C0} },
	[0x1D6D2] = { unicodeslot=0x1D6D2, category='ll', description='MATHEMATICAL BOLD SMALL RHO', specials={'font',0x03C1} },
	[0x1D6D3] = { unicodeslot=0x1D6D3, category='ll', description='MATHEMATICAL BOLD SMALL FINAL SIGMA', specials={'font',0x03C2} },
	[0x1D6D4] = { unicodeslot=0x1D6D4, category='ll', description='MATHEMATICAL BOLD SMALL SIGMA', specials={'font',0x03C3} },
	[0x1D6D5] = { unicodeslot=0x1D6D5, category='ll', description='MATHEMATICAL BOLD SMALL TAU', specials={'font',0x03C4} },
	[0x1D6D6] = { unicodeslot=0x1D6D6, category='ll', description='MATHEMATICAL BOLD SMALL UPSILON', specials={'font',0x03C5} },
	[0x1D6D7] = { unicodeslot=0x1D6D7, category='ll', description='MATHEMATICAL BOLD SMALL PHI', specials={'font',0x03C6} },
	[0x1D6D8] = { unicodeslot=0x1D6D8, category='ll', description='MATHEMATICAL BOLD SMALL CHI', specials={'font',0x03C7} },
	[0x1D6D9] = { unicodeslot=0x1D6D9, category='ll', description='MATHEMATICAL BOLD SMALL PSI', specials={'font',0x03C8} },
	[0x1D6DA] = { unicodeslot=0x1D6DA, category='ll', description='MATHEMATICAL BOLD SMALL OMEGA', specials={'font',0x03C9} },
	[0x1D6DB] = { unicodeslot=0x1D6DB, category='sm', description='MATHEMATICAL BOLD PARTIAL DIFFERENTIAL', specials={'font',0x2202} },
	[0x1D6DC] = { unicodeslot=0x1D6DC, category='ll', description='MATHEMATICAL BOLD EPSILON SYMBOL', specials={'font',0x03F5} },
	[0x1D6DD] = { unicodeslot=0x1D6DD, category='ll', description='MATHEMATICAL BOLD THETA SYMBOL', specials={'font',0x03D1} },
	[0x1D6DE] = { unicodeslot=0x1D6DE, category='ll', description='MATHEMATICAL BOLD KAPPA SYMBOL', specials={'font',0x03F0} },
	[0x1D6DF] = { unicodeslot=0x1D6DF, category='ll', description='MATHEMATICAL BOLD PHI SYMBOL', specials={'font',0x03D5} },
	[0x1D6E0] = { unicodeslot=0x1D6E0, category='ll', description='MATHEMATICAL BOLD RHO SYMBOL', specials={'font',0x03F1} },
	[0x1D6E1] = { unicodeslot=0x1D6E1, category='ll', description='MATHEMATICAL BOLD PI SYMBOL', specials={'font',0x03D6} },
	[0x1D6E2] = { unicodeslot=0x1D6E2, category='lu', description='MATHEMATICAL ITALIC CAPITAL ALPHA', specials={'font',0x0391} },
	[0x1D6E3] = { unicodeslot=0x1D6E3, category='lu', description='MATHEMATICAL ITALIC CAPITAL BETA', specials={'font',0x0392} },
	[0x1D6E4] = { unicodeslot=0x1D6E4, category='lu', description='MATHEMATICAL ITALIC CAPITAL GAMMA', specials={'font',0x0393} },
	[0x1D6E5] = { unicodeslot=0x1D6E5, category='lu', description='MATHEMATICAL ITALIC CAPITAL DELTA', specials={'font',0x0394} },
	[0x1D6E6] = { unicodeslot=0x1D6E6, category='lu', description='MATHEMATICAL ITALIC CAPITAL EPSILON', specials={'font',0x0395} },
	[0x1D6E7] = { unicodeslot=0x1D6E7, category='lu', description='MATHEMATICAL ITALIC CAPITAL ZETA', specials={'font',0x0396} },
	[0x1D6E8] = { unicodeslot=0x1D6E8, category='lu', description='MATHEMATICAL ITALIC CAPITAL ETA', specials={'font',0x0397} },
	[0x1D6E9] = { unicodeslot=0x1D6E9, category='lu', description='MATHEMATICAL ITALIC CAPITAL THETA', specials={'font',0x0398} },
	[0x1D6EA] = { unicodeslot=0x1D6EA, category='lu', description='MATHEMATICAL ITALIC CAPITAL IOTA', specials={'font',0x0399} },
	[0x1D6EB] = { unicodeslot=0x1D6EB, category='lu', description='MATHEMATICAL ITALIC CAPITAL KAPPA', specials={'font',0x039A} },
	[0x1D6EC] = { unicodeslot=0x1D6EC, category='lu', description='MATHEMATICAL ITALIC CAPITAL LAMDA', specials={'font',0x039B} },
	[0x1D6ED] = { unicodeslot=0x1D6ED, category='lu', description='MATHEMATICAL ITALIC CAPITAL MU', specials={'font',0x039C} },
	[0x1D6EE] = { unicodeslot=0x1D6EE, category='lu', description='MATHEMATICAL ITALIC CAPITAL NU', specials={'font',0x039D} },
	[0x1D6EF] = { unicodeslot=0x1D6EF, category='lu', description='MATHEMATICAL ITALIC CAPITAL XI', specials={'font',0x039E} },
	[0x1D6F0] = { unicodeslot=0x1D6F0, category='lu', description='MATHEMATICAL ITALIC CAPITAL OMICRON', specials={'font',0x039F} },
	[0x1D6F1] = { unicodeslot=0x1D6F1, category='lu', description='MATHEMATICAL ITALIC CAPITAL PI', specials={'font',0x03A0} },
	[0x1D6F2] = { unicodeslot=0x1D6F2, category='lu', description='MATHEMATICAL ITALIC CAPITAL RHO', specials={'font',0x03A1} },
	[0x1D6F3] = { unicodeslot=0x1D6F3, category='lu', description='MATHEMATICAL ITALIC CAPITAL THETA SYMBOL', specials={'font',0x03F4} },
	[0x1D6F4] = { unicodeslot=0x1D6F4, category='lu', description='MATHEMATICAL ITALIC CAPITAL SIGMA', specials={'font',0x03A3} },
	[0x1D6F5] = { unicodeslot=0x1D6F5, category='lu', description='MATHEMATICAL ITALIC CAPITAL TAU', specials={'font',0x03A4} },
	[0x1D6F6] = { unicodeslot=0x1D6F6, category='lu', description='MATHEMATICAL ITALIC CAPITAL UPSILON', specials={'font',0x03A5} },
	[0x1D6F7] = { unicodeslot=0x1D6F7, category='lu', description='MATHEMATICAL ITALIC CAPITAL PHI', specials={'font',0x03A6} },
	[0x1D6F8] = { unicodeslot=0x1D6F8, category='lu', description='MATHEMATICAL ITALIC CAPITAL CHI', specials={'font',0x03A7} },
	[0x1D6F9] = { unicodeslot=0x1D6F9, category='lu', description='MATHEMATICAL ITALIC CAPITAL PSI', specials={'font',0x03A8} },
	[0x1D6FA] = { unicodeslot=0x1D6FA, category='lu', description='MATHEMATICAL ITALIC CAPITAL OMEGA', specials={'font',0x03A9} },
	[0x1D6FB] = { unicodeslot=0x1D6FB, category='sm', description='MATHEMATICAL ITALIC NABLA', specials={'font',0x2207} },
	[0x1D6FC] = { unicodeslot=0x1D6FC, category='ll', description='MATHEMATICAL ITALIC SMALL ALPHA', specials={'font',0x03B1} },
	[0x1D6FD] = { unicodeslot=0x1D6FD, category='ll', description='MATHEMATICAL ITALIC SMALL BETA', specials={'font',0x03B2} },
	[0x1D6FE] = { unicodeslot=0x1D6FE, category='ll', description='MATHEMATICAL ITALIC SMALL GAMMA', specials={'font',0x03B3} },
	[0x1D6FF] = { unicodeslot=0x1D6FF, category='ll', description='MATHEMATICAL ITALIC SMALL DELTA', specials={'font',0x03B4} },
	[0x1D700] = { unicodeslot=0x1D700, category='ll', description='MATHEMATICAL ITALIC SMALL EPSILON', specials={'font',0x03B5} },
	[0x1D701] = { unicodeslot=0x1D701, category='ll', description='MATHEMATICAL ITALIC SMALL ZETA', specials={'font',0x03B6} },
	[0x1D702] = { unicodeslot=0x1D702, category='ll', description='MATHEMATICAL ITALIC SMALL ETA', specials={'font',0x03B7} },
	[0x1D703] = { unicodeslot=0x1D703, category='ll', description='MATHEMATICAL ITALIC SMALL THETA', specials={'font',0x03B8} },
	[0x1D704] = { unicodeslot=0x1D704, category='ll', description='MATHEMATICAL ITALIC SMALL IOTA', specials={'font',0x03B9} },
	[0x1D705] = { unicodeslot=0x1D705, category='ll', description='MATHEMATICAL ITALIC SMALL KAPPA', specials={'font',0x03BA} },
	[0x1D706] = { unicodeslot=0x1D706, category='ll', description='MATHEMATICAL ITALIC SMALL LAMDA', specials={'font',0x03BB} },
	[0x1D707] = { unicodeslot=0x1D707, category='ll', description='MATHEMATICAL ITALIC SMALL MU', specials={'font',0x03BC} },
	[0x1D708] = { unicodeslot=0x1D708, category='ll', description='MATHEMATICAL ITALIC SMALL NU', specials={'font',0x03BD} },
	[0x1D709] = { unicodeslot=0x1D709, category='ll', description='MATHEMATICAL ITALIC SMALL XI', specials={'font',0x03BE} },
	[0x1D70A] = { unicodeslot=0x1D70A, category='ll', description='MATHEMATICAL ITALIC SMALL OMICRON', specials={'font',0x03BF} },
	[0x1D70B] = { unicodeslot=0x1D70B, category='ll', description='MATHEMATICAL ITALIC SMALL PI', specials={'font',0x03C0} },
	[0x1D70C] = { unicodeslot=0x1D70C, category='ll', description='MATHEMATICAL ITALIC SMALL RHO', specials={'font',0x03C1} },
	[0x1D70D] = { unicodeslot=0x1D70D, category='ll', description='MATHEMATICAL ITALIC SMALL FINAL SIGMA', specials={'font',0x03C2} },
	[0x1D70E] = { unicodeslot=0x1D70E, category='ll', description='MATHEMATICAL ITALIC SMALL SIGMA', specials={'font',0x03C3} },
	[0x1D70F] = { unicodeslot=0x1D70F, category='ll', description='MATHEMATICAL ITALIC SMALL TAU', specials={'font',0x03C4} },
	[0x1D710] = { unicodeslot=0x1D710, category='ll', description='MATHEMATICAL ITALIC SMALL UPSILON', specials={'font',0x03C5} },
	[0x1D711] = { unicodeslot=0x1D711, category='ll', description='MATHEMATICAL ITALIC SMALL PHI', specials={'font',0x03C6} },
	[0x1D712] = { unicodeslot=0x1D712, category='ll', description='MATHEMATICAL ITALIC SMALL CHI', specials={'font',0x03C7} },
	[0x1D713] = { unicodeslot=0x1D713, category='ll', description='MATHEMATICAL ITALIC SMALL PSI', specials={'font',0x03C8} },
	[0x1D714] = { unicodeslot=0x1D714, category='ll', description='MATHEMATICAL ITALIC SMALL OMEGA', specials={'font',0x03C9} },
	[0x1D715] = { unicodeslot=0x1D715, category='sm', description='MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL', specials={'font',0x2202} },
	[0x1D716] = { unicodeslot=0x1D716, category='ll', description='MATHEMATICAL ITALIC EPSILON SYMBOL', specials={'font',0x03F5} },
	[0x1D717] = { unicodeslot=0x1D717, category='ll', description='MATHEMATICAL ITALIC THETA SYMBOL', specials={'font',0x03D1} },
	[0x1D718] = { unicodeslot=0x1D718, category='ll', description='MATHEMATICAL ITALIC KAPPA SYMBOL', specials={'font',0x03F0} },
	[0x1D719] = { unicodeslot=0x1D719, category='ll', description='MATHEMATICAL ITALIC PHI SYMBOL', specials={'font',0x03D5} },
	[0x1D71A] = { unicodeslot=0x1D71A, category='ll', description='MATHEMATICAL ITALIC RHO SYMBOL', specials={'font',0x03F1} },
	[0x1D71B] = { unicodeslot=0x1D71B, category='ll', description='MATHEMATICAL ITALIC PI SYMBOL', specials={'font',0x03D6} },
	[0x1D71C] = { unicodeslot=0x1D71C, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL ALPHA', specials={'font',0x0391} },
	[0x1D71D] = { unicodeslot=0x1D71D, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL BETA', specials={'font',0x0392} },
	[0x1D71E] = { unicodeslot=0x1D71E, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL GAMMA', specials={'font',0x0393} },
	[0x1D71F] = { unicodeslot=0x1D71F, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL DELTA', specials={'font',0x0394} },
	[0x1D720] = { unicodeslot=0x1D720, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL EPSILON', specials={'font',0x0395} },
	[0x1D721] = { unicodeslot=0x1D721, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL ZETA', specials={'font',0x0396} },
	[0x1D722] = { unicodeslot=0x1D722, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL ETA', specials={'font',0x0397} },
	[0x1D723] = { unicodeslot=0x1D723, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL THETA', specials={'font',0x0398} },
	[0x1D724] = { unicodeslot=0x1D724, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL IOTA', specials={'font',0x0399} },
	[0x1D725] = { unicodeslot=0x1D725, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL KAPPA', specials={'font',0x039A} },
	[0x1D726] = { unicodeslot=0x1D726, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL LAMDA', specials={'font',0x039B} },
	[0x1D727] = { unicodeslot=0x1D727, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL MU', specials={'font',0x039C} },
	[0x1D728] = { unicodeslot=0x1D728, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL NU', specials={'font',0x039D} },
	[0x1D729] = { unicodeslot=0x1D729, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL XI', specials={'font',0x039E} },
	[0x1D72A] = { unicodeslot=0x1D72A, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL OMICRON', specials={'font',0x039F} },
	[0x1D72B] = { unicodeslot=0x1D72B, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL PI', specials={'font',0x03A0} },
	[0x1D72C] = { unicodeslot=0x1D72C, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL RHO', specials={'font',0x03A1} },
	[0x1D72D] = { unicodeslot=0x1D72D, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL THETA SYMBOL', specials={'font',0x03F4} },
	[0x1D72E] = { unicodeslot=0x1D72E, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL SIGMA', specials={'font',0x03A3} },
	[0x1D72F] = { unicodeslot=0x1D72F, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL TAU', specials={'font',0x03A4} },
	[0x1D730] = { unicodeslot=0x1D730, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL UPSILON', specials={'font',0x03A5} },
	[0x1D731] = { unicodeslot=0x1D731, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL PHI', specials={'font',0x03A6} },
	[0x1D732] = { unicodeslot=0x1D732, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL CHI', specials={'font',0x03A7} },
	[0x1D733] = { unicodeslot=0x1D733, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL PSI', specials={'font',0x03A8} },
	[0x1D734] = { unicodeslot=0x1D734, category='lu', description='MATHEMATICAL BOLD ITALIC CAPITAL OMEGA', specials={'font',0x03A9} },
	[0x1D735] = { unicodeslot=0x1D735, category='sm', description='MATHEMATICAL BOLD ITALIC NABLA', specials={'font',0x2207} },
	[0x1D736] = { unicodeslot=0x1D736, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL ALPHA', specials={'font',0x03B1} },
	[0x1D737] = { unicodeslot=0x1D737, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL BETA', specials={'font',0x03B2} },
	[0x1D738] = { unicodeslot=0x1D738, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL GAMMA', specials={'font',0x03B3} },
	[0x1D739] = { unicodeslot=0x1D739, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL DELTA', specials={'font',0x03B4} },
	[0x1D73A] = { unicodeslot=0x1D73A, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL EPSILON', specials={'font',0x03B5} },
	[0x1D73B] = { unicodeslot=0x1D73B, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL ZETA', specials={'font',0x03B6} },
	[0x1D73C] = { unicodeslot=0x1D73C, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL ETA', specials={'font',0x03B7} },
	[0x1D73D] = { unicodeslot=0x1D73D, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL THETA', specials={'font',0x03B8} },
	[0x1D73E] = { unicodeslot=0x1D73E, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL IOTA', specials={'font',0x03B9} },
	[0x1D73F] = { unicodeslot=0x1D73F, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL KAPPA', specials={'font',0x03BA} },
	[0x1D740] = { unicodeslot=0x1D740, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL LAMDA', specials={'font',0x03BB} },
	[0x1D741] = { unicodeslot=0x1D741, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL MU', specials={'font',0x03BC} },
	[0x1D742] = { unicodeslot=0x1D742, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL NU', specials={'font',0x03BD} },
	[0x1D743] = { unicodeslot=0x1D743, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL XI', specials={'font',0x03BE} },
	[0x1D744] = { unicodeslot=0x1D744, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL OMICRON', specials={'font',0x03BF} },
	[0x1D745] = { unicodeslot=0x1D745, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL PI', specials={'font',0x03C0} },
	[0x1D746] = { unicodeslot=0x1D746, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL RHO', specials={'font',0x03C1} },
	[0x1D747] = { unicodeslot=0x1D747, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL FINAL SIGMA', specials={'font',0x03C2} },
	[0x1D748] = { unicodeslot=0x1D748, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL SIGMA', specials={'font',0x03C3} },
	[0x1D749] = { unicodeslot=0x1D749, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL TAU', specials={'font',0x03C4} },
	[0x1D74A] = { unicodeslot=0x1D74A, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL UPSILON', specials={'font',0x03C5} },
	[0x1D74B] = { unicodeslot=0x1D74B, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL PHI', specials={'font',0x03C6} },
	[0x1D74C] = { unicodeslot=0x1D74C, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL CHI', specials={'font',0x03C7} },
	[0x1D74D] = { unicodeslot=0x1D74D, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL PSI', specials={'font',0x03C8} },
	[0x1D74E] = { unicodeslot=0x1D74E, category='ll', description='MATHEMATICAL BOLD ITALIC SMALL OMEGA', specials={'font',0x03C9} },
	[0x1D74F] = { unicodeslot=0x1D74F, category='sm', description='MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL', specials={'font',0x2202} },
	[0x1D750] = { unicodeslot=0x1D750, category='ll', description='MATHEMATICAL BOLD ITALIC EPSILON SYMBOL', specials={'font',0x03F5} },
	[0x1D751] = { unicodeslot=0x1D751, category='ll', description='MATHEMATICAL BOLD ITALIC THETA SYMBOL', specials={'font',0x03D1} },
	[0x1D752] = { unicodeslot=0x1D752, category='ll', description='MATHEMATICAL BOLD ITALIC KAPPA SYMBOL', specials={'font',0x03F0} },
	[0x1D753] = { unicodeslot=0x1D753, category='ll', description='MATHEMATICAL BOLD ITALIC PHI SYMBOL', specials={'font',0x03D5} },
	[0x1D754] = { unicodeslot=0x1D754, category='ll', description='MATHEMATICAL BOLD ITALIC RHO SYMBOL', specials={'font',0x03F1} },
	[0x1D755] = { unicodeslot=0x1D755, category='ll', description='MATHEMATICAL BOLD ITALIC PI SYMBOL', specials={'font',0x03D6} },
	[0x1D756] = { unicodeslot=0x1D756, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA', specials={'font',0x0391} },
	[0x1D757] = { unicodeslot=0x1D757, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA', specials={'font',0x0392} },
	[0x1D758] = { unicodeslot=0x1D758, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL GAMMA', specials={'font',0x0393} },
	[0x1D759] = { unicodeslot=0x1D759, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL DELTA', specials={'font',0x0394} },
	[0x1D75A] = { unicodeslot=0x1D75A, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL EPSILON', specials={'font',0x0395} },
	[0x1D75B] = { unicodeslot=0x1D75B, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL ZETA', specials={'font',0x0396} },
	[0x1D75C] = { unicodeslot=0x1D75C, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL ETA', specials={'font',0x0397} },
	[0x1D75D] = { unicodeslot=0x1D75D, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA', specials={'font',0x0398} },
	[0x1D75E] = { unicodeslot=0x1D75E, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL IOTA', specials={'font',0x0399} },
	[0x1D75F] = { unicodeslot=0x1D75F, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL KAPPA', specials={'font',0x039A} },
	[0x1D760] = { unicodeslot=0x1D760, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL LAMDA', specials={'font',0x039B} },
	[0x1D761] = { unicodeslot=0x1D761, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL MU', specials={'font',0x039C} },
	[0x1D762] = { unicodeslot=0x1D762, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL NU', specials={'font',0x039D} },
	[0x1D763] = { unicodeslot=0x1D763, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL XI', specials={'font',0x039E} },
	[0x1D764] = { unicodeslot=0x1D764, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL OMICRON', specials={'font',0x039F} },
	[0x1D765] = { unicodeslot=0x1D765, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL PI', specials={'font',0x03A0} },
	[0x1D766] = { unicodeslot=0x1D766, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL RHO', specials={'font',0x03A1} },
	[0x1D767] = { unicodeslot=0x1D767, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA SYMBOL', specials={'font',0x03F4} },
	[0x1D768] = { unicodeslot=0x1D768, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL SIGMA', specials={'font',0x03A3} },
	[0x1D769] = { unicodeslot=0x1D769, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL TAU', specials={'font',0x03A4} },
	[0x1D76A] = { unicodeslot=0x1D76A, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL UPSILON', specials={'font',0x03A5} },
	[0x1D76B] = { unicodeslot=0x1D76B, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL PHI', specials={'font',0x03A6} },
	[0x1D76C] = { unicodeslot=0x1D76C, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL CHI', specials={'font',0x03A7} },
	[0x1D76D] = { unicodeslot=0x1D76D, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL PSI', specials={'font',0x03A8} },
	[0x1D76E] = { unicodeslot=0x1D76E, category='lu', description='MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA', specials={'font',0x03A9} },
	[0x1D76F] = { unicodeslot=0x1D76F, category='sm', description='MATHEMATICAL SANS-SERIF BOLD NABLA', specials={'font',0x2207} },
	[0x1D770] = { unicodeslot=0x1D770, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA', specials={'font',0x03B1} },
	[0x1D771] = { unicodeslot=0x1D771, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL BETA', specials={'font',0x03B2} },
	[0x1D772] = { unicodeslot=0x1D772, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL GAMMA', specials={'font',0x03B3} },
	[0x1D773] = { unicodeslot=0x1D773, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL DELTA', specials={'font',0x03B4} },
	[0x1D774] = { unicodeslot=0x1D774, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL EPSILON', specials={'font',0x03B5} },
	[0x1D775] = { unicodeslot=0x1D775, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL ZETA', specials={'font',0x03B6} },
	[0x1D776] = { unicodeslot=0x1D776, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL ETA', specials={'font',0x03B7} },
	[0x1D777] = { unicodeslot=0x1D777, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL THETA', specials={'font',0x03B8} },
	[0x1D778] = { unicodeslot=0x1D778, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL IOTA', specials={'font',0x03B9} },
	[0x1D779] = { unicodeslot=0x1D779, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL KAPPA', specials={'font',0x03BA} },
	[0x1D77A] = { unicodeslot=0x1D77A, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL LAMDA', specials={'font',0x03BB} },
	[0x1D77B] = { unicodeslot=0x1D77B, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL MU', specials={'font',0x03BC} },
	[0x1D77C] = { unicodeslot=0x1D77C, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL NU', specials={'font',0x03BD} },
	[0x1D77D] = { unicodeslot=0x1D77D, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL XI', specials={'font',0x03BE} },
	[0x1D77E] = { unicodeslot=0x1D77E, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL OMICRON', specials={'font',0x03BF} },
	[0x1D77F] = { unicodeslot=0x1D77F, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL PI', specials={'font',0x03C0} },
	[0x1D780] = { unicodeslot=0x1D780, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL RHO', specials={'font',0x03C1} },
	[0x1D781] = { unicodeslot=0x1D781, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL FINAL SIGMA', specials={'font',0x03C2} },
	[0x1D782] = { unicodeslot=0x1D782, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL SIGMA', specials={'font',0x03C3} },
	[0x1D783] = { unicodeslot=0x1D783, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL TAU', specials={'font',0x03C4} },
	[0x1D784] = { unicodeslot=0x1D784, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL UPSILON', specials={'font',0x03C5} },
	[0x1D785] = { unicodeslot=0x1D785, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL PHI', specials={'font',0x03C6} },
	[0x1D786] = { unicodeslot=0x1D786, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL CHI', specials={'font',0x03C7} },
	[0x1D787] = { unicodeslot=0x1D787, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL PSI', specials={'font',0x03C8} },
	[0x1D788] = { unicodeslot=0x1D788, category='ll', description='MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA', specials={'font',0x03C9} },
	[0x1D789] = { unicodeslot=0x1D789, category='sm', description='MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL', specials={'font',0x2202} },
	[0x1D78A] = { unicodeslot=0x1D78A, category='ll', description='MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL', specials={'font',0x03F5} },
	[0x1D78B] = { unicodeslot=0x1D78B, category='ll', description='MATHEMATICAL SANS-SERIF BOLD THETA SYMBOL', specials={'font',0x03D1} },
	[0x1D78C] = { unicodeslot=0x1D78C, category='ll', description='MATHEMATICAL SANS-SERIF BOLD KAPPA SYMBOL', specials={'font',0x03F0} },
	[0x1D78D] = { unicodeslot=0x1D78D, category='ll', description='MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL', specials={'font',0x03D5} },
	[0x1D78E] = { unicodeslot=0x1D78E, category='ll', description='MATHEMATICAL SANS-SERIF BOLD RHO SYMBOL', specials={'font',0x03F1} },
	[0x1D78F] = { unicodeslot=0x1D78F, category='ll', description='MATHEMATICAL SANS-SERIF BOLD PI SYMBOL', specials={'font',0x03D6} },
	[0x1D790] = { unicodeslot=0x1D790, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA', specials={'font',0x0391} },
	[0x1D791] = { unicodeslot=0x1D791, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL BETA', specials={'font',0x0392} },
	[0x1D792] = { unicodeslot=0x1D792, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL GAMMA', specials={'font',0x0393} },
	[0x1D793] = { unicodeslot=0x1D793, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL DELTA', specials={'font',0x0394} },
	[0x1D794] = { unicodeslot=0x1D794, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL EPSILON', specials={'font',0x0395} },
	[0x1D795] = { unicodeslot=0x1D795, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ZETA', specials={'font',0x0396} },
	[0x1D796] = { unicodeslot=0x1D796, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ETA', specials={'font',0x0397} },
	[0x1D797] = { unicodeslot=0x1D797, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA', specials={'font',0x0398} },
	[0x1D798] = { unicodeslot=0x1D798, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL IOTA', specials={'font',0x0399} },
	[0x1D799] = { unicodeslot=0x1D799, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL KAPPA', specials={'font',0x039A} },
	[0x1D79A] = { unicodeslot=0x1D79A, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL LAMDA', specials={'font',0x039B} },
	[0x1D79B] = { unicodeslot=0x1D79B, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL MU', specials={'font',0x039C} },
	[0x1D79C] = { unicodeslot=0x1D79C, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL NU', specials={'font',0x039D} },
	[0x1D79D] = { unicodeslot=0x1D79D, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL XI', specials={'font',0x039E} },
	[0x1D79E] = { unicodeslot=0x1D79E, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMICRON', specials={'font',0x039F} },
	[0x1D79F] = { unicodeslot=0x1D79F, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PI', specials={'font',0x03A0} },
	[0x1D7A0] = { unicodeslot=0x1D7A0, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL RHO', specials={'font',0x03A1} },
	[0x1D7A1] = { unicodeslot=0x1D7A1, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA SYMBOL', specials={'font',0x03F4} },
	[0x1D7A2] = { unicodeslot=0x1D7A2, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL SIGMA', specials={'font',0x03A3} },
	[0x1D7A3] = { unicodeslot=0x1D7A3, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL TAU', specials={'font',0x03A4} },
	[0x1D7A4] = { unicodeslot=0x1D7A4, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL UPSILON', specials={'font',0x03A5} },
	[0x1D7A5] = { unicodeslot=0x1D7A5, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PHI', specials={'font',0x03A6} },
	[0x1D7A6] = { unicodeslot=0x1D7A6, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL CHI', specials={'font',0x03A7} },
	[0x1D7A7] = { unicodeslot=0x1D7A7, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PSI', specials={'font',0x03A8} },
	[0x1D7A8] = { unicodeslot=0x1D7A8, category='lu', description='MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA', specials={'font',0x03A9} },
	[0x1D7A9] = { unicodeslot=0x1D7A9, category='sm', description='MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA', specials={'font',0x2207} },
	[0x1D7AA] = { unicodeslot=0x1D7AA, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA', specials={'font',0x03B1} },
	[0x1D7AB] = { unicodeslot=0x1D7AB, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL BETA', specials={'font',0x03B2} },
	[0x1D7AC] = { unicodeslot=0x1D7AC, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL GAMMA', specials={'font',0x03B3} },
	[0x1D7AD] = { unicodeslot=0x1D7AD, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL DELTA', specials={'font',0x03B4} },
	[0x1D7AE] = { unicodeslot=0x1D7AE, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL EPSILON', specials={'font',0x03B5} },
	[0x1D7AF] = { unicodeslot=0x1D7AF, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ZETA', specials={'font',0x03B6} },
	[0x1D7B0] = { unicodeslot=0x1D7B0, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ETA', specials={'font',0x03B7} },
	[0x1D7B1] = { unicodeslot=0x1D7B1, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL THETA', specials={'font',0x03B8} },
	[0x1D7B2] = { unicodeslot=0x1D7B2, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL IOTA', specials={'font',0x03B9} },
	[0x1D7B3] = { unicodeslot=0x1D7B3, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL KAPPA', specials={'font',0x03BA} },
	[0x1D7B4] = { unicodeslot=0x1D7B4, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL LAMDA', specials={'font',0x03BB} },
	[0x1D7B5] = { unicodeslot=0x1D7B5, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL MU', specials={'font',0x03BC} },
	[0x1D7B6] = { unicodeslot=0x1D7B6, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL NU', specials={'font',0x03BD} },
	[0x1D7B7] = { unicodeslot=0x1D7B7, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL XI', specials={'font',0x03BE} },
	[0x1D7B8] = { unicodeslot=0x1D7B8, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMICRON', specials={'font',0x03BF} },
	[0x1D7B9] = { unicodeslot=0x1D7B9, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PI', specials={'font',0x03C0} },
	[0x1D7BA] = { unicodeslot=0x1D7BA, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL RHO', specials={'font',0x03C1} },
	[0x1D7BB] = { unicodeslot=0x1D7BB, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL FINAL SIGMA', specials={'font',0x03C2} },
	[0x1D7BC] = { unicodeslot=0x1D7BC, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL SIGMA', specials={'font',0x03C3} },
	[0x1D7BD] = { unicodeslot=0x1D7BD, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL TAU', specials={'font',0x03C4} },
	[0x1D7BE] = { unicodeslot=0x1D7BE, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL UPSILON', specials={'font',0x03C5} },
	[0x1D7BF] = { unicodeslot=0x1D7BF, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PHI', specials={'font',0x03C6} },
	[0x1D7C0] = { unicodeslot=0x1D7C0, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL CHI', specials={'font',0x03C7} },
	[0x1D7C1] = { unicodeslot=0x1D7C1, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PSI', specials={'font',0x03C8} },
	[0x1D7C2] = { unicodeslot=0x1D7C2, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA', specials={'font',0x03C9} },
	[0x1D7C3] = { unicodeslot=0x1D7C3, category='sm', description='MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL', specials={'font',0x2202} },
	[0x1D7C4] = { unicodeslot=0x1D7C4, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL', specials={'font',0x03F5} },
	[0x1D7C5] = { unicodeslot=0x1D7C5, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC THETA SYMBOL', specials={'font',0x03D1} },
	[0x1D7C6] = { unicodeslot=0x1D7C6, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC KAPPA SYMBOL', specials={'font',0x03F0} },
	[0x1D7C7] = { unicodeslot=0x1D7C7, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC PHI SYMBOL', specials={'font',0x03D5} },
	[0x1D7C8] = { unicodeslot=0x1D7C8, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC RHO SYMBOL', specials={'font',0x03F1} },
	[0x1D7C9] = { unicodeslot=0x1D7C9, category='ll', description='MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL', specials={'font',0x03D6} },
	[0x1D7CA] = { unicodeslot=0x1D7CA, category='lu', description='MATHEMATICAL BOLD CAPITAL DIGAMMA', specials={'font',0x03DC} },
	[0x1D7CB] = { unicodeslot=0x1D7CB, category='ll', description='MATHEMATICAL BOLD SMALL DIGAMMA', specials={'font',0x03DD} },
	[0x1D7CE] = { unicodeslot=0x1D7CE, category='nd', description='MATHEMATICAL BOLD DIGIT ZERO', specials={'font',0x0030} },
	[0x1D7CF] = { unicodeslot=0x1D7CF, category='nd', description='MATHEMATICAL BOLD DIGIT ONE', specials={'font',0x0031} },
	[0x1D7D0] = { unicodeslot=0x1D7D0, category='nd', description='MATHEMATICAL BOLD DIGIT TWO', specials={'font',0x0032} },
	[0x1D7D1] = { unicodeslot=0x1D7D1, category='nd', description='MATHEMATICAL BOLD DIGIT THREE', specials={'font',0x0033} },
	[0x1D7D2] = { unicodeslot=0x1D7D2, category='nd', description='MATHEMATICAL BOLD DIGIT FOUR', specials={'font',0x0034} },
	[0x1D7D3] = { unicodeslot=0x1D7D3, category='nd', description='MATHEMATICAL BOLD DIGIT FIVE', specials={'font',0x0035} },
	[0x1D7D4] = { unicodeslot=0x1D7D4, category='nd', description='MATHEMATICAL BOLD DIGIT SIX', specials={'font',0x0036} },
	[0x1D7D5] = { unicodeslot=0x1D7D5, category='nd', description='MATHEMATICAL BOLD DIGIT SEVEN', specials={'font',0x0037} },
	[0x1D7D6] = { unicodeslot=0x1D7D6, category='nd', description='MATHEMATICAL BOLD DIGIT EIGHT', specials={'font',0x0038} },
	[0x1D7D7] = { unicodeslot=0x1D7D7, category='nd', description='MATHEMATICAL BOLD DIGIT NINE', specials={'font',0x0039} },
	[0x1D7D8] = { unicodeslot=0x1D7D8, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT ZERO', specials={'font',0x0030} },
	[0x1D7D9] = { unicodeslot=0x1D7D9, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT ONE', specials={'font',0x0031} },
	[0x1D7DA] = { unicodeslot=0x1D7DA, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT TWO', specials={'font',0x0032} },
	[0x1D7DB] = { unicodeslot=0x1D7DB, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT THREE', specials={'font',0x0033} },
	[0x1D7DC] = { unicodeslot=0x1D7DC, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT FOUR', specials={'font',0x0034} },
	[0x1D7DD] = { unicodeslot=0x1D7DD, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT FIVE', specials={'font',0x0035} },
	[0x1D7DE] = { unicodeslot=0x1D7DE, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT SIX', specials={'font',0x0036} },
	[0x1D7DF] = { unicodeslot=0x1D7DF, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN', specials={'font',0x0037} },
	[0x1D7E0] = { unicodeslot=0x1D7E0, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT EIGHT', specials={'font',0x0038} },
	[0x1D7E1] = { unicodeslot=0x1D7E1, category='nd', description='MATHEMATICAL DOUBLE-STRUCK DIGIT NINE', specials={'font',0x0039} },
	[0x1D7E2] = { unicodeslot=0x1D7E2, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT ZERO', specials={'font',0x0030} },
	[0x1D7E3] = { unicodeslot=0x1D7E3, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT ONE', specials={'font',0x0031} },
	[0x1D7E4] = { unicodeslot=0x1D7E4, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT TWO', specials={'font',0x0032} },
	[0x1D7E5] = { unicodeslot=0x1D7E5, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT THREE', specials={'font',0x0033} },
	[0x1D7E6] = { unicodeslot=0x1D7E6, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT FOUR', specials={'font',0x0034} },
	[0x1D7E7] = { unicodeslot=0x1D7E7, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT FIVE', specials={'font',0x0035} },
	[0x1D7E8] = { unicodeslot=0x1D7E8, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT SIX', specials={'font',0x0036} },
	[0x1D7E9] = { unicodeslot=0x1D7E9, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT SEVEN', specials={'font',0x0037} },
	[0x1D7EA] = { unicodeslot=0x1D7EA, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT EIGHT', specials={'font',0x0038} },
	[0x1D7EB] = { unicodeslot=0x1D7EB, category='nd', description='MATHEMATICAL SANS-SERIF DIGIT NINE', specials={'font',0x0039} },
	[0x1D7EC] = { unicodeslot=0x1D7EC, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT ZERO', specials={'font',0x0030} },
	[0x1D7ED] = { unicodeslot=0x1D7ED, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT ONE', specials={'font',0x0031} },
	[0x1D7EE] = { unicodeslot=0x1D7EE, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT TWO', specials={'font',0x0032} },
	[0x1D7EF] = { unicodeslot=0x1D7EF, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT THREE', specials={'font',0x0033} },
	[0x1D7F0] = { unicodeslot=0x1D7F0, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT FOUR', specials={'font',0x0034} },
	[0x1D7F1] = { unicodeslot=0x1D7F1, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT FIVE', specials={'font',0x0035} },
	[0x1D7F2] = { unicodeslot=0x1D7F2, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT SIX', specials={'font',0x0036} },
	[0x1D7F3] = { unicodeslot=0x1D7F3, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT SEVEN', specials={'font',0x0037} },
	[0x1D7F4] = { unicodeslot=0x1D7F4, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT EIGHT', specials={'font',0x0038} },
	[0x1D7F5] = { unicodeslot=0x1D7F5, category='nd', description='MATHEMATICAL SANS-SERIF BOLD DIGIT NINE', specials={'font',0x0039} },
	[0x1D7F6] = { unicodeslot=0x1D7F6, category='nd', description='MATHEMATICAL MONOSPACE DIGIT ZERO', specials={'font',0x0030} },
	[0x1D7F7] = { unicodeslot=0x1D7F7, category='nd', description='MATHEMATICAL MONOSPACE DIGIT ONE', specials={'font',0x0031} },
	[0x1D7F8] = { unicodeslot=0x1D7F8, category='nd', description='MATHEMATICAL MONOSPACE DIGIT TWO', specials={'font',0x0032} },
	[0x1D7F9] = { unicodeslot=0x1D7F9, category='nd', description='MATHEMATICAL MONOSPACE DIGIT THREE', specials={'font',0x0033} },
	[0x1D7FA] = { unicodeslot=0x1D7FA, category='nd', description='MATHEMATICAL MONOSPACE DIGIT FOUR', specials={'font',0x0034} },
	[0x1D7FB] = { unicodeslot=0x1D7FB, category='nd', description='MATHEMATICAL MONOSPACE DIGIT FIVE', specials={'font',0x0035} },
	[0x1D7FC] = { unicodeslot=0x1D7FC, category='nd', description='MATHEMATICAL MONOSPACE DIGIT SIX', specials={'font',0x0036} },
	[0x1D7FD] = { unicodeslot=0x1D7FD, category='nd', description='MATHEMATICAL MONOSPACE DIGIT SEVEN', specials={'font',0x0037} },
	[0x1D7FE] = { unicodeslot=0x1D7FE, category='nd', description='MATHEMATICAL MONOSPACE DIGIT EIGHT', specials={'font',0x0038} },
	[0x1D7FF] = { unicodeslot=0x1D7FF, category='nd', description='MATHEMATICAL MONOSPACE DIGIT NINE', specials={'font',0x0039} },
	[0x20000] = { unicodeslot=0x20000, category='lo', description='<CJK Ideograph Extension B, First>' },
	[0x2A6D6] = { unicodeslot=0x2A6D6, category='lo', description='<CJK Ideograph Extension B, Last>' },
	[0x2F800] = { unicodeslot=0x2F800, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F800', specials={'char',0x4E3D} },
	[0x2F801] = { unicodeslot=0x2F801, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F801', specials={'char',0x4E38} },
	[0x2F802] = { unicodeslot=0x2F802, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F802', specials={'char',0x4E41} },
	[0x2F803] = { unicodeslot=0x2F803, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F803', specials={'char',0x20122} },
	[0x2F804] = { unicodeslot=0x2F804, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F804', specials={'char',0x4F60} },
	[0x2F805] = { unicodeslot=0x2F805, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F805', specials={'char',0x4FAE} },
	[0x2F806] = { unicodeslot=0x2F806, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F806', specials={'char',0x4FBB} },
	[0x2F807] = { unicodeslot=0x2F807, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F807', specials={'char',0x5002} },
	[0x2F808] = { unicodeslot=0x2F808, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F808', specials={'char',0x507A} },
	[0x2F809] = { unicodeslot=0x2F809, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F809', specials={'char',0x5099} },
	[0x2F80A] = { unicodeslot=0x2F80A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F80A', specials={'char',0x50E7} },
	[0x2F80B] = { unicodeslot=0x2F80B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F80B', specials={'char',0x50CF} },
	[0x2F80C] = { unicodeslot=0x2F80C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F80C', specials={'char',0x349E} },
	[0x2F80D] = { unicodeslot=0x2F80D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F80D', specials={'char',0x2063A} },
	[0x2F80E] = { unicodeslot=0x2F80E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F80E', specials={'char',0x514D} },
	[0x2F80F] = { unicodeslot=0x2F80F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F80F', specials={'char',0x5154} },
	[0x2F810] = { unicodeslot=0x2F810, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F810', specials={'char',0x5164} },
	[0x2F811] = { unicodeslot=0x2F811, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F811', specials={'char',0x5177} },
	[0x2F812] = { unicodeslot=0x2F812, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F812', specials={'char',0x2051C} },
	[0x2F813] = { unicodeslot=0x2F813, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F813', specials={'char',0x34B9} },
	[0x2F814] = { unicodeslot=0x2F814, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F814', specials={'char',0x5167} },
	[0x2F815] = { unicodeslot=0x2F815, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F815', specials={'char',0x518D} },
	[0x2F816] = { unicodeslot=0x2F816, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F816', specials={'char',0x2054B} },
	[0x2F817] = { unicodeslot=0x2F817, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F817', specials={'char',0x5197} },
	[0x2F818] = { unicodeslot=0x2F818, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F818', specials={'char',0x51A4} },
	[0x2F819] = { unicodeslot=0x2F819, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F819', specials={'char',0x4ECC} },
	[0x2F81A] = { unicodeslot=0x2F81A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F81A', specials={'char',0x51AC} },
	[0x2F81B] = { unicodeslot=0x2F81B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F81B', specials={'char',0x51B5} },
	[0x2F81C] = { unicodeslot=0x2F81C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F81C', specials={'char',0x291DF} },
	[0x2F81D] = { unicodeslot=0x2F81D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F81D', specials={'char',0x51F5} },
	[0x2F81E] = { unicodeslot=0x2F81E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F81E', specials={'char',0x5203} },
	[0x2F81F] = { unicodeslot=0x2F81F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F81F', specials={'char',0x34DF} },
	[0x2F820] = { unicodeslot=0x2F820, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F820', specials={'char',0x523B} },
	[0x2F821] = { unicodeslot=0x2F821, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F821', specials={'char',0x5246} },
	[0x2F822] = { unicodeslot=0x2F822, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F822', specials={'char',0x5272} },
	[0x2F823] = { unicodeslot=0x2F823, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F823', specials={'char',0x5277} },
	[0x2F824] = { unicodeslot=0x2F824, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F824', specials={'char',0x3515} },
	[0x2F825] = { unicodeslot=0x2F825, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F825', specials={'char',0x52C7} },
	[0x2F826] = { unicodeslot=0x2F826, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F826', specials={'char',0x52C9} },
	[0x2F827] = { unicodeslot=0x2F827, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F827', specials={'char',0x52E4} },
	[0x2F828] = { unicodeslot=0x2F828, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F828', specials={'char',0x52FA} },
	[0x2F829] = { unicodeslot=0x2F829, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F829', specials={'char',0x5305} },
	[0x2F82A] = { unicodeslot=0x2F82A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F82A', specials={'char',0x5306} },
	[0x2F82B] = { unicodeslot=0x2F82B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F82B', specials={'char',0x5317} },
	[0x2F82C] = { unicodeslot=0x2F82C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F82C', specials={'char',0x5349} },
	[0x2F82D] = { unicodeslot=0x2F82D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F82D', specials={'char',0x5351} },
	[0x2F82E] = { unicodeslot=0x2F82E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F82E', specials={'char',0x535A} },
	[0x2F82F] = { unicodeslot=0x2F82F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F82F', specials={'char',0x5373} },
	[0x2F830] = { unicodeslot=0x2F830, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F830', specials={'char',0x537D} },
	[0x2F831] = { unicodeslot=0x2F831, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F831', specials={'char',0x537F} },
	[0x2F832] = { unicodeslot=0x2F832, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F832', specials={'char',0x537F} },
	[0x2F833] = { unicodeslot=0x2F833, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F833', specials={'char',0x537F} },
	[0x2F834] = { unicodeslot=0x2F834, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F834', specials={'char',0x20A2C} },
	[0x2F835] = { unicodeslot=0x2F835, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F835', specials={'char',0x7070} },
	[0x2F836] = { unicodeslot=0x2F836, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F836', specials={'char',0x53CA} },
	[0x2F837] = { unicodeslot=0x2F837, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F837', specials={'char',0x53DF} },
	[0x2F838] = { unicodeslot=0x2F838, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F838', specials={'char',0x20B63} },
	[0x2F839] = { unicodeslot=0x2F839, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F839', specials={'char',0x53EB} },
	[0x2F83A] = { unicodeslot=0x2F83A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F83A', specials={'char',0x53F1} },
	[0x2F83B] = { unicodeslot=0x2F83B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F83B', specials={'char',0x5406} },
	[0x2F83C] = { unicodeslot=0x2F83C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F83C', specials={'char',0x549E} },
	[0x2F83D] = { unicodeslot=0x2F83D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F83D', specials={'char',0x5438} },
	[0x2F83E] = { unicodeslot=0x2F83E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F83E', specials={'char',0x5448} },
	[0x2F83F] = { unicodeslot=0x2F83F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F83F', specials={'char',0x5468} },
	[0x2F840] = { unicodeslot=0x2F840, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F840', specials={'char',0x54A2} },
	[0x2F841] = { unicodeslot=0x2F841, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F841', specials={'char',0x54F6} },
	[0x2F842] = { unicodeslot=0x2F842, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F842', specials={'char',0x5510} },
	[0x2F843] = { unicodeslot=0x2F843, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F843', specials={'char',0x5553} },
	[0x2F844] = { unicodeslot=0x2F844, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F844', specials={'char',0x5563} },
	[0x2F845] = { unicodeslot=0x2F845, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F845', specials={'char',0x5584} },
	[0x2F846] = { unicodeslot=0x2F846, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F846', specials={'char',0x5584} },
	[0x2F847] = { unicodeslot=0x2F847, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F847', specials={'char',0x5599} },
	[0x2F848] = { unicodeslot=0x2F848, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F848', specials={'char',0x55AB} },
	[0x2F849] = { unicodeslot=0x2F849, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F849', specials={'char',0x55B3} },
	[0x2F84A] = { unicodeslot=0x2F84A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F84A', specials={'char',0x55C2} },
	[0x2F84B] = { unicodeslot=0x2F84B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F84B', specials={'char',0x5716} },
	[0x2F84C] = { unicodeslot=0x2F84C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F84C', specials={'char',0x5606} },
	[0x2F84D] = { unicodeslot=0x2F84D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F84D', specials={'char',0x5717} },
	[0x2F84E] = { unicodeslot=0x2F84E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F84E', specials={'char',0x5651} },
	[0x2F84F] = { unicodeslot=0x2F84F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F84F', specials={'char',0x5674} },
	[0x2F850] = { unicodeslot=0x2F850, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F850', specials={'char',0x5207} },
	[0x2F851] = { unicodeslot=0x2F851, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F851', specials={'char',0x58EE} },
	[0x2F852] = { unicodeslot=0x2F852, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F852', specials={'char',0x57CE} },
	[0x2F853] = { unicodeslot=0x2F853, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F853', specials={'char',0x57F4} },
	[0x2F854] = { unicodeslot=0x2F854, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F854', specials={'char',0x580D} },
	[0x2F855] = { unicodeslot=0x2F855, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F855', specials={'char',0x578B} },
	[0x2F856] = { unicodeslot=0x2F856, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F856', specials={'char',0x5832} },
	[0x2F857] = { unicodeslot=0x2F857, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F857', specials={'char',0x5831} },
	[0x2F858] = { unicodeslot=0x2F858, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F858', specials={'char',0x58AC} },
	[0x2F859] = { unicodeslot=0x2F859, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F859', specials={'char',0x214E4} },
	[0x2F85A] = { unicodeslot=0x2F85A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F85A', specials={'char',0x58F2} },
	[0x2F85B] = { unicodeslot=0x2F85B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F85B', specials={'char',0x58F7} },
	[0x2F85C] = { unicodeslot=0x2F85C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F85C', specials={'char',0x5906} },
	[0x2F85D] = { unicodeslot=0x2F85D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F85D', specials={'char',0x591A} },
	[0x2F85E] = { unicodeslot=0x2F85E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F85E', specials={'char',0x5922} },
	[0x2F85F] = { unicodeslot=0x2F85F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F85F', specials={'char',0x5962} },
	[0x2F860] = { unicodeslot=0x2F860, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F860', specials={'char',0x216A8} },
	[0x2F861] = { unicodeslot=0x2F861, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F861', specials={'char',0x216EA} },
	[0x2F862] = { unicodeslot=0x2F862, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F862', specials={'char',0x59EC} },
	[0x2F863] = { unicodeslot=0x2F863, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F863', specials={'char',0x5A1B} },
	[0x2F864] = { unicodeslot=0x2F864, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F864', specials={'char',0x5A27} },
	[0x2F865] = { unicodeslot=0x2F865, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F865', specials={'char',0x59D8} },
	[0x2F866] = { unicodeslot=0x2F866, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F866', specials={'char',0x5A66} },
	[0x2F867] = { unicodeslot=0x2F867, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F867', specials={'char',0x36EE} },
	[0x2F868] = { unicodeslot=0x2F868, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F868', specials={'char',0x36FC} },
	[0x2F869] = { unicodeslot=0x2F869, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F869', specials={'char',0x5B08} },
	[0x2F86A] = { unicodeslot=0x2F86A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F86A', specials={'char',0x5B3E} },
	[0x2F86B] = { unicodeslot=0x2F86B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F86B', specials={'char',0x5B3E} },
	[0x2F86C] = { unicodeslot=0x2F86C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F86C', specials={'char',0x219C8} },
	[0x2F86D] = { unicodeslot=0x2F86D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F86D', specials={'char',0x5BC3} },
	[0x2F86E] = { unicodeslot=0x2F86E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F86E', specials={'char',0x5BD8} },
	[0x2F86F] = { unicodeslot=0x2F86F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F86F', specials={'char',0x5BE7} },
	[0x2F870] = { unicodeslot=0x2F870, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F870', specials={'char',0x5BF3} },
	[0x2F871] = { unicodeslot=0x2F871, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F871', specials={'char',0x21B18} },
	[0x2F872] = { unicodeslot=0x2F872, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F872', specials={'char',0x5BFF} },
	[0x2F873] = { unicodeslot=0x2F873, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F873', specials={'char',0x5C06} },
	[0x2F874] = { unicodeslot=0x2F874, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F874', specials={'char',0x5F53} },
	[0x2F875] = { unicodeslot=0x2F875, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F875', specials={'char',0x5C22} },
	[0x2F876] = { unicodeslot=0x2F876, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F876', specials={'char',0x3781} },
	[0x2F877] = { unicodeslot=0x2F877, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F877', specials={'char',0x5C60} },
	[0x2F878] = { unicodeslot=0x2F878, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F878', specials={'char',0x5C6E} },
	[0x2F879] = { unicodeslot=0x2F879, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F879', specials={'char',0x5CC0} },
	[0x2F87A] = { unicodeslot=0x2F87A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F87A', specials={'char',0x5C8D} },
	[0x2F87B] = { unicodeslot=0x2F87B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F87B', specials={'char',0x21DE4} },
	[0x2F87C] = { unicodeslot=0x2F87C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F87C', specials={'char',0x5D43} },
	[0x2F87D] = { unicodeslot=0x2F87D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F87D', specials={'char',0x21DE6} },
	[0x2F87E] = { unicodeslot=0x2F87E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F87E', specials={'char',0x5D6E} },
	[0x2F87F] = { unicodeslot=0x2F87F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F87F', specials={'char',0x5D6B} },
	[0x2F880] = { unicodeslot=0x2F880, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F880', specials={'char',0x5D7C} },
	[0x2F881] = { unicodeslot=0x2F881, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F881', specials={'char',0x5DE1} },
	[0x2F882] = { unicodeslot=0x2F882, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F882', specials={'char',0x5DE2} },
	[0x2F883] = { unicodeslot=0x2F883, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F883', specials={'char',0x382F} },
	[0x2F884] = { unicodeslot=0x2F884, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F884', specials={'char',0x5DFD} },
	[0x2F885] = { unicodeslot=0x2F885, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F885', specials={'char',0x5E28} },
	[0x2F886] = { unicodeslot=0x2F886, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F886', specials={'char',0x5E3D} },
	[0x2F887] = { unicodeslot=0x2F887, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F887', specials={'char',0x5E69} },
	[0x2F888] = { unicodeslot=0x2F888, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F888', specials={'char',0x3862} },
	[0x2F889] = { unicodeslot=0x2F889, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F889', specials={'char',0x22183} },
	[0x2F88A] = { unicodeslot=0x2F88A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F88A', specials={'char',0x387C} },
	[0x2F88B] = { unicodeslot=0x2F88B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F88B', specials={'char',0x5EB0} },
	[0x2F88C] = { unicodeslot=0x2F88C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F88C', specials={'char',0x5EB3} },
	[0x2F88D] = { unicodeslot=0x2F88D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F88D', specials={'char',0x5EB6} },
	[0x2F88E] = { unicodeslot=0x2F88E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F88E', specials={'char',0x5ECA} },
	[0x2F88F] = { unicodeslot=0x2F88F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F88F', specials={'char',0x2A392} },
	[0x2F890] = { unicodeslot=0x2F890, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F890', specials={'char',0x5EFE} },
	[0x2F891] = { unicodeslot=0x2F891, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F891', specials={'char',0x22331} },
	[0x2F892] = { unicodeslot=0x2F892, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F892', specials={'char',0x22331} },
	[0x2F893] = { unicodeslot=0x2F893, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F893', specials={'char',0x8201} },
	[0x2F894] = { unicodeslot=0x2F894, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F894', specials={'char',0x5F22} },
	[0x2F895] = { unicodeslot=0x2F895, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F895', specials={'char',0x5F22} },
	[0x2F896] = { unicodeslot=0x2F896, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F896', specials={'char',0x38C7} },
	[0x2F897] = { unicodeslot=0x2F897, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F897', specials={'char',0x232B8} },
	[0x2F898] = { unicodeslot=0x2F898, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F898', specials={'char',0x261DA} },
	[0x2F899] = { unicodeslot=0x2F899, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F899', specials={'char',0x5F62} },
	[0x2F89A] = { unicodeslot=0x2F89A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F89A', specials={'char',0x5F6B} },
	[0x2F89B] = { unicodeslot=0x2F89B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F89B', specials={'char',0x38E3} },
	[0x2F89C] = { unicodeslot=0x2F89C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F89C', specials={'char',0x5F9A} },
	[0x2F89D] = { unicodeslot=0x2F89D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F89D', specials={'char',0x5FCD} },
	[0x2F89E] = { unicodeslot=0x2F89E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F89E', specials={'char',0x5FD7} },
	[0x2F89F] = { unicodeslot=0x2F89F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F89F', specials={'char',0x5FF9} },
	[0x2F8A0] = { unicodeslot=0x2F8A0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A0', specials={'char',0x6081} },
	[0x2F8A1] = { unicodeslot=0x2F8A1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A1', specials={'char',0x393A} },
	[0x2F8A2] = { unicodeslot=0x2F8A2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A2', specials={'char',0x391C} },
	[0x2F8A3] = { unicodeslot=0x2F8A3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A3', specials={'char',0x6094} },
	[0x2F8A4] = { unicodeslot=0x2F8A4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A4', specials={'char',0x226D4} },
	[0x2F8A5] = { unicodeslot=0x2F8A5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A5', specials={'char',0x60C7} },
	[0x2F8A6] = { unicodeslot=0x2F8A6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A6', specials={'char',0x6148} },
	[0x2F8A7] = { unicodeslot=0x2F8A7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A7', specials={'char',0x614C} },
	[0x2F8A8] = { unicodeslot=0x2F8A8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A8', specials={'char',0x614E} },
	[0x2F8A9] = { unicodeslot=0x2F8A9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8A9', specials={'char',0x614C} },
	[0x2F8AA] = { unicodeslot=0x2F8AA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8AA', specials={'char',0x617A} },
	[0x2F8AB] = { unicodeslot=0x2F8AB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8AB', specials={'char',0x618E} },
	[0x2F8AC] = { unicodeslot=0x2F8AC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8AC', specials={'char',0x61B2} },
	[0x2F8AD] = { unicodeslot=0x2F8AD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8AD', specials={'char',0x61A4} },
	[0x2F8AE] = { unicodeslot=0x2F8AE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8AE', specials={'char',0x61AF} },
	[0x2F8AF] = { unicodeslot=0x2F8AF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8AF', specials={'char',0x61DE} },
	[0x2F8B0] = { unicodeslot=0x2F8B0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B0', specials={'char',0x61F2} },
	[0x2F8B1] = { unicodeslot=0x2F8B1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B1', specials={'char',0x61F6} },
	[0x2F8B2] = { unicodeslot=0x2F8B2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B2', specials={'char',0x6210} },
	[0x2F8B3] = { unicodeslot=0x2F8B3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B3', specials={'char',0x621B} },
	[0x2F8B4] = { unicodeslot=0x2F8B4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B4', specials={'char',0x625D} },
	[0x2F8B5] = { unicodeslot=0x2F8B5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B5', specials={'char',0x62B1} },
	[0x2F8B6] = { unicodeslot=0x2F8B6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B6', specials={'char',0x62D4} },
	[0x2F8B7] = { unicodeslot=0x2F8B7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B7', specials={'char',0x6350} },
	[0x2F8B8] = { unicodeslot=0x2F8B8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B8', specials={'char',0x22B0C} },
	[0x2F8B9] = { unicodeslot=0x2F8B9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8B9', specials={'char',0x633D} },
	[0x2F8BA] = { unicodeslot=0x2F8BA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8BA', specials={'char',0x62FC} },
	[0x2F8BB] = { unicodeslot=0x2F8BB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8BB', specials={'char',0x6368} },
	[0x2F8BC] = { unicodeslot=0x2F8BC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8BC', specials={'char',0x6383} },
	[0x2F8BD] = { unicodeslot=0x2F8BD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8BD', specials={'char',0x63E4} },
	[0x2F8BE] = { unicodeslot=0x2F8BE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8BE', specials={'char',0x22BF1} },
	[0x2F8BF] = { unicodeslot=0x2F8BF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8BF', specials={'char',0x6422} },
	[0x2F8C0] = { unicodeslot=0x2F8C0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C0', specials={'char',0x63C5} },
	[0x2F8C1] = { unicodeslot=0x2F8C1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C1', specials={'char',0x63A9} },
	[0x2F8C2] = { unicodeslot=0x2F8C2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C2', specials={'char',0x3A2E} },
	[0x2F8C3] = { unicodeslot=0x2F8C3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C3', specials={'char',0x6469} },
	[0x2F8C4] = { unicodeslot=0x2F8C4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C4', specials={'char',0x647E} },
	[0x2F8C5] = { unicodeslot=0x2F8C5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C5', specials={'char',0x649D} },
	[0x2F8C6] = { unicodeslot=0x2F8C6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C6', specials={'char',0x6477} },
	[0x2F8C7] = { unicodeslot=0x2F8C7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C7', specials={'char',0x3A6C} },
	[0x2F8C8] = { unicodeslot=0x2F8C8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C8', specials={'char',0x654F} },
	[0x2F8C9] = { unicodeslot=0x2F8C9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8C9', specials={'char',0x656C} },
	[0x2F8CA] = { unicodeslot=0x2F8CA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8CA', specials={'char',0x2300A} },
	[0x2F8CB] = { unicodeslot=0x2F8CB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8CB', specials={'char',0x65E3} },
	[0x2F8CC] = { unicodeslot=0x2F8CC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8CC', specials={'char',0x66F8} },
	[0x2F8CD] = { unicodeslot=0x2F8CD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8CD', specials={'char',0x6649} },
	[0x2F8CE] = { unicodeslot=0x2F8CE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8CE', specials={'char',0x3B19} },
	[0x2F8CF] = { unicodeslot=0x2F8CF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8CF', specials={'char',0x6691} },
	[0x2F8D0] = { unicodeslot=0x2F8D0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D0', specials={'char',0x3B08} },
	[0x2F8D1] = { unicodeslot=0x2F8D1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D1', specials={'char',0x3AE4} },
	[0x2F8D2] = { unicodeslot=0x2F8D2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D2', specials={'char',0x5192} },
	[0x2F8D3] = { unicodeslot=0x2F8D3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D3', specials={'char',0x5195} },
	[0x2F8D4] = { unicodeslot=0x2F8D4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D4', specials={'char',0x6700} },
	[0x2F8D5] = { unicodeslot=0x2F8D5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D5', specials={'char',0x669C} },
	[0x2F8D6] = { unicodeslot=0x2F8D6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D6', specials={'char',0x80AD} },
	[0x2F8D7] = { unicodeslot=0x2F8D7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D7', specials={'char',0x43D9} },
	[0x2F8D8] = { unicodeslot=0x2F8D8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D8', specials={'char',0x6717} },
	[0x2F8D9] = { unicodeslot=0x2F8D9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8D9', specials={'char',0x671B} },
	[0x2F8DA] = { unicodeslot=0x2F8DA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8DA', specials={'char',0x6721} },
	[0x2F8DB] = { unicodeslot=0x2F8DB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8DB', specials={'char',0x675E} },
	[0x2F8DC] = { unicodeslot=0x2F8DC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8DC', specials={'char',0x6753} },
	[0x2F8DD] = { unicodeslot=0x2F8DD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8DD', specials={'char',0x233C3} },
	[0x2F8DE] = { unicodeslot=0x2F8DE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8DE', specials={'char',0x3B49} },
	[0x2F8DF] = { unicodeslot=0x2F8DF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8DF', specials={'char',0x67FA} },
	[0x2F8E0] = { unicodeslot=0x2F8E0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E0', specials={'char',0x6785} },
	[0x2F8E1] = { unicodeslot=0x2F8E1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E1', specials={'char',0x6852} },
	[0x2F8E2] = { unicodeslot=0x2F8E2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E2', specials={'char',0x6885} },
	[0x2F8E3] = { unicodeslot=0x2F8E3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E3', specials={'char',0x2346D} },
	[0x2F8E4] = { unicodeslot=0x2F8E4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E4', specials={'char',0x688E} },
	[0x2F8E5] = { unicodeslot=0x2F8E5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E5', specials={'char',0x681F} },
	[0x2F8E6] = { unicodeslot=0x2F8E6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E6', specials={'char',0x6914} },
	[0x2F8E7] = { unicodeslot=0x2F8E7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E7', specials={'char',0x3B9D} },
	[0x2F8E8] = { unicodeslot=0x2F8E8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E8', specials={'char',0x6942} },
	[0x2F8E9] = { unicodeslot=0x2F8E9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8E9', specials={'char',0x69A3} },
	[0x2F8EA] = { unicodeslot=0x2F8EA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8EA', specials={'char',0x69EA} },
	[0x2F8EB] = { unicodeslot=0x2F8EB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8EB', specials={'char',0x6AA8} },
	[0x2F8EC] = { unicodeslot=0x2F8EC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8EC', specials={'char',0x236A3} },
	[0x2F8ED] = { unicodeslot=0x2F8ED, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8ED', specials={'char',0x6ADB} },
	[0x2F8EE] = { unicodeslot=0x2F8EE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8EE', specials={'char',0x3C18} },
	[0x2F8EF] = { unicodeslot=0x2F8EF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8EF', specials={'char',0x6B21} },
	[0x2F8F0] = { unicodeslot=0x2F8F0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F0', specials={'char',0x238A7} },
	[0x2F8F1] = { unicodeslot=0x2F8F1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F1', specials={'char',0x6B54} },
	[0x2F8F2] = { unicodeslot=0x2F8F2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F2', specials={'char',0x3C4E} },
	[0x2F8F3] = { unicodeslot=0x2F8F3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F3', specials={'char',0x6B72} },
	[0x2F8F4] = { unicodeslot=0x2F8F4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F4', specials={'char',0x6B9F} },
	[0x2F8F5] = { unicodeslot=0x2F8F5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F5', specials={'char',0x6BBA} },
	[0x2F8F6] = { unicodeslot=0x2F8F6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F6', specials={'char',0x6BBB} },
	[0x2F8F7] = { unicodeslot=0x2F8F7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F7', specials={'char',0x23A8D} },
	[0x2F8F8] = { unicodeslot=0x2F8F8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F8', specials={'char',0x21D0B} },
	[0x2F8F9] = { unicodeslot=0x2F8F9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8F9', specials={'char',0x23AFA} },
	[0x2F8FA] = { unicodeslot=0x2F8FA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8FA', specials={'char',0x6C4E} },
	[0x2F8FB] = { unicodeslot=0x2F8FB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8FB', specials={'char',0x23CBC} },
	[0x2F8FC] = { unicodeslot=0x2F8FC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8FC', specials={'char',0x6CBF} },
	[0x2F8FD] = { unicodeslot=0x2F8FD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8FD', specials={'char',0x6CCD} },
	[0x2F8FE] = { unicodeslot=0x2F8FE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8FE', specials={'char',0x6C67} },
	[0x2F8FF] = { unicodeslot=0x2F8FF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F8FF', specials={'char',0x6D16} },
	[0x2F900] = { unicodeslot=0x2F900, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F900', specials={'char',0x6D3E} },
	[0x2F901] = { unicodeslot=0x2F901, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F901', specials={'char',0x6D77} },
	[0x2F902] = { unicodeslot=0x2F902, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F902', specials={'char',0x6D41} },
	[0x2F903] = { unicodeslot=0x2F903, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F903', specials={'char',0x6D69} },
	[0x2F904] = { unicodeslot=0x2F904, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F904', specials={'char',0x6D78} },
	[0x2F905] = { unicodeslot=0x2F905, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F905', specials={'char',0x6D85} },
	[0x2F906] = { unicodeslot=0x2F906, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F906', specials={'char',0x23D1E} },
	[0x2F907] = { unicodeslot=0x2F907, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F907', specials={'char',0x6D34} },
	[0x2F908] = { unicodeslot=0x2F908, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F908', specials={'char',0x6E2F} },
	[0x2F909] = { unicodeslot=0x2F909, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F909', specials={'char',0x6E6E} },
	[0x2F90A] = { unicodeslot=0x2F90A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F90A', specials={'char',0x3D33} },
	[0x2F90B] = { unicodeslot=0x2F90B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F90B', specials={'char',0x6ECB} },
	[0x2F90C] = { unicodeslot=0x2F90C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F90C', specials={'char',0x6EC7} },
	[0x2F90D] = { unicodeslot=0x2F90D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F90D', specials={'char',0x23ED1} },
	[0x2F90E] = { unicodeslot=0x2F90E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F90E', specials={'char',0x6DF9} },
	[0x2F90F] = { unicodeslot=0x2F90F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F90F', specials={'char',0x6F6E} },
	[0x2F910] = { unicodeslot=0x2F910, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F910', specials={'char',0x23F5E} },
	[0x2F911] = { unicodeslot=0x2F911, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F911', specials={'char',0x23F8E} },
	[0x2F912] = { unicodeslot=0x2F912, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F912', specials={'char',0x6FC6} },
	[0x2F913] = { unicodeslot=0x2F913, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F913', specials={'char',0x7039} },
	[0x2F914] = { unicodeslot=0x2F914, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F914', specials={'char',0x701E} },
	[0x2F915] = { unicodeslot=0x2F915, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F915', specials={'char',0x701B} },
	[0x2F916] = { unicodeslot=0x2F916, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F916', specials={'char',0x3D96} },
	[0x2F917] = { unicodeslot=0x2F917, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F917', specials={'char',0x704A} },
	[0x2F918] = { unicodeslot=0x2F918, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F918', specials={'char',0x707D} },
	[0x2F919] = { unicodeslot=0x2F919, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F919', specials={'char',0x7077} },
	[0x2F91A] = { unicodeslot=0x2F91A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F91A', specials={'char',0x70AD} },
	[0x2F91B] = { unicodeslot=0x2F91B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F91B', specials={'char',0x20525} },
	[0x2F91C] = { unicodeslot=0x2F91C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F91C', specials={'char',0x7145} },
	[0x2F91D] = { unicodeslot=0x2F91D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F91D', specials={'char',0x24263} },
	[0x2F91E] = { unicodeslot=0x2F91E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F91E', specials={'char',0x719C} },
	[0x2F91F] = { unicodeslot=0x2F91F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F91F', specials={'char',0x243AB} },
	[0x2F920] = { unicodeslot=0x2F920, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F920', specials={'char',0x7228} },
	[0x2F921] = { unicodeslot=0x2F921, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F921', specials={'char',0x7235} },
	[0x2F922] = { unicodeslot=0x2F922, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F922', specials={'char',0x7250} },
	[0x2F923] = { unicodeslot=0x2F923, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F923', specials={'char',0x24608} },
	[0x2F924] = { unicodeslot=0x2F924, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F924', specials={'char',0x7280} },
	[0x2F925] = { unicodeslot=0x2F925, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F925', specials={'char',0x7295} },
	[0x2F926] = { unicodeslot=0x2F926, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F926', specials={'char',0x24735} },
	[0x2F927] = { unicodeslot=0x2F927, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F927', specials={'char',0x24814} },
	[0x2F928] = { unicodeslot=0x2F928, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F928', specials={'char',0x737A} },
	[0x2F929] = { unicodeslot=0x2F929, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F929', specials={'char',0x738B} },
	[0x2F92A] = { unicodeslot=0x2F92A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F92A', specials={'char',0x3EAC} },
	[0x2F92B] = { unicodeslot=0x2F92B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F92B', specials={'char',0x73A5} },
	[0x2F92C] = { unicodeslot=0x2F92C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F92C', specials={'char',0x3EB8} },
	[0x2F92D] = { unicodeslot=0x2F92D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F92D', specials={'char',0x3EB8} },
	[0x2F92E] = { unicodeslot=0x2F92E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F92E', specials={'char',0x7447} },
	[0x2F92F] = { unicodeslot=0x2F92F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F92F', specials={'char',0x745C} },
	[0x2F930] = { unicodeslot=0x2F930, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F930', specials={'char',0x7471} },
	[0x2F931] = { unicodeslot=0x2F931, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F931', specials={'char',0x7485} },
	[0x2F932] = { unicodeslot=0x2F932, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F932', specials={'char',0x74CA} },
	[0x2F933] = { unicodeslot=0x2F933, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F933', specials={'char',0x3F1B} },
	[0x2F934] = { unicodeslot=0x2F934, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F934', specials={'char',0x7524} },
	[0x2F935] = { unicodeslot=0x2F935, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F935', specials={'char',0x24C36} },
	[0x2F936] = { unicodeslot=0x2F936, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F936', specials={'char',0x753E} },
	[0x2F937] = { unicodeslot=0x2F937, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F937', specials={'char',0x24C92} },
	[0x2F938] = { unicodeslot=0x2F938, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F938', specials={'char',0x7570} },
	[0x2F939] = { unicodeslot=0x2F939, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F939', specials={'char',0x2219F} },
	[0x2F93A] = { unicodeslot=0x2F93A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F93A', specials={'char',0x7610} },
	[0x2F93B] = { unicodeslot=0x2F93B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F93B', specials={'char',0x24FA1} },
	[0x2F93C] = { unicodeslot=0x2F93C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F93C', specials={'char',0x24FB8} },
	[0x2F93D] = { unicodeslot=0x2F93D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F93D', specials={'char',0x25044} },
	[0x2F93E] = { unicodeslot=0x2F93E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F93E', specials={'char',0x3FFC} },
	[0x2F93F] = { unicodeslot=0x2F93F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F93F', specials={'char',0x4008} },
	[0x2F940] = { unicodeslot=0x2F940, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F940', specials={'char',0x76F4} },
	[0x2F941] = { unicodeslot=0x2F941, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F941', specials={'char',0x250F3} },
	[0x2F942] = { unicodeslot=0x2F942, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F942', specials={'char',0x250F2} },
	[0x2F943] = { unicodeslot=0x2F943, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F943', specials={'char',0x25119} },
	[0x2F944] = { unicodeslot=0x2F944, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F944', specials={'char',0x25133} },
	[0x2F945] = { unicodeslot=0x2F945, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F945', specials={'char',0x771E} },
	[0x2F946] = { unicodeslot=0x2F946, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F946', specials={'char',0x771F} },
	[0x2F947] = { unicodeslot=0x2F947, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F947', specials={'char',0x771F} },
	[0x2F948] = { unicodeslot=0x2F948, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F948', specials={'char',0x774A} },
	[0x2F949] = { unicodeslot=0x2F949, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F949', specials={'char',0x4039} },
	[0x2F94A] = { unicodeslot=0x2F94A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F94A', specials={'char',0x778B} },
	[0x2F94B] = { unicodeslot=0x2F94B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F94B', specials={'char',0x4046} },
	[0x2F94C] = { unicodeslot=0x2F94C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F94C', specials={'char',0x4096} },
	[0x2F94D] = { unicodeslot=0x2F94D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F94D', specials={'char',0x2541D} },
	[0x2F94E] = { unicodeslot=0x2F94E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F94E', specials={'char',0x784E} },
	[0x2F94F] = { unicodeslot=0x2F94F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F94F', specials={'char',0x788C} },
	[0x2F950] = { unicodeslot=0x2F950, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F950', specials={'char',0x78CC} },
	[0x2F951] = { unicodeslot=0x2F951, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F951', specials={'char',0x40E3} },
	[0x2F952] = { unicodeslot=0x2F952, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F952', specials={'char',0x25626} },
	[0x2F953] = { unicodeslot=0x2F953, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F953', specials={'char',0x7956} },
	[0x2F954] = { unicodeslot=0x2F954, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F954', specials={'char',0x2569A} },
	[0x2F955] = { unicodeslot=0x2F955, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F955', specials={'char',0x256C5} },
	[0x2F956] = { unicodeslot=0x2F956, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F956', specials={'char',0x798F} },
	[0x2F957] = { unicodeslot=0x2F957, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F957', specials={'char',0x79EB} },
	[0x2F958] = { unicodeslot=0x2F958, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F958', specials={'char',0x412F} },
	[0x2F959] = { unicodeslot=0x2F959, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F959', specials={'char',0x7A40} },
	[0x2F95A] = { unicodeslot=0x2F95A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F95A', specials={'char',0x7A4A} },
	[0x2F95B] = { unicodeslot=0x2F95B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F95B', specials={'char',0x7A4F} },
	[0x2F95C] = { unicodeslot=0x2F95C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F95C', specials={'char',0x2597C} },
	[0x2F95D] = { unicodeslot=0x2F95D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F95D', specials={'char',0x25AA7} },
	[0x2F95E] = { unicodeslot=0x2F95E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F95E', specials={'char',0x25AA7} },
	[0x2F95F] = { unicodeslot=0x2F95F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F95F', specials={'char',0x7AEE} },
	[0x2F960] = { unicodeslot=0x2F960, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F960', specials={'char',0x4202} },
	[0x2F961] = { unicodeslot=0x2F961, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F961', specials={'char',0x25BAB} },
	[0x2F962] = { unicodeslot=0x2F962, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F962', specials={'char',0x7BC6} },
	[0x2F963] = { unicodeslot=0x2F963, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F963', specials={'char',0x7BC9} },
	[0x2F964] = { unicodeslot=0x2F964, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F964', specials={'char',0x4227} },
	[0x2F965] = { unicodeslot=0x2F965, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F965', specials={'char',0x25C80} },
	[0x2F966] = { unicodeslot=0x2F966, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F966', specials={'char',0x7CD2} },
	[0x2F967] = { unicodeslot=0x2F967, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F967', specials={'char',0x42A0} },
	[0x2F968] = { unicodeslot=0x2F968, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F968', specials={'char',0x7CE8} },
	[0x2F969] = { unicodeslot=0x2F969, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F969', specials={'char',0x7CE3} },
	[0x2F96A] = { unicodeslot=0x2F96A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F96A', specials={'char',0x7D00} },
	[0x2F96B] = { unicodeslot=0x2F96B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F96B', specials={'char',0x25F86} },
	[0x2F96C] = { unicodeslot=0x2F96C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F96C', specials={'char',0x7D63} },
	[0x2F96D] = { unicodeslot=0x2F96D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F96D', specials={'char',0x4301} },
	[0x2F96E] = { unicodeslot=0x2F96E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F96E', specials={'char',0x7DC7} },
	[0x2F96F] = { unicodeslot=0x2F96F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F96F', specials={'char',0x7E02} },
	[0x2F970] = { unicodeslot=0x2F970, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F970', specials={'char',0x7E45} },
	[0x2F971] = { unicodeslot=0x2F971, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F971', specials={'char',0x4334} },
	[0x2F972] = { unicodeslot=0x2F972, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F972', specials={'char',0x26228} },
	[0x2F973] = { unicodeslot=0x2F973, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F973', specials={'char',0x26247} },
	[0x2F974] = { unicodeslot=0x2F974, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F974', specials={'char',0x4359} },
	[0x2F975] = { unicodeslot=0x2F975, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F975', specials={'char',0x262D9} },
	[0x2F976] = { unicodeslot=0x2F976, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F976', specials={'char',0x7F7A} },
	[0x2F977] = { unicodeslot=0x2F977, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F977', specials={'char',0x2633E} },
	[0x2F978] = { unicodeslot=0x2F978, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F978', specials={'char',0x7F95} },
	[0x2F979] = { unicodeslot=0x2F979, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F979', specials={'char',0x7FFA} },
	[0x2F97A] = { unicodeslot=0x2F97A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F97A', specials={'char',0x8005} },
	[0x2F97B] = { unicodeslot=0x2F97B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F97B', specials={'char',0x264DA} },
	[0x2F97C] = { unicodeslot=0x2F97C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F97C', specials={'char',0x26523} },
	[0x2F97D] = { unicodeslot=0x2F97D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F97D', specials={'char',0x8060} },
	[0x2F97E] = { unicodeslot=0x2F97E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F97E', specials={'char',0x265A8} },
	[0x2F97F] = { unicodeslot=0x2F97F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F97F', specials={'char',0x8070} },
	[0x2F980] = { unicodeslot=0x2F980, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F980', specials={'char',0x2335F} },
	[0x2F981] = { unicodeslot=0x2F981, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F981', specials={'char',0x43D5} },
	[0x2F982] = { unicodeslot=0x2F982, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F982', specials={'char',0x80B2} },
	[0x2F983] = { unicodeslot=0x2F983, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F983', specials={'char',0x8103} },
	[0x2F984] = { unicodeslot=0x2F984, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F984', specials={'char',0x440B} },
	[0x2F985] = { unicodeslot=0x2F985, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F985', specials={'char',0x813E} },
	[0x2F986] = { unicodeslot=0x2F986, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F986', specials={'char',0x5AB5} },
	[0x2F987] = { unicodeslot=0x2F987, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F987', specials={'char',0x267A7} },
	[0x2F988] = { unicodeslot=0x2F988, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F988', specials={'char',0x267B5} },
	[0x2F989] = { unicodeslot=0x2F989, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F989', specials={'char',0x23393} },
	[0x2F98A] = { unicodeslot=0x2F98A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F98A', specials={'char',0x2339C} },
	[0x2F98B] = { unicodeslot=0x2F98B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F98B', specials={'char',0x8201} },
	[0x2F98C] = { unicodeslot=0x2F98C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F98C', specials={'char',0x8204} },
	[0x2F98D] = { unicodeslot=0x2F98D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F98D', specials={'char',0x8F9E} },
	[0x2F98E] = { unicodeslot=0x2F98E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F98E', specials={'char',0x446B} },
	[0x2F98F] = { unicodeslot=0x2F98F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F98F', specials={'char',0x8291} },
	[0x2F990] = { unicodeslot=0x2F990, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F990', specials={'char',0x828B} },
	[0x2F991] = { unicodeslot=0x2F991, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F991', specials={'char',0x829D} },
	[0x2F992] = { unicodeslot=0x2F992, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F992', specials={'char',0x52B3} },
	[0x2F993] = { unicodeslot=0x2F993, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F993', specials={'char',0x82B1} },
	[0x2F994] = { unicodeslot=0x2F994, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F994', specials={'char',0x82B3} },
	[0x2F995] = { unicodeslot=0x2F995, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F995', specials={'char',0x82BD} },
	[0x2F996] = { unicodeslot=0x2F996, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F996', specials={'char',0x82E6} },
	[0x2F997] = { unicodeslot=0x2F997, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F997', specials={'char',0x26B3C} },
	[0x2F998] = { unicodeslot=0x2F998, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F998', specials={'char',0x82E5} },
	[0x2F999] = { unicodeslot=0x2F999, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F999', specials={'char',0x831D} },
	[0x2F99A] = { unicodeslot=0x2F99A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F99A', specials={'char',0x8363} },
	[0x2F99B] = { unicodeslot=0x2F99B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F99B', specials={'char',0x83AD} },
	[0x2F99C] = { unicodeslot=0x2F99C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F99C', specials={'char',0x8323} },
	[0x2F99D] = { unicodeslot=0x2F99D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F99D', specials={'char',0x83BD} },
	[0x2F99E] = { unicodeslot=0x2F99E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F99E', specials={'char',0x83E7} },
	[0x2F99F] = { unicodeslot=0x2F99F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F99F', specials={'char',0x8457} },
	[0x2F9A0] = { unicodeslot=0x2F9A0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A0', specials={'char',0x8353} },
	[0x2F9A1] = { unicodeslot=0x2F9A1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A1', specials={'char',0x83CA} },
	[0x2F9A2] = { unicodeslot=0x2F9A2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A2', specials={'char',0x83CC} },
	[0x2F9A3] = { unicodeslot=0x2F9A3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A3', specials={'char',0x83DC} },
	[0x2F9A4] = { unicodeslot=0x2F9A4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A4', specials={'char',0x26C36} },
	[0x2F9A5] = { unicodeslot=0x2F9A5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A5', specials={'char',0x26D6B} },
	[0x2F9A6] = { unicodeslot=0x2F9A6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A6', specials={'char',0x26CD5} },
	[0x2F9A7] = { unicodeslot=0x2F9A7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A7', specials={'char',0x452B} },
	[0x2F9A8] = { unicodeslot=0x2F9A8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A8', specials={'char',0x84F1} },
	[0x2F9A9] = { unicodeslot=0x2F9A9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9A9', specials={'char',0x84F3} },
	[0x2F9AA] = { unicodeslot=0x2F9AA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9AA', specials={'char',0x8516} },
	[0x2F9AB] = { unicodeslot=0x2F9AB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9AB', specials={'char',0x273CA} },
	[0x2F9AC] = { unicodeslot=0x2F9AC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9AC', specials={'char',0x8564} },
	[0x2F9AD] = { unicodeslot=0x2F9AD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9AD', specials={'char',0x26F2C} },
	[0x2F9AE] = { unicodeslot=0x2F9AE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9AE', specials={'char',0x455D} },
	[0x2F9AF] = { unicodeslot=0x2F9AF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9AF', specials={'char',0x4561} },
	[0x2F9B0] = { unicodeslot=0x2F9B0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B0', specials={'char',0x26FB1} },
	[0x2F9B1] = { unicodeslot=0x2F9B1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B1', specials={'char',0x270D2} },
	[0x2F9B2] = { unicodeslot=0x2F9B2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B2', specials={'char',0x456B} },
	[0x2F9B3] = { unicodeslot=0x2F9B3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B3', specials={'char',0x8650} },
	[0x2F9B4] = { unicodeslot=0x2F9B4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B4', specials={'char',0x865C} },
	[0x2F9B5] = { unicodeslot=0x2F9B5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B5', specials={'char',0x8667} },
	[0x2F9B6] = { unicodeslot=0x2F9B6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B6', specials={'char',0x8669} },
	[0x2F9B7] = { unicodeslot=0x2F9B7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B7', specials={'char',0x86A9} },
	[0x2F9B8] = { unicodeslot=0x2F9B8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B8', specials={'char',0x8688} },
	[0x2F9B9] = { unicodeslot=0x2F9B9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9B9', specials={'char',0x870E} },
	[0x2F9BA] = { unicodeslot=0x2F9BA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9BA', specials={'char',0x86E2} },
	[0x2F9BB] = { unicodeslot=0x2F9BB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9BB', specials={'char',0x8779} },
	[0x2F9BC] = { unicodeslot=0x2F9BC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9BC', specials={'char',0x8728} },
	[0x2F9BD] = { unicodeslot=0x2F9BD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9BD', specials={'char',0x876B} },
	[0x2F9BE] = { unicodeslot=0x2F9BE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9BE', specials={'char',0x8786} },
	[0x2F9BF] = { unicodeslot=0x2F9BF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9BF', specials={'char',0x45D7} },
	[0x2F9C0] = { unicodeslot=0x2F9C0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C0', specials={'char',0x87E1} },
	[0x2F9C1] = { unicodeslot=0x2F9C1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C1', specials={'char',0x8801} },
	[0x2F9C2] = { unicodeslot=0x2F9C2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C2', specials={'char',0x45F9} },
	[0x2F9C3] = { unicodeslot=0x2F9C3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C3', specials={'char',0x8860} },
	[0x2F9C4] = { unicodeslot=0x2F9C4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C4', specials={'char',0x8863} },
	[0x2F9C5] = { unicodeslot=0x2F9C5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C5', specials={'char',0x27667} },
	[0x2F9C6] = { unicodeslot=0x2F9C6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C6', specials={'char',0x88D7} },
	[0x2F9C7] = { unicodeslot=0x2F9C7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C7', specials={'char',0x88DE} },
	[0x2F9C8] = { unicodeslot=0x2F9C8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C8', specials={'char',0x4635} },
	[0x2F9C9] = { unicodeslot=0x2F9C9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9C9', specials={'char',0x88FA} },
	[0x2F9CA] = { unicodeslot=0x2F9CA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9CA', specials={'char',0x34BB} },
	[0x2F9CB] = { unicodeslot=0x2F9CB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9CB', specials={'char',0x278AE} },
	[0x2F9CC] = { unicodeslot=0x2F9CC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9CC', specials={'char',0x27966} },
	[0x2F9CD] = { unicodeslot=0x2F9CD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9CD', specials={'char',0x46BE} },
	[0x2F9CE] = { unicodeslot=0x2F9CE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9CE', specials={'char',0x46C7} },
	[0x2F9CF] = { unicodeslot=0x2F9CF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9CF', specials={'char',0x8AA0} },
	[0x2F9D0] = { unicodeslot=0x2F9D0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D0', specials={'char',0x8AED} },
	[0x2F9D1] = { unicodeslot=0x2F9D1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D1', specials={'char',0x8B8A} },
	[0x2F9D2] = { unicodeslot=0x2F9D2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D2', specials={'char',0x8C55} },
	[0x2F9D3] = { unicodeslot=0x2F9D3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D3', specials={'char',0x27CA8} },
	[0x2F9D4] = { unicodeslot=0x2F9D4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D4', specials={'char',0x8CAB} },
	[0x2F9D5] = { unicodeslot=0x2F9D5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D5', specials={'char',0x8CC1} },
	[0x2F9D6] = { unicodeslot=0x2F9D6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D6', specials={'char',0x8D1B} },
	[0x2F9D7] = { unicodeslot=0x2F9D7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D7', specials={'char',0x8D77} },
	[0x2F9D8] = { unicodeslot=0x2F9D8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D8', specials={'char',0x27F2F} },
	[0x2F9D9] = { unicodeslot=0x2F9D9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9D9', specials={'char',0x20804} },
	[0x2F9DA] = { unicodeslot=0x2F9DA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9DA', specials={'char',0x8DCB} },
	[0x2F9DB] = { unicodeslot=0x2F9DB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9DB', specials={'char',0x8DBC} },
	[0x2F9DC] = { unicodeslot=0x2F9DC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9DC', specials={'char',0x8DF0} },
	[0x2F9DD] = { unicodeslot=0x2F9DD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9DD', specials={'char',0x208DE} },
	[0x2F9DE] = { unicodeslot=0x2F9DE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9DE', specials={'char',0x8ED4} },
	[0x2F9DF] = { unicodeslot=0x2F9DF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9DF', specials={'char',0x8F38} },
	[0x2F9E0] = { unicodeslot=0x2F9E0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E0', specials={'char',0x285D2} },
	[0x2F9E1] = { unicodeslot=0x2F9E1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E1', specials={'char',0x285ED} },
	[0x2F9E2] = { unicodeslot=0x2F9E2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E2', specials={'char',0x9094} },
	[0x2F9E3] = { unicodeslot=0x2F9E3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E3', specials={'char',0x90F1} },
	[0x2F9E4] = { unicodeslot=0x2F9E4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E4', specials={'char',0x9111} },
	[0x2F9E5] = { unicodeslot=0x2F9E5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E5', specials={'char',0x2872E} },
	[0x2F9E6] = { unicodeslot=0x2F9E6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E6', specials={'char',0x911B} },
	[0x2F9E7] = { unicodeslot=0x2F9E7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E7', specials={'char',0x9238} },
	[0x2F9E8] = { unicodeslot=0x2F9E8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E8', specials={'char',0x92D7} },
	[0x2F9E9] = { unicodeslot=0x2F9E9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9E9', specials={'char',0x92D8} },
	[0x2F9EA] = { unicodeslot=0x2F9EA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9EA', specials={'char',0x927C} },
	[0x2F9EB] = { unicodeslot=0x2F9EB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9EB', specials={'char',0x93F9} },
	[0x2F9EC] = { unicodeslot=0x2F9EC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9EC', specials={'char',0x9415} },
	[0x2F9ED] = { unicodeslot=0x2F9ED, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9ED', specials={'char',0x28BFA} },
	[0x2F9EE] = { unicodeslot=0x2F9EE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9EE', specials={'char',0x958B} },
	[0x2F9EF] = { unicodeslot=0x2F9EF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9EF', specials={'char',0x4995} },
	[0x2F9F0] = { unicodeslot=0x2F9F0, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F0', specials={'char',0x95B7} },
	[0x2F9F1] = { unicodeslot=0x2F9F1, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F1', specials={'char',0x28D77} },
	[0x2F9F2] = { unicodeslot=0x2F9F2, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F2', specials={'char',0x49E6} },
	[0x2F9F3] = { unicodeslot=0x2F9F3, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F3', specials={'char',0x96C3} },
	[0x2F9F4] = { unicodeslot=0x2F9F4, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F4', specials={'char',0x5DB2} },
	[0x2F9F5] = { unicodeslot=0x2F9F5, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F5', specials={'char',0x9723} },
	[0x2F9F6] = { unicodeslot=0x2F9F6, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F6', specials={'char',0x29145} },
	[0x2F9F7] = { unicodeslot=0x2F9F7, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F7', specials={'char',0x2921A} },
	[0x2F9F8] = { unicodeslot=0x2F9F8, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F8', specials={'char',0x4A6E} },
	[0x2F9F9] = { unicodeslot=0x2F9F9, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9F9', specials={'char',0x4A76} },
	[0x2F9FA] = { unicodeslot=0x2F9FA, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9FA', specials={'char',0x97E0} },
	[0x2F9FB] = { unicodeslot=0x2F9FB, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9FB', specials={'char',0x2940A} },
	[0x2F9FC] = { unicodeslot=0x2F9FC, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9FC', specials={'char',0x4AB2} },
	[0x2F9FD] = { unicodeslot=0x2F9FD, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9FD', specials={'char',0x29496} },
	[0x2F9FE] = { unicodeslot=0x2F9FE, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9FE', specials={'char',0x980B} },
	[0x2F9FF] = { unicodeslot=0x2F9FF, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2F9FF', specials={'char',0x980B} },
	[0x2FA00] = { unicodeslot=0x2FA00, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA00', specials={'char',0x9829} },
	[0x2FA01] = { unicodeslot=0x2FA01, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA01', specials={'char',0x295B6} },
	[0x2FA02] = { unicodeslot=0x2FA02, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA02', specials={'char',0x98E2} },
	[0x2FA03] = { unicodeslot=0x2FA03, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA03', specials={'char',0x4B33} },
	[0x2FA04] = { unicodeslot=0x2FA04, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA04', specials={'char',0x9929} },
	[0x2FA05] = { unicodeslot=0x2FA05, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA05', specials={'char',0x99A7} },
	[0x2FA06] = { unicodeslot=0x2FA06, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA06', specials={'char',0x99C2} },
	[0x2FA07] = { unicodeslot=0x2FA07, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA07', specials={'char',0x99FE} },
	[0x2FA08] = { unicodeslot=0x2FA08, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA08', specials={'char',0x4BCE} },
	[0x2FA09] = { unicodeslot=0x2FA09, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA09', specials={'char',0x29B30} },
	[0x2FA0A] = { unicodeslot=0x2FA0A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA0A', specials={'char',0x9B12} },
	[0x2FA0B] = { unicodeslot=0x2FA0B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA0B', specials={'char',0x9C40} },
	[0x2FA0C] = { unicodeslot=0x2FA0C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA0C', specials={'char',0x9CFD} },
	[0x2FA0D] = { unicodeslot=0x2FA0D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA0D', specials={'char',0x4CCE} },
	[0x2FA0E] = { unicodeslot=0x2FA0E, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA0E', specials={'char',0x4CED} },
	[0x2FA0F] = { unicodeslot=0x2FA0F, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA0F', specials={'char',0x9D67} },
	[0x2FA10] = { unicodeslot=0x2FA10, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA10', specials={'char',0x2A0CE} },
	[0x2FA11] = { unicodeslot=0x2FA11, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA11', specials={'char',0x4CF8} },
	[0x2FA12] = { unicodeslot=0x2FA12, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA12', specials={'char',0x2A105} },
	[0x2FA13] = { unicodeslot=0x2FA13, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA13', specials={'char',0x2A20E} },
	[0x2FA14] = { unicodeslot=0x2FA14, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA14', specials={'char',0x2A291} },
	[0x2FA15] = { unicodeslot=0x2FA15, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA15', specials={'char',0x9EBB} },
	[0x2FA16] = { unicodeslot=0x2FA16, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA16', specials={'char',0x4D56} },
	[0x2FA17] = { unicodeslot=0x2FA17, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA17', specials={'char',0x9EF9} },
	[0x2FA18] = { unicodeslot=0x2FA18, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA18', specials={'char',0x9EFE} },
	[0x2FA19] = { unicodeslot=0x2FA19, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA19', specials={'char',0x9F05} },
	[0x2FA1A] = { unicodeslot=0x2FA1A, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA1A', specials={'char',0x9F0F} },
	[0x2FA1B] = { unicodeslot=0x2FA1B, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA1B', specials={'char',0x9F16} },
	[0x2FA1C] = { unicodeslot=0x2FA1C, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA1C', specials={'char',0x9F3B} },
	[0x2FA1D] = { unicodeslot=0x2FA1D, category='lo', description='CJK COMPATIBILITY IDEOGRAPH-2FA1D', specials={'char',0x2A600} },
	[0xE0001] = { unicodeslot=0xE0001, category='cf', description='LANGUAGE TAG' },
	[0xE0020] = { unicodeslot=0xE0020, category='cf', description='TAG SPACE' },
	[0xE0021] = { unicodeslot=0xE0021, category='cf', description='TAG EXCLAMATION MARK' },
	[0xE0022] = { unicodeslot=0xE0022, category='cf', description='TAG QUOTATION MARK' },
	[0xE0023] = { unicodeslot=0xE0023, category='cf', description='TAG NUMBER SIGN' },
	[0xE0024] = { unicodeslot=0xE0024, category='cf', description='TAG DOLLAR SIGN' },
	[0xE0025] = { unicodeslot=0xE0025, category='cf', description='TAG PERCENT SIGN' },
	[0xE0026] = { unicodeslot=0xE0026, category='cf', description='TAG AMPERSAND' },
	[0xE0027] = { unicodeslot=0xE0027, category='cf', description='TAG APOSTROPHE' },
	[0xE0028] = { unicodeslot=0xE0028, category='cf', description='TAG LEFT PARENTHESIS' },
	[0xE0029] = { unicodeslot=0xE0029, category='cf', description='TAG RIGHT PARENTHESIS' },
	[0xE002A] = { unicodeslot=0xE002A, category='cf', description='TAG ASTERISK' },
	[0xE002B] = { unicodeslot=0xE002B, category='cf', description='TAG PLUS SIGN' },
	[0xE002C] = { unicodeslot=0xE002C, category='cf', description='TAG COMMA' },
	[0xE002D] = { unicodeslot=0xE002D, category='cf', description='TAG HYPHEN-MINUS' },
	[0xE002E] = { unicodeslot=0xE002E, category='cf', description='TAG FULL STOP' },
	[0xE002F] = { unicodeslot=0xE002F, category='cf', description='TAG SOLIDUS' },
	[0xE0030] = { unicodeslot=0xE0030, category='cf', description='TAG DIGIT ZERO' },
	[0xE0031] = { unicodeslot=0xE0031, category='cf', description='TAG DIGIT ONE' },
	[0xE0032] = { unicodeslot=0xE0032, category='cf', description='TAG DIGIT TWO' },
	[0xE0033] = { unicodeslot=0xE0033, category='cf', description='TAG DIGIT THREE' },
	[0xE0034] = { unicodeslot=0xE0034, category='cf', description='TAG DIGIT FOUR' },
	[0xE0035] = { unicodeslot=0xE0035, category='cf', description='TAG DIGIT FIVE' },
	[0xE0036] = { unicodeslot=0xE0036, category='cf', description='TAG DIGIT SIX' },
	[0xE0037] = { unicodeslot=0xE0037, category='cf', description='TAG DIGIT SEVEN' },
	[0xE0038] = { unicodeslot=0xE0038, category='cf', description='TAG DIGIT EIGHT' },
	[0xE0039] = { unicodeslot=0xE0039, category='cf', description='TAG DIGIT NINE' },
	[0xE003A] = { unicodeslot=0xE003A, category='cf', description='TAG COLON' },
	[0xE003B] = { unicodeslot=0xE003B, category='cf', description='TAG SEMICOLON' },
	[0xE003C] = { unicodeslot=0xE003C, category='cf', description='TAG LESS-THAN SIGN' },
	[0xE003D] = { unicodeslot=0xE003D, category='cf', description='TAG EQUALS SIGN' },
	[0xE003E] = { unicodeslot=0xE003E, category='cf', description='TAG GREATER-THAN SIGN' },
	[0xE003F] = { unicodeslot=0xE003F, category='cf', description='TAG QUESTION MARK' },
	[0xE0040] = { unicodeslot=0xE0040, category='cf', description='TAG COMMERCIAL AT' },
	[0xE0041] = { unicodeslot=0xE0041, category='cf', description='TAG LATIN CAPITAL LETTER A' },
	[0xE0042] = { unicodeslot=0xE0042, category='cf', description='TAG LATIN CAPITAL LETTER B' },
	[0xE0043] = { unicodeslot=0xE0043, category='cf', description='TAG LATIN CAPITAL LETTER C' },
	[0xE0044] = { unicodeslot=0xE0044, category='cf', description='TAG LATIN CAPITAL LETTER D' },
	[0xE0045] = { unicodeslot=0xE0045, category='cf', description='TAG LATIN CAPITAL LETTER E' },
	[0xE0046] = { unicodeslot=0xE0046, category='cf', description='TAG LATIN CAPITAL LETTER F' },
	[0xE0047] = { unicodeslot=0xE0047, category='cf', description='TAG LATIN CAPITAL LETTER G' },
	[0xE0048] = { unicodeslot=0xE0048, category='cf', description='TAG LATIN CAPITAL LETTER H' },
	[0xE0049] = { unicodeslot=0xE0049, category='cf', description='TAG LATIN CAPITAL LETTER I' },
	[0xE004A] = { unicodeslot=0xE004A, category='cf', description='TAG LATIN CAPITAL LETTER J' },
	[0xE004B] = { unicodeslot=0xE004B, category='cf', description='TAG LATIN CAPITAL LETTER K' },
	[0xE004C] = { unicodeslot=0xE004C, category='cf', description='TAG LATIN CAPITAL LETTER L' },
	[0xE004D] = { unicodeslot=0xE004D, category='cf', description='TAG LATIN CAPITAL LETTER M' },
	[0xE004E] = { unicodeslot=0xE004E, category='cf', description='TAG LATIN CAPITAL LETTER N' },
	[0xE004F] = { unicodeslot=0xE004F, category='cf', description='TAG LATIN CAPITAL LETTER O' },
	[0xE0050] = { unicodeslot=0xE0050, category='cf', description='TAG LATIN CAPITAL LETTER P' },
	[0xE0051] = { unicodeslot=0xE0051, category='cf', description='TAG LATIN CAPITAL LETTER Q' },
	[0xE0052] = { unicodeslot=0xE0052, category='cf', description='TAG LATIN CAPITAL LETTER R' },
	[0xE0053] = { unicodeslot=0xE0053, category='cf', description='TAG LATIN CAPITAL LETTER S' },
	[0xE0054] = { unicodeslot=0xE0054, category='cf', description='TAG LATIN CAPITAL LETTER T' },
	[0xE0055] = { unicodeslot=0xE0055, category='cf', description='TAG LATIN CAPITAL LETTER U' },
	[0xE0056] = { unicodeslot=0xE0056, category='cf', description='TAG LATIN CAPITAL LETTER V' },
	[0xE0057] = { unicodeslot=0xE0057, category='cf', description='TAG LATIN CAPITAL LETTER W' },
	[0xE0058] = { unicodeslot=0xE0058, category='cf', description='TAG LATIN CAPITAL LETTER X' },
	[0xE0059] = { unicodeslot=0xE0059, category='cf', description='TAG LATIN CAPITAL LETTER Y' },
	[0xE005A] = { unicodeslot=0xE005A, category='cf', description='TAG LATIN CAPITAL LETTER Z' },
	[0xE005B] = { unicodeslot=0xE005B, category='cf', description='TAG LEFT SQUARE BRACKET' },
	[0xE005C] = { unicodeslot=0xE005C, category='cf', description='TAG REVERSE SOLIDUS' },
	[0xE005D] = { unicodeslot=0xE005D, category='cf', description='TAG RIGHT SQUARE BRACKET' },
	[0xE005E] = { unicodeslot=0xE005E, category='cf', description='TAG CIRCUMFLEX ACCENT' },
	[0xE005F] = { unicodeslot=0xE005F, category='cf', description='TAG LOW LINE' },
	[0xE0060] = { unicodeslot=0xE0060, category='cf', description='TAG GRAVE ACCENT' },
	[0xE0061] = { unicodeslot=0xE0061, category='cf', description='TAG LATIN SMALL LETTER A' },
	[0xE0062] = { unicodeslot=0xE0062, category='cf', description='TAG LATIN SMALL LETTER B' },
	[0xE0063] = { unicodeslot=0xE0063, category='cf', description='TAG LATIN SMALL LETTER C' },
	[0xE0064] = { unicodeslot=0xE0064, category='cf', description='TAG LATIN SMALL LETTER D' },
	[0xE0065] = { unicodeslot=0xE0065, category='cf', description='TAG LATIN SMALL LETTER E' },
	[0xE0066] = { unicodeslot=0xE0066, category='cf', description='TAG LATIN SMALL LETTER F' },
	[0xE0067] = { unicodeslot=0xE0067, category='cf', description='TAG LATIN SMALL LETTER G' },
	[0xE0068] = { unicodeslot=0xE0068, category='cf', description='TAG LATIN SMALL LETTER H' },
	[0xE0069] = { unicodeslot=0xE0069, category='cf', description='TAG LATIN SMALL LETTER I' },
	[0xE006A] = { unicodeslot=0xE006A, category='cf', description='TAG LATIN SMALL LETTER J' },
	[0xE006B] = { unicodeslot=0xE006B, category='cf', description='TAG LATIN SMALL LETTER K' },
	[0xE006C] = { unicodeslot=0xE006C, category='cf', description='TAG LATIN SMALL LETTER L' },
	[0xE006D] = { unicodeslot=0xE006D, category='cf', description='TAG LATIN SMALL LETTER M' },
	[0xE006E] = { unicodeslot=0xE006E, category='cf', description='TAG LATIN SMALL LETTER N' },
	[0xE006F] = { unicodeslot=0xE006F, category='cf', description='TAG LATIN SMALL LETTER O' },
	[0xE0070] = { unicodeslot=0xE0070, category='cf', description='TAG LATIN SMALL LETTER P' },
	[0xE0071] = { unicodeslot=0xE0071, category='cf', description='TAG LATIN SMALL LETTER Q' },
	[0xE0072] = { unicodeslot=0xE0072, category='cf', description='TAG LATIN SMALL LETTER R' },
	[0xE0073] = { unicodeslot=0xE0073, category='cf', description='TAG LATIN SMALL LETTER S' },
	[0xE0074] = { unicodeslot=0xE0074, category='cf', description='TAG LATIN SMALL LETTER T' },
	[0xE0075] = { unicodeslot=0xE0075, category='cf', description='TAG LATIN SMALL LETTER U' },
	[0xE0076] = { unicodeslot=0xE0076, category='cf', description='TAG LATIN SMALL LETTER V' },
	[0xE0077] = { unicodeslot=0xE0077, category='cf', description='TAG LATIN SMALL LETTER W' },
	[0xE0078] = { unicodeslot=0xE0078, category='cf', description='TAG LATIN SMALL LETTER X' },
	[0xE0079] = { unicodeslot=0xE0079, category='cf', description='TAG LATIN SMALL LETTER Y' },
	[0xE007A] = { unicodeslot=0xE007A, category='cf', description='TAG LATIN SMALL LETTER Z' },
	[0xE007B] = { unicodeslot=0xE007B, category='cf', description='TAG LEFT CURLY BRACKET' },
	[0xE007C] = { unicodeslot=0xE007C, category='cf', description='TAG VERTICAL LINE' },
	[0xE007D] = { unicodeslot=0xE007D, category='cf', description='TAG RIGHT CURLY BRACKET' },
	[0xE007E] = { unicodeslot=0xE007E, category='cf', description='TAG TILDE' },
	[0xE007F] = { unicodeslot=0xE007F, category='cf', description='CANCEL TAG' },
	[0xE0100] = { unicodeslot=0xE0100, category='mn', description='VARIATION SELECTOR-17' },
	[0xE0101] = { unicodeslot=0xE0101, category='mn', description='VARIATION SELECTOR-18' },
	[0xE0102] = { unicodeslot=0xE0102, category='mn', description='VARIATION SELECTOR-19' },
	[0xE0103] = { unicodeslot=0xE0103, category='mn', description='VARIATION SELECTOR-20' },
	[0xE0104] = { unicodeslot=0xE0104, category='mn', description='VARIATION SELECTOR-21' },
	[0xE0105] = { unicodeslot=0xE0105, category='mn', description='VARIATION SELECTOR-22' },
	[0xE0106] = { unicodeslot=0xE0106, category='mn', description='VARIATION SELECTOR-23' },
	[0xE0107] = { unicodeslot=0xE0107, category='mn', description='VARIATION SELECTOR-24' },
	[0xE0108] = { unicodeslot=0xE0108, category='mn', description='VARIATION SELECTOR-25' },
	[0xE0109] = { unicodeslot=0xE0109, category='mn', description='VARIATION SELECTOR-26' },
	[0xE010A] = { unicodeslot=0xE010A, category='mn', description='VARIATION SELECTOR-27' },
	[0xE010B] = { unicodeslot=0xE010B, category='mn', description='VARIATION SELECTOR-28' },
	[0xE010C] = { unicodeslot=0xE010C, category='mn', description='VARIATION SELECTOR-29' },
	[0xE010D] = { unicodeslot=0xE010D, category='mn', description='VARIATION SELECTOR-30' },
	[0xE010E] = { unicodeslot=0xE010E, category='mn', description='VARIATION SELECTOR-31' },
	[0xE010F] = { unicodeslot=0xE010F, category='mn', description='VARIATION SELECTOR-32' },
	[0xE0110] = { unicodeslot=0xE0110, category='mn', description='VARIATION SELECTOR-33' },
	[0xE0111] = { unicodeslot=0xE0111, category='mn', description='VARIATION SELECTOR-34' },
	[0xE0112] = { unicodeslot=0xE0112, category='mn', description='VARIATION SELECTOR-35' },
	[0xE0113] = { unicodeslot=0xE0113, category='mn', description='VARIATION SELECTOR-36' },
	[0xE0114] = { unicodeslot=0xE0114, category='mn', description='VARIATION SELECTOR-37' },
	[0xE0115] = { unicodeslot=0xE0115, category='mn', description='VARIATION SELECTOR-38' },
	[0xE0116] = { unicodeslot=0xE0116, category='mn', description='VARIATION SELECTOR-39' },
	[0xE0117] = { unicodeslot=0xE0117, category='mn', description='VARIATION SELECTOR-40' },
	[0xE0118] = { unicodeslot=0xE0118, category='mn', description='VARIATION SELECTOR-41' },
	[0xE0119] = { unicodeslot=0xE0119, category='mn', description='VARIATION SELECTOR-42' },
	[0xE011A] = { unicodeslot=0xE011A, category='mn', description='VARIATION SELECTOR-43' },
	[0xE011B] = { unicodeslot=0xE011B, category='mn', description='VARIATION SELECTOR-44' },
	[0xE011C] = { unicodeslot=0xE011C, category='mn', description='VARIATION SELECTOR-45' },
	[0xE011D] = { unicodeslot=0xE011D, category='mn', description='VARIATION SELECTOR-46' },
	[0xE011E] = { unicodeslot=0xE011E, category='mn', description='VARIATION SELECTOR-47' },
	[0xE011F] = { unicodeslot=0xE011F, category='mn', description='VARIATION SELECTOR-48' },
	[0xE0120] = { unicodeslot=0xE0120, category='mn', description='VARIATION SELECTOR-49' },
	[0xE0121] = { unicodeslot=0xE0121, category='mn', description='VARIATION SELECTOR-50' },
	[0xE0122] = { unicodeslot=0xE0122, category='mn', description='VARIATION SELECTOR-51' },
	[0xE0123] = { unicodeslot=0xE0123, category='mn', description='VARIATION SELECTOR-52' },
	[0xE0124] = { unicodeslot=0xE0124, category='mn', description='VARIATION SELECTOR-53' },
	[0xE0125] = { unicodeslot=0xE0125, category='mn', description='VARIATION SELECTOR-54' },
	[0xE0126] = { unicodeslot=0xE0126, category='mn', description='VARIATION SELECTOR-55' },
	[0xE0127] = { unicodeslot=0xE0127, category='mn', description='VARIATION SELECTOR-56' },
	[0xE0128] = { unicodeslot=0xE0128, category='mn', description='VARIATION SELECTOR-57' },
	[0xE0129] = { unicodeslot=0xE0129, category='mn', description='VARIATION SELECTOR-58' },
	[0xE012A] = { unicodeslot=0xE012A, category='mn', description='VARIATION SELECTOR-59' },
	[0xE012B] = { unicodeslot=0xE012B, category='mn', description='VARIATION SELECTOR-60' },
	[0xE012C] = { unicodeslot=0xE012C, category='mn', description='VARIATION SELECTOR-61' },
	[0xE012D] = { unicodeslot=0xE012D, category='mn', description='VARIATION SELECTOR-62' },
	[0xE012E] = { unicodeslot=0xE012E, category='mn', description='VARIATION SELECTOR-63' },
	[0xE012F] = { unicodeslot=0xE012F, category='mn', description='VARIATION SELECTOR-64' },
	[0xE0130] = { unicodeslot=0xE0130, category='mn', description='VARIATION SELECTOR-65' },
	[0xE0131] = { unicodeslot=0xE0131, category='mn', description='VARIATION SELECTOR-66' },
	[0xE0132] = { unicodeslot=0xE0132, category='mn', description='VARIATION SELECTOR-67' },
	[0xE0133] = { unicodeslot=0xE0133, category='mn', description='VARIATION SELECTOR-68' },
	[0xE0134] = { unicodeslot=0xE0134, category='mn', description='VARIATION SELECTOR-69' },
	[0xE0135] = { unicodeslot=0xE0135, category='mn', description='VARIATION SELECTOR-70' },
	[0xE0136] = { unicodeslot=0xE0136, category='mn', description='VARIATION SELECTOR-71' },
	[0xE0137] = { unicodeslot=0xE0137, category='mn', description='VARIATION SELECTOR-72' },
	[0xE0138] = { unicodeslot=0xE0138, category='mn', description='VARIATION SELECTOR-73' },
	[0xE0139] = { unicodeslot=0xE0139, category='mn', description='VARIATION SELECTOR-74' },
	[0xE013A] = { unicodeslot=0xE013A, category='mn', description='VARIATION SELECTOR-75' },
	[0xE013B] = { unicodeslot=0xE013B, category='mn', description='VARIATION SELECTOR-76' },
	[0xE013C] = { unicodeslot=0xE013C, category='mn', description='VARIATION SELECTOR-77' },
	[0xE013D] = { unicodeslot=0xE013D, category='mn', description='VARIATION SELECTOR-78' },
	[0xE013E] = { unicodeslot=0xE013E, category='mn', description='VARIATION SELECTOR-79' },
	[0xE013F] = { unicodeslot=0xE013F, category='mn', description='VARIATION SELECTOR-80' },
	[0xE0140] = { unicodeslot=0xE0140, category='mn', description='VARIATION SELECTOR-81' },
	[0xE0141] = { unicodeslot=0xE0141, category='mn', description='VARIATION SELECTOR-82' },
	[0xE0142] = { unicodeslot=0xE0142, category='mn', description='VARIATION SELECTOR-83' },
	[0xE0143] = { unicodeslot=0xE0143, category='mn', description='VARIATION SELECTOR-84' },
	[0xE0144] = { unicodeslot=0xE0144, category='mn', description='VARIATION SELECTOR-85' },
	[0xE0145] = { unicodeslot=0xE0145, category='mn', description='VARIATION SELECTOR-86' },
	[0xE0146] = { unicodeslot=0xE0146, category='mn', description='VARIATION SELECTOR-87' },
	[0xE0147] = { unicodeslot=0xE0147, category='mn', description='VARIATION SELECTOR-88' },
	[0xE0148] = { unicodeslot=0xE0148, category='mn', description='VARIATION SELECTOR-89' },
	[0xE0149] = { unicodeslot=0xE0149, category='mn', description='VARIATION SELECTOR-90' },
	[0xE014A] = { unicodeslot=0xE014A, category='mn', description='VARIATION SELECTOR-91' },
	[0xE014B] = { unicodeslot=0xE014B, category='mn', description='VARIATION SELECTOR-92' },
	[0xE014C] = { unicodeslot=0xE014C, category='mn', description='VARIATION SELECTOR-93' },
	[0xE014D] = { unicodeslot=0xE014D, category='mn', description='VARIATION SELECTOR-94' },
	[0xE014E] = { unicodeslot=0xE014E, category='mn', description='VARIATION SELECTOR-95' },
	[0xE014F] = { unicodeslot=0xE014F, category='mn', description='VARIATION SELECTOR-96' },
	[0xE0150] = { unicodeslot=0xE0150, category='mn', description='VARIATION SELECTOR-97' },
	[0xE0151] = { unicodeslot=0xE0151, category='mn', description='VARIATION SELECTOR-98' },
	[0xE0152] = { unicodeslot=0xE0152, category='mn', description='VARIATION SELECTOR-99' },
	[0xE0153] = { unicodeslot=0xE0153, category='mn', description='VARIATION SELECTOR-100' },
	[0xE0154] = { unicodeslot=0xE0154, category='mn', description='VARIATION SELECTOR-101' },
	[0xE0155] = { unicodeslot=0xE0155, category='mn', description='VARIATION SELECTOR-102' },
	[0xE0156] = { unicodeslot=0xE0156, category='mn', description='VARIATION SELECTOR-103' },
	[0xE0157] = { unicodeslot=0xE0157, category='mn', description='VARIATION SELECTOR-104' },
	[0xE0158] = { unicodeslot=0xE0158, category='mn', description='VARIATION SELECTOR-105' },
	[0xE0159] = { unicodeslot=0xE0159, category='mn', description='VARIATION SELECTOR-106' },
	[0xE015A] = { unicodeslot=0xE015A, category='mn', description='VARIATION SELECTOR-107' },
	[0xE015B] = { unicodeslot=0xE015B, category='mn', description='VARIATION SELECTOR-108' },
	[0xE015C] = { unicodeslot=0xE015C, category='mn', description='VARIATION SELECTOR-109' },
	[0xE015D] = { unicodeslot=0xE015D, category='mn', description='VARIATION SELECTOR-110' },
	[0xE015E] = { unicodeslot=0xE015E, category='mn', description='VARIATION SELECTOR-111' },
	[0xE015F] = { unicodeslot=0xE015F, category='mn', description='VARIATION SELECTOR-112' },
	[0xE0160] = { unicodeslot=0xE0160, category='mn', description='VARIATION SELECTOR-113' },
	[0xE0161] = { unicodeslot=0xE0161, category='mn', description='VARIATION SELECTOR-114' },
	[0xE0162] = { unicodeslot=0xE0162, category='mn', description='VARIATION SELECTOR-115' },
	[0xE0163] = { unicodeslot=0xE0163, category='mn', description='VARIATION SELECTOR-116' },
	[0xE0164] = { unicodeslot=0xE0164, category='mn', description='VARIATION SELECTOR-117' },
	[0xE0165] = { unicodeslot=0xE0165, category='mn', description='VARIATION SELECTOR-118' },
	[0xE0166] = { unicodeslot=0xE0166, category='mn', description='VARIATION SELECTOR-119' },
	[0xE0167] = { unicodeslot=0xE0167, category='mn', description='VARIATION SELECTOR-120' },
	[0xE0168] = { unicodeslot=0xE0168, category='mn', description='VARIATION SELECTOR-121' },
	[0xE0169] = { unicodeslot=0xE0169, category='mn', description='VARIATION SELECTOR-122' },
	[0xE016A] = { unicodeslot=0xE016A, category='mn', description='VARIATION SELECTOR-123' },
	[0xE016B] = { unicodeslot=0xE016B, category='mn', description='VARIATION SELECTOR-124' },
	[0xE016C] = { unicodeslot=0xE016C, category='mn', description='VARIATION SELECTOR-125' },
	[0xE016D] = { unicodeslot=0xE016D, category='mn', description='VARIATION SELECTOR-126' },
	[0xE016E] = { unicodeslot=0xE016E, category='mn', description='VARIATION SELECTOR-127' },
	[0xE016F] = { unicodeslot=0xE016F, category='mn', description='VARIATION SELECTOR-128' },
	[0xE0170] = { unicodeslot=0xE0170, category='mn', description='VARIATION SELECTOR-129' },
	[0xE0171] = { unicodeslot=0xE0171, category='mn', description='VARIATION SELECTOR-130' },
	[0xE0172] = { unicodeslot=0xE0172, category='mn', description='VARIATION SELECTOR-131' },
	[0xE0173] = { unicodeslot=0xE0173, category='mn', description='VARIATION SELECTOR-132' },
	[0xE0174] = { unicodeslot=0xE0174, category='mn', description='VARIATION SELECTOR-133' },
	[0xE0175] = { unicodeslot=0xE0175, category='mn', description='VARIATION SELECTOR-134' },
	[0xE0176] = { unicodeslot=0xE0176, category='mn', description='VARIATION SELECTOR-135' },
	[0xE0177] = { unicodeslot=0xE0177, category='mn', description='VARIATION SELECTOR-136' },
	[0xE0178] = { unicodeslot=0xE0178, category='mn', description='VARIATION SELECTOR-137' },
	[0xE0179] = { unicodeslot=0xE0179, category='mn', description='VARIATION SELECTOR-138' },
	[0xE017A] = { unicodeslot=0xE017A, category='mn', description='VARIATION SELECTOR-139' },
	[0xE017B] = { unicodeslot=0xE017B, category='mn', description='VARIATION SELECTOR-140' },
	[0xE017C] = { unicodeslot=0xE017C, category='mn', description='VARIATION SELECTOR-141' },
	[0xE017D] = { unicodeslot=0xE017D, category='mn', description='VARIATION SELECTOR-142' },
	[0xE017E] = { unicodeslot=0xE017E, category='mn', description='VARIATION SELECTOR-143' },
	[0xE017F] = { unicodeslot=0xE017F, category='mn', description='VARIATION SELECTOR-144' },
	[0xE0180] = { unicodeslot=0xE0180, category='mn', description='VARIATION SELECTOR-145' },
	[0xE0181] = { unicodeslot=0xE0181, category='mn', description='VARIATION SELECTOR-146' },
	[0xE0182] = { unicodeslot=0xE0182, category='mn', description='VARIATION SELECTOR-147' },
	[0xE0183] = { unicodeslot=0xE0183, category='mn', description='VARIATION SELECTOR-148' },
	[0xE0184] = { unicodeslot=0xE0184, category='mn', description='VARIATION SELECTOR-149' },
	[0xE0185] = { unicodeslot=0xE0185, category='mn', description='VARIATION SELECTOR-150' },
	[0xE0186] = { unicodeslot=0xE0186, category='mn', description='VARIATION SELECTOR-151' },
	[0xE0187] = { unicodeslot=0xE0187, category='mn', description='VARIATION SELECTOR-152' },
	[0xE0188] = { unicodeslot=0xE0188, category='mn', description='VARIATION SELECTOR-153' },
	[0xE0189] = { unicodeslot=0xE0189, category='mn', description='VARIATION SELECTOR-154' },
	[0xE018A] = { unicodeslot=0xE018A, category='mn', description='VARIATION SELECTOR-155' },
	[0xE018B] = { unicodeslot=0xE018B, category='mn', description='VARIATION SELECTOR-156' },
	[0xE018C] = { unicodeslot=0xE018C, category='mn', description='VARIATION SELECTOR-157' },
	[0xE018D] = { unicodeslot=0xE018D, category='mn', description='VARIATION SELECTOR-158' },
	[0xE018E] = { unicodeslot=0xE018E, category='mn', description='VARIATION SELECTOR-159' },
	[0xE018F] = { unicodeslot=0xE018F, category='mn', description='VARIATION SELECTOR-160' },
	[0xE0190] = { unicodeslot=0xE0190, category='mn', description='VARIATION SELECTOR-161' },
	[0xE0191] = { unicodeslot=0xE0191, category='mn', description='VARIATION SELECTOR-162' },
	[0xE0192] = { unicodeslot=0xE0192, category='mn', description='VARIATION SELECTOR-163' },
	[0xE0193] = { unicodeslot=0xE0193, category='mn', description='VARIATION SELECTOR-164' },
	[0xE0194] = { unicodeslot=0xE0194, category='mn', description='VARIATION SELECTOR-165' },
	[0xE0195] = { unicodeslot=0xE0195, category='mn', description='VARIATION SELECTOR-166' },
	[0xE0196] = { unicodeslot=0xE0196, category='mn', description='VARIATION SELECTOR-167' },
	[0xE0197] = { unicodeslot=0xE0197, category='mn', description='VARIATION SELECTOR-168' },
	[0xE0198] = { unicodeslot=0xE0198, category='mn', description='VARIATION SELECTOR-169' },
	[0xE0199] = { unicodeslot=0xE0199, category='mn', description='VARIATION SELECTOR-170' },
	[0xE019A] = { unicodeslot=0xE019A, category='mn', description='VARIATION SELECTOR-171' },
	[0xE019B] = { unicodeslot=0xE019B, category='mn', description='VARIATION SELECTOR-172' },
	[0xE019C] = { unicodeslot=0xE019C, category='mn', description='VARIATION SELECTOR-173' },
	[0xE019D] = { unicodeslot=0xE019D, category='mn', description='VARIATION SELECTOR-174' },
	[0xE019E] = { unicodeslot=0xE019E, category='mn', description='VARIATION SELECTOR-175' },
	[0xE019F] = { unicodeslot=0xE019F, category='mn', description='VARIATION SELECTOR-176' },
	[0xE01A0] = { unicodeslot=0xE01A0, category='mn', description='VARIATION SELECTOR-177' },
	[0xE01A1] = { unicodeslot=0xE01A1, category='mn', description='VARIATION SELECTOR-178' },
	[0xE01A2] = { unicodeslot=0xE01A2, category='mn', description='VARIATION SELECTOR-179' },
	[0xE01A3] = { unicodeslot=0xE01A3, category='mn', description='VARIATION SELECTOR-180' },
	[0xE01A4] = { unicodeslot=0xE01A4, category='mn', description='VARIATION SELECTOR-181' },
	[0xE01A5] = { unicodeslot=0xE01A5, category='mn', description='VARIATION SELECTOR-182' },
	[0xE01A6] = { unicodeslot=0xE01A6, category='mn', description='VARIATION SELECTOR-183' },
	[0xE01A7] = { unicodeslot=0xE01A7, category='mn', description='VARIATION SELECTOR-184' },
	[0xE01A8] = { unicodeslot=0xE01A8, category='mn', description='VARIATION SELECTOR-185' },
	[0xE01A9] = { unicodeslot=0xE01A9, category='mn', description='VARIATION SELECTOR-186' },
	[0xE01AA] = { unicodeslot=0xE01AA, category='mn', description='VARIATION SELECTOR-187' },
	[0xE01AB] = { unicodeslot=0xE01AB, category='mn', description='VARIATION SELECTOR-188' },
	[0xE01AC] = { unicodeslot=0xE01AC, category='mn', description='VARIATION SELECTOR-189' },
	[0xE01AD] = { unicodeslot=0xE01AD, category='mn', description='VARIATION SELECTOR-190' },
	[0xE01AE] = { unicodeslot=0xE01AE, category='mn', description='VARIATION SELECTOR-191' },
	[0xE01AF] = { unicodeslot=0xE01AF, category='mn', description='VARIATION SELECTOR-192' },
	[0xE01B0] = { unicodeslot=0xE01B0, category='mn', description='VARIATION SELECTOR-193' },
	[0xE01B1] = { unicodeslot=0xE01B1, category='mn', description='VARIATION SELECTOR-194' },
	[0xE01B2] = { unicodeslot=0xE01B2, category='mn', description='VARIATION SELECTOR-195' },
	[0xE01B3] = { unicodeslot=0xE01B3, category='mn', description='VARIATION SELECTOR-196' },
	[0xE01B4] = { unicodeslot=0xE01B4, category='mn', description='VARIATION SELECTOR-197' },
	[0xE01B5] = { unicodeslot=0xE01B5, category='mn', description='VARIATION SELECTOR-198' },
	[0xE01B6] = { unicodeslot=0xE01B6, category='mn', description='VARIATION SELECTOR-199' },
	[0xE01B7] = { unicodeslot=0xE01B7, category='mn', description='VARIATION SELECTOR-200' },
	[0xE01B8] = { unicodeslot=0xE01B8, category='mn', description='VARIATION SELECTOR-201' },
	[0xE01B9] = { unicodeslot=0xE01B9, category='mn', description='VARIATION SELECTOR-202' },
	[0xE01BA] = { unicodeslot=0xE01BA, category='mn', description='VARIATION SELECTOR-203' },
	[0xE01BB] = { unicodeslot=0xE01BB, category='mn', description='VARIATION SELECTOR-204' },
	[0xE01BC] = { unicodeslot=0xE01BC, category='mn', description='VARIATION SELECTOR-205' },
	[0xE01BD] = { unicodeslot=0xE01BD, category='mn', description='VARIATION SELECTOR-206' },
	[0xE01BE] = { unicodeslot=0xE01BE, category='mn', description='VARIATION SELECTOR-207' },
	[0xE01BF] = { unicodeslot=0xE01BF, category='mn', description='VARIATION SELECTOR-208' },
	[0xE01C0] = { unicodeslot=0xE01C0, category='mn', description='VARIATION SELECTOR-209' },
	[0xE01C1] = { unicodeslot=0xE01C1, category='mn', description='VARIATION SELECTOR-210' },
	[0xE01C2] = { unicodeslot=0xE01C2, category='mn', description='VARIATION SELECTOR-211' },
	[0xE01C3] = { unicodeslot=0xE01C3, category='mn', description='VARIATION SELECTOR-212' },
	[0xE01C4] = { unicodeslot=0xE01C4, category='mn', description='VARIATION SELECTOR-213' },
	[0xE01C5] = { unicodeslot=0xE01C5, category='mn', description='VARIATION SELECTOR-214' },
	[0xE01C6] = { unicodeslot=0xE01C6, category='mn', description='VARIATION SELECTOR-215' },
	[0xE01C7] = { unicodeslot=0xE01C7, category='mn', description='VARIATION SELECTOR-216' },
	[0xE01C8] = { unicodeslot=0xE01C8, category='mn', description='VARIATION SELECTOR-217' },
	[0xE01C9] = { unicodeslot=0xE01C9, category='mn', description='VARIATION SELECTOR-218' },
	[0xE01CA] = { unicodeslot=0xE01CA, category='mn', description='VARIATION SELECTOR-219' },
	[0xE01CB] = { unicodeslot=0xE01CB, category='mn', description='VARIATION SELECTOR-220' },
	[0xE01CC] = { unicodeslot=0xE01CC, category='mn', description='VARIATION SELECTOR-221' },
	[0xE01CD] = { unicodeslot=0xE01CD, category='mn', description='VARIATION SELECTOR-222' },
	[0xE01CE] = { unicodeslot=0xE01CE, category='mn', description='VARIATION SELECTOR-223' },
	[0xE01CF] = { unicodeslot=0xE01CF, category='mn', description='VARIATION SELECTOR-224' },
	[0xE01D0] = { unicodeslot=0xE01D0, category='mn', description='VARIATION SELECTOR-225' },
	[0xE01D1] = { unicodeslot=0xE01D1, category='mn', description='VARIATION SELECTOR-226' },
	[0xE01D2] = { unicodeslot=0xE01D2, category='mn', description='VARIATION SELECTOR-227' },
	[0xE01D3] = { unicodeslot=0xE01D3, category='mn', description='VARIATION SELECTOR-228' },
	[0xE01D4] = { unicodeslot=0xE01D4, category='mn', description='VARIATION SELECTOR-229' },
	[0xE01D5] = { unicodeslot=0xE01D5, category='mn', description='VARIATION SELECTOR-230' },
	[0xE01D6] = { unicodeslot=0xE01D6, category='mn', description='VARIATION SELECTOR-231' },
	[0xE01D7] = { unicodeslot=0xE01D7, category='mn', description='VARIATION SELECTOR-232' },
	[0xE01D8] = { unicodeslot=0xE01D8, category='mn', description='VARIATION SELECTOR-233' },
	[0xE01D9] = { unicodeslot=0xE01D9, category='mn', description='VARIATION SELECTOR-234' },
	[0xE01DA] = { unicodeslot=0xE01DA, category='mn', description='VARIATION SELECTOR-235' },
	[0xE01DB] = { unicodeslot=0xE01DB, category='mn', description='VARIATION SELECTOR-236' },
	[0xE01DC] = { unicodeslot=0xE01DC, category='mn', description='VARIATION SELECTOR-237' },
	[0xE01DD] = { unicodeslot=0xE01DD, category='mn', description='VARIATION SELECTOR-238' },
	[0xE01DE] = { unicodeslot=0xE01DE, category='mn', description='VARIATION SELECTOR-239' },
	[0xE01DF] = { unicodeslot=0xE01DF, category='mn', description='VARIATION SELECTOR-240' },
	[0xE01E0] = { unicodeslot=0xE01E0, category='mn', description='VARIATION SELECTOR-241' },
	[0xE01E1] = { unicodeslot=0xE01E1, category='mn', description='VARIATION SELECTOR-242' },
	[0xE01E2] = { unicodeslot=0xE01E2, category='mn', description='VARIATION SELECTOR-243' },
	[0xE01E3] = { unicodeslot=0xE01E3, category='mn', description='VARIATION SELECTOR-244' },
	[0xE01E4] = { unicodeslot=0xE01E4, category='mn', description='VARIATION SELECTOR-245' },
	[0xE01E5] = { unicodeslot=0xE01E5, category='mn', description='VARIATION SELECTOR-246' },
	[0xE01E6] = { unicodeslot=0xE01E6, category='mn', description='VARIATION SELECTOR-247' },
	[0xE01E7] = { unicodeslot=0xE01E7, category='mn', description='VARIATION SELECTOR-248' },
	[0xE01E8] = { unicodeslot=0xE01E8, category='mn', description='VARIATION SELECTOR-249' },
	[0xE01E9] = { unicodeslot=0xE01E9, category='mn', description='VARIATION SELECTOR-250' },
	[0xE01EA] = { unicodeslot=0xE01EA, category='mn', description='VARIATION SELECTOR-251' },
	[0xE01EB] = { unicodeslot=0xE01EB, category='mn', description='VARIATION SELECTOR-252' },
	[0xE01EC] = { unicodeslot=0xE01EC, category='mn', description='VARIATION SELECTOR-253' },
	[0xE01ED] = { unicodeslot=0xE01ED, category='mn', description='VARIATION SELECTOR-254' },
	[0xE01EE] = { unicodeslot=0xE01EE, category='mn', description='VARIATION SELECTOR-255' },
	[0xE01EF] = { unicodeslot=0xE01EF, category='mn', description='VARIATION SELECTOR-256' },
	[0xF0000] = { unicodeslot=0xF0000, category='co', description='<Plane 15 Private Use, First>' },
	[0xFFFFD] = { unicodeslot=0xFFFFD, category='co', description='<Plane 15 Private Use, Last>' },
	[0x100000] = { unicodeslot=0x100000, category='co', description='<Plane 16 Private Use, First>' },
	[0x10FFFD] = { unicodeslot=0x10FFFD, category='co', description='<Plane 16 Private Use, Last>' },
}
